(in-package "PDDL")

(define (domain mystery-typed)
   (:requirements :typing)
   (:types province planet food emotion - object
           pleasure pain - emotion)
   (:predicates
       (eats ?n1 ?n2 - food)
       (craves ?v - emotion ?n - food)
       (fears ?c - pain ?v - pleasure)
       (locale ?n - food ?a - province)
       (harmony ?v - emotion ?s - planet)
       (attacks ?i ?j - province)
       (orbits ?i ?j - planet))

   (:action overcome
       :parameters (?c - pain ?v - pleasure)
       :vars (?n - food ?s1 ?s2 - planet)
       :precondition (and (craves ?c ?n)
                          (craves ?v ?n)
                          (harmony ?v ?s2)
                          (orbits ?s1 ?s2))
       :effect (and (not (craves ?c ?n))
                    (fears ?c ?v)
                    (not (harmony ?v ?s2))
                    (harmony ?v ?s1)))
   (:action feast
       :parameters (?v - pleasure ?n1 ?n2 - food)
       :vars (?l1 ?l2 - province)
       :precondition (and (craves ?v ?n1)
                          (eats ?n1 ?n2)
                          (locale ?n1 ?l2)
                          (attacks ?l1 ?l2))
       :effect (and (not (craves ?v ?n1))
                    (craves ?v ?n2)
                    (not (locale ?n1 ?l2))
                    (locale ?n1 ?l1)))
   (:action succumb
       :parameters (?c - pain ?v - pleasure)
       :vars (?n - food ?s1 ?s2 - planet)
       :precondition (and (fears ?c ?v)
                          (craves ?v ?n)
                          (harmony ?v ?s1)
                          (orbits ?s1 ?s2))
       :effect (and (not (fears ?c ?v))
                    (craves ?c ?n)
                    (not (harmony ?v ?s1))
                    (harmony ?v ?s2))))

(define (domain mystery-strips)
   (:predicates
       (province ?x)
       (planet ?x)
       (food ?x)
       (pleasure ?x)
       (pain ?x)
       (eats ?n1 ?n2)
       (craves ?v ?n)
       (fears ?c ?v)
       (locale ?n ?a)
       (harmony ?v ?s)
       (attacks ?i ?j)
       (orbits ?i ?j))

   (:action overcome
       :parameters (?c ?v)
       :vars (?n ?s1 ?s2)
       :precondition (and (pain ?c)
			  (pleasure ?v)
			  (craves ?c ?n)
                          (craves ?v ?n)
			  (food ?n)
                          (harmony ?v ?s2)
			  (planet ?s2)
			  (orbits ?s1 ?s2)
                          (planet ?s1))
       :effect (and (not (craves ?c ?n))
                    (fears ?c ?v)
                    (not (harmony ?v ?s2))
                    (harmony ?v ?s1)))
   (:action feast
       :parameters (?v ?n1 ?n2)
       :vars (?l1 ?l2)
       :precondition (and (craves ?v ?n1)
			  (food ?n1)
			  (pleasure ?v)
                          (eats ?n1 ?n2)
			  (food ?n2)
                          (locale ?n1 ?l2)
                          (attacks ?l1 ?l2))
       :effect (and (not (craves ?v ?n1))
                    (craves ?v ?n2)
                    (not (locale ?n1 ?l2))
                    (locale ?n1 ?l1)))
   (:action succumb
       :parameters (?c ?v)
       :vars (?n ?s1 ?s2)
       :precondition (and (fears ?c ?v)
			  (pain ?c)
			  (pleasure ?v)
                          (craves ?v ?n)
			  (food ?n)
			  (harmony ?v ?s1)
                          (orbits ?s1 ?s2))
       :effect (and (not (fears ?c ?v))
                    (craves ?c ?n)
                    (not (harmony ?v ?s1))
                    (harmony ?v ?s2))))

; The following 71 problems were generated by a program.  They are
; roughly in order of size.  I don't know how many have solutions.

; Order: First all 71 for the mystery-typed domain, then the same 71 for
; the mystery-strips domain

(DEFINE (PROBLEM MYSTY-A-1)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS HAM WONDERBREAD LETTUCE SNICKERS MUFFIN BEEF COD
             SWEETROLL LAMB SCALLION KALE PORK CHICKEN SHRIMP - FOOD
             ACHIEVEMENT INTOXICATION UNDERSTANDING - PLEASURE
             SCIATICA GRIEF ANXIETY DREAD ANGINA ABRASION PROSTATITIS
             - PAIN
             GOIAS ARIZONA - PROVINCE
             SATURN MARS NEPTUNE - PLANET)
   (:INIT (EATS MUFFIN WONDERBREAD)
          (EATS SWEETROLL HAM)
          (EATS CHICKEN SHRIMP)
          (HARMONY ACHIEVEMENT MARS)
          (EATS SWEETROLL COD)
          (EATS WONDERBREAD MUFFIN)
          (LOCALE KALE GOIAS)
          (EATS SWEETROLL LAMB)
          (LOCALE LETTUCE GOIAS)
          (CRAVES ANGINA LAMB)
          (EATS LETTUCE SNICKERS)
          (EATS HAM SWEETROLL)
          (LOCALE HAM GOIAS)
          (CRAVES GRIEF MUFFIN)
          (LOCALE BEEF GOIAS)
          (EATS CHICKEN PORK)
          (LOCALE SCALLION ARIZONA)
          (EATS SHRIMP LAMB)
          (EATS BEEF LAMB)
          (LOCALE COD ARIZONA)
          (EATS WONDERBREAD LETTUCE)
          (LOCALE SWEETROLL GOIAS)
          (HARMONY UNDERSTANDING MARS)
          (ORBITS SATURN MARS)
          (EATS SCALLION KALE)
          (EATS LAMB SHRIMP)
          (EATS LAMB BEEF)
          (ORBITS MARS NEPTUNE)
          (LOCALE PORK GOIAS)
          (LOCALE SHRIMP GOIAS)
          (CRAVES ABRASION LAMB)
          (CRAVES INTOXICATION CHICKEN)
          (EATS BEEF COD)
          (EATS PORK CHICKEN)
          (CRAVES DREAD LAMB)
          (LOCALE SNICKERS ARIZONA)
          (EATS HAM MUFFIN)
          (EATS COD BEEF)
          (EATS SNICKERS LETTUCE)
          (EATS PORK KALE)
          (EATS KALE SCALLION)
          (CRAVES UNDERSTANDING SHRIMP)
          (EATS SCALLION SHRIMP)
          (LOCALE LAMB GOIAS)
          (EATS LETTUCE WONDERBREAD)
          (EATS MUFFIN HAM)
          (EATS SNICKERS HAM)
          (CRAVES SCIATICA MUFFIN)
          (CRAVES ACHIEVEMENT HAM)
          (EATS KALE PORK)
          (ATTACKS GOIAS ARIZONA)
          (EATS SHRIMP CHICKEN)
          (EATS COD SWEETROLL)
          (CRAVES ANXIETY MUFFIN)
          (CRAVES PROSTATITIS PORK)
          (HARMONY INTOXICATION NEPTUNE)
          (LOCALE WONDERBREAD GOIAS)
          (LOCALE CHICKEN ARIZONA)
          (EATS SHRIMP SCALLION)
          (EATS HAM SNICKERS)
          (EATS LAMB SWEETROLL)
          (LOCALE MUFFIN ARIZONA))
   (:GOAL (AND (CRAVES PROSTATITIS SNICKERS))))

(DEFINE (PROBLEM MYSTY-A-2)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS HAROSET SCALLOP HOTDOG SCALLION MELON SNICKERS LEMON
             CHOCOLATE LETTUCE KALE PISTACHIO CANTELOPE SHRIMP - FOOD
             UNDERSTANDING ACHIEVEMENT INTOXICATION SATIETY - PLEASURE
             PROSTATITIS ANGINA ANGER LONELINESS ANXIETY SCIATICA GRIEF
             LACERATION HANGOVER DREAD DEPRESSION GRIEF-2 ABRASION BOILS
             JEALOUSY DEPRESSION-1 PROSTATITIS-8 LONELINESS-3 HANGOVER-4
             SCIATICA-6 ANGER-7 ANXIETY-14 ANGINA-15 LACERATION-16 DREAD-5
             ABRASION-13 DREAD-10 BOILS-11 JEALOUSY-12 - PAIN
             GUANABARA ALSACE GOIAS - PROVINCE
             URANUS MARS NEPTUNE MERCURY - PLANET)
   (:INIT (CRAVES DEPRESSION-1 LEMON)
          (EATS CHOCOLATE CANTELOPE)
          (EATS LEMON SCALLOP)
          (LOCALE SNICKERS GUANABARA)
          (LOCALE SCALLION ALSACE)
          (EATS LEMON CHOCOLATE)
          (LOCALE LETTUCE ALSACE)
          (EATS CHOCOLATE LETTUCE)
          (CRAVES PROSTATITIS-8 CHOCOLATE)
          (EATS SCALLION HAROSET)
          (ORBITS MARS NEPTUNE)
          (CRAVES JEALOUSY SNICKERS)
          (EATS CANTELOPE SHRIMP)
          (CRAVES ANGER-7 KALE)
          (CRAVES ACHIEVEMENT SNICKERS)
          (CRAVES HANGOVER-4 CHOCOLATE)
          (CRAVES DREAD-5 PISTACHIO)
          (CRAVES ANGINA-15 PISTACHIO)
          (EATS CHOCOLATE SCALLION)
          (CRAVES HANGOVER SCALLION)
          (CRAVES BOILS SNICKERS)
          (EATS PISTACHIO CHOCOLATE)
          (EATS SCALLOP MELON)
          (CRAVES JEALOUSY-12 SHRIMP)
          (EATS SCALLOP HAROSET)
          (LOCALE KALE GOIAS)
          (CRAVES SATIETY LETTUCE)
          (CRAVES LACERATION SCALLION)
          (EATS HOTDOG SNICKERS)
          (CRAVES DREAD-10 SHRIMP)
          (EATS CHOCOLATE LEMON)
          (CRAVES ABRASION-13 CANTELOPE)
          (CRAVES GRIEF-2 SNICKERS)
          (EATS CANTELOPE PISTACHIO)
          (EATS KALE LEMON)
          (LOCALE HAROSET GOIAS)
          (EATS HOTDOG SCALLION)
          (CRAVES ANXIETY SCALLOP)
          (EATS SNICKERS MELON)
          (LOCALE MELON GOIAS)
          (EATS MELON SNICKERS)
          (HARMONY UNDERSTANDING MERCURY)
          (HARMONY SATIETY MARS)
          (LOCALE LEMON ALSACE)
          (CRAVES LONELINESS-3 CHOCOLATE)
          (CRAVES ANXIETY-14 PISTACHIO)
          (CRAVES BOILS-11 SHRIMP)
          (EATS LETTUCE CHOCOLATE)
          (CRAVES PROSTATITIS HAROSET)
          (EATS KALE LETTUCE)
          (HARMONY INTOXICATION NEPTUNE)
          (EATS MELON SCALLOP)
          (EATS PISTACHIO CANTELOPE)
          (CRAVES DREAD MELON)
          (LOCALE PISTACHIO ALSACE)
          (EATS SHRIMP LETTUCE)
          (EATS LETTUCE KALE)
          (EATS SHRIMP CANTELOPE)
          (CRAVES SCIATICA-6 KALE)
          (ORBITS NEPTUNE MERCURY)
          (CRAVES LONELINESS SCALLOP)
          (CRAVES UNDERSTANDING HAROSET)
          (EATS SNICKERS HOTDOG)
          (CRAVES ABRASION SNICKERS)
          (EATS CANTELOPE CHOCOLATE)
          (LOCALE SHRIMP ALSACE)
          (CRAVES GRIEF HOTDOG)
          (CRAVES ANGER HAROSET)
          (ORBITS URANUS MARS)
          (EATS LEMON KALE)
          (EATS HAROSET SCALLION)
          (CRAVES INTOXICATION CHOCOLATE)
          (CRAVES LACERATION-16 PISTACHIO)
          (ATTACKS ALSACE GOIAS)
          (LOCALE SCALLOP GOIAS)
          (CRAVES SCIATICA HOTDOG)
          (CRAVES ANGINA HAROSET)
          (EATS CHOCOLATE PISTACHIO)
          (LOCALE CHOCOLATE ALSACE)
          (LOCALE HOTDOG ALSACE)
          (CRAVES DEPRESSION MELON)
          (EATS LETTUCE SHRIMP)
          (HARMONY ACHIEVEMENT MARS)
          (EATS SCALLOP LEMON)
          (LOCALE CANTELOPE GOIAS)
          (ATTACKS GUANABARA ALSACE)
          (EATS SCALLION HOTDOG)
          (EATS SCALLION CHOCOLATE)
          (EATS HAROSET SCALLOP))
   (:GOAL (AND (CRAVES ABRASION-13 SCALLOP)
               (CRAVES JEALOUSY LEMON))))

(DEFINE (PROBLEM MYSTY-A-3)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SCALLOP FLOUNDER ARUGULA KALE TOFU SCALLION YOGURT
             PAPAYA OKRA ORANGE HAM POTATO LEMON WONDERBREAD MARZIPAN
             SWEETROLL LOBSTER TUNA - FOOD
             EXPECTATION AESTHETICS LOVE STIMULATION SATIETY CURIOSITY EMPATHY
             INTOXICATION TRIUMPH LUBRICITY - PLEASURE
             SCIATICA LACERATION - PAIN
             ARIZONA BAVARIA MORAVIA SURREY OREGON - PROVINCE
             JUPITER EARTH URANUS MARS - PLANET)
   (:INIT (EATS FLOUNDER ARUGULA)
          (HARMONY SATIETY EARTH)
          (CRAVES LUBRICITY WONDERBREAD)
          (CRAVES EMPATHY ORANGE)
          (EATS SCALLOP KALE)
          (ORBITS URANUS MARS)
          (HARMONY LUBRICITY URANUS)
          (EATS MARZIPAN YOGURT)
          (EATS YOGURT MARZIPAN)
          (EATS HAM LOBSTER)
          (EATS FLOUNDER SCALLOP)
          (LOCALE PAPAYA BAVARIA)
          (LOCALE OKRA ARIZONA)
          (EATS KALE SCALLOP)
          (EATS WONDERBREAD HAM)
          (EATS SWEETROLL MARZIPAN)
          (LOCALE SCALLOP MORAVIA)
          (ORBITS EARTH URANUS)
          (EATS SCALLION OKRA)
          (LOCALE WONDERBREAD ARIZONA)
          (EATS LEMON POTATO)
          (EATS WONDERBREAD TUNA)
          (LOCALE HAM BAVARIA)
          (CRAVES TRIUMPH POTATO)
          (EATS SCALLION TOFU)
          (EATS LOBSTER SWEETROLL)
          (LOCALE YOGURT MORAVIA)
          (EATS LEMON SWEETROLL)
          (CRAVES INTOXICATION HAM)
          (EATS SWEETROLL POTATO)
          (EATS TOFU SCALLION)
          (EATS YOGURT OKRA)
          (CRAVES EXPECTATION FLOUNDER)
          (LOCALE POTATO OREGON)
          (CRAVES CURIOSITY OKRA)
          (EATS PAPAYA ARUGULA)
          (EATS OKRA PAPAYA)
          (EATS TUNA MARZIPAN)
          (LOCALE ARUGULA OREGON)
          (HARMONY EMPATHY MARS)
          (HARMONY INTOXICATION MARS)
          (EATS TOFU ORANGE)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES AESTHETICS ARUGULA)
          (LOCALE ORANGE SURREY)
          (LOCALE MARZIPAN OREGON)
          (EATS MARZIPAN SWEETROLL)
          (LOCALE FLOUNDER MORAVIA)
          (LOCALE KALE SURREY)
          (EATS ARUGULA PAPAYA)
          (ATTACKS ARIZONA BAVARIA)
          (EATS ORANGE YOGURT)
          (HARMONY AESTHETICS URANUS)
          (LOCALE LOBSTER SURREY)
          (EATS PAPAYA YOGURT)
          (LOCALE TUNA BAVARIA)
          (EATS YOGURT SCALLION)
          (HARMONY STIMULATION URANUS)
          (EATS PAPAYA OKRA)
          (EATS LOBSTER LEMON)
          (CRAVES STIMULATION SCALLION)
          (EATS LEMON TUNA)
          (EATS YOGURT PAPAYA)
          (HARMONY LOVE URANUS)
          (EATS TUNA WONDERBREAD)
          (CRAVES SATIETY YOGURT)
          (CRAVES SCIATICA POTATO)
          (EATS SWEETROLL LOBSTER)
          (CRAVES LOVE TOFU)
          (EATS YOGURT ORANGE)
          (LOCALE SWEETROLL SURREY)
          (ORBITS JUPITER EARTH)
          (CRAVES LACERATION LEMON)
          (LOCALE LEMON ARIZONA)
          (EATS MARZIPAN TUNA)
          (EATS OKRA SCALLION)
          (HARMONY EXPECTATION MARS)
          (ATTACKS SURREY OREGON)
          (HARMONY TRIUMPH URANUS)
          (EATS POTATO LEMON)
          (EATS OKRA YOGURT)
          (EATS LEMON LOBSTER)
          (EATS ARUGULA FLOUNDER)
          (LOCALE SCALLION ARIZONA)
          (EATS SCALLOP FLOUNDER)
          (EATS ORANGE TOFU)
          (EATS KALE ARUGULA)
          (EATS SWEETROLL LEMON)
          (EATS SCALLION YOGURT)
          (EATS ARUGULA KALE)
          (EATS POTATO MARZIPAN)
          (EATS TUNA LEMON)
          (HARMONY CURIOSITY EARTH)
          (EATS MARZIPAN POTATO)
          (ATTACKS MORAVIA SURREY)
          (EATS POTATO SWEETROLL)
          (EATS HAM WONDERBREAD)
          (EATS LOBSTER HAM)
          (LOCALE TOFU SURREY))
   (:GOAL (AND (CRAVES SCIATICA PAPAYA))))

(DEFINE (PROBLEM MYSTY-A-4)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS WONDERBREAD KALE HOTDOG PORK SNICKERS MUTTON GUAVA
             POPOVER WURST SHRIMP - FOOD
             EXCITEMENT TRIUMPH - PLEASURE
             PROSTATITIS ANGER GRIEF LONELINESS ANGINA BOILS JEALOUSY HANGOVER
             - PAIN
             PENNSYLVANIA BOSNIA KENTUCKY ARIZONA GOIAS - PROVINCE
             SATURN MERCURY VENUS VULCAN - PLANET)
   (:INIT (LOCALE PORK GOIAS)
          (EATS MUTTON WURST)
          (LOCALE SNICKERS KENTUCKY)
          (CRAVES GRIEF PORK)
          (CRAVES BOILS MUTTON)
          (EATS WURST MUTTON)
          (EATS SHRIMP GUAVA)
          (EATS SNICKERS GUAVA)
          (EATS POPOVER KALE)
          (EATS KALE POPOVER)
          (CRAVES EXCITEMENT WONDERBREAD)
          (EATS KALE PORK)
          (CRAVES ANGINA MUTTON)
          (ATTACKS PENNSYLVANIA BOSNIA)
          (EATS SNICKERS POPOVER)
          (CRAVES PROSTATITIS PORK)
          (EATS WURST HOTDOG)
          (ORBITS MERCURY VENUS)
          (CRAVES LONELINESS MUTTON)
          (LOCALE MUTTON ARIZONA)
          (EATS PORK WONDERBREAD)
          (EATS HOTDOG WURST)
          (EATS SHRIMP MUTTON)
          (HARMONY EXCITEMENT MERCURY)
          (ATTACKS BOSNIA KENTUCKY)
          (HARMONY TRIUMPH VULCAN)
          (ATTACKS KENTUCKY ARIZONA)
          (EATS POPOVER HOTDOG)
          (ATTACKS ARIZONA GOIAS)
          (CRAVES HANGOVER WURST)
          (LOCALE POPOVER PENNSYLVANIA)
          (CRAVES TRIUMPH POPOVER)
          (EATS WONDERBREAD SHRIMP)
          (EATS POPOVER SNICKERS)
          (EATS HOTDOG POPOVER)
          (LOCALE HOTDOG PENNSYLVANIA)
          (EATS SHRIMP WONDERBREAD)
          (CRAVES JEALOUSY WURST)
          (ORBITS VENUS VULCAN)
          (EATS PORK KALE)
          (EATS GUAVA SHRIMP)
          (ORBITS SATURN MERCURY)
          (LOCALE SHRIMP BOSNIA)
          (LOCALE WONDERBREAD ARIZONA)
          (LOCALE GUAVA PENNSYLVANIA)
          (EATS MUTTON SHRIMP)
          (CRAVES ANGER PORK)
          (LOCALE WURST PENNSYLVANIA)
          (EATS WONDERBREAD PORK)
          (LOCALE KALE ARIZONA)
          (EATS GUAVA SNICKERS))
   (:GOAL (AND (CRAVES ANGER SNICKERS))))

(DEFINE (PROBLEM MYSTY-A-5)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SCALLOP PEA HOTDOG CANTELOPE CHICKEN ORANGE TOFU ONION
             SNICKERS COD LAMB BAGUETTE HAROSET - FOOD
             ENTERTAINMENT EXCITEMENT LOVE - PLEASURE
             HANGOVER ANGINA SCIATICA PROSTATITIS LONELINESS - PAIN
             BOSNIA BAVARIA GOIAS - PROVINCE
             VENUS NEPTUNE URANUS MARS - PLANET)
   (:INIT (LOCALE SNICKERS GOIAS)
          (EATS PEA ORANGE)
          (EATS SCALLOP PEA)
          (ORBITS VENUS NEPTUNE)
          (EATS ORANGE HOTDOG)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS LAMB BAGUETTE)
          (EATS CHICKEN CANTELOPE)
          (EATS CHICKEN SCALLOP)
          (HARMONY LOVE MARS)
          (EATS BAGUETTE CANTELOPE)
          (EATS ORANGE PEA)
          (LOCALE PEA GOIAS)
          (LOCALE TOFU BOSNIA)
          (LOCALE HOTDOG BAVARIA)
          (CRAVES PROSTATITIS SNICKERS)
          (EATS TOFU LAMB)
          (ATTACKS BAVARIA GOIAS)
          (EATS CANTELOPE BAGUETTE)
          (LOCALE BAGUETTE BAVARIA)
          (CRAVES HANGOVER CHICKEN)
          (LOCALE ONION GOIAS)
          (EATS BAGUETTE ONION)
          (EATS HAROSET COD)
          (EATS PEA SCALLOP)
          (CRAVES LOVE TOFU)
          (HARMONY EXCITEMENT MARS)
          (LOCALE HAROSET BAVARIA)
          (LOCALE CANTELOPE BOSNIA)
          (LOCALE CHICKEN BAVARIA)
          (CRAVES LONELINESS LAMB)
          (LOCALE COD BAVARIA)
          (LOCALE ORANGE BOSNIA)
          (EATS COD SNICKERS)
          (EATS SNICKERS TOFU)
          (EATS BAGUETTE LAMB)
          (EATS SNICKERS COD)
          (EATS HAROSET ONION)
          (EATS ONION HAROSET)
          (ATTACKS BOSNIA BAVARIA)
          (ORBITS URANUS MARS)
          (EATS SCALLOP CHICKEN)
          (EATS CANTELOPE HOTDOG)
          (EATS HOTDOG CANTELOPE)
          (EATS HOTDOG ORANGE)
          (CRAVES ANGINA TOFU)
          (EATS ONION BAGUETTE)
          (EATS LAMB TOFU)
          (EATS COD HAROSET)
          (CRAVES ENTERTAINMENT SCALLOP)
          (EATS CANTELOPE CHICKEN)
          (LOCALE SCALLOP BOSNIA)
          (LOCALE LAMB GOIAS)
          (CRAVES SCIATICA ONION)
          (CRAVES EXCITEMENT HOTDOG)
          (EATS TOFU SNICKERS)
          (ORBITS NEPTUNE URANUS))
   (:GOAL (AND (CRAVES LONELINESS ONION))))

(DEFINE (PROBLEM MYSTY-A-6)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS ONION FLOUNDER MUTTON TURKEY BAGUETTE CHOCOLATE MUFFIN
             PEAR CUCUMBER OKRA ENDIVE WONDERBREAD GRAPEFRUIT SHRIMP
             HAROSET BEEF ORANGE - FOOD
             CURIOSITY STIMULATION EXPECTATION LEARNING LUBRICITY
             ENTERTAINMENT SATISFACTION UNDERSTANDING LOVE - PLEASURE
             HANGOVER GRIEF DEPRESSION ANGER ABRASION ANGINA PROSTATITIS
             LACERATION DREAD - PAIN
             ARIZONA PENNSYLVANIA BAVARIA - PROVINCE
             JUPITER VULCAN EARTH MARS - PLANET)
   (:INIT (LOCALE FLOUNDER PENNSYLVANIA)
          (CRAVES ANGINA OKRA)
          (EATS ENDIVE SHRIMP)
          (EATS MUFFIN CHOCOLATE)
          (LOCALE SHRIMP PENNSYLVANIA)
          (EATS WONDERBREAD ENDIVE)
          (CRAVES DEPRESSION CHOCOLATE)
          (CRAVES PROSTATITIS ENDIVE)
          (EATS TURKEY MUTTON)
          (HARMONY LEARNING MARS)
          (EATS ORANGE SHRIMP)
          (EATS BAGUETTE CUCUMBER)
          (ATTACKS ARIZONA PENNSYLVANIA)
          (EATS OKRA MUFFIN)
          (CRAVES SATISFACTION WONDERBREAD)
          (ORBITS JUPITER VULCAN)
          (EATS WONDERBREAD ORANGE)
          (EATS HAROSET BEEF)
          (CRAVES EXPECTATION TURKEY)
          (EATS CHOCOLATE GRAPEFRUIT)
          (EATS MUTTON FLOUNDER)
          (LOCALE GRAPEFRUIT ARIZONA)
          (EATS SHRIMP ORANGE)
          (EATS ENDIVE GRAPEFRUIT)
          (CRAVES GRIEF TURKEY)
          (CRAVES ANGER PEAR)
          (LOCALE TURKEY ARIZONA)
          (EATS PEAR CHOCOLATE)
          (EATS CUCUMBER PEAR)
          (EATS PEAR CUCUMBER)
          (CRAVES UNDERSTANDING HAROSET)
          (EATS ONION TURKEY)
          (EATS BEEF HAROSET)
          (LOCALE HAROSET PENNSYLVANIA)
          (EATS ORANGE WONDERBREAD)
          (EATS WONDERBREAD BEEF)
          (EATS CHOCOLATE PEAR)
          (HARMONY SATISFACTION MARS)
          (EATS BEEF WONDERBREAD)
          (CRAVES DREAD HAROSET)
          (LOCALE MUTTON BAVARIA)
          (EATS FLOUNDER MUTTON)
          (EATS GRAPEFRUIT CHOCOLATE)
          (LOCALE MUFFIN BAVARIA)
          (EATS OKRA BAGUETTE)
          (EATS GRAPEFRUIT ENDIVE)
          (EATS ENDIVE WONDERBREAD)
          (LOCALE OKRA PENNSYLVANIA)
          (LOCALE ENDIVE ARIZONA)
          (EATS BAGUETTE OKRA)
          (HARMONY CURIOSITY VULCAN)
          (LOCALE CHOCOLATE ARIZONA)
          (CRAVES LEARNING BAGUETTE)
          (EATS FLOUNDER ONION)
          (HARMONY STIMULATION MARS)
          (LOCALE WONDERBREAD BAVARIA)
          (EATS CHOCOLATE MUFFIN)
          (EATS SHRIMP GRAPEFRUIT)
          (EATS SHRIMP WONDERBREAD)
          (EATS BAGUETTE MUTTON)
          (CRAVES LUBRICITY CHOCOLATE)
          (LOCALE ORANGE BAVARIA)
          (CRAVES ABRASION CUCUMBER)
          (EATS WONDERBREAD SHRIMP)
          (ORBITS VULCAN EARTH)
          (HARMONY EXPECTATION EARTH)
          (EATS ONION FLOUNDER)
          (LOCALE CUCUMBER ARIZONA)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (HARMONY ENTERTAINMENT VULCAN)
          (EATS MUTTON BAGUETTE)
          (CRAVES LOVE ORANGE)
          (HARMONY UNDERSTANDING VULCAN)
          (CRAVES CURIOSITY ONION)
          (HARMONY LUBRICITY VULCAN)
          (ORBITS EARTH MARS)
          (EATS HAROSET GRAPEFRUIT)
          (EATS TURKEY ONION)
          (EATS MUTTON TURKEY)
          (LOCALE BAGUETTE PENNSYLVANIA)
          (HARMONY LOVE EARTH)
          (LOCALE PEAR BAVARIA)
          (LOCALE BEEF PENNSYLVANIA)
          (EATS GRAPEFRUIT SHRIMP)
          (CRAVES ENTERTAINMENT MUFFIN)
          (CRAVES STIMULATION MUTTON)
          (CRAVES HANGOVER MUTTON)
          (LOCALE ONION ARIZONA)
          (EATS CUCUMBER BAGUETTE)
          (EATS MUFFIN OKRA)
          (CRAVES LACERATION SHRIMP)
          (EATS SHRIMP ENDIVE)
          (EATS GRAPEFRUIT HAROSET))
   (:GOAL (AND (CRAVES ANGER SHRIMP))))

(DEFINE (PROBLEM MYSTY-A-7)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS BAGUETTE LETTUCE SWEETROLL SNICKERS WURST SCALLOP BEEF
             GRAPEFRUIT HOTDOG ONION TOFU ENDIVE CHICKEN KALE TOMATO TUNA
             CUCUMBER HAMBURGER SHRIMP LOBSTER - FOOD
             EXPECTATION CURIOSITY SATISFACTION ACHIEVEMENT STIMULATION
             - PLEASURE
             LONELINESS LACERATION GRIEF HANGOVER ANGER ANGINA - PAIN
             GUANABARA MANITOBA BAVARIA - PROVINCE
             JUPITER VULCAN EARTH URANUS - PLANET)
   (:INIT (LOCALE HOTDOG GUANABARA)
          (LOCALE LETTUCE BAVARIA)
          (EATS WURST BAGUETTE)
          (EATS SNICKERS BAGUETTE)
          (EATS TOMATO TUNA)
          (LOCALE ENDIVE MANITOBA)
          (HARMONY ACHIEVEMENT EARTH)
          (EATS SWEETROLL LETTUCE)
          (CRAVES LONELINESS BEEF)
          (CRAVES ANGINA KALE)
          (EATS ONION TOFU)
          (CRAVES ANGER KALE)
          (LOCALE TOMATO GUANABARA)
          (EATS HOTDOG GRAPEFRUIT)
          (EATS SHRIMP TOMATO)
          (EATS TUNA TOMATO)
          (EATS LETTUCE SWEETROLL)
          (EATS KALE CUCUMBER)
          (EATS TUNA SHRIMP)
          (EATS SWEETROLL SNICKERS)
          (LOCALE TUNA MANITOBA)
          (ATTACKS GUANABARA MANITOBA)
          (LOCALE BAGUETTE GUANABARA)
          (EATS HAMBURGER KALE)
          (LOCALE BEEF BAVARIA)
          (EATS TUNA CHICKEN)
          (EATS LETTUCE KALE)
          (LOCALE ONION GUANABARA)
          (LOCALE LOBSTER BAVARIA)
          (EATS CHICKEN TUNA)
          (EATS LOBSTER CUCUMBER)
          (EATS TOFU ONION)
          (EATS CUCUMBER LOBSTER)
          (LOCALE CUCUMBER MANITOBA)
          (HARMONY CURIOSITY EARTH)
          (EATS KALE LETTUCE)
          (EATS TUNA BEEF)
          (EATS SCALLOP ENDIVE)
          (EATS SCALLOP HOTDOG)
          (ORBITS EARTH URANUS)
          (LOCALE HAMBURGER MANITOBA)
          (ORBITS JUPITER VULCAN)
          (EATS ONION GRAPEFRUIT)
          (EATS HOTDOG SCALLOP)
          (EATS GRAPEFRUIT ONION)
          (EATS WURST LETTUCE)
          (HARMONY STIMULATION URANUS)
          (EATS BEEF TUNA)
          (EATS TOMATO SHRIMP)
          (EATS HAMBURGER TUNA)
          (LOCALE SCALLOP GUANABARA)
          (EATS ENDIVE BEEF)
          (LOCALE SNICKERS MANITOBA)
          (EATS TOMATO HAMBURGER)
          (EATS TUNA HAMBURGER)
          (EATS HAMBURGER TOMATO)
          (EATS BEEF ENDIVE)
          (CRAVES CURIOSITY CHICKEN)
          (CRAVES ACHIEVEMENT TUNA)
          (EATS SNICKERS SWEETROLL)
          (CRAVES SATISFACTION KALE)
          (ATTACKS MANITOBA BAVARIA)
          (EATS BAGUETTE SNICKERS)
          (CRAVES EXPECTATION SNICKERS)
          (LOCALE SWEETROLL BAVARIA)
          (EATS ENDIVE SCALLOP)
          (EATS GRAPEFRUIT HOTDOG)
          (CRAVES LACERATION BEEF)
          (CRAVES HANGOVER TOFU)
          (LOCALE KALE GUANABARA)
          (CRAVES STIMULATION CUCUMBER)
          (EATS SWEETROLL BEEF)
          (EATS TOFU BEEF)
          (EATS BEEF SWEETROLL)
          (EATS KALE HAMBURGER)
          (HARMONY EXPECTATION URANUS)
          (ORBITS VULCAN EARTH)
          (LOCALE SHRIMP GUANABARA)
          (CRAVES GRIEF BEEF)
          (EATS BEEF TOFU)
          (LOCALE CHICKEN GUANABARA)
          (HARMONY SATISFACTION VULCAN)
          (EATS LETTUCE WURST)
          (LOCALE TOFU GUANABARA)
          (EATS CUCUMBER KALE)
          (LOCALE WURST GUANABARA)
          (EATS SHRIMP TUNA)
          (EATS LOBSTER CHICKEN)
          (EATS BAGUETTE WURST)
          (EATS CHICKEN LOBSTER)
          (LOCALE GRAPEFRUIT GUANABARA))
   (:GOAL (AND (CRAVES HANGOVER CUCUMBER))))

(DEFINE (PROBLEM MYSTY-A-8)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SHRIMP HAM SCALLION RICE HOTDOG YOGURT CHICKEN KALE
             SNICKERS - FOOD
             ENTERTAINMENT AESTHETICS STIMULATION - PLEASURE
             GRIEF LACERATION SCIATICA LONELINESS PROSTATITIS ANGER
             ANGINA - PAIN
             GUANABARA KENTUCKY BAVARIA BOSNIA - PROVINCE
             JUPITER SATURN - PLANET)
   (:INIT (EATS SCALLION RICE)
          (EATS KALE SNICKERS)
          (LOCALE RICE BOSNIA)
          (CRAVES ENTERTAINMENT HAM)
          (EATS RICE SCALLION)
          (EATS KALE CHICKEN)
          (CRAVES AESTHETICS SCALLION)
          (HARMONY AESTHETICS SATURN)
          (EATS SNICKERS HAM)
          (CRAVES GRIEF SHRIMP)
          (ORBITS JUPITER SATURN)
          (CRAVES SCIATICA HOTDOG)
          (CRAVES ANGINA SNICKERS)
          (EATS KALE YOGURT)
          (EATS HAM SCALLION)
          (LOCALE SCALLION BOSNIA)
          (EATS SHRIMP HAM)
          (CRAVES LACERATION SCALLION)
          (EATS SHRIMP RICE)
          (CRAVES PROSTATITIS CHICKEN)
          (EATS SNICKERS KALE)
          (ATTACKS KENTUCKY BAVARIA)
          (EATS RICE SHRIMP)
          (EATS SNICKERS HOTDOG)
          (EATS CHICKEN YOGURT)
          (LOCALE HOTDOG BOSNIA)
          (HARMONY ENTERTAINMENT SATURN)
          (EATS YOGURT CHICKEN)
          (LOCALE YOGURT BOSNIA)
          (LOCALE CHICKEN BAVARIA)
          (EATS HAM RICE)
          (HARMONY STIMULATION SATURN)
          (EATS YOGURT HOTDOG)
          (EATS RICE HAM)
          (EATS HAM SNICKERS)
          (EATS HAM SHRIMP)
          (CRAVES STIMULATION SNICKERS)
          (ATTACKS BAVARIA BOSNIA)
          (EATS SCALLION HAM)
          (EATS YOGURT KALE)
          (LOCALE KALE KENTUCKY)
          (CRAVES LONELINESS YOGURT)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS CHICKEN KALE)
          (CRAVES ANGER KALE)
          (LOCALE SHRIMP BAVARIA)
          (EATS KALE HOTDOG)
          (EATS HOTDOG KALE)
          (LOCALE SNICKERS GUANABARA)
          (EATS HOTDOG SNICKERS)
          (LOCALE HAM BOSNIA)
          (EATS HOTDOG YOGURT))
   (:GOAL (AND (CRAVES LACERATION KALE))))

(DEFINE (PROBLEM MYSTY-A-9)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS COD YOGURT SCALLION CHICKEN WONDERBREAD PAPAYA TOFU
             CUCUMBER HOTDOG PORK BAGUETTE TUNA SNICKERS POTATO SHRIMP HAM
             LAMB - FOOD
             EXCITEMENT STIMULATION LUBRICITY - PLEASURE
             LONELINESS ANGER GRIEF DREAD PROSTATITIS DEPRESSION ANGINA
             HANGOVER BOILS ANXIETY SCIATICA JEALOUSY LACERATION JEALOUSY-2
             ABRASION BOILS-1 - PAIN
             GOIAS OREGON MORAVIA PENNSYLVANIA - PROVINCE
             JUPITER VENUS NEPTUNE MARS - PLANET)
   (:INIT (LOCALE PORK MORAVIA)
          (LOCALE PAPAYA GOIAS)
          (EATS WONDERBREAD COD)
          (LOCALE CUCUMBER PENNSYLVANIA)
          (CRAVES ANXIETY TOFU)
          (EATS COD WONDERBREAD)
          (EATS SNICKERS SHRIMP)
          (EATS POTATO LAMB)
          (CRAVES DEPRESSION YOGURT)
          (CRAVES GRIEF COD)
          (EATS TUNA SNICKERS)
          (CRAVES EXCITEMENT SCALLION)
          (EATS HAM SNICKERS)
          (EATS TUNA PORK)
          (LOCALE LAMB PENNSYLVANIA)
          (LOCALE HOTDOG MORAVIA)
          (EATS PAPAYA TOFU)
          (EATS CUCUMBER COD)
          (LOCALE HAM OREGON)
          (CRAVES ANGER COD)
          (LOCALE POTATO OREGON)
          (EATS WONDERBREAD YOGURT)
          (EATS SCALLION YOGURT)
          (CRAVES BOILS TOFU)
          (EATS LAMB POTATO)
          (EATS PORK TUNA)
          (EATS HAM PORK)
          (CRAVES ANGINA WONDERBREAD)
          (LOCALE BAGUETTE OREGON)
          (CRAVES BOILS-1 POTATO)
          (LOCALE COD OREGON)
          (CRAVES JEALOUSY CUCUMBER)
          (EATS COD CUCUMBER)
          (ATTACKS OREGON MORAVIA)
          (EATS SNICKERS HAM)
          (EATS CUCUMBER TOFU)
          (EATS SHRIMP SNICKERS)
          (EATS CHICKEN SCALLION)
          (CRAVES ABRASION BAGUETTE)
          (LOCALE TUNA MORAVIA)
          (EATS HOTDOG LAMB)
          (EATS BAGUETTE SHRIMP)
          (EATS HOTDOG CUCUMBER)
          (EATS HAM LAMB)
          (EATS YOGURT WONDERBREAD)
          (EATS CHICKEN COD)
          (LOCALE CHICKEN GOIAS)
          (EATS TUNA SHRIMP)
          (EATS CUCUMBER HOTDOG)
          (LOCALE YOGURT OREGON)
          (EATS LAMB HOTDOG)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS SHRIMP BAGUETTE)
          (EATS LAMB TUNA)
          (CRAVES LACERATION PORK)
          (ORBITS JUPITER VENUS)
          (LOCALE TOFU MORAVIA)
          (EATS PAPAYA HOTDOG)
          (ORBITS VENUS NEPTUNE)
          (EATS LAMB HAM)
          (LOCALE WONDERBREAD MORAVIA)
          (CRAVES STIMULATION PORK)
          (CRAVES LUBRICITY HAM)
          (CRAVES LONELINESS COD)
          (CRAVES PROSTATITIS YOGURT)
          (EATS TOFU PAPAYA)
          (EATS YOGURT SCALLION)
          (CRAVES SCIATICA CUCUMBER)
          (ORBITS NEPTUNE MARS)
          (EATS POTATO BAGUETTE)
          (CRAVES JEALOUSY-2 BAGUETTE)
          (EATS TUNA LAMB)
          (EATS SCALLION CHICKEN)
          (EATS PORK HAM)
          (EATS TOFU CUCUMBER)
          (ATTACKS GOIAS OREGON)
          (EATS BAGUETTE POTATO)
          (EATS HOTDOG PAPAYA)
          (LOCALE SCALLION GOIAS)
          (CRAVES HANGOVER PAPAYA)
          (HARMONY LUBRICITY NEPTUNE)
          (HARMONY STIMULATION MARS)
          (LOCALE SHRIMP OREGON)
          (EATS COD CHICKEN)
          (LOCALE SNICKERS PENNSYLVANIA)
          (ATTACKS MORAVIA PENNSYLVANIA)
          (CRAVES DREAD YOGURT)
          (EATS SNICKERS TUNA)
          (EATS SHRIMP TUNA))
   (:GOAL (AND (CRAVES DEPRESSION CUCUMBER))))

(DEFINE (PROBLEM MYSTY-A-10)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LEMON YOGURT OKRA CHOCOLATE - FOOD
             LEARNING CURIOSITY LOVE - PLEASURE
             ANXIETY DREAD SCIATICA LONELINESS BOILS GRIEF ANGINA ABRASION
             - PAIN
             BAVARIA QUEBEC - PROVINCE
             SATURN MERCURY JUPITER VULCAN - PLANET)
   (:INIT (CRAVES CURIOSITY OKRA)
          (EATS LEMON CHOCOLATE)
          (LOCALE OKRA BAVARIA)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES LOVE CHOCOLATE)
          (EATS OKRA CHOCOLATE)
          (CRAVES ANXIETY YOGURT)
          (EATS YOGURT OKRA)
          (LOCALE LEMON QUEBEC)
          (ORBITS SATURN MERCURY)
          (ORBITS MERCURY JUPITER)
          (EATS CHOCOLATE LEMON)
          (LOCALE CHOCOLATE QUEBEC)
          (CRAVES DREAD YOGURT)
          (CRAVES BOILS YOGURT)
          (HARMONY LOVE VULCAN)
          (LOCALE YOGURT QUEBEC)
          (ATTACKS BAVARIA QUEBEC)
          (ORBITS JUPITER VULCAN)
          (CRAVES ABRASION OKRA)
          (CRAVES SCIATICA YOGURT)
          (CRAVES GRIEF OKRA)
          (EATS OKRA YOGURT)
          (EATS LEMON YOGURT)
          (HARMONY LEARNING JUPITER)
          (EATS YOGURT LEMON)
          (CRAVES ANGINA OKRA)
          (CRAVES LEARNING LEMON)
          (EATS CHOCOLATE OKRA)
          (CRAVES LONELINESS YOGURT))
   (:GOAL (AND (CRAVES BOILS CHOCOLATE))))

(DEFINE (PROBLEM MYSTY-A-11)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PEPPER LAMB TOMATO OKRA - FOOD
             REST - PLEASURE
             BOILS GRIEF ABRASION LONELINESS DREAD JEALOUSY - PAIN
             BAVARIA MANITOBA ALSACE - PROVINCE
             NEPTUNE PLUTO VULCAN JUPITER - PLANET)
   (:INIT (EATS OKRA PEPPER)
          (EATS PEPPER OKRA)
          (EATS PEPPER LAMB)
          (EATS OKRA TOMATO)
          (EATS LAMB TOMATO)
          (CRAVES LONELINESS TOMATO)
          (LOCALE LAMB BAVARIA)
          (CRAVES REST TOMATO)
          (CRAVES JEALOUSY OKRA)
          (CRAVES ABRASION TOMATO)
          (LOCALE OKRA MANITOBA)
          (ORBITS NEPTUNE PLUTO)
          (ATTACKS MANITOBA ALSACE)
          (EATS TOMATO LAMB)
          (LOCALE PEPPER ALSACE)
          (CRAVES BOILS PEPPER)
          (ORBITS PLUTO VULCAN)
          (ORBITS VULCAN JUPITER)
          (CRAVES GRIEF PEPPER)
          (HARMONY REST JUPITER)
          (ATTACKS BAVARIA MANITOBA)
          (EATS TOMATO OKRA)
          (LOCALE TOMATO MANITOBA)
          (CRAVES DREAD OKRA)
          (EATS LAMB PEPPER))
   (:GOAL (AND (CRAVES LONELINESS PEPPER)
               (CRAVES DREAD LAMB))))

(DEFINE (PROBLEM MYSTY-A-12)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TURKEY PEA RICE HAM MARZIPAN SCALLOP MUTTON TOFU
             PISTACHIO SHRIMP CUCUMBER ONION FLOUNDER - FOOD
             ACHIEVEMENT LOVE EXCITEMENT UNDERSTANDING LEARNING LUBRICITY
             INTOXICATION - PLEASURE
             ANXIETY GRIEF DEPRESSION BOILS LACERATION DREAD JEALOUSY
             PROSTATITIS LONELINESS ANGER HANGOVER HANGOVER-2 ABRASION
             SCIATICA ANGINA ANGER-3 ANGINA-4 DREAD-1 ANXIETY-8
             LONELINESS-16 JEALOUSY-5 LACERATION-6 BOILS-7 DEPRESSION-12
             ABRASION-13 GRIEF-14 SCIATICA-15 DREAD-10 PROSTATITIS-11
             HANGOVER-31 ANGER-32 BOILS-9 GRIEF-27 JEALOUSY-28 ABRASION-29
             ANGINA-30 LONELINESS-23 PROSTATITIS-24 ANXIETY-25
             DEPRESSION-26 - PAIN
             PENNSYLVANIA ARIZONA OREGON - PROVINCE
             PLUTO MARS EARTH URANUS - PLANET)
   (:INIT (CRAVES ANGER HAM)
          (CRAVES ABRASION MARZIPAN)
          (EATS TOFU ONION)
          (CRAVES UNDERSTANDING PISTACHIO)
          (CRAVES ANGER-3 SCALLOP)
          (CRAVES BOILS-7 TOFU)
          (EATS HAM SCALLOP)
          (LOCALE MUTTON PENNSYLVANIA)
          (ORBITS MARS EARTH)
          (ORBITS PLUTO MARS)
          (EATS HAM MARZIPAN)
          (CRAVES DEPRESSION TURKEY)
          (ORBITS EARTH URANUS)
          (LOCALE MARZIPAN OREGON)
          (HARMONY LEARNING URANUS)
          (EATS SCALLOP PISTACHIO)
          (EATS SCALLOP FLOUNDER)
          (LOCALE ONION ARIZONA)
          (CRAVES HANGOVER HAM)
          (CRAVES LONELINESS-23 FLOUNDER)
          (HARMONY ACHIEVEMENT EARTH)
          (CRAVES INTOXICATION FLOUNDER)
          (EATS RICE TURKEY)
          (EATS SHRIMP PISTACHIO)
          (CRAVES HANGOVER-2 MARZIPAN)
          (EATS CUCUMBER SHRIMP)
          (EATS TOFU PISTACHIO)
          (CRAVES BOILS-9 CUCUMBER)
          (CRAVES ANXIETY-8 MUTTON)
          (CRAVES LOVE HAM)
          (EATS CUCUMBER TOFU)
          (CRAVES DREAD-1 SCALLOP)
          (EATS MUTTON TOFU)
          (CRAVES DEPRESSION-26 FLOUNDER)
          (EATS FLOUNDER SCALLOP)
          (EATS MUTTON PEA)
          (CRAVES LONELINESS HAM)
          (EATS PEA MARZIPAN)
          (LOCALE SCALLOP OREGON)
          (EATS TOFU MUTTON)
          (CRAVES ANGINA-4 SCALLOP)
          (CRAVES ANXIETY TURKEY)
          (HARMONY LOVE URANUS)
          (EATS PISTACHIO SHRIMP)
          (CRAVES PROSTATITIS-24 FLOUNDER)
          (EATS PISTACHIO SCALLOP)
          (LOCALE TURKEY PENNSYLVANIA)
          (HARMONY EXCITEMENT URANUS)
          (CRAVES LEARNING SHRIMP)
          (CRAVES JEALOUSY-28 ONION)
          (CRAVES ANGINA-30 ONION)
          (HARMONY LUBRICITY URANUS)
          (EATS ONION SCALLOP)
          (EATS PISTACHIO TOFU)
          (EATS SCALLOP ONION)
          (EATS PISTACHIO ONION)
          (LOCALE FLOUNDER ARIZONA)
          (CRAVES ANGER-32 CUCUMBER)
          (CRAVES SCIATICA MARZIPAN)
          (EATS TOFU CUCUMBER)
          (EATS PISTACHIO FLOUNDER)
          (CRAVES LACERATION-6 TOFU)
          (EATS PEA TURKEY)
          (EATS SHRIMP FLOUNDER)
          (EATS PEA MUTTON)
          (CRAVES DREAD PEA)
          (LOCALE RICE PENNSYLVANIA)
          (LOCALE HAM PENNSYLVANIA)
          (LOCALE CUCUMBER OREGON)
          (CRAVES JEALOUSY PEA)
          (HARMONY UNDERSTANDING EARTH)
          (CRAVES DREAD-10 SHRIMP)
          (EATS TURKEY PEA)
          (CRAVES ANGINA MARZIPAN)
          (CRAVES PROSTATITIS-11 SHRIMP)
          (CRAVES JEALOUSY-5 TOFU)
          (EATS SCALLOP HAM)
          (HARMONY INTOXICATION URANUS)
          (EATS MARZIPAN HAM)
          (EATS FLOUNDER SHRIMP)
          (EATS SHRIMP MUTTON)
          (CRAVES DEPRESSION-12 PISTACHIO)
          (CRAVES GRIEF-14 PISTACHIO)
          (EATS TURKEY RICE)
          (CRAVES EXCITEMENT TOFU)
          (LOCALE SHRIMP OREGON)
          (EATS FLOUNDER PISTACHIO)
          (CRAVES PROSTATITIS RICE)
          (ATTACKS ARIZONA OREGON)
          (EATS RICE HAM)
          (LOCALE PEA OREGON)
          (EATS SHRIMP CUCUMBER)
          (CRAVES GRIEF-27 ONION)
          (CRAVES LUBRICITY CUCUMBER)
          (CRAVES BOILS TURKEY)
          (CRAVES ABRASION-13 PISTACHIO)
          (CRAVES ACHIEVEMENT PEA)
          (CRAVES LACERATION PEA)
          (CRAVES HANGOVER-31 CUCUMBER)
          (EATS MARZIPAN PEA)
          (LOCALE TOFU PENNSYLVANIA)
          (CRAVES SCIATICA-15 PISTACHIO)
          (EATS HAM RICE)
          (CRAVES LONELINESS-16 TOFU)
          (CRAVES ABRASION-29 ONION)
          (CRAVES GRIEF TURKEY)
          (EATS ONION TOFU)
          (CRAVES ANXIETY-25 FLOUNDER)
          (LOCALE PISTACHIO PENNSYLVANIA)
          (EATS ONION PISTACHIO)
          (EATS MUTTON SHRIMP)
          (ATTACKS PENNSYLVANIA ARIZONA))
   (:GOAL (AND (CRAVES ANXIETY-25 FLOUNDER))))

(DEFINE (PROBLEM MYSTY-A-13)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TUNA CHOCOLATE WONDERBREAD PEAR LOBSTER GUAVA CHICKEN
             BROCCOLI MUFFIN SNICKERS SCALLOP LEMON PAPAYA KALE - FOOD
             REST EXCITEMENT - PLEASURE
             PROSTATITIS ANGINA ANGER GRIEF LACERATION LONELINESS ABRASION
             DREAD ANXIETY SCIATICA HANGOVER JEALOUSY BOILS DEPRESSION
             GRIEF-8 ABRASION-3 HANGOVER-4 LACERATION-1 ANXIETY-2
             SCIATICA-15 ANGER-16 JEALOUSY-5 LONELINESS-6 DREAD-7
             PROSTATITIS-13 DEPRESSION-14 DEPRESSION-32 SCIATICA-9
             LONELINESS-10 ANGINA-11 BOILS-12 - PAIN
             MANITOBA BAVARIA ARIZONA KENTUCKY - PROVINCE
             VENUS MARS NEPTUNE URANUS - PLANET)
   (:INIT (EATS TUNA GUAVA)
          (LOCALE SCALLOP KENTUCKY)
          (EATS SCALLOP KALE)
          (LOCALE GUAVA KENTUCKY)
          (CRAVES LONELINESS-6 BROCCOLI)
          (ATTACKS MANITOBA BAVARIA)
          (EATS SCALLOP LEMON)
          (EATS SCALLOP MUFFIN)
          (CRAVES PROSTATITIS-13 MUFFIN)
          (EATS SNICKERS BROCCOLI)
          (EATS GUAVA TUNA)
          (EATS KALE SCALLOP)
          (ATTACKS ARIZONA KENTUCKY)
          (EATS BROCCOLI SNICKERS)
          (EATS LEMON PAPAYA)
          (LOCALE SNICKERS BAVARIA)
          (EATS MUFFIN SNICKERS)
          (CRAVES DREAD-7 BROCCOLI)
          (EATS PAPAYA LEMON)
          (CRAVES HANGOVER PEAR)
          (ORBITS MARS NEPTUNE)
          (LOCALE CHICKEN BAVARIA)
          (CRAVES DEPRESSION-14 MUFFIN)
          (HARMONY EXCITEMENT MARS)
          (CRAVES ABRASION-3 CHICKEN)
          (CRAVES ANXIETY-2 CHICKEN)
          (CRAVES LACERATION WONDERBREAD)
          (EATS LOBSTER TUNA)
          (CRAVES SCIATICA-9 LEMON)
          (EATS PEAR WONDERBREAD)
          (ORBITS NEPTUNE URANUS)
          (CRAVES JEALOUSY LOBSTER)
          (EATS LEMON SCALLOP)
          (EATS PEAR BROCCOLI)
          (CRAVES EXCITEMENT PAPAYA)
          (CRAVES HANGOVER-4 CHICKEN)
          (CRAVES DEPRESSION LOBSTER)
          (CRAVES ANGER-16 BROCCOLI)
          (EATS WONDERBREAD CHICKEN)
          (EATS MUFFIN KALE)
          (CRAVES LONELINESS WONDERBREAD)
          (EATS CHOCOLATE LOBSTER)
          (EATS GUAVA CHICKEN)
          (CRAVES GRIEF WONDERBREAD)
          (LOCALE PEAR ARIZONA)
          (EATS CHICKEN WONDERBREAD)
          (LOCALE BROCCOLI MANITOBA)
          (EATS PAPAYA BROCCOLI)
          (CRAVES GRIEF-8 CHICKEN)
          (EATS SNICKERS MUFFIN)
          (CRAVES BOILS LOBSTER)
          (HARMONY REST URANUS)
          (LOCALE LEMON BAVARIA)
          (EATS CHOCOLATE PEAR)
          (CRAVES ANGINA TUNA)
          (CRAVES SCIATICA PEAR)
          (LOCALE PAPAYA MANITOBA)
          (CRAVES SCIATICA-15 BROCCOLI)
          (EATS TUNA LOBSTER)
          (EATS BROCCOLI PAPAYA)
          (CRAVES BOILS-12 LEMON)
          (EATS GUAVA LEMON)
          (CRAVES DEPRESSION-32 LEMON)
          (CRAVES ANXIETY PEAR)
          (CRAVES LONELINESS-10 LEMON)
          (EATS PEAR CHOCOLATE)
          (LOCALE MUFFIN MANITOBA)
          (EATS KALE MUFFIN)
          (LOCALE CHOCOLATE ARIZONA)
          (EATS MUFFIN SCALLOP)
          (CRAVES ANGER TUNA)
          (CRAVES DREAD WONDERBREAD)
          (LOCALE LOBSTER MANITOBA)
          (ATTACKS BAVARIA ARIZONA)
          (EATS BROCCOLI PEAR)
          (LOCALE KALE KENTUCKY)
          (LOCALE WONDERBREAD KENTUCKY)
          (CRAVES ANGINA-11 LEMON)
          (EATS LEMON GUAVA)
          (ORBITS VENUS MARS)
          (CRAVES LACERATION-1 CHICKEN)
          (EATS WONDERBREAD PEAR)
          (LOCALE TUNA MANITOBA)
          (CRAVES REST LEMON)
          (CRAVES JEALOUSY-5 BROCCOLI)
          (CRAVES ABRASION WONDERBREAD)
          (EATS LOBSTER CHOCOLATE)
          (CRAVES PROSTATITIS TUNA)
          (EATS CHICKEN GUAVA))
   (:GOAL (AND (CRAVES ABRASION-3 WONDERBREAD)
               (CRAVES ANXIETY-2 WONDERBREAD))))

(DEFINE (PROBLEM MYSTY-A-14)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TUNA HAM SNICKERS POPOVER CANTELOPE MARZIPAN PAPAYA
             FLOUNDER ONION MUFFIN SHRIMP LEMON SCALLOP SCALLION - FOOD
             INTOXICATION ACHIEVEMENT - PLEASURE
             ANGINA DREAD ANXIETY LACERATION LONELINESS ABRASION SCIATICA
             BOILS JEALOUSY DEPRESSION HANGOVER PROSTATITIS ANGER
             LACERATION-2 GRIEF - PAIN
             MANITOBA BAVARIA MORAVIA - PROVINCE
             MARS EARTH - PLANET)
   (:INIT (CRAVES PROSTATITIS LEMON)
          (HARMONY ACHIEVEMENT EARTH)
          (LOCALE PAPAYA MANITOBA)
          (EATS CANTELOPE MARZIPAN)
          (EATS MARZIPAN PAPAYA)
          (CRAVES LONELINESS PAPAYA)
          (EATS LEMON ONION)
          (LOCALE TUNA BAVARIA)
          (CRAVES ANGER SCALLOP)
          (EATS SCALLOP MUFFIN)
          (EATS PAPAYA MARZIPAN)
          (HARMONY INTOXICATION EARTH)
          (CRAVES DREAD SNICKERS)
          (EATS MUFFIN SCALLOP)
          (CRAVES JEALOUSY MUFFIN)
          (EATS ONION LEMON)
          (CRAVES GRIEF SCALLION)
          (CRAVES HANGOVER SHRIMP)
          (EATS CANTELOPE FLOUNDER)
          (CRAVES INTOXICATION ONION)
          (EATS SHRIMP LEMON)
          (EATS CANTELOPE HAM)
          (CRAVES ABRASION PAPAYA)
          (EATS LEMON SHRIMP)
          (LOCALE SNICKERS BAVARIA)
          (EATS FLOUNDER PAPAYA)
          (EATS HAM CANTELOPE)
          (LOCALE SHRIMP MANITOBA)
          (CRAVES ACHIEVEMENT LEMON)
          (CRAVES LACERATION CANTELOPE)
          (EATS MARZIPAN CANTELOPE)
          (EATS HAM TUNA)
          (EATS SCALLOP ONION)
          (LOCALE LEMON MORAVIA)
          (EATS HAM POPOVER)
          (EATS PAPAYA LEMON)
          (EATS MUFFIN SCALLION)
          (EATS SCALLION SHRIMP)
          (EATS SNICKERS POPOVER)
          (EATS HAM SNICKERS)
          (LOCALE SCALLION BAVARIA)
          (LOCALE ONION BAVARIA)
          (CRAVES BOILS MUFFIN)
          (EATS TUNA HAM)
          (LOCALE HAM BAVARIA)
          (EATS POPOVER SNICKERS)
          (EATS SHRIMP SCALLION)
          (LOCALE MARZIPAN BAVARIA)
          (LOCALE MUFFIN BAVARIA)
          (CRAVES SCIATICA FLOUNDER)
          (CRAVES LACERATION-2 SCALLION)
          (EATS LEMON PAPAYA)
          (CRAVES ANGINA TUNA)
          (EATS POPOVER HAM)
          (EATS ONION SCALLOP)
          (ATTACKS BAVARIA MORAVIA)
          (LOCALE CANTELOPE BAVARIA)
          (CRAVES ANXIETY POPOVER)
          (ORBITS MARS EARTH)
          (ATTACKS MANITOBA BAVARIA)
          (LOCALE SCALLOP BAVARIA)
          (LOCALE FLOUNDER MANITOBA)
          (EATS SCALLION MUFFIN)
          (EATS POPOVER TUNA)
          (EATS FLOUNDER CANTELOPE)
          (EATS SNICKERS HAM)
          (EATS PAPAYA FLOUNDER)
          (LOCALE POPOVER MANITOBA)
          (CRAVES DEPRESSION MUFFIN)
          (EATS TUNA POPOVER))
   (:GOAL (AND (CRAVES ANGER TUNA))))

(DEFINE (PROBLEM MYSTY-A-15)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LOBSTER WURST BROCCOLI ARUGULA PAPAYA SCALLOP
             PISTACHIO SNICKERS ONION - FOOD
             LUBRICITY INTOXICATION - PLEASURE
             ANGINA BOILS HANGOVER PROSTATITIS ANGER DREAD ANXIETY
             LACERATION JEALOUSY GRIEF DEPRESSION LONELINESS SCIATICA
             ABRASION LONELINESS-4 HANGOVER-1 ANXIETY-2 SCIATICA-8 ANGER-3
             DREAD-7 - PAIN
             GUANABARA OREGON SURREY - PROVINCE
             JUPITER EARTH NEPTUNE MARS - PLANET)
   (:INIT (CRAVES DREAD WURST)
          (CRAVES DEPRESSION ARUGULA)
          (EATS ONION LOBSTER)
          (CRAVES LONELINESS PAPAYA)
          (CRAVES SCIATICA PAPAYA)
          (CRAVES HANGOVER-1 SCALLOP)
          (CRAVES SCIATICA-8 PISTACHIO)
          (CRAVES INTOXICATION PISTACHIO)
          (CRAVES ANGINA LOBSTER)
          (LOCALE BROCCOLI GUANABARA)
          (EATS PISTACHIO BROCCOLI)
          (CRAVES DREAD-7 ONION)
          (EATS WURST SNICKERS)
          (LOCALE SNICKERS SURREY)
          (EATS ARUGULA PAPAYA)
          (EATS PAPAYA LOBSTER)
          (EATS LOBSTER PAPAYA)
          (CRAVES HANGOVER LOBSTER)
          (EATS ONION SCALLOP)
          (CRAVES ANXIETY WURST)
          (CRAVES GRIEF ARUGULA)
          (EATS SCALLOP ONION)
          (EATS PISTACHIO WURST)
          (LOCALE ARUGULA GUANABARA)
          (LOCALE WURST GUANABARA)
          (CRAVES ABRASION PAPAYA)
          (EATS PAPAYA ARUGULA)
          (CRAVES BOILS LOBSTER)
          (EATS LOBSTER ONION)
          (ORBITS NEPTUNE MARS)
          (EATS SNICKERS ARUGULA)
          (CRAVES ANGER-3 PISTACHIO)
          (LOCALE ONION SURREY)
          (EATS ARUGULA SNICKERS)
          (HARMONY LUBRICITY NEPTUNE)
          (EATS SNICKERS WURST)
          (HARMONY INTOXICATION MARS)
          (LOCALE PISTACHIO GUANABARA)
          (EATS WURST PISTACHIO)
          (CRAVES ANGER LOBSTER)
          (CRAVES JEALOUSY WURST)
          (EATS BROCCOLI PISTACHIO)
          (ORBITS EARTH NEPTUNE)
          (CRAVES LUBRICITY BROCCOLI)
          (CRAVES ANXIETY-2 SCALLOP)
          (LOCALE LOBSTER GUANABARA)
          (LOCALE SCALLOP OREGON)
          (ATTACKS GUANABARA OREGON)
          (LOCALE PAPAYA GUANABARA)
          (ORBITS JUPITER EARTH)
          (CRAVES LONELINESS-4 SCALLOP)
          (EATS SCALLOP BROCCOLI)
          (CRAVES PROSTATITIS LOBSTER)
          (CRAVES LACERATION WURST)
          (EATS BROCCOLI SCALLOP)
          (ATTACKS OREGON SURREY))
   (:GOAL (AND (CRAVES DREAD-7 LOBSTER))))

(DEFINE (PROBLEM MYSTY-A-16)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS MUTTON SCALLION RICE PEAR HAM CHICKEN APPLE BEEF
             SWEETROLL COD - FOOD
             STIMULATION - PLEASURE
             ANGER JEALOUSY DREAD GRIEF LACERATION PROSTATITIS
             DEPRESSION ANXIETY LONELINESS ABRASION BOILS ANGINA - PAIN
             MANITOBA SURREY PENNSYLVANIA QUEBEC - PROVINCE
             EARTH JUPITER NEPTUNE - PLANET)
   (:INIT (LOCALE APPLE MANITOBA)
          (EATS RICE SCALLION)
          (EATS SWEETROLL BEEF)
          (EATS APPLE CHICKEN)
          (EATS RICE COD)
          (EATS HAM PEAR)
          (CRAVES STIMULATION PEAR)
          (EATS CHICKEN BEEF)
          (EATS SCALLION PEAR)
          (LOCALE PEAR MANITOBA)
          (EATS PEAR HAM)
          (EATS SCALLION MUTTON)
          (ATTACKS MANITOBA SURREY)
          (EATS HAM MUTTON)
          (EATS COD PEAR)
          (CRAVES BOILS COD)
          (EATS RICE PEAR)
          (ORBITS JUPITER NEPTUNE)
          (EATS COD RICE)
          (EATS SWEETROLL COD)
          (CRAVES ANGER MUTTON)
          (EATS MUTTON SCALLION)
          (LOCALE MUTTON QUEBEC)
          (LOCALE RICE SURREY)
          (EATS PEAR COD)
          (CRAVES DEPRESSION APPLE)
          (EATS SCALLION RICE)
          (ATTACKS SURREY PENNSYLVANIA)
          (CRAVES GRIEF SCALLION)
          (HARMONY STIMULATION NEPTUNE)
          (EATS COD APPLE)
          (CRAVES ANXIETY SWEETROLL)
          (CRAVES LONELINESS SWEETROLL)
          (LOCALE HAM SURREY)
          (CRAVES JEALOUSY MUTTON)
          (LOCALE CHICKEN PENNSYLVANIA)
          (CRAVES DREAD SCALLION)
          (EATS BEEF CHICKEN)
          (EATS COD SWEETROLL)
          (ATTACKS PENNSYLVANIA QUEBEC)
          (LOCALE SWEETROLL PENNSYLVANIA)
          (LOCALE COD SURREY)
          (CRAVES ABRASION SWEETROLL)
          (CRAVES ANGINA COD)
          (CRAVES PROSTATITIS APPLE)
          (CRAVES LACERATION APPLE)
          (EATS PEAR RICE)
          (EATS CHICKEN APPLE)
          (EATS APPLE COD)
          (LOCALE BEEF QUEBEC)
          (EATS MUTTON HAM)
          (ORBITS EARTH JUPITER)
          (LOCALE SCALLION SURREY)
          (EATS PEAR SCALLION)
          (EATS BEEF SWEETROLL))
   (:GOAL (AND (CRAVES GRIEF SWEETROLL))))

(DEFINE (PROBLEM MYSTY-A-17)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS CUCUMBER TOMATO CANTELOPE PEAR SNICKERS LOBSTER PORK
             CHICKEN TURKEY MUTTON HAROSET BEEF SWEETROLL GRAPEFRUIT TOFU
             HAM HOTDOG BACON ORANGE LETTUCE - FOOD
             LUBRICITY SATISFACTION SATIETY LEARNING STIMULATION CURIOSITY
             - PLEASURE
             PROSTATITIS LACERATION ANXIETY HANGOVER LONELINESS JEALOUSY
             ANGINA ANGER DEPRESSION GRIEF BOILS DREAD-1 DEPRESSION-2
             DREAD ABRASION SCIATICA ABRASION-3 SCIATICA-4 ANGINA-16
             PROSTATITIS-5 ANGER-6 GRIEF-7 LONELINESS-8 LACERATION-13
             HANGOVER-14 BOILS-15 JEALOUSY-12 ANGINA-32 PROSTATITIS-9
             HANGOVER-10 ANXIETY-11 LACERATION-30 SCIATICA-31 ANGER-29
             DEPRESSION-24 GRIEF-25 JEALOUSY-26 ANXIETY-27 BOILS-28 ABRASION-22
             LONELINESS-23 DREAD-21 - PAIN
             GUANABARA OREGON MORAVIA BAVARIA - PROVINCE
             URANUS MARS EARTH JUPITER - PLANET)
   (:INIT (CRAVES ABRASION-3 LOBSTER)
          (EATS TURKEY BEEF)
          (LOCALE BEEF MORAVIA)
          (EATS ORANGE GRAPEFRUIT)
          (CRAVES SCIATICA-4 LOBSTER)
          (CRAVES STIMULATION ORANGE)
          (EATS ORANGE HAM)
          (HARMONY STIMULATION EARTH)
          (EATS TOMATO PEAR)
          (EATS CUCUMBER PORK)
          (CRAVES ANXIETY-11 GRAPEFRUIT)
          (CRAVES BOILS-15 CHICKEN)
          (LOCALE HOTDOG MORAVIA)
          (EATS PEAR LOBSTER)
          (EATS TOMATO SNICKERS)
          (EATS SNICKERS CHICKEN)
          (EATS HAM TOFU)
          (EATS GRAPEFRUIT LETTUCE)
          (CRAVES DREAD-1 SNICKERS)
          (EATS LOBSTER CANTELOPE)
          (EATS GRAPEFRUIT ORANGE)
          (EATS SNICKERS TOMATO)
          (HARMONY LEARNING MARS)
          (EATS LOBSTER PEAR)
          (CRAVES ANGER PEAR)
          (CRAVES JEALOUSY-26 HOTDOG)
          (CRAVES PROSTATITIS CUCUMBER)
          (EATS MUTTON SWEETROLL)
          (EATS HAM SWEETROLL)
          (EATS CHICKEN SNICKERS)
          (EATS PEAR TOMATO)
          (EATS BEEF PEAR)
          (CRAVES LACERATION-13 CHICKEN)
          (LOCALE BACON GUANABARA)
          (CRAVES BOILS-28 HOTDOG)
          (EATS PORK CANTELOPE)
          (EATS LETTUCE HOTDOG)
          (LOCALE LOBSTER OREGON)
          (CRAVES SATISFACTION BEEF)
          (ORBITS MARS EARTH)
          (CRAVES LONELINESS-8 PORK)
          (EATS CANTELOPE LOBSTER)
          (EATS TURKEY LETTUCE)
          (CRAVES PROSTATITIS-9 GRAPEFRUIT)
          (CRAVES PROSTATITIS-5 PORK)
          (ATTACKS MORAVIA BAVARIA)
          (HARMONY CURIOSITY MARS)
          (CRAVES DEPRESSION-2 SNICKERS)
          (CRAVES DEPRESSION-24 HOTDOG)
          (CRAVES ANXIETY CUCUMBER)
          (LOCALE CHICKEN OREGON)
          (EATS HOTDOG LETTUCE)
          (CRAVES BOILS PEAR)
          (EATS HAROSET BACON)
          (CRAVES SCIATICA SNICKERS)
          (EATS CUCUMBER CHICKEN)
          (CRAVES ANGINA CANTELOPE)
          (CRAVES GRIEF-7 PORK)
          (CRAVES HANGOVER-14 CHICKEN)
          (CRAVES SCIATICA-31 TOFU)
          (EATS TOFU BEEF)
          (ATTACKS OREGON MORAVIA)
          (LOCALE TURKEY GUANABARA)
          (EATS SWEETROLL MUTTON)
          (EATS TOFU HAM)
          (LOCALE HAM MORAVIA)
          (EATS BACON HOTDOG)
          (CRAVES LEARNING BACON)
          (CRAVES ABRASION SNICKERS)
          (EATS BACON MUTTON)
          (LOCALE CANTELOPE BAVARIA)
          (EATS HAM ORANGE)
          (EATS HOTDOG BACON)
          (EATS LOBSTER BACON)
          (ORBITS URANUS MARS)
          (LOCALE HAROSET OREGON)
          (CRAVES DREAD SNICKERS)
          (LOCALE ORANGE MORAVIA)
          (CRAVES LONELINESS TOMATO)
          (CRAVES LACERATION CUCUMBER)
          (LOCALE MUTTON GUANABARA)
          (CRAVES ANGINA-32 GRAPEFRUIT)
          (HARMONY SATISFACTION JUPITER)
          (EATS LETTUCE GRAPEFRUIT)
          (CRAVES LUBRICITY PORK)
          (EATS BACON HAROSET)
          (LOCALE TOFU BAVARIA)
          (CRAVES DEPRESSION PEAR)
          (LOCALE SNICKERS MORAVIA)
          (EATS CHICKEN CUCUMBER)
          (CRAVES ANGER-6 PORK)
          (LOCALE TOMATO OREGON)
          (CRAVES GRIEF-25 HOTDOG)
          (EATS HAROSET ORANGE)
          (LOCALE GRAPEFRUIT OREGON)
          (EATS PEAR BEEF)
          (CRAVES ABRASION-22 BACON)
          (LOCALE CUCUMBER OREGON)
          (EATS LETTUCE TURKEY)
          (EATS BEEF TOFU)
          (EATS PORK CUCUMBER)
          (CRAVES HANGOVER CUCUMBER)
          (LOCALE PORK BAVARIA)
          (LOCALE PEAR BAVARIA)
          (CRAVES ANXIETY-27 HOTDOG)
          (CRAVES HANGOVER-10 GRAPEFRUIT)
          (ATTACKS GUANABARA OREGON)
          (CRAVES LACERATION-30 TOFU)
          (CRAVES ANGER-29 HAM)
          (CRAVES DREAD-21 ORANGE)
          (EATS CANTELOPE PORK)
          (EATS ORANGE HAROSET)
          (CRAVES GRIEF PEAR)
          (EATS MUTTON BACON)
          (HARMONY LUBRICITY JUPITER)
          (CRAVES JEALOUSY-12 MUTTON)
          (EATS BEEF TURKEY)
          (HARMONY SATIETY JUPITER)
          (CRAVES SATIETY GRAPEFRUIT)
          (CRAVES LONELINESS-23 BACON)
          (CRAVES JEALOUSY TOMATO)
          (EATS SWEETROLL HAM)
          (CRAVES CURIOSITY LETTUCE)
          (LOCALE LETTUCE GUANABARA)
          (ORBITS EARTH JUPITER)
          (EATS BACON LOBSTER)
          (LOCALE SWEETROLL MORAVIA)
          (CRAVES ANGINA-16 PORK))
   (:GOAL (AND (CRAVES ANGINA HOTDOG)
               (CRAVES HANGOVER-10 HOTDOG))))

(DEFINE (PROBLEM MYSTY-A-18)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS ARUGULA WURST LOBSTER TUNA TURKEY APPLE - FOOD
             AESTHETICS UNDERSTANDING STIMULATION EXCITEMENT EXPECTATION
             - PLEASURE
             JEALOUSY SCIATICA PROSTATITIS GRIEF DREAD HANGOVER - PAIN
             GUANABARA MORAVIA MANITOBA - PROVINCE
             JUPITER URANUS NEPTUNE MARS - PLANET)
   (:INIT (EATS ARUGULA LOBSTER)
          (ORBITS NEPTUNE MARS)
          (CRAVES STIMULATION LOBSTER)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS TURKEY TUNA)
          (EATS APPLE WURST)
          (CRAVES GRIEF ARUGULA)
          (CRAVES AESTHETICS ARUGULA)
          (EATS LOBSTER ARUGULA)
          (LOCALE LOBSTER GUANABARA)
          (EATS WURST TURKEY)
          (EATS TUNA TURKEY)
          (LOCALE TURKEY MORAVIA)
          (CRAVES JEALOUSY ARUGULA)
          (EATS APPLE ARUGULA)
          (EATS WURST APPLE)
          (CRAVES EXPECTATION APPLE)
          (HARMONY AESTHETICS NEPTUNE)
          (EATS TUNA LOBSTER)
          (LOCALE WURST GUANABARA)
          (CRAVES EXCITEMENT TUNA)
          (CRAVES DREAD WURST)
          (CRAVES SCIATICA ARUGULA)
          (ATTACKS GUANABARA MORAVIA)
          (HARMONY STIMULATION MARS)
          (CRAVES HANGOVER TUNA)
          (LOCALE ARUGULA GUANABARA)
          (EATS ARUGULA APPLE)
          (EATS TURKEY WURST)
          (LOCALE TUNA MANITOBA)
          (CRAVES UNDERSTANDING WURST)
          (EATS LOBSTER TUNA)
          (LOCALE APPLE GUANABARA)
          (HARMONY UNDERSTANDING MARS)
          (CRAVES PROSTATITIS ARUGULA)
          (ORBITS URANUS NEPTUNE)
          (ATTACKS MORAVIA MANITOBA)
          (HARMONY EXPECTATION MARS)
          (ORBITS JUPITER URANUS))
   (:GOAL (AND (CRAVES HANGOVER APPLE))))

(DEFINE (PROBLEM MYSTY-A-19)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SHRIMP CHOCOLATE MARZIPAN PEPPER LEMON PAPAYA ONION
             SCALLOP SNICKERS HAROSET TURKEY CHICKEN FLOUNDER LETTUCE TOFU
             POPOVER WURST - FOOD
             INTOXICATION LOVE STIMULATION SATIETY REST EMPATHY UNDERSTANDING
             LEARNING EXCITEMENT LUBRICITY - PLEASURE
             ANXIETY LACERATION GRIEF ANGER PROSTATITIS ABRASION ANGINA
             SCIATICA BOILS LONELINESS DEPRESSION JEALOUSY HANGOVER DREAD
             ANXIETY-1 ANGINA-2 SCIATICA-4 JEALOUSY-3 BOILS-7 ANGER-8
             LACERATION-5 HANGOVER-6 - PAIN
             GUANABARA QUEBEC MANITOBA ALSACE OREGON ARIZONA - PROVINCE
             MARS SATURN URANUS EARTH - PLANET)
   (:INIT (EATS ONION SHRIMP)
          (CRAVES REST HAROSET)
          (EATS POPOVER TOFU)
          (EATS CHOCOLATE SHRIMP)
          (CRAVES DEPRESSION PAPAYA)
          (EATS HAROSET ONION)
          (LOCALE SCALLOP ALSACE)
          (EATS FLOUNDER POPOVER)
          (EATS LETTUCE WURST)
          (ATTACKS GUANABARA QUEBEC)
          (EATS POPOVER FLOUNDER)
          (CRAVES LEARNING LETTUCE)
          (CRAVES EXCITEMENT TOFU)
          (EATS FLOUNDER CHICKEN)
          (CRAVES HANGOVER ONION)
          (CRAVES ABRASION PEPPER)
          (LOCALE TOFU QUEBEC)
          (EATS PEPPER LEMON)
          (LOCALE HAROSET GUANABARA)
          (CRAVES SCIATICA LEMON)
          (CRAVES DREAD ONION)
          (HARMONY LUBRICITY URANUS)
          (ATTACKS MANITOBA ALSACE)
          (LOCALE SHRIMP GUANABARA)
          (CRAVES ANGER-8 LETTUCE)
          (CRAVES UNDERSTANDING CHICKEN)
          (EATS MARZIPAN PEPPER)
          (CRAVES BOILS-7 LETTUCE)
          (CRAVES ANGINA LEMON)
          (EATS SCALLOP SNICKERS)
          (LOCALE LEMON ARIZONA)
          (LOCALE POPOVER QUEBEC)
          (EATS MARZIPAN SHRIMP)
          (HARMONY REST SATURN)
          (CRAVES JEALOUSY ONION)
          (CRAVES ANGINA-2 HAROSET)
          (EATS ONION PAPAYA)
          (ORBITS SATURN URANUS)
          (EATS SNICKERS WURST)
          (HARMONY INTOXICATION SATURN)
          (ORBITS URANUS EARTH)
          (CRAVES BOILS LEMON)
          (EATS FLOUNDER WURST)
          (HARMONY SATIETY URANUS)
          (CRAVES ANXIETY-1 HAROSET)
          (EATS SHRIMP ONION)
          (CRAVES GRIEF CHOCOLATE)
          (CRAVES LACERATION CHOCOLATE)
          (EATS SHRIMP MARZIPAN)
          (HARMONY LEARNING SATURN)
          (EATS WURST LETTUCE)
          (LOCALE PAPAYA ALSACE)
          (CRAVES JEALOUSY-3 CHICKEN)
          (EATS CHICKEN TOFU)
          (EATS WURST FLOUNDER)
          (LOCALE PEPPER ARIZONA)
          (EATS PAPAYA TURKEY)
          (LOCALE MARZIPAN QUEBEC)
          (ORBITS MARS SATURN)
          (HARMONY LOVE SATURN)
          (CRAVES LACERATION-5 TOFU)
          (EATS SHRIMP CHOCOLATE)
          (CRAVES STIMULATION PEPPER)
          (ATTACKS ALSACE OREGON)
          (EATS SNICKERS SCALLOP)
          (CRAVES SATIETY SCALLOP)
          (EATS LETTUCE CHICKEN)
          (EATS CHICKEN FLOUNDER)
          (ATTACKS QUEBEC MANITOBA)
          (HARMONY UNDERSTANDING URANUS)
          (EATS TOFU CHICKEN)
          (LOCALE WURST GUANABARA)
          (EATS CHICKEN LETTUCE)
          (EATS SCALLOP TURKEY)
          (EATS CHOCOLATE LEMON)
          (CRAVES HANGOVER-6 TOFU)
          (EATS SNICKERS HAROSET)
          (LOCALE TURKEY MANITOBA)
          (EATS LEMON PEPPER)
          (HARMONY STIMULATION SATURN)
          (CRAVES ANXIETY SHRIMP)
          (LOCALE ONION ALSACE)
          (EATS TURKEY SCALLOP)
          (LOCALE LETTUCE GUANABARA)
          (CRAVES INTOXICATION SHRIMP)
          (EATS TURKEY PAPAYA)
          (EATS PAPAYA ONION)
          (CRAVES SCIATICA-4 TURKEY)
          (HARMONY EMPATHY EARTH)
          (HARMONY EXCITEMENT EARTH)
          (LOCALE SNICKERS ALSACE)
          (CRAVES PROSTATITIS PEPPER)
          (CRAVES LUBRICITY WURST)
          (CRAVES LOVE MARZIPAN)
          (EATS ONION HAROSET)
          (LOCALE CHOCOLATE OREGON)
          (EATS LEMON CHOCOLATE)
          (EATS HAROSET SNICKERS)
          (CRAVES ANGER PEPPER)
          (CRAVES LONELINESS PAPAYA)
          (EATS WURST SNICKERS)
          (ATTACKS OREGON ARIZONA)
          (CRAVES EMPATHY TURKEY)
          (LOCALE FLOUNDER QUEBEC)
          (LOCALE CHICKEN ALSACE)
          (EATS PEPPER MARZIPAN)
          (EATS TOFU POPOVER))
   (:GOAL (AND (CRAVES JEALOUSY CHOCOLATE))))

(DEFINE (PROBLEM MYSTY-A-20)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TURKEY OKRA YOGURT SCALLION - FOOD
             REST - PLEASURE
             ABRASION ANGER HANGOVER - PAIN
             MANITOBA KENTUCKY GUANABARA GOIAS BAVARIA - PROVINCE
             NEPTUNE SATURN MARS VENUS - PLANET)
   (:INIT (EATS YOGURT SCALLION)
          (ATTACKS MANITOBA KENTUCKY)
          (LOCALE TURKEY GOIAS)
          (EATS OKRA SCALLION)
          (CRAVES REST OKRA)
          (EATS SCALLION TURKEY)
          (EATS OKRA TURKEY)
          (ORBITS NEPTUNE SATURN)
          (LOCALE YOGURT BAVARIA)
          (EATS OKRA YOGURT)
          (CRAVES ANGER SCALLION)
          (ATTACKS GUANABARA GOIAS)
          (EATS SCALLION YOGURT)
          (HARMONY REST VENUS)
          (ORBITS MARS VENUS)
          (EATS TURKEY OKRA)
          (LOCALE SCALLION GOIAS)
          (CRAVES ABRASION SCALLION)
          (EATS SCALLION OKRA)
          (ATTACKS GOIAS BAVARIA)
          (ATTACKS KENTUCKY GUANABARA)
          (ORBITS SATURN MARS)
          (EATS YOGURT OKRA)
          (LOCALE OKRA GUANABARA)
          (EATS TURKEY SCALLION)
          (CRAVES HANGOVER SCALLION))
   (:GOAL (AND (CRAVES ANGER TURKEY)
               (CRAVES ABRASION TURKEY))))

(DEFINE (PROBLEM MYSTY-A-21)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS OKRA GUAVA LETTUCE SNICKERS LOBSTER MUFFIN PORK SHRIMP
             SWEETROLL HOTDOG HAMBURGER WONDERBREAD PEA LAMB CHICKEN - FOOD
             TRIUMPH EMPATHY CURIOSITY INTOXICATION - PLEASURE
             BOILS HANGOVER ANGER PROSTATITIS GRIEF LONELINESS DREAD
             JEALOUSY - PAIN
             GUANABARA PENNSYLVANIA ALSACE - PROVINCE
             NEPTUNE URANUS PLUTO - PLANET)
   (:INIT (EATS WONDERBREAD CHICKEN)
          (EATS HOTDOG LOBSTER)
          (EATS PEA WONDERBREAD)
          (ATTACKS PENNSYLVANIA ALSACE)
          (HARMONY CURIOSITY PLUTO)
          (CRAVES GRIEF MUFFIN)
          (EATS GUAVA OKRA)
          (EATS WONDERBREAD PEA)
          (EATS CHICKEN WONDERBREAD)
          (LOCALE HOTDOG ALSACE)
          (HARMONY TRIUMPH PLUTO)
          (EATS SWEETROLL MUFFIN)
          (EATS OKRA GUAVA)
          (EATS HOTDOG PORK)
          (EATS LOBSTER MUFFIN)
          (EATS SNICKERS PORK)
          (EATS LETTUCE GUAVA)
          (EATS OKRA SNICKERS)
          (LOCALE WONDERBREAD PENNSYLVANIA)
          (LOCALE PEA GUANABARA)
          (EATS LETTUCE SNICKERS)
          (LOCALE CHICKEN PENNSYLVANIA)
          (LOCALE SWEETROLL GUANABARA)
          (EATS HOTDOG PEA)
          (EATS HAMBURGER LAMB)
          (CRAVES INTOXICATION CHICKEN)
          (EATS LOBSTER HOTDOG)
          (LOCALE LOBSTER ALSACE)
          (EATS OKRA LETTUCE)
          (EATS MUFFIN LOBSTER)
          (CRAVES EMPATHY SHRIMP)
          (EATS LETTUCE OKRA)
          (HARMONY EMPATHY URANUS)
          (EATS MUFFIN SWEETROLL)
          (EATS LAMB CHICKEN)
          (EATS LAMB HAMBURGER)
          (CRAVES PROSTATITIS MUFFIN)
          (CRAVES CURIOSITY WONDERBREAD)
          (CRAVES HANGOVER MUFFIN)
          (CRAVES JEALOUSY CHICKEN)
          (CRAVES LONELINESS LAMB)
          (EATS PEA HOTDOG)
          (ORBITS NEPTUNE URANUS)
          (EATS SHRIMP SWEETROLL)
          (EATS PORK HOTDOG)
          (EATS SHRIMP PORK)
          (LOCALE OKRA PENNSYLVANIA)
          (LOCALE GUAVA ALSACE)
          (LOCALE PORK ALSACE)
          (LOCALE LAMB GUANABARA)
          (ATTACKS GUANABARA PENNSYLVANIA)
          (EATS PEA HAMBURGER)
          (LOCALE HAMBURGER GUANABARA)
          (EATS PORK SHRIMP)
          (EATS SNICKERS LETTUCE)
          (EATS PORK SNICKERS)
          (CRAVES DREAD LAMB)
          (LOCALE SHRIMP ALSACE)
          (ORBITS URANUS PLUTO)
          (LOCALE MUFFIN GUANABARA)
          (CRAVES TRIUMPH PORK)
          (LOCALE SNICKERS ALSACE)
          (EATS HAMBURGER PEA)
          (EATS SWEETROLL SHRIMP)
          (CRAVES ANGER MUFFIN)
          (EATS CHICKEN LAMB)
          (CRAVES BOILS MUFFIN)
          (HARMONY INTOXICATION PLUTO)
          (LOCALE LETTUCE ALSACE)
          (EATS GUAVA LETTUCE)
          (EATS SNICKERS OKRA))
   (:GOAL (AND (CRAVES LONELINESS PEA))))

(DEFINE (PROBLEM MYSTY-A-22)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS CHICKEN TOFU SHRIMP POPOVER HAM HAROSET PISTACHIO
             ENDIVE SNICKERS MUFFIN - FOOD
             LEARNING EXCITEMENT - PLEASURE
             ANXIETY HANGOVER GRIEF DEPRESSION PROSTATITIS ANGINA ANGER
             LACERATION JEALOUSY DREAD SCIATICA LONELINESS BOILS HANGOVER-2
             ABRASION BOILS-4 GRIEF-1 - PAIN
             MANITOBA BAVARIA BOSNIA - PROVINCE
             PLUTO JUPITER NEPTUNE MARS - PLANET)
   (:INIT (CRAVES GRIEF-1 MUFFIN)
          (CRAVES DEPRESSION TOFU)
          (EATS POPOVER SHRIMP)
          (LOCALE ENDIVE BAVARIA)
          (HARMONY LEARNING MARS)
          (ATTACKS MANITOBA BAVARIA)
          (CRAVES DREAD HAM)
          (EATS MUFFIN PISTACHIO)
          (LOCALE POPOVER BOSNIA)
          (LOCALE TOFU MANITOBA)
          (EATS PISTACHIO HAM)
          (EATS HAROSET ENDIVE)
          (CRAVES ANXIETY CHICKEN)
          (EATS SHRIMP TOFU)
          (EATS ENDIVE HAROSET)
          (CRAVES JEALOUSY POPOVER)
          (EATS MUFFIN SHRIMP)
          (EATS ENDIVE PISTACHIO)
          (CRAVES ABRASION SNICKERS)
          (CRAVES EXCITEMENT SNICKERS)
          (EATS TOFU SHRIMP)
          (CRAVES SCIATICA HAM)
          (EATS SNICKERS POPOVER)
          (EATS HAM SNICKERS)
          (ATTACKS BAVARIA BOSNIA)
          (CRAVES GRIEF CHICKEN)
          (EATS PISTACHIO MUFFIN)
          (CRAVES LONELINESS HAROSET)
          (CRAVES BOILS-4 MUFFIN)
          (EATS HAROSET PISTACHIO)
          (CRAVES BOILS HAROSET)
          (EATS SHRIMP POPOVER)
          (EATS SNICKERS HAM)
          (LOCALE PISTACHIO BAVARIA)
          (LOCALE MUFFIN BAVARIA)
          (EATS HAM PISTACHIO)
          (CRAVES HANGOVER-2 SNICKERS)
          (EATS TOFU CHICKEN)
          (CRAVES ANGINA SHRIMP)
          (CRAVES PROSTATITIS SHRIMP)
          (EATS MUFFIN SNICKERS)
          (LOCALE SNICKERS BAVARIA)
          (LOCALE SHRIMP BAVARIA)
          (EATS PISTACHIO HAROSET)
          (EATS CHICKEN TOFU)
          (LOCALE HAM BAVARIA)
          (EATS POPOVER SNICKERS)
          (ORBITS NEPTUNE MARS)
          (EATS SNICKERS HAROSET)
          (CRAVES ANGER SHRIMP)
          (CRAVES LEARNING HAROSET)
          (EATS PISTACHIO ENDIVE)
          (LOCALE CHICKEN MANITOBA)
          (EATS CHICKEN POPOVER)
          (ORBITS JUPITER NEPTUNE)
          (EATS POPOVER CHICKEN)
          (CRAVES LACERATION POPOVER)
          (EATS HAROSET SNICKERS)
          (CRAVES HANGOVER CHICKEN)
          (EATS SNICKERS MUFFIN)
          (ORBITS PLUTO JUPITER)
          (HARMONY EXCITEMENT JUPITER)
          (LOCALE HAROSET BAVARIA)
          (EATS SHRIMP MUFFIN))
   (:GOAL (AND (CRAVES LONELINESS TOFU))))

(DEFINE (PROBLEM MYSTY-A-23)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS ORANGE WURST HAROSET HOTDOG GRAPEFRUIT KALE CHOCOLATE
             PEA PEAR ONION SNICKERS - FOOD
             CURIOSITY LUBRICITY EXCITEMENT - PLEASURE
             GRIEF PROSTATITIS SCIATICA DREAD HANGOVER DEPRESSION
             ABRASION LACERATION ANGER BOILS LONELINESS - PAIN
             OREGON GOIAS BAVARIA KENTUCKY MANITOBA ARIZONA MORAVIA
             - PROVINCE
             PLUTO URANUS MARS EARTH - PLANET)
   (:INIT (ORBITS PLUTO URANUS)
          (LOCALE CHOCOLATE BAVARIA)
          (EATS GRAPEFRUIT HAROSET)
          (LOCALE HAROSET KENTUCKY)
          (EATS KALE PEAR)
          (HARMONY EXCITEMENT URANUS)
          (CRAVES DREAD HOTDOG)
          (CRAVES LUBRICITY HAROSET)
          (EATS ONION SNICKERS)
          (ATTACKS BAVARIA KENTUCKY)
          (ORBITS MARS EARTH)
          (EATS PEAR KALE)
          (EATS HOTDOG GRAPEFRUIT)
          (ATTACKS KENTUCKY MANITOBA)
          (EATS PEAR HAROSET)
          (CRAVES LACERATION PEA)
          (ATTACKS ARIZONA MORAVIA)
          (LOCALE HOTDOG GOIAS)
          (EATS SNICKERS PEA)
          (ATTACKS MANITOBA ARIZONA)
          (EATS ORANGE WURST)
          (CRAVES EXCITEMENT PEA)
          (CRAVES LONELINESS SNICKERS)
          (CRAVES SCIATICA HAROSET)
          (LOCALE ONION GOIAS)
          (EATS SNICKERS ONION)
          (CRAVES PROSTATITIS WURST)
          (CRAVES HANGOVER GRAPEFRUIT)
          (EATS HOTDOG HAROSET)
          (EATS KALE CHOCOLATE)
          (EATS WURST ORANGE)
          (CRAVES ABRASION CHOCOLATE)
          (CRAVES CURIOSITY WURST)
          (CRAVES ANGER PEAR)
          (ORBITS URANUS MARS)
          (EATS PEA SNICKERS)
          (HARMONY CURIOSITY EARTH)
          (LOCALE WURST ARIZONA)
          (LOCALE GRAPEFRUIT MORAVIA)
          (EATS HAROSET PEAR)
          (LOCALE KALE MANITOBA)
          (HARMONY LUBRICITY URANUS)
          (LOCALE ORANGE MANITOBA)
          (LOCALE PEAR MANITOBA)
          (EATS CHOCOLATE PEA)
          (ATTACKS GOIAS BAVARIA)
          (EATS HAROSET GRAPEFRUIT)
          (EATS HAROSET HOTDOG)
          (EATS HAROSET ORANGE)
          (EATS ORANGE HAROSET)
          (EATS ONION PEAR)
          (EATS PEAR ONION)
          (ATTACKS OREGON GOIAS)
          (LOCALE SNICKERS GOIAS)
          (CRAVES GRIEF ORANGE)
          (EATS GRAPEFRUIT WURST)
          (LOCALE PEA GOIAS)
          (EATS PEA CHOCOLATE)
          (EATS CHOCOLATE KALE)
          (CRAVES DEPRESSION KALE)
          (CRAVES BOILS ONION)
          (EATS WURST GRAPEFRUIT)
          (EATS GRAPEFRUIT HOTDOG))
   (:GOAL (AND (CRAVES LONELINESS ONION))))

(DEFINE (PROBLEM MYSTY-A-24)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS HAM TURKEY LOBSTER SCALLION CHERRY PEA TOMATO - FOOD
             CURIOSITY LOVE LEARNING - PLEASURE
             DREAD DEPRESSION - PAIN
             MORAVIA ALSACE MANITOBA - PROVINCE
             JUPITER VENUS URANUS SATURN - PLANET)
   (:INIT (HARMONY CURIOSITY URANUS)
          (CRAVES CURIOSITY HAM)
          (EATS TURKEY HAM)
          (EATS LOBSTER TOMATO)
          (EATS LOBSTER PEA)
          (CRAVES LEARNING PEA)
          (ATTACKS ALSACE MANITOBA)
          (LOCALE CHERRY MANITOBA)
          (LOCALE TURKEY MANITOBA)
          (HARMONY LEARNING SATURN)
          (LOCALE LOBSTER MANITOBA)
          (EATS CHERRY PEA)
          (EATS LOBSTER SCALLION)
          (EATS SCALLION LOBSTER)
          (CRAVES DEPRESSION PEA)
          (EATS HAM TURKEY)
          (EATS PEA CHERRY)
          (EATS SCALLION TURKEY)
          (LOCALE SCALLION MANITOBA)
          (LOCALE TOMATO ALSACE)
          (ORBITS VENUS URANUS)
          (EATS TURKEY SCALLION)
          (LOCALE PEA MANITOBA)
          (CRAVES DREAD SCALLION)
          (ORBITS JUPITER VENUS)
          (CRAVES LOVE LOBSTER)
          (EATS HAM TOMATO)
          (ORBITS URANUS SATURN)
          (EATS TOMATO LOBSTER)
          (EATS CHERRY SCALLION)
          (LOCALE HAM ALSACE)
          (EATS PEA LOBSTER)
          (EATS SCALLION CHERRY)
          (HARMONY LOVE SATURN)
          (EATS TOMATO HAM)
          (ATTACKS MORAVIA ALSACE))
   (:GOAL (AND (CRAVES DEPRESSION CHERRY))))

(DEFINE (PROBLEM MYSTY-A-25)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS HAM YOGURT CHOCOLATE SCALLOP PORK CHERRY FLOUNDER
             CHICKEN ARUGULA ORANGE LEMON MARZIPAN - FOOD
             LUBRICITY EXPECTATION - PLEASURE
             HANGOVER GRIEF PROSTATITIS ANGINA ANXIETY SCIATICA DEPRESSION
             ANGER - PAIN
             SURREY GOIAS KENTUCKY - PROVINCE
             URANUS MERCURY JUPITER EARTH - PLANET)
   (:INIT (EATS PORK YOGURT)
          (CRAVES LUBRICITY FLOUNDER)
          (LOCALE ORANGE SURREY)
          (CRAVES ANXIETY CHERRY)
          (EATS CHICKEN ARUGULA)
          (EATS SCALLOP YOGURT)
          (EATS CHERRY HAM)
          (EATS ARUGULA CHICKEN)
          (EATS ORANGE LEMON)
          (EATS FLOUNDER SCALLOP)
          (HARMONY LUBRICITY MERCURY)
          (LOCALE CHOCOLATE KENTUCKY)
          (EATS MARZIPAN LEMON)
          (EATS ORANGE CHICKEN)
          (EATS YOGURT SCALLOP)
          (ORBITS JUPITER EARTH)
          (EATS MARZIPAN ARUGULA)
          (EATS CHERRY PORK)
          (EATS FLOUNDER CHOCOLATE)
          (EATS HAM LEMON)
          (CRAVES EXPECTATION ORANGE)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS LEMON ORANGE)
          (CRAVES PROSTATITIS SCALLOP)
          (LOCALE CHICKEN SURREY)
          (CRAVES ANGINA CHERRY)
          (LOCALE PORK GOIAS)
          (EATS HAM CHERRY)
          (ORBITS URANUS MERCURY)
          (EATS CHOCOLATE HAM)
          (LOCALE YOGURT GOIAS)
          (LOCALE HAM KENTUCKY)
          (LOCALE SCALLOP SURREY)
          (LOCALE CHERRY GOIAS)
          (ORBITS MERCURY JUPITER)
          (HARMONY EXPECTATION EARTH)
          (EATS ARUGULA MARZIPAN)
          (LOCALE LEMON KENTUCKY)
          (EATS LEMON YOGURT)
          (EATS YOGURT PORK)
          (EATS CHOCOLATE FLOUNDER)
          (EATS YOGURT LEMON)
          (LOCALE FLOUNDER GOIAS)
          (ATTACKS SURREY GOIAS)
          (EATS CHICKEN ORANGE)
          (CRAVES DEPRESSION ARUGULA)
          (LOCALE ARUGULA SURREY)
          (CRAVES GRIEF CHOCOLATE)
          (EATS PORK CHERRY)
          (ATTACKS GOIAS KENTUCKY)
          (EATS HAM CHOCOLATE)
          (EATS LEMON HAM)
          (CRAVES SCIATICA ARUGULA)
          (EATS LEMON MARZIPAN)
          (EATS SCALLOP FLOUNDER)
          (CRAVES HANGOVER CHOCOLATE)
          (CRAVES ANGER ORANGE))
   (:GOAL (AND (CRAVES SCIATICA ORANGE))))

(DEFINE (PROBLEM MYSTY-A-26)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TOMATO GRAPEFRUIT PEAR CHICKEN SCALLION SHRIMP RICE
             BROCCOLI MUTTON HAM ARUGULA CUCUMBER KALE LETTUCE WONDERBREAD
             MARZIPAN TUNA COD - FOOD
             UNDERSTANDING - PLEASURE
             JEALOUSY HANGOVER ANGER ANXIETY ANGINA BOILS LONELINESS
             SCIATICA LACERATION GRIEF ABRASION PROSTATITIS - PAIN
             KENTUCKY MORAVIA BAVARIA GUANABARA ALSACE - PROVINCE
             MERCURY JUPITER EARTH MARS - PLANET)
   (:INIT (LOCALE KALE BAVARIA)
          (CRAVES JEALOUSY GRAPEFRUIT)
          (EATS WONDERBREAD LETTUCE)
          (EATS MUTTON LETTUCE)
          (EATS LETTUCE TUNA)
          (ORBITS JUPITER EARTH)
          (LOCALE TUNA KENTUCKY)
          (EATS TOMATO CHICKEN)
          (CRAVES ANGINA MUTTON)
          (ATTACKS GUANABARA ALSACE)
          (CRAVES ANXIETY RICE)
          (EATS SCALLION GRAPEFRUIT)
          (CRAVES ANGER SHRIMP)
          (EATS WONDERBREAD COD)
          (LOCALE COD BAVARIA)
          (EATS BROCCOLI MUTTON)
          (LOCALE WONDERBREAD MORAVIA)
          (EATS TUNA LETTUCE)
          (ATTACKS MORAVIA BAVARIA)
          (EATS CUCUMBER COD)
          (EATS RICE BROCCOLI)
          (EATS BROCCOLI RICE)
          (EATS PEAR TOMATO)
          (EATS TUNA MARZIPAN)
          (CRAVES BOILS HAM)
          (EATS KALE CUCUMBER)
          (EATS GRAPEFRUIT SCALLION)
          (LOCALE CHICKEN MORAVIA)
          (EATS CUCUMBER KALE)
          (CRAVES LACERATION KALE)
          (LOCALE CUCUMBER GUANABARA)
          (CRAVES GRIEF LETTUCE)
          (EATS SCALLION CHICKEN)
          (LOCALE SHRIMP BAVARIA)
          (EATS MUTTON HAM)
          (EATS TUNA KALE)
          (EATS LETTUCE KALE)
          (CRAVES ABRASION WONDERBREAD)
          (CRAVES LONELINESS ARUGULA)
          (EATS COD WONDERBREAD)
          (ORBITS EARTH MARS)
          (EATS HAM SHRIMP)
          (EATS SCALLION BROCCOLI)
          (ATTACKS KENTUCKY MORAVIA)
          (EATS GRAPEFRUIT PEAR)
          (EATS CHICKEN TOMATO)
          (CRAVES HANGOVER PEAR)
          (ORBITS MERCURY JUPITER)
          (EATS MUTTON BROCCOLI)
          (EATS SHRIMP RICE)
          (LOCALE HAM MORAVIA)
          (LOCALE GRAPEFRUIT MORAVIA)
          (LOCALE ARUGULA KENTUCKY)
          (LOCALE TOMATO BAVARIA)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS CHICKEN SCALLION)
          (EATS ARUGULA MARZIPAN)
          (EATS PEAR GRAPEFRUIT)
          (EATS RICE SHRIMP)
          (EATS LETTUCE MUTTON)
          (HARMONY UNDERSTANDING MARS)
          (EATS HAM MUTTON)
          (EATS KALE LETTUCE)
          (LOCALE PEAR MORAVIA)
          (CRAVES UNDERSTANDING ARUGULA)
          (LOCALE MUTTON ALSACE)
          (CRAVES SCIATICA CUCUMBER)
          (EATS LETTUCE WONDERBREAD)
          (EATS SHRIMP HAM)
          (EATS TOMATO PEAR)
          (LOCALE BROCCOLI MORAVIA)
          (CRAVES PROSTATITIS TUNA)
          (EATS ARUGULA WONDERBREAD)
          (LOCALE LETTUCE KENTUCKY)
          (ATTACKS BAVARIA GUANABARA)
          (EATS WONDERBREAD ARUGULA)
          (LOCALE RICE ALSACE)
          (LOCALE SCALLION BAVARIA)
          (EATS BROCCOLI SCALLION)
          (EATS COD CUCUMBER)
          (EATS MARZIPAN TUNA)
          (EATS MARZIPAN ARUGULA)
          (EATS KALE TUNA))
   (:GOAL (AND (CRAVES SCIATICA CHICKEN))))

(DEFINE (PROBLEM MYSTY-A-27)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LEMON WURST GRAPEFRUIT CHERRY PEPPER LAMB POPOVER
             LETTUCE BEEF ARUGULA ENDIVE LOBSTER WONDERBREAD SNICKERS
             MARZIPAN RICE TURKEY - FOOD
             REST ENTERTAINMENT STIMULATION ACHIEVEMENT EXPECTATION
             CURIOSITY SATISFACTION LUBRICITY - PLEASURE
             DEPRESSION ANGINA JEALOUSY ANXIETY SCIATICA ABRASION BOILS
             LONELINESS HANGOVER ANGER PROSTATITIS GRIEF DREAD LACERATION
             HANGOVER-4 BOILS-1 ANGINA-2 JEALOUSY-6 LACERATION-7 ABRASION-8
             ANGER-3 ANXIETY-5 SCIATICA-13 LONELINESS-14 GRIEF-15
             DREAD-16 GRIEF-32 BOILS-9 ANGINA-10 PROSTATITIS-11
             DEPRESSION-12 DREAD-31 DEPRESSION-27 SCIATICA-28 HANGOVER-29
             ANGER-30 JEALOUSY-25 PROSTATITIS-26 - PAIN
             ALSACE BOSNIA MORAVIA OREGON - PROVINCE
             URANUS EARTH VENUS SATURN - PLANET)
   (:INIT (EATS CHERRY LEMON)
          (LOCALE WONDERBREAD OREGON)
          (LOCALE ARUGULA OREGON)
          (LOCALE LETTUCE ALSACE)
          (EATS SNICKERS ARUGULA)
          (ORBITS VENUS SATURN)
          (EATS LETTUCE BEEF)
          (CRAVES ANGINA-2 LAMB)
          (EATS RICE MARZIPAN)
          (CRAVES GRIEF PEPPER)
          (EATS TURKEY ENDIVE)
          (LOCALE MARZIPAN BOSNIA)
          (EATS POPOVER LEMON)
          (CRAVES HANGOVER CHERRY)
          (EATS LAMB POPOVER)
          (EATS ENDIVE TURKEY)
          (CRAVES SCIATICA-13 ARUGULA)
          (CRAVES SCIATICA GRAPEFRUIT)
          (CRAVES ABRASION CHERRY)
          (LOCALE GRAPEFRUIT OREGON)
          (HARMONY ACHIEVEMENT SATURN)
          (CRAVES BOILS-1 LAMB)
          (LOCALE POPOVER OREGON)
          (LOCALE LEMON OREGON)
          (EATS TURKEY SNICKERS)
          (EATS GRAPEFRUIT CHERRY)
          (CRAVES PROSTATITIS-26 TURKEY)
          (EATS LEMON PEPPER)
          (CRAVES LONELINESS-14 ARUGULA)
          (CRAVES ANGINA WURST)
          (EATS WURST GRAPEFRUIT)
          (CRAVES HANGOVER-4 LAMB)
          (EATS LETTUCE POPOVER)
          (CRAVES GRIEF-32 ENDIVE)
          (CRAVES LONELINESS CHERRY)
          (CRAVES BOILS CHERRY)
          (CRAVES ANGER-3 POPOVER)
          (EATS LEMON POPOVER)
          (EATS LOBSTER WONDERBREAD)
          (CRAVES CURIOSITY BEEF)
          (CRAVES LACERATION-7 POPOVER)
          (LOCALE BEEF OREGON)
          (ATTACKS ALSACE BOSNIA)
          (CRAVES PROSTATITIS-11 ENDIVE)
          (LOCALE WURST BOSNIA)
          (CRAVES EXPECTATION POPOVER)
          (HARMONY CURIOSITY EARTH)
          (EATS SNICKERS TURKEY)
          (EATS MARZIPAN BEEF)
          (LOCALE PEPPER BOSNIA)
          (EATS ARUGULA SNICKERS)
          (LOCALE RICE BOSNIA)
          (HARMONY REST VENUS)
          (EATS WONDERBREAD RICE)
          (CRAVES ANXIETY-5 LETTUCE)
          (EATS ARUGULA MARZIPAN)
          (EATS PEPPER LEMON)
          (CRAVES DREAD PEPPER)
          (CRAVES REST LEMON)
          (LOCALE LOBSTER ALSACE)
          (CRAVES ACHIEVEMENT LAMB)
          (EATS WONDERBREAD TURKEY)
          (EATS BEEF LETTUCE)
          (ATTACKS MORAVIA OREGON)
          (CRAVES DEPRESSION LEMON)
          (CRAVES HANGOVER-29 MARZIPAN)
          (EATS GRAPEFRUIT WURST)
          (CRAVES LACERATION PEPPER)
          (CRAVES STIMULATION CHERRY)
          (CRAVES SATISFACTION LOBSTER)
          (CRAVES ABRASION-8 POPOVER)
          (CRAVES SCIATICA-28 MARZIPAN)
          (CRAVES ANGER CHERRY)
          (EATS WONDERBREAD LOBSTER)
          (CRAVES JEALOUSY WURST)
          (EATS CHERRY GRAPEFRUIT)
          (CRAVES BOILS-9 ENDIVE)
          (EATS MARZIPAN LOBSTER)
          (ATTACKS BOSNIA MORAVIA)
          (CRAVES ANGER-30 MARZIPAN)
          (CRAVES DEPRESSION-27 MARZIPAN)
          (HARMONY LUBRICITY SATURN)
          (EATS RICE ENDIVE)
          (CRAVES LUBRICITY MARZIPAN)
          (ORBITS EARTH VENUS)
          (EATS RICE WONDERBREAD)
          (EATS LAMB BEEF)
          (EATS PEPPER WURST)
          (CRAVES GRIEF-15 ARUGULA)
          (CRAVES ANXIETY GRAPEFRUIT)
          (EATS LEMON CHERRY)
          (CRAVES ENTERTAINMENT GRAPEFRUIT)
          (LOCALE TURKEY ALSACE)
          (LOCALE ENDIVE OREGON)
          (LOCALE SNICKERS BOSNIA)
          (CRAVES PROSTATITIS PEPPER)
          (EATS BEEF MARZIPAN)
          (EATS BEEF LAMB)
          (LOCALE LAMB MORAVIA)
          (EATS POPOVER LETTUCE)
          (CRAVES DREAD-16 ARUGULA)
          (CRAVES JEALOUSY-6 POPOVER)
          (EATS MARZIPAN ARUGULA)
          (HARMONY SATISFACTION VENUS)
          (EATS LOBSTER MARZIPAN)
          (EATS TURKEY WONDERBREAD)
          (CRAVES DEPRESSION-12 ENDIVE)
          (EATS MARZIPAN RICE)
          (HARMONY STIMULATION EARTH)
          (EATS POPOVER LAMB)
          (CRAVES ANGINA-10 ENDIVE)
          (ORBITS URANUS EARTH)
          (LOCALE CHERRY OREGON)
          (CRAVES DREAD-31 WONDERBREAD)
          (CRAVES JEALOUSY-25 TURKEY)
          (EATS WURST PEPPER)
          (EATS ENDIVE RICE)
          (HARMONY ENTERTAINMENT SATURN)
          (HARMONY EXPECTATION VENUS))
   (:GOAL (AND (CRAVES LACERATION WURST))))

(DEFINE (PROBLEM MYSTY-A-28)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS BEEF BROCCOLI MELON OKRA PAPAYA LETTUCE HAMBURGER
             POPOVER SCALLOP CHOCOLATE SHRIMP YOGURT ORANGE SNICKERS
             LOBSTER PEA LEMON - FOOD
             INTOXICATION SATIETY EXPECTATION EMPATHY ENTERTAINMENT
             ACHIEVEMENT CURIOSITY - PLEASURE
             DEPRESSION GRIEF PROSTATITIS LONELINESS ABRASION DREAD SCIATICA
             HANGOVER LACERATION JEALOUSY ANXIETY ANGER BOILS ANGINA
             LACERATION-2 HANGOVER-4 ANGER-1 - PAIN
             BAVARIA GUANABARA QUEBEC - PROVINCE
             PLUTO VENUS EARTH SATURN - PLANET)
   (:INIT (EATS MELON BEEF)
          (CRAVES PROSTATITIS MELON)
          (LOCALE OKRA QUEBEC)
          (LOCALE ORANGE GUANABARA)
          (EATS POPOVER SNICKERS)
          (HARMONY EMPATHY EARTH)
          (LOCALE BROCCOLI GUANABARA)
          (HARMONY ACHIEVEMENT VENUS)
          (CRAVES GRIEF BROCCOLI)
          (EATS ORANGE SCALLOP)
          (LOCALE SCALLOP GUANABARA)
          (EATS ORANGE MELON)
          (EATS SHRIMP HAMBURGER)
          (EATS SNICKERS CHOCOLATE)
          (CRAVES ANXIETY CHOCOLATE)
          (CRAVES JEALOUSY POPOVER)
          (EATS LOBSTER ORANGE)
          (EATS HAMBURGER SHRIMP)
          (CRAVES ABRASION OKRA)
          (EATS BROCCOLI MELON)
          (EATS PEA SCALLOP)
          (CRAVES DREAD LETTUCE)
          (HARMONY INTOXICATION EARTH)
          (ORBITS VENUS EARTH)
          (EATS SNICKERS POPOVER)
          (EATS YOGURT PEA)
          (EATS BEEF PAPAYA)
          (LOCALE CHOCOLATE QUEBEC)
          (ATTACKS BAVARIA GUANABARA)
          (CRAVES INTOXICATION BEEF)
          (CRAVES ENTERTAINMENT POPOVER)
          (LOCALE SHRIMP GUANABARA)
          (EATS PEA YOGURT)
          (LOCALE LOBSTER GUANABARA)
          (EATS ORANGE SHRIMP)
          (EATS BEEF OKRA)
          (ORBITS PLUTO VENUS)
          (CRAVES SCIATICA LETTUCE)
          (EATS PEA LEMON)
          (LOCALE MELON BAVARIA)
          (ATTACKS GUANABARA QUEBEC)
          (EATS SHRIMP ORANGE)
          (LOCALE YOGURT GUANABARA)
          (HARMONY ENTERTAINMENT VENUS)
          (CRAVES ANGER CHOCOLATE)
          (EATS LOBSTER YOGURT)
          (CRAVES EMPATHY LETTUCE)
          (EATS POPOVER SHRIMP)
          (LOCALE LEMON QUEBEC)
          (HARMONY SATIETY EARTH)
          (CRAVES HANGOVER HAMBURGER)
          (EATS OKRA PAPAYA)
          (EATS CHOCOLATE SHRIMP)
          (LOCALE POPOVER GUANABARA)
          (HARMONY EXPECTATION SATURN)
          (LOCALE PEA GUANABARA)
          (EATS OKRA MELON)
          (HARMONY CURIOSITY SATURN)
          (CRAVES ANGER-1 PEA)
          (LOCALE LETTUCE QUEBEC)
          (EATS LETTUCE PAPAYA)
          (CRAVES DEPRESSION BEEF)
          (CRAVES BOILS CHOCOLATE)
          (EATS BEEF MELON)
          (EATS POPOVER LEMON)
          (EATS BROCCOLI LETTUCE)
          (EATS PAPAYA OKRA)
          (EATS MELON OKRA)
          (CRAVES LONELINESS OKRA)
          (EATS SCALLOP ORANGE)
          (EATS HAMBURGER LEMON)
          (CRAVES SATIETY BROCCOLI)
          (LOCALE BEEF QUEBEC)
          (CRAVES CURIOSITY SNICKERS)
          (EATS YOGURT LOBSTER)
          (EATS LEMON HAMBURGER)
          (LOCALE PAPAYA QUEBEC)
          (EATS SHRIMP CHOCOLATE)
          (EATS PAPAYA BEEF)
          (EATS SHRIMP POPOVER)
          (EATS MELON ORANGE)
          (EATS LEMON PEA)
          (CRAVES ANGINA YOGURT)
          (CRAVES LACERATION POPOVER)
          (CRAVES HANGOVER-4 PEA)
          (ORBITS EARTH SATURN)
          (EATS MELON BROCCOLI)
          (EATS OKRA BEEF)
          (EATS PAPAYA LETTUCE)
          (EATS CHOCOLATE SNICKERS)
          (LOCALE HAMBURGER GUANABARA)
          (CRAVES LACERATION-2 LOBSTER)
          (CRAVES EXPECTATION OKRA)
          (LOCALE SNICKERS BAVARIA)
          (EATS LETTUCE BROCCOLI)
          (EATS LEMON POPOVER)
          (EATS ORANGE LOBSTER)
          (EATS SCALLOP PEA)
          (CRAVES ACHIEVEMENT SCALLOP))
   (:GOAL (AND (CRAVES ANGINA LOBSTER))))

(DEFINE (PROBLEM MYSTY-A-29)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS OKRA BROCCOLI TOFU ORANGE PISTACHIO GRAPEFRUIT BEEF
             SCALLOP APPLE HAM MARZIPAN BACON SHRIMP PAPAYA CHERRY COD
             - FOOD
             STIMULATION ENTERTAINMENT - PLEASURE
             PROSTATITIS LACERATION ABRASION HANGOVER GRIEF LONELINESS DREAD
             DEPRESSION ANXIETY SCIATICA GRIEF-2 ANGINA JEALOUSY ANGER BOILS
             PROSTATITIS-1 DEPRESSION-7 HANGOVER-8 LACERATION-3 DREAD-4
             ABRASION-16 ANGINA-5 ANGER-6 JEALOUSY-15 BOILS-12 SCIATICA-13
             LONELINESS-14 ANXIETY-11 LONELINESS-31 BOILS-32 GRIEF-9
             SCIATICA-10 ABRASION-28 ANXIETY-29 DREAD-30 - PAIN
             BOSNIA ARIZONA OREGON QUEBEC MANITOBA GUANABARA KENTUCKY
             BAVARIA GOIAS - PROVINCE
             URANUS EARTH MERCURY - PLANET)
   (:INIT (CRAVES PROSTATITIS OKRA)
          (EATS COD SHRIMP)
          (EATS SHRIMP BACON)
          (LOCALE GRAPEFRUIT KENTUCKY)
          (EATS APPLE HAM)
          (EATS OKRA BROCCOLI)
          (CRAVES ANGINA PISTACHIO)
          (CRAVES ANGINA-5 APPLE)
          (CRAVES BOILS-12 BACON)
          (HARMONY STIMULATION MERCURY)
          (CRAVES GRIEF-2 PISTACHIO)
          (CRAVES SCIATICA TOFU)
          (EATS APPLE BEEF)
          (EATS ORANGE OKRA)
          (EATS PAPAYA BACON)
          (CRAVES PROSTATITIS-1 GRAPEFRUIT)
          (CRAVES ABRASION OKRA)
          (EATS TOFU BROCCOLI)
          (ATTACKS MANITOBA GUANABARA)
          (EATS GRAPEFRUIT APPLE)
          (CRAVES ANXIETY-29 COD)
          (CRAVES DEPRESSION-7 SCALLOP)
          (ORBITS URANUS EARTH)
          (CRAVES LONELINESS-31 PAPAYA)
          (EATS TOFU ORANGE)
          (EATS BEEF SCALLOP)
          (LOCALE OKRA QUEBEC)
          (LOCALE SHRIMP KENTUCKY)
          (EATS MARZIPAN SCALLOP)
          (CRAVES LONELINESS-14 BACON)
          (CRAVES ANGER-6 APPLE)
          (EATS SCALLOP MARZIPAN)
          (EATS GRAPEFRUIT OKRA)
          (CRAVES STIMULATION PISTACHIO)
          (ATTACKS GUANABARA KENTUCKY)
          (LOCALE HAM GUANABARA)
          (CRAVES DEPRESSION BROCCOLI)
          (CRAVES ABRASION-28 COD)
          (CRAVES LONELINESS BROCCOLI)
          (LOCALE PAPAYA MANITOBA)
          (EATS HAM PISTACHIO)
          (EATS BACON APPLE)
          (EATS CHERRY COD)
          (CRAVES LACERATION-3 SCALLOP)
          (CRAVES JEALOUSY-15 HAM)
          (CRAVES ENTERTAINMENT HAM)
          (LOCALE APPLE QUEBEC)
          (HARMONY ENTERTAINMENT MERCURY)
          (EATS CHERRY PAPAYA)
          (ATTACKS KENTUCKY BAVARIA)
          (CRAVES ABRASION-16 APPLE)
          (CRAVES GRIEF OKRA)
          (EATS SHRIMP COD)
          (CRAVES DREAD-4 SCALLOP)
          (ATTACKS OREGON QUEBEC)
          (CRAVES HANGOVER-8 SCALLOP)
          (CRAVES JEALOUSY PISTACHIO)
          (EATS OKRA GRAPEFRUIT)
          (ATTACKS BAVARIA GOIAS)
          (EATS PAPAYA CHERRY)
          (ATTACKS BOSNIA ARIZONA)
          (LOCALE CHERRY ARIZONA)
          (CRAVES SCIATICA-10 PAPAYA)
          (CRAVES ANXIETY-11 SHRIMP)
          (EATS BEEF APPLE)
          (EATS COD CHERRY)
          (CRAVES DREAD BROCCOLI)
          (CRAVES LACERATION OKRA)
          (CRAVES DREAD-30 COD)
          (EATS BROCCOLI OKRA)
          (EATS ORANGE TOFU)
          (EATS BROCCOLI TOFU)
          (CRAVES BOILS PISTACHIO)
          (LOCALE MARZIPAN BAVARIA)
          (EATS APPLE GRAPEFRUIT)
          (LOCALE SCALLOP BAVARIA)
          (CRAVES ANGER PISTACHIO)
          (CRAVES HANGOVER OKRA)
          (EATS GRAPEFRUIT MARZIPAN)
          (CRAVES ANXIETY TOFU)
          (EATS PISTACHIO HAM)
          (ATTACKS QUEBEC MANITOBA)
          (EATS BACON PAPAYA)
          (CRAVES SCIATICA-13 BACON)
          (LOCALE BACON GUANABARA)
          (CRAVES GRIEF-9 PAPAYA)
          (EATS APPLE BACON)
          (EATS HAM APPLE)
          (ATTACKS ARIZONA OREGON)
          (LOCALE TOFU BAVARIA)
          (EATS SCALLOP BEEF)
          (EATS MARZIPAN PISTACHIO)
          (EATS BACON SHRIMP)
          (EATS PISTACHIO MARZIPAN)
          (CRAVES BOILS-32 PAPAYA)
          (LOCALE COD ARIZONA)
          (LOCALE BEEF KENTUCKY)
          (LOCALE BROCCOLI QUEBEC)
          (LOCALE PISTACHIO GOIAS)
          (EATS MARZIPAN GRAPEFRUIT)
          (LOCALE ORANGE GUANABARA)
          (EATS OKRA ORANGE)
          (ORBITS EARTH MERCURY))
   (:GOAL (AND (CRAVES HANGOVER-8 HAM))))

(DEFINE (PROBLEM MYSTY-A-30)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SHRIMP ARUGULA CANTELOPE POTATO TURKEY PEA POPOVER
             CUCUMBER YOGURT GUAVA PISTACHIO HOTDOG HAM CHOCOLATE TOFU MUTTON
             - FOOD
             CURIOSITY UNDERSTANDING AESTHETICS ENTERTAINMENT EXPECTATION
             ACHIEVEMENT - PLEASURE
             PROSTATITIS LONELINESS BOILS ANXIETY DEPRESSION GRIEF HANGOVER
             SCIATICA DREAD LACERATION ANGINA JEALOUSY ANGER JEALOUSY-2
             ABRASION DREAD-1 - PAIN
             PENNSYLVANIA BOSNIA MANITOBA GOIAS QUEBEC ARIZONA GUANABARA BAVARIA
             MORAVIA - PROVINCE
             MARS VULCAN PLUTO NEPTUNE - PLANET)
   (:INIT (LOCALE POPOVER MORAVIA)
          (EATS CUCUMBER YOGURT)
          (EATS PEA GUAVA)
          (CRAVES SCIATICA CUCUMBER)
          (EATS POPOVER MUTTON)
          (CRAVES ENTERTAINMENT HOTDOG)
          (HARMONY ENTERTAINMENT PLUTO)
          (HARMONY AESTHETICS VULCAN)
          (EATS MUTTON HAM)
          (ATTACKS QUEBEC ARIZONA)
          (CRAVES EXPECTATION TOFU)
          (CRAVES ANGER YOGURT)
          (LOCALE POTATO QUEBEC)
          (EATS CUCUMBER POPOVER)
          (CRAVES DEPRESSION ARUGULA)
          (EATS CANTELOPE POTATO)
          (EATS TOFU MUTTON)
          (HARMONY EXPECTATION PLUTO)
          (LOCALE SHRIMP GUANABARA)
          (LOCALE MUTTON GUANABARA)
          (LOCALE GUAVA GOIAS)
          (EATS YOGURT CUCUMBER)
          (LOCALE YOGURT GOIAS)
          (EATS TURKEY POTATO)
          (LOCALE HOTDOG ARIZONA)
          (EATS CANTELOPE ARUGULA)
          (CRAVES DREAD-1 MUTTON)
          (EATS POTATO CANTELOPE)
          (CRAVES HANGOVER CUCUMBER)
          (EATS YOGURT GUAVA)
          (EATS ARUGULA SHRIMP)
          (CRAVES ANXIETY ARUGULA)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS CHOCOLATE PISTACHIO)
          (HARMONY ACHIEVEMENT NEPTUNE)
          (LOCALE TURKEY MANITOBA)
          (ATTACKS ARIZONA GUANABARA)
          (LOCALE PEA GUANABARA)
          (CRAVES GRIEF POTATO)
          (LOCALE TOFU BAVARIA)
          (EATS TURKEY SHRIMP)
          (LOCALE HAM GOIAS)
          (CRAVES LACERATION YOGURT)
          (ATTACKS GOIAS QUEBEC)
          (EATS HOTDOG HAM)
          (CRAVES ANGINA YOGURT)
          (EATS HAM HOTDOG)
          (EATS CUCUMBER CANTELOPE)
          (CRAVES UNDERSTANDING ARUGULA)
          (EATS PISTACHIO TOFU)
          (LOCALE PISTACHIO GUANABARA)
          (CRAVES LONELINESS ARUGULA)
          (EATS HOTDOG TOFU)
          (EATS CHOCOLATE HOTDOG)
          (EATS SHRIMP TURKEY)
          (EATS POPOVER CUCUMBER)
          (ATTACKS MANITOBA GOIAS)
          (EATS POTATO TURKEY)
          (EATS PISTACHIO CHOCOLATE)
          (EATS POPOVER GUAVA)
          (EATS HOTDOG CHOCOLATE)
          (EATS MUTTON POPOVER)
          (EATS TOFU PISTACHIO)
          (EATS ARUGULA CANTELOPE)
          (CRAVES CURIOSITY SHRIMP)
          (ATTACKS PENNSYLVANIA BOSNIA)
          (LOCALE CANTELOPE GOIAS)
          (LOCALE ARUGULA BOSNIA)
          (ATTACKS BOSNIA MANITOBA)
          (LOCALE CUCUMBER BAVARIA)
          (CRAVES BOILS ARUGULA)
          (ATTACKS BAVARIA MORAVIA)
          (EATS SHRIMP ARUGULA)
          (HARMONY CURIOSITY PLUTO)
          (CRAVES JEALOUSY-2 CHOCOLATE)
          (EATS CANTELOPE CUCUMBER)
          (EATS MUTTON TOFU)
          (EATS GUAVA PEA)
          (HARMONY UNDERSTANDING VULCAN)
          (EATS PEA CUCUMBER)
          (ORBITS VULCAN PLUTO)
          (EATS HAM MUTTON)
          (EATS GUAVA POPOVER)
          (CRAVES ACHIEVEMENT MUTTON)
          (ORBITS MARS VULCAN)
          (CRAVES PROSTATITIS ARUGULA)
          (CRAVES ABRASION CHOCOLATE)
          (ORBITS PLUTO NEPTUNE)
          (EATS YOGURT PEA)
          (ATTACKS GUANABARA BAVARIA)
          (EATS PISTACHIO CANTELOPE)
          (EATS PEA YOGURT)
          (CRAVES DREAD CUCUMBER)
          (EATS GUAVA YOGURT)
          (CRAVES AESTHETICS PEA)
          (EATS CUCUMBER PEA)
          (CRAVES JEALOUSY YOGURT)
          (EATS TOFU HOTDOG)
          (EATS CANTELOPE PISTACHIO))
   (:GOAL (AND (CRAVES JEALOUSY CHOCOLATE)
               (CRAVES ANGINA CHOCOLATE))))

(DEFINE (PROBLEM MYSTY-1)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS OKRA MUFFIN TOMATO FLOUNDER CHICKEN - FOOD
             TRIUMPH SATIETY - PLEASURE
             ABRASION SCIATICA GRIEF LONELINESS DEPRESSION JEALOUSY DREAD
             PROSTATITIS HANGOVER ANGINA - PAIN
             GOIAS - PROVINCE
             MARS EARTH NEPTUNE - PLANET)
   (:INIT (LOCALE CHICKEN GOIAS)
          (CRAVES PROSTATITIS TOMATO)
          (EATS TOMATO OKRA)
          (EATS OKRA MUFFIN)
          (EATS MUFFIN CHICKEN)
          (LOCALE FLOUNDER GOIAS)
          (LOCALE MUFFIN GOIAS)
          (EATS TOMATO FLOUNDER)
          (EATS OKRA TOMATO)
          (CRAVES SATIETY FLOUNDER)
          (CRAVES ABRASION OKRA)
          (EATS CHICKEN TOMATO)
          (CRAVES JEALOUSY TOMATO)
          (ORBITS MARS EARTH)
          (CRAVES LONELINESS MUFFIN)
          (CRAVES DREAD TOMATO)
          (EATS CHICKEN FLOUNDER)
          (EATS FLOUNDER TOMATO)
          (ORBITS EARTH NEPTUNE)
          (CRAVES ANGINA CHICKEN)
          (CRAVES HANGOVER FLOUNDER)
          (CRAVES GRIEF MUFFIN)
          (HARMONY TRIUMPH NEPTUNE)
          (HARMONY SATIETY EARTH)
          (CRAVES DEPRESSION MUFFIN)
          (EATS TOMATO CHICKEN)
          (CRAVES TRIUMPH MUFFIN)
          (EATS FLOUNDER MUFFIN)
          (EATS FLOUNDER CHICKEN)
          (CRAVES SCIATICA OKRA)
          (EATS MUFFIN OKRA)
          (EATS MUFFIN FLOUNDER)
          (LOCALE OKRA GOIAS)
          (LOCALE TOMATO GOIAS)
          (EATS CHICKEN MUFFIN))
   (:GOAL (AND (CRAVES PROSTATITIS FLOUNDER))))

(DEFINE (PROBLEM MYSTY-2)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS POPOVER PISTACHIO PEAR PAPAYA POTATO - FOOD
             EXCITEMENT - PLEASURE
             LONELINESS GRIEF BOILS SCIATICA ANGER - PAIN
             ARIZONA - PROVINCE
             PLUTO MARS JUPITER VULCAN - PLANET)
   (:INIT (LOCALE PEAR ARIZONA)
          (CRAVES SCIATICA PAPAYA)
          (EATS POTATO PAPAYA)
          (EATS PEAR PISTACHIO)
          (EATS POPOVER PISTACHIO)
          (CRAVES LONELINESS POPOVER)
          (CRAVES GRIEF PISTACHIO)
          (CRAVES BOILS PEAR)
          (LOCALE POPOVER ARIZONA)
          (CRAVES ANGER POTATO)
          (ORBITS PLUTO MARS)
          (LOCALE PISTACHIO ARIZONA)
          (LOCALE POTATO ARIZONA)
          (EATS PAPAYA POTATO)
          (HARMONY EXCITEMENT VULCAN)
          (ORBITS MARS JUPITER)
          (EATS PISTACHIO POPOVER)
          (EATS POTATO PEAR)
          (EATS PISTACHIO PEAR)
          (ORBITS JUPITER VULCAN)
          (CRAVES EXCITEMENT PAPAYA)
          (EATS PEAR PAPAYA)
          (EATS POTATO POPOVER)
          (EATS PAPAYA PEAR)
          (EATS POPOVER POTATO)
          (LOCALE PAPAYA ARIZONA)
          (EATS PEAR POTATO))
   (:GOAL (AND (CRAVES LONELINESS POPOVER))))

(DEFINE (PROBLEM MYSTY-3)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LOBSTER LETTUCE WURST CUCUMBER TOMATO OKRA COD ONION
             LEMON CHICKEN - FOOD
             SATIETY - PLEASURE
             DEPRESSION LONELINESS SCIATICA PROSTATITIS ANGINA ABRASION GRIEF
             LACERATION DREAD HANGOVER ANXIETY JEALOUSY BOILS ANGER JEALOUSY-2
             GRIEF-7 HANGOVER-8 DEPRESSION-3 LONELINESS-4 ANGER-1
             DREAD-16 PROSTATITIS-5 SCIATICA-6 ABRASION-15 PROSTATITIS-10
             BOILS-11 LACERATION-12 ANXIETY-13 ANGINA-14 GRIEF-9 - PAIN
             QUEBEC GOIAS - PROVINCE
             MERCURY NEPTUNE VENUS URANUS - PLANET)
   (:INIT (EATS CUCUMBER LEMON)
          (CRAVES SCIATICA LOBSTER)
          (CRAVES GRIEF WURST)
          (CRAVES BOILS CUCUMBER)
          (CRAVES ANGINA LETTUCE)
          (CRAVES ANGER CUCUMBER)
          (CRAVES LACERATION-12 LEMON)
          (CRAVES GRIEF-7 OKRA)
          (LOCALE OKRA QUEBEC)
          (CRAVES HANGOVER-8 OKRA)
          (LOCALE CUCUMBER GOIAS)
          (EATS ONION LETTUCE)
          (CRAVES ABRASION LETTUCE)
          (CRAVES ANXIETY WURST)
          (CRAVES BOILS-11 LEMON)
          (CRAVES DREAD-16 COD)
          (EATS LEMON ONION)
          (CRAVES JEALOUSY CUCUMBER)
          (EATS OKRA TOMATO)
          (EATS OKRA WURST)
          (CRAVES PROSTATITIS-10 LEMON)
          (CRAVES LACERATION WURST)
          (CRAVES DEPRESSION-3 OKRA)
          (CRAVES SCIATICA-6 COD)
          (LOCALE LOBSTER GOIAS)
          (EATS COD OKRA)
          (LOCALE TOMATO GOIAS)
          (EATS LEMON CUCUMBER)
          (ORBITS MERCURY NEPTUNE)
          (EATS CHICKEN LOBSTER)
          (CRAVES ANGINA-14 LEMON)
          (LOCALE LEMON QUEBEC)
          (EATS CUCUMBER TOMATO)
          (LOCALE COD QUEBEC)
          (CRAVES LONELINESS LOBSTER)
          (EATS LETTUCE ONION)
          (CRAVES JEALOUSY-2 TOMATO)
          (HARMONY SATIETY URANUS)
          (ORBITS VENUS URANUS)
          (EATS WURST OKRA)
          (LOCALE LETTUCE GOIAS)
          (EATS TOMATO LOBSTER)
          (EATS LOBSTER CHICKEN)
          (LOCALE WURST QUEBEC)
          (EATS OKRA COD)
          (CRAVES SATIETY LETTUCE)
          (CRAVES DREAD WURST)
          (CRAVES ANXIETY-13 LEMON)
          (EATS LETTUCE WURST)
          (CRAVES ABRASION-15 ONION)
          (EATS TOMATO OKRA)
          (CRAVES HANGOVER WURST)
          (CRAVES GRIEF-9 CHICKEN)
          (CRAVES PROSTATITIS-5 COD)
          (EATS WURST LETTUCE)
          (CRAVES LONELINESS-4 OKRA)
          (CRAVES DEPRESSION LOBSTER)
          (EATS ONION LEMON)
          (ORBITS NEPTUNE VENUS)
          (EATS CHICKEN COD)
          (EATS COD CHICKEN)
          (EATS LOBSTER TOMATO)
          (LOCALE ONION GOIAS)
          (CRAVES PROSTATITIS LOBSTER)
          (EATS TOMATO CUCUMBER)
          (LOCALE CHICKEN QUEBEC)
          (ATTACKS QUEBEC GOIAS)
          (CRAVES ANGER-1 OKRA))
   (:GOAL (AND (CRAVES JEALOUSY WURST))))

(DEFINE (PROBLEM MYSTY-4)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS POTATO BACON SNICKERS SWEETROLL COD PEPPER KALE
             MARZIPAN CUCUMBER PEAR OKRA SCALLOP TURKEY WURST PEA - FOOD
             STIMULATION REST CURIOSITY EXCITEMENT UNDERSTANDING EXPECTATION
             TRIUMPH - PLEASURE
             SCIATICA ABRASION LONELINESS PROSTATITIS GRIEF DEPRESSION
             HANGOVER DREAD JEALOUSY ANGINA ANGER BOILS - PAIN
             QUEBEC SURREY ALSACE MORAVIA - PROVINCE
             MARS NEPTUNE JUPITER URANUS - PLANET)
   (:INIT (EATS PEA COD)
          (CRAVES EXCITEMENT CUCUMBER)
          (EATS BACON SNICKERS)
          (EATS PEAR SCALLOP)
          (CRAVES DEPRESSION CUCUMBER)
          (HARMONY CURIOSITY URANUS)
          (CRAVES CURIOSITY COD)
          (CRAVES UNDERSTANDING PEAR)
          (LOCALE BACON QUEBEC)
          (EATS PEPPER KALE)
          (LOCALE PEA MORAVIA)
          (CRAVES ANGINA PEAR)
          (CRAVES SCIATICA SWEETROLL)
          (EATS BACON POTATO)
          (CRAVES REST SNICKERS)
          (HARMONY UNDERSTANDING URANUS)
          (LOCALE SCALLOP SURREY)
          (LOCALE SWEETROLL SURREY)
          (CRAVES ANGER PEA)
          (EATS TURKEY WURST)
          (ORBITS MARS NEPTUNE)
          (LOCALE COD MORAVIA)
          (LOCALE WURST ALSACE)
          (HARMONY TRIUMPH JUPITER)
          (LOCALE CUCUMBER QUEBEC)
          (EATS PEA SCALLOP)
          (EATS SWEETROLL POTATO)
          (CRAVES DREAD CUCUMBER)
          (EATS SNICKERS SWEETROLL)
          (LOCALE MARZIPAN SURREY)
          (EATS SCALLOP PEA)
          (LOCALE SNICKERS MORAVIA)
          (CRAVES LONELINESS PEPPER)
          (CRAVES EXPECTATION WURST)
          (EATS WURST SCALLOP)
          (HARMONY EXCITEMENT JUPITER)
          (EATS PEPPER BACON)
          (EATS MARZIPAN COD)
          (EATS SNICKERS BACON)
          (LOCALE OKRA QUEBEC)
          (EATS KALE PEPPER)
          (EATS POTATO BACON)
          (HARMONY STIMULATION JUPITER)
          (EATS PEAR CUCUMBER)
          (EATS OKRA CUCUMBER)
          (EATS CUCUMBER PEAR)
          (LOCALE KALE ALSACE)
          (EATS TURKEY OKRA)
          (CRAVES BOILS PEA)
          (CRAVES HANGOVER CUCUMBER)
          (CRAVES GRIEF KALE)
          (EATS MARZIPAN KALE)
          (CRAVES TRIUMPH PEA)
          (EATS WURST TURKEY)
          (LOCALE PEAR QUEBEC)
          (LOCALE PEPPER SURREY)
          (ATTACKS QUEBEC SURREY)
          (HARMONY REST URANUS)
          (EATS BACON PEPPER)
          (HARMONY EXPECTATION JUPITER)
          (EATS COD MARZIPAN)
          (EATS SCALLOP PEAR)
          (EATS CUCUMBER OKRA)
          (EATS PEA WURST)
          (ATTACKS SURREY ALSACE)
          (ORBITS NEPTUNE JUPITER)
          (ATTACKS ALSACE MORAVIA)
          (EATS OKRA TURKEY)
          (EATS PEPPER COD)
          (EATS COD PEA)
          (LOCALE POTATO SURREY)
          (CRAVES ABRASION PEPPER)
          (EATS WURST PEA)
          (CRAVES PROSTATITIS PEPPER)
          (EATS POTATO SWEETROLL)
          (LOCALE TURKEY QUEBEC)
          (EATS COD PEPPER)
          (CRAVES STIMULATION POTATO)
          (CRAVES JEALOUSY PEAR)
          (ORBITS JUPITER URANUS)
          (EATS SWEETROLL SNICKERS)
          (EATS SCALLOP WURST)
          (EATS KALE MARZIPAN))
   (:GOAL (AND (CRAVES ANGINA CUCUMBER))))

(DEFINE (PROBLEM MYSTY-5)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS MUFFIN YOGURT HAROSET ENDIVE KALE TUNA CHOCOLATE
             SNICKERS PAPAYA MUTTON PEAR BROCCOLI POTATO BACON SCALLOP TOMATO
             - FOOD
             SATISFACTION AESTHETICS UNDERSTANDING - PLEASURE
             ANGER HANGOVER JEALOUSY DREAD SCIATICA LONELINESS GRIEF
             ANGINA ABRASION BOILS DEPRESSION ANXIETY ANGER-2 LACERATION
             PROSTATITIS GRIEF-3 ANXIETY-4 ABRASION-1 ANGINA-8 HANGOVER-5
             LONELINESS-6 DREAD-7 DEPRESSION-14 SCIATICA-15 LACERATION-16
             PROSTATITIS-13 JEALOUSY-12 GRIEF-10 BOILS-11 PROSTATITIS-31
             DEPRESSION-32 HANGOVER-9 ABRASION-29 SCIATICA-30 ANXIETY-26
             DREAD-27 LONELINESS-28 - PAIN
             QUEBEC - PROVINCE
             VENUS NEPTUNE VULCAN SATURN - PLANET)
   (:INIT (EATS TUNA HAROSET)
          (EATS CHOCOLATE BROCCOLI)
          (CRAVES LONELINESS YOGURT)
          (LOCALE PAPAYA QUEBEC)
          (CRAVES HANGOVER-5 PAPAYA)
          (LOCALE TUNA QUEBEC)
          (CRAVES ANGINA-8 SNICKERS)
          (EATS SNICKERS PAPAYA)
          (EATS HAROSET TUNA)
          (CRAVES DEPRESSION-32 BACON)
          (CRAVES LACERATION-16 MUTTON)
          (EATS POTATO BACON)
          (CRAVES ANXIETY KALE)
          (LOCALE POTATO QUEBEC)
          (EATS SNICKERS BROCCOLI)
          (CRAVES PROSTATITIS-13 PEAR)
          (EATS MUTTON PAPAYA)
          (CRAVES ANXIETY-4 CHOCOLATE)
          (CRAVES BOILS-11 POTATO)
          (CRAVES SCIATICA YOGURT)
          (CRAVES DREAD-7 PAPAYA)
          (EATS TUNA MUFFIN)
          (LOCALE SCALLOP QUEBEC)
          (CRAVES JEALOUSY-12 BROCCOLI)
          (LOCALE CHOCOLATE QUEBEC)
          (EATS BROCCOLI SNICKERS)
          (EATS BROCCOLI BACON)
          (EATS TOMATO POTATO)
          (EATS PAPAYA CHOCOLATE)
          (EATS POTATO TOMATO)
          (EATS BACON BROCCOLI)
          (ORBITS NEPTUNE VULCAN)
          (EATS SCALLOP TOMATO)
          (LOCALE SNICKERS QUEBEC)
          (EATS SNICKERS PEAR)
          (CRAVES DEPRESSION-14 MUTTON)
          (EATS PEAR PAPAYA)
          (CRAVES UNDERSTANDING BROCCOLI)
          (EATS MUFFIN TUNA)
          (CRAVES ANGINA HAROSET)
          (EATS PEAR SNICKERS)
          (CRAVES ABRASION ENDIVE)
          (CRAVES PROSTATITIS-31 BACON)
          (CRAVES HANGOVER MUFFIN)
          (CRAVES ABRASION-29 SCALLOP)
          (LOCALE HAROSET QUEBEC)
          (CRAVES ANXIETY-26 TOMATO)
          (CRAVES PROSTATITIS TUNA)
          (LOCALE BACON QUEBEC)
          (EATS MUFFIN YOGURT)
          (EATS ENDIVE SNICKERS)
          (CRAVES AESTHETICS HAROSET)
          (CRAVES LACERATION TUNA)
          (CRAVES DREAD YOGURT)
          (LOCALE TOMATO QUEBEC)
          (CRAVES LONELINESS-28 TOMATO)
          (CRAVES ABRASION-1 CHOCOLATE)
          (CRAVES JEALOUSY MUFFIN)
          (EATS ENDIVE KALE)
          (HARMONY AESTHETICS NEPTUNE)
          (LOCALE KALE QUEBEC)
          (EATS YOGURT KALE)
          (EATS CHOCOLATE PAPAYA)
          (LOCALE ENDIVE QUEBEC)
          (CRAVES GRIEF-3 CHOCOLATE)
          (CRAVES SATISFACTION YOGURT)
          (LOCALE MUTTON QUEBEC)
          (CRAVES GRIEF HAROSET)
          (LOCALE PEAR QUEBEC)
          (EATS BROCCOLI CHOCOLATE)
          (HARMONY SATISFACTION SATURN)
          (CRAVES SCIATICA-30 SCALLOP)
          (EATS KALE ENDIVE)
          (EATS PAPAYA PEAR)
          (CRAVES ANGER MUFFIN)
          (EATS PAPAYA SNICKERS)
          (CRAVES GRIEF-10 POTATO)
          (EATS TOMATO SCALLOP)
          (HARMONY UNDERSTANDING VULCAN)
          (EATS BACON POTATO)
          (CRAVES DREAD-27 TOMATO)
          (CRAVES BOILS ENDIVE)
          (ORBITS VENUS NEPTUNE)
          (EATS PAPAYA MUTTON)
          (CRAVES SCIATICA-15 MUTTON)
          (EATS BACON SCALLOP)
          (CRAVES ANGER-2 TUNA)
          (EATS PEAR MUTTON)
          (EATS YOGURT MUFFIN)
          (EATS MUTTON PEAR)
          (LOCALE BROCCOLI QUEBEC)
          (EATS SCALLOP BACON)
          (EATS ENDIVE HAROSET)
          (EATS KALE YOGURT)
          (EATS SNICKERS ENDIVE)
          (EATS HAROSET ENDIVE)
          (LOCALE MUFFIN QUEBEC)
          (CRAVES LONELINESS-6 PAPAYA)
          (ORBITS VULCAN SATURN)
          (LOCALE YOGURT QUEBEC)
          (CRAVES DEPRESSION KALE)
          (CRAVES HANGOVER-9 BACON))
   (:GOAL (AND (CRAVES ANGER CHOCOLATE))))

(DEFINE (PROBLEM MYSTY-6)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PISTACHIO WONDERBREAD MELON PEA CHOCOLATE PORK
             FLOUNDER HAM PAPAYA CUCUMBER PEPPER - FOOD
             LOVE REST - PLEASURE
             LONELINESS GRIEF PROSTATITIS - PAIN
             KENTUCKY GOIAS MANITOBA - PROVINCE
             VENUS SATURN EARTH NEPTUNE - PLANET)
   (:INIT (EATS MELON HAM)
          (EATS FLOUNDER CHOCOLATE)
          (LOCALE MELON GOIAS)
          (EATS PISTACHIO PORK)
          (LOCALE WONDERBREAD KENTUCKY)
          (EATS CHOCOLATE FLOUNDER)
          (ATTACKS GOIAS MANITOBA)
          (ORBITS VENUS SATURN)
          (EATS HAM PEPPER)
          (EATS PAPAYA WONDERBREAD)
          (EATS HAM WONDERBREAD)
          (EATS CUCUMBER CHOCOLATE)
          (ATTACKS KENTUCKY GOIAS)
          (EATS PEPPER HAM)
          (CRAVES PROSTATITIS PORK)
          (LOCALE HAM MANITOBA)
          (EATS PEPPER PEA)
          (EATS FLOUNDER PEPPER)
          (EATS PORK FLOUNDER)
          (LOCALE CHOCOLATE KENTUCKY)
          (EATS CUCUMBER PEA)
          (LOCALE PAPAYA GOIAS)
          (EATS PAPAYA CUCUMBER)
          (LOCALE PORK KENTUCKY)
          (EATS PISTACHIO MELON)
          (EATS PEA FLOUNDER)
          (LOCALE PISTACHIO GOIAS)
          (HARMONY REST NEPTUNE)
          (EATS CHOCOLATE CUCUMBER)
          (EATS PORK PEPPER)
          (EATS PEPPER PORK)
          (EATS FLOUNDER PEA)
          (CRAVES GRIEF PORK)
          (HARMONY LOVE SATURN)
          (EATS CUCUMBER PAPAYA)
          (EATS WONDERBREAD HAM)
          (LOCALE CUCUMBER MANITOBA)
          (EATS PEA PEPPER)
          (LOCALE PEA KENTUCKY)
          (EATS PEA CUCUMBER)
          (ORBITS SATURN EARTH)
          (EATS FLOUNDER PORK)
          (LOCALE FLOUNDER MANITOBA)
          (LOCALE PEPPER MANITOBA)
          (CRAVES LOVE PEA)
          (EATS CHOCOLATE PAPAYA)
          (EATS MELON PISTACHIO)
          (EATS PEPPER FLOUNDER)
          (EATS PORK PISTACHIO)
          (EATS HAM MELON)
          (EATS PAPAYA CHOCOLATE)
          (CRAVES REST HAM)
          (EATS WONDERBREAD PAPAYA)
          (ORBITS EARTH NEPTUNE)
          (CRAVES LONELINESS PORK))
   (:GOAL (AND (CRAVES GRIEF HAM)
               (CRAVES PROSTATITIS HAM))))

(DEFINE (PROBLEM MYSTY-7)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS CHOCOLATE BEEF FLOUNDER MUTTON SHRIMP TUNA SWEETROLL
             ONION CANTELOPE YOGURT GUAVA RICE PEPPER - FOOD
             LUBRICITY ACHIEVEMENT - PLEASURE
             ANGINA HANGOVER ANGER GRIEF BOILS DEPRESSION LACERATION
             ABRASION - PAIN
             GOIAS ALSACE KENTUCKY BOSNIA GUANABARA ARIZONA - PROVINCE
             NEPTUNE PLUTO SATURN - PLANET)
   (:INIT (EATS FLOUNDER CANTELOPE)
          (LOCALE BEEF KENTUCKY)
          (LOCALE GUAVA ARIZONA)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS RICE BEEF)
          (LOCALE CHOCOLATE KENTUCKY)
          (EATS MUTTON RICE)
          (EATS CANTELOPE MUTTON)
          (EATS SWEETROLL PEPPER)
          (ATTACKS GOIAS ALSACE)
          (CRAVES BOILS TUNA)
          (EATS ONION PEPPER)
          (EATS CHOCOLATE SWEETROLL)
          (EATS YOGURT SHRIMP)
          (EATS TUNA YOGURT)
          (EATS FLOUNDER SWEETROLL)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS YOGURT TUNA)
          (EATS RICE ONION)
          (EATS MUTTON CANTELOPE)
          (LOCALE SHRIMP ALSACE)
          (EATS RICE MUTTON)
          (CRAVES LACERATION CANTELOPE)
          (CRAVES ACHIEVEMENT YOGURT)
          (EATS GUAVA CANTELOPE)
          (CRAVES HANGOVER BEEF)
          (EATS SHRIMP CANTELOPE)
          (CRAVES ANGINA CHOCOLATE)
          (EATS CANTELOPE GUAVA)
          (EATS ONION MUTTON)
          (EATS ONION RICE)
          (EATS SWEETROLL TUNA)
          (EATS ONION CHOCOLATE)
          (EATS SWEETROLL MUTTON)
          (EATS SWEETROLL CHOCOLATE)
          (EATS TUNA SWEETROLL)
          (EATS CANTELOPE SHRIMP)
          (LOCALE YOGURT BOSNIA)
          (EATS GUAVA BEEF)
          (ATTACKS GUANABARA ARIZONA)
          (ORBITS NEPTUNE PLUTO)
          (EATS MUTTON ONION)
          (EATS SHRIMP YOGURT)
          (EATS PEPPER SWEETROLL)
          (ATTACKS ALSACE KENTUCKY)
          (LOCALE ONION KENTUCKY)
          (LOCALE FLOUNDER KENTUCKY)
          (EATS PEPPER ONION)
          (EATS BEEF GUAVA)
          (HARMONY ACHIEVEMENT PLUTO)
          (EATS MUTTON SWEETROLL)
          (LOCALE PEPPER KENTUCKY)
          (LOCALE CANTELOPE ARIZONA)
          (CRAVES ANGER FLOUNDER)
          (EATS CANTELOPE FLOUNDER)
          (ATTACKS BOSNIA GUANABARA)
          (CRAVES GRIEF SHRIMP)
          (LOCALE TUNA ALSACE)
          (LOCALE MUTTON ARIZONA)
          (LOCALE RICE GUANABARA)
          (EATS SWEETROLL FLOUNDER)
          (EATS BEEF RICE)
          (CRAVES LUBRICITY ONION)
          (HARMONY LUBRICITY SATURN)
          (CRAVES DEPRESSION SWEETROLL)
          (EATS CHOCOLATE ONION)
          (CRAVES ABRASION PEPPER)
          (ORBITS PLUTO SATURN))
   (:GOAL (AND (CRAVES LACERATION GUAVA)
               (CRAVES ANGINA BEEF)
               (CRAVES BOILS SWEETROLL))))

(DEFINE (PROBLEM MYSTY-8)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS BACON PEAR HAMBURGER SCALLION ARUGULA CANTELOPE TOFU
             LAMB BEEF TURKEY MUFFIN HOTDOG SWEETROLL PEPPER FLOUNDER COD
             BAGUETTE SNICKERS ENDIVE RICE HAM PAPAYA WONDERBREAD PORK
             CHICKEN YOGURT SHRIMP LOBSTER CHOCOLATE LEMON HAROSET - FOOD
             SATISFACTION AESTHETICS ENTERTAINMENT - PLEASURE
             PROSTATITIS JEALOUSY BOILS SCIATICA ABRASION GRIEF LONELINESS
             ANGINA DEPRESSION ANXIETY DREAD ABRASION-1 SCIATICA-2 ANGER
             LACERATION HANGOVER DREAD-3 LONELINESS-4 LACERATION-6 GRIEF-7
             JEALOUSY-8 DEPRESSION-16 BOILS-5 ANGER-14 ANXIETY-15 ABRASION-9
             GRIEF-10 ANGINA-11 HANGOVER-12 PROSTATITIS-13 PROSTATITIS-30
             JEALOUSY-31 BOILS-32 DEPRESSION-28 DREAD-29 HANGOVER-23
             SCIATICA-24 LACERATION-25 ANGINA-26 ANGER-27 ANXIETY-21
             LONELINESS-22 DEPRESSION-64 DREAD-17 LONELINESS-18 PROSTATITIS-19
             ANGER-20 GRIEF-63 ABRASION-59 ANGINA-60 HANGOVER-61
             SCIATICA-62 LACERATION-58 ANGINA-54 BOILS-55 JEALOUSY-56
             ANXIETY-57 BOILS-50 GRIEF-51 HANGOVER-52 LACERATION-53 ANGER-48
             PROSTATITIS-49 LONELINESS-43 ABRASION-44 DEPRESSION-45 JEALOUSY-46
             ANXIETY-47 DEPRESSION-38 GRIEF-39 ANGINA-40 DREAD-41
             SCIATICA-42 BOILS-33 ANXIETY-34 LACERATION-35 ABRASION-36
             HANGOVER-37 DREAD-125 PROSTATITIS-126 ANGER-127 JEALOUSY-128
             SCIATICA-123 LONELINESS-124 PROSTATITIS-119 ABRASION-120
             ANGINA-121 ANGER-122 DREAD-116 ANXIETY-117 BOILS-118
             HANGOVER-113 LACERATION-114 JEALOUSY-115 SCIATICA-110
             LONELINESS-111 DEPRESSION-112 - PAIN
             GOIAS - PROVINCE
             VENUS SATURN JUPITER - PLANET)
   (:INIT (EATS LOBSTER YOGURT)
          (EATS MUFFIN HOTDOG)
          (CRAVES ANGER-27 PEPPER)
          (CRAVES ANXIETY-21 FLOUNDER)
          (CRAVES LONELINESS-22 FLOUNDER)
          (CRAVES DEPRESSION SCALLION)
          (LOCALE BACON GOIAS)
          (EATS PEPPER MUFFIN)
          (CRAVES DREAD-116 CHOCOLATE)
          (EATS COD SWEETROLL)
          (CRAVES HANGOVER-61 SNICKERS)
          (LOCALE SCALLION GOIAS)
          (LOCALE LAMB GOIAS)
          (EATS HAMBURGER SCALLION)
          (EATS BEEF PEPPER)
          (LOCALE RICE GOIAS)
          (LOCALE PAPAYA GOIAS)
          (LOCALE CHICKEN GOIAS)
          (CRAVES GRIEF-10 MUFFIN)
          (CRAVES ANXIETY-117 CHOCOLATE)
          (EATS ARUGULA CANTELOPE)
          (CRAVES AESTHETICS CHICKEN)
          (CRAVES DREAD-3 TOFU)
          (EATS LAMB SWEETROLL)
          (ORBITS VENUS SATURN)
          (CRAVES ENTERTAINMENT LEMON)
          (CRAVES ANGER CANTELOPE)
          (EATS HAM LEMON)
          (EATS TURKEY FLOUNDER)
          (CRAVES PROSTATITIS-19 COD)
          (EATS SHRIMP YOGURT)
          (LOCALE BAGUETTE GOIAS)
          (CRAVES BOILS-50 HAM)
          (EATS YOGURT ENDIVE)
          (CRAVES GRIEF-63 BAGUETTE)
          (CRAVES HANGOVER-113 LEMON)
          (LOCALE PEAR GOIAS)
          (CRAVES ABRASION-1 CANTELOPE)
          (EATS TOFU BEEF)
          (CRAVES ANGINA-11 MUFFIN)
          (CRAVES SCIATICA-42 PORK)
          (LOCALE LOBSTER GOIAS)
          (EATS LAMB HOTDOG)
          (EATS PORK BAGUETTE)
          (EATS SNICKERS LEMON)
          (EATS ARUGULA BACON)
          (CRAVES JEALOUSY-128 YOGURT)
          (EATS CHOCOLATE HAM)
          (EATS HAM CHICKEN)
          (CRAVES JEALOUSY BACON)
          (EATS HAM CHOCOLATE)
          (CRAVES PROSTATITIS-13 MUFFIN)
          (EATS CHICKEN YOGURT)
          (CRAVES SCIATICA-24 PEPPER)
          (EATS BAGUETTE RICE)
          (EATS SWEETROLL MUFFIN)
          (CRAVES SCIATICA-123 SHRIMP)
          (EATS LEMON SNICKERS)
          (CRAVES DREAD-125 YOGURT)
          (CRAVES SATISFACTION SCALLION)
          (EATS YOGURT CHICKEN)
          (CRAVES DREAD-17 COD)
          (CRAVES ANGINA-60 SNICKERS)
          (CRAVES PROSTATITIS-30 HOTDOG)
          (EATS FLOUNDER TOFU)
          (EATS CANTELOPE ARUGULA)
          (EATS ENDIVE SNICKERS)
          (EATS CANTELOPE HAMBURGER)
          (CRAVES GRIEF HAMBURGER)
          (CRAVES PROSTATITIS-49 PAPAYA)
          (LOCALE HAROSET GOIAS)
          (LOCALE COD GOIAS)
          (LOCALE FLOUNDER GOIAS)
          (CRAVES ANGER-127 YOGURT)
          (LOCALE TOFU GOIAS)
          (LOCALE SHRIMP GOIAS)
          (CRAVES HANGOVER-52 HAM)
          (EATS TOFU FLOUNDER)
          (LOCALE HAM GOIAS)
          (CRAVES ANXIETY ARUGULA)
          (CRAVES HANGOVER CANTELOPE)
          (EATS RICE HAROSET)
          (CRAVES BOILS PEAR)
          (CRAVES DEPRESSION-16 BEEF)
          (EATS LEMON HAM)
          (EATS CHICKEN HAM)
          (CRAVES LONELINESS-43 WONDERBREAD)
          (LOCALE CANTELOPE GOIAS)
          (EATS CHICKEN LEMON)
          (LOCALE HOTDOG GOIAS)
          (CRAVES ANGER-48 PAPAYA)
          (EATS BACON PEAR)
          (LOCALE ARUGULA GOIAS)
          (CRAVES ANGINA-40 PORK)
          (EATS COD HOTDOG)
          (CRAVES ANGINA-54 RICE)
          (EATS RICE BAGUETTE)
          (CRAVES ANXIETY-34 CHICKEN)
          (CRAVES LACERATION CANTELOPE)
          (CRAVES ABRASION-36 CHICKEN)
          (LOCALE SWEETROLL GOIAS)
          (CRAVES LACERATION-58 ENDIVE)
          (CRAVES HANGOVER-23 PEPPER)
          (LOCALE TURKEY GOIAS)
          (CRAVES LACERATION-53 HAM)
          (EATS WONDERBREAD LOBSTER)
          (CRAVES DEPRESSION-28 SWEETROLL)
          (EATS CHOCOLATE CHICKEN)
          (EATS FLOUNDER PEAR)
          (EATS PAPAYA SHRIMP)
          (EATS TURKEY HOTDOG)
          (LOCALE CHOCOLATE GOIAS)
          (LOCALE BEEF GOIAS)
          (EATS LOBSTER WONDERBREAD)
          (EATS YOGURT SHRIMP)
          (CRAVES BOILS-32 HOTDOG)
          (EATS PEPPER BEEF)
          (CRAVES LACERATION-25 PEPPER)
          (EATS CHICKEN CHOCOLATE)
          (CRAVES LACERATION-114 LEMON)
          (CRAVES ABRASION HAMBURGER)
          (CRAVES ABRASION-59 SNICKERS)
          (CRAVES JEALOUSY-8 LAMB)
          (CRAVES DEPRESSION-112 HAROSET)
          (CRAVES SCIATICA-62 SNICKERS)
          (HARMONY ENTERTAINMENT JUPITER)
          (CRAVES DEPRESSION-38 PORK)
          (EATS LAMB SNICKERS)
          (LOCALE MUFFIN GOIAS)
          (CRAVES LONELINESS-111 HAROSET)
          (EATS YOGURT LOBSTER)
          (CRAVES ABRASION-44 WONDERBREAD)
          (CRAVES BOILS-55 RICE)
          (EATS HAROSET RICE)
          (CRAVES JEALOUSY-31 HOTDOG)
          (EATS HOTDOG LAMB)
          (LOCALE SNICKERS GOIAS)
          (EATS HOTDOG TURKEY)
          (CRAVES ANGER-20 COD)
          (EATS MUFFIN PEPPER)
          (EATS MUFFIN SWEETROLL)
          (CRAVES BOILS-33 CHICKEN)
          (CRAVES DREAD-41 PORK)
          (LOCALE YOGURT GOIAS)
          (EATS SHRIMP LEMON)
          (CRAVES ANGER-14 TURKEY)
          (EATS SCALLION HAMBURGER)
          (LOCALE HAMBURGER GOIAS)
          (EATS HAROSET PAPAYA)
          (LOCALE PEPPER GOIAS)
          (CRAVES PROSTATITIS BACON)
          (EATS SWEETROLL LAMB)
          (CRAVES DREAD ARUGULA)
          (CRAVES SCIATICA-2 CANTELOPE)
          (EATS FLOUNDER TURKEY)
          (EATS PEAR BACON)
          (CRAVES GRIEF-39 PORK)
          (CRAVES ABRASION-120 LOBSTER)
          (CRAVES ANGER-122 LOBSTER)
          (ORBITS SATURN JUPITER)
          (CRAVES SCIATICA PEAR)
          (EATS SNICKERS LAMB)
          (CRAVES LONELINESS-4 TOFU)
          (CRAVES ANGINA-121 LOBSTER)
          (EATS ENDIVE YOGURT)
          (EATS HOTDOG MUFFIN)
          (EATS PORK WONDERBREAD)
          (EATS SCALLION PEAR)
          (EATS PEAR FLOUNDER)
          (CRAVES JEALOUSY-115 LEMON)
          (EATS PAPAYA HAROSET)
          (CRAVES HANGOVER-12 MUFFIN)
          (CRAVES BOILS-118 CHOCOLATE)
          (EATS HAMBURGER CANTELOPE)
          (CRAVES DREAD-29 SWEETROLL)
          (CRAVES PROSTATITIS-126 YOGURT)
          (CRAVES JEALOUSY-56 RICE)
          (CRAVES LACERATION-6 LAMB)
          (CRAVES DEPRESSION-45 WONDERBREAD)
          (CRAVES JEALOUSY-46 WONDERBREAD)
          (EATS SWEETROLL COD)
          (EATS WONDERBREAD PORK)
          (CRAVES ANXIETY-15 TURKEY)
          (EATS BAGUETTE PORK)
          (CRAVES ANXIETY-47 WONDERBREAD)
          (EATS SNICKERS ENDIVE)
          (CRAVES ANGINA-26 PEPPER)
          (CRAVES PROSTATITIS-119 LOBSTER)
          (LOCALE ENDIVE GOIAS)
          (CRAVES GRIEF-51 HAM)
          (EATS PEAR SCALLION)
          (CRAVES DEPRESSION-64 COD)
          (EATS LEMON SHRIMP)
          (LOCALE WONDERBREAD GOIAS)
          (CRAVES SCIATICA-110 HAROSET)
          (EATS HOTDOG COD)
          (CRAVES GRIEF-7 LAMB)
          (CRAVES BOILS-5 BEEF)
          (CRAVES LONELINESS HAMBURGER)
          (HARMONY AESTHETICS JUPITER)
          (HARMONY SATISFACTION JUPITER)
          (CRAVES HANGOVER-37 CHICKEN)
          (CRAVES LACERATION-35 CHICKEN)
          (LOCALE LEMON GOIAS)
          (CRAVES LONELINESS-18 COD)
          (CRAVES ABRASION-9 MUFFIN)
          (CRAVES LONELINESS-124 SHRIMP)
          (EATS BACON ARUGULA)
          (EATS SHRIMP PAPAYA)
          (EATS BEEF TOFU)
          (CRAVES ANGINA SCALLION)
          (CRAVES ANXIETY-57 RICE)
          (LOCALE PORK GOIAS)
          (EATS LEMON CHICKEN))
   (:GOAL (AND (CRAVES HANGOVER-12 HOTDOG)
               (CRAVES GRIEF-10 CHICKEN))))

(DEFINE (PROBLEM MYSTY-9)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LEMON OKRA LETTUCE SCALLION CHOCOLATE YOGURT RICE BEEF
             ENDIVE ORANGE CHERRY HAM LOBSTER ONION MUFFIN COD APPLE
             CUCUMBER FLOUNDER PEAR MUTTON CHICKEN TURKEY HAMBURGER
             SWEETROLL PAPAYA - FOOD
             ACHIEVEMENT AESTHETICS - PLEASURE
             ANGINA HANGOVER ANXIETY ANGER LONELINESS BOILS LACERATION
             JEALOUSY SCIATICA DEPRESSION GRIEF PROSTATITIS ANGER-1 BOILS-2
             DREAD ABRASION ANGINA-4 PROSTATITIS-8 HANGOVER-3
             JEALOUSY-16 GRIEF-5 DEPRESSION-6 ANXIETY-7 LONELINESS-13
             LACERATION-14 SCIATICA-15 ABRASION-11 DREAD-12 HANGOVER-9
             LONELINESS-10 ANGER-30 ANGINA-31 DEPRESSION-32 BOILS-29
             ABRASION-26 GRIEF-27 JEALOUSY-28 - PAIN
             MANITOBA SURREY GUANABARA KENTUCKY - PROVINCE
             NEPTUNE JUPITER MARS EARTH - PLANET)
   (:INIT (LOCALE YOGURT MANITOBA)
          (LOCALE ONION KENTUCKY)
          (EATS PEAR MUFFIN)
          (LOCALE RICE KENTUCKY)
          (EATS CHOCOLATE LEMON)
          (EATS FLOUNDER ENDIVE)
          (EATS BEEF RICE)
          (EATS ORANGE LEMON)
          (EATS SCALLION OKRA)
          (HARMONY ACHIEVEMENT EARTH)
          (CRAVES ANGER-1 ENDIVE)
          (EATS YOGURT ENDIVE)
          (CRAVES ANGINA-31 CHICKEN)
          (EATS PAPAYA CHICKEN)
          (ORBITS MARS EARTH)
          (CRAVES ABRASION ENDIVE)
          (LOCALE ENDIVE SURREY)
          (EATS PEAR LOBSTER)
          (CRAVES GRIEF-5 ONION)
          (EATS HAM PAPAYA)
          (EATS TURKEY COD)
          (EATS CUCUMBER PEAR)
          (EATS CUCUMBER MUTTON)
          (CRAVES LONELINESS-10 MUTTON)
          (LOCALE ORANGE MANITOBA)
          (ORBITS JUPITER MARS)
          (CRAVES BOILS-29 TURKEY)
          (EATS MUTTON ONION)
          (EATS CHICKEN FLOUNDER)
          (CRAVES BOILS-2 ENDIVE)
          (EATS HAM CHERRY)
          (CRAVES HANGOVER LEMON)
          (EATS PEAR CUCUMBER)
          (LOCALE PEAR GUANABARA)
          (EATS RICE BEEF)
          (EATS PAPAYA HAM)
          (LOCALE TURKEY MANITOBA)
          (CRAVES LACERATION SCALLION)
          (EATS COD CHICKEN)
          (EATS BEEF ENDIVE)
          (EATS CHICKEN HAMBURGER)
          (EATS SWEETROLL HAMBURGER)
          (EATS CHERRY HAM)
          (LOCALE CHERRY GUANABARA)
          (EATS PEAR SWEETROLL)
          (CRAVES SCIATICA RICE)
          (CRAVES JEALOUSY-16 ONION)
          (EATS APPLE CUCUMBER)
          (CRAVES ANGINA LEMON)
          (EATS COD PAPAYA)
          (EATS CHERRY MUTTON)
          (EATS CUCUMBER APPLE)
          (LOCALE CHOCOLATE KENTUCKY)
          (LOCALE CHICKEN KENTUCKY)
          (CRAVES ANGINA-4 CHERRY)
          (CRAVES JEALOUSY-28 SWEETROLL)
          (EATS CHOCOLATE RICE)
          (CRAVES ABRASION-26 SWEETROLL)
          (EATS LOBSTER PEAR)
          (EATS FLOUNDER CHICKEN)
          (LOCALE LETTUCE KENTUCKY)
          (CRAVES DEPRESSION-32 CHICKEN)
          (CRAVES ANXIETY LEMON)
          (LOCALE LOBSTER MANITOBA)
          (EATS LEMON ORANGE)
          (CRAVES DREAD ENDIVE)
          (LOCALE CUCUMBER KENTUCKY)
          (EATS LETTUCE CHOCOLATE)
          (LOCALE OKRA MANITOBA)
          (CRAVES DREAD-12 FLOUNDER)
          (CRAVES ACHIEVEMENT SCALLION)
          (EATS RICE ORANGE)
          (EATS ORANGE RICE)
          (EATS CHOCOLATE LETTUCE)
          (EATS SCALLION ORANGE)
          (EATS ONION MUTTON)
          (EATS PAPAYA COD)
          (CRAVES PROSTATITIS RICE)
          (LOCALE FLOUNDER KENTUCKY)
          (EATS CHICKEN COD)
          (EATS APPLE SWEETROLL)
          (LOCALE SCALLION MANITOBA)
          (CRAVES JEALOUSY YOGURT)
          (LOCALE COD GUANABARA)
          (CRAVES ANGER-30 CHICKEN)
          (EATS PEAR MUTTON)
          (CRAVES GRIEF-27 SWEETROLL)
          (EATS LETTUCE YOGURT)
          (EATS FLOUNDER TURKEY)
          (EATS ONION PAPAYA)
          (EATS LOBSTER HAMBURGER)
          (CRAVES HANGOVER-3 LOBSTER)
          (CRAVES LONELINESS-13 COD)
          (EATS MUTTON PEAR)
          (LOCALE HAMBURGER SURREY)
          (ATTACKS SURREY GUANABARA)
          (EATS LEMON CHOCOLATE)
          (CRAVES ABRASION-11 FLOUNDER)
          (EATS MUFFIN PEAR)
          (ATTACKS MANITOBA SURREY)
          (LOCALE MUFFIN GUANABARA)
          (EATS LETTUCE SCALLION)
          (CRAVES LACERATION-14 COD)
          (EATS ENDIVE OKRA)
          (EATS ENDIVE FLOUNDER)
          (CRAVES LONELINESS OKRA)
          (CRAVES PROSTATITIS-8 LOBSTER)
          (EATS MUTTON CHERRY)
          (EATS TURKEY FLOUNDER)
          (LOCALE SWEETROLL KENTUCKY)
          (CRAVES ANGER OKRA)
          (LOCALE APPLE GUANABARA)
          (CRAVES AESTHETICS PAPAYA)
          (EATS ORANGE SCALLION)
          (CRAVES DEPRESSION-6 ONION)
          (ORBITS NEPTUNE JUPITER)
          (EATS RICE CHOCOLATE)
          (LOCALE PAPAYA GUANABARA)
          (EATS ONION SWEETROLL)
          (EATS ENDIVE BEEF)
          (LOCALE MUTTON SURREY)
          (EATS MUTTON CUCUMBER)
          (CRAVES BOILS SCALLION)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS SCALLION LETTUCE)
          (EATS HAMBURGER LOBSTER)
          (CRAVES ANXIETY-7 ONION)
          (EATS APPLE MUFFIN)
          (CRAVES GRIEF RICE)
          (EATS SWEETROLL PEAR)
          (EATS ENDIVE YOGURT)
          (EATS SWEETROLL APPLE)
          (EATS CHICKEN PAPAYA)
          (EATS MUFFIN APPLE)
          (CRAVES DEPRESSION RICE)
          (CRAVES SCIATICA-15 COD)
          (EATS OKRA SCALLION)
          (EATS HAMBURGER CHICKEN)
          (EATS SWEETROLL ONION)
          (LOCALE LEMON MANITOBA)
          (EATS COD TURKEY)
          (CRAVES HANGOVER-9 MUTTON)
          (HARMONY AESTHETICS MARS)
          (LOCALE BEEF GUANABARA)
          (EATS YOGURT LETTUCE)
          (EATS PAPAYA ONION)
          (LOCALE HAM GUANABARA)
          (EATS HAMBURGER SWEETROLL)
          (EATS OKRA ENDIVE))
   (:GOAL (AND (CRAVES ANGINA-4 RICE)
               (CRAVES LONELINESS-13 RICE))))

(DEFINE (PROBLEM MYST-10)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS POTATO KALE MUTTON WURST GRAPEFRUIT POPOVER HAROSET
             CUCUMBER APPLE HOTDOG ORANGE PORK SNICKERS LEMON TOMATO MUFFIN
             LOBSTER SCALLION HAMBURGER SHRIMP ONION - FOOD
             ACHIEVEMENT AESTHETICS UNDERSTANDING ENTERTAINMENT LUBRICITY
             EXCITEMENT REST TRIUMPH LEARNING SATIETY - PLEASURE
             LONELINESS DEPRESSION LACERATION PROSTATITIS ANXIETY SCIATICA
             JEALOUSY ANGER - PAIN
             SURREY GUANABARA ARIZONA BOSNIA OREGON GOIAS QUEBEC
             PENNSYLVANIA BAVARIA KENTUCKY MANITOBA - PROVINCE
             VULCAN VENUS SATURN PLUTO - PLANET)
   (:INIT (EATS CUCUMBER SNICKERS)
          (EATS PORK HOTDOG)
          (LOCALE LOBSTER GUANABARA)
          (EATS PORK GRAPEFRUIT)
          (EATS HOTDOG ORANGE)
          (ATTACKS ARIZONA BOSNIA)
          (CRAVES LEARNING SCALLION)
          (LOCALE WURST QUEBEC)
          (LOCALE ONION QUEBEC)
          (CRAVES ANXIETY LEMON)
          (ATTACKS BOSNIA OREGON)
          (EATS LEMON ORANGE)
          (CRAVES DEPRESSION WURST)
          (EATS LEMON SNICKERS)
          (LOCALE MUFFIN GOIAS)
          (LOCALE MUTTON QUEBEC)
          (ATTACKS GUANABARA ARIZONA)
          (HARMONY TRIUMPH VENUS)
          (LOCALE KALE MANITOBA)
          (CRAVES LONELINESS KALE)
          (ATTACKS SURREY GUANABARA)
          (EATS SHRIMP TOMATO)
          (EATS APPLE POPOVER)
          (EATS SNICKERS HAROSET)
          (EATS KALE GRAPEFRUIT)
          (LOCALE ORANGE ARIZONA)
          (CRAVES ENTERTAINMENT GRAPEFRUIT)
          (ATTACKS GOIAS QUEBEC)
          (ATTACKS KENTUCKY MANITOBA)
          (LOCALE LEMON BOSNIA)
          (LOCALE POTATO KENTUCKY)
          (EATS LOBSTER SHRIMP)
          (CRAVES EXCITEMENT APPLE)
          (EATS WURST MUTTON)
          (EATS POTATO WURST)
          (CRAVES JEALOUSY HAMBURGER)
          (HARMONY AESTHETICS PLUTO)
          (EATS MUTTON KALE)
          (EATS PORK CUCUMBER)
          (EATS SNICKERS LEMON)
          (EATS SNICKERS POPOVER)
          (CRAVES LUBRICITY HAROSET)
          (LOCALE SHRIMP GOIAS)
          (LOCALE APPLE OREGON)
          (EATS GRAPEFRUIT WURST)
          (LOCALE SCALLION OREGON)
          (CRAVES LACERATION POPOVER)
          (EATS GRAPEFRUIT KALE)
          (LOCALE HOTDOG ARIZONA)
          (HARMONY LUBRICITY VENUS)
          (CRAVES REST HOTDOG)
          (LOCALE CUCUMBER BAVARIA)
          (CRAVES SATIETY SHRIMP)
          (CRAVES UNDERSTANDING MUTTON)
          (HARMONY REST VENUS)
          (EATS POPOVER SNICKERS)
          (ORBITS VENUS SATURN)
          (EATS POPOVER ORANGE)
          (LOCALE PORK PENNSYLVANIA)
          (EATS MUFFIN TOMATO)
          (EATS APPLE ORANGE)
          (EATS HAMBURGER SCALLION)
          (CRAVES ANGER SHRIMP)
          (LOCALE POPOVER OREGON)
          (EATS POPOVER APPLE)
          (EATS CUCUMBER PORK)
          (ATTACKS OREGON GOIAS)
          (CRAVES ACHIEVEMENT POTATO)
          (EATS SCALLION MUFFIN)
          (EATS ONION SHRIMP)
          (EATS TOMATO ONION)
          (EATS APPLE HAROSET)
          (HARMONY ENTERTAINMENT PLUTO)
          (EATS HAROSET SNICKERS)
          (LOCALE HAMBURGER GUANABARA)
          (EATS WURST GRAPEFRUIT)
          (EATS SHRIMP ONION)
          (ATTACKS QUEBEC PENNSYLVANIA)
          (EATS ONION TOMATO)
          (EATS LOBSTER HAMBURGER)
          (EATS SHRIMP LOBSTER)
          (EATS HAMBURGER LOBSTER)
          (CRAVES TRIUMPH MUFFIN)
          (EATS MUTTON WURST)
          (EATS SNICKERS SCALLION)
          (EATS WURST POTATO)
          (HARMONY UNDERSTANDING VENUS)
          (LOCALE TOMATO ARIZONA)
          (CRAVES PROSTATITIS HAROSET)
          (HARMONY LEARNING VENUS)
          (EATS MUFFIN SCALLION)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS SCALLION HAMBURGER)
          (CRAVES AESTHETICS KALE)
          (EATS ORANGE POPOVER)
          (EATS KALE MUTTON)
          (EATS HOTDOG APPLE)
          (ORBITS VULCAN VENUS)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (LOCALE HAROSET BOSNIA)
          (HARMONY EXCITEMENT VENUS)
          (EATS APPLE HOTDOG)
          (EATS ONION SCALLION)
          (EATS SNICKERS CUCUMBER)
          (EATS HOTDOG PORK)
          (LOCALE GRAPEFRUIT QUEBEC)
          (EATS TOMATO SHRIMP)
          (EATS ORANGE APPLE)
          (EATS HAROSET APPLE)
          (EATS KALE POTATO)
          (LOCALE SNICKERS MANITOBA)
          (EATS SCALLION SNICKERS)
          (EATS SCALLION ONION)
          (EATS ORANGE LEMON)
          (ORBITS SATURN PLUTO)
          (HARMONY SATIETY SATURN)
          (EATS POTATO KALE)
          (EATS TOMATO MUFFIN)
          (ATTACKS BAVARIA KENTUCKY)
          (EATS ORANGE HOTDOG)
          (EATS GRAPEFRUIT PORK)
          (CRAVES SCIATICA SCALLION))
   (:GOAL (AND (CRAVES SCIATICA TOMATO)
               (CRAVES LONELINESS CUCUMBER)
               (CRAVES ANGER APPLE))))

(DEFINE (PROBLEM MYSTY-11)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS HAMBURGER HAM SHRIMP MUFFIN YOGURT SCALLOP
             TUNA OKRA CUCUMBER MARZIPAN TOMATO MELON
             FLOUNDER KALE SNICKERS - FOOD
             LUBRICITY - PLEASURE
             HANGOVER BOILS DEPRESSION GRIEF PROSTATITIS
             JEALOUSY SCIATICA DREAD ABRASION ANXIETY ANGER
             LONELINESS ANGINA LACERATION JEALOUSY-1 GRIEF-2
             LACERATION-8 PROSTATITIS-3 ANXIETY-4 DEPRESSION-7
             ANGINA-16 SCIATICA-5 HANGOVER-6 LONELINESS-15
             ABRASION-13 DREAD-14 - PAIN
             MANITOBA - PROVINCE
             PLUTO MARS - PLANET)
   (:INIT (EATS TOMATO KALE)
          (EATS TOMATO SNICKERS)
          (CRAVES DEPRESSION HAM)
          (EATS YOGURT OKRA)
          (EATS TUNA OKRA)
          (EATS MUFFIN YOGURT)
          (EATS SNICKERS MELON)
          (EATS MUFFIN SHRIMP)
          (LOCALE MARZIPAN MANITOBA)
          (LOCALE OKRA MANITOBA)
          (LOCALE YOGURT MANITOBA)
          (CRAVES LUBRICITY CUCUMBER)
          (EATS MELON MARZIPAN)
          (CRAVES DREAD YOGURT)
          (LOCALE MELON MANITOBA)
          (LOCALE TUNA MANITOBA)
          (CRAVES LONELINESS OKRA)
          (CRAVES LACERATION-8 TOMATO)
          (EATS CUCUMBER FLOUNDER)
          (EATS OKRA YOGURT)
          (CRAVES SCIATICA-5 FLOUNDER)
          (LOCALE MUFFIN MANITOBA)
          (CRAVES GRIEF HAM)
          (CRAVES SCIATICA MUFFIN)
          (EATS MARZIPAN CUCUMBER)
          (EATS CUCUMBER MARZIPAN)
          (EATS YOGURT SCALLOP)
          (LOCALE SCALLOP MANITOBA)
          (EATS FLOUNDER KALE)
          (CRAVES GRIEF-2 MARZIPAN)
          (EATS OKRA FLOUNDER)
          (EATS KALE TOMATO)
          (CRAVES DEPRESSION-7 MELON)
          (CRAVES ANXIETY TUNA)
          (EATS FLOUNDER CUCUMBER)
          (CRAVES HANGOVER-6 FLOUNDER)
          (EATS YOGURT MUFFIN)
          (CRAVES HANGOVER HAMBURGER)
          (CRAVES ANGINA-16 FLOUNDER)
          (EATS MELON SNICKERS)
          (ORBITS PLUTO MARS)
          (EATS TUNA SCALLOP)
          (CRAVES JEALOUSY SHRIMP)
          (CRAVES JEALOUSY-1 MARZIPAN)
          (EATS FLOUNDER OKRA)
          (EATS HAMBURGER HAM)
          (CRAVES PROSTATITIS-3 TOMATO)
          (EATS SNICKERS TOMATO)
          (EATS SHRIMP HAM)
          (CRAVES ANGINA CUCUMBER)
          (EATS SCALLOP YOGURT)
          (CRAVES BOILS HAM)
          (EATS MARZIPAN MELON)
          (CRAVES LONELINESS-15 KALE)
          (EATS HAM SHRIMP)
          (LOCALE HAMBURGER MANITOBA)
          (LOCALE HAM MANITOBA)
          (EATS FLOUNDER TOMATO)
          (CRAVES DREAD-14 SNICKERS)
          (CRAVES LACERATION CUCUMBER)
          (LOCALE KALE MANITOBA)
          (LOCALE TOMATO MANITOBA)
          (EATS HAM HAMBURGER)
          (LOCALE CUCUMBER MANITOBA)
          (LOCALE FLOUNDER MANITOBA)
          (CRAVES ABRASION SCALLOP)
          (EATS SHRIMP MUFFIN)
          (LOCALE SNICKERS MANITOBA)
          (LOCALE SHRIMP MANITOBA)
          (CRAVES ANXIETY-4 TOMATO)
          (EATS OKRA TUNA)
          (EATS MUFFIN HAMBURGER)
          (CRAVES ANGER OKRA)
          (EATS HAMBURGER MUFFIN)
          (EATS SCALLOP TUNA)
          (EATS KALE FLOUNDER)
          (HARMONY LUBRICITY MARS)
          (EATS TOMATO FLOUNDER)
          (CRAVES ABRASION-13 SNICKERS)
          (CRAVES PROSTATITIS SHRIMP))
   (:GOAL (AND (CRAVES GRIEF-2 SNICKERS))))

(DEFINE (PROBLEM MYSTY-12)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TUNA BROCCOLI LETTUCE SWEETROLL KALE LAMB
             SCALLOP TOMATO CANTELOPE MARZIPAN HAROSET APPLE
             FLOUNDER CHICKEN - FOOD
             UNDERSTANDING INTOXICATION SATISFACTION CURIOSITY
             ACHIEVEMENT REST SATIETY TRIUMPH LEARNING EXCITEMENT
             ENTERTAINMENT - PLEASURE
             ABRASION BOILS LACERATION GRIEF JEALOUSY DREAD
             LONELINESS ANGER ANGINA SCIATICA ANXIETY DEPRESSION
             HANGOVER JEALOUSY-1 HANGOVER-2 PROSTATITIS
             ANXIETY-7 ANGINA-8 DEPRESSION-3 ANGER-4
             LONELINESS-15 LACERATION-16 BOILS-5 GRIEF-6
             PROSTATITIS-11 DREAD-12 ABRASION-13 SCIATICA-14
             DEPRESSION-31 ANGER-32 JEALOUSY-9 ABRASION-10 GRIEF-29
             HANGOVER-30 DREAD-26 ANGINA-27 BOILS-28 LONELINESS-22
             ANXIETY-23 PROSTATITIS-24 LACERATION-25 - PAIN
             MANITOBA BAVARIA ARIZONA - PROVINCE
             EARTH URANUS VULCAN VENUS - PLANET)
   (:INIT (CRAVES INTOXICATION LETTUCE)
          (EATS TUNA SCALLOP)
          (EATS LETTUCE BROCCOLI)
          (CRAVES DREAD-26 FLOUNDER)
          (CRAVES DEPRESSION-3 TOMATO)
          (HARMONY INTOXICATION URANUS)
          (HARMONY SATISFACTION VULCAN)
          (HARMONY CURIOSITY URANUS)
          (CRAVES SCIATICA-14 MARZIPAN)
          (HARMONY REST VENUS)
          (CRAVES PROSTATITIS-11 MARZIPAN)
          (CRAVES ABRASION-10 HAROSET)
          (CRAVES SCIATICA SWEETROLL)
          (LOCALE APPLE BAVARIA)
          (CRAVES BOILS BROCCOLI)
          (LOCALE BROCCOLI BAVARIA)
          (CRAVES SATIETY CANTELOPE)
          (CRAVES ANGER SWEETROLL)
          (CRAVES ABRASION-13 MARZIPAN)
          (ATTACKS BAVARIA ARIZONA)
          (LOCALE FLOUNDER BAVARIA)
          (EATS HAROSET APPLE)
          (EATS APPLE HAROSET)
          (EATS SCALLOP TUNA)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS KALE APPLE)
          (EATS HAROSET CHICKEN)
          (EATS TUNA BROCCOLI)
          (CRAVES ANGER-32 HAROSET)
          (CRAVES ANGINA-8 TOMATO)
          (CRAVES HANGOVER-2 SCALLOP)
          (LOCALE TOMATO ARIZONA)
          (LOCALE LAMB MANITOBA)
          (EATS KALE TOMATO)
          (CRAVES UNDERSTANDING TUNA)
          (CRAVES REST TOMATO)
          (EATS BROCCOLI LETTUCE)
          (CRAVES CURIOSITY LAMB)
          (EATS SCALLOP LAMB)
          (LOCALE SCALLOP ARIZONA)
          (CRAVES ANXIETY-7 TOMATO)
          (CRAVES ABRASION TUNA)
          (LOCALE SWEETROLL ARIZONA)
          (CRAVES ANXIETY-23 CHICKEN)
          (CRAVES PROSTATITIS-24 CHICKEN)
          (CRAVES LONELINESS LETTUCE)
          (LOCALE TUNA BAVARIA)
          (EATS TOMATO LAMB)
          (EATS TOMATO KALE)
          (EATS APPLE KALE)
          (LOCALE LETTUCE MANITOBA)
          (EATS FLOUNDER MARZIPAN)
          (ORBITS VULCAN VENUS)
          (CRAVES ANXIETY SWEETROLL)
          (CRAVES ACHIEVEMENT SCALLOP)
          (EATS MARZIPAN FLOUNDER)
          (EATS LAMB TOMATO)
          (CRAVES HANGOVER-30 APPLE)
          (CRAVES ANGINA SWEETROLL)
          (EATS CANTELOPE TOMATO)
          (EATS CHICKEN HAROSET)
          (ORBITS EARTH URANUS)
          (EATS LAMB SCALLOP)
          (HARMONY ENTERTAINMENT VENUS)
          (CRAVES JEALOUSY-9 HAROSET)
          (EATS APPLE SWEETROLL)
          (CRAVES GRIEF LETTUCE)
          (EATS SWEETROLL APPLE)
          (ORBITS URANUS VULCAN)
          (EATS CANTELOPE LAMB)
          (LOCALE CANTELOPE MANITOBA)
          (CRAVES BOILS-28 FLOUNDER)
          (EATS TUNA SWEETROLL)
          (EATS SWEETROLL LETTUCE)
          (EATS SWEETROLL TUNA)
          (EATS FLOUNDER APPLE)
          (CRAVES LONELINESS-15 CANTELOPE)
          (CRAVES EXCITEMENT APPLE)
          (EATS BROCCOLI TUNA)
          (CRAVES DREAD LETTUCE)
          (CRAVES HANGOVER LAMB)
          (HARMONY EXCITEMENT URANUS)
          (LOCALE MARZIPAN MANITOBA)
          (CRAVES PROSTATITIS SCALLOP)
          (LOCALE HAROSET MANITOBA)
          (HARMONY LEARNING URANUS)
          (CRAVES ANGER-4 TOMATO)
          (EATS LETTUCE SWEETROLL)
          (CRAVES TRIUMPH MARZIPAN)
          (ATTACKS MANITOBA BAVARIA)
          (CRAVES LEARNING HAROSET)
          (CRAVES JEALOUSY LETTUCE)
          (EATS APPLE FLOUNDER)
          (CRAVES DEPRESSION-31 HAROSET)
          (CRAVES LONELINESS-22 CHICKEN)
          (CRAVES DREAD-12 MARZIPAN)
          (CRAVES LACERATION-16 CANTELOPE)
          (EATS SCALLOP KALE)
          (CRAVES DEPRESSION KALE)
          (HARMONY UNDERSTANDING VULCAN)
          (HARMONY TRIUMPH VULCAN)
          (EATS KALE SCALLOP)
          (CRAVES SATISFACTION KALE)
          (HARMONY SATIETY VENUS)
          (CRAVES BOILS-5 CANTELOPE)
          (EATS CHICKEN MARZIPAN)
          (LOCALE CHICKEN BAVARIA)
          (CRAVES GRIEF-29 APPLE)
          (CRAVES LACERATION BROCCOLI)
          (CRAVES GRIEF-6 CANTELOPE)
          (CRAVES ENTERTAINMENT CHICKEN)
          (EATS MARZIPAN CHICKEN)
          (CRAVES ANGINA-27 FLOUNDER)
          (EATS LAMB CANTELOPE)
          (CRAVES JEALOUSY-1 SCALLOP)
          (CRAVES LACERATION-25 CHICKEN)
          (LOCALE KALE MANITOBA)
          (EATS TOMATO CANTELOPE))
   (:GOAL (AND (CRAVES JEALOUSY LAMB))))

(DEFINE (PROBLEM MYSTY-13)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS OKRA TOFU HAM SCALLOP SHRIMP HAMBURGER
             PAPAYA HOTDOG TUNA - FOOD
             ENTERTAINMENT STIMULATION TRIUMPH LEARNING EXCITEMENT
             CURIOSITY INTOXICATION - PLEASURE
             HANGOVER GRIEF ANGINA ANXIETY LACERATION JEALOUSY
             ANGER SCIATICA PROSTATITIS BOILS DEPRESSION
             DREAD ABRASION - PAIN
             ALSACE QUEBEC MORAVIA MANITOBA - PROVINCE
             MERCURY PLUTO URANUS EARTH - PLANET)
   (:INIT (HARMONY INTOXICATION URANUS)
          (EATS SCALLOP TOFU)
          (CRAVES DEPRESSION HOTDOG)
          (CRAVES TRIUMPH HAM)
          (CRAVES BOILS PAPAYA)
          (HARMONY STIMULATION PLUTO)
          (LOCALE TOFU QUEBEC)
          (HARMONY EXCITEMENT EARTH)
          (CRAVES ANXIETY SCALLOP)
          (LOCALE TUNA MANITOBA)
          (LOCALE SHRIMP MORAVIA)
          (CRAVES JEALOUSY SHRIMP)
          (CRAVES CURIOSITY HOTDOG)
          (EATS PAPAYA OKRA)
          (EATS HAM TUNA)
          (EATS TUNA HAM)
          (CRAVES ANGER SHRIMP)
          (HARMONY ENTERTAINMENT URANUS)
          (CRAVES ANGINA HAM)
          (CRAVES GRIEF TOFU)
          (LOCALE SCALLOP MORAVIA)
          (EATS TOFU HAMBURGER)
          (CRAVES STIMULATION TOFU)
          (EATS HOTDOG PAPAYA)
          (LOCALE HOTDOG ALSACE)
          (CRAVES EXCITEMENT PAPAYA)
          (EATS PAPAYA HOTDOG)
          (EATS HOTDOG HAM)
          (CRAVES PROSTATITIS HAMBURGER)
          (HARMONY TRIUMPH URANUS)
          (CRAVES DREAD TUNA)
          (HARMONY LEARNING PLUTO)
          (EATS HOTDOG SHRIMP)
          (EATS TOFU SCALLOP)
          (CRAVES SCIATICA HAMBURGER)
          (CRAVES INTOXICATION TUNA)
          (ATTACKS QUEBEC MORAVIA)
          (EATS SHRIMP SCALLOP)
          (ORBITS MERCURY PLUTO)
          (CRAVES LEARNING HAMBURGER)
          (ATTACKS ALSACE QUEBEC)
          (ORBITS URANUS EARTH)
          (CRAVES HANGOVER OKRA)
          (EATS TUNA SHRIMP)
          (LOCALE OKRA ALSACE)
          (CRAVES ABRASION TUNA)
          (LOCALE PAPAYA ALSACE)
          (EATS HAMBURGER TOFU)
          (EATS HAM HOTDOG)
          (EATS OKRA PAPAYA)
          (EATS SHRIMP TUNA)
          (EATS SCALLOP SHRIMP)
          (LOCALE HAM ALSACE)
          (CRAVES ENTERTAINMENT OKRA)
          (LOCALE HAMBURGER QUEBEC)
          (EATS OKRA HAMBURGER)
          (ATTACKS MORAVIA MANITOBA)
          (EATS HAMBURGER OKRA)
          (CRAVES LACERATION SCALLOP)
          (ORBITS PLUTO URANUS)
          (EATS SHRIMP HOTDOG)
          (HARMONY CURIOSITY EARTH))
   (:GOAL (AND (CRAVES ANXIETY HAM))))

(DEFINE (PROBLEM MYSTY-14)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS WURST PEA PAPAYA RICE CUCUMBER YOGURT PEAR
             HAMBURGER TOMATO ENDIVE - FOOD
             INTOXICATION - PLEASURE
             DEPRESSION ABRASION HANGOVER JEALOUSY GRIEF
             PROSTATITIS ANGINA DREAD SCIATICA BOILS LONELINESS
             - PAIN
             BAVARIA - PROVINCE
             EARTH - PLANET)
   (:INIT (HARMONY INTOXICATION EARTH)
          (EATS WURST PAPAYA)
          (CRAVES INTOXICATION ENDIVE)
          (EATS PEA YOGURT)
          (CRAVES BOILS ENDIVE)
          (EATS HAMBURGER PEAR)
          (EATS PAPAYA WURST)
          (LOCALE RICE BAVARIA)
          (EATS PAPAYA CUCUMBER)
          (LOCALE YOGURT BAVARIA)
          (EATS PEAR TOMATO)
          (LOCALE PEA BAVARIA)
          (CRAVES PROSTATITIS YOGURT)
          (EATS TOMATO YOGURT)
          (CRAVES ANGINA YOGURT)
          (EATS PEA PAPAYA)
          (CRAVES JEALOUSY PAPAYA)
          (EATS YOGURT PEA)
          (EATS WURST RICE)
          (EATS HAMBURGER TOMATO)
          (EATS YOGURT TOMATO)
          (CRAVES HANGOVER PAPAYA)
          (CRAVES LONELINESS ENDIVE)
          (LOCALE HAMBURGER BAVARIA)
          (LOCALE WURST BAVARIA)
          (CRAVES SCIATICA TOMATO)
          (EATS YOGURT ENDIVE)
          (EATS RICE CUCUMBER)
          (EATS CUCUMBER RICE)
          (LOCALE TOMATO BAVARIA)
          (CRAVES GRIEF CUCUMBER)
          (LOCALE CUCUMBER BAVARIA)
          (EATS RICE WURST)
          (EATS PAPAYA PEA)
          (EATS PEA CUCUMBER)
          (EATS ENDIVE PEAR)
          (EATS PEAR ENDIVE)
          (EATS CUCUMBER PAPAYA)
          (EATS PEAR HAMBURGER)
          (EATS TOMATO HAMBURGER)
          (EATS ENDIVE YOGURT)
          (EATS TOMATO PEAR)
          (EATS CUCUMBER PEA)
          (LOCALE ENDIVE BAVARIA)
          (LOCALE PAPAYA BAVARIA)
          (CRAVES ABRASION PAPAYA)
          (CRAVES DREAD TOMATO)
          (LOCALE PEAR BAVARIA)
          (CRAVES DEPRESSION WURST))
   (:GOAL (AND (CRAVES SCIATICA YOGURT))))

(DEFINE (PROBLEM MYSTY-15)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LAMB SCALLION CANTELOPE TOMATO POTATO KALE
             HAMBURGER PEAR BAGUETTE CHERRY PAPAYA TUNA BEEF
             CHOCOLATE LETTUCE COD HAM PEPPER TURKEY GUAVA SCALLOP
             POPOVER HOTDOG LEMON OKRA BROCCOLI CUCUMBER PEA
             APPLE MUTTON SNICKERS FLOUNDER MUFFIN TOFU SHRIMP
             - FOOD
             EXPECTATION AESTHETICS UNDERSTANDING STIMULATION LOVE
             CURIOSITY INTOXICATION SATIETY EXCITEMENT LUBRICITY
             EMPATHY SATISFACTION ENTERTAINMENT - PLEASURE
             ANGINA LACERATION ABRASION DEPRESSION ANXIETY
             GRIEF HANGOVER PROSTATITIS DREAD JEALOUSY
             LONELINESS SCIATICA HANGOVER-2 BOILS ANGER ANGER-3
             ABRASION-4 GRIEF-1 ANXIETY-6 BOILS-7 JEALOUSY-8
             LONELINESS-15 ANGINA-16 LACERATION-5 DREAD-12
             SCIATICA-13 PROSTATITIS-14 ANGINA-10 DEPRESSION-11
             SCIATICA-32 ANGER-9 LONELINESS-31 BOILS-29 ANXIETY-30
             GRIEF-26 JEALOUSY-27 ABRASION-28 PROSTATITIS-23
             LACERATION-24 HANGOVER-25 DEPRESSION-21 DREAD-22
             ANXIETY-18 DEPRESSION-19 ABRASION-20 HANGOVER-17
             ANGINA-64 LONELINESS-61 SCIATICA-62 DREAD-63
             ANGER-60 PROSTATITIS-59 GRIEF-57 JEALOUSY-58
             BOILS-55 LACERATION-56 SCIATICA-53 HANGOVER-54
             ANGINA-51 BOILS-52 ANGER-49 GRIEF-50 PROSTATITIS-47
             DEPRESSION-48 LONELINESS-46 ABRASION-44 DREAD-45
             ANXIETY-41 LACERATION-42 JEALOUSY-43 DEPRESSION-39
             ABRASION-40 ANGER-37 HANGOVER-38 - PAIN
             ARIZONA BAVARIA ALSACE KENTUCKY MANITOBA
             PENNSYLVANIA - PROVINCE
             SATURN URANUS NEPTUNE MARS - PLANET)
   (:INIT (EATS LETTUCE OKRA)
          (EATS GUAVA APPLE)
          (EATS HAM CHOCOLATE)
          (CRAVES ANXIETY-41 MUFFIN)
          (LOCALE KALE MANITOBA)
          (CRAVES HANGOVER-2 HAMBURGER)
          (CRAVES BOILS-7 BAGUETTE)
          (HARMONY ENTERTAINMENT MARS)
          (LOCALE HAM ARIZONA)
          (HARMONY LUBRICITY URANUS)
          (EATS CHOCOLATE HAM)
          (CRAVES LONELINESS-31 CHOCOLATE)
          (LOCALE FLOUNDER BAVARIA)
          (HARMONY EXCITEMENT URANUS)
          (EATS CANTELOPE POTATO)
          (CRAVES JEALOUSY-58 OKRA)
          (ORBITS NEPTUNE MARS)
          (EATS MUTTON PEPPER)
          (EATS HOTDOG MUFFIN)
          (EATS BROCCOLI SCALLOP)
          (ATTACKS BAVARIA ALSACE)
          (CRAVES LONELINESS POTATO)
          (LOCALE CUCUMBER ARIZONA)
          (HARMONY INTOXICATION URANUS)
          (CRAVES LONELINESS-15 CHERRY)
          (EATS HAM MUTTON)
          (CRAVES GRIEF-57 OKRA)
          (CRAVES ABRASION LAMB)
          (CRAVES ANXIETY-6 BAGUETTE)
          (LOCALE OKRA ALSACE)
          (CRAVES JEALOUSY TOMATO)
          (CRAVES GRIEF SCALLION)
          (CRAVES DEPRESSION-39 TOFU)
          (EATS POTATO CANTELOPE)
          (EATS PAPAYA CHERRY)
          (EATS MUTTON HAM)
          (EATS PEPPER MUTTON)
          (HARMONY CURIOSITY NEPTUNE)
          (EATS HAM COD)
          (EATS SCALLION KALE)
          (LOCALE BROCCOLI BAVARIA)
          (EATS BROCCOLI LEMON)
          (EATS GUAVA CUCUMBER)
          (CRAVES SCIATICA-13 PAPAYA)
          (CRAVES ABRASION-28 COD)
          (CRAVES GRIEF-26 COD)
          (EATS APPLE HOTDOG)
          (CRAVES LACERATION-56 BROCCOLI)
          (CRAVES GRIEF-1 PEAR)
          (EATS CUCUMBER GUAVA)
          (CRAVES ANGER-3 PEAR)
          (LOCALE CHOCOLATE ARIZONA)
          (CRAVES ANGER-49 APPLE)
          (LOCALE POPOVER ARIZONA)
          (EATS POTATO PEAR)
          (CRAVES LONELINESS-46 SNICKERS)
          (EATS LAMB HAMBURGER)
          (CRAVES EXCITEMENT MUTTON)
          (EATS TOFU PEPPER)
          (CRAVES JEALOUSY-27 COD)
          (EATS KALE LAMB)
          (EATS PEPPER TOFU)
          (CRAVES GRIEF-50 APPLE)
          (EATS SHRIMP SNICKERS)
          (LOCALE PEA ARIZONA)
          (EATS HAM OKRA)
          (EATS HAMBURGER TOMATO)
          (CRAVES PROSTATITIS-59 LEMON)
          (HARMONY EMPATHY NEPTUNE)
          (EATS GUAVA OKRA)
          (CRAVES ANGER-60 HOTDOG)
          (EATS OKRA LETTUCE)
          (LOCALE SNICKERS ALSACE)
          (CRAVES HANGOVER-54 CUCUMBER)
          (CRAVES LONELINESS-61 POPOVER)
          (EATS CUCUMBER KALE)
          (LOCALE TURKEY ARIZONA)
          (LOCALE CHERRY ALSACE)
          (EATS SCALLOP BROCCOLI)
          (EATS COD HAM)
          (LOCALE HAMBURGER MANITOBA)
          (LOCALE SHRIMP PENNSYLVANIA)
          (LOCALE PEPPER ARIZONA)
          (CRAVES ANGINA-51 PEA)
          (EATS TURKEY SHRIMP)
          (EATS LEMON SNICKERS)
          (CRAVES ANGER-9 BEEF)
          (CRAVES UNDERSTANDING HAMBURGER)
          (EATS TUNA BEEF)
          (CRAVES EXPECTATION SCALLION)
          (CRAVES PROSTATITIS CANTELOPE)
          (EATS PEA SNICKERS)
          (CRAVES SCIATICA-53 CUCUMBER)
          (LOCALE APPLE ARIZONA)
          (CRAVES ANGINA-64 SCALLOP)
          (EATS CUCUMBER SCALLOP)
          (LOCALE POTATO ALSACE)
          (CRAVES ANGINA LAMB)
          (CRAVES ANGINA-10 TUNA)
          (CRAVES SATISFACTION MUFFIN)
          (EATS FLOUNDER PEA)
          (EATS MUFFIN CHERRY)
          (CRAVES PROSTATITIS-47 MUTTON)
          (EATS SCALLION TUNA)
          (CRAVES DEPRESSION-19 TURKEY)
          (CRAVES DREAD-63 POPOVER)
          (EATS TUNA SCALLION)
          (EATS HOTDOG POPOVER)
          (LOCALE LETTUCE MANITOBA)
          (LOCALE SCALLOP ARIZONA)
          (EATS PEAR POTATO)
          (EATS HOTDOG APPLE)
          (EATS SHRIMP TURKEY)
          (EATS SNICKERS SHRIMP)
          (CRAVES DREAD-12 PAPAYA)
          (CRAVES EMPATHY FLOUNDER)
          (LOCALE BAGUETTE KENTUCKY)
          (ATTACKS ARIZONA BAVARIA)
          (CRAVES ANGER-37 SHRIMP)
          (EATS MUFFIN POPOVER)
          (ATTACKS ALSACE KENTUCKY)
          (CRAVES ANGINA-16 CHERRY)
          (EATS POTATO BAGUETTE)
          (EATS POPOVER HOTDOG)
          (CRAVES HANGOVER-38 SHRIMP)
          (CRAVES ABRASION-4 PEAR)
          (EATS APPLE GUAVA)
          (EATS FLOUNDER LEMON)
          (ORBITS SATURN URANUS)
          (EATS CUCUMBER COD)
          (CRAVES CURIOSITY TUNA)
          (EATS KALE CUCUMBER)
          (EATS PEA FLOUNDER)
          (CRAVES HANGOVER CANTELOPE)
          (ATTACKS MANITOBA PENNSYLVANIA)
          (HARMONY STIMULATION NEPTUNE)
          (CRAVES BOILS-29 LETTUCE)
          (HARMONY EXPECTATION MARS)
          (EATS APPLE FLOUNDER)
          (EATS SCALLOP CUCUMBER)
          (CRAVES LUBRICITY SNICKERS)
          (HARMONY LOVE URANUS)
          (CRAVES HANGOVER-25 HAM)
          (EATS LAMB KALE)
          (EATS BEEF CHERRY)
          (EATS MUFFIN HOTDOG)
          (LOCALE TOFU ARIZONA)
          (ORBITS URANUS NEPTUNE)
          (CRAVES SCIATICA-62 POPOVER)
          (CRAVES DREAD-22 PEPPER)
          (LOCALE SCALLION KENTUCKY)
          (CRAVES ANXIETY-30 LETTUCE)
          (CRAVES DREAD TOMATO)
          (LOCALE LAMB PENNSYLVANIA)
          (LOCALE CANTELOPE BAVARIA)
          (CRAVES JEALOUSY-43 MUFFIN)
          (CRAVES DEPRESSION SCALLION)
          (HARMONY AESTHETICS URANUS)
          (EATS TOMATO HAMBURGER)
          (EATS CHERRY BEEF)
          (EATS LEMON FLOUNDER)
          (CRAVES BOILS-55 BROCCOLI)
          (LOCALE MUFFIN MANITOBA)
          (CRAVES DEPRESSION-21 PEPPER)
          (EATS PEAR TOMATO)
          (CRAVES STIMULATION BAGUETTE)
          (EATS LEMON BROCCOLI)
          (CRAVES AESTHETICS KALE)
          (EATS CHERRY MUFFIN)
          (HARMONY SATIETY MARS)
          (LOCALE LEMON KENTUCKY)
          (LOCALE PEAR PENNSYLVANIA)
          (CRAVES JEALOUSY-8 BAGUETTE)
          (CRAVES BOILS-52 PEA)
          (CRAVES ENTERTAINMENT SHRIMP)
          (EATS HAMBURGER LAMB)
          (EATS HAMBURGER CANTELOPE)
          (LOCALE BEEF ARIZONA)
          (HARMONY SATISFACTION URANUS)
          (CRAVES ABRASION-40 TOFU)
          (EATS TUNA PAPAYA)
          (EATS SNICKERS LEMON)
          (LOCALE GUAVA ALSACE)
          (EATS OKRA HAM)
          (EATS BAGUETTE SCALLION)
          (CRAVES LACERATION-5 CHERRY)
          (CRAVES PROSTATITIS-14 PAPAYA)
          (LOCALE COD ARIZONA)
          (CRAVES SCIATICA-32 BEEF)
          (LOCALE TUNA BAVARIA)
          (CRAVES ANGER HAMBURGER)
          (CRAVES ABRASION-20 TURKEY)
          (CRAVES INTOXICATION CHOCOLATE)
          (CRAVES ABRASION-44 FLOUNDER)
          (CRAVES PROSTATITIS-23 HAM)
          (EATS CANTELOPE HAMBURGER)
          (EATS KALE SCALLION)
          (CRAVES LACERATION-24 HAM)
          (EATS FLOUNDER APPLE)
          (LOCALE PAPAYA ARIZONA)
          (CRAVES LACERATION LAMB)
          (CRAVES LACERATION-42 MUFFIN)
          (EATS OKRA GUAVA)
          (CRAVES ANXIETY SCALLION)
          (EATS CHOCOLATE SNICKERS)
          (EATS CHERRY PAPAYA)
          (EATS TOFU LETTUCE)
          (EATS TURKEY MUTTON)
          (EATS BAGUETTE POTATO)
          (EATS POPOVER TOFU)
          (EATS MUTTON TURKEY)
          (ATTACKS KENTUCKY MANITOBA)
          (CRAVES DEPRESSION-11 TUNA)
          (EATS SNICKERS CHOCOLATE)
          (EATS COD CUCUMBER)
          (CRAVES DREAD-45 FLOUNDER)
          (HARMONY UNDERSTANDING URANUS)
          (LOCALE MUTTON ARIZONA)
          (EATS BEEF TUNA)
          (CRAVES LOVE CHERRY)
          (EATS TOMATO PEAR)
          (CRAVES SATIETY OKRA)
          (CRAVES ANXIETY-18 TURKEY)
          (CRAVES HANGOVER-17 GUAVA)
          (EATS SCALLION BAGUETTE)
          (EATS PAPAYA TUNA)
          (EATS TOFU POPOVER)
          (CRAVES BOILS HAMBURGER)
          (LOCALE HOTDOG ALSACE)
          (EATS SNICKERS PEA)
          (EATS LETTUCE TOFU)
          (EATS POPOVER MUFFIN)
          (CRAVES SCIATICA KALE)
          (LOCALE TOMATO ARIZONA)
          (CRAVES DEPRESSION-48 MUTTON))
   (:GOAL (AND (CRAVES LACERATION-56 POPOVER)
               (CRAVES ABRASION-40 POPOVER)
               (CRAVES DEPRESSION-39 POTATO))))

(DEFINE (PROBLEM MYSTY-16)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS ARUGULA WURST LAMB HAROSET ONION HAM BACON
             OKRA MUFFIN TOMATO FLOUNDER CHICKEN - FOOD
             SATISFACTION CURIOSITY ENTERTAINMENT LOVE
             UNDERSTANDING ACHIEVEMENT - PLEASURE
             HANGOVER ANGINA SCIATICA ANGER LACERATION JEALOUSY
             ANXIETY GRIEF BOILS DEPRESSION PROSTATITIS DREAD
             ABRASION LONELINESS SCIATICA-1 LACERATION-2
             DREAD-3 ABRASION-4 HANGOVER-8 BOILS-5 ANGINA-6
             ANXIETY-7 LONELINESS-16 - PAIN
             ALSACE SURREY - PROVINCE
             NEPTUNE SATURN VULCAN VENUS - PLANET)
   (:INIT (EATS BACON MUFFIN)
          (EATS MUFFIN HAM)
          (CRAVES ENTERTAINMENT HAM)
          (EATS FLOUNDER HAROSET)
          (EATS HAROSET ONION)
          (LOCALE ARUGULA SURREY)
          (CRAVES ANGINA WURST)
          (ORBITS NEPTUNE SATURN)
          (CRAVES LONELINESS BACON)
          (LOCALE WURST ALSACE)
          (CRAVES PROSTATITIS HAM)
          (CRAVES JEALOUSY HAROSET)
          (CRAVES ANXIETY HAROSET)
          (EATS WURST HAROSET)
          (EATS HAM OKRA)
          (HARMONY LOVE SATURN)
          (ORBITS SATURN VULCAN)
          (EATS HAM ONION)
          (CRAVES HANGOVER ARUGULA)
          (EATS LAMB OKRA)
          (HARMONY UNDERSTANDING SATURN)
          (LOCALE HAROSET ALSACE)
          (LOCALE FLOUNDER ALSACE)
          (EATS LAMB TOMATO)
          (LOCALE CHICKEN SURREY)
          (CRAVES HANGOVER-8 TOMATO)
          (EATS ONION HAROSET)
          (EATS HAM TOMATO)
          (EATS HAM MUFFIN)
          (CRAVES LONELINESS-16 CHICKEN)
          (EATS CHICKEN FLOUNDER)
          (CRAVES ANGINA-6 FLOUNDER)
          (CRAVES ABRASION BACON)
          (EATS ONION HAM)
          (CRAVES BOILS-5 FLOUNDER)
          (EATS OKRA HAM)
          (EATS MUFFIN CHICKEN)
          (CRAVES BOILS ONION)
          (EATS TOMATO ARUGULA)
          (EATS OKRA BACON)
          (EATS CHICKEN WURST)
          (CRAVES SCIATICA LAMB)
          (EATS FLOUNDER TOMATO)
          (CRAVES LACERATION-2 OKRA)
          (LOCALE BACON SURREY)
          (CRAVES UNDERSTANDING TOMATO)
          (LOCALE MUFFIN ALSACE)
          (EATS ARUGULA ONION)
          (EATS FLOUNDER CHICKEN)
          (CRAVES ABRASION-4 MUFFIN)
          (LOCALE ONION SURREY)
          (ORBITS VULCAN VENUS)
          (LOCALE OKRA ALSACE)
          (CRAVES ANGER LAMB)
          (CRAVES SCIATICA-1 OKRA)
          (EATS WURST CHICKEN)
          (LOCALE TOMATO ALSACE)
          (EATS HAROSET WURST)
          (EATS CHICKEN HAM)
          (CRAVES ACHIEVEMENT FLOUNDER)
          (CRAVES DREAD-3 MUFFIN)
          (EATS TOMATO HAM)
          (CRAVES DEPRESSION HAM)
          (HARMONY SATISFACTION SATURN)
          (LOCALE LAMB ALSACE)
          (EATS ARUGULA TOMATO)
          (HARMONY ACHIEVEMENT VENUS)
          (CRAVES ANXIETY-7 FLOUNDER)
          (CRAVES LOVE BACON)
          (CRAVES CURIOSITY LAMB)
          (EATS BACON OKRA)
          (EATS MUFFIN BACON)
          (CRAVES SATISFACTION ARUGULA)
          (HARMONY CURIOSITY VENUS)
          (EATS CHICKEN MUFFIN)
          (EATS HAROSET FLOUNDER)
          (CRAVES LACERATION HAROSET)
          (EATS HAM CHICKEN)
          (EATS ONION ARUGULA)
          (CRAVES GRIEF ONION)
          (LOCALE HAM SURREY)
          (EATS OKRA LAMB)
          (CRAVES DREAD BACON)
          (HARMONY ENTERTAINMENT SATURN)
          (ATTACKS ALSACE SURREY)
          (EATS TOMATO LAMB)
          (EATS TOMATO FLOUNDER))
   (:GOAL (AND (CRAVES LONELINESS LAMB)
               (CRAVES DREAD ARUGULA)
               (CRAVES HANGOVER-8 ARUGULA))))

(DEFINE (PROBLEM MYSTY-17)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS ARUGULA ORANGE FLOUNDER TUNA TOFU BACON
             SCALLOP LETTUCE RICE CHOCOLATE HOTDOG PEPPER WURST
             CHICKEN SWEETROLL PAPAYA LOBSTER TURKEY SHRIMP HAM
             APPLE MARZIPAN ONION PISTACHIO LEMON SCALLION
             SNICKERS CUCUMBER - FOOD
             UNDERSTANDING CURIOSITY ACHIEVEMENT LUBRICITY EMPATHY
             EXPECTATION - PLEASURE
             GRIEF PROSTATITIS HANGOVER ANGER JEALOUSY
             LACERATION ANGINA DEPRESSION DREAD ABRASION
             LONELINESS BOILS ANXIETY SCIATICA PROSTATITIS-4
             ANXIETY-1 HANGOVER-2 ANGER-8 DREAD-3 DEPRESSION-7
             JEALOUSY-6 LONELINESS-15 LACERATION-16 ANGINA-5
             BOILS-14 ABRASION-12 GRIEF-13 SCIATICA-11 BOILS-32
             HANGOVER-9 ANGER-10 ANGINA-31 GRIEF-29 SCIATICA-30
             LACERATION-26 PROSTATITIS-27 DREAD-28 JEALOUSY-24
             DEPRESSION-25 LONELINESS-22 ABRASION-23 GRIEF-20
             ANXIETY-21 ANGER-17 LONELINESS-18 LACERATION-19
             JEALOUSY-64 BOILS-61 SCIATICA-62 PROSTATITIS-63
             DREAD-60 ABRASION-58 HANGOVER-59 - PAIN
             BOSNIA ALSACE GUANABARA MORAVIA OREGON QUEBEC
             SURREY KENTUCKY - PROVINCE
             PLUTO MARS SATURN MERCURY - PLANET)
   (:INIT (CRAVES ANGER-10 LOBSTER)
          (EATS PISTACHIO ONION)
          (CRAVES PROSTATITIS ARUGULA)
          (EATS SCALLION APPLE)
          (LOCALE HAM ALSACE)
          (CRAVES GRIEF-20 ONION)
          (ORBITS MARS SATURN)
          (EATS HAM LOBSTER)
          (LOCALE SWEETROLL QUEBEC)
          (EATS APPLE SCALLION)
          (LOCALE LOBSTER MORAVIA)
          (EATS MARZIPAN LETTUCE)
          (EATS TUNA TOFU)
          (EATS SHRIMP HOTDOG)
          (EATS ARUGULA BACON)
          (CRAVES DREAD-3 CHOCOLATE)
          (EATS CHOCOLATE ONION)
          (EATS SNICKERS RICE)
          (EATS SWEETROLL SHRIMP)
          (EATS SHRIMP CUCUMBER)
          (LOCALE LETTUCE ALSACE)
          (EATS FLOUNDER ORANGE)
          (ATTACKS ALSACE GUANABARA)
          (CRAVES CURIOSITY RICE)
          (EATS WURST LEMON)
          (CRAVES ANGER-8 CHOCOLATE)
          (EATS PAPAYA CUCUMBER)
          (ATTACKS MORAVIA OREGON)
          (LOCALE SHRIMP KENTUCKY)
          (LOCALE CUCUMBER GUANABARA)
          (LOCALE ONION MORAVIA)
          (CRAVES DEPRESSION-7 HOTDOG)
          (CRAVES GRIEF ARUGULA)
          (LOCALE ORANGE KENTUCKY)
          (HARMONY LUBRICITY MERCURY)
          (CRAVES BOILS-14 CHICKEN)
          (ATTACKS BOSNIA ALSACE)
          (CRAVES PROSTATITIS-63 SCALLION)
          (CRAVES LONELINESS-15 WURST)
          (LOCALE BACON ALSACE)
          (CRAVES BOILS-61 SCALLION)
          (EATS PEPPER PISTACHIO)
          (CRAVES BOILS-32 LOBSTER)
          (EATS TURKEY SHRIMP)
          (CRAVES ACHIEVEMENT CHOCOLATE)
          (CRAVES GRIEF-13 SWEETROLL)
          (CRAVES PROSTATITIS-27 HAM)
          (CRAVES EMPATHY HAM)
          (EATS HAM RICE)
          (ORBITS PLUTO MARS)
          (HARMONY ACHIEVEMENT MARS)
          (CRAVES ABRASION-23 MARZIPAN)
          (EATS HOTDOG FLOUNDER)
          (EATS PEPPER LOBSTER)
          (CRAVES JEALOUSY-64 LEMON)
          (CRAVES PROSTATITIS-4 RICE)
          (EATS LEMON SCALLOP)
          (EATS TOFU TUNA)
          (CRAVES LACERATION-16 WURST)
          (EATS ONION BACON)
          (CRAVES SCIATICA LETTUCE)
          (CRAVES DREAD-28 HAM)
          (EATS SCALLION SNICKERS)
          (EATS APPLE LETTUCE)
          (CRAVES ABRASION TOFU)
          (LOCALE TUNA BOSNIA)
          (HARMONY EMPATHY MARS)
          (CRAVES LACERATION-26 HAM)
          (EATS MARZIPAN LOBSTER)
          (CRAVES DEPRESSION TOFU)
          (CRAVES ANGINA TUNA)
          (CRAVES LONELINESS-22 MARZIPAN)
          (EATS WURST CHICKEN)
          (EATS SWEETROLL ONION)
          (CRAVES HANGOVER-2 RICE)
          (EATS BACON ONION)
          (HARMONY CURIOSITY MARS)
          (EATS MARZIPAN TUNA)
          (EATS ORANGE FLOUNDER)
          (LOCALE SNICKERS GUANABARA)
          (EATS ONION CHOCOLATE)
          (LOCALE TURKEY SURREY)
          (EATS TOFU SCALLION)
          (CRAVES JEALOUSY-24 APPLE)
          (EATS RICE SNICKERS)
          (CRAVES ANGER FLOUNDER)
          (CRAVES ABRASION-58 CUCUMBER)
          (CRAVES ANGER-17 PISTACHIO)
          (LOCALE CHICKEN BOSNIA)
          (CRAVES LONELINESS BACON)
          (EATS APPLE TURKEY)
          (CRAVES LONELINESS-18 PISTACHIO)
          (EATS BACON LETTUCE)
          (LOCALE APPLE GUANABARA)
          (LOCALE RICE MORAVIA)
          (EATS PISTACHIO SWEETROLL)
          (CRAVES ANXIETY-21 ONION)
          (EATS LOBSTER PEPPER)
          (EATS CUCUMBER PAPAYA)
          (CRAVES ABRASION-12 SWEETROLL)
          (CRAVES SCIATICA-30 SHRIMP)
          (EATS LETTUCE ARUGULA)
          (EATS SHRIMP TURKEY)
          (CRAVES ANXIETY-1 RICE)
          (EATS SWEETROLL CUCUMBER)
          (EATS APPLE ONION)
          (CRAVES BOILS SCALLOP)
          (CRAVES ANXIETY LETTUCE)
          (LOCALE HOTDOG MORAVIA)
          (CRAVES GRIEF-29 SHRIMP)
          (EATS PAPAYA CHICKEN)
          (EATS TUNA MARZIPAN)
          (CRAVES LACERATION TUNA)
          (ATTACKS OREGON QUEBEC)
          (EATS CHICKEN PAPAYA)
          (LOCALE CHOCOLATE MORAVIA)
          (EATS LETTUCE BACON)
          (EATS SWEETROLL PISTACHIO)
          (LOCALE PISTACHIO SURREY)
          (LOCALE SCALLOP GUANABARA)
          (LOCALE FLOUNDER MORAVIA)
          (ATTACKS QUEBEC SURREY)
          (ORBITS SATURN MERCURY)
          (EATS CHICKEN WURST)
          (LOCALE SCALLION QUEBEC)
          (CRAVES JEALOUSY-6 PEPPER)
          (LOCALE PAPAYA GUANABARA)
          (EATS SCALLION TOFU)
          (ATTACKS GUANABARA MORAVIA)
          (EATS SCALLOP LEMON)
          (EATS BACON ARUGULA)
          (EATS TURKEY APPLE)
          (EATS ARUGULA LETTUCE)
          (EATS HOTDOG SWEETROLL)
          (CRAVES HANGOVER ORANGE)
          (LOCALE WURST OREGON)
          (EATS RICE HAM)
          (EATS BACON LOBSTER)
          (EATS SNICKERS SCALLION)
          (EATS HOTDOG SHRIMP)
          (EATS FLOUNDER HOTDOG)
          (EATS LOBSTER MARZIPAN)
          (EATS PISTACHIO PEPPER)
          (LOCALE PEPPER ALSACE)
          (EATS SHRIMP SWEETROLL)
          (CRAVES UNDERSTANDING SCALLOP)
          (EATS ONION ARUGULA)
          (CRAVES ANGINA-31 TURKEY)
          (EATS ONION APPLE)
          (EATS LETTUCE APPLE)
          (EATS LEMON WURST)
          (EATS SCALLOP TURKEY)
          (EATS CUCUMBER SHRIMP)
          (EATS SWEETROLL HOTDOG)
          (EATS LOBSTER BACON)
          (CRAVES DREAD TOFU)
          (CRAVES JEALOUSY FLOUNDER)
          (CRAVES LUBRICITY WURST)
          (LOCALE MARZIPAN ALSACE)
          (EATS ONION PISTACHIO)
          (CRAVES DEPRESSION-25 APPLE)
          (CRAVES HANGOVER-59 CUCUMBER)
          (EATS LOBSTER HAM)
          (CRAVES HANGOVER-9 LOBSTER)
          (CRAVES SCIATICA-62 SCALLION)
          (EATS ARUGULA ONION)
          (CRAVES EXPECTATION CUCUMBER)
          (EATS TURKEY SCALLOP)
          (EATS ORANGE CHOCOLATE)
          (LOCALE ARUGULA BOSNIA)
          (HARMONY EXPECTATION MERCURY)
          (CRAVES LACERATION-19 PISTACHIO)
          (CRAVES DREAD-60 SNICKERS)
          (EATS ONION SWEETROLL)
          (ATTACKS SURREY KENTUCKY)
          (LOCALE LEMON SURREY)
          (CRAVES ANGINA-5 WURST)
          (HARMONY UNDERSTANDING MERCURY)
          (EATS CHOCOLATE ORANGE)
          (EATS CUCUMBER SWEETROLL)
          (EATS LETTUCE MARZIPAN)
          (LOCALE TOFU SURREY)
          (CRAVES SCIATICA-11 PAPAYA))
   (:GOAL (AND (CRAVES PROSTATITIS-4 TUNA)
               (CRAVES BOILS-32 TUNA)
               (CRAVES ANGER-10 TUNA))))

(DEFINE (PROBLEM MYSTY-18)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PORK ONION FLOUNDER MUFFIN TUNA GRAPEFRUIT
             BROCCOLI YOGURT LEMON TOFU PAPAYA HOTDOG PISTACHIO
             SWEETROLL CHOCOLATE LOBSTER ENDIVE RICE CHICKEN
             SNICKERS SHRIMP SCALLOP HAM TOMATO KALE ORANGE CHERRY
             MARZIPAN PEPPER PEAR SCALLION TURKEY POTATO - FOOD
             STIMULATION LOVE LUBRICITY AESTHETICS EXPECTATION
             LEARNING CURIOSITY TRIUMPH ACHIEVEMENT
             UNDERSTANDING SATISFACTION ENTERTAINMENT INTOXICATION
             SATIETY EMPATHY REST EXCITEMENT - PLEASURE
             LACERATION DREAD ANGINA PROSTATITIS JEALOUSY ABRASION
             HANGOVER DEPRESSION BOILS ANXIETY ANGER LONELINESS
             SCIATICA GRIEF LONELINESS-1 ANXIETY-2 GRIEF-4
             ABRASION-8 DEPRESSION-3 PROSTATITIS-7 DREAD-6
             BOILS-16 SCIATICA-5 ANGER-15 - PAIN
             BOSNIA PENNSYLVANIA GOIAS OREGON - PROVINCE
             URANUS JUPITER MARS VULCAN - PLANET)
   (:INIT (EATS PEPPER TOMATO)
          (EATS BROCCOLI TURKEY)
          (LOCALE CHOCOLATE BOSNIA)
          (LOCALE CHICKEN GOIAS)
          (EATS POTATO ORANGE)
          (EATS HAM PEPPER)
          (HARMONY CURIOSITY VULCAN)
          (EATS ENDIVE ORANGE)
          (HARMONY LOVE JUPITER)
          (EATS GRAPEFRUIT TOMATO)
          (HARMONY EXCITEMENT MARS)
          (EATS MARZIPAN PEAR)
          (EATS SHRIMP HOTDOG)
          (EATS CHERRY TOMATO)
          (LOCALE RICE PENNSYLVANIA)
          (HARMONY EXPECTATION VULCAN)
          (EATS ONION LOBSTER)
          (EATS SWEETROLL SNICKERS)
          (HARMONY LEARNING MARS)
          (EATS PAPAYA SNICKERS)
          (EATS CHICKEN FLOUNDER)
          (EATS ONION CHICKEN)
          (CRAVES UNDERSTANDING RICE)
          (LOCALE HAM BOSNIA)
          (CRAVES DREAD-6 SCALLION)
          (EATS PISTACHIO CHERRY)
          (CRAVES LOVE ONION)
          (EATS PAPAYA SWEETROLL)
          (CRAVES LONELINESS HOTDOG)
          (CRAVES PROSTATITIS TUNA)
          (EATS TOFU CHOCOLATE)
          (CRAVES TRIUMPH PISTACHIO)
          (EATS SCALLOP CHICKEN)
          (CRAVES LONELINESS-1 SHRIMP)
          (LOCALE HOTDOG OREGON)
          (CRAVES ABRASION-8 KALE)
          (CRAVES SCIATICA LOBSTER)
          (EATS PEPPER HAM)
          (HARMONY UNDERSTANDING JUPITER)
          (ORBITS URANUS JUPITER)
          (EATS SNICKERS PEAR)
          (HARMONY INTOXICATION JUPITER)
          (EATS TOMATO PEPPER)
          (HARMONY SATIETY MARS)
          (EATS KALE MARZIPAN)
          (CRAVES BOILS LEMON)
          (EATS SNICKERS PAPAYA)
          (CRAVES STIMULATION PORK)
          (CRAVES GRIEF-4 SCALLOP)
          (EATS SCALLOP MUFFIN)
          (EATS SCALLION GRAPEFRUIT)
          (EATS SWEETROLL PAPAYA)
          (EATS PORK PEAR)
          (CRAVES EXPECTATION LEMON)
          (EATS CHERRY PEPPER)
          (EATS SCALLOP SHRIMP)
          (LOCALE TOMATO BOSNIA)
          (HARMONY REST VULCAN)
          (HARMONY STIMULATION VULCAN)
          (LOCALE TOFU GOIAS)
          (CRAVES EXCITEMENT TURKEY)
          (CRAVES HANGOVER YOGURT)
          (EATS PISTACHIO TOFU)
          (LOCALE PISTACHIO PENNSYLVANIA)
          (CRAVES DEPRESSION-3 KALE)
          (EATS PAPAYA YOGURT)
          (EATS PEAR SNICKERS)
          (EATS CHICKEN ONION)
          (EATS TUNA CHOCOLATE)
          (CRAVES ANGINA TUNA)
          (EATS LEMON PAPAYA)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (EATS SNICKERS CHERRY)
          (EATS POTATO SNICKERS)
          (EATS YOGURT FLOUNDER)
          (CRAVES BOILS-16 TURKEY)
          (EATS YOGURT PAPAYA)
          (HARMONY TRIUMPH VULCAN)
          (LOCALE ORANGE GOIAS)
          (HARMONY LUBRICITY JUPITER)
          (EATS FLOUNDER CHICKEN)
          (EATS GRAPEFRUIT SCALLION)
          (EATS LEMON POTATO)
          (EATS TOMATO GRAPEFRUIT)
          (EATS MUFFIN YOGURT)
          (EATS SNICKERS POTATO)
          (LOCALE FLOUNDER BOSNIA)
          (EATS SCALLION TUNA)
          (EATS CHICKEN SNICKERS)
          (EATS SCALLOP RICE)
          (EATS SCALLION SCALLOP)
          (CRAVES JEALOUSY BROCCOLI)
          (LOCALE SCALLION BOSNIA)
          (LOCALE POTATO BOSNIA)
          (EATS CHOCOLATE TOFU)
          (HARMONY SATISFACTION VULCAN)
          (LOCALE PEAR BOSNIA)
          (EATS RICE SCALLOP)
          (EATS ORANGE ENDIVE)
          (CRAVES ANGER-15 POTATO)
          (EATS SHRIMP SCALLOP)
          (LOCALE ENDIVE OREGON)
          (EATS YOGURT MUFFIN)
          (EATS LOBSTER ONION)
          (CRAVES ANGER PAPAYA)
          (CRAVES LACERATION ONION)
          (EATS BROCCOLI ORANGE)
          (EATS TURKEY BROCCOLI)
          (LOCALE SNICKERS PENNSYLVANIA)
          (CRAVES SATIETY HAM)
          (LOCALE LEMON PENNSYLVANIA)
          (EATS CHERRY SNICKERS)
          (ORBITS JUPITER MARS)
          (CRAVES GRIEF ENDIVE)
          (LOCALE MUFFIN GOIAS)
          (EATS FLOUNDER YOGURT)
          (EATS MUFFIN SCALLOP)
          (CRAVES ACHIEVEMENT CHOCOLATE)
          (EATS KALE POTATO)
          (CRAVES ANXIETY-2 SHRIMP)
          (EATS SNICKERS SWEETROLL)
          (LOCALE TURKEY PENNSYLVANIA)
          (LOCALE TUNA BOSNIA)
          (EATS CHERRY PISTACHIO)
          (CRAVES LUBRICITY FLOUNDER)
          (EATS ENDIVE RICE)
          (LOCALE CHERRY BOSNIA)
          (EATS ORANGE POTATO)
          (HARMONY AESTHETICS VULCAN)
          (LOCALE GRAPEFRUIT GOIAS)
          (EATS TOFU PISTACHIO)
          (EATS POTATO KALE)
          (CRAVES LEARNING PAPAYA)
          (LOCALE PEPPER OREGON)
          (EATS SNICKERS CHICKEN)
          (EATS SWEETROLL LOBSTER)
          (CRAVES EMPATHY ORANGE)
          (HARMONY ACHIEVEMENT JUPITER)
          (CRAVES PROSTATITIS-7 MARZIPAN)
          (EATS TURKEY HOTDOG)
          (EATS POTATO LEMON)
          (CRAVES SATISFACTION CHICKEN)
          (EATS ORANGE BROCCOLI)
          (EATS CHICKEN SCALLION)
          (EATS CHOCOLATE TUNA)
          (ATTACKS GOIAS OREGON)
          (EATS PISTACHIO TOMATO)
          (CRAVES AESTHETICS TUNA)
          (EATS PEPPER CHERRY)
          (CRAVES DEPRESSION YOGURT)
          (CRAVES DREAD FLOUNDER)
          (HARMONY ENTERTAINMENT MARS)
          (HARMONY EMPATHY JUPITER)
          (EATS PAPAYA LEMON)
          (EATS TOMATO CHERRY)
          (CRAVES SCIATICA-5 TURKEY)
          (CRAVES CURIOSITY HOTDOG)
          (LOCALE ONION BOSNIA)
          (ORBITS MARS VULCAN)
          (CRAVES ABRASION BROCCOLI)
          (EATS PORK HAM)
          (CRAVES REST PEAR)
          (EATS PEAR PORK)
          (EATS HOTDOG TURKEY)
          (LOCALE SHRIMP GOIAS)
          (LOCALE SCALLOP PENNSYLVANIA)
          (EATS SCALLOP SCALLION)
          (CRAVES INTOXICATION SCALLOP)
          (LOCALE LOBSTER PENNSYLVANIA)
          (ATTACKS BOSNIA PENNSYLVANIA)
          (EATS HAM PORK)
          (EATS HOTDOG SHRIMP)
          (CRAVES ANXIETY LEMON)
          (EATS TUNA SCALLION)
          (ATTACKS PENNSYLVANIA GOIAS)
          (CRAVES ENTERTAINMENT SHRIMP)
          (LOCALE PAPAYA BOSNIA)
          (EATS MARZIPAN KALE)
          (EATS TOMATO PISTACHIO)
          (LOCALE YOGURT PENNSYLVANIA)
          (LOCALE PORK GOIAS)
          (EATS SCALLION CHICKEN)
          (LOCALE BROCCOLI BOSNIA)
          (EATS RICE ENDIVE)
          (EATS CHICKEN SCALLOP)
          (EATS PEAR MARZIPAN)
          (LOCALE SWEETROLL BOSNIA)
          (LOCALE KALE BOSNIA)
          (EATS LOBSTER SWEETROLL))
   (:GOAL (AND (CRAVES LACERATION CHICKEN)
               (CRAVES ANGINA CHICKEN)
               (CRAVES ANGER-15 CHICKEN)
               (CRAVES DREAD CHICKEN))))

(DEFINE (PROBLEM MYSTY-19)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS COD POPOVER PISTACHIO KALE POTATO TOFU
             HOTDOG SNICKERS MUFFIN MARZIPAN LETTUCE GUAVA
             SWEETROLL CANTELOPE APPLE WURST OKRA PORK HAMBURGER
             LAMB ENDIVE CHERRY TURKEY LEMON SHRIMP HAROSET
             MUTTON BACON - FOOD
             AESTHETICS SATISFACTION UNDERSTANDING TRIUMPH
             ENTERTAINMENT CURIOSITY LOVE LUBRICITY SATIETY
             ACHIEVEMENT LEARNING EMPATHY INTOXICATION EXCITEMENT
             - PLEASURE
             LONELINESS ABRASION GRIEF DEPRESSION ANGER SCIATICA
             PROSTATITIS ANXIETY DREAD ANGINA HANGOVER BOILS - PAIN
             BOSNIA GOIAS KENTUCKY MANITOBA ALSACE ARIZONA
             BAVARIA PENNSYLVANIA GUANABARA MORAVIA
             - PROVINCE
             SATURN NEPTUNE MARS EARTH - PLANET)
   (:INIT (EATS POPOVER HOTDOG)
          (CRAVES LUBRICITY WURST)
          (LOCALE BACON KENTUCKY)
          (CRAVES LONELINESS KALE)
          (CRAVES ANXIETY CANTELOPE)
          (EATS LETTUCE BACON)
          (EATS TOFU POTATO)
          (EATS HAMBURGER SWEETROLL)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS HAMBURGER LAMB)
          (LOCALE OKRA BOSNIA)
          (LOCALE HAMBURGER KENTUCKY)
          (EATS LAMB TURKEY)
          (EATS HAMBURGER LEMON)
          (LOCALE APPLE MORAVIA)
          (EATS CANTELOPE LETTUCE)
          (EATS SHRIMP MARZIPAN)
          (EATS CANTELOPE WURST)
          (EATS APPLE KALE)
          (EATS SHRIMP COD)
          (EATS LETTUCE CANTELOPE)
          (EATS SNICKERS COD)
          (CRAVES TRIUMPH TOFU)
          (CRAVES ANGER LETTUCE)
          (EATS TURKEY LAMB)
          (EATS SHRIMP HAROSET)
          (CRAVES ENTERTAINMENT HOTDOG)
          (CRAVES DEPRESSION LETTUCE)
          (CRAVES HANGOVER SHRIMP)
          (EATS PISTACHIO SNICKERS)
          (ATTACKS ALSACE ARIZONA)
          (EATS BACON LETTUCE)
          (EATS POTATO TOFU)
          (LOCALE HOTDOG KENTUCKY)
          (EATS POTATO POPOVER)
          (EATS KALE SNICKERS)
          (HARMONY ACHIEVEMENT MARS)
          (EATS HOTDOG PISTACHIO)
          (CRAVES SCIATICA GUAVA)
          (EATS MUTTON TURKEY)
          (EATS KALE PISTACHIO)
          (ATTACKS MANITOBA ALSACE)
          (ATTACKS GOIAS KENTUCKY)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS HAROSET SHRIMP)
          (LOCALE PORK ARIZONA)
          (HARMONY AESTHETICS MARS)
          (LOCALE LEMON ARIZONA)
          (EATS LAMB HAMBURGER)
          (EATS PISTACHIO HOTDOG)
          (EATS BACON PORK)
          (EATS KALE COD)
          (LOCALE POTATO MORAVIA)
          (EATS MUFFIN COD)
          (HARMONY UNDERSTANDING NEPTUNE)
          (EATS POPOVER POTATO)
          (EATS HAMBURGER PORK)
          (CRAVES AESTHETICS POPOVER)
          (EATS PORK SHRIMP)
          (EATS LEMON HAMBURGER)
          (EATS HOTDOG SNICKERS)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (EATS TURKEY MUTTON)
          (CRAVES EXCITEMENT BACON)
          (EATS SWEETROLL HAMBURGER)
          (CRAVES UNDERSTANDING KALE)
          (CRAVES SATIETY OKRA)
          (EATS ENDIVE WURST)
          (EATS SNICKERS HOTDOG)
          (CRAVES CURIOSITY MUFFIN)
          (LOCALE KALE GUANABARA)
          (EATS SNICKERS MUFFIN)
          (CRAVES LOVE MARZIPAN)
          (EATS TOFU MUFFIN)
          (LOCALE TURKEY GOIAS)
          (LOCALE LETTUCE BAVARIA)
          (ATTACKS KENTUCKY MANITOBA)
          (EATS SNICKERS KALE)
          (CRAVES PROSTATITIS GUAVA)
          (EATS GUAVA TURKEY)
          (EATS SWEETROLL SHRIMP)
          (LOCALE GUAVA ALSACE)
          (EATS LAMB MARZIPAN)
          (HARMONY LUBRICITY EARTH)
          (ATTACKS BOSNIA GOIAS)
          (EATS OKRA CHERRY)
          (HARMONY LEARNING MARS)
          (EATS LAMB MUTTON)
          (EATS LEMON PORK)
          (CRAVES BOILS SHRIMP)
          (EATS MARZIPAN SHRIMP)
          (EATS COD SHRIMP)
          (EATS COD SNICKERS)
          (EATS LEMON WURST)
          (EATS OKRA MUTTON)
          (EATS MUTTON HAROSET)
          (LOCALE CANTELOPE BAVARIA)
          (LOCALE CHERRY GOIAS)
          (EATS PISTACHIO KALE)
          (EATS SNICKERS PISTACHIO)
          (LOCALE SNICKERS KENTUCKY)
          (EATS WURST LEMON)
          (CRAVES DREAD LAMB)
          (EATS PORK LEMON)
          (HARMONY INTOXICATION NEPTUNE)
          (LOCALE LAMB MANITOBA)
          (EATS APPLE ENDIVE)
          (ATTACKS ARIZONA BAVARIA)
          (ORBITS SATURN NEPTUNE)
          (EATS HAROSET GUAVA)
          (ATTACKS GUANABARA MORAVIA)
          (CRAVES ABRASION KALE)
          (EATS PORK HAMBURGER)
          (EATS SHRIMP PORK)
          (LOCALE COD KENTUCKY)
          (LOCALE MARZIPAN BOSNIA)
          (LOCALE SHRIMP ARIZONA)
          (EATS TURKEY MARZIPAN)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS KALE APPLE)
          (LOCALE ENDIVE BAVARIA)
          (CRAVES EMPATHY CHERRY)
          (LOCALE MUFFIN BOSNIA)
          (CRAVES INTOXICATION SHRIMP)
          (HARMONY LOVE MARS)
          (LOCALE PISTACHIO BAVARIA)
          (EATS TURKEY SHRIMP)
          (EATS SHRIMP TURKEY)
          (HARMONY SATISFACTION NEPTUNE)
          (EATS COD KALE)
          (EATS CHERRY OKRA)
          (EATS BACON APPLE)
          (HARMONY CURIOSITY MARS)
          (HARMONY SATIETY EARTH)
          (EATS GUAVA HAROSET)
          (EATS MARZIPAN TURKEY)
          (EATS HOTDOG POPOVER)
          (ORBITS MARS EARTH)
          (EATS POTATO KALE)
          (CRAVES ANGINA LEMON)
          (CRAVES GRIEF SNICKERS)
          (LOCALE HAROSET GOIAS)
          (EATS WURST CANTELOPE)
          (HARMONY TRIUMPH EARTH)
          (EATS MUFFIN SNICKERS)
          (EATS WURST ENDIVE)
          (EATS MUTTON LAMB)
          (EATS SHRIMP SWEETROLL)
          (EATS CHERRY CANTELOPE)
          (CRAVES SATISFACTION PISTACHIO)
          (EATS ENDIVE APPLE)
          (EATS MUFFIN TOFU)
          (EATS APPLE BACON)
          (EATS CANTELOPE CHERRY)
          (LOCALE POPOVER GOIAS)
          (EATS COD MUFFIN)
          (EATS TURKEY GUAVA)
          (EATS KALE POTATO)
          (LOCALE TOFU ALSACE)
          (LOCALE MUTTON ARIZONA)
          (LOCALE WURST MANITOBA)
          (CRAVES LEARNING LAMB)
          (EATS HAROSET MUTTON)
          (EATS PORK BACON)
          (ORBITS NEPTUNE MARS)
          (HARMONY EMPATHY EARTH)
          (EATS MUTTON OKRA)
          (ATTACKS BAVARIA PENNSYLVANIA)
          (EATS MARZIPAN LAMB)
          (CRAVES ACHIEVEMENT PORK))
   (:GOAL (AND (CRAVES SCIATICA MUTTON)
               (CRAVES GRIEF LETTUCE)
               (CRAVES DREAD PISTACHIO))))

(DEFINE (PROBLEM MYSTY-20)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS POTATO-12 HAMBURGER-13 HAROSET-14
             WURST-15 CHERRY-7 POPOVER-6 BEEF-5 CHICKEN-16
             GRAPEFRUIT-8 MUFFIN-3 RICE-4 MARZIPAN-1 MELON-2 TUNA
             MELON PORK KALE CHOCOLATE SHRIMP GRAPEFRUIT
             PEPPER BROCCOLI CANTELOPE PEA HAM BAGUETTE
             FLOUNDER COD APPLE TOMATO GUAVA CHERRY LAMB YOGURT
             MUTTON PISTACHIO LEMON SCALLION LETTUCE SNICKERS
             TURKEY WONDERBREAD HOTDOG PAPAYA POTATO MARZIPAN
             RICE PEAR HAMBURGER HAROSET SWEETROLL TOFU OKRA
             ORANGE SCALLOP WURST ONION BEEF ARUGULA MUFFIN
             LOBSTER BACON CHICKEN CUCUMBER ENDIVE POPOVER
             - FOOD
             AESTHETICS ACHIEVEMENT LUBRICITY EXCITEMENT
             EXPECTATION UNDERSTANDING STIMULATION TRIUMPH REST
             SATISFACTION INTOXICATION LOVE SATIETY EMPATHY LEARNING
             ENTERTAINMENT CURIOSITY ACHIEVEMENT-11 EXPECTATION-10
             INTOXICATION-9 EXCITEMENT-32 ENTERTAINMENT-31
             LEARNING-30 LOVE-29 REST-28 - PLEASURE
             SCIATICA BOILS LACERATION DREAD ANGER LONELINESS
             HANGOVER JEALOUSY GRIEF ANGINA PROSTATITIS ANXIETY
             DEPRESSION ABRASION LONELINESS-24 PROSTATITIS-25
             DREAD-26 BOILS-27 ANGINA-23 DEPRESSION-22 ANGER-20
             SCIATICA-21 GRIEF-19 LACERATION-63 HANGOVER-64
             ANXIETY-17 ABRASION-18 HANGOVER-59 GRIEF-60 BOILS-61
             JEALOUSY-62 ANXIETY-57 DEPRESSION-58 LONELINESS-53
             PROSTATITIS-54 ABRASION-55 DREAD-56 SCIATICA-51
             ANGINA-52 SCIATICA-47 JEALOUSY-48 LACERATION-49
             ANGER-50 - PAIN
             GUANABARA ALSACE KENTUCKY MORAVIA OREGON SURREY
             PENNSYLVANIA QUEBEC - PROVINCE
             JUPITER EARTH URANUS VULCAN - PLANET)
   (:INIT (EATS HAROSET-14 HAMBURGER-13)
          (CRAVES EXPECTATION-10 HOTDOG)
          (LOCALE BAGUETTE PENNSYLVANIA)
          (EATS LAMB CHICKEN)
          (EATS SCALLION PISTACHIO)
          (LOCALE SCALLION KENTUCKY)
          (EATS PISTACHIO BACON)
          (EATS PORK BROCCOLI)
          (EATS PEPPER TUNA)
          (CRAVES ANXIETY-17 POTATO)
          (CRAVES ACHIEVEMENT-11 TURKEY)
          (LOCALE MUFFIN-3 SURREY)
          (LOCALE PORK ALSACE)
          (LOCALE TOMATO GUANABARA)
          (HARMONY ENTERTAINMENT-31 URANUS)
          (CRAVES SCIATICA-47 ENDIVE)
          (EATS TURKEY TOFU)
          (LOCALE OKRA SURREY)
          (CRAVES ANGINA-52 BEEF)
          (EATS POPOVER PEA)
          (CRAVES DEPRESSION-58 OKRA)
          (CRAVES ENTERTAINMENT MUTTON)
          (EATS PEAR HAMBURGER)
          (LOCALE CHERRY QUEBEC)
          (CRAVES DREAD-26 BROCCOLI)
          (EATS SWEETROLL MUFFIN)
          (EATS HAM SNICKERS)
          (EATS KALE RICE-4)
          (EATS BACON PAPAYA)
          (LOCALE HOTDOG ALSACE)
          (CRAVES EXPECTATION CHERRY-7)
          (CRAVES INTOXICATION-9 PAPAYA)
          (EATS GRAPEFRUIT MARZIPAN-1)
          (LOCALE MARZIPAN-1 GUANABARA)
          (EATS BEEF LAMB)
          (CRAVES STIMULATION GRAPEFRUIT-8)
          (EATS TUNA HAMBURGER-13)
          (ATTACKS SURREY PENNSYLVANIA)
          (EATS CHICKEN-16 WURST-15)
          (CRAVES LACERATION CHERRY-7)
          (EATS HAM PEAR)
          (HARMONY EXCITEMENT-32 VULCAN)
          (EATS BEEF-5 HAMBURGER-13)
          (EATS OKRA RICE)
          (EATS ARUGULA HOTDOG)
          (EATS LEMON HAROSET)
          (EATS HAMBURGER COD)
          (EATS APPLE WURST)
          (LOCALE KALE OREGON)
          (EATS CHERRY-7 CHICKEN-16)
          (EATS PISTACHIO BAGUETTE)
          (EATS MUFFIN-3 TOFU)
          (EATS FLOUNDER TOFU)
          (EATS LOBSTER HOTDOG)
          (CRAVES PROSTATITIS PEPPER)
          (EATS KALE GRAPEFRUIT-8)
          (EATS MUTTON CANTELOPE)
          (EATS LOBSTER HAM)
          (EATS HOTDOG LOBSTER)
          (CRAVES LACERATION-63 POTATO)
          (CRAVES DREAD CHERRY-7)
          (HARMONY LUBRICITY VULCAN)
          (EATS POTATO CHICKEN)
          (HARMONY ACHIEVEMENT-11 VULCAN)
          (EATS TURKEY BEEF)
          (EATS WONDERBREAD APPLE)
          (LOCALE SNICKERS PENNSYLVANIA)
          (LOCALE APPLE QUEBEC)
          (EATS CHERRY-7 POTATO-12)
          (LOCALE POPOVER MORAVIA)
          (HARMONY INTOXICATION EARTH)
          (EATS PEPPER GRAPEFRUIT-8)
          (EATS ENDIVE RICE)
          (EATS PAPAYA SWEETROLL)
          (EATS TUNA PEPPER)
          (LOCALE BACON ALSACE)
          (EATS POPOVER GUAVA)
          (CRAVES DEPRESSION PEPPER)
          (CRAVES LONELINESS-24 BROCCOLI)
          (LOCALE HAMBURGER-13 GUANABARA)
          (LOCALE COD MORAVIA)
          (EATS BEEF-5 POPOVER-6)
          (EATS POTATO-12 CHICKEN-16)
          (HARMONY REST-28 VULCAN)
          (EATS POTATO-12 CHERRY-7)
          (LOCALE CHICKEN GUANABARA)
          (EATS ONION ENDIVE)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS ORANGE LETTUCE)
          (CRAVES SCIATICA-21 TURKEY)
          (CRAVES HANGOVER-64 POTATO)
          (EATS GUAVA POPOVER)
          (CRAVES PROSTATITIS-25 BROCCOLI)
          (LOCALE GRAPEFRUIT-8 GUANABARA)
          (CRAVES SATIETY HAM)
          (CRAVES GRIEF-19 PAPAYA)
          (EATS CHERRY LOBSTER)
          (EATS WURST LOBSTER)
          (CRAVES HANGOVER-59 HAMBURGER)
          (EATS MELON-2 MELON)
          (CRAVES ANGER-20 TURKEY)
          (EATS TUNA CHOCOLATE)
          (CRAVES LONELINESS-53 ORANGE)
          (CRAVES JEALOUSY-48 ENDIVE)
          (LOCALE PEA OREGON)
          (LOCALE POTATO GUANABARA)
          (CRAVES ANGER-50 ENDIVE)
          (EATS PEAR HAM)
          (CRAVES BOILS CHERRY-7)
          (EATS HAROSET ORANGE)
          (EATS RICE OKRA)
          (EATS SNICKERS HAMBURGER)
          (CRAVES ACHIEVEMENT HAMBURGER-13)
          (LOCALE CANTELOPE SURREY)
          (LOCALE SWEETROLL GUANABARA)
          (HARMONY STIMULATION EARTH)
          (EATS WURST-15 CHICKEN-16)
          (LOCALE GUAVA GUANABARA)
          (EATS HOTDOG ARUGULA)
          (EATS CHICKEN-16 CHERRY-7)
          (EATS CHOCOLATE TUNA)
          (EATS PEA POPOVER)
          (EATS RICE ONION)
          (EATS HAM LOBSTER)
          (EATS PORK MELON)
          (EATS CHOCOLATE GRAPEFRUIT)
          (EATS HAMBURGER SNICKERS)
          (EATS POTATO LETTUCE)
          (EATS SHRIMP MARZIPAN-1)
          (EATS CHERRY-7 POPOVER-6)
          (LOCALE CUCUMBER MORAVIA)
          (CRAVES LACERATION-49 ENDIVE)
          (EATS ORANGE BACON)
          (CRAVES EMPATHY FLOUNDER)
          (CRAVES ABRASION PEPPER)
          (EATS TOFU FLOUNDER)
          (CRAVES LONELINESS TUNA)
          (EATS HAROSET LEMON)
          (EATS BACON YOGURT)
          (EATS SCALLION TOMATO)
          (LOCALE GRAPEFRUIT ALSACE)
          (EATS MELON-2 SHRIMP)
          (LOCALE TUNA GUANABARA)
          (LOCALE WONDERBREAD QUEBEC)
          (EATS LOBSTER WURST)
          (LOCALE WURST-15 OREGON)
          (EATS CANTELOPE MUTTON)
          (LOCALE PEAR QUEBEC)
          (EATS PAPAYA BACON)
          (CRAVES AESTHETICS POTATO-12)
          (EATS SNICKERS PEA)
          (LOCALE MELON-2 ALSACE)
          (LOCALE TURKEY MORAVIA)
          (EATS BACON SCALLION)
          (EATS SCALLION BACON)
          (LOCALE ARUGULA MORAVIA)
          (LOCALE HAMBURGER GUANABARA)
          (EATS PISTACHIO SWEETROLL)
          (CRAVES INTOXICATION CHOCOLATE)
          (HARMONY SATISFACTION URANUS)
          (EATS BROCCOLI RICE-4)
          (EATS MUFFIN CUCUMBER)
          (EATS ONION ARUGULA)
          (ATTACKS KENTUCKY MORAVIA)
          (EATS HAROSET-14 WURST-15)
          (EATS HAMBURGER-13 WURST-15)
          (LOCALE HAROSET-14 PENNSYLVANIA)
          (LOCALE PISTACHIO GUANABARA)
          (EATS GUAVA ARUGULA)
          (EATS WURST APPLE)
          (LOCALE PAPAYA OREGON)
          (EATS HAMBURGER-13 HAROSET-14)
          (EATS SHRIMP MELON-2)
          (LOCALE MARZIPAN GUANABARA)
          (LOCALE ORANGE QUEBEC)
          (LOCALE SCALLOP MORAVIA)
          (EATS LEMON CUCUMBER)
          (CRAVES BOILS-27 BROCCOLI)
          (EATS MUFFIN SWEETROLL)
          (CRAVES BOILS-61 HAMBURGER)
          (ATTACKS PENNSYLVANIA QUEBEC)
          (EATS RICE ENDIVE)
          (EATS LETTUCE ORANGE)
          (EATS TOMATO SCALLOP)
          (LOCALE RICE-4 GUANABARA)
          (EATS SWEETROLL PISTACHIO)
          (CRAVES REST-28 CHICKEN)
          (EATS LETTUCE POTATO)
          (HARMONY EXCITEMENT EARTH)
          (EATS CHICKEN FLOUNDER)
          (CRAVES JEALOUSY-62 HAMBURGER)
          (EATS ARUGULA GUAVA)
          (EATS MUFFIN-3 SHRIMP)
          (HARMONY UNDERSTANDING EARTH)
          (CRAVES ANXIETY-57 OKRA)
          (EATS MUTTON BAGUETTE)
          (EATS POTATO-12 WURST-15)
          (HARMONY ACHIEVEMENT VULCAN)
          (HARMONY CURIOSITY EARTH)
          (LOCALE FLOUNDER ALSACE)
          (LOCALE ENDIVE ALSACE)
          (EATS ORANGE HAROSET)
          (EATS COD TURKEY)
          (HARMONY INTOXICATION-9 VULCAN)
          (EATS MELON PORK)
          (EATS MELON MELON-2)
          (EATS SNICKERS HAM)
          (EATS ONION CANTELOPE)
          (HARMONY ENTERTAINMENT VULCAN)
          (EATS OKRA MARZIPAN)
          (CRAVES HANGOVER TUNA)
          (HARMONY EXPECTATION-10 VULCAN)
          (CRAVES UNDERSTANDING POPOVER-6)
          (EATS PEAR WURST)
          (LOCALE HAROSET SURREY)
          (EATS POPOVER-6 BEEF-5)
          (LOCALE CHICKEN-16 ALSACE)
          (CRAVES ANGINA CHOCOLATE)
          (ORBITS EARTH URANUS)
          (LOCALE POPOVER-6 GUANABARA)
          (EATS RICE-4 BROCCOLI)
          (EATS APPLE WONDERBREAD)
          (EATS WURST-15 POPOVER-6)
          (LOCALE BEEF-5 GUANABARA)
          (EATS CUCUMBER MARZIPAN)
          (ORBITS URANUS VULCAN)
          (LOCALE RICE GUANABARA)
          (EATS WONDERBREAD YOGURT)
          (LOCALE LOBSTER QUEBEC)
          (EATS POPOVER BEEF)
          (ATTACKS MORAVIA OREGON)
          (EATS PEA SNICKERS)
          (EATS LAMB BEEF)
          (EATS PISTACHIO SCALLION)
          (CRAVES ANGINA-23 APPLE)
          (LOCALE MUTTON KENTUCKY)
          (EATS WURST-15 BEEF-5)
          (CRAVES ANGER TUNA)
          (CRAVES LOVE PEA)
          (EATS CHICKEN POTATO)
          (ATTACKS OREGON SURREY)
          (EATS CANTELOPE ONION)
          (EATS CUCUMBER MUFFIN)
          (EATS YOGURT BACON)
          (EATS SCALLOP TOMATO)
          (LOCALE BROCCOLI QUEBEC)
          (EATS MARZIPAN-1 SHRIMP)
          (LOCALE BEEF ALSACE)
          (EATS MARZIPAN-1 GRAPEFRUIT)
          (LOCALE MELON KENTUCKY)
          (HARMONY SATIETY EARTH)
          (LOCALE LAMB GUANABARA)
          (EATS FLOUNDER CHICKEN)
          (EATS CHERRY SCALLOP)
          (LOCALE LEMON QUEBEC)
          (EATS CHICKEN-16 HAROSET-14)
          (CRAVES LEARNING-30 ARUGULA)
          (LOCALE LETTUCE GUANABARA)
          (HARMONY EMPATHY VULCAN)
          (EATS LOBSTER CHERRY)
          (EATS MARZIPAN CUCUMBER)
          (EATS SHRIMP MUFFIN-3)
          (EATS CHICKEN-16 POTATO-12)
          (CRAVES DREAD-56 ORANGE)
          (EATS YOGURT WONDERBREAD)
          (CRAVES JEALOUSY TUNA)
          (LOCALE CHERRY-7 GUANABARA)
          (LOCALE HAM SURREY)
          (EATS GRAPEFRUIT CHOCOLATE)
          (EATS OKRA ENDIVE)
          (EATS BACON ORANGE)
          (LOCALE SHRIMP OREGON)
          (LOCALE POTATO-12 PENNSYLVANIA)
          (EATS CUCUMBER LEMON)
          (CRAVES GRIEF-60 HAMBURGER)
          (HARMONY TRIUMPH VULCAN)
          (EATS HAMBURGER-13 BEEF-5)
          (EATS TOMATO SCALLION)
          (LOCALE YOGURT ALSACE)
          (EATS KALE MUFFIN-3)
          (CRAVES SATISFACTION MELON)
          (HARMONY LEARNING-30 VULCAN)
          (HARMONY REST VULCAN)
          (EATS RICE MUFFIN)
          (EATS ARUGULA ONION)
          (CRAVES PROSTATITIS-54 ORANGE)
          (EATS BACON PISTACHIO)
          (CRAVES ANXIETY PEPPER)
          (EATS MUFFIN-3 KALE)
          (HARMONY LEARNING URANUS)
          (EATS HAMBURGER PEAR)
          (EATS SWEETROLL PAPAYA)
          (CRAVES ABRASION-18 POTATO)
          (EATS TURKEY COD)
          (LOCALE MUFFIN GUANABARA)
          (CRAVES TRIUMPH MARZIPAN-1)
          (EATS WURST PEAR)
          (EATS BEEF-5 WURST-15)
          (EATS ONION RICE)
          (LOCALE ONION MORAVIA)
          (CRAVES DEPRESSION-22 SCALLION)
          (CRAVES SCIATICA CHERRY-7)
          (HARMONY EXPECTATION VULCAN)
          (EATS GRAPEFRUIT-8 KALE)
          (HARMONY LOVE-29 EARTH)
          (CRAVES ENTERTAINMENT-31 WURST)
          (EATS BEEF TURKEY)
          (CRAVES LUBRICITY HAROSET-14)
          (EATS TOFU TURKEY)
          (EATS BAGUETTE PISTACHIO)
          (EATS TOFU MUFFIN-3)
          (EATS WURST-15 POTATO-12)
          (EATS BAGUETTE MUTTON)
          (EATS BROCCOLI PORK)
          (EATS POPOVER-6 CHERRY-7)
          (LOCALE PEPPER ALSACE)
          (EATS WURST-15 HAROSET-14)
          (EATS ENDIVE OKRA)
          (EATS CHICKEN LAMB)
          (CRAVES ABRASION-55 ORANGE)
          (LOCALE TOFU SURREY)
          (CRAVES REST TUNA)
          (EATS ENDIVE ONION)
          (EATS SCALLOP CHERRY)
          (CRAVES CURIOSITY PISTACHIO)
          (EATS HAMBURGER-13 TUNA)
          (LOCALE WURST KENTUCKY)
          (EATS HAROSET-14 CHICKEN-16)
          (CRAVES EXCITEMENT WURST-15)
          (EATS WURST-15 HAMBURGER-13)
          (CRAVES LOVE-29 LOBSTER)
          (EATS BEEF POPOVER)
          (EATS POPOVER-6 WURST-15)
          (EATS GRAPEFRUIT-8 PEPPER)
          (ATTACKS ALSACE KENTUCKY)
          (EATS COD HAMBURGER)
          (HARMONY LOVE URANUS)
          (HARMONY AESTHETICS VULCAN)
          (CRAVES LEARNING LAMB)
          (EATS MARZIPAN OKRA)
          (CRAVES SCIATICA-51 BEEF)
          (ORBITS JUPITER EARTH)
          (EATS RICE-4 KALE)
          (CRAVES EXCITEMENT-32 SWEETROLL)
          (CRAVES GRIEF CHOCOLATE)
          (EATS MUFFIN RICE)
          (ATTACKS GUANABARA ALSACE))
   (:GOAL (AND (CRAVES GRIEF PISTACHIO)
               (CRAVES ANGINA PISTACHIO))))

(DEFINE (PROBLEM MYSTY-21)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PAPAYA GRAPEFRUIT CHOCOLATE TURKEY LAMB
             ENDIVE TOMATO SWEETROLL BEEF BAGUETTE COD
             HAMBURGER HAM WURST POTATO TUNA APPLE PEPPER LETTUCE
             WONDERBREAD CHICKEN BROCCOLI LEMON MELON ONION POPOVER
             MARZIPAN HOTDOG FLOUNDER PISTACHIO KALE CHERRY PORK
             MUTTON SCALLOP RICE LOBSTER MUFFIN GUAVA PEA YOGURT
             - FOOD
             EXPECTATION LUBRICITY CURIOSITY LOVE AESTHETICS
             INTOXICATION ENTERTAINMENT ACHIEVEMENT UNDERSTANDING
             SATISFACTION LEARNING - PLEASURE
             SCIATICA HANGOVER ABRASION ANGER DREAD GRIEF
             JEALOUSY PROSTATITIS BOILS DEPRESSION LONELINESS
             LACERATION ANGINA JEALOUSY-2 ANXIETY GRIEF-4 BOILS-1
             SCIATICA-3 LACERATION-7 LONELINESS-8 HANGOVER-6
             ANXIETY-16 DEPRESSION-5 PROSTATITIS-13 ANGER-14
             ANGINA-15 ABRASION-11 DREAD-12 - PAIN
             PENNSYLVANIA GUANABARA ARIZONA MANITOBA BOSNIA BAVARIA
             - PROVINCE
             SATURN NEPTUNE VULCAN VENUS - PLANET)
   (:INIT (EATS GUAVA POPOVER)
          (EATS TUNA YOGURT)
          (EATS LETTUCE KALE)
          (LOCALE ENDIVE GUANABARA)
          (EATS PAPAYA BAGUETTE)
          (EATS RICE APPLE)
          (EATS APPLE RICE)
          (EATS ONION PORK)
          (LOCALE LETTUCE PENNSYLVANIA)
          (EATS BROCCOLI FLOUNDER)
          (EATS BROCCOLI GUAVA)
          (EATS POPOVER WURST)
          (EATS MUFFIN LOBSTER)
          (CRAVES ACHIEVEMENT CHERRY)
          (EATS YOGURT PISTACHIO)
          (EATS LOBSTER PISTACHIO)
          (EATS CHERRY FLOUNDER)
          (EATS PISTACHIO SCALLOP)
          (LOCALE POPOVER MANITOBA)
          (EATS YOGURT RICE)
          (ORBITS SATURN NEPTUNE)
          (EATS KALE PEA)
          (CRAVES PROSTATITIS COD)
          (EATS SCALLOP MARZIPAN)
          (CRAVES DEPRESSION HAMBURGER)
          (EATS WONDERBREAD CHICKEN)
          (CRAVES AESTHETICS MELON)
          (HARMONY LEARNING VULCAN)
          (LOCALE CHICKEN GUANABARA)
          (HARMONY INTOXICATION VENUS)
          (LOCALE HOTDOG PENNSYLVANIA)
          (EATS TURKEY LAMB)
          (EATS MUTTON FLOUNDER)
          (EATS ONION LEMON)
          (EATS HAM HAMBURGER)
          (EATS ENDIVE LAMB)
          (EATS SCALLOP LOBSTER)
          (LOCALE FLOUNDER GUANABARA)
          (ORBITS VULCAN VENUS)
          (CRAVES ANXIETY WURST)
          (EATS PEA KALE)
          (EATS MUFFIN FLOUNDER)
          (EATS PEPPER MUTTON)
          (EATS GUAVA BROCCOLI)
          (EATS RICE YOGURT)
          (EATS HAM WURST)
          (CRAVES JEALOUSY-2 WURST)
          (LOCALE PORK ARIZONA)
          (EATS PEPPER LOBSTER)
          (EATS COD HAMBURGER)
          (EATS PEA GUAVA)
          (EATS GRAPEFRUIT LAMB)
          (EATS KALE MUTTON)
          (CRAVES SATISFACTION MUFFIN)
          (LOCALE HAMBURGER MANITOBA)
          (EATS CHICKEN WONDERBREAD)
          (EATS PORK MARZIPAN)
          (HARMONY UNDERSTANDING VENUS)
          (EATS HOTDOG CHERRY)
          (EATS KALE PORK)
          (EATS POPOVER KALE)
          (ATTACKS GUANABARA ARIZONA)
          (LOCALE LAMB ARIZONA)
          (EATS LAMB SWEETROLL)
          (LOCALE MELON PENNSYLVANIA)
          (ATTACKS MANITOBA BOSNIA)
          (EATS TOMATO PAPAYA)
          (EATS LETTUCE CHICKEN)
          (EATS ONION SCALLOP)
          (EATS HAMBURGER HAM)
          (CRAVES LONELINESS HAMBURGER)
          (EATS GUAVA PEA)
          (EATS LEMON YOGURT)
          (EATS BAGUETTE ENDIVE)
          (CRAVES LOVE CHICKEN)
          (LOCALE GUAVA ARIZONA)
          (EATS SCALLOP TUNA)
          (EATS ENDIVE BAGUETTE)
          (CRAVES ABRASION SWEETROLL)
          (EATS PORK ONION)
          (LOCALE CHOCOLATE BAVARIA)
          (HARMONY LOVE NEPTUNE)
          (CRAVES LONELINESS-8 MELON)
          (EATS MARZIPAN ONION)
          (EATS KALE LETTUCE)
          (EATS LETTUCE MUTTON)
          (LOCALE PAPAYA MANITOBA)
          (CRAVES GRIEF BAGUETTE)
          (EATS BEEF TURKEY)
          (LOCALE POTATO PENNSYLVANIA)
          (CRAVES SCIATICA-3 PEPPER)
          (CRAVES ANGER-14 CHERRY)
          (CRAVES DEPRESSION-5 PISTACHIO)
          (EATS TURKEY LOBSTER)
          (EATS WURST POPOVER)
          (EATS LAMB BEEF)
          (ATTACKS BOSNIA BAVARIA)
          (EATS SCALLOP ONION)
          (EATS MUTTON LETTUCE)
          (EATS CHICKEN LETTUCE)
          (CRAVES HANGOVER TURKEY)
          (EATS GRAPEFRUIT CHOCOLATE)
          (EATS HAMBURGER COD)
          (ORBITS NEPTUNE VULCAN)
          (LOCALE WONDERBREAD BOSNIA)
          (HARMONY LUBRICITY VENUS)
          (EATS ENDIVE TURKEY)
          (LOCALE BEEF GUANABARA)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (EATS LEMON ONION)
          (CRAVES PROSTATITIS-13 CHERRY)
          (EATS COD BEEF)
          (LOCALE LEMON GUANABARA)
          (CRAVES LACERATION HAM)
          (HARMONY CURIOSITY NEPTUNE)
          (EATS ONION MARZIPAN)
          (CRAVES LUBRICITY PEPPER)
          (EATS WONDERBREAD SCALLOP)
          (EATS GUAVA HOTDOG)
          (LOCALE RICE ARIZONA)
          (CRAVES DREAD-12 MUTTON)
          (LOCALE SWEETROLL PENNSYLVANIA)
          (EATS SWEETROLL BEEF)
          (EATS LOBSTER MUFFIN)
          (EATS WURST POTATO)
          (CRAVES BOILS-1 TUNA)
          (EATS KALE HOTDOG)
          (EATS PORK KALE)
          (EATS MARZIPAN SCALLOP)
          (EATS FLOUNDER CHERRY)
          (LOCALE ONION PENNSYLVANIA)
          (EATS LOBSTER SCALLOP)
          (LOCALE CHERRY GUANABARA)
          (EATS PEA POPOVER)
          (EATS PISTACHIO LOBSTER)
          (HARMONY ENTERTAINMENT VULCAN)
          (CRAVES ANGER SWEETROLL)
          (ATTACKS ARIZONA MANITOBA)
          (EATS APPLE ONION)
          (EATS BEEF COD)
          (EATS MELON PEA)
          (EATS LAMB GRAPEFRUIT)
          (EATS POTATO COD)
          (CRAVES ENTERTAINMENT HOTDOG)
          (LOCALE SCALLOP PENNSYLVANIA)
          (CRAVES EXPECTATION ENDIVE)
          (LOCALE BROCCOLI MANITOBA)
          (EATS CHOCOLATE TOMATO)
          (LOCALE GRAPEFRUIT GUANABARA)
          (EATS FLOUNDER BROCCOLI)
          (CRAVES ABRASION-11 MUTTON)
          (CRAVES BOILS HAMBURGER)
          (EATS CHERRY HOTDOG)
          (EATS RICE MELON)
          (LOCALE PEPPER ARIZONA)
          (LOCALE TOMATO MANITOBA)
          (CRAVES INTOXICATION ONION)
          (EATS SCALLOP WONDERBREAD)
          (EATS BEEF LAMB)
          (LOCALE KALE MANITOBA)
          (LOCALE PEA ARIZONA)
          (LOCALE WURST GUANABARA)
          (EATS SCALLOP MUTTON)
          (EATS YOGURT LEMON)
          (HARMONY SATISFACTION NEPTUNE)
          (CRAVES SCIATICA TURKEY)
          (EATS POPOVER GUAVA)
          (EATS YOGURT TUNA)
          (EATS TOMATO CHOCOLATE)
          (EATS MUTTON PEPPER)
          (CRAVES GRIEF-4 TUNA)
          (EATS ONION APPLE)
          (LOCALE MUFFIN PENNSYLVANIA)
          (EATS FLOUNDER MUTTON)
          (CRAVES CURIOSITY WONDERBREAD)
          (CRAVES LEARNING GUAVA)
          (EATS HOTDOG GUAVA)
          (EATS LOBSTER PEPPER)
          (EATS BEEF SWEETROLL)
          (LOCALE COD PENNSYLVANIA)
          (HARMONY EXPECTATION NEPTUNE)
          (EATS SWEETROLL LAMB)
          (CRAVES DREAD SWEETROLL)
          (LOCALE LOBSTER PENNSYLVANIA)
          (CRAVES LACERATION-7 MELON)
          (EATS LAMB ENDIVE)
          (LOCALE HAM GUANABARA)
          (EATS MELON RICE)
          (LOCALE YOGURT BOSNIA)
          (EATS TURKEY ENDIVE)
          (EATS MUTTON CHERRY)
          (EATS PAPAYA TOMATO)
          (EATS KALE POPOVER)
          (EATS CHERRY MUTTON)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS CHOCOLATE GRAPEFRUIT)
          (LOCALE BAGUETTE GUANABARA)
          (EATS POPOVER PEA)
          (LOCALE TUNA MANITOBA)
          (EATS LOBSTER TURKEY)
          (EATS PORK RICE)
          (CRAVES ANGINA-15 CHERRY)
          (EATS WURST HAM)
          (EATS BAGUETTE PAPAYA)
          (EATS MUTTON KALE)
          (EATS HOTDOG KALE)
          (LOCALE MUTTON BOSNIA)
          (EATS PISTACHIO YOGURT)
          (LOCALE TURKEY GUANABARA)
          (EATS TURKEY BEEF)
          (EATS POTATO WURST)
          (CRAVES ANXIETY-16 PISTACHIO)
          (EATS LAMB TURKEY)
          (EATS FLOUNDER MUFFIN)
          (EATS TUNA SCALLOP)
          (EATS COD POTATO)
          (CRAVES JEALOUSY BAGUETTE)
          (EATS RICE PORK)
          (LOCALE PISTACHIO ARIZONA)
          (LOCALE APPLE PENNSYLVANIA)
          (EATS PEA MELON)
          (CRAVES UNDERSTANDING LOBSTER)
          (EATS MARZIPAN PORK)
          (CRAVES HANGOVER-6 ONION)
          (CRAVES ANGINA HAM)
          (EATS MUTTON SCALLOP)
          (EATS SCALLOP PISTACHIO)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (HARMONY AESTHETICS VULCAN))
   (:GOAL (AND (CRAVES ANXIETY BEEF)
               (CRAVES JEALOUSY-2 BEEF))))

(DEFINE (PROBLEM MYSTY-22)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TOMATO GUAVA HOTDOG MUTTON ENDIVE CHERRY
             BEEF LETTUCE OKRA ONION TOFU KALE SHRIMP PEA
             SWEETROLL HAROSET PEPPER CHOCOLATE MUFFIN SCALLOP
             CHICKEN ARUGULA - FOOD
             REST LOVE CURIOSITY TRIUMPH LEARNING EXCITEMENT
             EXPECTATION - PLEASURE
             LONELINESS ANXIETY LACERATION BOILS JEALOUSY GRIEF
             ANGER ANGINA SCIATICA HANGOVER - PAIN
             QUEBEC OREGON BAVARIA MORAVIA - PROVINCE
             MARS VULCAN VENUS SATURN - PLANET)
   (:INIT (HARMONY CURIOSITY VULCAN)
          (EATS GUAVA MUTTON)
          (LOCALE SHRIMP QUEBEC)
          (ATTACKS QUEBEC OREGON)
          (EATS MUTTON GUAVA)
          (EATS HAROSET MUFFIN)
          (EATS TOMATO CHOCOLATE)
          (LOCALE CHICKEN QUEBEC)
          (LOCALE ARUGULA QUEBEC)
          (EATS SHRIMP CHERRY)
          (LOCALE TOFU QUEBEC)
          (CRAVES BOILS BEEF)
          (EATS PEPPER CHERRY)
          (EATS SHRIMP ENDIVE)
          (CRAVES ANGER CHOCOLATE)
          (LOCALE KALE QUEBEC)
          (EATS ARUGULA PEPPER)
          (EATS SHRIMP SWEETROLL)
          (HARMONY TRIUMPH VENUS)
          (ATTACKS OREGON BAVARIA)
          (HARMONY REST SATURN)
          (EATS CHOCOLATE TOMATO)
          (EATS SCALLOP GUAVA)
          (EATS MUTTON HOTDOG)
          (CRAVES TRIUMPH TOFU)
          (HARMONY EXCITEMENT VULCAN)
          (LOCALE HOTDOG QUEBEC)
          (ORBITS MARS VULCAN)
          (LOCALE PEPPER QUEBEC)
          (EATS SWEETROLL ONION)
          (EATS SHRIMP OKRA)
          (EATS BEEF HOTDOG)
          (EATS ARUGULA LETTUCE)
          (LOCALE HAROSET QUEBEC)
          (EATS SWEETROLL SHRIMP)
          (EATS HOTDOG BEEF)
          (EATS HAROSET ONION)
          (EATS MUFFIN SHRIMP)
          (EATS PEPPER ARUGULA)
          (EATS CHICKEN TOFU)
          (LOCALE MUTTON BAVARIA)
          (LOCALE LETTUCE MORAVIA)
          (EATS ONION MUFFIN)
          (EATS SWEETROLL CHOCOLATE)
          (EATS TOFU SCALLOP)
          (LOCALE CHOCOLATE QUEBEC)
          (HARMONY EXPECTATION SATURN)
          (EATS LETTUCE OKRA)
          (EATS ENDIVE PEPPER)
          (EATS ARUGULA MUFFIN)
          (ORBITS VENUS SATURN)
          (EATS MUFFIN HAROSET)
          (CRAVES ANXIETY MUTTON)
          (CRAVES JEALOUSY SHRIMP)
          (LOCALE ENDIVE QUEBEC)
          (EATS CHOCOLATE SWEETROLL)
          (EATS OKRA LETTUCE)
          (LOCALE MUFFIN OREGON)
          (EATS HAROSET CHOCOLATE)
          (LOCALE BEEF QUEBEC)
          (EATS CHERRY PEPPER)
          (CRAVES LEARNING PEA)
          (EATS CHERRY SHRIMP)
          (LOCALE CHERRY QUEBEC)
          (LOCALE ONION BAVARIA)
          (EATS CHOCOLATE BEEF)
          (EATS MUFFIN ARUGULA)
          (LOCALE PEA BAVARIA)
          (EATS CHICKEN PEA)
          (HARMONY LEARNING VULCAN)
          (CRAVES EXPECTATION CHICKEN)
          (CRAVES LOVE CHERRY)
          (CRAVES GRIEF SWEETROLL)
          (EATS HOTDOG MUTTON)
          (EATS PEPPER ENDIVE)
          (HARMONY LOVE VENUS)
          (CRAVES CURIOSITY LETTUCE)
          (EATS PEA CHICKEN)
          (EATS ENDIVE SHRIMP)
          (EATS PEA KALE)
          (CRAVES LONELINESS GUAVA)
          (EATS MUFFIN ONION)
          (EATS KALE PEA)
          (LOCALE OKRA QUEBEC)
          (EATS ONION SWEETROLL)
          (ATTACKS BAVARIA MORAVIA)
          (EATS PEPPER KALE)
          (EATS OKRA SHRIMP)
          (CRAVES EXCITEMENT CHOCOLATE)
          (EATS GUAVA SCALLOP)
          (CRAVES HANGOVER ARUGULA)
          (EATS TOFU CHICKEN)
          (ORBITS VULCAN VENUS)
          (CRAVES REST HOTDOG)
          (CRAVES SCIATICA CHICKEN)
          (EATS KALE PEPPER)
          (LOCALE SWEETROLL QUEBEC)
          (EATS TOMATO CHERRY)
          (EATS ONION HAROSET)
          (EATS SCALLOP TOFU)
          (EATS CHOCOLATE HAROSET)
          (EATS LETTUCE ARUGULA)
          (LOCALE SCALLOP BAVARIA)
          (CRAVES LACERATION ENDIVE)
          (LOCALE TOMATO QUEBEC)
          (EATS BEEF CHOCOLATE)
          (EATS CHERRY TOMATO)
          (LOCALE GUAVA OREGON)
          (CRAVES ANGINA MUFFIN)
          (EATS SHRIMP MUFFIN))
   (:GOAL (AND (CRAVES ANGER HAROSET))))

(DEFINE (PROBLEM MYSTY-23)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS CANTELOPE ARUGULA CHOCOLATE SNICKERS LAMB
             TURKEY BROCCOLI LETTUCE PEPPER PEAR TOFU ENDIVE
             LEMON WONDERBREAD POPOVER TUNA SCALLION CHICKEN
             GUAVA TOMATO PORK CUCUMBER HAMBURGER MELON
             PISTACHIO FLOUNDER APPLE HOTDOG OKRA SWEETROLL WURST
             HAM GRAPEFRUIT KALE CHERRY - FOOD
             UNDERSTANDING LUBRICITY EMPATHY TRIUMPH ENTERTAINMENT
             SATIETY AESTHETICS ACHIEVEMENT EXPECTATION
             CURIOSITY EXCITEMENT STIMULATION - PLEASURE
             PROSTATITIS LACERATION GRIEF ANGINA DEPRESSION
             LONELINESS DREAD ABRASION ANGER HANGOVER JEALOUSY
             BOILS ANXIETY SCIATICA ANXIETY-2 DREAD-1
             LACERATION-4 HANGOVER-3 DEPRESSION-8 BOILS-7
             JEALOUSY-6 - PAIN
             MORAVIA QUEBEC OREGON GOIAS GUANABARA KENTUCKY
             ARIZONA PENNSYLVANIA BAVARIA SURREY - PROVINCE
             VENUS VULCAN MARS MERCURY - PLANET)
   (:INIT (ORBITS MARS MERCURY)
          (CRAVES CURIOSITY CUCUMBER)
          (HARMONY AESTHETICS MARS)
          (EATS LEMON ENDIVE)
          (EATS FLOUNDER HAMBURGER)
          (CRAVES ABRASION ENDIVE)
          (ATTACKS MORAVIA QUEBEC)
          (EATS PEAR ARUGULA)
          (LOCALE GUAVA MORAVIA)
          (CRAVES DEPRESSION-8 WURST)
          (EATS MELON CHERRY)
          (EATS PISTACHIO TOMATO)
          (LOCALE LETTUCE QUEBEC)
          (EATS ARUGULA PEAR)
          (EATS TURKEY SNICKERS)
          (EATS TOFU TURKEY)
          (LOCALE SNICKERS MORAVIA)
          (EATS OKRA SWEETROLL)
          (EATS TURKEY CHOCOLATE)
          (EATS OKRA HAM)
          (CRAVES EMPATHY TOFU)
          (EATS SNICKERS TURKEY)
          (CRAVES BOILS CHICKEN)
          (LOCALE TOFU MORAVIA)
          (LOCALE CUCUMBER GUANABARA)
          (HARMONY SATIETY VULCAN)
          (EATS CUCUMBER PISTACHIO)
          (ATTACKS QUEBEC OREGON)
          (EATS CHERRY TUNA)
          (CRAVES UNDERSTANDING TURKEY)
          (EATS APPLE MELON)
          (CRAVES ACHIEVEMENT GUAVA)
          (HARMONY EXPECTATION VULCAN)
          (ATTACKS BAVARIA SURREY)
          (CRAVES LACERATION-4 APPLE)
          (HARMONY EXCITEMENT MERCURY)
          (EATS CUCUMBER PORK)
          (HARMONY TRIUMPH VULCAN)
          (EATS WURST APPLE)
          (LOCALE FLOUNDER GOIAS)
          (EATS ENDIVE LEMON)
          (LOCALE PEAR BAVARIA)
          (EATS FLOUNDER GUAVA)
          (EATS TOMATO PISTACHIO)
          (CRAVES JEALOUSY SCALLION)
          (EATS CHICKEN HOTDOG)
          (EATS TUNA ENDIVE)
          (CRAVES ANXIETY-2 PORK)
          (EATS SWEETROLL OKRA)
          (EATS CUCUMBER HOTDOG)
          (LOCALE TOMATO OREGON)
          (CRAVES JEALOUSY-6 CHERRY)
          (EATS ENDIVE TUNA)
          (LOCALE WURST GOIAS)
          (EATS HOTDOG SWEETROLL)
          (LOCALE PORK PENNSYLVANIA)
          (LOCALE CANTELOPE MORAVIA)
          (EATS GRAPEFRUIT CHICKEN)
          (ATTACKS KENTUCKY ARIZONA)
          (CRAVES ANGINA BROCCOLI)
          (EATS CHOCOLATE ARUGULA)
          (HARMONY UNDERSTANDING MERCURY)
          (EATS ENDIVE PEPPER)
          (CRAVES ANXIETY GUAVA)
          (CRAVES GRIEF TURKEY)
          (LOCALE MELON MORAVIA)
          (CRAVES BOILS-7 KALE)
          (EATS CHERRY MELON)
          (CRAVES HANGOVER-3 HOTDOG)
          (HARMONY LUBRICITY MERCURY)
          (CRAVES DREAD-1 PISTACHIO)
          (EATS LAMB LEMON)
          (EATS PEAR BROCCOLI)
          (EATS BROCCOLI PEAR)
          (EATS POPOVER SWEETROLL)
          (LOCALE HAM PENNSYLVANIA)
          (HARMONY ACHIEVEMENT MERCURY)
          (LOCALE HAMBURGER QUEBEC)
          (HARMONY STIMULATION VULCAN)
          (CRAVES SATIETY POPOVER)
          (CRAVES DEPRESSION LETTUCE)
          (LOCALE OKRA PENNSYLVANIA)
          (EATS LEMON LAMB)
          (EATS MELON APPLE)
          (EATS WURST GUAVA)
          (EATS PORK CUCUMBER)
          (EATS CANTELOPE LETTUCE)
          (EATS TOFU PEPPER)
          (EATS GUAVA WURST)
          (EATS HAM OKRA)
          (EATS HOTDOG SCALLION)
          (HARMONY ENTERTAINMENT MARS)
          (EATS TUNA PORK)
          (HARMONY EMPATHY MARS)
          (LOCALE LEMON KENTUCKY)
          (EATS SCALLION PORK)
          (CRAVES HANGOVER POPOVER)
          (EATS SWEETROLL POPOVER)
          (LOCALE CHERRY KENTUCKY)
          (EATS CHERRY CUCUMBER)
          (LOCALE SWEETROLL GUANABARA)
          (EATS HOTDOG KALE)
          (ATTACKS GOIAS GUANABARA)
          (EATS PORK KALE)
          (LOCALE TURKEY MORAVIA)
          (EATS BROCCOLI LETTUCE)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS PISTACHIO HOTDOG)
          (EATS LETTUCE BROCCOLI)
          (EATS KALE PORK)
          (EATS GRAPEFRUIT KALE)
          (ATTACKS OREGON GOIAS)
          (EATS PEPPER ENDIVE)
          (LOCALE TUNA SURREY)
          (LOCALE KALE GUANABARA)
          (EATS PORK SCALLION)
          (CRAVES LUBRICITY BROCCOLI)
          (EATS HAM WONDERBREAD)
          (CRAVES AESTHETICS SCALLION)
          (LOCALE APPLE MORAVIA)
          (LOCALE POPOVER GUANABARA)
          (EATS LAMB LETTUCE)
          (EATS TURKEY TOFU)
          (EATS WONDERBREAD WURST)
          (CRAVES ANGER WONDERBREAD)
          (EATS HOTDOG WURST)
          (EATS SWEETROLL HOTDOG)
          (EATS WONDERBREAD HAM)
          (CRAVES LACERATION CHOCOLATE)
          (EATS TOMATO APPLE)
          (EATS CHOCOLATE TURKEY)
          (LOCALE PISTACHIO PENNSYLVANIA)
          (LOCALE BROCCOLI GUANABARA)
          (CRAVES EXPECTATION TOMATO)
          (EATS CANTELOPE SNICKERS)
          (LOCALE PEPPER MORAVIA)
          (EATS PISTACHIO CUCUMBER)
          (EATS LETTUCE LAMB)
          (EATS CUCUMBER CHERRY)
          (EATS HOTDOG CUCUMBER)
          (EATS WURST WONDERBREAD)
          (CRAVES SCIATICA TOMATO)
          (LOCALE CHOCOLATE QUEBEC)
          (CRAVES EXCITEMENT KALE)
          (EATS POPOVER GRAPEFRUIT)
          (ORBITS VENUS VULCAN)
          (CRAVES LONELINESS PEPPER)
          (EATS LETTUCE CANTELOPE)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (CRAVES TRIUMPH ENDIVE)
          (HARMONY CURIOSITY MERCURY)
          (CRAVES DREAD PEAR)
          (ORBITS VULCAN MARS)
          (LOCALE CHICKEN QUEBEC)
          (EATS KALE HOTDOG)
          (EATS SNICKERS CANTELOPE)
          (EATS GRAPEFRUIT POPOVER)
          (LOCALE ARUGULA PENNSYLVANIA)
          (EATS HAMBURGER SWEETROLL)
          (EATS HOTDOG PISTACHIO)
          (EATS HOTDOG CHICKEN)
          (LOCALE GRAPEFRUIT PENNSYLVANIA)
          (EATS WURST HOTDOG)
          (EATS APPLE TOMATO)
          (ATTACKS ARIZONA PENNSYLVANIA)
          (EATS CHICKEN GRAPEFRUIT)
          (LOCALE HOTDOG MORAVIA)
          (LOCALE WONDERBREAD QUEBEC)
          (LOCALE SCALLION OREGON)
          (LOCALE ENDIVE OREGON)
          (CRAVES PROSTATITIS CANTELOPE)
          (EATS ARUGULA CHOCOLATE)
          (EATS PEPPER TOFU)
          (EATS HAMBURGER FLOUNDER)
          (EATS KALE GRAPEFRUIT)
          (EATS PORK TUNA)
          (CRAVES STIMULATION CHERRY)
          (EATS APPLE WURST)
          (EATS TOFU PEAR)
          (EATS SWEETROLL HAMBURGER)
          (LOCALE LAMB QUEBEC)
          (CRAVES ENTERTAINMENT LEMON)
          (EATS WURST PISTACHIO)
          (EATS SCALLION HOTDOG)
          (EATS PEAR TOFU)
          (EATS TUNA CHERRY)
          (EATS GUAVA FLOUNDER)
          (EATS PISTACHIO WURST))
   (:GOAL (AND (CRAVES DREAD WURST)
               (CRAVES PROSTATITIS LETTUCE))))

(DEFINE (PROBLEM MYSTY-24)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LEMON PEPPER HAMBURGER HAM CHOCOLATE
             POPOVER ONION OKRA LETTUCE SCALLION SWEETROLL
             ORANGE MUFFIN PAPAYA TUNA PEAR POTATO HOTDOG MELON
             HAROSET SCALLOP SNICKERS BACON GRAPEFRUIT
             PISTACHIO PEA ENDIVE TOMATO LAMB CHICKEN RICE
             CANTELOPE CUCUMBER KALE BAGUETTE TOFU LOBSTER
             BROCCOLI MARZIPAN TURKEY PORK COD - FOOD
             UNDERSTANDING ACHIEVEMENT ENTERTAINMENT EMPATHY
             LEARNING STIMULATION CURIOSITY SATISFACTION
             SATIETY LOVE AESTHETICS LUBRICITY REST
             INTOXICATION EXPECTATION - PLEASURE
             SCIATICA LONELINESS DEPRESSION ANGER LACERATION
             PROSTATITIS BOILS GRIEF DREAD HANGOVER ANGINA ANXIETY
             JEALOUSY ABRASION DREAD-2 ANGINA-1 GRIEF-4
             LONELINESS-8 HANGOVER-3 BOILS-7 ANGER-6 ANXIETY-16
             LACERATION-5 JEALOUSY-15 PROSTATITIS-14 SCIATICA-13
             DEPRESSION-11 ABRASION-12 DEPRESSION-9 ANGINA-10
             JEALOUSY-31 LONELINESS-32 GRIEF-29 PROSTATITIS-30
             SCIATICA-28 ANXIETY-26 BOILS-27 DREAD-25 ABRASION-24
             LACERATION-22 HANGOVER-23 ANGER-21 BOILS-20
             LACERATION-19 JEALOUSY-18 ANGER-64 HANGOVER-17
             ANGINA-62 ABRASION-63 ANXIETY-61 PROSTATITIS-59
             DREAD-60 DEPRESSION-58 SCIATICA-57 LONELINESS-55
             GRIEF-56 DREAD-53 JEALOUSY-54 - PAIN
             MORAVIA QUEBEC BAVARIA OREGON ARIZONA SURREY
             - PROVINCE
             MARS NEPTUNE MERCURY JUPITER - PLANET)
   (:INIT (EATS TOMATO KALE)
          (EATS BROCCOLI ENDIVE)
          (CRAVES ANGINA ONION)
          (EATS MELON TURKEY)
          (EATS CHICKEN LOBSTER)
          (EATS HOTDOG SCALLOP)
          (CRAVES ANXIETY-16 POTATO)
          (CRAVES SATISFACTION ENDIVE)
          (EATS RICE LAMB)
          (EATS PAPAYA GRAPEFRUIT)
          (LOCALE KALE BAVARIA)
          (EATS SCALLOP SCALLION)
          (HARMONY SATISFACTION NEPTUNE)
          (LOCALE ONION MORAVIA)
          (CRAVES LONELINESS-32 BACON)
          (LOCALE BROCCOLI OREGON)
          (EATS RICE BAGUETTE)
          (LOCALE RICE SURREY)
          (CRAVES DEPRESSION-11 SCALLOP)
          (EATS HAROSET POPOVER)
          (EATS HAMBURGER TUNA)
          (LOCALE HAM QUEBEC)
          (EATS HAROSET TUNA)
          (EATS TOFU BROCCOLI)
          (HARMONY CURIOSITY NEPTUNE)
          (LOCALE PEPPER MORAVIA)
          (CRAVES GRIEF-56 PORK)
          (EATS LAMB LOBSTER)
          (LOCALE BACON SURREY)
          (EATS TURKEY PORK)
          (LOCALE HOTDOG QUEBEC)
          (CRAVES SCIATICA-57 TURKEY)
          (EATS PISTACHIO TURKEY)
          (EATS MELON HAM)
          (EATS SCALLOP HOTDOG)
          (CRAVES ANGER-21 CHICKEN)
          (CRAVES HANGOVER ONION)
          (EATS ORANGE HAROSET)
          (CRAVES DREAD-53 COD)
          (EATS PEPPER HAROSET)
          (CRAVES SCIATICA-13 HAROSET)
          (EATS HAM ORANGE)
          (CRAVES ENTERTAINMENT TUNA)
          (CRAVES GRIEF-4 ORANGE)
          (EATS GRAPEFRUIT ONION)
          (EATS PORK TOFU)
          (EATS SCALLION ORANGE)
          (ORBITS MARS NEPTUNE)
          (EATS TOMATO BAGUETTE)
          (EATS LETTUCE TUNA)
          (CRAVES BOILS-27 PEA)
          (EATS SCALLION SCALLOP)
          (CRAVES SATIETY CHICKEN)
          (LOCALE GRAPEFRUIT BAVARIA)
          (EATS OKRA PAPAYA)
          (EATS MUFFIN PEAR)
          (LOCALE PEAR BAVARIA)
          (EATS ORANGE SCALLION)
          (EATS TOFU PORK)
          (EATS SNICKERS POTATO)
          (EATS PEAR MUFFIN)
          (CRAVES ANGER-6 TUNA)
          (EATS POPOVER HOTDOG)
          (ATTACKS BAVARIA OREGON)
          (LOCALE SCALLOP BAVARIA)
          (CRAVES ANGINA-62 TOFU)
          (LOCALE ENDIVE QUEBEC)
          (EATS SCALLOP PEPPER)
          (LOCALE PORK ARIZONA)
          (LOCALE SCALLION MORAVIA)
          (LOCALE MELON MORAVIA)
          (CRAVES PROSTATITIS-14 MELON)
          (LOCALE LEMON SURREY)
          (LOCALE SNICKERS MORAVIA)
          (HARMONY REST NEPTUNE)
          (EATS ONION TUNA)
          (EATS GRAPEFRUIT MELON)
          (CRAVES ANGER-64 BAGUETTE)
          (EATS PEA BAGUETTE)
          (EATS RICE LOBSTER)
          (HARMONY ACHIEVEMENT MERCURY)
          (EATS PEA RICE)
          (EATS CHICKEN CANTELOPE)
          (EATS MARZIPAN KALE)
          (EATS LEMON PEAR)
          (LOCALE BAGUETTE MORAVIA)
          (LOCALE POPOVER SURREY)
          (EATS TURKEY MELON)
          (ATTACKS ARIZONA SURREY)
          (EATS ENDIVE BROCCOLI)
          (EATS SWEETROLL BACON)
          (ORBITS NEPTUNE MERCURY)
          (ATTACKS QUEBEC BAVARIA)
          (EATS BAGUETTE TOMATO)
          (EATS POTATO HAROSET)
          (CRAVES HANGOVER-23 LAMB)
          (CRAVES DREAD-25 ENDIVE)
          (CRAVES ANGINA-10 SNICKERS)
          (EATS ENDIVE CUCUMBER)
          (CRAVES ABRASION-63 TOFU)
          (CRAVES LACERATION HAM)
          (LOCALE TOMATO MORAVIA)
          (EATS PEAR HAMBURGER)
          (LOCALE OKRA ARIZONA)
          (CRAVES AESTHETICS CUCUMBER)
          (HARMONY ENTERTAINMENT JUPITER)
          (EATS CANTELOPE RICE)
          (LOCALE CHOCOLATE QUEBEC)
          (CRAVES CURIOSITY PEA)
          (EATS HAM MELON)
          (LOCALE LAMB SURREY)
          (LOCALE HAROSET SURREY)
          (EATS CUCUMBER PISTACHIO)
          (EATS PISTACHIO CUCUMBER)
          (EATS HAROSET PEPPER)
          (EATS PEA COD)
          (EATS LAMB TOFU)
          (CRAVES ABRASION-24 TOMATO)
          (CRAVES PROSTATITIS-30 GRAPEFRUIT)
          (EATS LEMON CHOCOLATE)
          (EATS CHOCOLATE LEMON)
          (CRAVES ANGINA-1 SWEETROLL)
          (CRAVES JEALOUSY-18 KALE)
          (EATS POPOVER HAROSET)
          (CRAVES EXPECTATION COD)
          (CRAVES GRIEF-29 GRAPEFRUIT)
          (CRAVES ABRASION-12 SCALLOP)
          (HARMONY AESTHETICS JUPITER)
          (EATS CHOCOLATE GRAPEFRUIT)
          (LOCALE TOFU BAVARIA)
          (EATS BACON SWEETROLL)
          (CRAVES ANGER HAMBURGER)
          (CRAVES DREAD-2 SCALLION)
          (LOCALE TUNA MORAVIA)
          (EATS BAGUETTE CANTELOPE)
          (LOCALE POTATO QUEBEC)
          (CRAVES PROSTATITIS-59 BROCCOLI)
          (LOCALE PEA SURREY)
          (EATS TURKEY TOFU)
          (CRAVES SCIATICA LEMON)
          (ATTACKS MORAVIA QUEBEC)
          (CRAVES ABRASION LETTUCE)
          (EATS HAMBURGER PEAR)
          (LOCALE CHICKEN BAVARIA)
          (EATS POTATO SNICKERS)
          (EATS TURKEY PISTACHIO)
          (HARMONY STIMULATION JUPITER)
          (LOCALE HAMBURGER ARIZONA)
          (HARMONY SATIETY NEPTUNE)
          (EATS TUNA ONION)
          (EATS TOFU TURKEY)
          (EATS CANTELOPE CHICKEN)
          (CRAVES LONELINESS LEMON)
          (CRAVES ANXIETY-26 PEA)
          (EATS LOBSTER LAMB)
          (EATS LOBSTER RICE)
          (CRAVES DREAD POPOVER)
          (CRAVES ANXIETY OKRA)
          (LOCALE LOBSTER QUEBEC)
          (EATS PAPAYA OKRA)
          (CRAVES DEPRESSION-9 SNICKERS)
          (EATS MUFFIN SWEETROLL)
          (LOCALE COD MORAVIA)
          (EATS BROCCOLI LOBSTER)
          (CRAVES PROSTATITIS HAM)
          (EATS LOBSTER CHICKEN)
          (EATS LETTUCE POTATO)
          (EATS GRAPEFRUIT SCALLION)
          (CRAVES BOILS CHOCOLATE)
          (ATTACKS OREGON ARIZONA)
          (HARMONY LUBRICITY NEPTUNE)
          (EATS HOTDOG POPOVER)
          (CRAVES ANXIETY-61 LOBSTER)
          (CRAVES ACHIEVEMENT SWEETROLL)
          (EATS POTATO BACON)
          (HARMONY UNDERSTANDING JUPITER)
          (EATS LOBSTER BROCCOLI)
          (CRAVES LEARNING SCALLOP)
          (CRAVES SCIATICA-28 PISTACHIO)
          (CRAVES JEALOUSY-54 COD)
          (CRAVES DEPRESSION PEPPER)
          (CRAVES BOILS-20 RICE)
          (CRAVES JEALOUSY-15 HOTDOG)
          (EATS HAROSET POTATO)
          (EATS KALE MARZIPAN)
          (EATS TUNA HAMBURGER)
          (CRAVES LUBRICITY KALE)
          (LOCALE ORANGE QUEBEC)
          (EATS TUNA LETTUCE)
          (EATS CANTELOPE BAGUETTE)
          (EATS PEPPER SCALLOP)
          (EATS BACON POTATO)
          (EATS GRAPEFRUIT PAPAYA)
          (EATS BAGUETTE RICE)
          (LOCALE MUFFIN MORAVIA)
          (CRAVES JEALOUSY-31 BACON)
          (EATS BAGUETTE PEA)
          (EATS RICE CANTELOPE)
          (EATS KALE TOMATO)
          (EATS HAROSET ORANGE)
          (EATS PEAR LEMON)
          (LOCALE MARZIPAN MORAVIA)
          (LOCALE TURKEY MORAVIA)
          (LOCALE PISTACHIO MORAVIA)
          (LOCALE CANTELOPE MORAVIA)
          (CRAVES INTOXICATION LOBSTER)
          (CRAVES HANGOVER-3 MUFFIN)
          (EATS COD MARZIPAN)
          (EATS ORANGE HAM)
          (CRAVES EMPATHY HAROSET)
          (EATS POTATO LETTUCE)
          (EATS OKRA BACON)
          (CRAVES DREAD-60 BROCCOLI)
          (CRAVES LOVE CANTELOPE)
          (EATS SWEETROLL MUFFIN)
          (EATS GRAPEFRUIT HAMBURGER)
          (EATS SNICKERS PEPPER)
          (EATS TUNA HAROSET)
          (EATS RICE PEA)
          (ORBITS MERCURY JUPITER)
          (CRAVES REST TOFU)
          (EATS PORK TURKEY)
          (CRAVES UNDERSTANDING OKRA)
          (HARMONY EXPECTATION JUPITER)
          (CRAVES JEALOUSY LETTUCE)
          (CRAVES STIMULATION BACON)
          (EATS BACON OKRA)
          (CRAVES LACERATION-19 CANTELOPE)
          (HARMONY LOVE NEPTUNE)
          (EATS COD PEA)
          (EATS LAMB RICE)
          (CRAVES BOILS-7 PAPAYA)
          (CRAVES LONELINESS-55 PORK)
          (CRAVES DEPRESSION-58 MARZIPAN)
          (EATS CUCUMBER ENDIVE)
          (EATS PEPPER SNICKERS)
          (EATS HAMBURGER GRAPEFRUIT)
          (EATS MARZIPAN COD)
          (HARMONY LEARNING NEPTUNE)
          (LOCALE LETTUCE MORAVIA)
          (EATS ONION GRAPEFRUIT)
          (CRAVES LACERATION-5 POTATO)
          (EATS GRAPEFRUIT CHOCOLATE)
          (LOCALE SWEETROLL MORAVIA)
          (HARMONY EMPATHY MERCURY)
          (EATS TOFU LAMB)
          (CRAVES GRIEF CHOCOLATE)
          (LOCALE CUCUMBER QUEBEC)
          (HARMONY INTOXICATION NEPTUNE)
          (CRAVES LONELINESS-8 MUFFIN)
          (CRAVES HANGOVER-17 BAGUETTE)
          (LOCALE PAPAYA QUEBEC)
          (EATS MELON GRAPEFRUIT)
          (CRAVES LACERATION-22 LAMB)
          (EATS SCALLION GRAPEFRUIT)
          (EATS BROCCOLI TOFU))
   (:GOAL (AND (CRAVES ANXIETY-16 CANTELOPE)
               (CRAVES LACERATION-5 HAM)
               (CRAVES ANGINA-62 SCALLION)
               (CRAVES ABRASION-63 HAROSET))))

(DEFINE (PROBLEM MYSTY-25)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS LEMON-12 BEEF-13 YOGURT-14 SHRIMP-15
             HAM-16 PAPAYA-5 BACON-6 ENDIVE-7 FLOUNDER-8
             ARUGULA-3 PEAR-4 SCALLION-1 SNICKERS-2 MARZIPAN
             POTATO WURST TUNA KALE WONDERBREAD CHERRY TOFU
             FLOUNDER PORK APPLE TOMATO LEMON BEEF SCALLION PEAR
             PAPAYA BROCCOLI SCALLOP CANTELOPE LOBSTER
             SNICKERS BACON CUCUMBER OKRA HAMBURGER LETTUCE HAM
             HOTDOG MELON SWEETROLL YOGURT ORANGE GUAVA
             CHOCOLATE ARUGULA RICE LAMB GRAPEFRUIT ONION MUTTON
             CHICKEN SHRIMP PEPPER ENDIVE POPOVER PEA MUFFIN
             BAGUETTE HAROSET TURKEY PISTACHIO COD - FOOD
             TRIUMPH LEARNING CURIOSITY UNDERSTANDING
             SATISFACTION EXCITEMENT ENTERTAINMENT REST SATIETY
             EMPATHY ACHIEVEMENT LOVE INTOXICATION STIMULATION
             - PLEASURE
             ANGER ANGINA LONELINESS DEPRESSION ABRASION
             BOILS HANGOVER ANXIETY GRIEF PROSTATITIS DREAD
             JEALOUSY SCIATICA BOILS-32 GRIEF-9 JEALOUSY-10
             HANGOVER-11 LACERATION ANXIETY-27 ANGER-28 DREAD-29
             ANGINA-30 SCIATICA-31 PROSTATITIS-22 LONELINESS-23
             LACERATION-24 ABRASION-25 DEPRESSION-26 DEPRESSION-18
             HANGOVER-19 JEALOUSY-20 GRIEF-21 ANGINA-64 BOILS-17
             DREAD-61 ANXIETY-62 PROSTATITIS-63 LONELINESS-57
             ANGER-58 LACERATION-59 ABRASION-60 LACERATION-52
             JEALOUSY-53 HANGOVER-54 PROSTATITIS-55 SCIATICA-56
             ANGER-49 BOILS-50 LONELINESS-51 ANGINA-48
             ANXIETY-47 DREAD-43 SCIATICA-44 DEPRESSION-45
             GRIEF-46 PROSTATITIS-40 JEALOUSY-41 ABRASION-42
             - PAIN
             ALSACE BOSNIA SURREY PENNSYLVANIA MORAVIA BAVARIA
             OREGON GOIAS - PROVINCE
             URANUS VENUS NEPTUNE JUPITER - PLANET)
   (:INIT (CRAVES PROSTATITIS-40 PISTACHIO)
          (EATS RICE COD)
          (EATS LEMON-12 CHERRY)
          (CRAVES GRIEF-46 HAROSET)
          (LOCALE BEEF ALSACE)
          (EATS SCALLION OKRA)
          (EATS LEMON PAPAYA)
          (CRAVES BOILS-17 ORANGE)
          (EATS GRAPEFRUIT SWEETROLL)
          (LOCALE WONDERBREAD PENNSYLVANIA)
          (LOCALE BEEF-13 MORAVIA)
          (EATS PAPAYA LEMON)
          (LOCALE HAM ALSACE)
          (EATS MELON PEPPER)
          (EATS POPOVER BACON)
          (HARMONY SATIETY VENUS)
          (EATS APPLE HAROSET)
          (EATS CANTELOPE MUFFIN)
          (LOCALE TURKEY SURREY)
          (CRAVES JEALOUSY-20 SWEETROLL)
          (EATS LAMB POPOVER)
          (EATS SCALLION-1 TOFU)
          (EATS ENDIVE-7 BEEF-13)
          (EATS BROCCOLI LETTUCE)
          (EATS TUNA SHRIMP-15)
          (CRAVES EXCITEMENT LEMON)
          (EATS PEAR SWEETROLL)
          (EATS OKRA CHICKEN)
          (EATS LETTUCE BROCCOLI)
          (EATS PEA BEEF)
          (LOCALE POTATO BOSNIA)
          (LOCALE SCALLION BOSNIA)
          (EATS TUNA WURST)
          (EATS SCALLION-1 SNICKERS-2)
          (EATS OKRA SCALLION)
          (CRAVES PROSTATITIS-55 GRAPEFRUIT)
          (HARMONY SATISFACTION JUPITER)
          (EATS CHERRY LEMON-12)
          (EATS HAM-16 TOFU)
          (ATTACKS BOSNIA SURREY)
          (EATS ONION ENDIVE)
          (LOCALE RICE PENNSYLVANIA)
          (EATS HAMBURGER COD)
          (EATS PAPAYA SCALLOP)
          (LOCALE TUNA MORAVIA)
          (EATS HOTDOG PEPPER)
          (CRAVES PROSTATITIS POTATO)
          (LOCALE BACON SURREY)
          (EATS CANTELOPE PISTACHIO)
          (EATS MUTTON PISTACHIO)
          (CRAVES STIMULATION PISTACHIO)
          (HARMONY LEARNING NEPTUNE)
          (EATS PISTACHIO MUTTON)
          (CRAVES DEPRESSION ENDIVE-7)
          (EATS TOFU PAPAYA-5)
          (LOCALE SHRIMP SURREY)
          (EATS FLOUNDER SNICKERS-2)
          (EATS SWEETROLL GRAPEFRUIT)
          (EATS SCALLION-1 BEEF-13)
          (EATS KALE PEAR-4)
          (LOCALE CUCUMBER SURREY)
          (LOCALE OKRA SURREY)
          (LOCALE MUTTON ALSACE)
          (ATTACKS BAVARIA OREGON)
          (EATS GRAPEFRUIT SCALLION)
          (EATS CHOCOLATE RICE)
          (EATS SCALLOP PEA)
          (LOCALE GRAPEFRUIT SURREY)
          (HARMONY LOVE JUPITER)
          (CRAVES SCIATICA-31 BACON)
          (CRAVES LONELINESS-51 ONION)
          (EATS PEA PEAR)
          (LOCALE YOGURT SURREY)
          (CRAVES SATISFACTION PORK)
          (LOCALE PEAR-4 OREGON)
          (EATS BEEF-13 SCALLION-1)
          (EATS GUAVA SNICKERS)
          (EATS BAGUETTE TURKEY)
          (CRAVES DEPRESSION-18 SWEETROLL)
          (EATS FLOUNDER POTATO)
          (EATS CHERRY PAPAYA-5)
          (EATS SHRIMP-15 TUNA)
          (EATS PEAR PEA)
          (LOCALE KALE GOIAS)
          (EATS SCALLION-1 FLOUNDER)
          (EATS FLOUNDER-8 CHERRY)
          (EATS GUAVA PEAR)
          (EATS LOBSTER ONION)
          (EATS HAROSET APPLE)
          (CRAVES LONELINESS-23 LETTUCE)
          (EATS GUAVA CHICKEN)
          (EATS APPLE ENDIVE)
          (LOCALE LOBSTER OREGON)
          (LOCALE CHERRY ALSACE)
          (EATS PISTACHIO BAGUETTE)
          (EATS CUCUMBER TOMATO)
          (ORBITS VENUS NEPTUNE)
          (LOCALE SNICKERS-2 MORAVIA)
          (EATS BACON POPOVER)
          (LOCALE FLOUNDER-8 SURREY)
          (LOCALE HAM-16 ALSACE)
          (EATS HAROSET HAMBURGER)
          (EATS POTATO FLOUNDER)
          (EATS KALE YOGURT-14)
          (EATS PAPAYA-5 CHERRY)
          (CRAVES ABRASION-25 LETTUCE)
          (CRAVES ABRASION ENDIVE-7)
          (EATS BAGUETTE PISTACHIO)
          (CRAVES HANGOVER-11 LOBSTER)
          (EATS BEEF-13 ENDIVE-7)
          (EATS MUFFIN FLOUNDER-8)
          (EATS HAM LEMON)
          (EATS BACON-6 PEAR-4)
          (CRAVES INTOXICATION HAROSET)
          (EATS FLOUNDER SCALLION-1)
          (EATS FLOUNDER-8 MUFFIN)
          (CRAVES LOVE PEA)
          (CRAVES ANGINA-30 BACON)
          (CRAVES BOILS-50 ONION)
          (EATS MARZIPAN PORK)
          (CRAVES LACERATION-59 LAMB)
          (LOCALE SCALLION-1 BOSNIA)
          (EATS SHRIMP POPOVER)
          (ATTACKS ALSACE BOSNIA)
          (LOCALE CANTELOPE ALSACE)
          (EATS CHICKEN OKRA)
          (EATS LETTUCE SHRIMP)
          (EATS POTATO PORK)
          (LOCALE CHICKEN BOSNIA)
          (CRAVES ANGER YOGURT-14)
          (HARMONY UNDERSTANDING JUPITER)
          (EATS PORK MARZIPAN)
          (EATS RICE HAMBURGER)
          (LOCALE PEPPER SURREY)
          (EATS TOFU HAM-16)
          (CRAVES ANXIETY-47 BAGUETTE)
          (EATS CHICKEN GUAVA)
          (EATS HAM-16 SNICKERS-2)
          (EATS PEAR-4 BACON-6)
          (EATS SCALLION GRAPEFRUIT)
          (CRAVES JEALOUSY APPLE)
          (LOCALE BACON-6 MORAVIA)
          (LOCALE SCALLOP PENNSYLVANIA)
          (EATS HAMBURGER RICE)
          (LOCALE ONION BOSNIA)
          (EATS KALE MARZIPAN)
          (LOCALE ORANGE PENNSYLVANIA)
          (EATS PEAR GUAVA)
          (CRAVES ANGER-49 ONION)
          (LOCALE CHOCOLATE SURREY)
          (EATS WONDERBREAD PORK)
          (EATS HAM BROCCOLI)
          (LOCALE LEMON BOSNIA)
          (EATS HAROSET CUCUMBER)
          (EATS SHRIMP LETTUCE)
          (EATS RICE CHOCOLATE)
          (LOCALE MELON BAVARIA)
          (EATS HOTDOG TURKEY)
          (LOCALE PEAR PENNSYLVANIA)
          (EATS ONION LOBSTER)
          (CRAVES ACHIEVEMENT ARUGULA)
          (CRAVES DEPRESSION-26 LETTUCE)
          (CRAVES ANXIETY-62 GUAVA)
          (EATS PEPPER CHICKEN)
          (EATS LOBSTER MELON)
          (CRAVES ANGINA YOGURT-14)
          (HARMONY ACHIEVEMENT NEPTUNE)
          (LOCALE POPOVER BOSNIA)
          (CRAVES LACERATION-24 LETTUCE)
          (EATS SCALLOP PAPAYA)
          (EATS FLOUNDER YOGURT-14)
          (CRAVES GRIEF-9 LOBSTER)
          (EATS MELON HOTDOG)
          (EATS SNICKERS PEA)
          (EATS BEEF PEA)
          (LOCALE ENDIVE SURREY)
          (EATS ENDIVE ONION)
          (EATS BACON YOGURT)
          (EATS YOGURT-14 KALE)
          (LOCALE YOGURT-14 BOSNIA)
          (EATS CHERRY FLOUNDER-8)
          (LOCALE PISTACHIO ALSACE)
          (CRAVES LEARNING ARUGULA-3)
          (CRAVES JEALOUSY-10 LOBSTER)
          (EATS ORANGE PEA)
          (EATS YOGURT BACON)
          (EATS POPOVER SHRIMP)
          (EATS PEA SNICKERS)
          (CRAVES ANXIETY-27 BACON)
          (EATS TURKEY MELON)
          (LOCALE TOMATO BOSNIA)
          (EATS WURST FLOUNDER-8)
          (EATS PEA MUFFIN)
          (EATS KALE WURST)
          (LOCALE HOTDOG MORAVIA)
          (EATS MELON TURKEY)
          (EATS PEPPER BAGUETTE)
          (LOCALE HAROSET BOSNIA)
          (EATS PEAR OKRA)
          (CRAVES ANGER-28 BACON)
          (LOCALE LEMON-12 ALSACE)
          (EATS WURST TUNA)
          (CRAVES ANGINA-64 ORANGE)
          (LOCALE WURST MORAVIA)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS YOGURT GUAVA)
          (CRAVES DREAD-61 GUAVA)
          (EATS HAMBURGER HAROSET)
          (CRAVES BOILS ENDIVE-7)
          (EATS PORK POTATO)
          (EATS ENDIVE APPLE)
          (EATS PEPPER ARUGULA)
          (EATS SNICKERS-2 HAM-16)
          (EATS SCALLION-1 TUNA)
          (EATS ENDIVE-7 SHRIMP-15)
          (EATS POPOVER LAMB)
          (EATS TURKEY HOTDOG)
          (EATS SHRIMP-15 ENDIVE-7)
          (ORBITS URANUS VENUS)
          (EATS ENDIVE-7 TOFU)
          (EATS SHRIMP MUTTON)
          (CRAVES SCIATICA APPLE)
          (ATTACKS PENNSYLVANIA MORAVIA)
          (EATS ARUGULA PEPPER)
          (CRAVES BOILS-32 LOBSTER)
          (CRAVES EMPATHY YOGURT)
          (LOCALE GUAVA BAVARIA)
          (EATS MELON LOBSTER)
          (LOCALE TOFU PENNSYLVANIA)
          (CRAVES SCIATICA-44 HAROSET)
          (EATS CHOCOLATE ORANGE)
          (LOCALE BROCCOLI BOSNIA)
          (CRAVES HANGOVER ENDIVE-7)
          (EATS COD RICE)
          (CRAVES PROSTATITIS-22 LETTUCE)
          (EATS LAMB ARUGULA)
          (EATS BACON-6 ARUGULA-3)
          (EATS BAGUETTE PEPPER)
          (EATS SNICKERS GUAVA)
          (CRAVES REST LOBSTER)
          (LOCALE SNICKERS OREGON)
          (ATTACKS MORAVIA BAVARIA)
          (CRAVES UNDERSTANDING FLOUNDER)
          (CRAVES ANGER-58 LAMB)
          (EATS CHOCOLATE HAMBURGER)
          (EATS TOFU ENDIVE-7)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS SNICKERS-2 FLOUNDER)
          (EATS GUAVA YOGURT)
          (EATS MARZIPAN KALE)
          (EATS LEMON-12 WONDERBREAD)
          (EATS ARUGULA LAMB)
          (EATS WONDERBREAD ARUGULA-3)
          (EATS ARUGULA-3 MARZIPAN)
          (EATS WURST KALE)
          (EATS PISTACHIO CANTELOPE)
          (EATS PEAR-4 KALE)
          (EATS WONDERBREAD LEMON-12)
          (LOCALE MARZIPAN BOSNIA)
          (EATS PEPPER MELON)
          (HARMONY REST VENUS)
          (CRAVES SCIATICA-56 GRAPEFRUIT)
          (EATS TURKEY BAGUETTE)
          (LOCALE ENDIVE-7 ALSACE)
          (EATS GRAPEFRUIT HAROSET)
          (EATS MARZIPAN ARUGULA-3)
          (EATS BROCCOLI HAM)
          (HARMONY EMPATHY NEPTUNE)
          (LOCALE LAMB BOSNIA)
          (LOCALE PEA BAVARIA)
          (CRAVES ANGINA-48 POPOVER)
          (EATS MUFFIN PEA)
          (LOCALE BAGUETTE BOSNIA)
          (EATS POPOVER BEEF)
          (EATS PEPPER SHRIMP)
          (EATS SWEETROLL PEAR)
          (EATS PAPAYA-5 TOFU)
          (LOCALE ARUGULA-3 BAVARIA)
          (EATS PEPPER HOTDOG)
          (LOCALE MUFFIN BAVARIA)
          (EATS TOMATO CHICKEN)
          (EATS CHICKEN TOMATO)
          (EATS SHRIMP PEPPER)
          (EATS LEMON HAM)
          (CRAVES TRIUMPH BACON-6)
          (HARMONY TRIUMPH NEPTUNE)
          (EATS CHICKEN HAROSET)
          (EATS OKRA PEAR)
          (CRAVES ENTERTAINMENT BEEF)
          (EATS HAMBURGER CHOCOLATE)
          (LOCALE FLOUNDER PENNSYLVANIA)
          (LOCALE COD PENNSYLVANIA)
          (EATS MUFFIN CANTELOPE)
          (EATS ENDIVE CUCUMBER)
          (EATS TOMATO CUCUMBER)
          (EATS TOFU SCALLION-1)
          (EATS CUCUMBER ENDIVE)
          (CRAVES DEPRESSION-45 HAROSET)
          (EATS PEA SCALLOP)
          (EATS ARUGULA-3 BACON-6)
          (ORBITS NEPTUNE JUPITER)
          (CRAVES DREAD KALE)
          (EATS HAROSET CHICKEN)
          (CRAVES ABRASION-42 PISTACHIO)
          (CRAVES LACERATION LOBSTER)
          (CRAVES HANGOVER-54 GRAPEFRUIT)
          (CRAVES JEALOUSY-41 PISTACHIO)
          (CRAVES LACERATION-52 GRAPEFRUIT)
          (EATS ORANGE CHOCOLATE)
          (CRAVES LONELINESS YOGURT-14)
          (EATS YOGURT-14 FLOUNDER)
          (EATS TUNA SCALLION-1)
          (CRAVES GRIEF-21 SWEETROLL)
          (CRAVES HANGOVER-19 SWEETROLL)
          (CRAVES SATIETY SNICKERS)
          (ATTACKS SURREY PENNSYLVANIA)
          (LOCALE SWEETROLL SURREY)
          (EATS BEEF POPOVER)
          (HARMONY CURIOSITY JUPITER)
          (EATS COD HAMBURGER)
          (EATS PORK WONDERBREAD)
          (CRAVES DREAD-43 HAROSET)
          (CRAVES LONELINESS-57 LAMB)
          (CRAVES JEALOUSY-53 GRAPEFRUIT)
          (HARMONY STIMULATION VENUS)
          (LOCALE PAPAYA PENNSYLVANIA)
          (EATS SNICKERS-2 SCALLION-1)
          (CRAVES CURIOSITY WONDERBREAD)
          (LOCALE PAPAYA-5 MORAVIA)
          (LOCALE APPLE SURREY)
          (ATTACKS OREGON GOIAS)
          (CRAVES ANXIETY MARZIPAN)
          (HARMONY INTOXICATION VENUS)
          (LOCALE HAMBURGER BOSNIA)
          (LOCALE PORK SURREY)
          (LOCALE ARUGULA ALSACE)
          (CRAVES GRIEF POTATO)
          (EATS PEA ORANGE)
          (LOCALE SHRIMP-15 ALSACE)
          (CRAVES ABRASION-60 LAMB)
          (EATS ARUGULA-3 WONDERBREAD)
          (LOCALE LETTUCE ALSACE)
          (EATS MUTTON SHRIMP)
          (EATS CHICKEN PEPPER)
          (EATS CUCUMBER HAROSET)
          (EATS HOTDOG MELON)
          (CRAVES DREAD-29 BACON)
          (EATS FLOUNDER-8 WURST)
          (EATS HAROSET GRAPEFRUIT)
          (CRAVES PROSTATITIS-63 GUAVA))
   (:GOAL (AND (CRAVES LONELINESS-23 MUTTON))))

(DEFINE (PROBLEM MYSTY-26)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS BACON-31 CANTELOPE-30 TUNA-29 CHERRY-28
             TOFU-32 COD-9 BROCCOLI-10 YOGURT-11 TOMATO-12
             MARZIPAN-16 LOBSTER-15 SCALLION-14 GUAVA-13 PORK-5
             MUFFIN-6 PEPPER-7 WURST-8 POPOVER-3 TURKEY-4
             ENDIVE-1 HAMBURGER-2 HAM COD SHRIMP HOTDOG LETTUCE
             PAPAYA BEEF PEA APPLE POTATO MARZIPAN TUNA
             WONDERBREAD ORANGE SWEETROLL HAMBURGER ARUGULA
             FLOUNDER PEAR SCALLOP PEPPER CUCUMBER BACON TOMATO
             MUTTON HAROSET YOGURT CHICKEN BROCCOLI LAMB TURKEY
             CHERRY PISTACHIO GRAPEFRUIT TOFU BAGUETTE WURST
             OKRA KALE MUFFIN CHOCOLATE ENDIVE GUAVA MELON
             ONION POPOVER LOBSTER SCALLION PORK SNICKERS
             CANTELOPE RICE LEMON - FOOD
             STIMULATION EXPECTATION LEARNING INTOXICATION EMPATHY
             EXCITEMENT REST LOVE SATISFACTION TRIUMPH
             UNDERSTANDING SATIETY ACHIEVEMENT LUBRICITY
             ENTERTAINMENT CURIOSITY AESTHETICS REST-27
             ENTERTAINMENT-26 EXPECTATION-25 ACHIEVEMENT-24
             SATISFACTION-23 TRIUMPH-22 CURIOSITY-21 EXCITEMENT-20
             LEARNING-19 LOVE-18 INTOXICATION-17 STIMULATION-64
             EMPATHY-63 AESTHETICS-62 UNDERSTANDING-61
             LUBRICITY-60 - PLEASURE
             ANGER HANGOVER GRIEF BOILS ANGINA ABRASION
             DEPRESSION JEALOUSY DREAD PROSTATITIS LACERATION
             SCIATICA LONELINESS ANXIETY SCIATICA-58
             HANGOVER-59 DEPRESSION-54 GRIEF-55 ANGINA-56
             PROSTATITIS-57 LONELINESS-50 ANXIETY-51 LACERATION-52
             ANGER-53 JEALOUSY-46 DREAD-47 ABRASION-48 BOILS-49
             PROSTATITIS-42 ANXIETY-43 JEALOUSY-44 GRIEF-45
             LACERATION-39 DREAD-40 DEPRESSION-41 HANGOVER-37
             ANGINA-38 LONELINESS-34 ABRASION-35 BOILS-36
             ANXIETY-127 ANGER-128 SCIATICA-33 HANGOVER-126
             DREAD-125 ANGER-121 PROSTATITIS-122 DEPRESSION-123
             ABRASION-124 ANGINA-120 BOILS-118 LACERATION-119
             JEALOUSY-114 LONELINESS-115 SCIATICA-116 GRIEF-117
             ANGINA-113 - PAIN
             BOSNIA GOIAS PENNSYLVANIA GUANABARA OREGON
             KENTUCKY QUEBEC - PROVINCE
             PLUTO VENUS MERCURY NEPTUNE - PLANET)
   (:INIT (LOCALE RICE GUANABARA)
          (CRAVES LACERATION-119 PORK)
          (CRAVES UNDERSTANDING TUNA)
          (CRAVES LOVE COD)
          (HARMONY SATISFACTION MERCURY)
          (EATS POPOVER PEAR)
          (CRAVES SATISFACTION PEA)
          (EATS LOBSTER HAM)
          (CRAVES PROSTATITIS POPOVER-3)
          (EATS RICE CANTELOPE)
          (EATS TOFU TOMATO)
          (EATS LOBSTER-15 SCALLION-14)
          (HARMONY EXPECTATION-25 NEPTUNE)
          (EATS PORK SCALLION)
          (EATS MARZIPAN GUAVA)
          (EATS BEEF POPOVER)
          (CRAVES CURIOSITY-21 PISTACHIO)
          (CRAVES LACERATION POPOVER-3)
          (HARMONY TRIUMPH NEPTUNE)
          (EATS MUTTON SHRIMP)
          (CRAVES ABRASION PEPPER-7)
          (CRAVES CURIOSITY FLOUNDER)
          (CRAVES SATIETY WONDERBREAD)
          (EATS CHERRY-28 BACON-31)
          (EATS WURST-8 POPOVER-3)
          (EATS BACON CUCUMBER)
          (EATS TOMATO-12 BROCCOLI-10)
          (EATS PEPPER PEAR)
          (EATS TOMATO SWEETROLL)
          (LOCALE CHERRY-28 GUANABARA)
          (LOCALE POPOVER-3 GUANABARA)
          (EATS YOGURT TURKEY)
          (EATS TOFU-32 TOMATO-12)
          (CRAVES LUBRICITY-60 LEMON)
          (LOCALE GRAPEFRUIT GUANABARA)
          (EATS PORK-5 HAROSET)
          (EATS MELON CHERRY)
          (EATS HOTDOG HAMBURGER)
          (LOCALE SCALLOP KENTUCKY)
          (HARMONY EXCITEMENT-20 NEPTUNE)
          (CRAVES ABRASION-124 TURKEY)
          (CRAVES DREAD-47 LETTUCE)
          (EATS TOFU-32 YOGURT-11)
          (EATS KALE COD)
          (CRAVES ANXIETY-43 BEEF)
          (EATS YOGURT-11 COD-9)
          (CRAVES INTOXICATION PORK-5)
          (EATS ENDIVE-1 MUFFIN)
          (HARMONY CURIOSITY MERCURY)
          (CRAVES GRIEF-117 SNICKERS)
          (HARMONY EXCITEMENT MERCURY)
          (LOCALE GUAVA GUANABARA)
          (EATS PEA BROCCOLI)
          (EATS ENDIVE CHICKEN)
          (EATS CUCUMBER LEMON)
          (HARMONY REST-27 VENUS)
          (ATTACKS BOSNIA GOIAS)
          (EATS SCALLOP LAMB)
          (CRAVES ANXIETY-127 TOMATO)
          (LOCALE CANTELOPE KENTUCKY)
          (EATS POPOVER BEEF)
          (CRAVES SCIATICA-58 HAM)
          (EATS OKRA GRAPEFRUIT)
          (CRAVES SCIATICA ENDIVE-1)
          (EATS RICE PEPPER-7)
          (LOCALE BACON OREGON)
          (CRAVES DREAD-40 APPLE)
          (LOCALE ONION GOIAS)
          (LOCALE PEPPER GUANABARA)
          (CRAVES HANGOVER-37 MARZIPAN)
          (CRAVES ANXIETY ENDIVE-1)
          (CRAVES LEARNING MARZIPAN-16)
          (EATS COD-9 CANTELOPE-30)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (CRAVES ABRASION-35 WONDERBREAD)
          (EATS PORK-5 MELON)
          (EATS SNICKERS COD)
          (EATS FLOUNDER CHERRY)
          (EATS SCALLION POTATO)
          (LOCALE LETTUCE BOSNIA)
          (HARMONY LOVE VENUS)
          (EATS POTATO ORANGE)
          (EATS HAMBURGER-2 PISTACHIO)
          (EATS TUNA-29 CANTELOPE-30)
          (CRAVES EMPATHY MUFFIN-6)
          (LOCALE BROCCOLI-10 GUANABARA)
          (CRAVES TRIUMPH-22 CHERRY)
          (EATS YOGURT-11 GUAVA-13)
          (LOCALE HOTDOG KENTUCKY)
          (EATS BROCCOLI-10 SCALLION-14)
          (EATS CHOCOLATE MARZIPAN)
          (LOCALE HAMBURGER PENNSYLVANIA)
          (CRAVES GRIEF-45 BEEF)
          (CRAVES DEPRESSION-54 COD)
          (CRAVES LACERATION-39 APPLE)
          (EATS CHICKEN OKRA)
          (EATS BROCCOLI-10 COD-9)
          (LOCALE COD-9 QUEBEC)
          (EATS SWEETROLL ORANGE)
          (CRAVES ENTERTAINMENT-26 MUTTON)
          (EATS SCALLOP BEEF)
          (EATS SCALLION-14 LOBSTER-15)
          (CRAVES LONELINESS ENDIVE-1)
          (LOCALE MUFFIN-6 GOIAS)
          (EATS PEAR PEPPER)
          (CRAVES EMPATHY-63 SCALLION)
          (EATS ENDIVE-1 BROCCOLI)
          (EATS MUFFIN-6 POPOVER-3)
          (EATS MUFFIN-6 MUFFIN)
          (LOCALE COD KENTUCKY)
          (EATS TUNA HAMBURGER-2)
          (EATS ARUGULA TOMATO)
          (EATS SHRIMP SCALLION)
          (EATS PISTACHIO GUAVA)
          (EATS YOGURT PEPPER)
          (ATTACKS KENTUCKY QUEBEC)
          (EATS OKRA SHRIMP)
          (CRAVES REST-27 BACON)
          (EATS SCALLION SHRIMP)
          (EATS MUTTON ENDIVE)
          (EATS PISTACHIO HAMBURGER-2)
          (LOCALE CANTELOPE-30 GUANABARA)
          (EATS TUNA PEA)
          (CRAVES ANGER-53 SHRIMP)
          (EATS FLOUNDER BAGUETTE)
          (EATS SNICKERS LEMON)
          (CRAVES SCIATICA-116 SNICKERS)
          (EATS POPOVER-3 WURST-8)
          (LOCALE ENDIVE GOIAS)
          (LOCALE CHERRY KENTUCKY)
          (CRAVES EXCITEMENT TURKEY-4)
          (EATS LAMB KALE)
          (EATS WURST-8 RICE)
          (CRAVES ENTERTAINMENT ARUGULA)
          (CRAVES AESTHETICS-62 PORK)
          (CRAVES ANGINA-120 BAGUETTE)
          (LOCALE SCALLION GOIAS)
          (EATS TOFU ORANGE)
          (EATS ONION LETTUCE)
          (EATS PEPPER YOGURT)
          (EATS MUFFIN CANTELOPE)
          (LOCALE LOBSTER-15 KENTUCKY)
          (LOCALE MELON OREGON)
          (HARMONY LUBRICITY VENUS)
          (EATS BACON WURST)
          (EATS PORK GRAPEFRUIT)
          (LOCALE WONDERBREAD BOSNIA)
          (CRAVES HANGOVER-126 HAROSET)
          (EATS LOBSTER APPLE)
          (EATS RICE WURST-8)
          (EATS PISTACHIO PEPPER-7)
          (LOCALE ENDIVE-1 OREGON)
          (EATS CHICKEN ENDIVE)
          (CRAVES ANGINA PEPPER-7)
          (EATS SHRIMP OKRA)
          (CRAVES PROSTATITIS-122 TURKEY)
          (LOCALE YOGURT-11 GOIAS)
          (EATS TURKEY-4 HOTDOG)
          (EATS TURKEY YOGURT)
          (LOCALE HAROSET BOSNIA)
          (CRAVES HANGOVER CANTELOPE-30)
          (EATS COD SNICKERS)
          (HARMONY ACHIEVEMENT VENUS)
          (CRAVES ANGER-121 TURKEY)
          (CRAVES DEPRESSION PEPPER-7)
          (LOCALE CHOCOLATE GUANABARA)
          (EATS PISTACHIO MUFFIN)
          (EATS PISTACHIO TURKEY-4)
          (EATS SWEETROLL TOMATO)
          (EATS CANTELOPE-30 TUNA-29)
          (EATS GUAVA BROCCOLI)
          (LOCALE MARZIPAN OREGON)
          (CRAVES DREAD POPOVER-3)
          (EATS ORANGE TOFU)
          (HARMONY INTOXICATION-17 NEPTUNE)
          (ORBITS PLUTO VENUS)
          (EATS GUAVA MARZIPAN)
          (CRAVES EXPECTATION-25 HAROSET)
          (CRAVES ACHIEVEMENT ORANGE)
          (HARMONY CURIOSITY-21 NEPTUNE)
          (LOCALE TUNA OREGON)
          (EATS CANTELOPE RICE)
          (EATS PAPAYA MELON)
          (LOCALE WURST-8 KENTUCKY)
          (EATS CANTELOPE-30 COD-9)
          (CRAVES GRIEF-55 COD)
          (CRAVES DEPRESSION-41 APPLE)
          (LOCALE PEAR OREGON)
          (EATS COD-9 BROCCOLI-10)
          (LOCALE TOFU OREGON)
          (EATS CANTELOPE-30 CHERRY-28)
          (EATS APPLE LOBSTER)
          (LOCALE SHRIMP KENTUCKY)
          (ATTACKS GOIAS PENNSYLVANIA)
          (EATS HAROSET PORK-5)
          (CRAVES BOILS-36 WONDERBREAD)
          (LOCALE PISTACHIO GOIAS)
          (HARMONY TRIUMPH-22 VENUS)
          (EATS ENDIVE OKRA)
          (LOCALE BAGUETTE OREGON)
          (EATS HAMBURGER CHOCOLATE)
          (EATS WURST BACON)
          (CRAVES STIMULATION-64 LOBSTER)
          (LOCALE POPOVER BOSNIA)
          (CRAVES EXPECTATION BROCCOLI-10)
          (LOCALE TOFU-32 BOSNIA)
          (EATS CHOCOLATE HAMBURGER)
          (EATS HAMBURGER HOTDOG)
          (LOCALE PAPAYA BOSNIA)
          (EATS BROCCOLI GUAVA)
          (CRAVES ANGER-128 TOMATO)
          (EATS BEEF SCALLOP)
          (EATS HAMBURGER-2 TUNA)
          (EATS TOFU-32 BROCCOLI-10)
          (EATS TOMATO-12 TOFU-32)
          (HARMONY STIMULATION VENUS)
          (HARMONY AESTHETICS NEPTUNE)
          (EATS COD-9 WURST-8)
          (HARMONY AESTHETICS-62 VENUS)
          (CRAVES LONELINESS-34 WONDERBREAD)
          (HARMONY UNDERSTANDING-61 NEPTUNE)
          (LOCALE MARZIPAN-16 GOIAS)
          (EATS SWEETROLL WONDERBREAD)
          (EATS BROCCOLI ENDIVE-1)
          (EATS CANTELOPE-30 BACON-31)
          (EATS POPOVER-3 MUFFIN-6)
          (LOCALE PEPPER-7 OREGON)
          (LOCALE SCALLION-14 GUANABARA)
          (EATS MARZIPAN-16 LOBSTER-15)
          (EATS OKRA BAGUETTE)
          (EATS PEA TUNA)
          (CRAVES HANGOVER-59 HAM)
          (HARMONY SATIETY VENUS)
          (EATS GUAVA PISTACHIO)
          (CRAVES ABRASION-48 LETTUCE)
          (EATS TOMATO ARUGULA)
          (CRAVES PROSTATITIS-57 COD)
          (HARMONY LUBRICITY-60 NEPTUNE)
          (LOCALE SNICKERS GUANABARA)
          (CRAVES BOILS PEPPER-7)
          (EATS TOMATO TOFU)
          (EATS PISTACHIO HAM)
          (HARMONY ACHIEVEMENT-24 VENUS)
          (EATS PORK WONDERBREAD)
          (EATS SCALLION PORK)
          (EATS MELON PAPAYA)
          (CRAVES LONELINESS-50 SHRIMP)
          (LOCALE TOMATO-12 PENNSYLVANIA)
          (HARMONY ENTERTAINMENT-26 MERCURY)
          (CRAVES ANGINA-56 COD)
          (EATS HAMBURGER APPLE)
          (LOCALE APPLE GUANABARA)
          (CRAVES LONELINESS-115 SNICKERS)
          (LOCALE WURST GOIAS)
          (HARMONY SATISFACTION-23 VENUS)
          (CRAVES JEALOUSY POPOVER-3)
          (EATS ARUGULA LOBSTER)
          (EATS CANTELOPE MUFFIN)
          (EATS BAGUETTE FLOUNDER)
          (CRAVES ANGINA-38 MARZIPAN)
          (CRAVES EXCITEMENT-20 KALE)
          (EATS KALE LAMB)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS GUAVA HOTDOG)
          (LOCALE CUCUMBER QUEBEC)
          (LOCALE CHICKEN GUANABARA)
          (CRAVES AESTHETICS PEAR)
          (EATS CHERRY-28 CANTELOPE-30)
          (EATS MUFFIN ENDIVE-1)
          (EATS MUFFIN MUFFIN-6)
          (LOCALE ARUGULA GUANABARA)
          (CRAVES TRIUMPH APPLE)
          (EATS GUAVA-13 TOMATO-12)
          (EATS OKRA CHICKEN)
          (CRAVES JEALOUSY-44 BEEF)
          (LOCALE TUNA-29 OREGON)
          (EATS TOFU ONION)
          (EATS HAM PISTACHIO)
          (HARMONY LOVE-18 MERCURY)
          (CRAVES PROSTATITIS-42 BEEF)
          (EATS CHERRY-28 TUNA-29)
          (EATS CHICKEN TURKEY)
          (LOCALE LOBSTER PENNSYLVANIA)
          (CRAVES LUBRICITY HAMBURGER)
          (EATS YOGURT-11 TOFU-32)
          (EATS HOTDOG GUAVA)
          (EATS COD KALE)
          (LOCALE HAMBURGER-2 GUANABARA)
          (CRAVES DEPRESSION-123 TURKEY)
          (EATS SCALLION-14 BROCCOLI-10)
          (EATS WURST-8 COD-9)
          (CRAVES DREAD-125 BROCCOLI)
          (LOCALE HAM PENNSYLVANIA)
          (EATS GRAPEFRUIT OKRA)
          (CRAVES SCIATICA-33 TOMATO)
          (EATS BAGUETTE OKRA)
          (EATS ONION LOBSTER)
          (EATS PEPPER-7 PISTACHIO)
          (LOCALE TURKEY GUANABARA)
          (CRAVES LACERATION-52 SHRIMP)
          (LOCALE BACON-31 KENTUCKY)
          (HARMONY LEARNING-19 NEPTUNE)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (EATS MARZIPAN CHOCOLATE)
          (EATS MARZIPAN-16 COD-9)
          (EATS WONDERBREAD SWEETROLL)
          (EATS GRAPEFRUIT PORK)
          (EATS LEMON CUCUMBER)
          (LOCALE KALE KENTUCKY)
          (CRAVES LEARNING-19 CHOCOLATE)
          (ORBITS VENUS MERCURY)
          (LOCALE LEMON QUEBEC)
          (EATS ENDIVE MUTTON)
          (CRAVES UNDERSTANDING-61 RICE)
          (LOCALE PORK GOIAS)
          (EATS LETTUCE ONION)
          (CRAVES BOILS-49 LETTUCE)
          (EATS LAMB SCALLOP)
          (EATS GUAVA-13 YOGURT-11)
          (CRAVES JEALOUSY-46 LETTUCE)
          (EATS LETTUCE CHOCOLATE)
          (EATS LEMON SNICKERS)
          (CRAVES STIMULATION BACON-31)
          (EATS BROCCOLI PEA)
          (CRAVES ANGER CANTELOPE-30)
          (EATS MUFFIN PISTACHIO)
          (EATS HOTDOG TURKEY-4)
          (LOCALE MUTTON KENTUCKY)
          (EATS LOBSTER ONION)
          (EATS APPLE HAMBURGER)
          (EATS CHOCOLATE LETTUCE)
          (EATS ORANGE SWEETROLL)
          (EATS PEPPER-7 RICE)
          (EATS CHERRY MELON)
          (HARMONY EXPECTATION MERCURY)
          (HARMONY REST VENUS)
          (LOCALE ORANGE BOSNIA)
          (HARMONY UNDERSTANDING MERCURY)
          (CRAVES BOILS-118 PORK)
          (EATS MELON PORK-5)
          (LOCALE OKRA OREGON)
          (EATS WURST HAROSET)
          (EATS BACON COD)
          (CRAVES JEALOUSY-114 SNICKERS)
          (LOCALE TOMATO KENTUCKY)
          (LOCALE PORK-5 GOIAS)
          (LOCALE LAMB KENTUCKY)
          (LOCALE FLOUNDER GUANABARA)
          (EATS BROCCOLI-10 TOFU-32)
          (HARMONY STIMULATION-64 MERCURY)
          (LOCALE GUAVA-13 OREGON)
          (CRAVES ANXIETY-51 SHRIMP)
          (EATS POTATO SCALLION)
          (LOCALE PEA PENNSYLVANIA)
          (HARMONY LEARNING VENUS)
          (EATS ORANGE POTATO)
          (EATS COD-9 MARZIPAN-16)
          (EATS OKRA ENDIVE)
          (CRAVES GRIEF YOGURT-11)
          (CRAVES INTOXICATION-17 MELON)
          (LOCALE MUFFIN OREGON)
          (EATS TUNA-29 CHERRY-28)
          (EATS LOBSTER ARUGULA)
          (EATS TURKEY CHICKEN)
          (CRAVES REST ENDIVE-1)
          (EATS LOBSTER-15 MARZIPAN-16)
          (LOCALE POTATO GOIAS)
          (EATS BROCCOLI-10 TOMATO-12)
          (HARMONY INTOXICATION NEPTUNE)
          (EATS TURKEY-4 PISTACHIO)
          (EATS COD BACON)
          (ATTACKS GUANABARA OREGON)
          (EATS SHRIMP MUTTON)
          (EATS COD-9 YOGURT-11)
          (EATS HAM LOBSTER)
          (LOCALE BEEF PENNSYLVANIA)
          (CRAVES ACHIEVEMENT-24 BROCCOLI)
          (EATS PEAR POPOVER)
          (CRAVES ANGINA-113 LEMON)
          (EATS WONDERBREAD PORK)
          (EATS TOMATO-12 GUAVA-13)
          (EATS BACON-31 CANTELOPE-30)
          (CRAVES LOVE-18 ENDIVE)
          (EATS ONION TOFU)
          (ORBITS MERCURY NEPTUNE)
          (EATS HAROSET WURST)
          (HARMONY EMPATHY NEPTUNE)
          (EATS CHERRY FLOUNDER)
          (HARMONY EMPATHY-63 NEPTUNE)
          (LOCALE YOGURT BOSNIA)
          (EATS BACON-31 CHERRY-28)
          (EATS POPOVER PAPAYA)
          (EATS CUCUMBER BACON)
          (CRAVES SATISFACTION-23 LAMB)
          (LOCALE BROCCOLI PENNSYLVANIA)
          (EATS PAPAYA POPOVER)
          (ATTACKS OREGON KENTUCKY)
          (LOCALE TURKEY-4 GOIAS))
   (:GOAL (AND (CRAVES HANGOVER-59 SCALLION-14)
               (CRAVES SCIATICA-58 SCALLION-14))))

(DEFINE (PROBLEM MYSTY-27)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS FLOUNDER-2 BROCCOLI TOMATO MELON MARZIPAN
             PORK SWEETROLL GRAPEFRUIT TURKEY KALE HAMBURGER
             FLOUNDER OKRA HAROSET BAGUETTE CHOCOLATE PISTACHIO
             ORANGE COD POTATO BEEF ENDIVE PEA SCALLOP
             WONDERBREAD TOFU ONION LEMON PAPAYA SCALLION GUAVA PEAR
             WURST HAM CHICKEN LETTUCE YOGURT BACON CANTELOPE
             PEPPER LAMB CUCUMBER LOBSTER ARUGULA MUTTON RICE
             SHRIMP MUFFIN HOTDOG CHERRY POPOVER TUNA SNICKERS
             APPLE - FOOD
             LEARNING TRIUMPH EXCITEMENT REST CURIOSITY
             EXPECTATION ACHIEVEMENT LOVE ENTERTAINMENT SATIETY
             STIMULATION INTOXICATION UNDERSTANDING EMPATHY
             AESTHETICS SATISFACTION LUBRICITY SATIETY-1 LOVE-4
             EXCITEMENT-3 INTOXICATION-8 EMPATHY-7 UNDERSTANDING-6
             CURIOSITY-5 TRIUMPH-16 REST-15 LEARNING-14
             SATISFACTION-13 AESTHETICS-12 ENTERTAINMENT-11
             ACHIEVEMENT-10 EXPECTATION-9 STIMULATION-32
             LUBRICITY-31 EXPECTATION-30 INTOXICATION-29
             - PLEASURE
             HANGOVER GRIEF ANGER DEPRESSION PROSTATITIS BOILS
             JEALOUSY SCIATICA ANGINA LONELINESS ANXIETY
             LACERATION ABRASION DREAD JEALOUSY-27 ANGER-28
             ANXIETY-25 ANGINA-26 LACERATION-23 HANGOVER-24
             SCIATICA-21 BOILS-22 DEPRESSION-20 LONELINESS-19
             ABRASION-17 DREAD-18 PROSTATITIS-63 GRIEF-64
             ANGINA-62 GRIEF-61 DEPRESSION-60 ABRASION-59
             SCIATICA-57 ANXIETY-58 PROSTATITIS-56 LONELINESS-55
             DREAD-53 ANGER-54 LACERATION-51 HANGOVER-52
             JEALOUSY-50 ABRASION-48 BOILS-49 LONELINESS-46
             JEALOUSY-47 PROSTATITIS-45 BOILS-44 DREAD-43 - PAIN
             BAVARIA MORAVIA KENTUCKY MANITOBA - PROVINCE
             EARTH VENUS VULCAN JUPITER - PLANET)
   (:INIT (EATS CHOCOLATE PAPAYA)
          (LOCALE YOGURT BAVARIA)
          (CRAVES JEALOUSY TURKEY)
          (EATS PAPAYA CHOCOLATE)
          (LOCALE SNICKERS KENTUCKY)
          (EATS HAM BACON)
          (EATS CANTELOPE HAM)
          (EATS RICE SNICKERS)
          (EATS HAM CANTELOPE)
          (LOCALE KALE MANITOBA)
          (CRAVES GRIEF BROCCOLI)
          (LOCALE BROCCOLI BAVARIA)
          (CRAVES ABRASION-17 TOFU)
          (CRAVES ACHIEVEMENT-10 RICE)
          (EATS TOFU SCALLION)
          (HARMONY LEARNING JUPITER)
          (CRAVES LACERATION-23 BEEF)
          (EATS PEA CANTELOPE)
          (EATS MUFFIN CUCUMBER)
          (EATS SCALLION TOFU)
          (HARMONY LOVE-4 JUPITER)
          (EATS LOBSTER APPLE)
          (LOCALE PISTACHIO BAVARIA)
          (EATS HOTDOG SHRIMP)
          (EATS TURKEY TOMATO)
          (EATS YOGURT MUTTON)
          (EATS BACON HAM)
          (EATS TUNA SNICKERS)
          (EATS CHICKEN ORANGE)
          (CRAVES DEPRESSION TOMATO)
          (CRAVES STIMULATION ORANGE)
          (HARMONY EXPECTATION-30 JUPITER)
          (LOCALE PEPPER BAVARIA)
          (EATS WURST BACON)
          (HARMONY SATISFACTION VULCAN)
          (EATS HAROSET LETTUCE)
          (CRAVES ABRASION-48 MUFFIN)
          (CRAVES CURIOSITY-5 LETTUCE)
          (CRAVES ENTERTAINMENT CHOCOLATE)
          (CRAVES PROSTATITIS-45 CHERRY)
          (ORBITS VULCAN JUPITER)
          (CRAVES UNDERSTANDING BEEF)
          (HARMONY TRIUMPH-16 VULCAN)
          (EATS MUTTON SHRIMP)
          (CRAVES ANXIETY-58 LAMB)
          (CRAVES ABRASION HAROSET)
          (EATS CHICKEN HAMBURGER)
          (CRAVES INTOXICATION-8 GUAVA)
          (CRAVES SCIATICA TURKEY)
          (CRAVES TRIUMPH MELON)
          (EATS YOGURT POTATO)
          (EATS COD BACON)
          (EATS PEAR LEMON)
          (LOCALE LOBSTER BAVARIA)
          (EATS TUNA MUFFIN)
          (EATS LAMB LOBSTER)
          (LOCALE CANTELOPE BAVARIA)
          (CRAVES PROSTATITIS MELON)
          (EATS MUTTON MUFFIN)
          (HARMONY LUBRICITY JUPITER)
          (EATS SCALLOP WURST)
          (HARMONY INTOXICATION-29 VENUS)
          (LOCALE WONDERBREAD MANITOBA)
          (LOCALE TUNA BAVARIA)
          (CRAVES EXCITEMENT-3 SCALLION)
          (LOCALE COD BAVARIA)
          (EATS SWEETROLL FLOUNDER-2)
          (CRAVES JEALOUSY-50 SHRIMP)
          (EATS YOGURT WONDERBREAD)
          (EATS HAMBURGER GUAVA)
          (CRAVES HANGOVER-24 BEEF)
          (EATS MELON SWEETROLL)
          (EATS TURKEY PORK)
          (LOCALE CHOCOLATE BAVARIA)
          (CRAVES SCIATICA-57 LAMB)
          (EATS CHOCOLATE ORANGE)
          (EATS TUNA RICE)
          (EATS CHERRY ARUGULA)
          (LOCALE SCALLOP BAVARIA)
          (EATS YOGURT PISTACHIO)
          (CRAVES ANGINA HAMBURGER)
          (CRAVES REST-15 CANTELOPE)
          (LOCALE TOMATO BAVARIA)
          (EATS ONION PEPPER)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS MUFFIN TUNA)
          (CRAVES LONELINESS-46 HOTDOG)
          (EATS TOFU CHICKEN)
          (HARMONY CURIOSITY VENUS)
          (EATS POPOVER SHRIMP)
          (EATS PISTACHIO CHICKEN)
          (LOCALE TOFU BAVARIA)
          (EATS HOTDOG LOBSTER)
          (LOCALE MARZIPAN BAVARIA)
          (EATS PAPAYA FLOUNDER)
          (EATS PORK FLOUNDER-2)
          (ORBITS VENUS VULCAN)
          (EATS FLOUNDER BEEF)
          (CRAVES LEARNING BROCCOLI)
          (EATS FLOUNDER-2 PORK)
          (EATS POPOVER APPLE)
          (LOCALE POTATO BAVARIA)
          (HARMONY REST VULCAN)
          (CRAVES AESTHETICS WONDERBREAD)
          (CRAVES GRIEF-64 LEMON)
          (EATS SNICKERS RICE)
          (HARMONY EXPECTATION JUPITER)
          (HARMONY LEARNING-14 JUPITER)
          (EATS RICE MUFFIN)
          (EATS ONION SCALLION)
          (EATS TOMATO TURKEY)
          (EATS GUAVA YOGURT)
          (CRAVES LOVE BAGUETTE)
          (HARMONY EXCITEMENT-3 VULCAN)
          (CRAVES TRIUMPH-16 BACON)
          (CRAVES ANGINA-62 GUAVA)
          (LOCALE MELON BAVARIA)
          (EATS KALE BROCCOLI)
          (CRAVES SCIATICA-21 ENDIVE)
          (HARMONY EXCITEMENT JUPITER)
          (EATS ONION LEMON)
          (LOCALE MUFFIN BAVARIA)
          (CRAVES JEALOUSY-47 HOTDOG)
          (LOCALE ENDIVE KENTUCKY)
          (CRAVES HANGOVER-52 MUTTON)
          (EATS CANTELOPE SCALLION)
          (EATS OKRA SCALLOP)
          (EATS PEPPER ONION)
          (EATS WONDERBREAD YOGURT)
          (LOCALE GRAPEFRUIT MORAVIA)
          (EATS MARZIPAN TOMATO)
          (EATS KALE GUAVA)
          (CRAVES ENTERTAINMENT-11 LOBSTER)
          (EATS MARZIPAN PORK)
          (EATS LETTUCE PEPPER)
          (EATS HOTDOG CUCUMBER)
          (CRAVES CURIOSITY TURKEY)
          (EATS COD OKRA)
          (HARMONY AESTHETICS-12 VULCAN)
          (CRAVES EMPATHY SCALLOP)
          (EATS MUTTON YOGURT)
          (EATS BEEF FLOUNDER)
          (LOCALE BAGUETTE BAVARIA)
          (LOCALE CHICKEN MANITOBA)
          (CRAVES EMPATHY-7 PEAR)
          (CRAVES HANGOVER BROCCOLI)
          (CRAVES LOVE-4 PAPAYA)
          (EATS ARUGULA MUFFIN)
          (EATS PISTACHIO YOGURT)
          (EATS BAGUETTE SCALLION)
          (CRAVES ANGER-54 ARUGULA)
          (HARMONY INTOXICATION VULCAN)
          (EATS MUFFIN MUTTON)
          (EATS PEAR ENDIVE)
          (EATS OKRA BAGUETTE)
          (EATS LEMON PEAR)
          (HARMONY UNDERSTANDING VULCAN)
          (EATS SWEETROLL KALE)
          (LOCALE SCALLION BAVARIA)
          (CRAVES PROSTATITIS-63 LEMON)
          (HARMONY REST-15 VULCAN)
          (EATS SHRIMP MUTTON)
          (LOCALE APPLE BAVARIA)
          (EATS BROCCOLI PORK)
          (EATS ORANGE CHICKEN)
          (HARMONY EMPATHY VENUS)
          (LOCALE LEMON MANITOBA)
          (EATS ORANGE BEEF)
          (EATS BACON WURST)
          (EATS PEA ONION)
          (CRAVES ANXIETY FLOUNDER)
          (EATS GRAPEFRUIT TOMATO)
          (HARMONY ENTERTAINMENT-11 VENUS)
          (EATS CUCUMBER HOTDOG)
          (LOCALE CHERRY BAVARIA)
          (CRAVES BOILS-49 MUFFIN)
          (LOCALE HOTDOG BAVARIA)
          (LOCALE ARUGULA BAVARIA)
          (EATS BACON COD)
          (EATS SHRIMP HOTDOG)
          (EATS BAGUETTE BACON)
          (EATS APPLE SHRIMP)
          (CRAVES JEALOUSY-27 PISTACHIO)
          (HARMONY SATIETY-1 JUPITER)
          (EATS SCALLION CANTELOPE)
          (EATS SCALLION ONION)
          (CRAVES BOILS-44 POPOVER)
          (CRAVES LONELINESS-55 LOBSTER)
          (EATS LEMON ONION)
          (EATS GRAPEFRUIT MELON)
          (LOCALE ORANGE BAVARIA)
          (EATS TURKEY GRAPEFRUIT)
          (LOCALE PEAR MORAVIA)
          (LOCALE MUTTON BAVARIA)
          (LOCALE HAM BAVARIA)
          (CRAVES AESTHETICS-12 CUCUMBER)
          (EATS SCALLOP OKRA)
          (EATS CHICKEN TOFU)
          (CRAVES DREAD-43 TUNA)
          (CRAVES SATISFACTION TOFU)
          (EATS CHICKEN PISTACHIO)
          (CRAVES REST GRAPEFRUIT)
          (CRAVES SATISFACTION-13 LAMB)
          (LOCALE TURKEY BAVARIA)
          (EATS LETTUCE WONDERBREAD)
          (CRAVES LUBRICITY-31 POPOVER)
          (EATS LOBSTER LAMB)
          (EATS TURKEY KALE)
          (LOCALE FLOUNDER-2 KENTUCKY)
          (EATS HOTDOG CHERRY)
          (LOCALE BEEF MORAVIA)
          (LOCALE PAPAYA KENTUCKY)
          (EATS WURST GUAVA)
          (CRAVES ANGINA-26 POTATO)
          (HARMONY ACHIEVEMENT JUPITER)
          (CRAVES UNDERSTANDING-6 HAM)
          (HARMONY EMPATHY-7 VENUS)
          (EATS CHICKEN SCALLOP)
          (EATS ONION PEA)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES INTOXICATION COD)
          (EATS KALE TURKEY)
          (CRAVES LONELINESS FLOUNDER)
          (EATS PORK TURKEY)
          (EATS SHRIMP POPOVER)
          (HARMONY UNDERSTANDING-6 VULCAN)
          (EATS TOMATO GRAPEFRUIT)
          (CRAVES LUBRICITY ONION)
          (CRAVES DEPRESSION-20 PEA)
          (EATS APPLE POPOVER)
          (LOCALE ONION BAVARIA)
          (EATS ORANGE CHOCOLATE)
          (LOCALE CUCUMBER BAVARIA)
          (EATS BROCCOLI KALE)
          (EATS APPLE LOBSTER)
          (LOCALE OKRA MORAVIA)
          (CRAVES EXPECTATION-9 HOTDOG)
          (LOCALE FLOUNDER BAVARIA)
          (EATS TOMATO MARZIPAN)
          (CRAVES BOILS GRAPEFRUIT)
          (CRAVES LEARNING-14 PEPPER)
          (CRAVES GRIEF-61 CHICKEN)
          (EATS SWEETROLL MELON)
          (CRAVES ANGER TOMATO)
          (EATS LOBSTER HOTDOG)
          (CRAVES SATIETY PISTACHIO)
          (EATS SHRIMP APPLE)
          (EATS PORK MARZIPAN)
          (LOCALE WURST BAVARIA)
          (LOCALE GUAVA BAVARIA)
          (CRAVES ANXIETY-25 POTATO)
          (EATS SHRIMP LAMB)
          (CRAVES ACHIEVEMENT FLOUNDER)
          (EATS ORANGE YOGURT)
          (CRAVES DREAD-53 ARUGULA)
          (EATS BAGUETTE OKRA)
          (HARMONY AESTHETICS JUPITER)
          (EATS YOGURT ORANGE)
          (LOCALE BACON MORAVIA)
          (EATS POTATO ENDIVE)
          (LOCALE LETTUCE BAVARIA)
          (LOCALE RICE BAVARIA)
          (EATS GUAVA KALE)
          (EATS CANTELOPE PEA)
          (EATS WURST SCALLOP)
          (EATS WONDERBREAD LETTUCE)
          (CRAVES DREAD CHOCOLATE)
          (EATS BEEF ORANGE)
          (EATS PEPPER LETTUCE)
          (EATS LAMB SHRIMP)
          (EATS CUCUMBER MUFFIN)
          (HARMONY LOVE VENUS)
          (CRAVES STIMULATION-32 CHERRY)
          (EATS LETTUCE HAROSET)
          (EATS PORK BROCCOLI)
          (EATS HAROSET PEAR)
          (CRAVES SATIETY-1 LEMON)
          (LOCALE PORK BAVARIA)
          (HARMONY CURIOSITY-5 VULCAN)
          (EATS FLOUNDER-2 SWEETROLL)
          (LOCALE SHRIMP BAVARIA)
          (EATS POTATO YOGURT)
          (CRAVES EXCITEMENT SWEETROLL)
          (EATS MUFFIN ARUGULA)
          (HARMONY SATISFACTION-13 VULCAN)
          (EATS CHERRY HOTDOG)
          (EATS ENDIVE POTATO)
          (HARMONY STIMULATION VENUS)
          (ATTACKS KENTUCKY MANITOBA)
          (HARMONY ENTERTAINMENT VENUS)
          (EATS SCALLOP CHICKEN)
          (EATS HAMBURGER CHICKEN)
          (CRAVES LONELINESS-19 SCALLOP)
          (ATTACKS MORAVIA KENTUCKY)
          (CRAVES LACERATION OKRA)
          (CRAVES DEPRESSION-60 YOGURT)
          (CRAVES EXPECTATION-30 TUNA)
          (HARMONY LUBRICITY-31 VENUS)
          (EATS SNICKERS TUNA)
          (HARMONY STIMULATION-32 VENUS)
          (EATS KALE SWEETROLL)
          (LOCALE PEA BAVARIA)
          (EATS ARUGULA CHERRY)
          (EATS MUFFIN RICE)
          (EATS RICE TUNA)
          (EATS PAPAYA LEMON)
          (EATS FLOUNDER PAPAYA)
          (EATS CHERRY SNICKERS)
          (LOCALE HAROSET BAVARIA)
          (CRAVES DREAD-18 TOFU)
          (HARMONY ACHIEVEMENT-10 VULCAN)
          (EATS MELON GRAPEFRUIT)
          (HARMONY EXPECTATION-9 VULCAN)
          (CRAVES LACERATION-51 MUTTON)
          (EATS ENDIVE PEAR)
          (EATS GRAPEFRUIT TURKEY)
          (ORBITS EARTH VENUS)
          (EATS PEAR HAROSET)
          (HARMONY TRIUMPH VULCAN)
          (EATS GUAVA WURST)
          (EATS SCALLION BAGUETTE)
          (EATS CHICKEN BEEF)
          (EATS BEEF CHICKEN)
          (LOCALE HAMBURGER BAVARIA)
          (CRAVES ABRASION-59 CANTELOPE)
          (CRAVES INTOXICATION-29 APPLE)
          (CRAVES ANGER-28 PISTACHIO)
          (EATS GUAVA HAMBURGER)
          (EATS OKRA COD)
          (LOCALE LAMB MANITOBA)
          (CRAVES BOILS-22 ENDIVE)
          (EATS SNICKERS CHERRY)
          (EATS LEMON PAPAYA)
          (HARMONY INTOXICATION-8 VULCAN)
          (EATS YOGURT GUAVA)
          (HARMONY SATIETY JUPITER)
          (LOCALE POPOVER MANITOBA)
          (CRAVES EXPECTATION KALE)
          (EATS BACON BAGUETTE)
          (CRAVES PROSTATITIS-56 CUCUMBER))
   (:GOAL (AND (CRAVES JEALOUSY-47 BACON)
               (CRAVES ANGINA-26 YOGURT))))

(DEFINE (PROBLEM MYSTY-28)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS BACON-19 GUAVA-20 PEPPER-21 ORANGE-22
             GRAPEFRUIT-23 SCALLION-24 PAPAYA-25 CHOCOLATE-26
             BROCCOLI-27 CUCUMBER-28 YOGURT-29 APPLE-30 HAM-31
             KALE-32 MUFFIN-9 CANTELOPE-10 MUTTON-11 WURST-12
             PORK-16 LEMON-15 SHRIMP-14 WONDERBREAD-13
             HAMBURGER-5 TOMATO-6 SCALLOP-7 LAMB-8 HAROSET-3
             HOTDOG-4 FLOUNDER-1 POTATO-2 CHERRY APPLE SWEETROLL
             LETTUCE LOBSTER SCALLION PISTACHIO OKRA HAMBURGER
             CHICKEN POPOVER CUCUMBER GRAPEFRUIT MELON TOFU
             LEMON PEA BEEF BROCCOLI SHRIMP SCALLOP HOTDOG
             ARUGULA HAROSET LAMB KALE HAM PAPAYA ENDIVE RICE
             WONDERBREAD MUTTON TUNA SNICKERS GUAVA CANTELOPE POTATO
             PORK BACON FLOUNDER YOGURT MARZIPAN ORANGE ONION
             BAGUETTE PEPPER TURKEY CHOCOLATE COD PEAR MUFFIN
             TOMATO WURST - FOOD
             CURIOSITY EXPECTATION SATIETY INTOXICATION
             EXCITEMENT LEARNING REST LOVE STIMULATION AESTHETICS
             SATISFACTION TRIUMPH UNDERSTANDING EMPATHY ACHIEVEMENT
             LUBRICITY ENTERTAINMENT UNDERSTANDING-18
             SATIETY-17 EMPATHY-64 CURIOSITY-63 TRIUMPH-62
             INTOXICATION-61 LOVE-60 LEARNING-59 EXCITEMENT-58 REST-57
             STIMULATION-56 ACHIEVEMENT-55 ENTERTAINMENT-54
             LUBRICITY-53 AESTHETICS-52 EXPECTATION-51 - PLEASURE
             GRIEF LACERATION PROSTATITIS DEPRESSION
             LONELINESS HANGOVER ABRASION DREAD SCIATICA BOILS
             ANGINA ANXIETY DEPRESSION-50 JEALOUSY ANGER
             JEALOUSY-49 BOILS-48 ANXIETY-44 HANGOVER-45
             LACERATION-46 ANGINA-47 SCIATICA-42 ANGER-43 DREAD-39
             ABRASION-40 LONELINESS-41 PROSTATITIS-38 DREAD-35
             SCIATICA-36 GRIEF-37 GRIEF-34 LONELINESS-126
             HANGOVER-127 PROSTATITIS-128 JEALOUSY-33 BOILS-123
             DEPRESSION-124 ABRASION-125 LACERATION-119 ANGER-120
             ANGINA-121 ANXIETY-122 SCIATICA-118 ANXIETY-114
             BOILS-115 LACERATION-116 ABRASION-117 GRIEF-113
             DEPRESSION-109 HANGOVER-110 PROSTATITIS-111
             JEALOUSY-112 ANGINA-105 DREAD-106 ANGER-107
             LONELINESS-108 HANGOVER-101 SCIATICA-102 DREAD-103
             PROSTATITIS-104 ABRASION-98 GRIEF-99 BOILS-100 ANGINA-94
             ANXIETY-95 LONELINESS-96 DEPRESSION-97
             LACERATION-93 ANGER-92 JEALOUSY-91 ANGINA-87
             SCIATICA-88 ANGER-89 GRIEF-90 BOILS-83 LACERATION-84
             LONELINESS-85 HANGOVER-86 ABRASION-81 ANXIETY-82
             DREAD-79 DEPRESSION-80 JEALOUSY-78 BOILS-75
             HANGOVER-76 PROSTATITIS-77 ABRASION-73 DREAD-74
             SCIATICA-71 LONELINESS-72 GRIEF-70 ANGINA-69
             PROSTATITIS-67 JEALOUSY-68 ANGER-256 ANXIETY-65
             DEPRESSION-66 JEALOUSY-253 LACERATION-254
             LACERATION-255 ANXIETY-250 GRIEF-251 HANGOVER-252
             ANGER-249 PROSTATITIS-247 SCIATICA-248
             LONELINESS-244 ANGINA-245 DEPRESSION-246 DREAD-243
             BOILS-241 ABRASION-242 PROSTATITIS-238
             DEPRESSION-239 GRIEF-240 JEALOUSY-236 ABRASION-237
             LACERATION-235 ANXIETY-234 BOILS-233 ANGINA-231
             HANGOVER-232 LONELINESS-227 SCIATICA-228 ANGER-229
             DREAD-230 GRIEF-225 ANXIETY-226 DEPRESSION-224
             HANGOVER-223 LONELINESS-222 DREAD-221 ANGINA-219
             ANGER-220 BOILS-216 LACERATION-217 JEALOUSY-218
             SCIATICA-214 ABRASION-215 LACERATION-212
             PROSTATITIS-213 ABRASION-208 PROSTATITIS-209 GRIEF-210
             HANGOVER-211 DREAD-204 SCIATICA-205 LONELINESS-206
             DEPRESSION-207 ANXIETY-203 BOILS-201 JEALOUSY-202
             PROSTATITIS-197 DEPRESSION-198 ANGINA-199 ANGER-200
             ABRASION-194 LONELINESS-195 HANGOVER-196 ANXIETY-192
             GRIEF-193 DREAD-191 LACERATION-189 ANGER-190
             SCIATICA-188 ANGINA-185 BOILS-186 JEALOUSY-187
             DEPRESSION-182 PROSTATITIS-183 ANXIETY-184 HANGOVER-180
             ANGINA-181 GRIEF-178 ANGER-179 SCIATICA-176
             BOILS-177 LONELINESS-173 JEALOUSY-174 DREAD-175
             ANGINA-169 ANGER-170 LACERATION-171 ABRASION-172
             SCIATICA-167 ABRASION-168 HANGOVER-163
             PROSTATITIS-164 GRIEF-165 LONELINESS-166 BOILS-162
             - PAIN
             BAVARIA OREGON - PROVINCE
             JUPITER NEPTUNE EARTH MARS - PLANET)
   (:INIT (CRAVES ANGER-43 CUCUMBER-28)
          (CRAVES DEPRESSION-97 SCALLOP-7)
          (LOCALE CHOCOLATE-26 BAVARIA)
          (EATS COD YOGURT)
          (HARMONY SATIETY-17 EARTH)
          (EATS CHOCOLATE ENDIVE)
          (EATS PEAR LOBSTER)
          (CRAVES LONELINESS-173 COD)
          (CRAVES JEALOUSY-218 WONDERBREAD)
          (LOCALE BROCCOLI BAVARIA)
          (HARMONY INTOXICATION-61 EARTH)
          (CRAVES LACERATION-119 MUTTON-11)
          (EATS GUAVA PEA)
          (EATS YOGURT SNICKERS)
          (CRAVES LACERATION-255 POPOVER)
          (LOCALE WURST BAVARIA)
          (CRAVES BOILS-123 CANTELOPE-10)
          (CRAVES JEALOUSY-68 HAMBURGER)
          (CRAVES HANGOVER-223 HAM)
          (LOCALE POTATO-2 BAVARIA)
          (CRAVES LACERATION-116 PORK-16)
          (CRAVES ABRASION-172 PEAR)
          (EATS WONDERBREAD LETTUCE)
          (CRAVES ANXIETY-192 FLOUNDER)
          (EATS FLOUNDER ONION)
          (EATS BROCCOLI CHERRY)
          (LOCALE ORANGE-22 OREGON)
          (CRAVES ANGINA-94 SCALLOP-7)
          (EATS MUFFIN-9 GUAVA-20)
          (EATS MUTTON HOTDOG)
          (EATS HAMBURGER-5 BAGUETTE)
          (CRAVES BOILS-201 POTATO)
          (LOCALE ENDIVE OREGON)
          (EATS MELON SCALLOP-7)
          (EATS MUTTON POTATO)
          (EATS MUTTON-11 ORANGE-22)
          (CRAVES GRIEF-240 BEEF)
          (LOCALE LEMON BAVARIA)
          (EATS MARZIPAN PORK)
          (CRAVES DREAD-79 APPLE)
          (CRAVES ANGER-249 GRAPEFRUIT)
          (EATS TOMATO PEPPER)
          (EATS POTATO-2 POTATO)
          (EATS CANTELOPE-10 KALE-32)
          (CRAVES ANGER-200 PORK)
          (LOCALE SWEETROLL BAVARIA)
          (CRAVES LACERATION-46 BROCCOLI-27)
          (HARMONY ENTERTAINMENT-54 EARTH)
          (CRAVES PROSTATITIS-77 LETTUCE)
          (CRAVES ANGINA-169 PEAR)
          (LOCALE OKRA OREGON)
          (EATS SCALLOP BEEF)
          (EATS WURST-12 LEMON-15)
          (EATS TURKEY PISTACHIO)
          (EATS BACON TURKEY)
          (EATS MELON GUAVA)
          (CRAVES LEARNING MUFFIN-9)
          (EATS CUCUMBER BAGUETTE)
          (LOCALE TUNA BAVARIA)
          (CRAVES JEALOUSY-202 POTATO)
          (CRAVES ABRASION-81 CHERRY)
          (CRAVES DEPRESSION-124 CANTELOPE-10)
          (EATS LETTUCE WONDERBREAD)
          (EATS WONDERBREAD-13 APPLE-30)
          (EATS ONION GUAVA)
          (CRAVES ABRASION-215 MUTTON)
          (EATS FLOUNDER TUNA)
          (CRAVES BOILS-233 HOTDOG)
          (EATS SCALLOP-7 MELON)
          (LOCALE LAMB BAVARIA)
          (EATS CANTELOPE COD)
          (HARMONY EXCITEMENT NEPTUNE)
          (CRAVES GRIEF-99 TOMATO-6)
          (CRAVES ANGER-190 MARZIPAN)
          (EATS TOMATO-6 ORANGE)
          (CRAVES ANGER-107 WONDERBREAD-13)
          (EATS ENDIVE SCALLION)
          (EATS KALE HAM)
          (EATS LEMON PEA)
          (CRAVES ANGER-229 HAROSET)
          (CRAVES LONELINESS GUAVA-20)
          (CRAVES HANGOVER-196 BACON)
          (CRAVES ABRASION-237 BROCCOLI)
          (CRAVES PROSTATITIS-67 HAMBURGER)
          (EATS BROCCOLI-27 MUFFIN-9)
          (CRAVES INTOXICATION-61 ENDIVE)
          (CRAVES LONELINESS-227 HAROSET)
          (EATS HAMBURGER-5 POTATO)
          (CRAVES GRIEF-90 FLOUNDER-1)
          (CRAVES BOILS-83 POTATO-2)
          (EATS SCALLION SHRIMP)
          (CRAVES ANGINA-87 FLOUNDER-1)
          (EATS TUNA ORANGE)
          (LOCALE ARUGULA BAVARIA)
          (CRAVES BOILS-75 LETTUCE)
          (EATS MUTTON-11 BACON-19)
          (EATS LEMON-15 WURST-12)
          (CRAVES ABRASION-208 SNICKERS)
          (LOCALE GUAVA BAVARIA)
          (LOCALE PEAR BAVARIA)
          (EATS HAM MUTTON)
          (EATS CHICKEN PORK)
          (CRAVES DREAD-230 HAROSET)
          (EATS SWEETROLL SNICKERS)
          (CRAVES JEALOUSY-33 MUFFIN-9)
          (LOCALE MUTTON OREGON)
          (CRAVES GRIEF-193 FLOUNDER)
          (LOCALE LEMON-15 BAVARIA)
          (EATS FLOUNDER-1 ONION)
          (EATS GUAVA ONION)
          (EATS SCALLOP ONION)
          (EATS CUCUMBER SHRIMP)
          (EATS SCALLOP MUFFIN)
          (LOCALE SNICKERS OREGON)
          (CRAVES JEALOUSY-49 PAPAYA-25)
          (EATS SHRIMP-14 APPLE-30)
          (CRAVES HANGOVER-101 HAMBURGER-5)
          (CRAVES ABRASION-40 YOGURT-29)
          (EATS POTATO MARZIPAN)
          (EATS WURST SHRIMP)
          (EATS PAPAYA HAMBURGER)
          (CRAVES PROSTATITIS-213 TUNA)
          (EATS APPLE-30 SHRIMP-14)
          (CRAVES SATIETY ORANGE-22)
          (CRAVES UNDERSTANDING-18 PEA)
          (EATS SCALLION CUCUMBER)
          (EATS MUTTON HAM)
          (EATS SNICKERS GUAVA)
          (CRAVES ANGINA-231 ARUGULA)
          (CRAVES PROSTATITIS-104 HAMBURGER-5)
          (CRAVES ABRASION-98 TOMATO-6)
          (CRAVES ANXIETY-82 CHERRY)
          (EATS PORK-16 HAM-31)
          (CRAVES SCIATICA-248 MELON)
          (EATS GUAVA MELON)
          (EATS PEPPER TOMATO)
          (CRAVES ANXIETY-65 CHICKEN)
          (LOCALE PEPPER BAVARIA)
          (EATS YOGURT COD)
          (EATS SCALLION-24 APPLE-30)
          (EATS PEAR WONDERBREAD)
          (CRAVES JEALOUSY-187 ONION)
          (CRAVES ANGER-179 TURKEY)
          (CRAVES LONELINESS-96 SCALLOP-7)
          (CRAVES LONELINESS-85 POTATO-2)
          (CRAVES LACERATION-189 MARZIPAN)
          (CRAVES DREAD-191 YOGURT)
          (EATS LAMB HAROSET-3)
          (EATS PAPAYA PISTACHIO)
          (CRAVES ANGINA-199 PORK)
          (HARMONY EMPATHY-64 NEPTUNE)
          (CRAVES LACERATION-254 POPOVER)
          (EATS WONDERBREAD-13 BROCCOLI-27)
          (CRAVES LACERATION BACON-19)
          (CRAVES GRIEF-70 PISTACHIO)
          (CRAVES ANGINA-185 ONION)
          (EATS BROCCOLI CHOCOLATE)
          (EATS SHRIMP CUCUMBER)
          (EATS CHOCOLATE BROCCOLI)
          (CRAVES ANGINA-121 MUTTON-11)
          (CRAVES EXCITEMENT-58 TUNA)
          (CRAVES DEPRESSION-80 APPLE)
          (EATS HAMBURGER PAPAYA)
          (LOCALE TOFU OREGON)
          (EATS LAMB-8 HAMBURGER)
          (CRAVES PROSTATITIS-164 TOMATO)
          (EATS LEMON-15 YOGURT-29)
          (LOCALE HAMBURGER BAVARIA)
          (EATS OKRA ORANGE)
          (CRAVES ANGER-120 MUTTON-11)
          (HARMONY STIMULATION-56 NEPTUNE)
          (CRAVES DEPRESSION GUAVA-20)
          (CRAVES ACHIEVEMENT CUCUMBER)
          (LOCALE RICE OREGON)
          (EATS SNICKERS MELON)
          (EATS POTATO-2 LETTUCE)
          (CRAVES ANXIETY-114 PORK-16)
          (EATS POTATO HAMBURGER-5)
          (EATS ARUGULA MARZIPAN)
          (CRAVES BOILS-162 WURST)
          (ORBITS EARTH MARS)
          (CRAVES JEALOUSY-112 SHRIMP-14)
          (CRAVES ACHIEVEMENT-55 ONION)
          (HARMONY LEARNING MARS)
          (LOCALE POPOVER BAVARIA)
          (EATS LOBSTER PEAR)
          (CRAVES EMPATHY-64 SCALLOP)
          (EATS MELON SNICKERS)
          (EATS APPLE ORANGE)
          (EATS HAM KALE)
          (CRAVES EXCITEMENT HAM-31)
          (EATS MUFFIN-9 WURST-12)
          (EATS TURKEY LAMB-8)
          (CRAVES ANXIETY-250 CUCUMBER)
          (EATS PAPAYA-25 CANTELOPE-10)
          (CRAVES HANGOVER-110 SHRIMP-14)
          (CRAVES ANXIETY GRAPEFRUIT-23)
          (CRAVES LONELINESS-222 PAPAYA)
          (EATS CANTELOPE-10 GUAVA-20)
          (EATS ORANGE SWEETROLL)
          (EATS SHRIMP WURST)
          (CRAVES ANXIETY-226 LAMB)
          (EATS FLOUNDER TOMATO)
          (CRAVES SATIETY-17 BROCCOLI)
          (EATS APPLE-30 SCALLION-24)
          (EATS CANTELOPE PEPPER)
          (EATS LAMB BACON)
          (CRAVES LACERATION-171 PEAR)
          (EATS CUCUMBER-28 GRAPEFRUIT-23)
          (LOCALE MUTTON-11 BAVARIA)
          (EATS HAROSET-3 LAMB)
          (CRAVES ABRASION-117 PORK-16)
          (LOCALE HOTDOG-4 BAVARIA)
          (CRAVES HANGOVER-163 TOMATO)
          (EATS MUTTON-11 CHOCOLATE-26)
          (CRAVES LONELINESS-206 GUAVA)
          (EATS PORK KALE)
          (EATS MARZIPAN POTATO)
          (CRAVES HANGOVER-76 LETTUCE)
          (CRAVES LONELINESS-126 MUFFIN-9)
          (CRAVES BOILS-241 PEA)
          (CRAVES PROSTATITIS-238 BEEF)
          (EATS HAROSET MUTTON)
          (HARMONY ACHIEVEMENT-55 MARS)
          (LOCALE BEEF BAVARIA)
          (CRAVES GRIEF-37 HAM-31)
          (EATS GRAPEFRUIT-23 WURST-12)
          (EATS TUNA FLOUNDER)
          (HARMONY LUBRICITY NEPTUNE)
          (CRAVES CURIOSITY-63 KALE)
          (EATS WONDERBREAD-13 CANTELOPE-10)
          (LOCALE HOTDOG BAVARIA)
          (CRAVES LONELINESS-108 WONDERBREAD-13)
          (LOCALE POTATO BAVARIA)
          (EATS SNICKERS HAROSET-3)
          (CRAVES ANGINA-47 BROCCOLI-27)
          (EATS SHRIMP-14 YOGURT-29)
          (CRAVES DREAD-221 ENDIVE)
          (EATS SWEETROLL ORANGE)
          (CRAVES GRIEF-225 LAMB)
          (CRAVES UNDERSTANDING APPLE)
          (EATS LETTUCE POTATO-2)
          (CRAVES ANGINA-105 WONDERBREAD-13)
          (LOCALE HAM OREGON)
          (CRAVES GRIEF-165 TOMATO)
          (CRAVES LEARNING-59 MUTTON)
          (CRAVES ABRASION-194 BACON)
          (EATS HOTDOG MUTTON)
          (EATS WONDERBREAD BAGUETTE)
          (EATS CHOCOLATE YOGURT)
          (LOCALE SCALLOP BAVARIA)
          (EATS GUAVA-20 ARUGULA)
          (CRAVES ANXIETY-95 SCALLOP-7)
          (EATS BEEF MUFFIN)
          (LOCALE PAPAYA BAVARIA)
          (CRAVES LONELINESS-195 BACON)
          (EATS WONDERBREAD-13 CHOCOLATE-26)
          (HARMONY EMPATHY NEPTUNE)
          (HARMONY LOVE-60 MARS)
          (EATS SCALLOP HAMBURGER)
          (CRAVES SCIATICA-214 MUTTON)
          (LOCALE ONION BAVARIA)
          (HARMONY REST MARS)
          (EATS LAMB-8 LAMB)
          (CRAVES PROSTATITIS-197 PORK)
          (EATS CANTELOPE TOMATO-6)
          (EATS CUCUMBER SCALLION)
          (EATS MUTTON HAROSET)
          (EATS ORANGE HOTDOG-4)
          (CRAVES DEPRESSION-207 GUAVA)
          (EATS BROCCOLI-27 PAPAYA-25)
          (CRAVES GRIEF-34 KALE-32)
          (CRAVES JEALOUSY-236 BROCCOLI)
          (CRAVES ANGER-256 CHICKEN)
          (EATS WONDERBREAD MARZIPAN)
          (CRAVES LONELINESS-41 YOGURT-29)
          (CRAVES ANGER-89 FLOUNDER-1)
          (CRAVES SCIATICA-228 HAROSET)
          (LOCALE TOMATO BAVARIA)
          (EATS YOGURT CHOCOLATE)
          (HARMONY STIMULATION MARS)
          (EATS CHOCOLATE-26 MUTTON-11)
          (EATS SNICKERS BROCCOLI)
          (EATS KALE-32 SHRIMP-14)
          (EATS CANTELOPE-10 LEMON-15)
          (EATS MARZIPAN ARUGULA)
          (CRAVES JEALOUSY SCALLION-24)
          (LOCALE SCALLION-24 BAVARIA)
          (CRAVES LONELINESS-72 SCALLION)
          (HARMONY ACHIEVEMENT NEPTUNE)
          (EATS GRAPEFRUIT APPLE)
          (CRAVES LACERATION-84 POTATO-2)
          (EATS SCALLION-24 KALE-32)
          (LOCALE LOBSTER BAVARIA)
          (LOCALE PEA BAVARIA)
          (EATS GRAPEFRUIT FLOUNDER)
          (CRAVES DREAD-243 LEMON)
          (LOCALE SCALLION BAVARIA)
          (CRAVES LOVE-60 RICE)
          (EATS BROCCOLI SNICKERS)
          (LOCALE APPLE-30 BAVARIA)
          (EATS ONION FLOUNDER)
          (EATS CANTELOPE-10 PAPAYA-25)
          (EATS COD POPOVER)
          (CRAVES JEALOUSY-91 HOTDOG-4)
          (EATS YOGURT ORANGE)
          (EATS PEA LEMON)
          (EATS MUTTON-11 PORK-16)
          (EATS PEPPER-21 WURST-12)
          (EATS MUFFIN BEEF)
          (EATS HOTDOG-4 COD)
          (CRAVES HANGOVER-45 BROCCOLI-27)
          (CRAVES ABRASION-73 LOBSTER)
          (CRAVES ANXIETY-122 MUTTON-11)
          (EATS HAM-31 MUTTON-11)
          (EATS BACON-19 MUTTON-11)
          (LOCALE GRAPEFRUIT BAVARIA)
          (CRAVES SCIATICA-71 SCALLION)
          (CRAVES PROSTATITIS-38 APPLE-30)
          (EATS PEAR BACON)
          (CRAVES PROSTATITIS-209 SNICKERS)
          (CRAVES ANXIETY-44 BROCCOLI-27)
          (EATS HAM-31 CUCUMBER-28)
          (LOCALE YOGURT BAVARIA)
          (EATS SCALLION POPOVER)
          (HARMONY SATISFACTION NEPTUNE)
          (EATS TUNA TOMATO)
          (HARMONY REST-57 NEPTUNE)
          (LOCALE HAROSET-3 BAVARIA)
          (LOCALE PORK BAVARIA)
          (EATS CHOCOLATE RICE)
          (EATS PISTACHIO PAPAYA)
          (CRAVES GRIEF-210 SNICKERS)
          (LOCALE WONDERBREAD-13 BAVARIA)
          (EATS YOGURT-29 SHRIMP-14)
          (EATS SNICKERS SWEETROLL)
          (EATS BEEF TURKEY)
          (HARMONY LUBRICITY-53 MARS)
          (CRAVES SCIATICA-167 MUFFIN)
          (CRAVES REST-57 POTATO)
          (CRAVES GRIEF BACON-19)
          (CRAVES BOILS-100 TOMATO-6)
          (LOCALE KALE-32 OREGON)
          (EATS POTATO POTATO-2)
          (EATS LOBSTER ARUGULA)
          (CRAVES GRIEF-113 LEMON-15)
          (EATS LAMB-8 TURKEY)
          (HARMONY LOVE EARTH)
          (CRAVES GRIEF-251 CUCUMBER)
          (CRAVES BOILS-186 ONION)
          (EATS BAGUETTE CUCUMBER)
          (EATS ENDIVE CHOCOLATE)
          (LOCALE HAMBURGER-5 BAVARIA)
          (CRAVES PROSTATITIS-111 SHRIMP-14)
          (EATS RICE SNICKERS)
          (CRAVES SCIATICA-36 HAM-31)
          (HARMONY CURIOSITY-63 NEPTUNE)
          (LOCALE CHICKEN BAVARIA)
          (EATS HAM CHERRY)
          (LOCALE CUCUMBER BAVARIA)
          (EATS BEEF SCALLOP)
          (LOCALE SCALLOP-7 BAVARIA)
          (CRAVES PROSTATITIS GUAVA-20)
          (EATS HAMBURGER LAMB-8)
          (CRAVES LOVE PORK-16)
          (HARMONY LEARNING-59 NEPTUNE)
          (CRAVES PROSTATITIS-247 MELON)
          (CRAVES DEPRESSION-239 BEEF)
          (LOCALE LAMB-8 OREGON)
          (LOCALE CANTELOPE-10 BAVARIA)
          (CRAVES HANGOVER GUAVA-20)
          (CRAVES BOILS-216 WONDERBREAD)
          (EATS MELON FLOUNDER-1)
          (CRAVES DEPRESSION-66 CHICKEN)
          (EATS HOTDOG-4 ORANGE)
          (CRAVES DREAD-175 COD)
          (EATS APPLE GRAPEFRUIT)
          (EATS TURKEY BEEF)
          (LOCALE CHOCOLATE BAVARIA)
          (EATS ONION OKRA)
          (EATS RICE CHOCOLATE)
          (EATS APPLE-30 WONDERBREAD-13)
          (CRAVES INTOXICATION SCALLION-24)
          (EATS PEPPER-21 ORANGE-22)
          (EATS TURKEY BACON)
          (CRAVES ANGINA-181 PEPPER)
          (EATS MUFFIN ONION)
          (CRAVES AESTHETICS HAROSET-3)
          (CRAVES ABRASION-125 CANTELOPE-10)
          (EATS ARUGULA GUAVA-20)
          (CRAVES HANGOVER-180 PEPPER)
          (EATS CHOCOLATE MUTTON)
          (EATS KALE-32 CANTELOPE-10)
          (CRAVES GRIEF-178 TURKEY)
          (EATS PEA GUAVA)
          (EATS GUAVA-20 CANTELOPE-10)
          (EATS YOGURT-29 LEMON-15)
          (LOCALE GRAPEFRUIT-23 BAVARIA)
          (EATS ORANGE SCALLOP-7)
          (CRAVES ANXIETY-234 SCALLOP)
          (LOCALE COD BAVARIA)
          (EATS BACON PEAR)
          (CRAVES JEALOUSY-174 COD)
          (EATS HOTDOG ENDIVE)
          (EATS HAROSET HAM)
          (CRAVES ENTERTAINMENT LEMON)
          (EATS BROCCOLI-27 CHOCOLATE-26)
          (CRAVES SATISFACTION HOTDOG-4)
          (CRAVES ANGINA GRAPEFRUIT-23)
          (CRAVES PROSTATITIS-183 BAGUETTE)
          (EATS WURST-12 MUFFIN-9)
          (EATS BAGUETTE HAMBURGER-5)
          (EATS PORK-16 MUTTON-11)
          (HARMONY EXCITEMENT-58 EARTH)
          (CRAVES ANXIETY-184 BAGUETTE)
          (EATS SCALLION ENDIVE)
          (EATS ORANGE YOGURT)
          (CRAVES ENTERTAINMENT-54 BAGUETTE)
          (EATS ORANGE-22 PEPPER-21)
          (EATS SNICKERS YOGURT)
          (CRAVES SCIATICA-188 ORANGE)
          (CRAVES CURIOSITY BACON-19)
          (EATS MUFFIN-9 BROCCOLI-27)
          (CRAVES BOILS-48 CHOCOLATE-26)
          (EATS HAMBURGER SNICKERS)
          (CRAVES DREAD-35 HAM-31)
          (EATS ENDIVE COD)
          (CRAVES LACERATION-217 WONDERBREAD)
          (EATS CHERRY HAM)
          (LOCALE LETTUCE BAVARIA)
          (LOCALE PISTACHIO OREGON)
          (CRAVES ANGER-170 PEAR)
          (CRAVES ANGINA-245 TOFU)
          (EATS GUAVA SNICKERS)
          (EATS ORANGE APPLE)
          (LOCALE YOGURT-29 BAVARIA)
          (ORBITS NEPTUNE EARTH)
          (EATS BROCCOLI-27 WONDERBREAD-13)
          (EATS FLOUNDER GRAPEFRUIT)
          (LOCALE HAROSET BAVARIA)
          (HARMONY UNDERSTANDING-18 NEPTUNE)
          (EATS TOMATO TUNA)
          (CRAVES SCIATICA ORANGE-22)
          (EATS MARZIPAN WONDERBREAD)
          (CRAVES ANGER-92 HAROSET-3)
          (CRAVES LACERATION-212 TUNA)
          (CRAVES BOILS-177 CHOCOLATE)
          (EATS HAROSET TOFU)
          (CRAVES SCIATICA-88 FLOUNDER-1)
          (EATS SNICKERS HAMBURGER)
          (CRAVES BOILS-115 PORK-16)
          (EATS ARUGULA LOBSTER)
          (LOCALE WONDERBREAD OREGON)
          (EATS CHOCOLATE-26 BROCCOLI-27)
          (EATS COD CANTELOPE)
          (EATS KALE PORK)
          (CRAVES SCIATICA-205 GUAVA)
          (CRAVES LACERATION-93 LAMB-8)
          (HARMONY SATIETY NEPTUNE)
          (CRAVES STIMULATION WONDERBREAD-13)
          (CRAVES JEALOUSY-253 POPOVER)
          (HARMONY AESTHETICS-52 NEPTUNE)
          (LOCALE MARZIPAN BAVARIA)
          (LOCALE SHRIMP-14 BAVARIA)
          (CRAVES HANGOVER-211 SNICKERS)
          (CRAVES TRIUMPH-62 PAPAYA)
          (EATS TOMATO FLOUNDER)
          (LOCALE BROCCOLI-27 BAVARIA)
          (HARMONY CURIOSITY MARS)
          (CRAVES STIMULATION-56 ORANGE)
          (EATS PEAR CHICKEN)
          (EATS HAM CHOCOLATE)
          (EATS WONDERBREAD PEAR)
          (LOCALE SHRIMP BAVARIA)
          (EATS POPOVER COD)
          (EATS SNICKERS RICE)
          (CRAVES DREAD-39 YOGURT-29)
          (LOCALE MELON OREGON)
          (CRAVES HANGOVER-232 ARUGULA)
          (EATS CHERRY BROCCOLI)
          (EATS CANTELOPE-10 WONDERBREAD-13)
          (ORBITS JUPITER NEPTUNE)
          (CRAVES LONELINESS-166 TOMATO)
          (EATS PEAR BAGUETTE)
          (LOCALE MUFFIN-9 BAVARIA)
          (EATS BACON-19 MUFFIN-9)
          (CRAVES REST MUTTON-11)
          (LOCALE KALE OREGON)
          (CRAVES SCIATICA-102 HAMBURGER-5)
          (EATS PEPPER CANTELOPE)
          (LOCALE APPLE BAVARIA)
          (LOCALE MUFFIN BAVARIA)
          (EATS BACON LAMB)
          (HARMONY INTOXICATION EARTH)
          (EATS PISTACHIO TURKEY)
          (CRAVES DREAD-103 HAMBURGER-5)
          (CRAVES DREAD-106 WONDERBREAD-13)
          (CRAVES SCIATICA-118 WURST-12)
          (LOCALE FLOUNDER BAVARIA)
          (LOCALE ORANGE BAVARIA)
          (EATS SCALLOP-7 ORANGE)
          (LOCALE BACON-19 BAVARIA)
          (CRAVES ANGINA-69 OKRA)
          (HARMONY TRIUMPH-62 NEPTUNE)
          (EATS WURST-12 GRAPEFRUIT-23)
          (CRAVES ANXIETY-203 CANTELOPE)
          (EATS WONDERBREAD-13 KALE-32)
          (CRAVES HANGOVER-252 CUCUMBER)
          (HARMONY AESTHETICS EARTH)
          (CRAVES DEPRESSION-224 KALE)
          (EATS COD ENDIVE)
          (CRAVES LUBRICITY MELON)
          (EATS BAGUETTE ENDIVE)
          (EATS GRAPEFRUIT-23 CUCUMBER-28)
          (CRAVES DREAD-204 GUAVA)
          (LOCALE CUCUMBER-28 BAVARIA)
          (EATS MUTTON-11 HAM-31)
          (EATS LEMON SCALLOP)
          (EATS CHOCOLATE COD)
          (HARMONY ENTERTAINMENT MARS)
          (EATS WURST-12 PEPPER-21)
          (EATS HAROSET-3 SNICKERS)
          (EATS GUAVA-20 MUFFIN-9)
          (EATS PORK CHICKEN)
          (CRAVES ANGER SCALLION-24)
          (EATS ORANGE TUNA)
          (LOCALE BACON BAVARIA)
          (LOCALE BAGUETTE BAVARIA)
          (CRAVES DREAD ORANGE-22)
          (CRAVES DREAD-74 LOBSTER)
          (EATS ORANGE-22 MUTTON-11)
          (CRAVES ABRASION PEPPER-21)
          (HARMONY UNDERSTANDING EARTH)
          (EATS ONION MUFFIN)
          (EATS PAPAYA-25 BROCCOLI-27)
          (EATS PORK TOFU)
          (CRAVES PROSTATITIS-128 MUFFIN-9)
          (CRAVES EXPECTATION-51 MUFFIN)
          (EATS ENDIVE BAGUETTE)
          (CRAVES DEPRESSION-182 BAGUETTE)
          (CRAVES SCIATICA-176 CHOCOLATE)
          (LOCALE TURKEY OREGON)
          (EATS OKRA ONION)
          (CRAVES HANGOVER-127 MUFFIN-9)
          (CRAVES DEPRESSION-246 TOFU)
          (LOCALE PEPPER-21 BAVARIA)
          (EATS HAMBURGER SCALLOP)
          (LOCALE FLOUNDER-1 OREGON)
          (LOCALE GUAVA-20 BAVARIA)
          (CRAVES ANGER-220 RICE)
          (EATS MUFFIN-9 BACON-19)
          (CRAVES ANGINA-219 RICE)
          (EATS BAGUETTE PEAR)
          (EATS ONION FLOUNDER-1)
          (CRAVES LUBRICITY-53 PEPPER)
          (LOCALE CHERRY BAVARIA)
          (LOCALE HAM-31 BAVARIA)
          (LOCALE WURST-12 BAVARIA)
          (EATS TOFU PORK)
          (EATS CUCUMBER-28 HAM-31)
          (LOCALE TOMATO-6 BAVARIA)
          (EATS POTATO MUTTON)
          (EATS WURST BAGUETTE)
          (EATS COD HOTDOG-4)
          (HARMONY TRIUMPH EARTH)
          (ATTACKS BAVARIA OREGON)
          (EATS SHRIMP-14 KALE-32)
          (CRAVES DEPRESSION-50 SCALLION-24)
          (EATS ENDIVE HOTDOG)
          (EATS ORANGE OKRA)
          (EATS MUFFIN SCALLOP)
          (EATS POPOVER SCALLION)
          (EATS SHRIMP COD)
          (EATS ONION SCALLOP)
          (EATS CHICKEN PEAR)
          (EATS MUTTON CHOCOLATE)
          (EATS CHOCOLATE HAM)
          (CRAVES HANGOVER-86 POTATO-2)
          (EATS ORANGE TOMATO-6)
          (CRAVES LONELINESS-244 TOFU)
          (EATS COD SHRIMP)
          (HARMONY EXPECTATION NEPTUNE)
          (EATS CHOCOLATE-26 WONDERBREAD-13)
          (CRAVES SCIATICA-42 CUCUMBER-28)
          (CRAVES AESTHETICS-52 CHOCOLATE)
          (CRAVES DEPRESSION-198 PORK)
          (EATS LEMON-15 CANTELOPE-10)
          (CRAVES TRIUMPH POTATO-2)
          (EATS LAMB LAMB-8)
          (LOCALE CANTELOPE BAVARIA)
          (EATS KALE-32 WONDERBREAD-13)
          (CRAVES DEPRESSION-109 SHRIMP-14)
          (CRAVES EXPECTATION PEPPER-21)
          (HARMONY EXPECTATION-51 MARS)
          (CRAVES JEALOUSY-78 SWEETROLL)
          (EATS BAGUETTE WURST)
          (CRAVES LACERATION-235 SHRIMP)
          (EATS TOFU HAROSET)
          (CRAVES ABRASION-242 PEA)
          (EATS SHRIMP SCALLION)
          (EATS HAM HAROSET)
          (EATS COD CHOCOLATE)
          (EATS SCALLOP LEMON)
          (CRAVES EMPATHY CHICKEN)
          (EATS FLOUNDER-1 MELON)
          (LOCALE PORK-16 BAVARIA)
          (EATS TOMATO-6 CANTELOPE)
          (LOCALE PAPAYA-25 BAVARIA)
          (EATS BAGUETTE WONDERBREAD)
          (EATS PORK MARZIPAN)
          (EATS HAM-31 PORK-16)
          (CRAVES BOILS GRAPEFRUIT-23)
          (EATS KALE-32 SCALLION-24)
          (CRAVES ABRASION-168 MUFFIN))
   (:GOAL (AND (CRAVES JEALOUSY-91 PISTACHIO)
               (CRAVES ANGINA-87 PISTACHIO))))

(DEFINE (PROBLEM MYSTY-29)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SNICKERS WURST BROCCOLI TUNA RICE MARZIPAN
             MUFFIN MELON SCALLOP POTATO CUCUMBER PORK PEPPER
             CHOCOLATE PEA APPLE GUAVA FLOUNDER YOGURT POPOVER
             TURKEY HAM - FOOD
             STIMULATION INTOXICATION UNDERSTANDING LEARNING
             TRIUMPH EMPATHY EXCITEMENT SATIETY LOVE
             ENTERTAINMENT SATISFACTION REST ACHIEVEMENT EXPECTATION
             CURIOSITY AESTHETICS - PLEASURE
             HANGOVER ANGER ANGINA GRIEF BOILS JEALOUSY
             LACERATION DEPRESSION ANXIETY ABRASION PROSTATITIS
             DREAD LONELINESS SCIATICA JEALOUSY-2 ANXIETY-1
             LACERATION-4 ABRASION-3 BOILS-8 DEPRESSION-7 - PAIN
             MANITOBA-6 BAVARIA ARIZONA QUEBEC PENNSYLVANIA OREGON
             GOIAS MORAVIA GUANABARA BOSNIA SURREY ALSACE
             KENTUCKY MANITOBA - PROVINCE
             VULCAN PLUTO URANUS MARS - PLANET)
   (:INIT (EATS YOGURT PORK)
          (EATS POTATO POPOVER)
          (CRAVES SATIETY SCALLOP)
          (CRAVES ABRASION POTATO)
          (EATS FLOUNDER PORK)
          (LOCALE PEPPER PENNSYLVANIA)
          (HARMONY TRIUMPH URANUS)
          (EATS SNICKERS BROCCOLI)
          (EATS MARZIPAN TUNA)
          (EATS MELON CUCUMBER)
          (EATS APPLE PEA)
          (ATTACKS SURREY ALSACE)
          (CRAVES EXCITEMENT MELON)
          (EATS GUAVA MELON)
          (EATS MELON POPOVER)
          (LOCALE PORK QUEBEC)
          (EATS APPLE HAM)
          (EATS WURST HAM)
          (HARMONY AESTHETICS MARS)
          (EATS CUCUMBER GUAVA)
          (ATTACKS MORAVIA GUANABARA)
          (HARMONY INTOXICATION URANUS)
          (LOCALE PEA GUANABARA)
          (CRAVES EXPECTATION POPOVER)
          (LOCALE WURST PENNSYLVANIA)
          (CRAVES ENTERTAINMENT CUCUMBER)
          (CRAVES ANGINA BROCCOLI)
          (ATTACKS GUANABARA BOSNIA)
          (EATS WURST CUCUMBER)
          (CRAVES EMPATHY MUFFIN)
          (HARMONY ACHIEVEMENT PLUTO)
          (CRAVES LACERATION-4 FLOUNDER)
          (CRAVES GRIEF TUNA)
          (HARMONY EXPECTATION PLUTO)
          (EATS YOGURT CUCUMBER)
          (EATS RICE HAM)
          (EATS FLOUNDER HAM)
          (CRAVES LONELINESS PEPPER)
          (EATS PEPPER APPLE)
          (EATS RICE PEA)
          (CRAVES ANXIETY-1 GUAVA)
          (LOCALE SNICKERS OREGON)
          (HARMONY REST MARS)
          (EATS PORK FLOUNDER)
          (EATS PORK YOGURT)
          (EATS HAM FLOUNDER)
          (EATS GUAVA TUNA)
          (CRAVES ANGER WURST)
          (ATTACKS MANITOBA-6 BAVARIA)
          (EATS GUAVA POTATO)
          (CRAVES SCIATICA PEA)
          (CRAVES DEPRESSION MELON)
          (EATS SCALLOP SNICKERS)
          (CRAVES INTOXICATION WURST)
          (EATS CHOCOLATE MARZIPAN)
          (CRAVES BOILS RICE)
          (EATS PEA APPLE)
          (HARMONY EMPATHY URANUS)
          (EATS TURKEY PEA)
          (LOCALE APPLE PENNSYLVANIA)
          (EATS CUCUMBER YOGURT)
          (LOCALE MELON BAVARIA)
          (CRAVES DREAD PORK)
          (EATS SCALLOP HAM)
          (HARMONY UNDERSTANDING PLUTO)
          (ATTACKS GOIAS MORAVIA)
          (LOCALE TURKEY OREGON)
          (EATS TURKEY APPLE)
          (EATS HAM WURST)
          (CRAVES LEARNING RICE)
          (EATS TUNA MARZIPAN)
          (EATS HAM APPLE)
          (EATS POTATO GUAVA)
          (EATS YOGURT CHOCOLATE)
          (HARMONY ENTERTAINMENT PLUTO)
          (CRAVES JEALOUSY MARZIPAN)
          (ATTACKS BOSNIA SURREY)
          (EATS SNICKERS SCALLOP)
          (CRAVES ACHIEVEMENT YOGURT)
          (CRAVES BOILS-8 TURKEY)
          (EATS APPLE TURKEY)
          (CRAVES STIMULATION SNICKERS)
          (HARMONY EXCITEMENT URANUS)
          (EATS POPOVER MELON)
          (LOCALE MUFFIN OREGON)
          (HARMONY LEARNING URANUS)
          (EATS MUFFIN BROCCOLI)
          (LOCALE CUCUMBER BAVARIA)
          (EATS MUFFIN POPOVER)
          (LOCALE HAM GUANABARA)
          (EATS MARZIPAN CHOCOLATE)
          (HARMONY STIMULATION PLUTO)
          (LOCALE GUAVA MANITOBA-6)
          (EATS GUAVA CUCUMBER)
          (ATTACKS OREGON GOIAS)
          (LOCALE MARZIPAN QUEBEC)
          (ATTACKS KENTUCKY MANITOBA)
          (LOCALE BROCCOLI QUEBEC)
          (CRAVES ABRASION-3 YOGURT)
          (CRAVES HANGOVER SNICKERS)
          (EATS PEPPER POPOVER)
          (CRAVES LACERATION MUFFIN)
          (LOCALE POTATO GUANABARA)
          (CRAVES SATISFACTION APPLE)
          (EATS HAM RICE)
          (CRAVES REST FLOUNDER)
          (ORBITS VULCAN PLUTO)
          (EATS CUCUMBER MELON)
          (EATS CHOCOLATE YOGURT)
          (EATS CUCUMBER WURST)
          (ATTACKS PENNSYLVANIA OREGON)
          (EATS PEA TURKEY)
          (EATS POPOVER POTATO)
          (EATS TUNA GUAVA)
          (HARMONY SATISFACTION MARS)
          (HARMONY LOVE URANUS)
          (LOCALE FLOUNDER GUANABARA)
          (CRAVES AESTHETICS HAM)
          (LOCALE RICE PENNSYLVANIA)
          (ATTACKS BAVARIA ARIZONA)
          (CRAVES ANXIETY SCALLOP)
          (ATTACKS QUEBEC PENNSYLVANIA)
          (LOCALE SCALLOP BOSNIA)
          (HARMONY CURIOSITY PLUTO)
          (EATS POPOVER MUFFIN)
          (EATS PEA RICE)
          (ORBITS PLUTO URANUS)
          (HARMONY SATIETY MARS)
          (EATS APPLE PEPPER)
          (CRAVES CURIOSITY TURKEY)
          (ATTACKS ARIZONA QUEBEC)
          (ATTACKS ALSACE KENTUCKY)
          (CRAVES PROSTATITIS CUCUMBER)
          (ORBITS URANUS MARS)
          (CRAVES DEPRESSION-7 HAM)
          (LOCALE YOGURT GUANABARA)
          (CRAVES TRIUMPH MARZIPAN)
          (CRAVES LOVE POTATO)
          (EATS MELON GUAVA)
          (CRAVES UNDERSTANDING TUNA)
          (LOCALE CHOCOLATE BOSNIA)
          (CRAVES JEALOUSY-2 APPLE)
          (LOCALE POPOVER MANITOBA)
          (EATS HAM SCALLOP)
          (EATS POPOVER PEPPER)
          (EATS BROCCOLI MUFFIN)
          (EATS BROCCOLI SNICKERS)
          (LOCALE TUNA MANITOBA-6))
   (:GOAL (AND (CRAVES ANGER SNICKERS))))

(DEFINE (PROBLEM MYSTY-30)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS ENDIVE CUCUMBER POPOVER MARZIPAN - FOOD
             INTOXICATION - PLEASURE
             ANGINA HANGOVER ANGER JEALOUSY GRIEF - PAIN
             BAVARIA KENTUCKY BOSNIA - PROVINCE
             URANUS MARS - PLANET)
   (:INIT (CRAVES JEALOUSY CUCUMBER)
          (EATS CUCUMBER POPOVER)
          (LOCALE MARZIPAN BOSNIA)
          (HARMONY INTOXICATION MARS)
          (LOCALE POPOVER BAVARIA)
          (LOCALE CUCUMBER KENTUCKY)
          (EATS POPOVER CUCUMBER)
          (LOCALE ENDIVE BOSNIA)
          (CRAVES ANGINA ENDIVE)
          (CRAVES ANGER CUCUMBER)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS POPOVER MARZIPAN)
          (CRAVES HANGOVER ENDIVE)
          (ORBITS URANUS MARS)
          (EATS ENDIVE CUCUMBER)
          (EATS MARZIPAN POPOVER)
          (EATS MARZIPAN ENDIVE)
          (EATS ENDIVE MARZIPAN)
          (CRAVES GRIEF POPOVER)
          (ATTACKS BAVARIA KENTUCKY)
          (CRAVES INTOXICATION POPOVER)
          (EATS CUCUMBER ENDIVE))
   (:GOAL (AND (CRAVES HANGOVER CUCUMBER)
               (CRAVES JEALOUSY POPOVER)
               (CRAVES ANGER MARZIPAN)
               (CRAVES GRIEF ENDIVE)
               (CRAVES ANGINA ENDIVE))))

(DEFINE (PROBLEM MYSTY-31)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PEAR ONION HOTDOG ENDIVE PAPAYA SCALLOP PORK
             BROCCOLI GUAVA YOGURT ARUGULA CUCUMBER BAGUETTE
             TURKEY WONDERBREAD CHICKEN CHOCOLATE HAMBURGER
             HAM MUTTON POTATO SHRIMP CANTELOPE OKRA PEPPER
             SNICKERS LEMON LAMB BACON FLOUNDER TOFU LOBSTER
             SWEETROLL WURST PISTACHIO MUFFIN GRAPEFRUIT BEEF
             APPLE ORANGE SCALLION POPOVER MELON RICE LETTUCE
             MARZIPAN - FOOD
             UNDERSTANDING ENTERTAINMENT TRIUMPH AESTHETICS
             ACHIEVEMENT CURIOSITY STIMULATION LUBRICITY LEARNING
             EXPECTATION INTOXICATION SATISFACTION EXCITEMENT REST
             LOVE EMPATHY SATIETY REST-2 EMPATHY-1 SATIETY-4
             LEARNING-3 LOVE-8 INTOXICATION-7 ACHIEVEMENT-6
             EXCITEMENT-5 EXPECTATION-16 - PLEASURE
             GRIEF PROSTATITIS ANGER HANGOVER JEALOUSY ANGINA
             DREAD DEPRESSION ABRASION LONELINESS SCIATICA
             LACERATION BOILS DEPRESSION-14 DREAD-15 ANXIETY
             GRIEF-11 PROSTATITIS-12 LACERATION-13
             LONELINESS-31 ANGINA-32 HANGOVER-9 ANGER-10 ABRASION-30
             ANXIETY-29 BOILS-27 JEALOUSY-28 DEPRESSION-24
             SCIATICA-25 SCIATICA-26 ANGINA-21 BOILS-22
             HANGOVER-23 PROSTATITIS-17 DREAD-18 LONELINESS-19
             ABRASION-20 JEALOUSY-62 ANXIETY-63 GRIEF-64
             HANGOVER-59 ANGER-60 LACERATION-61 ANGER-55 GRIEF-56
             ANGINA-57 DEPRESSION-58 JEALOUSY-54 PROSTATITIS-53
             DREAD-52 LONELINESS-48 ANXIETY-49 SCIATICA-50
             ABRASION-51 BOILS-46 LACERATION-47 ABRASION-43
             DREAD-44 HANGOVER-45 BOILS-41 PROSTATITIS-42
             GRIEF-39 DEPRESSION-40 JEALOUSY-38 - PAIN
             PENNSYLVANIA GOIAS ARIZONA KENTUCKY - PROVINCE
             SATURN NEPTUNE EARTH VENUS - PLANET)
   (:INIT (EATS TURKEY HAMBURGER)
          (EATS SWEETROLL LETTUCE)
          (EATS POTATO ARUGULA)
          (EATS ORANGE HAMBURGER)
          (LOCALE MELON PENNSYLVANIA)
          (EATS HAMBURGER ORANGE)
          (LOCALE BAGUETTE PENNSYLVANIA)
          (CRAVES LEARNING-3 BEEF)
          (EATS ORANGE MUFFIN)
          (LOCALE HAM GOIAS)
          (CRAVES EXCITEMENT CANTELOPE)
          (CRAVES BOILS-22 PEPPER)
          (CRAVES EXPECTATION-16 MARZIPAN)
          (EATS SHRIMP SNICKERS)
          (EATS CUCUMBER BROCCOLI)
          (EATS ORANGE FLOUNDER)
          (EATS BROCCOLI POTATO)
          (LOCALE CANTELOPE ARIZONA)
          (CRAVES BOILS-46 APPLE)
          (LOCALE LEMON ARIZONA)
          (LOCALE TURKEY ARIZONA)
          (HARMONY SATIETY-4 VENUS)
          (CRAVES LACERATION GUAVA)
          (LOCALE SCALLOP GOIAS)
          (EATS BAGUETTE BROCCOLI)
          (EATS TOFU POPOVER)
          (CRAVES EXPECTATION HAM)
          (CRAVES BOILS-27 SHRIMP)
          (EATS HAMBURGER CHICKEN)
          (LOCALE SWEETROLL PENNSYLVANIA)
          (EATS WONDERBREAD CHOCOLATE)
          (CRAVES ACHIEVEMENT-6 POPOVER)
          (HARMONY EXPECTATION EARTH)
          (EATS POTATO WURST)
          (CRAVES LACERATION-13 ARUGULA)
          (EATS CUCUMBER PAPAYA)
          (LOCALE ENDIVE KENTUCKY)
          (EATS HAM SCALLOP)
          (CRAVES ABRASION SCALLOP)
          (EATS CHOCOLATE ARUGULA)
          (CRAVES JEALOUSY-38 LETTUCE)
          (EATS ARUGULA HAM)
          (CRAVES LOVE-8 ORANGE)
          (ATTACKS ARIZONA KENTUCKY)
          (EATS CHICKEN PEPPER)
          (CRAVES EMPATHY-1 PISTACHIO)
          (EATS CHICKEN TURKEY)
          (HARMONY TRIUMPH EARTH)
          (LOCALE MUTTON PENNSYLVANIA)
          (EATS CUCUMBER ENDIVE)
          (EATS OKRA MUTTON)
          (EATS PEPPER CHICKEN)
          (EATS WURST POTATO)
          (EATS LEMON SHRIMP)
          (EATS TURKEY CHICKEN)
          (EATS CANTELOPE PEPPER)
          (CRAVES ANGINA-32 WONDERBREAD)
          (EATS POPOVER GRAPEFRUIT)
          (EATS SCALLOP CHICKEN)
          (EATS MUTTON YOGURT)
          (HARMONY UNDERSTANDING NEPTUNE)
          (CRAVES LONELINESS-19 LEMON)
          (EATS MARZIPAN SCALLION)
          (EATS GUAVA BAGUETTE)
          (HARMONY LUBRICITY VENUS)
          (EATS HAM OKRA)
          (EATS APPLE MARZIPAN)
          (EATS LAMB BEEF)
          (HARMONY EXPECTATION-16 EARTH)
          (EATS LOBSTER MARZIPAN)
          (CRAVES LACERATION-61 BACON)
          (LOCALE LAMB GOIAS)
          (HARMONY REST VENUS)
          (CRAVES REST-2 SWEETROLL)
          (EATS APPLE GRAPEFRUIT)
          (LOCALE ONION PENNSYLVANIA)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (LOCALE GRAPEFRUIT GOIAS)
          (EATS LETTUCE SWEETROLL)
          (EATS RICE BEEF)
          (EATS BEEF RICE)
          (CRAVES LONELINESS-31 WONDERBREAD)
          (HARMONY LEARNING-3 NEPTUNE)
          (EATS POTATO ONION)
          (EATS HAMBURGER TURKEY)
          (CRAVES ANXIETY YOGURT)
          (EATS POTATO PEAR)
          (LOCALE ARUGULA PENNSYLVANIA)
          (EATS CHOCOLATE POTATO)
          (CRAVES LEARNING WONDERBREAD)
          (CRAVES GRIEF-39 POPOVER)
          (CRAVES JEALOUSY-62 LAMB)
          (EATS FLOUNDER ORANGE)
          (EATS LEMON GUAVA)
          (EATS SCALLION MARZIPAN)
          (EATS MARZIPAN LOBSTER)
          (LOCALE GUAVA KENTUCKY)
          (EATS GRAPEFRUIT POPOVER)
          (CRAVES SATISFACTION SHRIMP)
          (CRAVES JEALOUSY-54 LOBSTER)
          (EATS TOFU GRAPEFRUIT)
          (ORBITS EARTH VENUS)
          (EATS BEEF LAMB)
          (CRAVES GRIEF-11 ARUGULA)
          (EATS WURST MELON)
          (ORBITS NEPTUNE EARTH)
          (EATS CHOCOLATE WONDERBREAD)
          (CRAVES SCIATICA-50 GRAPEFRUIT)
          (CRAVES DREAD-52 PISTACHIO)
          (EATS PAPAYA CUCUMBER)
          (CRAVES LOVE LEMON)
          (CRAVES BOILS-41 SCALLION)
          (CRAVES ANGINA-21 PEPPER)
          (EATS MELON WURST)
          (EATS SHRIMP ENDIVE)
          (CRAVES CURIOSITY GUAVA)
          (CRAVES HANGOVER-23 PEPPER)
          (CRAVES ANXIETY-63 LAMB)
          (EATS POTATO BROCCOLI)
          (LOCALE RICE PENNSYLVANIA)
          (LOCALE CUCUMBER ARIZONA)
          (EATS ENDIVE SHRIMP)
          (EATS CHICKEN HAMBURGER)
          (CRAVES STIMULATION YOGURT)
          (CRAVES DEPRESSION-24 OKRA)
          (HARMONY EXCITEMENT EARTH)
          (CRAVES INTOXICATION MUTTON)
          (EATS MARZIPAN APPLE)
          (EATS SWEETROLL RICE)
          (CRAVES ACHIEVEMENT BROCCOLI)
          (CRAVES ANXIETY-49 GRAPEFRUIT)
          (EATS WONDERBREAD CANTELOPE)
          (EATS MUFFIN SCALLION)
          (HARMONY LEARNING EARTH)
          (HARMONY LOVE-8 NEPTUNE)
          (LOCALE POPOVER GOIAS)
          (HARMONY REST-2 EARTH)
          (LOCALE OKRA PENNSYLVANIA)
          (EATS BEEF PISTACHIO)
          (EATS BACON APPLE)
          (EATS TURKEY HOTDOG)
          (EATS SNICKERS CANTELOPE)
          (EATS POPOVER MARZIPAN)
          (EATS GUAVA LEMON)
          (EATS SNICKERS SHRIMP)
          (EATS OKRA HAM)
          (EATS CANTELOPE SNICKERS)
          (CRAVES LUBRICITY CUCUMBER)
          (EATS PEPPER PORK)
          (CRAVES AESTHETICS PORK)
          (EATS WURST TOFU)
          (EATS FLOUNDER PISTACHIO)
          (CRAVES ABRASION-51 GRAPEFRUIT)
          (LOCALE PEAR PENNSYLVANIA)
          (LOCALE WURST PENNSYLVANIA)
          (EATS PEAR OKRA)
          (EATS CHICKEN SCALLOP)
          (HARMONY INTOXICATION-7 VENUS)
          (HARMONY EMPATHY EARTH)
          (CRAVES DREAD PAPAYA)
          (LOCALE HAMBURGER ARIZONA)
          (CRAVES JEALOUSY ENDIVE)
          (EATS GRAPEFRUIT TOFU)
          (CRAVES ANGINA PAPAYA)
          (CRAVES ANGER-60 BACON)
          (CRAVES PROSTATITIS-12 ARUGULA)
          (LOCALE ORANGE ARIZONA)
          (EATS ONION POTATO)
          (CRAVES BOILS GUAVA)
          (ATTACKS PENNSYLVANIA GOIAS)
          (EATS PORK HAMBURGER)
          (CRAVES INTOXICATION-7 SCALLION)
          (EATS PORK PEPPER)
          (CRAVES DEPRESSION-14 YOGURT)
          (EATS MUFFIN ORANGE)
          (EATS CUCUMBER BAGUETTE)
          (CRAVES ANGER-55 FLOUNDER)
          (CRAVES SCIATICA-25 OKRA)
          (CRAVES HANGOVER-59 BACON)
          (CRAVES JEALOUSY-28 SHRIMP)
          (EATS PISTACHIO FLOUNDER)
          (CRAVES ANGER ENDIVE)
          (EATS YOGURT BAGUETTE)
          (CRAVES PROSTATITIS ENDIVE)
          (CRAVES PROSTATITIS-53 SWEETROLL)
          (HARMONY INTOXICATION EARTH)
          (EATS POPOVER TOFU)
          (LOCALE HOTDOG PENNSYLVANIA)
          (EATS BROCCOLI CUCUMBER)
          (HARMONY AESTHETICS NEPTUNE)
          (LOCALE TOFU ARIZONA)
          (HARMONY CURIOSITY EARTH)
          (LOCALE BEEF PENNSYLVANIA)
          (EATS BROCCOLI BAGUETTE)
          (EATS LOBSTER GRAPEFRUIT)
          (EATS LAMB SCALLION)
          (CRAVES REST OKRA)
          (EATS APPLE BACON)
          (ATTACKS GOIAS ARIZONA)
          (EATS POPOVER MELON)
          (EATS OKRA PEAR)
          (EATS HAM ARUGULA)
          (HARMONY SATISFACTION VENUS)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS HAMBURGER PORK)
          (CRAVES ANXIETY-29 HAM)
          (EATS LEMON YOGURT)
          (LOCALE MUFFIN KENTUCKY)
          (EATS YOGURT LEMON)
          (EATS CANTELOPE WONDERBREAD)
          (LOCALE APPLE ARIZONA)
          (CRAVES UNDERSTANDING PEAR)
          (EATS TOFU WURST)
          (EATS MUTTON OKRA)
          (CRAVES EMPATHY TOFU)
          (CRAVES DEPRESSION PAPAYA)
          (LOCALE PISTACHIO KENTUCKY)
          (EATS PISTACHIO BEEF)
          (EATS LETTUCE SCALLION)
          (CRAVES HANGOVER ENDIVE)
          (EATS MARZIPAN POPOVER)
          (LOCALE BACON PENNSYLVANIA)
          (EATS BAGUETTE GUAVA)
          (CRAVES ABRASION-43 ORANGE)
          (CRAVES ENTERTAINMENT HOTDOG)
          (LOCALE BROCCOLI ARIZONA)
          (LOCALE PEPPER PENNSYLVANIA)
          (EATS ENDIVE CUCUMBER)
          (LOCALE SHRIMP KENTUCKY)
          (CRAVES HANGOVER-45 ORANGE)
          (EATS BAGUETTE YOGURT)
          (CRAVES DREAD-18 LEMON)
          (CRAVES EXCITEMENT-5 RICE)
          (HARMONY STIMULATION EARTH)
          (CRAVES GRIEF-64 LAMB)
          (EATS ARUGULA CHOCOLATE)
          (LOCALE LOBSTER PENNSYLVANIA)
          (CRAVES SCIATICA BROCCOLI)
          (LOCALE FLOUNDER GOIAS)
          (LOCALE LETTUCE ARIZONA)
          (EATS GRAPEFRUIT LOBSTER)
          (EATS BAGUETTE POTATO)
          (CRAVES ANGINA-57 FLOUNDER)
          (CRAVES DEPRESSION-58 FLOUNDER)
          (HARMONY ACHIEVEMENT-6 EARTH)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS WURST RICE)
          (CRAVES LACERATION-47 APPLE)
          (LOCALE WONDERBREAD KENTUCKY)
          (CRAVES TRIUMPH PAPAYA)
          (LOCALE YOGURT GOIAS)
          (LOCALE SCALLION ARIZONA)
          (EATS SHRIMP LEMON)
          (EATS YOGURT ONION)
          (CRAVES LONELINESS BROCCOLI)
          (HARMONY SATIETY EARTH)
          (EATS SCALLION MUFFIN)
          (HARMONY EXCITEMENT-5 VENUS)
          (EATS YOGURT MUTTON)
          (CRAVES DREAD-44 ORANGE)
          (CRAVES ANGER-10 WONDERBREAD)
          (CRAVES SCIATICA-26 OKRA)
          (EATS BACON ORANGE)
          (EATS ARUGULA POTATO)
          (HARMONY ENTERTAINMENT VENUS)
          (LOCALE POTATO ARIZONA)
          (EATS HOTDOG CHOCOLATE)
          (EATS HOTDOG TURKEY)
          (EATS POTATO BAGUETTE)
          (EATS BAGUETTE CUCUMBER)
          (EATS POTATO CHOCOLATE)
          (EATS SCALLION LETTUCE)
          (EATS PEPPER CANTELOPE)
          (CRAVES PROSTATITIS-17 LEMON)
          (EATS PEAR POTATO)
          (EATS GRAPEFRUIT APPLE)
          (EATS SCALLOP HAM)
          (ORBITS SATURN NEPTUNE)
          (EATS RICE SWEETROLL)
          (EATS MELON POPOVER)
          (EATS CHOCOLATE HOTDOG)
          (CRAVES SATIETY LOBSTER)
          (CRAVES DREAD-15 YOGURT)
          (EATS CANTELOPE PAPAYA)
          (LOCALE PAPAYA GOIAS)
          (LOCALE PORK PENNSYLVANIA)
          (EATS ORANGE BACON)
          (CRAVES GRIEF-56 FLOUNDER)
          (CRAVES GRIEF ONION)
          (LOCALE SNICKERS PENNSYLVANIA)
          (HARMONY LOVE NEPTUNE)
          (CRAVES LONELINESS-48 GRAPEFRUIT)
          (LOCALE CHICKEN PENNSYLVANIA)
          (CRAVES ABRASION-20 LEMON)
          (EATS ONION YOGURT)
          (EATS SCALLION LAMB)
          (CRAVES DEPRESSION-40 POPOVER)
          (CRAVES PROSTATITIS-42 SCALLION)
          (CRAVES HANGOVER-9 WONDERBREAD)
          (CRAVES SATIETY-4 MUFFIN)
          (HARMONY EMPATHY-1 EARTH)
          (EATS RICE WURST)
          (CRAVES ABRASION-30 CHICKEN)
          (EATS PAPAYA CANTELOPE))
   (:GOAL (AND (CRAVES HANGOVER LETTUCE)
               (CRAVES ANGER LETTUCE)
               (CRAVES ANGINA LETTUCE)
               (CRAVES DREAD LETTUCE)
               (CRAVES DEPRESSION-14 ORANGE)
               (CRAVES ABRASION LETTUCE))))

(DEFINE (PROBLEM MYSTY-32)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS GRAPEFRUIT-43 POTATO-44 PEA-45
             BROCCOLI-46 TOMATO-47 MARZIPAN-48 MUFFIN-49
             SWEETROLL-50 LEMON-51 ARUGULA-52 ORANGE-53 CHICKEN-54
             TUNA-55 HAROSET-56 MELON-57 HOTDOG-58 APPLE-59
             SCALLOP-60 PEAR-61 CHERRY-62 PORK-63 TOFU-64 WURST-17
             WONDERBREAD-18 CANTELOPE-19 SNICKERS-20 HAM-21
             POPOVER-22 SCALLION-23 PAPAYA-24 YOGURT-25
             FLOUNDER-26 CUCUMBER-27 HAMBURGER-28 CHOCOLATE-29
             LOBSTER-9 KALE-32 COD-31 LETTUCE-30 BAGUETTE-10
             OKRA-11 SHRIMP-12 BACON-13 BEEF-14 RICE-15
             TURKEY-16 LAMB-5 MUTTON-6 GUAVA-7 ENDIVE-8
             GRAPEFRUIT-3 PISTACHIO-4 PEPPER-1 ONION-2 CANTELOPE
             PAPAYA WURST LAMB WONDERBREAD CHOCOLATE HOTDOG
             ONION SCALLION LETTUCE CUCUMBER HAROSET PEPPER
             HAM GRAPEFRUIT PISTACHIO LOBSTER FLOUNDER
             POPOVER SHRIMP ORANGE RICE GUAVA TOMATO BAGUETTE
             SCALLOP OKRA SWEETROLL MUTTON BEEF HAMBURGER TOFU
             TURKEY MARZIPAN CHICKEN SNICKERS APPLE LEMON PEA
             MELON KALE BACON YOGURT TUNA ARUGULA CHERRY ENDIVE
             PEAR MUFFIN COD BROCCOLI PORK POTATO - FOOD
             ENTERTAINMENT LUBRICITY SATISFACTION AESTHETICS
             EXPECTATION REST CURIOSITY EXCITEMENT EMPATHY
             STIMULATION ACHIEVEMENT LEARNING TRIUMPH SATIETY
             UNDERSTANDING LOVE INTOXICATION SATISFACTION-42
             CURIOSITY-41 EXCITEMENT-40 STIMULATION-39
             ENTERTAINMENT-38 INTOXICATION-37 ACHIEVEMENT-36
             UNDERSTANDING-35 LUBRICITY-34 LOVE-33 AESTHETICS-128
             EXPECTATION-127 REST-126 SATIETY-125 EMPATHY-124
             TRIUMPH-123 LEARNING-122 EXPECTATION-121
             STIMULATION-120 LEARNING-119 SATISFACTION-118 REST-117
             EXCITEMENT-116 LOVE-115 LUBRICITY-114 TRIUMPH-113
             AESTHETICS-112 ACHIEVEMENT-111 SATIETY-110
             UNDERSTANDING-109 INTOXICATION-108 EMPATHY-107
             CURIOSITY-106 ENTERTAINMENT-105 TRIUMPH-104
             EXPECTATION-103 CURIOSITY-102 ENTERTAINMENT-101
             STIMULATION-100 SATISFACTION-99 LUBRICITY-98
             ACHIEVEMENT-97 AESTHETICS-96 - PLEASURE
             ANGINA PROSTATITIS BOILS JEALOUSY DREAD GRIEF
             LACERATION DEPRESSION ANXIETY HANGOVER ANGER
             LONELINESS ABRASION SCIATICA HANGOVER-95 DREAD-94
             PROSTATITIS-93 ANGER-92 LONELINESS-91 ANGINA-90 BOILS-89
             JEALOUSY-88 LACERATION-87 ANXIETY-86 SCIATICA-85
             DEPRESSION-84 GRIEF-83 ABRASION-82 DREAD-81 ANXIETY-80
             ANGER-79 BOILS-78 - PAIN
             MORAVIA ALSACE - PROVINCE
             URANUS SATURN MARS EARTH - PLANET)
   (:INIT (EATS SHRIMP GUAVA)
          (EATS CANTELOPE FLOUNDER)
          (HARMONY SATISFACTION SATURN)
          (EATS PEPPER ORANGE)
          (EATS CHERRY-62 KALE-32)
          (EATS ENDIVE-8 MUFFIN)
          (HARMONY EMPATHY EARTH)
          (CRAVES CURIOSITY CHICKEN-54)
          (EATS LETTUCE MELON)
          (EATS BAGUETTE-10 WONDERBREAD)
          (HARMONY EXCITEMENT-40 MARS)
          (EATS POPOVER GRAPEFRUIT-3)
          (EATS WONDERBREAD BAGUETTE-10)
          (CRAVES JEALOUSY-88 CUCUMBER)
          (LOCALE HOTDOG ALSACE)
          (EATS BAGUETTE-10 KALE)
          (CRAVES TRIUMPH-123 CANTELOPE)
          (EATS KALE CHERRY)
          (CRAVES ENTERTAINMENT-38 BAGUETTE-10)
          (EATS TUNA-55 BROCCOLI-46)
          (EATS ENDIVE CHERRY)
          (EATS HAM-21 ARUGULA-52)
          (HARMONY INTOXICATION MARS)
          (EATS WONDERBREAD-18 PAPAYA-24)
          (HARMONY EMPATHY-107 MARS)
          (EATS LETTUCE LEMON)
          (HARMONY LUBRICITY-34 SATURN)
          (CRAVES GRIEF-83 CHICKEN)
          (EATS COD-31 FLOUNDER-26)
          (EATS CHICKEN SWEETROLL)
          (EATS HAMBURGER BAGUETTE)
          (EATS BROCCOLI-46 TUNA-55)
          (EATS HAM POPOVER)
          (EATS WURST FLOUNDER)
          (EATS HAROSET CHICKEN)
          (LOCALE ARUGULA ALSACE)
          (EATS TOMATO-47 SCALLION-23)
          (LOCALE SNICKERS ALSACE)
          (CRAVES TRIUMPH-113 FLOUNDER)
          (EATS POPOVER-22 CANTELOPE-19)
          (EATS APPLE POPOVER)
          (EATS CHOCOLATE-29 LEMON-51)
          (EATS MARZIPAN LAMB-5)
          (EATS SNICKERS-20 TUNA-55)
          (EATS ONION-2 PEA)
          (EATS HOTDOG LEMON)
          (CRAVES LONELINESS-91 ONION-2)
          (EATS SWEETROLL-50 KALE-32)
          (EATS TURKEY-16 PEPPER)
          (HARMONY LUBRICITY-114 SATURN)
          (EATS PEA GUAVA)
          (EATS SCALLOP LAMB-5)
          (LOCALE GRAPEFRUIT-3 MORAVIA)
          (EATS WURST-17 CHOCOLATE-29)
          (EATS MUFFIN ENDIVE-8)
          (EATS GRAPEFRUIT-43 CUCUMBER-27)
          (EATS OKRA-11 POTATO)
          (EATS FLOUNDER-26 COD-31)
          (LOCALE SHRIMP-12 ALSACE)
          (EATS TURKEY SHRIMP-12)
          (LOCALE PEPPER MORAVIA)
          (EATS RICE PEAR)
          (EATS PORK HAMBURGER)
          (EATS POTATO ORANGE)
          (LOCALE PISTACHIO MORAVIA)
          (EATS PEA MUTTON)
          (LOCALE PORK-63 ALSACE)
          (EATS CUCUMBER-27 PEA-45)
          (LOCALE APPLE-59 ALSACE)
          (LOCALE MUTTON MORAVIA)
          (LOCALE PEA-45 MORAVIA)
          (EATS APPLE PISTACHIO)
          (EATS TOFU RICE)
          (CRAVES EXPECTATION-103 BACON)
          (CRAVES TRIUMPH-104 MELON)
          (EATS TOFU-64 WONDERBREAD-18)
          (EATS LETTUCE-30 CHOCOLATE-29)
          (EATS BROCCOLI HAROSET)
          (LOCALE ONION MORAVIA)
          (LOCALE MARZIPAN ALSACE)
          (CRAVES ACHIEVEMENT-111 RICE)
          (EATS GRAPEFRUIT PEA)
          (EATS BAGUETTE PEAR)
          (HARMONY CURIOSITY-106 EARTH)
          (HARMONY TRIUMPH-113 SATURN)
          (CRAVES STIMULATION-120 ONION)
          (EATS HAMBURGER-28 SCALLION-23)
          (LOCALE CHOCOLATE ALSACE)
          (EATS WONDERBREAD FLOUNDER)
          (EATS CHERRY ENDIVE)
          (EATS CUCUMBER-27 GRAPEFRUIT-43)
          (EATS TURKEY-16 MARZIPAN)
          (LOCALE POPOVER MORAVIA)
          (EATS OKRA KALE)
          (EATS CHOCOLATE APPLE)
          (CRAVES LUBRICITY-34 BEEF-14)
          (EATS MARZIPAN-48 FLOUNDER-26)
          (EATS SCALLOP-60 APPLE-59)
          (EATS GUAVA-7 PEAR)
          (EATS LEMON KALE)
          (EATS BACON-13 CHICKEN)
          (EATS TURKEY BACON)
          (LOCALE COD-31 MORAVIA)
          (EATS YOGURT-25 FLOUNDER-26)
          (EATS RICE TOFU)
          (EATS PISTACHIO ONION)
          (HARMONY ENTERTAINMENT MARS)
          (EATS HAMBURGER-28 LOBSTER-9)
          (EATS YOGURT MUFFIN)
          (EATS PEPPER SCALLOP)
          (LOCALE ONION-2 MORAVIA)
          (EATS APPLE-59 HAMBURGER-28)
          (EATS HAMBURGER GUAVA-7)
          (LOCALE PISTACHIO-4 MORAVIA)
          (EATS SNICKERS-20 HAROSET-56)
          (LOCALE BAGUETTE-10 ALSACE)
          (EATS PEPPER TURKEY-16)
          (HARMONY UNDERSTANDING-35 SATURN)
          (EATS HAM GRAPEFRUIT-3)
          (EATS PAPAYA-24 TOFU-64)
          (EATS MUTTON-6 ORANGE)
          (HARMONY EMPATHY-124 SATURN)
          (EATS HAROSET LEMON-51)
          (LOCALE BACON-13 MORAVIA)
          (HARMONY STIMULATION-39 SATURN)
          (LOCALE HAM ALSACE)
          (EATS SCALLOP GUAVA)
          (CRAVES EXPECTATION-121 WONDERBREAD)
          (EATS PEAR BAGUETTE)
          (EATS TOFU-64 YOGURT-25)
          (EATS FLOUNDER WURST)
          (HARMONY EXCITEMENT-116 MARS)
          (EATS YOGURT-25 SNICKERS-20)
          (EATS PEPPER-1 SWEETROLL)
          (EATS SNICKERS MUFFIN)
          (EATS CUCUMBER-27 LEMON-51)
          (EATS POTATO COD)
          (CRAVES BOILS LEMON-51)
          (LOCALE LEMON MORAVIA)
          (EATS SHRIMP-12 TURKEY)
          (LOCALE OKRA-11 MORAVIA)
          (CRAVES REST-117 HAM)
          (HARMONY EXCITEMENT MARS)
          (EATS LETTUCE CHERRY)
          (EATS PEAR BROCCOLI)
          (EATS BROCCOLI PEAR)
          (HARMONY AESTHETICS-96 SATURN)
          (HARMONY EXPECTATION-103 MARS)
          (EATS PEAR PORK)
          (EATS BEEF-14 PISTACHIO-4)
          (LOCALE CHERRY-62 ALSACE)
          (CRAVES SATIETY-110 TOMATO)
          (LOCALE SHRIMP ALSACE)
          (LOCALE POPOVER-22 ALSACE)
          (HARMONY TRIUMPH EARTH)
          (EATS GUAVA MUTTON-6)
          (EATS PISTACHIO APPLE)
          (LOCALE GRAPEFRUIT MORAVIA)
          (CRAVES INTOXICATION-108 HAMBURGER)
          (EATS ORANGE PEPPER)
          (EATS PORK-63 KALE-32)
          (EATS KALE LEMON)
          (EATS LEMON TURKEY)
          (EATS KALE-32 MARZIPAN-48)
          (CRAVES SATIETY-125 PEPPER-1)
          (EATS CHOCOLATE HAM)
          (EATS GUAVA MARZIPAN-48)
          (EATS GUAVA SCALLOP)
          (CRAVES SATIETY HAM-21)
          (EATS HAM PISTACHIO)
          (EATS ORANGE MUTTON-6)
          (EATS MELON-57 SNICKERS-20)
          (EATS WONDERBREAD-18 ORANGE-53)
          (CRAVES ANGINA-90 WURST)
          (EATS GUAVA-7 HAMBURGER)
          (CRAVES EMPATHY-124 ONION-2)
          (EATS PEAR HOTDOG)
          (EATS POTATO PISTACHIO)
          (EATS BROCCOLI-46 CHERRY-62)
          (EATS SCALLOP SCALLION)
          (EATS KALE BAGUETTE-10)
          (EATS RICE-15 BACON-13)
          (EATS HAM-21 KALE-32)
          (HARMONY SATIETY-110 EARTH)
          (EATS POPOVER POTATO)
          (LOCALE OKRA MORAVIA)
          (EATS PISTACHIO HAM)
          (CRAVES JEALOUSY CHICKEN-54)
          (EATS BEEF PEAR)
          (CRAVES DREAD SCALLOP-60)
          (HARMONY AESTHETICS-128 EARTH)
          (CRAVES ANGER-79 ENDIVE)
          (LOCALE CANTELOPE-19 ALSACE)
          (HARMONY LOVE EARTH)
          (HARMONY SATIETY-125 SATURN)
          (LOCALE RICE MORAVIA)
          (CRAVES DEPRESSION-84 BEEF)
          (EATS HAMBURGER PORK)
          (EATS PAPAYA-24 WONDERBREAD-18)
          (CRAVES AESTHETICS-128 LAMB-5)
          (CRAVES ACHIEVEMENT-97 MUFFIN)
          (EATS ENDIVE-8 ARUGULA)
          (EATS MARZIPAN SCALLOP)
          (EATS POTATO PEPPER)
          (EATS CHOCOLATE-29 POPOVER-22)
          (EATS CUCUMBER BROCCOLI)
          (EATS WURST MARZIPAN)
          (EATS PORK PEAR)
          (LOCALE LEMON-51 ALSACE)
          (EATS LOBSTER-9 HAMBURGER-28)
          (EATS BACON TURKEY)
          (CRAVES EMPATHY MELON-57)
          (LOCALE TOMATO MORAVIA)
          (EATS PEAR-61 LETTUCE-30)
          (CRAVES REST-126 PISTACHIO-4)
          (LOCALE WURST ALSACE)
          (EATS KALE-32 SWEETROLL-50)
          (EATS PEPPER-1 MARZIPAN)
          (EATS PISTACHIO-4 LAMB-5)
          (EATS MARZIPAN-48 PORK-63)
          (EATS TURKEY LEMON)
          (LOCALE ENDIVE-8 ALSACE)
          (EATS LEMON HOTDOG)
          (HARMONY INTOXICATION-108 SATURN)
          (EATS PORK-63 YOGURT-25)
          (EATS SCALLION MUTTON)
          (EATS GRAPEFRUIT APPLE)
          (EATS TUNA ENDIVE-8)
          (CRAVES UNDERSTANDING POPOVER-22)
          (EATS MELON LETTUCE)
          (CRAVES STIMULATION-39 LETTUCE-30)
          (LOCALE CUCUMBER-27 ALSACE)
          (LOCALE FLOUNDER ALSACE)
          (LOCALE KALE-32 ALSACE)
          (CRAVES REST MUFFIN-49)
          (EATS ENDIVE MELON)
          (EATS WONDERBREAD-18 CHOCOLATE-29)
          (LOCALE PAPAYA MORAVIA)
          (LOCALE BROCCOLI MORAVIA)
          (EATS GRAPEFRUIT-43 TOMATO-47)
          (EATS SCALLION SHRIMP)
          (EATS SCALLION-23 HAMBURGER-28)
          (LOCALE CHOCOLATE-29 ALSACE)
          (HARMONY ACHIEVEMENT-97 SATURN)
          (LOCALE HOTDOG-58 ALSACE)
          (EATS CUCUMBER MUTTON)
          (EATS KALE-32 HAM-21)
          (EATS POPOVER HAM)
          (LOCALE CHERRY ALSACE)
          (LOCALE BEEF MORAVIA)
          (HARMONY LEARNING-122 MARS)
          (CRAVES ENTERTAINMENT-101 TUNA)
          (HARMONY EXPECTATION-121 SATURN)
          (CRAVES STIMULATION HOTDOG-58)
          (EATS KALE OKRA)
          (LOCALE POTATO MORAVIA)
          (LOCALE POTATO-44 MORAVIA)
          (EATS GUAVA PEPPER)
          (EATS CHICKEN HAROSET)
          (EATS TUNA-55 SNICKERS-20)
          (LOCALE PORK MORAVIA)
          (EATS ARUGULA ENDIVE-8)
          (LOCALE CUCUMBER ALSACE)
          (EATS TOFU BACON)
          (LOCALE HAMBURGER-28 ALSACE)
          (HARMONY ENTERTAINMENT-105 SATURN)
          (EATS ARUGULA SHRIMP-12)
          (EATS CHICKEN-54 MUFFIN-49)
          (LOCALE HAROSET-56 ALSACE)
          (CRAVES SATISFACTION-99 ENDIVE)
          (EATS SWEETROLL-50 SNICKERS-20)
          (CRAVES ENTERTAINMENT GRAPEFRUIT-43)
          (EATS SHRIMP SCALLOP)
          (LOCALE PEA MORAVIA)
          (CRAVES LEARNING-122 PAPAYA)
          (HARMONY CURIOSITY-41 EARTH)
          (HARMONY SATISFACTION-42 EARTH)
          (LOCALE MELON-57 ALSACE)
          (CRAVES SATISFACTION-118 PEPPER)
          (EATS LAMB-5 SCALLOP)
          (LOCALE HAM-21 MORAVIA)
          (LOCALE LOBSTER-9 ALSACE)
          (EATS COD POPOVER)
          (EATS TOMATO-47 GRAPEFRUIT-43)
          (CRAVES ABRASION RICE-15)
          (EATS SWEETROLL PEPPER-1)
          (EATS CANTELOPE OKRA-11)
          (CRAVES LUBRICITY-114 LOBSTER)
          (EATS APPLE CHOCOLATE)
          (LOCALE ENDIVE MORAVIA)
          (CRAVES CURIOSITY-41 LOBSTER-9)
          (EATS MUFFIN-49 MELON-57)
          (CRAVES EMPATHY-107 MARZIPAN)
          (EATS POTATO MARZIPAN)
          (EATS SWEETROLL CHICKEN)
          (LOCALE TOMATO-47 MORAVIA)
          (EATS BAGUETTE LAMB)
          (CRAVES PROSTATITIS-93 PISTACHIO-4)
          (EATS PEPPER POTATO)
          (HARMONY STIMULATION SATURN)
          (EATS LOBSTER-9 HAM-21)
          (CRAVES ANGER-92 PEPPER-1)
          (LOCALE YOGURT ALSACE)
          (ATTACKS MORAVIA ALSACE)
          (CRAVES LACERATION-87 GRAPEFRUIT)
          (CRAVES ANXIETY PAPAYA-24)
          (EATS KALE-32 CHERRY-62)
          (EATS PISTACHIO POTATO)
          (EATS MUFFIN SNICKERS)
          (EATS SCALLION SCALLOP)
          (CRAVES ANGINA POTATO-44)
          (HARMONY TRIUMPH-104 SATURN)
          (EATS CHOCOLATE-29 WONDERBREAD-18)
          (EATS CUCUMBER-27 POTATO-44)
          (EATS MARZIPAN-48 GUAVA)
          (CRAVES SCIATICA-85 MUTTON)
          (EATS FLOUNDER-26 MARZIPAN-48)
          (CRAVES GRIEF WONDERBREAD-18)
          (HARMONY STIMULATION-120 MARS)
          (LOCALE PEPPER-1 ALSACE)
          (EATS CHERRY-62 ARUGULA-52)
          (EATS BACON SNICKERS)
          (HARMONY SATISFACTION-118 SATURN)
          (EATS POTATO OKRA-11)
          (CRAVES SATISFACTION-42 YOGURT-25)
          (LOCALE ORANGE-53 MORAVIA)
          (LOCALE HAROSET ALSACE)
          (EATS TOMATO CHERRY)
          (LOCALE APPLE MORAVIA)
          (CRAVES UNDERSTANDING-35 BACON-13)
          (EATS PEA ONION-2)
          (EATS PISTACHIO-4 BEEF-14)
          (EATS ORANGE-53 WONDERBREAD-18)
          (EATS ORANGE-53 FLOUNDER-26)
          (EATS SWEETROLL KALE)
          (EATS ONION ONION-2)
          (CRAVES LACERATION CANTELOPE-19)
          (EATS APPLE-59 SCALLOP-60)
          (LOCALE MUFFIN MORAVIA)
          (CRAVES ANXIETY-86 BAGUETTE)
          (EATS GUAVA PEA)
          (LOCALE BACON MORAVIA)
          (EATS MARZIPAN PEPPER-1)
          (EATS HAMBURGER-28 PEAR-61)
          (EATS PISTACHIO ORANGE)
          (EATS CHERRY LETTUCE)
          (HARMONY LEARNING SATURN)
          (EATS FLOUNDER WONDERBREAD)
          (LOCALE MELON ALSACE)
          (EATS FLOUNDER CANTELOPE)
          (EATS LAMB-5 PISTACHIO-4)
          (EATS YOGURT-25 TOFU-64)
          (CRAVES LOVE-115 PISTACHIO)
          (EATS LEMON-51 CHOCOLATE-29)
          (EATS PAPAYA YOGURT)
          (LOCALE FLOUNDER-26 MORAVIA)
          (EATS WURST-17 PAPAYA-24)
          (CRAVES UNDERSTANDING-109 SWEETROLL)
          (LOCALE KALE MORAVIA)
          (EATS RICE-15 BEEF)
          (LOCALE LETTUCE MORAVIA)
          (LOCALE SWEETROLL-50 ALSACE)
          (LOCALE YOGURT-25 ALSACE)
          (EATS OKRA BEEF)
          (EATS PEAR-61 HAMBURGER-28)
          (LOCALE MUTTON-6 MORAVIA)
          (EATS GRAPEFRUIT-3 POTATO)
          (HARMONY EXPECTATION-127 EARTH)
          (EATS MUFFIN MELON)
          (CRAVES INTOXICATION PAPAYA-24)
          (EATS MARZIPAN WURST)
          (LOCALE CHICKEN-54 ALSACE)
          (EATS CHICKEN BACON-13)
          (EATS SCALLOP PEPPER)
          (EATS BAGUETTE HAMBURGER)
          (EATS PORK-63 MARZIPAN-48)
          (CRAVES LOVE-33 TURKEY-16)
          (HARMONY REST-117 SATURN)
          (CRAVES ACHIEVEMENT-36 SHRIMP-12)
          (LOCALE ORANGE MORAVIA)
          (EATS BROCCOLI BEEF-14)
          (HARMONY UNDERSTANDING-109 MARS)
          (EATS MELON TUNA)
          (EATS ONION PISTACHIO)
          (CRAVES LEARNING PEAR-61)
          (EATS CANTELOPE-19 HOTDOG-58)
          (CRAVES EXCITEMENT TUNA-55)
          (EATS GRAPEFRUIT-3 HAM)
          (CRAVES LONELINESS BAGUETTE-10)
          (LOCALE TUNA-55 ALSACE)
          (EATS PEAR BEEF)
          (HARMONY TRIUMPH-123 MARS)
          (EATS HAMBURGER-28 APPLE-59)
          (LOCALE SCALLOP-60 ALSACE)
          (CRAVES DREAD-81 KALE)
          (EATS POPOVER-22 CHOCOLATE-29)
          (CRAVES HANGOVER CUCUMBER-27)
          (HARMONY LOVE-115 SATURN)
          (LOCALE LAMB MORAVIA)
          (HARMONY LUBRICITY-98 SATURN)
          (LOCALE CHICKEN ALSACE)
          (EATS MELON MUFFIN)
          (EATS PAPAYA BAGUETTE)
          (CRAVES DEPRESSION SCALLION-23)
          (EATS BROCCOLI SCALLOP)
          (EATS CHOCOLATE-29 WURST-17)
          (LOCALE SNICKERS-20 ALSACE)
          (LOCALE LAMB-5 ALSACE)
          (EATS SCALLOP BROCCOLI)
          (HARMONY ENTERTAINMENT-101 MARS)
          (EATS APPLE GRAPEFRUIT)
          (EATS HAM-21 LOBSTER-9)
          (EATS PEAR RICE)
          (HARMONY SATIETY SATURN)
          (LOCALE MUFFIN-49 ALSACE)
          (EATS BAGUETTE PAPAYA)
          (LOCALE WONDERBREAD MORAVIA)
          (HARMONY AESTHETICS MARS)
          (EATS SCALLOP SHRIMP)
          (EATS MUTTON SCALLION)
          (EATS BEEF RICE-15)
          (EATS POTATO TOMATO)
          (EATS SNICKERS-20 PEA-45)
          (EATS POPOVER APPLE)
          (ORBITS SATURN MARS)
          (EATS GRAPEFRUIT-3 POPOVER)
          (EATS BACON TOFU)
          (CRAVES AESTHETICS-112 SHRIMP)
          (EATS BEEF-14 BROCCOLI)
          (HARMONY INTOXICATION-37 EARTH)
          (CRAVES ABRASION-82 APPLE)
          (LOCALE BEEF-14 ALSACE)
          (CRAVES LOVE SCALLION-23)
          (HARMONY STIMULATION-100 SATURN)
          (EATS SNICKERS-20 MELON-57)
          (CRAVES ANGER COD-31)
          (EATS KALE SWEETROLL)
          (LOCALE GUAVA ALSACE)
          (EATS MUTTON PEA)
          (EATS MUTTON-6 GUAVA)
          (EATS LAMB BAGUETTE)
          (EATS PEAR LOBSTER)
          (CRAVES EXPECTATION MARZIPAN-48)
          (CRAVES INTOXICATION-37 OKRA-11)
          (EATS PEA-45 SNICKERS-20)
          (HARMONY REST-126 EARTH)
          (CRAVES HANGOVER-95 GUAVA-7)
          (LOCALE TURKEY-16 MORAVIA)
          (LOCALE TOFU MORAVIA)
          (LOCALE TOFU-64 MORAVIA)
          (EATS YOGURT PAPAYA)
          (EATS POTATO-44 CUCUMBER-27)
          (EATS BROCCOLI CUCUMBER)
          (LOCALE COD ALSACE)
          (EATS CHERRY KALE)
          (EATS LEMON-51 HAROSET)
          (EATS MUTTON CUCUMBER)
          (CRAVES AESTHETICS TOMATO-47)
          (HARMONY SATISFACTION-99 SATURN)
          (CRAVES ANXIETY-80 CHERRY)
          (EATS PAPAYA-24 WURST-17)
          (CRAVES CURIOSITY-106 CHICKEN)
          (EATS SNICKERS-20 YOGURT-25)
          (EATS SCALLOP-60 HAROSET-56)
          (CRAVES ACHIEVEMENT APPLE-59)
          (EATS BACON-13 RICE-15)
          (CRAVES DREAD-94 ENDIVE-8)
          (LOCALE WONDERBREAD-18 ALSACE)
          (HARMONY LOVE-33 SATURN)
          (EATS HAROSET-56 SNICKERS-20)
          (EATS GUAVA SHRIMP)
          (EATS SCALLOP MUTTON)
          (EATS SCALLION-23 TOMATO-47)
          (EATS PEA-45 CUCUMBER-27)
          (LOCALE SCALLION-23 ALSACE)
          (EATS HAM CHOCOLATE)
          (EATS PEPPER GUAVA)
          (EATS COD-31 WONDERBREAD-18)
          (EATS BEEF OKRA)
          (EATS HAMBURGER YOGURT)
          (EATS CHERRY-62 BROCCOLI-46)
          (LOCALE BROCCOLI-46 MORAVIA)
          (EATS WONDERBREAD-18 YOGURT-25)
          (HARMONY LUBRICITY SATURN)
          (EATS ONION-2 ONION)
          (EATS TOFU-64 PAPAYA-24)
          (CRAVES STIMULATION-100 CHERRY)
          (EATS ENDIVE-8 TUNA)
          (EATS FLOUNDER-26 YOGURT-25)
          (LOCALE SCALLION MORAVIA)
          (EATS HOTDOG PEAR)
          (CRAVES BOILS-78 PORK)
          (CRAVES AESTHETICS-96 COD)
          (LOCALE PEAR-61 MORAVIA)
          (EATS YOGURT-25 WONDERBREAD-18)
          (ORBITS MARS EARTH)
          (CRAVES SATISFACTION BROCCOLI-46)
          (HARMONY CURIOSITY EARTH)
          (EATS YOGURT HAMBURGER)
          (LOCALE LOBSTER MORAVIA)
          (LOCALE SCALLOP MORAVIA)
          (HARMONY CURIOSITY-102 SATURN)
          (EATS ARUGULA-52 CHERRY-62)
          (CRAVES SCIATICA LAMB-5)
          (LOCALE TUNA MORAVIA)
          (CRAVES PROSTATITIS SWEETROLL-50)
          (LOCALE HAMBURGER MORAVIA)
          (EATS WONDERBREAD-18 COD-31)
          (EATS POPOVER COD)
          (EATS MARZIPAN POTATO)
          (EATS POTATO POPOVER)
          (LOCALE PAPAYA-24 ALSACE)
          (EATS MUFFIN YOGURT)
          (HARMONY ENTERTAINMENT-38 MARS)
          (LOCALE ARUGULA-52 MORAVIA)
          (LOCALE CANTELOPE MORAVIA)
          (EATS MUTTON SCALLOP)
          (EATS COD POTATO)
          (EATS MUFFIN ENDIVE)
          (EATS CHOCOLATE-29 LETTUCE-30)
          (HARMONY ACHIEVEMENT-36 SATURN)
          (CRAVES LUBRICITY-98 PEAR)
          (EATS OKRA-11 CANTELOPE)
          (EATS POPOVER-22 YOGURT-25)
          (CRAVES EXPECTATION-127 MUTTON-6)
          (EATS TUNA MELON)
          (HARMONY REST EARTH)
          (EATS MELON ENDIVE)
          (EATS CHICKEN-54 LOBSTER-9)
          (EATS ARUGULA-52 HAM-21)
          (EATS LOBSTER KALE)
          (EATS LEMON LETTUCE)
          (LOCALE TURKEY MORAVIA)
          (HARMONY UNDERSTANDING MARS)
          (EATS KALE-32 PORK-63)
          (EATS FLOUNDER-26 ORANGE-53)
          (EATS LOBSTER-9 CHICKEN-54)
          (EATS MUFFIN-49 CHICKEN-54)
          (CRAVES LUBRICITY POTATO-44)
          (LOCALE RICE-15 MORAVIA)
          (EATS MELON-57 MUFFIN-49)
          (EATS YOGURT-25 POPOVER-22)
          (LOCALE SWEETROLL ALSACE)
          (EATS HAROSET BROCCOLI)
          (EATS ORANGE PISTACHIO)
          (HARMONY EXPECTATION EARTH)
          (EATS SNICKERS BACON)
          (EATS HOTDOG-58 CANTELOPE-19)
          (HARMONY ACHIEVEMENT-111 EARTH)
          (EATS PEA GRAPEFRUIT)
          (LOCALE MARZIPAN-48 MORAVIA)
          (EATS SNICKERS LAMB)
          (EATS HAROSET-56 SCALLOP-60)
          (EATS TOMATO POTATO)
          (LOCALE GRAPEFRUIT-43 MORAVIA)
          (EATS SHRIMP SCALLION)
          (EATS ORANGE POTATO)
          (EATS POTATO-44 HOTDOG-58)
          (ORBITS URANUS SATURN)
          (CRAVES LEARNING-119 HAROSET)
          (EATS CANTELOPE-19 POPOVER-22)
          (EATS CHERRY TOMATO)
          (EATS LAMB-5 MARZIPAN)
          (EATS LEMON-51 CUCUMBER-27)
          (EATS LETTUCE-30 PEAR-61)
          (EATS KALE LOBSTER)
          (LOCALE LETTUCE-30 MORAVIA)
          (EATS MARZIPAN TURKEY-16)
          (HARMONY ACHIEVEMENT SATURN)
          (EATS PEAR GUAVA-7)
          (LOCALE PEAR MORAVIA)
          (LOCALE WURST-17 MORAVIA)
          (CRAVES BOILS-89 SCALLION)
          (CRAVES EXCITEMENT-40 KALE-32)
          (EATS SNICKERS-20 SWEETROLL-50)
          (EATS SCALLOP MARZIPAN)
          (EATS MARZIPAN-48 KALE-32)
          (CRAVES CURIOSITY-102 YOGURT)
          (HARMONY AESTHETICS-112 EARTH)
          (EATS WONDERBREAD-18 TOFU-64)
          (HARMONY LEARNING-119 MARS)
          (CRAVES TRIUMPH PORK-63)
          (LOCALE GUAVA-7 ALSACE)
          (EATS LAMB SNICKERS)
          (CRAVES EXCITEMENT-116 GRAPEFRUIT)
          (CRAVES ENTERTAINMENT-105 SNICKERS)
          (EATS POTATO GRAPEFRUIT-3)
          (EATS SHRIMP-12 ARUGULA)
          (EATS HOTDOG-58 POTATO-44)
          (EATS LOBSTER PEAR)
          (EATS YOGURT-25 PORK-63)
          (LOCALE BAGUETTE ALSACE)
          (EATS ENDIVE MUFFIN))
   (:GOAL (AND (CRAVES LACERATION-87 PORK)
               (CRAVES DREAD GUAVA)
               (CRAVES DREAD-81 PEPPER)
               (CRAVES HANGOVER-95 LAMB-5)
               (CRAVES SCIATICA SHRIMP-12)
               (CRAVES ANGER-92 POPOVER-22)
               (CRAVES JEALOUSY POPOVER-22))))

(DEFINE (PROBLEM MYSTY-33)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TOFU-16 ARUGULA-5 LAMB-6 SNICKERS-7
             CHICKEN-8 LOBSTER-3 PEAR-4 CUCUMBER-1 YOGURT-2 APPLE
             BEEF PISTACHIO ARUGULA CUCUMBER ENDIVE RICE
             PEPPER MUTTON ONION MUFFIN SHRIMP BAGUETTE
             SCALLION TOFU PAPAYA GUAVA CANTELOPE HOTDOG TOMATO
             SWEETROLL LETTUCE PORK WONDERBREAD TURKEY LEMON KALE
             SNICKERS YOGURT POPOVER TUNA LOBSTER POTATO
             CHOCOLATE BACON HAM SCALLOP MELON WURST LAMB PEA
             MARZIPAN HAROSET HAMBURGER ORANGE GRAPEFRUIT
             CHICKEN FLOUNDER COD CHERRY OKRA BROCCOLI PEAR
             - FOOD
             LUBRICITY ACHIEVEMENT EMPATHY EXPECTATION
             STIMULATION AESTHETICS ENTERTAINMENT SATISFACTION
             CURIOSITY LEARNING REST EXCITEMENT - PLEASURE
             LONELINESS ANGINA LACERATION DEPRESSION HANGOVER
             BOILS GRIEF ABRASION ANXIETY DREAD
             PROSTATITIS-15 SCIATICA ANGER JEALOUSY PROSTATITIS
             HANGOVER-14 LONELINESS-10 ANXIETY-11 DREAD-12
             ABRASION-13 JEALOUSY-31 ANGER-32 LACERATION-9
             DEPRESSION-30 SCIATICA-26 BOILS-27 ANGINA-28 GRIEF-29
             PROSTATITIS-22 JEALOUSY-23 ANGER-24 BOILS-25
             DEPRESSION-17 ANGINA-18 HANGOVER-19 LACERATION-20
             ANXIETY-21 ABRASION-61 SCIATICA-62 GRIEF-63
             LONELINESS-64 HANGOVER-57 JEALOUSY-58 BOILS-59 DREAD-60
             ANXIETY-53 ANGER-54 DEPRESSION-55 LONELINESS-56
             ANGINA-51 LACERATION-52 PROSTATITIS-48 SCIATICA-49
             GRIEF-50 ABRASION-47 ANGER-44 ANGINA-45 DREAD-46
             LONELINESS-42 BOILS-43 HANGOVER-40 SCIATICA-41
             ANXIETY-37 JEALOUSY-38 DEPRESSION-39
             PROSTATITIS-128 DREAD-33 ABRASION-34 GRIEF-35
             LACERATION-36 ANXIETY-123 GRIEF-124 LACERATION-125
             HANGOVER-126 DREAD-127 SCIATICA-119 LONELINESS-120
             ABRASION-121 JEALOUSY-122 PROSTATITIS-114 ANGER-115
             ANGINA-116 DEPRESSION-117 BOILS-118 ANGER-111
             ANGINA-112 BOILS-113 ANXIETY-107 HANGOVER-108
             JEALOUSY-109 ABRASION-110 LACERATION-106 DREAD-104
             LONELINESS-105 GRIEF-100 DEPRESSION-101 PROSTATITIS-102
             SCIATICA-103 SCIATICA-98 ABRASION-99 ANXIETY-96
             JEALOUSY-97 ANGER-95 DEPRESSION-90 DREAD-91
             LONELINESS-92 PROSTATITIS-93 BOILS-94 ANGINA-87
             HANGOVER-88 LACERATION-89 DEPRESSION-84 GRIEF-85
             GRIEF-86 SCIATICA-79 DREAD-80 ABRASION-81
             HANGOVER-82 JEALOUSY-83 PROSTATITIS-74 BOILS-75
             ANGINA-76 ANGER-77 LONELINESS-78 HANGOVER-70
             ANGINA-71 LACERATION-72 ANXIETY-73 ANXIETY-69
             ANGER-66 GRIEF-67 LACERATION-68 BOILS-256
             DEPRESSION-65 PROSTATITIS-252 LONELINESS-253
             JEALOUSY-254 ABRASION-255 - PAIN
             BOSNIA GUANABARA KENTUCKY OREGON - PROVINCE
             SATURN VULCAN MARS NEPTUNE - PLANET)
   (:INIT (CRAVES SCIATICA-26 ARUGULA)
          (EATS KALE LOBSTER)
          (EATS LETTUCE LEMON)
          (EATS YOGURT-2 GRAPEFRUIT)
          (CRAVES JEALOUSY-23 CUCUMBER)
          (EATS HAMBURGER LEMON)
          (CRAVES ANGINA-51 TOFU)
          (EATS MARZIPAN PORK)
          (CRAVES HANGOVER-82 HAMBURGER)
          (EATS SNICKERS OKRA)
          (EATS RICE GRAPEFRUIT)
          (CRAVES ANXIETY-123 WONDERBREAD)
          (LOCALE CHICKEN-8 GUANABARA)
          (EATS RICE LAMB-6)
          (EATS LEMON HAMBURGER)
          (LOCALE RICE OREGON)
          (LOCALE POPOVER BOSNIA)
          (EATS COD POTATO)
          (CRAVES JEALOUSY-31 BEEF)
          (ORBITS MARS NEPTUNE)
          (CRAVES PROSTATITIS LOBSTER-3)
          (EATS CANTELOPE LAMB)
          (EATS RICE BROCCOLI)
          (EATS BROCCOLI SNICKERS)
          (EATS LETTUCE MARZIPAN)
          (EATS HAROSET SNICKERS)
          (CRAVES JEALOUSY-38 LETTUCE)
          (EATS ORANGE POTATO)
          (LOCALE PEAR-4 OREGON)
          (EATS SCALLOP YOGURT-2)
          (CRAVES GRIEF-100 POTATO)
          (EATS PORK LEMON)
          (CRAVES SCIATICA-41 SWEETROLL)
          (EATS OKRA SWEETROLL)
          (CRAVES GRIEF ARUGULA-5)
          (CRAVES DREAD-104 LOBSTER)
          (CRAVES HANGOVER-126 WONDERBREAD)
          (EATS PEAR CHERRY)
          (EATS CHERRY TOFU)
          (EATS BROCCOLI LAMB)
          (LOCALE TUNA KENTUCKY)
          (CRAVES DREAD-80 HAMBURGER)
          (CRAVES ANXIETY-96 SCALLOP)
          (EATS WURST LOBSTER)
          (EATS TURKEY CUCUMBER)
          (HARMONY ACHIEVEMENT VULCAN)
          (LOCALE GRAPEFRUIT OREGON)
          (EATS HAMBURGER LOBSTER)
          (EATS POPOVER POTATO)
          (CRAVES LACERATION ARUGULA-5)
          (EATS BEEF ARUGULA-5)
          (CRAVES ANGINA-116 KALE)
          (EATS PEA POPOVER)
          (LOCALE PEA BOSNIA)
          (CRAVES ANXIETY-21 RICE)
          (CRAVES HANGOVER-88 MARZIPAN)
          (EATS MARZIPAN SCALLION)
          (LOCALE SNICKERS OREGON)
          (EATS SNICKERS-7 WURST)
          (EATS PEAR CUCUMBER)
          (EATS MUFFIN TUNA)
          (CRAVES ANGER LOBSTER-3)
          (EATS HAROSET PISTACHIO)
          (CRAVES GRIEF-50 PAPAYA)
          (CRAVES ANGER-77 ORANGE)
          (HARMONY EXCITEMENT MARS)
          (CRAVES JEALOUSY-83 HAMBURGER)
          (CRAVES ANGER-24 CUCUMBER)
          (CRAVES BOILS-256 OKRA)
          (CRAVES BOILS-118 KALE)
          (CRAVES BOILS-94 PEA)
          (CRAVES SCIATICA-119 LEMON)
          (CRAVES DREAD SNICKERS-7)
          (EATS PAPAYA SWEETROLL)
          (CRAVES DEPRESSION-101 POTATO)
          (EATS SCALLOP WURST)
          (EATS PISTACHIO HAROSET)
          (EATS YOGURT-2 SCALLOP)
          (EATS LAMB-6 HAM)
          (EATS LOBSTER-3 BROCCOLI)
          (EATS ONION WURST)
          (EATS ONION HAMBURGER)
          (EATS GRAPEFRUIT HAROSET)
          (CRAVES LONELINESS TOFU-16)
          (EATS BROCCOLI RICE)
          (EATS BACON FLOUNDER)
          (CRAVES GRIEF-63 MUTTON)
          (EATS LOBSTER HAMBURGER)
          (LOCALE BROCCOLI GUANABARA)
          (CRAVES ANXIETY LAMB-6)
          (CRAVES DEPRESSION-17 RICE)
          (CRAVES JEALOUSY-254 BROCCOLI)
          (EATS TURKEY MARZIPAN)
          (EATS CHOCOLATE LOBSTER-3)
          (CRAVES DEPRESSION-84 HAROSET)
          (HARMONY EXPECTATION MARS)
          (CRAVES BOILS-25 CUCUMBER)
          (CRAVES DEPRESSION-30 PISTACHIO)
          (CRAVES ANXIETY-107 YOGURT)
          (EATS TUNA BEEF)
          (EATS SNICKERS BROCCOLI)
          (CRAVES JEALOUSY-58 ONION)
          (CRAVES EMPATHY PISTACHIO)
          (EATS PEPPER LEMON)
          (CRAVES LUBRICITY ARUGULA-5)
          (HARMONY STIMULATION MARS)
          (EATS MUTTON SHRIMP)
          (EATS KALE HAMBURGER)
          (EATS APPLE TUNA)
          (LOCALE HAMBURGER GUANABARA)
          (LOCALE PEAR GUANABARA)
          (EATS GRAPEFRUIT ORANGE)
          (LOCALE PORK KENTUCKY)
          (LOCALE COD BOSNIA)
          (CRAVES ANXIETY-53 MUFFIN)
          (EATS ENDIVE PEPPER)
          (LOCALE SHRIMP BOSNIA)
          (CRAVES JEALOUSY-122 LEMON)
          (LOCALE LEMON BOSNIA)
          (EATS SWEETROLL OKRA)
          (EATS CHICKEN-8 SCALLOP)
          (EATS PEAR PORK)
          (HARMONY SATISFACTION NEPTUNE)
          (EATS LEMON CHERRY)
          (EATS PEA COD)
          (CRAVES SCIATICA-79 HAMBURGER)
          (EATS LAMB SCALLOP)
          (CRAVES STIMULATION WONDERBREAD)
          (LOCALE TURKEY OREGON)
          (EATS COD POPOVER)
          (EATS HAROSET OKRA)
          (EATS WURST CANTELOPE)
          (HARMONY LEARNING NEPTUNE)
          (EATS GRAPEFRUIT TOMATO)
          (CRAVES ANGINA-18 RICE)
          (EATS LOBSTER KALE)
          (EATS ORANGE POPOVER)
          (LOCALE BACON BOSNIA)
          (EATS LOBSTER SHRIMP)
          (CRAVES GRIEF-29 ARUGULA)
          (EATS SNICKERS HAROSET)
          (EATS CUCUMBER PORK)
          (EATS BAGUETTE SCALLION)
          (CRAVES ACHIEVEMENT LOBSTER-3)
          (LOCALE HAM GUANABARA)
          (ATTACKS KENTUCKY OREGON)
          (LOCALE LAMB-6 GUANABARA)
          (EATS MARZIPAN LETTUCE)
          (LOCALE PISTACHIO BOSNIA)
          (EATS BEEF TUNA)
          (EATS YOGURT SNICKERS-7)
          (CRAVES LONELINESS-42 HOTDOG)
          (CRAVES ANGINA-112 SNICKERS)
          (LOCALE GUAVA BOSNIA)
          (LOCALE MUFFIN OREGON)
          (EATS ENDIVE PEAR)
          (EATS BEEF WURST)
          (LOCALE HAROSET OREGON)
          (CRAVES DEPRESSION-55 MUFFIN)
          (LOCALE PAPAYA GUANABARA)
          (HARMONY REST MARS)
          (EATS ARUGULA BROCCOLI)
          (CRAVES LONELINESS-78 ORANGE)
          (CRAVES JEALOUSY LOBSTER-3)
          (LOCALE BEEF BOSNIA)
          (CRAVES PROSTATITIS-128 PORK)
          (EATS CANTELOPE HAMBURGER)
          (EATS LAMB YOGURT)
          (LOCALE CANTELOPE BOSNIA)
          (EATS MUTTON MUFFIN)
          (EATS WONDERBREAD HAROSET)
          (CRAVES PROSTATITIS-48 PAPAYA)
          (EATS TURKEY FLOUNDER)
          (CRAVES ABRASION-81 HAMBURGER)
          (HARMONY LUBRICITY NEPTUNE)
          (EATS LAMB BROCCOLI)
          (ORBITS SATURN VULCAN)
          (CRAVES SCIATICA LOBSTER-3)
          (CRAVES HANGOVER-108 YOGURT)
          (EATS GRAPEFRUIT YOGURT-2)
          (CRAVES SATISFACTION LOBSTER)
          (EATS LEMON PORK)
          (EATS BACON SCALLION)
          (CRAVES LACERATION-125 WONDERBREAD)
          (LOCALE POTATO BOSNIA)
          (CRAVES ANGINA TOFU-16)
          (EATS PORK MARZIPAN)
          (CRAVES ABRASION-121 LEMON)
          (EATS GUAVA PEAR-4)
          (LOCALE MUTTON KENTUCKY)
          (LOCALE CHERRY GUANABARA)
          (EATS ORANGE GRAPEFRUIT)
          (LOCALE HOTDOG GUANABARA)
          (CRAVES ABRASION-255 BROCCOLI)
          (CRAVES ANGINA-87 MARZIPAN)
          (CRAVES REST MARZIPAN)
          (EATS HAMBURGER CANTELOPE)
          (EATS TOFU LEMON)
          (EATS GRAPEFRUIT RICE)
          (CRAVES ABRASION-13 YOGURT-2)
          (LOCALE WONDERBREAD GUANABARA)
          (EATS LETTUCE HAMBURGER)
          (CRAVES LONELINESS-92 PEA)
          (EATS TOFU-16 SHRIMP)
          (CRAVES DREAD-12 YOGURT-2)
          (EATS SHRIMP MUTTON)
          (HARMONY CURIOSITY NEPTUNE)
          (LOCALE TOMATO BOSNIA)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS PEAR ENDIVE)
          (CRAVES EXCITEMENT FLOUNDER)
          (CRAVES ANGER-32 BEEF)
          (CRAVES SCIATICA-62 MUTTON)
          (EATS POTATO COD)
          (EATS BEEF CUCUMBER-1)
          (LOCALE WURST BOSNIA)
          (CRAVES LACERATION-36 PORK)
          (ORBITS VULCAN MARS)
          (EATS WURST SNICKERS-7)
          (EATS ARUGULA-5 BEEF)
          (CRAVES BOILS-75 ORANGE)
          (EATS KALE CHERRY)
          (CRAVES ANGER-44 CANTELOPE)
          (EATS LAMB MELON)
          (CRAVES PROSTATITIS-102 POTATO)
          (EATS FLOUNDER CHICKEN)
          (CRAVES HANGOVER-14 PEAR-4)
          (EATS SHRIMP TOFU-16)
          (EATS POTATO WONDERBREAD)
          (CRAVES SCIATICA-103 POTATO)
          (EATS BROCCOLI LOBSTER-3)
          (EATS TUNA MUFFIN)
          (EATS WURST GRAPEFRUIT)
          (CRAVES ANGER-95 MELON)
          (EATS KALE TOFU)
          (EATS CHERRY LOBSTER)
          (EATS SCALLOP CHICKEN-8)
          (EATS BROCCOLI ARUGULA)
          (EATS LEMON LETTUCE)
          (CRAVES PROSTATITIS-114 KALE)
          (EATS HAM LAMB-6)
          (LOCALE OKRA OREGON)
          (EATS WURST SCALLOP)
          (EATS HOTDOG SWEETROLL)
          (EATS BAGUETTE MELON)
          (EATS CANTELOPE WURST)
          (EATS PORK PEAR)
          (EATS PEAR-4 GUAVA)
          (LOCALE YOGURT OREGON)
          (EATS HAM CHICKEN-8)
          (CRAVES LACERATION-9 BEEF)
          (EATS LAMB CANTELOPE)
          (EATS TOFU KALE)
          (CRAVES ANGER-66 CHERRY)
          (CRAVES ANXIETY-69 COD)
          (EATS HAROSET GRAPEFRUIT)
          (EATS PAPAYA PISTACHIO)
          (EATS TUNA PEA)
          (EATS CHERRY TUNA)
          (CRAVES ABRASION LAMB-6)
          (LOCALE TOFU-16 GUANABARA)
          (CRAVES SCIATICA-49 PAPAYA)
          (CRAVES GRIEF-35 PORK)
          (EATS CUCUMBER-1 APPLE)
          (EATS TOFU CHERRY)
          (EATS CHICKEN FLOUNDER)
          (LOCALE LOBSTER GUANABARA)
          (ATTACKS BOSNIA GUANABARA)
          (EATS ARUGULA-5 POPOVER)
          (LOCALE CHOCOLATE BOSNIA)
          (CRAVES PROSTATITIS-252 BROCCOLI)
          (CRAVES EXPECTATION TOMATO)
          (CRAVES ANXIETY-11 YOGURT-2)
          (LOCALE ARUGULA-5 OREGON)
          (EATS PORK CUCUMBER)
          (EATS PISTACHIO PAPAYA)
          (CRAVES CURIOSITY LAMB)
          (CRAVES PROSTATITIS-74 ORANGE)
          (EATS FLOUNDER BACON)
          (CRAVES BOILS-27 ARUGULA)
          (CRAVES LACERATION-89 MARZIPAN)
          (EATS POPOVER WURST)
          (LOCALE YOGURT-2 KENTUCKY)
          (CRAVES BOILS-113 SNICKERS)
          (EATS OKRA HAROSET)
          (EATS LEMON MARZIPAN)
          (LOCALE ARUGULA BOSNIA)
          (EATS CUCUMBER-1 BEEF)
          (LOCALE APPLE KENTUCKY)
          (EATS MELON PEAR-4)
          (EATS SCALLION BAGUETTE)
          (CRAVES DEPRESSION ARUGULA-5)
          (EATS LOBSTER CHERRY)
          (LOCALE MELON KENTUCKY)
          (EATS CHERRY LEMON)
          (EATS CUCUMBER PEAR)
          (EATS LEMON TOFU)
          (EATS BROCCOLI HAROSET)
          (EATS LOBSTER WURST)
          (CRAVES LACERATION-72 FLOUNDER)
          (LOCALE SWEETROLL BOSNIA)
          (LOCALE BAGUETTE BOSNIA)
          (CRAVES DREAD-60 ONION)
          (CRAVES ABRASION-110 YOGURT)
          (CRAVES LONELINESS-64 MUTTON)
          (CRAVES ANGER-115 KALE)
          (CRAVES DEPRESSION-39 LETTUCE)
          (EATS HAMBURGER LETTUCE)
          (EATS CHICKEN ARUGULA)
          (EATS MARZIPAN TURKEY)
          (EATS HAROSET BROCCOLI)
          (CRAVES HANGOVER-40 SWEETROLL)
          (CRAVES HANGOVER-57 ONION)
          (CRAVES DEPRESSION-65 OKRA)
          (LOCALE FLOUNDER OREGON)
          (EATS MELON LAMB)
          (EATS CUCUMBER-1 WURST)
          (CRAVES ANXIETY-37 LETTUCE)
          (HARMONY ENTERTAINMENT VULCAN)
          (LOCALE CUCUMBER-1 OREGON)
          (EATS POPOVER ARUGULA-5)
          (CRAVES AESTHETICS SNICKERS)
          (CRAVES ANXIETY-73 FLOUNDER)
          (CRAVES PROSTATITIS-93 PEA)
          (EATS CHERRY PEAR)
          (CRAVES HANGOVER-70 FLOUNDER)
          (EATS HAMBURGER ONION)
          (EATS SHRIMP LOBSTER)
          (CRAVES LACERATION-106 TUNA)
          (CRAVES ANGER-54 MUFFIN)
          (LOCALE PEPPER OREGON)
          (CRAVES LONELINESS-10 YOGURT-2)
          (EATS POTATO HOTDOG)
          (EATS SWEETROLL HOTDOG)
          (EATS POPOVER COD)
          (LOCALE TOFU BOSNIA)
          (EATS SCALLION MARZIPAN)
          (EATS CHERRY KALE)
          (EATS TUNA CHERRY)
          (CRAVES BOILS ARUGULA-5)
          (CRAVES ANGINA-76 ORANGE)
          (CRAVES BOILS-59 ONION)
          (LOCALE ONION BOSNIA)
          (CRAVES ABRASION-34 PORK)
          (EATS WURST POPOVER)
          (EATS WONDERBREAD POTATO)
          (CRAVES ANGINA-45 CANTELOPE)
          (EATS LEMON PEPPER)
          (EATS POTATO TOMATO)
          (EATS HAROSET WONDERBREAD)
          (EATS YOGURT LAMB)
          (EATS SCALLION BACON)
          (EATS MARZIPAN BACON)
          (CRAVES JEALOUSY-109 YOGURT)
          (EATS FLOUNDER TURKEY)
          (CRAVES LACERATION-20 RICE)
          (CRAVES ABRASION-47 GUAVA)
          (CRAVES ANGINA-28 ARUGULA)
          (LOCALE CUCUMBER OREGON)
          (EATS MELON BAGUETTE)
          (CRAVES GRIEF-67 CHERRY)
          (EATS RICE HAROSET)
          (CRAVES DREAD-33 PORK)
          (EATS WURST CUCUMBER-1)
          (CRAVES ANGINA-71 FLOUNDER)
          (EATS SWEETROLL PAPAYA)
          (CRAVES ABRASION-61 MUTTON)
          (EATS HAMBURGER KALE)
          (LOCALE ORANGE BOSNIA)
          (EATS HAROSET RICE)
          (EATS APPLE CUCUMBER-1)
          (EATS POPOVER ORANGE)
          (EATS CUCUMBER TURKEY)
          (EATS WURST BEEF)
          (LOCALE MARZIPAN BOSNIA)
          (EATS PEA TUNA)
          (EATS OKRA SNICKERS)
          (EATS PEAR-4 MELON)
          (CRAVES HANGOVER-19 RICE)
          (EATS CHICKEN-8 HAM)
          (CRAVES DREAD-46 CANTELOPE)
          (LOCALE KALE OREGON)
          (CRAVES HANGOVER ARUGULA-5)
          (LOCALE SCALLION BOSNIA)
          (LOCALE LETTUCE OREGON)
          (EATS ARUGULA CHICKEN)
          (EATS COD PEA)
          (EATS GRAPEFRUIT WURST)
          (EATS POTATO ORANGE)
          (CRAVES LEARNING PEA)
          (CRAVES DREAD-91 PEA)
          (CRAVES LACERATION-52 TOFU)
          (LOCALE SNICKERS-7 OREGON)
          (EATS SNICKERS-7 YOGURT)
          (CRAVES ANGER-111 SNICKERS)
          (CRAVES DREAD-127 WONDERBREAD)
          (CRAVES GRIEF-85 HAROSET)
          (LOCALE ENDIVE GUANABARA)
          (EATS LOBSTER-3 CHOCOLATE)
          (EATS CHERRY MUFFIN)
          (EATS POPOVER PEA)
          (CRAVES ABRASION-99 CHOCOLATE)
          (CRAVES SCIATICA-98 CHOCOLATE)
          (EATS TOMATO POTATO)
          (CRAVES DEPRESSION-117 KALE)
          (EATS MUFFIN MUTTON)
          (EATS MUFFIN CHERRY)
          (CRAVES GRIEF-86 HAROSET)
          (CRAVES JEALOUSY-97 SCALLOP)
          (EATS BACON MARZIPAN)
          (HARMONY AESTHETICS NEPTUNE)
          (CRAVES LONELINESS-253 BROCCOLI)
          (EATS CHERRY TOFU-16)
          (LOCALE LAMB BOSNIA)
          (EATS HOTDOG POTATO)
          (EATS TUNA APPLE)
          (EATS CHOCOLATE GUAVA)
          (CRAVES DEPRESSION-90 PEA)
          (LOCALE LOBSTER-3 GUANABARA)
          (CRAVES BOILS-43 HOTDOG)
          (CRAVES LONELINESS-56 MUFFIN)
          (CRAVES PROSTATITIS-22 CUCUMBER)
          (CRAVES PROSTATITIS-15 LOBSTER-3)
          (CRAVES LONELINESS-105 LOBSTER)
          (CRAVES LONELINESS-120 LEMON)
          (EATS TOMATO GRAPEFRUIT)
          (CRAVES ENTERTAINMENT YOGURT)
          (EATS MARZIPAN LEMON)
          (HARMONY EMPATHY NEPTUNE)
          (CRAVES GRIEF-124 WONDERBREAD)
          (LOCALE SCALLOP OREGON)
          (EATS PEPPER ENDIVE)
          (EATS TOFU-16 CHERRY)
          (EATS WURST ONION)
          (LOCALE CHICKEN KENTUCKY)
          (EATS SCALLOP LAMB)
          (EATS POTATO POPOVER)
          (EATS GUAVA CHOCOLATE)
          (EATS LAMB-6 RICE)
          (CRAVES LACERATION-68 CHERRY))
   (:GOAL (AND (CRAVES DREAD-104 COD))))

(DEFINE (PROBLEM MYSTY-34)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS BEEF-23 SNICKERS-27 KALE-26 ARUGULA-25
             POPOVER-24 SCALLION-28 SHRIMP-29 ENDIVE-30
             CHICKEN-31 HAROSET-32 HAMBURGER-9 RICE-10 HOTDOG-11
             LOBSTER-12 BROCCOLI-13 TURKEY-14 LEMON-15
             CUCUMBER-16 GUAVA-5 PAPAYA-6 SCALLOP-7 OKRA-8 PEAR-3
             FLOUNDER-4 CHOCOLATE-1 PEPPER-2 RICE WURST PEAR ENDIVE
             PORK TURKEY OKRA HAMBURGER GRAPEFRUIT LEMON BEEF
             POPOVER HAROSET ONION MUTTON LOBSTER MUFFIN SCALLOP
             GUAVA TOMATO LETTUCE HAM SWEETROLL TOFU PEA
             CHOCOLATE ORANGE BROCCOLI HOTDOG APPLE LAMB BACON
             PISTACHIO SHRIMP PAPAYA POTATO SNICKERS WONDERBREAD
             CHICKEN MELON YOGURT BAGUETTE MARZIPAN PEPPER
             CHERRY CANTELOPE CUCUMBER COD SCALLION KALE
             ARUGULA TUNA FLOUNDER - FOOD
             EMPATHY SATIETY AESTHETICS UNDERSTANDING LEARNING
             ACHIEVEMENT TRIUMPH EXCITEMENT LUBRICITY LOVE
             EXPECTATION STIMULATION CURIOSITY SATISFACTION
             ENTERTAINMENT INTOXICATION REST INTOXICATION-22 LOVE-21
             - PLEASURE
             DREAD LONELINESS ABRASION GRIEF LACERATION BOILS
             ANXIETY SCIATICA ANGER PROSTATITIS DEPRESSION
             HANGOVER JEALOUSY BOILS-17 GRIEF-18 JEALOUSY-19
             HANGOVER-20 ANGINA ANXIETY-60 ANGER-61 DREAD-62
             ANGINA-63 SCIATICA-64 PROSTATITIS-55 LONELINESS-56
             LACERATION-57 ABRASION-58 DEPRESSION-59 PROSTATITIS-52
             DEPRESSION-53 GRIEF-54 ABRASION-49 ANGER-50
             LACERATION-51 ANGINA-47 ANXIETY-48 SCIATICA-44
             JEALOUSY-45 DREAD-46 PROSTATITIS-40 BOILS-41
             HANGOVER-42 LONELINESS-43 ANXIETY-37 HANGOVER-38
             ANGER-39 JEALOUSY-34 BOILS-35 DREAD-36 ANGINA-33
             SCIATICA-124 LONELINESS-125 DEPRESSION-126 GRIEF-127
             LACERATION-128 ABRASION-123 ANGINA-119 HANGOVER-120
             DREAD-121 ANGER-122 LACERATION-117 PROSTATITIS-118
             ANXIETY-115 SCIATICA-116 ABRASION-111 BOILS-112
             JEALOUSY-113 LONELINESS-114 LONELINESS-108
             DEPRESSION-109 GRIEF-110 ANGER-104 GRIEF-105
             DEPRESSION-106 ANGINA-107 HANGOVER-102 BOILS-103
             LACERATION-100 ABRASION-101 DREAD-96 JEALOUSY-97
             ANXIETY-98 PROSTATITIS-99 ANGER-92 LONELINESS-93
             PROSTATITIS-94 SCIATICA-95 DEPRESSION-89 ANGINA-90
             GRIEF-91 HANGOVER-88 BOILS-86 ABRASION-87
             LACERATION-82 SCIATICA-83 JEALOUSY-84 ANXIETY-85
             DREAD-81 BOILS-78 DEPRESSION-79 JEALOUSY-80
             ABRASION-76 HANGOVER-77 ANGER-74 ANGINA-75
             PROSTATITIS-72 LACERATION-73 GRIEF-69 ANXIETY-70
             DREAD-71 ANGINA-66 SCIATICA-67 LONELINESS-68
             HANGOVER-254 PROSTATITIS-255 ANGER-256 BOILS-65
             JEALOUSY-250 ANXIETY-251 DEPRESSION-252 GRIEF-253
             - PAIN
             SURREY QUEBEC ALSACE KENTUCKY BOSNIA OREGON
             PENNSYLVANIA BAVARIA GUANABARA GOIAS MORAVIA ARIZONA
             MANITOBA - PROVINCE
             JUPITER EARTH MERCURY VENUS - PLANET)
   (:INIT (CRAVES GRIEF-54 PEPPER-2)
          (EATS PISTACHIO POTATO)
          (CRAVES ANGINA-33 HAROSET)
          (LOCALE SCALLION-28 BAVARIA)
          (LOCALE ARUGULA BOSNIA)
          (EATS TURKEY-14 FLOUNDER)
          (CRAVES ABRASION-111 HAM)
          (EATS ARUGULA-25 BEEF-23)
          (EATS PISTACHIO SNICKERS)
          (CRAVES BOILS-112 HAM)
          (EATS LOBSTER CHICKEN-31)
          (EATS SHRIMP-29 GRAPEFRUIT)
          (CRAVES HANGOVER-38 GRAPEFRUIT)
          (CRAVES JEALOUSY-250 FLOUNDER)
          (EATS PEA CANTELOPE)
          (EATS SCALLOP KALE)
          (EATS HAM YOGURT)
          (EATS TUNA FLOUNDER)
          (EATS FLOUNDER TURKEY-14)
          (CRAVES HANGOVER-88 POTATO)
          (EATS BAGUETTE TURKEY-14)
          (EATS OKRA CUCUMBER)
          (EATS CHICKEN-31 PEPPER-2)
          (EATS GUAVA-5 BAGUETTE)
          (EATS COD ARUGULA)
          (CRAVES LOVE GUAVA)
          (EATS GUAVA BROCCOLI-13)
          (EATS POPOVER SNICKERS)
          (EATS BAGUETTE CUCUMBER)
          (CRAVES JEALOUSY-97 LAMB)
          (EATS SHRIMP GUAVA-5)
          (EATS CANTELOPE HOTDOG)
          (CRAVES DREAD-36 BEEF)
          (EATS POTATO PISTACHIO)
          (LOCALE LOBSTER-12 MORAVIA)
          (ATTACKS GUANABARA GOIAS)
          (EATS FLOUNDER-4 POPOVER)
          (CRAVES ANXIETY-115 GUAVA)
          (CRAVES HANGOVER-20 GUAVA-5)
          (ATTACKS QUEBEC ALSACE)
          (EATS KALE-26 ARUGULA-25)
          (HARMONY LEARNING VENUS)
          (CRAVES SCIATICA-124 ONION)
          (EATS COD PEPPER-2)
          (EATS HAROSET MUTTON)
          (EATS CANTELOPE SWEETROLL)
          (EATS SCALLION SCALLOP)
          (LOCALE MUFFIN ARIZONA)
          (EATS TURKEY-14 BAGUETTE)
          (EATS SCALLOP-7 WONDERBREAD)
          (EATS LEMON FLOUNDER)
          (CRAVES ANGINA-47 PEAR)
          (EATS LEMON-15 COD)
          (LOCALE COD GOIAS)
          (EATS PEA LAMB)
          (EATS BAGUETTE CHICKEN)
          (CRAVES PROSTATITIS-40 HAMBURGER)
          (EATS PAPAYA MUTTON)
          (EATS HAMBURGER-9 SCALLION-28)
          (LOCALE ENDIVE PENNSYLVANIA)
          (CRAVES ANXIETY-98 LAMB)
          (HARMONY LUBRICITY VENUS)
          (LOCALE MARZIPAN OREGON)
          (EATS FLOUNDER CHICKEN)
          (EATS BROCCOLI POTATO)
          (LOCALE OKRA-8 ALSACE)
          (EATS ENDIVE CUCUMBER-16)
          (CRAVES ACHIEVEMENT PAPAYA-6)
          (LOCALE LOBSTER BOSNIA)
          (EATS COD KALE)
          (LOCALE CHICKEN MANITOBA)
          (EATS CUCUMBER OKRA)
          (EATS PORK CANTELOPE)
          (LOCALE RICE GOIAS)
          (EATS WURST RICE)
          (EATS MUFFIN COD)
          (LOCALE LEMON-15 OREGON)
          (CRAVES EXCITEMENT MUTTON)
          (HARMONY REST MERCURY)
          (LOCALE GRAPEFRUIT BAVARIA)
          (LOCALE SCALLOP BAVARIA)
          (EATS MUFFIN BROCCOLI-13)
          (EATS CUCUMBER GUAVA)
          (EATS ARUGULA CHERRY)
          (EATS HAROSET APPLE)
          (CRAVES SCIATICA-83 YOGURT)
          (CRAVES LACERATION-117 SCALLOP)
          (EATS PISTACHIO ENDIVE)
          (EATS LOBSTER OKRA-8)
          (CRAVES ABRASION-101 BROCCOLI)
          (EATS BEEF-23 SNICKERS-27)
          (EATS PAPAYA KALE)
          (EATS PAPAYA OKRA)
          (LOCALE ORANGE PENNSYLVANIA)
          (CRAVES LOVE-21 CUCUMBER)
          (EATS APPLE SHRIMP)
          (CRAVES JEALOUSY-113 HAM)
          (EATS SNICKERS POPOVER)
          (HARMONY CURIOSITY MERCURY)
          (EATS KALE-26 SNICKERS-27)
          (LOCALE SHRIMP-29 SURREY)
          (EATS POTATO ENDIVE)
          (EATS LOBSTER CHOCOLATE)
          (LOCALE WURST ALSACE)
          (EATS FLOUNDER LEMON)
          (EATS GRAPEFRUIT SHRIMP-29)
          (EATS APPLE HAROSET)
          (LOCALE PORK PENNSYLVANIA)
          (EATS COD OKRA-8)
          (CRAVES ANXIETY HAMBURGER-9)
          (CRAVES ANGER-74 CHERRY)
          (LOCALE CUCUMBER BOSNIA)
          (HARMONY SATISFACTION VENUS)
          (HARMONY AESTHETICS VENUS)
          (CRAVES ANGINA-63 SCALLOP-7)
          (EATS LEMON SCALLION)
          (LOCALE KALE MORAVIA)
          (EATS HAMBURGER APPLE)
          (EATS ORANGE TOMATO)
          (EATS COD LEMON-15)
          (EATS CHERRY GRAPEFRUIT)
          (CRAVES LACERATION-73 CUCUMBER)
          (CRAVES DEPRESSION RICE-10)
          (EATS TOMATO BROCCOLI)
          (CRAVES GRIEF-127 ONION)
          (EATS POPOVER TUNA)
          (CRAVES JEALOUSY-19 GUAVA-5)
          (EATS RICE CHOCOLATE)
          (LOCALE GUAVA-5 QUEBEC)
          (EATS POPOVER FLOUNDER-4)
          (CRAVES INTOXICATION WONDERBREAD)
          (HARMONY EMPATHY EARTH)
          (EATS TURKEY BEEF)
          (CRAVES ANXIETY-37 GRAPEFRUIT)
          (LOCALE PISTACHIO ARIZONA)
          (EATS BACON TOFU)
          (CRAVES DREAD-46 ENDIVE)
          (EATS MARZIPAN FLOUNDER-4)
          (EATS SHRIMP SCALLION)
          (EATS CANTELOPE PEA)
          (EATS HOTDOG LAMB)
          (EATS CHICKEN-31 LOBSTER)
          (EATS MUFFIN SNICKERS-27)
          (EATS HOTDOG-11 BACON)
          (CRAVES SATIETY KALE-26)
          (CRAVES EXPECTATION LETTUCE)
          (LOCALE BROCCOLI BOSNIA)
          (EATS YOGURT PISTACHIO)
          (EATS FLOUNDER CUCUMBER-16)
          (LOCALE CHERRY BOSNIA)
          (CRAVES PROSTATITIS-52 PEPPER-2)
          (EATS MUTTON PAPAYA)
          (EATS RICE WURST)
          (CRAVES DEPRESSION-106 CHOCOLATE)
          (CRAVES GRIEF-18 GUAVA-5)
          (CRAVES BOILS HAMBURGER-9)
          (EATS SCALLION-28 SNICKERS)
          (EATS HAROSET SCALLOP)
          (HARMONY EXCITEMENT EARTH)
          (EATS CHERRY PEPPER)
          (EATS CANTELOPE POTATO)
          (EATS SWEETROLL CANTELOPE)
          (EATS LAMB HOTDOG)
          (EATS BAGUETTE GUAVA-5)
          (EATS ORANGE LETTUCE)
          (CRAVES ANGER-61 SCALLOP-7)
          (EATS PAPAYA-6 CHERRY)
          (CRAVES LONELINESS-108 PEA)
          (EATS PISTACHIO TUNA)
          (CRAVES PROSTATITIS-55 CHOCOLATE-1)
          (EATS YOGURT LOBSTER-12)
          (CRAVES TRIUMPH OKRA-8)
          (EATS BROCCOLI YOGURT)
          (EATS SCALLOP SCALLION)
          (ATTACKS SURREY QUEBEC)
          (ATTACKS BAVARIA GUANABARA)
          (EATS APPLE HAMBURGER)
          (CRAVES LEARNING TURKEY-14)
          (EATS HAROSET-32 CUCUMBER)
          (CRAVES LONELINESS-68 KALE)
          (LOCALE BACON BAVARIA)
          (CRAVES CURIOSITY PISTACHIO)
          (EATS SNICKERS SCALLION-28)
          (EATS COD LOBSTER-12)
          (EATS SHRIMP APPLE)
          (CRAVES SATISFACTION SHRIMP)
          (EATS BACON HOTDOG-11)
          (EATS SCALLION SHRIMP)
          (CRAVES DEPRESSION-53 PEPPER-2)
          (EATS MUFFIN KALE)
          (EATS FLOUNDER-4 WONDERBREAD)
          (LOCALE OKRA MORAVIA)
          (EATS PAPAYA-6 POPOVER)
          (CRAVES GRIEF HAROSET-32)
          (ATTACKS ARIZONA MANITOBA)
          (EATS HOTDOG-11 SNICKERS)
          (EATS KALE-26 BEEF-23)
          (LOCALE PEA OREGON)
          (EATS ENDIVE-30 HAMBURGER-9)
          (EATS TOMATO ORANGE)
          (CRAVES PROSTATITIS-94 SHRIMP)
          (EATS TUNA POPOVER)
          (ATTACKS MORAVIA ARIZONA)
          (EATS LEMON-15 PEAR)
          (CRAVES BOILS-103 ORANGE)
          (EATS HAMBURGER SCALLION)
          (LOCALE PEPPER-2 BOSNIA)
          (LOCALE GUAVA GUANABARA)
          (CRAVES ABRASION-87 MELON)
          (CRAVES DEPRESSION-126 ONION)
          (CRAVES ANGINA-66 KALE)
          (CRAVES LONELINESS-56 CHOCOLATE-1)
          (CRAVES BOILS-78 MARZIPAN)
          (EATS MARZIPAN TURKEY)
          (EATS SNICKERS-27 MUFFIN)
          (CRAVES JEALOUSY-34 BEEF)
          (EATS PEPPER CHERRY)
          (CRAVES BOILS-17 GUAVA-5)
          (EATS FLOUNDER TUNA)
          (CRAVES PROSTATITIS-72 CUCUMBER)
          (EATS PORK ORANGE)
          (CRAVES HANGOVER RICE-10)
          (EATS KALE COD)
          (LOCALE TURKEY SURREY)
          (LOCALE CHOCOLATE-1 BAVARIA)
          (CRAVES JEALOUSY-84 YOGURT)
          (EATS ENDIVE POTATO)
          (EATS MELON PEAR-3)
          (LOCALE BEEF-23 BAVARIA)
          (LOCALE SHRIMP BOSNIA)
          (CRAVES LONELINESS-125 ONION)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (CRAVES JEALOUSY RICE-10)
          (CRAVES AESTHETICS SCALLION-28)
          (EATS CUCUMBER HAROSET-32)
          (EATS SCALLION LEMON)
          (EATS BROCCOLI-13 MUFFIN)
          (EATS HOTDOG MELON)
          (EATS SNICKERS-27 BEEF-23)
          (EATS POTATO YOGURT)
          (EATS LAMB BAGUETTE)
          (CRAVES REST CHERRY)
          (EATS MELON HOTDOG)
          (EATS SCALLOP HAROSET)
          (EATS CHOCOLATE YOGURT)
          (EATS PEAR LEMON-15)
          (HARMONY UNDERSTANDING EARTH)
          (ATTACKS OREGON PENNSYLVANIA)
          (EATS CHICKEN BAGUETTE)
          (CRAVES HANGOVER-42 HAMBURGER)
          (LOCALE POPOVER-24 PENNSYLVANIA)
          (EATS LETTUCE LEMON-15)
          (LOCALE WONDERBREAD ALSACE)
          (EATS BROCCOLI-13 GUAVA)
          (LOCALE KALE-26 OREGON)
          (EATS POPOVER-24 SNICKERS-27)
          (EATS HAM TOFU)
          (EATS HAMBURGER-9 ENDIVE-30)
          (EATS PEPPER-2 COD)
          (LOCALE APPLE BOSNIA)
          (LOCALE POTATO KENTUCKY)
          (EATS SCALLION HAMBURGER)
          (CRAVES ANGER-256 ARUGULA)
          (CRAVES ANGER-122 MUFFIN)
          (EATS YOGURT CHOCOLATE)
          (EATS GRAPEFRUIT CHERRY)
          (CRAVES ANXIETY-70 SCALLION)
          (EATS PEAR-3 BAGUETTE)
          (CRAVES LACERATION-100 BROCCOLI)
          (LOCALE LEMON BAVARIA)
          (LOCALE PEAR BOSNIA)
          (CRAVES DEPRESSION-252 FLOUNDER)
          (EATS PEAR ORANGE)
          (CRAVES ANGINA-107 CHOCOLATE)
          (CRAVES ANGER-92 SHRIMP)
          (CRAVES DREAD-81 BAGUETTE)
          (CRAVES HANGOVER-254 ARUGULA)
          (CRAVES SCIATICA-67 KALE)
          (CRAVES ANGINA-90 PAPAYA)
          (EATS RICE-10 LETTUCE)
          (EATS SWEETROLL ORANGE)
          (EATS ENDIVE-30 BACON)
          (HARMONY ENTERTAINMENT VENUS)
          (EATS SNICKERS-27 KALE-26)
          (LOCALE FLOUNDER-4 BAVARIA)
          (CRAVES PROSTATITIS-255 ARUGULA)
          (CRAVES ANXIETY-85 YOGURT)
          (EATS LETTUCE ORANGE)
          (LOCALE YOGURT GUANABARA)
          (EATS CHOCOLATE-1 CHICKEN)
          (LOCALE HAMBURGER-9 BAVARIA)
          (EATS LEMON-15 LETTUCE)
          (HARMONY INTOXICATION-22 EARTH)
          (CRAVES BOILS-35 BEEF)
          (EATS OKRA-8 COD)
          (EATS ORANGE PORK)
          (CRAVES DEPRESSION-79 MARZIPAN)
          (CRAVES LACERATION-57 CHOCOLATE-1)
          (EATS CHICKEN CHOCOLATE-1)
          (EATS CANTELOPE PORK)
          (EATS BEEF TURKEY)
          (HARMONY INTOXICATION VENUS)
          (CRAVES BOILS-41 HAMBURGER)
          (ORBITS MERCURY VENUS)
          (LOCALE TUNA ARIZONA)
          (EATS PEAR-3 MELON)
          (EATS TOFU BACON)
          (EATS WONDERBREAD MARZIPAN)
          (EATS ARUGULA-25 POPOVER-24)
          (LOCALE MUTTON BAVARIA)
          (EATS GRAPEFRUIT CHOCOLATE)
          (EATS CUCUMBER-16 FLOUNDER)
          (LOCALE HAROSET BAVARIA)
          (EATS SHRIMP-29 ARUGULA)
          (LOCALE HAROSET-32 GOIAS)
          (EATS MUFFIN HAROSET-32)
          (CRAVES JEALOUSY-80 MARZIPAN)
          (EATS BROCCOLI CANTELOPE)
          (HARMONY TRIUMPH MERCURY)
          (CRAVES LACERATION-128 ONION)
          (CRAVES ANGER-39 GRAPEFRUIT)
          (CRAVES ENTERTAINMENT SNICKERS)
          (EATS CHOCOLATE RICE)
          (EATS ARUGULA SHRIMP-29)
          (HARMONY EXPECTATION VENUS)
          (CRAVES EMPATHY SNICKERS-27)
          (EATS COD PEAR)
          (LOCALE SCALLION BAVARIA)
          (CRAVES ANXIETY-251 FLOUNDER)
          (CRAVES STIMULATION APPLE)
          (EATS LETTUCE RICE-10)
          (EATS LOBSTER-12 COD)
          (HARMONY SATIETY MERCURY)
          (EATS LETTUCE PORK)
          (EATS PEPPER TUNA)
          (CRAVES PROSTATITIS-118 SCALLOP)
          (EATS POPOVER-24 BACON)
          (EATS MUTTON HAROSET)
          (LOCALE BAGUETTE MORAVIA)
          (EATS LEMON-15 GUAVA)
          (EATS LAMB PEA)
          (CRAVES DEPRESSION-109 PEA)
          (EATS COD MUFFIN)
          (EATS ARUGULA-25 KALE-26)
          (CRAVES ANGINA-119 MUFFIN)
          (CRAVES DREAD ARUGULA-25)
          (CRAVES INTOXICATION-22 CANTELOPE)
          (CRAVES ANGER RICE-10)
          (EATS PORK LETTUCE)
          (CRAVES GRIEF-253 FLOUNDER)
          (LOCALE BROCCOLI-13 GOIAS)
          (EATS SNICKERS FLOUNDER-4)
          (EATS FLOUNDER-4 SNICKERS)
          (LOCALE CUCUMBER-16 GUANABARA)
          (CRAVES HANGOVER-102 ORANGE)
          (CRAVES PROSTATITIS RICE-10)
          (LOCALE HAM ALSACE)
          (LOCALE HOTDOG-11 ARIZONA)
          (CRAVES ABRASION-123 LOBSTER)
          (EATS GUAVA LEMON-15)
          (EATS ORANGE SWEETROLL)
          (EATS CHOCOLATE-1 ONION)
          (CRAVES PROSTATITIS-99 LAMB)
          (CRAVES BOILS-65 ARUGULA)
          (EATS HOTDOG CANTELOPE)
          (EATS BEEF-23 ARUGULA-25)
          (LOCALE SWEETROLL BAVARIA)
          (CRAVES HANGOVER-77 PEPPER)
          (EATS SCALLOP-7 CHERRY)
          (CRAVES LACERATION-51 RICE)
          (EATS POTATO ONION)
          (EATS ARUGULA COD)
          (EATS YOGURT BROCCOLI)
          (EATS CUCUMBER-16 ENDIVE)
          (CRAVES JEALOUSY-45 ENDIVE)
          (CRAVES DREAD-71 SCALLION)
          (LOCALE ENDIVE-30 OREGON)
          (EATS WONDERBREAD FLOUNDER-4)
          (EATS CHOCOLATE BEEF)
          (EATS TOFU HAM)
          (CRAVES GRIEF-91 PAPAYA)
          (CRAVES LUBRICITY SCALLOP)
          (EATS KALE SCALLOP)
          (CRAVES ANGER-50 RICE)
          (CRAVES ABRASION POPOVER-24)
          (EATS BACON ENDIVE-30)
          (EATS GUAVA-5 SHRIMP)
          (CRAVES DREAD-96 LAMB)
          (LOCALE FLOUNDER MANITOBA)
          (EATS CUCUMBER RICE-10)
          (CRAVES DEPRESSION-59 CHOCOLATE-1)
          (LOCALE CHICKEN-31 PENNSYLVANIA)
          (LOCALE TOMATO KENTUCKY)
          (LOCALE TURKEY-14 OREGON)
          (EATS PEAR COD)
          (EATS CHICKEN LAMB)
          (HARMONY ACHIEVEMENT MERCURY)
          (CRAVES HANGOVER-120 MUFFIN)
          (LOCALE RICE-10 OREGON)
          (CRAVES ABRASION-76 PEPPER)
          (CRAVES SCIATICA-64 SCALLOP-7)
          (LOCALE MELON PENNSYLVANIA)
          (CRAVES LACERATION-82 YOGURT)
          (EATS PISTACHIO YOGURT)
          (LOCALE ONION BOSNIA)
          (CRAVES DEPRESSION-89 PAPAYA)
          (EATS SNICKERS HOTDOG-11)
          (LOCALE SNICKERS MANITOBA)
          (EATS LOBSTER-12 YOGURT)
          (ATTACKS BOSNIA OREGON)
          (EATS POTATO CANTELOPE)
          (EATS BAGUETTE PEAR-3)
          (CRAVES ANGER-104 CHOCOLATE)
          (LOCALE LAMB GUANABARA)
          (EATS TUNA PISTACHIO)
          (CRAVES ABRASION-58 CHOCOLATE-1)
          (CRAVES DREAD-121 MUFFIN)
          (CRAVES LONELINESS ARUGULA-25)
          (ATTACKS GOIAS MORAVIA)
          (CRAVES SCIATICA HAMBURGER-9)
          (LOCALE BEEF OREGON)
          (HARMONY STIMULATION EARTH)
          (EATS SNICKERS-27 POPOVER-24)
          (EATS YOGURT HAM)
          (EATS BROCCOLI TOMATO)
          (CRAVES ANXIETY-48 PEAR)
          (EATS HAROSET-32 MUFFIN)
          (EATS WURST HOTDOG-11)
          (CRAVES GRIEF-105 CHOCOLATE)
          (EATS POPOVER PAPAYA-6)
          (LOCALE POPOVER BOSNIA)
          (EATS BEEF CHOCOLATE)
          (CRAVES BOILS-86 MELON)
          (EATS RICE-10 CUCUMBER)
          (EATS WONDERBREAD SCALLOP-7)
          (EATS OKRA PAPAYA)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS GUAVA CUCUMBER)
          (EATS LAMB CHICKEN)
          (LOCALE SNICKERS-27 GOIAS)
          (LOCALE ARUGULA-25 OREGON)
          (EATS PEPPER-2 CHICKEN-31)
          (CRAVES DREAD-62 SCALLOP-7)
          (EATS YOGURT PEPPER-2)
          (EATS ONION CHOCOLATE-1)
          (LOCALE PAPAYA ARIZONA)
          (CRAVES SCIATICA-44 ENDIVE)
          (CRAVES ABRASION-49 RICE)
          (EATS ONION POTATO)
          (EATS SCALLION-28 HAMBURGER-9)
          (EATS KALE PAPAYA)
          (LOCALE PEAR-3 GOIAS)
          (ATTACKS ALSACE KENTUCKY)
          (EATS BEEF-23 KALE-26)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS CHOCOLATE GRAPEFRUIT)
          (EATS YOGURT POTATO)
          (EATS CHERRY ARUGULA)
          (CRAVES ANGINA-75 CHERRY)
          (EATS BAGUETTE LAMB)
          (EATS CHOCOLATE LOBSTER)
          (CRAVES SCIATICA-95 SHRIMP)
          (HARMONY LOVE-21 MERCURY)
          (CRAVES SCIATICA-116 GUAVA)
          (CRAVES ANGINA GUAVA-5)
          (EATS CUCUMBER BAGUETTE)
          (EATS POTATO BROCCOLI)
          (EATS PEPPER-2 YOGURT)
          (LOCALE SCALLOP-7 SURREY)
          (ORBITS EARTH MERCURY)
          (CRAVES UNDERSTANDING SHRIMP-29)
          (LOCALE TOFU QUEBEC)
          (CRAVES LONELINESS-114 HAM)
          (EATS TURKEY MARZIPAN)
          (LOCALE LETTUCE GOIAS)
          (CRAVES LONELINESS-43 HAMBURGER)
          (EATS MARZIPAN WONDERBREAD)
          (EATS TUNA PEPPER)
          (LOCALE PAPAYA-6 BAVARIA)
          (EATS SNICKERS PISTACHIO)
          (EATS CHERRY PAPAYA-6)
          (EATS ENDIVE PISTACHIO)
          (EATS POPOVER-24 ARUGULA-25)
          (EATS CANTELOPE BROCCOLI)
          (CRAVES GRIEF-110 PEA)
          (LOCALE PEPPER BOSNIA)
          (EATS BACON POPOVER-24)
          (EATS KALE MUFFIN)
          (CRAVES GRIEF-69 SCALLION)
          (EATS CHERRY SCALLOP-7)
          (EATS ORANGE PEAR)
          (EATS HOTDOG-11 WURST)
          (ORBITS JUPITER EARTH)
          (LOCALE HOTDOG KENTUCKY)
          (EATS FLOUNDER-4 MARZIPAN)
          (EATS CHICKEN FLOUNDER)
          (CRAVES ANXIETY-60 SCALLOP-7)
          (LOCALE CANTELOPE OREGON)
          (LOCALE HAMBURGER KENTUCKY)
          (CRAVES LONELINESS-93 SHRIMP)
          (EATS OKRA-8 LOBSTER)
          (CRAVES LACERATION HAROSET-32)
          (HARMONY LOVE VENUS))
   (:GOAL (AND (CRAVES BOILS-86 CANTELOPE)
               (CRAVES ABRASION-87 CANTELOPE)
               (CRAVES ANXIETY-115 CANTELOPE)
               (CRAVES SCIATICA-116 CANTELOPE))))

(DEFINE (PROBLEM MYSTY-35)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PEAR POPOVER GRAPEFRUIT PORK ENDIVE ORANGE
             POTATO COD YOGURT MUTTON TURKEY HAROSET KALE
             CUCUMBER PAPAYA APPLE MARZIPAN SNICKERS GUAVA
             WONDERBREAD ONION SCALLOP BROCCOLI TUNA WURST SCALLION
             MUFFIN MELON HAMBURGER PEPPER SHRIMP RICE TOMATO
             CHOCOLATE CHICKEN PEA FLOUNDER LOBSTER HAM - FOOD
             LOVE INTOXICATION EXCITEMENT REST CURIOSITY
             SATISFACTION EXPECTATION STIMULATION ACHIEVEMENT
             LEARNING UNDERSTANDING - PLEASURE
             HANGOVER ANXIETY BOILS ANGINA JEALOUSY LACERATION
             ANGER ABRASION GRIEF DEPRESSION LONELINESS DREAD
             - PAIN
             GUANABARA PENNSYLVANIA BAVARIA - PROVINCE
             JUPITER VULCAN EARTH URANUS - PLANET)
   (:INIT (CRAVES JEALOUSY TUNA)
          (EATS ONION SHRIMP)
          (CRAVES LACERATION TUNA)
          (EATS TOMATO WONDERBREAD)
          (EATS CHICKEN HAM)
          (LOCALE APPLE PENNSYLVANIA)
          (LOCALE RICE PENNSYLVANIA)
          (HARMONY SATISFACTION VULCAN)
          (EATS HAROSET MUTTON)
          (LOCALE FLOUNDER BAVARIA)
          (EATS SCALLION SNICKERS)
          (EATS PEPPER BROCCOLI)
          (HARMONY UNDERSTANDING URANUS)
          (EATS TUNA HAMBURGER)
          (LOCALE KALE PENNSYLVANIA)
          (LOCALE SNICKERS GUANABARA)
          (EATS CUCUMBER SCALLOP)
          (CRAVES HANGOVER POTATO)
          (EATS CUCUMBER YOGURT)
          (EATS ORANGE PEAR)
          (HARMONY EXPECTATION EARTH)
          (LOCALE PEPPER BAVARIA)
          (LOCALE SCALLOP GUANABARA)
          (LOCALE WURST PENNSYLVANIA)
          (EATS MUTTON APPLE)
          (LOCALE PEAR PENNSYLVANIA)
          (CRAVES EXCITEMENT POTATO)
          (CRAVES LEARNING MELON)
          (EATS PEPPER WURST)
          (CRAVES CURIOSITY APPLE)
          (EATS POTATO GRAPEFRUIT)
          (CRAVES STIMULATION BROCCOLI)
          (EATS APPLE POPOVER)
          (EATS TURKEY APPLE)
          (EATS SHRIMP FLOUNDER)
          (EATS WURST CHOCOLATE)
          (EATS SNICKERS SCALLION)
          (EATS RICE MELON)
          (LOCALE SHRIMP GUANABARA)
          (EATS MARZIPAN TURKEY)
          (EATS HAM CHICKEN)
          (EATS ONION LOBSTER)
          (HARMONY REST EARTH)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS TOMATO SCALLION)
          (EATS HAM MUFFIN)
          (EATS POPOVER PORK)
          (EATS HAROSET PAPAYA)
          (LOCALE SCALLION GUANABARA)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (LOCALE PEA GUANABARA)
          (EATS WURST PEPPER)
          (EATS BROCCOLI HAM)
          (ORBITS VULCAN EARTH)
          (LOCALE MUTTON BAVARIA)
          (HARMONY ACHIEVEMENT URANUS)
          (EATS LOBSTER ONION)
          (HARMONY CURIOSITY VULCAN)
          (EATS MELON CHOCOLATE)
          (EATS BROCCOLI PEPPER)
          (CRAVES EXPECTATION SCALLOP)
          (EATS APPLE GRAPEFRUIT)
          (EATS GRAPEFRUIT POTATO)
          (EATS GUAVA RICE)
          (EATS PEA PEPPER)
          (EATS YOGURT TURKEY)
          (EATS PORK CUCUMBER)
          (EATS ORANGE POPOVER)
          (EATS WONDERBREAD CHICKEN)
          (CRAVES UNDERSTANDING CHICKEN)
          (EATS CHOCOLATE SCALLION)
          (EATS SCALLION TOMATO)
          (EATS COD CUCUMBER)
          (EATS POPOVER APPLE)
          (EATS FLOUNDER SHRIMP)
          (LOCALE TOMATO BAVARIA)
          (EATS KALE TURKEY)
          (EATS ENDIVE POTATO)
          (LOCALE TUNA GUANABARA)
          (EATS FLOUNDER LOBSTER)
          (EATS SHRIMP ONION)
          (EATS APPLE MUTTON)
          (EATS SCALLOP CHOCOLATE)
          (EATS TURKEY YOGURT)
          (CRAVES DREAD PEA)
          (EATS MARZIPAN KALE)
          (EATS CHOCOLATE WURST)
          (HARMONY INTOXICATION URANUS)
          (CRAVES REST KALE)
          (EATS SCALLOP BROCCOLI)
          (EATS HAMBURGER SNICKERS)
          (EATS BROCCOLI MUFFIN)
          (EATS COD PAPAYA)
          (EATS CHOCOLATE SCALLOP)
          (EATS HAMBURGER TOMATO)
          (LOCALE CHICKEN BAVARIA)
          (EATS CHOCOLATE HAMBURGER)
          (EATS PAPAYA HAROSET)
          (LOCALE PAPAYA GUANABARA)
          (EATS SNICKERS HAMBURGER)
          (EATS RICE CHICKEN)
          (EATS TOMATO SHRIMP)
          (EATS MUTTON PEAR)
          (CRAVES ABRASION HAMBURGER)
          (ORBITS JUPITER VULCAN)
          (EATS HAROSET CUCUMBER)
          (LOCALE HAROSET GUANABARA)
          (CRAVES GRIEF HAMBURGER)
          (EATS POTATO ENDIVE)
          (EATS PORK POPOVER)
          (EATS CHOCOLATE MELON)
          (LOCALE GUAVA GUANABARA)
          (EATS GUAVA SCALLION)
          (EATS MUFFIN PEPPER)
          (ORBITS EARTH URANUS)
          (LOCALE ENDIVE PENNSYLVANIA)
          (LOCALE BROCCOLI PENNSYLVANIA)
          (EATS TOMATO HAMBURGER)
          (EATS TUNA FLOUNDER)
          (HARMONY EXCITEMENT VULCAN)
          (CRAVES LOVE POPOVER)
          (EATS HAMBURGER CHOCOLATE)
          (LOCALE HAM GUANABARA)
          (EATS TOMATO LOBSTER)
          (CRAVES ANGER TUNA)
          (LOCALE POTATO GUANABARA)
          (EATS YOGURT CUCUMBER)
          (LOCALE POPOVER GUANABARA)
          (EATS MUTTON HAROSET)
          (LOCALE CUCUMBER PENNSYLVANIA)
          (EATS MUFFIN HAM)
          (LOCALE GRAPEFRUIT PENNSYLVANIA)
          (CRAVES SATISFACTION GUAVA)
          (EATS YOGURT ENDIVE)
          (HARMONY STIMULATION EARTH)
          (CRAVES ACHIEVEMENT WURST)
          (EATS CHICKEN WONDERBREAD)
          (CRAVES INTOXICATION ORANGE)
          (LOCALE PORK GUANABARA)
          (LOCALE YOGURT GUANABARA)
          (EATS PEPPER PEA)
          (EATS GRAPEFRUIT APPLE)
          (EATS SCALLION CHOCOLATE)
          (EATS TURKEY MARZIPAN)
          (CRAVES LONELINESS CHICKEN)
          (LOCALE TURKEY PENNSYLVANIA)
          (EATS YOGURT KALE)
          (EATS MELON RICE)
          (EATS WONDERBREAD TOMATO)
          (EATS SHRIMP TOMATO)
          (LOCALE HAMBURGER PENNSYLVANIA)
          (LOCALE ORANGE GUANABARA)
          (EATS SCALLOP CUCUMBER)
          (EATS PAPAYA COD)
          (EATS CUCUMBER KALE)
          (EATS HAMBURGER TUNA)
          (EATS BROCCOLI SCALLOP)
          (EATS MUFFIN BROCCOLI)
          (HARMONY LEARNING URANUS)
          (EATS PEAR ORANGE)
          (EATS POPOVER ORANGE)
          (LOCALE WONDERBREAD GUANABARA)
          (LOCALE LOBSTER BAVARIA)
          (EATS CUCUMBER PORK)
          (EATS SCALLION GUAVA)
          (EATS MELON HAM)
          (CRAVES ANXIETY COD)
          (EATS PEAR MUTTON)
          (EATS KALE YOGURT)
          (EATS KALE MARZIPAN)
          (EATS PEA MUFFIN)
          (LOCALE MELON GUANABARA)
          (LOCALE ONION BAVARIA)
          (HARMONY LOVE URANUS)
          (LOCALE COD GUANABARA)
          (EATS HAM MELON)
          (EATS ORANGE HAROSET)
          (EATS APPLE TURKEY)
          (EATS PEPPER MUFFIN)
          (EATS TURKEY KALE)
          (EATS LOBSTER FLOUNDER)
          (CRAVES DEPRESSION PEPPER)
          (EATS ENDIVE YOGURT)
          (CRAVES BOILS COD)
          (CRAVES ANGINA SCALLOP)
          (EATS FLOUNDER TUNA)
          (LOCALE MUFFIN GUANABARA)
          (EATS HAROSET ORANGE)
          (EATS CHICKEN RICE)
          (EATS CUCUMBER HAROSET)
          (ATTACKS GUANABARA PENNSYLVANIA)
          (EATS RICE GUAVA)
          (EATS KALE CUCUMBER)
          (EATS CUCUMBER COD)
          (EATS LOBSTER TOMATO)
          (EATS HAM BROCCOLI)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (EATS MUFFIN PEA))
   (:GOAL (AND (CRAVES LONELINESS HAMBURGER)
               (CRAVES GRIEF HAMBURGER)
               (CRAVES HANGOVER ONION)
               (CRAVES ANGINA MELON))))

(DEFINE (PROBLEM MYSTY-36)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PAPAYA-15 LAMB-16 TOFU-5 SNICKERS-6
             MUFFIN-7 HAM-8 TUNA-3 SHRIMP-4 WONDERBREAD-1
             BACON-2 POTATO YOGURT GRAPEFRUIT KALE BROCCOLI TUNA
             BACON FLOUNDER PISTACHIO OKRA LEMON MARZIPAN BEEF
             HAMBURGER SCALLOP LAMB TOFU CANTELOPE LOBSTER HOTDOG
             SWEETROLL WONDERBREAD BAGUETTE ORANGE HAM PEPPER
             SCALLION MELON COD PEA APPLE CHERRY TOMATO PAPAYA
             TURKEY CUCUMBER WURST ARUGULA ONION RICE GUAVA
             POPOVER PEAR CHOCOLATE LETTUCE MUTTON SHRIMP ENDIVE
             SNICKERS CHICKEN MUFFIN PORK HAROSET - FOOD
             EMPATHY UNDERSTANDING REST SATISFACTION
             STIMULATION EXPECTATION INTOXICATION TRIUMPH LEARNING
             EXCITEMENT SATIETY CURIOSITY LOVE LUBRICITY
             AESTHETICS ACHIEVEMENT ENTERTAINMENT TRIUMPH-14
             LUBRICITY-13 LOVE-12 SATISFACTION-11 CURIOSITY-10
             STIMULATION-9 EXPECTATION-32 ENTERTAINMENT-31
             AESTHETICS-30 INTOXICATION-29 UNDERSTANDING-28
             ACHIEVEMENT-27 SATIETY-26 EMPATHY-25 LEARNING-24 REST-23
             EXCITEMENT-22 AESTHETICS-21 EXCITEMENT-20 REST-19
             STIMULATION-18 LEARNING-17 TRIUMPH-64 - PLEASURE
             SCIATICA GRIEF DREAD ABRASION LACERATION ANXIETY
             DEPRESSION LONELINESS ANGINA PROSTATITIS ANGER
             HANGOVER BOILS GRIEF-63 JEALOUSY ANGER-60
             HANGOVER-61 DEPRESSION-62 PROSTATITIS-57 DREAD-58
             JEALOUSY-59 SCIATICA-53 LONELINESS-54 BOILS-55
             ABRASION-56 ANXIETY-52 LACERATION-50 ANGINA-51
             ANGINA-49 JEALOUSY-45 DREAD-46 HANGOVER-47
             LACERATION-48 ANXIETY-41 GRIEF-42 ANGER-43
             PROSTATITIS-44 BOILS-40 DEPRESSION-39 ABRASION-37
             LONELINESS-38 HANGOVER-35 SCIATICA-36 PROSTATITIS-127
             ABRASION-128 ANGER-33 ANGINA-34 JEALOUSY-124
             DEPRESSION-125 GRIEF-126 LACERATION-122 BOILS-123
             LONELINESS-119 DREAD-120 ANXIETY-121 SCIATICA-118
             DREAD-116 GRIEF-117 LACERATION-115 ANGER-113
             DEPRESSION-114 ANGINA-112 PROSTATITIS-108 ANXIETY-109
             HANGOVER-110 BOILS-111 SCIATICA-105 ABRASION-106
             JEALOUSY-107 DREAD-101 ABRASION-102 PROSTATITIS-103
             LONELINESS-104 LONELINESS-98 BOILS-99 ANGINA-100
             SCIATICA-94 HANGOVER-95 DEPRESSION-96 GRIEF-97
             LACERATION-91 JEALOUSY-92 ANGER-93 LACERATION-89
             ANXIETY-90 DEPRESSION-85 ANXIETY-86 LONELINESS-87
             ANGER-88 ANGINA-82 BOILS-83 DREAD-84 JEALOUSY-80
             GRIEF-81 PROSTATITIS-77 ABRASION-78 HANGOVER-79
             ANGINA-73 BOILS-74 PROSTATITIS-75 SCIATICA-76
             ABRASION-71 SCIATICA-72 DEPRESSION-67 ANGER-68
             DREAD-69 LONELINESS-70 - PAIN
             KENTUCKY QUEBEC - PROVINCE
             MERCURY SATURN MARS JUPITER - PLANET)
   (:INIT (EATS LETTUCE ARUGULA)
          (CRAVES DREAD LAMB-16)
          (CRAVES SATIETY FLOUNDER)
          (CRAVES ACHIEVEMENT LAMB)
          (EATS HOTDOG POPOVER)
          (CRAVES EMPATHY PAPAYA-15)
          (CRAVES ANGINA-82 LETTUCE)
          (EATS BACON HAM)
          (CRAVES GRIEF-117 COD)
          (HARMONY LUBRICITY JUPITER)
          (LOCALE SCALLION KENTUCKY)
          (EATS ONION OKRA)
          (CRAVES SATISFACTION-11 ORANGE)
          (EATS CUCUMBER SNICKERS)
          (EATS TOFU MUTTON)
          (CRAVES CURIOSITY-10 HAM)
          (EATS ORANGE CANTELOPE)
          (EATS SNICKERS-6 KALE)
          (EATS SNICKERS CUCUMBER)
          (EATS CHOCOLATE PEA)
          (ORBITS MERCURY SATURN)
          (LOCALE TOFU-5 KENTUCKY)
          (CRAVES HANGOVER-47 FLOUNDER)
          (HARMONY EXPECTATION-32 MARS)
          (EATS TOFU-5 GRAPEFRUIT)
          (CRAVES DEPRESSION-96 ONION)
          (EATS POTATO KALE)
          (CRAVES HANGOVER-61 SHRIMP-4)
          (CRAVES ANXIETY-90 POPOVER)
          (CRAVES ANGER-113 CHERRY)
          (EATS POTATO PAPAYA-15)
          (HARMONY ACHIEVEMENT SATURN)
          (EATS MELON LOBSTER)
          (EATS BROCCOLI SNICKERS-6)
          (EATS OKRA PAPAYA)
          (EATS GRAPEFRUIT PAPAYA-15)
          (EATS CHOCOLATE TOMATO)
          (LOCALE HAM QUEBEC)
          (EATS PEA ENDIVE)
          (EATS POPOVER LETTUCE)
          (LOCALE LAMB-16 QUEBEC)
          (EATS ENDIVE PEA)
          (EATS SNICKERS SCALLOP)
          (HARMONY INTOXICATION SATURN)
          (LOCALE OKRA KENTUCKY)
          (LOCALE PEAR QUEBEC)
          (EATS RICE SHRIMP)
          (HARMONY STIMULATION-9 JUPITER)
          (EATS POPOVER LAMB)
          (EATS MUFFIN-7 LAMB-16)
          (CRAVES UNDERSTANDING-28 TURKEY)
          (EATS KALE SHRIMP-4)
          (EATS GRAPEFRUIT TOFU-5)
          (LOCALE POPOVER KENTUCKY)
          (CRAVES AESTHETICS SCALLOP)
          (CRAVES PROSTATITIS-127 WONDERBREAD)
          (EATS TUNA-3 YOGURT)
          (CRAVES UNDERSTANDING SNICKERS-6)
          (LOCALE MELON QUEBEC)
          (CRAVES ANXIETY-109 PAPAYA)
          (EATS YOGURT TUNA-3)
          (HARMONY LEARNING-24 SATURN)
          (CRAVES DEPRESSION-125 BAGUETTE)
          (CRAVES ANGER-68 HAROSET)
          (CRAVES PROSTATITIS-103 CUCUMBER)
          (EATS TURKEY MUFFIN)
          (EATS SNICKERS-6 BROCCOLI)
          (CRAVES EXPECTATION POTATO)
          (CRAVES ANGINA-34 WONDERBREAD)
          (LOCALE ORANGE QUEBEC)
          (CRAVES BOILS-123 PEPPER)
          (EATS YOGURT BACON-2)
          (LOCALE KALE KENTUCKY)
          (CRAVES SCIATICA-94 ONION)
          (LOCALE ENDIVE KENTUCKY)
          (CRAVES ABRASION-128 WONDERBREAD)
          (CRAVES LONELINESS-119 SCALLION)
          (EATS COD GUAVA)
          (HARMONY LEARNING JUPITER)
          (CRAVES LONELINESS TOFU-5)
          (EATS ARUGULA LETTUCE)
          (EATS POPOVER LOBSTER)
          (CRAVES ANXIETY TOFU-5)
          (CRAVES ANXIETY-86 PEAR)
          (EATS TOFU-5 BACON-2)
          (HARMONY UNDERSTANDING MARS)
          (EATS FLOUNDER ENDIVE)
          (EATS PEAR WURST)
          (EATS MUTTON PEPPER)
          (EATS LETTUCE HAROSET)
          (CRAVES JEALOUSY-107 TURKEY)
          (EATS PEAR MUTTON)
          (EATS SCALLION BAGUETTE)
          (CRAVES ABRASION-71 PORK)
          (LOCALE PORK KENTUCKY)
          (CRAVES STIMULATION BACON-2)
          (CRAVES DREAD-58 WONDERBREAD-1)
          (EATS WONDERBREAD-1 BACON-2)
          (EATS ORANGE PEAR)
          (EATS PAPAYA CUCUMBER)
          (CRAVES EMPATHY-25 GUAVA)
          (EATS WONDERBREAD LETTUCE)
          (CRAVES ANGINA-73 MUFFIN)
          (CRAVES LEARNING-24 PEAR)
          (LOCALE TOMATO KENTUCKY)
          (HARMONY CURIOSITY-10 SATURN)
          (CRAVES DREAD-46 FLOUNDER)
          (EATS HAM BACON)
          (EATS BACON-2 WONDERBREAD-1)
          (HARMONY REST-19 SATURN)
          (LOCALE PEPPER KENTUCKY)
          (LOCALE SNICKERS-6 KENTUCKY)
          (EATS LAMB POPOVER)
          (EATS WURST SNICKERS)
          (CRAVES PROSTATITIS-108 PAPAYA)
          (EATS ENDIVE FLOUNDER)
          (LOCALE GUAVA KENTUCKY)
          (EATS TURKEY CHICKEN)
          (CRAVES JEALOUSY TUNA-3)
          (EATS LOBSTER POPOVER)
          (LOCALE PEA KENTUCKY)
          (EATS TURKEY COD)
          (EATS POPOVER HOTDOG)
          (EATS PISTACHIO TURKEY)
          (EATS ARUGULA CHICKEN)
          (LOCALE PAPAYA-15 KENTUCKY)
          (LOCALE CANTELOPE QUEBEC)
          (EATS HAM-8 BROCCOLI)
          (EATS SNICKERS WURST)
          (EATS BROCCOLI HAM-8)
          (EATS PEAR COD)
          (EATS LAMB MUTTON)
          (EATS CANTELOPE HAM)
          (CRAVES LONELINESS-54 YOGURT)
          (HARMONY LEARNING-17 JUPITER)
          (EATS GUAVA ARUGULA)
          (LOCALE SNICKERS KENTUCKY)
          (EATS WONDERBREAD LOBSTER)
          (EATS MUTTON LAMB)
          (CRAVES DREAD-120 SCALLION)
          (EATS MUTTON TOFU)
          (EATS MELON WONDERBREAD)
          (EATS TUNA BACON-2)
          (HARMONY LOVE-12 JUPITER)
          (LOCALE WONDERBREAD-1 KENTUCKY)
          (CRAVES STIMULATION-18 SNICKERS)
          (LOCALE MUTTON KENTUCKY)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS TOFU WURST)
          (HARMONY EMPATHY-25 MARS)
          (EATS SCALLOP SNICKERS)
          (EATS PEA BEEF)
          (EATS ARUGULA POPOVER)
          (EATS HAM CANTELOPE)
          (EATS MARZIPAN LETTUCE)
          (EATS BACON-2 TOFU-5)
          (CRAVES JEALOUSY-92 GUAVA)
          (ORBITS MARS JUPITER)
          (EATS HAROSET BAGUETTE)
          (CRAVES ANGER-93 GUAVA)
          (LOCALE POTATO KENTUCKY)
          (EATS BEEF TOMATO)
          (CRAVES SCIATICA-76 MUFFIN)
          (EATS CHERRY CHICKEN)
          (EATS HAMBURGER SNICKERS)
          (CRAVES ABRASION-106 TURKEY)
          (CRAVES REST-19 ENDIVE)
          (LOCALE LEMON KENTUCKY)
          (EATS SHRIMP ENDIVE)
          (CRAVES GRIEF-63 TUNA-3)
          (CRAVES DREAD-84 LETTUCE)
          (LOCALE PAPAYA KENTUCKY)
          (CRAVES EXCITEMENT-20 SHRIMP)
          (EATS MELON SHRIMP)
          (CRAVES DREAD-69 HAROSET)
          (CRAVES EXCITEMENT-22 LETTUCE)
          (LOCALE COD QUEBEC)
          (HARMONY SATISFACTION-11 SATURN)
          (LOCALE CHERRY KENTUCKY)
          (EATS LEMON CHOCOLATE)
          (EATS SNICKERS HAMBURGER)
          (CRAVES LEARNING-17 CHICKEN)
          (CRAVES AESTHETICS-21 MUTTON)
          (CRAVES EXCITEMENT BACON)
          (HARMONY ENTERTAINMENT MARS)
          (EATS COD CHERRY)
          (EATS CHOCOLATE BEEF)
          (EATS PORK SNICKERS)
          (HARMONY AESTHETICS-30 SATURN)
          (HARMONY TRIUMPH SATURN)
          (CRAVES BOILS-83 LETTUCE)
          (EATS GUAVA CHICKEN)
          (CRAVES LACERATION-122 PEPPER)
          (CRAVES PROSTATITIS-75 MUFFIN)
          (EATS TURKEY PISTACHIO)
          (CRAVES JEALOUSY-80 ENDIVE)
          (LOCALE HAM-8 QUEBEC)
          (CRAVES LOVE-12 WONDERBREAD)
          (EATS PEPPER GUAVA)
          (EATS MUTTON PEAR)
          (EATS GUAVA PEAR)
          (LOCALE MUFFIN KENTUCKY)
          (LOCALE BAGUETTE KENTUCKY)
          (CRAVES GRIEF PAPAYA-15)
          (CRAVES JEALOUSY-124 BAGUETTE)
          (HARMONY STIMULATION SATURN)
          (EATS WURST LEMON)
          (EATS SWEETROLL APPLE)
          (CRAVES INTOXICATION KALE)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS COD PEAR)
          (CRAVES LUBRICITY HAMBURGER)
          (CRAVES HANGOVER SNICKERS-6)
          (CRAVES GRIEF-42 LAMB)
          (LOCALE SHRIMP-4 QUEBEC)
          (EATS CHERRY COD)
          (CRAVES SATIETY-26 RICE)
          (LOCALE HAROSET KENTUCKY)
          (HARMONY ENTERTAINMENT-31 MARS)
          (EATS HOTDOG GUAVA)
          (EATS ONION PORK)
          (LOCALE PISTACHIO KENTUCKY)
          (EATS CHOCOLATE SNICKERS)
          (CRAVES PROSTATITIS SNICKERS-6)
          (EATS LAMB-16 MUFFIN-7)
          (EATS HAMBURGER MUFFIN)
          (CRAVES SCIATICA-72 PORK)
          (EATS PEA CHOCOLATE)
          (EATS LETTUCE WONDERBREAD)
          (EATS TOMATO CHOCOLATE)
          (EATS CHOCOLATE LEMON)
          (HARMONY LUBRICITY-13 SATURN)
          (LOCALE LETTUCE QUEBEC)
          (CRAVES PROSTATITIS-44 LAMB)
          (CRAVES GRIEF-97 ONION)
          (EATS SNICKERS PORK)
          (HARMONY AESTHETICS-21 SATURN)
          (CRAVES ANXIETY-121 SCALLION)
          (EATS HAM PISTACHIO)
          (HARMONY EXPECTATION MARS)
          (HARMONY INTOXICATION-29 MARS)
          (LOCALE CUCUMBER KENTUCKY)
          (CRAVES TRIUMPH BROCCOLI)
          (EATS CHICKEN GUAVA)
          (CRAVES REST MUFFIN-7)
          (EATS BEEF PEA)
          (EATS BACON-2 TUNA)
          (LOCALE WURST QUEBEC)
          (LOCALE ARUGULA QUEBEC)
          (CRAVES ACHIEVEMENT-27 CUCUMBER)
          (EATS HOTDOG YOGURT)
          (LOCALE TUNA-3 QUEBEC)
          (LOCALE HOTDOG KENTUCKY)
          (EATS OKRA ONION)
          (CRAVES AESTHETICS-30 PEA)
          (EATS SCALLION MARZIPAN)
          (CRAVES JEALOUSY-59 WONDERBREAD-1)
          (LOCALE BROCCOLI KENTUCKY)
          (CRAVES ANGINA-112 TOMATO)
          (EATS LETTUCE POPOVER)
          (LOCALE HAMBURGER KENTUCKY)
          (EATS ONION CHOCOLATE)
          (CRAVES EXPECTATION-32 MELON)
          (CRAVES LACERATION-48 FLOUNDER)
          (EATS TOMATO BEEF)
          (LOCALE YOGURT KENTUCKY)
          (CRAVES ANGINA-49 TUNA)
          (EATS PEAR GUAVA)
          (EATS SHRIMP RICE)
          (CRAVES JEALOUSY-45 FLOUNDER)
          (EATS WONDERBREAD-1 HAM-8)
          (CRAVES ENTERTAINMENT-31 COD)
          (CRAVES ABRASION LAMB-16)
          (CRAVES REST-23 CHOCOLATE)
          (LOCALE SHRIMP KENTUCKY)
          (EATS BACON MUFFIN)
          (EATS PAPAYA-15 ORANGE)
          (EATS GRAPEFRUIT TUNA)
          (LOCALE RICE KENTUCKY)
          (CRAVES CURIOSITY LEMON)
          (EATS RICE SCALLION)
          (HARMONY SATISFACTION MARS)
          (EATS BACON-2 YOGURT)
          (LOCALE LOBSTER KENTUCKY)
          (HARMONY EXCITEMENT-22 SATURN)
          (CRAVES DEPRESSION-85 PEAR)
          (LOCALE CHOCOLATE KENTUCKY)
          (LOCALE FLOUNDER KENTUCKY)
          (LOCALE APPLE KENTUCKY)
          (EATS WONDERBREAD-1 MUFFIN-7)
          (EATS LETTUCE CHICKEN)
          (EATS FLOUNDER MUTTON)
          (EATS YOGURT SHRIMP-4)
          (CRAVES ABRASION-37 HOTDOG)
          (CRAVES ANGINA-51 BROCCOLI)
          (EATS TUNA LAMB-16)
          (EATS LOBSTER MELON)
          (CRAVES SCIATICA-105 TURKEY)
          (CRAVES BOILS-55 YOGURT)
          (EATS PAPAYA-15 GRAPEFRUIT)
          (EATS LAMB-16 TUNA)
          (EATS TUNA GRAPEFRUIT)
          (EATS CHICKEN ARUGULA)
          (HARMONY STIMULATION-18 JUPITER)
          (EATS ARUGULA GUAVA)
          (EATS POPOVER APPLE)
          (EATS GUAVA COD)
          (LOCALE TOFU KENTUCKY)
          (CRAVES PROSTATITIS-57 WONDERBREAD-1)
          (CRAVES DEPRESSION-114 CHERRY)
          (CRAVES LONELINESS-70 HAROSET)
          (CRAVES LACERATION-115 APPLE)
          (EATS SNICKERS CHOCOLATE)
          (EATS WONDERBREAD MELON)
          (CRAVES SCIATICA-118 MELON)
          (EATS KALE SNICKERS-6)
          (EATS CHICKEN LETTUCE)
          (EATS MUTTON WURST)
          (ORBITS SATURN MARS)
          (LOCALE ONION QUEBEC)
          (EATS WURST PEAR)
          (CRAVES LACERATION-50 BROCCOLI)
          (EATS APPLE MELON)
          (CRAVES PROSTATITIS-77 CHICKEN)
          (EATS POPOVER ARUGULA)
          (CRAVES ANXIETY-41 LAMB)
          (LOCALE GRAPEFRUIT QUEBEC)
          (LOCALE SCALLOP QUEBEC)
          (LOCALE BACON QUEBEC)
          (EATS KALE POTATO)
          (CRAVES LONELINESS-87 PEAR)
          (LOCALE LAMB KENTUCKY)
          (HARMONY EMPATHY SATURN)
          (CRAVES SATISFACTION HAM-8)
          (EATS PAPAYA OKRA)
          (EATS MUFFIN HAMBURGER)
          (EATS MUTTON FLOUNDER)
          (EATS HAM-8 WONDERBREAD-1)
          (CRAVES BOILS HAM-8)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES ABRASION-56 YOGURT)
          (CRAVES ABRASION-78 CHICKEN)
          (EATS PISTACHIO HAM)
          (CRAVES DREAD-101 CUCUMBER)
          (CRAVES BOILS-40 CANTELOPE)
          (EATS PORK TOMATO)
          (EATS ORANGE PAPAYA-15)
          (EATS PORK ONION)
          (EATS SHRIMP-4 KALE)
          (EATS MUFFIN BACON)
          (EATS APPLE POPOVER)
          (EATS MELON APPLE)
          (CRAVES ENTERTAINMENT TOFU)
          (HARMONY ACHIEVEMENT-27 JUPITER)
          (LOCALE CHICKEN KENTUCKY)
          (CRAVES LONELINESS-104 CUCUMBER)
          (LOCALE WONDERBREAD KENTUCKY)
          (CRAVES DEPRESSION TOFU-5)
          (EATS COD TURKEY)
          (EATS SCALLOP PEAR)
          (EATS PEPPER MUTTON)
          (EATS BEEF CHOCOLATE)
          (EATS CHICKEN TURKEY)
          (CRAVES HANGOVER-35 SWEETROLL)
          (CRAVES SCIATICA-36 SWEETROLL)
          (LOCALE TURKEY KENTUCKY)
          (EATS ENDIVE CHOCOLATE)
          (EATS PAPAYA-15 POTATO)
          (HARMONY AESTHETICS SATURN)
          (CRAVES HANGOVER-95 ONION)
          (EATS CANTELOPE ORANGE)
          (CRAVES GRIEF-81 ENDIVE)
          (EATS ENDIVE SHRIMP)
          (CRAVES ANGER-43 LAMB)
          (HARMONY REST SATURN)
          (EATS LETTUCE MARZIPAN)
          (CRAVES LOVE BEEF)
          (CRAVES BOILS-111 PAPAYA)
          (EATS GUAVA HOTDOG)
          (EATS CHOCOLATE ONION)
          (HARMONY LOVE MARS)
          (HARMONY REST-23 SATURN)
          (EATS CHOCOLATE ENDIVE)
          (EATS APPLE SWEETROLL)
          (CRAVES ANXIETY-52 GRAPEFRUIT)
          (EATS SHRIMP SWEETROLL)
          (EATS BAGUETTE HAROSET)
          (EATS WURST TOFU)
          (ATTACKS KENTUCKY QUEBEC)
          (HARMONY SATIETY-26 SATURN)
          (EATS LEMON WURST)
          (EATS CUCUMBER PAPAYA)
          (HARMONY EXCITEMENT-20 JUPITER)
          (LOCALE MUFFIN-7 KENTUCKY)
          (EATS CHOCOLATE TOFU)
          (HARMONY SATIETY MARS)
          (CRAVES TRIUMPH-64 PORK)
          (CRAVES LACERATION-89 POPOVER)
          (EATS SWEETROLL SHRIMP)
          (CRAVES DEPRESSION-62 SHRIMP-4)
          (CRAVES ANGER-33 WONDERBREAD)
          (EATS MUFFIN TURKEY)
          (CRAVES LUBRICITY-13 HOTDOG)
          (HARMONY UNDERSTANDING-28 JUPITER)
          (CRAVES BOILS-99 WURST)
          (EATS SHRIMP-4 YOGURT)
          (EATS BAGUETTE SCALLION)
          (CRAVES DEPRESSION-67 HAROSET)
          (EATS PEAR ORANGE)
          (CRAVES ANGINA SNICKERS-6)
          (CRAVES LEARNING TUNA)
          (EATS CHICKEN CHERRY)
          (CRAVES LACERATION-91 GUAVA)
          (EATS HAROSET LETTUCE)
          (HARMONY TRIUMPH-14 SATURN)
          (CRAVES ANGER-60 SHRIMP-4)
          (CRAVES ANGER-88 PEAR)
          (EATS LOBSTER WONDERBREAD)
          (EATS WURST MUTTON)
          (CRAVES LONELINESS-98 WURST)
          (CRAVES DREAD-116 COD)
          (CRAVES HANGOVER-110 PAPAYA)
          (LOCALE BACON-2 QUEBEC)
          (CRAVES DEPRESSION-39 LOBSTER)
          (EATS GUAVA PEPPER)
          (CRAVES SCIATICA-53 YOGURT)
          (CRAVES BOILS-74 MUFFIN)
          (EATS PEAR SCALLOP)
          (CRAVES SCIATICA PAPAYA-15)
          (EATS MUFFIN-7 WONDERBREAD-1)
          (EATS BROCCOLI TUNA-3)
          (CRAVES GRIEF-126 BAGUETTE)
          (EATS SCALLION RICE)
          (LOCALE TUNA KENTUCKY)
          (CRAVES HANGOVER-79 CHICKEN)
          (CRAVES STIMULATION-9 PEPPER)
          (CRAVES INTOXICATION-29 CHERRY)
          (EATS YOGURT HOTDOG)
          (EATS MARZIPAN SCALLION)
          (EATS TOMATO PORK)
          (EATS SHRIMP MELON)
          (CRAVES ANGER SNICKERS-6)
          (LOCALE BEEF KENTUCKY)
          (HARMONY TRIUMPH-64 MARS)
          (CRAVES LACERATION LAMB-16)
          (CRAVES TRIUMPH-14 LOBSTER)
          (EATS TOFU CHOCOLATE)
          (CRAVES ANGINA-100 WURST)
          (CRAVES LONELINESS-38 HOTDOG)
          (CRAVES ABRASION-102 CUCUMBER)
          (EATS TUNA-3 BROCCOLI)
          (HARMONY EXCITEMENT SATURN))
   (:GOAL (AND (CRAVES JEALOUSY CANTELOPE)
               (CRAVES GRIEF-117 CANTELOPE)
               (CRAVES ANGINA-73 ORANGE)
               (CRAVES PROSTATITIS HOTDOG)
               (CRAVES ANGINA HOTDOG)
               (CRAVES BOILS-123 BEEF)
               (CRAVES ABRASION-102 GRAPEFRUIT))))

(DEFINE (PROBLEM MYSTY-37)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS HAROSET KALE LETTUCE TOMATO SHRIMP HOTDOG
             LEMON BROCCOLI TUNA TOFU HAM SWEETROLL BACON BEEF
             SCALLOP MARZIPAN CUCUMBER WONDERBREAD FLOUNDER
             - FOOD
             SATISFACTION INTOXICATION LUBRICITY EMPATHY AESTHETICS
             CURIOSITY EXPECTATION STIMULATION ENTERTAINMENT
             - PLEASURE
             ANGINA DEPRESSION HANGOVER ANGER JEALOUSY
             PROSTATITIS GRIEF DREAD LACERATION SCIATICA ABRASION
             ANXIETY BOILS ANXIETY-2 LONELINESS ANGINA-4
             HANGOVER-1 ANGER-8 LACERATION-3 SCIATICA-7
             JEALOUSY-6 PROSTATITIS-15 DREAD-16 ABRASION-5
             - PAIN
             ARIZONA MANITOBA GUANABARA ALSACE - PROVINCE
             URANUS JUPITER PLUTO VULCAN - PLANET)
   (:INIT (HARMONY SATISFACTION JUPITER)
          (EATS TOFU SCALLOP)
          (EATS SWEETROLL MARZIPAN)
          (EATS WONDERBREAD KALE)
          (HARMONY ENTERTAINMENT JUPITER)
          (EATS BACON HOTDOG)
          (CRAVES ANGINA-4 HAM)
          (CRAVES INTOXICATION SHRIMP)
          (CRAVES CURIOSITY BEEF)
          (LOCALE SCALLOP ARIZONA)
          (LOCALE BEEF ARIZONA)
          (LOCALE BACON MANITOBA)
          (LOCALE FLOUNDER ARIZONA)
          (ATTACKS MANITOBA GUANABARA)
          (HARMONY INTOXICATION JUPITER)
          (EATS BROCCOLI MARZIPAN)
          (LOCALE TUNA ALSACE)
          (EATS KALE WONDERBREAD)
          (CRAVES LACERATION-3 SWEETROLL)
          (CRAVES EMPATHY BROCCOLI)
          (CRAVES ENTERTAINMENT WONDERBREAD)
          (EATS TUNA FLOUNDER)
          (HARMONY AESTHETICS PLUTO)
          (CRAVES BOILS HOTDOG)
          (LOCALE LEMON ARIZONA)
          (LOCALE KALE ARIZONA)
          (CRAVES STIMULATION MARZIPAN)
          (EATS TOMATO HAROSET)
          (LOCALE BROCCOLI ARIZONA)
          (EATS BROCCOLI TOFU)
          (CRAVES ANGER-8 SWEETROLL)
          (EATS HAROSET TOMATO)
          (EATS HAROSET TOFU)
          (CRAVES LACERATION SHRIMP)
          (EATS WONDERBREAD CUCUMBER)
          (CRAVES PROSTATITIS-15 WONDERBREAD)
          (HARMONY EMPATHY PLUTO)
          (CRAVES GRIEF TOMATO)
          (EATS HOTDOG HAM)
          (EATS WONDERBREAD HAROSET)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES ANGINA KALE)
          (EATS TOMATO LEMON)
          (CRAVES EXPECTATION SCALLOP)
          (CRAVES PROSTATITIS TOMATO)
          (CRAVES JEALOUSY-6 SCALLOP)
          (LOCALE SHRIMP GUANABARA)
          (EATS MARZIPAN BROCCOLI)
          (EATS WONDERBREAD SHRIMP)
          (ORBITS PLUTO VULCAN)
          (EATS KALE LEMON)
          (EATS FLOUNDER MARZIPAN)
          (HARMONY LUBRICITY VULCAN)
          (CRAVES HANGOVER-1 HAM)
          (EATS HOTDOG LEMON)
          (LOCALE LETTUCE MANITOBA)
          (ORBITS URANUS JUPITER)
          (LOCALE SWEETROLL ARIZONA)
          (EATS HAM HOTDOG)
          (EATS LEMON HOTDOG)
          (CRAVES SCIATICA HOTDOG)
          (EATS HAM WONDERBREAD)
          (CRAVES LONELINESS BROCCOLI)
          (CRAVES AESTHETICS BACON)
          (EATS HAROSET WONDERBREAD)
          (EATS HAM BACON)
          (CRAVES ABRASION-5 WONDERBREAD)
          (CRAVES JEALOUSY TOMATO)
          (LOCALE HOTDOG ALSACE)
          (EATS BEEF CUCUMBER)
          (EATS LEMON KALE)
          (EATS SWEETROLL LETTUCE)
          (CRAVES SCIATICA-7 BACON)
          (EATS SCALLOP SHRIMP)
          (CRAVES LUBRICITY LEMON)
          (CRAVES SATISFACTION LETTUCE)
          (EATS BACON HAM)
          (CRAVES DREAD-16 WONDERBREAD)
          (EATS BACON LETTUCE)
          (EATS SCALLOP TOFU)
          (CRAVES HANGOVER KALE)
          (EATS TOFU HAROSET)
          (EATS CUCUMBER BEEF)
          (EATS WONDERBREAD BEEF)
          (LOCALE CUCUMBER ARIZONA)
          (CRAVES DEPRESSION KALE)
          (LOCALE TOFU ARIZONA)
          (CRAVES DREAD SHRIMP)
          (CRAVES ANXIETY-2 BROCCOLI)
          (EATS MARZIPAN FLOUNDER)
          (HARMONY EXPECTATION VULCAN)
          (EATS SHRIMP WONDERBREAD)
          (EATS BEEF SCALLOP)
          (EATS LETTUCE BACON)
          (CRAVES ANGER KALE)
          (LOCALE MARZIPAN ARIZONA)
          (CRAVES ABRASION HOTDOG)
          (HARMONY STIMULATION VULCAN)
          (EATS LEMON TOMATO)
          (EATS TOFU BROCCOLI)
          (EATS SCALLOP BEEF)
          (EATS MARZIPAN SWEETROLL)
          (CRAVES ANXIETY HOTDOG)
          (LOCALE HAM MANITOBA)
          (LOCALE TOMATO ARIZONA)
          (ATTACKS GUANABARA ALSACE)
          (EATS LETTUCE SWEETROLL)
          (LOCALE WONDERBREAD GUANABARA)
          (EATS FLOUNDER TUNA)
          (EATS HOTDOG BACON)
          (EATS WONDERBREAD HAM)
          (EATS BEEF WONDERBREAD)
          (EATS TUNA HAM)
          (EATS CUCUMBER WONDERBREAD)
          (ATTACKS ARIZONA MANITOBA)
          (LOCALE HAROSET ARIZONA)
          (EATS SHRIMP SCALLOP)
          (EATS HAM TUNA)
          (ORBITS JUPITER PLUTO))
   (:GOAL (AND (CRAVES PROSTATITIS-15 MARZIPAN)
               (CRAVES DREAD-16 KALE)
               (CRAVES LACERATION HAM)
               (CRAVES LACERATION-3 LEMON)
               (CRAVES PROSTATITIS SHRIMP)
               (CRAVES JEALOUSY TOMATO)
               (CRAVES ANXIETY BACON)
               (CRAVES ANXIETY-2 TOFU)
               (CRAVES GRIEF WONDERBREAD)
               (CRAVES JEALOUSY-6 TOMATO))))

(DEFINE (PROBLEM MYSTY-38)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PISTACHIO-47 HAROSET-51 COD-50 APPLE-49
             CANTELOPE-48 TUNA-52 BROCCOLI-53 HOTDOG-54 PEA-55
             PORK-56 SCALLION-57 WONDERBREAD-58 CHERRY-59
             KALE-60 CHOCOLATE-61 BAGUETTE-62 WURST-63
             HAMBURGER-64 CHICKEN-17 YOGURT-18 POPOVER-19 TOMATO-20
             SCALLOP-21 PEPPER-22 PAPAYA-23 FLOUNDER-24
             CUCUMBER-25 POTATO-26 HAM-27 SWEETROLL-28
             GRAPEFRUIT-29 MELON-30 RICE-31 MUFFIN-32 PEAR-9 LEMON-10
             ONION-11 BEEF-12 MARZIPAN-13 TURKEY-14 LAMB-15
             LETTUCE-16 SHRIMP-5 OKRA-6 LOBSTER-7 ENDIVE-8 TOFU-3
             MUTTON-4 SNICKERS-1 GUAVA-2 ONION ARUGULA HAROSET
             ORANGE PEA MELON CHERRY KALE LEMON CHICKEN BACON
             BROCCOLI GUAVA LOBSTER BAGUETTE TOMATO COD MUTTON
             WURST HOTDOG WONDERBREAD TUNA ENDIVE LAMB BEEF
             APPLE TOFU TURKEY PISTACHIO MARZIPAN POPOVER
             CUCUMBER YOGURT PEAR OKRA CHOCOLATE SNICKERS
             GRAPEFRUIT MUFFIN LETTUCE PAPAYA HAMBURGER PEPPER
             SHRIMP POTATO SWEETROLL FLOUNDER PORK SCALLION
             RICE HAM CANTELOPE SCALLOP - FOOD
             STIMULATION LOVE ENTERTAINMENT UNDERSTANDING REST
             INTOXICATION LEARNING EXCITEMENT EXPECTATION SATIETY
             EMPATHY TRIUMPH LUBRICITY SATISFACTION
             ACHIEVEMENT AESTHETICS CURIOSITY SATISFACTION-46
             EXCITEMENT-45 REST-44 EMPATHY-43 STIMULATION-42
             TRIUMPH-41 EXPECTATION-40 AESTHETICS-39
             LUBRICITY-38 ENTERTAINMENT-37 ACHIEVEMENT-36
             CURIOSITY-35 LEARNING-34 LOVE-33 UNDERSTANDING-128
             INTOXICATION-127 SATIETY-126 CURIOSITY-125
             INTOXICATION-124 LUBRICITY-123 STIMULATION-122
             EXPECTATION-121 AESTHETICS-120 SATISFACTION-119
             ACHIEVEMENT-118 LEARNING-117 ENTERTAINMENT-116
             EXCITEMENT-115 UNDERSTANDING-114 EMPATHY-113
             SATIETY-112 REST-111 TRIUMPH-110 LOVE-109 LOVE-108
             EXCITEMENT-107 ENTERTAINMENT-106 SATIETY-105
             ACHIEVEMENT-104 - PLEASURE
             ANGINA BOILS LONELINESS ABRASION JEALOUSY
             LACERATION PROSTATITIS GRIEF ANXIETY DEPRESSION
             SCIATICA HANGOVER DREAD ANGER LONELINESS-102
             DREAD-103 SCIATICA-100 GRIEF-101 HANGOVER-98
             PROSTATITIS-99 DEPRESSION-97 ABRASION-96 ANXIETY-94
             LACERATION-95 BOILS-92 ANGER-93 JEALOUSY-91 SCIATICA-89
             ANGINA-90 HANGOVER-88 LACERATION-86 BOILS-87
             ANXIETY-84 ANGER-85 ANGINA-83 DREAD-81 GRIEF-82
             ABRASION-79 JEALOUSY-80 PROSTATITIS-77 LONELINESS-78
             DREAD-75 DEPRESSION-76 GRIEF-73 ANGINA-74
             ANXIETY-71 ANGER-72 LACERATION-69 BOILS-70
             DEPRESSION-67 JEALOUSY-68 ABRASION-66 - PAIN
             PENNSYLVANIA GUANABARA ALSACE KENTUCKY BOSNIA QUEBEC
             MANITOBA SURREY ARIZONA GOIAS OREGON MORAVIA BAVARIA
             - PROVINCE
             PLUTO URANUS EARTH MERCURY - PLANET)
   (:INIT (LOCALE KALE ARIZONA)
          (EATS MUTTON HAMBURGER)
          (LOCALE SWEETROLL-28 OREGON)
          (CRAVES SATISFACTION PAPAYA-23)
          (EATS CANTELOPE GUAVA-2)
          (EATS BACON MELON)
          (HARMONY LUBRICITY URANUS)
          (EATS RICE SWEETROLL-28)
          (CRAVES EXCITEMENT-45 MELON-30)
          (EATS FLOUNDER-24 MUFFIN-32)
          (CRAVES SCIATICA-89 MELON)
          (EATS TURKEY-14 APPLE)
          (EATS CHOCOLATE SNICKERS)
          (EATS HOTDOG PISTACHIO)
          (EATS PEA SCALLION)
          (EATS BACON LEMON)
          (CRAVES ANXIETY-94 MUTTON-4)
          (LOCALE SCALLOP-21 SURREY)
          (ATTACKS BOSNIA QUEBEC)
          (EATS BROCCOLI TOFU-3)
          (LOCALE ENDIVE GUANABARA)
          (EATS TOFU SHRIMP-5)
          (EATS HAM-27 LETTUCE-16)
          (LOCALE FLOUNDER OREGON)
          (EATS BAGUETTE TOMATO)
          (EATS POPOVER CUCUMBER)
          (EATS APPLE TOFU-3)
          (HARMONY LOVE-33 URANUS)
          (CRAVES ANGER PEPPER-22)
          (EATS TUNA-52 BAGUETTE-62)
          (CRAVES DEPRESSION-76 PEAR)
          (EATS CUCUMBER LEMON)
          (LOCALE TOMATO-20 ALSACE)
          (CRAVES DREAD-75 PEAR)
          (EATS SCALLION-57 MELON)
          (CRAVES LACERATION PEA-55)
          (HARMONY EXCITEMENT-115 EARTH)
          (EATS MELON-30 LEMON-10)
          (EATS CHICKEN GRAPEFRUIT)
          (EATS TURKEY-14 HAMBURGER)
          (CRAVES TRIUMPH-110 CHOCOLATE)
          (EATS POPOVER SCALLOP-21)
          (LOCALE PEPPER KENTUCKY)
          (ORBITS PLUTO URANUS)
          (CRAVES ACHIEVEMENT POTATO-26)
          (CRAVES LACERATION-86 LEMON)
          (EATS TOFU-3 TURKEY-14)
          (EATS YOGURT TOFU)
          (HARMONY INTOXICATION-124 EARTH)
          (LOCALE TOFU-3 OREGON)
          (EATS ONION PAPAYA)
          (CRAVES REST-44 RICE-31)
          (CRAVES ANGER-93 GUAVA-2)
          (EATS MELON-30 HAMBURGER)
          (LOCALE CUCUMBER-25 GOIAS)
          (CRAVES DREAD PEPPER-22)
          (LOCALE COD-50 MANITOBA)
          (LOCALE BEEF SURREY)
          (CRAVES EXCITEMENT WONDERBREAD-58)
          (EATS SWEETROLL TURKEY)
          (LOCALE BEEF-12 PENNSYLVANIA)
          (EATS TUNA FLOUNDER)
          (LOCALE SHRIMP GUANABARA)
          (EATS PISTACHIO SCALLION)
          (EATS HAMBURGER TURKEY-14)
          (LOCALE BAGUETTE-62 QUEBEC)
          (EATS KALE POPOVER)
          (HARMONY EXPECTATION MERCURY)
          (CRAVES SATISFACTION-46 GRAPEFRUIT-29)
          (EATS BEEF-12 SNICKERS)
          (EATS MARZIPAN CHERRY)
          (LOCALE GUAVA QUEBEC)
          (HARMONY EXPECTATION-40 MERCURY)
          (LOCALE HAM ARIZONA)
          (EATS BAGUETTE ENDIVE-8)
          (EATS BEEF CHERRY)
          (EATS SNICKERS CHOCOLATE)
          (EATS CHERRY-59 ONION)
          (LOCALE PISTACHIO ALSACE)
          (CRAVES LONELINESS TUNA-52)
          (CRAVES STIMULATION-42 LEMON-10)
          (CRAVES EXPECTATION CHOCOLATE-61)
          (EATS APPLE TURKEY-14)
          (LOCALE MUFFIN-32 ARIZONA)
          (EATS LEMON SCALLION)
          (HARMONY EXCITEMENT-45 URANUS)
          (CRAVES EMPATHY-113 POPOVER)
          (EATS ARUGULA LETTUCE)
          (EATS HAM HAM-27)
          (HARMONY REST-44 URANUS)
          (EATS TOFU-3 BROCCOLI)
          (EATS LETTUCE-16 HAM-27)
          (EATS TURKEY PAPAYA)
          (EATS TURKEY-14 TOFU-3)
          (EATS MUTTON-4 CHERRY)
          (LOCALE TURKEY-14 GOIAS)
          (EATS APPLE-49 PISTACHIO-47)
          (LOCALE TURKEY ARIZONA)
          (EATS PEAR BAGUETTE)
          (EATS COD-50 PISTACHIO-47)
          (EATS MELON SWEETROLL)
          (HARMONY REST URANUS)
          (CRAVES ENTERTAINMENT-116 LAMB)
          (EATS PISTACHIO-47 COD-50)
          (EATS ENDIVE ENDIVE-8)
          (HARMONY LOVE-109 MERCURY)
          (EATS YOGURT-18 MELON)
          (EATS TOMATO-20 SCALLOP-21)
          (CRAVES GRIEF-82 TOFU)
          (EATS MELON BACON)
          (EATS CUCUMBER-25 LETTUCE)
          (CRAVES EMPATHY-43 PEAR-9)
          (EATS TUNA HAROSET)
          (HARMONY TRIUMPH-110 EARTH)
          (LOCALE WURST ARIZONA)
          (CRAVES LEARNING-117 TUNA)
          (HARMONY LOVE-108 EARTH)
          (EATS BAGUETTE PEAR)
          (HARMONY EMPATHY-43 EARTH)
          (EATS BROCCOLI KALE)
          (EATS MARZIPAN-13 POTATO)
          (EATS TOFU GUAVA)
          (LOCALE SHRIMP-5 MANITOBA)
          (CRAVES DEPRESSION-97 LAMB-15)
          (EATS FLOUNDER GRAPEFRUIT)
          (EATS ENDIVE TOMATO)
          (LOCALE BAGUETTE ARIZONA)
          (EATS PEAR-9 POPOVER)
          (EATS LEMON-10 TUNA)
          (EATS LEMON-10 MELON-30)
          (HARMONY LEARNING EARTH)
          (EATS ENDIVE PAPAYA-23)
          (LOCALE YOGURT ALSACE)
          (CRAVES SATIETY-126 CHICKEN)
          (EATS OKRA-6 YOGURT)
          (EATS SWEETROLL BACON)
          (LOCALE COD BOSNIA)
          (LOCALE LEMON QUEBEC)
          (EATS TURKEY-14 POPOVER-19)
          (EATS HAMBURGER TOFU-3)
          (HARMONY EXCITEMENT-107 EARTH)
          (EATS WONDERBREAD WURST-63)
          (EATS PAPAYA-23 RICE-31)
          (CRAVES AESTHETICS-120 WURST)
          (EATS CHICKEN ENDIVE-8)
          (ATTACKS QUEBEC MANITOBA)
          (HARMONY ENTERTAINMENT-37 MERCURY)
          (EATS LAMB-15 SCALLOP)
          (EATS TOFU YOGURT)
          (EATS TURKEY-14 LOBSTER-7)
          (CRAVES DREAD-81 TOFU)
          (EATS SNICKERS SCALLION)
          (EATS SNICKERS ORANGE)
          (EATS SNICKERS KALE)
          (LOCALE TOMATO SURREY)
          (EATS BROCCOLI-53 YOGURT)
          (EATS GUAVA-2 CANTELOPE)
          (EATS SCALLOP-21 POPOVER)
          (EATS LOBSTER-7 PEPPER)
          (CRAVES ANXIETY YOGURT-18)
          (EATS WURST PORK)
          (CRAVES LOVE COD-50)
          (EATS YOGURT MELON)
          (EATS COD-50 APPLE-49)
          (EATS PORK-56 BACON)
          (EATS POPOVER PEA-55)
          (LOCALE CHERRY-59 QUEBEC)
          (EATS PISTACHIO CUCUMBER)
          (CRAVES ABRASION-96 SHRIMP-5)
          (EATS PORK WURST)
          (HARMONY LUBRICITY-38 MERCURY)
          (HARMONY ACHIEVEMENT-36 MERCURY)
          (EATS RICE-31 SNICKERS)
          (ATTACKS ALSACE KENTUCKY)
          (CRAVES CURIOSITY-35 SNICKERS-1)
          (LOCALE GRAPEFRUIT-29 MANITOBA)
          (EATS SWEETROLL-28 RICE)
          (CRAVES LONELINESS-102 MELON-30)
          (EATS CHICKEN LETTUCE-16)
          (EATS POTATO-26 PEA)
          (EATS BACON SCALLION)
          (EATS BEEF PEPPER)
          (EATS MUFFIN-32 FLOUNDER-24)
          (ATTACKS SURREY ARIZONA)
          (EATS ORANGE GRAPEFRUIT-29)
          (CRAVES LOVE-33 ORANGE)
          (LOCALE LEMON-10 GOIAS)
          (EATS CANTELOPE PAPAYA)
          (EATS ENDIVE SNICKERS)
          (LOCALE MUTTON MANITOBA)
          (EATS HAMBURGER MELON-30)
          (EATS MARZIPAN TUNA)
          (EATS RICE BEEF)
          (EATS TURKEY MARZIPAN-13)
          (ORBITS URANUS EARTH)
          (EATS ONION-11 GRAPEFRUIT-29)
          (EATS GRAPEFRUIT-29 ONION-11)
          (CRAVES REST-111 PEAR)
          (EATS ENDIVE-8 CHICKEN)
          (EATS OKRA SHRIMP)
          (EATS PAPAYA SCALLION)
          (EATS KALE-60 POPOVER)
          (EATS POTATO GUAVA-2)
          (EATS SHRIMP-5 LOBSTER)
          (EATS PEPPER MUTTON-4)
          (EATS YOGURT BROCCOLI-53)
          (CRAVES STIMULATION-122 COD)
          (EATS SCALLOP-21 TOMATO-20)
          (ATTACKS OREGON MORAVIA)
          (LOCALE ONION-11 SURREY)
          (EATS POTATO PAPAYA)
          (HARMONY LEARNING-117 URANUS)
          (HARMONY REST-111 MERCURY)
          (LOCALE LAMB-15 MANITOBA)
          (LOCALE WONDERBREAD-58 GUANABARA)
          (EATS SCALLION SNICKERS)
          (EATS LOBSTER-7 HAMBURGER-64)
          (EATS GRAPEFRUIT-29 BEEF-12)
          (CRAVES ANGINA-90 MELON)
          (EATS GUAVA TOFU)
          (EATS CHERRY MUTTON-4)
          (LOCALE ORANGE KENTUCKY)
          (LOCALE PORK BOSNIA)
          (EATS POTATO CANTELOPE)
          (EATS COD LETTUCE)
          (HARMONY EMPATHY MERCURY)
          (HARMONY SATIETY-126 MERCURY)
          (EATS CUCUMBER POPOVER)
          (HARMONY ENTERTAINMENT-106 URANUS)
          (CRAVES DREAD-103 MELON-30)
          (EATS CHOCOLATE-61 WURST-63)
          (LOCALE CHOCOLATE ARIZONA)
          (EATS ONION GRAPEFRUIT-29)
          (CRAVES PROSTATITIS-77 YOGURT)
          (LOCALE BROCCOLI-53 ALSACE)
          (EATS CANTELOPE LAMB)
          (EATS SCALLOP-21 SCALLOP)
          (EATS CHERRY-59 PAPAYA)
          (EATS CUCUMBER COD)
          (EATS HAROSET TUNA)
          (EATS TOMATO WONDERBREAD-58)
          (HARMONY SATISFACTION-119 MERCURY)
          (CRAVES UNDERSTANDING-128 CHERRY)
          (EATS FLOUNDER MUFFIN)
          (LOCALE HOTDOG GUANABARA)
          (EATS PEA-55 SCALLOP)
          (EATS LETTUCE ARUGULA)
          (EATS LAMB OKRA-6)
          (CRAVES LUBRICITY-123 BAGUETTE)
          (EATS ORANGE SNICKERS)
          (EATS CHERRY-59 OKRA)
          (CRAVES LOVE-109 SNICKERS)
          (EATS COD LAMB-15)
          (HARMONY EXPECTATION-121 URANUS)
          (LOCALE CHICKEN SURREY)
          (EATS SHRIMP OKRA)
          (EATS ONION-11 ONION)
          (EATS YOGURT-18 CUCUMBER)
          (EATS BROCCOLI PEAR-9)
          (EATS SHRIMP COD-50)
          (CRAVES PROSTATITIS-99 BEEF-12)
          (LOCALE ARUGULA GUANABARA)
          (CRAVES EXCITEMENT-115 TOFU)
          (ATTACKS MORAVIA BAVARIA)
          (CRAVES ANXIETY-84 HOTDOG)
          (LOCALE WURST-63 SURREY)
          (EATS TUNA-52 PORK-56)
          (EATS PAPAYA CHERRY-59)
          (CRAVES BOILS-87 LEMON)
          (CRAVES HANGOVER-98 BEEF-12)
          (EATS SCALLOP LAMB-15)
          (LOCALE PEAR ARIZONA)
          (EATS WONDERBREAD HAM)
          (EATS LEMON-10 FLOUNDER)
          (ORBITS EARTH MERCURY)
          (CRAVES STIMULATION PISTACHIO-47)
          (LOCALE FLOUNDER-24 KENTUCKY)
          (EATS SNICKERS ENDIVE)
          (EATS TOMATO SNICKERS-1)
          (EATS ENDIVE-8 BAGUETTE)
          (EATS PISTACHIO KALE)
          (LOCALE PEA-55 PENNSYLVANIA)
          (EATS BACON PORK-56)
          (EATS MARZIPAN PORK)
          (CRAVES AESTHETICS HAM-27)
          (LOCALE PORK-56 KENTUCKY)
          (CRAVES ACHIEVEMENT-36 MUTTON-4)
          (LOCALE LETTUCE-16 QUEBEC)
          (EATS TOFU-3 HAMBURGER)
          (EATS LETTUCE-16 CHICKEN)
          (HARMONY AESTHETICS URANUS)
          (EATS TOMATO-20 SCALLOP)
          (CRAVES JEALOUSY PEA-55)
          (LOCALE TUNA GUANABARA)
          (EATS HAMBURGER BROCCOLI)
          (EATS POPOVER-19 PORK)
          (LOCALE PAPAYA-23 BOSNIA)
          (LOCALE PEA ARIZONA)
          (ATTACKS ARIZONA GOIAS)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (LOCALE HOTDOG-54 BOSNIA)
          (HARMONY EMPATHY-113 MERCURY)
          (EATS SCALLION PAPAYA)
          (EATS BACON SWEETROLL)
          (CRAVES BOILS-92 GUAVA-2)
          (LOCALE CHOCOLATE-61 QUEBEC)
          (EATS BROCCOLI-53 CHICKEN-17)
          (EATS MARZIPAN SWEETROLL-28)
          (EATS MELON SCALLION-57)
          (HARMONY LUBRICITY-123 MERCURY)
          (EATS GRAPEFRUIT WONDERBREAD)
          (HARMONY UNDERSTANDING-114 EARTH)
          (CRAVES LEARNING SCALLION-57)
          (EATS GRAPEFRUIT FLOUNDER)
          (CRAVES LUBRICITY-38 OKRA-6)
          (EATS POTATO-26 ONION)
          (EATS CANTELOPE-48 APPLE-49)
          (EATS APPLE BROCCOLI)
          (EATS CHICKEN CHOCOLATE-61)
          (EATS LOBSTER ARUGULA)
          (CRAVES EMPATHY CHICKEN-17)
          (EATS PAPAYA-23 ENDIVE)
          (EATS RICE MUFFIN)
          (LOCALE ENDIVE-8 GUANABARA)
          (LOCALE PAPAYA QUEBEC)
          (EATS CUCUMBER LETTUCE)
          (EATS SNICKERS-1 ONION-11)
          (EATS MELON YOGURT)
          (CRAVES TRIUMPH YOGURT-18)
          (EATS ONION CHERRY-59)
          (EATS PEAR HAM)
          (EATS BEEF-12 SNICKERS-1)
          (HARMONY TRIUMPH-41 MERCURY)
          (LOCALE TOFU SURREY)
          (LOCALE POTATO-26 SURREY)
          (EATS APPLE TOMATO-20)
          (EATS OKRA WONDERBREAD-58)
          (CRAVES EXCITEMENT-107 LETTUCE)
          (CRAVES CURIOSITY SWEETROLL-28)
          (EATS FLOUNDER LEMON-10)
          (HARMONY EXCITEMENT URANUS)
          (CRAVES SATISFACTION-119 HOTDOG)
          (CRAVES ANGER-72 LETTUCE)
          (EATS PEPPER PORK)
          (EATS SCALLION LEMON)
          (LOCALE GRAPEFRUIT GOIAS)
          (CRAVES SATIETY-112 CUCUMBER)
          (EATS CANTELOPE POTATO)
          (EATS ENDIVE-8 LEMON-10)
          (EATS LETTUCE CUCUMBER-25)
          (LOCALE LAMB SURREY)
          (CRAVES BOILS-70 HAMBURGER)
          (EATS SCALLION BACON)
          (EATS HAROSET-51 PISTACHIO-47)
          (CRAVES EXPECTATION-121 MUTTON)
          (EATS KALE SNICKERS)
          (HARMONY LEARNING-34 MERCURY)
          (EATS HOTDOG KALE-60)
          (EATS SNICKERS-1 BEEF-12)
          (EATS TOMATO RICE-31)
          (CRAVES PROSTATITIS KALE-60)
          (CRAVES LACERATION-69 HAMBURGER)
          (LOCALE SCALLION QUEBEC)
          (CRAVES EXPECTATION-40 TURKEY-14)
          (EATS BROCCOLI HAMBURGER)
          (LOCALE HAROSET-51 KENTUCKY)
          (LOCALE PEPPER-22 GUANABARA)
          (HARMONY SATISFACTION MERCURY)
          (EATS SHRIMP-5 TOFU)
          (CRAVES LOVE-108 MUFFIN)
          (EATS CHOCOLATE MUTTON)
          (HARMONY AESTHETICS-39 MERCURY)
          (LOCALE ONION KENTUCKY)
          (EATS TOMATO ENDIVE)
          (CRAVES TRIUMPH-41 MARZIPAN-13)
          (HARMONY TRIUMPH EARTH)
          (HARMONY SATIETY-112 EARTH)
          (CRAVES ANGINA COD-50)
          (CRAVES LONELINESS-78 YOGURT)
          (CRAVES SATIETY HAMBURGER-64)
          (HARMONY INTOXICATION MERCURY)
          (CRAVES DEPRESSION-67 PORK)
          (CRAVES ANGER-85 HOTDOG)
          (EATS LETTUCE COD)
          (EATS CANTELOPE-48 HAROSET-51)
          (EATS ORANGE PEA)
          (EATS PORK HAMBURGER)
          (CRAVES ENTERTAINMENT-37 ENDIVE-8)
          (HARMONY ACHIEVEMENT-104 EARTH)
          (EATS ONION-11 SNICKERS-1)
          (EATS LAMB CANTELOPE)
          (ATTACKS GUANABARA ALSACE)
          (EATS YOGURT OKRA-6)
          (EATS SWEETROLL-28 MARZIPAN)
          (EATS HAMBURGER PORK)
          (EATS WURST-63 WONDERBREAD)
          (EATS TUNA MARZIPAN)
          (EATS CHOCOLATE-61 CHICKEN)
          (EATS SCALLION PEA)
          (EATS SCALLOP-21 APPLE)
          (EATS CUCUMBER PISTACHIO)
          (LOCALE POPOVER-19 OREGON)
          (EATS SNICKERS-1 TOMATO)
          (CRAVES JEALOUSY-68 PORK)
          (EATS KALE BROCCOLI)
          (EATS POPOVER PEAR-9)
          (EATS BAGUETTE-62 TUNA-52)
          (EATS POTATO MARZIPAN-13)
          (CRAVES DEPRESSION YOGURT-18)
          (EATS SCALLOP TOMATO-20)
          (EATS SNICKERS-1 HOTDOG-54)
          (HARMONY UNDERSTANDING EARTH)
          (CRAVES SATIETY-105 CANTELOPE)
          (LOCALE GUAVA-2 MANITOBA)
          (CRAVES BOILS APPLE-49)
          (LOCALE MELON-30 GOIAS)
          (LOCALE POPOVER GUANABARA)
          (LOCALE SCALLION-57 BOSNIA)
          (LOCALE TUNA-52 GUANABARA)
          (HARMONY CURIOSITY-125 URANUS)
          (CRAVES GRIEF CHOCOLATE-61)
          (EATS PEPPER-22 CHOCOLATE)
          (HARMONY AESTHETICS-120 MERCURY)
          (EATS PEAR OKRA)
          (HARMONY CURIOSITY-35 URANUS)
          (EATS ENDIVE PEPPER-22)
          (EATS LETTUCE CUCUMBER)
          (EATS HAMBURGER-64 APPLE)
          (EATS BROCCOLI APPLE)
          (EATS APPLE-49 CANTELOPE-48)
          (LOCALE MUTTON-4 QUEBEC)
          (LOCALE HAMBURGER-64 ARIZONA)
          (EATS MELON YOGURT-18)
          (HARMONY ENTERTAINMENT-116 MERCURY)
          (LOCALE OKRA-6 PENNSYLVANIA)
          (EATS TOMATO-20 APPLE)
          (EATS ONION POTATO-26)
          (EATS ONION OKRA)
          (EATS OKRA-6 GUAVA-2)
          (EATS SCALLION-57 CUCUMBER)
          (EATS COD-50 SHRIMP)
          (EATS PAPAYA TURKEY)
          (HARMONY CURIOSITY EARTH)
          (EATS LOBSTER-7 TURKEY-14)
          (LOCALE HAMBURGER QUEBEC)
          (CRAVES INTOXICATION-124 BROCCOLI)
          (EATS CUCUMBER SCALLION-57)
          (EATS CUCUMBER YOGURT-18)
          (EATS ONION ONION-11)
          (LOCALE RICE GOIAS)
          (LOCALE MELON GUANABARA)
          (EATS PAPAYA POTATO)
          (CRAVES INTOXICATION PEA-55)
          (EATS CANTELOPE SHRIMP)
          (CRAVES UNDERSTANDING-114 MARZIPAN)
          (EATS POPOVER KALE-60)
          (HARMONY STIMULATION EARTH)
          (HARMONY UNDERSTANDING-128 EARTH)
          (LOCALE MUFFIN ARIZONA)
          (EATS HAMBURGER TUNA)
          (LOCALE BACON MANITOBA)
          (EATS SCALLOP PEPPER)
          (EATS GRAPEFRUIT-29 ORANGE)
          (EATS KALE-60 HOTDOG)
          (CRAVES ANGINA-83 ENDIVE)
          (CRAVES LEARNING-34 ARUGULA)
          (CRAVES JEALOUSY-91 ONION)
          (EATS PAPAYA BAGUETTE-62)
          (EATS PORK POPOVER-19)
          (EATS HAROSET WURST)
          (EATS CHICKEN-17 TURKEY)
          (LOCALE YOGURT-18 ALSACE)
          (EATS HOTDOG-54 OKRA)
          (EATS LEMON-10 ENDIVE-8)
          (HARMONY SATIETY URANUS)
          (EATS POTATO FLOUNDER-24)
          (EATS PEAR-9 BROCCOLI)
          (EATS FLOUNDER-24 POTATO)
          (EATS SHRIMP CANTELOPE)
          (EATS BAGUETTE-62 PAPAYA)
          (EATS TUNA HAMBURGER)
          (EATS CUCUMBER-25 SCALLION-57)
          (EATS PAPAYA SHRIMP)
          (EATS TURKEY SWEETROLL)
          (EATS MUFFIN-32 YOGURT)
          (CRAVES HANGOVER-88 KALE)
          (LOCALE SNICKERS SURREY)
          (EATS HAM WONDERBREAD)
          (EATS HAMBURGER-64 LOBSTER-7)
          (LOCALE PEAR-9 ARIZONA)
          (EATS APPLE HAMBURGER-64)
          (HARMONY ACHIEVEMENT-118 MERCURY)
          (LOCALE CHICKEN-17 MANITOBA)
          (EATS LOBSTER SHRIMP-5)
          (CRAVES ACHIEVEMENT-104 SCALLOP)
          (EATS TURKEY-14 PEPPER)
          (CRAVES REST TUNA-52)
          (CRAVES JEALOUSY-80 MARZIPAN)
          (LOCALE WONDERBREAD BAVARIA)
          (HARMONY STIMULATION-122 URANUS)
          (EATS GRAPEFRUIT-29 ONION)
          (EATS OKRA ONION)
          (CRAVES ENTERTAINMENT APPLE-49)
          (LOCALE BROCCOLI BOSNIA)
          (HARMONY STIMULATION-42 EARTH)
          (CRAVES ENTERTAINMENT-106 PEPPER)
          (EATS CHERRY BEEF)
          (HARMONY ENTERTAINMENT MERCURY)
          (CRAVES GRIEF-73 MUFFIN)
          (CRAVES ABRASION-66 CANTELOPE)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS CHERRY MARZIPAN)
          (LOCALE CANTELOPE-48 ALSACE)
          (EATS PISTACHIO-47 APPLE-49)
          (EATS PEA POTATO-26)
          (EATS APPLE-49 COD-50)
          (LOCALE LETTUCE QUEBEC)
          (EATS PEPPER LOBSTER-7)
          (EATS SCALLION PISTACHIO)
          (EATS PEA-55 POPOVER)
          (CRAVES UNDERSTANDING CANTELOPE-48)
          (EATS SCALLOP SCALLOP-21)
          (CRAVES AESTHETICS-39 SHRIMP-5)
          (EATS TOFU LOBSTER)
          (HARMONY SATISFACTION-46 EARTH)
          (LOCALE OKRA SURREY)
          (EATS WURST-63 CHOCOLATE-61)
          (CRAVES ANXIETY-71 LETTUCE)
          (EATS COD POPOVER)
          (LOCALE HAM-27 GUANABARA)
          (LOCALE RICE-31 BOSNIA)
          (LOCALE CANTELOPE QUEBEC)
          (CRAVES ACHIEVEMENT-118 WONDERBREAD)
          (EATS TUNA LEMON-10)
          (EATS ARUGULA LOBSTER)
          (EATS RICE-31 PAPAYA-23)
          (LOCALE SCALLOP SURREY)
          (EATS SCALLOP PEA-55)
          (LOCALE APPLE-49 GUANABARA)
          (EATS LAMB-15 COD)
          (LOCALE CUCUMBER ALSACE)
          (LOCALE SNICKERS-1 GUANABARA)
          (LOCALE APPLE QUEBEC)
          (EATS LEMON BACON)
          (EATS BEEF RICE)
          (EATS PEPPER TURKEY-14)
          (EATS GUAVA SCALLOP)
          (HARMONY LOVE URANUS)
          (EATS RICE-31 TOMATO)
          (EATS HAM-27 HAM)
          (EATS HAM PEAR)
          (CRAVES ANGINA-74 MUFFIN)
          (EATS PAPAYA CANTELOPE)
          (EATS PEPPER-22 ENDIVE)
          (LOCALE LOBSTER-7 MORAVIA)
          (LOCALE MARZIPAN-13 ARIZONA)
          (CRAVES CURIOSITY-125 BACON)
          (EATS OKRA HOTDOG-54)
          (EATS TURKEY CHICKEN-17)
          (EATS POPOVER KALE)
          (EATS GUAVA-2 POTATO)
          (EATS COD CUCUMBER)
          (EATS MARZIPAN-13 TURKEY)
          (EATS LEMON CUCUMBER)
          (EATS WONDERBREAD-58 TOMATO)
          (EATS SCALLOP GUAVA)
          (EATS OKRA-6 LAMB)
          (LOCALE LOBSTER GOIAS)
          (EATS APPLE SCALLOP-21)
          (EATS POPOVER-19 TURKEY-14)
          (CRAVES ABRASION-79 MARZIPAN)
          (CRAVES HANGOVER TOMATO-20)
          (EATS GUAVA-2 LAMB)
          (EATS WONDERBREAD-58 OKRA)
          (EATS PISTACHIO HOTDOG)
          (LOCALE SWEETROLL ARIZONA)
          (EATS PISTACHIO-47 HAROSET-51)
          (EATS HOTDOG-54 SNICKERS-1)
          (EATS TOMATO BAGUETTE)
          (EATS WONDERBREAD GRAPEFRUIT)
          (HARMONY ACHIEVEMENT EARTH)
          (EATS PEPPER BEEF)
          (EATS SCALLION-57 CUCUMBER-25)
          (EATS HAROSET-51 CANTELOPE-48)
          (EATS ENDIVE-8 ENDIVE)
          (EATS PEPPER SCALLOP)
          (EATS OKRA PEAR)
          (ATTACKS MANITOBA SURREY)
          (CRAVES LUBRICITY PEPPER-22)
          (EATS PORK-56 TUNA-52)
          (CRAVES LACERATION-95 MUTTON-4)
          (CRAVES INTOXICATION-127 LEMON)
          (CRAVES SCIATICA-100 MUFFIN-32)
          (EATS KALE PISTACHIO)
          (LOCALE PISTACHIO-47 PENNSYLVANIA)
          (ATTACKS GOIAS OREGON)
          (CRAVES SCIATICA TOMATO-20)
          (EATS MUFFIN RICE)
          (LOCALE CHERRY SURREY)
          (EATS PORK MARZIPAN)
          (EATS SNICKERS RICE-31)
          (EATS SHRIMP-5 SCALLOP)
          (EATS SWEETROLL MELON)
          (EATS MUTTON CHOCOLATE)
          (EATS OKRA CHERRY-59)
          (EATS GUAVA-2 OKRA-6)
          (EATS LAMB GUAVA-2)
          (CRAVES GRIEF-101 MUFFIN-32)
          (LOCALE POTATO MORAVIA)
          (HARMONY INTOXICATION-127 URANUS)
          (EATS SNICKERS BEEF-12)
          (EATS WURST HAROSET)
          (EATS YOGURT MUFFIN-32)
          (EATS GRAPEFRUIT CHICKEN)
          (EATS SHRIMP PAPAYA)
          (EATS POPOVER COD)
          (EATS CHICKEN-17 BROCCOLI-53)
          (EATS TOFU-3 APPLE)
          (EATS PAPAYA ONION)
          (LOCALE HAROSET ALSACE)
          (EATS MUTTON-4 PEPPER)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (EATS SCALLOP SHRIMP-5)
          (EATS CHOCOLATE PEPPER-22)
          (EATS LOBSTER TOFU)
          (EATS FLOUNDER TUNA)
          (EATS PEA ORANGE)
          (EATS BEEF-12 GRAPEFRUIT-29)
          (CRAVES ABRASION TUNA-52)
          (EATS PORK PEPPER)
          (HARMONY SATIETY-105 MERCURY)
          (EATS MUFFIN FLOUNDER)
          (LOCALE KALE-60 BOSNIA)
          (EATS HAMBURGER MUTTON))
   (:GOAL (AND (CRAVES DREAD COD-50)
               (CRAVES ANGER COD-50))))

(DEFINE (PROBLEM MYSTY-39)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS TUNA-54 LEMON-53 PEPPER-52 FLOUNDER-51
             POTATO-55 ORANGE-56 HOTDOG-57 GRAPEFRUIT-58
             SNICKERS-59 PEAR-60 TOMATO-61 CHERRY-62 BAGUETTE-63
             GUAVA-64 LAMB-17 APPLE-18 PORK-19 TOFU-20
             WONDERBREAD-21 ENDIVE-22 COD-23 KALE-24 YOGURT-25
             HAMBURGER-26 PAPAYA-27 WURST-28 CANTELOPE-29
             CHICKEN-30 SCALLOP-31 RICE-32 OKRA-9 HAM-10 TURKEY-11
             LOBSTER-12 CHOCOLATE-13 POPOVER-14 MARZIPAN-15
             LETTUCE-16 SCALLION-5 CUCUMBER-6 MUFFIN-7 SHRIMP-8
             BROCCOLI-3 BEEF-4 MUTTON-1 SWEETROLL-2 PEPPER SCALLOP
             FLOUNDER WURST BAGUETTE CHOCOLATE BEEF PEA
             GRAPEFRUIT CHERRY TOFU BACON PEAR LETTUCE HAM APPLE
             HOTDOG SNICKERS COD ENDIVE HAMBURGER POPOVER
             MUTTON CHICKEN ARUGULA WONDERBREAD KALE MUFFIN
             PISTACHIO BROCCOLI SCALLION CUCUMBER PORK LEMON
             TOMATO LAMB TURKEY RICE CANTELOPE HAROSET TUNA
             ONION OKRA LOBSTER POTATO YOGURT SWEETROLL SHRIMP
             MARZIPAN ORANGE MELON PAPAYA GUAVA - FOOD
             SATISFACTION EXPECTATION ENTERTAINMENT AESTHETICS
             CURIOSITY EMPATHY EXCITEMENT STIMULATION SATIETY
             UNDERSTANDING ACHIEVEMENT REST LEARNING LUBRICITY
             TRIUMPH INTOXICATION LOVE INTOXICATION-50
             TRIUMPH-49 STIMULATION-48 ACHIEVEMENT-47
             LEARNING-46 EXPECTATION-45 ENTERTAINMENT-44
             SATISFACTION-43 LUBRICITY-42 UNDERSTANDING-41 REST-40
             LOVE-39 SATIETY-38 EXCITEMENT-37 EMPATHY-36
             AESTHETICS-35 CURIOSITY-34 EXCITEMENT-33
             UNDERSTANDING-128 SATISFACTION-127 TRIUMPH-126
             CURIOSITY-125 REST-124 ENTERTAINMENT-123 SATIETY-122
             ACHIEVEMENT-121 LUBRICITY-120 EXPECTATION-119
             STIMULATION-118 LEARNING-117 AESTHETICS-116 LOVE-115
             INTOXICATION-114 EMPATHY-113 EXPECTATION-112
             LUBRICITY-111 INTOXICATION-110 SATISFACTION-109
             - PLEASURE
             SCIATICA PROSTATITIS DEPRESSION LONELINESS ANGER
             LACERATION HANGOVER GRIEF JEALOUSY ANXIETY ANGINA
             BOILS DREAD DEPRESSION-106 ANGINA-107
             LACERATION-108 ABRASION HANGOVER-102 JEALOUSY-103
             ANGER-104 GRIEF-105 BOILS-99 PROSTATITIS-100
             SCIATICA-101 LONELINESS-96 ABRASION-97 DREAD-98
             LACERATION-92 DREAD-93 HANGOVER-94 ANXIETY-95
             JEALOUSY-89 GRIEF-90 SCIATICA-91 LONELINESS-85
             BOILS-86 PROSTATITIS-87 DEPRESSION-88 ANGINA-81
             ANGER-82 ABRASION-83 ANXIETY-84 ANGER-76 ANGINA-77
             HANGOVER-78 ANXIETY-79 GRIEF-80 SCIATICA-73
             LONELINESS-74 LACERATION-75 JEALOUSY-70 PROSTATITIS-71
             ABRASION-72 DEPRESSION-68 BOILS-69 DREAD-67 DREAD-256
             SCIATICA-65 LONELINESS-66 ANGINA-255 ANXIETY-254
             LACERATION-250 HANGOVER-251 ANGER-252 JEALOUSY-253
             ABRASION-248 BOILS-249 GRIEF-247 DEPRESSION-246
             GRIEF-242 JEALOUSY-243 SCIATICA-244
             PROSTATITIS-245 HANGOVER-239 DEPRESSION-240 BOILS-241
             PROSTATITIS-238 ANXIETY-236 LONELINESS-237 ABRASION-234
             ANGINA-235 BOILS-230 ANGER-231 DREAD-232
             LACERATION-233 ANGINA-228 ANGER-229 SCIATICA-224
             ANXIETY-225 JEALOUSY-226 HANGOVER-227 ABRASION-220
             LONELINESS-221 DREAD-222 LACERATION-223 GRIEF-219
             ANGINA-215 HANGOVER-216 PROSTATITIS-217
             DEPRESSION-218 GRIEF-211 LONELINESS-212 SCIATICA-213
             ANGER-214 JEALOUSY-207 BOILS-208 LACERATION-209
             ANXIETY-210 DREAD-203 DEPRESSION-204 ABRASION-205
             PROSTATITIS-206 ABRASION-198 LACERATION-199 DREAD-200
             ANGINA-201 HANGOVER-202 ANGER-197 GRIEF-192
             ANXIETY-193 BOILS-194 DEPRESSION-195 JEALOUSY-196
             PROSTATITIS-191 LONELINESS-190 HANGOVER-188 SCIATICA-189
             DREAD-186 DEPRESSION-187 ABRASION-184 GRIEF-185
             ANGER-181 SCIATICA-182 PROSTATITIS-183 ANXIETY-176
             JEALOUSY-177 ANGINA-178 LONELINESS-179 BOILS-180
             LACERATION-175 JEALOUSY-172 LONELINESS-173 HANGOVER-174
             BOILS-167 PROSTATITIS-168 DREAD-169 SCIATICA-170
             GRIEF-171 ANXIETY-165 ANGER-166 ANGINA-161
             LACERATION-162 DEPRESSION-163 ABRASION-164 ANGER-157
             BOILS-158 DREAD-159 SCIATICA-160 ANXIETY-153
             ANGINA-154 JEALOUSY-155 GRIEF-156 ABRASION-151
             PROSTATITIS-152 ABRASION-146 LONELINESS-147
             LACERATION-148 DEPRESSION-149 HANGOVER-150 ANXIETY-141
             JEALOUSY-142 DEPRESSION-143 GRIEF-144 HANGOVER-145
             BOILS-136 ANGINA-137 PROSTATITIS-138 ANGER-139
             LACERATION-140 BOILS-131 ANGER-132 SCIATICA-133
             LONELINESS-134 DREAD-135 GRIEF-129 HANGOVER-130
             JEALOUSY-508 DEPRESSION-509 ANXIETY-510 ANGINA-511
             SCIATICA-512 ABRASION-506 PROSTATITIS-507
             LONELINESS-504 DREAD-505 ABRASION-499 ANGINA-500
             GRIEF-501 BOILS-502 LACERATION-503 ANGER-497
             LACERATION-498 JEALOUSY-493 HANGOVER-494 DREAD-495
             ANXIETY-496 SCIATICA-492 LONELINESS-491
             PROSTATITIS-490 GRIEF-488 DEPRESSION-489 DREAD-484
             HANGOVER-485 ANXIETY-486 ANGER-487 LACERATION-481
             DEPRESSION-482 PROSTATITIS-483 JEALOUSY-476 ANGINA-477
             SCIATICA-478 LONELINESS-479 ABRASION-480 BOILS-475
             LONELINESS-471 DEPRESSION-472 HANGOVER-473
             LACERATION-474 JEALOUSY-466 BOILS-467 ANXIETY-468
             ANGINA-469 ANGER-470 ABRASION-463 GRIEF-464
             PROSTATITIS-465 DREAD-461 SCIATICA-462 JEALOUSY-459
             GRIEF-460 PROSTATITIS-457 LACERATION-458 DREAD-456
             ANXIETY-454 DEPRESSION-455 LONELINESS-449
             SCIATICA-450 HANGOVER-451 BOILS-452 ABRASION-453
             PROSTATITIS-446 ANGINA-447 ANGER-448 ABRASION-443
             ANXIETY-444 ANGINA-445 GRIEF-440 HANGOVER-441
             SCIATICA-442 LONELINESS-437 DEPRESSION-438 BOILS-439
             LACERATION-436 JEALOUSY-433 ANGER-434 DREAD-435
             HANGOVER-431 DEPRESSION-432 LACERATION-428 ANGER-429
             ANXIETY-430 LONELINESS-426 JEALOUSY-427 SCIATICA-425
             ABRASION-424 ANGINA-422 GRIEF-423 SCIATICA-417
             LONELINESS-418 DREAD-419 PROSTATITIS-420 BOILS-421
             ABRASION-415 DREAD-416 - PAIN
             GUANABARA QUEBEC BAVARIA KENTUCKY SURREY - PROVINCE
             JUPITER PLUTO EARTH URANUS - PLANET)
   (:INIT (CRAVES BOILS-452 CANTELOPE)
          (CRAVES ANGER-157 GRAPEFRUIT)
          (CRAVES HANGOVER-102 HOTDOG-57)
          (CRAVES ABRASION-151 TOFU)
          (EATS TOFU PISTACHIO)
          (LOCALE SWEETROLL-2 GUANABARA)
          (EATS MUTTON-1 SWEETROLL)
          (EATS ENDIVE MELON)
          (EATS LETTUCE TUNA)
          (EATS GUAVA-64 ONION)
          (CRAVES BOILS-208 LETTUCE-16)
          (EATS ARUGULA MUTTON-1)
          (EATS SWEETROLL-2 MUFFIN)
          (HARMONY REST EARTH)
          (EATS WURST-28 SCALLION)
          (EATS CANTELOPE KALE)
          (CRAVES JEALOUSY-155 CHERRY)
          (CRAVES DREAD-159 GRAPEFRUIT)
          (CRAVES GRIEF-501 ENDIVE)
          (EATS PEA POPOVER)
          (EATS PORK SHRIMP)
          (EATS ARUGULA PORK-19)
          (CRAVES GRIEF-211 MARZIPAN-15)
          (CRAVES LACERATION-233 OKRA-9)
          (CRAVES ANXIETY-430 SWEETROLL)
          (CRAVES JEALOUSY-508 HOTDOG)
          (CRAVES LONELINESS-173 BAGUETTE)
          (LOCALE CHOCOLATE GUANABARA)
          (CRAVES HANGOVER-494 POPOVER)
          (EATS TURKEY LETTUCE)
          (CRAVES BOILS-241 CANTELOPE-29)
          (CRAVES ANGINA-161 PEA)
          (EATS CUCUMBER-6 TOFU)
          (EATS GRAPEFRUIT YOGURT)
          (HARMONY ENTERTAINMENT URANUS)
          (EATS OKRA TUNA)
          (CRAVES SATIETY-38 CHERRY)
          (LOCALE ARUGULA QUEBEC)
          (EATS KALE-24 PAPAYA-27)
          (EATS SHRIMP-8 BROCCOLI)
          (ATTACKS KENTUCKY SURREY)
          (CRAVES BOILS-167 CHOCOLATE)
          (LOCALE ONION KENTUCKY)
          (CRAVES HANGOVER-94 PEAR-60)
          (CRAVES ANGINA-511 HOTDOG)
          (LOCALE SHRIMP-8 KENTUCKY)
          (CRAVES JEALOUSY-466 CUCUMBER)
          (LOCALE MUFFIN QUEBEC)
          (LOCALE APPLE-18 BAVARIA)
          (CRAVES ABRASION-453 CANTELOPE)
          (EATS BACON COD)
          (CRAVES PROSTATITIS-87 CHERRY-62)
          (CRAVES LONELINESS-471 SCALLION)
          (HARMONY EMPATHY-36 URANUS)
          (CRAVES BOILS-131 HAM)
          (EATS SCALLOP SWEETROLL-2)
          (CRAVES ANGINA-77 GUAVA-64)
          (CRAVES LONELINESS-479 PISTACHIO)
          (CRAVES HANGOVER-174 BAGUETTE)
          (EATS HOTDOG HAROSET)
          (EATS GRAPEFRUIT-58 SCALLION-5)
          (CRAVES ANXIETY-193 SHRIMP-8)
          (CRAVES PROSTATITIS-420 PAPAYA)
          (EATS BAGUETTE-63 GUAVA-64)
          (HARMONY SATISFACTION-127 PLUTO)
          (EATS POPOVER TOFU-20)
          (CRAVES PROSTATITIS-152 TOFU)
          (CRAVES AESTHETICS-35 SNICKERS)
          (EATS SCALLOP PEA)
          (CRAVES DEPRESSION-455 RICE)
          (EATS KALE ORANGE-56)
          (LOCALE OKRA-9 GUANABARA)
          (CRAVES SCIATICA-462 LEMON)
          (EATS BROCCOLI-3 PISTACHIO)
          (LOCALE SNICKERS GUANABARA)
          (LOCALE WURST QUEBEC)
          (CRAVES PROSTATITIS-490 ARUGULA)
          (CRAVES STIMULATION-48 TURKEY-11)
          (CRAVES LACERATION PEPPER-52)
          (CRAVES SCIATICA-170 CHOCOLATE)
          (EATS WURST BAGUETTE-63)
          (EATS BEEF COD)
          (LOCALE SCALLION-5 GUANABARA)
          (CRAVES ENTERTAINMENT-44 MUTTON-1)
          (LOCALE FLOUNDER BAVARIA)
          (HARMONY EXCITEMENT PLUTO)
          (EATS CHERRY-62 SCALLION)
          (EATS TURKEY TOMATO)
          (CRAVES ANGINA-81 BAGUETTE-63)
          (EATS MUFFIN POTATO)
          (CRAVES DEPRESSION-438 OKRA)
          (LOCALE POPOVER QUEBEC)
          (LOCALE ORANGE-56 KENTUCKY)
          (EATS PEAR-60 TUNA)
          (EATS POPOVER LAMB)
          (CRAVES DEPRESSION-240 CANTELOPE-29)
          (EATS COD MUTTON)
          (CRAVES SCIATICA-478 PISTACHIO)
          (EATS BROCCOLI-3 POTATO)
          (EATS OKRA-9 MARZIPAN)
          (CRAVES ANGINA-201 CUCUMBER-6)
          (LOCALE HOTDOG BAVARIA)
          (LOCALE KALE QUEBEC)
          (LOCALE COD QUEBEC)
          (EATS PEAR-60 OKRA-9)
          (HARMONY CURIOSITY-34 EARTH)
          (CRAVES LACERATION-148 BACON)
          (HARMONY SATIETY-38 EARTH)
          (EATS PEA COD-23)
          (CRAVES EMPATHY TOMATO-61)
          (LOCALE LETTUCE-16 GUANABARA)
          (LOCALE LEMON QUEBEC)
          (EATS POTATO TOMATO-61)
          (EATS ORANGE-56 MUFFIN-7)
          (EATS FLOUNDER KALE)
          (EATS CUCUMBER-6 ARUGULA)
          (CRAVES HANGOVER-227 TURKEY-11)
          (EATS WURST KALE)
          (EATS LETTUCE-16 SCALLION)
          (CRAVES ANGINA-178 FLOUNDER)
          (EATS PEA PEPPER-52)
          (EATS COD-23 PEA)
          (CRAVES ANGER-132 HAM)
          (CRAVES ANGER-429 SWEETROLL)
          (EATS HAM-10 POTATO)
          (EATS MARZIPAN-15 APPLE-18)
          (EATS ORANGE-56 KALE)
          (CRAVES DEPRESSION-68 PORK-19)
          (HARMONY EMPATHY-113 PLUTO)
          (EATS YOGURT APPLE-18)
          (EATS APPLE CANTELOPE-29)
          (CRAVES ABRASION-205 SCALLION-5)
          (EATS POTATO HAM)
          (EATS BEEF-4 ENDIVE)
          (CRAVES BOILS-230 OKRA-9)
          (CRAVES SCIATICA-189 MUTTON-1)
          (CRAVES LUBRICITY-120 SCALLION)
          (CRAVES ANGINA-477 PISTACHIO)
          (EATS SHRIMP PORK)
          (EATS CHERRY-62 LOBSTER-12)
          (EATS ENDIVE-22 CHOCOLATE-13)
          (EATS PEA SCALLOP)
          (CRAVES LACERATION-140 LETTUCE)
          (EATS PAPAYA-27 CHERRY)
          (EATS GRAPEFRUIT CHOCOLATE)
          (CRAVES HANGOVER-485 KALE)
          (EATS CHOCOLATE HOTDOG)
          (CRAVES DREAD-416 GUAVA)
          (CRAVES TRIUMPH HAMBURGER-26)
          (LOCALE MUFFIN-7 BAVARIA)
          (EATS WURST TUNA)
          (EATS LOBSTER-12 CHERRY-62)
          (LOCALE PEA QUEBEC)
          (ORBITS PLUTO EARTH)
          (EATS LEMON-53 TUNA-54)
          (CRAVES LONELINESS LEMON-53)
          (CRAVES SCIATICA-244 WURST-28)
          (EATS MUFFIN RICE)
          (CRAVES ANGINA-235 RICE-32)
          (EATS CHERRY ONION)
          (LOCALE CHERRY SURREY)
          (CRAVES ANGER-139 LETTUCE)
          (EATS YOGURT CANTELOPE)
          (LOCALE BEEF QUEBEC)
          (HARMONY INTOXICATION-114 PLUTO)
          (CRAVES TRIUMPH-49 OKRA-9)
          (CRAVES CURIOSITY-34 COD)
          (EATS GRAPEFRUIT-58 YOGURT)
          (EATS BACON PISTACHIO)
          (CRAVES EXCITEMENT-37 HAM)
          (EATS OKRA-9 PEAR-60)
          (EATS FLOUNDER-51 LEMON-53)
          (EATS CHOCOLATE HAROSET)
          (CRAVES PROSTATITIS-465 PORK)
          (CRAVES ANGINA-137 LETTUCE)
          (EATS CANTELOPE HAM)
          (CRAVES SCIATICA TUNA-54)
          (EATS PISTACHIO TOFU)
          (CRAVES LONELINESS-74 LAMB-17)
          (EATS HAMBURGER PAPAYA)
          (LOCALE HAM QUEBEC)
          (HARMONY LUBRICITY-120 PLUTO)
          (CRAVES LONELINESS-504 COD)
          (LOCALE CANTELOPE-29 QUEBEC)
          (CRAVES ANXIETY-79 GUAVA-64)
          (EATS BAGUETTE ARUGULA)
          (CRAVES DEPRESSION-143 PEAR)
          (LOCALE TURKEY BAVARIA)
          (CRAVES HANGOVER-150 BACON)
          (CRAVES LONELINESS-212 MARZIPAN-15)
          (CRAVES SCIATICA-182 SCALLOP)
          (CRAVES JEALOUSY-103 HOTDOG-57)
          (EATS BROCCOLI SHRIMP-8)
          (HARMONY TRIUMPH-126 EARTH)
          (EATS SNICKERS HOTDOG-57)
          (CRAVES ABRASION-184 PEPPER)
          (EATS FLOUNDER HAMBURGER-26)
          (EATS PEAR CANTELOPE)
          (CRAVES SCIATICA-160 GRAPEFRUIT)
          (EATS RICE-32 PISTACHIO)
          (CRAVES GRIEF-423 MELON)
          (EATS PEA RICE-32)
          (CRAVES GRIEF-80 GUAVA-64)
          (EATS SWEETROLL-2 SCALLOP)
          (EATS LOBSTER-12 LETTUCE-16)
          (LOCALE SCALLOP-31 KENTUCKY)
          (HARMONY LUBRICITY EARTH)
          (LOCALE GUAVA-64 BAVARIA)
          (CRAVES BOILS-439 OKRA)
          (CRAVES LACERATION-458 LAMB)
          (CRAVES ANGINA-422 MELON)
          (CRAVES SCIATICA-492 MUTTON)
          (HARMONY SATISFACTION-109 PLUTO)
          (CRAVES DREAD-484 KALE)
          (LOCALE CHERRY-62 GUANABARA)
          (EATS KALE WURST)
          (EATS PISTACHIO CHICKEN)
          (EATS TOMATO PORK)
          (CRAVES LACERATION-503 ENDIVE)
          (HARMONY CURIOSITY URANUS)
          (EATS RICE-32 SNICKERS-59)
          (HARMONY EXPECTATION-119 URANUS)
          (LOCALE GRAPEFRUIT BAVARIA)
          (LOCALE CHICKEN-30 GUANABARA)
          (EATS RICE WURST-28)
          (EATS SCALLION CHERRY-62)
          (LOCALE YOGURT-25 GUANABARA)
          (EATS HOTDOG-57 SNICKERS)
          (EATS SNICKERS LOBSTER)
          (HARMONY SATISFACTION PLUTO)
          (EATS FLOUNDER-51 TUNA-54)
          (EATS BAGUETTE LOBSTER)
          (CRAVES LACERATION-108 ORANGE-56)
          (EATS SCALLION-5 GRAPEFRUIT-58)
          (EATS CHICKEN PISTACHIO)
          (CRAVES ABRASION-164 PEA)
          (EATS WURST CHERRY)
          (CRAVES DEPRESSION-204 SCALLION-5)
          (CRAVES ENTERTAINMENT-123 WONDERBREAD)
          (LOCALE CUCUMBER GUANABARA)
          (EATS CHOCOLATE CUCUMBER)
          (EATS HAM CANTELOPE)
          (EATS SCALLOP POPOVER)
          (EATS HAROSET LAMB-17)
          (CRAVES DEPRESSION-509 HOTDOG)
          (CRAVES GRIEF-185 PEPPER)
          (EATS PAPAYA-27 PEAR-60)
          (CRAVES PROSTATITIS-446 HAROSET)
          (LOCALE SCALLION QUEBEC)
          (CRAVES GRIEF PEPPER-52)
          (EATS COD BACON)
          (CRAVES GRIEF-247 HAMBURGER-26)
          (EATS ARUGULA CUCUMBER-6)
          (EATS SCALLION PAPAYA)
          (EATS CUCUMBER-6 BROCCOLI-3)
          (CRAVES DEPRESSION-432 YOGURT)
          (CRAVES DEPRESSION-472 SCALLION)
          (HARMONY INTOXICATION-110 EARTH)
          (EATS WONDERBREAD MELON)
          (HARMONY LUBRICITY-111 URANUS)
          (CRAVES DREAD-456 TURKEY)
          (CRAVES LACERATION-474 SCALLION)
          (EATS HOTDOG CHOCOLATE)
          (CRAVES SATISFACTION-43 SWEETROLL-2)
          (CRAVES DREAD-256 WONDERBREAD-21)
          (LOCALE TOMATO-61 SURREY)
          (CRAVES DREAD-435 POTATO)
          (CRAVES GRIEF-242 WURST-28)
          (EATS SCALLOP-31 CHERRY)
          (LOCALE TOMATO QUEBEC)
          (EATS BROCCOLI GUAVA)
          (CRAVES PROSTATITIS-483 MUFFIN)
          (CRAVES BOILS-194 SHRIMP-8)
          (CRAVES DREAD-186 SWEETROLL-2)
          (EATS GUAVA PEPPER)
          (CRAVES ANXIETY-95 PEAR-60)
          (CRAVES ANXIETY-236 SCALLOP-31)
          (EATS PORK-19 ARUGULA)
          (CRAVES ANXIETY-176 FLOUNDER)
          (CRAVES LONELINESS-221 LOBSTER-12)
          (CRAVES ANGER-197 MUFFIN-7)
          (EATS CANTELOPE TUNA)
          (EATS LOBSTER YOGURT)
          (HARMONY REST-40 URANUS)
          (CRAVES JEALOUSY-172 BAGUETTE)
          (HARMONY SATISFACTION-43 URANUS)
          (EATS MARZIPAN SHRIMP)
          (EATS HOTDOG-57 GRAPEFRUIT)
          (EATS SCALLOP RICE)
          (CRAVES ACHIEVEMENT TOFU-20)
          (LOCALE POPOVER-14 GUANABARA)
          (EATS CHICKEN-30 POPOVER)
          (CRAVES DREAD-93 PEAR-60)
          (EATS COD BEEF)
          (LOCALE SWEETROLL KENTUCKY)
          (CRAVES LONELINESS-491 CHICKEN)
          (EATS MUTTON TOFU)
          (CRAVES ANGER-487 KALE)
          (LOCALE PORK QUEBEC)
          (EATS YOGURT GRAPEFRUIT-58)
          (EATS HAROSET FLOUNDER)
          (CRAVES PROSTATITIS-457 LAMB)
          (HARMONY STIMULATION-48 EARTH)
          (EATS HAM-10 BAGUETTE)
          (CRAVES ANXIETY FLOUNDER-51)
          (EATS POPOVER-14 COD-23)
          (EATS SWEETROLL CHOCOLATE-13)
          (CRAVES HANGOVER-188 MUTTON-1)
          (EATS ONION GUAVA-64)
          (CRAVES ACHIEVEMENT-47 CHOCOLATE-13)
          (CRAVES HANGOVER-251 KALE-24)
          (CRAVES SATISFACTION LEMON-53)
          (CRAVES ABRASION-480 PISTACHIO)
          (EATS CUCUMBER MELON)
          (LOCALE MUTTON QUEBEC)
          (LOCALE MUTTON-1 QUEBEC)
          (LOCALE HOTDOG-57 BAVARIA)
          (EATS TUNA MUFFIN-7)
          (CRAVES LEARNING COD-23)
          (EATS PORK TOMATO)
          (CRAVES PROSTATITIS-507 SNICKERS)
          (EATS RICE MUFFIN)
          (EATS SCALLOP-31 PAPAYA-27)
          (CRAVES BOILS-421 PAPAYA)
          (CRAVES JEALOUSY-70 APPLE-18)
          (CRAVES UNDERSTANDING PORK-19)
          (EATS SWEETROLL BEEF)
          (LOCALE APPLE GUANABARA)
          (LOCALE TUNA-54 BAVARIA)
          (CRAVES ABRASION-220 LOBSTER-12)
          (EATS LEMON POTATO-55)
          (LOCALE PEPPER-52 KENTUCKY)
          (EATS APPLE LEMON)
          (CRAVES EXPECTATION-112 POTATO)
          (EATS GRAPEFRUIT HOTDOG-57)
          (EATS BROCCOLI-3 CUCUMBER-6)
          (EATS ENDIVE BEEF-4)
          (CRAVES ABRASION-499 ENDIVE)
          (EATS ENDIVE-22 MUTTON)
          (CRAVES ANXIETY-141 PEAR)
          (EATS TUNA LETTUCE)
          (HARMONY LOVE PLUTO)
          (EATS MUFFIN POPOVER-14)
          (CRAVES DEPRESSION-106 ORANGE-56)
          (EATS MUTTON PORK-19)
          (EATS LAMB POPOVER)
          (LOCALE ORANGE QUEBEC)
          (CRAVES SCIATICA-417 PAPAYA)
          (EATS LEMON-53 FLOUNDER-51)
          (CRAVES ABRASION ORANGE-56)
          (CRAVES LONELINESS-66 WONDERBREAD-21)
          (CRAVES PROSTATITIS-217 POPOVER-14)
          (EATS TOFU-20 PISTACHIO)
          (LOCALE CUCUMBER-6 QUEBEC)
          (CRAVES LONELINESS-190 BEEF-4)
          (CRAVES ABRASION-463 PORK)
          (CRAVES PROSTATITIS-168 CHOCOLATE)
          (CRAVES ANXIETY-210 LETTUCE-16)
          (EATS KALE FLOUNDER)
          (EATS HAMBURGER RICE)
          (CRAVES DREAD-98 SNICKERS-59)
          (EATS POTATO SNICKERS-59)
          (CRAVES ABRASION-424 ORANGE)
          (CRAVES GRIEF-90 TOMATO-61)
          (EATS POPOVER SCALLION)
          (EATS KALE-24 SCALLOP-31)
          (EATS ORANGE HOTDOG)
          (LOCALE OKRA QUEBEC)
          (CRAVES GRIEF-460 TOMATO)
          (CRAVES HANGOVER-441 ONION)
          (CRAVES DREAD-203 SCALLION-5)
          (CRAVES ANXIETY-165 BEEF)
          (EATS HAROSET YOGURT)
          (EATS PEAR POTATO)
          (LOCALE HAM-10 GUANABARA)
          (EATS MELON ENDIVE)
          (EATS POTATO MUFFIN)
          (CRAVES DEPRESSION-489 WONDERBREAD)
          (EATS GUAVA BROCCOLI)
          (CRAVES DREAD-461 LEMON)
          (EATS YOGURT GRAPEFRUIT)
          (CRAVES ABRASION-83 BAGUETTE-63)
          (HARMONY TRIUMPH PLUTO)
          (EATS POTATO HAM-10)
          (EATS TUNA OKRA-9)
          (CRAVES GRIEF-129 APPLE)
          (LOCALE BEEF-4 GUANABARA)
          (EATS POPOVER SCALLOP)
          (EATS LAMB-17 KALE)
          (CRAVES EXPECTATION-119 CUCUMBER)
          (CRAVES GRIEF-144 PEAR)
          (CRAVES JEALOUSY-493 POPOVER)
          (EATS CHICKEN-30 LETTUCE-16)
          (EATS YOGURT LOBSTER)
          (CRAVES PROSTATITIS-100 GRAPEFRUIT-58)
          (CRAVES LUBRICITY YOGURT-25)
          (EATS GUAVA-64 BAGUETTE-63)
          (EATS MUTTON-1 ARUGULA)
          (CRAVES HANGOVER-130 APPLE)
          (LOCALE POTATO-55 GUANABARA)
          (EATS MARZIPAN PAPAYA-27)
          (LOCALE LAMB-17 BAVARIA)
          (CRAVES BOILS-158 GRAPEFRUIT)
          (CRAVES LONELINESS-134 HAM)
          (EATS TOFU MUTTON)
          (CRAVES LACERATION-92 PEAR-60)
          (CRAVES ABRASION-415 GUAVA)
          (CRAVES ANGER-252 KALE-24)
          (CRAVES STIMULATION BAGUETTE-63)
          (CRAVES BOILS-249 YOGURT-25)
          (HARMONY EXCITEMENT-37 PLUTO)
          (CRAVES JEALOUSY-243 WURST-28)
          (CRAVES DEPRESSION-246 PAPAYA-27)
          (EATS LOBSTER SNICKERS)
          (LOCALE MARZIPAN GUANABARA)
          (EATS PISTACHIO BACON)
          (CRAVES LUBRICITY-42 PEPPER)
          (EATS MARZIPAN OKRA-9)
          (ATTACKS GUANABARA QUEBEC)
          (CRAVES JEALOUSY-476 PISTACHIO)
          (EATS PISTACHIO TOFU-20)
          (EATS MELON LEMON)
          (CRAVES DREAD-169 CHOCOLATE)
          (HARMONY EXPECTATION-45 URANUS)
          (HARMONY CURIOSITY-125 EARTH)
          (ATTACKS QUEBEC BAVARIA)
          (EATS LOBSTER BAGUETTE)
          (EATS KALE CANTELOPE)
          (CRAVES LONELINESS-449 CANTELOPE)
          (EATS POPOVER-14 RICE-32)
          (EATS RICE LOBSTER-12)
          (HARMONY EXPECTATION-112 EARTH)
          (EATS PAPAYA-27 KALE-24)
          (CRAVES JEALOUSY-427 SHRIMP)
          (EATS CANTELOPE YOGURT)
          (CRAVES LACERATION-162 PEA)
          (CRAVES ANGINA-469 CUCUMBER)
          (CRAVES PROSTATITIS-238 CHICKEN-30)
          (CRAVES ANGER-448 HAROSET)
          (CRAVES LACERATION-175 WURST)
          (EATS LEMON-53 PEPPER-52)
          (CRAVES LOVE CANTELOPE-29)
          (CRAVES DREAD-419 PAPAYA)
          (CRAVES ANXIETY-225 TURKEY-11)
          (EATS LEMON MELON)
          (EATS TOMATO-61 MARZIPAN-15)
          (EATS TUNA OKRA)
          (CRAVES ABRASION-248 YOGURT-25)
          (EATS TOMATO MARZIPAN)
          (EATS KALE ONION)
          (CRAVES LUBRICITY-111 SWEETROLL)
          (LOCALE LETTUCE QUEBEC)
          (CRAVES EXCITEMENT CHERRY-62)
          (LOCALE PEAR-60 QUEBEC)
          (CRAVES ANGINA-255 ENDIVE-22)
          (EATS ORANGE CUCUMBER)
          (EATS LAMB CHICKEN)
          (LOCALE PEAR KENTUCKY)
          (EATS RICE SCALLOP)
          (EATS WONDERBREAD-21 KALE-24)
          (EATS FLOUNDER HAROSET)
          (ATTACKS BAVARIA KENTUCKY)
          (LOCALE POTATO KENTUCKY)
          (EATS CANTELOPE-29 COD)
          (LOCALE WONDERBREAD-21 GUANABARA)
          (HARMONY AESTHETICS-116 EARTH)
          (HARMONY ACHIEVEMENT-47 EARTH)
          (EATS POTATO PEAR)
          (EATS WURST-28 RICE)
          (CRAVES SATIETY-122 PISTACHIO)
          (CRAVES REST WONDERBREAD-21)
          (EATS KALE-24 WONDERBREAD-21)
          (HARMONY STIMULATION EARTH)
          (LOCALE PORK-19 QUEBEC)
          (HARMONY LUBRICITY-42 EARTH)
          (CRAVES ANXIETY-468 CUCUMBER)
          (LOCALE LOBSTER-12 GUANABARA)
          (LOCALE COD-23 KENTUCKY)
          (CRAVES ABRASION-443 TUNA)
          (EATS HOTDOG ORANGE)
          (CRAVES EXPECTATION-45 SHRIMP-8)
          (CRAVES EMPATHY-36 APPLE)
          (EATS OKRA PEPPER)
          (CRAVES ANGER-231 OKRA-9)
          (EATS MARZIPAN TOMATO)
          (CRAVES CURIOSITY PEAR-60)
          (LOCALE GUAVA BAVARIA)
          (CRAVES PROSTATITIS-191 BROCCOLI-3)
          (LOCALE LOBSTER KENTUCKY)
          (CRAVES EMPATHY-113 LOBSTER)
          (HARMONY UNDERSTANDING PLUTO)
          (CRAVES ANXIETY-254 COD-23)
          (CRAVES HANGOVER-473 SCALLION)
          (EATS SNICKERS-59 RICE-32)
          (EATS ENDIVE CANTELOPE-29)
          (CRAVES UNDERSTANDING-41 BAGUETTE)
          (CRAVES ANGINA-228 HAM-10)
          (EATS PEPPER GUAVA)
          (EATS HAMBURGER-26 TURKEY-11)
          (EATS PEPPER-52 FLOUNDER-51)
          (EATS TURKEY-11 HAMBURGER-26)
          (CRAVES GRIEF-440 ONION)
          (EATS COD-23 POPOVER-14)
          (LOCALE LAMB QUEBEC)
          (CRAVES SATISFACTION-127 POPOVER)
          (CRAVES HANGOVER-239 CANTELOPE-29)
          (EATS TUNA HAM)
          (EATS RICE HAMBURGER)
          (CRAVES SCIATICA-224 TURKEY-11)
          (EATS SCALLOP-31 KALE-24)
          (CRAVES JEALOUSY-253 KALE-24)
          (CRAVES DREAD-135 HAM)
          (EATS PAPAYA-27 MARZIPAN)
          (LOCALE HAMBURGER-26 QUEBEC)
          (LOCALE MARZIPAN-15 KENTUCKY)
          (CRAVES GRIEF-171 CHOCOLATE)
          (HARMONY AESTHETICS-35 EARTH)
          (EATS LAMB WONDERBREAD)
          (CRAVES ABRASION-97 SNICKERS-59)
          (CRAVES LACERATION-436 LOBSTER)
          (EATS KALE YOGURT)
          (CRAVES SCIATICA-442 ONION)
          (CRAVES PROSTATITIS-183 SCALLOP)
          (EATS TOMATO TURKEY)
          (EATS SCALLION LETTUCE-16)
          (ORBITS JUPITER PLUTO)
          (CRAVES LEARNING-117 LAMB)
          (CRAVES DREAD-222 LOBSTER-12)
          (CRAVES SCIATICA-65 WONDERBREAD-21)
          (CRAVES JEALOUSY FLOUNDER-51)
          (EATS PEAR-60 PAPAYA-27)
          (EATS RICE-32 POPOVER-14)
          (CRAVES ANGER-214 MARZIPAN-15)
          (CRAVES SATIETY GUAVA-64)
          (EATS WONDERBREAD-21 TUNA)
          (EATS POTATO-55 LEMON)
          (EATS ORANGE MARZIPAN)
          (CRAVES LONELINESS-96 SNICKERS-59)
          (EATS CHERRY WURST)
          (EATS SNICKERS YOGURT-25)
          (EATS TUNA PEAR-60)
          (EATS CHICKEN POPOVER)
          (EATS ONION KALE)
          (CRAVES LONELINESS-418 PAPAYA)
          (EATS TUNA-54 LEMON-53)
          (HARMONY ENTERTAINMENT-123 PLUTO)
          (HARMONY TRIUMPH-49 PLUTO)
          (EATS COD CANTELOPE-29)
          (CRAVES SCIATICA-133 HAM)
          (EATS BEEF SWEETROLL)
          (HARMONY EMPATHY PLUTO)
          (CRAVES ANGER-470 CUCUMBER)
          (EATS HAMBURGER-26 FLOUNDER)
          (EATS CUCUMBER CHOCOLATE)
          (CRAVES ANXIETY-486 KALE)
          (CRAVES ABRASION-146 BACON)
          (CRAVES LONELINESS-426 SHRIMP)
          (HARMONY INTOXICATION PLUTO)
          (EATS APPLE COD)
          (CRAVES LOVE-39 GRAPEFRUIT)
          (LOCALE GRAPEFRUIT-58 BAVARIA)
          (CRAVES LACERATION-250 KALE-24)
          (HARMONY REST-124 PLUTO)
          (CRAVES ANGINA-107 ORANGE-56)
          (CRAVES ABRASION-234 RICE-32)
          (CRAVES BOILS-86 CHERRY-62)
          (EATS SCALLION WURST-28)
          (LOCALE HAROSET QUEBEC)
          (HARMONY LEARNING-117 PLUTO)
          (EATS PAPAYA-27 SCALLOP-31)
          (LOCALE ENDIVE BAVARIA)
          (CRAVES HANGOVER-431 YOGURT)
          (EATS LOBSTER-12 RICE)
          (EATS POTATO BROCCOLI-3)
          (EATS WONDERBREAD LAMB)
          (CRAVES DEPRESSION-195 SHRIMP-8)
          (EATS SWEETROLL MUTTON-1)
          (CRAVES JEALOUSY-142 PEAR)
          (LOCALE BAGUETTE QUEBEC)
          (CRAVES ACHIEVEMENT-121 BROCCOLI)
          (CRAVES BOILS-99 GRAPEFRUIT-58)
          (CRAVES AESTHETICS ORANGE-56)
          (CRAVES GRIEF-219 CHOCOLATE-13)
          (EATS PEPPER-52 PEA)
          (CRAVES PROSTATITIS-138 LETTUCE)
          (EATS CANTELOPE-29 ENDIVE)
          (HARMONY LEARNING-46 PLUTO)
          (CRAVES HANGOVER-78 GUAVA-64)
          (LOCALE TUNA KENTUCKY)
          (LOCALE TURKEY-11 GUANABARA)
          (HARMONY INTOXICATION-50 URANUS)
          (CRAVES DEPRESSION-149 BACON)
          (CRAVES BOILS POTATO-55)
          (EATS FLOUNDER-51 PEPPER-52)
          (LOCALE BACON QUEBEC)
          (EATS PEPPER-52 LEMON-53)
          (LOCALE PAPAYA GUANABARA)
          (CRAVES BOILS-502 ENDIVE)
          (CRAVES DEPRESSION-187 SWEETROLL-2)
          (EATS CHOCOLATE-13 SWEETROLL)
          (LOCALE HAMBURGER QUEBEC)
          (CRAVES GRIEF-488 WONDERBREAD)
          (EATS WONDERBREAD CHICKEN)
          (EATS APPLE-18 YOGURT)
          (LOCALE CHOCOLATE-13 BAVARIA)
          (CRAVES PROSTATITIS-245 WURST-28)
          (CRAVES EXCITEMENT-33 ENDIVE)
          (EATS MUFFIN-7 ORANGE-56)
          (EATS SCALLION-5 BAGUETTE)
          (CRAVES LONELINESS-85 CHERRY-62)
          (CRAVES ANGER-181 SCALLOP)
          (CRAVES DEPRESSION-482 MUFFIN)
          (EATS TURKEY-11 MARZIPAN)
          (CRAVES UNDERSTANDING-128 HAMBURGER)
          (EATS MUFFIN-7 CANTELOPE)
          (CRAVES DEPRESSION LEMON-53)
          (EATS MUFFIN-7 TUNA)
          (CRAVES HANGOVER-216 POPOVER-14)
          (CRAVES ANGER-229 HAM-10)
          (EATS YOGURT HAROSET)
          (CRAVES JEALOUSY-226 TURKEY-11)
          (CRAVES INTOXICATION WURST-28)
          (EATS MUTTON ENDIVE-22)
          (LOCALE BROCCOLI-3 BAVARIA)
          (EATS RICE-32 PEA)
          (LOCALE PAPAYA-27 GUANABARA)
          (LOCALE RICE QUEBEC)
          (CRAVES DEPRESSION-88 CHERRY-62)
          (EATS CHERRY PAPAYA-27)
          (CRAVES CURIOSITY-125 CHICKEN)
          (HARMONY UNDERSTANDING-41 PLUTO)
          (CRAVES GRIEF-192 SHRIMP-8)
          (EATS PEAR YOGURT)
          (CRAVES SCIATICA-512 HOTDOG)
          (CRAVES STIMULATION-118 LEMON)
          (LOCALE TOFU BAVARIA)
          (HARMONY LEARNING PLUTO)
          (EATS MELON CUCUMBER)
          (CRAVES LEARNING-46 SCALLION-5)
          (LOCALE YOGURT KENTUCKY)
          (EATS TUNA-54 FLOUNDER-51)
          (EATS CHERRY SCALLOP-31)
          (EATS CANTELOPE MUFFIN-7)
          (CRAVES ANGINA-445 TUNA)
          (LOCALE BAGUETTE-63 QUEBEC)
          (CRAVES BOILS-180 FLOUNDER)
          (CRAVES PROSTATITIS-71 APPLE-18)
          (CRAVES HANGOVER-145 PEAR)
          (CRAVES SCIATICA-91 TOMATO-61)
          (CRAVES BOILS-475 BROCCOLI)
          (EATS PORK-19 MUTTON)
          (EATS APPLE-18 MARZIPAN-15)
          (EATS SNICKERS-59 POTATO)
          (CRAVES DEPRESSION-218 POPOVER-14)
          (EATS POPOVER CHICKEN-30)
          (HARMONY AESTHETICS URANUS)
          (EATS PISTACHIO BROCCOLI-3)
          (LOCALE WURST-28 KENTUCKY)
          (LOCALE KALE-24 GUANABARA)
          (EATS OKRA-9 TUNA)
          (CRAVES INTOXICATION-110 PAPAYA)
          (CRAVES DEPRESSION-163 PEA)
          (EATS CUCUMBER LEMON)
          (EATS SHRIMP SHRIMP-8)
          (EATS CHICKEN BEEF-4)
          (CRAVES ANXIETY-153 CHERRY)
          (CRAVES ANGER-434 POTATO)
          (LOCALE PISTACHIO QUEBEC)
          (CRAVES ABRASION-198 CUCUMBER-6)
          (EATS BAGUETTE SCALLION-5)
          (EATS PISTACHIO RICE-32)
          (CRAVES ANXIETY-510 HOTDOG)
          (LOCALE FLOUNDER-51 KENTUCKY)
          (CRAVES LONELINESS-237 SCALLOP-31)
          (CRAVES REST-124 ARUGULA)
          (EATS PAPAYA SCALLION)
          (CRAVES GRIEF-464 PORK)
          (EATS MELON WONDERBREAD)
          (CRAVES JEALOUSY-433 POTATO)
          (EATS CUCUMBER ORANGE)
          (CRAVES GRIEF-156 CHERRY)
          (CRAVES JEALOUSY-196 SHRIMP-8)
          (CRAVES JEALOUSY-207 LETTUCE-16)
          (EATS MARZIPAN TURKEY-11)
          (EATS YOGURT KALE)
          (CRAVES DREAD-200 CUCUMBER-6)
          (EATS HAROSET HOTDOG)
          (CRAVES ANXIETY-444 TUNA)
          (HARMONY LOVE-115 URANUS)
          (EATS LOBSTER SWEETROLL)
          (CRAVES LONELINESS-147 BACON)
          (LOCALE SNICKERS-59 BAVARIA)
          (EATS POTATO-55 YOGURT-25)
          (EATS LETTUCE-16 CHICKEN-30)
          (CRAVES ANGINA-215 POPOVER-14)
          (CRAVES ANGINA-447 HAROSET)
          (EATS POTATO ARUGULA)
          (LOCALE LEMON-53 SURREY)
          (LOCALE RICE-32 QUEBEC)
          (EATS ARUGULA POTATO)
          (CRAVES LONELINESS-437 OKRA)
          (CRAVES ANGINA-154 CHERRY)
          (LOCALE PEPPER GUANABARA)
          (CRAVES DREAD-495 POPOVER)
          (LOCALE CANTELOPE KENTUCKY)
          (EATS CHICKEN LAMB)
          (EATS MARZIPAN ORANGE)
          (EATS HAMBURGER-26 ORANGE)
          (HARMONY STIMULATION-118 URANUS)
          (HARMONY UNDERSTANDING-128 URANUS)
          (EATS ARUGULA BAGUETTE)
          (EATS YOGURT-25 POTATO-55)
          (EATS LETTUCE-16 LOBSTER-12)
          (CRAVES ENTERTAINMENT POTATO-55)
          (LOCALE SCALLOP GUANABARA)
          (CRAVES BOILS-467 CUCUMBER)
          (CRAVES JEALOUSY-177 FLOUNDER)
          (CRAVES AESTHETICS-116 RICE)
          (CRAVES DREAD-232 OKRA-9)
          (EATS TUNA WURST)
          (EATS CHOCOLATE-13 ENDIVE-22)
          (EATS TOMATO-61 POTATO)
          (CRAVES LACERATION-481 MUFFIN)
          (CRAVES ANGER-104 HOTDOG-57)
          (LOCALE CHICKEN GUANABARA)
          (HARMONY LOVE-39 PLUTO)
          (CRAVES REST-40 CHOCOLATE)
          (CRAVES EXPECTATION FLOUNDER-51)
          (EATS LEMON APPLE)
          (EATS CANTELOPE PEAR)
          (EATS LAMB-17 HAROSET)
          (CRAVES SCIATICA-213 MARZIPAN-15)
          (HARMONY ACHIEVEMENT-121 EARTH)
          (EATS HAM TUNA)
          (EATS TOFU-20 POPOVER)
          (HARMONY ENTERTAINMENT-44 URANUS)
          (CRAVES ANGER PEPPER-52)
          (CRAVES ABRASION-506 SNICKERS)
          (EATS LETTUCE TURKEY)
          (CRAVES DREAD-67 TOFU-20)
          (EATS TOFU CUCUMBER-6)
          (CRAVES PROSTATITIS-206 SCALLION-5)
          (CRAVES BOILS-69 PORK-19)
          (EATS MUTTON COD)
          (EATS KALE LAMB-17)
          (CRAVES PROSTATITIS LEMON-53)
          (CRAVES ANXIETY-496 POPOVER)
          (CRAVES DREAD POTATO-55)
          (CRAVES HANGOVER-451 CANTELOPE)
          (CRAVES ANGER-166 BEEF)
          (HARMONY EXPECTATION URANUS)
          (LOCALE SHRIMP QUEBEC)
          (EATS ONION CHERRY)
          (EATS COD APPLE)
          (EATS PEPPER OKRA)
          (EATS BEEF-4 CHICKEN)
          (HARMONY ACHIEVEMENT URANUS)
          (EATS SHRIMP MARZIPAN)
          (CRAVES TRIUMPH-126 MUTTON)
          (EATS TUNA CANTELOPE)
          (CRAVES BOILS-136 LETTUCE)
          (CRAVES LACERATION-498 HAMBURGER)
          (HARMONY SATIETY-122 PLUTO)
          (CRAVES ANGINA FLOUNDER-51)
          (CRAVES SATISFACTION-109 GUAVA)
          (HARMONY SATIETY URANUS)
          (CRAVES JEALOUSY-89 TOMATO-61)
          (LOCALE ENDIVE-22 GUANABARA)
          (LOCALE MELON GUANABARA)
          (CRAVES SCIATICA-450 CANTELOPE)
          (EATS SWEETROLL LOBSTER)
          (CRAVES LACERATION-75 LAMB-17)
          (ORBITS EARTH URANUS)
          (EATS YOGURT-25 SNICKERS)
          (CRAVES HANGOVER-202 CUCUMBER-6)
          (EATS CHICKEN WONDERBREAD)
          (CRAVES LACERATION-209 LETTUCE-16)
          (CRAVES GRIEF-105 HOTDOG-57)
          (CRAVES INTOXICATION-50 SCALLOP-31)
          (CRAVES ANXIETY-84 BAGUETTE-63)
          (CRAVES LACERATION-428 SWEETROLL)
          (CRAVES ANGINA-500 ENDIVE)
          (EATS MARZIPAN-15 TOMATO-61)
          (CRAVES LONELINESS-179 FLOUNDER)
          (CRAVES ABRASION-72 APPLE-18)
          (EATS ORANGE HAMBURGER-26)
          (EATS TUNA WONDERBREAD-21)
          (EATS POPOVER PEA)
          (EATS HAM POTATO)
          (EATS POPOVER CHICKEN)
          (EATS CHOCOLATE GRAPEFRUIT)
          (CRAVES ANXIETY-454 RICE)
          (EATS LEMON CUCUMBER)
          (EATS HAROSET CHOCOLATE)
          (LOCALE WONDERBREAD GUANABARA)
          (CRAVES ANGER-76 GUAVA-64)
          (EATS BAGUETTE-63 WURST)
          (LOCALE BROCCOLI KENTUCKY)
          (CRAVES LACERATION-199 CUCUMBER-6)
          (EATS SCALLION POPOVER)
          (CRAVES ANGER-82 BAGUETTE-63)
          (CRAVES ANGER-497 HAMBURGER)
          (EATS YOGURT PEAR)
          (CRAVES INTOXICATION-114 ONION)
          (CRAVES HANGOVER PEPPER-52)
          (EATS PAPAYA HAMBURGER)
          (CRAVES LOVE-115 CANTELOPE)
          (CRAVES JEALOUSY-459 TOMATO)
          (CRAVES SCIATICA-73 LAMB-17)
          (EATS MUFFIN SWEETROLL-2)
          (EATS SHRIMP-8 SHRIMP)
          (EATS BAGUETTE HAM-10)
          (CRAVES DREAD-505 COD)
          (CRAVES SCIATICA-101 GRAPEFRUIT-58)
          (HARMONY EXCITEMENT-33 URANUS)
          (CRAVES LACERATION-223 LOBSTER-12)
          (EATS CANTELOPE-29 APPLE)
          (CRAVES SCIATICA-425 MARZIPAN)
          (EATS POPOVER-14 MUFFIN)
          (LOCALE TOFU-20 KENTUCKY))
   (:GOAL (AND (CRAVES DEPRESSION-438 BAGUETTE)
               (CRAVES LONELINESS-437 RICE-32)
               (CRAVES BOILS-439 RICE-32)
               (CRAVES ANGER-470 RICE-32)
               (CRAVES ANGINA-469 RICE-32)
               (CRAVES JEALOUSY-466 RICE-32)
               (CRAVES BOILS-475 RICE-32)
               (CRAVES HANGOVER-94 RICE-32)
               (CRAVES ANXIETY-95 RICE-32)
               (CRAVES LACERATION-92 TOMATO)
               (CRAVES BOILS-167 TOMATO))))

(DEFINE (PROBLEM MYSTY-40)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS SCALLOP-53 TUNA-54 APPLE-55 SCALLION-56
             TOFU-57 ARUGULA-58 ONION-59 LETTUCE-60 HOTDOG-61
             HAROSET-62 PEPPER-63 WURST-64 COD-17 HAMBURGER-18
             PORK-19 TURKEY-20 CHICKEN-21 ORANGE-22 TOMATO-23
             BAGUETTE-24 YOGURT-25 POTATO-26 MUTTON-27 GUAVA-28
             BACON-29 MUFFIN-30 HAM-31 BEEF-32 ENDIVE-9
             CANTELOPE-10 PEA-11 CHOCOLATE-12 LAMB-13 CHERRY-14
             LEMON-15 KALE-16 SHRIMP-5 FLOUNDER-6 PISTACHIO-7
             OKRA-8 SNICKERS-3 GRAPEFRUIT-4 PEAR-1 MARZIPAN-2
             SWEETROLL LOBSTER LEMON ORANGE COD ARUGULA CANTELOPE
             PISTACHIO HAM OKRA LAMB SNICKERS KALE MARZIPAN TOFU
             YOGURT WURST SCALLION HAMBURGER CHERRY LETTUCE
             PAPAYA GUAVA POPOVER POTATO CHICKEN PEA CUCUMBER
             MELON ONION TUNA HAROSET BROCCOLI APPLE HOTDOG
             PORK BACON WONDERBREAD BAGUETTE CHOCOLATE RICE
             SHRIMP MUFFIN TURKEY SCALLOP FLOUNDER GRAPEFRUIT
             PEPPER PEAR BEEF TOMATO MUTTON ENDIVE - FOOD
             INTOXICATION LEARNING EXCITEMENT LUBRICITY SATIETY LOVE
             REST ENTERTAINMENT EXPECTATION TRIUMPH
             UNDERSTANDING EMPATHY STIMULATION AESTHETICS
             SATISFACTION ACHIEVEMENT CURIOSITY EXPECTATION-52
             LEARNING-51 LOVE-50 ENTERTAINMENT-49
             UNDERSTANDING-48 SATIETY-47 ACHIEVEMENT-46 AESTHETICS-45
             STIMULATION-44 CURIOSITY-43 SATISFACTION-42 EMPATHY-41
             INTOXICATION-40 LUBRICITY-39 TRIUMPH-38 EXCITEMENT-37
             REST-36 INTOXICATION-35 SATISFACTION-34
             LEARNING-33 CURIOSITY-128 LUBRICITY-127
             AESTHETICS-126 ACHIEVEMENT-125 LOVE-124 EXPECTATION-123
             SATIETY-122 EMPATHY-121 TRIUMPH-120
             ENTERTAINMENT-119 EXCITEMENT-118 UNDERSTANDING-117
             REST-116 STIMULATION-115 LUBRICITY-114
             AESTHETICS-113 TRIUMPH-112 - PLEASURE
             LONELINESS HANGOVER ANGINA PROSTATITIS BOILS DREAD
             SCIATICA GRIEF DEPRESSION ANXIETY JEALOUSY ABRASION
             LACERATION PROSTATITIS-111 ANGER HANGOVER-110
             DEPRESSION-109 DREAD-107 ANGER-108 ANGINA-106
             LACERATION-105 JEALOUSY-103 ANXIETY-104 BOILS-102
             GRIEF-101 LONELINESS-99 SCIATICA-100 ABRASION-97
             ABRASION-98 BOILS-96 DREAD-95 GRIEF-93 JEALOUSY-94
             SCIATICA-91 PROSTATITIS-92 LACERATION-89 ANGER-90
             DEPRESSION-88 ANXIETY-86 LONELINESS-87 ANGINA-85
             GRIEF-83 HANGOVER-84 ANXIETY-82 DEPRESSION-80
             LACERATION-81 JEALOUSY-79 LONELINESS-77 BOILS-78
             HANGOVER-75 PROSTATITIS-76 ABRASION-74 SCIATICA-72
             DREAD-73 ANGINA-71 ANGER-70 ANGER-68 ANGINA-69
             GRIEF-66 PROSTATITIS-67 DREAD-256 ABRASION-65
             SCIATICA-255 DEPRESSION-254 HANGOVER-252
             LONELINESS-253 LACERATION-250 BOILS-251 ANXIETY-249
             ANXIETY-247 JEALOUSY-248 SCIATICA-246 BOILS-245
             LONELINESS-243 ANGER-244 LACERATION-242 HANGOVER-240
             ANGINA-241 ABRASION-239 - PAIN
             MANITOBA ALSACE GUANABARA BOSNIA OREGON KENTUCKY
             PENNSYLVANIA BAVARIA MORAVIA GOIAS QUEBEC SURREY
             - PROVINCE
             MERCURY JUPITER VULCAN MARS - PLANET)
   (:INIT (EATS ONION APPLE)
          (CRAVES SCIATICA-255 APPLE)
          (LOCALE BROCCOLI MORAVIA)
          (EATS SNICKERS TOFU)
          (CRAVES EXCITEMENT ARUGULA-58)
          (LOCALE TOMATO BOSNIA)
          (EATS TUNA-54 MUFFIN)
          (HARMONY LEARNING-33 JUPITER)
          (EATS CHERRY-14 PEAR)
          (CRAVES SATIETY-47 PISTACHIO-7)
          (EATS SNICKERS-3 TURKEY-20)
          (EATS PORK-19 HAROSET)
          (EATS APPLE SHRIMP)
          (CRAVES ANGINA-85 PISTACHIO)
          (EATS TOMATO MARZIPAN-2)
          (LOCALE TOFU PENNSYLVANIA)
          (EATS TUNA LETTUCE)
          (CRAVES UNDERSTANDING-48 FLOUNDER-6)
          (CRAVES HANGOVER APPLE-55)
          (EATS TUNA SHRIMP)
          (EATS BROCCOLI PEAR)
          (EATS OKRA SCALLOP)
          (EATS HAM CANTELOPE-10)
          (EATS LOBSTER SHRIMP)
          (EATS KALE PEPPER)
          (EATS GRAPEFRUIT-4 BAGUETTE-24)
          (EATS POTATO LAMB)
          (EATS CHICKEN POTATO)
          (EATS TOMATO MUTTON-27)
          (EATS FLOUNDER-6 TUNA)
          (CRAVES ANGINA-71 POTATO)
          (LOCALE BACON-29 PENNSYLVANIA)
          (CRAVES JEALOUSY-103 CANTELOPE-10)
          (EATS BEEF KALE-16)
          (LOCALE TOFU-57 PENNSYLVANIA)
          (LOCALE LEMON GUANABARA)
          (HARMONY STIMULATION-115 VULCAN)
          (EATS HAM-31 MUFFIN-30)
          (LOCALE MELON OREGON)
          (CRAVES LONELINESS APPLE-55)
          (HARMONY UNDERSTANDING-117 JUPITER)
          (EATS PEA BROCCOLI)
          (CRAVES ANGER-68 CUCUMBER)
          (HARMONY UNDERSTANDING-48 MARS)
          (CRAVES AESTHETICS-113 BEEF)
          (LOCALE LAMB GUANABARA)
          (HARMONY INTOXICATION VULCAN)
          (CRAVES ANGINA-106 GUAVA-28)
          (LOCALE CUCUMBER KENTUCKY)
          (EATS HAROSET LEMON-15)
          (EATS PISTACHIO-7 MUTTON-27)
          (EATS TOFU LAMB)
          (EATS MUFFIN-30 CHERRY-14)
          (EATS SCALLOP OKRA)
          (HARMONY EXPECTATION MARS)
          (LOCALE SCALLION-56 BOSNIA)
          (CRAVES ANGER-70 CHICKEN)
          (CRAVES SATIETY-122 HOTDOG)
          (EATS CUCUMBER SCALLION)
          (CRAVES LONELINESS-253 WONDERBREAD)
          (EATS APPLE TUNA)
          (EATS HAROSET HAM)
          (EATS CANTELOPE-10 PAPAYA)
          (EATS PEA MUTTON-27)
          (EATS CUCUMBER YOGURT-25)
          (HARMONY LEARNING MARS)
          (CRAVES LUBRICITY-39 MARZIPAN)
          (EATS BAGUETTE-24 GRAPEFRUIT-4)
          (EATS CHOCOLATE-12 WURST)
          (HARMONY CURIOSITY-43 MARS)
          (CRAVES DREAD-73 POPOVER)
          (EATS KALE-16 BEEF)
          (LOCALE ONION-59 OREGON)
          (CRAVES HANGOVER-75 WURST)
          (EATS TOMATO COD)
          (EATS POTATO-26 COD-17)
          (LOCALE MUTTON-27 MANITOBA)
          (HARMONY CURIOSITY-128 VULCAN)
          (LOCALE KALE KENTUCKY)
          (EATS PEAR LAMB-13)
          (CRAVES LOVE-50 LAMB-13)
          (CRAVES INTOXICATION-35 PAPAYA)
          (CRAVES JEALOUSY HAMBURGER-18)
          (CRAVES CURIOSITY-43 MARZIPAN-2)
          (EATS SHRIMP LOBSTER)
          (LOCALE GRAPEFRUIT-4 KENTUCKY)
          (EATS SWEETROLL SNICKERS)
          (CRAVES SATISFACTION-34 GUAVA)
          (EATS FLOUNDER-6 ARUGULA-58)
          (LOCALE LAMB-13 KENTUCKY)
          (CRAVES HANGOVER-110 YOGURT-25)
          (EATS PEPPER KALE)
          (LOCALE HAROSET-62 OREGON)
          (LOCALE PORK BOSNIA)
          (EATS GRAPEFRUIT-4 LEMON-15)
          (HARMONY ENTERTAINMENT-119 VULCAN)
          (LOCALE KALE-16 PENNSYLVANIA)
          (EATS TUNA COD-17)
          (EATS TUNA-54 CANTELOPE-10)
          (EATS ORANGE BAGUETTE)
          (EATS MUFFIN-30 HAM-31)
          (LOCALE BEEF-32 PENNSYLVANIA)
          (EATS YOGURT-25 MUFFIN-30)
          (EATS APPLE LEMON)
          (EATS MUFFIN LEMON-15)
          (CRAVES DEPRESSION-80 SNICKERS)
          (EATS PEAR CHERRY-14)
          (LOCALE FLOUNDER PENNSYLVANIA)
          (EATS TUNA FLOUNDER-6)
          (HARMONY EMPATHY-121 JUPITER)
          (EATS GRAPEFRUIT-4 CHICKEN-21)
          (EATS GRAPEFRUIT-4 SCALLOP)
          (CRAVES GRIEF-101 LAMB-13)
          (EATS SHRIMP-5 OKRA)
          (CRAVES DREAD-256 HAROSET)
          (HARMONY AESTHETICS-45 JUPITER)
          (EATS POTATO ORANGE-22)
          (CRAVES ACHIEVEMENT BEEF-32)
          (EATS HAROSET-62 HAM)
          (CRAVES ACHIEVEMENT-46 SNICKERS-3)
          (EATS ARUGULA-58 FLOUNDER-6)
          (EATS LOBSTER ORANGE)
          (LOCALE CHOCOLATE-12 MORAVIA)
          (EATS HAM CHICKEN)
          (HARMONY EXCITEMENT-118 MARS)
          (EATS BEEF LETTUCE)
          (EATS PEAR HAROSET)
          (CRAVES AESTHETICS-126 ONION)
          (EATS CANTELOPE SNICKERS-3)
          (EATS SCALLOP GRAPEFRUIT-4)
          (EATS CHERRY PORK)
          (CRAVES LACERATION TURKEY-20)
          (CRAVES EXCITEMENT-118 CHOCOLATE)
          (EATS CANTELOPE-10 TUNA-54)
          (CRAVES ABRASION-97 SHRIMP-5)
          (EATS TUNA KALE-16)
          (LOCALE OKRA BOSNIA)
          (EATS LOBSTER ARUGULA-58)
          (CRAVES GRIEF-83 HAM)
          (CRAVES GRIEF-66 ONION)
          (EATS PEPPER MUFFIN)
          (EATS SCALLOP-53 RICE)
          (EATS PEAR BEEF-32)
          (EATS HAROSET-62 HAMBURGER-18)
          (EATS GUAVA-28 LEMON-15)
          (CRAVES BOILS-96 FLOUNDER-6)
          (CRAVES LEARNING SCALLION-56)
          (EATS FLOUNDER GRAPEFRUIT)
          (EATS PEPPER-63 RICE)
          (EATS KALE BAGUETTE)
          (EATS CHERRY MARZIPAN)
          (HARMONY ENTERTAINMENT-49 JUPITER)
          (HARMONY AESTHETICS-113 MARS)
          (CRAVES DEPRESSION-88 LEMON)
          (CRAVES LEARNING-33 POPOVER)
          (EATS SWEETROLL PEPPER)
          (EATS PAPAYA ORANGE-22)
          (EATS SNICKERS SWEETROLL)
          (EATS PISTACHIO-7 TOMATO)
          (EATS HOTDOG-61 RICE)
          (EATS ENDIVE-9 LETTUCE-60)
          (ATTACKS OREGON KENTUCKY)
          (CRAVES CURIOSITY CANTELOPE-10)
          (HARMONY LOVE MARS)
          (LOCALE HAM-31 GUANABARA)
          (ATTACKS MANITOBA ALSACE)
          (HARMONY AESTHETICS JUPITER)
          (HARMONY REST-116 JUPITER)
          (EATS LEMON-15 GRAPEFRUIT-4)
          (HARMONY SATIETY-47 JUPITER)
          (LOCALE WURST OREGON)
          (EATS TOFU OKRA-8)
          (EATS RICE SCALLOP-53)
          (CRAVES LUBRICITY-114 PEAR)
          (LOCALE BEEF PENNSYLVANIA)
          (LOCALE HOTDOG MANITOBA)
          (CRAVES LUBRICITY-127 CUCUMBER)
          (LOCALE ARUGULA BOSNIA)
          (CRAVES ANXIETY COD-17)
          (EATS CHICKEN PAPAYA)
          (EATS HAMBURGER-18 PORK-19)
          (EATS PEPPER APPLE)
          (CRAVES SCIATICA-91 PEAR-1)
          (EATS LAMB POTATO)
          (HARMONY SATISFACTION MARS)
          (EATS FLOUNDER HAMBURGER-18)
          (CRAVES ANXIETY-104 CANTELOPE-10)
          (CRAVES BOILS-102 PEA-11)
          (HARMONY INTOXICATION-40 MARS)
          (HARMONY LUBRICITY JUPITER)
          (EATS MARZIPAN TOFU-57)
          (EATS PEAR POPOVER)
          (HARMONY LOVE-50 JUPITER)
          (CRAVES DREAD-107 MUTTON-27)
          (LOCALE TOMATO-23 ALSACE)
          (EATS LEMON HOTDOG)
          (EATS ARUGULA-58 LOBSTER)
          (LOCALE BACON MANITOBA)
          (LOCALE HAM MORAVIA)
          (EATS KALE SHRIMP)
          (LOCALE PEPPER PENNSYLVANIA)
          (HARMONY EXCITEMENT-37 JUPITER)
          (EATS CHICKEN GUAVA)
          (LOCALE LOBSTER GUANABARA)
          (EATS YOGURT BEEF)
          (CRAVES STIMULATION-44 PEAR-1)
          (CRAVES ANGER-108 MUTTON-27)
          (LOCALE POTATO-26 BOSNIA)
          (LOCALE BAGUETTE-24 ALSACE)
          (EATS MELON GUAVA)
          (HARMONY INTOXICATION-35 VULCAN)
          (LOCALE CHERRY QUEBEC)
          (LOCALE GUAVA ALSACE)
          (LOCALE YOGURT MANITOBA)
          (EATS CHERRY BROCCOLI)
          (EATS CUCUMBER GRAPEFRUIT)
          (EATS PEAR-1 COD)
          (EATS PEPPER-63 LAMB-13)
          (HARMONY ACHIEVEMENT VULCAN)
          (EATS COD PEAR-1)
          (EATS HAM GUAVA-28)
          (CRAVES ABRASION-74 PAPAYA)
          (EATS TOFU SNICKERS)
          (LOCALE BAGUETTE BOSNIA)
          (EATS PEA-11 PEAR)
          (EATS APPLE APPLE-55)
          (LOCALE TURKEY MORAVIA)
          (EATS POTATO CHICKEN)
          (CRAVES ANGINA-241 MUTTON)
          (CRAVES TRIUMPH-38 WURST)
          (EATS CANTELOPE-10 HAM)
          (EATS RICE HOTDOG-61)
          (CRAVES EXPECTATION-123 APPLE)
          (EATS BAGUETTE-24 MUFFIN)
          (CRAVES DEPRESSION-109 POTATO-26)
          (EATS BAGUETTE ENDIVE)
          (LOCALE ENDIVE MANITOBA)
          (EATS TUNA BAGUETTE)
          (EATS SCALLION CUCUMBER)
          (EATS CHICKEN HAM)
          (CRAVES HANGOVER-240 MUTTON)
          (EATS SCALLION-56 CANTELOPE)
          (EATS POTATO WURST-64)
          (EATS GUAVA-28 HAM)
          (EATS HAM HAROSET-62)
          (HARMONY ACHIEVEMENT-46 JUPITER)
          (EATS ARUGULA MUTTON)
          (CRAVES EXCITEMENT-37 CHERRY)
          (EATS ENDIVE BAGUETTE)
          (EATS ONION SCALLOP)
          (LOCALE OKRA-8 MANITOBA)
          (CRAVES INTOXICATION-40 SNICKERS)
          (ATTACKS KENTUCKY PENNSYLVANIA)
          (HARMONY EXPECTATION-52 VULCAN)
          (EATS MELON FLOUNDER)
          (EATS MELON ENDIVE)
          (CRAVES SCIATICA PEPPER-63)
          (EATS WONDERBREAD BEEF-32)
          (EATS PORK SNICKERS-3)
          (EATS WURST CHOCOLATE-12)
          (EATS CHOCOLATE ENDIVE-9)
          (EATS TURKEY PORK)
          (EATS PORK CHERRY)
          (LOCALE SHRIMP-5 MANITOBA)
          (HARMONY LOVE-124 MARS)
          (LOCALE CHICKEN-21 BAVARIA)
          (EATS APPLE-55 MUFFIN)
          (CRAVES ENTERTAINMENT-119 BAGUETTE)
          (EATS BACON-29 OKRA)
          (EATS LAMB ONION-59)
          (CRAVES UNDERSTANDING ORANGE-22)
          (EATS TOFU-57 MARZIPAN)
          (EATS KALE-16 TUNA)
          (HARMONY EXPECTATION-123 VULCAN)
          (EATS WONDERBREAD HOTDOG-61)
          (EATS POPOVER SCALLOP)
          (LOCALE SCALLION ALSACE)
          (CRAVES ANGER-90 MARZIPAN-2)
          (CRAVES LACERATION-89 MARZIPAN-2)
          (EATS HAMBURGER WURST-64)
          (EATS BACON SCALLOP)
          (HARMONY SATIETY MARS)
          (EATS PORK TURKEY)
          (CRAVES ANGER-244 BEEF)
          (EATS WURST-64 HAMBURGER)
          (EATS TOFU-57 MARZIPAN-2)
          (CRAVES JEALOUSY-248 MUFFIN)
          (CRAVES PROSTATITIS-76 WURST)
          (EATS HAM-31 SCALLION)
          (CRAVES BOILS-251 CHOCOLATE)
          (EATS RICE PORK)
          (EATS WURST BAGUETTE)
          (CRAVES ANXIETY-247 MUFFIN)
          (LOCALE PEA-11 GOIAS)
          (EATS PAPAYA CANTELOPE-10)
          (EATS CHERRY-14 MUFFIN-30)
          (EATS MARZIPAN CHERRY)
          (EATS MARZIPAN-2 TOMATO)
          (LOCALE ORANGE MANITOBA)
          (EATS MUFFIN APPLE-55)
          (EATS MUFFIN TUNA-54)
          (EATS MARZIPAN-2 TOFU-57)
          (CRAVES LACERATION-250 CHOCOLATE)
          (CRAVES BOILS-245 SCALLOP)
          (EATS PEA-11 CANTELOPE)
          (EATS CHOCOLATE TURKEY)
          (CRAVES EXPECTATION-52 PEA-11)
          (LOCALE ENDIVE-9 MANITOBA)
          (EATS OKRA SHRIMP-5)
          (CRAVES ENTERTAINMENT-49 SHRIMP-5)
          (LOCALE POTATO GUANABARA)
          (EATS GRAPEFRUIT FLOUNDER)
          (EATS ORANGE-22 PAPAYA)
          (CRAVES SCIATICA-72 POPOVER)
          (ORBITS JUPITER VULCAN)
          (LOCALE MARZIPAN-2 GUANABARA)
          (CRAVES ABRASION-98 SHRIMP-5)
          (CRAVES LACERATION-105 BACON-29)
          (EATS ENDIVE MELON)
          (LOCALE HOTDOG-61 MANITOBA)
          (EATS HAROSET-62 FLOUNDER)
          (EATS MUTTON PISTACHIO)
          (EATS CHOCOLATE-12 PEPPER)
          (LOCALE PEAR GOIAS)
          (EATS LEMON-15 GUAVA-28)
          (CRAVES DEPRESSION COD-17)
          (CRAVES BOILS-78 YOGURT)
          (EATS LEMON-15 MUFFIN)
          (EATS WURST TOFU)
          (HARMONY STIMULATION-44 VULCAN)
          (EATS ENDIVE HAMBURGER)
          (LOCALE HAMBURGER GUANABARA)
          (EATS CANTELOPE SCALLION-56)
          (CRAVES LOVE HOTDOG-61)
          (EATS LAMB-13 PEAR)
          (EATS PEA-11 LAMB-13)
          (EATS GRAPEFRUIT LEMON)
          (EATS TOMATO PISTACHIO-7)
          (EATS HAM-31 HAROSET)
          (EATS SCALLION HAM-31)
          (EATS PISTACHIO MUTTON)
          (EATS APPLE PEPPER)
          (EATS BAGUETTE FLOUNDER-6)
          (EATS PEPPER SWEETROLL)
          (LOCALE SCALLOP-53 PENNSYLVANIA)
          (HARMONY TRIUMPH-112 JUPITER)
          (CRAVES DREAD ONION-59)
          (CRAVES EMPATHY-121 PORK)
          (EATS APPLE ONION)
          (EATS COD-17 ONION)
          (EATS ONION COD-17)
          (EATS FLOUNDER MELON)
          (LOCALE RICE KENTUCKY)
          (CRAVES PROSTATITIS-67 ONION)
          (HARMONY SATISFACTION-42 JUPITER)
          (CRAVES SCIATICA-246 TURKEY)
          (EATS COD-17 POTATO-26)
          (EATS BROCCOLI CHERRY)
          (HARMONY TRIUMPH-120 JUPITER)
          (EATS LAMB-13 PEPPER-63)
          (EATS PAPAYA CHICKEN)
          (EATS ONION-59 LAMB)
          (EATS POTATO-26 SCALLOP)
          (EATS COD-17 TUNA)
          (LOCALE PISTACHIO MANITOBA)
          (LOCALE ONION BOSNIA)
          (CRAVES SCIATICA-100 KALE-16)
          (CRAVES ACHIEVEMENT-125 TUNA)
          (LOCALE PEAR-1 GUANABARA)
          (ATTACKS GUANABARA BOSNIA)
          (EATS PORK LETTUCE-60)
          (LOCALE PEPPER-63 BAVARIA)
          (HARMONY TRIUMPH MARS)
          (LOCALE HAROSET BOSNIA)
          (EATS MUTTON-27 BACON)
          (EATS ARUGULA CHOCOLATE)
          (EATS TURKEY PEAR-1)
          (EATS BROCCOLI PEA)
          (LOCALE SCALLOP ALSACE)
          (EATS HAROSET PORK-19)
          (EATS SHRIMP APPLE)
          (LOCALE COD OREGON)
          (CRAVES JEALOUSY-79 KALE)
          (EATS RICE MUTTON)
          (CRAVES TRIUMPH HAMBURGER-18)
          (EATS HAMBURGER-18 FLOUNDER)
          (EATS WURST-64 POTATO)
          (CRAVES EMPATHY TOMATO-23)
          (EATS SHRIMP TUNA)
          (EATS MUFFIN TOMATO-23)
          (EATS BACON-29 POPOVER)
          (EATS BEEF-32 PEAR)
          (CRAVES PROSTATITIS-111 BAGUETTE-24)
          (CRAVES JEALOUSY-94 SNICKERS-3)
          (LOCALE FLOUNDER-6 ALSACE)
          (CRAVES EMPATHY-41 LAMB)
          (EATS CHERRY PEAR)
          (EATS TOMATO-23 MUFFIN)
          (EATS PORK-19 HAM-31)
          (CRAVES LONELINESS-99 KALE-16)
          (LOCALE MUTTON BAVARIA)
          (EATS BAGUETTE POTATO)
          (EATS LETTUCE POTATO-26)
          (CRAVES AESTHETICS MUTTON-27)
          (CRAVES TRIUMPH-112 ENDIVE)
          (EATS SCALLOP-53 TURKEY-20)
          (EATS LETTUCE TUNA)
          (CRAVES HANGOVER-84 HAM)
          (EATS ONION-59 MUFFIN)
          (EATS PEAR BROCCOLI)
          (LOCALE POPOVER GUANABARA)
          (EATS YOGURT BAGUETTE)
          (LOCALE ARUGULA-58 MANITOBA)
          (EATS CHICKEN FLOUNDER)
          (EATS BROCCOLI SHRIMP-5)
          (CRAVES DREAD-95 PISTACHIO-7)
          (LOCALE CHICKEN ALSACE)
          (EATS PISTACHIO-7 BROCCOLI)
          (CRAVES GRIEF-93 SNICKERS-3)
          (EATS BAGUETTE TUNA)
          (EATS MUFFIN-30 YOGURT-25)
          (ATTACKS GOIAS QUEBEC)
          (CRAVES ANXIETY-82 OKRA)
          (EATS POTATO BAGUETTE)
          (EATS HAROSET PEAR)
          (EATS TOFU WURST)
          (CRAVES LEARNING-51 CHOCOLATE-12)
          (EATS SHRIMP-5 BROCCOLI)
          (EATS OKRA-8 BAGUETTE)
          (EATS FLOUNDER GUAVA)
          (LOCALE TUNA KENTUCKY)
          (CRAVES UNDERSTANDING-117 TURKEY)
          (EATS LEMON GRAPEFRUIT)
          (EATS GUAVA FLOUNDER)
          (EATS CHICKEN-21 GRAPEFRUIT-4)
          (CRAVES LONELINESS-87 ARUGULA)
          (HARMONY SATISFACTION-34 VULCAN)
          (EATS SCALLOP BACON)
          (EATS CHOCOLATE ARUGULA)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (HARMONY UNDERSTANDING MARS)
          (EATS TURKEY-20 SCALLOP-53)
          (EATS HOTDOG-61 WONDERBREAD)
          (EATS FLOUNDER-6 BAGUETTE)
          (EATS MARZIPAN PISTACHIO-7)
          (CRAVES ABRASION-65 HAROSET)
          (LOCALE TUNA-54 MORAVIA)
          (EATS PEAR CHERRY)
          (CRAVES LACERATION-81 SNICKERS)
          (CRAVES LACERATION-242 TOMATO)
          (CRAVES LUBRICITY ONION-59)
          (ORBITS VULCAN MARS)
          (EATS COD TOMATO)
          (LOCALE SNICKERS-3 PENNSYLVANIA)
          (EATS BACON PEA)
          (CRAVES LONELINESS-77 YOGURT)
          (CRAVES STIMULATION POTATO-26)
          (EATS MUFFIN PEPPER)
          (EATS BEEF YOGURT)
          (EATS SHRIMP KALE)
          (HARMONY EXCITEMENT MARS)
          (CRAVES STIMULATION-115 PEPPER)
          (LOCALE PAPAYA ALSACE)
          (EATS GUAVA ENDIVE)
          (CRAVES EXPECTATION COD-17)
          (EATS CHICKEN HAMBURGER)
          (EATS PORK RICE)
          (EATS SCALLOP ONION)
          (EATS HAMBURGER-18 HAROSET-62)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES INTOXICATION APPLE-55)
          (HARMONY ACHIEVEMENT-125 JUPITER)
          (HARMONY AESTHETICS-126 VULCAN)
          (EATS BAGUETTE KALE)
          (HARMONY LUBRICITY-39 JUPITER)
          (LOCALE CANTELOPE-10 GOIAS)
          (HARMONY REST-36 MARS)
          (CRAVES BOILS ONION-59)
          (EATS ORANGE LOBSTER)
          (LOCALE SHRIMP ALSACE)
          (CRAVES ABRASION HAMBURGER-18)
          (LOCALE WONDERBREAD BOSNIA)
          (HARMONY LUBRICITY-127 VULCAN)
          (CRAVES SATISFACTION HAM-31)
          (LOCALE GUAVA-28 BOSNIA)
          (LOCALE MUFFIN-30 MANITOBA)
          (EATS HOTDOG PISTACHIO)
          (EATS LEMON APPLE)
          (EATS WONDERBREAD GRAPEFRUIT)
          (LOCALE CANTELOPE OREGON)
          (HARMONY SATIETY-122 MARS)
          (EATS LETTUCE-60 ENDIVE-9)
          (EATS TURKEY CHOCOLATE)
          (EATS OKRA BACON-29)
          (EATS GRAPEFRUIT CUCUMBER)
          (EATS MUFFIN ONION-59)
          (HARMONY LEARNING-51 JUPITER)
          (EATS LAMB TOFU)
          (CRAVES REST HAROSET-62)
          (EATS APPLE-55 APPLE)
          (EATS MUTTON-27 PISTACHIO-7)
          (CRAVES ANXIETY-249 SHRIMP)
          (EATS POPOVER PEAR)
          (EATS OKRA-8 LAMB)
          (EATS ENDIVE GUAVA)
          (EATS BROCCOLI PISTACHIO-7)
          (CRAVES GRIEF WURST-64)
          (ATTACKS MORAVIA GOIAS)
          (LOCALE ORANGE-22 OREGON)
          (ATTACKS QUEBEC SURREY)
          (HARMONY TRIUMPH-38 MARS)
          (LOCALE COD-17 ALSACE)
          (EATS CHICKEN-21 APPLE)
          (EATS BAGUETTE ORANGE)
          (EATS BAGUETTE YOGURT)
          (LOCALE YOGURT-25 MANITOBA)
          (CRAVES PROSTATITIS-92 PEAR-1)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES ANXIETY-86 ARUGULA)
          (EATS TUNA APPLE)
          (CRAVES REST-116 FLOUNDER)
          (LOCALE LETTUCE-60 OREGON)
          (EATS PEAR-1 TURKEY)
          (EATS LEMON-15 HAROSET)
          (CRAVES CURIOSITY-128 POTATO)
          (EATS FLOUNDER SCALLION)
          (LOCALE MARZIPAN BOSNIA)
          (EATS SNICKERS-3 PORK)
          (EATS LETTUCE-60 PORK)
          (EATS RICE SCALLION-56)
          (CRAVES LONELINESS-243 BEEF)
          (EATS HAM HAROSET)
          (ATTACKS ALSACE GUANABARA)
          (EATS PORK-19 HAMBURGER-18)
          (EATS GRAPEFRUIT WONDERBREAD)
          (EATS RICE CHOCOLATE)
          (CRAVES LOVE-124 HAROSET)
          (CRAVES ANGINA-69 CUCUMBER)
          (CRAVES SATIETY LETTUCE-60)
          (LOCALE TURKEY-20 KENTUCKY)
          (EATS CHOCOLATE RICE)
          (LOCALE APPLE SURREY)
          (EATS BAGUETTE OKRA-8)
          (EATS PEAR PEA-11)
          (EATS POTATO-26 LETTUCE)
          (LOCALE SNICKERS BOSNIA)
          (LOCALE GRAPEFRUIT BAVARIA)
          (EATS GUAVA CHICKEN)
          (EATS FLOUNDER HAROSET-62)
          (EATS GUAVA MELON)
          (LOCALE SWEETROLL BOSNIA)
          (HARMONY REST MARS)
          (CRAVES ANGINA SCALLION-56)
          (EATS LAMB OKRA-8)
          (LOCALE LETTUCE MANITOBA)
          (LOCALE CHERRY-14 MANITOBA)
          (EATS MUTTON-27 PEA)
          (CRAVES TRIUMPH-120 BACON)
          (EATS POPOVER BACON-29)
          (CRAVES ANGER BAGUETTE-24)
          (EATS ORANGE-22 POTATO)
          (CRAVES HANGOVER-252 WONDERBREAD)
          (EATS HOTDOG LEMON)
          (EATS SCALLOP POTATO-26)
          (EATS LETTUCE BEEF)
          (EATS FLOUNDER CHICKEN)
          (EATS BACON MUTTON-27)
          (HARMONY EMPATHY MARS)
          (EATS TOMATO-23 PAPAYA)
          (CRAVES SATISFACTION-42 PISTACHIO)
          (EATS PISTACHIO-7 MARZIPAN)
          (EATS SCALLOP POPOVER)
          (EATS PAPAYA TOMATO-23)
          (EATS LAMB-13 PEA-11)
          (CRAVES PROSTATITIS TOFU-57)
          (EATS TURKEY-20 SNICKERS-3)
          (EATS PISTACHIO HOTDOG)
          (CRAVES REST-36 LETTUCE)
          (LOCALE PEA ALSACE)
          (CRAVES ENTERTAINMENT PEPPER-63)
          (EATS ENDIVE-9 CHOCOLATE)
          (EATS SCALLION-56 RICE)
          (EATS MUTTON RICE)
          (EATS MARZIPAN PORK)
          (EATS SNICKERS-3 CANTELOPE)
          (EATS PORK MARZIPAN)
          (EATS HAMBURGER CHICKEN)
          (LOCALE PISTACHIO-7 OREGON)
          (EATS YOGURT-25 CUCUMBER)
          (EATS RICE PEPPER-63)
          (EATS HAMBURGER ENDIVE)
          (LOCALE MUFFIN OREGON)
          (ORBITS MERCURY JUPITER)
          (CRAVES AESTHETICS-45 GRAPEFRUIT-4)
          (HARMONY EMPATHY-41 JUPITER)
          (EATS BEEF-32 WONDERBREAD)
          (LOCALE HAMBURGER-18 GOIAS)
          (LOCALE WURST-64 OREGON)
          (EATS APPLE CHICKEN-21)
          (HARMONY STIMULATION VULCAN)
          (EATS PEA BACON)
          (EATS PEPPER CHOCOLATE-12)
          (HARMONY LUBRICITY-114 MARS)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (CRAVES ABRASION-239 ENDIVE)
          (LOCALE PORK-19 KENTUCKY)
          (CRAVES DEPRESSION-254 PORK)
          (EATS OKRA-8 TOFU)
          (EATS SCALLION FLOUNDER)
          (LOCALE LEMON-15 MANITOBA)
          (ATTACKS BOSNIA OREGON)
          (EATS BAGUETTE WURST)
          (EATS MUTTON-27 TOMATO)
          (EATS MUFFIN BAGUETTE-24)
          (EATS MUTTON ARUGULA)
          (EATS CANTELOPE PEA-11)
          (EATS HAROSET HAM-31)
          (LOCALE APPLE-55 GOIAS)
          (EATS HAM-31 PORK-19)
          (HARMONY ENTERTAINMENT VULCAN))
   (:GOAL (AND (CRAVES DREAD PORK-19)
               (CRAVES BOILS PORK-19))))

(DEFINE (PROBLEM MYSTY-41)
   (:DOMAIN MYSTERY-TYPED)
   (:OBJECTS PORK-107 CANTELOPE-108 RICE-109
             MUTTON-110 KALE-111 SHRIMP-112 LAMB-113 OKRA-114
             SCALLION-118 TOMATO-117 PAPAYA-116 HAMBURGER-115
             WONDERBREAD-119 BROCCOLI-120 TUNA-121 ENDIVE-122
             MARZIPAN-123 MUFFIN-124 MELON-125 SCALLOP-126
             POTATO-127 SNICKERS-128 POPOVER-33 CHOCOLATE-34
             FLOUNDER-35 PEA-36 CUCUMBER-37 GUAVA-38 PEPPER-39
             HAM-40 TURKEY-41 WURST-42 YOGURT-43 TUNA-44
             BROCCOLI-45 ENDIVE-46 HAMBURGER-47 PORK-48 BEEF-49
             HAM-50 APPLE-51 LAMB-52 CHERRY-53 CANTELOPE-54
             OKRA-55 YOGURT-56 TOMATO-57 SCALLOP-58 PEPPER-59
             GRAPEFRUIT-60 BAGUETTE-61 HOTDOG-62 LETTUCE-63 LEMON-64
             POPOVER-17 MUTTON-18 PISTACHIO-19 LOBSTER-20
             GUAVA-21 CHOCOLATE-22 KALE-23 WURST-24 ONION-25
             ARUGULA-26 PEAR-27 TURKEY-28 CUCUMBER-29 COD-30
             MELON-31 TOFU-32 PEA-9 WONDERBREAD-10 FLOUNDER-11
             PAPAYA-12 ORANGE-13 BACON-14 SHRIMP-15 SWEETROLL-16
             HAROSET-5 SNICKERS-6 MARZIPAN-7 RICE-8 MUFFIN-3
             POTATO-4 SCALLION-1 CHICKEN-2 PAPAYA SCALLION HAM
             CANTELOPE LAMB COD PISTACHIO ENDIVE BACON BAGUETTE
             PEPPER WONDERBREAD CHOCOLATE LOBSTER SNICKERS
             MUTTON ARUGULA GRAPEFRUIT GUAVA RICE PEAR PORK KALE
             CHICKEN TOMATO SCALLOP MUFFIN HOTDOG ONION BEEF
             WURST SWEETROLL PEA MELON TUNA HAMBURGER YOGURT
             SHRIMP LETTUCE CUCUMBER APPLE TURKEY BROCCOLI
             POTATO OKRA HAROSET TOFU POPOVER LEMON ORANGE
             CHERRY MARZIPAN FLOUNDER - FOOD
             REST INTOXICATION STIMULATION ENTERTAINMENT
             EXCITEMENT LOVE UNDERSTANDING EMPATHY SATIETY
             LEARNING SATISFACTION CURIOSITY TRIUMPH
             EXPECTATION ACHIEVEMENT AESTHETICS LUBRICITY
             UNDERSTANDING-106 LEARNING-105 LOVE-104 INTOXICATION-103
             EMPATHY-102 TRIUMPH-101 SATISFACTION-100
             EXCITEMENT-99 SATIETY-98 REST-97 EXPECTATION-96
             CURIOSITY-95 ACHIEVEMENT-94 LUBRICITY-93
             ENTERTAINMENT-92 STIMULATION-91 AESTHETICS-90
             STIMULATION-89 UNDERSTANDING-88 SATIETY-87
             EXPECTATION-86 EXCITEMENT-85 ENTERTAINMENT-84
             INTOXICATION-83 LEARNING-82 REST-81 ACHIEVEMENT-80
             CURIOSITY-79 AESTHETICS-78 LOVE-77 EMPATHY-76
             SATISFACTION-75 TRIUMPH-74 LUBRICITY-73 INTOXICATION-72
             EXPECTATION-71 LUBRICITY-70 ACHIEVEMENT-69
             STIMULATION-68 AESTHETICS-67 LOVE-66 UNDERSTANDING-65
             CURIOSITY-256 SATISFACTION-255 ENTERTAINMENT-254
             SATIETY-253 TRIUMPH-252 REST-251 EXCITEMENT-250
             LEARNING-249 EMPATHY-248 TRIUMPH-247 ACHIEVEMENT-246
             SATISFACTION-245 EXCITEMENT-244 STIMULATION-243 LOVE-242
             REST-241 INTOXICATION-240 LUBRICITY-239
             ENTERTAINMENT-238 LEARNING-237 SATIETY-236
             UNDERSTANDING-235 EMPATHY-234 AESTHETICS-233 CURIOSITY-232
             EXPECTATION-231 LOVE-230 ENTERTAINMENT-229
             SATISFACTION-228 TRIUMPH-227 EXCITEMENT-226 EMPATHY-225
             REST-224 STIMULATION-223 UNDERSTANDING-222
             INTOXICATION-221 ACHIEVEMENT-220 - PLEASURE
             ANGER PROSTATITIS HANGOVER LONELINESS ANGINA
             ANXIETY BOILS LACERATION JEALOUSY SCIATICA
             DEPRESSION GRIEF ANGER-218 HANGOVER-219 DREAD
             ABRASION ABRASION-217 ANGINA-215 BOILS-216
             LACERATION-213 JEALOUSY-214 SCIATICA-210 ANXIETY-211
             GRIEF-212 DREAD-207 LONELINESS-208 DEPRESSION-209
             LONELINESS-205 PROSTATITIS-206 ANGINA-201 JEALOUSY-202
             SCIATICA-203 HANGOVER-204 DREAD-200 GRIEF-197
             ABRASION-198 LACERATION-199 ANXIETY-194 ANGER-195
             DEPRESSION-196 HANGOVER-191 BOILS-192 PROSTATITIS-193
             ANGER-187 ANXIETY-188 GRIEF-189 SCIATICA-190
             BOILS-184 LACERATION-185 DEPRESSION-186
             LONELINESS-182 PROSTATITIS-183 ANGINA-180 JEALOUSY-181
             GRIEF-177 ABRASION-178 DREAD-179 JEALOUSY-173
             HANGOVER-174 PROSTATITIS-175 BOILS-176 ANGINA-169
             LONELINESS-170 SCIATICA-171 ANGER-172 ABRASION-165
             DREAD-166 LACERATION-167 ANXIETY-168 HANGOVER-163
             DEPRESSION-164 DEPRESSION-161 GRIEF-162 JEALOUSY-157
             BOILS-158 PROSTATITIS-159 ANXIETY-160
             LACERATION-155 ANGER-156 SCIATICA-151 ABRASION-152
             DREAD-153 ANGINA-154 ANXIETY-148 DEPRESSION-149
             LONELINESS-150 LACERATION-144 BOILS-145 HANGOVER-146
             SCIATICA-147 ANGINA-143 LONELINESS-142 ANGER-140
             ABRASION-141 GRIEF-137 DREAD-138 JEALOUSY-139
             SCIATICA-134 PROSTATITIS-135 PROSTATITIS-136
             DEPRESSION-132 GRIEF-133 ABRASION-131 JEALOUSY-129
             LONELINESS-130 DREAD-511 ANGINA-512 HANGOVER-510
             BOILS-509 BOILS-505 ANXIETY-506 LACERATION-507
             ANGER-508 SCIATICA-501 ABRASION-502 GRIEF-503
             ANGINA-504 ANXIETY-497 DEPRESSION-498 HANGOVER-499
             LACERATION-500 PROSTATITIS-494 ANGER-495 JEALOUSY-496
             DREAD-492 LONELINESS-493 SCIATICA-488 BOILS-489
             DREAD-490 PROSTATITIS-491 DEPRESSION-487
             LACERATION-485 ANXIETY-486 LONELINESS-481 ABRASION-482
             ANGER-483 GRIEF-484 ANGINA-480 HANGOVER-478
             JEALOUSY-479 BOILS-475 JEALOUSY-476 GRIEF-477
             DREAD-471 PROSTATITIS-472 ANXIETY-473
             DEPRESSION-474 LACERATION-470 LONELINESS-468
             ABRASION-469 ANGINA-466 HANGOVER-467 JEALOUSY-463
             SCIATICA-464 ANGER-465 LACERATION-460 GRIEF-461
             ANXIETY-462 DEPRESSION-459 BOILS-455 ANGINA-456
             PROSTATITIS-457 HANGOVER-458 SCIATICA-454 DREAD-452
             ANGER-453 LONELINESS-451 ANGINA-448 LONELINESS-449
             ABRASION-450 BOILS-446 GRIEF-447 PROSTATITIS-445
             SCIATICA-441 DEPRESSION-442 JEALOUSY-443 HANGOVER-444
             ANXIETY-439 LACERATION-440 DREAD-437 ABRASION-438
             ANGER-436 DEPRESSION-433 GRIEF-434 BOILS-435
             LACERATION-431 ANXIETY-432 PROSTATITIS-429 HANGOVER-430
             SCIATICA-427 ANGINA-428 LONELINESS-424 ANGER-425
             JEALOUSY-426 ANXIETY-420 GRIEF-421 DREAD-422
             ABRASION-423 SCIATICA-419 LONELINESS-415
             PROSTATITIS-416 BOILS-417 HANGOVER-418 ANGINA-412
             ABRASION-413 JEALOUSY-414 DREAD-411 LACERATION-408
             ANGER-409 DEPRESSION-410 GRIEF-405 LONELINESS-406
             ABRASION-407 ANGER-402 SCIATICA-403 HANGOVER-404
             BOILS-399 DREAD-400 ANGINA-401 PROSTATITIS-398
             LACERATION-395 DEPRESSION-396 JEALOUSY-397 HANGOVER-393
             ANXIETY-394 SCIATICA-391 BOILS-392 ANGER-389
             ANGINA-390 JEALOUSY-388 LONELINESS-385 DREAD-386
             LACERATION-387 ABRASION-384 ANXIETY-382 PROSTATITIS-383
             ABRASION-379 GRIEF-380 DEPRESSION-381 HANGOVER-375
             JEALOUSY-376 LACERATION-377 SCIATICA-378 DREAD-371
             LONELINESS-372 PROSTATITIS-373 ANXIETY-374 BOILS-369
             DEPRESSION-370 ANGER-367 ANGINA-368 GRIEF-365 GRIEF-366
             ABRASION-363 PROSTATITIS-364 DEPRESSION-361 DREAD-362
             ANGINA-357 HANGOVER-358 ANGER-359 ANXIETY-360
             LACERATION-354 LONELINESS-355 SCIATICA-356 JEALOUSY-350
             HANGOVER-351 JEALOUSY-352 BOILS-353 GRIEF-346
             ANGER-347 LONELINESS-348 DREAD-349 ANGINA-345
             PROSTATITIS-343 DEPRESSION-344 LACERATION-339 BOILS-340
             SCIATICA-341 ABRASION-342 BOILS-337 ANXIETY-338
             GRIEF-335 DEPRESSION-336 ANGER-331 JEALOUSY-332
             LACERATION-333 PROSTATITIS-334 DREAD-328 HANGOVER-329
             ABRASION-330 ANGINA-324 LONELINESS-325 SCIATICA-326
             ANXIETY-327 LONELINESS-320 ANXIETY-321 DREAD-322
             ABRASION-323 BOILS-316 JEALOUSY-317 HANGOVER-318
             LACERATION-319 SCIATICA-312 ANGINA-313 PROSTATITIS-314
             ANGER-315 GRIEF-311 SCIATICA-309 DEPRESSION-310
             BOILS-306 ABRASION-307 LACERATION-308
             LONELINESS-303 ANGINA-304 ANGER-305 ANXIETY-302
             DEPRESSION-299 JEALOUSY-300 HANGOVER-301 LACERATION-295
             DREAD-296 GRIEF-297 PROSTATITIS-298 ANXIETY-291
             ANGER-292 HANGOVER-293 PROSTATITIS-294 ANGINA-288
             BOILS-289 JEALOUSY-290 ABRASION-286 SCIATICA-287
             DREAD-282 GRIEF-283 LONELINESS-284 DEPRESSION-285
             ANXIETY-278 GRIEF-279 PROSTATITIS-280 HANGOVER-281
             DEPRESSION-274 ANGER-275 ABRASION-276 BOILS-277
             DREAD-273 SCIATICA-269 LACERATION-270 JEALOUSY-271
             ANGINA-272 DEPRESSION-267 LONELINESS-268
             SCIATICA-263 LACERATION-264 ANGER-265 ABRASION-266
             BOILS-260 ANGINA-261 HANGOVER-262 PROSTATITIS-258
             JEALOUSY-259 - PAIN
             BAVARIA-1023 GUANABARA-1024 ALSACE-257 GOIAS ARIZONA
             BOSNIA OREGON PENNSYLVANIA BAVARIA MORAVIA
             MANITOBA QUEBEC SURREY ALSACE GUANABARA KENTUCKY
             - PROVINCE
             JUPITER NEPTUNE MARS PLUTO - PLANET)
   (:INIT (EATS TUNA-44 POPOVER)
          (CRAVES SCIATICA-287 POTATO)
          (LOCALE POTATO-4 ALSACE-257)
          (CRAVES STIMULATION-91 BEEF-49)
          (EATS GUAVA-21 LEMON-64)
          (CRAVES LEARNING-249 PISTACHIO)
          (CRAVES GRIEF-133 BEEF-49)
          (LOCALE MUTTON-18 OREGON)
          (CRAVES HANGOVER-351 PORK)
          (EATS SNICKERS PAPAYA-12)
          (EATS ONION-25 YOGURT-43)
          (CRAVES ANGER-195 MARZIPAN-123)
          (EATS PEA-36 BEEF)
          (EATS LETTUCE-63 MARZIPAN)
          (CRAVES PROSTATITIS-334 ONION)
          (CRAVES SCIATICA-464 KALE-23)
          (CRAVES EXCITEMENT-99 HAM-40)
          (EATS LETTUCE TURKEY)
          (EATS PISTACHIO-19 CUCUMBER-29)
          (EATS WONDERBREAD-119 GRAPEFRUIT)
          (EATS MUTTON SHRIMP)
          (EATS ORANGE GRAPEFRUIT-60)
          (CRAVES LONELINESS-268 ORANGE)
          (CRAVES PROSTATITIS-175 CHOCOLATE-34)
          (LOCALE WONDERBREAD-10 ALSACE-257)
          (HARMONY ACHIEVEMENT-246 NEPTUNE)
          (LOCALE PEPPER-59 MANITOBA)
          (CRAVES DEPRESSION-149 WURST-42)
          (EATS PORK POTATO)
          (CRAVES GRIEF-189 MELON-125)
          (EATS CHERRY KALE)
          (CRAVES LUBRICITY MELON-125)
          (EATS WURST-24 PISTACHIO)
          (HARMONY EXCITEMENT PLUTO)
          (CRAVES ANXIETY RICE-109)
          (CRAVES JEALOUSY-476 MUTTON-18)
          (EATS SCALLION-118 LAMB-113)
          (HARMONY SATIETY-253 NEPTUNE)
          (HARMONY EXCITEMENT-244 NEPTUNE)
          (CRAVES ABRASION-438 FLOUNDER-11)
          (CRAVES ABRASION-217 OKRA-114)
          (EATS TURKEY-28 PEAR)
          (EATS YOGURT-43 ONION-25)
          (EATS PAPAYA-12 SNICKERS)
          (CRAVES GRIEF-461 WURST-24)
          (CRAVES HANGOVER-146 YOGURT-43)
          (LOCALE MELON PENNSYLVANIA)
          (CRAVES SCIATICA SHRIMP-112)
          (CRAVES ENTERTAINMENT-84 PEPPER-59)
          (CRAVES ANGINA-313 MELON)
          (HARMONY AESTHETICS-78 MARS)
          (EATS OKRA-55 PEA-9)
          (LOCALE TUNA-44 BOSNIA)
          (CRAVES PROSTATITIS-429 SHRIMP-15)
          (CRAVES LONELINESS-451 CUCUMBER-29)
          (CRAVES LACERATION-460 WURST-24)
          (CRAVES TRIUMPH-74 TOFU-32)
          (CRAVES DREAD-179 POPOVER-33)
          (EATS GUAVA-21 MUFFIN)
          (CRAVES ENTERTAINMENT-92 HAMBURGER-47)
          (CRAVES AESTHETICS MUFFIN-124)
          (CRAVES BOILS-306 YOGURT)
          (CRAVES LACERATION-485 HOTDOG-62)
          (CRAVES SATISFACTION-245 ARUGULA)
          (EATS HAMBURGER SHRIMP-15)
          (EATS SHRIMP CHICKEN)
          (EATS LAMB BROCCOLI)
          (CRAVES ANXIETY-360 RICE)
          (CRAVES DREAD-471 PISTACHIO-19)
          (EATS CANTELOPE HOTDOG)
          (EATS MUFFIN GUAVA-21)
          (CRAVES ANXIETY-160 PEPPER-39)
          (EATS ONION SNICKERS)
          (EATS WONDERBREAD GUAVA-38)
          (CRAVES SCIATICA-151 TURKEY-41)
          (HARMONY SATISFACTION-100 MARS)
          (CRAVES DEPRESSION-274 TOFU)
          (CRAVES LOVE-77 KALE-23)
          (CRAVES JEALOUSY-414 MUFFIN-3)
          (CRAVES ANGER-508 OKRA-55)
          (HARMONY UNDERSTANDING-222 NEPTUNE)
          (LOCALE CHOCOLATE-34 BOSNIA)
          (EATS TOMATO-57 WONDERBREAD-10)
          (HARMONY CURIOSITY-256 NEPTUNE)
          (CRAVES AESTHETICS-67 RICE-8)
          (LOCALE HOTDOG ARIZONA)
          (EATS HAM-50 RICE)
          (HARMONY EXPECTATION-71 PLUTO)
          (EATS TOMATO APPLE-51)
          (EATS CHICKEN OKRA)
          (CRAVES ANGINA-368 MUTTON)
          (CRAVES JEALOUSY-290 BROCCOLI)
          (EATS CHOCOLATE HAM-40)
          (EATS BROCCOLI CUCUMBER-37)
          (ATTACKS BAVARIA-1023 GUANABARA-1024)
          (EATS TURKEY PORK)
          (CRAVES HANGOVER-430 SHRIMP-15)
          (EATS CHICKEN-2 HAM)
          (CRAVES ANGINA-401 SCALLION)
          (CRAVES ANXIETY-432 BACON-14)
          (CRAVES LOVE-104 CHOCOLATE-34)
          (EATS PEA-9 OKRA-55)
          (HARMONY AESTHETICS-67 PLUTO)
          (EATS SCALLOP LOBSTER-20)
          (CRAVES DEPRESSION-410 SCALLION-1)
          (CRAVES DEPRESSION-186 SCALLOP-126)
          (EATS CHERRY-53 RICE-8)
          (CRAVES SCIATICA-203 BROCCOLI-120)
          (EATS PAPAYA-12 ONION)
          (HARMONY SATISFACTION-228 NEPTUNE)
          (CRAVES ANGER-436 PAPAYA-12)
          (LOCALE ENDIVE-122 GOIAS)
          (CRAVES SCIATICA-190 MELON-125)
          (CRAVES DEPRESSION-459 ONION-25)
          (EATS CANTELOPE-54 GRAPEFRUIT)
          (HARMONY INTOXICATION-103 PLUTO)
          (LOCALE PEPPER QUEBEC)
          (EATS HOTDOG CANTELOPE)
          (CRAVES ANXIETY-473 PISTACHIO-19)
          (CRAVES SATISFACTION-100 PEPPER-39)
          (EATS TOMATO-117 CANTELOPE-108)
          (CRAVES HANGOVER-281 HAROSET)
          (EATS GRAPEFRUIT-60 ORANGE)
          (EATS BAGUETTE COD)
          (EATS YOGURT BROCCOLI-120)
          (HARMONY EXPECTATION-86 NEPTUNE)
          (EATS PEA-9 POPOVER-33)
          (CRAVES HANGOVER-318 PEA)
          (CRAVES SATISFACTION-228 CUCUMBER)
          (CRAVES DREAD-138 HAMBURGER-47)
          (CRAVES DEPRESSION-336 HOTDOG)
          (CRAVES HANGOVER-191 MUFFIN-124)
          (LOCALE SHRIMP-15 ARIZONA)
          (HARMONY STIMULATION-91 NEPTUNE)
          (EATS ORANGE ORANGE-13)
          (EATS GUAVA-21 BROCCOLI)
          (CRAVES ANGINA-466 CHOCOLATE-22)
          (CRAVES GRIEF-311 TUNA)
          (EATS LOBSTER CHICKEN-2)
          (EATS LEMON-64 GUAVA-21)
          (EATS PEA MELON)
          (CRAVES DEPRESSION-209 HAMBURGER-115)
          (LOCALE HAMBURGER GOIAS)
          (EATS COD-30 MUTTON-18)
          (CRAVES LACERATION-264 CHERRY)
          (CRAVES PROSTATITIS-135 PORK-48)
          (CRAVES SCIATICA-391 COD)
          (CRAVES BOILS-455 ARUGULA-26)
          (CRAVES ANXIETY-278 HAROSET)
          (EATS LEMON SWEETROLL-16)
          (EATS WONDERBREAD-10 CUCUMBER)
          (EATS BACON-14 SHRIMP)
          (CRAVES HANGOVER-478 POPOVER-17)
          (CRAVES CURIOSITY-256 CHICKEN-2)
          (EATS GUAVA-21 BROCCOLI-120)
          (LOCALE CANTELOPE-108 ALSACE-257)
          (CRAVES ANGINA-448 COD-30)
          (EATS HAROSET SCALLOP)
          (EATS BROCCOLI-120 YOGURT)
          (CRAVES LACERATION-500 TOMATO-57)
          (HARMONY STIMULATION-89 MARS)
          (LOCALE TOFU-32 ARIZONA)
          (CRAVES LACERATION-185 SCALLOP-126)
          (HARMONY CURIOSITY MARS)
          (EATS PEA HOTDOG)
          (EATS RICE-8 CHERRY-53)
          (LOCALE HAM-40 PENNSYLVANIA)
          (HARMONY INTOXICATION-72 MARS)
          (CRAVES BOILS MUTTON-110)
          (CRAVES JEALOUSY-479 POPOVER-17)
          (EATS PEPPER-59 FLOUNDER)
          (EATS RICE PEPPER-39)
          (EATS LOBSTER YOGURT)
          (LOCALE PAPAYA QUEBEC)
          (EATS SWEETROLL-16 KALE-23)
          (CRAVES HANGOVER-418 RICE-8)
          (HARMONY LOVE-242 NEPTUNE)
          (EATS OKRA SCALLOP-58)
          (EATS TOFU KALE)
          (HARMONY LEARNING-82 MARS)
          (CRAVES EXCITEMENT KALE-111)
          (CRAVES PROSTATITIS-416 RICE-8)
          (CRAVES DREAD-411 POTATO-4)
          (CRAVES LACERATION MUTTON-110)
          (CRAVES EMPATHY-234 WURST)
          (EATS CUCUMBER WONDERBREAD-10)
          (EATS MUTTON TOMATO)
          (EATS ORANGE WONDERBREAD)
          (EATS WURST ONION)
          (LOCALE PORK-107 BAVARIA-1023)
          (EATS WURST-24 SWEETROLL)
          (CRAVES SATIETY-98 TURKEY-41)
          (CRAVES BOILS-505 OKRA-55)
          (HARMONY EMPATHY-225 NEPTUNE)
          (EATS OKRA-114 HAMBURGER-115)
          (LOCALE POPOVER-33 ALSACE-257)
          (CRAVES ANGINA-143 TUNA-44)
          (EATS BROCCOLI TUNA-121)
          (EATS MARZIPAN YOGURT)
          (CRAVES TRIUMPH BROCCOLI-120)
          (EATS PAPAYA PEPPER-59)
          (CRAVES LACERATION-167 PEA-36)
          (LOCALE HAROSET-5 MANITOBA)
          (CRAVES ANXIETY-439 WONDERBREAD-10)
          (CRAVES ANGINA-154 TURKEY-41)
          (EATS SCALLOP HAROSET)
          (CRAVES LONELINESS-415 RICE-8)
          (CRAVES PROSTATITIS-294 TURKEY)
          (CRAVES INTOXICATION-221 POPOVER)
          (CRAVES ANGINA-345 CHICKEN)
          (LOCALE HAM GOIAS)
          (CRAVES LACERATION-155 HAM-40)
          (CRAVES ANGER-367 MUTTON)
          (CRAVES HANGOVER-204 BROCCOLI-120)
          (CRAVES DREAD-490 GRAPEFRUIT-60)
          (HARMONY SATIETY PLUTO)
          (CRAVES ABRASION-413 MUFFIN-3)
          (LOCALE TOMATO GOIAS)
          (LOCALE PAPAYA-116 BOSNIA)
          (CRAVES ENTERTAINMENT-229 LETTUCE)
          (CRAVES ABRASION-502 YOGURT-56)
          (CRAVES ANGER-156 HAM-40)
          (HARMONY EMPATHY-248 MARS)
          (CRAVES LONELINESS-424 HAROSET-5)
          (CRAVES CURIOSITY-232 PEA)
          (HARMONY STIMULATION-243 PLUTO)
          (HARMONY LUBRICITY-239 MARS)
          (EATS POPOVER-33 PEA-9)
          (EATS GUAVA-38 PEA)
          (CRAVES ANXIETY-327 WURST)
          (LOCALE BAGUETTE-61 BOSNIA)
          (EATS MELON PEA)
          (EATS SNICKERS PEA)
          (CRAVES ANGINA-428 SWEETROLL-16)
          (CRAVES LACERATION-408 SCALLION-1)
          (CRAVES GRIEF SHRIMP-112)
          (EATS LAMB-113 OKRA-114)
          (CRAVES BOILS-316 PEA)
          (LOCALE SHRIMP OREGON)
          (HARMONY LOVE-230 PLUTO)
          (EATS APPLE-51 TOMATO)
          (CRAVES ANGER-140 ENDIVE-46)
          (CRAVES ANGINA-180 SNICKERS-128)
          (EATS MUTTON-18 FLOUNDER)
          (EATS BROCCOLI-120 GUAVA-21)
          (EATS OKRA-114 PAPAYA-116)
          (CRAVES ANGINA-456 ARUGULA-26)
          (CRAVES JEALOUSY-202 BROCCOLI-120)
          (CRAVES HANGOVER-375 CHOCOLATE)
          (EATS APPLE-51 TUNA-44)
          (EATS TURKEY-28 KALE)
          (CRAVES JEALOUSY-350 PORK)
          (EATS SNICKERS-128 APPLE)
          (CRAVES SCIATICA-488 GRAPEFRUIT-60)
          (LOCALE POTATO-127 GUANABARA-1024)
          (EATS TUNA POTATO)
          (LOCALE CUCUMBER-29 OREGON)
          (EATS ARUGULA MARZIPAN-7)
          (LOCALE CHERRY-53 BAVARIA)
          (LOCALE FLOUNDER BAVARIA)
          (CRAVES JEALOUSY-388 ENDIVE)
          (EATS TURKEY-28 MARZIPAN-123)
          (CRAVES ENTERTAINMENT-254 SCALLION)
          (EATS SHRIMP-112 SCALLION-118)
          (EATS PEA-36 GRAPEFRUIT-60)
          (CRAVES SCIATICA-309 HAMBURGER)
          (CRAVES BOILS-158 PEPPER-39)
          (EATS RICE OKRA-55)
          (CRAVES ANXIETY-486 HOTDOG-62)
          (HARMONY UNDERSTANDING-106 NEPTUNE)
          (EATS BROCCOLI-45 TURKEY)
          (EATS MELON-31 OKRA)
          (CRAVES EXPECTATION-86 OKRA-55)
          (CRAVES JEALOUSY-259 FLOUNDER)
          (CRAVES JEALOUSY-463 KALE-23)
          (EATS TURKEY PEPPER-59)
          (EATS LOBSTER LETTUCE-63)
          (CRAVES HANGOVER-499 TOMATO-57)
          (EATS MARZIPAN-123 BROCCOLI)
          (EATS FLOUNDER-11 TURKEY)
          (EATS KALE-23 BROCCOLI)
          (EATS MUFFIN-3 OKRA)
          (EATS SHRIMP-15 WURST)
          (CRAVES DEPRESSION-381 WONDERBREAD)
          (EATS WONDERBREAD ORANGE)
          (CRAVES ACHIEVEMENT-69 SWEETROLL-16)
          (EATS LAMB HOTDOG-62)
          (CRAVES JEALOUSY-317 PEA)
          (ATTACKS MORAVIA MANITOBA)
          (CRAVES CURIOSITY-95 TUNA-44)
          (CRAVES EMPATHY-248 BAGUETTE)
          (EATS LAMB-113 PORK-107)
          (CRAVES JEALOUSY-443 PEA-9)
          (CRAVES ABRASION-152 TURKEY-41)
          (EATS GUAVA-21 PEAR)
          (CRAVES ANXIETY-338 MUFFIN)
          (EATS WONDERBREAD-10 TOMATO-57)
          (EATS SHRIMP BACON-14)
          (CRAVES GRIEF-177 POPOVER-33)
          (CRAVES GRIEF-162 GUAVA-38)
          (HARMONY REST-81 MARS)
          (HARMONY ENTERTAINMENT-84 MARS)
          (HARMONY CURIOSITY-79 NEPTUNE)
          (LOCALE MARZIPAN-123 BAVARIA-1023)
          (CRAVES SATISFACTION-255 PAPAYA)
          (EATS LEMON-64 SHRIMP)
          (EATS ONION-25 SWEETROLL)
          (CRAVES ANGER-305 SHRIMP)
          (CRAVES ABRASION-323 SWEETROLL)
          (LOCALE FLOUNDER-35 GUANABARA-1024)
          (CRAVES DEPRESSION-433 ORANGE-13)
          (CRAVES HANGOVER-174 CHOCOLATE-34)
          (CRAVES GRIEF-484 LETTUCE-63)
          (CRAVES ANXIETY-291 TURKEY)
          (CRAVES REST-241 KALE)
          (CRAVES ANGINA-504 YOGURT-56)
          (EATS POTATO YOGURT-56)
          (EATS MUTTON APPLE)
          (EATS ORANGE-13 ORANGE)
          (CRAVES ANGINA-324 WURST)
          (EATS BEEF-49 LAMB)
          (CRAVES LUBRICITY-93 ENDIVE-46)
          (CRAVES DREAD-511 LAMB-52)
          (EATS TURKEY LETTUCE)
          (CRAVES EMPATHY OKRA-114)
          (LOCALE OKRA-55 MANITOBA)
          (CRAVES ANGER-347 KALE)
          (CRAVES ABRASION-407 CHICKEN-2)
          (LOCALE POPOVER-17 ARIZONA)
          (CRAVES LONELINESS CANTELOPE-108)
          (ATTACKS BOSNIA OREGON)
          (EATS HAM-40 RICE)
          (EATS RICE HAM-50)
          (CRAVES ANXIETY-394 LAMB)
          (EATS PAPAYA-12 HAROSET-5)
          (LOCALE BACON QUEBEC)
          (CRAVES UNDERSTANDING-235 BEEF)
          (LOCALE LOBSTER-20 MANITOBA)
          (EATS SCALLOP-58 OKRA)
          (CRAVES DREAD-349 KALE)
          (HARMONY CURIOSITY-95 NEPTUNE)
          (EATS PAPAYA-116 CANTELOPE-108)
          (LOCALE KALE-111 BAVARIA-1023)
          (CRAVES ABRASION-450 COD-30)
          (CRAVES LACERATION-395 CANTELOPE)
          (CRAVES ANGINA-480 LEMON-64)
          (EATS SCALLION CHOCOLATE-34)
          (EATS KALE CHERRY)
          (CRAVES ANGER-359 RICE)
          (LOCALE ONION ALSACE)
          (EATS TUNA PORK-48)
          (EATS MUFFIN LEMON-64)
          (HARMONY ACHIEVEMENT-220 MARS)
          (CRAVES SATIETY-87 CHERRY-53)
          (EATS GRAPEFRUIT WONDERBREAD-119)
          (LOCALE BROCCOLI-45 GOIAS)
          (CRAVES DREAD-492 PEPPER-59)
          (CRAVES UNDERSTANDING-88 LAMB-52)
          (EATS HAMBURGER-47 ARUGULA-26)
          (ORBITS JUPITER NEPTUNE)
          (EATS SNICKERS-6 PEAR-27)
          (CRAVES DREAD-322 SWEETROLL)
          (CRAVES LEARNING TOMATO-117)
          (EATS LEMON CHOCOLATE-34)
          (EATS MUFFIN-124 BEEF-49)
          (CRAVES AESTHETICS-90 HAM-50)
          (EATS YOGURT OKRA)
          (CRAVES ABRASION-307 YOGURT)
          (LOCALE SWEETROLL GOIAS)
          (CRAVES HANGOVER-510 CHERRY-53)
          (LOCALE BEEF-49 ALSACE)
          (CRAVES EXPECTATION TUNA-121)
          (EATS PORK ONION)
          (EATS APPLE PEPPER)
          (EATS SHRIMP-112 RICE-109)
          (EATS PEA POTATO-127)
          (EATS ONION PAPAYA-12)
          (LOCALE MUFFIN-124 OREGON)
          (EATS POPOVER PEPPER)
          (CRAVES ABRASION LAMB-113)
          (LOCALE PISTACHIO-19 PENNSYLVANIA)
          (CRAVES EXCITEMENT-244 GUAVA)
          (HARMONY UNDERSTANDING-235 MARS)
          (CRAVES PROSTATITIS-280 HAROSET)
          (LOCALE PEAR GUANABARA-1024)
          (HARMONY AESTHETICS PLUTO)
          (EATS ARUGULA-26 HAMBURGER-47)
          (EATS BAGUETTE-61 FLOUNDER)
          (HARMONY ACHIEVEMENT-69 MARS)
          (EATS PEA HAROSET-5)
          (CRAVES BOILS-435 ORANGE-13)
          (EATS YOGURT-43 HOTDOG)
          (CRAVES GRIEF-137 HAMBURGER-47)
          (CRAVES ABRASION-286 POTATO)
          (CRAVES JEALOUSY-129 APPLE-51)
          (CRAVES LONELINESS-150 WURST-42)
          (LOCALE CANTELOPE GUANABARA-1024)
          (EATS TUNA LAMB-52)
          (HARMONY SATISFACTION-245 MARS)
          (LOCALE SCALLION GUANABARA-1024)
          (EATS TURKEY FLOUNDER-11)
          (HARMONY LUBRICITY-73 NEPTUNE)
          (EATS CHOCOLATE-34 LEMON)
          (CRAVES LONELINESS-303 SHRIMP)
          (EATS HOTDOG-62 LEMON)
          (CRAVES SCIATICA-403 PAPAYA)
          (EATS CANTELOPE SWEETROLL)
          (LOCALE WURST OREGON)
          (EATS HAMBURGER GUAVA)
          (CRAVES PROSTATITIS-298 APPLE)
          (EATS SCALLION-118 HAMBURGER-115)
          (CRAVES DREAD-422 SNICKERS-6)
          (LOCALE ORANGE PENNSYLVANIA)
          (CRAVES HANGOVER-329 BEEF)
          (EATS GUAVA HAMBURGER)
          (LOCALE HAROSET QUEBEC)
          (LOCALE HAMBURGER-115 GOIAS)
          (CRAVES DREAD-328 BEEF)
          (EATS ONION PORK)
          (CRAVES ACHIEVEMENT-246 CHOCOLATE)
          (EATS COD BAGUETTE)
          (EATS GUAVA-38 WONDERBREAD)
          (EATS BROCCOLI MARZIPAN-123)
          (EATS SCALLOP-58 SCALLOP)
          (EATS FLOUNDER PEPPER-59)
          (CRAVES ANGER-331 ONION)
          (EATS CHERRY-53 LETTUCE)
          (EATS MELON-125 PEPPER)
          (CRAVES HANGOVER-404 PAPAYA)
          (CRAVES DEPRESSION-299 CUCUMBER)
          (CRAVES GRIEF-380 WONDERBREAD)
          (HARMONY TRIUMPH-74 MARS)
          (LOCALE TURKEY-41 BAVARIA)
          (EATS LETTUCE CUCUMBER)
          (CRAVES ANXIETY-211 PAPAYA-116)
          (CRAVES LONELINESS-325 WURST)
          (EATS ARUGULA ENDIVE-46)
          (EATS BROCCOLI KALE-23)
          (CRAVES GRIEF-365 ARUGULA)
          (CRAVES REST-97 WURST-42)
          (CRAVES INTOXICATION-240 CHICKEN)
          (CRAVES SCIATICA-269 LEMON)
          (CRAVES BOILS-260 MARZIPAN)
          (EATS SCALLION-1 COD)
          (LOCALE GRAPEFRUIT-60 GOIAS)
          (EATS CANTELOPE-108 TOMATO-117)
          (LOCALE LETTUCE-63 BAVARIA)
          (CRAVES DREAD-153 TURKEY-41)
          (EATS OKRA MELON-31)
          (EATS MARZIPAN-123 TURKEY-28)
          (LOCALE LEMON OREGON)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS HAMBURGER-47 SCALLION-1)
          (CRAVES EXPECTATION-231 TUNA)
          (EATS HAM TOFU)
          (HARMONY AESTHETICS-90 NEPTUNE)
          (EATS PORK MARZIPAN-7)
          (EATS TOMATO-117 RICE-109)
          (EATS CUCUMBER POPOVER-17)
          (CRAVES ANGER-402 PAPAYA)
          (CRAVES JEALOUSY-181 SNICKERS-128)
          (EATS KALE-23 SWEETROLL-16)
          (CRAVES SCIATICA-378 CHOCOLATE)
          (CRAVES GRIEF-297 APPLE)
          (EATS SWEETROLL CANTELOPE)
          (EATS TUNA TURKEY)
          (EATS BACON APPLE)
          (CRAVES GRIEF-197 ENDIVE-122)
          (CRAVES LACERATION-431 BACON-14)
          (LOCALE BACON-14 BOSNIA)
          (LOCALE HOTDOG-62 ALSACE-257)
          (LOCALE SCALLION-118 ARIZONA)
          (EATS MELON-31 BACON)
          (EATS ENDIVE BACON-14)
          (EATS PISTACHIO WURST-24)
          (EATS LAMB BEEF-49)
          (EATS CUCUMBER ARUGULA-26)
          (CRAVES HANGOVER-301 CUCUMBER)
          (CRAVES JEALOUSY-300 CUCUMBER)
          (LOCALE WURST-42 BAVARIA-1023)
          (EATS BEEF ORANGE-13)
          (CRAVES HANGOVER-393 LAMB)
          (CRAVES TRIUMPH-227 APPLE)
          (LOCALE LAMB-113 GOIAS)
          (CRAVES EMPATHY-225 BROCCOLI)
          (CRAVES ACHIEVEMENT-94 BROCCOLI-45)
          (EATS PEPPER MELON-125)
          (EATS ENDIVE-46 ONION)
          (EATS KALE TURKEY-28)
          (EATS PEPPER POPOVER)
          (HARMONY SATIETY-87 PLUTO)
          (EATS MUTTON-110 TOMATO-117)
          (ATTACKS MANITOBA QUEBEC)
          (EATS COD SCALLION-1)
          (CRAVES ANGER PORK-107)
          (EATS SCALLOP-126 MARZIPAN)
          (EATS SWEETROLL GRAPEFRUIT)
          (CRAVES DREAD-166 PEA-36)
          (CRAVES DEPRESSION-161 GUAVA-38)
          (HARMONY EMPATHY-234 PLUTO)
          (EATS LAMB-52 WONDERBREAD-119)
          (CRAVES ANGINA-261 MARZIPAN)
          (CRAVES LONELINESS-493 PEPPER-59)
          (HARMONY ENTERTAINMENT-238 MARS)
          (EATS CUCUMBER-37 BROCCOLI)
          (HARMONY LOVE-104 MARS)
          (CRAVES LACERATION-270 LEMON)
          (CRAVES GRIEF-421 SNICKERS-6)
          (CRAVES LACERATION-470 LOBSTER-20)
          (EATS BEEF-49 MUFFIN-124)
          (EATS BROCCOLI-45 PAPAYA)
          (LOCALE MUFFIN GUANABARA-1024)
          (CRAVES DEPRESSION-285 OKRA)
          (CRAVES DREAD-386 BACON)
          (CRAVES LONELINESS-406 CHICKEN-2)
          (EATS MUTTON-110 KALE-111)
          (EATS CUCUMBER POPOVER)
          (ORBITS MARS PLUTO)
          (LOCALE COD ALSACE-257)
          (LOCALE LOBSTER GOIAS)
          (CRAVES LACERATION-354 PEAR)
          (CRAVES SCIATICA-326 WURST)
          (EATS WONDERBREAD PISTACHIO-19)
          (EATS OKRA YOGURT)
          (EATS PAPAYA CHOCOLATE-22)
          (CRAVES EMPATHY-102 PEA-36)
          (EATS POTATO-127 PEA)
          (LOCALE TOMATO-57 GOIAS)
          (CRAVES ABRASION-198 ENDIVE-122)
          (EATS PEA SNICKERS)
          (CRAVES ANXIETY-188 MELON-125)
          (CRAVES ANGINA-201 BROCCOLI-120)
          (EATS BEEF MELON)
          (EATS LEMON-64 MUFFIN)
          (CRAVES PROSTATITIS-494 SCALLOP-58)
          (EATS HAROSET-5 PAPAYA-12)
          (CRAVES DEPRESSION-474 PISTACHIO-19)
          (LOCALE POPOVER ALSACE)
          (EATS GRAPEFRUIT COD-30)
          (CRAVES REST-81 MUTTON-18)
          (CRAVES DREAD-207 HAMBURGER-115)
          (CRAVES REST-251 LAMB)
          (EATS SCALLION-1 HAMBURGER-47)
          (CRAVES LOVE SHRIMP-112)
          (CRAVES SCIATICA-501 YOGURT-56)
          (CRAVES LONELINESS-372 LOBSTER)
          (EATS PORK-48 FLOUNDER-11)
          (LOCALE YOGURT-56 BAVARIA-1023)
          (HARMONY LOVE MARS)
          (LOCALE CHICKEN MANITOBA)
          (CRAVES ANXIETY-374 LOBSTER)
          (ATTACKS ARIZONA BOSNIA)
          (EATS LOBSTER-20 SCALLOP)
          (CRAVES SCIATICA-210 PAPAYA-116)
          (CRAVES TRIUMPH-247 WONDERBREAD)
          (CRAVES UNDERSTANDING-65 SCALLION-1)
          (EATS SWEETROLL HAROSET-5)
          (CRAVES JEALOUSY-214 TOMATO-117)
          (CRAVES LACERATION-377 CHOCOLATE)
          (EATS POTATO PISTACHIO)
          (CRAVES BOILS-176 CHOCOLATE-34)
          (CRAVES PROSTATITIS-445 TOFU-32)
          (EATS SCALLOP SCALLOP-58)
          (EATS PEAR-27 POPOVER)
          (LOCALE GUAVA BAVARIA)
          (EATS MELON-125 MUTTON)
          (EATS PEAR-27 SNICKERS-6)
          (EATS YOGURT LOBSTER)
          (HARMONY EXPECTATION-96 NEPTUNE)
          (EATS OKRA-55 RICE)
          (EATS KALE-111 SCALLION-118)
          (EATS TURKEY BROCCOLI-45)
          (CRAVES DEPRESSION-344 TOMATO)
          (LOCALE SHRIMP-112 GUANABARA-1024)
          (HARMONY REST-251 MARS)
          (LOCALE APPLE QUEBEC)
          (EATS MELON-31 SCALLOP)
          (CRAVES BOILS-446 MELON-31)
          (CRAVES BOILS-184 SCALLOP-126)
          (CRAVES ANGER-483 LETTUCE-63)
          (CRAVES HANGOVER-458 ARUGULA-26)
          (CRAVES ANGER-389 PISTACHIO)
          (CRAVES LUBRICITY-70 SHRIMP-15)
          (CRAVES ABRASION-266 CHERRY)
          (CRAVES JEALOUSY-139 HAMBURGER-47)
          (EATS BACON HAROSET)
          (LOCALE PORK BOSNIA)
          (LOCALE WONDERBREAD-119 GUANABARA-1024)
          (EATS CUCUMBER-29 SCALLION)
          (EATS POTATO-127 CUCUMBER-29)
          (LOCALE ARUGULA GOIAS)
          (CRAVES LACERATION-295 APPLE)
          (LOCALE YOGURT-43 ALSACE-257)
          (EATS HAMBURGER-115 PORK-107)
          (CRAVES BOILS-192 MUFFIN-124)
          (LOCALE RICE-109 BAVARIA)
          (HARMONY ENTERTAINMENT-92 MARS)
          (CRAVES PROSTATITIS PORK-107)
          (EATS HAMBURGER-115 OKRA-114)
          (CRAVES ANGER-292 TURKEY)
          (EATS WURST-42 LEMON-64)
          (LOCALE CHICKEN-2 GOIAS)
          (CRAVES EXCITEMENT-85 SCALLOP-58)
          (HARMONY ACHIEVEMENT PLUTO)
          (CRAVES JEALOUSY-352 PORK)
          (CRAVES GRIEF-335 HOTDOG)
          (EATS TURKEY TUNA)
          (CRAVES LACERATION-339 SCALLOP)
          (EATS TURKEY-41 RICE)
          (HARMONY EMPATHY MARS)
          (EATS CHOCOLATE-34 SCALLION)
          (HARMONY INTOXICATION-240 NEPTUNE)
          (EATS KALE TOFU)
          (CRAVES HANGOVER PORK-107)
          (EATS POTATO TUNA)
          (EATS HAM-40 CHOCOLATE)
          (EATS POPOVER PEAR-27)
          (CRAVES LACERATION-333 ONION)
          (LOCALE OKRA MANITOBA)
          (CRAVES LACERATION-144 YOGURT-43)
          (CRAVES PROSTATITIS-193 MUFFIN-124)
          (HARMONY INTOXICATION MARS)
          (EATS PEPPER-59 TURKEY)
          (CRAVES GRIEF-405 CHICKEN-2)
          (CRAVES CURIOSITY HAMBURGER-115)
          (HARMONY EMPATHY-76 MARS)
          (CRAVES BOILS-417 RICE-8)
          (EATS BACON-14 ENDIVE)
          (CRAVES LACERATION-440 WONDERBREAD-10)
          (EATS POPOVER CUCUMBER)
          (EATS BAGUETTE HAROSET)
          (EATS GRAPEFRUIT CANTELOPE-54)
          (CRAVES TRIUMPH-101 CUCUMBER-37)
          (EATS MELON BEEF)
          (CRAVES GRIEF-279 HAROSET)
          (ATTACKS OREGON PENNSYLVANIA)
          (EATS BEEF PEA-36)
          (CRAVES ABRASION-131 HAM-50)
          (EATS MUTTON-18 COD-30)
          (CRAVES ABRASION-330 BEEF)
          (CRAVES LEARNING-105 SNICKERS-128)
          (CRAVES ABRASION-165 PEA-36)
          (CRAVES LACERATION-319 PEA)
          (CRAVES GRIEF-503 YOGURT-56)
          (EATS POPOVER-17 CUCUMBER)
          (EATS CUCUMBER-37 TURKEY-28)
          (EATS SHRIMP-15 HAMBURGER)
          (CRAVES LOVE-230 SHRIMP)
          (EATS SHRIMP-15 POPOVER-17)
          (EATS SCALLOP MELON-31)
          (EATS LOBSTER PEAR)
          (EATS TOMATO MUTTON)
          (CRAVES PROSTATITIS-373 LOBSTER)
          (LOCALE TURKEY-28 ARIZONA)
          (EATS YOGURT-56 FLOUNDER-11)
          (CRAVES HANGOVER-262 MARZIPAN)
          (CRAVES ENTERTAINMENT MUTTON-110)
          (CRAVES SCIATICA-454 PEAR-27)
          (EATS PEPPER-39 ONION-25)
          (HARMONY EXPECTATION NEPTUNE)
          (EATS TOFU-32 COD-30)
          (EATS PEAR LOBSTER)
          (CRAVES JEALOUSY-157 PEPPER-39)
          (CRAVES ABRASION-469 GUAVA-21)
          (EATS ENDIVE-122 BAGUETTE)
          (CRAVES SCIATICA-341 SCALLOP)
          (EATS TUNA-121 MUTTON)
          (EATS LAMB-113 SCALLION-118)
          (EATS ORANGE-13 BEEF)
          (LOCALE YOGURT MORAVIA)
          (EATS ONION WURST)
          (EATS POPOVER-17 SHRIMP-15)
          (EATS TOMATO-117 MUTTON-110)
          (ATTACKS GUANABARA-1024 ALSACE-257)
          (CRAVES ANGER-495 SCALLOP-58)
          (EATS TOFU MARZIPAN)
          (LOCALE LAMB-52 ARIZONA)
          (EATS SWEETROLL ONION-25)
          (CRAVES INTOXICATION-103 FLOUNDER-35)
          (CRAVES ABRASION-342 SCALLOP)
          (EATS RICE TURKEY-41)
          (LOCALE LETTUCE ARIZONA)
          (CRAVES LACERATION-308 YOGURT)
          (EATS HAMBURGER-115 OKRA)
          (CRAVES PROSTATITIS-457 ARUGULA-26)
          (EATS FLOUNDER BAGUETTE-61)
          (CRAVES UNDERSTANDING-222 TOFU)
          (CRAVES EXPECTATION-71 ORANGE-13)
          (CRAVES ANGINA-169 FLOUNDER-35)
          (EATS PORK-107 HAMBURGER-115)
          (CRAVES STIMULATION-68 SNICKERS-6)
          (EATS POTATO PORK)
          (HARMONY LUBRICITY-70 MARS)
          (HARMONY REST-97 MARS)
          (EATS TOMATO-57 ONION)
          (CRAVES ANGER-218 LAMB-113)
          (HARMONY UNDERSTANDING-88 PLUTO)
          (HARMONY LEARNING-249 NEPTUNE)
          (LOCALE SNICKERS-6 QUEBEC)
          (CRAVES PROSTATITIS-136 PORK-48)
          (LOCALE CHOCOLATE GUANABARA-1024)
          (LOCALE ORANGE-13 BOSNIA)
          (LOCALE TURKEY ALSACE-257)
          (CRAVES SATIETY-236 ONION)
          (EATS ARUGULA LETTUCE)
          (EATS POTATO-4 ENDIVE)
          (EATS FLOUNDER-35 PEAR)
          (CRAVES PROSTATITIS-343 TOMATO)
          (HARMONY REST-241 PLUTO)
          (CRAVES SATISFACTION PAPAYA-116)
          (HARMONY STIMULATION-68 NEPTUNE)
          (LOCALE TOFU PENNSYLVANIA)
          (EATS SWEETROLL-16 LEMON)
          (CRAVES HANGOVER-293 TURKEY)
          (CRAVES AESTHETICS-78 CHOCOLATE-22)
          (CRAVES DEPRESSION-132 BEEF-49)
          (EATS OKRA MUFFIN-3)
          (EATS ONION ENDIVE-46)
          (EATS APPLE-51 MUFFIN-124)
          (EATS CHICKEN SHRIMP)
          (LOCALE PISTACHIO BOSNIA)
          (CRAVES LONELINESS-348 KALE)
          (CRAVES HANGOVER-163 CUCUMBER-37)
          (EATS PORK-48 TUNA)
          (LOCALE GUAVA-38 GUANABARA-1024)
          (LOCALE SWEETROLL-16 BOSNIA)
          (CRAVES JEALOUSY-271 LEMON)
          (CRAVES DREAD-273 POPOVER)
          (CRAVES SCIATICA-441 PEA-9)
          (CRAVES ENTERTAINMENT-238 SCALLOP)
          (CRAVES BOILS-145 YOGURT-43)
          (CRAVES DEPRESSION-498 TOMATO-57)
          (EATS GRAPEFRUIT SWEETROLL)
          (CRAVES PROSTATITIS-398 HAM)
          (EATS PEAR TURKEY-28)
          (EATS MARZIPAN LOBSTER-20)
          (EATS LEMON HOTDOG-62)
          (EATS BEEF-49 POPOVER)
          (HARMONY TRIUMPH-101 NEPTUNE)
          (CRAVES SCIATICA-356 PEAR)
          (CRAVES DEPRESSION-267 ORANGE)
          (ATTACKS SURREY ALSACE)
          (CRAVES LONELINESS-355 PEAR)
          (EATS ONION-25 PEPPER-39)
          (CRAVES ANGINA-288 BROCCOLI)
          (EATS PAPAYA-116 SHRIMP-112)
          (EATS PAPAYA-12 POTATO)
          (CRAVES STIMULATION-243 PEAR)
          (HARMONY CURIOSITY-232 MARS)
          (EATS APPLE MUFFIN-3)
          (EATS MARZIPAN-7 PORK)
          (EATS LETTUCE CHERRY-53)
          (CRAVES ANGER-315 MELON)
          (EATS BACON MELON-31)
          (CRAVES JEALOUSY KALE-111)
          (CRAVES BOILS-289 BROCCOLI)
          (CRAVES ANXIETY-420 SNICKERS-6)
          (LOCALE SCALLION-1 MORAVIA)
          (EATS ENDIVE-46 ARUGULA)
          (CRAVES BOILS-340 SCALLOP)
          (EATS POTATO PAPAYA-12)
          (EATS CANTELOPE-108 PAPAYA-116)
          (EATS APPLE SNICKERS-128)
          (CRAVES GRIEF-346 KALE)
          (EATS BAGUETTE-61 CHOCOLATE)
          (CRAVES ABRASION-363 GRAPEFRUIT)
          (CRAVES ANXIETY-302 LETTUCE)
          (EATS HAROSET BACON)
          (LOCALE APPLE-51 ARIZONA)
          (EATS OKRA-114 LAMB-113)
          (CRAVES LONELINESS-320 SWEETROLL)
          (LOCALE PORK-48 ALSACE-257)
          (EATS PEPPER-59 PAPAYA)
          (HARMONY EXCITEMENT-226 NEPTUNE)
          (LOCALE BEEF BOSNIA)
          (EATS MELON POPOVER-33)
          (LOCALE GRAPEFRUIT GUANABARA-1024)
          (EATS RICE-8 HAROSET)
          (CRAVES LONELINESS-449 COD-30)
          (CRAVES SCIATICA-312 MELON)
          (EATS PAPAYA-116 OKRA-114)
          (CRAVES ANGINA-412 MUFFIN-3)
          (CRAVES PROSTATITIS-314 MELON)
          (CRAVES ANGINA-215 SCALLION-118)
          (EATS CHERRY CUCUMBER-37)
          (LOCALE ENDIVE-46 MORAVIA)
          (HARMONY TRIUMPH-252 NEPTUNE)
          (CRAVES INTOXICATION-72 PAPAYA-12)
          (EATS TURKEY HAROSET)
          (CRAVES BOILS-509 CANTELOPE-54)
          (EATS SNICKERS ONION)
          (EATS PEPPER-39 RICE)
          (EATS CANTELOPE-54 TOFU-32)
          (EATS COD-30 TOFU-32)
          (CRAVES JEALOUSY-376 CHOCOLATE)
          (HARMONY SATIETY-98 NEPTUNE)
          (CRAVES LONELINESS-481 LETTUCE-63)
          (CRAVES PROSTATITIS-183 POTATO-127)
          (LOCALE MARZIPAN-7 GUANABARA-1024)
          (EATS YOGURT-56 POTATO)
          (CRAVES SATISFACTION-75 ONION-25)
          (EATS MUFFIN POTATO-4)
          (EATS SCALLOP-126 HAM)
          (EATS HAROSET BAGUETTE)
          (EATS ARUGULA-26 CUCUMBER)
          (EATS PEAR GUAVA-21)
          (EATS BROCCOLI GUAVA-21)
          (HARMONY UNDERSTANDING MARS)
          (EATS MARZIPAN LETTUCE-63)
          (CRAVES GRIEF-447 MELON-31)
          (HARMONY LOVE-66 NEPTUNE)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES HANGOVER-358 RICE)
          (EATS CHERRY BROCCOLI)
          (HARMONY LOVE-77 MARS)
          (EATS HAM-50 ORANGE-13)
          (HARMONY SATISFACTION-255 MARS)
          (CRAVES LOVE-66 POTATO-4)
          (CRAVES DREAD-437 FLOUNDER-11)
          (CRAVES DEPRESSION-164 CUCUMBER-37)
          (HARMONY STIMULATION-223 PLUTO)
          (CRAVES ABRASION-384 BAGUETTE)
          (LOCALE SNICKERS-128 OREGON)
          (HARMONY SATISFACTION-75 NEPTUNE)
          (LOCALE HAM-50 BAVARIA)
          (EATS PEAR FLOUNDER-35)
          (EATS SNICKERS-6 GUAVA)
          (LOCALE KALE-23 ALSACE-257)
          (EATS WURST SHRIMP-15)
          (LOCALE TOMATO-117 GOIAS)
          (EATS SNICKERS-128 HAROSET)
          (EATS WONDERBREAD-119 LAMB-52)
          (CRAVES LONELINESS-385 BACON)
          (EATS ENDIVE-122 POPOVER)
          (EATS PISTACHIO-19 LEMON)
          (LOCALE WONDERBREAD PENNSYLVANIA)
          (LOCALE LEMON-64 BAVARIA-1023)
          (CRAVES ANGER-453 TURKEY-28)
          (EATS SCALLION CUCUMBER-29)
          (EATS BAGUETTE ENDIVE-122)
          (CRAVES EXCITEMENT-226 TURKEY)
          (HARMONY LUBRICITY-93 PLUTO)
          (CRAVES GRIEF-366 ARUGULA)
          (LOCALE MUFFIN-3 OREGON)
          (CRAVES INTOXICATION-83 BAGUETTE-61)
          (CRAVES LUBRICITY-73 PEA-9)
          (CRAVES LOVE-242 PORK)
          (HARMONY INTOXICATION-221 NEPTUNE)
          (LOCALE ENDIVE OREGON)
          (CRAVES LONELINESS-142 BROCCOLI-45)
          (CRAVES STIMULATION RICE-109)
          (EATS FLOUNDER TURKEY)
          (CRAVES SCIATICA-147 YOGURT-43)
          (LOCALE MUTTON-110 GUANABARA-1024)
          (CRAVES LACERATION-507 OKRA-55)
          (EATS ORANGE-13 HAM-50)
          (LOCALE CHOCOLATE-22 PENNSYLVANIA)
          (CRAVES ANGER-275 TOFU)
          (EATS HAROSET RICE-8)
          (EATS POPOVER-33 MELON)
          (EATS RICE HAM-40)
          (CRAVES ANGER-172 FLOUNDER-35)
          (CRAVES BOILS-277 TOFU)
          (EATS CUCUMBER-37 CHERRY)
          (LOCALE FLOUNDER-11 BAVARIA-1023)
          (CRAVES DEPRESSION-361 GUAVA)
          (CRAVES ANGER-425 HAROSET-5)
          (CRAVES DEPRESSION-370 SNICKERS)
          (CRAVES LONELINESS-130 APPLE-51)
          (CRAVES DREAD-282 OKRA)
          (CRAVES BOILS-369 SNICKERS)
          (CRAVES PROSTATITIS-491 GRAPEFRUIT-60)
          (CRAVES UNDERSTANDING LAMB-113)
          (CRAVES DEPRESSION-196 MARZIPAN-123)
          (EATS HAROSET-5 SWEETROLL)
          (EATS WURST-42 BROCCOLI)
          (CRAVES PROSTATITIS-206 WONDERBREAD-119)
          (LOCALE ONION-25 OREGON)
          (CRAVES JEALOUSY-426 HAROSET-5)
          (CRAVES DEPRESSION-396 CANTELOPE)
          (LOCALE GUAVA-21 GOIAS)
          (EATS POPOVER BEEF-49)
          (LOCALE POTATO OREGON)
          (EATS PISTACHIO-19 WONDERBREAD)
          (HARMONY LEARNING-237 MARS)
          (HARMONY UNDERSTANDING-65 NEPTUNE)
          (EATS YOGURT CHICKEN)
          (EATS HAROSET COD)
          (EATS PEPPER APPLE)
          (EATS ONION POTATO)
          (LOCALE HAMBURGER-47 BAVARIA)
          (CRAVES PROSTATITIS-258 FLOUNDER)
          (CRAVES ANXIETY-168 PEA-36)
          (CRAVES ABRASION-423 SNICKERS-6)
          (EATS RICE-109 SHRIMP-112)
          (EATS APPLE MUTTON)
          (EATS LEMON-64 WURST-42)
          (EATS HOTDOG YOGURT-43)
          (EATS HAROSET SNICKERS-128)
          (CRAVES ANGINA-357 RICE)
          (CRAVES PROSTATITIS-364 GRAPEFRUIT)
          (HARMONY ENTERTAINMENT-229 MARS)
          (CRAVES ANXIETY-497 TOMATO-57)
          (EATS PAPAYA BROCCOLI-45)
          (CRAVES SCIATICA-263 CHERRY)
          (LOCALE PEPPER-39 PENNSYLVANIA)
          (CRAVES ANGER-187 MELON-125)
          (LOCALE MELON-125 BAVARIA)
          (HARMONY INTOXICATION-83 MARS)
          (CRAVES SATIETY SCALLION-118)
          (CRAVES DEPRESSION-487 BAGUETTE-61)
          (EATS PISTACHIO POTATO)
          (CRAVES GRIEF-434 ORANGE-13)
          (CRAVES SCIATICA-427 SWEETROLL-16)
          (EATS OKRA CHICKEN)
          (EATS SWEETROLL WURST-24)
          (CRAVES CURIOSITY-79 LOBSTER-20)
          (CRAVES JEALOUSY-496 SCALLOP-58)
          (EATS TUNA-44 APPLE-51)
          (EATS SHRIMP-112 PAPAYA-116)
          (ATTACKS GOIAS ARIZONA)
          (LOCALE PEAR-27 MORAVIA)
          (ORBITS NEPTUNE MARS)
          (CRAVES HANGOVER-444 PEA-9)
          (CRAVES ABRASION-141 ENDIVE-46)
          (EATS MARZIPAN-7 ARUGULA)
          (CRAVES PROSTATITIS-472 PISTACHIO-19)
          (EATS TOFU PEAR)
          (EATS SHRIMP LEMON-64)
          (CRAVES DREAD-362 GUAVA)
          (CRAVES BOILS-475 MUTTON-18)
          (EATS TOFU-32 CANTELOPE-54)
          (CRAVES JEALOUSY-397 CANTELOPE)
          (CRAVES ANGINA-390 PISTACHIO)
          (HARMONY TRIUMPH-227 MARS)
          (CRAVES LONELINESS-182 POTATO-127)
          (EATS LAMB-52 TUNA)
          (ATTACKS QUEBEC SURREY)
          (LOCALE LAMB MORAVIA)
          (CRAVES ACHIEVEMENT MARZIPAN-123)
          (HARMONY ENTERTAINMENT-254 NEPTUNE)
          (HARMONY STIMULATION MARS)
          (CRAVES SCIATICA-171 FLOUNDER-35)
          (CRAVES ACHIEVEMENT-80 PISTACHIO-19)
          (CRAVES ANXIETY-321 SWEETROLL)
          (EATS FLOUNDER-35 BROCCOLI)
          (EATS CHOCOLATE-22 HAROSET)
          (HARMONY ACHIEVEMENT-80 NEPTUNE)
          (EATS PORK-107 LAMB-113)
          (CRAVES DREAD LAMB-113)
          (CRAVES EMPATHY-76 WURST-24)
          (EATS COD-30 GRAPEFRUIT)
          (CRAVES PROSTATITIS-383 PEPPER)
          (LOCALE SCALLOP MORAVIA)
          (EATS HAROSET-5 PEA)
          (EATS CUCUMBER-29 POTATO-127)
          (CRAVES EXPECTATION-96 YOGURT-43)
          (LOCALE SCALLOP-58 PENNSYLVANIA)
          (EATS COD HAROSET)
          (CRAVES ANGINA-512 LAMB-52)
          (EATS OKRA HAMBURGER-115)
          (LOCALE MELON-31 MANITOBA)
          (EATS HAM SCALLOP-126)
          (EATS CHICKEN YOGURT)
          (EATS PEAR TOFU)
          (HARMONY EXPECTATION-231 MARS)
          (LOCALE PEA-9 BAVARIA-1023)
          (CRAVES ANGER-409 SCALLION-1)
          (CRAVES DREAD-200 TUNA-121)
          (LOCALE CUCUMBER BAVARIA)
          (EATS PEA GUAVA-38)
          (EATS SCALLION-118 SHRIMP-112)
          (HARMONY SATISFACTION MARS)
          (EATS CUCUMBER LETTUCE)
          (EATS POTATO-4 MUFFIN)
          (EATS MELON HOTDOG)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (EATS YOGURT MARZIPAN)
          (EATS FLOUNDER-11 PORK-48)
          (EATS BROCCOLI CHERRY)
          (EATS POPOVER ENDIVE-122)
          (EATS TOFU HAM)
          (EATS HOTDOG MELON)
          (CRAVES LEARNING-82 HOTDOG-62)
          (CRAVES ANGINA RICE-109)
          (EATS POTATO ONION)
          (CRAVES DREAD-452 TURKEY-28)
          (EATS HAMBURGER-115 SCALLION-118)
          (CRAVES ANXIETY-194 MARZIPAN-123)
          (CRAVES DEPRESSION SHRIMP-112)
          (EATS SHRIMP MUTTON)
          (EATS RICE-109 TOMATO-117)
          (EATS BROCCOLI WURST-42)
          (EATS KALE-111 MUTTON-110)
          (EATS ENDIVE POTATO-4)
          (EATS YOGURT-43 TURKEY-41)
          (EATS TURKEY FLOUNDER)
          (EATS MUFFIN-3 APPLE)
          (EATS CHICKEN-2 LOBSTER)
          (HARMONY TRIUMPH NEPTUNE)
          (EATS SHRIMP-112 OKRA-114)
          (CRAVES BOILS-489 GRAPEFRUIT-60)
          (CRAVES SCIATICA-134 PORK-48)
          (CRAVES ABRASION-482 LETTUCE-63)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS HAROSET CHOCOLATE-22)
          (CRAVES LONELINESS-468 GUAVA-21)
          (LOCALE BROCCOLI-120 GUANABARA-1024)
          (CRAVES LACERATION-199 ENDIVE-122)
          (CRAVES DREAD-400 SCALLION)
          (CRAVES DEPRESSION-442 PEA-9)
          (EATS MUTTON TUNA-121)
          (EATS CHOCOLATE-22 PAPAYA)
          (LOCALE CHERRY BOSNIA)
          (CRAVES HANGOVER-219 LAMB-113)
          (CRAVES ANXIETY-148 WURST-42)
          (CRAVES LACERATION-387 BACON)
          (EATS OKRA-114 SHRIMP-112)
          (HARMONY LEARNING NEPTUNE)
          (EATS BROCCOLI FLOUNDER-35)
          (EATS FLOUNDER-11 YOGURT-56)
          (CRAVES ANGINA-272 LEMON)
          (LOCALE COD-30 MORAVIA)
          (CRAVES INTOXICATION CANTELOPE-108)
          (EATS CUCUMBER-29 PISTACHIO-19)
          (CRAVES DREAD-371 LOBSTER)
          (CRAVES ABRASION-379 WONDERBREAD)
          (CRAVES LONELINESS-208 HAMBURGER-115)
          (LOCALE BAGUETTE GUANABARA-1024)
          (HARMONY EXCITEMENT-85 MARS)
          (HARMONY SATIETY-236 PLUTO)
          (CRAVES LONELINESS-284 OKRA)
          (EATS TURKEY-28 CUCUMBER-37)
          (EATS HAM CHICKEN-2)
          (CRAVES REST PORK-107)
          (CRAVES GRIEF-283 OKRA)
          (EATS MUFFIN-124 APPLE-51)
          (CRAVES HANGOVER-467 CHOCOLATE-22)
          (CRAVES ANXIETY-382 PEPPER)
          (LOCALE CUCUMBER-37 ALSACE-257)
          (EATS LETTUCE ARUGULA)
          (CRAVES BOILS-337 MUFFIN)
          (CRAVES AESTHETICS-233 SWEETROLL)
          (HARMONY EXCITEMENT-250 NEPTUNE)
          (LOCALE SCALLOP-126 QUEBEC)
          (CRAVES TRIUMPH-252 CANTELOPE)
          (CRAVES BOILS-353 PORK)
          (CRAVES REST-224 POTATO)
          (CRAVES ABRASION-178 POPOVER-33)
          (CRAVES EXCITEMENT-250 COD)
          (LOCALE WURST-24 GUANABARA-1024)
          (EATS POPOVER TUNA-44)
          (EATS ONION TOMATO-57)
          (CRAVES DREAD-296 APPLE)
          (CRAVES ANXIETY-462 WURST-24)
          (CRAVES ANGER-265 CHERRY)
          (ATTACKS ALSACE GUANABARA)
          (EATS TURKEY TOFU-32)
          (EATS MARZIPAN SCALLOP-126)
          (CRAVES LONELINESS-170 FLOUNDER-35)
          (LOCALE ARUGULA-26 PENNSYLVANIA)
          (CRAVES LONELINESS-205 WONDERBREAD-119)
          (LOCALE PEA MORAVIA)
          (EATS LETTUCE-63 LOBSTER)
          (HARMONY TRIUMPH-247 MARS)
          (LOCALE SNICKERS SURREY)
          (CRAVES JEALOUSY-173 CHOCOLATE-34)
          (EATS MUTTON MELON-125)
          (HARMONY EMPATHY-102 MARS)
          (CRAVES ANGER-465 KALE-23)
          (EATS SCALLION-118 KALE-111)
          (EATS GRAPEFRUIT-60 PEA-36)
          (LOCALE KALE MORAVIA)
          (CRAVES PROSTATITIS-159 PEPPER-39)
          (CRAVES UNDERSTANDING-106 POTATO-127)
          (LOCALE TUNA ALSACE-257)
          (HARMONY LEARNING-105 MARS)
          (LOCALE RICE-8 MORAVIA)
          (LOCALE MUTTON OREGON)
          (EATS PORK TURKEY)
          (EATS APPLE BACON)
          (EATS BROCCOLI LAMB)
          (LOCALE TUNA-121 GUANABARA-1024)
          (LOCALE PEA-36 GUANABARA-1024)
          (CRAVES GRIEF-477 MUTTON-18)
          (CRAVES ABRASION-276 TOFU)
          (CRAVES SATIETY-253 HAM)
          (CRAVES JEALOUSY-332 ONION)
          (LOCALE PAPAYA-12 MANITOBA)
          (LOCALE BROCCOLI ALSACE-257)
          (CRAVES ANXIETY-506 OKRA-55)
          (CRAVES ACHIEVEMENT-220 MARZIPAN)
          (EATS TUNA-121 BROCCOLI)
          (LOCALE OKRA-114 ARIZONA)
          (HARMONY REST PLUTO)
          (EATS HOTDOG-62 LAMB)
          (EATS HAROSET TURKEY)
          (EATS FLOUNDER MUTTON-18)
          (HARMONY REST-224 MARS)
          (EATS GUAVA SNICKERS-6)
          (CRAVES BOILS-399 SCALLION)
          (HARMONY AESTHETICS-233 PLUTO)
          (CRAVES GRIEF-212 PAPAYA-116)
          (EATS TURKEY-41 YOGURT-43)
          (HARMONY EXCITEMENT-99 MARS)
          (HARMONY ACHIEVEMENT-94 NEPTUNE)
          (EATS CHOCOLATE BAGUETTE-61)
          (HARMONY LUBRICITY PLUTO)
          (CRAVES BOILS-216 SCALLION-118)
          (ATTACKS ALSACE-257 GOIAS)
          (EATS LEMON PISTACHIO-19)
          (CRAVES STIMULATION-223 OKRA)
          (CRAVES STIMULATION-89 APPLE-51)
          (CRAVES LACERATION-213 TOMATO-117)
          (LOCALE MARZIPAN KENTUCKY)
          (CRAVES DEPRESSION-310 HAMBURGER)
          (EATS TOFU-32 TURKEY)
          (CRAVES BOILS-392 COD)
          (EATS HOTDOG PEA)
          (EATS LOBSTER-20 MARZIPAN)
          (CRAVES ANGINA-304 SHRIMP)
          (CRAVES LEARNING-237 HOTDOG)
          (LOCALE CANTELOPE-54 GUANABARA-1024)
          (LOCALE RICE ALSACE)
          (CRAVES SCIATICA-419 MARZIPAN-7)
          (EATS MARZIPAN TOFU)
          (CRAVES LUBRICITY-239 TOMATO))
   (:GOAL (AND (CRAVES BOILS-216 WONDERBREAD)
               (CRAVES LACERATION-333 POTATO-127)
               (CRAVES JEALOUSY-332 POTATO-127)
               (CRAVES HANGOVER-204 POTATO-127)
               (CRAVES ANGINA-201 POTATO-127)
               (CRAVES GRIEF-212 POTATO-127)
               (CRAVES ANGER-292 POTATO-127)
               (CRAVES PROSTATITIS-294 POTATO-127)
               (CRAVES DEPRESSION-361 POTATO-127)
               (CRAVES DREAD-362 POTATO-127)
               (CRAVES ANGER-409 POTATO-127)
               (CRAVES LACERATION-395 YOGURT)
               (CRAVES PROSTATITIS-429 YOGURT)
               (CRAVES HANGOVER-430 YOGURT)
               (CRAVES ANGER-425 YOGURT)
               (CRAVES JEALOUSY-426 MUFFIN))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-1)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS HAM WONDERBREAD LETTUCE SNICKERS MUFFIN BEEF COD
             SWEETROLL LAMB SCALLION KALE PORK CHICKEN SHRIMP ACHIEVEMENT
             INTOXICATION UNDERSTANDING SCIATICA GRIEF ANXIETY DREAD ANGINA
             ABRASION PROSTATITIS GOIAS ARIZONA SATURN MARS NEPTUNE)
   (:INIT (FOOD HAM)
          (FOOD WONDERBREAD)
          (FOOD LETTUCE)
          (FOOD SNICKERS)
          (FOOD MUFFIN)
          (FOOD BEEF)
          (FOOD COD)
          (FOOD SWEETROLL)
          (FOOD LAMB)
          (FOOD SCALLION)
          (FOOD KALE)
          (FOOD PORK)
          (FOOD CHICKEN)
          (FOOD SHRIMP)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE INTOXICATION)
          (PLEASURE UNDERSTANDING)
          (PAIN SCIATICA)
          (PAIN GRIEF)
          (PAIN ANXIETY)
          (PAIN DREAD)
          (PAIN ANGINA)
          (PAIN ABRASION)
          (PAIN PROSTATITIS)
          (PROVINCE GOIAS)
          (PROVINCE ARIZONA)
          (PLANET SATURN)
          (PLANET MARS)
          (PLANET NEPTUNE)
          (EATS MUFFIN WONDERBREAD)
          (EATS SWEETROLL HAM)
          (EATS CHICKEN SHRIMP)
          (HARMONY ACHIEVEMENT MARS)
          (EATS SWEETROLL COD)
          (EATS WONDERBREAD MUFFIN)
          (LOCALE KALE GOIAS)
          (EATS SWEETROLL LAMB)
          (LOCALE LETTUCE GOIAS)
          (CRAVES ANGINA LAMB)
          (EATS LETTUCE SNICKERS)
          (EATS HAM SWEETROLL)
          (LOCALE HAM GOIAS)
          (CRAVES GRIEF MUFFIN)
          (LOCALE BEEF GOIAS)
          (EATS CHICKEN PORK)
          (LOCALE SCALLION ARIZONA)
          (EATS SHRIMP LAMB)
          (EATS BEEF LAMB)
          (LOCALE COD ARIZONA)
          (EATS WONDERBREAD LETTUCE)
          (LOCALE SWEETROLL GOIAS)
          (HARMONY UNDERSTANDING MARS)
          (ORBITS SATURN MARS)
          (EATS SCALLION KALE)
          (EATS LAMB SHRIMP)
          (EATS LAMB BEEF)
          (ORBITS MARS NEPTUNE)
          (LOCALE PORK GOIAS)
          (LOCALE SHRIMP GOIAS)
          (CRAVES ABRASION LAMB)
          (CRAVES INTOXICATION CHICKEN)
          (EATS BEEF COD)
          (EATS PORK CHICKEN)
          (CRAVES DREAD LAMB)
          (LOCALE SNICKERS ARIZONA)
          (EATS HAM MUFFIN)
          (EATS COD BEEF)
          (EATS SNICKERS LETTUCE)
          (EATS PORK KALE)
          (EATS KALE SCALLION)
          (CRAVES UNDERSTANDING SHRIMP)
          (EATS SCALLION SHRIMP)
          (LOCALE LAMB GOIAS)
          (EATS LETTUCE WONDERBREAD)
          (EATS MUFFIN HAM)
          (EATS SNICKERS HAM)
          (CRAVES SCIATICA MUFFIN)
          (CRAVES ACHIEVEMENT HAM)
          (EATS KALE PORK)
          (ATTACKS GOIAS ARIZONA)
          (EATS SHRIMP CHICKEN)
          (EATS COD SWEETROLL)
          (CRAVES ANXIETY MUFFIN)
          (CRAVES PROSTATITIS PORK)
          (HARMONY INTOXICATION NEPTUNE)
          (LOCALE WONDERBREAD GOIAS)
          (LOCALE CHICKEN ARIZONA)
          (EATS SHRIMP SCALLION)
          (EATS HAM SNICKERS)
          (EATS LAMB SWEETROLL)
          (LOCALE MUFFIN ARIZONA))
   (:GOAL (AND (CRAVES PROSTATITIS SNICKERS))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-2)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS HAROSET SCALLOP HOTDOG SCALLION MELON SNICKERS LEMON
             CHOCOLATE LETTUCE KALE PISTACHIO CANTELOPE SHRIMP UNDERSTANDING
             ACHIEVEMENT INTOXICATION SATIETY PROSTATITIS ANGINA ANGER
             LONELINESS ANXIETY SCIATICA GRIEF LACERATION HANGOVER DREAD
             DEPRESSION GRIEF-2 ABRASION BOILS JEALOUSY DEPRESSION-1
             PROSTATITIS-8 LONELINESS-3 HANGOVER-4 SCIATICA-6 ANGER-7
             ANXIETY-14 ANGINA-15 LACERATION-16 DREAD-5 ABRASION-13 DREAD-10
             BOILS-11 JEALOUSY-12 GUANABARA ALSACE GOIAS URANUS MARS NEPTUNE
             MERCURY)
   (:INIT (FOOD HAROSET)
          (FOOD SCALLOP)
          (FOOD HOTDOG)
          (FOOD SCALLION)
          (FOOD MELON)
          (FOOD SNICKERS)
          (FOOD LEMON)
          (FOOD CHOCOLATE)
          (FOOD LETTUCE)
          (FOOD KALE)
          (FOOD PISTACHIO)
          (FOOD CANTELOPE)
          (FOOD SHRIMP)
          (PLEASURE UNDERSTANDING)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE INTOXICATION)
          (PLEASURE SATIETY)
          (PAIN PROSTATITIS)
          (PAIN ANGINA)
          (PAIN ANGER)
          (PAIN LONELINESS)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN HANGOVER)
          (PAIN DREAD)
          (PAIN DEPRESSION)
          (PAIN GRIEF-2)
          (PAIN ABRASION)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN DEPRESSION-1)
          (PAIN PROSTATITIS-8)
          (PAIN LONELINESS-3)
          (PAIN HANGOVER-4)
          (PAIN SCIATICA-6)
          (PAIN ANGER-7)
          (PAIN ANXIETY-14)
          (PAIN ANGINA-15)
          (PAIN LACERATION-16)
          (PAIN DREAD-5)
          (PAIN ABRASION-13)
          (PAIN DREAD-10)
          (PAIN BOILS-11)
          (PAIN JEALOUSY-12)
          (PROVINCE GUANABARA)
          (PROVINCE ALSACE)
          (PROVINCE GOIAS)
          (PLANET URANUS)
          (PLANET MARS)
          (PLANET NEPTUNE)
          (PLANET MERCURY)
          (CRAVES DEPRESSION-1 LEMON)
          (EATS CHOCOLATE CANTELOPE)
          (EATS LEMON SCALLOP)
          (LOCALE SNICKERS GUANABARA)
          (LOCALE SCALLION ALSACE)
          (EATS LEMON CHOCOLATE)
          (LOCALE LETTUCE ALSACE)
          (EATS CHOCOLATE LETTUCE)
          (CRAVES PROSTATITIS-8 CHOCOLATE)
          (EATS SCALLION HAROSET)
          (ORBITS MARS NEPTUNE)
          (CRAVES JEALOUSY SNICKERS)
          (EATS CANTELOPE SHRIMP)
          (CRAVES ANGER-7 KALE)
          (CRAVES ACHIEVEMENT SNICKERS)
          (CRAVES HANGOVER-4 CHOCOLATE)
          (CRAVES DREAD-5 PISTACHIO)
          (CRAVES ANGINA-15 PISTACHIO)
          (EATS CHOCOLATE SCALLION)
          (CRAVES HANGOVER SCALLION)
          (CRAVES BOILS SNICKERS)
          (EATS PISTACHIO CHOCOLATE)
          (EATS SCALLOP MELON)
          (CRAVES JEALOUSY-12 SHRIMP)
          (EATS SCALLOP HAROSET)
          (LOCALE KALE GOIAS)
          (CRAVES SATIETY LETTUCE)
          (CRAVES LACERATION SCALLION)
          (EATS HOTDOG SNICKERS)
          (CRAVES DREAD-10 SHRIMP)
          (EATS CHOCOLATE LEMON)
          (CRAVES ABRASION-13 CANTELOPE)
          (CRAVES GRIEF-2 SNICKERS)
          (EATS CANTELOPE PISTACHIO)
          (EATS KALE LEMON)
          (LOCALE HAROSET GOIAS)
          (EATS HOTDOG SCALLION)
          (CRAVES ANXIETY SCALLOP)
          (EATS SNICKERS MELON)
          (LOCALE MELON GOIAS)
          (EATS MELON SNICKERS)
          (HARMONY UNDERSTANDING MERCURY)
          (HARMONY SATIETY MARS)
          (LOCALE LEMON ALSACE)
          (CRAVES LONELINESS-3 CHOCOLATE)
          (CRAVES ANXIETY-14 PISTACHIO)
          (CRAVES BOILS-11 SHRIMP)
          (EATS LETTUCE CHOCOLATE)
          (CRAVES PROSTATITIS HAROSET)
          (EATS KALE LETTUCE)
          (HARMONY INTOXICATION NEPTUNE)
          (EATS MELON SCALLOP)
          (EATS PISTACHIO CANTELOPE)
          (CRAVES DREAD MELON)
          (LOCALE PISTACHIO ALSACE)
          (EATS SHRIMP LETTUCE)
          (EATS LETTUCE KALE)
          (EATS SHRIMP CANTELOPE)
          (CRAVES SCIATICA-6 KALE)
          (ORBITS NEPTUNE MERCURY)
          (CRAVES LONELINESS SCALLOP)
          (CRAVES UNDERSTANDING HAROSET)
          (EATS SNICKERS HOTDOG)
          (CRAVES ABRASION SNICKERS)
          (EATS CANTELOPE CHOCOLATE)
          (LOCALE SHRIMP ALSACE)
          (CRAVES GRIEF HOTDOG)
          (CRAVES ANGER HAROSET)
          (ORBITS URANUS MARS)
          (EATS LEMON KALE)
          (EATS HAROSET SCALLION)
          (CRAVES INTOXICATION CHOCOLATE)
          (CRAVES LACERATION-16 PISTACHIO)
          (ATTACKS ALSACE GOIAS)
          (LOCALE SCALLOP GOIAS)
          (CRAVES SCIATICA HOTDOG)
          (CRAVES ANGINA HAROSET)
          (EATS CHOCOLATE PISTACHIO)
          (LOCALE CHOCOLATE ALSACE)
          (LOCALE HOTDOG ALSACE)
          (CRAVES DEPRESSION MELON)
          (EATS LETTUCE SHRIMP)
          (HARMONY ACHIEVEMENT MARS)
          (EATS SCALLOP LEMON)
          (LOCALE CANTELOPE GOIAS)
          (ATTACKS GUANABARA ALSACE)
          (EATS SCALLION HOTDOG)
          (EATS SCALLION CHOCOLATE)
          (EATS HAROSET SCALLOP))
   (:GOAL (AND (CRAVES ABRASION-13 SCALLOP)
               (CRAVES JEALOUSY LEMON))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-3)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SCALLOP FLOUNDER ARUGULA KALE TOFU SCALLION YOGURT
             PAPAYA OKRA ORANGE HAM POTATO LEMON WONDERBREAD MARZIPAN
             SWEETROLL LOBSTER TUNA EXPECTATION AESTHETICS LOVE STIMULATION
             SATIETY CURIOSITY EMPATHY INTOXICATION TRIUMPH LUBRICITY
             SCIATICA LACERATION ARIZONA BAVARIA MORAVIA SURREY OREGON
             JUPITER EARTH URANUS MARS)
   (:INIT (FOOD SCALLOP)
          (FOOD FLOUNDER)
          (FOOD ARUGULA)
          (FOOD KALE)
          (FOOD TOFU)
          (FOOD SCALLION)
          (FOOD YOGURT)
          (FOOD PAPAYA)
          (FOOD OKRA)
          (FOOD ORANGE)
          (FOOD HAM)
          (FOOD POTATO)
          (FOOD LEMON)
          (FOOD WONDERBREAD)
          (FOOD MARZIPAN)
          (FOOD SWEETROLL)
          (FOOD LOBSTER)
          (FOOD TUNA)
          (PLEASURE EXPECTATION)
          (PLEASURE AESTHETICS)
          (PLEASURE LOVE)
          (PLEASURE STIMULATION)
          (PLEASURE SATIETY)
          (PLEASURE CURIOSITY)
          (PLEASURE EMPATHY)
          (PLEASURE INTOXICATION)
          (PLEASURE TRIUMPH)
          (PLEASURE LUBRICITY)
          (PAIN SCIATICA)
          (PAIN LACERATION)
          (PROVINCE ARIZONA)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PROVINCE SURREY)
          (PROVINCE OREGON)
          (PLANET JUPITER)
          (PLANET EARTH)
          (PLANET URANUS)
          (PLANET MARS)
          (EATS FLOUNDER ARUGULA)
          (HARMONY SATIETY EARTH)
          (CRAVES LUBRICITY WONDERBREAD)
          (CRAVES EMPATHY ORANGE)
          (EATS SCALLOP KALE)
          (ORBITS URANUS MARS)
          (HARMONY LUBRICITY URANUS)
          (EATS MARZIPAN YOGURT)
          (EATS YOGURT MARZIPAN)
          (EATS HAM LOBSTER)
          (EATS FLOUNDER SCALLOP)
          (LOCALE PAPAYA BAVARIA)
          (LOCALE OKRA ARIZONA)
          (EATS KALE SCALLOP)
          (EATS WONDERBREAD HAM)
          (EATS SWEETROLL MARZIPAN)
          (LOCALE SCALLOP MORAVIA)
          (ORBITS EARTH URANUS)
          (EATS SCALLION OKRA)
          (LOCALE WONDERBREAD ARIZONA)
          (EATS LEMON POTATO)
          (EATS WONDERBREAD TUNA)
          (LOCALE HAM BAVARIA)
          (CRAVES TRIUMPH POTATO)
          (EATS SCALLION TOFU)
          (EATS LOBSTER SWEETROLL)
          (LOCALE YOGURT MORAVIA)
          (EATS LEMON SWEETROLL)
          (CRAVES INTOXICATION HAM)
          (EATS SWEETROLL POTATO)
          (EATS TOFU SCALLION)
          (EATS YOGURT OKRA)
          (CRAVES EXPECTATION FLOUNDER)
          (LOCALE POTATO OREGON)
          (CRAVES CURIOSITY OKRA)
          (EATS PAPAYA ARUGULA)
          (EATS OKRA PAPAYA)
          (EATS TUNA MARZIPAN)
          (LOCALE ARUGULA OREGON)
          (HARMONY EMPATHY MARS)
          (HARMONY INTOXICATION MARS)
          (EATS TOFU ORANGE)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES AESTHETICS ARUGULA)
          (LOCALE ORANGE SURREY)
          (LOCALE MARZIPAN OREGON)
          (EATS MARZIPAN SWEETROLL)
          (LOCALE FLOUNDER MORAVIA)
          (LOCALE KALE SURREY)
          (EATS ARUGULA PAPAYA)
          (ATTACKS ARIZONA BAVARIA)
          (EATS ORANGE YOGURT)
          (HARMONY AESTHETICS URANUS)
          (LOCALE LOBSTER SURREY)
          (EATS PAPAYA YOGURT)
          (LOCALE TUNA BAVARIA)
          (EATS YOGURT SCALLION)
          (HARMONY STIMULATION URANUS)
          (EATS PAPAYA OKRA)
          (EATS LOBSTER LEMON)
          (CRAVES STIMULATION SCALLION)
          (EATS LEMON TUNA)
          (EATS YOGURT PAPAYA)
          (HARMONY LOVE URANUS)
          (EATS TUNA WONDERBREAD)
          (CRAVES SATIETY YOGURT)
          (CRAVES SCIATICA POTATO)
          (EATS SWEETROLL LOBSTER)
          (CRAVES LOVE TOFU)
          (EATS YOGURT ORANGE)
          (LOCALE SWEETROLL SURREY)
          (ORBITS JUPITER EARTH)
          (CRAVES LACERATION LEMON)
          (LOCALE LEMON ARIZONA)
          (EATS MARZIPAN TUNA)
          (EATS OKRA SCALLION)
          (HARMONY EXPECTATION MARS)
          (ATTACKS SURREY OREGON)
          (HARMONY TRIUMPH URANUS)
          (EATS POTATO LEMON)
          (EATS OKRA YOGURT)
          (EATS LEMON LOBSTER)
          (EATS ARUGULA FLOUNDER)
          (LOCALE SCALLION ARIZONA)
          (EATS SCALLOP FLOUNDER)
          (EATS ORANGE TOFU)
          (EATS KALE ARUGULA)
          (EATS SWEETROLL LEMON)
          (EATS SCALLION YOGURT)
          (EATS ARUGULA KALE)
          (EATS POTATO MARZIPAN)
          (EATS TUNA LEMON)
          (HARMONY CURIOSITY EARTH)
          (EATS MARZIPAN POTATO)
          (ATTACKS MORAVIA SURREY)
          (EATS POTATO SWEETROLL)
          (EATS HAM WONDERBREAD)
          (EATS LOBSTER HAM)
          (LOCALE TOFU SURREY))
   (:GOAL (AND (CRAVES SCIATICA PAPAYA))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-4)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS WONDERBREAD KALE HOTDOG PORK SNICKERS MUTTON GUAVA
             POPOVER WURST SHRIMP EXCITEMENT TRIUMPH PROSTATITIS ANGER
             GRIEF LONELINESS ANGINA BOILS JEALOUSY HANGOVER
             PENNSYLVANIA BOSNIA KENTUCKY ARIZONA GOIAS SATURN MERCURY VENUS
             VULCAN)
   (:INIT (FOOD WONDERBREAD)
          (FOOD KALE)
          (FOOD HOTDOG)
          (FOOD PORK)
          (FOOD SNICKERS)
          (FOOD MUTTON)
          (FOOD GUAVA)
          (FOOD POPOVER)
          (FOOD WURST)
          (FOOD SHRIMP)
          (PLEASURE EXCITEMENT)
          (PLEASURE TRIUMPH)
          (PAIN PROSTATITIS)
          (PAIN ANGER)
          (PAIN GRIEF)
          (PAIN LONELINESS)
          (PAIN ANGINA)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN HANGOVER)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BOSNIA)
          (PROVINCE KENTUCKY)
          (PROVINCE ARIZONA)
          (PROVINCE GOIAS)
          (PLANET SATURN)
          (PLANET MERCURY)
          (PLANET VENUS)
          (PLANET VULCAN)
          (LOCALE PORK GOIAS)
          (EATS MUTTON WURST)
          (LOCALE SNICKERS KENTUCKY)
          (CRAVES GRIEF PORK)
          (CRAVES BOILS MUTTON)
          (EATS WURST MUTTON)
          (EATS SHRIMP GUAVA)
          (EATS SNICKERS GUAVA)
          (EATS POPOVER KALE)
          (EATS KALE POPOVER)
          (CRAVES EXCITEMENT WONDERBREAD)
          (EATS KALE PORK)
          (CRAVES ANGINA MUTTON)
          (ATTACKS PENNSYLVANIA BOSNIA)
          (EATS SNICKERS POPOVER)
          (CRAVES PROSTATITIS PORK)
          (EATS WURST HOTDOG)
          (ORBITS MERCURY VENUS)
          (CRAVES LONELINESS MUTTON)
          (LOCALE MUTTON ARIZONA)
          (EATS PORK WONDERBREAD)
          (EATS HOTDOG WURST)
          (EATS SHRIMP MUTTON)
          (HARMONY EXCITEMENT MERCURY)
          (ATTACKS BOSNIA KENTUCKY)
          (HARMONY TRIUMPH VULCAN)
          (ATTACKS KENTUCKY ARIZONA)
          (EATS POPOVER HOTDOG)
          (ATTACKS ARIZONA GOIAS)
          (CRAVES HANGOVER WURST)
          (LOCALE POPOVER PENNSYLVANIA)
          (CRAVES TRIUMPH POPOVER)
          (EATS WONDERBREAD SHRIMP)
          (EATS POPOVER SNICKERS)
          (EATS HOTDOG POPOVER)
          (LOCALE HOTDOG PENNSYLVANIA)
          (EATS SHRIMP WONDERBREAD)
          (CRAVES JEALOUSY WURST)
          (ORBITS VENUS VULCAN)
          (EATS PORK KALE)
          (EATS GUAVA SHRIMP)
          (ORBITS SATURN MERCURY)
          (LOCALE SHRIMP BOSNIA)
          (LOCALE WONDERBREAD ARIZONA)
          (LOCALE GUAVA PENNSYLVANIA)
          (EATS MUTTON SHRIMP)
          (CRAVES ANGER PORK)
          (LOCALE WURST PENNSYLVANIA)
          (EATS WONDERBREAD PORK)
          (LOCALE KALE ARIZONA)
          (EATS GUAVA SNICKERS))
   (:GOAL (AND (CRAVES ANGER SNICKERS))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-5)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SCALLOP PEA HOTDOG CANTELOPE CHICKEN ORANGE TOFU ONION
             SNICKERS COD LAMB BAGUETTE HAROSET ENTERTAINMENT EXCITEMENT
             LOVE HANGOVER ANGINA SCIATICA PROSTATITIS LONELINESS
             BOSNIA BAVARIA GOIAS VENUS NEPTUNE URANUS MARS)
   (:INIT (FOOD SCALLOP)
          (FOOD PEA)
          (FOOD HOTDOG)
          (FOOD CANTELOPE)
          (FOOD CHICKEN)
          (FOOD ORANGE)
          (FOOD TOFU)
          (FOOD ONION)
          (FOOD SNICKERS)
          (FOOD COD)
          (FOOD LAMB)
          (FOOD BAGUETTE)
          (FOOD HAROSET)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE EXCITEMENT)
          (PLEASURE LOVE)
          (PAIN HANGOVER)
          (PAIN ANGINA)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS)
          (PAIN LONELINESS)
          (PROVINCE BOSNIA)
          (PROVINCE BAVARIA)
          (PROVINCE GOIAS)
          (PLANET VENUS)
          (PLANET NEPTUNE)
          (PLANET URANUS)
          (PLANET MARS)
          (LOCALE SNICKERS GOIAS)
          (EATS PEA ORANGE)
          (EATS SCALLOP PEA)
          (ORBITS VENUS NEPTUNE)
          (EATS ORANGE HOTDOG)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS LAMB BAGUETTE)
          (EATS CHICKEN CANTELOPE)
          (EATS CHICKEN SCALLOP)
          (HARMONY LOVE MARS)
          (EATS BAGUETTE CANTELOPE)
          (EATS ORANGE PEA)
          (LOCALE PEA GOIAS)
          (LOCALE TOFU BOSNIA)
          (LOCALE HOTDOG BAVARIA)
          (CRAVES PROSTATITIS SNICKERS)
          (EATS TOFU LAMB)
          (ATTACKS BAVARIA GOIAS)
          (EATS CANTELOPE BAGUETTE)
          (LOCALE BAGUETTE BAVARIA)
          (CRAVES HANGOVER CHICKEN)
          (LOCALE ONION GOIAS)
          (EATS BAGUETTE ONION)
          (EATS HAROSET COD)
          (EATS PEA SCALLOP)
          (CRAVES LOVE TOFU)
          (HARMONY EXCITEMENT MARS)
          (LOCALE HAROSET BAVARIA)
          (LOCALE CANTELOPE BOSNIA)
          (LOCALE CHICKEN BAVARIA)
          (CRAVES LONELINESS LAMB)
          (LOCALE COD BAVARIA)
          (LOCALE ORANGE BOSNIA)
          (EATS COD SNICKERS)
          (EATS SNICKERS TOFU)
          (EATS BAGUETTE LAMB)
          (EATS SNICKERS COD)
          (EATS HAROSET ONION)
          (EATS ONION HAROSET)
          (ATTACKS BOSNIA BAVARIA)
          (ORBITS URANUS MARS)
          (EATS SCALLOP CHICKEN)
          (EATS CANTELOPE HOTDOG)
          (EATS HOTDOG CANTELOPE)
          (EATS HOTDOG ORANGE)
          (CRAVES ANGINA TOFU)
          (EATS ONION BAGUETTE)
          (EATS LAMB TOFU)
          (EATS COD HAROSET)
          (CRAVES ENTERTAINMENT SCALLOP)
          (EATS CANTELOPE CHICKEN)
          (LOCALE SCALLOP BOSNIA)
          (LOCALE LAMB GOIAS)
          (CRAVES SCIATICA ONION)
          (CRAVES EXCITEMENT HOTDOG)
          (EATS TOFU SNICKERS)
          (ORBITS NEPTUNE URANUS))
   (:GOAL (AND (CRAVES LONELINESS ONION))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-6)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS ONION FLOUNDER MUTTON TURKEY BAGUETTE CHOCOLATE MUFFIN
             PEAR CUCUMBER OKRA ENDIVE WONDERBREAD GRAPEFRUIT SHRIMP
             HAROSET BEEF ORANGE CURIOSITY STIMULATION EXPECTATION
             LEARNING LUBRICITY ENTERTAINMENT SATISFACTION UNDERSTANDING
             LOVE HANGOVER GRIEF DEPRESSION ANGER ABRASION ANGINA
             PROSTATITIS LACERATION DREAD ARIZONA PENNSYLVANIA BAVARIA JUPITER
             VULCAN EARTH MARS)
   (:INIT (FOOD ONION)
          (FOOD FLOUNDER)
          (FOOD MUTTON)
          (FOOD TURKEY)
          (FOOD BAGUETTE)
          (FOOD CHOCOLATE)
          (FOOD MUFFIN)
          (FOOD PEAR)
          (FOOD CUCUMBER)
          (FOOD OKRA)
          (FOOD ENDIVE)
          (FOOD WONDERBREAD)
          (FOOD GRAPEFRUIT)
          (FOOD SHRIMP)
          (FOOD HAROSET)
          (FOOD BEEF)
          (FOOD ORANGE)
          (PLEASURE CURIOSITY)
          (PLEASURE STIMULATION)
          (PLEASURE EXPECTATION)
          (PLEASURE LEARNING)
          (PLEASURE LUBRICITY)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE SATISFACTION)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LOVE)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN ANGER)
          (PAIN ABRASION)
          (PAIN ANGINA)
          (PAIN PROSTATITIS)
          (PAIN LACERATION)
          (PAIN DREAD)
          (PROVINCE ARIZONA)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PLANET JUPITER)
          (PLANET VULCAN)
          (PLANET EARTH)
          (PLANET MARS)
          (LOCALE FLOUNDER PENNSYLVANIA)
          (CRAVES ANGINA OKRA)
          (EATS ENDIVE SHRIMP)
          (EATS MUFFIN CHOCOLATE)
          (LOCALE SHRIMP PENNSYLVANIA)
          (EATS WONDERBREAD ENDIVE)
          (CRAVES DEPRESSION CHOCOLATE)
          (CRAVES PROSTATITIS ENDIVE)
          (EATS TURKEY MUTTON)
          (HARMONY LEARNING MARS)
          (EATS ORANGE SHRIMP)
          (EATS BAGUETTE CUCUMBER)
          (ATTACKS ARIZONA PENNSYLVANIA)
          (EATS OKRA MUFFIN)
          (CRAVES SATISFACTION WONDERBREAD)
          (ORBITS JUPITER VULCAN)
          (EATS WONDERBREAD ORANGE)
          (EATS HAROSET BEEF)
          (CRAVES EXPECTATION TURKEY)
          (EATS CHOCOLATE GRAPEFRUIT)
          (EATS MUTTON FLOUNDER)
          (LOCALE GRAPEFRUIT ARIZONA)
          (EATS SHRIMP ORANGE)
          (EATS ENDIVE GRAPEFRUIT)
          (CRAVES GRIEF TURKEY)
          (CRAVES ANGER PEAR)
          (LOCALE TURKEY ARIZONA)
          (EATS PEAR CHOCOLATE)
          (EATS CUCUMBER PEAR)
          (EATS PEAR CUCUMBER)
          (CRAVES UNDERSTANDING HAROSET)
          (EATS ONION TURKEY)
          (EATS BEEF HAROSET)
          (LOCALE HAROSET PENNSYLVANIA)
          (EATS ORANGE WONDERBREAD)
          (EATS WONDERBREAD BEEF)
          (EATS CHOCOLATE PEAR)
          (HARMONY SATISFACTION MARS)
          (EATS BEEF WONDERBREAD)
          (CRAVES DREAD HAROSET)
          (LOCALE MUTTON BAVARIA)
          (EATS FLOUNDER MUTTON)
          (EATS GRAPEFRUIT CHOCOLATE)
          (LOCALE MUFFIN BAVARIA)
          (EATS OKRA BAGUETTE)
          (EATS GRAPEFRUIT ENDIVE)
          (EATS ENDIVE WONDERBREAD)
          (LOCALE OKRA PENNSYLVANIA)
          (LOCALE ENDIVE ARIZONA)
          (EATS BAGUETTE OKRA)
          (HARMONY CURIOSITY VULCAN)
          (LOCALE CHOCOLATE ARIZONA)
          (CRAVES LEARNING BAGUETTE)
          (EATS FLOUNDER ONION)
          (HARMONY STIMULATION MARS)
          (LOCALE WONDERBREAD BAVARIA)
          (EATS CHOCOLATE MUFFIN)
          (EATS SHRIMP GRAPEFRUIT)
          (EATS SHRIMP WONDERBREAD)
          (EATS BAGUETTE MUTTON)
          (CRAVES LUBRICITY CHOCOLATE)
          (LOCALE ORANGE BAVARIA)
          (CRAVES ABRASION CUCUMBER)
          (EATS WONDERBREAD SHRIMP)
          (ORBITS VULCAN EARTH)
          (HARMONY EXPECTATION EARTH)
          (EATS ONION FLOUNDER)
          (LOCALE CUCUMBER ARIZONA)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (HARMONY ENTERTAINMENT VULCAN)
          (EATS MUTTON BAGUETTE)
          (CRAVES LOVE ORANGE)
          (HARMONY UNDERSTANDING VULCAN)
          (CRAVES CURIOSITY ONION)
          (HARMONY LUBRICITY VULCAN)
          (ORBITS EARTH MARS)
          (EATS HAROSET GRAPEFRUIT)
          (EATS TURKEY ONION)
          (EATS MUTTON TURKEY)
          (LOCALE BAGUETTE PENNSYLVANIA)
          (HARMONY LOVE EARTH)
          (LOCALE PEAR BAVARIA)
          (LOCALE BEEF PENNSYLVANIA)
          (EATS GRAPEFRUIT SHRIMP)
          (CRAVES ENTERTAINMENT MUFFIN)
          (CRAVES STIMULATION MUTTON)
          (CRAVES HANGOVER MUTTON)
          (LOCALE ONION ARIZONA)
          (EATS CUCUMBER BAGUETTE)
          (EATS MUFFIN OKRA)
          (CRAVES LACERATION SHRIMP)
          (EATS SHRIMP ENDIVE)
          (EATS GRAPEFRUIT HAROSET))
   (:GOAL (AND (CRAVES ANGER SHRIMP))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-7)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS BAGUETTE LETTUCE SWEETROLL SNICKERS WURST SCALLOP BEEF
             GRAPEFRUIT HOTDOG ONION TOFU ENDIVE CHICKEN KALE TOMATO TUNA
             CUCUMBER HAMBURGER SHRIMP LOBSTER EXPECTATION CURIOSITY
             SATISFACTION ACHIEVEMENT STIMULATION LONELINESS LACERATION GRIEF
             HANGOVER ANGER ANGINA GUANABARA MANITOBA BAVARIA JUPITER VULCAN
             EARTH URANUS)
   (:INIT (FOOD BAGUETTE)
          (FOOD LETTUCE)
          (FOOD SWEETROLL)
          (FOOD SNICKERS)
          (FOOD WURST)
          (FOOD SCALLOP)
          (FOOD BEEF)
          (FOOD GRAPEFRUIT)
          (FOOD HOTDOG)
          (FOOD ONION)
          (FOOD TOFU)
          (FOOD ENDIVE)
          (FOOD CHICKEN)
          (FOOD KALE)
          (FOOD TOMATO)
          (FOOD TUNA)
          (FOOD CUCUMBER)
          (FOOD HAMBURGER)
          (FOOD SHRIMP)
          (FOOD LOBSTER)
          (PLEASURE EXPECTATION)
          (PLEASURE CURIOSITY)
          (PLEASURE SATISFACTION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE STIMULATION)
          (PAIN LONELINESS)
          (PAIN LACERATION)
          (PAIN GRIEF)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN ANGINA)
          (PROVINCE GUANABARA)
          (PROVINCE MANITOBA)
          (PROVINCE BAVARIA)
          (PLANET JUPITER)
          (PLANET VULCAN)
          (PLANET EARTH)
          (PLANET URANUS)
          (LOCALE HOTDOG GUANABARA)
          (LOCALE LETTUCE BAVARIA)
          (EATS WURST BAGUETTE)
          (EATS SNICKERS BAGUETTE)
          (EATS TOMATO TUNA)
          (LOCALE ENDIVE MANITOBA)
          (HARMONY ACHIEVEMENT EARTH)
          (EATS SWEETROLL LETTUCE)
          (CRAVES LONELINESS BEEF)
          (CRAVES ANGINA KALE)
          (EATS ONION TOFU)
          (CRAVES ANGER KALE)
          (LOCALE TOMATO GUANABARA)
          (EATS HOTDOG GRAPEFRUIT)
          (EATS SHRIMP TOMATO)
          (EATS TUNA TOMATO)
          (EATS LETTUCE SWEETROLL)
          (EATS KALE CUCUMBER)
          (EATS TUNA SHRIMP)
          (EATS SWEETROLL SNICKERS)
          (LOCALE TUNA MANITOBA)
          (ATTACKS GUANABARA MANITOBA)
          (LOCALE BAGUETTE GUANABARA)
          (EATS HAMBURGER KALE)
          (LOCALE BEEF BAVARIA)
          (EATS TUNA CHICKEN)
          (EATS LETTUCE KALE)
          (LOCALE ONION GUANABARA)
          (LOCALE LOBSTER BAVARIA)
          (EATS CHICKEN TUNA)
          (EATS LOBSTER CUCUMBER)
          (EATS TOFU ONION)
          (EATS CUCUMBER LOBSTER)
          (LOCALE CUCUMBER MANITOBA)
          (HARMONY CURIOSITY EARTH)
          (EATS KALE LETTUCE)
          (EATS TUNA BEEF)
          (EATS SCALLOP ENDIVE)
          (EATS SCALLOP HOTDOG)
          (ORBITS EARTH URANUS)
          (LOCALE HAMBURGER MANITOBA)
          (ORBITS JUPITER VULCAN)
          (EATS ONION GRAPEFRUIT)
          (EATS HOTDOG SCALLOP)
          (EATS GRAPEFRUIT ONION)
          (EATS WURST LETTUCE)
          (HARMONY STIMULATION URANUS)
          (EATS BEEF TUNA)
          (EATS TOMATO SHRIMP)
          (EATS HAMBURGER TUNA)
          (LOCALE SCALLOP GUANABARA)
          (EATS ENDIVE BEEF)
          (LOCALE SNICKERS MANITOBA)
          (EATS TOMATO HAMBURGER)
          (EATS TUNA HAMBURGER)
          (EATS HAMBURGER TOMATO)
          (EATS BEEF ENDIVE)
          (CRAVES CURIOSITY CHICKEN)
          (CRAVES ACHIEVEMENT TUNA)
          (EATS SNICKERS SWEETROLL)
          (CRAVES SATISFACTION KALE)
          (ATTACKS MANITOBA BAVARIA)
          (EATS BAGUETTE SNICKERS)
          (CRAVES EXPECTATION SNICKERS)
          (LOCALE SWEETROLL BAVARIA)
          (EATS ENDIVE SCALLOP)
          (EATS GRAPEFRUIT HOTDOG)
          (CRAVES LACERATION BEEF)
          (CRAVES HANGOVER TOFU)
          (LOCALE KALE GUANABARA)
          (CRAVES STIMULATION CUCUMBER)
          (EATS SWEETROLL BEEF)
          (EATS TOFU BEEF)
          (EATS BEEF SWEETROLL)
          (EATS KALE HAMBURGER)
          (HARMONY EXPECTATION URANUS)
          (ORBITS VULCAN EARTH)
          (LOCALE SHRIMP GUANABARA)
          (CRAVES GRIEF BEEF)
          (EATS BEEF TOFU)
          (LOCALE CHICKEN GUANABARA)
          (HARMONY SATISFACTION VULCAN)
          (EATS LETTUCE WURST)
          (LOCALE TOFU GUANABARA)
          (EATS CUCUMBER KALE)
          (LOCALE WURST GUANABARA)
          (EATS SHRIMP TUNA)
          (EATS LOBSTER CHICKEN)
          (EATS BAGUETTE WURST)
          (EATS CHICKEN LOBSTER)
          (LOCALE GRAPEFRUIT GUANABARA))
   (:GOAL (AND (CRAVES HANGOVER CUCUMBER))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-8)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SHRIMP HAM SCALLION RICE HOTDOG YOGURT CHICKEN KALE
             SNICKERS ENTERTAINMENT AESTHETICS STIMULATION GRIEF
             LACERATION SCIATICA LONELINESS PROSTATITIS ANGER ANGINA
             GUANABARA KENTUCKY BAVARIA BOSNIA JUPITER SATURN)
   (:INIT (FOOD SHRIMP)
          (FOOD HAM)
          (FOOD SCALLION)
          (FOOD RICE)
          (FOOD HOTDOG)
          (FOOD YOGURT)
          (FOOD CHICKEN)
          (FOOD KALE)
          (FOOD SNICKERS)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE AESTHETICS)
          (PLEASURE STIMULATION)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN SCIATICA)
          (PAIN LONELINESS)
          (PAIN PROSTATITIS)
          (PAIN ANGER)
          (PAIN ANGINA)
          (PROVINCE GUANABARA)
          (PROVINCE KENTUCKY)
          (PROVINCE BAVARIA)
          (PROVINCE BOSNIA)
          (PLANET JUPITER)
          (PLANET SATURN)
          (EATS SCALLION RICE)
          (EATS KALE SNICKERS)
          (LOCALE RICE BOSNIA)
          (CRAVES ENTERTAINMENT HAM)
          (EATS RICE SCALLION)
          (EATS KALE CHICKEN)
          (CRAVES AESTHETICS SCALLION)
          (HARMONY AESTHETICS SATURN)
          (EATS SNICKERS HAM)
          (CRAVES GRIEF SHRIMP)
          (ORBITS JUPITER SATURN)
          (CRAVES SCIATICA HOTDOG)
          (CRAVES ANGINA SNICKERS)
          (EATS KALE YOGURT)
          (EATS HAM SCALLION)
          (LOCALE SCALLION BOSNIA)
          (EATS SHRIMP HAM)
          (CRAVES LACERATION SCALLION)
          (EATS SHRIMP RICE)
          (CRAVES PROSTATITIS CHICKEN)
          (EATS SNICKERS KALE)
          (ATTACKS KENTUCKY BAVARIA)
          (EATS RICE SHRIMP)
          (EATS SNICKERS HOTDOG)
          (EATS CHICKEN YOGURT)
          (LOCALE HOTDOG BOSNIA)
          (HARMONY ENTERTAINMENT SATURN)
          (EATS YOGURT CHICKEN)
          (LOCALE YOGURT BOSNIA)
          (LOCALE CHICKEN BAVARIA)
          (EATS HAM RICE)
          (HARMONY STIMULATION SATURN)
          (EATS YOGURT HOTDOG)
          (EATS RICE HAM)
          (EATS HAM SNICKERS)
          (EATS HAM SHRIMP)
          (CRAVES STIMULATION SNICKERS)
          (ATTACKS BAVARIA BOSNIA)
          (EATS SCALLION HAM)
          (EATS YOGURT KALE)
          (LOCALE KALE KENTUCKY)
          (CRAVES LONELINESS YOGURT)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS CHICKEN KALE)
          (CRAVES ANGER KALE)
          (LOCALE SHRIMP BAVARIA)
          (EATS KALE HOTDOG)
          (EATS HOTDOG KALE)
          (LOCALE SNICKERS GUANABARA)
          (EATS HOTDOG SNICKERS)
          (LOCALE HAM BOSNIA)
          (EATS HOTDOG YOGURT))
   (:GOAL (AND (CRAVES LACERATION KALE))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-9)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS COD YOGURT SCALLION CHICKEN WONDERBREAD PAPAYA TOFU
             CUCUMBER HOTDOG PORK BAGUETTE TUNA SNICKERS POTATO SHRIMP HAM
             LAMB EXCITEMENT STIMULATION LUBRICITY LONELINESS ANGER
             GRIEF DREAD PROSTATITIS DEPRESSION ANGINA HANGOVER BOILS
             ANXIETY SCIATICA JEALOUSY LACERATION JEALOUSY-2 ABRASION
             BOILS-1 GOIAS OREGON MORAVIA PENNSYLVANIA JUPITER VENUS
             NEPTUNE MARS)
   (:INIT (FOOD COD)
          (FOOD YOGURT)
          (FOOD SCALLION)
          (FOOD CHICKEN)
          (FOOD WONDERBREAD)
          (FOOD PAPAYA)
          (FOOD TOFU)
          (FOOD CUCUMBER)
          (FOOD HOTDOG)
          (FOOD PORK)
          (FOOD BAGUETTE)
          (FOOD TUNA)
          (FOOD SNICKERS)
          (FOOD POTATO)
          (FOOD SHRIMP)
          (FOOD HAM)
          (FOOD LAMB)
          (PLEASURE EXCITEMENT)
          (PLEASURE STIMULATION)
          (PLEASURE LUBRICITY)
          (PAIN LONELINESS)
          (PAIN ANGER)
          (PAIN GRIEF)
          (PAIN DREAD)
          (PAIN PROSTATITIS)
          (PAIN DEPRESSION)
          (PAIN ANGINA)
          (PAIN HANGOVER)
          (PAIN BOILS)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN JEALOUSY)
          (PAIN LACERATION)
          (PAIN JEALOUSY-2)
          (PAIN ABRASION)
          (PAIN BOILS-1)
          (PROVINCE GOIAS)
          (PROVINCE OREGON)
          (PROVINCE MORAVIA)
          (PROVINCE PENNSYLVANIA)
          (PLANET JUPITER)
          (PLANET VENUS)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (LOCALE PORK MORAVIA)
          (LOCALE PAPAYA GOIAS)
          (EATS WONDERBREAD COD)
          (LOCALE CUCUMBER PENNSYLVANIA)
          (CRAVES ANXIETY TOFU)
          (EATS COD WONDERBREAD)
          (EATS SNICKERS SHRIMP)
          (EATS POTATO LAMB)
          (CRAVES DEPRESSION YOGURT)
          (CRAVES GRIEF COD)
          (EATS TUNA SNICKERS)
          (CRAVES EXCITEMENT SCALLION)
          (EATS HAM SNICKERS)
          (EATS TUNA PORK)
          (LOCALE LAMB PENNSYLVANIA)
          (LOCALE HOTDOG MORAVIA)
          (EATS PAPAYA TOFU)
          (EATS CUCUMBER COD)
          (LOCALE HAM OREGON)
          (CRAVES ANGER COD)
          (LOCALE POTATO OREGON)
          (EATS WONDERBREAD YOGURT)
          (EATS SCALLION YOGURT)
          (CRAVES BOILS TOFU)
          (EATS LAMB POTATO)
          (EATS PORK TUNA)
          (EATS HAM PORK)
          (CRAVES ANGINA WONDERBREAD)
          (LOCALE BAGUETTE OREGON)
          (CRAVES BOILS-1 POTATO)
          (LOCALE COD OREGON)
          (CRAVES JEALOUSY CUCUMBER)
          (EATS COD CUCUMBER)
          (ATTACKS OREGON MORAVIA)
          (EATS SNICKERS HAM)
          (EATS CUCUMBER TOFU)
          (EATS SHRIMP SNICKERS)
          (EATS CHICKEN SCALLION)
          (CRAVES ABRASION BAGUETTE)
          (LOCALE TUNA MORAVIA)
          (EATS HOTDOG LAMB)
          (EATS BAGUETTE SHRIMP)
          (EATS HOTDOG CUCUMBER)
          (EATS HAM LAMB)
          (EATS YOGURT WONDERBREAD)
          (EATS CHICKEN COD)
          (LOCALE CHICKEN GOIAS)
          (EATS TUNA SHRIMP)
          (EATS CUCUMBER HOTDOG)
          (LOCALE YOGURT OREGON)
          (EATS LAMB HOTDOG)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS SHRIMP BAGUETTE)
          (EATS LAMB TUNA)
          (CRAVES LACERATION PORK)
          (ORBITS JUPITER VENUS)
          (LOCALE TOFU MORAVIA)
          (EATS PAPAYA HOTDOG)
          (ORBITS VENUS NEPTUNE)
          (EATS LAMB HAM)
          (LOCALE WONDERBREAD MORAVIA)
          (CRAVES STIMULATION PORK)
          (CRAVES LUBRICITY HAM)
          (CRAVES LONELINESS COD)
          (CRAVES PROSTATITIS YOGURT)
          (EATS TOFU PAPAYA)
          (EATS YOGURT SCALLION)
          (CRAVES SCIATICA CUCUMBER)
          (ORBITS NEPTUNE MARS)
          (EATS POTATO BAGUETTE)
          (CRAVES JEALOUSY-2 BAGUETTE)
          (EATS TUNA LAMB)
          (EATS SCALLION CHICKEN)
          (EATS PORK HAM)
          (EATS TOFU CUCUMBER)
          (ATTACKS GOIAS OREGON)
          (EATS BAGUETTE POTATO)
          (EATS HOTDOG PAPAYA)
          (LOCALE SCALLION GOIAS)
          (CRAVES HANGOVER PAPAYA)
          (HARMONY LUBRICITY NEPTUNE)
          (HARMONY STIMULATION MARS)
          (LOCALE SHRIMP OREGON)
          (EATS COD CHICKEN)
          (LOCALE SNICKERS PENNSYLVANIA)
          (ATTACKS MORAVIA PENNSYLVANIA)
          (CRAVES DREAD YOGURT)
          (EATS SNICKERS TUNA)
          (EATS SHRIMP TUNA))
   (:GOAL (AND (CRAVES DEPRESSION CUCUMBER))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-10)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LEMON YOGURT OKRA CHOCOLATE LEARNING CURIOSITY LOVE
             ANXIETY DREAD SCIATICA LONELINESS BOILS GRIEF ANGINA ABRASION
             BAVARIA QUEBEC SATURN MERCURY JUPITER VULCAN)
   (:INIT (FOOD LEMON)
          (FOOD YOGURT)
          (FOOD OKRA)
          (FOOD CHOCOLATE)
          (PLEASURE LEARNING)
          (PLEASURE CURIOSITY)
          (PLEASURE LOVE)
          (PAIN ANXIETY)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN LONELINESS)
          (PAIN BOILS)
          (PAIN GRIEF)
          (PAIN ANGINA)
          (PAIN ABRASION)
          (PROVINCE BAVARIA)
          (PROVINCE QUEBEC)
          (PLANET SATURN)
          (PLANET MERCURY)
          (PLANET JUPITER)
          (PLANET VULCAN)
          (CRAVES CURIOSITY OKRA)
          (EATS LEMON CHOCOLATE)
          (LOCALE OKRA BAVARIA)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES LOVE CHOCOLATE)
          (EATS OKRA CHOCOLATE)
          (CRAVES ANXIETY YOGURT)
          (EATS YOGURT OKRA)
          (LOCALE LEMON QUEBEC)
          (ORBITS SATURN MERCURY)
          (ORBITS MERCURY JUPITER)
          (EATS CHOCOLATE LEMON)
          (LOCALE CHOCOLATE QUEBEC)
          (CRAVES DREAD YOGURT)
          (CRAVES BOILS YOGURT)
          (HARMONY LOVE VULCAN)
          (LOCALE YOGURT QUEBEC)
          (ATTACKS BAVARIA QUEBEC)
          (ORBITS JUPITER VULCAN)
          (CRAVES ABRASION OKRA)
          (CRAVES SCIATICA YOGURT)
          (CRAVES GRIEF OKRA)
          (EATS OKRA YOGURT)
          (EATS LEMON YOGURT)
          (HARMONY LEARNING JUPITER)
          (EATS YOGURT LEMON)
          (CRAVES ANGINA OKRA)
          (CRAVES LEARNING LEMON)
          (EATS CHOCOLATE OKRA)
          (CRAVES LONELINESS YOGURT))
   (:GOAL (AND (CRAVES BOILS CHOCOLATE))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-11)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PEPPER LAMB TOMATO OKRA REST BOILS GRIEF ABRASION
             LONELINESS DREAD JEALOUSY BAVARIA MANITOBA ALSACE NEPTUNE PLUTO
             VULCAN JUPITER)
   (:INIT (FOOD PEPPER)
          (FOOD LAMB)
          (FOOD TOMATO)
          (FOOD OKRA)
          (PLEASURE REST)
          (PAIN BOILS)
          (PAIN GRIEF)
          (PAIN ABRASION)
          (PAIN LONELINESS)
          (PAIN DREAD)
          (PAIN JEALOUSY)
          (PROVINCE BAVARIA)
          (PROVINCE MANITOBA)
          (PROVINCE ALSACE)
          (PLANET NEPTUNE)
          (PLANET PLUTO)
          (PLANET VULCAN)
          (PLANET JUPITER)
          (EATS OKRA PEPPER)
          (EATS PEPPER OKRA)
          (EATS PEPPER LAMB)
          (EATS OKRA TOMATO)
          (EATS LAMB TOMATO)
          (CRAVES LONELINESS TOMATO)
          (LOCALE LAMB BAVARIA)
          (CRAVES REST TOMATO)
          (CRAVES JEALOUSY OKRA)
          (CRAVES ABRASION TOMATO)
          (LOCALE OKRA MANITOBA)
          (ORBITS NEPTUNE PLUTO)
          (ATTACKS MANITOBA ALSACE)
          (EATS TOMATO LAMB)
          (LOCALE PEPPER ALSACE)
          (CRAVES BOILS PEPPER)
          (ORBITS PLUTO VULCAN)
          (ORBITS VULCAN JUPITER)
          (CRAVES GRIEF PEPPER)
          (HARMONY REST JUPITER)
          (ATTACKS BAVARIA MANITOBA)
          (EATS TOMATO OKRA)
          (LOCALE TOMATO MANITOBA)
          (CRAVES DREAD OKRA)
          (EATS LAMB PEPPER))
   (:GOAL (AND (CRAVES LONELINESS PEPPER)
               (CRAVES DREAD LAMB))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-12)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TURKEY PEA RICE HAM MARZIPAN SCALLOP MUTTON TOFU
             PISTACHIO SHRIMP CUCUMBER ONION FLOUNDER ACHIEVEMENT LOVE
             EXCITEMENT UNDERSTANDING LEARNING LUBRICITY INTOXICATION
             ANXIETY GRIEF DEPRESSION BOILS LACERATION DREAD JEALOUSY
             PROSTATITIS LONELINESS ANGER HANGOVER HANGOVER-2 ABRASION
             SCIATICA ANGINA ANGER-3 ANGINA-4 DREAD-1 ANXIETY-8
             LONELINESS-16 JEALOUSY-5 LACERATION-6 BOILS-7 DEPRESSION-12
             ABRASION-13 GRIEF-14 SCIATICA-15 DREAD-10 PROSTATITIS-11
             HANGOVER-31 ANGER-32 BOILS-9 GRIEF-27 JEALOUSY-28 ABRASION-29
             ANGINA-30 LONELINESS-23 PROSTATITIS-24 ANXIETY-25
             DEPRESSION-26 PENNSYLVANIA ARIZONA OREGON PLUTO MARS EARTH URANUS)
   (:INIT (FOOD TURKEY)
          (FOOD PEA)
          (FOOD RICE)
          (FOOD HAM)
          (FOOD MARZIPAN)
          (FOOD SCALLOP)
          (FOOD MUTTON)
          (FOOD TOFU)
          (FOOD PISTACHIO)
          (FOOD SHRIMP)
          (FOOD CUCUMBER)
          (FOOD ONION)
          (FOOD FLOUNDER)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LOVE)
          (PLEASURE EXCITEMENT)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LEARNING)
          (PLEASURE LUBRICITY)
          (PLEASURE INTOXICATION)
          (PAIN ANXIETY)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN BOILS)
          (PAIN LACERATION)
          (PAIN DREAD)
          (PAIN JEALOUSY)
          (PAIN PROSTATITIS)
          (PAIN LONELINESS)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PAIN HANGOVER-2)
          (PAIN ABRASION)
          (PAIN SCIATICA)
          (PAIN ANGINA)
          (PAIN ANGER-3)
          (PAIN ANGINA-4)
          (PAIN DREAD-1)
          (PAIN ANXIETY-8)
          (PAIN LONELINESS-16)
          (PAIN JEALOUSY-5)
          (PAIN LACERATION-6)
          (PAIN BOILS-7)
          (PAIN DEPRESSION-12)
          (PAIN ABRASION-13)
          (PAIN GRIEF-14)
          (PAIN SCIATICA-15)
          (PAIN DREAD-10)
          (PAIN PROSTATITIS-11)
          (PAIN HANGOVER-31)
          (PAIN ANGER-32)
          (PAIN BOILS-9)
          (PAIN GRIEF-27)
          (PAIN JEALOUSY-28)
          (PAIN ABRASION-29)
          (PAIN ANGINA-30)
          (PAIN LONELINESS-23)
          (PAIN PROSTATITIS-24)
          (PAIN ANXIETY-25)
          (PAIN DEPRESSION-26)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE ARIZONA)
          (PROVINCE OREGON)
          (PLANET PLUTO)
          (PLANET MARS)
          (PLANET EARTH)
          (PLANET URANUS)
          (CRAVES ANGER HAM)
          (CRAVES ABRASION MARZIPAN)
          (EATS TOFU ONION)
          (CRAVES UNDERSTANDING PISTACHIO)
          (CRAVES ANGER-3 SCALLOP)
          (CRAVES BOILS-7 TOFU)
          (EATS HAM SCALLOP)
          (LOCALE MUTTON PENNSYLVANIA)
          (ORBITS MARS EARTH)
          (ORBITS PLUTO MARS)
          (EATS HAM MARZIPAN)
          (CRAVES DEPRESSION TURKEY)
          (ORBITS EARTH URANUS)
          (LOCALE MARZIPAN OREGON)
          (HARMONY LEARNING URANUS)
          (EATS SCALLOP PISTACHIO)
          (EATS SCALLOP FLOUNDER)
          (LOCALE ONION ARIZONA)
          (CRAVES HANGOVER HAM)
          (CRAVES LONELINESS-23 FLOUNDER)
          (HARMONY ACHIEVEMENT EARTH)
          (CRAVES INTOXICATION FLOUNDER)
          (EATS RICE TURKEY)
          (EATS SHRIMP PISTACHIO)
          (CRAVES HANGOVER-2 MARZIPAN)
          (EATS CUCUMBER SHRIMP)
          (EATS TOFU PISTACHIO)
          (CRAVES BOILS-9 CUCUMBER)
          (CRAVES ANXIETY-8 MUTTON)
          (CRAVES LOVE HAM)
          (EATS CUCUMBER TOFU)
          (CRAVES DREAD-1 SCALLOP)
          (EATS MUTTON TOFU)
          (CRAVES DEPRESSION-26 FLOUNDER)
          (EATS FLOUNDER SCALLOP)
          (EATS MUTTON PEA)
          (CRAVES LONELINESS HAM)
          (EATS PEA MARZIPAN)
          (LOCALE SCALLOP OREGON)
          (EATS TOFU MUTTON)
          (CRAVES ANGINA-4 SCALLOP)
          (CRAVES ANXIETY TURKEY)
          (HARMONY LOVE URANUS)
          (EATS PISTACHIO SHRIMP)
          (CRAVES PROSTATITIS-24 FLOUNDER)
          (EATS PISTACHIO SCALLOP)
          (LOCALE TURKEY PENNSYLVANIA)
          (HARMONY EXCITEMENT URANUS)
          (CRAVES LEARNING SHRIMP)
          (CRAVES JEALOUSY-28 ONION)
          (CRAVES ANGINA-30 ONION)
          (HARMONY LUBRICITY URANUS)
          (EATS ONION SCALLOP)
          (EATS PISTACHIO TOFU)
          (EATS SCALLOP ONION)
          (EATS PISTACHIO ONION)
          (LOCALE FLOUNDER ARIZONA)
          (CRAVES ANGER-32 CUCUMBER)
          (CRAVES SCIATICA MARZIPAN)
          (EATS TOFU CUCUMBER)
          (EATS PISTACHIO FLOUNDER)
          (CRAVES LACERATION-6 TOFU)
          (EATS PEA TURKEY)
          (EATS SHRIMP FLOUNDER)
          (EATS PEA MUTTON)
          (CRAVES DREAD PEA)
          (LOCALE RICE PENNSYLVANIA)
          (LOCALE HAM PENNSYLVANIA)
          (LOCALE CUCUMBER OREGON)
          (CRAVES JEALOUSY PEA)
          (HARMONY UNDERSTANDING EARTH)
          (CRAVES DREAD-10 SHRIMP)
          (EATS TURKEY PEA)
          (CRAVES ANGINA MARZIPAN)
          (CRAVES PROSTATITIS-11 SHRIMP)
          (CRAVES JEALOUSY-5 TOFU)
          (EATS SCALLOP HAM)
          (HARMONY INTOXICATION URANUS)
          (EATS MARZIPAN HAM)
          (EATS FLOUNDER SHRIMP)
          (EATS SHRIMP MUTTON)
          (CRAVES DEPRESSION-12 PISTACHIO)
          (CRAVES GRIEF-14 PISTACHIO)
          (EATS TURKEY RICE)
          (CRAVES EXCITEMENT TOFU)
          (LOCALE SHRIMP OREGON)
          (EATS FLOUNDER PISTACHIO)
          (CRAVES PROSTATITIS RICE)
          (ATTACKS ARIZONA OREGON)
          (EATS RICE HAM)
          (LOCALE PEA OREGON)
          (EATS SHRIMP CUCUMBER)
          (CRAVES GRIEF-27 ONION)
          (CRAVES LUBRICITY CUCUMBER)
          (CRAVES BOILS TURKEY)
          (CRAVES ABRASION-13 PISTACHIO)
          (CRAVES ACHIEVEMENT PEA)
          (CRAVES LACERATION PEA)
          (CRAVES HANGOVER-31 CUCUMBER)
          (EATS MARZIPAN PEA)
          (LOCALE TOFU PENNSYLVANIA)
          (CRAVES SCIATICA-15 PISTACHIO)
          (EATS HAM RICE)
          (CRAVES LONELINESS-16 TOFU)
          (CRAVES ABRASION-29 ONION)
          (CRAVES GRIEF TURKEY)
          (EATS ONION TOFU)
          (CRAVES ANXIETY-25 FLOUNDER)
          (LOCALE PISTACHIO PENNSYLVANIA)
          (EATS ONION PISTACHIO)
          (EATS MUTTON SHRIMP)
          (ATTACKS PENNSYLVANIA ARIZONA))
   (:GOAL (AND (CRAVES ANXIETY-25 FLOUNDER))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-13)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TUNA CHOCOLATE WONDERBREAD PEAR LOBSTER GUAVA CHICKEN
             BROCCOLI MUFFIN SNICKERS SCALLOP LEMON PAPAYA KALE REST
             EXCITEMENT PROSTATITIS ANGINA ANGER GRIEF LACERATION LONELINESS
             ABRASION DREAD ANXIETY SCIATICA HANGOVER JEALOUSY BOILS
             DEPRESSION GRIEF-8 ABRASION-3 HANGOVER-4 LACERATION-1 ANXIETY-2
             SCIATICA-15 ANGER-16 JEALOUSY-5 LONELINESS-6 DREAD-7
             PROSTATITIS-13 DEPRESSION-14 DEPRESSION-32 SCIATICA-9
             LONELINESS-10 ANGINA-11 BOILS-12 MANITOBA BAVARIA ARIZONA KENTUCKY
             VENUS MARS NEPTUNE URANUS)
   (:INIT (FOOD TUNA)
          (FOOD CHOCOLATE)
          (FOOD WONDERBREAD)
          (FOOD PEAR)
          (FOOD LOBSTER)
          (FOOD GUAVA)
          (FOOD CHICKEN)
          (FOOD BROCCOLI)
          (FOOD MUFFIN)
          (FOOD SNICKERS)
          (FOOD SCALLOP)
          (FOOD LEMON)
          (FOOD PAPAYA)
          (FOOD KALE)
          (PLEASURE REST)
          (PLEASURE EXCITEMENT)
          (PAIN PROSTATITIS)
          (PAIN ANGINA)
          (PAIN ANGER)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN DREAD)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN GRIEF-8)
          (PAIN ABRASION-3)
          (PAIN HANGOVER-4)
          (PAIN LACERATION-1)
          (PAIN ANXIETY-2)
          (PAIN SCIATICA-15)
          (PAIN ANGER-16)
          (PAIN JEALOUSY-5)
          (PAIN LONELINESS-6)
          (PAIN DREAD-7)
          (PAIN PROSTATITIS-13)
          (PAIN DEPRESSION-14)
          (PAIN DEPRESSION-32)
          (PAIN SCIATICA-9)
          (PAIN LONELINESS-10)
          (PAIN ANGINA-11)
          (PAIN BOILS-12)
          (PROVINCE MANITOBA)
          (PROVINCE BAVARIA)
          (PROVINCE ARIZONA)
          (PROVINCE KENTUCKY)
          (PLANET VENUS)
          (PLANET MARS)
          (PLANET NEPTUNE)
          (PLANET URANUS)
          (EATS TUNA GUAVA)
          (LOCALE SCALLOP KENTUCKY)
          (EATS SCALLOP KALE)
          (LOCALE GUAVA KENTUCKY)
          (CRAVES LONELINESS-6 BROCCOLI)
          (ATTACKS MANITOBA BAVARIA)
          (EATS SCALLOP LEMON)
          (EATS SCALLOP MUFFIN)
          (CRAVES PROSTATITIS-13 MUFFIN)
          (EATS SNICKERS BROCCOLI)
          (EATS GUAVA TUNA)
          (EATS KALE SCALLOP)
          (ATTACKS ARIZONA KENTUCKY)
          (EATS BROCCOLI SNICKERS)
          (EATS LEMON PAPAYA)
          (LOCALE SNICKERS BAVARIA)
          (EATS MUFFIN SNICKERS)
          (CRAVES DREAD-7 BROCCOLI)
          (EATS PAPAYA LEMON)
          (CRAVES HANGOVER PEAR)
          (ORBITS MARS NEPTUNE)
          (LOCALE CHICKEN BAVARIA)
          (CRAVES DEPRESSION-14 MUFFIN)
          (HARMONY EXCITEMENT MARS)
          (CRAVES ABRASION-3 CHICKEN)
          (CRAVES ANXIETY-2 CHICKEN)
          (CRAVES LACERATION WONDERBREAD)
          (EATS LOBSTER TUNA)
          (CRAVES SCIATICA-9 LEMON)
          (EATS PEAR WONDERBREAD)
          (ORBITS NEPTUNE URANUS)
          (CRAVES JEALOUSY LOBSTER)
          (EATS LEMON SCALLOP)
          (EATS PEAR BROCCOLI)
          (CRAVES EXCITEMENT PAPAYA)
          (CRAVES HANGOVER-4 CHICKEN)
          (CRAVES DEPRESSION LOBSTER)
          (CRAVES ANGER-16 BROCCOLI)
          (EATS WONDERBREAD CHICKEN)
          (EATS MUFFIN KALE)
          (CRAVES LONELINESS WONDERBREAD)
          (EATS CHOCOLATE LOBSTER)
          (EATS GUAVA CHICKEN)
          (CRAVES GRIEF WONDERBREAD)
          (LOCALE PEAR ARIZONA)
          (EATS CHICKEN WONDERBREAD)
          (LOCALE BROCCOLI MANITOBA)
          (EATS PAPAYA BROCCOLI)
          (CRAVES GRIEF-8 CHICKEN)
          (EATS SNICKERS MUFFIN)
          (CRAVES BOILS LOBSTER)
          (HARMONY REST URANUS)
          (LOCALE LEMON BAVARIA)
          (EATS CHOCOLATE PEAR)
          (CRAVES ANGINA TUNA)
          (CRAVES SCIATICA PEAR)
          (LOCALE PAPAYA MANITOBA)
          (CRAVES SCIATICA-15 BROCCOLI)
          (EATS TUNA LOBSTER)
          (EATS BROCCOLI PAPAYA)
          (CRAVES BOILS-12 LEMON)
          (EATS GUAVA LEMON)
          (CRAVES DEPRESSION-32 LEMON)
          (CRAVES ANXIETY PEAR)
          (CRAVES LONELINESS-10 LEMON)
          (EATS PEAR CHOCOLATE)
          (LOCALE MUFFIN MANITOBA)
          (EATS KALE MUFFIN)
          (LOCALE CHOCOLATE ARIZONA)
          (EATS MUFFIN SCALLOP)
          (CRAVES ANGER TUNA)
          (CRAVES DREAD WONDERBREAD)
          (LOCALE LOBSTER MANITOBA)
          (ATTACKS BAVARIA ARIZONA)
          (EATS BROCCOLI PEAR)
          (LOCALE KALE KENTUCKY)
          (LOCALE WONDERBREAD KENTUCKY)
          (CRAVES ANGINA-11 LEMON)
          (EATS LEMON GUAVA)
          (ORBITS VENUS MARS)
          (CRAVES LACERATION-1 CHICKEN)
          (EATS WONDERBREAD PEAR)
          (LOCALE TUNA MANITOBA)
          (CRAVES REST LEMON)
          (CRAVES JEALOUSY-5 BROCCOLI)
          (CRAVES ABRASION WONDERBREAD)
          (EATS LOBSTER CHOCOLATE)
          (CRAVES PROSTATITIS TUNA)
          (EATS CHICKEN GUAVA))
   (:GOAL (AND (CRAVES ABRASION-3 WONDERBREAD)
               (CRAVES ANXIETY-2 WONDERBREAD))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-14)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TUNA HAM SNICKERS POPOVER CANTELOPE MARZIPAN PAPAYA
             FLOUNDER ONION MUFFIN SHRIMP LEMON SCALLOP SCALLION
             INTOXICATION ACHIEVEMENT ANGINA DREAD ANXIETY LACERATION
             LONELINESS ABRASION SCIATICA BOILS JEALOUSY DEPRESSION HANGOVER
             PROSTATITIS ANGER LACERATION-2 GRIEF MANITOBA BAVARIA MORAVIA MARS
             EARTH)
   (:INIT (FOOD TUNA)
          (FOOD HAM)
          (FOOD SNICKERS)
          (FOOD POPOVER)
          (FOOD CANTELOPE)
          (FOOD MARZIPAN)
          (FOOD PAPAYA)
          (FOOD FLOUNDER)
          (FOOD ONION)
          (FOOD MUFFIN)
          (FOOD SHRIMP)
          (FOOD LEMON)
          (FOOD SCALLOP)
          (FOOD SCALLION)
          (PLEASURE INTOXICATION)
          (PLEASURE ACHIEVEMENT)
          (PAIN ANGINA)
          (PAIN DREAD)
          (PAIN ANXIETY)
          (PAIN LACERATION)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN SCIATICA)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN DEPRESSION)
          (PAIN HANGOVER)
          (PAIN PROSTATITIS)
          (PAIN ANGER)
          (PAIN LACERATION-2)
          (PAIN GRIEF)
          (PROVINCE MANITOBA)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PLANET MARS)
          (PLANET EARTH)
          (CRAVES PROSTATITIS LEMON)
          (HARMONY ACHIEVEMENT EARTH)
          (LOCALE PAPAYA MANITOBA)
          (EATS CANTELOPE MARZIPAN)
          (EATS MARZIPAN PAPAYA)
          (CRAVES LONELINESS PAPAYA)
          (EATS LEMON ONION)
          (LOCALE TUNA BAVARIA)
          (CRAVES ANGER SCALLOP)
          (EATS SCALLOP MUFFIN)
          (EATS PAPAYA MARZIPAN)
          (HARMONY INTOXICATION EARTH)
          (CRAVES DREAD SNICKERS)
          (EATS MUFFIN SCALLOP)
          (CRAVES JEALOUSY MUFFIN)
          (EATS ONION LEMON)
          (CRAVES GRIEF SCALLION)
          (CRAVES HANGOVER SHRIMP)
          (EATS CANTELOPE FLOUNDER)
          (CRAVES INTOXICATION ONION)
          (EATS SHRIMP LEMON)
          (EATS CANTELOPE HAM)
          (CRAVES ABRASION PAPAYA)
          (EATS LEMON SHRIMP)
          (LOCALE SNICKERS BAVARIA)
          (EATS FLOUNDER PAPAYA)
          (EATS HAM CANTELOPE)
          (LOCALE SHRIMP MANITOBA)
          (CRAVES ACHIEVEMENT LEMON)
          (CRAVES LACERATION CANTELOPE)
          (EATS MARZIPAN CANTELOPE)
          (EATS HAM TUNA)
          (EATS SCALLOP ONION)
          (LOCALE LEMON MORAVIA)
          (EATS HAM POPOVER)
          (EATS PAPAYA LEMON)
          (EATS MUFFIN SCALLION)
          (EATS SCALLION SHRIMP)
          (EATS SNICKERS POPOVER)
          (EATS HAM SNICKERS)
          (LOCALE SCALLION BAVARIA)
          (LOCALE ONION BAVARIA)
          (CRAVES BOILS MUFFIN)
          (EATS TUNA HAM)
          (LOCALE HAM BAVARIA)
          (EATS POPOVER SNICKERS)
          (EATS SHRIMP SCALLION)
          (LOCALE MARZIPAN BAVARIA)
          (LOCALE MUFFIN BAVARIA)
          (CRAVES SCIATICA FLOUNDER)
          (CRAVES LACERATION-2 SCALLION)
          (EATS LEMON PAPAYA)
          (CRAVES ANGINA TUNA)
          (EATS POPOVER HAM)
          (EATS ONION SCALLOP)
          (ATTACKS BAVARIA MORAVIA)
          (LOCALE CANTELOPE BAVARIA)
          (CRAVES ANXIETY POPOVER)
          (ORBITS MARS EARTH)
          (ATTACKS MANITOBA BAVARIA)
          (LOCALE SCALLOP BAVARIA)
          (LOCALE FLOUNDER MANITOBA)
          (EATS SCALLION MUFFIN)
          (EATS POPOVER TUNA)
          (EATS FLOUNDER CANTELOPE)
          (EATS SNICKERS HAM)
          (EATS PAPAYA FLOUNDER)
          (LOCALE POPOVER MANITOBA)
          (CRAVES DEPRESSION MUFFIN)
          (EATS TUNA POPOVER))
   (:GOAL (AND (CRAVES ANGER TUNA))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-15)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LOBSTER WURST BROCCOLI ARUGULA PAPAYA SCALLOP
             PISTACHIO SNICKERS ONION LUBRICITY INTOXICATION ANGINA BOILS
             HANGOVER PROSTATITIS ANGER DREAD ANXIETY LACERATION JEALOUSY
             GRIEF DEPRESSION LONELINESS SCIATICA ABRASION LONELINESS-4
             HANGOVER-1 ANXIETY-2 SCIATICA-8 ANGER-3 DREAD-7 GUANABARA OREGON
             SURREY JUPITER EARTH NEPTUNE MARS)
   (:INIT (FOOD LOBSTER)
          (FOOD WURST)
          (FOOD BROCCOLI)
          (FOOD ARUGULA)
          (FOOD PAPAYA)
          (FOOD SCALLOP)
          (FOOD PISTACHIO)
          (FOOD SNICKERS)
          (FOOD ONION)
          (PLEASURE LUBRICITY)
          (PLEASURE INTOXICATION)
          (PAIN ANGINA)
          (PAIN BOILS)
          (PAIN HANGOVER)
          (PAIN PROSTATITIS)
          (PAIN ANGER)
          (PAIN DREAD)
          (PAIN ANXIETY)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN ABRASION)
          (PAIN LONELINESS-4)
          (PAIN HANGOVER-1)
          (PAIN ANXIETY-2)
          (PAIN SCIATICA-8)
          (PAIN ANGER-3)
          (PAIN DREAD-7)
          (PROVINCE GUANABARA)
          (PROVINCE OREGON)
          (PROVINCE SURREY)
          (PLANET JUPITER)
          (PLANET EARTH)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (CRAVES DREAD WURST)
          (CRAVES DEPRESSION ARUGULA)
          (EATS ONION LOBSTER)
          (CRAVES LONELINESS PAPAYA)
          (CRAVES SCIATICA PAPAYA)
          (CRAVES HANGOVER-1 SCALLOP)
          (CRAVES SCIATICA-8 PISTACHIO)
          (CRAVES INTOXICATION PISTACHIO)
          (CRAVES ANGINA LOBSTER)
          (LOCALE BROCCOLI GUANABARA)
          (EATS PISTACHIO BROCCOLI)
          (CRAVES DREAD-7 ONION)
          (EATS WURST SNICKERS)
          (LOCALE SNICKERS SURREY)
          (EATS ARUGULA PAPAYA)
          (EATS PAPAYA LOBSTER)
          (EATS LOBSTER PAPAYA)
          (CRAVES HANGOVER LOBSTER)
          (EATS ONION SCALLOP)
          (CRAVES ANXIETY WURST)
          (CRAVES GRIEF ARUGULA)
          (EATS SCALLOP ONION)
          (EATS PISTACHIO WURST)
          (LOCALE ARUGULA GUANABARA)
          (LOCALE WURST GUANABARA)
          (CRAVES ABRASION PAPAYA)
          (EATS PAPAYA ARUGULA)
          (CRAVES BOILS LOBSTER)
          (EATS LOBSTER ONION)
          (ORBITS NEPTUNE MARS)
          (EATS SNICKERS ARUGULA)
          (CRAVES ANGER-3 PISTACHIO)
          (LOCALE ONION SURREY)
          (EATS ARUGULA SNICKERS)
          (HARMONY LUBRICITY NEPTUNE)
          (EATS SNICKERS WURST)
          (HARMONY INTOXICATION MARS)
          (LOCALE PISTACHIO GUANABARA)
          (EATS WURST PISTACHIO)
          (CRAVES ANGER LOBSTER)
          (CRAVES JEALOUSY WURST)
          (EATS BROCCOLI PISTACHIO)
          (ORBITS EARTH NEPTUNE)
          (CRAVES LUBRICITY BROCCOLI)
          (CRAVES ANXIETY-2 SCALLOP)
          (LOCALE LOBSTER GUANABARA)
          (LOCALE SCALLOP OREGON)
          (ATTACKS GUANABARA OREGON)
          (LOCALE PAPAYA GUANABARA)
          (ORBITS JUPITER EARTH)
          (CRAVES LONELINESS-4 SCALLOP)
          (EATS SCALLOP BROCCOLI)
          (CRAVES PROSTATITIS LOBSTER)
          (CRAVES LACERATION WURST)
          (EATS BROCCOLI SCALLOP)
          (ATTACKS OREGON SURREY))
   (:GOAL (AND (CRAVES DREAD-7 LOBSTER))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-16)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS MUTTON SCALLION RICE PEAR HAM CHICKEN APPLE BEEF
             SWEETROLL COD STIMULATION ANGER JEALOUSY DREAD GRIEF LACERATION
             PROSTATITIS DEPRESSION ANXIETY LONELINESS ABRASION BOILS ANGINA
             MANITOBA SURREY PENNSYLVANIA QUEBEC EARTH JUPITER NEPTUNE)
   (:INIT (FOOD MUTTON)
          (FOOD SCALLION)
          (FOOD RICE)
          (FOOD PEAR)
          (FOOD HAM)
          (FOOD CHICKEN)
          (FOOD APPLE)
          (FOOD BEEF)
          (FOOD SWEETROLL)
          (FOOD COD)
          (PLEASURE STIMULATION)
          (PAIN ANGER)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN PROSTATITIS)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN BOILS)
          (PAIN ANGINA)
          (PROVINCE MANITOBA)
          (PROVINCE SURREY)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE QUEBEC)
          (PLANET EARTH)
          (PLANET JUPITER)
          (PLANET NEPTUNE)
          (LOCALE APPLE MANITOBA)
          (EATS RICE SCALLION)
          (EATS SWEETROLL BEEF)
          (EATS APPLE CHICKEN)
          (EATS RICE COD)
          (EATS HAM PEAR)
          (CRAVES STIMULATION PEAR)
          (EATS CHICKEN BEEF)
          (EATS SCALLION PEAR)
          (LOCALE PEAR MANITOBA)
          (EATS PEAR HAM)
          (EATS SCALLION MUTTON)
          (ATTACKS MANITOBA SURREY)
          (EATS HAM MUTTON)
          (EATS COD PEAR)
          (CRAVES BOILS COD)
          (EATS RICE PEAR)
          (ORBITS JUPITER NEPTUNE)
          (EATS COD RICE)
          (EATS SWEETROLL COD)
          (CRAVES ANGER MUTTON)
          (EATS MUTTON SCALLION)
          (LOCALE MUTTON QUEBEC)
          (LOCALE RICE SURREY)
          (EATS PEAR COD)
          (CRAVES DEPRESSION APPLE)
          (EATS SCALLION RICE)
          (ATTACKS SURREY PENNSYLVANIA)
          (CRAVES GRIEF SCALLION)
          (HARMONY STIMULATION NEPTUNE)
          (EATS COD APPLE)
          (CRAVES ANXIETY SWEETROLL)
          (CRAVES LONELINESS SWEETROLL)
          (LOCALE HAM SURREY)
          (CRAVES JEALOUSY MUTTON)
          (LOCALE CHICKEN PENNSYLVANIA)
          (CRAVES DREAD SCALLION)
          (EATS BEEF CHICKEN)
          (EATS COD SWEETROLL)
          (ATTACKS PENNSYLVANIA QUEBEC)
          (LOCALE SWEETROLL PENNSYLVANIA)
          (LOCALE COD SURREY)
          (CRAVES ABRASION SWEETROLL)
          (CRAVES ANGINA COD)
          (CRAVES PROSTATITIS APPLE)
          (CRAVES LACERATION APPLE)
          (EATS PEAR RICE)
          (EATS CHICKEN APPLE)
          (EATS APPLE COD)
          (LOCALE BEEF QUEBEC)
          (EATS MUTTON HAM)
          (ORBITS EARTH JUPITER)
          (LOCALE SCALLION SURREY)
          (EATS PEAR SCALLION)
          (EATS BEEF SWEETROLL))
   (:GOAL (AND (CRAVES GRIEF SWEETROLL))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-17)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS CUCUMBER TOMATO CANTELOPE PEAR SNICKERS LOBSTER PORK
             CHICKEN TURKEY MUTTON HAROSET BEEF SWEETROLL GRAPEFRUIT TOFU
             HAM HOTDOG BACON ORANGE LETTUCE LUBRICITY SATISFACTION
             SATIETY LEARNING STIMULATION CURIOSITY PROSTATITIS
             LACERATION ANXIETY HANGOVER LONELINESS JEALOUSY ANGINA ANGER
             DEPRESSION GRIEF BOILS DREAD-1 DEPRESSION-2 DREAD ABRASION
             SCIATICA ABRASION-3 SCIATICA-4 ANGINA-16 PROSTATITIS-5
             ANGER-6 GRIEF-7 LONELINESS-8 LACERATION-13 HANGOVER-14
             BOILS-15 JEALOUSY-12 ANGINA-32 PROSTATITIS-9 HANGOVER-10
             ANXIETY-11 LACERATION-30 SCIATICA-31 ANGER-29 DEPRESSION-24
             GRIEF-25 JEALOUSY-26 ANXIETY-27 BOILS-28 ABRASION-22
             LONELINESS-23 DREAD-21 GUANABARA OREGON MORAVIA BAVARIA URANUS MARS
             EARTH JUPITER)
   (:INIT (FOOD CUCUMBER)
          (FOOD TOMATO)
          (FOOD CANTELOPE)
          (FOOD PEAR)
          (FOOD SNICKERS)
          (FOOD LOBSTER)
          (FOOD PORK)
          (FOOD CHICKEN)
          (FOOD TURKEY)
          (FOOD MUTTON)
          (FOOD HAROSET)
          (FOOD BEEF)
          (FOOD SWEETROLL)
          (FOOD GRAPEFRUIT)
          (FOOD TOFU)
          (FOOD HAM)
          (FOOD HOTDOG)
          (FOOD BACON)
          (FOOD ORANGE)
          (FOOD LETTUCE)
          (PLEASURE LUBRICITY)
          (PLEASURE SATISFACTION)
          (PLEASURE SATIETY)
          (PLEASURE LEARNING)
          (PLEASURE STIMULATION)
          (PLEASURE CURIOSITY)
          (PAIN PROSTATITIS)
          (PAIN LACERATION)
          (PAIN ANXIETY)
          (PAIN HANGOVER)
          (PAIN LONELINESS)
          (PAIN JEALOUSY)
          (PAIN ANGINA)
          (PAIN ANGER)
          (PAIN DEPRESSION)
          (PAIN GRIEF)
          (PAIN BOILS)
          (PAIN DREAD-1)
          (PAIN DEPRESSION-2)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN SCIATICA)
          (PAIN ABRASION-3)
          (PAIN SCIATICA-4)
          (PAIN ANGINA-16)
          (PAIN PROSTATITIS-5)
          (PAIN ANGER-6)
          (PAIN GRIEF-7)
          (PAIN LONELINESS-8)
          (PAIN LACERATION-13)
          (PAIN HANGOVER-14)
          (PAIN BOILS-15)
          (PAIN JEALOUSY-12)
          (PAIN ANGINA-32)
          (PAIN PROSTATITIS-9)
          (PAIN HANGOVER-10)
          (PAIN ANXIETY-11)
          (PAIN LACERATION-30)
          (PAIN SCIATICA-31)
          (PAIN ANGER-29)
          (PAIN DEPRESSION-24)
          (PAIN GRIEF-25)
          (PAIN JEALOUSY-26)
          (PAIN ANXIETY-27)
          (PAIN BOILS-28)
          (PAIN ABRASION-22)
          (PAIN LONELINESS-23)
          (PAIN DREAD-21)
          (PROVINCE GUANABARA)
          (PROVINCE OREGON)
          (PROVINCE MORAVIA)
          (PROVINCE BAVARIA)
          (PLANET URANUS)
          (PLANET MARS)
          (PLANET EARTH)
          (PLANET JUPITER)
          (CRAVES ABRASION-3 LOBSTER)
          (EATS TURKEY BEEF)
          (LOCALE BEEF MORAVIA)
          (EATS ORANGE GRAPEFRUIT)
          (CRAVES SCIATICA-4 LOBSTER)
          (CRAVES STIMULATION ORANGE)
          (EATS ORANGE HAM)
          (HARMONY STIMULATION EARTH)
          (EATS TOMATO PEAR)
          (EATS CUCUMBER PORK)
          (CRAVES ANXIETY-11 GRAPEFRUIT)
          (CRAVES BOILS-15 CHICKEN)
          (LOCALE HOTDOG MORAVIA)
          (EATS PEAR LOBSTER)
          (EATS TOMATO SNICKERS)
          (EATS SNICKERS CHICKEN)
          (EATS HAM TOFU)
          (EATS GRAPEFRUIT LETTUCE)
          (CRAVES DREAD-1 SNICKERS)
          (EATS LOBSTER CANTELOPE)
          (EATS GRAPEFRUIT ORANGE)
          (EATS SNICKERS TOMATO)
          (HARMONY LEARNING MARS)
          (EATS LOBSTER PEAR)
          (CRAVES ANGER PEAR)
          (CRAVES JEALOUSY-26 HOTDOG)
          (CRAVES PROSTATITIS CUCUMBER)
          (EATS MUTTON SWEETROLL)
          (EATS HAM SWEETROLL)
          (EATS CHICKEN SNICKERS)
          (EATS PEAR TOMATO)
          (EATS BEEF PEAR)
          (CRAVES LACERATION-13 CHICKEN)
          (LOCALE BACON GUANABARA)
          (CRAVES BOILS-28 HOTDOG)
          (EATS PORK CANTELOPE)
          (EATS LETTUCE HOTDOG)
          (LOCALE LOBSTER OREGON)
          (CRAVES SATISFACTION BEEF)
          (ORBITS MARS EARTH)
          (CRAVES LONELINESS-8 PORK)
          (EATS CANTELOPE LOBSTER)
          (EATS TURKEY LETTUCE)
          (CRAVES PROSTATITIS-9 GRAPEFRUIT)
          (CRAVES PROSTATITIS-5 PORK)
          (ATTACKS MORAVIA BAVARIA)
          (HARMONY CURIOSITY MARS)
          (CRAVES DEPRESSION-2 SNICKERS)
          (CRAVES DEPRESSION-24 HOTDOG)
          (CRAVES ANXIETY CUCUMBER)
          (LOCALE CHICKEN OREGON)
          (EATS HOTDOG LETTUCE)
          (CRAVES BOILS PEAR)
          (EATS HAROSET BACON)
          (CRAVES SCIATICA SNICKERS)
          (EATS CUCUMBER CHICKEN)
          (CRAVES ANGINA CANTELOPE)
          (CRAVES GRIEF-7 PORK)
          (CRAVES HANGOVER-14 CHICKEN)
          (CRAVES SCIATICA-31 TOFU)
          (EATS TOFU BEEF)
          (ATTACKS OREGON MORAVIA)
          (LOCALE TURKEY GUANABARA)
          (EATS SWEETROLL MUTTON)
          (EATS TOFU HAM)
          (LOCALE HAM MORAVIA)
          (EATS BACON HOTDOG)
          (CRAVES LEARNING BACON)
          (CRAVES ABRASION SNICKERS)
          (EATS BACON MUTTON)
          (LOCALE CANTELOPE BAVARIA)
          (EATS HAM ORANGE)
          (EATS HOTDOG BACON)
          (EATS LOBSTER BACON)
          (ORBITS URANUS MARS)
          (LOCALE HAROSET OREGON)
          (CRAVES DREAD SNICKERS)
          (LOCALE ORANGE MORAVIA)
          (CRAVES LONELINESS TOMATO)
          (CRAVES LACERATION CUCUMBER)
          (LOCALE MUTTON GUANABARA)
          (CRAVES ANGINA-32 GRAPEFRUIT)
          (HARMONY SATISFACTION JUPITER)
          (EATS LETTUCE GRAPEFRUIT)
          (CRAVES LUBRICITY PORK)
          (EATS BACON HAROSET)
          (LOCALE TOFU BAVARIA)
          (CRAVES DEPRESSION PEAR)
          (LOCALE SNICKERS MORAVIA)
          (EATS CHICKEN CUCUMBER)
          (CRAVES ANGER-6 PORK)
          (LOCALE TOMATO OREGON)
          (CRAVES GRIEF-25 HOTDOG)
          (EATS HAROSET ORANGE)
          (LOCALE GRAPEFRUIT OREGON)
          (EATS PEAR BEEF)
          (CRAVES ABRASION-22 BACON)
          (LOCALE CUCUMBER OREGON)
          (EATS LETTUCE TURKEY)
          (EATS BEEF TOFU)
          (EATS PORK CUCUMBER)
          (CRAVES HANGOVER CUCUMBER)
          (LOCALE PORK BAVARIA)
          (LOCALE PEAR BAVARIA)
          (CRAVES ANXIETY-27 HOTDOG)
          (CRAVES HANGOVER-10 GRAPEFRUIT)
          (ATTACKS GUANABARA OREGON)
          (CRAVES LACERATION-30 TOFU)
          (CRAVES ANGER-29 HAM)
          (CRAVES DREAD-21 ORANGE)
          (EATS CANTELOPE PORK)
          (EATS ORANGE HAROSET)
          (CRAVES GRIEF PEAR)
          (EATS MUTTON BACON)
          (HARMONY LUBRICITY JUPITER)
          (CRAVES JEALOUSY-12 MUTTON)
          (EATS BEEF TURKEY)
          (HARMONY SATIETY JUPITER)
          (CRAVES SATIETY GRAPEFRUIT)
          (CRAVES LONELINESS-23 BACON)
          (CRAVES JEALOUSY TOMATO)
          (EATS SWEETROLL HAM)
          (CRAVES CURIOSITY LETTUCE)
          (LOCALE LETTUCE GUANABARA)
          (ORBITS EARTH JUPITER)
          (EATS BACON LOBSTER)
          (LOCALE SWEETROLL MORAVIA)
          (CRAVES ANGINA-16 PORK))
   (:GOAL (AND (CRAVES ANGINA HOTDOG)
               (CRAVES HANGOVER-10 HOTDOG))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-18)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS ARUGULA WURST LOBSTER TUNA TURKEY APPLE AESTHETICS
             UNDERSTANDING STIMULATION EXCITEMENT EXPECTATION JEALOUSY SCIATICA
             PROSTATITIS GRIEF DREAD HANGOVER GUANABARA MORAVIA MANITOBA
             JUPITER URANUS NEPTUNE MARS)
   (:INIT (FOOD ARUGULA)
          (FOOD WURST)
          (FOOD LOBSTER)
          (FOOD TUNA)
          (FOOD TURKEY)
          (FOOD APPLE)
          (PLEASURE AESTHETICS)
          (PLEASURE UNDERSTANDING)
          (PLEASURE STIMULATION)
          (PLEASURE EXCITEMENT)
          (PLEASURE EXPECTATION)
          (PAIN JEALOUSY)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS)
          (PAIN GRIEF)
          (PAIN DREAD)
          (PAIN HANGOVER)
          (PROVINCE GUANABARA)
          (PROVINCE MORAVIA)
          (PROVINCE MANITOBA)
          (PLANET JUPITER)
          (PLANET URANUS)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (EATS ARUGULA LOBSTER)
          (ORBITS NEPTUNE MARS)
          (CRAVES STIMULATION LOBSTER)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS TURKEY TUNA)
          (EATS APPLE WURST)
          (CRAVES GRIEF ARUGULA)
          (CRAVES AESTHETICS ARUGULA)
          (EATS LOBSTER ARUGULA)
          (LOCALE LOBSTER GUANABARA)
          (EATS WURST TURKEY)
          (EATS TUNA TURKEY)
          (LOCALE TURKEY MORAVIA)
          (CRAVES JEALOUSY ARUGULA)
          (EATS APPLE ARUGULA)
          (EATS WURST APPLE)
          (CRAVES EXPECTATION APPLE)
          (HARMONY AESTHETICS NEPTUNE)
          (EATS TUNA LOBSTER)
          (LOCALE WURST GUANABARA)
          (CRAVES EXCITEMENT TUNA)
          (CRAVES DREAD WURST)
          (CRAVES SCIATICA ARUGULA)
          (ATTACKS GUANABARA MORAVIA)
          (HARMONY STIMULATION MARS)
          (CRAVES HANGOVER TUNA)
          (LOCALE ARUGULA GUANABARA)
          (EATS ARUGULA APPLE)
          (EATS TURKEY WURST)
          (LOCALE TUNA MANITOBA)
          (CRAVES UNDERSTANDING WURST)
          (EATS LOBSTER TUNA)
          (LOCALE APPLE GUANABARA)
          (HARMONY UNDERSTANDING MARS)
          (CRAVES PROSTATITIS ARUGULA)
          (ORBITS URANUS NEPTUNE)
          (ATTACKS MORAVIA MANITOBA)
          (HARMONY EXPECTATION MARS)
          (ORBITS JUPITER URANUS))
   (:GOAL (AND (CRAVES HANGOVER APPLE))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-19)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SHRIMP CHOCOLATE MARZIPAN PEPPER LEMON PAPAYA ONION
             SCALLOP SNICKERS HAROSET TURKEY CHICKEN FLOUNDER LETTUCE TOFU
             POPOVER WURST INTOXICATION LOVE STIMULATION SATIETY REST
             EMPATHY UNDERSTANDING LEARNING EXCITEMENT LUBRICITY ANXIETY
             LACERATION GRIEF ANGER PROSTATITIS ABRASION ANGINA SCIATICA BOILS
             LONELINESS DEPRESSION JEALOUSY HANGOVER DREAD ANXIETY-1 ANGINA-2
             SCIATICA-4 JEALOUSY-3 BOILS-7 ANGER-8 LACERATION-5 HANGOVER-6
             GUANABARA QUEBEC MANITOBA ALSACE OREGON ARIZONA MARS SATURN
             URANUS EARTH)
   (:INIT (FOOD SHRIMP)
          (FOOD CHOCOLATE)
          (FOOD MARZIPAN)
          (FOOD PEPPER)
          (FOOD LEMON)
          (FOOD PAPAYA)
          (FOOD ONION)
          (FOOD SCALLOP)
          (FOOD SNICKERS)
          (FOOD HAROSET)
          (FOOD TURKEY)
          (FOOD CHICKEN)
          (FOOD FLOUNDER)
          (FOOD LETTUCE)
          (FOOD TOFU)
          (FOOD POPOVER)
          (FOOD WURST)
          (PLEASURE INTOXICATION)
          (PLEASURE LOVE)
          (PLEASURE STIMULATION)
          (PLEASURE SATIETY)
          (PLEASURE REST)
          (PLEASURE EMPATHY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE LUBRICITY)
          (PAIN ANXIETY)
          (PAIN LACERATION)
          (PAIN GRIEF)
          (PAIN ANGER)
          (PAIN PROSTATITIS)
          (PAIN ABRASION)
          (PAIN ANGINA)
          (PAIN SCIATICA)
          (PAIN BOILS)
          (PAIN LONELINESS)
          (PAIN DEPRESSION)
          (PAIN JEALOUSY)
          (PAIN HANGOVER)
          (PAIN DREAD)
          (PAIN ANXIETY-1)
          (PAIN ANGINA-2)
          (PAIN SCIATICA-4)
          (PAIN JEALOUSY-3)
          (PAIN BOILS-7)
          (PAIN ANGER-8)
          (PAIN LACERATION-5)
          (PAIN HANGOVER-6)
          (PROVINCE GUANABARA)
          (PROVINCE QUEBEC)
          (PROVINCE MANITOBA)
          (PROVINCE ALSACE)
          (PROVINCE OREGON)
          (PROVINCE ARIZONA)
          (PLANET MARS)
          (PLANET SATURN)
          (PLANET URANUS)
          (PLANET EARTH)
          (EATS ONION SHRIMP)
          (CRAVES REST HAROSET)
          (EATS POPOVER TOFU)
          (EATS CHOCOLATE SHRIMP)
          (CRAVES DEPRESSION PAPAYA)
          (EATS HAROSET ONION)
          (LOCALE SCALLOP ALSACE)
          (EATS FLOUNDER POPOVER)
          (EATS LETTUCE WURST)
          (ATTACKS GUANABARA QUEBEC)
          (EATS POPOVER FLOUNDER)
          (CRAVES LEARNING LETTUCE)
          (CRAVES EXCITEMENT TOFU)
          (EATS FLOUNDER CHICKEN)
          (CRAVES HANGOVER ONION)
          (CRAVES ABRASION PEPPER)
          (LOCALE TOFU QUEBEC)
          (EATS PEPPER LEMON)
          (LOCALE HAROSET GUANABARA)
          (CRAVES SCIATICA LEMON)
          (CRAVES DREAD ONION)
          (HARMONY LUBRICITY URANUS)
          (ATTACKS MANITOBA ALSACE)
          (LOCALE SHRIMP GUANABARA)
          (CRAVES ANGER-8 LETTUCE)
          (CRAVES UNDERSTANDING CHICKEN)
          (EATS MARZIPAN PEPPER)
          (CRAVES BOILS-7 LETTUCE)
          (CRAVES ANGINA LEMON)
          (EATS SCALLOP SNICKERS)
          (LOCALE LEMON ARIZONA)
          (LOCALE POPOVER QUEBEC)
          (EATS MARZIPAN SHRIMP)
          (HARMONY REST SATURN)
          (CRAVES JEALOUSY ONION)
          (CRAVES ANGINA-2 HAROSET)
          (EATS ONION PAPAYA)
          (ORBITS SATURN URANUS)
          (EATS SNICKERS WURST)
          (HARMONY INTOXICATION SATURN)
          (ORBITS URANUS EARTH)
          (CRAVES BOILS LEMON)
          (EATS FLOUNDER WURST)
          (HARMONY SATIETY URANUS)
          (CRAVES ANXIETY-1 HAROSET)
          (EATS SHRIMP ONION)
          (CRAVES GRIEF CHOCOLATE)
          (CRAVES LACERATION CHOCOLATE)
          (EATS SHRIMP MARZIPAN)
          (HARMONY LEARNING SATURN)
          (EATS WURST LETTUCE)
          (LOCALE PAPAYA ALSACE)
          (CRAVES JEALOUSY-3 CHICKEN)
          (EATS CHICKEN TOFU)
          (EATS WURST FLOUNDER)
          (LOCALE PEPPER ARIZONA)
          (EATS PAPAYA TURKEY)
          (LOCALE MARZIPAN QUEBEC)
          (ORBITS MARS SATURN)
          (HARMONY LOVE SATURN)
          (CRAVES LACERATION-5 TOFU)
          (EATS SHRIMP CHOCOLATE)
          (CRAVES STIMULATION PEPPER)
          (ATTACKS ALSACE OREGON)
          (EATS SNICKERS SCALLOP)
          (CRAVES SATIETY SCALLOP)
          (EATS LETTUCE CHICKEN)
          (EATS CHICKEN FLOUNDER)
          (ATTACKS QUEBEC MANITOBA)
          (HARMONY UNDERSTANDING URANUS)
          (EATS TOFU CHICKEN)
          (LOCALE WURST GUANABARA)
          (EATS CHICKEN LETTUCE)
          (EATS SCALLOP TURKEY)
          (EATS CHOCOLATE LEMON)
          (CRAVES HANGOVER-6 TOFU)
          (EATS SNICKERS HAROSET)
          (LOCALE TURKEY MANITOBA)
          (EATS LEMON PEPPER)
          (HARMONY STIMULATION SATURN)
          (CRAVES ANXIETY SHRIMP)
          (LOCALE ONION ALSACE)
          (EATS TURKEY SCALLOP)
          (LOCALE LETTUCE GUANABARA)
          (CRAVES INTOXICATION SHRIMP)
          (EATS TURKEY PAPAYA)
          (EATS PAPAYA ONION)
          (CRAVES SCIATICA-4 TURKEY)
          (HARMONY EMPATHY EARTH)
          (HARMONY EXCITEMENT EARTH)
          (LOCALE SNICKERS ALSACE)
          (CRAVES PROSTATITIS PEPPER)
          (CRAVES LUBRICITY WURST)
          (CRAVES LOVE MARZIPAN)
          (EATS ONION HAROSET)
          (LOCALE CHOCOLATE OREGON)
          (EATS LEMON CHOCOLATE)
          (EATS HAROSET SNICKERS)
          (CRAVES ANGER PEPPER)
          (CRAVES LONELINESS PAPAYA)
          (EATS WURST SNICKERS)
          (ATTACKS OREGON ARIZONA)
          (CRAVES EMPATHY TURKEY)
          (LOCALE FLOUNDER QUEBEC)
          (LOCALE CHICKEN ALSACE)
          (EATS PEPPER MARZIPAN)
          (EATS TOFU POPOVER))
   (:GOAL (AND (CRAVES JEALOUSY CHOCOLATE))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-20)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TURKEY OKRA YOGURT SCALLION REST ABRASION ANGER
             HANGOVER MANITOBA KENTUCKY GUANABARA GOIAS BAVARIA NEPTUNE
             SATURN MARS VENUS)
   (:INIT (FOOD TURKEY)
          (FOOD OKRA)
          (FOOD YOGURT)
          (FOOD SCALLION)
          (PLEASURE REST)
          (PAIN ABRASION)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PROVINCE MANITOBA)
          (PROVINCE KENTUCKY)
          (PROVINCE GUANABARA)
          (PROVINCE GOIAS)
          (PROVINCE BAVARIA)
          (PLANET NEPTUNE)
          (PLANET SATURN)
          (PLANET MARS)
          (PLANET VENUS)
          (EATS YOGURT SCALLION)
          (ATTACKS MANITOBA KENTUCKY)
          (LOCALE TURKEY GOIAS)
          (EATS OKRA SCALLION)
          (CRAVES REST OKRA)
          (EATS SCALLION TURKEY)
          (EATS OKRA TURKEY)
          (ORBITS NEPTUNE SATURN)
          (LOCALE YOGURT BAVARIA)
          (EATS OKRA YOGURT)
          (CRAVES ANGER SCALLION)
          (ATTACKS GUANABARA GOIAS)
          (EATS SCALLION YOGURT)
          (HARMONY REST VENUS)
          (ORBITS MARS VENUS)
          (EATS TURKEY OKRA)
          (LOCALE SCALLION GOIAS)
          (CRAVES ABRASION SCALLION)
          (EATS SCALLION OKRA)
          (ATTACKS GOIAS BAVARIA)
          (ATTACKS KENTUCKY GUANABARA)
          (ORBITS SATURN MARS)
          (EATS YOGURT OKRA)
          (LOCALE OKRA GUANABARA)
          (EATS TURKEY SCALLION)
          (CRAVES HANGOVER SCALLION))
   (:GOAL (AND (CRAVES ANGER TURKEY)
               (CRAVES ABRASION TURKEY))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-21)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS OKRA GUAVA LETTUCE SNICKERS LOBSTER MUFFIN PORK SHRIMP
             SWEETROLL HOTDOG HAMBURGER WONDERBREAD PEA LAMB CHICKEN TRIUMPH
             EMPATHY CURIOSITY INTOXICATION BOILS HANGOVER ANGER
             PROSTATITIS GRIEF LONELINESS DREAD JEALOUSY GUANABARA
             PENNSYLVANIA ALSACE NEPTUNE URANUS PLUTO)
   (:INIT (FOOD OKRA)
          (FOOD GUAVA)
          (FOOD LETTUCE)
          (FOOD SNICKERS)
          (FOOD LOBSTER)
          (FOOD MUFFIN)
          (FOOD PORK)
          (FOOD SHRIMP)
          (FOOD SWEETROLL)
          (FOOD HOTDOG)
          (FOOD HAMBURGER)
          (FOOD WONDERBREAD)
          (FOOD PEA)
          (FOOD LAMB)
          (FOOD CHICKEN)
          (PLEASURE TRIUMPH)
          (PLEASURE EMPATHY)
          (PLEASURE CURIOSITY)
          (PLEASURE INTOXICATION)
          (PAIN BOILS)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN PROSTATITIS)
          (PAIN GRIEF)
          (PAIN LONELINESS)
          (PAIN DREAD)
          (PAIN JEALOUSY)
          (PROVINCE GUANABARA)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE ALSACE)
          (PLANET NEPTUNE)
          (PLANET URANUS)
          (PLANET PLUTO)
          (EATS WONDERBREAD CHICKEN)
          (EATS HOTDOG LOBSTER)
          (EATS PEA WONDERBREAD)
          (ATTACKS PENNSYLVANIA ALSACE)
          (HARMONY CURIOSITY PLUTO)
          (CRAVES GRIEF MUFFIN)
          (EATS GUAVA OKRA)
          (EATS WONDERBREAD PEA)
          (EATS CHICKEN WONDERBREAD)
          (LOCALE HOTDOG ALSACE)
          (HARMONY TRIUMPH PLUTO)
          (EATS SWEETROLL MUFFIN)
          (EATS OKRA GUAVA)
          (EATS HOTDOG PORK)
          (EATS LOBSTER MUFFIN)
          (EATS SNICKERS PORK)
          (EATS LETTUCE GUAVA)
          (EATS OKRA SNICKERS)
          (LOCALE WONDERBREAD PENNSYLVANIA)
          (LOCALE PEA GUANABARA)
          (EATS LETTUCE SNICKERS)
          (LOCALE CHICKEN PENNSYLVANIA)
          (LOCALE SWEETROLL GUANABARA)
          (EATS HOTDOG PEA)
          (EATS HAMBURGER LAMB)
          (CRAVES INTOXICATION CHICKEN)
          (EATS LOBSTER HOTDOG)
          (LOCALE LOBSTER ALSACE)
          (EATS OKRA LETTUCE)
          (EATS MUFFIN LOBSTER)
          (CRAVES EMPATHY SHRIMP)
          (EATS LETTUCE OKRA)
          (HARMONY EMPATHY URANUS)
          (EATS MUFFIN SWEETROLL)
          (EATS LAMB CHICKEN)
          (EATS LAMB HAMBURGER)
          (CRAVES PROSTATITIS MUFFIN)
          (CRAVES CURIOSITY WONDERBREAD)
          (CRAVES HANGOVER MUFFIN)
          (CRAVES JEALOUSY CHICKEN)
          (CRAVES LONELINESS LAMB)
          (EATS PEA HOTDOG)
          (ORBITS NEPTUNE URANUS)
          (EATS SHRIMP SWEETROLL)
          (EATS PORK HOTDOG)
          (EATS SHRIMP PORK)
          (LOCALE OKRA PENNSYLVANIA)
          (LOCALE GUAVA ALSACE)
          (LOCALE PORK ALSACE)
          (LOCALE LAMB GUANABARA)
          (ATTACKS GUANABARA PENNSYLVANIA)
          (EATS PEA HAMBURGER)
          (LOCALE HAMBURGER GUANABARA)
          (EATS PORK SHRIMP)
          (EATS SNICKERS LETTUCE)
          (EATS PORK SNICKERS)
          (CRAVES DREAD LAMB)
          (LOCALE SHRIMP ALSACE)
          (ORBITS URANUS PLUTO)
          (LOCALE MUFFIN GUANABARA)
          (CRAVES TRIUMPH PORK)
          (LOCALE SNICKERS ALSACE)
          (EATS HAMBURGER PEA)
          (EATS SWEETROLL SHRIMP)
          (CRAVES ANGER MUFFIN)
          (EATS CHICKEN LAMB)
          (CRAVES BOILS MUFFIN)
          (HARMONY INTOXICATION PLUTO)
          (LOCALE LETTUCE ALSACE)
          (EATS GUAVA LETTUCE)
          (EATS SNICKERS OKRA))
   (:GOAL (AND (CRAVES LONELINESS PEA))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-22)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS CHICKEN TOFU SHRIMP POPOVER HAM HAROSET PISTACHIO
             ENDIVE SNICKERS MUFFIN LEARNING EXCITEMENT ANXIETY HANGOVER
             GRIEF DEPRESSION PROSTATITIS ANGINA ANGER LACERATION
             JEALOUSY DREAD SCIATICA LONELINESS BOILS HANGOVER-2 ABRASION
             BOILS-4 GRIEF-1 MANITOBA BAVARIA BOSNIA PLUTO JUPITER NEPTUNE
             MARS)
   (:INIT (FOOD CHICKEN)
          (FOOD TOFU)
          (FOOD SHRIMP)
          (FOOD POPOVER)
          (FOOD HAM)
          (FOOD HAROSET)
          (FOOD PISTACHIO)
          (FOOD ENDIVE)
          (FOOD SNICKERS)
          (FOOD MUFFIN)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PAIN ANXIETY)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN PROSTATITIS)
          (PAIN ANGINA)
          (PAIN ANGER)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN LONELINESS)
          (PAIN BOILS)
          (PAIN HANGOVER-2)
          (PAIN ABRASION)
          (PAIN BOILS-4)
          (PAIN GRIEF-1)
          (PROVINCE MANITOBA)
          (PROVINCE BAVARIA)
          (PROVINCE BOSNIA)
          (PLANET PLUTO)
          (PLANET JUPITER)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (CRAVES GRIEF-1 MUFFIN)
          (CRAVES DEPRESSION TOFU)
          (EATS POPOVER SHRIMP)
          (LOCALE ENDIVE BAVARIA)
          (HARMONY LEARNING MARS)
          (ATTACKS MANITOBA BAVARIA)
          (CRAVES DREAD HAM)
          (EATS MUFFIN PISTACHIO)
          (LOCALE POPOVER BOSNIA)
          (LOCALE TOFU MANITOBA)
          (EATS PISTACHIO HAM)
          (EATS HAROSET ENDIVE)
          (CRAVES ANXIETY CHICKEN)
          (EATS SHRIMP TOFU)
          (EATS ENDIVE HAROSET)
          (CRAVES JEALOUSY POPOVER)
          (EATS MUFFIN SHRIMP)
          (EATS ENDIVE PISTACHIO)
          (CRAVES ABRASION SNICKERS)
          (CRAVES EXCITEMENT SNICKERS)
          (EATS TOFU SHRIMP)
          (CRAVES SCIATICA HAM)
          (EATS SNICKERS POPOVER)
          (EATS HAM SNICKERS)
          (ATTACKS BAVARIA BOSNIA)
          (CRAVES GRIEF CHICKEN)
          (EATS PISTACHIO MUFFIN)
          (CRAVES LONELINESS HAROSET)
          (CRAVES BOILS-4 MUFFIN)
          (EATS HAROSET PISTACHIO)
          (CRAVES BOILS HAROSET)
          (EATS SHRIMP POPOVER)
          (EATS SNICKERS HAM)
          (LOCALE PISTACHIO BAVARIA)
          (LOCALE MUFFIN BAVARIA)
          (EATS HAM PISTACHIO)
          (CRAVES HANGOVER-2 SNICKERS)
          (EATS TOFU CHICKEN)
          (CRAVES ANGINA SHRIMP)
          (CRAVES PROSTATITIS SHRIMP)
          (EATS MUFFIN SNICKERS)
          (LOCALE SNICKERS BAVARIA)
          (LOCALE SHRIMP BAVARIA)
          (EATS PISTACHIO HAROSET)
          (EATS CHICKEN TOFU)
          (LOCALE HAM BAVARIA)
          (EATS POPOVER SNICKERS)
          (ORBITS NEPTUNE MARS)
          (EATS SNICKERS HAROSET)
          (CRAVES ANGER SHRIMP)
          (CRAVES LEARNING HAROSET)
          (EATS PISTACHIO ENDIVE)
          (LOCALE CHICKEN MANITOBA)
          (EATS CHICKEN POPOVER)
          (ORBITS JUPITER NEPTUNE)
          (EATS POPOVER CHICKEN)
          (CRAVES LACERATION POPOVER)
          (EATS HAROSET SNICKERS)
          (CRAVES HANGOVER CHICKEN)
          (EATS SNICKERS MUFFIN)
          (ORBITS PLUTO JUPITER)
          (HARMONY EXCITEMENT JUPITER)
          (LOCALE HAROSET BAVARIA)
          (EATS SHRIMP MUFFIN))
   (:GOAL (AND (CRAVES LONELINESS TOFU))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-23)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS ORANGE WURST HAROSET HOTDOG GRAPEFRUIT KALE CHOCOLATE
             PEA PEAR ONION SNICKERS CURIOSITY LUBRICITY EXCITEMENT
             GRIEF PROSTATITIS SCIATICA DREAD HANGOVER DEPRESSION
             ABRASION LACERATION ANGER BOILS LONELINESS OREGON GOIAS BAVARIA
             KENTUCKY MANITOBA ARIZONA MORAVIA PLUTO URANUS MARS EARTH)
   (:INIT (FOOD ORANGE)
          (FOOD WURST)
          (FOOD HAROSET)
          (FOOD HOTDOG)
          (FOOD GRAPEFRUIT)
          (FOOD KALE)
          (FOOD CHOCOLATE)
          (FOOD PEA)
          (FOOD PEAR)
          (FOOD ONION)
          (FOOD SNICKERS)
          (PLEASURE CURIOSITY)
          (PLEASURE LUBRICITY)
          (PLEASURE EXCITEMENT)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN SCIATICA)
          (PAIN DREAD)
          (PAIN HANGOVER)
          (PAIN DEPRESSION)
          (PAIN ABRASION)
          (PAIN LACERATION)
          (PAIN ANGER)
          (PAIN BOILS)
          (PAIN LONELINESS)
          (PROVINCE OREGON)
          (PROVINCE GOIAS)
          (PROVINCE BAVARIA)
          (PROVINCE KENTUCKY)
          (PROVINCE MANITOBA)
          (PROVINCE ARIZONA)
          (PROVINCE MORAVIA)
          (PLANET PLUTO)
          (PLANET URANUS)
          (PLANET MARS)
          (PLANET EARTH)
          (ORBITS PLUTO URANUS)
          (LOCALE CHOCOLATE BAVARIA)
          (EATS GRAPEFRUIT HAROSET)
          (LOCALE HAROSET KENTUCKY)
          (EATS KALE PEAR)
          (HARMONY EXCITEMENT URANUS)
          (CRAVES DREAD HOTDOG)
          (CRAVES LUBRICITY HAROSET)
          (EATS ONION SNICKERS)
          (ATTACKS BAVARIA KENTUCKY)
          (ORBITS MARS EARTH)
          (EATS PEAR KALE)
          (EATS HOTDOG GRAPEFRUIT)
          (ATTACKS KENTUCKY MANITOBA)
          (EATS PEAR HAROSET)
          (CRAVES LACERATION PEA)
          (ATTACKS ARIZONA MORAVIA)
          (LOCALE HOTDOG GOIAS)
          (EATS SNICKERS PEA)
          (ATTACKS MANITOBA ARIZONA)
          (EATS ORANGE WURST)
          (CRAVES EXCITEMENT PEA)
          (CRAVES LONELINESS SNICKERS)
          (CRAVES SCIATICA HAROSET)
          (LOCALE ONION GOIAS)
          (EATS SNICKERS ONION)
          (CRAVES PROSTATITIS WURST)
          (CRAVES HANGOVER GRAPEFRUIT)
          (EATS HOTDOG HAROSET)
          (EATS KALE CHOCOLATE)
          (EATS WURST ORANGE)
          (CRAVES ABRASION CHOCOLATE)
          (CRAVES CURIOSITY WURST)
          (CRAVES ANGER PEAR)
          (ORBITS URANUS MARS)
          (EATS PEA SNICKERS)
          (HARMONY CURIOSITY EARTH)
          (LOCALE WURST ARIZONA)
          (LOCALE GRAPEFRUIT MORAVIA)
          (EATS HAROSET PEAR)
          (LOCALE KALE MANITOBA)
          (HARMONY LUBRICITY URANUS)
          (LOCALE ORANGE MANITOBA)
          (LOCALE PEAR MANITOBA)
          (EATS CHOCOLATE PEA)
          (ATTACKS GOIAS BAVARIA)
          (EATS HAROSET GRAPEFRUIT)
          (EATS HAROSET HOTDOG)
          (EATS HAROSET ORANGE)
          (EATS ORANGE HAROSET)
          (EATS ONION PEAR)
          (EATS PEAR ONION)
          (ATTACKS OREGON GOIAS)
          (LOCALE SNICKERS GOIAS)
          (CRAVES GRIEF ORANGE)
          (EATS GRAPEFRUIT WURST)
          (LOCALE PEA GOIAS)
          (EATS PEA CHOCOLATE)
          (EATS CHOCOLATE KALE)
          (CRAVES DEPRESSION KALE)
          (CRAVES BOILS ONION)
          (EATS WURST GRAPEFRUIT)
          (EATS GRAPEFRUIT HOTDOG))
   (:GOAL (AND (CRAVES LONELINESS ONION))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-24)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS HAM TURKEY LOBSTER SCALLION CHERRY PEA TOMATO CURIOSITY
             LOVE LEARNING DREAD DEPRESSION MORAVIA ALSACE MANITOBA
             JUPITER VENUS URANUS SATURN)
   (:INIT (FOOD HAM)
          (FOOD TURKEY)
          (FOOD LOBSTER)
          (FOOD SCALLION)
          (FOOD CHERRY)
          (FOOD PEA)
          (FOOD TOMATO)
          (PLEASURE CURIOSITY)
          (PLEASURE LOVE)
          (PLEASURE LEARNING)
          (PAIN DREAD)
          (PAIN DEPRESSION)
          (PROVINCE MORAVIA)
          (PROVINCE ALSACE)
          (PROVINCE MANITOBA)
          (PLANET JUPITER)
          (PLANET VENUS)
          (PLANET URANUS)
          (PLANET SATURN)
          (HARMONY CURIOSITY URANUS)
          (CRAVES CURIOSITY HAM)
          (EATS TURKEY HAM)
          (EATS LOBSTER TOMATO)
          (EATS LOBSTER PEA)
          (CRAVES LEARNING PEA)
          (ATTACKS ALSACE MANITOBA)
          (LOCALE CHERRY MANITOBA)
          (LOCALE TURKEY MANITOBA)
          (HARMONY LEARNING SATURN)
          (LOCALE LOBSTER MANITOBA)
          (EATS CHERRY PEA)
          (EATS LOBSTER SCALLION)
          (EATS SCALLION LOBSTER)
          (CRAVES DEPRESSION PEA)
          (EATS HAM TURKEY)
          (EATS PEA CHERRY)
          (EATS SCALLION TURKEY)
          (LOCALE SCALLION MANITOBA)
          (LOCALE TOMATO ALSACE)
          (ORBITS VENUS URANUS)
          (EATS TURKEY SCALLION)
          (LOCALE PEA MANITOBA)
          (CRAVES DREAD SCALLION)
          (ORBITS JUPITER VENUS)
          (CRAVES LOVE LOBSTER)
          (EATS HAM TOMATO)
          (ORBITS URANUS SATURN)
          (EATS TOMATO LOBSTER)
          (EATS CHERRY SCALLION)
          (LOCALE HAM ALSACE)
          (EATS PEA LOBSTER)
          (EATS SCALLION CHERRY)
          (HARMONY LOVE SATURN)
          (EATS TOMATO HAM)
          (ATTACKS MORAVIA ALSACE))
   (:GOAL (AND (CRAVES DEPRESSION CHERRY))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-25)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS HAM YOGURT CHOCOLATE SCALLOP PORK CHERRY FLOUNDER
             CHICKEN ARUGULA ORANGE LEMON MARZIPAN LUBRICITY EXPECTATION
             HANGOVER GRIEF PROSTATITIS ANGINA ANXIETY SCIATICA DEPRESSION
             ANGER SURREY GOIAS KENTUCKY URANUS MERCURY JUPITER EARTH)
   (:INIT (FOOD HAM)
          (FOOD YOGURT)
          (FOOD CHOCOLATE)
          (FOOD SCALLOP)
          (FOOD PORK)
          (FOOD CHERRY)
          (FOOD FLOUNDER)
          (FOOD CHICKEN)
          (FOOD ARUGULA)
          (FOOD ORANGE)
          (FOOD LEMON)
          (FOOD MARZIPAN)
          (PLEASURE LUBRICITY)
          (PLEASURE EXPECTATION)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN ANGINA)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN DEPRESSION)
          (PAIN ANGER)
          (PROVINCE SURREY)
          (PROVINCE GOIAS)
          (PROVINCE KENTUCKY)
          (PLANET URANUS)
          (PLANET MERCURY)
          (PLANET JUPITER)
          (PLANET EARTH)
          (EATS PORK YOGURT)
          (CRAVES LUBRICITY FLOUNDER)
          (LOCALE ORANGE SURREY)
          (CRAVES ANXIETY CHERRY)
          (EATS CHICKEN ARUGULA)
          (EATS SCALLOP YOGURT)
          (EATS CHERRY HAM)
          (EATS ARUGULA CHICKEN)
          (EATS ORANGE LEMON)
          (EATS FLOUNDER SCALLOP)
          (HARMONY LUBRICITY MERCURY)
          (LOCALE CHOCOLATE KENTUCKY)
          (EATS MARZIPAN LEMON)
          (EATS ORANGE CHICKEN)
          (EATS YOGURT SCALLOP)
          (ORBITS JUPITER EARTH)
          (EATS MARZIPAN ARUGULA)
          (EATS CHERRY PORK)
          (EATS FLOUNDER CHOCOLATE)
          (EATS HAM LEMON)
          (CRAVES EXPECTATION ORANGE)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS LEMON ORANGE)
          (CRAVES PROSTATITIS SCALLOP)
          (LOCALE CHICKEN SURREY)
          (CRAVES ANGINA CHERRY)
          (LOCALE PORK GOIAS)
          (EATS HAM CHERRY)
          (ORBITS URANUS MERCURY)
          (EATS CHOCOLATE HAM)
          (LOCALE YOGURT GOIAS)
          (LOCALE HAM KENTUCKY)
          (LOCALE SCALLOP SURREY)
          (LOCALE CHERRY GOIAS)
          (ORBITS MERCURY JUPITER)
          (HARMONY EXPECTATION EARTH)
          (EATS ARUGULA MARZIPAN)
          (LOCALE LEMON KENTUCKY)
          (EATS LEMON YOGURT)
          (EATS YOGURT PORK)
          (EATS CHOCOLATE FLOUNDER)
          (EATS YOGURT LEMON)
          (LOCALE FLOUNDER GOIAS)
          (ATTACKS SURREY GOIAS)
          (EATS CHICKEN ORANGE)
          (CRAVES DEPRESSION ARUGULA)
          (LOCALE ARUGULA SURREY)
          (CRAVES GRIEF CHOCOLATE)
          (EATS PORK CHERRY)
          (ATTACKS GOIAS KENTUCKY)
          (EATS HAM CHOCOLATE)
          (EATS LEMON HAM)
          (CRAVES SCIATICA ARUGULA)
          (EATS LEMON MARZIPAN)
          (EATS SCALLOP FLOUNDER)
          (CRAVES HANGOVER CHOCOLATE)
          (CRAVES ANGER ORANGE))
   (:GOAL (AND (CRAVES SCIATICA ORANGE))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-26)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TOMATO GRAPEFRUIT PEAR CHICKEN SCALLION SHRIMP RICE
             BROCCOLI MUTTON HAM ARUGULA CUCUMBER KALE LETTUCE WONDERBREAD
             MARZIPAN TUNA COD UNDERSTANDING JEALOUSY HANGOVER ANGER ANXIETY
             ANGINA BOILS LONELINESS SCIATICA LACERATION GRIEF ABRASION
             PROSTATITIS KENTUCKY MORAVIA BAVARIA GUANABARA ALSACE MERCURY
             JUPITER EARTH MARS)
   (:INIT (FOOD TOMATO)
          (FOOD GRAPEFRUIT)
          (FOOD PEAR)
          (FOOD CHICKEN)
          (FOOD SCALLION)
          (FOOD SHRIMP)
          (FOOD RICE)
          (FOOD BROCCOLI)
          (FOOD MUTTON)
          (FOOD HAM)
          (FOOD ARUGULA)
          (FOOD CUCUMBER)
          (FOOD KALE)
          (FOOD LETTUCE)
          (FOOD WONDERBREAD)
          (FOOD MARZIPAN)
          (FOOD TUNA)
          (FOOD COD)
          (PLEASURE UNDERSTANDING)
          (PAIN JEALOUSY)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN ANXIETY)
          (PAIN ANGINA)
          (PAIN BOILS)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN LACERATION)
          (PAIN GRIEF)
          (PAIN ABRASION)
          (PAIN PROSTATITIS)
          (PROVINCE KENTUCKY)
          (PROVINCE MORAVIA)
          (PROVINCE BAVARIA)
          (PROVINCE GUANABARA)
          (PROVINCE ALSACE)
          (PLANET MERCURY)
          (PLANET JUPITER)
          (PLANET EARTH)
          (PLANET MARS)
          (LOCALE KALE BAVARIA)
          (CRAVES JEALOUSY GRAPEFRUIT)
          (EATS WONDERBREAD LETTUCE)
          (EATS MUTTON LETTUCE)
          (EATS LETTUCE TUNA)
          (ORBITS JUPITER EARTH)
          (LOCALE TUNA KENTUCKY)
          (EATS TOMATO CHICKEN)
          (CRAVES ANGINA MUTTON)
          (ATTACKS GUANABARA ALSACE)
          (CRAVES ANXIETY RICE)
          (EATS SCALLION GRAPEFRUIT)
          (CRAVES ANGER SHRIMP)
          (EATS WONDERBREAD COD)
          (LOCALE COD BAVARIA)
          (EATS BROCCOLI MUTTON)
          (LOCALE WONDERBREAD MORAVIA)
          (EATS TUNA LETTUCE)
          (ATTACKS MORAVIA BAVARIA)
          (EATS CUCUMBER COD)
          (EATS RICE BROCCOLI)
          (EATS BROCCOLI RICE)
          (EATS PEAR TOMATO)
          (EATS TUNA MARZIPAN)
          (CRAVES BOILS HAM)
          (EATS KALE CUCUMBER)
          (EATS GRAPEFRUIT SCALLION)
          (LOCALE CHICKEN MORAVIA)
          (EATS CUCUMBER KALE)
          (CRAVES LACERATION KALE)
          (LOCALE CUCUMBER GUANABARA)
          (CRAVES GRIEF LETTUCE)
          (EATS SCALLION CHICKEN)
          (LOCALE SHRIMP BAVARIA)
          (EATS MUTTON HAM)
          (EATS TUNA KALE)
          (EATS LETTUCE KALE)
          (CRAVES ABRASION WONDERBREAD)
          (CRAVES LONELINESS ARUGULA)
          (EATS COD WONDERBREAD)
          (ORBITS EARTH MARS)
          (EATS HAM SHRIMP)
          (EATS SCALLION BROCCOLI)
          (ATTACKS KENTUCKY MORAVIA)
          (EATS GRAPEFRUIT PEAR)
          (EATS CHICKEN TOMATO)
          (CRAVES HANGOVER PEAR)
          (ORBITS MERCURY JUPITER)
          (EATS MUTTON BROCCOLI)
          (EATS SHRIMP RICE)
          (LOCALE HAM MORAVIA)
          (LOCALE GRAPEFRUIT MORAVIA)
          (LOCALE ARUGULA KENTUCKY)
          (LOCALE TOMATO BAVARIA)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS CHICKEN SCALLION)
          (EATS ARUGULA MARZIPAN)
          (EATS PEAR GRAPEFRUIT)
          (EATS RICE SHRIMP)
          (EATS LETTUCE MUTTON)
          (HARMONY UNDERSTANDING MARS)
          (EATS HAM MUTTON)
          (EATS KALE LETTUCE)
          (LOCALE PEAR MORAVIA)
          (CRAVES UNDERSTANDING ARUGULA)
          (LOCALE MUTTON ALSACE)
          (CRAVES SCIATICA CUCUMBER)
          (EATS LETTUCE WONDERBREAD)
          (EATS SHRIMP HAM)
          (EATS TOMATO PEAR)
          (LOCALE BROCCOLI MORAVIA)
          (CRAVES PROSTATITIS TUNA)
          (EATS ARUGULA WONDERBREAD)
          (LOCALE LETTUCE KENTUCKY)
          (ATTACKS BAVARIA GUANABARA)
          (EATS WONDERBREAD ARUGULA)
          (LOCALE RICE ALSACE)
          (LOCALE SCALLION BAVARIA)
          (EATS BROCCOLI SCALLION)
          (EATS COD CUCUMBER)
          (EATS MARZIPAN TUNA)
          (EATS MARZIPAN ARUGULA)
          (EATS KALE TUNA))
   (:GOAL (AND (CRAVES SCIATICA CHICKEN))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-27)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LEMON WURST GRAPEFRUIT CHERRY PEPPER LAMB POPOVER
             LETTUCE BEEF ARUGULA ENDIVE LOBSTER WONDERBREAD SNICKERS
             MARZIPAN RICE TURKEY REST ENTERTAINMENT STIMULATION
             ACHIEVEMENT EXPECTATION CURIOSITY SATISFACTION LUBRICITY
             DEPRESSION ANGINA JEALOUSY ANXIETY SCIATICA ABRASION BOILS
             LONELINESS HANGOVER ANGER PROSTATITIS GRIEF DREAD LACERATION
             HANGOVER-4 BOILS-1 ANGINA-2 JEALOUSY-6 LACERATION-7 ABRASION-8
             ANGER-3 ANXIETY-5 SCIATICA-13 LONELINESS-14 GRIEF-15
             DREAD-16 GRIEF-32 BOILS-9 ANGINA-10 PROSTATITIS-11
             DEPRESSION-12 DREAD-31 DEPRESSION-27 SCIATICA-28 HANGOVER-29
             ANGER-30 JEALOUSY-25 PROSTATITIS-26 ALSACE BOSNIA MORAVIA
             OREGON URANUS EARTH VENUS SATURN)
   (:INIT (FOOD LEMON)
          (FOOD WURST)
          (FOOD GRAPEFRUIT)
          (FOOD CHERRY)
          (FOOD PEPPER)
          (FOOD LAMB)
          (FOOD POPOVER)
          (FOOD LETTUCE)
          (FOOD BEEF)
          (FOOD ARUGULA)
          (FOOD ENDIVE)
          (FOOD LOBSTER)
          (FOOD WONDERBREAD)
          (FOOD SNICKERS)
          (FOOD MARZIPAN)
          (FOOD RICE)
          (FOOD TURKEY)
          (PLEASURE REST)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE STIMULATION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE CURIOSITY)
          (PLEASURE SATISFACTION)
          (PLEASURE LUBRICITY)
          (PAIN DEPRESSION)
          (PAIN ANGINA)
          (PAIN JEALOUSY)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN ABRASION)
          (PAIN BOILS)
          (PAIN LONELINESS)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN PROSTATITIS)
          (PAIN GRIEF)
          (PAIN DREAD)
          (PAIN LACERATION)
          (PAIN HANGOVER-4)
          (PAIN BOILS-1)
          (PAIN ANGINA-2)
          (PAIN JEALOUSY-6)
          (PAIN LACERATION-7)
          (PAIN ABRASION-8)
          (PAIN ANGER-3)
          (PAIN ANXIETY-5)
          (PAIN SCIATICA-13)
          (PAIN LONELINESS-14)
          (PAIN GRIEF-15)
          (PAIN DREAD-16)
          (PAIN GRIEF-32)
          (PAIN BOILS-9)
          (PAIN ANGINA-10)
          (PAIN PROSTATITIS-11)
          (PAIN DEPRESSION-12)
          (PAIN DREAD-31)
          (PAIN DEPRESSION-27)
          (PAIN SCIATICA-28)
          (PAIN HANGOVER-29)
          (PAIN ANGER-30)
          (PAIN JEALOUSY-25)
          (PAIN PROSTATITIS-26)
          (PROVINCE ALSACE)
          (PROVINCE BOSNIA)
          (PROVINCE MORAVIA)
          (PROVINCE OREGON)
          (PLANET URANUS)
          (PLANET EARTH)
          (PLANET VENUS)
          (PLANET SATURN)
          (EATS CHERRY LEMON)
          (LOCALE WONDERBREAD OREGON)
          (LOCALE ARUGULA OREGON)
          (LOCALE LETTUCE ALSACE)
          (EATS SNICKERS ARUGULA)
          (ORBITS VENUS SATURN)
          (EATS LETTUCE BEEF)
          (CRAVES ANGINA-2 LAMB)
          (EATS RICE MARZIPAN)
          (CRAVES GRIEF PEPPER)
          (EATS TURKEY ENDIVE)
          (LOCALE MARZIPAN BOSNIA)
          (EATS POPOVER LEMON)
          (CRAVES HANGOVER CHERRY)
          (EATS LAMB POPOVER)
          (EATS ENDIVE TURKEY)
          (CRAVES SCIATICA-13 ARUGULA)
          (CRAVES SCIATICA GRAPEFRUIT)
          (CRAVES ABRASION CHERRY)
          (LOCALE GRAPEFRUIT OREGON)
          (HARMONY ACHIEVEMENT SATURN)
          (CRAVES BOILS-1 LAMB)
          (LOCALE POPOVER OREGON)
          (LOCALE LEMON OREGON)
          (EATS TURKEY SNICKERS)
          (EATS GRAPEFRUIT CHERRY)
          (CRAVES PROSTATITIS-26 TURKEY)
          (EATS LEMON PEPPER)
          (CRAVES LONELINESS-14 ARUGULA)
          (CRAVES ANGINA WURST)
          (EATS WURST GRAPEFRUIT)
          (CRAVES HANGOVER-4 LAMB)
          (EATS LETTUCE POPOVER)
          (CRAVES GRIEF-32 ENDIVE)
          (CRAVES LONELINESS CHERRY)
          (CRAVES BOILS CHERRY)
          (CRAVES ANGER-3 POPOVER)
          (EATS LEMON POPOVER)
          (EATS LOBSTER WONDERBREAD)
          (CRAVES CURIOSITY BEEF)
          (CRAVES LACERATION-7 POPOVER)
          (LOCALE BEEF OREGON)
          (ATTACKS ALSACE BOSNIA)
          (CRAVES PROSTATITIS-11 ENDIVE)
          (LOCALE WURST BOSNIA)
          (CRAVES EXPECTATION POPOVER)
          (HARMONY CURIOSITY EARTH)
          (EATS SNICKERS TURKEY)
          (EATS MARZIPAN BEEF)
          (LOCALE PEPPER BOSNIA)
          (EATS ARUGULA SNICKERS)
          (LOCALE RICE BOSNIA)
          (HARMONY REST VENUS)
          (EATS WONDERBREAD RICE)
          (CRAVES ANXIETY-5 LETTUCE)
          (EATS ARUGULA MARZIPAN)
          (EATS PEPPER LEMON)
          (CRAVES DREAD PEPPER)
          (CRAVES REST LEMON)
          (LOCALE LOBSTER ALSACE)
          (CRAVES ACHIEVEMENT LAMB)
          (EATS WONDERBREAD TURKEY)
          (EATS BEEF LETTUCE)
          (ATTACKS MORAVIA OREGON)
          (CRAVES DEPRESSION LEMON)
          (CRAVES HANGOVER-29 MARZIPAN)
          (EATS GRAPEFRUIT WURST)
          (CRAVES LACERATION PEPPER)
          (CRAVES STIMULATION CHERRY)
          (CRAVES SATISFACTION LOBSTER)
          (CRAVES ABRASION-8 POPOVER)
          (CRAVES SCIATICA-28 MARZIPAN)
          (CRAVES ANGER CHERRY)
          (EATS WONDERBREAD LOBSTER)
          (CRAVES JEALOUSY WURST)
          (EATS CHERRY GRAPEFRUIT)
          (CRAVES BOILS-9 ENDIVE)
          (EATS MARZIPAN LOBSTER)
          (ATTACKS BOSNIA MORAVIA)
          (CRAVES ANGER-30 MARZIPAN)
          (CRAVES DEPRESSION-27 MARZIPAN)
          (HARMONY LUBRICITY SATURN)
          (EATS RICE ENDIVE)
          (CRAVES LUBRICITY MARZIPAN)
          (ORBITS EARTH VENUS)
          (EATS RICE WONDERBREAD)
          (EATS LAMB BEEF)
          (EATS PEPPER WURST)
          (CRAVES GRIEF-15 ARUGULA)
          (CRAVES ANXIETY GRAPEFRUIT)
          (EATS LEMON CHERRY)
          (CRAVES ENTERTAINMENT GRAPEFRUIT)
          (LOCALE TURKEY ALSACE)
          (LOCALE ENDIVE OREGON)
          (LOCALE SNICKERS BOSNIA)
          (CRAVES PROSTATITIS PEPPER)
          (EATS BEEF MARZIPAN)
          (EATS BEEF LAMB)
          (LOCALE LAMB MORAVIA)
          (EATS POPOVER LETTUCE)
          (CRAVES DREAD-16 ARUGULA)
          (CRAVES JEALOUSY-6 POPOVER)
          (EATS MARZIPAN ARUGULA)
          (HARMONY SATISFACTION VENUS)
          (EATS LOBSTER MARZIPAN)
          (EATS TURKEY WONDERBREAD)
          (CRAVES DEPRESSION-12 ENDIVE)
          (EATS MARZIPAN RICE)
          (HARMONY STIMULATION EARTH)
          (EATS POPOVER LAMB)
          (CRAVES ANGINA-10 ENDIVE)
          (ORBITS URANUS EARTH)
          (LOCALE CHERRY OREGON)
          (CRAVES DREAD-31 WONDERBREAD)
          (CRAVES JEALOUSY-25 TURKEY)
          (EATS WURST PEPPER)
          (EATS ENDIVE RICE)
          (HARMONY ENTERTAINMENT SATURN)
          (HARMONY EXPECTATION VENUS))
   (:GOAL (AND (CRAVES LACERATION WURST))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-28)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS BEEF BROCCOLI MELON OKRA PAPAYA LETTUCE HAMBURGER
             POPOVER SCALLOP CHOCOLATE SHRIMP YOGURT ORANGE SNICKERS
             LOBSTER PEA LEMON INTOXICATION SATIETY EXPECTATION EMPATHY
             ENTERTAINMENT ACHIEVEMENT CURIOSITY DEPRESSION GRIEF PROSTATITIS
             LONELINESS ABRASION DREAD SCIATICA HANGOVER LACERATION JEALOUSY
             ANXIETY ANGER BOILS ANGINA LACERATION-2 HANGOVER-4 ANGER-1
             BAVARIA GUANABARA QUEBEC PLUTO VENUS EARTH SATURN)
   (:INIT (FOOD BEEF)
          (FOOD BROCCOLI)
          (FOOD MELON)
          (FOOD OKRA)
          (FOOD PAPAYA)
          (FOOD LETTUCE)
          (FOOD HAMBURGER)
          (FOOD POPOVER)
          (FOOD SCALLOP)
          (FOOD CHOCOLATE)
          (FOOD SHRIMP)
          (FOOD YOGURT)
          (FOOD ORANGE)
          (FOOD SNICKERS)
          (FOOD LOBSTER)
          (FOOD PEA)
          (FOOD LEMON)
          (PLEASURE INTOXICATION)
          (PLEASURE SATIETY)
          (PLEASURE EXPECTATION)
          (PLEASURE EMPATHY)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE CURIOSITY)
          (PAIN DEPRESSION)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN HANGOVER)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN ANXIETY)
          (PAIN ANGER)
          (PAIN BOILS)
          (PAIN ANGINA)
          (PAIN LACERATION-2)
          (PAIN HANGOVER-4)
          (PAIN ANGER-1)
          (PROVINCE BAVARIA)
          (PROVINCE GUANABARA)
          (PROVINCE QUEBEC)
          (PLANET PLUTO)
          (PLANET VENUS)
          (PLANET EARTH)
          (PLANET SATURN)
          (EATS MELON BEEF)
          (CRAVES PROSTATITIS MELON)
          (LOCALE OKRA QUEBEC)
          (LOCALE ORANGE GUANABARA)
          (EATS POPOVER SNICKERS)
          (HARMONY EMPATHY EARTH)
          (LOCALE BROCCOLI GUANABARA)
          (HARMONY ACHIEVEMENT VENUS)
          (CRAVES GRIEF BROCCOLI)
          (EATS ORANGE SCALLOP)
          (LOCALE SCALLOP GUANABARA)
          (EATS ORANGE MELON)
          (EATS SHRIMP HAMBURGER)
          (EATS SNICKERS CHOCOLATE)
          (CRAVES ANXIETY CHOCOLATE)
          (CRAVES JEALOUSY POPOVER)
          (EATS LOBSTER ORANGE)
          (EATS HAMBURGER SHRIMP)
          (CRAVES ABRASION OKRA)
          (EATS BROCCOLI MELON)
          (EATS PEA SCALLOP)
          (CRAVES DREAD LETTUCE)
          (HARMONY INTOXICATION EARTH)
          (ORBITS VENUS EARTH)
          (EATS SNICKERS POPOVER)
          (EATS YOGURT PEA)
          (EATS BEEF PAPAYA)
          (LOCALE CHOCOLATE QUEBEC)
          (ATTACKS BAVARIA GUANABARA)
          (CRAVES INTOXICATION BEEF)
          (CRAVES ENTERTAINMENT POPOVER)
          (LOCALE SHRIMP GUANABARA)
          (EATS PEA YOGURT)
          (LOCALE LOBSTER GUANABARA)
          (EATS ORANGE SHRIMP)
          (EATS BEEF OKRA)
          (ORBITS PLUTO VENUS)
          (CRAVES SCIATICA LETTUCE)
          (EATS PEA LEMON)
          (LOCALE MELON BAVARIA)
          (ATTACKS GUANABARA QUEBEC)
          (EATS SHRIMP ORANGE)
          (LOCALE YOGURT GUANABARA)
          (HARMONY ENTERTAINMENT VENUS)
          (CRAVES ANGER CHOCOLATE)
          (EATS LOBSTER YOGURT)
          (CRAVES EMPATHY LETTUCE)
          (EATS POPOVER SHRIMP)
          (LOCALE LEMON QUEBEC)
          (HARMONY SATIETY EARTH)
          (CRAVES HANGOVER HAMBURGER)
          (EATS OKRA PAPAYA)
          (EATS CHOCOLATE SHRIMP)
          (LOCALE POPOVER GUANABARA)
          (HARMONY EXPECTATION SATURN)
          (LOCALE PEA GUANABARA)
          (EATS OKRA MELON)
          (HARMONY CURIOSITY SATURN)
          (CRAVES ANGER-1 PEA)
          (LOCALE LETTUCE QUEBEC)
          (EATS LETTUCE PAPAYA)
          (CRAVES DEPRESSION BEEF)
          (CRAVES BOILS CHOCOLATE)
          (EATS BEEF MELON)
          (EATS POPOVER LEMON)
          (EATS BROCCOLI LETTUCE)
          (EATS PAPAYA OKRA)
          (EATS MELON OKRA)
          (CRAVES LONELINESS OKRA)
          (EATS SCALLOP ORANGE)
          (EATS HAMBURGER LEMON)
          (CRAVES SATIETY BROCCOLI)
          (LOCALE BEEF QUEBEC)
          (CRAVES CURIOSITY SNICKERS)
          (EATS YOGURT LOBSTER)
          (EATS LEMON HAMBURGER)
          (LOCALE PAPAYA QUEBEC)
          (EATS SHRIMP CHOCOLATE)
          (EATS PAPAYA BEEF)
          (EATS SHRIMP POPOVER)
          (EATS MELON ORANGE)
          (EATS LEMON PEA)
          (CRAVES ANGINA YOGURT)
          (CRAVES LACERATION POPOVER)
          (CRAVES HANGOVER-4 PEA)
          (ORBITS EARTH SATURN)
          (EATS MELON BROCCOLI)
          (EATS OKRA BEEF)
          (EATS PAPAYA LETTUCE)
          (EATS CHOCOLATE SNICKERS)
          (LOCALE HAMBURGER GUANABARA)
          (CRAVES LACERATION-2 LOBSTER)
          (CRAVES EXPECTATION OKRA)
          (LOCALE SNICKERS BAVARIA)
          (EATS LETTUCE BROCCOLI)
          (EATS LEMON POPOVER)
          (EATS ORANGE LOBSTER)
          (EATS SCALLOP PEA)
          (CRAVES ACHIEVEMENT SCALLOP))
   (:GOAL (AND (CRAVES ANGINA LOBSTER))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-29)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS OKRA BROCCOLI TOFU ORANGE PISTACHIO GRAPEFRUIT BEEF
             SCALLOP APPLE HAM MARZIPAN BACON SHRIMP PAPAYA CHERRY COD
             STIMULATION ENTERTAINMENT PROSTATITIS LACERATION ABRASION
             HANGOVER GRIEF LONELINESS DREAD DEPRESSION ANXIETY SCIATICA
             GRIEF-2 ANGINA JEALOUSY ANGER BOILS PROSTATITIS-1
             DEPRESSION-7 HANGOVER-8 LACERATION-3 DREAD-4 ABRASION-16 ANGINA-5
             ANGER-6 JEALOUSY-15 BOILS-12 SCIATICA-13 LONELINESS-14
             ANXIETY-11 LONELINESS-31 BOILS-32 GRIEF-9 SCIATICA-10
             ABRASION-28 ANXIETY-29 DREAD-30 BOSNIA ARIZONA OREGON QUEBEC
             MANITOBA GUANABARA KENTUCKY BAVARIA GOIAS URANUS EARTH MERCURY)
   (:INIT (FOOD OKRA)
          (FOOD BROCCOLI)
          (FOOD TOFU)
          (FOOD ORANGE)
          (FOOD PISTACHIO)
          (FOOD GRAPEFRUIT)
          (FOOD BEEF)
          (FOOD SCALLOP)
          (FOOD APPLE)
          (FOOD HAM)
          (FOOD MARZIPAN)
          (FOOD BACON)
          (FOOD SHRIMP)
          (FOOD PAPAYA)
          (FOOD CHERRY)
          (FOOD COD)
          (PLEASURE STIMULATION)
          (PLEASURE ENTERTAINMENT)
          (PAIN PROSTATITIS)
          (PAIN LACERATION)
          (PAIN ABRASION)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN LONELINESS)
          (PAIN DREAD)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN GRIEF-2)
          (PAIN ANGINA)
          (PAIN JEALOUSY)
          (PAIN ANGER)
          (PAIN BOILS)
          (PAIN PROSTATITIS-1)
          (PAIN DEPRESSION-7)
          (PAIN HANGOVER-8)
          (PAIN LACERATION-3)
          (PAIN DREAD-4)
          (PAIN ABRASION-16)
          (PAIN ANGINA-5)
          (PAIN ANGER-6)
          (PAIN JEALOUSY-15)
          (PAIN BOILS-12)
          (PAIN SCIATICA-13)
          (PAIN LONELINESS-14)
          (PAIN ANXIETY-11)
          (PAIN LONELINESS-31)
          (PAIN BOILS-32)
          (PAIN GRIEF-9)
          (PAIN SCIATICA-10)
          (PAIN ABRASION-28)
          (PAIN ANXIETY-29)
          (PAIN DREAD-30)
          (PROVINCE BOSNIA)
          (PROVINCE ARIZONA)
          (PROVINCE OREGON)
          (PROVINCE QUEBEC)
          (PROVINCE MANITOBA)
          (PROVINCE GUANABARA)
          (PROVINCE KENTUCKY)
          (PROVINCE BAVARIA)
          (PROVINCE GOIAS)
          (PLANET URANUS)
          (PLANET EARTH)
          (PLANET MERCURY)
          (CRAVES PROSTATITIS OKRA)
          (EATS COD SHRIMP)
          (EATS SHRIMP BACON)
          (LOCALE GRAPEFRUIT KENTUCKY)
          (EATS APPLE HAM)
          (EATS OKRA BROCCOLI)
          (CRAVES ANGINA PISTACHIO)
          (CRAVES ANGINA-5 APPLE)
          (CRAVES BOILS-12 BACON)
          (HARMONY STIMULATION MERCURY)
          (CRAVES GRIEF-2 PISTACHIO)
          (CRAVES SCIATICA TOFU)
          (EATS APPLE BEEF)
          (EATS ORANGE OKRA)
          (EATS PAPAYA BACON)
          (CRAVES PROSTATITIS-1 GRAPEFRUIT)
          (CRAVES ABRASION OKRA)
          (EATS TOFU BROCCOLI)
          (ATTACKS MANITOBA GUANABARA)
          (EATS GRAPEFRUIT APPLE)
          (CRAVES ANXIETY-29 COD)
          (CRAVES DEPRESSION-7 SCALLOP)
          (ORBITS URANUS EARTH)
          (CRAVES LONELINESS-31 PAPAYA)
          (EATS TOFU ORANGE)
          (EATS BEEF SCALLOP)
          (LOCALE OKRA QUEBEC)
          (LOCALE SHRIMP KENTUCKY)
          (EATS MARZIPAN SCALLOP)
          (CRAVES LONELINESS-14 BACON)
          (CRAVES ANGER-6 APPLE)
          (EATS SCALLOP MARZIPAN)
          (EATS GRAPEFRUIT OKRA)
          (CRAVES STIMULATION PISTACHIO)
          (ATTACKS GUANABARA KENTUCKY)
          (LOCALE HAM GUANABARA)
          (CRAVES DEPRESSION BROCCOLI)
          (CRAVES ABRASION-28 COD)
          (CRAVES LONELINESS BROCCOLI)
          (LOCALE PAPAYA MANITOBA)
          (EATS HAM PISTACHIO)
          (EATS BACON APPLE)
          (EATS CHERRY COD)
          (CRAVES LACERATION-3 SCALLOP)
          (CRAVES JEALOUSY-15 HAM)
          (CRAVES ENTERTAINMENT HAM)
          (LOCALE APPLE QUEBEC)
          (HARMONY ENTERTAINMENT MERCURY)
          (EATS CHERRY PAPAYA)
          (ATTACKS KENTUCKY BAVARIA)
          (CRAVES ABRASION-16 APPLE)
          (CRAVES GRIEF OKRA)
          (EATS SHRIMP COD)
          (CRAVES DREAD-4 SCALLOP)
          (ATTACKS OREGON QUEBEC)
          (CRAVES HANGOVER-8 SCALLOP)
          (CRAVES JEALOUSY PISTACHIO)
          (EATS OKRA GRAPEFRUIT)
          (ATTACKS BAVARIA GOIAS)
          (EATS PAPAYA CHERRY)
          (ATTACKS BOSNIA ARIZONA)
          (LOCALE CHERRY ARIZONA)
          (CRAVES SCIATICA-10 PAPAYA)
          (CRAVES ANXIETY-11 SHRIMP)
          (EATS BEEF APPLE)
          (EATS COD CHERRY)
          (CRAVES DREAD BROCCOLI)
          (CRAVES LACERATION OKRA)
          (CRAVES DREAD-30 COD)
          (EATS BROCCOLI OKRA)
          (EATS ORANGE TOFU)
          (EATS BROCCOLI TOFU)
          (CRAVES BOILS PISTACHIO)
          (LOCALE MARZIPAN BAVARIA)
          (EATS APPLE GRAPEFRUIT)
          (LOCALE SCALLOP BAVARIA)
          (CRAVES ANGER PISTACHIO)
          (CRAVES HANGOVER OKRA)
          (EATS GRAPEFRUIT MARZIPAN)
          (CRAVES ANXIETY TOFU)
          (EATS PISTACHIO HAM)
          (ATTACKS QUEBEC MANITOBA)
          (EATS BACON PAPAYA)
          (CRAVES SCIATICA-13 BACON)
          (LOCALE BACON GUANABARA)
          (CRAVES GRIEF-9 PAPAYA)
          (EATS APPLE BACON)
          (EATS HAM APPLE)
          (ATTACKS ARIZONA OREGON)
          (LOCALE TOFU BAVARIA)
          (EATS SCALLOP BEEF)
          (EATS MARZIPAN PISTACHIO)
          (EATS BACON SHRIMP)
          (EATS PISTACHIO MARZIPAN)
          (CRAVES BOILS-32 PAPAYA)
          (LOCALE COD ARIZONA)
          (LOCALE BEEF KENTUCKY)
          (LOCALE BROCCOLI QUEBEC)
          (LOCALE PISTACHIO GOIAS)
          (EATS MARZIPAN GRAPEFRUIT)
          (LOCALE ORANGE GUANABARA)
          (EATS OKRA ORANGE)
          (ORBITS EARTH MERCURY))
   (:GOAL (AND (CRAVES HANGOVER-8 HAM))))

(DEFINE (PROBLEM STRIPS-MYSTY-A-30)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SHRIMP ARUGULA CANTELOPE POTATO TURKEY PEA POPOVER
             CUCUMBER YOGURT GUAVA PISTACHIO HOTDOG HAM CHOCOLATE TOFU MUTTON
             CURIOSITY UNDERSTANDING AESTHETICS ENTERTAINMENT EXPECTATION
             ACHIEVEMENT PROSTATITIS LONELINESS BOILS ANXIETY DEPRESSION GRIEF
             HANGOVER SCIATICA DREAD LACERATION ANGINA JEALOUSY ANGER
             JEALOUSY-2 ABRASION DREAD-1 PENNSYLVANIA BOSNIA MANITOBA GOIAS
             QUEBEC ARIZONA GUANABARA BAVARIA MORAVIA MARS VULCAN PLUTO
             NEPTUNE)
   (:INIT (FOOD SHRIMP)
          (FOOD ARUGULA)
          (FOOD CANTELOPE)
          (FOOD POTATO)
          (FOOD TURKEY)
          (FOOD PEA)
          (FOOD POPOVER)
          (FOOD CUCUMBER)
          (FOOD YOGURT)
          (FOOD GUAVA)
          (FOOD PISTACHIO)
          (FOOD HOTDOG)
          (FOOD HAM)
          (FOOD CHOCOLATE)
          (FOOD TOFU)
          (FOOD MUTTON)
          (PLEASURE CURIOSITY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE AESTHETICS)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE ACHIEVEMENT)
          (PAIN PROSTATITIS)
          (PAIN LONELINESS)
          (PAIN BOILS)
          (PAIN ANXIETY)
          (PAIN DEPRESSION)
          (PAIN GRIEF)
          (PAIN HANGOVER)
          (PAIN SCIATICA)
          (PAIN DREAD)
          (PAIN LACERATION)
          (PAIN ANGINA)
          (PAIN JEALOUSY)
          (PAIN ANGER)
          (PAIN JEALOUSY-2)
          (PAIN ABRASION)
          (PAIN DREAD-1)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BOSNIA)
          (PROVINCE MANITOBA)
          (PROVINCE GOIAS)
          (PROVINCE QUEBEC)
          (PROVINCE ARIZONA)
          (PROVINCE GUANABARA)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PLANET MARS)
          (PLANET VULCAN)
          (PLANET PLUTO)
          (PLANET NEPTUNE)
          (LOCALE POPOVER MORAVIA)
          (EATS CUCUMBER YOGURT)
          (EATS PEA GUAVA)
          (CRAVES SCIATICA CUCUMBER)
          (EATS POPOVER MUTTON)
          (CRAVES ENTERTAINMENT HOTDOG)
          (HARMONY ENTERTAINMENT PLUTO)
          (HARMONY AESTHETICS VULCAN)
          (EATS MUTTON HAM)
          (ATTACKS QUEBEC ARIZONA)
          (CRAVES EXPECTATION TOFU)
          (CRAVES ANGER YOGURT)
          (LOCALE POTATO QUEBEC)
          (EATS CUCUMBER POPOVER)
          (CRAVES DEPRESSION ARUGULA)
          (EATS CANTELOPE POTATO)
          (EATS TOFU MUTTON)
          (HARMONY EXPECTATION PLUTO)
          (LOCALE SHRIMP GUANABARA)
          (LOCALE MUTTON GUANABARA)
          (LOCALE GUAVA GOIAS)
          (EATS YOGURT CUCUMBER)
          (LOCALE YOGURT GOIAS)
          (EATS TURKEY POTATO)
          (LOCALE HOTDOG ARIZONA)
          (EATS CANTELOPE ARUGULA)
          (CRAVES DREAD-1 MUTTON)
          (EATS POTATO CANTELOPE)
          (CRAVES HANGOVER CUCUMBER)
          (EATS YOGURT GUAVA)
          (EATS ARUGULA SHRIMP)
          (CRAVES ANXIETY ARUGULA)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS CHOCOLATE PISTACHIO)
          (HARMONY ACHIEVEMENT NEPTUNE)
          (LOCALE TURKEY MANITOBA)
          (ATTACKS ARIZONA GUANABARA)
          (LOCALE PEA GUANABARA)
          (CRAVES GRIEF POTATO)
          (LOCALE TOFU BAVARIA)
          (EATS TURKEY SHRIMP)
          (LOCALE HAM GOIAS)
          (CRAVES LACERATION YOGURT)
          (ATTACKS GOIAS QUEBEC)
          (EATS HOTDOG HAM)
          (CRAVES ANGINA YOGURT)
          (EATS HAM HOTDOG)
          (EATS CUCUMBER CANTELOPE)
          (CRAVES UNDERSTANDING ARUGULA)
          (EATS PISTACHIO TOFU)
          (LOCALE PISTACHIO GUANABARA)
          (CRAVES LONELINESS ARUGULA)
          (EATS HOTDOG TOFU)
          (EATS CHOCOLATE HOTDOG)
          (EATS SHRIMP TURKEY)
          (EATS POPOVER CUCUMBER)
          (ATTACKS MANITOBA GOIAS)
          (EATS POTATO TURKEY)
          (EATS PISTACHIO CHOCOLATE)
          (EATS POPOVER GUAVA)
          (EATS HOTDOG CHOCOLATE)
          (EATS MUTTON POPOVER)
          (EATS TOFU PISTACHIO)
          (EATS ARUGULA CANTELOPE)
          (CRAVES CURIOSITY SHRIMP)
          (ATTACKS PENNSYLVANIA BOSNIA)
          (LOCALE CANTELOPE GOIAS)
          (LOCALE ARUGULA BOSNIA)
          (ATTACKS BOSNIA MANITOBA)
          (LOCALE CUCUMBER BAVARIA)
          (CRAVES BOILS ARUGULA)
          (ATTACKS BAVARIA MORAVIA)
          (EATS SHRIMP ARUGULA)
          (HARMONY CURIOSITY PLUTO)
          (CRAVES JEALOUSY-2 CHOCOLATE)
          (EATS CANTELOPE CUCUMBER)
          (EATS MUTTON TOFU)
          (EATS GUAVA PEA)
          (HARMONY UNDERSTANDING VULCAN)
          (EATS PEA CUCUMBER)
          (ORBITS VULCAN PLUTO)
          (EATS HAM MUTTON)
          (EATS GUAVA POPOVER)
          (CRAVES ACHIEVEMENT MUTTON)
          (ORBITS MARS VULCAN)
          (CRAVES PROSTATITIS ARUGULA)
          (CRAVES ABRASION CHOCOLATE)
          (ORBITS PLUTO NEPTUNE)
          (EATS YOGURT PEA)
          (ATTACKS GUANABARA BAVARIA)
          (EATS PISTACHIO CANTELOPE)
          (EATS PEA YOGURT)
          (CRAVES DREAD CUCUMBER)
          (EATS GUAVA YOGURT)
          (CRAVES AESTHETICS PEA)
          (EATS CUCUMBER PEA)
          (CRAVES JEALOUSY YOGURT)
          (EATS TOFU HOTDOG)
          (EATS CANTELOPE PISTACHIO))
   (:GOAL (AND (CRAVES JEALOUSY CHOCOLATE)
               (CRAVES ANGINA CHOCOLATE))))

(DEFINE (PROBLEM STRIPS-MYSTY-1)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS OKRA MUFFIN TOMATO FLOUNDER CHICKEN TRIUMPH SATIETY
             ABRASION SCIATICA GRIEF LONELINESS DEPRESSION JEALOUSY DREAD
             PROSTATITIS HANGOVER ANGINA GOIAS MARS EARTH NEPTUNE)
   (:INIT (FOOD OKRA)
          (FOOD MUFFIN)
          (FOOD TOMATO)
          (FOOD FLOUNDER)
          (FOOD CHICKEN)
          (PLEASURE TRIUMPH)
          (PLEASURE SATIETY)
          (PAIN ABRASION)
          (PAIN SCIATICA)
          (PAIN GRIEF)
          (PAIN LONELINESS)
          (PAIN DEPRESSION)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN PROSTATITIS)
          (PAIN HANGOVER)
          (PAIN ANGINA)
          (PROVINCE GOIAS)
          (PLANET MARS)
          (PLANET EARTH)
          (PLANET NEPTUNE)
          (LOCALE CHICKEN GOIAS)
          (CRAVES PROSTATITIS TOMATO)
          (EATS TOMATO OKRA)
          (EATS OKRA MUFFIN)
          (EATS MUFFIN CHICKEN)
          (LOCALE FLOUNDER GOIAS)
          (LOCALE MUFFIN GOIAS)
          (EATS TOMATO FLOUNDER)
          (EATS OKRA TOMATO)
          (CRAVES SATIETY FLOUNDER)
          (CRAVES ABRASION OKRA)
          (EATS CHICKEN TOMATO)
          (CRAVES JEALOUSY TOMATO)
          (ORBITS MARS EARTH)
          (CRAVES LONELINESS MUFFIN)
          (CRAVES DREAD TOMATO)
          (EATS CHICKEN FLOUNDER)
          (EATS FLOUNDER TOMATO)
          (ORBITS EARTH NEPTUNE)
          (CRAVES ANGINA CHICKEN)
          (CRAVES HANGOVER FLOUNDER)
          (CRAVES GRIEF MUFFIN)
          (HARMONY TRIUMPH NEPTUNE)
          (HARMONY SATIETY EARTH)
          (CRAVES DEPRESSION MUFFIN)
          (EATS TOMATO CHICKEN)
          (CRAVES TRIUMPH MUFFIN)
          (EATS FLOUNDER MUFFIN)
          (EATS FLOUNDER CHICKEN)
          (CRAVES SCIATICA OKRA)
          (EATS MUFFIN OKRA)
          (EATS MUFFIN FLOUNDER)
          (LOCALE OKRA GOIAS)
          (LOCALE TOMATO GOIAS)
          (EATS CHICKEN MUFFIN))
   (:GOAL (AND (CRAVES PROSTATITIS FLOUNDER))))

(DEFINE (PROBLEM STRIPS-MYSTY-2)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS POPOVER PISTACHIO PEAR PAPAYA POTATO EXCITEMENT
             LONELINESS GRIEF BOILS SCIATICA ANGER ARIZONA PLUTO MARS JUPITER
             VULCAN)
   (:INIT (FOOD POPOVER)
          (FOOD PISTACHIO)
          (FOOD PEAR)
          (FOOD PAPAYA)
          (FOOD POTATO)
          (PLEASURE EXCITEMENT)
          (PAIN LONELINESS)
          (PAIN GRIEF)
          (PAIN BOILS)
          (PAIN SCIATICA)
          (PAIN ANGER)
          (PROVINCE ARIZONA)
          (PLANET PLUTO)
          (PLANET MARS)
          (PLANET JUPITER)
          (PLANET VULCAN)
          (LOCALE PEAR ARIZONA)
          (CRAVES SCIATICA PAPAYA)
          (EATS POTATO PAPAYA)
          (EATS PEAR PISTACHIO)
          (EATS POPOVER PISTACHIO)
          (CRAVES LONELINESS POPOVER)
          (CRAVES GRIEF PISTACHIO)
          (CRAVES BOILS PEAR)
          (LOCALE POPOVER ARIZONA)
          (CRAVES ANGER POTATO)
          (ORBITS PLUTO MARS)
          (LOCALE PISTACHIO ARIZONA)
          (LOCALE POTATO ARIZONA)
          (EATS PAPAYA POTATO)
          (HARMONY EXCITEMENT VULCAN)
          (ORBITS MARS JUPITER)
          (EATS PISTACHIO POPOVER)
          (EATS POTATO PEAR)
          (EATS PISTACHIO PEAR)
          (ORBITS JUPITER VULCAN)
          (CRAVES EXCITEMENT PAPAYA)
          (EATS PEAR PAPAYA)
          (EATS POTATO POPOVER)
          (EATS PAPAYA PEAR)
          (EATS POPOVER POTATO)
          (LOCALE PAPAYA ARIZONA)
          (EATS PEAR POTATO))
   (:GOAL (AND (CRAVES LONELINESS POPOVER))))

(DEFINE (PROBLEM STRIPS-MYSTY-3)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LOBSTER LETTUCE WURST CUCUMBER TOMATO OKRA COD ONION
             LEMON CHICKEN SATIETY DEPRESSION LONELINESS SCIATICA
             PROSTATITIS ANGINA ABRASION GRIEF LACERATION DREAD HANGOVER
             ANXIETY JEALOUSY BOILS ANGER JEALOUSY-2 GRIEF-7 HANGOVER-8
             DEPRESSION-3 LONELINESS-4 ANGER-1 DREAD-16 PROSTATITIS-5
             SCIATICA-6 ABRASION-15 PROSTATITIS-10 BOILS-11 LACERATION-12
             ANXIETY-13 ANGINA-14 GRIEF-9 QUEBEC GOIAS MERCURY NEPTUNE VENUS
             URANUS)
   (:INIT (FOOD LOBSTER)
          (FOOD LETTUCE)
          (FOOD WURST)
          (FOOD CUCUMBER)
          (FOOD TOMATO)
          (FOOD OKRA)
          (FOOD COD)
          (FOOD ONION)
          (FOOD LEMON)
          (FOOD CHICKEN)
          (PLEASURE SATIETY)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS)
          (PAIN ANGINA)
          (PAIN ABRASION)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN DREAD)
          (PAIN HANGOVER)
          (PAIN ANXIETY)
          (PAIN JEALOUSY)
          (PAIN BOILS)
          (PAIN ANGER)
          (PAIN JEALOUSY-2)
          (PAIN GRIEF-7)
          (PAIN HANGOVER-8)
          (PAIN DEPRESSION-3)
          (PAIN LONELINESS-4)
          (PAIN ANGER-1)
          (PAIN DREAD-16)
          (PAIN PROSTATITIS-5)
          (PAIN SCIATICA-6)
          (PAIN ABRASION-15)
          (PAIN PROSTATITIS-10)
          (PAIN BOILS-11)
          (PAIN LACERATION-12)
          (PAIN ANXIETY-13)
          (PAIN ANGINA-14)
          (PAIN GRIEF-9)
          (PROVINCE QUEBEC)
          (PROVINCE GOIAS)
          (PLANET MERCURY)
          (PLANET NEPTUNE)
          (PLANET VENUS)
          (PLANET URANUS)
          (EATS CUCUMBER LEMON)
          (CRAVES SCIATICA LOBSTER)
          (CRAVES GRIEF WURST)
          (CRAVES BOILS CUCUMBER)
          (CRAVES ANGINA LETTUCE)
          (CRAVES ANGER CUCUMBER)
          (CRAVES LACERATION-12 LEMON)
          (CRAVES GRIEF-7 OKRA)
          (LOCALE OKRA QUEBEC)
          (CRAVES HANGOVER-8 OKRA)
          (LOCALE CUCUMBER GOIAS)
          (EATS ONION LETTUCE)
          (CRAVES ABRASION LETTUCE)
          (CRAVES ANXIETY WURST)
          (CRAVES BOILS-11 LEMON)
          (CRAVES DREAD-16 COD)
          (EATS LEMON ONION)
          (CRAVES JEALOUSY CUCUMBER)
          (EATS OKRA TOMATO)
          (EATS OKRA WURST)
          (CRAVES PROSTATITIS-10 LEMON)
          (CRAVES LACERATION WURST)
          (CRAVES DEPRESSION-3 OKRA)
          (CRAVES SCIATICA-6 COD)
          (LOCALE LOBSTER GOIAS)
          (EATS COD OKRA)
          (LOCALE TOMATO GOIAS)
          (EATS LEMON CUCUMBER)
          (ORBITS MERCURY NEPTUNE)
          (EATS CHICKEN LOBSTER)
          (CRAVES ANGINA-14 LEMON)
          (LOCALE LEMON QUEBEC)
          (EATS CUCUMBER TOMATO)
          (LOCALE COD QUEBEC)
          (CRAVES LONELINESS LOBSTER)
          (EATS LETTUCE ONION)
          (CRAVES JEALOUSY-2 TOMATO)
          (HARMONY SATIETY URANUS)
          (ORBITS VENUS URANUS)
          (EATS WURST OKRA)
          (LOCALE LETTUCE GOIAS)
          (EATS TOMATO LOBSTER)
          (EATS LOBSTER CHICKEN)
          (LOCALE WURST QUEBEC)
          (EATS OKRA COD)
          (CRAVES SATIETY LETTUCE)
          (CRAVES DREAD WURST)
          (CRAVES ANXIETY-13 LEMON)
          (EATS LETTUCE WURST)
          (CRAVES ABRASION-15 ONION)
          (EATS TOMATO OKRA)
          (CRAVES HANGOVER WURST)
          (CRAVES GRIEF-9 CHICKEN)
          (CRAVES PROSTATITIS-5 COD)
          (EATS WURST LETTUCE)
          (CRAVES LONELINESS-4 OKRA)
          (CRAVES DEPRESSION LOBSTER)
          (EATS ONION LEMON)
          (ORBITS NEPTUNE VENUS)
          (EATS CHICKEN COD)
          (EATS COD CHICKEN)
          (EATS LOBSTER TOMATO)
          (LOCALE ONION GOIAS)
          (CRAVES PROSTATITIS LOBSTER)
          (EATS TOMATO CUCUMBER)
          (LOCALE CHICKEN QUEBEC)
          (ATTACKS QUEBEC GOIAS)
          (CRAVES ANGER-1 OKRA))
   (:GOAL (AND (CRAVES JEALOUSY WURST))))

(DEFINE (PROBLEM STRIPS-MYSTY-4)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS POTATO BACON SNICKERS SWEETROLL COD PEPPER KALE
             MARZIPAN CUCUMBER PEAR OKRA SCALLOP TURKEY WURST PEA STIMULATION
             REST CURIOSITY EXCITEMENT UNDERSTANDING EXPECTATION
             TRIUMPH SCIATICA ABRASION LONELINESS PROSTATITIS GRIEF
             DEPRESSION HANGOVER DREAD JEALOUSY ANGINA ANGER BOILS QUEBEC
             SURREY ALSACE MORAVIA MARS NEPTUNE JUPITER URANUS)
   (:INIT (FOOD POTATO)
          (FOOD BACON)
          (FOOD SNICKERS)
          (FOOD SWEETROLL)
          (FOOD COD)
          (FOOD PEPPER)
          (FOOD KALE)
          (FOOD MARZIPAN)
          (FOOD CUCUMBER)
          (FOOD PEAR)
          (FOOD OKRA)
          (FOOD SCALLOP)
          (FOOD TURKEY)
          (FOOD WURST)
          (FOOD PEA)
          (PLEASURE STIMULATION)
          (PLEASURE REST)
          (PLEASURE CURIOSITY)
          (PLEASURE EXCITEMENT)
          (PLEASURE UNDERSTANDING)
          (PLEASURE EXPECTATION)
          (PLEASURE TRIUMPH)
          (PAIN SCIATICA)
          (PAIN ABRASION)
          (PAIN LONELINESS)
          (PAIN PROSTATITIS)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN HANGOVER)
          (PAIN DREAD)
          (PAIN JEALOUSY)
          (PAIN ANGINA)
          (PAIN ANGER)
          (PAIN BOILS)
          (PROVINCE QUEBEC)
          (PROVINCE SURREY)
          (PROVINCE ALSACE)
          (PROVINCE MORAVIA)
          (PLANET MARS)
          (PLANET NEPTUNE)
          (PLANET JUPITER)
          (PLANET URANUS)
          (EATS PEA COD)
          (CRAVES EXCITEMENT CUCUMBER)
          (EATS BACON SNICKERS)
          (EATS PEAR SCALLOP)
          (CRAVES DEPRESSION CUCUMBER)
          (HARMONY CURIOSITY URANUS)
          (CRAVES CURIOSITY COD)
          (CRAVES UNDERSTANDING PEAR)
          (LOCALE BACON QUEBEC)
          (EATS PEPPER KALE)
          (LOCALE PEA MORAVIA)
          (CRAVES ANGINA PEAR)
          (CRAVES SCIATICA SWEETROLL)
          (EATS BACON POTATO)
          (CRAVES REST SNICKERS)
          (HARMONY UNDERSTANDING URANUS)
          (LOCALE SCALLOP SURREY)
          (LOCALE SWEETROLL SURREY)
          (CRAVES ANGER PEA)
          (EATS TURKEY WURST)
          (ORBITS MARS NEPTUNE)
          (LOCALE COD MORAVIA)
          (LOCALE WURST ALSACE)
          (HARMONY TRIUMPH JUPITER)
          (LOCALE CUCUMBER QUEBEC)
          (EATS PEA SCALLOP)
          (EATS SWEETROLL POTATO)
          (CRAVES DREAD CUCUMBER)
          (EATS SNICKERS SWEETROLL)
          (LOCALE MARZIPAN SURREY)
          (EATS SCALLOP PEA)
          (LOCALE SNICKERS MORAVIA)
          (CRAVES LONELINESS PEPPER)
          (CRAVES EXPECTATION WURST)
          (EATS WURST SCALLOP)
          (HARMONY EXCITEMENT JUPITER)
          (EATS PEPPER BACON)
          (EATS MARZIPAN COD)
          (EATS SNICKERS BACON)
          (LOCALE OKRA QUEBEC)
          (EATS KALE PEPPER)
          (EATS POTATO BACON)
          (HARMONY STIMULATION JUPITER)
          (EATS PEAR CUCUMBER)
          (EATS OKRA CUCUMBER)
          (EATS CUCUMBER PEAR)
          (LOCALE KALE ALSACE)
          (EATS TURKEY OKRA)
          (CRAVES BOILS PEA)
          (CRAVES HANGOVER CUCUMBER)
          (CRAVES GRIEF KALE)
          (EATS MARZIPAN KALE)
          (CRAVES TRIUMPH PEA)
          (EATS WURST TURKEY)
          (LOCALE PEAR QUEBEC)
          (LOCALE PEPPER SURREY)
          (ATTACKS QUEBEC SURREY)
          (HARMONY REST URANUS)
          (EATS BACON PEPPER)
          (HARMONY EXPECTATION JUPITER)
          (EATS COD MARZIPAN)
          (EATS SCALLOP PEAR)
          (EATS CUCUMBER OKRA)
          (EATS PEA WURST)
          (ATTACKS SURREY ALSACE)
          (ORBITS NEPTUNE JUPITER)
          (ATTACKS ALSACE MORAVIA)
          (EATS OKRA TURKEY)
          (EATS PEPPER COD)
          (EATS COD PEA)
          (LOCALE POTATO SURREY)
          (CRAVES ABRASION PEPPER)
          (EATS WURST PEA)
          (CRAVES PROSTATITIS PEPPER)
          (EATS POTATO SWEETROLL)
          (LOCALE TURKEY QUEBEC)
          (EATS COD PEPPER)
          (CRAVES STIMULATION POTATO)
          (CRAVES JEALOUSY PEAR)
          (ORBITS JUPITER URANUS)
          (EATS SWEETROLL SNICKERS)
          (EATS SCALLOP WURST)
          (EATS KALE MARZIPAN))
   (:GOAL (AND (CRAVES ANGINA CUCUMBER))))

(DEFINE (PROBLEM STRIPS-MYSTY-5)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS MUFFIN YOGURT HAROSET ENDIVE KALE TUNA CHOCOLATE
             SNICKERS PAPAYA MUTTON PEAR BROCCOLI POTATO BACON SCALLOP TOMATO
             SATISFACTION AESTHETICS UNDERSTANDING ANGER HANGOVER JEALOUSY
             DREAD SCIATICA LONELINESS GRIEF ANGINA ABRASION BOILS
             DEPRESSION ANXIETY ANGER-2 LACERATION PROSTATITIS GRIEF-3
             ANXIETY-4 ABRASION-1 ANGINA-8 HANGOVER-5 LONELINESS-6 DREAD-7
             DEPRESSION-14 SCIATICA-15 LACERATION-16 PROSTATITIS-13
             JEALOUSY-12 GRIEF-10 BOILS-11 PROSTATITIS-31 DEPRESSION-32
             HANGOVER-9 ABRASION-29 SCIATICA-30 ANXIETY-26 DREAD-27
             LONELINESS-28 QUEBEC VENUS NEPTUNE VULCAN SATURN)
   (:INIT (FOOD MUFFIN)
          (FOOD YOGURT)
          (FOOD HAROSET)
          (FOOD ENDIVE)
          (FOOD KALE)
          (FOOD TUNA)
          (FOOD CHOCOLATE)
          (FOOD SNICKERS)
          (FOOD PAPAYA)
          (FOOD MUTTON)
          (FOOD PEAR)
          (FOOD BROCCOLI)
          (FOOD POTATO)
          (FOOD BACON)
          (FOOD SCALLOP)
          (FOOD TOMATO)
          (PLEASURE SATISFACTION)
          (PLEASURE AESTHETICS)
          (PLEASURE UNDERSTANDING)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN LONELINESS)
          (PAIN GRIEF)
          (PAIN ANGINA)
          (PAIN ABRASION)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN ANGER-2)
          (PAIN LACERATION)
          (PAIN PROSTATITIS)
          (PAIN GRIEF-3)
          (PAIN ANXIETY-4)
          (PAIN ABRASION-1)
          (PAIN ANGINA-8)
          (PAIN HANGOVER-5)
          (PAIN LONELINESS-6)
          (PAIN DREAD-7)
          (PAIN DEPRESSION-14)
          (PAIN SCIATICA-15)
          (PAIN LACERATION-16)
          (PAIN PROSTATITIS-13)
          (PAIN JEALOUSY-12)
          (PAIN GRIEF-10)
          (PAIN BOILS-11)
          (PAIN PROSTATITIS-31)
          (PAIN DEPRESSION-32)
          (PAIN HANGOVER-9)
          (PAIN ABRASION-29)
          (PAIN SCIATICA-30)
          (PAIN ANXIETY-26)
          (PAIN DREAD-27)
          (PAIN LONELINESS-28)
          (PROVINCE QUEBEC)
          (PLANET VENUS)
          (PLANET NEPTUNE)
          (PLANET VULCAN)
          (PLANET SATURN)
          (EATS TUNA HAROSET)
          (EATS CHOCOLATE BROCCOLI)
          (CRAVES LONELINESS YOGURT)
          (LOCALE PAPAYA QUEBEC)
          (CRAVES HANGOVER-5 PAPAYA)
          (LOCALE TUNA QUEBEC)
          (CRAVES ANGINA-8 SNICKERS)
          (EATS SNICKERS PAPAYA)
          (EATS HAROSET TUNA)
          (CRAVES DEPRESSION-32 BACON)
          (CRAVES LACERATION-16 MUTTON)
          (EATS POTATO BACON)
          (CRAVES ANXIETY KALE)
          (LOCALE POTATO QUEBEC)
          (EATS SNICKERS BROCCOLI)
          (CRAVES PROSTATITIS-13 PEAR)
          (EATS MUTTON PAPAYA)
          (CRAVES ANXIETY-4 CHOCOLATE)
          (CRAVES BOILS-11 POTATO)
          (CRAVES SCIATICA YOGURT)
          (CRAVES DREAD-7 PAPAYA)
          (EATS TUNA MUFFIN)
          (LOCALE SCALLOP QUEBEC)
          (CRAVES JEALOUSY-12 BROCCOLI)
          (LOCALE CHOCOLATE QUEBEC)
          (EATS BROCCOLI SNICKERS)
          (EATS BROCCOLI BACON)
          (EATS TOMATO POTATO)
          (EATS PAPAYA CHOCOLATE)
          (EATS POTATO TOMATO)
          (EATS BACON BROCCOLI)
          (ORBITS NEPTUNE VULCAN)
          (EATS SCALLOP TOMATO)
          (LOCALE SNICKERS QUEBEC)
          (EATS SNICKERS PEAR)
          (CRAVES DEPRESSION-14 MUTTON)
          (EATS PEAR PAPAYA)
          (CRAVES UNDERSTANDING BROCCOLI)
          (EATS MUFFIN TUNA)
          (CRAVES ANGINA HAROSET)
          (EATS PEAR SNICKERS)
          (CRAVES ABRASION ENDIVE)
          (CRAVES PROSTATITIS-31 BACON)
          (CRAVES HANGOVER MUFFIN)
          (CRAVES ABRASION-29 SCALLOP)
          (LOCALE HAROSET QUEBEC)
          (CRAVES ANXIETY-26 TOMATO)
          (CRAVES PROSTATITIS TUNA)
          (LOCALE BACON QUEBEC)
          (EATS MUFFIN YOGURT)
          (EATS ENDIVE SNICKERS)
          (CRAVES AESTHETICS HAROSET)
          (CRAVES LACERATION TUNA)
          (CRAVES DREAD YOGURT)
          (LOCALE TOMATO QUEBEC)
          (CRAVES LONELINESS-28 TOMATO)
          (CRAVES ABRASION-1 CHOCOLATE)
          (CRAVES JEALOUSY MUFFIN)
          (EATS ENDIVE KALE)
          (HARMONY AESTHETICS NEPTUNE)
          (LOCALE KALE QUEBEC)
          (EATS YOGURT KALE)
          (EATS CHOCOLATE PAPAYA)
          (LOCALE ENDIVE QUEBEC)
          (CRAVES GRIEF-3 CHOCOLATE)
          (CRAVES SATISFACTION YOGURT)
          (LOCALE MUTTON QUEBEC)
          (CRAVES GRIEF HAROSET)
          (LOCALE PEAR QUEBEC)
          (EATS BROCCOLI CHOCOLATE)
          (HARMONY SATISFACTION SATURN)
          (CRAVES SCIATICA-30 SCALLOP)
          (EATS KALE ENDIVE)
          (EATS PAPAYA PEAR)
          (CRAVES ANGER MUFFIN)
          (EATS PAPAYA SNICKERS)
          (CRAVES GRIEF-10 POTATO)
          (EATS TOMATO SCALLOP)
          (HARMONY UNDERSTANDING VULCAN)
          (EATS BACON POTATO)
          (CRAVES DREAD-27 TOMATO)
          (CRAVES BOILS ENDIVE)
          (ORBITS VENUS NEPTUNE)
          (EATS PAPAYA MUTTON)
          (CRAVES SCIATICA-15 MUTTON)
          (EATS BACON SCALLOP)
          (CRAVES ANGER-2 TUNA)
          (EATS PEAR MUTTON)
          (EATS YOGURT MUFFIN)
          (EATS MUTTON PEAR)
          (LOCALE BROCCOLI QUEBEC)
          (EATS SCALLOP BACON)
          (EATS ENDIVE HAROSET)
          (EATS KALE YOGURT)
          (EATS SNICKERS ENDIVE)
          (EATS HAROSET ENDIVE)
          (LOCALE MUFFIN QUEBEC)
          (CRAVES LONELINESS-6 PAPAYA)
          (ORBITS VULCAN SATURN)
          (LOCALE YOGURT QUEBEC)
          (CRAVES DEPRESSION KALE)
          (CRAVES HANGOVER-9 BACON))
   (:GOAL (AND (CRAVES ANGER CHOCOLATE))))

(DEFINE (PROBLEM STRIPS-MYSTY-6)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PISTACHIO WONDERBREAD MELON PEA CHOCOLATE PORK
             FLOUNDER HAM PAPAYA CUCUMBER PEPPER LOVE REST LONELINESS GRIEF
             PROSTATITIS KENTUCKY GOIAS MANITOBA VENUS SATURN EARTH NEPTUNE)
   (:INIT (FOOD PISTACHIO)
          (FOOD WONDERBREAD)
          (FOOD MELON)
          (FOOD PEA)
          (FOOD CHOCOLATE)
          (FOOD PORK)
          (FOOD FLOUNDER)
          (FOOD HAM)
          (FOOD PAPAYA)
          (FOOD CUCUMBER)
          (FOOD PEPPER)
          (PLEASURE LOVE)
          (PLEASURE REST)
          (PAIN LONELINESS)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PROVINCE KENTUCKY)
          (PROVINCE GOIAS)
          (PROVINCE MANITOBA)
          (PLANET VENUS)
          (PLANET SATURN)
          (PLANET EARTH)
          (PLANET NEPTUNE)
          (EATS MELON HAM)
          (EATS FLOUNDER CHOCOLATE)
          (LOCALE MELON GOIAS)
          (EATS PISTACHIO PORK)
          (LOCALE WONDERBREAD KENTUCKY)
          (EATS CHOCOLATE FLOUNDER)
          (ATTACKS GOIAS MANITOBA)
          (ORBITS VENUS SATURN)
          (EATS HAM PEPPER)
          (EATS PAPAYA WONDERBREAD)
          (EATS HAM WONDERBREAD)
          (EATS CUCUMBER CHOCOLATE)
          (ATTACKS KENTUCKY GOIAS)
          (EATS PEPPER HAM)
          (CRAVES PROSTATITIS PORK)
          (LOCALE HAM MANITOBA)
          (EATS PEPPER PEA)
          (EATS FLOUNDER PEPPER)
          (EATS PORK FLOUNDER)
          (LOCALE CHOCOLATE KENTUCKY)
          (EATS CUCUMBER PEA)
          (LOCALE PAPAYA GOIAS)
          (EATS PAPAYA CUCUMBER)
          (LOCALE PORK KENTUCKY)
          (EATS PISTACHIO MELON)
          (EATS PEA FLOUNDER)
          (LOCALE PISTACHIO GOIAS)
          (HARMONY REST NEPTUNE)
          (EATS CHOCOLATE CUCUMBER)
          (EATS PORK PEPPER)
          (EATS PEPPER PORK)
          (EATS FLOUNDER PEA)
          (CRAVES GRIEF PORK)
          (HARMONY LOVE SATURN)
          (EATS CUCUMBER PAPAYA)
          (EATS WONDERBREAD HAM)
          (LOCALE CUCUMBER MANITOBA)
          (EATS PEA PEPPER)
          (LOCALE PEA KENTUCKY)
          (EATS PEA CUCUMBER)
          (ORBITS SATURN EARTH)
          (EATS FLOUNDER PORK)
          (LOCALE FLOUNDER MANITOBA)
          (LOCALE PEPPER MANITOBA)
          (CRAVES LOVE PEA)
          (EATS CHOCOLATE PAPAYA)
          (EATS MELON PISTACHIO)
          (EATS PEPPER FLOUNDER)
          (EATS PORK PISTACHIO)
          (EATS HAM MELON)
          (EATS PAPAYA CHOCOLATE)
          (CRAVES REST HAM)
          (EATS WONDERBREAD PAPAYA)
          (ORBITS EARTH NEPTUNE)
          (CRAVES LONELINESS PORK))
   (:GOAL (AND (CRAVES GRIEF HAM)
               (CRAVES PROSTATITIS HAM))))

(DEFINE (PROBLEM STRIPS-MYSTY-7)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS CHOCOLATE BEEF FLOUNDER MUTTON SHRIMP TUNA SWEETROLL
             ONION CANTELOPE YOGURT GUAVA RICE PEPPER LUBRICITY
             ACHIEVEMENT ANGINA HANGOVER ANGER GRIEF BOILS DEPRESSION
             LACERATION ABRASION GOIAS ALSACE KENTUCKY BOSNIA GUANABARA
             ARIZONA NEPTUNE PLUTO SATURN)
   (:INIT (FOOD CHOCOLATE)
          (FOOD BEEF)
          (FOOD FLOUNDER)
          (FOOD MUTTON)
          (FOOD SHRIMP)
          (FOOD TUNA)
          (FOOD SWEETROLL)
          (FOOD ONION)
          (FOOD CANTELOPE)
          (FOOD YOGURT)
          (FOOD GUAVA)
          (FOOD RICE)
          (FOOD PEPPER)
          (PLEASURE LUBRICITY)
          (PLEASURE ACHIEVEMENT)
          (PAIN ANGINA)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN GRIEF)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN LACERATION)
          (PAIN ABRASION)
          (PROVINCE GOIAS)
          (PROVINCE ALSACE)
          (PROVINCE KENTUCKY)
          (PROVINCE BOSNIA)
          (PROVINCE GUANABARA)
          (PROVINCE ARIZONA)
          (PLANET NEPTUNE)
          (PLANET PLUTO)
          (PLANET SATURN)
          (EATS FLOUNDER CANTELOPE)
          (LOCALE BEEF KENTUCKY)
          (LOCALE GUAVA ARIZONA)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS RICE BEEF)
          (LOCALE CHOCOLATE KENTUCKY)
          (EATS MUTTON RICE)
          (EATS CANTELOPE MUTTON)
          (EATS SWEETROLL PEPPER)
          (ATTACKS GOIAS ALSACE)
          (CRAVES BOILS TUNA)
          (EATS ONION PEPPER)
          (EATS CHOCOLATE SWEETROLL)
          (EATS YOGURT SHRIMP)
          (EATS TUNA YOGURT)
          (EATS FLOUNDER SWEETROLL)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS YOGURT TUNA)
          (EATS RICE ONION)
          (EATS MUTTON CANTELOPE)
          (LOCALE SHRIMP ALSACE)
          (EATS RICE MUTTON)
          (CRAVES LACERATION CANTELOPE)
          (CRAVES ACHIEVEMENT YOGURT)
          (EATS GUAVA CANTELOPE)
          (CRAVES HANGOVER BEEF)
          (EATS SHRIMP CANTELOPE)
          (CRAVES ANGINA CHOCOLATE)
          (EATS CANTELOPE GUAVA)
          (EATS ONION MUTTON)
          (EATS ONION RICE)
          (EATS SWEETROLL TUNA)
          (EATS ONION CHOCOLATE)
          (EATS SWEETROLL MUTTON)
          (EATS SWEETROLL CHOCOLATE)
          (EATS TUNA SWEETROLL)
          (EATS CANTELOPE SHRIMP)
          (LOCALE YOGURT BOSNIA)
          (EATS GUAVA BEEF)
          (ATTACKS GUANABARA ARIZONA)
          (ORBITS NEPTUNE PLUTO)
          (EATS MUTTON ONION)
          (EATS SHRIMP YOGURT)
          (EATS PEPPER SWEETROLL)
          (ATTACKS ALSACE KENTUCKY)
          (LOCALE ONION KENTUCKY)
          (LOCALE FLOUNDER KENTUCKY)
          (EATS PEPPER ONION)
          (EATS BEEF GUAVA)
          (HARMONY ACHIEVEMENT PLUTO)
          (EATS MUTTON SWEETROLL)
          (LOCALE PEPPER KENTUCKY)
          (LOCALE CANTELOPE ARIZONA)
          (CRAVES ANGER FLOUNDER)
          (EATS CANTELOPE FLOUNDER)
          (ATTACKS BOSNIA GUANABARA)
          (CRAVES GRIEF SHRIMP)
          (LOCALE TUNA ALSACE)
          (LOCALE MUTTON ARIZONA)
          (LOCALE RICE GUANABARA)
          (EATS SWEETROLL FLOUNDER)
          (EATS BEEF RICE)
          (CRAVES LUBRICITY ONION)
          (HARMONY LUBRICITY SATURN)
          (CRAVES DEPRESSION SWEETROLL)
          (EATS CHOCOLATE ONION)
          (CRAVES ABRASION PEPPER)
          (ORBITS PLUTO SATURN))
   (:GOAL (AND (CRAVES LACERATION GUAVA)
               (CRAVES ANGINA BEEF)
               (CRAVES BOILS SWEETROLL))))

(DEFINE (PROBLEM STRIPS-MYSTY-8)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS BACON PEAR HAMBURGER SCALLION ARUGULA CANTELOPE TOFU
             LAMB BEEF TURKEY MUFFIN HOTDOG SWEETROLL PEPPER FLOUNDER COD
             BAGUETTE SNICKERS ENDIVE RICE HAM PAPAYA WONDERBREAD PORK
             CHICKEN YOGURT SHRIMP LOBSTER CHOCOLATE LEMON HAROSET
             SATISFACTION AESTHETICS ENTERTAINMENT PROSTATITIS JEALOUSY BOILS
             SCIATICA ABRASION GRIEF LONELINESS ANGINA DEPRESSION ANXIETY
             DREAD ABRASION-1 SCIATICA-2 ANGER LACERATION HANGOVER
             DREAD-3 LONELINESS-4 LACERATION-6 GRIEF-7 JEALOUSY-8
             DEPRESSION-16 BOILS-5 ANGER-14 ANXIETY-15 ABRASION-9 GRIEF-10
             ANGINA-11 HANGOVER-12 PROSTATITIS-13 PROSTATITIS-30
             JEALOUSY-31 BOILS-32 DEPRESSION-28 DREAD-29 HANGOVER-23
             SCIATICA-24 LACERATION-25 ANGINA-26 ANGER-27 ANXIETY-21
             LONELINESS-22 DEPRESSION-64 DREAD-17 LONELINESS-18 PROSTATITIS-19
             ANGER-20 GRIEF-63 ABRASION-59 ANGINA-60 HANGOVER-61
             SCIATICA-62 LACERATION-58 ANGINA-54 BOILS-55 JEALOUSY-56
             ANXIETY-57 BOILS-50 GRIEF-51 HANGOVER-52 LACERATION-53 ANGER-48
             PROSTATITIS-49 LONELINESS-43 ABRASION-44 DEPRESSION-45 JEALOUSY-46
             ANXIETY-47 DEPRESSION-38 GRIEF-39 ANGINA-40 DREAD-41
             SCIATICA-42 BOILS-33 ANXIETY-34 LACERATION-35 ABRASION-36
             HANGOVER-37 DREAD-125 PROSTATITIS-126 ANGER-127 JEALOUSY-128
             SCIATICA-123 LONELINESS-124 PROSTATITIS-119 ABRASION-120
             ANGINA-121 ANGER-122 DREAD-116 ANXIETY-117 BOILS-118
             HANGOVER-113 LACERATION-114 JEALOUSY-115 SCIATICA-110
             LONELINESS-111 DEPRESSION-112 GOIAS VENUS SATURN JUPITER)
   (:INIT (FOOD BACON)
          (FOOD PEAR)
          (FOOD HAMBURGER)
          (FOOD SCALLION)
          (FOOD ARUGULA)
          (FOOD CANTELOPE)
          (FOOD TOFU)
          (FOOD LAMB)
          (FOOD BEEF)
          (FOOD TURKEY)
          (FOOD MUFFIN)
          (FOOD HOTDOG)
          (FOOD SWEETROLL)
          (FOOD PEPPER)
          (FOOD FLOUNDER)
          (FOOD COD)
          (FOOD BAGUETTE)
          (FOOD SNICKERS)
          (FOOD ENDIVE)
          (FOOD RICE)
          (FOOD HAM)
          (FOOD PAPAYA)
          (FOOD WONDERBREAD)
          (FOOD PORK)
          (FOOD CHICKEN)
          (FOOD YOGURT)
          (FOOD SHRIMP)
          (FOOD LOBSTER)
          (FOOD CHOCOLATE)
          (FOOD LEMON)
          (FOOD HAROSET)
          (PLEASURE SATISFACTION)
          (PLEASURE AESTHETICS)
          (PLEASURE ENTERTAINMENT)
          (PAIN PROSTATITIS)
          (PAIN JEALOUSY)
          (PAIN BOILS)
          (PAIN SCIATICA)
          (PAIN ABRASION)
          (PAIN GRIEF)
          (PAIN LONELINESS)
          (PAIN ANGINA)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN DREAD)
          (PAIN ABRASION-1)
          (PAIN SCIATICA-2)
          (PAIN ANGER)
          (PAIN LACERATION)
          (PAIN HANGOVER)
          (PAIN DREAD-3)
          (PAIN LONELINESS-4)
          (PAIN LACERATION-6)
          (PAIN GRIEF-7)
          (PAIN JEALOUSY-8)
          (PAIN DEPRESSION-16)
          (PAIN BOILS-5)
          (PAIN ANGER-14)
          (PAIN ANXIETY-15)
          (PAIN ABRASION-9)
          (PAIN GRIEF-10)
          (PAIN ANGINA-11)
          (PAIN HANGOVER-12)
          (PAIN PROSTATITIS-13)
          (PAIN PROSTATITIS-30)
          (PAIN JEALOUSY-31)
          (PAIN BOILS-32)
          (PAIN DEPRESSION-28)
          (PAIN DREAD-29)
          (PAIN HANGOVER-23)
          (PAIN SCIATICA-24)
          (PAIN LACERATION-25)
          (PAIN ANGINA-26)
          (PAIN ANGER-27)
          (PAIN ANXIETY-21)
          (PAIN LONELINESS-22)
          (PAIN DEPRESSION-64)
          (PAIN DREAD-17)
          (PAIN LONELINESS-18)
          (PAIN PROSTATITIS-19)
          (PAIN ANGER-20)
          (PAIN GRIEF-63)
          (PAIN ABRASION-59)
          (PAIN ANGINA-60)
          (PAIN HANGOVER-61)
          (PAIN SCIATICA-62)
          (PAIN LACERATION-58)
          (PAIN ANGINA-54)
          (PAIN BOILS-55)
          (PAIN JEALOUSY-56)
          (PAIN ANXIETY-57)
          (PAIN BOILS-50)
          (PAIN GRIEF-51)
          (PAIN HANGOVER-52)
          (PAIN LACERATION-53)
          (PAIN ANGER-48)
          (PAIN PROSTATITIS-49)
          (PAIN LONELINESS-43)
          (PAIN ABRASION-44)
          (PAIN DEPRESSION-45)
          (PAIN JEALOUSY-46)
          (PAIN ANXIETY-47)
          (PAIN DEPRESSION-38)
          (PAIN GRIEF-39)
          (PAIN ANGINA-40)
          (PAIN DREAD-41)
          (PAIN SCIATICA-42)
          (PAIN BOILS-33)
          (PAIN ANXIETY-34)
          (PAIN LACERATION-35)
          (PAIN ABRASION-36)
          (PAIN HANGOVER-37)
          (PAIN DREAD-125)
          (PAIN PROSTATITIS-126)
          (PAIN ANGER-127)
          (PAIN JEALOUSY-128)
          (PAIN SCIATICA-123)
          (PAIN LONELINESS-124)
          (PAIN PROSTATITIS-119)
          (PAIN ABRASION-120)
          (PAIN ANGINA-121)
          (PAIN ANGER-122)
          (PAIN DREAD-116)
          (PAIN ANXIETY-117)
          (PAIN BOILS-118)
          (PAIN HANGOVER-113)
          (PAIN LACERATION-114)
          (PAIN JEALOUSY-115)
          (PAIN SCIATICA-110)
          (PAIN LONELINESS-111)
          (PAIN DEPRESSION-112)
          (PROVINCE GOIAS)
          (PLANET VENUS)
          (PLANET SATURN)
          (PLANET JUPITER)
          (EATS LOBSTER YOGURT)
          (EATS MUFFIN HOTDOG)
          (CRAVES ANGER-27 PEPPER)
          (CRAVES ANXIETY-21 FLOUNDER)
          (CRAVES LONELINESS-22 FLOUNDER)
          (CRAVES DEPRESSION SCALLION)
          (LOCALE BACON GOIAS)
          (EATS PEPPER MUFFIN)
          (CRAVES DREAD-116 CHOCOLATE)
          (EATS COD SWEETROLL)
          (CRAVES HANGOVER-61 SNICKERS)
          (LOCALE SCALLION GOIAS)
          (LOCALE LAMB GOIAS)
          (EATS HAMBURGER SCALLION)
          (EATS BEEF PEPPER)
          (LOCALE RICE GOIAS)
          (LOCALE PAPAYA GOIAS)
          (LOCALE CHICKEN GOIAS)
          (CRAVES GRIEF-10 MUFFIN)
          (CRAVES ANXIETY-117 CHOCOLATE)
          (EATS ARUGULA CANTELOPE)
          (CRAVES AESTHETICS CHICKEN)
          (CRAVES DREAD-3 TOFU)
          (EATS LAMB SWEETROLL)
          (ORBITS VENUS SATURN)
          (CRAVES ENTERTAINMENT LEMON)
          (CRAVES ANGER CANTELOPE)
          (EATS HAM LEMON)
          (EATS TURKEY FLOUNDER)
          (CRAVES PROSTATITIS-19 COD)
          (EATS SHRIMP YOGURT)
          (LOCALE BAGUETTE GOIAS)
          (CRAVES BOILS-50 HAM)
          (EATS YOGURT ENDIVE)
          (CRAVES GRIEF-63 BAGUETTE)
          (CRAVES HANGOVER-113 LEMON)
          (LOCALE PEAR GOIAS)
          (CRAVES ABRASION-1 CANTELOPE)
          (EATS TOFU BEEF)
          (CRAVES ANGINA-11 MUFFIN)
          (CRAVES SCIATICA-42 PORK)
          (LOCALE LOBSTER GOIAS)
          (EATS LAMB HOTDOG)
          (EATS PORK BAGUETTE)
          (EATS SNICKERS LEMON)
          (EATS ARUGULA BACON)
          (CRAVES JEALOUSY-128 YOGURT)
          (EATS CHOCOLATE HAM)
          (EATS HAM CHICKEN)
          (CRAVES JEALOUSY BACON)
          (EATS HAM CHOCOLATE)
          (CRAVES PROSTATITIS-13 MUFFIN)
          (EATS CHICKEN YOGURT)
          (CRAVES SCIATICA-24 PEPPER)
          (EATS BAGUETTE RICE)
          (EATS SWEETROLL MUFFIN)
          (CRAVES SCIATICA-123 SHRIMP)
          (EATS LEMON SNICKERS)
          (CRAVES DREAD-125 YOGURT)
          (CRAVES SATISFACTION SCALLION)
          (EATS YOGURT CHICKEN)
          (CRAVES DREAD-17 COD)
          (CRAVES ANGINA-60 SNICKERS)
          (CRAVES PROSTATITIS-30 HOTDOG)
          (EATS FLOUNDER TOFU)
          (EATS CANTELOPE ARUGULA)
          (EATS ENDIVE SNICKERS)
          (EATS CANTELOPE HAMBURGER)
          (CRAVES GRIEF HAMBURGER)
          (CRAVES PROSTATITIS-49 PAPAYA)
          (LOCALE HAROSET GOIAS)
          (LOCALE COD GOIAS)
          (LOCALE FLOUNDER GOIAS)
          (CRAVES ANGER-127 YOGURT)
          (LOCALE TOFU GOIAS)
          (LOCALE SHRIMP GOIAS)
          (CRAVES HANGOVER-52 HAM)
          (EATS TOFU FLOUNDER)
          (LOCALE HAM GOIAS)
          (CRAVES ANXIETY ARUGULA)
          (CRAVES HANGOVER CANTELOPE)
          (EATS RICE HAROSET)
          (CRAVES BOILS PEAR)
          (CRAVES DEPRESSION-16 BEEF)
          (EATS LEMON HAM)
          (EATS CHICKEN HAM)
          (CRAVES LONELINESS-43 WONDERBREAD)
          (LOCALE CANTELOPE GOIAS)
          (EATS CHICKEN LEMON)
          (LOCALE HOTDOG GOIAS)
          (CRAVES ANGER-48 PAPAYA)
          (EATS BACON PEAR)
          (LOCALE ARUGULA GOIAS)
          (CRAVES ANGINA-40 PORK)
          (EATS COD HOTDOG)
          (CRAVES ANGINA-54 RICE)
          (EATS RICE BAGUETTE)
          (CRAVES ANXIETY-34 CHICKEN)
          (CRAVES LACERATION CANTELOPE)
          (CRAVES ABRASION-36 CHICKEN)
          (LOCALE SWEETROLL GOIAS)
          (CRAVES LACERATION-58 ENDIVE)
          (CRAVES HANGOVER-23 PEPPER)
          (LOCALE TURKEY GOIAS)
          (CRAVES LACERATION-53 HAM)
          (EATS WONDERBREAD LOBSTER)
          (CRAVES DEPRESSION-28 SWEETROLL)
          (EATS CHOCOLATE CHICKEN)
          (EATS FLOUNDER PEAR)
          (EATS PAPAYA SHRIMP)
          (EATS TURKEY HOTDOG)
          (LOCALE CHOCOLATE GOIAS)
          (LOCALE BEEF GOIAS)
          (EATS LOBSTER WONDERBREAD)
          (EATS YOGURT SHRIMP)
          (CRAVES BOILS-32 HOTDOG)
          (EATS PEPPER BEEF)
          (CRAVES LACERATION-25 PEPPER)
          (EATS CHICKEN CHOCOLATE)
          (CRAVES LACERATION-114 LEMON)
          (CRAVES ABRASION HAMBURGER)
          (CRAVES ABRASION-59 SNICKERS)
          (CRAVES JEALOUSY-8 LAMB)
          (CRAVES DEPRESSION-112 HAROSET)
          (CRAVES SCIATICA-62 SNICKERS)
          (HARMONY ENTERTAINMENT JUPITER)
          (CRAVES DEPRESSION-38 PORK)
          (EATS LAMB SNICKERS)
          (LOCALE MUFFIN GOIAS)
          (CRAVES LONELINESS-111 HAROSET)
          (EATS YOGURT LOBSTER)
          (CRAVES ABRASION-44 WONDERBREAD)
          (CRAVES BOILS-55 RICE)
          (EATS HAROSET RICE)
          (CRAVES JEALOUSY-31 HOTDOG)
          (EATS HOTDOG LAMB)
          (LOCALE SNICKERS GOIAS)
          (EATS HOTDOG TURKEY)
          (CRAVES ANGER-20 COD)
          (EATS MUFFIN PEPPER)
          (EATS MUFFIN SWEETROLL)
          (CRAVES BOILS-33 CHICKEN)
          (CRAVES DREAD-41 PORK)
          (LOCALE YOGURT GOIAS)
          (EATS SHRIMP LEMON)
          (CRAVES ANGER-14 TURKEY)
          (EATS SCALLION HAMBURGER)
          (LOCALE HAMBURGER GOIAS)
          (EATS HAROSET PAPAYA)
          (LOCALE PEPPER GOIAS)
          (CRAVES PROSTATITIS BACON)
          (EATS SWEETROLL LAMB)
          (CRAVES DREAD ARUGULA)
          (CRAVES SCIATICA-2 CANTELOPE)
          (EATS FLOUNDER TURKEY)
          (EATS PEAR BACON)
          (CRAVES GRIEF-39 PORK)
          (CRAVES ABRASION-120 LOBSTER)
          (CRAVES ANGER-122 LOBSTER)
          (ORBITS SATURN JUPITER)
          (CRAVES SCIATICA PEAR)
          (EATS SNICKERS LAMB)
          (CRAVES LONELINESS-4 TOFU)
          (CRAVES ANGINA-121 LOBSTER)
          (EATS ENDIVE YOGURT)
          (EATS HOTDOG MUFFIN)
          (EATS PORK WONDERBREAD)
          (EATS SCALLION PEAR)
          (EATS PEAR FLOUNDER)
          (CRAVES JEALOUSY-115 LEMON)
          (EATS PAPAYA HAROSET)
          (CRAVES HANGOVER-12 MUFFIN)
          (CRAVES BOILS-118 CHOCOLATE)
          (EATS HAMBURGER CANTELOPE)
          (CRAVES DREAD-29 SWEETROLL)
          (CRAVES PROSTATITIS-126 YOGURT)
          (CRAVES JEALOUSY-56 RICE)
          (CRAVES LACERATION-6 LAMB)
          (CRAVES DEPRESSION-45 WONDERBREAD)
          (CRAVES JEALOUSY-46 WONDERBREAD)
          (EATS SWEETROLL COD)
          (EATS WONDERBREAD PORK)
          (CRAVES ANXIETY-15 TURKEY)
          (EATS BAGUETTE PORK)
          (CRAVES ANXIETY-47 WONDERBREAD)
          (EATS SNICKERS ENDIVE)
          (CRAVES ANGINA-26 PEPPER)
          (CRAVES PROSTATITIS-119 LOBSTER)
          (LOCALE ENDIVE GOIAS)
          (CRAVES GRIEF-51 HAM)
          (EATS PEAR SCALLION)
          (CRAVES DEPRESSION-64 COD)
          (EATS LEMON SHRIMP)
          (LOCALE WONDERBREAD GOIAS)
          (CRAVES SCIATICA-110 HAROSET)
          (EATS HOTDOG COD)
          (CRAVES GRIEF-7 LAMB)
          (CRAVES BOILS-5 BEEF)
          (CRAVES LONELINESS HAMBURGER)
          (HARMONY AESTHETICS JUPITER)
          (HARMONY SATISFACTION JUPITER)
          (CRAVES HANGOVER-37 CHICKEN)
          (CRAVES LACERATION-35 CHICKEN)
          (LOCALE LEMON GOIAS)
          (CRAVES LONELINESS-18 COD)
          (CRAVES ABRASION-9 MUFFIN)
          (CRAVES LONELINESS-124 SHRIMP)
          (EATS BACON ARUGULA)
          (EATS SHRIMP PAPAYA)
          (EATS BEEF TOFU)
          (CRAVES ANGINA SCALLION)
          (CRAVES ANXIETY-57 RICE)
          (LOCALE PORK GOIAS)
          (EATS LEMON CHICKEN))
   (:GOAL (AND (CRAVES HANGOVER-12 HOTDOG)
               (CRAVES GRIEF-10 CHICKEN))))

(DEFINE (PROBLEM STRIPS-MYSTY-9)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LEMON OKRA LETTUCE SCALLION CHOCOLATE YOGURT RICE BEEF
             ENDIVE ORANGE CHERRY HAM LOBSTER ONION MUFFIN COD APPLE
             CUCUMBER FLOUNDER PEAR MUTTON CHICKEN TURKEY HAMBURGER
             SWEETROLL PAPAYA ACHIEVEMENT AESTHETICS ANGINA HANGOVER ANXIETY
             ANGER LONELINESS BOILS LACERATION JEALOUSY SCIATICA
             DEPRESSION GRIEF PROSTATITIS ANGER-1 BOILS-2 DREAD ABRASION
             ANGINA-4 PROSTATITIS-8 HANGOVER-3 JEALOUSY-16 GRIEF-5
             DEPRESSION-6 ANXIETY-7 LONELINESS-13 LACERATION-14 SCIATICA-15
             ABRASION-11 DREAD-12 HANGOVER-9 LONELINESS-10 ANGER-30 ANGINA-31
             DEPRESSION-32 BOILS-29 ABRASION-26 GRIEF-27 JEALOUSY-28 MANITOBA
             SURREY GUANABARA KENTUCKY NEPTUNE JUPITER MARS EARTH)
   (:INIT (FOOD LEMON)
          (FOOD OKRA)
          (FOOD LETTUCE)
          (FOOD SCALLION)
          (FOOD CHOCOLATE)
          (FOOD YOGURT)
          (FOOD RICE)
          (FOOD BEEF)
          (FOOD ENDIVE)
          (FOOD ORANGE)
          (FOOD CHERRY)
          (FOOD HAM)
          (FOOD LOBSTER)
          (FOOD ONION)
          (FOOD MUFFIN)
          (FOOD COD)
          (FOOD APPLE)
          (FOOD CUCUMBER)
          (FOOD FLOUNDER)
          (FOOD PEAR)
          (FOOD MUTTON)
          (FOOD CHICKEN)
          (FOOD TURKEY)
          (FOOD HAMBURGER)
          (FOOD SWEETROLL)
          (FOOD PAPAYA)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE AESTHETICS)
          (PAIN ANGINA)
          (PAIN HANGOVER)
          (PAIN ANXIETY)
          (PAIN ANGER)
          (PAIN LONELINESS)
          (PAIN BOILS)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN SCIATICA)
          (PAIN DEPRESSION)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN ANGER-1)
          (PAIN BOILS-2)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN ANGINA-4)
          (PAIN PROSTATITIS-8)
          (PAIN HANGOVER-3)
          (PAIN JEALOUSY-16)
          (PAIN GRIEF-5)
          (PAIN DEPRESSION-6)
          (PAIN ANXIETY-7)
          (PAIN LONELINESS-13)
          (PAIN LACERATION-14)
          (PAIN SCIATICA-15)
          (PAIN ABRASION-11)
          (PAIN DREAD-12)
          (PAIN HANGOVER-9)
          (PAIN LONELINESS-10)
          (PAIN ANGER-30)
          (PAIN ANGINA-31)
          (PAIN DEPRESSION-32)
          (PAIN BOILS-29)
          (PAIN ABRASION-26)
          (PAIN GRIEF-27)
          (PAIN JEALOUSY-28)
          (PROVINCE MANITOBA)
          (PROVINCE SURREY)
          (PROVINCE GUANABARA)
          (PROVINCE KENTUCKY)
          (PLANET NEPTUNE)
          (PLANET JUPITER)
          (PLANET MARS)
          (PLANET EARTH)
          (LOCALE YOGURT MANITOBA)
          (LOCALE ONION KENTUCKY)
          (EATS PEAR MUFFIN)
          (LOCALE RICE KENTUCKY)
          (EATS CHOCOLATE LEMON)
          (EATS FLOUNDER ENDIVE)
          (EATS BEEF RICE)
          (EATS ORANGE LEMON)
          (EATS SCALLION OKRA)
          (HARMONY ACHIEVEMENT EARTH)
          (CRAVES ANGER-1 ENDIVE)
          (EATS YOGURT ENDIVE)
          (CRAVES ANGINA-31 CHICKEN)
          (EATS PAPAYA CHICKEN)
          (ORBITS MARS EARTH)
          (CRAVES ABRASION ENDIVE)
          (LOCALE ENDIVE SURREY)
          (EATS PEAR LOBSTER)
          (CRAVES GRIEF-5 ONION)
          (EATS HAM PAPAYA)
          (EATS TURKEY COD)
          (EATS CUCUMBER PEAR)
          (EATS CUCUMBER MUTTON)
          (CRAVES LONELINESS-10 MUTTON)
          (LOCALE ORANGE MANITOBA)
          (ORBITS JUPITER MARS)
          (CRAVES BOILS-29 TURKEY)
          (EATS MUTTON ONION)
          (EATS CHICKEN FLOUNDER)
          (CRAVES BOILS-2 ENDIVE)
          (EATS HAM CHERRY)
          (CRAVES HANGOVER LEMON)
          (EATS PEAR CUCUMBER)
          (LOCALE PEAR GUANABARA)
          (EATS RICE BEEF)
          (EATS PAPAYA HAM)
          (LOCALE TURKEY MANITOBA)
          (CRAVES LACERATION SCALLION)
          (EATS COD CHICKEN)
          (EATS BEEF ENDIVE)
          (EATS CHICKEN HAMBURGER)
          (EATS SWEETROLL HAMBURGER)
          (EATS CHERRY HAM)
          (LOCALE CHERRY GUANABARA)
          (EATS PEAR SWEETROLL)
          (CRAVES SCIATICA RICE)
          (CRAVES JEALOUSY-16 ONION)
          (EATS APPLE CUCUMBER)
          (CRAVES ANGINA LEMON)
          (EATS COD PAPAYA)
          (EATS CHERRY MUTTON)
          (EATS CUCUMBER APPLE)
          (LOCALE CHOCOLATE KENTUCKY)
          (LOCALE CHICKEN KENTUCKY)
          (CRAVES ANGINA-4 CHERRY)
          (CRAVES JEALOUSY-28 SWEETROLL)
          (EATS CHOCOLATE RICE)
          (CRAVES ABRASION-26 SWEETROLL)
          (EATS LOBSTER PEAR)
          (EATS FLOUNDER CHICKEN)
          (LOCALE LETTUCE KENTUCKY)
          (CRAVES DEPRESSION-32 CHICKEN)
          (CRAVES ANXIETY LEMON)
          (LOCALE LOBSTER MANITOBA)
          (EATS LEMON ORANGE)
          (CRAVES DREAD ENDIVE)
          (LOCALE CUCUMBER KENTUCKY)
          (EATS LETTUCE CHOCOLATE)
          (LOCALE OKRA MANITOBA)
          (CRAVES DREAD-12 FLOUNDER)
          (CRAVES ACHIEVEMENT SCALLION)
          (EATS RICE ORANGE)
          (EATS ORANGE RICE)
          (EATS CHOCOLATE LETTUCE)
          (EATS SCALLION ORANGE)
          (EATS ONION MUTTON)
          (EATS PAPAYA COD)
          (CRAVES PROSTATITIS RICE)
          (LOCALE FLOUNDER KENTUCKY)
          (EATS CHICKEN COD)
          (EATS APPLE SWEETROLL)
          (LOCALE SCALLION MANITOBA)
          (CRAVES JEALOUSY YOGURT)
          (LOCALE COD GUANABARA)
          (CRAVES ANGER-30 CHICKEN)
          (EATS PEAR MUTTON)
          (CRAVES GRIEF-27 SWEETROLL)
          (EATS LETTUCE YOGURT)
          (EATS FLOUNDER TURKEY)
          (EATS ONION PAPAYA)
          (EATS LOBSTER HAMBURGER)
          (CRAVES HANGOVER-3 LOBSTER)
          (CRAVES LONELINESS-13 COD)
          (EATS MUTTON PEAR)
          (LOCALE HAMBURGER SURREY)
          (ATTACKS SURREY GUANABARA)
          (EATS LEMON CHOCOLATE)
          (CRAVES ABRASION-11 FLOUNDER)
          (EATS MUFFIN PEAR)
          (ATTACKS MANITOBA SURREY)
          (LOCALE MUFFIN GUANABARA)
          (EATS LETTUCE SCALLION)
          (CRAVES LACERATION-14 COD)
          (EATS ENDIVE OKRA)
          (EATS ENDIVE FLOUNDER)
          (CRAVES LONELINESS OKRA)
          (CRAVES PROSTATITIS-8 LOBSTER)
          (EATS MUTTON CHERRY)
          (EATS TURKEY FLOUNDER)
          (LOCALE SWEETROLL KENTUCKY)
          (CRAVES ANGER OKRA)
          (LOCALE APPLE GUANABARA)
          (CRAVES AESTHETICS PAPAYA)
          (EATS ORANGE SCALLION)
          (CRAVES DEPRESSION-6 ONION)
          (ORBITS NEPTUNE JUPITER)
          (EATS RICE CHOCOLATE)
          (LOCALE PAPAYA GUANABARA)
          (EATS ONION SWEETROLL)
          (EATS ENDIVE BEEF)
          (LOCALE MUTTON SURREY)
          (EATS MUTTON CUCUMBER)
          (CRAVES BOILS SCALLION)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS SCALLION LETTUCE)
          (EATS HAMBURGER LOBSTER)
          (CRAVES ANXIETY-7 ONION)
          (EATS APPLE MUFFIN)
          (CRAVES GRIEF RICE)
          (EATS SWEETROLL PEAR)
          (EATS ENDIVE YOGURT)
          (EATS SWEETROLL APPLE)
          (EATS CHICKEN PAPAYA)
          (EATS MUFFIN APPLE)
          (CRAVES DEPRESSION RICE)
          (CRAVES SCIATICA-15 COD)
          (EATS OKRA SCALLION)
          (EATS HAMBURGER CHICKEN)
          (EATS SWEETROLL ONION)
          (LOCALE LEMON MANITOBA)
          (EATS COD TURKEY)
          (CRAVES HANGOVER-9 MUTTON)
          (HARMONY AESTHETICS MARS)
          (LOCALE BEEF GUANABARA)
          (EATS YOGURT LETTUCE)
          (EATS PAPAYA ONION)
          (LOCALE HAM GUANABARA)
          (EATS HAMBURGER SWEETROLL)
          (EATS OKRA ENDIVE))
   (:GOAL (AND (CRAVES ANGINA-4 RICE)
               (CRAVES LONELINESS-13 RICE))))

(DEFINE (PROBLEM STRIPS-MYST-10)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS POTATO KALE MUTTON WURST GRAPEFRUIT POPOVER HAROSET
             CUCUMBER APPLE HOTDOG ORANGE PORK SNICKERS LEMON TOMATO MUFFIN
             LOBSTER SCALLION HAMBURGER SHRIMP ONION ACHIEVEMENT
             AESTHETICS UNDERSTANDING ENTERTAINMENT LUBRICITY EXCITEMENT
             REST TRIUMPH LEARNING SATIETY LONELINESS DEPRESSION
             LACERATION PROSTATITIS ANXIETY SCIATICA JEALOUSY ANGER SURREY
             GUANABARA ARIZONA BOSNIA OREGON GOIAS QUEBEC PENNSYLVANIA
             BAVARIA KENTUCKY MANITOBA VULCAN VENUS SATURN PLUTO)
   (:INIT (FOOD POTATO)
          (FOOD KALE)
          (FOOD MUTTON)
          (FOOD WURST)
          (FOOD GRAPEFRUIT)
          (FOOD POPOVER)
          (FOOD HAROSET)
          (FOOD CUCUMBER)
          (FOOD APPLE)
          (FOOD HOTDOG)
          (FOOD ORANGE)
          (FOOD PORK)
          (FOOD SNICKERS)
          (FOOD LEMON)
          (FOOD TOMATO)
          (FOOD MUFFIN)
          (FOOD LOBSTER)
          (FOOD SCALLION)
          (FOOD HAMBURGER)
          (FOOD SHRIMP)
          (FOOD ONION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE AESTHETICS)
          (PLEASURE UNDERSTANDING)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE EXCITEMENT)
          (PLEASURE REST)
          (PLEASURE TRIUMPH)
          (PLEASURE LEARNING)
          (PLEASURE SATIETY)
          (PAIN LONELINESS)
          (PAIN DEPRESSION)
          (PAIN LACERATION)
          (PAIN PROSTATITIS)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN JEALOUSY)
          (PAIN ANGER)
          (PROVINCE SURREY)
          (PROVINCE GUANABARA)
          (PROVINCE ARIZONA)
          (PROVINCE BOSNIA)
          (PROVINCE OREGON)
          (PROVINCE GOIAS)
          (PROVINCE QUEBEC)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PROVINCE KENTUCKY)
          (PROVINCE MANITOBA)
          (PLANET VULCAN)
          (PLANET VENUS)
          (PLANET SATURN)
          (PLANET PLUTO)
          (EATS CUCUMBER SNICKERS)
          (EATS PORK HOTDOG)
          (LOCALE LOBSTER GUANABARA)
          (EATS PORK GRAPEFRUIT)
          (EATS HOTDOG ORANGE)
          (ATTACKS ARIZONA BOSNIA)
          (CRAVES LEARNING SCALLION)
          (LOCALE WURST QUEBEC)
          (LOCALE ONION QUEBEC)
          (CRAVES ANXIETY LEMON)
          (ATTACKS BOSNIA OREGON)
          (EATS LEMON ORANGE)
          (CRAVES DEPRESSION WURST)
          (EATS LEMON SNICKERS)
          (LOCALE MUFFIN GOIAS)
          (LOCALE MUTTON QUEBEC)
          (ATTACKS GUANABARA ARIZONA)
          (HARMONY TRIUMPH VENUS)
          (LOCALE KALE MANITOBA)
          (CRAVES LONELINESS KALE)
          (ATTACKS SURREY GUANABARA)
          (EATS SHRIMP TOMATO)
          (EATS APPLE POPOVER)
          (EATS SNICKERS HAROSET)
          (EATS KALE GRAPEFRUIT)
          (LOCALE ORANGE ARIZONA)
          (CRAVES ENTERTAINMENT GRAPEFRUIT)
          (ATTACKS GOIAS QUEBEC)
          (ATTACKS KENTUCKY MANITOBA)
          (LOCALE LEMON BOSNIA)
          (LOCALE POTATO KENTUCKY)
          (EATS LOBSTER SHRIMP)
          (CRAVES EXCITEMENT APPLE)
          (EATS WURST MUTTON)
          (EATS POTATO WURST)
          (CRAVES JEALOUSY HAMBURGER)
          (HARMONY AESTHETICS PLUTO)
          (EATS MUTTON KALE)
          (EATS PORK CUCUMBER)
          (EATS SNICKERS LEMON)
          (EATS SNICKERS POPOVER)
          (CRAVES LUBRICITY HAROSET)
          (LOCALE SHRIMP GOIAS)
          (LOCALE APPLE OREGON)
          (EATS GRAPEFRUIT WURST)
          (LOCALE SCALLION OREGON)
          (CRAVES LACERATION POPOVER)
          (EATS GRAPEFRUIT KALE)
          (LOCALE HOTDOG ARIZONA)
          (HARMONY LUBRICITY VENUS)
          (CRAVES REST HOTDOG)
          (LOCALE CUCUMBER BAVARIA)
          (CRAVES SATIETY SHRIMP)
          (CRAVES UNDERSTANDING MUTTON)
          (HARMONY REST VENUS)
          (EATS POPOVER SNICKERS)
          (ORBITS VENUS SATURN)
          (EATS POPOVER ORANGE)
          (LOCALE PORK PENNSYLVANIA)
          (EATS MUFFIN TOMATO)
          (EATS APPLE ORANGE)
          (EATS HAMBURGER SCALLION)
          (CRAVES ANGER SHRIMP)
          (LOCALE POPOVER OREGON)
          (EATS POPOVER APPLE)
          (EATS CUCUMBER PORK)
          (ATTACKS OREGON GOIAS)
          (CRAVES ACHIEVEMENT POTATO)
          (EATS SCALLION MUFFIN)
          (EATS ONION SHRIMP)
          (EATS TOMATO ONION)
          (EATS APPLE HAROSET)
          (HARMONY ENTERTAINMENT PLUTO)
          (EATS HAROSET SNICKERS)
          (LOCALE HAMBURGER GUANABARA)
          (EATS WURST GRAPEFRUIT)
          (EATS SHRIMP ONION)
          (ATTACKS QUEBEC PENNSYLVANIA)
          (EATS ONION TOMATO)
          (EATS LOBSTER HAMBURGER)
          (EATS SHRIMP LOBSTER)
          (EATS HAMBURGER LOBSTER)
          (CRAVES TRIUMPH MUFFIN)
          (EATS MUTTON WURST)
          (EATS SNICKERS SCALLION)
          (EATS WURST POTATO)
          (HARMONY UNDERSTANDING VENUS)
          (LOCALE TOMATO ARIZONA)
          (CRAVES PROSTATITIS HAROSET)
          (HARMONY LEARNING VENUS)
          (EATS MUFFIN SCALLION)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS SCALLION HAMBURGER)
          (CRAVES AESTHETICS KALE)
          (EATS ORANGE POPOVER)
          (EATS KALE MUTTON)
          (EATS HOTDOG APPLE)
          (ORBITS VULCAN VENUS)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (LOCALE HAROSET BOSNIA)
          (HARMONY EXCITEMENT VENUS)
          (EATS APPLE HOTDOG)
          (EATS ONION SCALLION)
          (EATS SNICKERS CUCUMBER)
          (EATS HOTDOG PORK)
          (LOCALE GRAPEFRUIT QUEBEC)
          (EATS TOMATO SHRIMP)
          (EATS ORANGE APPLE)
          (EATS HAROSET APPLE)
          (EATS KALE POTATO)
          (LOCALE SNICKERS MANITOBA)
          (EATS SCALLION SNICKERS)
          (EATS SCALLION ONION)
          (EATS ORANGE LEMON)
          (ORBITS SATURN PLUTO)
          (HARMONY SATIETY SATURN)
          (EATS POTATO KALE)
          (EATS TOMATO MUFFIN)
          (ATTACKS BAVARIA KENTUCKY)
          (EATS ORANGE HOTDOG)
          (EATS GRAPEFRUIT PORK)
          (CRAVES SCIATICA SCALLION))
   (:GOAL (AND (CRAVES SCIATICA TOMATO)
               (CRAVES LONELINESS CUCUMBER)
               (CRAVES ANGER APPLE))))

(DEFINE (PROBLEM STRIPS-MYSTY-11)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS HAMBURGER HAM SHRIMP MUFFIN YOGURT SCALLOP TUNA OKRA
             CUCUMBER MARZIPAN TOMATO MELON FLOUNDER KALE SNICKERS LUBRICITY
             HANGOVER BOILS DEPRESSION GRIEF PROSTATITIS JEALOUSY SCIATICA
             DREAD ABRASION ANXIETY ANGER LONELINESS ANGINA LACERATION
             JEALOUSY-1 GRIEF-2 LACERATION-8 PROSTATITIS-3 ANXIETY-4
             DEPRESSION-7 ANGINA-16 SCIATICA-5 HANGOVER-6 LONELINESS-15
             ABRASION-13 DREAD-14 MANITOBA PLUTO MARS)
   (:INIT (FOOD HAMBURGER)
          (FOOD HAM)
          (FOOD SHRIMP)
          (FOOD MUFFIN)
          (FOOD YOGURT)
          (FOOD SCALLOP)
          (FOOD TUNA)
          (FOOD OKRA)
          (FOOD CUCUMBER)
          (FOOD MARZIPAN)
          (FOOD TOMATO)
          (FOOD MELON)
          (FOOD FLOUNDER)
          (FOOD KALE)
          (FOOD SNICKERS)
          (PLEASURE LUBRICITY)
          (PAIN HANGOVER)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN JEALOUSY)
          (PAIN SCIATICA)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN ANXIETY)
          (PAIN ANGER)
          (PAIN LONELINESS)
          (PAIN ANGINA)
          (PAIN LACERATION)
          (PAIN JEALOUSY-1)
          (PAIN GRIEF-2)
          (PAIN LACERATION-8)
          (PAIN PROSTATITIS-3)
          (PAIN ANXIETY-4)
          (PAIN DEPRESSION-7)
          (PAIN ANGINA-16)
          (PAIN SCIATICA-5)
          (PAIN HANGOVER-6)
          (PAIN LONELINESS-15)
          (PAIN ABRASION-13)
          (PAIN DREAD-14)
          (PROVINCE MANITOBA)
          (PLANET PLUTO)
          (PLANET MARS)
          (EATS TOMATO KALE)
          (EATS TOMATO SNICKERS)
          (CRAVES DEPRESSION HAM)
          (EATS YOGURT OKRA)
          (EATS TUNA OKRA)
          (EATS MUFFIN YOGURT)
          (EATS SNICKERS MELON)
          (EATS MUFFIN SHRIMP)
          (LOCALE MARZIPAN MANITOBA)
          (LOCALE OKRA MANITOBA)
          (LOCALE YOGURT MANITOBA)
          (CRAVES LUBRICITY CUCUMBER)
          (EATS MELON MARZIPAN)
          (CRAVES DREAD YOGURT)
          (LOCALE MELON MANITOBA)
          (LOCALE TUNA MANITOBA)
          (CRAVES LONELINESS OKRA)
          (CRAVES LACERATION-8 TOMATO)
          (EATS CUCUMBER FLOUNDER)
          (EATS OKRA YOGURT)
          (CRAVES SCIATICA-5 FLOUNDER)
          (LOCALE MUFFIN MANITOBA)
          (CRAVES GRIEF HAM)
          (CRAVES SCIATICA MUFFIN)
          (EATS MARZIPAN CUCUMBER)
          (EATS CUCUMBER MARZIPAN)
          (EATS YOGURT SCALLOP)
          (LOCALE SCALLOP MANITOBA)
          (EATS FLOUNDER KALE)
          (CRAVES GRIEF-2 MARZIPAN)
          (EATS OKRA FLOUNDER)
          (EATS KALE TOMATO)
          (CRAVES DEPRESSION-7 MELON)
          (CRAVES ANXIETY TUNA)
          (EATS FLOUNDER CUCUMBER)
          (CRAVES HANGOVER-6 FLOUNDER)
          (EATS YOGURT MUFFIN)
          (CRAVES HANGOVER HAMBURGER)
          (CRAVES ANGINA-16 FLOUNDER)
          (EATS MELON SNICKERS)
          (ORBITS PLUTO MARS)
          (EATS TUNA SCALLOP)
          (CRAVES JEALOUSY SHRIMP)
          (CRAVES JEALOUSY-1 MARZIPAN)
          (EATS FLOUNDER OKRA)
          (EATS HAMBURGER HAM)
          (CRAVES PROSTATITIS-3 TOMATO)
          (EATS SNICKERS TOMATO)
          (EATS SHRIMP HAM)
          (CRAVES ANGINA CUCUMBER)
          (EATS SCALLOP YOGURT)
          (CRAVES BOILS HAM)
          (EATS MARZIPAN MELON)
          (CRAVES LONELINESS-15 KALE)
          (EATS HAM SHRIMP)
          (LOCALE HAMBURGER MANITOBA)
          (LOCALE HAM MANITOBA)
          (EATS FLOUNDER TOMATO)
          (CRAVES DREAD-14 SNICKERS)
          (CRAVES LACERATION CUCUMBER)
          (LOCALE KALE MANITOBA)
          (LOCALE TOMATO MANITOBA)
          (EATS HAM HAMBURGER)
          (LOCALE CUCUMBER MANITOBA)
          (LOCALE FLOUNDER MANITOBA)
          (CRAVES ABRASION SCALLOP)
          (EATS SHRIMP MUFFIN)
          (LOCALE SNICKERS MANITOBA)
          (LOCALE SHRIMP MANITOBA)
          (CRAVES ANXIETY-4 TOMATO)
          (EATS OKRA TUNA)
          (EATS MUFFIN HAMBURGER)
          (CRAVES ANGER OKRA)
          (EATS HAMBURGER MUFFIN)
          (EATS SCALLOP TUNA)
          (EATS KALE FLOUNDER)
          (HARMONY LUBRICITY MARS)
          (EATS TOMATO FLOUNDER)
          (CRAVES ABRASION-13 SNICKERS)
          (CRAVES PROSTATITIS SHRIMP))
   (:GOAL (AND (CRAVES GRIEF-2 SNICKERS))))

(DEFINE (PROBLEM STRIPS-MYSTY-12)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TUNA BROCCOLI LETTUCE SWEETROLL KALE LAMB SCALLOP
             TOMATO CANTELOPE MARZIPAN HAROSET APPLE FLOUNDER CHICKEN
             UNDERSTANDING INTOXICATION SATISFACTION CURIOSITY ACHIEVEMENT REST
             SATIETY TRIUMPH LEARNING EXCITEMENT ENTERTAINMENT ABRASION
             BOILS LACERATION GRIEF JEALOUSY DREAD LONELINESS ANGER
             ANGINA SCIATICA ANXIETY DEPRESSION HANGOVER JEALOUSY-1
             HANGOVER-2 PROSTATITIS ANXIETY-7 ANGINA-8 DEPRESSION-3 ANGER-4
             LONELINESS-15 LACERATION-16 BOILS-5 GRIEF-6 PROSTATITIS-11
             DREAD-12 ABRASION-13 SCIATICA-14 DEPRESSION-31 ANGER-32
             JEALOUSY-9 ABRASION-10 GRIEF-29 HANGOVER-30 DREAD-26 ANGINA-27
             BOILS-28 LONELINESS-22 ANXIETY-23 PROSTATITIS-24
             LACERATION-25 MANITOBA BAVARIA ARIZONA EARTH URANUS VULCAN VENUS)
   (:INIT (FOOD TUNA)
          (FOOD BROCCOLI)
          (FOOD LETTUCE)
          (FOOD SWEETROLL)
          (FOOD KALE)
          (FOOD LAMB)
          (FOOD SCALLOP)
          (FOOD TOMATO)
          (FOOD CANTELOPE)
          (FOOD MARZIPAN)
          (FOOD HAROSET)
          (FOOD APPLE)
          (FOOD FLOUNDER)
          (FOOD CHICKEN)
          (PLEASURE UNDERSTANDING)
          (PLEASURE INTOXICATION)
          (PLEASURE SATISFACTION)
          (PLEASURE CURIOSITY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE REST)
          (PLEASURE SATIETY)
          (PLEASURE TRIUMPH)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE ENTERTAINMENT)
          (PAIN ABRASION)
          (PAIN BOILS)
          (PAIN LACERATION)
          (PAIN GRIEF)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN LONELINESS)
          (PAIN ANGER)
          (PAIN ANGINA)
          (PAIN SCIATICA)
          (PAIN ANXIETY)
          (PAIN DEPRESSION)
          (PAIN HANGOVER)
          (PAIN JEALOUSY-1)
          (PAIN HANGOVER-2)
          (PAIN PROSTATITIS)
          (PAIN ANXIETY-7)
          (PAIN ANGINA-8)
          (PAIN DEPRESSION-3)
          (PAIN ANGER-4)
          (PAIN LONELINESS-15)
          (PAIN LACERATION-16)
          (PAIN BOILS-5)
          (PAIN GRIEF-6)
          (PAIN PROSTATITIS-11)
          (PAIN DREAD-12)
          (PAIN ABRASION-13)
          (PAIN SCIATICA-14)
          (PAIN DEPRESSION-31)
          (PAIN ANGER-32)
          (PAIN JEALOUSY-9)
          (PAIN ABRASION-10)
          (PAIN GRIEF-29)
          (PAIN HANGOVER-30)
          (PAIN DREAD-26)
          (PAIN ANGINA-27)
          (PAIN BOILS-28)
          (PAIN LONELINESS-22)
          (PAIN ANXIETY-23)
          (PAIN PROSTATITIS-24)
          (PAIN LACERATION-25)
          (PROVINCE MANITOBA)
          (PROVINCE BAVARIA)
          (PROVINCE ARIZONA)
          (PLANET EARTH)
          (PLANET URANUS)
          (PLANET VULCAN)
          (PLANET VENUS)
          (CRAVES INTOXICATION LETTUCE)
          (EATS TUNA SCALLOP)
          (EATS LETTUCE BROCCOLI)
          (CRAVES DREAD-26 FLOUNDER)
          (CRAVES DEPRESSION-3 TOMATO)
          (HARMONY INTOXICATION URANUS)
          (HARMONY SATISFACTION VULCAN)
          (HARMONY CURIOSITY URANUS)
          (CRAVES SCIATICA-14 MARZIPAN)
          (HARMONY REST VENUS)
          (CRAVES PROSTATITIS-11 MARZIPAN)
          (CRAVES ABRASION-10 HAROSET)
          (CRAVES SCIATICA SWEETROLL)
          (LOCALE APPLE BAVARIA)
          (CRAVES BOILS BROCCOLI)
          (LOCALE BROCCOLI BAVARIA)
          (CRAVES SATIETY CANTELOPE)
          (CRAVES ANGER SWEETROLL)
          (CRAVES ABRASION-13 MARZIPAN)
          (ATTACKS BAVARIA ARIZONA)
          (LOCALE FLOUNDER BAVARIA)
          (EATS HAROSET APPLE)
          (EATS APPLE HAROSET)
          (EATS SCALLOP TUNA)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS KALE APPLE)
          (EATS HAROSET CHICKEN)
          (EATS TUNA BROCCOLI)
          (CRAVES ANGER-32 HAROSET)
          (CRAVES ANGINA-8 TOMATO)
          (CRAVES HANGOVER-2 SCALLOP)
          (LOCALE TOMATO ARIZONA)
          (LOCALE LAMB MANITOBA)
          (EATS KALE TOMATO)
          (CRAVES UNDERSTANDING TUNA)
          (CRAVES REST TOMATO)
          (EATS BROCCOLI LETTUCE)
          (CRAVES CURIOSITY LAMB)
          (EATS SCALLOP LAMB)
          (LOCALE SCALLOP ARIZONA)
          (CRAVES ANXIETY-7 TOMATO)
          (CRAVES ABRASION TUNA)
          (LOCALE SWEETROLL ARIZONA)
          (CRAVES ANXIETY-23 CHICKEN)
          (CRAVES PROSTATITIS-24 CHICKEN)
          (CRAVES LONELINESS LETTUCE)
          (LOCALE TUNA BAVARIA)
          (EATS TOMATO LAMB)
          (EATS TOMATO KALE)
          (EATS APPLE KALE)
          (LOCALE LETTUCE MANITOBA)
          (EATS FLOUNDER MARZIPAN)
          (ORBITS VULCAN VENUS)
          (CRAVES ANXIETY SWEETROLL)
          (CRAVES ACHIEVEMENT SCALLOP)
          (EATS MARZIPAN FLOUNDER)
          (EATS LAMB TOMATO)
          (CRAVES HANGOVER-30 APPLE)
          (CRAVES ANGINA SWEETROLL)
          (EATS CANTELOPE TOMATO)
          (EATS CHICKEN HAROSET)
          (ORBITS EARTH URANUS)
          (EATS LAMB SCALLOP)
          (HARMONY ENTERTAINMENT VENUS)
          (CRAVES JEALOUSY-9 HAROSET)
          (EATS APPLE SWEETROLL)
          (CRAVES GRIEF LETTUCE)
          (EATS SWEETROLL APPLE)
          (ORBITS URANUS VULCAN)
          (EATS CANTELOPE LAMB)
          (LOCALE CANTELOPE MANITOBA)
          (CRAVES BOILS-28 FLOUNDER)
          (EATS TUNA SWEETROLL)
          (EATS SWEETROLL LETTUCE)
          (EATS SWEETROLL TUNA)
          (EATS FLOUNDER APPLE)
          (CRAVES LONELINESS-15 CANTELOPE)
          (CRAVES EXCITEMENT APPLE)
          (EATS BROCCOLI TUNA)
          (CRAVES DREAD LETTUCE)
          (CRAVES HANGOVER LAMB)
          (HARMONY EXCITEMENT URANUS)
          (LOCALE MARZIPAN MANITOBA)
          (CRAVES PROSTATITIS SCALLOP)
          (LOCALE HAROSET MANITOBA)
          (HARMONY LEARNING URANUS)
          (CRAVES ANGER-4 TOMATO)
          (EATS LETTUCE SWEETROLL)
          (CRAVES TRIUMPH MARZIPAN)
          (ATTACKS MANITOBA BAVARIA)
          (CRAVES LEARNING HAROSET)
          (CRAVES JEALOUSY LETTUCE)
          (EATS APPLE FLOUNDER)
          (CRAVES DEPRESSION-31 HAROSET)
          (CRAVES LONELINESS-22 CHICKEN)
          (CRAVES DREAD-12 MARZIPAN)
          (CRAVES LACERATION-16 CANTELOPE)
          (EATS SCALLOP KALE)
          (CRAVES DEPRESSION KALE)
          (HARMONY UNDERSTANDING VULCAN)
          (HARMONY TRIUMPH VULCAN)
          (EATS KALE SCALLOP)
          (CRAVES SATISFACTION KALE)
          (HARMONY SATIETY VENUS)
          (CRAVES BOILS-5 CANTELOPE)
          (EATS CHICKEN MARZIPAN)
          (LOCALE CHICKEN BAVARIA)
          (CRAVES GRIEF-29 APPLE)
          (CRAVES LACERATION BROCCOLI)
          (CRAVES GRIEF-6 CANTELOPE)
          (CRAVES ENTERTAINMENT CHICKEN)
          (EATS MARZIPAN CHICKEN)
          (CRAVES ANGINA-27 FLOUNDER)
          (EATS LAMB CANTELOPE)
          (CRAVES JEALOUSY-1 SCALLOP)
          (CRAVES LACERATION-25 CHICKEN)
          (LOCALE KALE MANITOBA)
          (EATS TOMATO CANTELOPE))
   (:GOAL (AND (CRAVES JEALOUSY LAMB))))

(DEFINE (PROBLEM STRIPS-MYSTY-13)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS OKRA TOFU HAM SCALLOP SHRIMP HAMBURGER PAPAYA HOTDOG
             TUNA ENTERTAINMENT STIMULATION TRIUMPH LEARNING
             EXCITEMENT CURIOSITY INTOXICATION HANGOVER GRIEF ANGINA ANXIETY
             LACERATION JEALOUSY ANGER SCIATICA PROSTATITIS BOILS DEPRESSION
             DREAD ABRASION ALSACE QUEBEC MORAVIA MANITOBA MERCURY PLUTO
             URANUS EARTH)
   (:INIT (FOOD OKRA)
          (FOOD TOFU)
          (FOOD HAM)
          (FOOD SCALLOP)
          (FOOD SHRIMP)
          (FOOD HAMBURGER)
          (FOOD PAPAYA)
          (FOOD HOTDOG)
          (FOOD TUNA)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE STIMULATION)
          (PLEASURE TRIUMPH)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE CURIOSITY)
          (PLEASURE INTOXICATION)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN ANGINA)
          (PAIN ANXIETY)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN ANGER)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PROVINCE ALSACE)
          (PROVINCE QUEBEC)
          (PROVINCE MORAVIA)
          (PROVINCE MANITOBA)
          (PLANET MERCURY)
          (PLANET PLUTO)
          (PLANET URANUS)
          (PLANET EARTH)
          (HARMONY INTOXICATION URANUS)
          (EATS SCALLOP TOFU)
          (CRAVES DEPRESSION HOTDOG)
          (CRAVES TRIUMPH HAM)
          (CRAVES BOILS PAPAYA)
          (HARMONY STIMULATION PLUTO)
          (LOCALE TOFU QUEBEC)
          (HARMONY EXCITEMENT EARTH)
          (CRAVES ANXIETY SCALLOP)
          (LOCALE TUNA MANITOBA)
          (LOCALE SHRIMP MORAVIA)
          (CRAVES JEALOUSY SHRIMP)
          (CRAVES CURIOSITY HOTDOG)
          (EATS PAPAYA OKRA)
          (EATS HAM TUNA)
          (EATS TUNA HAM)
          (CRAVES ANGER SHRIMP)
          (HARMONY ENTERTAINMENT URANUS)
          (CRAVES ANGINA HAM)
          (CRAVES GRIEF TOFU)
          (LOCALE SCALLOP MORAVIA)
          (EATS TOFU HAMBURGER)
          (CRAVES STIMULATION TOFU)
          (EATS HOTDOG PAPAYA)
          (LOCALE HOTDOG ALSACE)
          (CRAVES EXCITEMENT PAPAYA)
          (EATS PAPAYA HOTDOG)
          (EATS HOTDOG HAM)
          (CRAVES PROSTATITIS HAMBURGER)
          (HARMONY TRIUMPH URANUS)
          (CRAVES DREAD TUNA)
          (HARMONY LEARNING PLUTO)
          (EATS HOTDOG SHRIMP)
          (EATS TOFU SCALLOP)
          (CRAVES SCIATICA HAMBURGER)
          (CRAVES INTOXICATION TUNA)
          (ATTACKS QUEBEC MORAVIA)
          (EATS SHRIMP SCALLOP)
          (ORBITS MERCURY PLUTO)
          (CRAVES LEARNING HAMBURGER)
          (ATTACKS ALSACE QUEBEC)
          (ORBITS URANUS EARTH)
          (CRAVES HANGOVER OKRA)
          (EATS TUNA SHRIMP)
          (LOCALE OKRA ALSACE)
          (CRAVES ABRASION TUNA)
          (LOCALE PAPAYA ALSACE)
          (EATS HAMBURGER TOFU)
          (EATS HAM HOTDOG)
          (EATS OKRA PAPAYA)
          (EATS SHRIMP TUNA)
          (EATS SCALLOP SHRIMP)
          (LOCALE HAM ALSACE)
          (CRAVES ENTERTAINMENT OKRA)
          (LOCALE HAMBURGER QUEBEC)
          (EATS OKRA HAMBURGER)
          (ATTACKS MORAVIA MANITOBA)
          (EATS HAMBURGER OKRA)
          (CRAVES LACERATION SCALLOP)
          (ORBITS PLUTO URANUS)
          (EATS SHRIMP HOTDOG)
          (HARMONY CURIOSITY EARTH))
   (:GOAL (AND (CRAVES ANXIETY HAM))))

(DEFINE (PROBLEM STRIPS-MYSTY-14)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS WURST PEA PAPAYA RICE CUCUMBER YOGURT PEAR HAMBURGER
             TOMATO ENDIVE INTOXICATION DEPRESSION ABRASION HANGOVER
	     JEALOUSY GRIEF PROSTATITIS ANGINA DREAD SCIATICA BOILS
	     LONELINESS BAVARIA EARTH)
   (:INIT (FOOD WURST)
          (FOOD PEA)
          (FOOD PAPAYA)
          (FOOD RICE)
          (FOOD CUCUMBER)
          (FOOD YOGURT)
          (FOOD PEAR)
          (FOOD HAMBURGER)
          (FOOD TOMATO)
          (FOOD ENDIVE)
	  (PLEASURE INTOXICATION)
          (PAIN DEPRESSION)
          (PAIN ABRASION)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN ANGINA)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN BOILS)
          (PAIN LONELINESS)
          (PROVINCE BAVARIA)
          (PLANET EARTH)
	  (HARMONY INTOXICATION EARTH)
          (EATS WURST PAPAYA)
	  (CRAVES INTOXICATION ENDIVE)
          (EATS PEA YOGURT)
          (CRAVES BOILS ENDIVE)
          (EATS HAMBURGER PEAR)
          (EATS PAPAYA WURST)
          (LOCALE RICE BAVARIA)
          (EATS PAPAYA CUCUMBER)
          (LOCALE YOGURT BAVARIA)
          (EATS PEAR TOMATO)
          (LOCALE PEA BAVARIA)
          (CRAVES PROSTATITIS YOGURT)
          (EATS TOMATO YOGURT)
          (CRAVES ANGINA YOGURT)
          (EATS PEA PAPAYA)
          (CRAVES JEALOUSY PAPAYA)
          (EATS YOGURT PEA)
          (EATS WURST RICE)
          (EATS HAMBURGER TOMATO)
          (EATS YOGURT TOMATO)
          (CRAVES HANGOVER PAPAYA)
          (CRAVES LONELINESS ENDIVE)
          (LOCALE HAMBURGER BAVARIA)
          (LOCALE WURST BAVARIA)
          (CRAVES SCIATICA TOMATO)
          (EATS YOGURT ENDIVE)
          (EATS RICE CUCUMBER)
          (EATS CUCUMBER RICE)
          (LOCALE TOMATO BAVARIA)
          (CRAVES GRIEF CUCUMBER)
          (LOCALE CUCUMBER BAVARIA)
          (EATS RICE WURST)
          (EATS PAPAYA PEA)
          (EATS PEA CUCUMBER)
          (EATS ENDIVE PEAR)
          (EATS PEAR ENDIVE)
          (EATS CUCUMBER PAPAYA)
          (EATS PEAR HAMBURGER)
          (EATS TOMATO HAMBURGER)
          (EATS ENDIVE YOGURT)
          (EATS TOMATO PEAR)
          (EATS CUCUMBER PEA)
          (LOCALE ENDIVE BAVARIA)
          (LOCALE PAPAYA BAVARIA)
          (CRAVES ABRASION PAPAYA)
          (CRAVES DREAD TOMATO)
          (LOCALE PEAR BAVARIA)
          (CRAVES DEPRESSION WURST))
   (:GOAL (AND (CRAVES SCIATICA YOGURT))))

(DEFINE (PROBLEM STRIPS-MYSTY-15)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LAMB SCALLION CANTELOPE TOMATO POTATO KALE HAMBURGER
             PEAR BAGUETTE CHERRY PAPAYA TUNA BEEF CHOCOLATE LETTUCE COD
             HAM PEPPER TURKEY GUAVA SCALLOP POPOVER HOTDOG LEMON OKRA
             BROCCOLI CUCUMBER PEA APPLE MUTTON SNICKERS FLOUNDER MUFFIN TOFU
             SHRIMP EXPECTATION AESTHETICS UNDERSTANDING STIMULATION
             LOVE CURIOSITY INTOXICATION SATIETY EXCITEMENT LUBRICITY
             EMPATHY SATISFACTION ENTERTAINMENT ANGINA LACERATION
             ABRASION DEPRESSION ANXIETY GRIEF HANGOVER PROSTATITIS DREAD
             JEALOUSY LONELINESS SCIATICA HANGOVER-2 BOILS ANGER ANGER-3
             ABRASION-4 GRIEF-1 ANXIETY-6 BOILS-7 JEALOUSY-8 LONELINESS-15
             ANGINA-16 LACERATION-5 DREAD-12 SCIATICA-13 PROSTATITIS-14
             ANGINA-10 DEPRESSION-11 SCIATICA-32 ANGER-9 LONELINESS-31
             BOILS-29 ANXIETY-30 GRIEF-26 JEALOUSY-27 ABRASION-28
             PROSTATITIS-23 LACERATION-24 HANGOVER-25 DEPRESSION-21 DREAD-22
             ANXIETY-18 DEPRESSION-19 ABRASION-20 HANGOVER-17 ANGINA-64
             LONELINESS-61 SCIATICA-62 DREAD-63 ANGER-60 PROSTATITIS-59
             GRIEF-57 JEALOUSY-58 BOILS-55 LACERATION-56 SCIATICA-53
             HANGOVER-54 ANGINA-51 BOILS-52 ANGER-49 GRIEF-50 PROSTATITIS-47
             DEPRESSION-48 LONELINESS-46 ABRASION-44 DREAD-45 ANXIETY-41
             LACERATION-42 JEALOUSY-43 DEPRESSION-39 ABRASION-40 ANGER-37
             HANGOVER-38 ARIZONA BAVARIA ALSACE KENTUCKY MANITOBA PENNSYLVANIA
             SATURN URANUS NEPTUNE MARS)
   (:INIT (FOOD LAMB)
          (FOOD SCALLION)
          (FOOD CANTELOPE)
          (FOOD TOMATO)
          (FOOD POTATO)
          (FOOD KALE)
          (FOOD HAMBURGER)
          (FOOD PEAR)
          (FOOD BAGUETTE)
          (FOOD CHERRY)
          (FOOD PAPAYA)
          (FOOD TUNA)
          (FOOD BEEF)
          (FOOD CHOCOLATE)
          (FOOD LETTUCE)
          (FOOD COD)
          (FOOD HAM)
          (FOOD PEPPER)
          (FOOD TURKEY)
          (FOOD GUAVA)
          (FOOD SCALLOP)
          (FOOD POPOVER)
          (FOOD HOTDOG)
          (FOOD LEMON)
          (FOOD OKRA)
          (FOOD BROCCOLI)
          (FOOD CUCUMBER)
          (FOOD PEA)
          (FOOD APPLE)
          (FOOD MUTTON)
          (FOOD SNICKERS)
          (FOOD FLOUNDER)
          (FOOD MUFFIN)
          (FOOD TOFU)
          (FOOD SHRIMP)
          (PLEASURE EXPECTATION)
          (PLEASURE AESTHETICS)
          (PLEASURE UNDERSTANDING)
          (PLEASURE STIMULATION)
          (PLEASURE LOVE)
          (PLEASURE CURIOSITY)
          (PLEASURE INTOXICATION)
          (PLEASURE SATIETY)
          (PLEASURE EXCITEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE EMPATHY)
          (PLEASURE SATISFACTION)
          (PLEASURE ENTERTAINMENT)
          (PAIN ANGINA)
          (PAIN LACERATION)
          (PAIN ABRASION)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN GRIEF)
          (PAIN HANGOVER)
          (PAIN PROSTATITIS)
          (PAIN DREAD)
          (PAIN JEALOUSY)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN HANGOVER-2)
          (PAIN BOILS)
          (PAIN ANGER)
          (PAIN ANGER-3)
          (PAIN ABRASION-4)
          (PAIN GRIEF-1)
          (PAIN ANXIETY-6)
          (PAIN BOILS-7)
          (PAIN JEALOUSY-8)
          (PAIN LONELINESS-15)
          (PAIN ANGINA-16)
          (PAIN LACERATION-5)
          (PAIN DREAD-12)
          (PAIN SCIATICA-13)
          (PAIN PROSTATITIS-14)
          (PAIN ANGINA-10)
          (PAIN DEPRESSION-11)
          (PAIN SCIATICA-32)
          (PAIN ANGER-9)
          (PAIN LONELINESS-31)
          (PAIN BOILS-29)
          (PAIN ANXIETY-30)
          (PAIN GRIEF-26)
          (PAIN JEALOUSY-27)
          (PAIN ABRASION-28)
          (PAIN PROSTATITIS-23)
          (PAIN LACERATION-24)
          (PAIN HANGOVER-25)
          (PAIN DEPRESSION-21)
          (PAIN DREAD-22)
          (PAIN ANXIETY-18)
          (PAIN DEPRESSION-19)
          (PAIN ABRASION-20)
          (PAIN HANGOVER-17)
          (PAIN ANGINA-64)
          (PAIN LONELINESS-61)
          (PAIN SCIATICA-62)
          (PAIN DREAD-63)
          (PAIN ANGER-60)
          (PAIN PROSTATITIS-59)
          (PAIN GRIEF-57)
          (PAIN JEALOUSY-58)
          (PAIN BOILS-55)
          (PAIN LACERATION-56)
          (PAIN SCIATICA-53)
          (PAIN HANGOVER-54)
          (PAIN ANGINA-51)
          (PAIN BOILS-52)
          (PAIN ANGER-49)
          (PAIN GRIEF-50)
          (PAIN PROSTATITIS-47)
          (PAIN DEPRESSION-48)
          (PAIN LONELINESS-46)
          (PAIN ABRASION-44)
          (PAIN DREAD-45)
          (PAIN ANXIETY-41)
          (PAIN LACERATION-42)
          (PAIN JEALOUSY-43)
          (PAIN DEPRESSION-39)
          (PAIN ABRASION-40)
          (PAIN ANGER-37)
          (PAIN HANGOVER-38)
          (PROVINCE ARIZONA)
          (PROVINCE BAVARIA)
          (PROVINCE ALSACE)
          (PROVINCE KENTUCKY)
          (PROVINCE MANITOBA)
          (PROVINCE PENNSYLVANIA)
          (PLANET SATURN)
          (PLANET URANUS)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (EATS LETTUCE OKRA)
          (EATS GUAVA APPLE)
          (EATS HAM CHOCOLATE)
          (CRAVES ANXIETY-41 MUFFIN)
          (LOCALE KALE MANITOBA)
          (CRAVES HANGOVER-2 HAMBURGER)
          (CRAVES BOILS-7 BAGUETTE)
          (HARMONY ENTERTAINMENT MARS)
          (LOCALE HAM ARIZONA)
          (HARMONY LUBRICITY URANUS)
          (EATS CHOCOLATE HAM)
          (CRAVES LONELINESS-31 CHOCOLATE)
          (LOCALE FLOUNDER BAVARIA)
          (HARMONY EXCITEMENT URANUS)
          (EATS CANTELOPE POTATO)
          (CRAVES JEALOUSY-58 OKRA)
          (ORBITS NEPTUNE MARS)
          (EATS MUTTON PEPPER)
          (EATS HOTDOG MUFFIN)
          (EATS BROCCOLI SCALLOP)
          (ATTACKS BAVARIA ALSACE)
          (CRAVES LONELINESS POTATO)
          (LOCALE CUCUMBER ARIZONA)
          (HARMONY INTOXICATION URANUS)
          (CRAVES LONELINESS-15 CHERRY)
          (EATS HAM MUTTON)
          (CRAVES GRIEF-57 OKRA)
          (CRAVES ABRASION LAMB)
          (CRAVES ANXIETY-6 BAGUETTE)
          (LOCALE OKRA ALSACE)
          (CRAVES JEALOUSY TOMATO)
          (CRAVES GRIEF SCALLION)
          (CRAVES DEPRESSION-39 TOFU)
          (EATS POTATO CANTELOPE)
          (EATS PAPAYA CHERRY)
          (EATS MUTTON HAM)
          (EATS PEPPER MUTTON)
          (HARMONY CURIOSITY NEPTUNE)
          (EATS HAM COD)
          (EATS SCALLION KALE)
          (LOCALE BROCCOLI BAVARIA)
          (EATS BROCCOLI LEMON)
          (EATS GUAVA CUCUMBER)
          (CRAVES SCIATICA-13 PAPAYA)
          (CRAVES ABRASION-28 COD)
          (CRAVES GRIEF-26 COD)
          (EATS APPLE HOTDOG)
          (CRAVES LACERATION-56 BROCCOLI)
          (CRAVES GRIEF-1 PEAR)
          (EATS CUCUMBER GUAVA)
          (CRAVES ANGER-3 PEAR)
          (LOCALE CHOCOLATE ARIZONA)
          (CRAVES ANGER-49 APPLE)
          (LOCALE POPOVER ARIZONA)
          (EATS POTATO PEAR)
          (CRAVES LONELINESS-46 SNICKERS)
          (EATS LAMB HAMBURGER)
          (CRAVES EXCITEMENT MUTTON)
          (EATS TOFU PEPPER)
          (CRAVES JEALOUSY-27 COD)
          (EATS KALE LAMB)
          (EATS PEPPER TOFU)
          (CRAVES GRIEF-50 APPLE)
          (EATS SHRIMP SNICKERS)
          (LOCALE PEA ARIZONA)
          (EATS HAM OKRA)
          (EATS HAMBURGER TOMATO)
          (CRAVES PROSTATITIS-59 LEMON)
          (HARMONY EMPATHY NEPTUNE)
          (EATS GUAVA OKRA)
          (CRAVES ANGER-60 HOTDOG)
          (EATS OKRA LETTUCE)
          (LOCALE SNICKERS ALSACE)
          (CRAVES HANGOVER-54 CUCUMBER)
          (CRAVES LONELINESS-61 POPOVER)
          (EATS CUCUMBER KALE)
          (LOCALE TURKEY ARIZONA)
          (LOCALE CHERRY ALSACE)
          (EATS SCALLOP BROCCOLI)
          (EATS COD HAM)
          (LOCALE HAMBURGER MANITOBA)
          (LOCALE SHRIMP PENNSYLVANIA)
          (LOCALE PEPPER ARIZONA)
          (CRAVES ANGINA-51 PEA)
          (EATS TURKEY SHRIMP)
          (EATS LEMON SNICKERS)
          (CRAVES ANGER-9 BEEF)
          (CRAVES UNDERSTANDING HAMBURGER)
          (EATS TUNA BEEF)
          (CRAVES EXPECTATION SCALLION)
          (CRAVES PROSTATITIS CANTELOPE)
          (EATS PEA SNICKERS)
          (CRAVES SCIATICA-53 CUCUMBER)
          (LOCALE APPLE ARIZONA)
          (CRAVES ANGINA-64 SCALLOP)
          (EATS CUCUMBER SCALLOP)
          (LOCALE POTATO ALSACE)
          (CRAVES ANGINA LAMB)
          (CRAVES ANGINA-10 TUNA)
          (CRAVES SATISFACTION MUFFIN)
          (EATS FLOUNDER PEA)
          (EATS MUFFIN CHERRY)
          (CRAVES PROSTATITIS-47 MUTTON)
          (EATS SCALLION TUNA)
          (CRAVES DEPRESSION-19 TURKEY)
          (CRAVES DREAD-63 POPOVER)
          (EATS TUNA SCALLION)
          (EATS HOTDOG POPOVER)
          (LOCALE LETTUCE MANITOBA)
          (LOCALE SCALLOP ARIZONA)
          (EATS PEAR POTATO)
          (EATS HOTDOG APPLE)
          (EATS SHRIMP TURKEY)
          (EATS SNICKERS SHRIMP)
          (CRAVES DREAD-12 PAPAYA)
          (CRAVES EMPATHY FLOUNDER)
          (LOCALE BAGUETTE KENTUCKY)
          (ATTACKS ARIZONA BAVARIA)
          (CRAVES ANGER-37 SHRIMP)
          (EATS MUFFIN POPOVER)
          (ATTACKS ALSACE KENTUCKY)
          (CRAVES ANGINA-16 CHERRY)
          (EATS POTATO BAGUETTE)
          (EATS POPOVER HOTDOG)
          (CRAVES HANGOVER-38 SHRIMP)
          (CRAVES ABRASION-4 PEAR)
          (EATS APPLE GUAVA)
          (EATS FLOUNDER LEMON)
          (ORBITS SATURN URANUS)
          (EATS CUCUMBER COD)
          (CRAVES CURIOSITY TUNA)
          (EATS KALE CUCUMBER)
          (EATS PEA FLOUNDER)
          (CRAVES HANGOVER CANTELOPE)
          (ATTACKS MANITOBA PENNSYLVANIA)
          (HARMONY STIMULATION NEPTUNE)
          (CRAVES BOILS-29 LETTUCE)
          (HARMONY EXPECTATION MARS)
          (EATS APPLE FLOUNDER)
          (EATS SCALLOP CUCUMBER)
          (CRAVES LUBRICITY SNICKERS)
          (HARMONY LOVE URANUS)
          (CRAVES HANGOVER-25 HAM)
          (EATS LAMB KALE)
          (EATS BEEF CHERRY)
          (EATS MUFFIN HOTDOG)
          (LOCALE TOFU ARIZONA)
          (ORBITS URANUS NEPTUNE)
          (CRAVES SCIATICA-62 POPOVER)
          (CRAVES DREAD-22 PEPPER)
          (LOCALE SCALLION KENTUCKY)
          (CRAVES ANXIETY-30 LETTUCE)
          (CRAVES DREAD TOMATO)
          (LOCALE LAMB PENNSYLVANIA)
          (LOCALE CANTELOPE BAVARIA)
          (CRAVES JEALOUSY-43 MUFFIN)
          (CRAVES DEPRESSION SCALLION)
          (HARMONY AESTHETICS URANUS)
          (EATS TOMATO HAMBURGER)
          (EATS CHERRY BEEF)
          (EATS LEMON FLOUNDER)
          (CRAVES BOILS-55 BROCCOLI)
          (LOCALE MUFFIN MANITOBA)
          (CRAVES DEPRESSION-21 PEPPER)
          (EATS PEAR TOMATO)
          (CRAVES STIMULATION BAGUETTE)
          (EATS LEMON BROCCOLI)
          (CRAVES AESTHETICS KALE)
          (EATS CHERRY MUFFIN)
          (HARMONY SATIETY MARS)
          (LOCALE LEMON KENTUCKY)
          (LOCALE PEAR PENNSYLVANIA)
          (CRAVES JEALOUSY-8 BAGUETTE)
          (CRAVES BOILS-52 PEA)
          (CRAVES ENTERTAINMENT SHRIMP)
          (EATS HAMBURGER LAMB)
          (EATS HAMBURGER CANTELOPE)
          (LOCALE BEEF ARIZONA)
          (HARMONY SATISFACTION URANUS)
          (CRAVES ABRASION-40 TOFU)
          (EATS TUNA PAPAYA)
          (EATS SNICKERS LEMON)
          (LOCALE GUAVA ALSACE)
          (EATS OKRA HAM)
          (EATS BAGUETTE SCALLION)
          (CRAVES LACERATION-5 CHERRY)
          (CRAVES PROSTATITIS-14 PAPAYA)
          (LOCALE COD ARIZONA)
          (CRAVES SCIATICA-32 BEEF)
          (LOCALE TUNA BAVARIA)
          (CRAVES ANGER HAMBURGER)
          (CRAVES ABRASION-20 TURKEY)
          (CRAVES INTOXICATION CHOCOLATE)
          (CRAVES ABRASION-44 FLOUNDER)
          (CRAVES PROSTATITIS-23 HAM)
          (EATS CANTELOPE HAMBURGER)
          (EATS KALE SCALLION)
          (CRAVES LACERATION-24 HAM)
          (EATS FLOUNDER APPLE)
          (LOCALE PAPAYA ARIZONA)
          (CRAVES LACERATION LAMB)
          (CRAVES LACERATION-42 MUFFIN)
          (EATS OKRA GUAVA)
          (CRAVES ANXIETY SCALLION)
          (EATS CHOCOLATE SNICKERS)
          (EATS CHERRY PAPAYA)
          (EATS TOFU LETTUCE)
          (EATS TURKEY MUTTON)
          (EATS BAGUETTE POTATO)
          (EATS POPOVER TOFU)
          (EATS MUTTON TURKEY)
          (ATTACKS KENTUCKY MANITOBA)
          (CRAVES DEPRESSION-11 TUNA)
          (EATS SNICKERS CHOCOLATE)
          (EATS COD CUCUMBER)
          (CRAVES DREAD-45 FLOUNDER)
          (HARMONY UNDERSTANDING URANUS)
          (LOCALE MUTTON ARIZONA)
          (EATS BEEF TUNA)
          (CRAVES LOVE CHERRY)
          (EATS TOMATO PEAR)
          (CRAVES SATIETY OKRA)
          (CRAVES ANXIETY-18 TURKEY)
          (CRAVES HANGOVER-17 GUAVA)
          (EATS SCALLION BAGUETTE)
          (EATS PAPAYA TUNA)
          (EATS TOFU POPOVER)
          (CRAVES BOILS HAMBURGER)
          (LOCALE HOTDOG ALSACE)
          (EATS SNICKERS PEA)
          (EATS LETTUCE TOFU)
          (EATS POPOVER MUFFIN)
          (CRAVES SCIATICA KALE)
          (LOCALE TOMATO ARIZONA)
          (CRAVES DEPRESSION-48 MUTTON))
   (:GOAL (AND (CRAVES LACERATION-56 POPOVER)
               (CRAVES ABRASION-40 POPOVER)
               (CRAVES DEPRESSION-39 POTATO))))

(DEFINE (PROBLEM STRIPS-MYSTY-16)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS ARUGULA WURST LAMB HAROSET ONION HAM BACON OKRA MUFFIN
             TOMATO FLOUNDER CHICKEN SATISFACTION CURIOSITY
             ENTERTAINMENT LOVE UNDERSTANDING ACHIEVEMENT HANGOVER ANGINA
             SCIATICA ANGER LACERATION JEALOUSY ANXIETY GRIEF BOILS
             DEPRESSION PROSTATITIS DREAD ABRASION LONELINESS SCIATICA-1
             LACERATION-2 DREAD-3 ABRASION-4 HANGOVER-8 BOILS-5 ANGINA-6
             ANXIETY-7 LONELINESS-16 ALSACE SURREY NEPTUNE SATURN VULCAN
             VENUS)
   (:INIT (FOOD ARUGULA)
          (FOOD WURST)
          (FOOD LAMB)
          (FOOD HAROSET)
          (FOOD ONION)
          (FOOD HAM)
          (FOOD BACON)
          (FOOD OKRA)
          (FOOD MUFFIN)
          (FOOD TOMATO)
          (FOOD FLOUNDER)
          (FOOD CHICKEN)
          (PLEASURE SATISFACTION)
          (PLEASURE CURIOSITY)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE LOVE)
          (PLEASURE UNDERSTANDING)
          (PLEASURE ACHIEVEMENT)
          (PAIN HANGOVER)
          (PAIN ANGINA)
          (PAIN SCIATICA)
          (PAIN ANGER)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN ANXIETY)
          (PAIN GRIEF)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN PROSTATITIS)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN LONELINESS)
          (PAIN SCIATICA-1)
          (PAIN LACERATION-2)
          (PAIN DREAD-3)
          (PAIN ABRASION-4)
          (PAIN HANGOVER-8)
          (PAIN BOILS-5)
          (PAIN ANGINA-6)
          (PAIN ANXIETY-7)
          (PAIN LONELINESS-16)
          (PROVINCE ALSACE)
          (PROVINCE SURREY)
          (PLANET NEPTUNE)
          (PLANET SATURN)
          (PLANET VULCAN)
          (PLANET VENUS)
          (EATS BACON MUFFIN)
          (EATS MUFFIN HAM)
          (CRAVES ENTERTAINMENT HAM)
          (EATS FLOUNDER HAROSET)
          (EATS HAROSET ONION)
          (LOCALE ARUGULA SURREY)
          (CRAVES ANGINA WURST)
          (ORBITS NEPTUNE SATURN)
          (CRAVES LONELINESS BACON)
          (LOCALE WURST ALSACE)
          (CRAVES PROSTATITIS HAM)
          (CRAVES JEALOUSY HAROSET)
          (CRAVES ANXIETY HAROSET)
          (EATS WURST HAROSET)
          (EATS HAM OKRA)
          (HARMONY LOVE SATURN)
          (ORBITS SATURN VULCAN)
          (EATS HAM ONION)
          (CRAVES HANGOVER ARUGULA)
          (EATS LAMB OKRA)
          (HARMONY UNDERSTANDING SATURN)
          (LOCALE HAROSET ALSACE)
          (LOCALE FLOUNDER ALSACE)
          (EATS LAMB TOMATO)
          (LOCALE CHICKEN SURREY)
          (CRAVES HANGOVER-8 TOMATO)
          (EATS ONION HAROSET)
          (EATS HAM TOMATO)
          (EATS HAM MUFFIN)
          (CRAVES LONELINESS-16 CHICKEN)
          (EATS CHICKEN FLOUNDER)
          (CRAVES ANGINA-6 FLOUNDER)
          (CRAVES ABRASION BACON)
          (EATS ONION HAM)
          (CRAVES BOILS-5 FLOUNDER)
          (EATS OKRA HAM)
          (EATS MUFFIN CHICKEN)
          (CRAVES BOILS ONION)
          (EATS TOMATO ARUGULA)
          (EATS OKRA BACON)
          (EATS CHICKEN WURST)
          (CRAVES SCIATICA LAMB)
          (EATS FLOUNDER TOMATO)
          (CRAVES LACERATION-2 OKRA)
          (LOCALE BACON SURREY)
          (CRAVES UNDERSTANDING TOMATO)
          (LOCALE MUFFIN ALSACE)
          (EATS ARUGULA ONION)
          (EATS FLOUNDER CHICKEN)
          (CRAVES ABRASION-4 MUFFIN)
          (LOCALE ONION SURREY)
          (ORBITS VULCAN VENUS)
          (LOCALE OKRA ALSACE)
          (CRAVES ANGER LAMB)
          (CRAVES SCIATICA-1 OKRA)
          (EATS WURST CHICKEN)
          (LOCALE TOMATO ALSACE)
          (EATS HAROSET WURST)
          (EATS CHICKEN HAM)
          (CRAVES ACHIEVEMENT FLOUNDER)
          (CRAVES DREAD-3 MUFFIN)
          (EATS TOMATO HAM)
          (CRAVES DEPRESSION HAM)
          (HARMONY SATISFACTION SATURN)
          (LOCALE LAMB ALSACE)
          (EATS ARUGULA TOMATO)
          (HARMONY ACHIEVEMENT VENUS)
          (CRAVES ANXIETY-7 FLOUNDER)
          (CRAVES LOVE BACON)
          (CRAVES CURIOSITY LAMB)
          (EATS BACON OKRA)
          (EATS MUFFIN BACON)
          (CRAVES SATISFACTION ARUGULA)
          (HARMONY CURIOSITY VENUS)
          (EATS CHICKEN MUFFIN)
          (EATS HAROSET FLOUNDER)
          (CRAVES LACERATION HAROSET)
          (EATS HAM CHICKEN)
          (EATS ONION ARUGULA)
          (CRAVES GRIEF ONION)
          (LOCALE HAM SURREY)
          (EATS OKRA LAMB)
          (CRAVES DREAD BACON)
          (HARMONY ENTERTAINMENT SATURN)
          (ATTACKS ALSACE SURREY)
          (EATS TOMATO LAMB)
          (EATS TOMATO FLOUNDER))
   (:GOAL (AND (CRAVES LONELINESS LAMB)
               (CRAVES DREAD ARUGULA)
               (CRAVES HANGOVER-8 ARUGULA))))

(DEFINE (PROBLEM STRIPS-MYSTY-17)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS ARUGULA ORANGE FLOUNDER TUNA TOFU BACON SCALLOP LETTUCE
             RICE CHOCOLATE HOTDOG PEPPER WURST CHICKEN SWEETROLL PAPAYA
             LOBSTER TURKEY SHRIMP HAM APPLE MARZIPAN ONION PISTACHIO LEMON
             SCALLION SNICKERS CUCUMBER UNDERSTANDING CURIOSITY
             ACHIEVEMENT LUBRICITY EMPATHY EXPECTATION GRIEF PROSTATITIS
             HANGOVER ANGER JEALOUSY LACERATION ANGINA DEPRESSION DREAD
             ABRASION LONELINESS BOILS ANXIETY SCIATICA PROSTATITIS-4
             ANXIETY-1 HANGOVER-2 ANGER-8 DREAD-3 DEPRESSION-7 JEALOUSY-6
             LONELINESS-15 LACERATION-16 ANGINA-5 BOILS-14 ABRASION-12 GRIEF-13
             SCIATICA-11 BOILS-32 HANGOVER-9 ANGER-10 ANGINA-31 GRIEF-29
             SCIATICA-30 LACERATION-26 PROSTATITIS-27 DREAD-28 JEALOUSY-24
             DEPRESSION-25 LONELINESS-22 ABRASION-23 GRIEF-20 ANXIETY-21
             ANGER-17 LONELINESS-18 LACERATION-19 JEALOUSY-64 BOILS-61
             SCIATICA-62 PROSTATITIS-63 DREAD-60 ABRASION-58 HANGOVER-59
             BOSNIA ALSACE GUANABARA MORAVIA OREGON QUEBEC SURREY KENTUCKY
             PLUTO MARS SATURN MERCURY)
   (:INIT (FOOD ARUGULA)
          (FOOD ORANGE)
          (FOOD FLOUNDER)
          (FOOD TUNA)
          (FOOD TOFU)
          (FOOD BACON)
          (FOOD SCALLOP)
          (FOOD LETTUCE)
          (FOOD RICE)
          (FOOD CHOCOLATE)
          (FOOD HOTDOG)
          (FOOD PEPPER)
          (FOOD WURST)
          (FOOD CHICKEN)
          (FOOD SWEETROLL)
          (FOOD PAPAYA)
          (FOOD LOBSTER)
          (FOOD TURKEY)
          (FOOD SHRIMP)
          (FOOD HAM)
          (FOOD APPLE)
          (FOOD MARZIPAN)
          (FOOD ONION)
          (FOOD PISTACHIO)
          (FOOD LEMON)
          (FOOD SCALLION)
          (FOOD SNICKERS)
          (FOOD CUCUMBER)
          (PLEASURE UNDERSTANDING)
          (PLEASURE CURIOSITY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE EMPATHY)
          (PLEASURE EXPECTATION)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN JEALOUSY)
          (PAIN LACERATION)
          (PAIN ANGINA)
          (PAIN DEPRESSION)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN LONELINESS)
          (PAIN BOILS)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS-4)
          (PAIN ANXIETY-1)
          (PAIN HANGOVER-2)
          (PAIN ANGER-8)
          (PAIN DREAD-3)
          (PAIN DEPRESSION-7)
          (PAIN JEALOUSY-6)
          (PAIN LONELINESS-15)
          (PAIN LACERATION-16)
          (PAIN ANGINA-5)
          (PAIN BOILS-14)
          (PAIN ABRASION-12)
          (PAIN GRIEF-13)
          (PAIN SCIATICA-11)
          (PAIN BOILS-32)
          (PAIN HANGOVER-9)
          (PAIN ANGER-10)
          (PAIN ANGINA-31)
          (PAIN GRIEF-29)
          (PAIN SCIATICA-30)
          (PAIN LACERATION-26)
          (PAIN PROSTATITIS-27)
          (PAIN DREAD-28)
          (PAIN JEALOUSY-24)
          (PAIN DEPRESSION-25)
          (PAIN LONELINESS-22)
          (PAIN ABRASION-23)
          (PAIN GRIEF-20)
          (PAIN ANXIETY-21)
          (PAIN ANGER-17)
          (PAIN LONELINESS-18)
          (PAIN LACERATION-19)
          (PAIN JEALOUSY-64)
          (PAIN BOILS-61)
          (PAIN SCIATICA-62)
          (PAIN PROSTATITIS-63)
          (PAIN DREAD-60)
          (PAIN ABRASION-58)
          (PAIN HANGOVER-59)
          (PROVINCE BOSNIA)
          (PROVINCE ALSACE)
          (PROVINCE GUANABARA)
          (PROVINCE MORAVIA)
          (PROVINCE OREGON)
          (PROVINCE QUEBEC)
          (PROVINCE SURREY)
          (PROVINCE KENTUCKY)
          (PLANET PLUTO)
          (PLANET MARS)
          (PLANET SATURN)
          (PLANET MERCURY)
          (CRAVES ANGER-10 LOBSTER)
          (EATS PISTACHIO ONION)
          (CRAVES PROSTATITIS ARUGULA)
          (EATS SCALLION APPLE)
          (LOCALE HAM ALSACE)
          (CRAVES GRIEF-20 ONION)
          (ORBITS MARS SATURN)
          (EATS HAM LOBSTER)
          (LOCALE SWEETROLL QUEBEC)
          (EATS APPLE SCALLION)
          (LOCALE LOBSTER MORAVIA)
          (EATS MARZIPAN LETTUCE)
          (EATS TUNA TOFU)
          (EATS SHRIMP HOTDOG)
          (EATS ARUGULA BACON)
          (CRAVES DREAD-3 CHOCOLATE)
          (EATS CHOCOLATE ONION)
          (EATS SNICKERS RICE)
          (EATS SWEETROLL SHRIMP)
          (EATS SHRIMP CUCUMBER)
          (LOCALE LETTUCE ALSACE)
          (EATS FLOUNDER ORANGE)
          (ATTACKS ALSACE GUANABARA)
          (CRAVES CURIOSITY RICE)
          (EATS WURST LEMON)
          (CRAVES ANGER-8 CHOCOLATE)
          (EATS PAPAYA CUCUMBER)
          (ATTACKS MORAVIA OREGON)
          (LOCALE SHRIMP KENTUCKY)
          (LOCALE CUCUMBER GUANABARA)
          (LOCALE ONION MORAVIA)
          (CRAVES DEPRESSION-7 HOTDOG)
          (CRAVES GRIEF ARUGULA)
          (LOCALE ORANGE KENTUCKY)
          (HARMONY LUBRICITY MERCURY)
          (CRAVES BOILS-14 CHICKEN)
          (ATTACKS BOSNIA ALSACE)
          (CRAVES PROSTATITIS-63 SCALLION)
          (CRAVES LONELINESS-15 WURST)
          (LOCALE BACON ALSACE)
          (CRAVES BOILS-61 SCALLION)
          (EATS PEPPER PISTACHIO)
          (CRAVES BOILS-32 LOBSTER)
          (EATS TURKEY SHRIMP)
          (CRAVES ACHIEVEMENT CHOCOLATE)
          (CRAVES GRIEF-13 SWEETROLL)
          (CRAVES PROSTATITIS-27 HAM)
          (CRAVES EMPATHY HAM)
          (EATS HAM RICE)
          (ORBITS PLUTO MARS)
          (HARMONY ACHIEVEMENT MARS)
          (CRAVES ABRASION-23 MARZIPAN)
          (EATS HOTDOG FLOUNDER)
          (EATS PEPPER LOBSTER)
          (CRAVES JEALOUSY-64 LEMON)
          (CRAVES PROSTATITIS-4 RICE)
          (EATS LEMON SCALLOP)
          (EATS TOFU TUNA)
          (CRAVES LACERATION-16 WURST)
          (EATS ONION BACON)
          (CRAVES SCIATICA LETTUCE)
          (CRAVES DREAD-28 HAM)
          (EATS SCALLION SNICKERS)
          (EATS APPLE LETTUCE)
          (CRAVES ABRASION TOFU)
          (LOCALE TUNA BOSNIA)
          (HARMONY EMPATHY MARS)
          (CRAVES LACERATION-26 HAM)
          (EATS MARZIPAN LOBSTER)
          (CRAVES DEPRESSION TOFU)
          (CRAVES ANGINA TUNA)
          (CRAVES LONELINESS-22 MARZIPAN)
          (EATS WURST CHICKEN)
          (EATS SWEETROLL ONION)
          (CRAVES HANGOVER-2 RICE)
          (EATS BACON ONION)
          (HARMONY CURIOSITY MARS)
          (EATS MARZIPAN TUNA)
          (EATS ORANGE FLOUNDER)
          (LOCALE SNICKERS GUANABARA)
          (EATS ONION CHOCOLATE)
          (LOCALE TURKEY SURREY)
          (EATS TOFU SCALLION)
          (CRAVES JEALOUSY-24 APPLE)
          (EATS RICE SNICKERS)
          (CRAVES ANGER FLOUNDER)
          (CRAVES ABRASION-58 CUCUMBER)
          (CRAVES ANGER-17 PISTACHIO)
          (LOCALE CHICKEN BOSNIA)
          (CRAVES LONELINESS BACON)
          (EATS APPLE TURKEY)
          (CRAVES LONELINESS-18 PISTACHIO)
          (EATS BACON LETTUCE)
          (LOCALE APPLE GUANABARA)
          (LOCALE RICE MORAVIA)
          (EATS PISTACHIO SWEETROLL)
          (CRAVES ANXIETY-21 ONION)
          (EATS LOBSTER PEPPER)
          (EATS CUCUMBER PAPAYA)
          (CRAVES ABRASION-12 SWEETROLL)
          (CRAVES SCIATICA-30 SHRIMP)
          (EATS LETTUCE ARUGULA)
          (EATS SHRIMP TURKEY)
          (CRAVES ANXIETY-1 RICE)
          (EATS SWEETROLL CUCUMBER)
          (EATS APPLE ONION)
          (CRAVES BOILS SCALLOP)
          (CRAVES ANXIETY LETTUCE)
          (LOCALE HOTDOG MORAVIA)
          (CRAVES GRIEF-29 SHRIMP)
          (EATS PAPAYA CHICKEN)
          (EATS TUNA MARZIPAN)
          (CRAVES LACERATION TUNA)
          (ATTACKS OREGON QUEBEC)
          (EATS CHICKEN PAPAYA)
          (LOCALE CHOCOLATE MORAVIA)
          (EATS LETTUCE BACON)
          (EATS SWEETROLL PISTACHIO)
          (LOCALE PISTACHIO SURREY)
          (LOCALE SCALLOP GUANABARA)
          (LOCALE FLOUNDER MORAVIA)
          (ATTACKS QUEBEC SURREY)
          (ORBITS SATURN MERCURY)
          (EATS CHICKEN WURST)
          (LOCALE SCALLION QUEBEC)
          (CRAVES JEALOUSY-6 PEPPER)
          (LOCALE PAPAYA GUANABARA)
          (EATS SCALLION TOFU)
          (ATTACKS GUANABARA MORAVIA)
          (EATS SCALLOP LEMON)
          (EATS BACON ARUGULA)
          (EATS TURKEY APPLE)
          (EATS ARUGULA LETTUCE)
          (EATS HOTDOG SWEETROLL)
          (CRAVES HANGOVER ORANGE)
          (LOCALE WURST OREGON)
          (EATS RICE HAM)
          (EATS BACON LOBSTER)
          (EATS SNICKERS SCALLION)
          (EATS HOTDOG SHRIMP)
          (EATS FLOUNDER HOTDOG)
          (EATS LOBSTER MARZIPAN)
          (EATS PISTACHIO PEPPER)
          (LOCALE PEPPER ALSACE)
          (EATS SHRIMP SWEETROLL)
          (CRAVES UNDERSTANDING SCALLOP)
          (EATS ONION ARUGULA)
          (CRAVES ANGINA-31 TURKEY)
          (EATS ONION APPLE)
          (EATS LETTUCE APPLE)
          (EATS LEMON WURST)
          (EATS SCALLOP TURKEY)
          (EATS CUCUMBER SHRIMP)
          (EATS SWEETROLL HOTDOG)
          (EATS LOBSTER BACON)
          (CRAVES DREAD TOFU)
          (CRAVES JEALOUSY FLOUNDER)
          (CRAVES LUBRICITY WURST)
          (LOCALE MARZIPAN ALSACE)
          (EATS ONION PISTACHIO)
          (CRAVES DEPRESSION-25 APPLE)
          (CRAVES HANGOVER-59 CUCUMBER)
          (EATS LOBSTER HAM)
          (CRAVES HANGOVER-9 LOBSTER)
          (CRAVES SCIATICA-62 SCALLION)
          (EATS ARUGULA ONION)
          (CRAVES EXPECTATION CUCUMBER)
          (EATS TURKEY SCALLOP)
          (EATS ORANGE CHOCOLATE)
          (LOCALE ARUGULA BOSNIA)
          (HARMONY EXPECTATION MERCURY)
          (CRAVES LACERATION-19 PISTACHIO)
          (CRAVES DREAD-60 SNICKERS)
          (EATS ONION SWEETROLL)
          (ATTACKS SURREY KENTUCKY)
          (LOCALE LEMON SURREY)
          (CRAVES ANGINA-5 WURST)
          (HARMONY UNDERSTANDING MERCURY)
          (EATS CHOCOLATE ORANGE)
          (EATS CUCUMBER SWEETROLL)
          (EATS LETTUCE MARZIPAN)
          (LOCALE TOFU SURREY)
          (CRAVES SCIATICA-11 PAPAYA))
   (:GOAL (AND (CRAVES PROSTATITIS-4 TUNA)
               (CRAVES BOILS-32 TUNA)
               (CRAVES ANGER-10 TUNA))))

(DEFINE (PROBLEM STRIPS-MYSTY-18)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PORK ONION FLOUNDER MUFFIN TUNA GRAPEFRUIT BROCCOLI
             YOGURT LEMON TOFU PAPAYA HOTDOG PISTACHIO SWEETROLL CHOCOLATE
             LOBSTER ENDIVE RICE CHICKEN SNICKERS SHRIMP SCALLOP HAM TOMATO
             KALE ORANGE CHERRY MARZIPAN PEPPER PEAR SCALLION TURKEY
             POTATO STIMULATION LOVE LUBRICITY AESTHETICS EXPECTATION
             LEARNING CURIOSITY TRIUMPH ACHIEVEMENT UNDERSTANDING
             SATISFACTION ENTERTAINMENT INTOXICATION SATIETY EMPATHY REST
             EXCITEMENT LACERATION DREAD ANGINA PROSTATITIS JEALOUSY ABRASION
             HANGOVER DEPRESSION BOILS ANXIETY ANGER LONELINESS SCIATICA
             GRIEF LONELINESS-1 ANXIETY-2 GRIEF-4 ABRASION-8
             DEPRESSION-3 PROSTATITIS-7 DREAD-6 BOILS-16 SCIATICA-5 ANGER-15
             BOSNIA PENNSYLVANIA GOIAS OREGON URANUS JUPITER MARS VULCAN)
   (:INIT (FOOD PORK)
          (FOOD ONION)
          (FOOD FLOUNDER)
          (FOOD MUFFIN)
          (FOOD TUNA)
          (FOOD GRAPEFRUIT)
          (FOOD BROCCOLI)
          (FOOD YOGURT)
          (FOOD LEMON)
          (FOOD TOFU)
          (FOOD PAPAYA)
          (FOOD HOTDOG)
          (FOOD PISTACHIO)
          (FOOD SWEETROLL)
          (FOOD CHOCOLATE)
          (FOOD LOBSTER)
          (FOOD ENDIVE)
          (FOOD RICE)
          (FOOD CHICKEN)
          (FOOD SNICKERS)
          (FOOD SHRIMP)
          (FOOD SCALLOP)
          (FOOD HAM)
          (FOOD TOMATO)
          (FOOD KALE)
          (FOOD ORANGE)
          (FOOD CHERRY)
          (FOOD MARZIPAN)
          (FOOD PEPPER)
          (FOOD PEAR)
          (FOOD SCALLION)
          (FOOD TURKEY)
          (FOOD POTATO)
          (PLEASURE STIMULATION)
          (PLEASURE LOVE)
          (PLEASURE LUBRICITY)
          (PLEASURE AESTHETICS)
          (PLEASURE EXPECTATION)
          (PLEASURE LEARNING)
          (PLEASURE CURIOSITY)
          (PLEASURE TRIUMPH)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE UNDERSTANDING)
          (PLEASURE SATISFACTION)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE INTOXICATION)
          (PLEASURE SATIETY)
          (PLEASURE EMPATHY)
          (PLEASURE REST)
          (PLEASURE EXCITEMENT)
          (PAIN LACERATION)
          (PAIN DREAD)
          (PAIN ANGINA)
          (PAIN PROSTATITIS)
          (PAIN JEALOUSY)
          (PAIN ABRASION)
          (PAIN HANGOVER)
          (PAIN DEPRESSION)
          (PAIN BOILS)
          (PAIN ANXIETY)
          (PAIN ANGER)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN GRIEF)
          (PAIN LONELINESS-1)
          (PAIN ANXIETY-2)
          (PAIN GRIEF-4)
          (PAIN ABRASION-8)
          (PAIN DEPRESSION-3)
          (PAIN PROSTATITIS-7)
          (PAIN DREAD-6)
          (PAIN BOILS-16)
          (PAIN SCIATICA-5)
          (PAIN ANGER-15)
          (PROVINCE BOSNIA)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE GOIAS)
          (PROVINCE OREGON)
          (PLANET URANUS)
          (PLANET JUPITER)
          (PLANET MARS)
          (PLANET VULCAN)
          (EATS PEPPER TOMATO)
          (EATS BROCCOLI TURKEY)
          (LOCALE CHOCOLATE BOSNIA)
          (LOCALE CHICKEN GOIAS)
          (EATS POTATO ORANGE)
          (EATS HAM PEPPER)
          (HARMONY CURIOSITY VULCAN)
          (EATS ENDIVE ORANGE)
          (HARMONY LOVE JUPITER)
          (EATS GRAPEFRUIT TOMATO)
          (HARMONY EXCITEMENT MARS)
          (EATS MARZIPAN PEAR)
          (EATS SHRIMP HOTDOG)
          (EATS CHERRY TOMATO)
          (LOCALE RICE PENNSYLVANIA)
          (HARMONY EXPECTATION VULCAN)
          (EATS ONION LOBSTER)
          (EATS SWEETROLL SNICKERS)
          (HARMONY LEARNING MARS)
          (EATS PAPAYA SNICKERS)
          (EATS CHICKEN FLOUNDER)
          (EATS ONION CHICKEN)
          (CRAVES UNDERSTANDING RICE)
          (LOCALE HAM BOSNIA)
          (CRAVES DREAD-6 SCALLION)
          (EATS PISTACHIO CHERRY)
          (CRAVES LOVE ONION)
          (EATS PAPAYA SWEETROLL)
          (CRAVES LONELINESS HOTDOG)
          (CRAVES PROSTATITIS TUNA)
          (EATS TOFU CHOCOLATE)
          (CRAVES TRIUMPH PISTACHIO)
          (EATS SCALLOP CHICKEN)
          (CRAVES LONELINESS-1 SHRIMP)
          (LOCALE HOTDOG OREGON)
          (CRAVES ABRASION-8 KALE)
          (CRAVES SCIATICA LOBSTER)
          (EATS PEPPER HAM)
          (HARMONY UNDERSTANDING JUPITER)
          (ORBITS URANUS JUPITER)
          (EATS SNICKERS PEAR)
          (HARMONY INTOXICATION JUPITER)
          (EATS TOMATO PEPPER)
          (HARMONY SATIETY MARS)
          (EATS KALE MARZIPAN)
          (CRAVES BOILS LEMON)
          (EATS SNICKERS PAPAYA)
          (CRAVES STIMULATION PORK)
          (CRAVES GRIEF-4 SCALLOP)
          (EATS SCALLOP MUFFIN)
          (EATS SCALLION GRAPEFRUIT)
          (EATS SWEETROLL PAPAYA)
          (EATS PORK PEAR)
          (CRAVES EXPECTATION LEMON)
          (EATS CHERRY PEPPER)
          (EATS SCALLOP SHRIMP)
          (LOCALE TOMATO BOSNIA)
          (HARMONY REST VULCAN)
          (HARMONY STIMULATION VULCAN)
          (LOCALE TOFU GOIAS)
          (CRAVES EXCITEMENT TURKEY)
          (CRAVES HANGOVER YOGURT)
          (EATS PISTACHIO TOFU)
          (LOCALE PISTACHIO PENNSYLVANIA)
          (CRAVES DEPRESSION-3 KALE)
          (EATS PAPAYA YOGURT)
          (EATS PEAR SNICKERS)
          (EATS CHICKEN ONION)
          (EATS TUNA CHOCOLATE)
          (CRAVES ANGINA TUNA)
          (EATS LEMON PAPAYA)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (EATS SNICKERS CHERRY)
          (EATS POTATO SNICKERS)
          (EATS YOGURT FLOUNDER)
          (CRAVES BOILS-16 TURKEY)
          (EATS YOGURT PAPAYA)
          (HARMONY TRIUMPH VULCAN)
          (LOCALE ORANGE GOIAS)
          (HARMONY LUBRICITY JUPITER)
          (EATS FLOUNDER CHICKEN)
          (EATS GRAPEFRUIT SCALLION)
          (EATS LEMON POTATO)
          (EATS TOMATO GRAPEFRUIT)
          (EATS MUFFIN YOGURT)
          (EATS SNICKERS POTATO)
          (LOCALE FLOUNDER BOSNIA)
          (EATS SCALLION TUNA)
          (EATS CHICKEN SNICKERS)
          (EATS SCALLOP RICE)
          (EATS SCALLION SCALLOP)
          (CRAVES JEALOUSY BROCCOLI)
          (LOCALE SCALLION BOSNIA)
          (LOCALE POTATO BOSNIA)
          (EATS CHOCOLATE TOFU)
          (HARMONY SATISFACTION VULCAN)
          (LOCALE PEAR BOSNIA)
          (EATS RICE SCALLOP)
          (EATS ORANGE ENDIVE)
          (CRAVES ANGER-15 POTATO)
          (EATS SHRIMP SCALLOP)
          (LOCALE ENDIVE OREGON)
          (EATS YOGURT MUFFIN)
          (EATS LOBSTER ONION)
          (CRAVES ANGER PAPAYA)
          (CRAVES LACERATION ONION)
          (EATS BROCCOLI ORANGE)
          (EATS TURKEY BROCCOLI)
          (LOCALE SNICKERS PENNSYLVANIA)
          (CRAVES SATIETY HAM)
          (LOCALE LEMON PENNSYLVANIA)
          (EATS CHERRY SNICKERS)
          (ORBITS JUPITER MARS)
          (CRAVES GRIEF ENDIVE)
          (LOCALE MUFFIN GOIAS)
          (EATS FLOUNDER YOGURT)
          (EATS MUFFIN SCALLOP)
          (CRAVES ACHIEVEMENT CHOCOLATE)
          (EATS KALE POTATO)
          (CRAVES ANXIETY-2 SHRIMP)
          (EATS SNICKERS SWEETROLL)
          (LOCALE TURKEY PENNSYLVANIA)
          (LOCALE TUNA BOSNIA)
          (EATS CHERRY PISTACHIO)
          (CRAVES LUBRICITY FLOUNDER)
          (EATS ENDIVE RICE)
          (LOCALE CHERRY BOSNIA)
          (EATS ORANGE POTATO)
          (HARMONY AESTHETICS VULCAN)
          (LOCALE GRAPEFRUIT GOIAS)
          (EATS TOFU PISTACHIO)
          (EATS POTATO KALE)
          (CRAVES LEARNING PAPAYA)
          (LOCALE PEPPER OREGON)
          (EATS SNICKERS CHICKEN)
          (EATS SWEETROLL LOBSTER)
          (CRAVES EMPATHY ORANGE)
          (HARMONY ACHIEVEMENT JUPITER)
          (CRAVES PROSTATITIS-7 MARZIPAN)
          (EATS TURKEY HOTDOG)
          (EATS POTATO LEMON)
          (CRAVES SATISFACTION CHICKEN)
          (EATS ORANGE BROCCOLI)
          (EATS CHICKEN SCALLION)
          (EATS CHOCOLATE TUNA)
          (ATTACKS GOIAS OREGON)
          (EATS PISTACHIO TOMATO)
          (CRAVES AESTHETICS TUNA)
          (EATS PEPPER CHERRY)
          (CRAVES DEPRESSION YOGURT)
          (CRAVES DREAD FLOUNDER)
          (HARMONY ENTERTAINMENT MARS)
          (HARMONY EMPATHY JUPITER)
          (EATS PAPAYA LEMON)
          (EATS TOMATO CHERRY)
          (CRAVES SCIATICA-5 TURKEY)
          (CRAVES CURIOSITY HOTDOG)
          (LOCALE ONION BOSNIA)
          (ORBITS MARS VULCAN)
          (CRAVES ABRASION BROCCOLI)
          (EATS PORK HAM)
          (CRAVES REST PEAR)
          (EATS PEAR PORK)
          (EATS HOTDOG TURKEY)
          (LOCALE SHRIMP GOIAS)
          (LOCALE SCALLOP PENNSYLVANIA)
          (EATS SCALLOP SCALLION)
          (CRAVES INTOXICATION SCALLOP)
          (LOCALE LOBSTER PENNSYLVANIA)
          (ATTACKS BOSNIA PENNSYLVANIA)
          (EATS HAM PORK)
          (EATS HOTDOG SHRIMP)
          (CRAVES ANXIETY LEMON)
          (EATS TUNA SCALLION)
          (ATTACKS PENNSYLVANIA GOIAS)
          (CRAVES ENTERTAINMENT SHRIMP)
          (LOCALE PAPAYA BOSNIA)
          (EATS MARZIPAN KALE)
          (EATS TOMATO PISTACHIO)
          (LOCALE YOGURT PENNSYLVANIA)
          (LOCALE PORK GOIAS)
          (EATS SCALLION CHICKEN)
          (LOCALE BROCCOLI BOSNIA)
          (EATS RICE ENDIVE)
          (EATS CHICKEN SCALLOP)
          (EATS PEAR MARZIPAN)
          (LOCALE SWEETROLL BOSNIA)
          (LOCALE KALE BOSNIA)
          (EATS LOBSTER SWEETROLL))
   (:GOAL (AND (CRAVES LACERATION CHICKEN)
               (CRAVES ANGINA CHICKEN)
               (CRAVES ANGER-15 CHICKEN)
               (CRAVES DREAD CHICKEN))))

(DEFINE (PROBLEM STRIPS-MYSTY-19)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS COD POPOVER PISTACHIO KALE POTATO TOFU HOTDOG SNICKERS
             MUFFIN MARZIPAN LETTUCE GUAVA SWEETROLL CANTELOPE APPLE WURST
             OKRA PORK HAMBURGER LAMB ENDIVE CHERRY TURKEY LEMON SHRIMP
             HAROSET MUTTON BACON AESTHETICS SATISFACTION UNDERSTANDING
             TRIUMPH ENTERTAINMENT CURIOSITY LOVE LUBRICITY SATIETY
             ACHIEVEMENT LEARNING EMPATHY INTOXICATION EXCITEMENT LONELINESS
             ABRASION GRIEF DEPRESSION ANGER SCIATICA PROSTATITIS ANXIETY
             DREAD ANGINA HANGOVER BOILS BOSNIA GOIAS KENTUCKY MANITOBA
             ALSACE ARIZONA BAVARIA PENNSYLVANIA GUANABARA MORAVIA SATURN
             NEPTUNE MARS EARTH)
   (:INIT (FOOD COD)
          (FOOD POPOVER)
          (FOOD PISTACHIO)
          (FOOD KALE)
          (FOOD POTATO)
          (FOOD TOFU)
          (FOOD HOTDOG)
          (FOOD SNICKERS)
          (FOOD MUFFIN)
          (FOOD MARZIPAN)
          (FOOD LETTUCE)
          (FOOD GUAVA)
          (FOOD SWEETROLL)
          (FOOD CANTELOPE)
          (FOOD APPLE)
          (FOOD WURST)
          (FOOD OKRA)
          (FOOD PORK)
          (FOOD HAMBURGER)
          (FOOD LAMB)
          (FOOD ENDIVE)
          (FOOD CHERRY)
          (FOOD TURKEY)
          (FOOD LEMON)
          (FOOD SHRIMP)
          (FOOD HAROSET)
          (FOOD MUTTON)
          (FOOD BACON)
          (PLEASURE AESTHETICS)
          (PLEASURE SATISFACTION)
          (PLEASURE UNDERSTANDING)
          (PLEASURE TRIUMPH)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE CURIOSITY)
          (PLEASURE LOVE)
          (PLEASURE LUBRICITY)
          (PLEASURE SATIETY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LEARNING)
          (PLEASURE EMPATHY)
          (PLEASURE INTOXICATION)
          (PLEASURE EXCITEMENT)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN ANGER)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS)
          (PAIN ANXIETY)
          (PAIN DREAD)
          (PAIN ANGINA)
          (PAIN HANGOVER)
          (PAIN BOILS)
          (PROVINCE BOSNIA)
          (PROVINCE GOIAS)
          (PROVINCE KENTUCKY)
          (PROVINCE MANITOBA)
          (PROVINCE ALSACE)
          (PROVINCE ARIZONA)
          (PROVINCE BAVARIA)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE GUANABARA)
          (PROVINCE MORAVIA)
          (PLANET SATURN)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (PLANET EARTH)
          (EATS POPOVER HOTDOG)
          (CRAVES LUBRICITY WURST)
          (LOCALE BACON KENTUCKY)
          (CRAVES LONELINESS KALE)
          (CRAVES ANXIETY CANTELOPE)
          (EATS LETTUCE BACON)
          (EATS TOFU POTATO)
          (EATS HAMBURGER SWEETROLL)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS HAMBURGER LAMB)
          (LOCALE OKRA BOSNIA)
          (LOCALE HAMBURGER KENTUCKY)
          (EATS LAMB TURKEY)
          (EATS HAMBURGER LEMON)
          (LOCALE APPLE MORAVIA)
          (EATS CANTELOPE LETTUCE)
          (EATS SHRIMP MARZIPAN)
          (EATS CANTELOPE WURST)
          (EATS APPLE KALE)
          (EATS SHRIMP COD)
          (EATS LETTUCE CANTELOPE)
          (EATS SNICKERS COD)
          (CRAVES TRIUMPH TOFU)
          (CRAVES ANGER LETTUCE)
          (EATS TURKEY LAMB)
          (EATS SHRIMP HAROSET)
          (CRAVES ENTERTAINMENT HOTDOG)
          (CRAVES DEPRESSION LETTUCE)
          (CRAVES HANGOVER SHRIMP)
          (EATS PISTACHIO SNICKERS)
          (ATTACKS ALSACE ARIZONA)
          (EATS BACON LETTUCE)
          (EATS POTATO TOFU)
          (LOCALE HOTDOG KENTUCKY)
          (EATS POTATO POPOVER)
          (EATS KALE SNICKERS)
          (HARMONY ACHIEVEMENT MARS)
          (EATS HOTDOG PISTACHIO)
          (CRAVES SCIATICA GUAVA)
          (EATS MUTTON TURKEY)
          (EATS KALE PISTACHIO)
          (ATTACKS MANITOBA ALSACE)
          (ATTACKS GOIAS KENTUCKY)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS HAROSET SHRIMP)
          (LOCALE PORK ARIZONA)
          (HARMONY AESTHETICS MARS)
          (LOCALE LEMON ARIZONA)
          (EATS LAMB HAMBURGER)
          (EATS PISTACHIO HOTDOG)
          (EATS BACON PORK)
          (EATS KALE COD)
          (LOCALE POTATO MORAVIA)
          (EATS MUFFIN COD)
          (HARMONY UNDERSTANDING NEPTUNE)
          (EATS POPOVER POTATO)
          (EATS HAMBURGER PORK)
          (CRAVES AESTHETICS POPOVER)
          (EATS PORK SHRIMP)
          (EATS LEMON HAMBURGER)
          (EATS HOTDOG SNICKERS)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (EATS TURKEY MUTTON)
          (CRAVES EXCITEMENT BACON)
          (EATS SWEETROLL HAMBURGER)
          (CRAVES UNDERSTANDING KALE)
          (CRAVES SATIETY OKRA)
          (EATS ENDIVE WURST)
          (EATS SNICKERS HOTDOG)
          (CRAVES CURIOSITY MUFFIN)
          (LOCALE KALE GUANABARA)
          (EATS SNICKERS MUFFIN)
          (CRAVES LOVE MARZIPAN)
          (EATS TOFU MUFFIN)
          (LOCALE TURKEY GOIAS)
          (LOCALE LETTUCE BAVARIA)
          (ATTACKS KENTUCKY MANITOBA)
          (EATS SNICKERS KALE)
          (CRAVES PROSTATITIS GUAVA)
          (EATS GUAVA TURKEY)
          (EATS SWEETROLL SHRIMP)
          (LOCALE GUAVA ALSACE)
          (EATS LAMB MARZIPAN)
          (HARMONY LUBRICITY EARTH)
          (ATTACKS BOSNIA GOIAS)
          (EATS OKRA CHERRY)
          (HARMONY LEARNING MARS)
          (EATS LAMB MUTTON)
          (EATS LEMON PORK)
          (CRAVES BOILS SHRIMP)
          (EATS MARZIPAN SHRIMP)
          (EATS COD SHRIMP)
          (EATS COD SNICKERS)
          (EATS LEMON WURST)
          (EATS OKRA MUTTON)
          (EATS MUTTON HAROSET)
          (LOCALE CANTELOPE BAVARIA)
          (LOCALE CHERRY GOIAS)
          (EATS PISTACHIO KALE)
          (EATS SNICKERS PISTACHIO)
          (LOCALE SNICKERS KENTUCKY)
          (EATS WURST LEMON)
          (CRAVES DREAD LAMB)
          (EATS PORK LEMON)
          (HARMONY INTOXICATION NEPTUNE)
          (LOCALE LAMB MANITOBA)
          (EATS APPLE ENDIVE)
          (ATTACKS ARIZONA BAVARIA)
          (ORBITS SATURN NEPTUNE)
          (EATS HAROSET GUAVA)
          (ATTACKS GUANABARA MORAVIA)
          (CRAVES ABRASION KALE)
          (EATS PORK HAMBURGER)
          (EATS SHRIMP PORK)
          (LOCALE COD KENTUCKY)
          (LOCALE MARZIPAN BOSNIA)
          (LOCALE SHRIMP ARIZONA)
          (EATS TURKEY MARZIPAN)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS KALE APPLE)
          (LOCALE ENDIVE BAVARIA)
          (CRAVES EMPATHY CHERRY)
          (LOCALE MUFFIN BOSNIA)
          (CRAVES INTOXICATION SHRIMP)
          (HARMONY LOVE MARS)
          (LOCALE PISTACHIO BAVARIA)
          (EATS TURKEY SHRIMP)
          (EATS SHRIMP TURKEY)
          (HARMONY SATISFACTION NEPTUNE)
          (EATS COD KALE)
          (EATS CHERRY OKRA)
          (EATS BACON APPLE)
          (HARMONY CURIOSITY MARS)
          (HARMONY SATIETY EARTH)
          (EATS GUAVA HAROSET)
          (EATS MARZIPAN TURKEY)
          (EATS HOTDOG POPOVER)
          (ORBITS MARS EARTH)
          (EATS POTATO KALE)
          (CRAVES ANGINA LEMON)
          (CRAVES GRIEF SNICKERS)
          (LOCALE HAROSET GOIAS)
          (EATS WURST CANTELOPE)
          (HARMONY TRIUMPH EARTH)
          (EATS MUFFIN SNICKERS)
          (EATS WURST ENDIVE)
          (EATS MUTTON LAMB)
          (EATS SHRIMP SWEETROLL)
          (EATS CHERRY CANTELOPE)
          (CRAVES SATISFACTION PISTACHIO)
          (EATS ENDIVE APPLE)
          (EATS MUFFIN TOFU)
          (EATS APPLE BACON)
          (EATS CANTELOPE CHERRY)
          (LOCALE POPOVER GOIAS)
          (EATS COD MUFFIN)
          (EATS TURKEY GUAVA)
          (EATS KALE POTATO)
          (LOCALE TOFU ALSACE)
          (LOCALE MUTTON ARIZONA)
          (LOCALE WURST MANITOBA)
          (CRAVES LEARNING LAMB)
          (EATS HAROSET MUTTON)
          (EATS PORK BACON)
          (ORBITS NEPTUNE MARS)
          (HARMONY EMPATHY EARTH)
          (EATS MUTTON OKRA)
          (ATTACKS BAVARIA PENNSYLVANIA)
          (EATS MARZIPAN LAMB)
          (CRAVES ACHIEVEMENT PORK))
   (:GOAL (AND (CRAVES SCIATICA MUTTON)
               (CRAVES GRIEF LETTUCE)
               (CRAVES DREAD PISTACHIO))))

(DEFINE (PROBLEM STRIPS-MYSTY-20)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS POTATO-12 HAMBURGER-13 HAROSET-14 WURST-15 CHERRY-7
             POPOVER-6 BEEF-5 CHICKEN-16 GRAPEFRUIT-8 MUFFIN-3 RICE-4
             MARZIPAN-1 MELON-2 TUNA MELON PORK KALE CHOCOLATE SHRIMP
             GRAPEFRUIT PEPPER BROCCOLI CANTELOPE PEA HAM BAGUETTE FLOUNDER COD
             APPLE TOMATO GUAVA CHERRY LAMB YOGURT MUTTON PISTACHIO LEMON
             SCALLION LETTUCE SNICKERS TURKEY WONDERBREAD HOTDOG PAPAYA
             POTATO MARZIPAN RICE PEAR HAMBURGER HAROSET SWEETROLL TOFU
             OKRA ORANGE SCALLOP WURST ONION BEEF ARUGULA MUFFIN LOBSTER
             BACON CHICKEN CUCUMBER ENDIVE POPOVER AESTHETICS
             ACHIEVEMENT LUBRICITY EXCITEMENT EXPECTATION UNDERSTANDING
             STIMULATION TRIUMPH REST SATISFACTION INTOXICATION LOVE SATIETY
             EMPATHY LEARNING ENTERTAINMENT CURIOSITY ACHIEVEMENT-11
             EXPECTATION-10 INTOXICATION-9 EXCITEMENT-32 ENTERTAINMENT-31
             LEARNING-30 LOVE-29 REST-28 SCIATICA BOILS LACERATION DREAD ANGER
             LONELINESS HANGOVER JEALOUSY GRIEF ANGINA PROSTATITIS ANXIETY
             DEPRESSION ABRASION LONELINESS-24 PROSTATITIS-25 DREAD-26
             BOILS-27 ANGINA-23 DEPRESSION-22 ANGER-20 SCIATICA-21
             GRIEF-19 LACERATION-63 HANGOVER-64 ANXIETY-17 ABRASION-18
             HANGOVER-59 GRIEF-60 BOILS-61 JEALOUSY-62 ANXIETY-57
             DEPRESSION-58 LONELINESS-53 PROSTATITIS-54 ABRASION-55 DREAD-56
             SCIATICA-51 ANGINA-52 SCIATICA-47 JEALOUSY-48 LACERATION-49
             ANGER-50 GUANABARA ALSACE KENTUCKY MORAVIA OREGON SURREY
             PENNSYLVANIA QUEBEC JUPITER EARTH URANUS VULCAN)
   (:INIT (FOOD POTATO-12)
          (FOOD HAMBURGER-13)
          (FOOD HAROSET-14)
          (FOOD WURST-15)
          (FOOD CHERRY-7)
          (FOOD POPOVER-6)
          (FOOD BEEF-5)
          (FOOD CHICKEN-16)
          (FOOD GRAPEFRUIT-8)
          (FOOD MUFFIN-3)
          (FOOD RICE-4)
          (FOOD MARZIPAN-1)
          (FOOD MELON-2)
          (FOOD TUNA)
          (FOOD MELON)
          (FOOD PORK)
          (FOOD KALE)
          (FOOD CHOCOLATE)
          (FOOD SHRIMP)
          (FOOD GRAPEFRUIT)
          (FOOD PEPPER)
          (FOOD BROCCOLI)
          (FOOD CANTELOPE)
          (FOOD PEA)
          (FOOD HAM)
          (FOOD BAGUETTE)
          (FOOD FLOUNDER)
          (FOOD COD)
          (FOOD APPLE)
          (FOOD TOMATO)
          (FOOD GUAVA)
          (FOOD CHERRY)
          (FOOD LAMB)
          (FOOD YOGURT)
          (FOOD MUTTON)
          (FOOD PISTACHIO)
          (FOOD LEMON)
          (FOOD SCALLION)
          (FOOD LETTUCE)
          (FOOD SNICKERS)
          (FOOD TURKEY)
          (FOOD WONDERBREAD)
          (FOOD HOTDOG)
          (FOOD PAPAYA)
          (FOOD POTATO)
          (FOOD MARZIPAN)
          (FOOD RICE)
          (FOOD PEAR)
          (FOOD HAMBURGER)
          (FOOD HAROSET)
          (FOOD SWEETROLL)
          (FOOD TOFU)
          (FOOD OKRA)
          (FOOD ORANGE)
          (FOOD SCALLOP)
          (FOOD WURST)
          (FOOD ONION)
          (FOOD BEEF)
          (FOOD ARUGULA)
          (FOOD MUFFIN)
          (FOOD LOBSTER)
          (FOOD BACON)
          (FOOD CHICKEN)
          (FOOD CUCUMBER)
          (FOOD ENDIVE)
          (FOOD POPOVER)
          (PLEASURE AESTHETICS)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE EXCITEMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE UNDERSTANDING)
          (PLEASURE STIMULATION)
          (PLEASURE TRIUMPH)
          (PLEASURE REST)
          (PLEASURE SATISFACTION)
          (PLEASURE INTOXICATION)
          (PLEASURE LOVE)
          (PLEASURE SATIETY)
          (PLEASURE EMPATHY)
          (PLEASURE LEARNING)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE CURIOSITY)
          (PLEASURE ACHIEVEMENT-11)
          (PLEASURE EXPECTATION-10)
          (PLEASURE INTOXICATION-9)
          (PLEASURE EXCITEMENT-32)
          (PLEASURE ENTERTAINMENT-31)
          (PLEASURE LEARNING-30)
          (PLEASURE LOVE-29)
          (PLEASURE REST-28)
          (PAIN SCIATICA)
          (PAIN BOILS)
          (PAIN LACERATION)
          (PAIN DREAD)
          (PAIN ANGER)
          (PAIN LONELINESS)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN GRIEF)
          (PAIN ANGINA)
          (PAIN PROSTATITIS)
          (PAIN ANXIETY)
          (PAIN DEPRESSION)
          (PAIN ABRASION)
          (PAIN LONELINESS-24)
          (PAIN PROSTATITIS-25)
          (PAIN DREAD-26)
          (PAIN BOILS-27)
          (PAIN ANGINA-23)
          (PAIN DEPRESSION-22)
          (PAIN ANGER-20)
          (PAIN SCIATICA-21)
          (PAIN GRIEF-19)
          (PAIN LACERATION-63)
          (PAIN HANGOVER-64)
          (PAIN ANXIETY-17)
          (PAIN ABRASION-18)
          (PAIN HANGOVER-59)
          (PAIN GRIEF-60)
          (PAIN BOILS-61)
          (PAIN JEALOUSY-62)
          (PAIN ANXIETY-57)
          (PAIN DEPRESSION-58)
          (PAIN LONELINESS-53)
          (PAIN PROSTATITIS-54)
          (PAIN ABRASION-55)
          (PAIN DREAD-56)
          (PAIN SCIATICA-51)
          (PAIN ANGINA-52)
          (PAIN SCIATICA-47)
          (PAIN JEALOUSY-48)
          (PAIN LACERATION-49)
          (PAIN ANGER-50)
          (PROVINCE GUANABARA)
          (PROVINCE ALSACE)
          (PROVINCE KENTUCKY)
          (PROVINCE MORAVIA)
          (PROVINCE OREGON)
          (PROVINCE SURREY)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE QUEBEC)
          (PLANET JUPITER)
          (PLANET EARTH)
          (PLANET URANUS)
          (PLANET VULCAN)
          (EATS HAROSET-14 HAMBURGER-13)
          (CRAVES EXPECTATION-10 HOTDOG)
          (LOCALE BAGUETTE PENNSYLVANIA)
          (EATS LAMB CHICKEN)
          (EATS SCALLION PISTACHIO)
          (LOCALE SCALLION KENTUCKY)
          (EATS PISTACHIO BACON)
          (EATS PORK BROCCOLI)
          (EATS PEPPER TUNA)
          (CRAVES ANXIETY-17 POTATO)
          (CRAVES ACHIEVEMENT-11 TURKEY)
          (LOCALE MUFFIN-3 SURREY)
          (LOCALE PORK ALSACE)
          (LOCALE TOMATO GUANABARA)
          (HARMONY ENTERTAINMENT-31 URANUS)
          (CRAVES SCIATICA-47 ENDIVE)
          (EATS TURKEY TOFU)
          (LOCALE OKRA SURREY)
          (CRAVES ANGINA-52 BEEF)
          (EATS POPOVER PEA)
          (CRAVES DEPRESSION-58 OKRA)
          (CRAVES ENTERTAINMENT MUTTON)
          (EATS PEAR HAMBURGER)
          (LOCALE CHERRY QUEBEC)
          (CRAVES DREAD-26 BROCCOLI)
          (EATS SWEETROLL MUFFIN)
          (EATS HAM SNICKERS)
          (EATS KALE RICE-4)
          (EATS BACON PAPAYA)
          (LOCALE HOTDOG ALSACE)
          (CRAVES EXPECTATION CHERRY-7)
          (CRAVES INTOXICATION-9 PAPAYA)
          (EATS GRAPEFRUIT MARZIPAN-1)
          (LOCALE MARZIPAN-1 GUANABARA)
          (EATS BEEF LAMB)
          (CRAVES STIMULATION GRAPEFRUIT-8)
          (EATS TUNA HAMBURGER-13)
          (ATTACKS SURREY PENNSYLVANIA)
          (EATS CHICKEN-16 WURST-15)
          (CRAVES LACERATION CHERRY-7)
          (EATS HAM PEAR)
          (HARMONY EXCITEMENT-32 VULCAN)
          (EATS BEEF-5 HAMBURGER-13)
          (EATS OKRA RICE)
          (EATS ARUGULA HOTDOG)
          (EATS LEMON HAROSET)
          (EATS HAMBURGER COD)
          (EATS APPLE WURST)
          (LOCALE KALE OREGON)
          (EATS CHERRY-7 CHICKEN-16)
          (EATS PISTACHIO BAGUETTE)
          (EATS MUFFIN-3 TOFU)
          (EATS FLOUNDER TOFU)
          (EATS LOBSTER HOTDOG)
          (CRAVES PROSTATITIS PEPPER)
          (EATS KALE GRAPEFRUIT-8)
          (EATS MUTTON CANTELOPE)
          (EATS LOBSTER HAM)
          (EATS HOTDOG LOBSTER)
          (CRAVES LACERATION-63 POTATO)
          (CRAVES DREAD CHERRY-7)
          (HARMONY LUBRICITY VULCAN)
          (EATS POTATO CHICKEN)
          (HARMONY ACHIEVEMENT-11 VULCAN)
          (EATS TURKEY BEEF)
          (EATS WONDERBREAD APPLE)
          (LOCALE SNICKERS PENNSYLVANIA)
          (LOCALE APPLE QUEBEC)
          (EATS CHERRY-7 POTATO-12)
          (LOCALE POPOVER MORAVIA)
          (HARMONY INTOXICATION EARTH)
          (EATS PEPPER GRAPEFRUIT-8)
          (EATS ENDIVE RICE)
          (EATS PAPAYA SWEETROLL)
          (EATS TUNA PEPPER)
          (LOCALE BACON ALSACE)
          (EATS POPOVER GUAVA)
          (CRAVES DEPRESSION PEPPER)
          (CRAVES LONELINESS-24 BROCCOLI)
          (LOCALE HAMBURGER-13 GUANABARA)
          (LOCALE COD MORAVIA)
          (EATS BEEF-5 POPOVER-6)
          (EATS POTATO-12 CHICKEN-16)
          (HARMONY REST-28 VULCAN)
          (EATS POTATO-12 CHERRY-7)
          (LOCALE CHICKEN GUANABARA)
          (EATS ONION ENDIVE)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS ORANGE LETTUCE)
          (CRAVES SCIATICA-21 TURKEY)
          (CRAVES HANGOVER-64 POTATO)
          (EATS GUAVA POPOVER)
          (CRAVES PROSTATITIS-25 BROCCOLI)
          (LOCALE GRAPEFRUIT-8 GUANABARA)
          (CRAVES SATIETY HAM)
          (CRAVES GRIEF-19 PAPAYA)
          (EATS CHERRY LOBSTER)
          (EATS WURST LOBSTER)
          (CRAVES HANGOVER-59 HAMBURGER)
          (EATS MELON-2 MELON)
          (CRAVES ANGER-20 TURKEY)
          (EATS TUNA CHOCOLATE)
          (CRAVES LONELINESS-53 ORANGE)
          (CRAVES JEALOUSY-48 ENDIVE)
          (LOCALE PEA OREGON)
          (LOCALE POTATO GUANABARA)
          (CRAVES ANGER-50 ENDIVE)
          (EATS PEAR HAM)
          (CRAVES BOILS CHERRY-7)
          (EATS HAROSET ORANGE)
          (EATS RICE OKRA)
          (EATS SNICKERS HAMBURGER)
          (CRAVES ACHIEVEMENT HAMBURGER-13)
          (LOCALE CANTELOPE SURREY)
          (LOCALE SWEETROLL GUANABARA)
          (HARMONY STIMULATION EARTH)
          (EATS WURST-15 CHICKEN-16)
          (LOCALE GUAVA GUANABARA)
          (EATS HOTDOG ARUGULA)
          (EATS CHICKEN-16 CHERRY-7)
          (EATS CHOCOLATE TUNA)
          (EATS PEA POPOVER)
          (EATS RICE ONION)
          (EATS HAM LOBSTER)
          (EATS PORK MELON)
          (EATS CHOCOLATE GRAPEFRUIT)
          (EATS HAMBURGER SNICKERS)
          (EATS POTATO LETTUCE)
          (EATS SHRIMP MARZIPAN-1)
          (EATS CHERRY-7 POPOVER-6)
          (LOCALE CUCUMBER MORAVIA)
          (CRAVES LACERATION-49 ENDIVE)
          (EATS ORANGE BACON)
          (CRAVES EMPATHY FLOUNDER)
          (CRAVES ABRASION PEPPER)
          (EATS TOFU FLOUNDER)
          (CRAVES LONELINESS TUNA)
          (EATS HAROSET LEMON)
          (EATS BACON YOGURT)
          (EATS SCALLION TOMATO)
          (LOCALE GRAPEFRUIT ALSACE)
          (EATS MELON-2 SHRIMP)
          (LOCALE TUNA GUANABARA)
          (LOCALE WONDERBREAD QUEBEC)
          (EATS LOBSTER WURST)
          (LOCALE WURST-15 OREGON)
          (EATS CANTELOPE MUTTON)
          (LOCALE PEAR QUEBEC)
          (EATS PAPAYA BACON)
          (CRAVES AESTHETICS POTATO-12)
          (EATS SNICKERS PEA)
          (LOCALE MELON-2 ALSACE)
          (LOCALE TURKEY MORAVIA)
          (EATS BACON SCALLION)
          (EATS SCALLION BACON)
          (LOCALE ARUGULA MORAVIA)
          (LOCALE HAMBURGER GUANABARA)
          (EATS PISTACHIO SWEETROLL)
          (CRAVES INTOXICATION CHOCOLATE)
          (HARMONY SATISFACTION URANUS)
          (EATS BROCCOLI RICE-4)
          (EATS MUFFIN CUCUMBER)
          (EATS ONION ARUGULA)
          (ATTACKS KENTUCKY MORAVIA)
          (EATS HAROSET-14 WURST-15)
          (EATS HAMBURGER-13 WURST-15)
          (LOCALE HAROSET-14 PENNSYLVANIA)
          (LOCALE PISTACHIO GUANABARA)
          (EATS GUAVA ARUGULA)
          (EATS WURST APPLE)
          (LOCALE PAPAYA OREGON)
          (EATS HAMBURGER-13 HAROSET-14)
          (EATS SHRIMP MELON-2)
          (LOCALE MARZIPAN GUANABARA)
          (LOCALE ORANGE QUEBEC)
          (LOCALE SCALLOP MORAVIA)
          (EATS LEMON CUCUMBER)
          (CRAVES BOILS-27 BROCCOLI)
          (EATS MUFFIN SWEETROLL)
          (CRAVES BOILS-61 HAMBURGER)
          (ATTACKS PENNSYLVANIA QUEBEC)
          (EATS RICE ENDIVE)
          (EATS LETTUCE ORANGE)
          (EATS TOMATO SCALLOP)
          (LOCALE RICE-4 GUANABARA)
          (EATS SWEETROLL PISTACHIO)
          (CRAVES REST-28 CHICKEN)
          (EATS LETTUCE POTATO)
          (HARMONY EXCITEMENT EARTH)
          (EATS CHICKEN FLOUNDER)
          (CRAVES JEALOUSY-62 HAMBURGER)
          (EATS ARUGULA GUAVA)
          (EATS MUFFIN-3 SHRIMP)
          (HARMONY UNDERSTANDING EARTH)
          (CRAVES ANXIETY-57 OKRA)
          (EATS MUTTON BAGUETTE)
          (EATS POTATO-12 WURST-15)
          (HARMONY ACHIEVEMENT VULCAN)
          (HARMONY CURIOSITY EARTH)
          (LOCALE FLOUNDER ALSACE)
          (LOCALE ENDIVE ALSACE)
          (EATS ORANGE HAROSET)
          (EATS COD TURKEY)
          (HARMONY INTOXICATION-9 VULCAN)
          (EATS MELON PORK)
          (EATS MELON MELON-2)
          (EATS SNICKERS HAM)
          (EATS ONION CANTELOPE)
          (HARMONY ENTERTAINMENT VULCAN)
          (EATS OKRA MARZIPAN)
          (CRAVES HANGOVER TUNA)
          (HARMONY EXPECTATION-10 VULCAN)
          (CRAVES UNDERSTANDING POPOVER-6)
          (EATS PEAR WURST)
          (LOCALE HAROSET SURREY)
          (EATS POPOVER-6 BEEF-5)
          (LOCALE CHICKEN-16 ALSACE)
          (CRAVES ANGINA CHOCOLATE)
          (ORBITS EARTH URANUS)
          (LOCALE POPOVER-6 GUANABARA)
          (EATS RICE-4 BROCCOLI)
          (EATS APPLE WONDERBREAD)
          (EATS WURST-15 POPOVER-6)
          (LOCALE BEEF-5 GUANABARA)
          (EATS CUCUMBER MARZIPAN)
          (ORBITS URANUS VULCAN)
          (LOCALE RICE GUANABARA)
          (EATS WONDERBREAD YOGURT)
          (LOCALE LOBSTER QUEBEC)
          (EATS POPOVER BEEF)
          (ATTACKS MORAVIA OREGON)
          (EATS PEA SNICKERS)
          (EATS LAMB BEEF)
          (EATS PISTACHIO SCALLION)
          (CRAVES ANGINA-23 APPLE)
          (LOCALE MUTTON KENTUCKY)
          (EATS WURST-15 BEEF-5)
          (CRAVES ANGER TUNA)
          (CRAVES LOVE PEA)
          (EATS CHICKEN POTATO)
          (ATTACKS OREGON SURREY)
          (EATS CANTELOPE ONION)
          (EATS CUCUMBER MUFFIN)
          (EATS YOGURT BACON)
          (EATS SCALLOP TOMATO)
          (LOCALE BROCCOLI QUEBEC)
          (EATS MARZIPAN-1 SHRIMP)
          (LOCALE BEEF ALSACE)
          (EATS MARZIPAN-1 GRAPEFRUIT)
          (LOCALE MELON KENTUCKY)
          (HARMONY SATIETY EARTH)
          (LOCALE LAMB GUANABARA)
          (EATS FLOUNDER CHICKEN)
          (EATS CHERRY SCALLOP)
          (LOCALE LEMON QUEBEC)
          (EATS CHICKEN-16 HAROSET-14)
          (CRAVES LEARNING-30 ARUGULA)
          (LOCALE LETTUCE GUANABARA)
          (HARMONY EMPATHY VULCAN)
          (EATS LOBSTER CHERRY)
          (EATS MARZIPAN CUCUMBER)
          (EATS SHRIMP MUFFIN-3)
          (EATS CHICKEN-16 POTATO-12)
          (CRAVES DREAD-56 ORANGE)
          (EATS YOGURT WONDERBREAD)
          (CRAVES JEALOUSY TUNA)
          (LOCALE CHERRY-7 GUANABARA)
          (LOCALE HAM SURREY)
          (EATS GRAPEFRUIT CHOCOLATE)
          (EATS OKRA ENDIVE)
          (EATS BACON ORANGE)
          (LOCALE SHRIMP OREGON)
          (LOCALE POTATO-12 PENNSYLVANIA)
          (EATS CUCUMBER LEMON)
          (CRAVES GRIEF-60 HAMBURGER)
          (HARMONY TRIUMPH VULCAN)
          (EATS HAMBURGER-13 BEEF-5)
          (EATS TOMATO SCALLION)
          (LOCALE YOGURT ALSACE)
          (EATS KALE MUFFIN-3)
          (CRAVES SATISFACTION MELON)
          (HARMONY LEARNING-30 VULCAN)
          (HARMONY REST VULCAN)
          (EATS RICE MUFFIN)
          (EATS ARUGULA ONION)
          (CRAVES PROSTATITIS-54 ORANGE)
          (EATS BACON PISTACHIO)
          (CRAVES ANXIETY PEPPER)
          (EATS MUFFIN-3 KALE)
          (HARMONY LEARNING URANUS)
          (EATS HAMBURGER PEAR)
          (EATS SWEETROLL PAPAYA)
          (CRAVES ABRASION-18 POTATO)
          (EATS TURKEY COD)
          (LOCALE MUFFIN GUANABARA)
          (CRAVES TRIUMPH MARZIPAN-1)
          (EATS WURST PEAR)
          (EATS BEEF-5 WURST-15)
          (EATS ONION RICE)
          (LOCALE ONION MORAVIA)
          (CRAVES DEPRESSION-22 SCALLION)
          (CRAVES SCIATICA CHERRY-7)
          (HARMONY EXPECTATION VULCAN)
          (EATS GRAPEFRUIT-8 KALE)
          (HARMONY LOVE-29 EARTH)
          (CRAVES ENTERTAINMENT-31 WURST)
          (EATS BEEF TURKEY)
          (CRAVES LUBRICITY HAROSET-14)
          (EATS TOFU TURKEY)
          (EATS BAGUETTE PISTACHIO)
          (EATS TOFU MUFFIN-3)
          (EATS WURST-15 POTATO-12)
          (EATS BAGUETTE MUTTON)
          (EATS BROCCOLI PORK)
          (EATS POPOVER-6 CHERRY-7)
          (LOCALE PEPPER ALSACE)
          (EATS WURST-15 HAROSET-14)
          (EATS ENDIVE OKRA)
          (EATS CHICKEN LAMB)
          (CRAVES ABRASION-55 ORANGE)
          (LOCALE TOFU SURREY)
          (CRAVES REST TUNA)
          (EATS ENDIVE ONION)
          (EATS SCALLOP CHERRY)
          (CRAVES CURIOSITY PISTACHIO)
          (EATS HAMBURGER-13 TUNA)
          (LOCALE WURST KENTUCKY)
          (EATS HAROSET-14 CHICKEN-16)
          (CRAVES EXCITEMENT WURST-15)
          (EATS WURST-15 HAMBURGER-13)
          (CRAVES LOVE-29 LOBSTER)
          (EATS BEEF POPOVER)
          (EATS POPOVER-6 WURST-15)
          (EATS GRAPEFRUIT-8 PEPPER)
          (ATTACKS ALSACE KENTUCKY)
          (EATS COD HAMBURGER)
          (HARMONY LOVE URANUS)
          (HARMONY AESTHETICS VULCAN)
          (CRAVES LEARNING LAMB)
          (EATS MARZIPAN OKRA)
          (CRAVES SCIATICA-51 BEEF)
          (ORBITS JUPITER EARTH)
          (EATS RICE-4 KALE)
          (CRAVES EXCITEMENT-32 SWEETROLL)
          (CRAVES GRIEF CHOCOLATE)
          (EATS MUFFIN RICE)
          (ATTACKS GUANABARA ALSACE))
   (:GOAL (AND (CRAVES GRIEF PISTACHIO)
               (CRAVES ANGINA PISTACHIO))))

(DEFINE (PROBLEM STRIPS-MYSTY-21)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PAPAYA GRAPEFRUIT CHOCOLATE TURKEY LAMB ENDIVE TOMATO
             SWEETROLL BEEF BAGUETTE COD HAMBURGER HAM WURST POTATO TUNA APPLE
             PEPPER LETTUCE WONDERBREAD CHICKEN BROCCOLI LEMON MELON ONION
             POPOVER MARZIPAN HOTDOG FLOUNDER PISTACHIO KALE CHERRY PORK
             MUTTON SCALLOP RICE LOBSTER MUFFIN GUAVA PEA YOGURT
             EXPECTATION LUBRICITY CURIOSITY LOVE AESTHETICS INTOXICATION
             ENTERTAINMENT ACHIEVEMENT UNDERSTANDING SATISFACTION LEARNING
             SCIATICA HANGOVER ABRASION ANGER DREAD GRIEF JEALOUSY
             PROSTATITIS BOILS DEPRESSION LONELINESS LACERATION ANGINA
             JEALOUSY-2 ANXIETY GRIEF-4 BOILS-1 SCIATICA-3 LACERATION-7
             LONELINESS-8 HANGOVER-6 ANXIETY-16 DEPRESSION-5 PROSTATITIS-13
             ANGER-14 ANGINA-15 ABRASION-11 DREAD-12 PENNSYLVANIA
             GUANABARA ARIZONA MANITOBA BOSNIA BAVARIA SATURN NEPTUNE VULCAN
             VENUS)
   (:INIT (FOOD PAPAYA)
          (FOOD GRAPEFRUIT)
          (FOOD CHOCOLATE)
          (FOOD TURKEY)
          (FOOD LAMB)
          (FOOD ENDIVE)
          (FOOD TOMATO)
          (FOOD SWEETROLL)
          (FOOD BEEF)
          (FOOD BAGUETTE)
          (FOOD COD)
          (FOOD HAMBURGER)
          (FOOD HAM)
          (FOOD WURST)
          (FOOD POTATO)
          (FOOD TUNA)
          (FOOD APPLE)
          (FOOD PEPPER)
          (FOOD LETTUCE)
          (FOOD WONDERBREAD)
          (FOOD CHICKEN)
          (FOOD BROCCOLI)
          (FOOD LEMON)
          (FOOD MELON)
          (FOOD ONION)
          (FOOD POPOVER)
          (FOOD MARZIPAN)
          (FOOD HOTDOG)
          (FOOD FLOUNDER)
          (FOOD PISTACHIO)
          (FOOD KALE)
          (FOOD CHERRY)
          (FOOD PORK)
          (FOOD MUTTON)
          (FOOD SCALLOP)
          (FOOD RICE)
          (FOOD LOBSTER)
          (FOOD MUFFIN)
          (FOOD GUAVA)
          (FOOD PEA)
          (FOOD YOGURT)
          (PLEASURE EXPECTATION)
          (PLEASURE LUBRICITY)
          (PLEASURE CURIOSITY)
          (PLEASURE LOVE)
          (PLEASURE AESTHETICS)
          (PLEASURE INTOXICATION)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE UNDERSTANDING)
          (PLEASURE SATISFACTION)
          (PLEASURE LEARNING)
          (PAIN SCIATICA)
          (PAIN HANGOVER)
          (PAIN ABRASION)
          (PAIN ANGER)
          (PAIN DREAD)
          (PAIN GRIEF)
          (PAIN JEALOUSY)
          (PAIN PROSTATITIS)
          (PAIN BOILS)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN LACERATION)
          (PAIN ANGINA)
          (PAIN JEALOUSY-2)
          (PAIN ANXIETY)
          (PAIN GRIEF-4)
          (PAIN BOILS-1)
          (PAIN SCIATICA-3)
          (PAIN LACERATION-7)
          (PAIN LONELINESS-8)
          (PAIN HANGOVER-6)
          (PAIN ANXIETY-16)
          (PAIN DEPRESSION-5)
          (PAIN PROSTATITIS-13)
          (PAIN ANGER-14)
          (PAIN ANGINA-15)
          (PAIN ABRASION-11)
          (PAIN DREAD-12)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE GUANABARA)
          (PROVINCE ARIZONA)
          (PROVINCE MANITOBA)
          (PROVINCE BOSNIA)
          (PROVINCE BAVARIA)
          (PLANET SATURN)
          (PLANET NEPTUNE)
          (PLANET VULCAN)
          (PLANET VENUS)
          (EATS GUAVA POPOVER)
          (EATS TUNA YOGURT)
          (EATS LETTUCE KALE)
          (LOCALE ENDIVE GUANABARA)
          (EATS PAPAYA BAGUETTE)
          (EATS RICE APPLE)
          (EATS APPLE RICE)
          (EATS ONION PORK)
          (LOCALE LETTUCE PENNSYLVANIA)
          (EATS BROCCOLI FLOUNDER)
          (EATS BROCCOLI GUAVA)
          (EATS POPOVER WURST)
          (EATS MUFFIN LOBSTER)
          (CRAVES ACHIEVEMENT CHERRY)
          (EATS YOGURT PISTACHIO)
          (EATS LOBSTER PISTACHIO)
          (EATS CHERRY FLOUNDER)
          (EATS PISTACHIO SCALLOP)
          (LOCALE POPOVER MANITOBA)
          (EATS YOGURT RICE)
          (ORBITS SATURN NEPTUNE)
          (EATS KALE PEA)
          (CRAVES PROSTATITIS COD)
          (EATS SCALLOP MARZIPAN)
          (CRAVES DEPRESSION HAMBURGER)
          (EATS WONDERBREAD CHICKEN)
          (CRAVES AESTHETICS MELON)
          (HARMONY LEARNING VULCAN)
          (LOCALE CHICKEN GUANABARA)
          (HARMONY INTOXICATION VENUS)
          (LOCALE HOTDOG PENNSYLVANIA)
          (EATS TURKEY LAMB)
          (EATS MUTTON FLOUNDER)
          (EATS ONION LEMON)
          (EATS HAM HAMBURGER)
          (EATS ENDIVE LAMB)
          (EATS SCALLOP LOBSTER)
          (LOCALE FLOUNDER GUANABARA)
          (ORBITS VULCAN VENUS)
          (CRAVES ANXIETY WURST)
          (EATS PEA KALE)
          (EATS MUFFIN FLOUNDER)
          (EATS PEPPER MUTTON)
          (EATS GUAVA BROCCOLI)
          (EATS RICE YOGURT)
          (EATS HAM WURST)
          (CRAVES JEALOUSY-2 WURST)
          (LOCALE PORK ARIZONA)
          (EATS PEPPER LOBSTER)
          (EATS COD HAMBURGER)
          (EATS PEA GUAVA)
          (EATS GRAPEFRUIT LAMB)
          (EATS KALE MUTTON)
          (CRAVES SATISFACTION MUFFIN)
          (LOCALE HAMBURGER MANITOBA)
          (EATS CHICKEN WONDERBREAD)
          (EATS PORK MARZIPAN)
          (HARMONY UNDERSTANDING VENUS)
          (EATS HOTDOG CHERRY)
          (EATS KALE PORK)
          (EATS POPOVER KALE)
          (ATTACKS GUANABARA ARIZONA)
          (LOCALE LAMB ARIZONA)
          (EATS LAMB SWEETROLL)
          (LOCALE MELON PENNSYLVANIA)
          (ATTACKS MANITOBA BOSNIA)
          (EATS TOMATO PAPAYA)
          (EATS LETTUCE CHICKEN)
          (EATS ONION SCALLOP)
          (EATS HAMBURGER HAM)
          (CRAVES LONELINESS HAMBURGER)
          (EATS GUAVA PEA)
          (EATS LEMON YOGURT)
          (EATS BAGUETTE ENDIVE)
          (CRAVES LOVE CHICKEN)
          (LOCALE GUAVA ARIZONA)
          (EATS SCALLOP TUNA)
          (EATS ENDIVE BAGUETTE)
          (CRAVES ABRASION SWEETROLL)
          (EATS PORK ONION)
          (LOCALE CHOCOLATE BAVARIA)
          (HARMONY LOVE NEPTUNE)
          (CRAVES LONELINESS-8 MELON)
          (EATS MARZIPAN ONION)
          (EATS KALE LETTUCE)
          (EATS LETTUCE MUTTON)
          (LOCALE PAPAYA MANITOBA)
          (CRAVES GRIEF BAGUETTE)
          (EATS BEEF TURKEY)
          (LOCALE POTATO PENNSYLVANIA)
          (CRAVES SCIATICA-3 PEPPER)
          (CRAVES ANGER-14 CHERRY)
          (CRAVES DEPRESSION-5 PISTACHIO)
          (EATS TURKEY LOBSTER)
          (EATS WURST POPOVER)
          (EATS LAMB BEEF)
          (ATTACKS BOSNIA BAVARIA)
          (EATS SCALLOP ONION)
          (EATS MUTTON LETTUCE)
          (EATS CHICKEN LETTUCE)
          (CRAVES HANGOVER TURKEY)
          (EATS GRAPEFRUIT CHOCOLATE)
          (EATS HAMBURGER COD)
          (ORBITS NEPTUNE VULCAN)
          (LOCALE WONDERBREAD BOSNIA)
          (HARMONY LUBRICITY VENUS)
          (EATS ENDIVE TURKEY)
          (LOCALE BEEF GUANABARA)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (EATS LEMON ONION)
          (CRAVES PROSTATITIS-13 CHERRY)
          (EATS COD BEEF)
          (LOCALE LEMON GUANABARA)
          (CRAVES LACERATION HAM)
          (HARMONY CURIOSITY NEPTUNE)
          (EATS ONION MARZIPAN)
          (CRAVES LUBRICITY PEPPER)
          (EATS WONDERBREAD SCALLOP)
          (EATS GUAVA HOTDOG)
          (LOCALE RICE ARIZONA)
          (CRAVES DREAD-12 MUTTON)
          (LOCALE SWEETROLL PENNSYLVANIA)
          (EATS SWEETROLL BEEF)
          (EATS LOBSTER MUFFIN)
          (EATS WURST POTATO)
          (CRAVES BOILS-1 TUNA)
          (EATS KALE HOTDOG)
          (EATS PORK KALE)
          (EATS MARZIPAN SCALLOP)
          (EATS FLOUNDER CHERRY)
          (LOCALE ONION PENNSYLVANIA)
          (EATS LOBSTER SCALLOP)
          (LOCALE CHERRY GUANABARA)
          (EATS PEA POPOVER)
          (EATS PISTACHIO LOBSTER)
          (HARMONY ENTERTAINMENT VULCAN)
          (CRAVES ANGER SWEETROLL)
          (ATTACKS ARIZONA MANITOBA)
          (EATS APPLE ONION)
          (EATS BEEF COD)
          (EATS MELON PEA)
          (EATS LAMB GRAPEFRUIT)
          (EATS POTATO COD)
          (CRAVES ENTERTAINMENT HOTDOG)
          (LOCALE SCALLOP PENNSYLVANIA)
          (CRAVES EXPECTATION ENDIVE)
          (LOCALE BROCCOLI MANITOBA)
          (EATS CHOCOLATE TOMATO)
          (LOCALE GRAPEFRUIT GUANABARA)
          (EATS FLOUNDER BROCCOLI)
          (CRAVES ABRASION-11 MUTTON)
          (CRAVES BOILS HAMBURGER)
          (EATS CHERRY HOTDOG)
          (EATS RICE MELON)
          (LOCALE PEPPER ARIZONA)
          (LOCALE TOMATO MANITOBA)
          (CRAVES INTOXICATION ONION)
          (EATS SCALLOP WONDERBREAD)
          (EATS BEEF LAMB)
          (LOCALE KALE MANITOBA)
          (LOCALE PEA ARIZONA)
          (LOCALE WURST GUANABARA)
          (EATS SCALLOP MUTTON)
          (EATS YOGURT LEMON)
          (HARMONY SATISFACTION NEPTUNE)
          (CRAVES SCIATICA TURKEY)
          (EATS POPOVER GUAVA)
          (EATS YOGURT TUNA)
          (EATS TOMATO CHOCOLATE)
          (EATS MUTTON PEPPER)
          (CRAVES GRIEF-4 TUNA)
          (EATS ONION APPLE)
          (LOCALE MUFFIN PENNSYLVANIA)
          (EATS FLOUNDER MUTTON)
          (CRAVES CURIOSITY WONDERBREAD)
          (CRAVES LEARNING GUAVA)
          (EATS HOTDOG GUAVA)
          (EATS LOBSTER PEPPER)
          (EATS BEEF SWEETROLL)
          (LOCALE COD PENNSYLVANIA)
          (HARMONY EXPECTATION NEPTUNE)
          (EATS SWEETROLL LAMB)
          (CRAVES DREAD SWEETROLL)
          (LOCALE LOBSTER PENNSYLVANIA)
          (CRAVES LACERATION-7 MELON)
          (EATS LAMB ENDIVE)
          (LOCALE HAM GUANABARA)
          (EATS MELON RICE)
          (LOCALE YOGURT BOSNIA)
          (EATS TURKEY ENDIVE)
          (EATS MUTTON CHERRY)
          (EATS PAPAYA TOMATO)
          (EATS KALE POPOVER)
          (EATS CHERRY MUTTON)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS CHOCOLATE GRAPEFRUIT)
          (LOCALE BAGUETTE GUANABARA)
          (EATS POPOVER PEA)
          (LOCALE TUNA MANITOBA)
          (EATS LOBSTER TURKEY)
          (EATS PORK RICE)
          (CRAVES ANGINA-15 CHERRY)
          (EATS WURST HAM)
          (EATS BAGUETTE PAPAYA)
          (EATS MUTTON KALE)
          (EATS HOTDOG KALE)
          (LOCALE MUTTON BOSNIA)
          (EATS PISTACHIO YOGURT)
          (LOCALE TURKEY GUANABARA)
          (EATS TURKEY BEEF)
          (EATS POTATO WURST)
          (CRAVES ANXIETY-16 PISTACHIO)
          (EATS LAMB TURKEY)
          (EATS FLOUNDER MUFFIN)
          (EATS TUNA SCALLOP)
          (EATS COD POTATO)
          (CRAVES JEALOUSY BAGUETTE)
          (EATS RICE PORK)
          (LOCALE PISTACHIO ARIZONA)
          (LOCALE APPLE PENNSYLVANIA)
          (EATS PEA MELON)
          (CRAVES UNDERSTANDING LOBSTER)
          (EATS MARZIPAN PORK)
          (CRAVES HANGOVER-6 ONION)
          (CRAVES ANGINA HAM)
          (EATS MUTTON SCALLOP)
          (EATS SCALLOP PISTACHIO)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (HARMONY AESTHETICS VULCAN))
   (:GOAL (AND (CRAVES ANXIETY BEEF)
               (CRAVES JEALOUSY-2 BEEF))))

(DEFINE (PROBLEM STRIPS-MYSTY-22)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TOMATO GUAVA HOTDOG MUTTON ENDIVE CHERRY BEEF LETTUCE
             OKRA ONION TOFU KALE SHRIMP PEA SWEETROLL HAROSET PEPPER
             CHOCOLATE MUFFIN SCALLOP CHICKEN ARUGULA REST LOVE CURIOSITY
             TRIUMPH LEARNING EXCITEMENT EXPECTATION LONELINESS ANXIETY
             LACERATION BOILS JEALOUSY GRIEF ANGER ANGINA SCIATICA HANGOVER
             QUEBEC OREGON BAVARIA MORAVIA MARS VULCAN VENUS SATURN)
   (:INIT (FOOD TOMATO)
          (FOOD GUAVA)
          (FOOD HOTDOG)
          (FOOD MUTTON)
          (FOOD ENDIVE)
          (FOOD CHERRY)
          (FOOD BEEF)
          (FOOD LETTUCE)
          (FOOD OKRA)
          (FOOD ONION)
          (FOOD TOFU)
          (FOOD KALE)
          (FOOD SHRIMP)
          (FOOD PEA)
          (FOOD SWEETROLL)
          (FOOD HAROSET)
          (FOOD PEPPER)
          (FOOD CHOCOLATE)
          (FOOD MUFFIN)
          (FOOD SCALLOP)
          (FOOD CHICKEN)
          (FOOD ARUGULA)
          (PLEASURE REST)
          (PLEASURE LOVE)
          (PLEASURE CURIOSITY)
          (PLEASURE TRIUMPH)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE EXPECTATION)
          (PAIN LONELINESS)
          (PAIN ANXIETY)
          (PAIN LACERATION)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN GRIEF)
          (PAIN ANGER)
          (PAIN ANGINA)
          (PAIN SCIATICA)
          (PAIN HANGOVER)
          (PROVINCE QUEBEC)
          (PROVINCE OREGON)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PLANET MARS)
          (PLANET VULCAN)
          (PLANET VENUS)
          (PLANET SATURN)
          (HARMONY CURIOSITY VULCAN)
          (EATS GUAVA MUTTON)
          (LOCALE SHRIMP QUEBEC)
          (ATTACKS QUEBEC OREGON)
          (EATS MUTTON GUAVA)
          (EATS HAROSET MUFFIN)
          (EATS TOMATO CHOCOLATE)
          (LOCALE CHICKEN QUEBEC)
          (LOCALE ARUGULA QUEBEC)
          (EATS SHRIMP CHERRY)
          (LOCALE TOFU QUEBEC)
          (CRAVES BOILS BEEF)
          (EATS PEPPER CHERRY)
          (EATS SHRIMP ENDIVE)
          (CRAVES ANGER CHOCOLATE)
          (LOCALE KALE QUEBEC)
          (EATS ARUGULA PEPPER)
          (EATS SHRIMP SWEETROLL)
          (HARMONY TRIUMPH VENUS)
          (ATTACKS OREGON BAVARIA)
          (HARMONY REST SATURN)
          (EATS CHOCOLATE TOMATO)
          (EATS SCALLOP GUAVA)
          (EATS MUTTON HOTDOG)
          (CRAVES TRIUMPH TOFU)
          (HARMONY EXCITEMENT VULCAN)
          (LOCALE HOTDOG QUEBEC)
          (ORBITS MARS VULCAN)
          (LOCALE PEPPER QUEBEC)
          (EATS SWEETROLL ONION)
          (EATS SHRIMP OKRA)
          (EATS BEEF HOTDOG)
          (EATS ARUGULA LETTUCE)
          (LOCALE HAROSET QUEBEC)
          (EATS SWEETROLL SHRIMP)
          (EATS HOTDOG BEEF)
          (EATS HAROSET ONION)
          (EATS MUFFIN SHRIMP)
          (EATS PEPPER ARUGULA)
          (EATS CHICKEN TOFU)
          (LOCALE MUTTON BAVARIA)
          (LOCALE LETTUCE MORAVIA)
          (EATS ONION MUFFIN)
          (EATS SWEETROLL CHOCOLATE)
          (EATS TOFU SCALLOP)
          (LOCALE CHOCOLATE QUEBEC)
          (HARMONY EXPECTATION SATURN)
          (EATS LETTUCE OKRA)
          (EATS ENDIVE PEPPER)
          (EATS ARUGULA MUFFIN)
          (ORBITS VENUS SATURN)
          (EATS MUFFIN HAROSET)
          (CRAVES ANXIETY MUTTON)
          (CRAVES JEALOUSY SHRIMP)
          (LOCALE ENDIVE QUEBEC)
          (EATS CHOCOLATE SWEETROLL)
          (EATS OKRA LETTUCE)
          (LOCALE MUFFIN OREGON)
          (EATS HAROSET CHOCOLATE)
          (LOCALE BEEF QUEBEC)
          (EATS CHERRY PEPPER)
          (CRAVES LEARNING PEA)
          (EATS CHERRY SHRIMP)
          (LOCALE CHERRY QUEBEC)
          (LOCALE ONION BAVARIA)
          (EATS CHOCOLATE BEEF)
          (EATS MUFFIN ARUGULA)
          (LOCALE PEA BAVARIA)
          (EATS CHICKEN PEA)
          (HARMONY LEARNING VULCAN)
          (CRAVES EXPECTATION CHICKEN)
          (CRAVES LOVE CHERRY)
          (CRAVES GRIEF SWEETROLL)
          (EATS HOTDOG MUTTON)
          (EATS PEPPER ENDIVE)
          (HARMONY LOVE VENUS)
          (CRAVES CURIOSITY LETTUCE)
          (EATS PEA CHICKEN)
          (EATS ENDIVE SHRIMP)
          (EATS PEA KALE)
          (CRAVES LONELINESS GUAVA)
          (EATS MUFFIN ONION)
          (EATS KALE PEA)
          (LOCALE OKRA QUEBEC)
          (EATS ONION SWEETROLL)
          (ATTACKS BAVARIA MORAVIA)
          (EATS PEPPER KALE)
          (EATS OKRA SHRIMP)
          (CRAVES EXCITEMENT CHOCOLATE)
          (EATS GUAVA SCALLOP)
          (CRAVES HANGOVER ARUGULA)
          (EATS TOFU CHICKEN)
          (ORBITS VULCAN VENUS)
          (CRAVES REST HOTDOG)
          (CRAVES SCIATICA CHICKEN)
          (EATS KALE PEPPER)
          (LOCALE SWEETROLL QUEBEC)
          (EATS TOMATO CHERRY)
          (EATS ONION HAROSET)
          (EATS SCALLOP TOFU)
          (EATS CHOCOLATE HAROSET)
          (EATS LETTUCE ARUGULA)
          (LOCALE SCALLOP BAVARIA)
          (CRAVES LACERATION ENDIVE)
          (LOCALE TOMATO QUEBEC)
          (EATS BEEF CHOCOLATE)
          (EATS CHERRY TOMATO)
          (LOCALE GUAVA OREGON)
          (CRAVES ANGINA MUFFIN)
          (EATS SHRIMP MUFFIN))
   (:GOAL (AND (CRAVES ANGER HAROSET))))

(DEFINE (PROBLEM STRIPS-MYSTY-23)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS CANTELOPE ARUGULA CHOCOLATE SNICKERS LAMB TURKEY
             BROCCOLI LETTUCE PEPPER PEAR TOFU ENDIVE LEMON WONDERBREAD
             POPOVER TUNA SCALLION CHICKEN GUAVA TOMATO PORK CUCUMBER
             HAMBURGER MELON PISTACHIO FLOUNDER APPLE HOTDOG OKRA SWEETROLL
             WURST HAM GRAPEFRUIT KALE CHERRY UNDERSTANDING LUBRICITY
             EMPATHY TRIUMPH ENTERTAINMENT SATIETY AESTHETICS ACHIEVEMENT
             EXPECTATION CURIOSITY EXCITEMENT STIMULATION PROSTATITIS
             LACERATION GRIEF ANGINA DEPRESSION LONELINESS DREAD ABRASION
             ANGER HANGOVER JEALOUSY BOILS ANXIETY SCIATICA ANXIETY-2
             DREAD-1 LACERATION-4 HANGOVER-3 DEPRESSION-8 BOILS-7
             JEALOUSY-6 MORAVIA QUEBEC OREGON GOIAS GUANABARA KENTUCKY ARIZONA
             PENNSYLVANIA BAVARIA SURREY VENUS VULCAN MARS MERCURY)
   (:INIT (FOOD CANTELOPE)
          (FOOD ARUGULA)
          (FOOD CHOCOLATE)
          (FOOD SNICKERS)
          (FOOD LAMB)
          (FOOD TURKEY)
          (FOOD BROCCOLI)
          (FOOD LETTUCE)
          (FOOD PEPPER)
          (FOOD PEAR)
          (FOOD TOFU)
          (FOOD ENDIVE)
          (FOOD LEMON)
          (FOOD WONDERBREAD)
          (FOOD POPOVER)
          (FOOD TUNA)
          (FOOD SCALLION)
          (FOOD CHICKEN)
          (FOOD GUAVA)
          (FOOD TOMATO)
          (FOOD PORK)
          (FOOD CUCUMBER)
          (FOOD HAMBURGER)
          (FOOD MELON)
          (FOOD PISTACHIO)
          (FOOD FLOUNDER)
          (FOOD APPLE)
          (FOOD HOTDOG)
          (FOOD OKRA)
          (FOOD SWEETROLL)
          (FOOD WURST)
          (FOOD HAM)
          (FOOD GRAPEFRUIT)
          (FOOD KALE)
          (FOOD CHERRY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LUBRICITY)
          (PLEASURE EMPATHY)
          (PLEASURE TRIUMPH)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE SATIETY)
          (PLEASURE AESTHETICS)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE CURIOSITY)
          (PLEASURE EXCITEMENT)
          (PLEASURE STIMULATION)
          (PAIN PROSTATITIS)
          (PAIN LACERATION)
          (PAIN GRIEF)
          (PAIN ANGINA)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN BOILS)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN ANXIETY-2)
          (PAIN DREAD-1)
          (PAIN LACERATION-4)
          (PAIN HANGOVER-3)
          (PAIN DEPRESSION-8)
          (PAIN BOILS-7)
          (PAIN JEALOUSY-6)
          (PROVINCE MORAVIA)
          (PROVINCE QUEBEC)
          (PROVINCE OREGON)
          (PROVINCE GOIAS)
          (PROVINCE GUANABARA)
          (PROVINCE KENTUCKY)
          (PROVINCE ARIZONA)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PROVINCE SURREY)
          (PLANET VENUS)
          (PLANET VULCAN)
          (PLANET MARS)
          (PLANET MERCURY)
          (ORBITS MARS MERCURY)
          (CRAVES CURIOSITY CUCUMBER)
          (HARMONY AESTHETICS MARS)
          (EATS LEMON ENDIVE)
          (EATS FLOUNDER HAMBURGER)
          (CRAVES ABRASION ENDIVE)
          (ATTACKS MORAVIA QUEBEC)
          (EATS PEAR ARUGULA)
          (LOCALE GUAVA MORAVIA)
          (CRAVES DEPRESSION-8 WURST)
          (EATS MELON CHERRY)
          (EATS PISTACHIO TOMATO)
          (LOCALE LETTUCE QUEBEC)
          (EATS ARUGULA PEAR)
          (EATS TURKEY SNICKERS)
          (EATS TOFU TURKEY)
          (LOCALE SNICKERS MORAVIA)
          (EATS OKRA SWEETROLL)
          (EATS TURKEY CHOCOLATE)
          (EATS OKRA HAM)
          (CRAVES EMPATHY TOFU)
          (EATS SNICKERS TURKEY)
          (CRAVES BOILS CHICKEN)
          (LOCALE TOFU MORAVIA)
          (LOCALE CUCUMBER GUANABARA)
          (HARMONY SATIETY VULCAN)
          (EATS CUCUMBER PISTACHIO)
          (ATTACKS QUEBEC OREGON)
          (EATS CHERRY TUNA)
          (CRAVES UNDERSTANDING TURKEY)
          (EATS APPLE MELON)
          (CRAVES ACHIEVEMENT GUAVA)
          (HARMONY EXPECTATION VULCAN)
          (ATTACKS BAVARIA SURREY)
          (CRAVES LACERATION-4 APPLE)
          (HARMONY EXCITEMENT MERCURY)
          (EATS CUCUMBER PORK)
          (HARMONY TRIUMPH VULCAN)
          (EATS WURST APPLE)
          (LOCALE FLOUNDER GOIAS)
          (EATS ENDIVE LEMON)
          (LOCALE PEAR BAVARIA)
          (EATS FLOUNDER GUAVA)
          (EATS TOMATO PISTACHIO)
          (CRAVES JEALOUSY SCALLION)
          (EATS CHICKEN HOTDOG)
          (EATS TUNA ENDIVE)
          (CRAVES ANXIETY-2 PORK)
          (EATS SWEETROLL OKRA)
          (EATS CUCUMBER HOTDOG)
          (LOCALE TOMATO OREGON)
          (CRAVES JEALOUSY-6 CHERRY)
          (EATS ENDIVE TUNA)
          (LOCALE WURST GOIAS)
          (EATS HOTDOG SWEETROLL)
          (LOCALE PORK PENNSYLVANIA)
          (LOCALE CANTELOPE MORAVIA)
          (EATS GRAPEFRUIT CHICKEN)
          (ATTACKS KENTUCKY ARIZONA)
          (CRAVES ANGINA BROCCOLI)
          (EATS CHOCOLATE ARUGULA)
          (HARMONY UNDERSTANDING MERCURY)
          (EATS ENDIVE PEPPER)
          (CRAVES ANXIETY GUAVA)
          (CRAVES GRIEF TURKEY)
          (LOCALE MELON MORAVIA)
          (CRAVES BOILS-7 KALE)
          (EATS CHERRY MELON)
          (CRAVES HANGOVER-3 HOTDOG)
          (HARMONY LUBRICITY MERCURY)
          (CRAVES DREAD-1 PISTACHIO)
          (EATS LAMB LEMON)
          (EATS PEAR BROCCOLI)
          (EATS BROCCOLI PEAR)
          (EATS POPOVER SWEETROLL)
          (LOCALE HAM PENNSYLVANIA)
          (HARMONY ACHIEVEMENT MERCURY)
          (LOCALE HAMBURGER QUEBEC)
          (HARMONY STIMULATION VULCAN)
          (CRAVES SATIETY POPOVER)
          (CRAVES DEPRESSION LETTUCE)
          (LOCALE OKRA PENNSYLVANIA)
          (EATS LEMON LAMB)
          (EATS MELON APPLE)
          (EATS WURST GUAVA)
          (EATS PORK CUCUMBER)
          (EATS CANTELOPE LETTUCE)
          (EATS TOFU PEPPER)
          (EATS GUAVA WURST)
          (EATS HAM OKRA)
          (EATS HOTDOG SCALLION)
          (HARMONY ENTERTAINMENT MARS)
          (EATS TUNA PORK)
          (HARMONY EMPATHY MARS)
          (LOCALE LEMON KENTUCKY)
          (EATS SCALLION PORK)
          (CRAVES HANGOVER POPOVER)
          (EATS SWEETROLL POPOVER)
          (LOCALE CHERRY KENTUCKY)
          (EATS CHERRY CUCUMBER)
          (LOCALE SWEETROLL GUANABARA)
          (EATS HOTDOG KALE)
          (ATTACKS GOIAS GUANABARA)
          (EATS PORK KALE)
          (LOCALE TURKEY MORAVIA)
          (EATS BROCCOLI LETTUCE)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS PISTACHIO HOTDOG)
          (EATS LETTUCE BROCCOLI)
          (EATS KALE PORK)
          (EATS GRAPEFRUIT KALE)
          (ATTACKS OREGON GOIAS)
          (EATS PEPPER ENDIVE)
          (LOCALE TUNA SURREY)
          (LOCALE KALE GUANABARA)
          (EATS PORK SCALLION)
          (CRAVES LUBRICITY BROCCOLI)
          (EATS HAM WONDERBREAD)
          (CRAVES AESTHETICS SCALLION)
          (LOCALE APPLE MORAVIA)
          (LOCALE POPOVER GUANABARA)
          (EATS LAMB LETTUCE)
          (EATS TURKEY TOFU)
          (EATS WONDERBREAD WURST)
          (CRAVES ANGER WONDERBREAD)
          (EATS HOTDOG WURST)
          (EATS SWEETROLL HOTDOG)
          (EATS WONDERBREAD HAM)
          (CRAVES LACERATION CHOCOLATE)
          (EATS TOMATO APPLE)
          (EATS CHOCOLATE TURKEY)
          (LOCALE PISTACHIO PENNSYLVANIA)
          (LOCALE BROCCOLI GUANABARA)
          (CRAVES EXPECTATION TOMATO)
          (EATS CANTELOPE SNICKERS)
          (LOCALE PEPPER MORAVIA)
          (EATS PISTACHIO CUCUMBER)
          (EATS LETTUCE LAMB)
          (EATS CUCUMBER CHERRY)
          (EATS HOTDOG CUCUMBER)
          (EATS WURST WONDERBREAD)
          (CRAVES SCIATICA TOMATO)
          (LOCALE CHOCOLATE QUEBEC)
          (CRAVES EXCITEMENT KALE)
          (EATS POPOVER GRAPEFRUIT)
          (ORBITS VENUS VULCAN)
          (CRAVES LONELINESS PEPPER)
          (EATS LETTUCE CANTELOPE)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (CRAVES TRIUMPH ENDIVE)
          (HARMONY CURIOSITY MERCURY)
          (CRAVES DREAD PEAR)
          (ORBITS VULCAN MARS)
          (LOCALE CHICKEN QUEBEC)
          (EATS KALE HOTDOG)
          (EATS SNICKERS CANTELOPE)
          (EATS GRAPEFRUIT POPOVER)
          (LOCALE ARUGULA PENNSYLVANIA)
          (EATS HAMBURGER SWEETROLL)
          (EATS HOTDOG PISTACHIO)
          (EATS HOTDOG CHICKEN)
          (LOCALE GRAPEFRUIT PENNSYLVANIA)
          (EATS WURST HOTDOG)
          (EATS APPLE TOMATO)
          (ATTACKS ARIZONA PENNSYLVANIA)
          (EATS CHICKEN GRAPEFRUIT)
          (LOCALE HOTDOG MORAVIA)
          (LOCALE WONDERBREAD QUEBEC)
          (LOCALE SCALLION OREGON)
          (LOCALE ENDIVE OREGON)
          (CRAVES PROSTATITIS CANTELOPE)
          (EATS ARUGULA CHOCOLATE)
          (EATS PEPPER TOFU)
          (EATS HAMBURGER FLOUNDER)
          (EATS KALE GRAPEFRUIT)
          (EATS PORK TUNA)
          (CRAVES STIMULATION CHERRY)
          (EATS APPLE WURST)
          (EATS TOFU PEAR)
          (EATS SWEETROLL HAMBURGER)
          (LOCALE LAMB QUEBEC)
          (CRAVES ENTERTAINMENT LEMON)
          (EATS WURST PISTACHIO)
          (EATS SCALLION HOTDOG)
          (EATS PEAR TOFU)
          (EATS TUNA CHERRY)
          (EATS GUAVA FLOUNDER)
          (EATS PISTACHIO WURST))
   (:GOAL (AND (CRAVES DREAD WURST)
               (CRAVES PROSTATITIS LETTUCE))))

(DEFINE (PROBLEM STRIPS-MYSTY-24)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LEMON PEPPER HAMBURGER HAM CHOCOLATE POPOVER ONION OKRA
             LETTUCE SCALLION SWEETROLL ORANGE MUFFIN PAPAYA TUNA PEAR
             POTATO HOTDOG MELON HAROSET SCALLOP SNICKERS BACON GRAPEFRUIT
             PISTACHIO PEA ENDIVE TOMATO LAMB CHICKEN RICE CANTELOPE CUCUMBER
             KALE BAGUETTE TOFU LOBSTER BROCCOLI MARZIPAN TURKEY PORK COD
             UNDERSTANDING ACHIEVEMENT ENTERTAINMENT EMPATHY LEARNING
             STIMULATION CURIOSITY SATISFACTION SATIETY LOVE AESTHETICS
             LUBRICITY REST INTOXICATION EXPECTATION SCIATICA LONELINESS
             DEPRESSION ANGER LACERATION PROSTATITIS BOILS GRIEF DREAD
             HANGOVER ANGINA ANXIETY JEALOUSY ABRASION DREAD-2 ANGINA-1
             GRIEF-4 LONELINESS-8 HANGOVER-3 BOILS-7 ANGER-6 ANXIETY-16
             LACERATION-5 JEALOUSY-15 PROSTATITIS-14 SCIATICA-13
             DEPRESSION-11 ABRASION-12 DEPRESSION-9 ANGINA-10 JEALOUSY-31
             LONELINESS-32 GRIEF-29 PROSTATITIS-30 SCIATICA-28 ANXIETY-26
             BOILS-27 DREAD-25 ABRASION-24 LACERATION-22 HANGOVER-23
             ANGER-21 BOILS-20 LACERATION-19 JEALOUSY-18 ANGER-64
             HANGOVER-17 ANGINA-62 ABRASION-63 ANXIETY-61 PROSTATITIS-59
             DREAD-60 DEPRESSION-58 SCIATICA-57 LONELINESS-55 GRIEF-56
             DREAD-53 JEALOUSY-54 MORAVIA QUEBEC BAVARIA OREGON ARIZONA
             SURREY MARS NEPTUNE MERCURY JUPITER)
   (:INIT (FOOD LEMON)
          (FOOD PEPPER)
          (FOOD HAMBURGER)
          (FOOD HAM)
          (FOOD CHOCOLATE)
          (FOOD POPOVER)
          (FOOD ONION)
          (FOOD OKRA)
          (FOOD LETTUCE)
          (FOOD SCALLION)
          (FOOD SWEETROLL)
          (FOOD ORANGE)
          (FOOD MUFFIN)
          (FOOD PAPAYA)
          (FOOD TUNA)
          (FOOD PEAR)
          (FOOD POTATO)
          (FOOD HOTDOG)
          (FOOD MELON)
          (FOOD HAROSET)
          (FOOD SCALLOP)
          (FOOD SNICKERS)
          (FOOD BACON)
          (FOOD GRAPEFRUIT)
          (FOOD PISTACHIO)
          (FOOD PEA)
          (FOOD ENDIVE)
          (FOOD TOMATO)
          (FOOD LAMB)
          (FOOD CHICKEN)
          (FOOD RICE)
          (FOOD CANTELOPE)
          (FOOD CUCUMBER)
          (FOOD KALE)
          (FOOD BAGUETTE)
          (FOOD TOFU)
          (FOOD LOBSTER)
          (FOOD BROCCOLI)
          (FOOD MARZIPAN)
          (FOOD TURKEY)
          (FOOD PORK)
          (FOOD COD)
          (PLEASURE UNDERSTANDING)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE EMPATHY)
          (PLEASURE LEARNING)
          (PLEASURE STIMULATION)
          (PLEASURE CURIOSITY)
          (PLEASURE SATISFACTION)
          (PLEASURE SATIETY)
          (PLEASURE LOVE)
          (PLEASURE AESTHETICS)
          (PLEASURE LUBRICITY)
          (PLEASURE REST)
          (PLEASURE INTOXICATION)
          (PLEASURE EXPECTATION)
          (PAIN SCIATICA)
          (PAIN LONELINESS)
          (PAIN DEPRESSION)
          (PAIN ANGER)
          (PAIN LACERATION)
          (PAIN PROSTATITIS)
          (PAIN BOILS)
          (PAIN GRIEF)
          (PAIN DREAD)
          (PAIN HANGOVER)
          (PAIN ANGINA)
          (PAIN ANXIETY)
          (PAIN JEALOUSY)
          (PAIN ABRASION)
          (PAIN DREAD-2)
          (PAIN ANGINA-1)
          (PAIN GRIEF-4)
          (PAIN LONELINESS-8)
          (PAIN HANGOVER-3)
          (PAIN BOILS-7)
          (PAIN ANGER-6)
          (PAIN ANXIETY-16)
          (PAIN LACERATION-5)
          (PAIN JEALOUSY-15)
          (PAIN PROSTATITIS-14)
          (PAIN SCIATICA-13)
          (PAIN DEPRESSION-11)
          (PAIN ABRASION-12)
          (PAIN DEPRESSION-9)
          (PAIN ANGINA-10)
          (PAIN JEALOUSY-31)
          (PAIN LONELINESS-32)
          (PAIN GRIEF-29)
          (PAIN PROSTATITIS-30)
          (PAIN SCIATICA-28)
          (PAIN ANXIETY-26)
          (PAIN BOILS-27)
          (PAIN DREAD-25)
          (PAIN ABRASION-24)
          (PAIN LACERATION-22)
          (PAIN HANGOVER-23)
          (PAIN ANGER-21)
          (PAIN BOILS-20)
          (PAIN LACERATION-19)
          (PAIN JEALOUSY-18)
          (PAIN ANGER-64)
          (PAIN HANGOVER-17)
          (PAIN ANGINA-62)
          (PAIN ABRASION-63)
          (PAIN ANXIETY-61)
          (PAIN PROSTATITIS-59)
          (PAIN DREAD-60)
          (PAIN DEPRESSION-58)
          (PAIN SCIATICA-57)
          (PAIN LONELINESS-55)
          (PAIN GRIEF-56)
          (PAIN DREAD-53)
          (PAIN JEALOUSY-54)
          (PROVINCE MORAVIA)
          (PROVINCE QUEBEC)
          (PROVINCE BAVARIA)
          (PROVINCE OREGON)
          (PROVINCE ARIZONA)
          (PROVINCE SURREY)
          (PLANET MARS)
          (PLANET NEPTUNE)
          (PLANET MERCURY)
          (PLANET JUPITER)
          (EATS TOMATO KALE)
          (EATS BROCCOLI ENDIVE)
          (CRAVES ANGINA ONION)
          (EATS MELON TURKEY)
          (EATS CHICKEN LOBSTER)
          (EATS HOTDOG SCALLOP)
          (CRAVES ANXIETY-16 POTATO)
          (CRAVES SATISFACTION ENDIVE)
          (EATS RICE LAMB)
          (EATS PAPAYA GRAPEFRUIT)
          (LOCALE KALE BAVARIA)
          (EATS SCALLOP SCALLION)
          (HARMONY SATISFACTION NEPTUNE)
          (LOCALE ONION MORAVIA)
          (CRAVES LONELINESS-32 BACON)
          (LOCALE BROCCOLI OREGON)
          (EATS RICE BAGUETTE)
          (LOCALE RICE SURREY)
          (CRAVES DEPRESSION-11 SCALLOP)
          (EATS HAROSET POPOVER)
          (EATS HAMBURGER TUNA)
          (LOCALE HAM QUEBEC)
          (EATS HAROSET TUNA)
          (EATS TOFU BROCCOLI)
          (HARMONY CURIOSITY NEPTUNE)
          (LOCALE PEPPER MORAVIA)
          (CRAVES GRIEF-56 PORK)
          (EATS LAMB LOBSTER)
          (LOCALE BACON SURREY)
          (EATS TURKEY PORK)
          (LOCALE HOTDOG QUEBEC)
          (CRAVES SCIATICA-57 TURKEY)
          (EATS PISTACHIO TURKEY)
          (EATS MELON HAM)
          (EATS SCALLOP HOTDOG)
          (CRAVES ANGER-21 CHICKEN)
          (CRAVES HANGOVER ONION)
          (EATS ORANGE HAROSET)
          (CRAVES DREAD-53 COD)
          (EATS PEPPER HAROSET)
          (CRAVES SCIATICA-13 HAROSET)
          (EATS HAM ORANGE)
          (CRAVES ENTERTAINMENT TUNA)
          (CRAVES GRIEF-4 ORANGE)
          (EATS GRAPEFRUIT ONION)
          (EATS PORK TOFU)
          (EATS SCALLION ORANGE)
          (ORBITS MARS NEPTUNE)
          (EATS TOMATO BAGUETTE)
          (EATS LETTUCE TUNA)
          (CRAVES BOILS-27 PEA)
          (EATS SCALLION SCALLOP)
          (CRAVES SATIETY CHICKEN)
          (LOCALE GRAPEFRUIT BAVARIA)
          (EATS OKRA PAPAYA)
          (EATS MUFFIN PEAR)
          (LOCALE PEAR BAVARIA)
          (EATS ORANGE SCALLION)
          (EATS TOFU PORK)
          (EATS SNICKERS POTATO)
          (EATS PEAR MUFFIN)
          (CRAVES ANGER-6 TUNA)
          (EATS POPOVER HOTDOG)
          (ATTACKS BAVARIA OREGON)
          (LOCALE SCALLOP BAVARIA)
          (CRAVES ANGINA-62 TOFU)
          (LOCALE ENDIVE QUEBEC)
          (EATS SCALLOP PEPPER)
          (LOCALE PORK ARIZONA)
          (LOCALE SCALLION MORAVIA)
          (LOCALE MELON MORAVIA)
          (CRAVES PROSTATITIS-14 MELON)
          (LOCALE LEMON SURREY)
          (LOCALE SNICKERS MORAVIA)
          (HARMONY REST NEPTUNE)
          (EATS ONION TUNA)
          (EATS GRAPEFRUIT MELON)
          (CRAVES ANGER-64 BAGUETTE)
          (EATS PEA BAGUETTE)
          (EATS RICE LOBSTER)
          (HARMONY ACHIEVEMENT MERCURY)
          (EATS PEA RICE)
          (EATS CHICKEN CANTELOPE)
          (EATS MARZIPAN KALE)
          (EATS LEMON PEAR)
          (LOCALE BAGUETTE MORAVIA)
          (LOCALE POPOVER SURREY)
          (EATS TURKEY MELON)
          (ATTACKS ARIZONA SURREY)
          (EATS ENDIVE BROCCOLI)
          (EATS SWEETROLL BACON)
          (ORBITS NEPTUNE MERCURY)
          (ATTACKS QUEBEC BAVARIA)
          (EATS BAGUETTE TOMATO)
          (EATS POTATO HAROSET)
          (CRAVES HANGOVER-23 LAMB)
          (CRAVES DREAD-25 ENDIVE)
          (CRAVES ANGINA-10 SNICKERS)
          (EATS ENDIVE CUCUMBER)
          (CRAVES ABRASION-63 TOFU)
          (CRAVES LACERATION HAM)
          (LOCALE TOMATO MORAVIA)
          (EATS PEAR HAMBURGER)
          (LOCALE OKRA ARIZONA)
          (CRAVES AESTHETICS CUCUMBER)
          (HARMONY ENTERTAINMENT JUPITER)
          (EATS CANTELOPE RICE)
          (LOCALE CHOCOLATE QUEBEC)
          (CRAVES CURIOSITY PEA)
          (EATS HAM MELON)
          (LOCALE LAMB SURREY)
          (LOCALE HAROSET SURREY)
          (EATS CUCUMBER PISTACHIO)
          (EATS PISTACHIO CUCUMBER)
          (EATS HAROSET PEPPER)
          (EATS PEA COD)
          (EATS LAMB TOFU)
          (CRAVES ABRASION-24 TOMATO)
          (CRAVES PROSTATITIS-30 GRAPEFRUIT)
          (EATS LEMON CHOCOLATE)
          (EATS CHOCOLATE LEMON)
          (CRAVES ANGINA-1 SWEETROLL)
          (CRAVES JEALOUSY-18 KALE)
          (EATS POPOVER HAROSET)
          (CRAVES EXPECTATION COD)
          (CRAVES GRIEF-29 GRAPEFRUIT)
          (CRAVES ABRASION-12 SCALLOP)
          (HARMONY AESTHETICS JUPITER)
          (EATS CHOCOLATE GRAPEFRUIT)
          (LOCALE TOFU BAVARIA)
          (EATS BACON SWEETROLL)
          (CRAVES ANGER HAMBURGER)
          (CRAVES DREAD-2 SCALLION)
          (LOCALE TUNA MORAVIA)
          (EATS BAGUETTE CANTELOPE)
          (LOCALE POTATO QUEBEC)
          (CRAVES PROSTATITIS-59 BROCCOLI)
          (LOCALE PEA SURREY)
          (EATS TURKEY TOFU)
          (CRAVES SCIATICA LEMON)
          (ATTACKS MORAVIA QUEBEC)
          (CRAVES ABRASION LETTUCE)
          (EATS HAMBURGER PEAR)
          (LOCALE CHICKEN BAVARIA)
          (EATS POTATO SNICKERS)
          (EATS TURKEY PISTACHIO)
          (HARMONY STIMULATION JUPITER)
          (LOCALE HAMBURGER ARIZONA)
          (HARMONY SATIETY NEPTUNE)
          (EATS TUNA ONION)
          (EATS TOFU TURKEY)
          (EATS CANTELOPE CHICKEN)
          (CRAVES LONELINESS LEMON)
          (CRAVES ANXIETY-26 PEA)
          (EATS LOBSTER LAMB)
          (EATS LOBSTER RICE)
          (CRAVES DREAD POPOVER)
          (CRAVES ANXIETY OKRA)
          (LOCALE LOBSTER QUEBEC)
          (EATS PAPAYA OKRA)
          (CRAVES DEPRESSION-9 SNICKERS)
          (EATS MUFFIN SWEETROLL)
          (LOCALE COD MORAVIA)
          (EATS BROCCOLI LOBSTER)
          (CRAVES PROSTATITIS HAM)
          (EATS LOBSTER CHICKEN)
          (EATS LETTUCE POTATO)
          (EATS GRAPEFRUIT SCALLION)
          (CRAVES BOILS CHOCOLATE)
          (ATTACKS OREGON ARIZONA)
          (HARMONY LUBRICITY NEPTUNE)
          (EATS HOTDOG POPOVER)
          (CRAVES ANXIETY-61 LOBSTER)
          (CRAVES ACHIEVEMENT SWEETROLL)
          (EATS POTATO BACON)
          (HARMONY UNDERSTANDING JUPITER)
          (EATS LOBSTER BROCCOLI)
          (CRAVES LEARNING SCALLOP)
          (CRAVES SCIATICA-28 PISTACHIO)
          (CRAVES JEALOUSY-54 COD)
          (CRAVES DEPRESSION PEPPER)
          (CRAVES BOILS-20 RICE)
          (CRAVES JEALOUSY-15 HOTDOG)
          (EATS HAROSET POTATO)
          (EATS KALE MARZIPAN)
          (EATS TUNA HAMBURGER)
          (CRAVES LUBRICITY KALE)
          (LOCALE ORANGE QUEBEC)
          (EATS TUNA LETTUCE)
          (EATS CANTELOPE BAGUETTE)
          (EATS PEPPER SCALLOP)
          (EATS BACON POTATO)
          (EATS GRAPEFRUIT PAPAYA)
          (EATS BAGUETTE RICE)
          (LOCALE MUFFIN MORAVIA)
          (CRAVES JEALOUSY-31 BACON)
          (EATS BAGUETTE PEA)
          (EATS RICE CANTELOPE)
          (EATS KALE TOMATO)
          (EATS HAROSET ORANGE)
          (EATS PEAR LEMON)
          (LOCALE MARZIPAN MORAVIA)
          (LOCALE TURKEY MORAVIA)
          (LOCALE PISTACHIO MORAVIA)
          (LOCALE CANTELOPE MORAVIA)
          (CRAVES INTOXICATION LOBSTER)
          (CRAVES HANGOVER-3 MUFFIN)
          (EATS COD MARZIPAN)
          (EATS ORANGE HAM)
          (CRAVES EMPATHY HAROSET)
          (EATS POTATO LETTUCE)
          (EATS OKRA BACON)
          (CRAVES DREAD-60 BROCCOLI)
          (CRAVES LOVE CANTELOPE)
          (EATS SWEETROLL MUFFIN)
          (EATS GRAPEFRUIT HAMBURGER)
          (EATS SNICKERS PEPPER)
          (EATS TUNA HAROSET)
          (EATS RICE PEA)
          (ORBITS MERCURY JUPITER)
          (CRAVES REST TOFU)
          (EATS PORK TURKEY)
          (CRAVES UNDERSTANDING OKRA)
          (HARMONY EXPECTATION JUPITER)
          (CRAVES JEALOUSY LETTUCE)
          (CRAVES STIMULATION BACON)
          (EATS BACON OKRA)
          (CRAVES LACERATION-19 CANTELOPE)
          (HARMONY LOVE NEPTUNE)
          (EATS COD PEA)
          (EATS LAMB RICE)
          (CRAVES BOILS-7 PAPAYA)
          (CRAVES LONELINESS-55 PORK)
          (CRAVES DEPRESSION-58 MARZIPAN)
          (EATS CUCUMBER ENDIVE)
          (EATS PEPPER SNICKERS)
          (EATS HAMBURGER GRAPEFRUIT)
          (EATS MARZIPAN COD)
          (HARMONY LEARNING NEPTUNE)
          (LOCALE LETTUCE MORAVIA)
          (EATS ONION GRAPEFRUIT)
          (CRAVES LACERATION-5 POTATO)
          (EATS GRAPEFRUIT CHOCOLATE)
          (LOCALE SWEETROLL MORAVIA)
          (HARMONY EMPATHY MERCURY)
          (EATS TOFU LAMB)
          (CRAVES GRIEF CHOCOLATE)
          (LOCALE CUCUMBER QUEBEC)
          (HARMONY INTOXICATION NEPTUNE)
          (CRAVES LONELINESS-8 MUFFIN)
          (CRAVES HANGOVER-17 BAGUETTE)
          (LOCALE PAPAYA QUEBEC)
          (EATS MELON GRAPEFRUIT)
          (CRAVES LACERATION-22 LAMB)
          (EATS SCALLION GRAPEFRUIT)
          (EATS BROCCOLI TOFU))
   (:GOAL (AND (CRAVES ANXIETY-16 CANTELOPE)
               (CRAVES LACERATION-5 HAM)
               (CRAVES ANGINA-62 SCALLION)
               (CRAVES ABRASION-63 HAROSET))))

(DEFINE (PROBLEM STRIPS-MYSTY-25)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS LEMON-12 BEEF-13 YOGURT-14 SHRIMP-15 HAM-16 PAPAYA-5
             BACON-6 ENDIVE-7 FLOUNDER-8 ARUGULA-3 PEAR-4 SCALLION-1
             SNICKERS-2 MARZIPAN POTATO WURST TUNA KALE WONDERBREAD CHERRY TOFU
             FLOUNDER PORK APPLE TOMATO LEMON BEEF SCALLION PEAR PAPAYA
             BROCCOLI SCALLOP CANTELOPE LOBSTER SNICKERS BACON CUCUMBER OKRA
             HAMBURGER LETTUCE HAM HOTDOG MELON SWEETROLL YOGURT ORANGE GUAVA
             CHOCOLATE ARUGULA RICE LAMB GRAPEFRUIT ONION MUTTON CHICKEN
             SHRIMP PEPPER ENDIVE POPOVER PEA MUFFIN BAGUETTE HAROSET
             TURKEY PISTACHIO COD TRIUMPH LEARNING CURIOSITY
             UNDERSTANDING SATISFACTION EXCITEMENT ENTERTAINMENT REST SATIETY
             EMPATHY ACHIEVEMENT LOVE INTOXICATION STIMULATION ANGER
             ANGINA LONELINESS DEPRESSION ABRASION BOILS HANGOVER ANXIETY
             GRIEF PROSTATITIS DREAD JEALOUSY SCIATICA BOILS-32 GRIEF-9
             JEALOUSY-10 HANGOVER-11 LACERATION ANXIETY-27 ANGER-28 DREAD-29
             ANGINA-30 SCIATICA-31 PROSTATITIS-22 LONELINESS-23
             LACERATION-24 ABRASION-25 DEPRESSION-26 DEPRESSION-18 HANGOVER-19
             JEALOUSY-20 GRIEF-21 ANGINA-64 BOILS-17 DREAD-61 ANXIETY-62
             PROSTATITIS-63 LONELINESS-57 ANGER-58 LACERATION-59 ABRASION-60
             LACERATION-52 JEALOUSY-53 HANGOVER-54 PROSTATITIS-55 SCIATICA-56
             ANGER-49 BOILS-50 LONELINESS-51 ANGINA-48 ANXIETY-47 DREAD-43
             SCIATICA-44 DEPRESSION-45 GRIEF-46 PROSTATITIS-40 JEALOUSY-41
             ABRASION-42 ALSACE BOSNIA SURREY PENNSYLVANIA MORAVIA BAVARIA
             OREGON GOIAS URANUS VENUS NEPTUNE JUPITER)
   (:INIT (FOOD LEMON-12)
          (FOOD BEEF-13)
          (FOOD YOGURT-14)
          (FOOD SHRIMP-15)
          (FOOD HAM-16)
          (FOOD PAPAYA-5)
          (FOOD BACON-6)
          (FOOD ENDIVE-7)
          (FOOD FLOUNDER-8)
          (FOOD ARUGULA-3)
          (FOOD PEAR-4)
          (FOOD SCALLION-1)
          (FOOD SNICKERS-2)
          (FOOD MARZIPAN)
          (FOOD POTATO)
          (FOOD WURST)
          (FOOD TUNA)
          (FOOD KALE)
          (FOOD WONDERBREAD)
          (FOOD CHERRY)
          (FOOD TOFU)
          (FOOD FLOUNDER)
          (FOOD PORK)
          (FOOD APPLE)
          (FOOD TOMATO)
          (FOOD LEMON)
          (FOOD BEEF)
          (FOOD SCALLION)
          (FOOD PEAR)
          (FOOD PAPAYA)
          (FOOD BROCCOLI)
          (FOOD SCALLOP)
          (FOOD CANTELOPE)
          (FOOD LOBSTER)
          (FOOD SNICKERS)
          (FOOD BACON)
          (FOOD CUCUMBER)
          (FOOD OKRA)
          (FOOD HAMBURGER)
          (FOOD LETTUCE)
          (FOOD HAM)
          (FOOD HOTDOG)
          (FOOD MELON)
          (FOOD SWEETROLL)
          (FOOD YOGURT)
          (FOOD ORANGE)
          (FOOD GUAVA)
          (FOOD CHOCOLATE)
          (FOOD ARUGULA)
          (FOOD RICE)
          (FOOD LAMB)
          (FOOD GRAPEFRUIT)
          (FOOD ONION)
          (FOOD MUTTON)
          (FOOD CHICKEN)
          (FOOD SHRIMP)
          (FOOD PEPPER)
          (FOOD ENDIVE)
          (FOOD POPOVER)
          (FOOD PEA)
          (FOOD MUFFIN)
          (FOOD BAGUETTE)
          (FOOD HAROSET)
          (FOOD TURKEY)
          (FOOD PISTACHIO)
          (FOOD COD)
          (PLEASURE TRIUMPH)
          (PLEASURE LEARNING)
          (PLEASURE CURIOSITY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE SATISFACTION)
          (PLEASURE EXCITEMENT)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE REST)
          (PLEASURE SATIETY)
          (PLEASURE EMPATHY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LOVE)
          (PLEASURE INTOXICATION)
          (PLEASURE STIMULATION)
          (PAIN ANGER)
          (PAIN ANGINA)
          (PAIN LONELINESS)
          (PAIN DEPRESSION)
          (PAIN ABRASION)
          (PAIN BOILS)
          (PAIN HANGOVER)
          (PAIN ANXIETY)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN DREAD)
          (PAIN JEALOUSY)
          (PAIN SCIATICA)
          (PAIN BOILS-32)
          (PAIN GRIEF-9)
          (PAIN JEALOUSY-10)
          (PAIN HANGOVER-11)
          (PAIN LACERATION)
          (PAIN ANXIETY-27)
          (PAIN ANGER-28)
          (PAIN DREAD-29)
          (PAIN ANGINA-30)
          (PAIN SCIATICA-31)
          (PAIN PROSTATITIS-22)
          (PAIN LONELINESS-23)
          (PAIN LACERATION-24)
          (PAIN ABRASION-25)
          (PAIN DEPRESSION-26)
          (PAIN DEPRESSION-18)
          (PAIN HANGOVER-19)
          (PAIN JEALOUSY-20)
          (PAIN GRIEF-21)
          (PAIN ANGINA-64)
          (PAIN BOILS-17)
          (PAIN DREAD-61)
          (PAIN ANXIETY-62)
          (PAIN PROSTATITIS-63)
          (PAIN LONELINESS-57)
          (PAIN ANGER-58)
          (PAIN LACERATION-59)
          (PAIN ABRASION-60)
          (PAIN LACERATION-52)
          (PAIN JEALOUSY-53)
          (PAIN HANGOVER-54)
          (PAIN PROSTATITIS-55)
          (PAIN SCIATICA-56)
          (PAIN ANGER-49)
          (PAIN BOILS-50)
          (PAIN LONELINESS-51)
          (PAIN ANGINA-48)
          (PAIN ANXIETY-47)
          (PAIN DREAD-43)
          (PAIN SCIATICA-44)
          (PAIN DEPRESSION-45)
          (PAIN GRIEF-46)
          (PAIN PROSTATITIS-40)
          (PAIN JEALOUSY-41)
          (PAIN ABRASION-42)
          (PROVINCE ALSACE)
          (PROVINCE BOSNIA)
          (PROVINCE SURREY)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE MORAVIA)
          (PROVINCE BAVARIA)
          (PROVINCE OREGON)
          (PROVINCE GOIAS)
          (PLANET URANUS)
          (PLANET VENUS)
          (PLANET NEPTUNE)
          (PLANET JUPITER)
          (CRAVES PROSTATITIS-40 PISTACHIO)
          (EATS RICE COD)
          (EATS LEMON-12 CHERRY)
          (CRAVES GRIEF-46 HAROSET)
          (LOCALE BEEF ALSACE)
          (EATS SCALLION OKRA)
          (EATS LEMON PAPAYA)
          (CRAVES BOILS-17 ORANGE)
          (EATS GRAPEFRUIT SWEETROLL)
          (LOCALE WONDERBREAD PENNSYLVANIA)
          (LOCALE BEEF-13 MORAVIA)
          (EATS PAPAYA LEMON)
          (LOCALE HAM ALSACE)
          (EATS MELON PEPPER)
          (EATS POPOVER BACON)
          (HARMONY SATIETY VENUS)
          (EATS APPLE HAROSET)
          (EATS CANTELOPE MUFFIN)
          (LOCALE TURKEY SURREY)
          (CRAVES JEALOUSY-20 SWEETROLL)
          (EATS LAMB POPOVER)
          (EATS SCALLION-1 TOFU)
          (EATS ENDIVE-7 BEEF-13)
          (EATS BROCCOLI LETTUCE)
          (EATS TUNA SHRIMP-15)
          (CRAVES EXCITEMENT LEMON)
          (EATS PEAR SWEETROLL)
          (EATS OKRA CHICKEN)
          (EATS LETTUCE BROCCOLI)
          (EATS PEA BEEF)
          (LOCALE POTATO BOSNIA)
          (LOCALE SCALLION BOSNIA)
          (EATS TUNA WURST)
          (EATS SCALLION-1 SNICKERS-2)
          (EATS OKRA SCALLION)
          (CRAVES PROSTATITIS-55 GRAPEFRUIT)
          (HARMONY SATISFACTION JUPITER)
          (EATS CHERRY LEMON-12)
          (EATS HAM-16 TOFU)
          (ATTACKS BOSNIA SURREY)
          (EATS ONION ENDIVE)
          (LOCALE RICE PENNSYLVANIA)
          (EATS HAMBURGER COD)
          (EATS PAPAYA SCALLOP)
          (LOCALE TUNA MORAVIA)
          (EATS HOTDOG PEPPER)
          (CRAVES PROSTATITIS POTATO)
          (LOCALE BACON SURREY)
          (EATS CANTELOPE PISTACHIO)
          (EATS MUTTON PISTACHIO)
          (CRAVES STIMULATION PISTACHIO)
          (HARMONY LEARNING NEPTUNE)
          (EATS PISTACHIO MUTTON)
          (CRAVES DEPRESSION ENDIVE-7)
          (EATS TOFU PAPAYA-5)
          (LOCALE SHRIMP SURREY)
          (EATS FLOUNDER SNICKERS-2)
          (EATS SWEETROLL GRAPEFRUIT)
          (EATS SCALLION-1 BEEF-13)
          (EATS KALE PEAR-4)
          (LOCALE CUCUMBER SURREY)
          (LOCALE OKRA SURREY)
          (LOCALE MUTTON ALSACE)
          (ATTACKS BAVARIA OREGON)
          (EATS GRAPEFRUIT SCALLION)
          (EATS CHOCOLATE RICE)
          (EATS SCALLOP PEA)
          (LOCALE GRAPEFRUIT SURREY)
          (HARMONY LOVE JUPITER)
          (CRAVES SCIATICA-31 BACON)
          (CRAVES LONELINESS-51 ONION)
          (EATS PEA PEAR)
          (LOCALE YOGURT SURREY)
          (CRAVES SATISFACTION PORK)
          (LOCALE PEAR-4 OREGON)
          (EATS BEEF-13 SCALLION-1)
          (EATS GUAVA SNICKERS)
          (EATS BAGUETTE TURKEY)
          (CRAVES DEPRESSION-18 SWEETROLL)
          (EATS FLOUNDER POTATO)
          (EATS CHERRY PAPAYA-5)
          (EATS SHRIMP-15 TUNA)
          (EATS PEAR PEA)
          (LOCALE KALE GOIAS)
          (EATS SCALLION-1 FLOUNDER)
          (EATS FLOUNDER-8 CHERRY)
          (EATS GUAVA PEAR)
          (EATS LOBSTER ONION)
          (EATS HAROSET APPLE)
          (CRAVES LONELINESS-23 LETTUCE)
          (EATS GUAVA CHICKEN)
          (EATS APPLE ENDIVE)
          (LOCALE LOBSTER OREGON)
          (LOCALE CHERRY ALSACE)
          (EATS PISTACHIO BAGUETTE)
          (EATS CUCUMBER TOMATO)
          (ORBITS VENUS NEPTUNE)
          (LOCALE SNICKERS-2 MORAVIA)
          (EATS BACON POPOVER)
          (LOCALE FLOUNDER-8 SURREY)
          (LOCALE HAM-16 ALSACE)
          (EATS HAROSET HAMBURGER)
          (EATS POTATO FLOUNDER)
          (EATS KALE YOGURT-14)
          (EATS PAPAYA-5 CHERRY)
          (CRAVES ABRASION-25 LETTUCE)
          (CRAVES ABRASION ENDIVE-7)
          (EATS BAGUETTE PISTACHIO)
          (CRAVES HANGOVER-11 LOBSTER)
          (EATS BEEF-13 ENDIVE-7)
          (EATS MUFFIN FLOUNDER-8)
          (EATS HAM LEMON)
          (EATS BACON-6 PEAR-4)
          (CRAVES INTOXICATION HAROSET)
          (EATS FLOUNDER SCALLION-1)
          (EATS FLOUNDER-8 MUFFIN)
          (CRAVES LOVE PEA)
          (CRAVES ANGINA-30 BACON)
          (CRAVES BOILS-50 ONION)
          (EATS MARZIPAN PORK)
          (CRAVES LACERATION-59 LAMB)
          (LOCALE SCALLION-1 BOSNIA)
          (EATS SHRIMP POPOVER)
          (ATTACKS ALSACE BOSNIA)
          (LOCALE CANTELOPE ALSACE)
          (EATS CHICKEN OKRA)
          (EATS LETTUCE SHRIMP)
          (EATS POTATO PORK)
          (LOCALE CHICKEN BOSNIA)
          (CRAVES ANGER YOGURT-14)
          (HARMONY UNDERSTANDING JUPITER)
          (EATS PORK MARZIPAN)
          (EATS RICE HAMBURGER)
          (LOCALE PEPPER SURREY)
          (EATS TOFU HAM-16)
          (CRAVES ANXIETY-47 BAGUETTE)
          (EATS CHICKEN GUAVA)
          (EATS HAM-16 SNICKERS-2)
          (EATS PEAR-4 BACON-6)
          (EATS SCALLION GRAPEFRUIT)
          (CRAVES JEALOUSY APPLE)
          (LOCALE BACON-6 MORAVIA)
          (LOCALE SCALLOP PENNSYLVANIA)
          (EATS HAMBURGER RICE)
          (LOCALE ONION BOSNIA)
          (EATS KALE MARZIPAN)
          (LOCALE ORANGE PENNSYLVANIA)
          (EATS PEAR GUAVA)
          (CRAVES ANGER-49 ONION)
          (LOCALE CHOCOLATE SURREY)
          (EATS WONDERBREAD PORK)
          (EATS HAM BROCCOLI)
          (LOCALE LEMON BOSNIA)
          (EATS HAROSET CUCUMBER)
          (EATS SHRIMP LETTUCE)
          (EATS RICE CHOCOLATE)
          (LOCALE MELON BAVARIA)
          (EATS HOTDOG TURKEY)
          (LOCALE PEAR PENNSYLVANIA)
          (EATS ONION LOBSTER)
          (CRAVES ACHIEVEMENT ARUGULA)
          (CRAVES DEPRESSION-26 LETTUCE)
          (CRAVES ANXIETY-62 GUAVA)
          (EATS PEPPER CHICKEN)
          (EATS LOBSTER MELON)
          (CRAVES ANGINA YOGURT-14)
          (HARMONY ACHIEVEMENT NEPTUNE)
          (LOCALE POPOVER BOSNIA)
          (CRAVES LACERATION-24 LETTUCE)
          (EATS SCALLOP PAPAYA)
          (EATS FLOUNDER YOGURT-14)
          (CRAVES GRIEF-9 LOBSTER)
          (EATS MELON HOTDOG)
          (EATS SNICKERS PEA)
          (EATS BEEF PEA)
          (LOCALE ENDIVE SURREY)
          (EATS ENDIVE ONION)
          (EATS BACON YOGURT)
          (EATS YOGURT-14 KALE)
          (LOCALE YOGURT-14 BOSNIA)
          (EATS CHERRY FLOUNDER-8)
          (LOCALE PISTACHIO ALSACE)
          (CRAVES LEARNING ARUGULA-3)
          (CRAVES JEALOUSY-10 LOBSTER)
          (EATS ORANGE PEA)
          (EATS YOGURT BACON)
          (EATS POPOVER SHRIMP)
          (EATS PEA SNICKERS)
          (CRAVES ANXIETY-27 BACON)
          (EATS TURKEY MELON)
          (LOCALE TOMATO BOSNIA)
          (EATS WURST FLOUNDER-8)
          (EATS PEA MUFFIN)
          (EATS KALE WURST)
          (LOCALE HOTDOG MORAVIA)
          (EATS MELON TURKEY)
          (EATS PEPPER BAGUETTE)
          (LOCALE HAROSET BOSNIA)
          (EATS PEAR OKRA)
          (CRAVES ANGER-28 BACON)
          (LOCALE LEMON-12 ALSACE)
          (EATS WURST TUNA)
          (CRAVES ANGINA-64 ORANGE)
          (LOCALE WURST MORAVIA)
          (HARMONY EXCITEMENT NEPTUNE)
          (EATS YOGURT GUAVA)
          (CRAVES DREAD-61 GUAVA)
          (EATS HAMBURGER HAROSET)
          (CRAVES BOILS ENDIVE-7)
          (EATS PORK POTATO)
          (EATS ENDIVE APPLE)
          (EATS PEPPER ARUGULA)
          (EATS SNICKERS-2 HAM-16)
          (EATS SCALLION-1 TUNA)
          (EATS ENDIVE-7 SHRIMP-15)
          (EATS POPOVER LAMB)
          (EATS TURKEY HOTDOG)
          (EATS SHRIMP-15 ENDIVE-7)
          (ORBITS URANUS VENUS)
          (EATS ENDIVE-7 TOFU)
          (EATS SHRIMP MUTTON)
          (CRAVES SCIATICA APPLE)
          (ATTACKS PENNSYLVANIA MORAVIA)
          (EATS ARUGULA PEPPER)
          (CRAVES BOILS-32 LOBSTER)
          (CRAVES EMPATHY YOGURT)
          (LOCALE GUAVA BAVARIA)
          (EATS MELON LOBSTER)
          (LOCALE TOFU PENNSYLVANIA)
          (CRAVES SCIATICA-44 HAROSET)
          (EATS CHOCOLATE ORANGE)
          (LOCALE BROCCOLI BOSNIA)
          (CRAVES HANGOVER ENDIVE-7)
          (EATS COD RICE)
          (CRAVES PROSTATITIS-22 LETTUCE)
          (EATS LAMB ARUGULA)
          (EATS BACON-6 ARUGULA-3)
          (EATS BAGUETTE PEPPER)
          (EATS SNICKERS GUAVA)
          (CRAVES REST LOBSTER)
          (LOCALE SNICKERS OREGON)
          (ATTACKS MORAVIA BAVARIA)
          (CRAVES UNDERSTANDING FLOUNDER)
          (CRAVES ANGER-58 LAMB)
          (EATS CHOCOLATE HAMBURGER)
          (EATS TOFU ENDIVE-7)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS SNICKERS-2 FLOUNDER)
          (EATS GUAVA YOGURT)
          (EATS MARZIPAN KALE)
          (EATS LEMON-12 WONDERBREAD)
          (EATS ARUGULA LAMB)
          (EATS WONDERBREAD ARUGULA-3)
          (EATS ARUGULA-3 MARZIPAN)
          (EATS WURST KALE)
          (EATS PISTACHIO CANTELOPE)
          (EATS PEAR-4 KALE)
          (EATS WONDERBREAD LEMON-12)
          (LOCALE MARZIPAN BOSNIA)
          (EATS PEPPER MELON)
          (HARMONY REST VENUS)
          (CRAVES SCIATICA-56 GRAPEFRUIT)
          (EATS TURKEY BAGUETTE)
          (LOCALE ENDIVE-7 ALSACE)
          (EATS GRAPEFRUIT HAROSET)
          (EATS MARZIPAN ARUGULA-3)
          (EATS BROCCOLI HAM)
          (HARMONY EMPATHY NEPTUNE)
          (LOCALE LAMB BOSNIA)
          (LOCALE PEA BAVARIA)
          (CRAVES ANGINA-48 POPOVER)
          (EATS MUFFIN PEA)
          (LOCALE BAGUETTE BOSNIA)
          (EATS POPOVER BEEF)
          (EATS PEPPER SHRIMP)
          (EATS SWEETROLL PEAR)
          (EATS PAPAYA-5 TOFU)
          (LOCALE ARUGULA-3 BAVARIA)
          (EATS PEPPER HOTDOG)
          (LOCALE MUFFIN BAVARIA)
          (EATS TOMATO CHICKEN)
          (EATS CHICKEN TOMATO)
          (EATS SHRIMP PEPPER)
          (EATS LEMON HAM)
          (CRAVES TRIUMPH BACON-6)
          (HARMONY TRIUMPH NEPTUNE)
          (EATS CHICKEN HAROSET)
          (EATS OKRA PEAR)
          (CRAVES ENTERTAINMENT BEEF)
          (EATS HAMBURGER CHOCOLATE)
          (LOCALE FLOUNDER PENNSYLVANIA)
          (LOCALE COD PENNSYLVANIA)
          (EATS MUFFIN CANTELOPE)
          (EATS ENDIVE CUCUMBER)
          (EATS TOMATO CUCUMBER)
          (EATS TOFU SCALLION-1)
          (EATS CUCUMBER ENDIVE)
          (CRAVES DEPRESSION-45 HAROSET)
          (EATS PEA SCALLOP)
          (EATS ARUGULA-3 BACON-6)
          (ORBITS NEPTUNE JUPITER)
          (CRAVES DREAD KALE)
          (EATS HAROSET CHICKEN)
          (CRAVES ABRASION-42 PISTACHIO)
          (CRAVES LACERATION LOBSTER)
          (CRAVES HANGOVER-54 GRAPEFRUIT)
          (CRAVES JEALOUSY-41 PISTACHIO)
          (CRAVES LACERATION-52 GRAPEFRUIT)
          (EATS ORANGE CHOCOLATE)
          (CRAVES LONELINESS YOGURT-14)
          (EATS YOGURT-14 FLOUNDER)
          (EATS TUNA SCALLION-1)
          (CRAVES GRIEF-21 SWEETROLL)
          (CRAVES HANGOVER-19 SWEETROLL)
          (CRAVES SATIETY SNICKERS)
          (ATTACKS SURREY PENNSYLVANIA)
          (LOCALE SWEETROLL SURREY)
          (EATS BEEF POPOVER)
          (HARMONY CURIOSITY JUPITER)
          (EATS COD HAMBURGER)
          (EATS PORK WONDERBREAD)
          (CRAVES DREAD-43 HAROSET)
          (CRAVES LONELINESS-57 LAMB)
          (CRAVES JEALOUSY-53 GRAPEFRUIT)
          (HARMONY STIMULATION VENUS)
          (LOCALE PAPAYA PENNSYLVANIA)
          (EATS SNICKERS-2 SCALLION-1)
          (CRAVES CURIOSITY WONDERBREAD)
          (LOCALE PAPAYA-5 MORAVIA)
          (LOCALE APPLE SURREY)
          (ATTACKS OREGON GOIAS)
          (CRAVES ANXIETY MARZIPAN)
          (HARMONY INTOXICATION VENUS)
          (LOCALE HAMBURGER BOSNIA)
          (LOCALE PORK SURREY)
          (LOCALE ARUGULA ALSACE)
          (CRAVES GRIEF POTATO)
          (EATS PEA ORANGE)
          (LOCALE SHRIMP-15 ALSACE)
          (CRAVES ABRASION-60 LAMB)
          (EATS ARUGULA-3 WONDERBREAD)
          (LOCALE LETTUCE ALSACE)
          (EATS MUTTON SHRIMP)
          (EATS CHICKEN PEPPER)
          (EATS CUCUMBER HAROSET)
          (EATS HOTDOG MELON)
          (CRAVES DREAD-29 BACON)
          (EATS FLOUNDER-8 WURST)
          (EATS HAROSET GRAPEFRUIT)
          (CRAVES PROSTATITIS-63 GUAVA))
   (:GOAL (AND (CRAVES LONELINESS-23 MUTTON))))

(DEFINE (PROBLEM STRIPS-MYSTY-26)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS BACON-31 CANTELOPE-30 TUNA-29 CHERRY-28 TOFU-32 COD-9
             BROCCOLI-10 YOGURT-11 TOMATO-12 MARZIPAN-16 LOBSTER-15
             SCALLION-14 GUAVA-13 PORK-5 MUFFIN-6 PEPPER-7 WURST-8 POPOVER-3
             TURKEY-4 ENDIVE-1 HAMBURGER-2 HAM COD SHRIMP HOTDOG LETTUCE
             PAPAYA BEEF PEA APPLE POTATO MARZIPAN TUNA WONDERBREAD ORANGE
             SWEETROLL HAMBURGER ARUGULA FLOUNDER PEAR SCALLOP PEPPER
             CUCUMBER BACON TOMATO MUTTON HAROSET YOGURT CHICKEN BROCCOLI
             LAMB TURKEY CHERRY PISTACHIO GRAPEFRUIT TOFU BAGUETTE WURST
             OKRA KALE MUFFIN CHOCOLATE ENDIVE GUAVA MELON ONION POPOVER
             LOBSTER SCALLION PORK SNICKERS CANTELOPE RICE LEMON
             STIMULATION EXPECTATION LEARNING INTOXICATION EMPATHY EXCITEMENT
             REST LOVE SATISFACTION TRIUMPH UNDERSTANDING SATIETY
             ACHIEVEMENT LUBRICITY ENTERTAINMENT CURIOSITY AESTHETICS REST-27
             ENTERTAINMENT-26 EXPECTATION-25 ACHIEVEMENT-24 SATISFACTION-23
             TRIUMPH-22 CURIOSITY-21 EXCITEMENT-20 LEARNING-19 LOVE-18
             INTOXICATION-17 STIMULATION-64 EMPATHY-63 AESTHETICS-62
             UNDERSTANDING-61 LUBRICITY-60 ANGER HANGOVER GRIEF BOILS ANGINA
             ABRASION DEPRESSION JEALOUSY DREAD PROSTATITIS LACERATION
             SCIATICA LONELINESS ANXIETY SCIATICA-58 HANGOVER-59
             DEPRESSION-54 GRIEF-55 ANGINA-56 PROSTATITIS-57 LONELINESS-50
             ANXIETY-51 LACERATION-52 ANGER-53 JEALOUSY-46 DREAD-47
             ABRASION-48 BOILS-49 PROSTATITIS-42 ANXIETY-43 JEALOUSY-44
             GRIEF-45 LACERATION-39 DREAD-40 DEPRESSION-41 HANGOVER-37
             ANGINA-38 LONELINESS-34 ABRASION-35 BOILS-36 ANXIETY-127
             ANGER-128 SCIATICA-33 HANGOVER-126 DREAD-125 ANGER-121
             PROSTATITIS-122 DEPRESSION-123 ABRASION-124 ANGINA-120 BOILS-118
             LACERATION-119 JEALOUSY-114 LONELINESS-115 SCIATICA-116 GRIEF-117
             ANGINA-113 BOSNIA GOIAS PENNSYLVANIA GUANABARA OREGON KENTUCKY
             QUEBEC PLUTO VENUS MERCURY NEPTUNE)
   (:INIT (FOOD BACON-31)
          (FOOD CANTELOPE-30)
          (FOOD TUNA-29)
          (FOOD CHERRY-28)
          (FOOD TOFU-32)
          (FOOD COD-9)
          (FOOD BROCCOLI-10)
          (FOOD YOGURT-11)
          (FOOD TOMATO-12)
          (FOOD MARZIPAN-16)
          (FOOD LOBSTER-15)
          (FOOD SCALLION-14)
          (FOOD GUAVA-13)
          (FOOD PORK-5)
          (FOOD MUFFIN-6)
          (FOOD PEPPER-7)
          (FOOD WURST-8)
          (FOOD POPOVER-3)
          (FOOD TURKEY-4)
          (FOOD ENDIVE-1)
          (FOOD HAMBURGER-2)
          (FOOD HAM)
          (FOOD COD)
          (FOOD SHRIMP)
          (FOOD HOTDOG)
          (FOOD LETTUCE)
          (FOOD PAPAYA)
          (FOOD BEEF)
          (FOOD PEA)
          (FOOD APPLE)
          (FOOD POTATO)
          (FOOD MARZIPAN)
          (FOOD TUNA)
          (FOOD WONDERBREAD)
          (FOOD ORANGE)
          (FOOD SWEETROLL)
          (FOOD HAMBURGER)
          (FOOD ARUGULA)
          (FOOD FLOUNDER)
          (FOOD PEAR)
          (FOOD SCALLOP)
          (FOOD PEPPER)
          (FOOD CUCUMBER)
          (FOOD BACON)
          (FOOD TOMATO)
          (FOOD MUTTON)
          (FOOD HAROSET)
          (FOOD YOGURT)
          (FOOD CHICKEN)
          (FOOD BROCCOLI)
          (FOOD LAMB)
          (FOOD TURKEY)
          (FOOD CHERRY)
          (FOOD PISTACHIO)
          (FOOD GRAPEFRUIT)
          (FOOD TOFU)
          (FOOD BAGUETTE)
          (FOOD WURST)
          (FOOD OKRA)
          (FOOD KALE)
          (FOOD MUFFIN)
          (FOOD CHOCOLATE)
          (FOOD ENDIVE)
          (FOOD GUAVA)
          (FOOD MELON)
          (FOOD ONION)
          (FOOD POPOVER)
          (FOOD LOBSTER)
          (FOOD SCALLION)
          (FOOD PORK)
          (FOOD SNICKERS)
          (FOOD CANTELOPE)
          (FOOD RICE)
          (FOOD LEMON)
          (PLEASURE STIMULATION)
          (PLEASURE EXPECTATION)
          (PLEASURE LEARNING)
          (PLEASURE INTOXICATION)
          (PLEASURE EMPATHY)
          (PLEASURE EXCITEMENT)
          (PLEASURE REST)
          (PLEASURE LOVE)
          (PLEASURE SATISFACTION)
          (PLEASURE TRIUMPH)
          (PLEASURE UNDERSTANDING)
          (PLEASURE SATIETY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE CURIOSITY)
          (PLEASURE AESTHETICS)
          (PLEASURE REST-27)
          (PLEASURE ENTERTAINMENT-26)
          (PLEASURE EXPECTATION-25)
          (PLEASURE ACHIEVEMENT-24)
          (PLEASURE SATISFACTION-23)
          (PLEASURE TRIUMPH-22)
          (PLEASURE CURIOSITY-21)
          (PLEASURE EXCITEMENT-20)
          (PLEASURE LEARNING-19)
          (PLEASURE LOVE-18)
          (PLEASURE INTOXICATION-17)
          (PLEASURE STIMULATION-64)
          (PLEASURE EMPATHY-63)
          (PLEASURE AESTHETICS-62)
          (PLEASURE UNDERSTANDING-61)
          (PLEASURE LUBRICITY-60)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN BOILS)
          (PAIN ANGINA)
          (PAIN ABRASION)
          (PAIN DEPRESSION)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN PROSTATITIS)
          (PAIN LACERATION)
          (PAIN SCIATICA)
          (PAIN LONELINESS)
          (PAIN ANXIETY)
          (PAIN SCIATICA-58)
          (PAIN HANGOVER-59)
          (PAIN DEPRESSION-54)
          (PAIN GRIEF-55)
          (PAIN ANGINA-56)
          (PAIN PROSTATITIS-57)
          (PAIN LONELINESS-50)
          (PAIN ANXIETY-51)
          (PAIN LACERATION-52)
          (PAIN ANGER-53)
          (PAIN JEALOUSY-46)
          (PAIN DREAD-47)
          (PAIN ABRASION-48)
          (PAIN BOILS-49)
          (PAIN PROSTATITIS-42)
          (PAIN ANXIETY-43)
          (PAIN JEALOUSY-44)
          (PAIN GRIEF-45)
          (PAIN LACERATION-39)
          (PAIN DREAD-40)
          (PAIN DEPRESSION-41)
          (PAIN HANGOVER-37)
          (PAIN ANGINA-38)
          (PAIN LONELINESS-34)
          (PAIN ABRASION-35)
          (PAIN BOILS-36)
          (PAIN ANXIETY-127)
          (PAIN ANGER-128)
          (PAIN SCIATICA-33)
          (PAIN HANGOVER-126)
          (PAIN DREAD-125)
          (PAIN ANGER-121)
          (PAIN PROSTATITIS-122)
          (PAIN DEPRESSION-123)
          (PAIN ABRASION-124)
          (PAIN ANGINA-120)
          (PAIN BOILS-118)
          (PAIN LACERATION-119)
          (PAIN JEALOUSY-114)
          (PAIN LONELINESS-115)
          (PAIN SCIATICA-116)
          (PAIN GRIEF-117)
          (PAIN ANGINA-113)
          (PROVINCE BOSNIA)
          (PROVINCE GOIAS)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE GUANABARA)
          (PROVINCE OREGON)
          (PROVINCE KENTUCKY)
          (PROVINCE QUEBEC)
          (PLANET PLUTO)
          (PLANET VENUS)
          (PLANET MERCURY)
          (PLANET NEPTUNE)
          (LOCALE RICE GUANABARA)
          (CRAVES LACERATION-119 PORK)
          (CRAVES UNDERSTANDING TUNA)
          (CRAVES LOVE COD)
          (HARMONY SATISFACTION MERCURY)
          (EATS POPOVER PEAR)
          (CRAVES SATISFACTION PEA)
          (EATS LOBSTER HAM)
          (CRAVES PROSTATITIS POPOVER-3)
          (EATS RICE CANTELOPE)
          (EATS TOFU TOMATO)
          (EATS LOBSTER-15 SCALLION-14)
          (HARMONY EXPECTATION-25 NEPTUNE)
          (EATS PORK SCALLION)
          (EATS MARZIPAN GUAVA)
          (EATS BEEF POPOVER)
          (CRAVES CURIOSITY-21 PISTACHIO)
          (CRAVES LACERATION POPOVER-3)
          (HARMONY TRIUMPH NEPTUNE)
          (EATS MUTTON SHRIMP)
          (CRAVES ABRASION PEPPER-7)
          (CRAVES CURIOSITY FLOUNDER)
          (CRAVES SATIETY WONDERBREAD)
          (EATS CHERRY-28 BACON-31)
          (EATS WURST-8 POPOVER-3)
          (EATS BACON CUCUMBER)
          (EATS TOMATO-12 BROCCOLI-10)
          (EATS PEPPER PEAR)
          (EATS TOMATO SWEETROLL)
          (LOCALE CHERRY-28 GUANABARA)
          (LOCALE POPOVER-3 GUANABARA)
          (EATS YOGURT TURKEY)
          (EATS TOFU-32 TOMATO-12)
          (CRAVES LUBRICITY-60 LEMON)
          (LOCALE GRAPEFRUIT GUANABARA)
          (EATS PORK-5 HAROSET)
          (EATS MELON CHERRY)
          (EATS HOTDOG HAMBURGER)
          (LOCALE SCALLOP KENTUCKY)
          (HARMONY EXCITEMENT-20 NEPTUNE)
          (CRAVES ABRASION-124 TURKEY)
          (CRAVES DREAD-47 LETTUCE)
          (EATS TOFU-32 YOGURT-11)
          (EATS KALE COD)
          (CRAVES ANXIETY-43 BEEF)
          (EATS YOGURT-11 COD-9)
          (CRAVES INTOXICATION PORK-5)
          (EATS ENDIVE-1 MUFFIN)
          (HARMONY CURIOSITY MERCURY)
          (CRAVES GRIEF-117 SNICKERS)
          (HARMONY EXCITEMENT MERCURY)
          (LOCALE GUAVA GUANABARA)
          (EATS PEA BROCCOLI)
          (EATS ENDIVE CHICKEN)
          (EATS CUCUMBER LEMON)
          (HARMONY REST-27 VENUS)
          (ATTACKS BOSNIA GOIAS)
          (EATS SCALLOP LAMB)
          (CRAVES ANXIETY-127 TOMATO)
          (LOCALE CANTELOPE KENTUCKY)
          (EATS POPOVER BEEF)
          (CRAVES SCIATICA-58 HAM)
          (EATS OKRA GRAPEFRUIT)
          (CRAVES SCIATICA ENDIVE-1)
          (EATS RICE PEPPER-7)
          (LOCALE BACON OREGON)
          (CRAVES DREAD-40 APPLE)
          (LOCALE ONION GOIAS)
          (LOCALE PEPPER GUANABARA)
          (CRAVES HANGOVER-37 MARZIPAN)
          (CRAVES ANXIETY ENDIVE-1)
          (CRAVES LEARNING MARZIPAN-16)
          (EATS COD-9 CANTELOPE-30)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (CRAVES ABRASION-35 WONDERBREAD)
          (EATS PORK-5 MELON)
          (EATS SNICKERS COD)
          (EATS FLOUNDER CHERRY)
          (EATS SCALLION POTATO)
          (LOCALE LETTUCE BOSNIA)
          (HARMONY LOVE VENUS)
          (EATS POTATO ORANGE)
          (EATS HAMBURGER-2 PISTACHIO)
          (EATS TUNA-29 CANTELOPE-30)
          (CRAVES EMPATHY MUFFIN-6)
          (LOCALE BROCCOLI-10 GUANABARA)
          (CRAVES TRIUMPH-22 CHERRY)
          (EATS YOGURT-11 GUAVA-13)
          (LOCALE HOTDOG KENTUCKY)
          (EATS BROCCOLI-10 SCALLION-14)
          (EATS CHOCOLATE MARZIPAN)
          (LOCALE HAMBURGER PENNSYLVANIA)
          (CRAVES GRIEF-45 BEEF)
          (CRAVES DEPRESSION-54 COD)
          (CRAVES LACERATION-39 APPLE)
          (EATS CHICKEN OKRA)
          (EATS BROCCOLI-10 COD-9)
          (LOCALE COD-9 QUEBEC)
          (EATS SWEETROLL ORANGE)
          (CRAVES ENTERTAINMENT-26 MUTTON)
          (EATS SCALLOP BEEF)
          (EATS SCALLION-14 LOBSTER-15)
          (CRAVES LONELINESS ENDIVE-1)
          (LOCALE MUFFIN-6 GOIAS)
          (EATS PEAR PEPPER)
          (CRAVES EMPATHY-63 SCALLION)
          (EATS ENDIVE-1 BROCCOLI)
          (EATS MUFFIN-6 POPOVER-3)
          (EATS MUFFIN-6 MUFFIN)
          (LOCALE COD KENTUCKY)
          (EATS TUNA HAMBURGER-2)
          (EATS ARUGULA TOMATO)
          (EATS SHRIMP SCALLION)
          (EATS PISTACHIO GUAVA)
          (EATS YOGURT PEPPER)
          (ATTACKS KENTUCKY QUEBEC)
          (EATS OKRA SHRIMP)
          (CRAVES REST-27 BACON)
          (EATS SCALLION SHRIMP)
          (EATS MUTTON ENDIVE)
          (EATS PISTACHIO HAMBURGER-2)
          (LOCALE CANTELOPE-30 GUANABARA)
          (EATS TUNA PEA)
          (CRAVES ANGER-53 SHRIMP)
          (EATS FLOUNDER BAGUETTE)
          (EATS SNICKERS LEMON)
          (CRAVES SCIATICA-116 SNICKERS)
          (EATS POPOVER-3 WURST-8)
          (LOCALE ENDIVE GOIAS)
          (LOCALE CHERRY KENTUCKY)
          (CRAVES EXCITEMENT TURKEY-4)
          (EATS LAMB KALE)
          (EATS WURST-8 RICE)
          (CRAVES ENTERTAINMENT ARUGULA)
          (CRAVES AESTHETICS-62 PORK)
          (CRAVES ANGINA-120 BAGUETTE)
          (LOCALE SCALLION GOIAS)
          (EATS TOFU ORANGE)
          (EATS ONION LETTUCE)
          (EATS PEPPER YOGURT)
          (EATS MUFFIN CANTELOPE)
          (LOCALE LOBSTER-15 KENTUCKY)
          (LOCALE MELON OREGON)
          (HARMONY LUBRICITY VENUS)
          (EATS BACON WURST)
          (EATS PORK GRAPEFRUIT)
          (LOCALE WONDERBREAD BOSNIA)
          (CRAVES HANGOVER-126 HAROSET)
          (EATS LOBSTER APPLE)
          (EATS RICE WURST-8)
          (EATS PISTACHIO PEPPER-7)
          (LOCALE ENDIVE-1 OREGON)
          (EATS CHICKEN ENDIVE)
          (CRAVES ANGINA PEPPER-7)
          (EATS SHRIMP OKRA)
          (CRAVES PROSTATITIS-122 TURKEY)
          (LOCALE YOGURT-11 GOIAS)
          (EATS TURKEY-4 HOTDOG)
          (EATS TURKEY YOGURT)
          (LOCALE HAROSET BOSNIA)
          (CRAVES HANGOVER CANTELOPE-30)
          (EATS COD SNICKERS)
          (HARMONY ACHIEVEMENT VENUS)
          (CRAVES ANGER-121 TURKEY)
          (CRAVES DEPRESSION PEPPER-7)
          (LOCALE CHOCOLATE GUANABARA)
          (EATS PISTACHIO MUFFIN)
          (EATS PISTACHIO TURKEY-4)
          (EATS SWEETROLL TOMATO)
          (EATS CANTELOPE-30 TUNA-29)
          (EATS GUAVA BROCCOLI)
          (LOCALE MARZIPAN OREGON)
          (CRAVES DREAD POPOVER-3)
          (EATS ORANGE TOFU)
          (HARMONY INTOXICATION-17 NEPTUNE)
          (ORBITS PLUTO VENUS)
          (EATS GUAVA MARZIPAN)
          (CRAVES EXPECTATION-25 HAROSET)
          (CRAVES ACHIEVEMENT ORANGE)
          (HARMONY CURIOSITY-21 NEPTUNE)
          (LOCALE TUNA OREGON)
          (EATS CANTELOPE RICE)
          (EATS PAPAYA MELON)
          (LOCALE WURST-8 KENTUCKY)
          (EATS CANTELOPE-30 COD-9)
          (CRAVES GRIEF-55 COD)
          (CRAVES DEPRESSION-41 APPLE)
          (LOCALE PEAR OREGON)
          (EATS COD-9 BROCCOLI-10)
          (LOCALE TOFU OREGON)
          (EATS CANTELOPE-30 CHERRY-28)
          (EATS APPLE LOBSTER)
          (LOCALE SHRIMP KENTUCKY)
          (ATTACKS GOIAS PENNSYLVANIA)
          (EATS HAROSET PORK-5)
          (CRAVES BOILS-36 WONDERBREAD)
          (LOCALE PISTACHIO GOIAS)
          (HARMONY TRIUMPH-22 VENUS)
          (EATS ENDIVE OKRA)
          (LOCALE BAGUETTE OREGON)
          (EATS HAMBURGER CHOCOLATE)
          (EATS WURST BACON)
          (CRAVES STIMULATION-64 LOBSTER)
          (LOCALE POPOVER BOSNIA)
          (CRAVES EXPECTATION BROCCOLI-10)
          (LOCALE TOFU-32 BOSNIA)
          (EATS CHOCOLATE HAMBURGER)
          (EATS HAMBURGER HOTDOG)
          (LOCALE PAPAYA BOSNIA)
          (EATS BROCCOLI GUAVA)
          (CRAVES ANGER-128 TOMATO)
          (EATS BEEF SCALLOP)
          (EATS HAMBURGER-2 TUNA)
          (EATS TOFU-32 BROCCOLI-10)
          (EATS TOMATO-12 TOFU-32)
          (HARMONY STIMULATION VENUS)
          (HARMONY AESTHETICS NEPTUNE)
          (EATS COD-9 WURST-8)
          (HARMONY AESTHETICS-62 VENUS)
          (CRAVES LONELINESS-34 WONDERBREAD)
          (HARMONY UNDERSTANDING-61 NEPTUNE)
          (LOCALE MARZIPAN-16 GOIAS)
          (EATS SWEETROLL WONDERBREAD)
          (EATS BROCCOLI ENDIVE-1)
          (EATS CANTELOPE-30 BACON-31)
          (EATS POPOVER-3 MUFFIN-6)
          (LOCALE PEPPER-7 OREGON)
          (LOCALE SCALLION-14 GUANABARA)
          (EATS MARZIPAN-16 LOBSTER-15)
          (EATS OKRA BAGUETTE)
          (EATS PEA TUNA)
          (CRAVES HANGOVER-59 HAM)
          (HARMONY SATIETY VENUS)
          (EATS GUAVA PISTACHIO)
          (CRAVES ABRASION-48 LETTUCE)
          (EATS TOMATO ARUGULA)
          (CRAVES PROSTATITIS-57 COD)
          (HARMONY LUBRICITY-60 NEPTUNE)
          (LOCALE SNICKERS GUANABARA)
          (CRAVES BOILS PEPPER-7)
          (EATS TOMATO TOFU)
          (EATS PISTACHIO HAM)
          (HARMONY ACHIEVEMENT-24 VENUS)
          (EATS PORK WONDERBREAD)
          (EATS SCALLION PORK)
          (EATS MELON PAPAYA)
          (CRAVES LONELINESS-50 SHRIMP)
          (LOCALE TOMATO-12 PENNSYLVANIA)
          (HARMONY ENTERTAINMENT-26 MERCURY)
          (CRAVES ANGINA-56 COD)
          (EATS HAMBURGER APPLE)
          (LOCALE APPLE GUANABARA)
          (CRAVES LONELINESS-115 SNICKERS)
          (LOCALE WURST GOIAS)
          (HARMONY SATISFACTION-23 VENUS)
          (CRAVES JEALOUSY POPOVER-3)
          (EATS ARUGULA LOBSTER)
          (EATS CANTELOPE MUFFIN)
          (EATS BAGUETTE FLOUNDER)
          (CRAVES ANGINA-38 MARZIPAN)
          (CRAVES EXCITEMENT-20 KALE)
          (EATS KALE LAMB)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS GUAVA HOTDOG)
          (LOCALE CUCUMBER QUEBEC)
          (LOCALE CHICKEN GUANABARA)
          (CRAVES AESTHETICS PEAR)
          (EATS CHERRY-28 CANTELOPE-30)
          (EATS MUFFIN ENDIVE-1)
          (EATS MUFFIN MUFFIN-6)
          (LOCALE ARUGULA GUANABARA)
          (CRAVES TRIUMPH APPLE)
          (EATS GUAVA-13 TOMATO-12)
          (EATS OKRA CHICKEN)
          (CRAVES JEALOUSY-44 BEEF)
          (LOCALE TUNA-29 OREGON)
          (EATS TOFU ONION)
          (EATS HAM PISTACHIO)
          (HARMONY LOVE-18 MERCURY)
          (CRAVES PROSTATITIS-42 BEEF)
          (EATS CHERRY-28 TUNA-29)
          (EATS CHICKEN TURKEY)
          (LOCALE LOBSTER PENNSYLVANIA)
          (CRAVES LUBRICITY HAMBURGER)
          (EATS YOGURT-11 TOFU-32)
          (EATS HOTDOG GUAVA)
          (EATS COD KALE)
          (LOCALE HAMBURGER-2 GUANABARA)
          (CRAVES DEPRESSION-123 TURKEY)
          (EATS SCALLION-14 BROCCOLI-10)
          (EATS WURST-8 COD-9)
          (CRAVES DREAD-125 BROCCOLI)
          (LOCALE HAM PENNSYLVANIA)
          (EATS GRAPEFRUIT OKRA)
          (CRAVES SCIATICA-33 TOMATO)
          (EATS BAGUETTE OKRA)
          (EATS ONION LOBSTER)
          (EATS PEPPER-7 PISTACHIO)
          (LOCALE TURKEY GUANABARA)
          (CRAVES LACERATION-52 SHRIMP)
          (LOCALE BACON-31 KENTUCKY)
          (HARMONY LEARNING-19 NEPTUNE)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (EATS MARZIPAN CHOCOLATE)
          (EATS MARZIPAN-16 COD-9)
          (EATS WONDERBREAD SWEETROLL)
          (EATS GRAPEFRUIT PORK)
          (EATS LEMON CUCUMBER)
          (LOCALE KALE KENTUCKY)
          (CRAVES LEARNING-19 CHOCOLATE)
          (ORBITS VENUS MERCURY)
          (LOCALE LEMON QUEBEC)
          (EATS ENDIVE MUTTON)
          (CRAVES UNDERSTANDING-61 RICE)
          (LOCALE PORK GOIAS)
          (EATS LETTUCE ONION)
          (CRAVES BOILS-49 LETTUCE)
          (EATS LAMB SCALLOP)
          (EATS GUAVA-13 YOGURT-11)
          (CRAVES JEALOUSY-46 LETTUCE)
          (EATS LETTUCE CHOCOLATE)
          (EATS LEMON SNICKERS)
          (CRAVES STIMULATION BACON-31)
          (EATS BROCCOLI PEA)
          (CRAVES ANGER CANTELOPE-30)
          (EATS MUFFIN PISTACHIO)
          (EATS HOTDOG TURKEY-4)
          (LOCALE MUTTON KENTUCKY)
          (EATS LOBSTER ONION)
          (EATS APPLE HAMBURGER)
          (EATS CHOCOLATE LETTUCE)
          (EATS ORANGE SWEETROLL)
          (EATS PEPPER-7 RICE)
          (EATS CHERRY MELON)
          (HARMONY EXPECTATION MERCURY)
          (HARMONY REST VENUS)
          (LOCALE ORANGE BOSNIA)
          (HARMONY UNDERSTANDING MERCURY)
          (CRAVES BOILS-118 PORK)
          (EATS MELON PORK-5)
          (LOCALE OKRA OREGON)
          (EATS WURST HAROSET)
          (EATS BACON COD)
          (CRAVES JEALOUSY-114 SNICKERS)
          (LOCALE TOMATO KENTUCKY)
          (LOCALE PORK-5 GOIAS)
          (LOCALE LAMB KENTUCKY)
          (LOCALE FLOUNDER GUANABARA)
          (EATS BROCCOLI-10 TOFU-32)
          (HARMONY STIMULATION-64 MERCURY)
          (LOCALE GUAVA-13 OREGON)
          (CRAVES ANXIETY-51 SHRIMP)
          (EATS POTATO SCALLION)
          (LOCALE PEA PENNSYLVANIA)
          (HARMONY LEARNING VENUS)
          (EATS ORANGE POTATO)
          (EATS COD-9 MARZIPAN-16)
          (EATS OKRA ENDIVE)
          (CRAVES GRIEF YOGURT-11)
          (CRAVES INTOXICATION-17 MELON)
          (LOCALE MUFFIN OREGON)
          (EATS TUNA-29 CHERRY-28)
          (EATS LOBSTER ARUGULA)
          (EATS TURKEY CHICKEN)
          (CRAVES REST ENDIVE-1)
          (EATS LOBSTER-15 MARZIPAN-16)
          (LOCALE POTATO GOIAS)
          (EATS BROCCOLI-10 TOMATO-12)
          (HARMONY INTOXICATION NEPTUNE)
          (EATS TURKEY-4 PISTACHIO)
          (EATS COD BACON)
          (ATTACKS GUANABARA OREGON)
          (EATS SHRIMP MUTTON)
          (EATS COD-9 YOGURT-11)
          (EATS HAM LOBSTER)
          (LOCALE BEEF PENNSYLVANIA)
          (CRAVES ACHIEVEMENT-24 BROCCOLI)
          (EATS PEAR POPOVER)
          (CRAVES ANGINA-113 LEMON)
          (EATS WONDERBREAD PORK)
          (EATS TOMATO-12 GUAVA-13)
          (EATS BACON-31 CANTELOPE-30)
          (CRAVES LOVE-18 ENDIVE)
          (EATS ONION TOFU)
          (ORBITS MERCURY NEPTUNE)
          (EATS HAROSET WURST)
          (HARMONY EMPATHY NEPTUNE)
          (EATS CHERRY FLOUNDER)
          (HARMONY EMPATHY-63 NEPTUNE)
          (LOCALE YOGURT BOSNIA)
          (EATS BACON-31 CHERRY-28)
          (EATS POPOVER PAPAYA)
          (EATS CUCUMBER BACON)
          (CRAVES SATISFACTION-23 LAMB)
          (LOCALE BROCCOLI PENNSYLVANIA)
          (EATS PAPAYA POPOVER)
          (ATTACKS OREGON KENTUCKY)
          (LOCALE TURKEY-4 GOIAS))
   (:GOAL (AND (CRAVES HANGOVER-59 SCALLION-14)
               (CRAVES SCIATICA-58 SCALLION-14))))

(DEFINE (PROBLEM STRIPS-MYSTY-27)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS FLOUNDER-2 BROCCOLI TOMATO MELON MARZIPAN PORK
             SWEETROLL GRAPEFRUIT TURKEY KALE HAMBURGER FLOUNDER OKRA HAROSET
             BAGUETTE CHOCOLATE PISTACHIO ORANGE COD POTATO BEEF ENDIVE PEA
             SCALLOP WONDERBREAD TOFU ONION LEMON PAPAYA SCALLION GUAVA PEAR
             WURST HAM CHICKEN LETTUCE YOGURT BACON CANTELOPE PEPPER LAMB
             CUCUMBER LOBSTER ARUGULA MUTTON RICE SHRIMP MUFFIN HOTDOG CHERRY
             POPOVER TUNA SNICKERS APPLE LEARNING TRIUMPH EXCITEMENT REST
             CURIOSITY EXPECTATION ACHIEVEMENT LOVE ENTERTAINMENT SATIETY
             STIMULATION INTOXICATION UNDERSTANDING EMPATHY AESTHETICS
             SATISFACTION LUBRICITY SATIETY-1 LOVE-4 EXCITEMENT-3
             INTOXICATION-8 EMPATHY-7 UNDERSTANDING-6 CURIOSITY-5 TRIUMPH-16
             REST-15 LEARNING-14 SATISFACTION-13 AESTHETICS-12
             ENTERTAINMENT-11 ACHIEVEMENT-10 EXPECTATION-9 STIMULATION-32
             LUBRICITY-31 EXPECTATION-30 INTOXICATION-29 HANGOVER GRIEF ANGER
             DEPRESSION PROSTATITIS BOILS JEALOUSY SCIATICA ANGINA LONELINESS
             ANXIETY LACERATION ABRASION DREAD JEALOUSY-27 ANGER-28
             ANXIETY-25 ANGINA-26 LACERATION-23 HANGOVER-24 SCIATICA-21
             BOILS-22 DEPRESSION-20 LONELINESS-19 ABRASION-17 DREAD-18
             PROSTATITIS-63 GRIEF-64 ANGINA-62 GRIEF-61 DEPRESSION-60
             ABRASION-59 SCIATICA-57 ANXIETY-58 PROSTATITIS-56 LONELINESS-55
             DREAD-53 ANGER-54 LACERATION-51 HANGOVER-52 JEALOUSY-50
             ABRASION-48 BOILS-49 LONELINESS-46 JEALOUSY-47 PROSTATITIS-45
             BOILS-44 DREAD-43 BAVARIA MORAVIA KENTUCKY MANITOBA EARTH VENUS
             VULCAN JUPITER)
   (:INIT (FOOD FLOUNDER-2)
          (FOOD BROCCOLI)
          (FOOD TOMATO)
          (FOOD MELON)
          (FOOD MARZIPAN)
          (FOOD PORK)
          (FOOD SWEETROLL)
          (FOOD GRAPEFRUIT)
          (FOOD TURKEY)
          (FOOD KALE)
          (FOOD HAMBURGER)
          (FOOD FLOUNDER)
          (FOOD OKRA)
          (FOOD HAROSET)
          (FOOD BAGUETTE)
          (FOOD CHOCOLATE)
          (FOOD PISTACHIO)
          (FOOD ORANGE)
          (FOOD COD)
          (FOOD POTATO)
          (FOOD BEEF)
          (FOOD ENDIVE)
          (FOOD PEA)
          (FOOD SCALLOP)
          (FOOD WONDERBREAD)
          (FOOD TOFU)
          (FOOD ONION)
          (FOOD LEMON)
          (FOOD PAPAYA)
          (FOOD SCALLION)
          (FOOD GUAVA)
          (FOOD PEAR)
          (FOOD WURST)
          (FOOD HAM)
          (FOOD CHICKEN)
          (FOOD LETTUCE)
          (FOOD YOGURT)
          (FOOD BACON)
          (FOOD CANTELOPE)
          (FOOD PEPPER)
          (FOOD LAMB)
          (FOOD CUCUMBER)
          (FOOD LOBSTER)
          (FOOD ARUGULA)
          (FOOD MUTTON)
          (FOOD RICE)
          (FOOD SHRIMP)
          (FOOD MUFFIN)
          (FOOD HOTDOG)
          (FOOD CHERRY)
          (FOOD POPOVER)
          (FOOD TUNA)
          (FOOD SNICKERS)
          (FOOD APPLE)
          (PLEASURE LEARNING)
          (PLEASURE TRIUMPH)
          (PLEASURE EXCITEMENT)
          (PLEASURE REST)
          (PLEASURE CURIOSITY)
          (PLEASURE EXPECTATION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LOVE)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE SATIETY)
          (PLEASURE STIMULATION)
          (PLEASURE INTOXICATION)
          (PLEASURE UNDERSTANDING)
          (PLEASURE EMPATHY)
          (PLEASURE AESTHETICS)
          (PLEASURE SATISFACTION)
          (PLEASURE LUBRICITY)
          (PLEASURE SATIETY-1)
          (PLEASURE LOVE-4)
          (PLEASURE EXCITEMENT-3)
          (PLEASURE INTOXICATION-8)
          (PLEASURE EMPATHY-7)
          (PLEASURE UNDERSTANDING-6)
          (PLEASURE CURIOSITY-5)
          (PLEASURE TRIUMPH-16)
          (PLEASURE REST-15)
          (PLEASURE LEARNING-14)
          (PLEASURE SATISFACTION-13)
          (PLEASURE AESTHETICS-12)
          (PLEASURE ENTERTAINMENT-11)
          (PLEASURE ACHIEVEMENT-10)
          (PLEASURE EXPECTATION-9)
          (PLEASURE STIMULATION-32)
          (PLEASURE LUBRICITY-31)
          (PLEASURE EXPECTATION-30)
          (PLEASURE INTOXICATION-29)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN ANGER)
          (PAIN DEPRESSION)
          (PAIN PROSTATITIS)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN SCIATICA)
          (PAIN ANGINA)
          (PAIN LONELINESS)
          (PAIN ANXIETY)
          (PAIN LACERATION)
          (PAIN ABRASION)
          (PAIN DREAD)
          (PAIN JEALOUSY-27)
          (PAIN ANGER-28)
          (PAIN ANXIETY-25)
          (PAIN ANGINA-26)
          (PAIN LACERATION-23)
          (PAIN HANGOVER-24)
          (PAIN SCIATICA-21)
          (PAIN BOILS-22)
          (PAIN DEPRESSION-20)
          (PAIN LONELINESS-19)
          (PAIN ABRASION-17)
          (PAIN DREAD-18)
          (PAIN PROSTATITIS-63)
          (PAIN GRIEF-64)
          (PAIN ANGINA-62)
          (PAIN GRIEF-61)
          (PAIN DEPRESSION-60)
          (PAIN ABRASION-59)
          (PAIN SCIATICA-57)
          (PAIN ANXIETY-58)
          (PAIN PROSTATITIS-56)
          (PAIN LONELINESS-55)
          (PAIN DREAD-53)
          (PAIN ANGER-54)
          (PAIN LACERATION-51)
          (PAIN HANGOVER-52)
          (PAIN JEALOUSY-50)
          (PAIN ABRASION-48)
          (PAIN BOILS-49)
          (PAIN LONELINESS-46)
          (PAIN JEALOUSY-47)
          (PAIN PROSTATITIS-45)
          (PAIN BOILS-44)
          (PAIN DREAD-43)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PROVINCE KENTUCKY)
          (PROVINCE MANITOBA)
          (PLANET EARTH)
          (PLANET VENUS)
          (PLANET VULCAN)
          (PLANET JUPITER)
          (EATS CHOCOLATE PAPAYA)
          (LOCALE YOGURT BAVARIA)
          (CRAVES JEALOUSY TURKEY)
          (EATS PAPAYA CHOCOLATE)
          (LOCALE SNICKERS KENTUCKY)
          (EATS HAM BACON)
          (EATS CANTELOPE HAM)
          (EATS RICE SNICKERS)
          (EATS HAM CANTELOPE)
          (LOCALE KALE MANITOBA)
          (CRAVES GRIEF BROCCOLI)
          (LOCALE BROCCOLI BAVARIA)
          (CRAVES ABRASION-17 TOFU)
          (CRAVES ACHIEVEMENT-10 RICE)
          (EATS TOFU SCALLION)
          (HARMONY LEARNING JUPITER)
          (CRAVES LACERATION-23 BEEF)
          (EATS PEA CANTELOPE)
          (EATS MUFFIN CUCUMBER)
          (EATS SCALLION TOFU)
          (HARMONY LOVE-4 JUPITER)
          (EATS LOBSTER APPLE)
          (LOCALE PISTACHIO BAVARIA)
          (EATS HOTDOG SHRIMP)
          (EATS TURKEY TOMATO)
          (EATS YOGURT MUTTON)
          (EATS BACON HAM)
          (EATS TUNA SNICKERS)
          (EATS CHICKEN ORANGE)
          (CRAVES DEPRESSION TOMATO)
          (CRAVES STIMULATION ORANGE)
          (HARMONY EXPECTATION-30 JUPITER)
          (LOCALE PEPPER BAVARIA)
          (EATS WURST BACON)
          (HARMONY SATISFACTION VULCAN)
          (EATS HAROSET LETTUCE)
          (CRAVES ABRASION-48 MUFFIN)
          (CRAVES CURIOSITY-5 LETTUCE)
          (CRAVES ENTERTAINMENT CHOCOLATE)
          (CRAVES PROSTATITIS-45 CHERRY)
          (ORBITS VULCAN JUPITER)
          (CRAVES UNDERSTANDING BEEF)
          (HARMONY TRIUMPH-16 VULCAN)
          (EATS MUTTON SHRIMP)
          (CRAVES ANXIETY-58 LAMB)
          (CRAVES ABRASION HAROSET)
          (EATS CHICKEN HAMBURGER)
          (CRAVES INTOXICATION-8 GUAVA)
          (CRAVES SCIATICA TURKEY)
          (CRAVES TRIUMPH MELON)
          (EATS YOGURT POTATO)
          (EATS COD BACON)
          (EATS PEAR LEMON)
          (LOCALE LOBSTER BAVARIA)
          (EATS TUNA MUFFIN)
          (EATS LAMB LOBSTER)
          (LOCALE CANTELOPE BAVARIA)
          (CRAVES PROSTATITIS MELON)
          (EATS MUTTON MUFFIN)
          (HARMONY LUBRICITY JUPITER)
          (EATS SCALLOP WURST)
          (HARMONY INTOXICATION-29 VENUS)
          (LOCALE WONDERBREAD MANITOBA)
          (LOCALE TUNA BAVARIA)
          (CRAVES EXCITEMENT-3 SCALLION)
          (LOCALE COD BAVARIA)
          (EATS SWEETROLL FLOUNDER-2)
          (CRAVES JEALOUSY-50 SHRIMP)
          (EATS YOGURT WONDERBREAD)
          (EATS HAMBURGER GUAVA)
          (CRAVES HANGOVER-24 BEEF)
          (EATS MELON SWEETROLL)
          (EATS TURKEY PORK)
          (LOCALE CHOCOLATE BAVARIA)
          (CRAVES SCIATICA-57 LAMB)
          (EATS CHOCOLATE ORANGE)
          (EATS TUNA RICE)
          (EATS CHERRY ARUGULA)
          (LOCALE SCALLOP BAVARIA)
          (EATS YOGURT PISTACHIO)
          (CRAVES ANGINA HAMBURGER)
          (CRAVES REST-15 CANTELOPE)
          (LOCALE TOMATO BAVARIA)
          (EATS ONION PEPPER)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS MUFFIN TUNA)
          (CRAVES LONELINESS-46 HOTDOG)
          (EATS TOFU CHICKEN)
          (HARMONY CURIOSITY VENUS)
          (EATS POPOVER SHRIMP)
          (EATS PISTACHIO CHICKEN)
          (LOCALE TOFU BAVARIA)
          (EATS HOTDOG LOBSTER)
          (LOCALE MARZIPAN BAVARIA)
          (EATS PAPAYA FLOUNDER)
          (EATS PORK FLOUNDER-2)
          (ORBITS VENUS VULCAN)
          (EATS FLOUNDER BEEF)
          (CRAVES LEARNING BROCCOLI)
          (EATS FLOUNDER-2 PORK)
          (EATS POPOVER APPLE)
          (LOCALE POTATO BAVARIA)
          (HARMONY REST VULCAN)
          (CRAVES AESTHETICS WONDERBREAD)
          (CRAVES GRIEF-64 LEMON)
          (EATS SNICKERS RICE)
          (HARMONY EXPECTATION JUPITER)
          (HARMONY LEARNING-14 JUPITER)
          (EATS RICE MUFFIN)
          (EATS ONION SCALLION)
          (EATS TOMATO TURKEY)
          (EATS GUAVA YOGURT)
          (CRAVES LOVE BAGUETTE)
          (HARMONY EXCITEMENT-3 VULCAN)
          (CRAVES TRIUMPH-16 BACON)
          (CRAVES ANGINA-62 GUAVA)
          (LOCALE MELON BAVARIA)
          (EATS KALE BROCCOLI)
          (CRAVES SCIATICA-21 ENDIVE)
          (HARMONY EXCITEMENT JUPITER)
          (EATS ONION LEMON)
          (LOCALE MUFFIN BAVARIA)
          (CRAVES JEALOUSY-47 HOTDOG)
          (LOCALE ENDIVE KENTUCKY)
          (CRAVES HANGOVER-52 MUTTON)
          (EATS CANTELOPE SCALLION)
          (EATS OKRA SCALLOP)
          (EATS PEPPER ONION)
          (EATS WONDERBREAD YOGURT)
          (LOCALE GRAPEFRUIT MORAVIA)
          (EATS MARZIPAN TOMATO)
          (EATS KALE GUAVA)
          (CRAVES ENTERTAINMENT-11 LOBSTER)
          (EATS MARZIPAN PORK)
          (EATS LETTUCE PEPPER)
          (EATS HOTDOG CUCUMBER)
          (CRAVES CURIOSITY TURKEY)
          (EATS COD OKRA)
          (HARMONY AESTHETICS-12 VULCAN)
          (CRAVES EMPATHY SCALLOP)
          (EATS MUTTON YOGURT)
          (EATS BEEF FLOUNDER)
          (LOCALE BAGUETTE BAVARIA)
          (LOCALE CHICKEN MANITOBA)
          (CRAVES EMPATHY-7 PEAR)
          (CRAVES HANGOVER BROCCOLI)
          (CRAVES LOVE-4 PAPAYA)
          (EATS ARUGULA MUFFIN)
          (EATS PISTACHIO YOGURT)
          (EATS BAGUETTE SCALLION)
          (CRAVES ANGER-54 ARUGULA)
          (HARMONY INTOXICATION VULCAN)
          (EATS MUFFIN MUTTON)
          (EATS PEAR ENDIVE)
          (EATS OKRA BAGUETTE)
          (EATS LEMON PEAR)
          (HARMONY UNDERSTANDING VULCAN)
          (EATS SWEETROLL KALE)
          (LOCALE SCALLION BAVARIA)
          (CRAVES PROSTATITIS-63 LEMON)
          (HARMONY REST-15 VULCAN)
          (EATS SHRIMP MUTTON)
          (LOCALE APPLE BAVARIA)
          (EATS BROCCOLI PORK)
          (EATS ORANGE CHICKEN)
          (HARMONY EMPATHY VENUS)
          (LOCALE LEMON MANITOBA)
          (EATS ORANGE BEEF)
          (EATS BACON WURST)
          (EATS PEA ONION)
          (CRAVES ANXIETY FLOUNDER)
          (EATS GRAPEFRUIT TOMATO)
          (HARMONY ENTERTAINMENT-11 VENUS)
          (EATS CUCUMBER HOTDOG)
          (LOCALE CHERRY BAVARIA)
          (CRAVES BOILS-49 MUFFIN)
          (LOCALE HOTDOG BAVARIA)
          (LOCALE ARUGULA BAVARIA)
          (EATS BACON COD)
          (EATS SHRIMP HOTDOG)
          (EATS BAGUETTE BACON)
          (EATS APPLE SHRIMP)
          (CRAVES JEALOUSY-27 PISTACHIO)
          (HARMONY SATIETY-1 JUPITER)
          (EATS SCALLION CANTELOPE)
          (EATS SCALLION ONION)
          (CRAVES BOILS-44 POPOVER)
          (CRAVES LONELINESS-55 LOBSTER)
          (EATS LEMON ONION)
          (EATS GRAPEFRUIT MELON)
          (LOCALE ORANGE BAVARIA)
          (EATS TURKEY GRAPEFRUIT)
          (LOCALE PEAR MORAVIA)
          (LOCALE MUTTON BAVARIA)
          (LOCALE HAM BAVARIA)
          (CRAVES AESTHETICS-12 CUCUMBER)
          (EATS SCALLOP OKRA)
          (EATS CHICKEN TOFU)
          (CRAVES DREAD-43 TUNA)
          (CRAVES SATISFACTION TOFU)
          (EATS CHICKEN PISTACHIO)
          (CRAVES REST GRAPEFRUIT)
          (CRAVES SATISFACTION-13 LAMB)
          (LOCALE TURKEY BAVARIA)
          (EATS LETTUCE WONDERBREAD)
          (CRAVES LUBRICITY-31 POPOVER)
          (EATS LOBSTER LAMB)
          (EATS TURKEY KALE)
          (LOCALE FLOUNDER-2 KENTUCKY)
          (EATS HOTDOG CHERRY)
          (LOCALE BEEF MORAVIA)
          (LOCALE PAPAYA KENTUCKY)
          (EATS WURST GUAVA)
          (CRAVES ANGINA-26 POTATO)
          (HARMONY ACHIEVEMENT JUPITER)
          (CRAVES UNDERSTANDING-6 HAM)
          (HARMONY EMPATHY-7 VENUS)
          (EATS CHICKEN SCALLOP)
          (EATS ONION PEA)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES INTOXICATION COD)
          (EATS KALE TURKEY)
          (CRAVES LONELINESS FLOUNDER)
          (EATS PORK TURKEY)
          (EATS SHRIMP POPOVER)
          (HARMONY UNDERSTANDING-6 VULCAN)
          (EATS TOMATO GRAPEFRUIT)
          (CRAVES LUBRICITY ONION)
          (CRAVES DEPRESSION-20 PEA)
          (EATS APPLE POPOVER)
          (LOCALE ONION BAVARIA)
          (EATS ORANGE CHOCOLATE)
          (LOCALE CUCUMBER BAVARIA)
          (EATS BROCCOLI KALE)
          (EATS APPLE LOBSTER)
          (LOCALE OKRA MORAVIA)
          (CRAVES EXPECTATION-9 HOTDOG)
          (LOCALE FLOUNDER BAVARIA)
          (EATS TOMATO MARZIPAN)
          (CRAVES BOILS GRAPEFRUIT)
          (CRAVES LEARNING-14 PEPPER)
          (CRAVES GRIEF-61 CHICKEN)
          (EATS SWEETROLL MELON)
          (CRAVES ANGER TOMATO)
          (EATS LOBSTER HOTDOG)
          (CRAVES SATIETY PISTACHIO)
          (EATS SHRIMP APPLE)
          (EATS PORK MARZIPAN)
          (LOCALE WURST BAVARIA)
          (LOCALE GUAVA BAVARIA)
          (CRAVES ANXIETY-25 POTATO)
          (EATS SHRIMP LAMB)
          (CRAVES ACHIEVEMENT FLOUNDER)
          (EATS ORANGE YOGURT)
          (CRAVES DREAD-53 ARUGULA)
          (EATS BAGUETTE OKRA)
          (HARMONY AESTHETICS JUPITER)
          (EATS YOGURT ORANGE)
          (LOCALE BACON MORAVIA)
          (EATS POTATO ENDIVE)
          (LOCALE LETTUCE BAVARIA)
          (LOCALE RICE BAVARIA)
          (EATS GUAVA KALE)
          (EATS CANTELOPE PEA)
          (EATS WURST SCALLOP)
          (EATS WONDERBREAD LETTUCE)
          (CRAVES DREAD CHOCOLATE)
          (EATS BEEF ORANGE)
          (EATS PEPPER LETTUCE)
          (EATS LAMB SHRIMP)
          (EATS CUCUMBER MUFFIN)
          (HARMONY LOVE VENUS)
          (CRAVES STIMULATION-32 CHERRY)
          (EATS LETTUCE HAROSET)
          (EATS PORK BROCCOLI)
          (EATS HAROSET PEAR)
          (CRAVES SATIETY-1 LEMON)
          (LOCALE PORK BAVARIA)
          (HARMONY CURIOSITY-5 VULCAN)
          (EATS FLOUNDER-2 SWEETROLL)
          (LOCALE SHRIMP BAVARIA)
          (EATS POTATO YOGURT)
          (CRAVES EXCITEMENT SWEETROLL)
          (EATS MUFFIN ARUGULA)
          (HARMONY SATISFACTION-13 VULCAN)
          (EATS CHERRY HOTDOG)
          (EATS ENDIVE POTATO)
          (HARMONY STIMULATION VENUS)
          (ATTACKS KENTUCKY MANITOBA)
          (HARMONY ENTERTAINMENT VENUS)
          (EATS SCALLOP CHICKEN)
          (EATS HAMBURGER CHICKEN)
          (CRAVES LONELINESS-19 SCALLOP)
          (ATTACKS MORAVIA KENTUCKY)
          (CRAVES LACERATION OKRA)
          (CRAVES DEPRESSION-60 YOGURT)
          (CRAVES EXPECTATION-30 TUNA)
          (HARMONY LUBRICITY-31 VENUS)
          (EATS SNICKERS TUNA)
          (HARMONY STIMULATION-32 VENUS)
          (EATS KALE SWEETROLL)
          (LOCALE PEA BAVARIA)
          (EATS ARUGULA CHERRY)
          (EATS MUFFIN RICE)
          (EATS RICE TUNA)
          (EATS PAPAYA LEMON)
          (EATS FLOUNDER PAPAYA)
          (EATS CHERRY SNICKERS)
          (LOCALE HAROSET BAVARIA)
          (CRAVES DREAD-18 TOFU)
          (HARMONY ACHIEVEMENT-10 VULCAN)
          (EATS MELON GRAPEFRUIT)
          (HARMONY EXPECTATION-9 VULCAN)
          (CRAVES LACERATION-51 MUTTON)
          (EATS ENDIVE PEAR)
          (EATS GRAPEFRUIT TURKEY)
          (ORBITS EARTH VENUS)
          (EATS PEAR HAROSET)
          (HARMONY TRIUMPH VULCAN)
          (EATS GUAVA WURST)
          (EATS SCALLION BAGUETTE)
          (EATS CHICKEN BEEF)
          (EATS BEEF CHICKEN)
          (LOCALE HAMBURGER BAVARIA)
          (CRAVES ABRASION-59 CANTELOPE)
          (CRAVES INTOXICATION-29 APPLE)
          (CRAVES ANGER-28 PISTACHIO)
          (EATS GUAVA HAMBURGER)
          (EATS OKRA COD)
          (LOCALE LAMB MANITOBA)
          (CRAVES BOILS-22 ENDIVE)
          (EATS SNICKERS CHERRY)
          (EATS LEMON PAPAYA)
          (HARMONY INTOXICATION-8 VULCAN)
          (EATS YOGURT GUAVA)
          (HARMONY SATIETY JUPITER)
          (LOCALE POPOVER MANITOBA)
          (CRAVES EXPECTATION KALE)
          (EATS BACON BAGUETTE)
          (CRAVES PROSTATITIS-56 CUCUMBER))
   (:GOAL (AND (CRAVES JEALOUSY-47 BACON)
               (CRAVES ANGINA-26 YOGURT))))

(DEFINE (PROBLEM STRIPS-MYSTY-28)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS BACON-19 GUAVA-20 PEPPER-21 ORANGE-22 GRAPEFRUIT-23
             SCALLION-24 PAPAYA-25 CHOCOLATE-26 BROCCOLI-27 CUCUMBER-28
             YOGURT-29 APPLE-30 HAM-31 KALE-32 MUFFIN-9 CANTELOPE-10
             MUTTON-11 WURST-12 PORK-16 LEMON-15 SHRIMP-14 WONDERBREAD-13
             HAMBURGER-5 TOMATO-6 SCALLOP-7 LAMB-8 HAROSET-3 HOTDOG-4
             FLOUNDER-1 POTATO-2 CHERRY APPLE SWEETROLL LETTUCE LOBSTER
             SCALLION PISTACHIO OKRA HAMBURGER CHICKEN POPOVER CUCUMBER
             GRAPEFRUIT MELON TOFU LEMON PEA BEEF BROCCOLI SHRIMP SCALLOP HOTDOG
             ARUGULA HAROSET LAMB KALE HAM PAPAYA ENDIVE RICE WONDERBREAD
             MUTTON TUNA SNICKERS GUAVA CANTELOPE POTATO PORK BACON
             FLOUNDER YOGURT MARZIPAN ORANGE ONION BAGUETTE PEPPER TURKEY
             CHOCOLATE COD PEAR MUFFIN TOMATO WURST CURIOSITY EXPECTATION
             SATIETY INTOXICATION EXCITEMENT LEARNING REST LOVE
             STIMULATION AESTHETICS SATISFACTION TRIUMPH UNDERSTANDING
             EMPATHY ACHIEVEMENT LUBRICITY ENTERTAINMENT
             UNDERSTANDING-18 SATIETY-17 EMPATHY-64 CURIOSITY-63 TRIUMPH-62
             INTOXICATION-61 LOVE-60 LEARNING-59 EXCITEMENT-58 REST-57
             STIMULATION-56 ACHIEVEMENT-55 ENTERTAINMENT-54 LUBRICITY-53
             AESTHETICS-52 EXPECTATION-51 GRIEF LACERATION PROSTATITIS
             DEPRESSION LONELINESS HANGOVER ABRASION DREAD SCIATICA BOILS
             ANGINA ANXIETY DEPRESSION-50 JEALOUSY ANGER JEALOUSY-49
             BOILS-48 ANXIETY-44 HANGOVER-45 LACERATION-46 ANGINA-47
             SCIATICA-42 ANGER-43 DREAD-39 ABRASION-40 LONELINESS-41
             PROSTATITIS-38 DREAD-35 SCIATICA-36 GRIEF-37 GRIEF-34
             LONELINESS-126 HANGOVER-127 PROSTATITIS-128 JEALOUSY-33 BOILS-123
             DEPRESSION-124 ABRASION-125 LACERATION-119 ANGER-120 ANGINA-121
             ANXIETY-122 SCIATICA-118 ANXIETY-114 BOILS-115 LACERATION-116
             ABRASION-117 GRIEF-113 DEPRESSION-109 HANGOVER-110
             PROSTATITIS-111 JEALOUSY-112 ANGINA-105 DREAD-106 ANGER-107
             LONELINESS-108 HANGOVER-101 SCIATICA-102 DREAD-103 PROSTATITIS-104
             ABRASION-98 GRIEF-99 BOILS-100 ANGINA-94 ANXIETY-95
             LONELINESS-96 DEPRESSION-97 LACERATION-93 ANGER-92 JEALOUSY-91
             ANGINA-87 SCIATICA-88 ANGER-89 GRIEF-90 BOILS-83 LACERATION-84
             LONELINESS-85 HANGOVER-86 ABRASION-81 ANXIETY-82 DREAD-79
             DEPRESSION-80 JEALOUSY-78 BOILS-75 HANGOVER-76 PROSTATITIS-77
             ABRASION-73 DREAD-74 SCIATICA-71 LONELINESS-72 GRIEF-70
             ANGINA-69 PROSTATITIS-67 JEALOUSY-68 ANGER-256 ANXIETY-65
             DEPRESSION-66 JEALOUSY-253 LACERATION-254 LACERATION-255
             ANXIETY-250 GRIEF-251 HANGOVER-252 ANGER-249 PROSTATITIS-247
             SCIATICA-248 LONELINESS-244 ANGINA-245 DEPRESSION-246 DREAD-243
             BOILS-241 ABRASION-242 PROSTATITIS-238 DEPRESSION-239
             GRIEF-240 JEALOUSY-236 ABRASION-237 LACERATION-235
             ANXIETY-234 BOILS-233 ANGINA-231 HANGOVER-232 LONELINESS-227
             SCIATICA-228 ANGER-229 DREAD-230 GRIEF-225 ANXIETY-226
             DEPRESSION-224 HANGOVER-223 LONELINESS-222 DREAD-221 ANGINA-219
             ANGER-220 BOILS-216 LACERATION-217 JEALOUSY-218 SCIATICA-214
             ABRASION-215 LACERATION-212 PROSTATITIS-213 ABRASION-208
             PROSTATITIS-209 GRIEF-210 HANGOVER-211 DREAD-204 SCIATICA-205
             LONELINESS-206 DEPRESSION-207 ANXIETY-203 BOILS-201 JEALOUSY-202
             PROSTATITIS-197 DEPRESSION-198 ANGINA-199 ANGER-200 ABRASION-194
             LONELINESS-195 HANGOVER-196 ANXIETY-192 GRIEF-193 DREAD-191
             LACERATION-189 ANGER-190 SCIATICA-188 ANGINA-185 BOILS-186
             JEALOUSY-187 DEPRESSION-182 PROSTATITIS-183 ANXIETY-184
             HANGOVER-180 ANGINA-181 GRIEF-178 ANGER-179 SCIATICA-176
             BOILS-177 LONELINESS-173 JEALOUSY-174 DREAD-175 ANGINA-169
             ANGER-170 LACERATION-171 ABRASION-172 SCIATICA-167
             ABRASION-168 HANGOVER-163 PROSTATITIS-164 GRIEF-165
             LONELINESS-166 BOILS-162 BAVARIA OREGON JUPITER NEPTUNE EARTH MARS)
   (:INIT (FOOD BACON-19)
          (FOOD GUAVA-20)
          (FOOD PEPPER-21)
          (FOOD ORANGE-22)
          (FOOD GRAPEFRUIT-23)
          (FOOD SCALLION-24)
          (FOOD PAPAYA-25)
          (FOOD CHOCOLATE-26)
          (FOOD BROCCOLI-27)
          (FOOD CUCUMBER-28)
          (FOOD YOGURT-29)
          (FOOD APPLE-30)
          (FOOD HAM-31)
          (FOOD KALE-32)
          (FOOD MUFFIN-9)
          (FOOD CANTELOPE-10)
          (FOOD MUTTON-11)
          (FOOD WURST-12)
          (FOOD PORK-16)
          (FOOD LEMON-15)
          (FOOD SHRIMP-14)
          (FOOD WONDERBREAD-13)
          (FOOD HAMBURGER-5)
          (FOOD TOMATO-6)
          (FOOD SCALLOP-7)
          (FOOD LAMB-8)
          (FOOD HAROSET-3)
          (FOOD HOTDOG-4)
          (FOOD FLOUNDER-1)
          (FOOD POTATO-2)
          (FOOD CHERRY)
          (FOOD APPLE)
          (FOOD SWEETROLL)
          (FOOD LETTUCE)
          (FOOD LOBSTER)
          (FOOD SCALLION)
          (FOOD PISTACHIO)
          (FOOD OKRA)
          (FOOD HAMBURGER)
          (FOOD CHICKEN)
          (FOOD POPOVER)
          (FOOD CUCUMBER)
          (FOOD GRAPEFRUIT)
          (FOOD MELON)
          (FOOD TOFU)
          (FOOD LEMON)
          (FOOD PEA)
          (FOOD BEEF)
          (FOOD BROCCOLI)
          (FOOD SHRIMP)
          (FOOD SCALLOP)
          (FOOD HOTDOG)
          (FOOD ARUGULA)
          (FOOD HAROSET)
          (FOOD LAMB)
          (FOOD KALE)
          (FOOD HAM)
          (FOOD PAPAYA)
          (FOOD ENDIVE)
          (FOOD RICE)
          (FOOD WONDERBREAD)
          (FOOD MUTTON)
          (FOOD TUNA)
          (FOOD SNICKERS)
          (FOOD GUAVA)
          (FOOD CANTELOPE)
          (FOOD POTATO)
          (FOOD PORK)
          (FOOD BACON)
          (FOOD FLOUNDER)
          (FOOD YOGURT)
          (FOOD MARZIPAN)
          (FOOD ORANGE)
          (FOOD ONION)
          (FOOD BAGUETTE)
          (FOOD PEPPER)
          (FOOD TURKEY)
          (FOOD CHOCOLATE)
          (FOOD COD)
          (FOOD PEAR)
          (FOOD MUFFIN)
          (FOOD TOMATO)
          (FOOD WURST)
          (PLEASURE CURIOSITY)
          (PLEASURE EXPECTATION)
          (PLEASURE SATIETY)
          (PLEASURE INTOXICATION)
          (PLEASURE EXCITEMENT)
          (PLEASURE LEARNING)
          (PLEASURE REST)
          (PLEASURE LOVE)
          (PLEASURE STIMULATION)
          (PLEASURE AESTHETICS)
          (PLEASURE SATISFACTION)
          (PLEASURE TRIUMPH)
          (PLEASURE UNDERSTANDING)
          (PLEASURE EMPATHY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE UNDERSTANDING-18)
          (PLEASURE SATIETY-17)
          (PLEASURE EMPATHY-64)
          (PLEASURE CURIOSITY-63)
          (PLEASURE TRIUMPH-62)
          (PLEASURE INTOXICATION-61)
          (PLEASURE LOVE-60)
          (PLEASURE LEARNING-59)
          (PLEASURE EXCITEMENT-58)
          (PLEASURE REST-57)
          (PLEASURE STIMULATION-56)
          (PLEASURE ACHIEVEMENT-55)
          (PLEASURE ENTERTAINMENT-54)
          (PLEASURE LUBRICITY-53)
          (PLEASURE AESTHETICS-52)
          (PLEASURE EXPECTATION-51)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN PROSTATITIS)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN HANGOVER)
          (PAIN ABRASION)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN BOILS)
          (PAIN ANGINA)
          (PAIN ANXIETY)
          (PAIN DEPRESSION-50)
          (PAIN JEALOUSY)
          (PAIN ANGER)
          (PAIN JEALOUSY-49)
          (PAIN BOILS-48)
          (PAIN ANXIETY-44)
          (PAIN HANGOVER-45)
          (PAIN LACERATION-46)
          (PAIN ANGINA-47)
          (PAIN SCIATICA-42)
          (PAIN ANGER-43)
          (PAIN DREAD-39)
          (PAIN ABRASION-40)
          (PAIN LONELINESS-41)
          (PAIN PROSTATITIS-38)
          (PAIN DREAD-35)
          (PAIN SCIATICA-36)
          (PAIN GRIEF-37)
          (PAIN GRIEF-34)
          (PAIN LONELINESS-126)
          (PAIN HANGOVER-127)
          (PAIN PROSTATITIS-128)
          (PAIN JEALOUSY-33)
          (PAIN BOILS-123)
          (PAIN DEPRESSION-124)
          (PAIN ABRASION-125)
          (PAIN LACERATION-119)
          (PAIN ANGER-120)
          (PAIN ANGINA-121)
          (PAIN ANXIETY-122)
          (PAIN SCIATICA-118)
          (PAIN ANXIETY-114)
          (PAIN BOILS-115)
          (PAIN LACERATION-116)
          (PAIN ABRASION-117)
          (PAIN GRIEF-113)
          (PAIN DEPRESSION-109)
          (PAIN HANGOVER-110)
          (PAIN PROSTATITIS-111)
          (PAIN JEALOUSY-112)
          (PAIN ANGINA-105)
          (PAIN DREAD-106)
          (PAIN ANGER-107)
          (PAIN LONELINESS-108)
          (PAIN HANGOVER-101)
          (PAIN SCIATICA-102)
          (PAIN DREAD-103)
          (PAIN PROSTATITIS-104)
          (PAIN ABRASION-98)
          (PAIN GRIEF-99)
          (PAIN BOILS-100)
          (PAIN ANGINA-94)
          (PAIN ANXIETY-95)
          (PAIN LONELINESS-96)
          (PAIN DEPRESSION-97)
          (PAIN LACERATION-93)
          (PAIN ANGER-92)
          (PAIN JEALOUSY-91)
          (PAIN ANGINA-87)
          (PAIN SCIATICA-88)
          (PAIN ANGER-89)
          (PAIN GRIEF-90)
          (PAIN BOILS-83)
          (PAIN LACERATION-84)
          (PAIN LONELINESS-85)
          (PAIN HANGOVER-86)
          (PAIN ABRASION-81)
          (PAIN ANXIETY-82)
          (PAIN DREAD-79)
          (PAIN DEPRESSION-80)
          (PAIN JEALOUSY-78)
          (PAIN BOILS-75)
          (PAIN HANGOVER-76)
          (PAIN PROSTATITIS-77)
          (PAIN ABRASION-73)
          (PAIN DREAD-74)
          (PAIN SCIATICA-71)
          (PAIN LONELINESS-72)
          (PAIN GRIEF-70)
          (PAIN ANGINA-69)
          (PAIN PROSTATITIS-67)
          (PAIN JEALOUSY-68)
          (PAIN ANGER-256)
          (PAIN ANXIETY-65)
          (PAIN DEPRESSION-66)
          (PAIN JEALOUSY-253)
          (PAIN LACERATION-254)
          (PAIN LACERATION-255)
          (PAIN ANXIETY-250)
          (PAIN GRIEF-251)
          (PAIN HANGOVER-252)
          (PAIN ANGER-249)
          (PAIN PROSTATITIS-247)
          (PAIN SCIATICA-248)
          (PAIN LONELINESS-244)
          (PAIN ANGINA-245)
          (PAIN DEPRESSION-246)
          (PAIN DREAD-243)
          (PAIN BOILS-241)
          (PAIN ABRASION-242)
          (PAIN PROSTATITIS-238)
          (PAIN DEPRESSION-239)
          (PAIN GRIEF-240)
          (PAIN JEALOUSY-236)
          (PAIN ABRASION-237)
          (PAIN LACERATION-235)
          (PAIN ANXIETY-234)
          (PAIN BOILS-233)
          (PAIN ANGINA-231)
          (PAIN HANGOVER-232)
          (PAIN LONELINESS-227)
          (PAIN SCIATICA-228)
          (PAIN ANGER-229)
          (PAIN DREAD-230)
          (PAIN GRIEF-225)
          (PAIN ANXIETY-226)
          (PAIN DEPRESSION-224)
          (PAIN HANGOVER-223)
          (PAIN LONELINESS-222)
          (PAIN DREAD-221)
          (PAIN ANGINA-219)
          (PAIN ANGER-220)
          (PAIN BOILS-216)
          (PAIN LACERATION-217)
          (PAIN JEALOUSY-218)
          (PAIN SCIATICA-214)
          (PAIN ABRASION-215)
          (PAIN LACERATION-212)
          (PAIN PROSTATITIS-213)
          (PAIN ABRASION-208)
          (PAIN PROSTATITIS-209)
          (PAIN GRIEF-210)
          (PAIN HANGOVER-211)
          (PAIN DREAD-204)
          (PAIN SCIATICA-205)
          (PAIN LONELINESS-206)
          (PAIN DEPRESSION-207)
          (PAIN ANXIETY-203)
          (PAIN BOILS-201)
          (PAIN JEALOUSY-202)
          (PAIN PROSTATITIS-197)
          (PAIN DEPRESSION-198)
          (PAIN ANGINA-199)
          (PAIN ANGER-200)
          (PAIN ABRASION-194)
          (PAIN LONELINESS-195)
          (PAIN HANGOVER-196)
          (PAIN ANXIETY-192)
          (PAIN GRIEF-193)
          (PAIN DREAD-191)
          (PAIN LACERATION-189)
          (PAIN ANGER-190)
          (PAIN SCIATICA-188)
          (PAIN ANGINA-185)
          (PAIN BOILS-186)
          (PAIN JEALOUSY-187)
          (PAIN DEPRESSION-182)
          (PAIN PROSTATITIS-183)
          (PAIN ANXIETY-184)
          (PAIN HANGOVER-180)
          (PAIN ANGINA-181)
          (PAIN GRIEF-178)
          (PAIN ANGER-179)
          (PAIN SCIATICA-176)
          (PAIN BOILS-177)
          (PAIN LONELINESS-173)
          (PAIN JEALOUSY-174)
          (PAIN DREAD-175)
          (PAIN ANGINA-169)
          (PAIN ANGER-170)
          (PAIN LACERATION-171)
          (PAIN ABRASION-172)
          (PAIN SCIATICA-167)
          (PAIN ABRASION-168)
          (PAIN HANGOVER-163)
          (PAIN PROSTATITIS-164)
          (PAIN GRIEF-165)
          (PAIN LONELINESS-166)
          (PAIN BOILS-162)
          (PROVINCE BAVARIA)
          (PROVINCE OREGON)
          (PLANET JUPITER)
          (PLANET NEPTUNE)
          (PLANET EARTH)
          (PLANET MARS)
          (CRAVES ANGER-43 CUCUMBER-28)
          (CRAVES DEPRESSION-97 SCALLOP-7)
          (LOCALE CHOCOLATE-26 BAVARIA)
          (EATS COD YOGURT)
          (HARMONY SATIETY-17 EARTH)
          (EATS CHOCOLATE ENDIVE)
          (EATS PEAR LOBSTER)
          (CRAVES LONELINESS-173 COD)
          (CRAVES JEALOUSY-218 WONDERBREAD)
          (LOCALE BROCCOLI BAVARIA)
          (HARMONY INTOXICATION-61 EARTH)
          (CRAVES LACERATION-119 MUTTON-11)
          (EATS GUAVA PEA)
          (EATS YOGURT SNICKERS)
          (CRAVES LACERATION-255 POPOVER)
          (LOCALE WURST BAVARIA)
          (CRAVES BOILS-123 CANTELOPE-10)
          (CRAVES JEALOUSY-68 HAMBURGER)
          (CRAVES HANGOVER-223 HAM)
          (LOCALE POTATO-2 BAVARIA)
          (CRAVES LACERATION-116 PORK-16)
          (CRAVES ABRASION-172 PEAR)
          (EATS WONDERBREAD LETTUCE)
          (CRAVES ANXIETY-192 FLOUNDER)
          (EATS FLOUNDER ONION)
          (EATS BROCCOLI CHERRY)
          (LOCALE ORANGE-22 OREGON)
          (CRAVES ANGINA-94 SCALLOP-7)
          (EATS MUFFIN-9 GUAVA-20)
          (EATS MUTTON HOTDOG)
          (EATS HAMBURGER-5 BAGUETTE)
          (CRAVES BOILS-201 POTATO)
          (LOCALE ENDIVE OREGON)
          (EATS MELON SCALLOP-7)
          (EATS MUTTON POTATO)
          (EATS MUTTON-11 ORANGE-22)
          (CRAVES GRIEF-240 BEEF)
          (LOCALE LEMON BAVARIA)
          (EATS MARZIPAN PORK)
          (CRAVES DREAD-79 APPLE)
          (CRAVES ANGER-249 GRAPEFRUIT)
          (EATS TOMATO PEPPER)
          (EATS POTATO-2 POTATO)
          (EATS CANTELOPE-10 KALE-32)
          (CRAVES ANGER-200 PORK)
          (LOCALE SWEETROLL BAVARIA)
          (CRAVES LACERATION-46 BROCCOLI-27)
          (HARMONY ENTERTAINMENT-54 EARTH)
          (CRAVES PROSTATITIS-77 LETTUCE)
          (CRAVES ANGINA-169 PEAR)
          (LOCALE OKRA OREGON)
          (EATS SCALLOP BEEF)
          (EATS WURST-12 LEMON-15)
          (EATS TURKEY PISTACHIO)
          (EATS BACON TURKEY)
          (EATS MELON GUAVA)
          (CRAVES LEARNING MUFFIN-9)
          (EATS CUCUMBER BAGUETTE)
          (LOCALE TUNA BAVARIA)
          (CRAVES JEALOUSY-202 POTATO)
          (CRAVES ABRASION-81 CHERRY)
          (CRAVES DEPRESSION-124 CANTELOPE-10)
          (EATS LETTUCE WONDERBREAD)
          (EATS WONDERBREAD-13 APPLE-30)
          (EATS ONION GUAVA)
          (CRAVES ABRASION-215 MUTTON)
          (EATS FLOUNDER TUNA)
          (CRAVES BOILS-233 HOTDOG)
          (EATS SCALLOP-7 MELON)
          (LOCALE LAMB BAVARIA)
          (EATS CANTELOPE COD)
          (HARMONY EXCITEMENT NEPTUNE)
          (CRAVES GRIEF-99 TOMATO-6)
          (CRAVES ANGER-190 MARZIPAN)
          (EATS TOMATO-6 ORANGE)
          (CRAVES ANGER-107 WONDERBREAD-13)
          (EATS ENDIVE SCALLION)
          (EATS KALE HAM)
          (EATS LEMON PEA)
          (CRAVES ANGER-229 HAROSET)
          (CRAVES LONELINESS GUAVA-20)
          (CRAVES HANGOVER-196 BACON)
          (CRAVES ABRASION-237 BROCCOLI)
          (CRAVES PROSTATITIS-67 HAMBURGER)
          (EATS BROCCOLI-27 MUFFIN-9)
          (CRAVES INTOXICATION-61 ENDIVE)
          (CRAVES LONELINESS-227 HAROSET)
          (EATS HAMBURGER-5 POTATO)
          (CRAVES GRIEF-90 FLOUNDER-1)
          (CRAVES BOILS-83 POTATO-2)
          (EATS SCALLION SHRIMP)
          (CRAVES ANGINA-87 FLOUNDER-1)
          (EATS TUNA ORANGE)
          (LOCALE ARUGULA BAVARIA)
          (CRAVES BOILS-75 LETTUCE)
          (EATS MUTTON-11 BACON-19)
          (EATS LEMON-15 WURST-12)
          (CRAVES ABRASION-208 SNICKERS)
          (LOCALE GUAVA BAVARIA)
          (LOCALE PEAR BAVARIA)
          (EATS HAM MUTTON)
          (EATS CHICKEN PORK)
          (CRAVES DREAD-230 HAROSET)
          (EATS SWEETROLL SNICKERS)
          (CRAVES JEALOUSY-33 MUFFIN-9)
          (LOCALE MUTTON OREGON)
          (CRAVES GRIEF-193 FLOUNDER)
          (LOCALE LEMON-15 BAVARIA)
          (EATS FLOUNDER-1 ONION)
          (EATS GUAVA ONION)
          (EATS SCALLOP ONION)
          (EATS CUCUMBER SHRIMP)
          (EATS SCALLOP MUFFIN)
          (LOCALE SNICKERS OREGON)
          (CRAVES JEALOUSY-49 PAPAYA-25)
          (EATS SHRIMP-14 APPLE-30)
          (CRAVES HANGOVER-101 HAMBURGER-5)
          (CRAVES ABRASION-40 YOGURT-29)
          (EATS POTATO MARZIPAN)
          (EATS WURST SHRIMP)
          (EATS PAPAYA HAMBURGER)
          (CRAVES PROSTATITIS-213 TUNA)
          (EATS APPLE-30 SHRIMP-14)
          (CRAVES SATIETY ORANGE-22)
          (CRAVES UNDERSTANDING-18 PEA)
          (EATS SCALLION CUCUMBER)
          (EATS MUTTON HAM)
          (EATS SNICKERS GUAVA)
          (CRAVES ANGINA-231 ARUGULA)
          (CRAVES PROSTATITIS-104 HAMBURGER-5)
          (CRAVES ABRASION-98 TOMATO-6)
          (CRAVES ANXIETY-82 CHERRY)
          (EATS PORK-16 HAM-31)
          (CRAVES SCIATICA-248 MELON)
          (EATS GUAVA MELON)
          (EATS PEPPER TOMATO)
          (CRAVES ANXIETY-65 CHICKEN)
          (LOCALE PEPPER BAVARIA)
          (EATS YOGURT COD)
          (EATS SCALLION-24 APPLE-30)
          (EATS PEAR WONDERBREAD)
          (CRAVES JEALOUSY-187 ONION)
          (CRAVES ANGER-179 TURKEY)
          (CRAVES LONELINESS-96 SCALLOP-7)
          (CRAVES LONELINESS-85 POTATO-2)
          (CRAVES LACERATION-189 MARZIPAN)
          (CRAVES DREAD-191 YOGURT)
          (EATS LAMB HAROSET-3)
          (EATS PAPAYA PISTACHIO)
          (CRAVES ANGINA-199 PORK)
          (HARMONY EMPATHY-64 NEPTUNE)
          (CRAVES LACERATION-254 POPOVER)
          (EATS WONDERBREAD-13 BROCCOLI-27)
          (CRAVES LACERATION BACON-19)
          (CRAVES GRIEF-70 PISTACHIO)
          (CRAVES ANGINA-185 ONION)
          (EATS BROCCOLI CHOCOLATE)
          (EATS SHRIMP CUCUMBER)
          (EATS CHOCOLATE BROCCOLI)
          (CRAVES ANGINA-121 MUTTON-11)
          (CRAVES EXCITEMENT-58 TUNA)
          (CRAVES DEPRESSION-80 APPLE)
          (EATS HAMBURGER PAPAYA)
          (LOCALE TOFU OREGON)
          (EATS LAMB-8 HAMBURGER)
          (CRAVES PROSTATITIS-164 TOMATO)
          (EATS LEMON-15 YOGURT-29)
          (LOCALE HAMBURGER BAVARIA)
          (EATS OKRA ORANGE)
          (CRAVES ANGER-120 MUTTON-11)
          (HARMONY STIMULATION-56 NEPTUNE)
          (CRAVES DEPRESSION GUAVA-20)
          (CRAVES ACHIEVEMENT CUCUMBER)
          (LOCALE RICE OREGON)
          (EATS SNICKERS MELON)
          (EATS POTATO-2 LETTUCE)
          (CRAVES ANXIETY-114 PORK-16)
          (EATS POTATO HAMBURGER-5)
          (EATS ARUGULA MARZIPAN)
          (CRAVES BOILS-162 WURST)
          (ORBITS EARTH MARS)
          (CRAVES JEALOUSY-112 SHRIMP-14)
          (CRAVES ACHIEVEMENT-55 ONION)
          (HARMONY LEARNING MARS)
          (LOCALE POPOVER BAVARIA)
          (EATS LOBSTER PEAR)
          (CRAVES EMPATHY-64 SCALLOP)
          (EATS MELON SNICKERS)
          (EATS APPLE ORANGE)
          (EATS HAM KALE)
          (CRAVES EXCITEMENT HAM-31)
          (EATS MUFFIN-9 WURST-12)
          (EATS TURKEY LAMB-8)
          (CRAVES ANXIETY-250 CUCUMBER)
          (EATS PAPAYA-25 CANTELOPE-10)
          (CRAVES HANGOVER-110 SHRIMP-14)
          (CRAVES ANXIETY GRAPEFRUIT-23)
          (CRAVES LONELINESS-222 PAPAYA)
          (EATS CANTELOPE-10 GUAVA-20)
          (EATS ORANGE SWEETROLL)
          (EATS SHRIMP WURST)
          (CRAVES ANXIETY-226 LAMB)
          (EATS FLOUNDER TOMATO)
          (CRAVES SATIETY-17 BROCCOLI)
          (EATS APPLE-30 SCALLION-24)
          (EATS CANTELOPE PEPPER)
          (EATS LAMB BACON)
          (CRAVES LACERATION-171 PEAR)
          (EATS CUCUMBER-28 GRAPEFRUIT-23)
          (LOCALE MUTTON-11 BAVARIA)
          (EATS HAROSET-3 LAMB)
          (CRAVES ABRASION-117 PORK-16)
          (LOCALE HOTDOG-4 BAVARIA)
          (CRAVES HANGOVER-163 TOMATO)
          (EATS MUTTON-11 CHOCOLATE-26)
          (CRAVES LONELINESS-206 GUAVA)
          (EATS PORK KALE)
          (EATS MARZIPAN POTATO)
          (CRAVES HANGOVER-76 LETTUCE)
          (CRAVES LONELINESS-126 MUFFIN-9)
          (CRAVES BOILS-241 PEA)
          (CRAVES PROSTATITIS-238 BEEF)
          (EATS HAROSET MUTTON)
          (HARMONY ACHIEVEMENT-55 MARS)
          (LOCALE BEEF BAVARIA)
          (CRAVES GRIEF-37 HAM-31)
          (EATS GRAPEFRUIT-23 WURST-12)
          (EATS TUNA FLOUNDER)
          (HARMONY LUBRICITY NEPTUNE)
          (CRAVES CURIOSITY-63 KALE)
          (EATS WONDERBREAD-13 CANTELOPE-10)
          (LOCALE HOTDOG BAVARIA)
          (CRAVES LONELINESS-108 WONDERBREAD-13)
          (LOCALE POTATO BAVARIA)
          (EATS SNICKERS HAROSET-3)
          (CRAVES ANGINA-47 BROCCOLI-27)
          (EATS SHRIMP-14 YOGURT-29)
          (CRAVES DREAD-221 ENDIVE)
          (EATS SWEETROLL ORANGE)
          (CRAVES GRIEF-225 LAMB)
          (CRAVES UNDERSTANDING APPLE)
          (EATS LETTUCE POTATO-2)
          (CRAVES ANGINA-105 WONDERBREAD-13)
          (LOCALE HAM OREGON)
          (CRAVES GRIEF-165 TOMATO)
          (CRAVES LEARNING-59 MUTTON)
          (CRAVES ABRASION-194 BACON)
          (EATS HOTDOG MUTTON)
          (EATS WONDERBREAD BAGUETTE)
          (EATS CHOCOLATE YOGURT)
          (LOCALE SCALLOP BAVARIA)
          (EATS GUAVA-20 ARUGULA)
          (CRAVES ANXIETY-95 SCALLOP-7)
          (EATS BEEF MUFFIN)
          (LOCALE PAPAYA BAVARIA)
          (CRAVES LONELINESS-195 BACON)
          (EATS WONDERBREAD-13 CHOCOLATE-26)
          (HARMONY EMPATHY NEPTUNE)
          (HARMONY LOVE-60 MARS)
          (EATS SCALLOP HAMBURGER)
          (CRAVES SCIATICA-214 MUTTON)
          (LOCALE ONION BAVARIA)
          (HARMONY REST MARS)
          (EATS LAMB-8 LAMB)
          (CRAVES PROSTATITIS-197 PORK)
          (EATS CANTELOPE TOMATO-6)
          (EATS CUCUMBER SCALLION)
          (EATS MUTTON HAROSET)
          (EATS ORANGE HOTDOG-4)
          (CRAVES DEPRESSION-207 GUAVA)
          (EATS BROCCOLI-27 PAPAYA-25)
          (CRAVES GRIEF-34 KALE-32)
          (CRAVES JEALOUSY-236 BROCCOLI)
          (CRAVES ANGER-256 CHICKEN)
          (EATS WONDERBREAD MARZIPAN)
          (CRAVES LONELINESS-41 YOGURT-29)
          (CRAVES ANGER-89 FLOUNDER-1)
          (CRAVES SCIATICA-228 HAROSET)
          (LOCALE TOMATO BAVARIA)
          (EATS YOGURT CHOCOLATE)
          (HARMONY STIMULATION MARS)
          (EATS CHOCOLATE-26 MUTTON-11)
          (EATS SNICKERS BROCCOLI)
          (EATS KALE-32 SHRIMP-14)
          (EATS CANTELOPE-10 LEMON-15)
          (EATS MARZIPAN ARUGULA)
          (CRAVES JEALOUSY SCALLION-24)
          (LOCALE SCALLION-24 BAVARIA)
          (CRAVES LONELINESS-72 SCALLION)
          (HARMONY ACHIEVEMENT NEPTUNE)
          (EATS GRAPEFRUIT APPLE)
          (CRAVES LACERATION-84 POTATO-2)
          (EATS SCALLION-24 KALE-32)
          (LOCALE LOBSTER BAVARIA)
          (LOCALE PEA BAVARIA)
          (EATS GRAPEFRUIT FLOUNDER)
          (CRAVES DREAD-243 LEMON)
          (LOCALE SCALLION BAVARIA)
          (CRAVES LOVE-60 RICE)
          (EATS BROCCOLI SNICKERS)
          (LOCALE APPLE-30 BAVARIA)
          (EATS ONION FLOUNDER)
          (EATS CANTELOPE-10 PAPAYA-25)
          (EATS COD POPOVER)
          (CRAVES JEALOUSY-91 HOTDOG-4)
          (EATS YOGURT ORANGE)
          (EATS PEA LEMON)
          (EATS MUTTON-11 PORK-16)
          (EATS PEPPER-21 WURST-12)
          (EATS MUFFIN BEEF)
          (EATS HOTDOG-4 COD)
          (CRAVES HANGOVER-45 BROCCOLI-27)
          (CRAVES ABRASION-73 LOBSTER)
          (CRAVES ANXIETY-122 MUTTON-11)
          (EATS HAM-31 MUTTON-11)
          (EATS BACON-19 MUTTON-11)
          (LOCALE GRAPEFRUIT BAVARIA)
          (CRAVES SCIATICA-71 SCALLION)
          (CRAVES PROSTATITIS-38 APPLE-30)
          (EATS PEAR BACON)
          (CRAVES PROSTATITIS-209 SNICKERS)
          (CRAVES ANXIETY-44 BROCCOLI-27)
          (EATS HAM-31 CUCUMBER-28)
          (LOCALE YOGURT BAVARIA)
          (EATS SCALLION POPOVER)
          (HARMONY SATISFACTION NEPTUNE)
          (EATS TUNA TOMATO)
          (HARMONY REST-57 NEPTUNE)
          (LOCALE HAROSET-3 BAVARIA)
          (LOCALE PORK BAVARIA)
          (EATS CHOCOLATE RICE)
          (EATS PISTACHIO PAPAYA)
          (CRAVES GRIEF-210 SNICKERS)
          (LOCALE WONDERBREAD-13 BAVARIA)
          (EATS YOGURT-29 SHRIMP-14)
          (EATS SNICKERS SWEETROLL)
          (EATS BEEF TURKEY)
          (HARMONY LUBRICITY-53 MARS)
          (CRAVES SCIATICA-167 MUFFIN)
          (CRAVES REST-57 POTATO)
          (CRAVES GRIEF BACON-19)
          (CRAVES BOILS-100 TOMATO-6)
          (LOCALE KALE-32 OREGON)
          (EATS POTATO POTATO-2)
          (EATS LOBSTER ARUGULA)
          (CRAVES GRIEF-113 LEMON-15)
          (EATS LAMB-8 TURKEY)
          (HARMONY LOVE EARTH)
          (CRAVES GRIEF-251 CUCUMBER)
          (CRAVES BOILS-186 ONION)
          (EATS BAGUETTE CUCUMBER)
          (EATS ENDIVE CHOCOLATE)
          (LOCALE HAMBURGER-5 BAVARIA)
          (CRAVES PROSTATITIS-111 SHRIMP-14)
          (EATS RICE SNICKERS)
          (CRAVES SCIATICA-36 HAM-31)
          (HARMONY CURIOSITY-63 NEPTUNE)
          (LOCALE CHICKEN BAVARIA)
          (EATS HAM CHERRY)
          (LOCALE CUCUMBER BAVARIA)
          (EATS BEEF SCALLOP)
          (LOCALE SCALLOP-7 BAVARIA)
          (CRAVES PROSTATITIS GUAVA-20)
          (EATS HAMBURGER LAMB-8)
          (CRAVES LOVE PORK-16)
          (HARMONY LEARNING-59 NEPTUNE)
          (CRAVES PROSTATITIS-247 MELON)
          (CRAVES DEPRESSION-239 BEEF)
          (LOCALE LAMB-8 OREGON)
          (LOCALE CANTELOPE-10 BAVARIA)
          (CRAVES HANGOVER GUAVA-20)
          (CRAVES BOILS-216 WONDERBREAD)
          (EATS MELON FLOUNDER-1)
          (CRAVES DEPRESSION-66 CHICKEN)
          (EATS HOTDOG-4 ORANGE)
          (CRAVES DREAD-175 COD)
          (EATS APPLE GRAPEFRUIT)
          (EATS TURKEY BEEF)
          (LOCALE CHOCOLATE BAVARIA)
          (EATS ONION OKRA)
          (EATS RICE CHOCOLATE)
          (EATS APPLE-30 WONDERBREAD-13)
          (CRAVES INTOXICATION SCALLION-24)
          (EATS PEPPER-21 ORANGE-22)
          (EATS TURKEY BACON)
          (CRAVES ANGINA-181 PEPPER)
          (EATS MUFFIN ONION)
          (CRAVES AESTHETICS HAROSET-3)
          (CRAVES ABRASION-125 CANTELOPE-10)
          (EATS ARUGULA GUAVA-20)
          (CRAVES HANGOVER-180 PEPPER)
          (EATS CHOCOLATE MUTTON)
          (EATS KALE-32 CANTELOPE-10)
          (CRAVES GRIEF-178 TURKEY)
          (EATS PEA GUAVA)
          (EATS GUAVA-20 CANTELOPE-10)
          (EATS YOGURT-29 LEMON-15)
          (LOCALE GRAPEFRUIT-23 BAVARIA)
          (EATS ORANGE SCALLOP-7)
          (CRAVES ANXIETY-234 SCALLOP)
          (LOCALE COD BAVARIA)
          (EATS BACON PEAR)
          (CRAVES JEALOUSY-174 COD)
          (EATS HOTDOG ENDIVE)
          (EATS HAROSET HAM)
          (CRAVES ENTERTAINMENT LEMON)
          (EATS BROCCOLI-27 CHOCOLATE-26)
          (CRAVES SATISFACTION HOTDOG-4)
          (CRAVES ANGINA GRAPEFRUIT-23)
          (CRAVES PROSTATITIS-183 BAGUETTE)
          (EATS WURST-12 MUFFIN-9)
          (EATS BAGUETTE HAMBURGER-5)
          (EATS PORK-16 MUTTON-11)
          (HARMONY EXCITEMENT-58 EARTH)
          (CRAVES ANXIETY-184 BAGUETTE)
          (EATS SCALLION ENDIVE)
          (EATS ORANGE YOGURT)
          (CRAVES ENTERTAINMENT-54 BAGUETTE)
          (EATS ORANGE-22 PEPPER-21)
          (EATS SNICKERS YOGURT)
          (CRAVES SCIATICA-188 ORANGE)
          (CRAVES CURIOSITY BACON-19)
          (EATS MUFFIN-9 BROCCOLI-27)
          (CRAVES BOILS-48 CHOCOLATE-26)
          (EATS HAMBURGER SNICKERS)
          (CRAVES DREAD-35 HAM-31)
          (EATS ENDIVE COD)
          (CRAVES LACERATION-217 WONDERBREAD)
          (EATS CHERRY HAM)
          (LOCALE LETTUCE BAVARIA)
          (LOCALE PISTACHIO OREGON)
          (CRAVES ANGER-170 PEAR)
          (CRAVES ANGINA-245 TOFU)
          (EATS GUAVA SNICKERS)
          (EATS ORANGE APPLE)
          (LOCALE YOGURT-29 BAVARIA)
          (ORBITS NEPTUNE EARTH)
          (EATS BROCCOLI-27 WONDERBREAD-13)
          (EATS FLOUNDER GRAPEFRUIT)
          (LOCALE HAROSET BAVARIA)
          (HARMONY UNDERSTANDING-18 NEPTUNE)
          (EATS TOMATO TUNA)
          (CRAVES SCIATICA ORANGE-22)
          (EATS MARZIPAN WONDERBREAD)
          (CRAVES ANGER-92 HAROSET-3)
          (CRAVES LACERATION-212 TUNA)
          (CRAVES BOILS-177 CHOCOLATE)
          (EATS HAROSET TOFU)
          (CRAVES SCIATICA-88 FLOUNDER-1)
          (EATS SNICKERS HAMBURGER)
          (CRAVES BOILS-115 PORK-16)
          (EATS ARUGULA LOBSTER)
          (LOCALE WONDERBREAD OREGON)
          (EATS CHOCOLATE-26 BROCCOLI-27)
          (EATS COD CANTELOPE)
          (EATS KALE PORK)
          (CRAVES SCIATICA-205 GUAVA)
          (CRAVES LACERATION-93 LAMB-8)
          (HARMONY SATIETY NEPTUNE)
          (CRAVES STIMULATION WONDERBREAD-13)
          (CRAVES JEALOUSY-253 POPOVER)
          (HARMONY AESTHETICS-52 NEPTUNE)
          (LOCALE MARZIPAN BAVARIA)
          (LOCALE SHRIMP-14 BAVARIA)
          (CRAVES HANGOVER-211 SNICKERS)
          (CRAVES TRIUMPH-62 PAPAYA)
          (EATS TOMATO FLOUNDER)
          (LOCALE BROCCOLI-27 BAVARIA)
          (HARMONY CURIOSITY MARS)
          (CRAVES STIMULATION-56 ORANGE)
          (EATS PEAR CHICKEN)
          (EATS HAM CHOCOLATE)
          (EATS WONDERBREAD PEAR)
          (LOCALE SHRIMP BAVARIA)
          (EATS POPOVER COD)
          (EATS SNICKERS RICE)
          (CRAVES DREAD-39 YOGURT-29)
          (LOCALE MELON OREGON)
          (CRAVES HANGOVER-232 ARUGULA)
          (EATS CHERRY BROCCOLI)
          (EATS CANTELOPE-10 WONDERBREAD-13)
          (ORBITS JUPITER NEPTUNE)
          (CRAVES LONELINESS-166 TOMATO)
          (EATS PEAR BAGUETTE)
          (LOCALE MUFFIN-9 BAVARIA)
          (EATS BACON-19 MUFFIN-9)
          (CRAVES REST MUTTON-11)
          (LOCALE KALE OREGON)
          (CRAVES SCIATICA-102 HAMBURGER-5)
          (EATS PEPPER CANTELOPE)
          (LOCALE APPLE BAVARIA)
          (LOCALE MUFFIN BAVARIA)
          (EATS BACON LAMB)
          (HARMONY INTOXICATION EARTH)
          (EATS PISTACHIO TURKEY)
          (CRAVES DREAD-103 HAMBURGER-5)
          (CRAVES DREAD-106 WONDERBREAD-13)
          (CRAVES SCIATICA-118 WURST-12)
          (LOCALE FLOUNDER BAVARIA)
          (LOCALE ORANGE BAVARIA)
          (EATS SCALLOP-7 ORANGE)
          (LOCALE BACON-19 BAVARIA)
          (CRAVES ANGINA-69 OKRA)
          (HARMONY TRIUMPH-62 NEPTUNE)
          (EATS WURST-12 GRAPEFRUIT-23)
          (CRAVES ANXIETY-203 CANTELOPE)
          (EATS WONDERBREAD-13 KALE-32)
          (CRAVES HANGOVER-252 CUCUMBER)
          (HARMONY AESTHETICS EARTH)
          (CRAVES DEPRESSION-224 KALE)
          (EATS COD ENDIVE)
          (CRAVES LUBRICITY MELON)
          (EATS BAGUETTE ENDIVE)
          (EATS GRAPEFRUIT-23 CUCUMBER-28)
          (CRAVES DREAD-204 GUAVA)
          (LOCALE CUCUMBER-28 BAVARIA)
          (EATS MUTTON-11 HAM-31)
          (EATS LEMON SCALLOP)
          (EATS CHOCOLATE COD)
          (HARMONY ENTERTAINMENT MARS)
          (EATS WURST-12 PEPPER-21)
          (EATS HAROSET-3 SNICKERS)
          (EATS GUAVA-20 MUFFIN-9)
          (EATS PORK CHICKEN)
          (CRAVES ANGER SCALLION-24)
          (EATS ORANGE TUNA)
          (LOCALE BACON BAVARIA)
          (LOCALE BAGUETTE BAVARIA)
          (CRAVES DREAD ORANGE-22)
          (CRAVES DREAD-74 LOBSTER)
          (EATS ORANGE-22 MUTTON-11)
          (CRAVES ABRASION PEPPER-21)
          (HARMONY UNDERSTANDING EARTH)
          (EATS ONION MUFFIN)
          (EATS PAPAYA-25 BROCCOLI-27)
          (EATS PORK TOFU)
          (CRAVES PROSTATITIS-128 MUFFIN-9)
          (CRAVES EXPECTATION-51 MUFFIN)
          (EATS ENDIVE BAGUETTE)
          (CRAVES DEPRESSION-182 BAGUETTE)
          (CRAVES SCIATICA-176 CHOCOLATE)
          (LOCALE TURKEY OREGON)
          (EATS OKRA ONION)
          (CRAVES HANGOVER-127 MUFFIN-9)
          (CRAVES DEPRESSION-246 TOFU)
          (LOCALE PEPPER-21 BAVARIA)
          (EATS HAMBURGER SCALLOP)
          (LOCALE FLOUNDER-1 OREGON)
          (LOCALE GUAVA-20 BAVARIA)
          (CRAVES ANGER-220 RICE)
          (EATS MUFFIN-9 BACON-19)
          (CRAVES ANGINA-219 RICE)
          (EATS BAGUETTE PEAR)
          (EATS ONION FLOUNDER-1)
          (CRAVES LUBRICITY-53 PEPPER)
          (LOCALE CHERRY BAVARIA)
          (LOCALE HAM-31 BAVARIA)
          (LOCALE WURST-12 BAVARIA)
          (EATS TOFU PORK)
          (EATS CUCUMBER-28 HAM-31)
          (LOCALE TOMATO-6 BAVARIA)
          (EATS POTATO MUTTON)
          (EATS WURST BAGUETTE)
          (EATS COD HOTDOG-4)
          (HARMONY TRIUMPH EARTH)
          (ATTACKS BAVARIA OREGON)
          (EATS SHRIMP-14 KALE-32)
          (CRAVES DEPRESSION-50 SCALLION-24)
          (EATS ENDIVE HOTDOG)
          (EATS ORANGE OKRA)
          (EATS MUFFIN SCALLOP)
          (EATS POPOVER SCALLION)
          (EATS SHRIMP COD)
          (EATS ONION SCALLOP)
          (EATS CHICKEN PEAR)
          (EATS MUTTON CHOCOLATE)
          (EATS CHOCOLATE HAM)
          (CRAVES HANGOVER-86 POTATO-2)
          (EATS ORANGE TOMATO-6)
          (CRAVES LONELINESS-244 TOFU)
          (EATS COD SHRIMP)
          (HARMONY EXPECTATION NEPTUNE)
          (EATS CHOCOLATE-26 WONDERBREAD-13)
          (CRAVES SCIATICA-42 CUCUMBER-28)
          (CRAVES AESTHETICS-52 CHOCOLATE)
          (CRAVES DEPRESSION-198 PORK)
          (EATS LEMON-15 CANTELOPE-10)
          (CRAVES TRIUMPH POTATO-2)
          (EATS LAMB LAMB-8)
          (LOCALE CANTELOPE BAVARIA)
          (EATS KALE-32 WONDERBREAD-13)
          (CRAVES DEPRESSION-109 SHRIMP-14)
          (CRAVES EXPECTATION PEPPER-21)
          (HARMONY EXPECTATION-51 MARS)
          (CRAVES JEALOUSY-78 SWEETROLL)
          (EATS BAGUETTE WURST)
          (CRAVES LACERATION-235 SHRIMP)
          (EATS TOFU HAROSET)
          (CRAVES ABRASION-242 PEA)
          (EATS SHRIMP SCALLION)
          (EATS HAM HAROSET)
          (EATS COD CHOCOLATE)
          (EATS SCALLOP LEMON)
          (CRAVES EMPATHY CHICKEN)
          (EATS FLOUNDER-1 MELON)
          (LOCALE PORK-16 BAVARIA)
          (EATS TOMATO-6 CANTELOPE)
          (LOCALE PAPAYA-25 BAVARIA)
          (EATS BAGUETTE WONDERBREAD)
          (EATS PORK MARZIPAN)
          (EATS HAM-31 PORK-16)
          (CRAVES BOILS GRAPEFRUIT-23)
          (EATS KALE-32 SCALLION-24)
          (CRAVES ABRASION-168 MUFFIN))
   (:GOAL (AND (CRAVES JEALOUSY-91 PISTACHIO)
               (CRAVES ANGINA-87 PISTACHIO))))

(DEFINE (PROBLEM STRIPS-MYSTY-29)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SNICKERS WURST BROCCOLI TUNA RICE MARZIPAN MUFFIN MELON
             SCALLOP POTATO CUCUMBER PORK PEPPER CHOCOLATE PEA APPLE GUAVA
             FLOUNDER YOGURT POPOVER TURKEY HAM STIMULATION INTOXICATION
             UNDERSTANDING LEARNING TRIUMPH EMPATHY EXCITEMENT SATIETY LOVE
             ENTERTAINMENT SATISFACTION REST ACHIEVEMENT EXPECTATION CURIOSITY
             AESTHETICS HANGOVER ANGER ANGINA GRIEF BOILS JEALOUSY LACERATION
             DEPRESSION ANXIETY ABRASION PROSTATITIS DREAD LONELINESS
             SCIATICA JEALOUSY-2 ANXIETY-1 LACERATION-4 ABRASION-3 BOILS-8
             DEPRESSION-7 MANITOBA-6 BAVARIA ARIZONA QUEBEC PENNSYLVANIA OREGON
             GOIAS MORAVIA GUANABARA BOSNIA SURREY ALSACE KENTUCKY
             MANITOBA VULCAN PLUTO URANUS MARS)
   (:INIT (FOOD SNICKERS)
          (FOOD WURST)
          (FOOD BROCCOLI)
          (FOOD TUNA)
          (FOOD RICE)
          (FOOD MARZIPAN)
          (FOOD MUFFIN)
          (FOOD MELON)
          (FOOD SCALLOP)
          (FOOD POTATO)
          (FOOD CUCUMBER)
          (FOOD PORK)
          (FOOD PEPPER)
          (FOOD CHOCOLATE)
          (FOOD PEA)
          (FOOD APPLE)
          (FOOD GUAVA)
          (FOOD FLOUNDER)
          (FOOD YOGURT)
          (FOOD POPOVER)
          (FOOD TURKEY)
          (FOOD HAM)
          (PLEASURE STIMULATION)
          (PLEASURE INTOXICATION)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LEARNING)
          (PLEASURE TRIUMPH)
          (PLEASURE EMPATHY)
          (PLEASURE EXCITEMENT)
          (PLEASURE SATIETY)
          (PLEASURE LOVE)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE SATISFACTION)
          (PLEASURE REST)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE CURIOSITY)
          (PLEASURE AESTHETICS)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN ANGINA)
          (PAIN GRIEF)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN LACERATION)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN ABRASION)
          (PAIN PROSTATITIS)
          (PAIN DREAD)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN JEALOUSY-2)
          (PAIN ANXIETY-1)
          (PAIN LACERATION-4)
          (PAIN ABRASION-3)
          (PAIN BOILS-8)
          (PAIN DEPRESSION-7)
          (PROVINCE MANITOBA-6)
          (PROVINCE BAVARIA)
          (PROVINCE ARIZONA)
          (PROVINCE QUEBEC)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE OREGON)
          (PROVINCE GOIAS)
          (PROVINCE MORAVIA)
          (PROVINCE GUANABARA)
          (PROVINCE BOSNIA)
          (PROVINCE SURREY)
          (PROVINCE ALSACE)
          (PROVINCE KENTUCKY)
          (PROVINCE MANITOBA)
          (PLANET VULCAN)
          (PLANET PLUTO)
          (PLANET URANUS)
          (PLANET MARS)
          (EATS YOGURT PORK)
          (EATS POTATO POPOVER)
          (CRAVES SATIETY SCALLOP)
          (CRAVES ABRASION POTATO)
          (EATS FLOUNDER PORK)
          (LOCALE PEPPER PENNSYLVANIA)
          (HARMONY TRIUMPH URANUS)
          (EATS SNICKERS BROCCOLI)
          (EATS MARZIPAN TUNA)
          (EATS MELON CUCUMBER)
          (EATS APPLE PEA)
          (ATTACKS SURREY ALSACE)
          (CRAVES EXCITEMENT MELON)
          (EATS GUAVA MELON)
          (EATS MELON POPOVER)
          (LOCALE PORK QUEBEC)
          (EATS APPLE HAM)
          (EATS WURST HAM)
          (HARMONY AESTHETICS MARS)
          (EATS CUCUMBER GUAVA)
          (ATTACKS MORAVIA GUANABARA)
          (HARMONY INTOXICATION URANUS)
          (LOCALE PEA GUANABARA)
          (CRAVES EXPECTATION POPOVER)
          (LOCALE WURST PENNSYLVANIA)
          (CRAVES ENTERTAINMENT CUCUMBER)
          (CRAVES ANGINA BROCCOLI)
          (ATTACKS GUANABARA BOSNIA)
          (EATS WURST CUCUMBER)
          (CRAVES EMPATHY MUFFIN)
          (HARMONY ACHIEVEMENT PLUTO)
          (CRAVES LACERATION-4 FLOUNDER)
          (CRAVES GRIEF TUNA)
          (HARMONY EXPECTATION PLUTO)
          (EATS YOGURT CUCUMBER)
          (EATS RICE HAM)
          (EATS FLOUNDER HAM)
          (CRAVES LONELINESS PEPPER)
          (EATS PEPPER APPLE)
          (EATS RICE PEA)
          (CRAVES ANXIETY-1 GUAVA)
          (LOCALE SNICKERS OREGON)
          (HARMONY REST MARS)
          (EATS PORK FLOUNDER)
          (EATS PORK YOGURT)
          (EATS HAM FLOUNDER)
          (EATS GUAVA TUNA)
          (CRAVES ANGER WURST)
          (ATTACKS MANITOBA-6 BAVARIA)
          (EATS GUAVA POTATO)
          (CRAVES SCIATICA PEA)
          (CRAVES DEPRESSION MELON)
          (EATS SCALLOP SNICKERS)
          (CRAVES INTOXICATION WURST)
          (EATS CHOCOLATE MARZIPAN)
          (CRAVES BOILS RICE)
          (EATS PEA APPLE)
          (HARMONY EMPATHY URANUS)
          (EATS TURKEY PEA)
          (LOCALE APPLE PENNSYLVANIA)
          (EATS CUCUMBER YOGURT)
          (LOCALE MELON BAVARIA)
          (CRAVES DREAD PORK)
          (EATS SCALLOP HAM)
          (HARMONY UNDERSTANDING PLUTO)
          (ATTACKS GOIAS MORAVIA)
          (LOCALE TURKEY OREGON)
          (EATS TURKEY APPLE)
          (EATS HAM WURST)
          (CRAVES LEARNING RICE)
          (EATS TUNA MARZIPAN)
          (EATS HAM APPLE)
          (EATS POTATO GUAVA)
          (EATS YOGURT CHOCOLATE)
          (HARMONY ENTERTAINMENT PLUTO)
          (CRAVES JEALOUSY MARZIPAN)
          (ATTACKS BOSNIA SURREY)
          (EATS SNICKERS SCALLOP)
          (CRAVES ACHIEVEMENT YOGURT)
          (CRAVES BOILS-8 TURKEY)
          (EATS APPLE TURKEY)
          (CRAVES STIMULATION SNICKERS)
          (HARMONY EXCITEMENT URANUS)
          (EATS POPOVER MELON)
          (LOCALE MUFFIN OREGON)
          (HARMONY LEARNING URANUS)
          (EATS MUFFIN BROCCOLI)
          (LOCALE CUCUMBER BAVARIA)
          (EATS MUFFIN POPOVER)
          (LOCALE HAM GUANABARA)
          (EATS MARZIPAN CHOCOLATE)
          (HARMONY STIMULATION PLUTO)
          (LOCALE GUAVA MANITOBA-6)
          (EATS GUAVA CUCUMBER)
          (ATTACKS OREGON GOIAS)
          (LOCALE MARZIPAN QUEBEC)
          (ATTACKS KENTUCKY MANITOBA)
          (LOCALE BROCCOLI QUEBEC)
          (CRAVES ABRASION-3 YOGURT)
          (CRAVES HANGOVER SNICKERS)
          (EATS PEPPER POPOVER)
          (CRAVES LACERATION MUFFIN)
          (LOCALE POTATO GUANABARA)
          (CRAVES SATISFACTION APPLE)
          (EATS HAM RICE)
          (CRAVES REST FLOUNDER)
          (ORBITS VULCAN PLUTO)
          (EATS CUCUMBER MELON)
          (EATS CHOCOLATE YOGURT)
          (EATS CUCUMBER WURST)
          (ATTACKS PENNSYLVANIA OREGON)
          (EATS PEA TURKEY)
          (EATS POPOVER POTATO)
          (EATS TUNA GUAVA)
          (HARMONY SATISFACTION MARS)
          (HARMONY LOVE URANUS)
          (LOCALE FLOUNDER GUANABARA)
          (CRAVES AESTHETICS HAM)
          (LOCALE RICE PENNSYLVANIA)
          (ATTACKS BAVARIA ARIZONA)
          (CRAVES ANXIETY SCALLOP)
          (ATTACKS QUEBEC PENNSYLVANIA)
          (LOCALE SCALLOP BOSNIA)
          (HARMONY CURIOSITY PLUTO)
          (EATS POPOVER MUFFIN)
          (EATS PEA RICE)
          (ORBITS PLUTO URANUS)
          (HARMONY SATIETY MARS)
          (EATS APPLE PEPPER)
          (CRAVES CURIOSITY TURKEY)
          (ATTACKS ARIZONA QUEBEC)
          (ATTACKS ALSACE KENTUCKY)
          (CRAVES PROSTATITIS CUCUMBER)
          (ORBITS URANUS MARS)
          (CRAVES DEPRESSION-7 HAM)
          (LOCALE YOGURT GUANABARA)
          (CRAVES TRIUMPH MARZIPAN)
          (CRAVES LOVE POTATO)
          (EATS MELON GUAVA)
          (CRAVES UNDERSTANDING TUNA)
          (LOCALE CHOCOLATE BOSNIA)
          (CRAVES JEALOUSY-2 APPLE)
          (LOCALE POPOVER MANITOBA)
          (EATS HAM SCALLOP)
          (EATS POPOVER PEPPER)
          (EATS BROCCOLI MUFFIN)
          (EATS BROCCOLI SNICKERS)
          (LOCALE TUNA MANITOBA-6))
   (:GOAL (AND (CRAVES ANGER SNICKERS))))

(DEFINE (PROBLEM STRIPS-MYSTY-30)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS ENDIVE CUCUMBER POPOVER MARZIPAN INTOXICATION ANGINA
             HANGOVER ANGER JEALOUSY GRIEF BAVARIA KENTUCKY BOSNIA URANUS
             MARS)
   (:INIT (FOOD ENDIVE)
          (FOOD CUCUMBER)
          (FOOD POPOVER)
          (FOOD MARZIPAN)
          (PLEASURE INTOXICATION)
          (PAIN ANGINA)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN JEALOUSY)
          (PAIN GRIEF)
          (PROVINCE BAVARIA)
          (PROVINCE KENTUCKY)
          (PROVINCE BOSNIA)
          (PLANET URANUS)
          (PLANET MARS)
          (CRAVES JEALOUSY CUCUMBER)
          (EATS CUCUMBER POPOVER)
          (LOCALE MARZIPAN BOSNIA)
          (HARMONY INTOXICATION MARS)
          (LOCALE POPOVER BAVARIA)
          (LOCALE CUCUMBER KENTUCKY)
          (EATS POPOVER CUCUMBER)
          (LOCALE ENDIVE BOSNIA)
          (CRAVES ANGINA ENDIVE)
          (CRAVES ANGER CUCUMBER)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS POPOVER MARZIPAN)
          (CRAVES HANGOVER ENDIVE)
          (ORBITS URANUS MARS)
          (EATS ENDIVE CUCUMBER)
          (EATS MARZIPAN POPOVER)
          (EATS MARZIPAN ENDIVE)
          (EATS ENDIVE MARZIPAN)
          (CRAVES GRIEF POPOVER)
          (ATTACKS BAVARIA KENTUCKY)
          (CRAVES INTOXICATION POPOVER)
          (EATS CUCUMBER ENDIVE))
   (:GOAL (AND (CRAVES HANGOVER CUCUMBER)
               (CRAVES JEALOUSY POPOVER)
               (CRAVES ANGER MARZIPAN)
               (CRAVES GRIEF ENDIVE)
               (CRAVES ANGINA ENDIVE))))

(DEFINE (PROBLEM STRIPS-MYSTY-31)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PEAR ONION HOTDOG ENDIVE PAPAYA SCALLOP PORK BROCCOLI
             GUAVA YOGURT ARUGULA CUCUMBER BAGUETTE TURKEY WONDERBREAD
             CHICKEN CHOCOLATE HAMBURGER HAM MUTTON POTATO SHRIMP CANTELOPE
             OKRA PEPPER SNICKERS LEMON LAMB BACON FLOUNDER TOFU LOBSTER
             SWEETROLL WURST PISTACHIO MUFFIN GRAPEFRUIT BEEF APPLE ORANGE
             SCALLION POPOVER MELON RICE LETTUCE MARZIPAN UNDERSTANDING
             ENTERTAINMENT TRIUMPH AESTHETICS ACHIEVEMENT CURIOSITY STIMULATION
             LUBRICITY LEARNING EXPECTATION INTOXICATION SATISFACTION
             EXCITEMENT REST LOVE EMPATHY SATIETY REST-2 EMPATHY-1 SATIETY-4
             LEARNING-3 LOVE-8 INTOXICATION-7 ACHIEVEMENT-6 EXCITEMENT-5
             EXPECTATION-16 GRIEF PROSTATITIS ANGER HANGOVER JEALOUSY ANGINA DREAD
             DEPRESSION ABRASION LONELINESS SCIATICA LACERATION BOILS
             DEPRESSION-14 DREAD-15 ANXIETY GRIEF-11 PROSTATITIS-12
             LACERATION-13 LONELINESS-31 ANGINA-32 HANGOVER-9 ANGER-10
             ABRASION-30 ANXIETY-29 BOILS-27 JEALOUSY-28 DEPRESSION-24
             SCIATICA-25 SCIATICA-26 ANGINA-21 BOILS-22 HANGOVER-23
             PROSTATITIS-17 DREAD-18 LONELINESS-19 ABRASION-20 JEALOUSY-62
             ANXIETY-63 GRIEF-64 HANGOVER-59 ANGER-60 LACERATION-61 ANGER-55
             GRIEF-56 ANGINA-57 DEPRESSION-58 JEALOUSY-54 PROSTATITIS-53
             DREAD-52 LONELINESS-48 ANXIETY-49 SCIATICA-50 ABRASION-51
             BOILS-46 LACERATION-47 ABRASION-43 DREAD-44 HANGOVER-45
             BOILS-41 PROSTATITIS-42 GRIEF-39 DEPRESSION-40 JEALOUSY-38
             PENNSYLVANIA GOIAS ARIZONA KENTUCKY SATURN NEPTUNE EARTH VENUS)
   (:INIT (FOOD PEAR)
          (FOOD ONION)
          (FOOD HOTDOG)
          (FOOD ENDIVE)
          (FOOD PAPAYA)
          (FOOD SCALLOP)
          (FOOD PORK)
          (FOOD BROCCOLI)
          (FOOD GUAVA)
          (FOOD YOGURT)
          (FOOD ARUGULA)
          (FOOD CUCUMBER)
          (FOOD BAGUETTE)
          (FOOD TURKEY)
          (FOOD WONDERBREAD)
          (FOOD CHICKEN)
          (FOOD CHOCOLATE)
          (FOOD HAMBURGER)
          (FOOD HAM)
          (FOOD MUTTON)
          (FOOD POTATO)
          (FOOD SHRIMP)
          (FOOD CANTELOPE)
          (FOOD OKRA)
          (FOOD PEPPER)
          (FOOD SNICKERS)
          (FOOD LEMON)
          (FOOD LAMB)
          (FOOD BACON)
          (FOOD FLOUNDER)
          (FOOD TOFU)
          (FOOD LOBSTER)
          (FOOD SWEETROLL)
          (FOOD WURST)
          (FOOD PISTACHIO)
          (FOOD MUFFIN)
          (FOOD GRAPEFRUIT)
          (FOOD BEEF)
          (FOOD APPLE)
          (FOOD ORANGE)
          (FOOD SCALLION)
          (FOOD POPOVER)
          (FOOD MELON)
          (FOOD RICE)
          (FOOD LETTUCE)
          (FOOD MARZIPAN)
          (PLEASURE UNDERSTANDING)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE TRIUMPH)
          (PLEASURE AESTHETICS)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE CURIOSITY)
          (PLEASURE STIMULATION)
          (PLEASURE LUBRICITY)
          (PLEASURE LEARNING)
          (PLEASURE EXPECTATION)
          (PLEASURE INTOXICATION)
          (PLEASURE SATISFACTION)
          (PLEASURE EXCITEMENT)
          (PLEASURE REST)
          (PLEASURE LOVE)
          (PLEASURE EMPATHY)
          (PLEASURE SATIETY)
          (PLEASURE REST-2)
          (PLEASURE EMPATHY-1)
          (PLEASURE SATIETY-4)
          (PLEASURE LEARNING-3)
          (PLEASURE LOVE-8)
          (PLEASURE INTOXICATION-7)
          (PLEASURE ACHIEVEMENT-6)
          (PLEASURE EXCITEMENT-5)
          (PLEASURE EXPECTATION-16)
          (PAIN GRIEF)
          (PAIN PROSTATITIS)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN ANGINA)
          (PAIN DREAD)
          (PAIN DEPRESSION)
          (PAIN ABRASION)
          (PAIN LONELINESS)
          (PAIN SCIATICA)
          (PAIN LACERATION)
          (PAIN BOILS)
          (PAIN DEPRESSION-14)
          (PAIN DREAD-15)
          (PAIN ANXIETY)
          (PAIN GRIEF-11)
          (PAIN PROSTATITIS-12)
          (PAIN LACERATION-13)
          (PAIN LONELINESS-31)
          (PAIN ANGINA-32)
          (PAIN HANGOVER-9)
          (PAIN ANGER-10)
          (PAIN ABRASION-30)
          (PAIN ANXIETY-29)
          (PAIN BOILS-27)
          (PAIN JEALOUSY-28)
          (PAIN DEPRESSION-24)
          (PAIN SCIATICA-25)
          (PAIN SCIATICA-26)
          (PAIN ANGINA-21)
          (PAIN BOILS-22)
          (PAIN HANGOVER-23)
          (PAIN PROSTATITIS-17)
          (PAIN DREAD-18)
          (PAIN LONELINESS-19)
          (PAIN ABRASION-20)
          (PAIN JEALOUSY-62)
          (PAIN ANXIETY-63)
          (PAIN GRIEF-64)
          (PAIN HANGOVER-59)
          (PAIN ANGER-60)
          (PAIN LACERATION-61)
          (PAIN ANGER-55)
          (PAIN GRIEF-56)
          (PAIN ANGINA-57)
          (PAIN DEPRESSION-58)
          (PAIN JEALOUSY-54)
          (PAIN PROSTATITIS-53)
          (PAIN DREAD-52)
          (PAIN LONELINESS-48)
          (PAIN ANXIETY-49)
          (PAIN SCIATICA-50)
          (PAIN ABRASION-51)
          (PAIN BOILS-46)
          (PAIN LACERATION-47)
          (PAIN ABRASION-43)
          (PAIN DREAD-44)
          (PAIN HANGOVER-45)
          (PAIN BOILS-41)
          (PAIN PROSTATITIS-42)
          (PAIN GRIEF-39)
          (PAIN DEPRESSION-40)
          (PAIN JEALOUSY-38)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE GOIAS)
          (PROVINCE ARIZONA)
          (PROVINCE KENTUCKY)
          (PLANET SATURN)
          (PLANET NEPTUNE)
          (PLANET EARTH)
          (PLANET VENUS)
          (EATS TURKEY HAMBURGER)
          (EATS SWEETROLL LETTUCE)
          (EATS POTATO ARUGULA)
          (EATS ORANGE HAMBURGER)
          (LOCALE MELON PENNSYLVANIA)
          (EATS HAMBURGER ORANGE)
          (LOCALE BAGUETTE PENNSYLVANIA)
          (CRAVES LEARNING-3 BEEF)
          (EATS ORANGE MUFFIN)
          (LOCALE HAM GOIAS)
          (CRAVES EXCITEMENT CANTELOPE)
          (CRAVES BOILS-22 PEPPER)
          (CRAVES EXPECTATION-16 MARZIPAN)
          (EATS SHRIMP SNICKERS)
          (EATS CUCUMBER BROCCOLI)
          (EATS ORANGE FLOUNDER)
          (EATS BROCCOLI POTATO)
          (LOCALE CANTELOPE ARIZONA)
          (CRAVES BOILS-46 APPLE)
          (LOCALE LEMON ARIZONA)
          (LOCALE TURKEY ARIZONA)
          (HARMONY SATIETY-4 VENUS)
          (CRAVES LACERATION GUAVA)
          (LOCALE SCALLOP GOIAS)
          (EATS BAGUETTE BROCCOLI)
          (EATS TOFU POPOVER)
          (CRAVES EXPECTATION HAM)
          (CRAVES BOILS-27 SHRIMP)
          (EATS HAMBURGER CHICKEN)
          (LOCALE SWEETROLL PENNSYLVANIA)
          (EATS WONDERBREAD CHOCOLATE)
          (CRAVES ACHIEVEMENT-6 POPOVER)
          (HARMONY EXPECTATION EARTH)
          (EATS POTATO WURST)
          (CRAVES LACERATION-13 ARUGULA)
          (EATS CUCUMBER PAPAYA)
          (LOCALE ENDIVE KENTUCKY)
          (EATS HAM SCALLOP)
          (CRAVES ABRASION SCALLOP)
          (EATS CHOCOLATE ARUGULA)
          (CRAVES JEALOUSY-38 LETTUCE)
          (EATS ARUGULA HAM)
          (CRAVES LOVE-8 ORANGE)
          (ATTACKS ARIZONA KENTUCKY)
          (EATS CHICKEN PEPPER)
          (CRAVES EMPATHY-1 PISTACHIO)
          (EATS CHICKEN TURKEY)
          (HARMONY TRIUMPH EARTH)
          (LOCALE MUTTON PENNSYLVANIA)
          (EATS CUCUMBER ENDIVE)
          (EATS OKRA MUTTON)
          (EATS PEPPER CHICKEN)
          (EATS WURST POTATO)
          (EATS LEMON SHRIMP)
          (EATS TURKEY CHICKEN)
          (EATS CANTELOPE PEPPER)
          (CRAVES ANGINA-32 WONDERBREAD)
          (EATS POPOVER GRAPEFRUIT)
          (EATS SCALLOP CHICKEN)
          (EATS MUTTON YOGURT)
          (HARMONY UNDERSTANDING NEPTUNE)
          (CRAVES LONELINESS-19 LEMON)
          (EATS MARZIPAN SCALLION)
          (EATS GUAVA BAGUETTE)
          (HARMONY LUBRICITY VENUS)
          (EATS HAM OKRA)
          (EATS APPLE MARZIPAN)
          (EATS LAMB BEEF)
          (HARMONY EXPECTATION-16 EARTH)
          (EATS LOBSTER MARZIPAN)
          (CRAVES LACERATION-61 BACON)
          (LOCALE LAMB GOIAS)
          (HARMONY REST VENUS)
          (CRAVES REST-2 SWEETROLL)
          (EATS APPLE GRAPEFRUIT)
          (LOCALE ONION PENNSYLVANIA)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (LOCALE GRAPEFRUIT GOIAS)
          (EATS LETTUCE SWEETROLL)
          (EATS RICE BEEF)
          (EATS BEEF RICE)
          (CRAVES LONELINESS-31 WONDERBREAD)
          (HARMONY LEARNING-3 NEPTUNE)
          (EATS POTATO ONION)
          (EATS HAMBURGER TURKEY)
          (CRAVES ANXIETY YOGURT)
          (EATS POTATO PEAR)
          (LOCALE ARUGULA PENNSYLVANIA)
          (EATS CHOCOLATE POTATO)
          (CRAVES LEARNING WONDERBREAD)
          (CRAVES GRIEF-39 POPOVER)
          (CRAVES JEALOUSY-62 LAMB)
          (EATS FLOUNDER ORANGE)
          (EATS LEMON GUAVA)
          (EATS SCALLION MARZIPAN)
          (EATS MARZIPAN LOBSTER)
          (LOCALE GUAVA KENTUCKY)
          (EATS GRAPEFRUIT POPOVER)
          (CRAVES SATISFACTION SHRIMP)
          (CRAVES JEALOUSY-54 LOBSTER)
          (EATS TOFU GRAPEFRUIT)
          (ORBITS EARTH VENUS)
          (EATS BEEF LAMB)
          (CRAVES GRIEF-11 ARUGULA)
          (EATS WURST MELON)
          (ORBITS NEPTUNE EARTH)
          (EATS CHOCOLATE WONDERBREAD)
          (CRAVES SCIATICA-50 GRAPEFRUIT)
          (CRAVES DREAD-52 PISTACHIO)
          (EATS PAPAYA CUCUMBER)
          (CRAVES LOVE LEMON)
          (CRAVES BOILS-41 SCALLION)
          (CRAVES ANGINA-21 PEPPER)
          (EATS MELON WURST)
          (EATS SHRIMP ENDIVE)
          (CRAVES CURIOSITY GUAVA)
          (CRAVES HANGOVER-23 PEPPER)
          (CRAVES ANXIETY-63 LAMB)
          (EATS POTATO BROCCOLI)
          (LOCALE RICE PENNSYLVANIA)
          (LOCALE CUCUMBER ARIZONA)
          (EATS ENDIVE SHRIMP)
          (EATS CHICKEN HAMBURGER)
          (CRAVES STIMULATION YOGURT)
          (CRAVES DEPRESSION-24 OKRA)
          (HARMONY EXCITEMENT EARTH)
          (CRAVES INTOXICATION MUTTON)
          (EATS MARZIPAN APPLE)
          (EATS SWEETROLL RICE)
          (CRAVES ACHIEVEMENT BROCCOLI)
          (CRAVES ANXIETY-49 GRAPEFRUIT)
          (EATS WONDERBREAD CANTELOPE)
          (EATS MUFFIN SCALLION)
          (HARMONY LEARNING EARTH)
          (HARMONY LOVE-8 NEPTUNE)
          (LOCALE POPOVER GOIAS)
          (HARMONY REST-2 EARTH)
          (LOCALE OKRA PENNSYLVANIA)
          (EATS BEEF PISTACHIO)
          (EATS BACON APPLE)
          (EATS TURKEY HOTDOG)
          (EATS SNICKERS CANTELOPE)
          (EATS POPOVER MARZIPAN)
          (EATS GUAVA LEMON)
          (EATS SNICKERS SHRIMP)
          (EATS OKRA HAM)
          (EATS CANTELOPE SNICKERS)
          (CRAVES LUBRICITY CUCUMBER)
          (EATS PEPPER PORK)
          (CRAVES AESTHETICS PORK)
          (EATS WURST TOFU)
          (EATS FLOUNDER PISTACHIO)
          (CRAVES ABRASION-51 GRAPEFRUIT)
          (LOCALE PEAR PENNSYLVANIA)
          (LOCALE WURST PENNSYLVANIA)
          (EATS PEAR OKRA)
          (EATS CHICKEN SCALLOP)
          (HARMONY INTOXICATION-7 VENUS)
          (HARMONY EMPATHY EARTH)
          (CRAVES DREAD PAPAYA)
          (LOCALE HAMBURGER ARIZONA)
          (CRAVES JEALOUSY ENDIVE)
          (EATS GRAPEFRUIT TOFU)
          (CRAVES ANGINA PAPAYA)
          (CRAVES ANGER-60 BACON)
          (CRAVES PROSTATITIS-12 ARUGULA)
          (LOCALE ORANGE ARIZONA)
          (EATS ONION POTATO)
          (CRAVES BOILS GUAVA)
          (ATTACKS PENNSYLVANIA GOIAS)
          (EATS PORK HAMBURGER)
          (CRAVES INTOXICATION-7 SCALLION)
          (EATS PORK PEPPER)
          (CRAVES DEPRESSION-14 YOGURT)
          (EATS MUFFIN ORANGE)
          (EATS CUCUMBER BAGUETTE)
          (CRAVES ANGER-55 FLOUNDER)
          (CRAVES SCIATICA-25 OKRA)
          (CRAVES HANGOVER-59 BACON)
          (CRAVES JEALOUSY-28 SHRIMP)
          (EATS PISTACHIO FLOUNDER)
          (CRAVES ANGER ENDIVE)
          (EATS YOGURT BAGUETTE)
          (CRAVES PROSTATITIS ENDIVE)
          (CRAVES PROSTATITIS-53 SWEETROLL)
          (HARMONY INTOXICATION EARTH)
          (EATS POPOVER TOFU)
          (LOCALE HOTDOG PENNSYLVANIA)
          (EATS BROCCOLI CUCUMBER)
          (HARMONY AESTHETICS NEPTUNE)
          (LOCALE TOFU ARIZONA)
          (HARMONY CURIOSITY EARTH)
          (LOCALE BEEF PENNSYLVANIA)
          (EATS BROCCOLI BAGUETTE)
          (EATS LOBSTER GRAPEFRUIT)
          (EATS LAMB SCALLION)
          (CRAVES REST OKRA)
          (EATS APPLE BACON)
          (ATTACKS GOIAS ARIZONA)
          (EATS POPOVER MELON)
          (EATS OKRA PEAR)
          (EATS HAM ARUGULA)
          (HARMONY SATISFACTION VENUS)
          (HARMONY ACHIEVEMENT VENUS)
          (EATS HAMBURGER PORK)
          (CRAVES ANXIETY-29 HAM)
          (EATS LEMON YOGURT)
          (LOCALE MUFFIN KENTUCKY)
          (EATS YOGURT LEMON)
          (EATS CANTELOPE WONDERBREAD)
          (LOCALE APPLE ARIZONA)
          (CRAVES UNDERSTANDING PEAR)
          (EATS TOFU WURST)
          (EATS MUTTON OKRA)
          (CRAVES EMPATHY TOFU)
          (CRAVES DEPRESSION PAPAYA)
          (LOCALE PISTACHIO KENTUCKY)
          (EATS PISTACHIO BEEF)
          (EATS LETTUCE SCALLION)
          (CRAVES HANGOVER ENDIVE)
          (EATS MARZIPAN POPOVER)
          (LOCALE BACON PENNSYLVANIA)
          (EATS BAGUETTE GUAVA)
          (CRAVES ABRASION-43 ORANGE)
          (CRAVES ENTERTAINMENT HOTDOG)
          (LOCALE BROCCOLI ARIZONA)
          (LOCALE PEPPER PENNSYLVANIA)
          (EATS ENDIVE CUCUMBER)
          (LOCALE SHRIMP KENTUCKY)
          (CRAVES HANGOVER-45 ORANGE)
          (EATS BAGUETTE YOGURT)
          (CRAVES DREAD-18 LEMON)
          (CRAVES EXCITEMENT-5 RICE)
          (HARMONY STIMULATION EARTH)
          (CRAVES GRIEF-64 LAMB)
          (EATS ARUGULA CHOCOLATE)
          (LOCALE LOBSTER PENNSYLVANIA)
          (CRAVES SCIATICA BROCCOLI)
          (LOCALE FLOUNDER GOIAS)
          (LOCALE LETTUCE ARIZONA)
          (EATS GRAPEFRUIT LOBSTER)
          (EATS BAGUETTE POTATO)
          (CRAVES ANGINA-57 FLOUNDER)
          (CRAVES DEPRESSION-58 FLOUNDER)
          (HARMONY ACHIEVEMENT-6 EARTH)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS WURST RICE)
          (CRAVES LACERATION-47 APPLE)
          (LOCALE WONDERBREAD KENTUCKY)
          (CRAVES TRIUMPH PAPAYA)
          (LOCALE YOGURT GOIAS)
          (LOCALE SCALLION ARIZONA)
          (EATS SHRIMP LEMON)
          (EATS YOGURT ONION)
          (CRAVES LONELINESS BROCCOLI)
          (HARMONY SATIETY EARTH)
          (EATS SCALLION MUFFIN)
          (HARMONY EXCITEMENT-5 VENUS)
          (EATS YOGURT MUTTON)
          (CRAVES DREAD-44 ORANGE)
          (CRAVES ANGER-10 WONDERBREAD)
          (CRAVES SCIATICA-26 OKRA)
          (EATS BACON ORANGE)
          (EATS ARUGULA POTATO)
          (HARMONY ENTERTAINMENT VENUS)
          (LOCALE POTATO ARIZONA)
          (EATS HOTDOG CHOCOLATE)
          (EATS HOTDOG TURKEY)
          (EATS POTATO BAGUETTE)
          (EATS BAGUETTE CUCUMBER)
          (EATS POTATO CHOCOLATE)
          (EATS SCALLION LETTUCE)
          (EATS PEPPER CANTELOPE)
          (CRAVES PROSTATITIS-17 LEMON)
          (EATS PEAR POTATO)
          (EATS GRAPEFRUIT APPLE)
          (EATS SCALLOP HAM)
          (ORBITS SATURN NEPTUNE)
          (EATS RICE SWEETROLL)
          (EATS MELON POPOVER)
          (EATS CHOCOLATE HOTDOG)
          (CRAVES SATIETY LOBSTER)
          (CRAVES DREAD-15 YOGURT)
          (EATS CANTELOPE PAPAYA)
          (LOCALE PAPAYA GOIAS)
          (LOCALE PORK PENNSYLVANIA)
          (EATS ORANGE BACON)
          (CRAVES GRIEF-56 FLOUNDER)
          (CRAVES GRIEF ONION)
          (LOCALE SNICKERS PENNSYLVANIA)
          (HARMONY LOVE NEPTUNE)
          (CRAVES LONELINESS-48 GRAPEFRUIT)
          (LOCALE CHICKEN PENNSYLVANIA)
          (CRAVES ABRASION-20 LEMON)
          (EATS ONION YOGURT)
          (EATS SCALLION LAMB)
          (CRAVES DEPRESSION-40 POPOVER)
          (CRAVES PROSTATITIS-42 SCALLION)
          (CRAVES HANGOVER-9 WONDERBREAD)
          (CRAVES SATIETY-4 MUFFIN)
          (HARMONY EMPATHY-1 EARTH)
          (EATS RICE WURST)
          (CRAVES ABRASION-30 CHICKEN)
          (EATS PAPAYA CANTELOPE))
   (:GOAL (AND (CRAVES HANGOVER LETTUCE)
               (CRAVES ANGER LETTUCE)
               (CRAVES ANGINA LETTUCE)
               (CRAVES DREAD LETTUCE)
               (CRAVES DEPRESSION-14 ORANGE)
               (CRAVES ABRASION LETTUCE))))

(DEFINE (PROBLEM STRIPS-MYSTY-32)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS GRAPEFRUIT-43 POTATO-44 PEA-45 BROCCOLI-46 TOMATO-47
             MARZIPAN-48 MUFFIN-49 SWEETROLL-50 LEMON-51 ARUGULA-52 ORANGE-53
             CHICKEN-54 TUNA-55 HAROSET-56 MELON-57 HOTDOG-58 APPLE-59
             SCALLOP-60 PEAR-61 CHERRY-62 PORK-63 TOFU-64 WURST-17
             WONDERBREAD-18 CANTELOPE-19 SNICKERS-20 HAM-21 POPOVER-22
             SCALLION-23 PAPAYA-24 YOGURT-25 FLOUNDER-26 CUCUMBER-27
             HAMBURGER-28 CHOCOLATE-29 LOBSTER-9 KALE-32 COD-31 LETTUCE-30
             BAGUETTE-10 OKRA-11 SHRIMP-12 BACON-13 BEEF-14 RICE-15 TURKEY-16
             LAMB-5 MUTTON-6 GUAVA-7 ENDIVE-8 GRAPEFRUIT-3 PISTACHIO-4
             PEPPER-1 ONION-2 CANTELOPE PAPAYA WURST LAMB WONDERBREAD
             CHOCOLATE HOTDOG ONION SCALLION LETTUCE CUCUMBER HAROSET PEPPER
             HAM GRAPEFRUIT PISTACHIO LOBSTER FLOUNDER POPOVER SHRIMP
             ORANGE RICE GUAVA TOMATO BAGUETTE SCALLOP OKRA SWEETROLL
             MUTTON BEEF HAMBURGER TOFU TURKEY MARZIPAN CHICKEN SNICKERS
             APPLE LEMON PEA MELON KALE BACON YOGURT TUNA ARUGULA CHERRY
             ENDIVE PEAR MUFFIN COD BROCCOLI PORK POTATO ENTERTAINMENT
             LUBRICITY SATISFACTION AESTHETICS EXPECTATION REST CURIOSITY
             EXCITEMENT EMPATHY STIMULATION ACHIEVEMENT LEARNING TRIUMPH
             SATIETY UNDERSTANDING LOVE INTOXICATION SATISFACTION-42
             CURIOSITY-41 EXCITEMENT-40 STIMULATION-39 ENTERTAINMENT-38
             INTOXICATION-37 ACHIEVEMENT-36 UNDERSTANDING-35 LUBRICITY-34
             LOVE-33 AESTHETICS-128 EXPECTATION-127 REST-126 SATIETY-125
             EMPATHY-124 TRIUMPH-123 LEARNING-122 EXPECTATION-121
             STIMULATION-120 LEARNING-119 SATISFACTION-118 REST-117
             EXCITEMENT-116 LOVE-115 LUBRICITY-114 TRIUMPH-113 AESTHETICS-112
             ACHIEVEMENT-111 SATIETY-110 UNDERSTANDING-109 INTOXICATION-108
             EMPATHY-107 CURIOSITY-106 ENTERTAINMENT-105 TRIUMPH-104
             EXPECTATION-103 CURIOSITY-102 ENTERTAINMENT-101 STIMULATION-100
             SATISFACTION-99 LUBRICITY-98 ACHIEVEMENT-97 AESTHETICS-96 ANGINA
             PROSTATITIS BOILS JEALOUSY DREAD GRIEF LACERATION DEPRESSION
             ANXIETY HANGOVER ANGER LONELINESS ABRASION SCIATICA
             HANGOVER-95 DREAD-94 PROSTATITIS-93 ANGER-92 LONELINESS-91
             ANGINA-90 BOILS-89 JEALOUSY-88 LACERATION-87 ANXIETY-86
             SCIATICA-85 DEPRESSION-84 GRIEF-83 ABRASION-82 DREAD-81
             ANXIETY-80 ANGER-79 BOILS-78 MORAVIA ALSACE URANUS SATURN MARS
             EARTH)
   (:INIT (FOOD GRAPEFRUIT-43)
          (FOOD POTATO-44)
          (FOOD PEA-45)
          (FOOD BROCCOLI-46)
          (FOOD TOMATO-47)
          (FOOD MARZIPAN-48)
          (FOOD MUFFIN-49)
          (FOOD SWEETROLL-50)
          (FOOD LEMON-51)
          (FOOD ARUGULA-52)
          (FOOD ORANGE-53)
          (FOOD CHICKEN-54)
          (FOOD TUNA-55)
          (FOOD HAROSET-56)
          (FOOD MELON-57)
          (FOOD HOTDOG-58)
          (FOOD APPLE-59)
          (FOOD SCALLOP-60)
          (FOOD PEAR-61)
          (FOOD CHERRY-62)
          (FOOD PORK-63)
          (FOOD TOFU-64)
          (FOOD WURST-17)
          (FOOD WONDERBREAD-18)
          (FOOD CANTELOPE-19)
          (FOOD SNICKERS-20)
          (FOOD HAM-21)
          (FOOD POPOVER-22)
          (FOOD SCALLION-23)
          (FOOD PAPAYA-24)
          (FOOD YOGURT-25)
          (FOOD FLOUNDER-26)
          (FOOD CUCUMBER-27)
          (FOOD HAMBURGER-28)
          (FOOD CHOCOLATE-29)
          (FOOD LOBSTER-9)
          (FOOD KALE-32)
          (FOOD COD-31)
          (FOOD LETTUCE-30)
          (FOOD BAGUETTE-10)
          (FOOD OKRA-11)
          (FOOD SHRIMP-12)
          (FOOD BACON-13)
          (FOOD BEEF-14)
          (FOOD RICE-15)
          (FOOD TURKEY-16)
          (FOOD LAMB-5)
          (FOOD MUTTON-6)
          (FOOD GUAVA-7)
          (FOOD ENDIVE-8)
          (FOOD GRAPEFRUIT-3)
          (FOOD PISTACHIO-4)
          (FOOD PEPPER-1)
          (FOOD ONION-2)
          (FOOD CANTELOPE)
          (FOOD PAPAYA)
          (FOOD WURST)
          (FOOD LAMB)
          (FOOD WONDERBREAD)
          (FOOD CHOCOLATE)
          (FOOD HOTDOG)
          (FOOD ONION)
          (FOOD SCALLION)
          (FOOD LETTUCE)
          (FOOD CUCUMBER)
          (FOOD HAROSET)
          (FOOD PEPPER)
          (FOOD HAM)
          (FOOD GRAPEFRUIT)
          (FOOD PISTACHIO)
          (FOOD LOBSTER)
          (FOOD FLOUNDER)
          (FOOD POPOVER)
          (FOOD SHRIMP)
          (FOOD ORANGE)
          (FOOD RICE)
          (FOOD GUAVA)
          (FOOD TOMATO)
          (FOOD BAGUETTE)
          (FOOD SCALLOP)
          (FOOD OKRA)
          (FOOD SWEETROLL)
          (FOOD MUTTON)
          (FOOD BEEF)
          (FOOD HAMBURGER)
          (FOOD TOFU)
          (FOOD TURKEY)
          (FOOD MARZIPAN)
          (FOOD CHICKEN)
          (FOOD SNICKERS)
          (FOOD APPLE)
          (FOOD LEMON)
          (FOOD PEA)
          (FOOD MELON)
          (FOOD KALE)
          (FOOD BACON)
          (FOOD YOGURT)
          (FOOD TUNA)
          (FOOD ARUGULA)
          (FOOD CHERRY)
          (FOOD ENDIVE)
          (FOOD PEAR)
          (FOOD MUFFIN)
          (FOOD COD)
          (FOOD BROCCOLI)
          (FOOD PORK)
          (FOOD POTATO)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE SATISFACTION)
          (PLEASURE AESTHETICS)
          (PLEASURE EXPECTATION)
          (PLEASURE REST)
          (PLEASURE CURIOSITY)
          (PLEASURE EXCITEMENT)
          (PLEASURE EMPATHY)
          (PLEASURE STIMULATION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LEARNING)
          (PLEASURE TRIUMPH)
          (PLEASURE SATIETY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LOVE)
          (PLEASURE INTOXICATION)
          (PLEASURE SATISFACTION-42)
          (PLEASURE CURIOSITY-41)
          (PLEASURE EXCITEMENT-40)
          (PLEASURE STIMULATION-39)
          (PLEASURE ENTERTAINMENT-38)
          (PLEASURE INTOXICATION-37)
          (PLEASURE ACHIEVEMENT-36)
          (PLEASURE UNDERSTANDING-35)
          (PLEASURE LUBRICITY-34)
          (PLEASURE LOVE-33)
          (PLEASURE AESTHETICS-128)
          (PLEASURE EXPECTATION-127)
          (PLEASURE REST-126)
          (PLEASURE SATIETY-125)
          (PLEASURE EMPATHY-124)
          (PLEASURE TRIUMPH-123)
          (PLEASURE LEARNING-122)
          (PLEASURE EXPECTATION-121)
          (PLEASURE STIMULATION-120)
          (PLEASURE LEARNING-119)
          (PLEASURE SATISFACTION-118)
          (PLEASURE REST-117)
          (PLEASURE EXCITEMENT-116)
          (PLEASURE LOVE-115)
          (PLEASURE LUBRICITY-114)
          (PLEASURE TRIUMPH-113)
          (PLEASURE AESTHETICS-112)
          (PLEASURE ACHIEVEMENT-111)
          (PLEASURE SATIETY-110)
          (PLEASURE UNDERSTANDING-109)
          (PLEASURE INTOXICATION-108)
          (PLEASURE EMPATHY-107)
          (PLEASURE CURIOSITY-106)
          (PLEASURE ENTERTAINMENT-105)
          (PLEASURE TRIUMPH-104)
          (PLEASURE EXPECTATION-103)
          (PLEASURE CURIOSITY-102)
          (PLEASURE ENTERTAINMENT-101)
          (PLEASURE STIMULATION-100)
          (PLEASURE SATISFACTION-99)
          (PLEASURE LUBRICITY-98)
          (PLEASURE ACHIEVEMENT-97)
          (PLEASURE AESTHETICS-96)
          (PAIN ANGINA)
          (PAIN PROSTATITIS)
          (PAIN BOILS)
          (PAIN JEALOUSY)
          (PAIN DREAD)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN SCIATICA)
          (PAIN HANGOVER-95)
          (PAIN DREAD-94)
          (PAIN PROSTATITIS-93)
          (PAIN ANGER-92)
          (PAIN LONELINESS-91)
          (PAIN ANGINA-90)
          (PAIN BOILS-89)
          (PAIN JEALOUSY-88)
          (PAIN LACERATION-87)
          (PAIN ANXIETY-86)
          (PAIN SCIATICA-85)
          (PAIN DEPRESSION-84)
          (PAIN GRIEF-83)
          (PAIN ABRASION-82)
          (PAIN DREAD-81)
          (PAIN ANXIETY-80)
          (PAIN ANGER-79)
          (PAIN BOILS-78)
          (PROVINCE MORAVIA)
          (PROVINCE ALSACE)
          (PLANET URANUS)
          (PLANET SATURN)
          (PLANET MARS)
          (PLANET EARTH)
          (EATS SHRIMP GUAVA)
          (EATS CANTELOPE FLOUNDER)
          (HARMONY SATISFACTION SATURN)
          (EATS PEPPER ORANGE)
          (EATS CHERRY-62 KALE-32)
          (EATS ENDIVE-8 MUFFIN)
          (HARMONY EMPATHY EARTH)
          (CRAVES CURIOSITY CHICKEN-54)
          (EATS LETTUCE MELON)
          (EATS BAGUETTE-10 WONDERBREAD)
          (HARMONY EXCITEMENT-40 MARS)
          (EATS POPOVER GRAPEFRUIT-3)
          (EATS WONDERBREAD BAGUETTE-10)
          (CRAVES JEALOUSY-88 CUCUMBER)
          (LOCALE HOTDOG ALSACE)
          (EATS BAGUETTE-10 KALE)
          (CRAVES TRIUMPH-123 CANTELOPE)
          (EATS KALE CHERRY)
          (CRAVES ENTERTAINMENT-38 BAGUETTE-10)
          (EATS TUNA-55 BROCCOLI-46)
          (EATS ENDIVE CHERRY)
          (EATS HAM-21 ARUGULA-52)
          (HARMONY INTOXICATION MARS)
          (EATS WONDERBREAD-18 PAPAYA-24)
          (HARMONY EMPATHY-107 MARS)
          (EATS LETTUCE LEMON)
          (HARMONY LUBRICITY-34 SATURN)
          (CRAVES GRIEF-83 CHICKEN)
          (EATS COD-31 FLOUNDER-26)
          (EATS CHICKEN SWEETROLL)
          (EATS HAMBURGER BAGUETTE)
          (EATS BROCCOLI-46 TUNA-55)
          (EATS HAM POPOVER)
          (EATS WURST FLOUNDER)
          (EATS HAROSET CHICKEN)
          (LOCALE ARUGULA ALSACE)
          (EATS TOMATO-47 SCALLION-23)
          (LOCALE SNICKERS ALSACE)
          (CRAVES TRIUMPH-113 FLOUNDER)
          (EATS POPOVER-22 CANTELOPE-19)
          (EATS APPLE POPOVER)
          (EATS CHOCOLATE-29 LEMON-51)
          (EATS MARZIPAN LAMB-5)
          (EATS SNICKERS-20 TUNA-55)
          (EATS ONION-2 PEA)
          (EATS HOTDOG LEMON)
          (CRAVES LONELINESS-91 ONION-2)
          (EATS SWEETROLL-50 KALE-32)
          (EATS TURKEY-16 PEPPER)
          (HARMONY LUBRICITY-114 SATURN)
          (EATS PEA GUAVA)
          (EATS SCALLOP LAMB-5)
          (LOCALE GRAPEFRUIT-3 MORAVIA)
          (EATS WURST-17 CHOCOLATE-29)
          (EATS MUFFIN ENDIVE-8)
          (EATS GRAPEFRUIT-43 CUCUMBER-27)
          (EATS OKRA-11 POTATO)
          (EATS FLOUNDER-26 COD-31)
          (LOCALE SHRIMP-12 ALSACE)
          (EATS TURKEY SHRIMP-12)
          (LOCALE PEPPER MORAVIA)
          (EATS RICE PEAR)
          (EATS PORK HAMBURGER)
          (EATS POTATO ORANGE)
          (LOCALE PISTACHIO MORAVIA)
          (EATS PEA MUTTON)
          (LOCALE PORK-63 ALSACE)
          (EATS CUCUMBER-27 PEA-45)
          (LOCALE APPLE-59 ALSACE)
          (LOCALE MUTTON MORAVIA)
          (LOCALE PEA-45 MORAVIA)
          (EATS APPLE PISTACHIO)
          (EATS TOFU RICE)
          (CRAVES EXPECTATION-103 BACON)
          (CRAVES TRIUMPH-104 MELON)
          (EATS TOFU-64 WONDERBREAD-18)
          (EATS LETTUCE-30 CHOCOLATE-29)
          (EATS BROCCOLI HAROSET)
          (LOCALE ONION MORAVIA)
          (LOCALE MARZIPAN ALSACE)
          (CRAVES ACHIEVEMENT-111 RICE)
          (EATS GRAPEFRUIT PEA)
          (EATS BAGUETTE PEAR)
          (HARMONY CURIOSITY-106 EARTH)
          (HARMONY TRIUMPH-113 SATURN)
          (CRAVES STIMULATION-120 ONION)
          (EATS HAMBURGER-28 SCALLION-23)
          (LOCALE CHOCOLATE ALSACE)
          (EATS WONDERBREAD FLOUNDER)
          (EATS CHERRY ENDIVE)
          (EATS CUCUMBER-27 GRAPEFRUIT-43)
          (EATS TURKEY-16 MARZIPAN)
          (LOCALE POPOVER MORAVIA)
          (EATS OKRA KALE)
          (EATS CHOCOLATE APPLE)
          (CRAVES LUBRICITY-34 BEEF-14)
          (EATS MARZIPAN-48 FLOUNDER-26)
          (EATS SCALLOP-60 APPLE-59)
          (EATS GUAVA-7 PEAR)
          (EATS LEMON KALE)
          (EATS BACON-13 CHICKEN)
          (EATS TURKEY BACON)
          (LOCALE COD-31 MORAVIA)
          (EATS YOGURT-25 FLOUNDER-26)
          (EATS RICE TOFU)
          (EATS PISTACHIO ONION)
          (HARMONY ENTERTAINMENT MARS)
          (EATS HAMBURGER-28 LOBSTER-9)
          (EATS YOGURT MUFFIN)
          (EATS PEPPER SCALLOP)
          (LOCALE ONION-2 MORAVIA)
          (EATS APPLE-59 HAMBURGER-28)
          (EATS HAMBURGER GUAVA-7)
          (LOCALE PISTACHIO-4 MORAVIA)
          (EATS SNICKERS-20 HAROSET-56)
          (LOCALE BAGUETTE-10 ALSACE)
          (EATS PEPPER TURKEY-16)
          (HARMONY UNDERSTANDING-35 SATURN)
          (EATS HAM GRAPEFRUIT-3)
          (EATS PAPAYA-24 TOFU-64)
          (EATS MUTTON-6 ORANGE)
          (HARMONY EMPATHY-124 SATURN)
          (EATS HAROSET LEMON-51)
          (LOCALE BACON-13 MORAVIA)
          (HARMONY STIMULATION-39 SATURN)
          (LOCALE HAM ALSACE)
          (EATS SCALLOP GUAVA)
          (CRAVES EXPECTATION-121 WONDERBREAD)
          (EATS PEAR BAGUETTE)
          (EATS TOFU-64 YOGURT-25)
          (EATS FLOUNDER WURST)
          (HARMONY EXCITEMENT-116 MARS)
          (EATS YOGURT-25 SNICKERS-20)
          (EATS PEPPER-1 SWEETROLL)
          (EATS SNICKERS MUFFIN)
          (EATS CUCUMBER-27 LEMON-51)
          (EATS POTATO COD)
          (CRAVES BOILS LEMON-51)
          (LOCALE LEMON MORAVIA)
          (EATS SHRIMP-12 TURKEY)
          (LOCALE OKRA-11 MORAVIA)
          (CRAVES REST-117 HAM)
          (HARMONY EXCITEMENT MARS)
          (EATS LETTUCE CHERRY)
          (EATS PEAR BROCCOLI)
          (EATS BROCCOLI PEAR)
          (HARMONY AESTHETICS-96 SATURN)
          (HARMONY EXPECTATION-103 MARS)
          (EATS PEAR PORK)
          (EATS BEEF-14 PISTACHIO-4)
          (LOCALE CHERRY-62 ALSACE)
          (CRAVES SATIETY-110 TOMATO)
          (LOCALE SHRIMP ALSACE)
          (LOCALE POPOVER-22 ALSACE)
          (HARMONY TRIUMPH EARTH)
          (EATS GUAVA MUTTON-6)
          (EATS PISTACHIO APPLE)
          (LOCALE GRAPEFRUIT MORAVIA)
          (CRAVES INTOXICATION-108 HAMBURGER)
          (EATS ORANGE PEPPER)
          (EATS PORK-63 KALE-32)
          (EATS KALE LEMON)
          (EATS LEMON TURKEY)
          (EATS KALE-32 MARZIPAN-48)
          (CRAVES SATIETY-125 PEPPER-1)
          (EATS CHOCOLATE HAM)
          (EATS GUAVA MARZIPAN-48)
          (EATS GUAVA SCALLOP)
          (CRAVES SATIETY HAM-21)
          (EATS HAM PISTACHIO)
          (EATS ORANGE MUTTON-6)
          (EATS MELON-57 SNICKERS-20)
          (EATS WONDERBREAD-18 ORANGE-53)
          (CRAVES ANGINA-90 WURST)
          (EATS GUAVA-7 HAMBURGER)
          (CRAVES EMPATHY-124 ONION-2)
          (EATS PEAR HOTDOG)
          (EATS POTATO PISTACHIO)
          (EATS BROCCOLI-46 CHERRY-62)
          (EATS SCALLOP SCALLION)
          (EATS KALE BAGUETTE-10)
          (EATS RICE-15 BACON-13)
          (EATS HAM-21 KALE-32)
          (HARMONY SATIETY-110 EARTH)
          (EATS POPOVER POTATO)
          (LOCALE OKRA MORAVIA)
          (EATS PISTACHIO HAM)
          (CRAVES JEALOUSY CHICKEN-54)
          (EATS BEEF PEAR)
          (CRAVES DREAD SCALLOP-60)
          (HARMONY AESTHETICS-128 EARTH)
          (CRAVES ANGER-79 ENDIVE)
          (LOCALE CANTELOPE-19 ALSACE)
          (HARMONY LOVE EARTH)
          (HARMONY SATIETY-125 SATURN)
          (LOCALE RICE MORAVIA)
          (CRAVES DEPRESSION-84 BEEF)
          (EATS HAMBURGER PORK)
          (EATS PAPAYA-24 WONDERBREAD-18)
          (CRAVES AESTHETICS-128 LAMB-5)
          (CRAVES ACHIEVEMENT-97 MUFFIN)
          (EATS ENDIVE-8 ARUGULA)
          (EATS MARZIPAN SCALLOP)
          (EATS POTATO PEPPER)
          (EATS CHOCOLATE-29 POPOVER-22)
          (EATS CUCUMBER BROCCOLI)
          (EATS WURST MARZIPAN)
          (EATS PORK PEAR)
          (LOCALE LEMON-51 ALSACE)
          (EATS LOBSTER-9 HAMBURGER-28)
          (EATS BACON TURKEY)
          (CRAVES EMPATHY MELON-57)
          (LOCALE TOMATO MORAVIA)
          (EATS PEAR-61 LETTUCE-30)
          (CRAVES REST-126 PISTACHIO-4)
          (LOCALE WURST ALSACE)
          (EATS KALE-32 SWEETROLL-50)
          (EATS PEPPER-1 MARZIPAN)
          (EATS PISTACHIO-4 LAMB-5)
          (EATS MARZIPAN-48 PORK-63)
          (EATS TURKEY LEMON)
          (LOCALE ENDIVE-8 ALSACE)
          (EATS LEMON HOTDOG)
          (HARMONY INTOXICATION-108 SATURN)
          (EATS PORK-63 YOGURT-25)
          (EATS SCALLION MUTTON)
          (EATS GRAPEFRUIT APPLE)
          (EATS TUNA ENDIVE-8)
          (CRAVES UNDERSTANDING POPOVER-22)
          (EATS MELON LETTUCE)
          (CRAVES STIMULATION-39 LETTUCE-30)
          (LOCALE CUCUMBER-27 ALSACE)
          (LOCALE FLOUNDER ALSACE)
          (LOCALE KALE-32 ALSACE)
          (CRAVES REST MUFFIN-49)
          (EATS ENDIVE MELON)
          (EATS WONDERBREAD-18 CHOCOLATE-29)
          (LOCALE PAPAYA MORAVIA)
          (LOCALE BROCCOLI MORAVIA)
          (EATS GRAPEFRUIT-43 TOMATO-47)
          (EATS SCALLION SHRIMP)
          (EATS SCALLION-23 HAMBURGER-28)
          (LOCALE CHOCOLATE-29 ALSACE)
          (HARMONY ACHIEVEMENT-97 SATURN)
          (LOCALE HOTDOG-58 ALSACE)
          (EATS CUCUMBER MUTTON)
          (EATS KALE-32 HAM-21)
          (EATS POPOVER HAM)
          (LOCALE CHERRY ALSACE)
          (LOCALE BEEF MORAVIA)
          (HARMONY LEARNING-122 MARS)
          (CRAVES ENTERTAINMENT-101 TUNA)
          (HARMONY EXPECTATION-121 SATURN)
          (CRAVES STIMULATION HOTDOG-58)
          (EATS KALE OKRA)
          (LOCALE POTATO MORAVIA)
          (LOCALE POTATO-44 MORAVIA)
          (EATS GUAVA PEPPER)
          (EATS CHICKEN HAROSET)
          (EATS TUNA-55 SNICKERS-20)
          (LOCALE PORK MORAVIA)
          (EATS ARUGULA ENDIVE-8)
          (LOCALE CUCUMBER ALSACE)
          (EATS TOFU BACON)
          (LOCALE HAMBURGER-28 ALSACE)
          (HARMONY ENTERTAINMENT-105 SATURN)
          (EATS ARUGULA SHRIMP-12)
          (EATS CHICKEN-54 MUFFIN-49)
          (LOCALE HAROSET-56 ALSACE)
          (CRAVES SATISFACTION-99 ENDIVE)
          (EATS SWEETROLL-50 SNICKERS-20)
          (CRAVES ENTERTAINMENT GRAPEFRUIT-43)
          (EATS SHRIMP SCALLOP)
          (LOCALE PEA MORAVIA)
          (CRAVES LEARNING-122 PAPAYA)
          (HARMONY CURIOSITY-41 EARTH)
          (HARMONY SATISFACTION-42 EARTH)
          (LOCALE MELON-57 ALSACE)
          (CRAVES SATISFACTION-118 PEPPER)
          (EATS LAMB-5 SCALLOP)
          (LOCALE HAM-21 MORAVIA)
          (LOCALE LOBSTER-9 ALSACE)
          (EATS COD POPOVER)
          (EATS TOMATO-47 GRAPEFRUIT-43)
          (CRAVES ABRASION RICE-15)
          (EATS SWEETROLL PEPPER-1)
          (EATS CANTELOPE OKRA-11)
          (CRAVES LUBRICITY-114 LOBSTER)
          (EATS APPLE CHOCOLATE)
          (LOCALE ENDIVE MORAVIA)
          (CRAVES CURIOSITY-41 LOBSTER-9)
          (EATS MUFFIN-49 MELON-57)
          (CRAVES EMPATHY-107 MARZIPAN)
          (EATS POTATO MARZIPAN)
          (EATS SWEETROLL CHICKEN)
          (LOCALE TOMATO-47 MORAVIA)
          (EATS BAGUETTE LAMB)
          (CRAVES PROSTATITIS-93 PISTACHIO-4)
          (EATS PEPPER POTATO)
          (HARMONY STIMULATION SATURN)
          (EATS LOBSTER-9 HAM-21)
          (CRAVES ANGER-92 PEPPER-1)
          (LOCALE YOGURT ALSACE)
          (ATTACKS MORAVIA ALSACE)
          (CRAVES LACERATION-87 GRAPEFRUIT)
          (CRAVES ANXIETY PAPAYA-24)
          (EATS KALE-32 CHERRY-62)
          (EATS PISTACHIO POTATO)
          (EATS MUFFIN SNICKERS)
          (EATS SCALLION SCALLOP)
          (CRAVES ANGINA POTATO-44)
          (HARMONY TRIUMPH-104 SATURN)
          (EATS CHOCOLATE-29 WONDERBREAD-18)
          (EATS CUCUMBER-27 POTATO-44)
          (EATS MARZIPAN-48 GUAVA)
          (CRAVES SCIATICA-85 MUTTON)
          (EATS FLOUNDER-26 MARZIPAN-48)
          (CRAVES GRIEF WONDERBREAD-18)
          (HARMONY STIMULATION-120 MARS)
          (LOCALE PEPPER-1 ALSACE)
          (EATS CHERRY-62 ARUGULA-52)
          (EATS BACON SNICKERS)
          (HARMONY SATISFACTION-118 SATURN)
          (EATS POTATO OKRA-11)
          (CRAVES SATISFACTION-42 YOGURT-25)
          (LOCALE ORANGE-53 MORAVIA)
          (LOCALE HAROSET ALSACE)
          (EATS TOMATO CHERRY)
          (LOCALE APPLE MORAVIA)
          (CRAVES UNDERSTANDING-35 BACON-13)
          (EATS PEA ONION-2)
          (EATS PISTACHIO-4 BEEF-14)
          (EATS ORANGE-53 WONDERBREAD-18)
          (EATS ORANGE-53 FLOUNDER-26)
          (EATS SWEETROLL KALE)
          (EATS ONION ONION-2)
          (CRAVES LACERATION CANTELOPE-19)
          (EATS APPLE-59 SCALLOP-60)
          (LOCALE MUFFIN MORAVIA)
          (CRAVES ANXIETY-86 BAGUETTE)
          (EATS GUAVA PEA)
          (LOCALE BACON MORAVIA)
          (EATS MARZIPAN PEPPER-1)
          (EATS HAMBURGER-28 PEAR-61)
          (EATS PISTACHIO ORANGE)
          (EATS CHERRY LETTUCE)
          (HARMONY LEARNING SATURN)
          (EATS FLOUNDER WONDERBREAD)
          (LOCALE MELON ALSACE)
          (EATS FLOUNDER CANTELOPE)
          (EATS LAMB-5 PISTACHIO-4)
          (EATS YOGURT-25 TOFU-64)
          (CRAVES LOVE-115 PISTACHIO)
          (EATS LEMON-51 CHOCOLATE-29)
          (EATS PAPAYA YOGURT)
          (LOCALE FLOUNDER-26 MORAVIA)
          (EATS WURST-17 PAPAYA-24)
          (CRAVES UNDERSTANDING-109 SWEETROLL)
          (LOCALE KALE MORAVIA)
          (EATS RICE-15 BEEF)
          (LOCALE LETTUCE MORAVIA)
          (LOCALE SWEETROLL-50 ALSACE)
          (LOCALE YOGURT-25 ALSACE)
          (EATS OKRA BEEF)
          (EATS PEAR-61 HAMBURGER-28)
          (LOCALE MUTTON-6 MORAVIA)
          (EATS GRAPEFRUIT-3 POTATO)
          (HARMONY EXPECTATION-127 EARTH)
          (EATS MUFFIN MELON)
          (CRAVES INTOXICATION PAPAYA-24)
          (EATS MARZIPAN WURST)
          (LOCALE CHICKEN-54 ALSACE)
          (EATS CHICKEN BACON-13)
          (EATS SCALLOP PEPPER)
          (EATS BAGUETTE HAMBURGER)
          (EATS PORK-63 MARZIPAN-48)
          (CRAVES LOVE-33 TURKEY-16)
          (HARMONY REST-117 SATURN)
          (CRAVES ACHIEVEMENT-36 SHRIMP-12)
          (LOCALE ORANGE MORAVIA)
          (EATS BROCCOLI BEEF-14)
          (HARMONY UNDERSTANDING-109 MARS)
          (EATS MELON TUNA)
          (EATS ONION PISTACHIO)
          (CRAVES LEARNING PEAR-61)
          (EATS CANTELOPE-19 HOTDOG-58)
          (CRAVES EXCITEMENT TUNA-55)
          (EATS GRAPEFRUIT-3 HAM)
          (CRAVES LONELINESS BAGUETTE-10)
          (LOCALE TUNA-55 ALSACE)
          (EATS PEAR BEEF)
          (HARMONY TRIUMPH-123 MARS)
          (EATS HAMBURGER-28 APPLE-59)
          (LOCALE SCALLOP-60 ALSACE)
          (CRAVES DREAD-81 KALE)
          (EATS POPOVER-22 CHOCOLATE-29)
          (CRAVES HANGOVER CUCUMBER-27)
          (HARMONY LOVE-115 SATURN)
          (LOCALE LAMB MORAVIA)
          (HARMONY LUBRICITY-98 SATURN)
          (LOCALE CHICKEN ALSACE)
          (EATS MELON MUFFIN)
          (EATS PAPAYA BAGUETTE)
          (CRAVES DEPRESSION SCALLION-23)
          (EATS BROCCOLI SCALLOP)
          (EATS CHOCOLATE-29 WURST-17)
          (LOCALE SNICKERS-20 ALSACE)
          (LOCALE LAMB-5 ALSACE)
          (EATS SCALLOP BROCCOLI)
          (HARMONY ENTERTAINMENT-101 MARS)
          (EATS APPLE GRAPEFRUIT)
          (EATS HAM-21 LOBSTER-9)
          (EATS PEAR RICE)
          (HARMONY SATIETY SATURN)
          (LOCALE MUFFIN-49 ALSACE)
          (EATS BAGUETTE PAPAYA)
          (LOCALE WONDERBREAD MORAVIA)
          (HARMONY AESTHETICS MARS)
          (EATS SCALLOP SHRIMP)
          (EATS MUTTON SCALLION)
          (EATS BEEF RICE-15)
          (EATS POTATO TOMATO)
          (EATS SNICKERS-20 PEA-45)
          (EATS POPOVER APPLE)
          (ORBITS SATURN MARS)
          (EATS GRAPEFRUIT-3 POPOVER)
          (EATS BACON TOFU)
          (CRAVES AESTHETICS-112 SHRIMP)
          (EATS BEEF-14 BROCCOLI)
          (HARMONY INTOXICATION-37 EARTH)
          (CRAVES ABRASION-82 APPLE)
          (LOCALE BEEF-14 ALSACE)
          (CRAVES LOVE SCALLION-23)
          (HARMONY STIMULATION-100 SATURN)
          (EATS SNICKERS-20 MELON-57)
          (CRAVES ANGER COD-31)
          (EATS KALE SWEETROLL)
          (LOCALE GUAVA ALSACE)
          (EATS MUTTON PEA)
          (EATS MUTTON-6 GUAVA)
          (EATS LAMB BAGUETTE)
          (EATS PEAR LOBSTER)
          (CRAVES EXPECTATION MARZIPAN-48)
          (CRAVES INTOXICATION-37 OKRA-11)
          (EATS PEA-45 SNICKERS-20)
          (HARMONY REST-126 EARTH)
          (CRAVES HANGOVER-95 GUAVA-7)
          (LOCALE TURKEY-16 MORAVIA)
          (LOCALE TOFU MORAVIA)
          (LOCALE TOFU-64 MORAVIA)
          (EATS YOGURT PAPAYA)
          (EATS POTATO-44 CUCUMBER-27)
          (EATS BROCCOLI CUCUMBER)
          (LOCALE COD ALSACE)
          (EATS CHERRY KALE)
          (EATS LEMON-51 HAROSET)
          (EATS MUTTON CUCUMBER)
          (CRAVES AESTHETICS TOMATO-47)
          (HARMONY SATISFACTION-99 SATURN)
          (CRAVES ANXIETY-80 CHERRY)
          (EATS PAPAYA-24 WURST-17)
          (CRAVES CURIOSITY-106 CHICKEN)
          (EATS SNICKERS-20 YOGURT-25)
          (EATS SCALLOP-60 HAROSET-56)
          (CRAVES ACHIEVEMENT APPLE-59)
          (EATS BACON-13 RICE-15)
          (CRAVES DREAD-94 ENDIVE-8)
          (LOCALE WONDERBREAD-18 ALSACE)
          (HARMONY LOVE-33 SATURN)
          (EATS HAROSET-56 SNICKERS-20)
          (EATS GUAVA SHRIMP)
          (EATS SCALLOP MUTTON)
          (EATS SCALLION-23 TOMATO-47)
          (EATS PEA-45 CUCUMBER-27)
          (LOCALE SCALLION-23 ALSACE)
          (EATS HAM CHOCOLATE)
          (EATS PEPPER GUAVA)
          (EATS COD-31 WONDERBREAD-18)
          (EATS BEEF OKRA)
          (EATS HAMBURGER YOGURT)
          (EATS CHERRY-62 BROCCOLI-46)
          (LOCALE BROCCOLI-46 MORAVIA)
          (EATS WONDERBREAD-18 YOGURT-25)
          (HARMONY LUBRICITY SATURN)
          (EATS ONION-2 ONION)
          (EATS TOFU-64 PAPAYA-24)
          (CRAVES STIMULATION-100 CHERRY)
          (EATS ENDIVE-8 TUNA)
          (EATS FLOUNDER-26 YOGURT-25)
          (LOCALE SCALLION MORAVIA)
          (EATS HOTDOG PEAR)
          (CRAVES BOILS-78 PORK)
          (CRAVES AESTHETICS-96 COD)
          (LOCALE PEAR-61 MORAVIA)
          (EATS YOGURT-25 WONDERBREAD-18)
          (ORBITS MARS EARTH)
          (CRAVES SATISFACTION BROCCOLI-46)
          (HARMONY CURIOSITY EARTH)
          (EATS YOGURT HAMBURGER)
          (LOCALE LOBSTER MORAVIA)
          (LOCALE SCALLOP MORAVIA)
          (HARMONY CURIOSITY-102 SATURN)
          (EATS ARUGULA-52 CHERRY-62)
          (CRAVES SCIATICA LAMB-5)
          (LOCALE TUNA MORAVIA)
          (CRAVES PROSTATITIS SWEETROLL-50)
          (LOCALE HAMBURGER MORAVIA)
          (EATS WONDERBREAD-18 COD-31)
          (EATS POPOVER COD)
          (EATS MARZIPAN POTATO)
          (EATS POTATO POPOVER)
          (LOCALE PAPAYA-24 ALSACE)
          (EATS MUFFIN YOGURT)
          (HARMONY ENTERTAINMENT-38 MARS)
          (LOCALE ARUGULA-52 MORAVIA)
          (LOCALE CANTELOPE MORAVIA)
          (EATS MUTTON SCALLOP)
          (EATS COD POTATO)
          (EATS MUFFIN ENDIVE)
          (EATS CHOCOLATE-29 LETTUCE-30)
          (HARMONY ACHIEVEMENT-36 SATURN)
          (CRAVES LUBRICITY-98 PEAR)
          (EATS OKRA-11 CANTELOPE)
          (EATS POPOVER-22 YOGURT-25)
          (CRAVES EXPECTATION-127 MUTTON-6)
          (EATS TUNA MELON)
          (HARMONY REST EARTH)
          (EATS MELON ENDIVE)
          (EATS CHICKEN-54 LOBSTER-9)
          (EATS ARUGULA-52 HAM-21)
          (EATS LOBSTER KALE)
          (EATS LEMON LETTUCE)
          (LOCALE TURKEY MORAVIA)
          (HARMONY UNDERSTANDING MARS)
          (EATS KALE-32 PORK-63)
          (EATS FLOUNDER-26 ORANGE-53)
          (EATS LOBSTER-9 CHICKEN-54)
          (EATS MUFFIN-49 CHICKEN-54)
          (CRAVES LUBRICITY POTATO-44)
          (LOCALE RICE-15 MORAVIA)
          (EATS MELON-57 MUFFIN-49)
          (EATS YOGURT-25 POPOVER-22)
          (LOCALE SWEETROLL ALSACE)
          (EATS HAROSET BROCCOLI)
          (EATS ORANGE PISTACHIO)
          (HARMONY EXPECTATION EARTH)
          (EATS SNICKERS BACON)
          (EATS HOTDOG-58 CANTELOPE-19)
          (HARMONY ACHIEVEMENT-111 EARTH)
          (EATS PEA GRAPEFRUIT)
          (LOCALE MARZIPAN-48 MORAVIA)
          (EATS SNICKERS LAMB)
          (EATS HAROSET-56 SCALLOP-60)
          (EATS TOMATO POTATO)
          (LOCALE GRAPEFRUIT-43 MORAVIA)
          (EATS SHRIMP SCALLION)
          (EATS ORANGE POTATO)
          (EATS POTATO-44 HOTDOG-58)
          (ORBITS URANUS SATURN)
          (CRAVES LEARNING-119 HAROSET)
          (EATS CANTELOPE-19 POPOVER-22)
          (EATS CHERRY TOMATO)
          (EATS LAMB-5 MARZIPAN)
          (EATS LEMON-51 CUCUMBER-27)
          (EATS LETTUCE-30 PEAR-61)
          (EATS KALE LOBSTER)
          (LOCALE LETTUCE-30 MORAVIA)
          (EATS MARZIPAN TURKEY-16)
          (HARMONY ACHIEVEMENT SATURN)
          (EATS PEAR GUAVA-7)
          (LOCALE PEAR MORAVIA)
          (LOCALE WURST-17 MORAVIA)
          (CRAVES BOILS-89 SCALLION)
          (CRAVES EXCITEMENT-40 KALE-32)
          (EATS SNICKERS-20 SWEETROLL-50)
          (EATS SCALLOP MARZIPAN)
          (EATS MARZIPAN-48 KALE-32)
          (CRAVES CURIOSITY-102 YOGURT)
          (HARMONY AESTHETICS-112 EARTH)
          (EATS WONDERBREAD-18 TOFU-64)
          (HARMONY LEARNING-119 MARS)
          (CRAVES TRIUMPH PORK-63)
          (LOCALE GUAVA-7 ALSACE)
          (EATS LAMB SNICKERS)
          (CRAVES EXCITEMENT-116 GRAPEFRUIT)
          (CRAVES ENTERTAINMENT-105 SNICKERS)
          (EATS POTATO GRAPEFRUIT-3)
          (EATS SHRIMP-12 ARUGULA)
          (EATS HOTDOG-58 POTATO-44)
          (EATS LOBSTER PEAR)
          (EATS YOGURT-25 PORK-63)
          (LOCALE BAGUETTE ALSACE)
          (EATS ENDIVE MUFFIN))
   (:GOAL (AND (CRAVES LACERATION-87 PORK)
               (CRAVES DREAD GUAVA)
               (CRAVES DREAD-81 PEPPER)
               (CRAVES HANGOVER-95 LAMB-5)
               (CRAVES SCIATICA SHRIMP-12)
               (CRAVES ANGER-92 POPOVER-22)
               (CRAVES JEALOUSY POPOVER-22))))

(DEFINE (PROBLEM STRIPS-MYSTY-33)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TOFU-16 ARUGULA-5 LAMB-6 SNICKERS-7 CHICKEN-8
             LOBSTER-3 PEAR-4 CUCUMBER-1 YOGURT-2 APPLE BEEF PISTACHIO
             ARUGULA CUCUMBER ENDIVE RICE PEPPER MUTTON ONION MUFFIN SHRIMP
             BAGUETTE SCALLION TOFU PAPAYA GUAVA CANTELOPE HOTDOG TOMATO
             SWEETROLL LETTUCE PORK WONDERBREAD TURKEY LEMON KALE SNICKERS
             YOGURT POPOVER TUNA LOBSTER POTATO CHOCOLATE BACON HAM SCALLOP
             MELON WURST LAMB PEA MARZIPAN HAROSET HAMBURGER ORANGE
             GRAPEFRUIT CHICKEN FLOUNDER COD CHERRY OKRA BROCCOLI PEAR
             LUBRICITY ACHIEVEMENT EMPATHY EXPECTATION STIMULATION
             AESTHETICS ENTERTAINMENT SATISFACTION CURIOSITY LEARNING REST
             EXCITEMENT LONELINESS ANGINA LACERATION DEPRESSION HANGOVER
             BOILS GRIEF ABRASION ANXIETY DREAD PROSTATITIS-15 SCIATICA
             ANGER JEALOUSY PROSTATITIS HANGOVER-14 LONELINESS-10
             ANXIETY-11 DREAD-12 ABRASION-13 JEALOUSY-31 ANGER-32
             LACERATION-9 DEPRESSION-30 SCIATICA-26 BOILS-27 ANGINA-28
             GRIEF-29 PROSTATITIS-22 JEALOUSY-23 ANGER-24 BOILS-25
             DEPRESSION-17 ANGINA-18 HANGOVER-19 LACERATION-20 ANXIETY-21
             ABRASION-61 SCIATICA-62 GRIEF-63 LONELINESS-64 HANGOVER-57
             JEALOUSY-58 BOILS-59 DREAD-60 ANXIETY-53 ANGER-54 DEPRESSION-55
             LONELINESS-56 ANGINA-51 LACERATION-52 PROSTATITIS-48 SCIATICA-49
             GRIEF-50 ABRASION-47 ANGER-44 ANGINA-45 DREAD-46
             LONELINESS-42 BOILS-43 HANGOVER-40 SCIATICA-41 ANXIETY-37
             JEALOUSY-38 DEPRESSION-39 PROSTATITIS-128 DREAD-33 ABRASION-34
             GRIEF-35 LACERATION-36 ANXIETY-123 GRIEF-124 LACERATION-125
             HANGOVER-126 DREAD-127 SCIATICA-119 LONELINESS-120 ABRASION-121
             JEALOUSY-122 PROSTATITIS-114 ANGER-115 ANGINA-116 DEPRESSION-117
             BOILS-118 ANGER-111 ANGINA-112 BOILS-113 ANXIETY-107
             HANGOVER-108 JEALOUSY-109 ABRASION-110 LACERATION-106 DREAD-104
             LONELINESS-105 GRIEF-100 DEPRESSION-101 PROSTATITIS-102
             SCIATICA-103 SCIATICA-98 ABRASION-99 ANXIETY-96 JEALOUSY-97
             ANGER-95 DEPRESSION-90 DREAD-91 LONELINESS-92 PROSTATITIS-93
             BOILS-94 ANGINA-87 HANGOVER-88 LACERATION-89 DEPRESSION-84
             GRIEF-85 GRIEF-86 SCIATICA-79 DREAD-80 ABRASION-81
             HANGOVER-82 JEALOUSY-83 PROSTATITIS-74 BOILS-75 ANGINA-76
             ANGER-77 LONELINESS-78 HANGOVER-70 ANGINA-71 LACERATION-72
             ANXIETY-73 ANXIETY-69 ANGER-66 GRIEF-67 LACERATION-68 BOILS-256
             DEPRESSION-65 PROSTATITIS-252 LONELINESS-253 JEALOUSY-254
             ABRASION-255 BOSNIA GUANABARA KENTUCKY OREGON SATURN VULCAN MARS
             NEPTUNE)
   (:INIT (FOOD TOFU-16)
          (FOOD ARUGULA-5)
          (FOOD LAMB-6)
          (FOOD SNICKERS-7)
          (FOOD CHICKEN-8)
          (FOOD LOBSTER-3)
          (FOOD PEAR-4)
          (FOOD CUCUMBER-1)
          (FOOD YOGURT-2)
          (FOOD APPLE)
          (FOOD BEEF)
          (FOOD PISTACHIO)
          (FOOD ARUGULA)
          (FOOD CUCUMBER)
          (FOOD ENDIVE)
          (FOOD RICE)
          (FOOD PEPPER)
          (FOOD MUTTON)
          (FOOD ONION)
          (FOOD MUFFIN)
          (FOOD SHRIMP)
          (FOOD BAGUETTE)
          (FOOD SCALLION)
          (FOOD TOFU)
          (FOOD PAPAYA)
          (FOOD GUAVA)
          (FOOD CANTELOPE)
          (FOOD HOTDOG)
          (FOOD TOMATO)
          (FOOD SWEETROLL)
          (FOOD LETTUCE)
          (FOOD PORK)
          (FOOD WONDERBREAD)
          (FOOD TURKEY)
          (FOOD LEMON)
          (FOOD KALE)
          (FOOD SNICKERS)
          (FOOD YOGURT)
          (FOOD POPOVER)
          (FOOD TUNA)
          (FOOD LOBSTER)
          (FOOD POTATO)
          (FOOD CHOCOLATE)
          (FOOD BACON)
          (FOOD HAM)
          (FOOD SCALLOP)
          (FOOD MELON)
          (FOOD WURST)
          (FOOD LAMB)
          (FOOD PEA)
          (FOOD MARZIPAN)
          (FOOD HAROSET)
          (FOOD HAMBURGER)
          (FOOD ORANGE)
          (FOOD GRAPEFRUIT)
          (FOOD CHICKEN)
          (FOOD FLOUNDER)
          (FOOD COD)
          (FOOD CHERRY)
          (FOOD OKRA)
          (FOOD BROCCOLI)
          (FOOD PEAR)
          (PLEASURE LUBRICITY)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE EMPATHY)
          (PLEASURE EXPECTATION)
          (PLEASURE STIMULATION)
          (PLEASURE AESTHETICS)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE SATISFACTION)
          (PLEASURE CURIOSITY)
          (PLEASURE LEARNING)
          (PLEASURE REST)
          (PLEASURE EXCITEMENT)
          (PAIN LONELINESS)
          (PAIN ANGINA)
          (PAIN LACERATION)
          (PAIN DEPRESSION)
          (PAIN HANGOVER)
          (PAIN BOILS)
          (PAIN GRIEF)
          (PAIN ABRASION)
          (PAIN ANXIETY)
          (PAIN DREAD)
          (PAIN PROSTATITIS-15)
          (PAIN SCIATICA)
          (PAIN ANGER)
          (PAIN JEALOUSY)
          (PAIN PROSTATITIS)
          (PAIN HANGOVER-14)
          (PAIN LONELINESS-10)
          (PAIN ANXIETY-11)
          (PAIN DREAD-12)
          (PAIN ABRASION-13)
          (PAIN JEALOUSY-31)
          (PAIN ANGER-32)
          (PAIN LACERATION-9)
          (PAIN DEPRESSION-30)
          (PAIN SCIATICA-26)
          (PAIN BOILS-27)
          (PAIN ANGINA-28)
          (PAIN GRIEF-29)
          (PAIN PROSTATITIS-22)
          (PAIN JEALOUSY-23)
          (PAIN ANGER-24)
          (PAIN BOILS-25)
          (PAIN DEPRESSION-17)
          (PAIN ANGINA-18)
          (PAIN HANGOVER-19)
          (PAIN LACERATION-20)
          (PAIN ANXIETY-21)
          (PAIN ABRASION-61)
          (PAIN SCIATICA-62)
          (PAIN GRIEF-63)
          (PAIN LONELINESS-64)
          (PAIN HANGOVER-57)
          (PAIN JEALOUSY-58)
          (PAIN BOILS-59)
          (PAIN DREAD-60)
          (PAIN ANXIETY-53)
          (PAIN ANGER-54)
          (PAIN DEPRESSION-55)
          (PAIN LONELINESS-56)
          (PAIN ANGINA-51)
          (PAIN LACERATION-52)
          (PAIN PROSTATITIS-48)
          (PAIN SCIATICA-49)
          (PAIN GRIEF-50)
          (PAIN ABRASION-47)
          (PAIN ANGER-44)
          (PAIN ANGINA-45)
          (PAIN DREAD-46)
          (PAIN LONELINESS-42)
          (PAIN BOILS-43)
          (PAIN HANGOVER-40)
          (PAIN SCIATICA-41)
          (PAIN ANXIETY-37)
          (PAIN JEALOUSY-38)
          (PAIN DEPRESSION-39)
          (PAIN PROSTATITIS-128)
          (PAIN DREAD-33)
          (PAIN ABRASION-34)
          (PAIN GRIEF-35)
          (PAIN LACERATION-36)
          (PAIN ANXIETY-123)
          (PAIN GRIEF-124)
          (PAIN LACERATION-125)
          (PAIN HANGOVER-126)
          (PAIN DREAD-127)
          (PAIN SCIATICA-119)
          (PAIN LONELINESS-120)
          (PAIN ABRASION-121)
          (PAIN JEALOUSY-122)
          (PAIN PROSTATITIS-114)
          (PAIN ANGER-115)
          (PAIN ANGINA-116)
          (PAIN DEPRESSION-117)
          (PAIN BOILS-118)
          (PAIN ANGER-111)
          (PAIN ANGINA-112)
          (PAIN BOILS-113)
          (PAIN ANXIETY-107)
          (PAIN HANGOVER-108)
          (PAIN JEALOUSY-109)
          (PAIN ABRASION-110)
          (PAIN LACERATION-106)
          (PAIN DREAD-104)
          (PAIN LONELINESS-105)
          (PAIN GRIEF-100)
          (PAIN DEPRESSION-101)
          (PAIN PROSTATITIS-102)
          (PAIN SCIATICA-103)
          (PAIN SCIATICA-98)
          (PAIN ABRASION-99)
          (PAIN ANXIETY-96)
          (PAIN JEALOUSY-97)
          (PAIN ANGER-95)
          (PAIN DEPRESSION-90)
          (PAIN DREAD-91)
          (PAIN LONELINESS-92)
          (PAIN PROSTATITIS-93)
          (PAIN BOILS-94)
          (PAIN ANGINA-87)
          (PAIN HANGOVER-88)
          (PAIN LACERATION-89)
          (PAIN DEPRESSION-84)
          (PAIN GRIEF-85)
          (PAIN GRIEF-86)
          (PAIN SCIATICA-79)
          (PAIN DREAD-80)
          (PAIN ABRASION-81)
          (PAIN HANGOVER-82)
          (PAIN JEALOUSY-83)
          (PAIN PROSTATITIS-74)
          (PAIN BOILS-75)
          (PAIN ANGINA-76)
          (PAIN ANGER-77)
          (PAIN LONELINESS-78)
          (PAIN HANGOVER-70)
          (PAIN ANGINA-71)
          (PAIN LACERATION-72)
          (PAIN ANXIETY-73)
          (PAIN ANXIETY-69)
          (PAIN ANGER-66)
          (PAIN GRIEF-67)
          (PAIN LACERATION-68)
          (PAIN BOILS-256)
          (PAIN DEPRESSION-65)
          (PAIN PROSTATITIS-252)
          (PAIN LONELINESS-253)
          (PAIN JEALOUSY-254)
          (PAIN ABRASION-255)
          (PROVINCE BOSNIA)
          (PROVINCE GUANABARA)
          (PROVINCE KENTUCKY)
          (PROVINCE OREGON)
          (PLANET SATURN)
          (PLANET VULCAN)
          (PLANET MARS)
          (PLANET NEPTUNE)
          (CRAVES SCIATICA-26 ARUGULA)
          (EATS KALE LOBSTER)
          (EATS LETTUCE LEMON)
          (EATS YOGURT-2 GRAPEFRUIT)
          (CRAVES JEALOUSY-23 CUCUMBER)
          (EATS HAMBURGER LEMON)
          (CRAVES ANGINA-51 TOFU)
          (EATS MARZIPAN PORK)
          (CRAVES HANGOVER-82 HAMBURGER)
          (EATS SNICKERS OKRA)
          (EATS RICE GRAPEFRUIT)
          (CRAVES ANXIETY-123 WONDERBREAD)
          (LOCALE CHICKEN-8 GUANABARA)
          (EATS RICE LAMB-6)
          (EATS LEMON HAMBURGER)
          (LOCALE RICE OREGON)
          (LOCALE POPOVER BOSNIA)
          (EATS COD POTATO)
          (CRAVES JEALOUSY-31 BEEF)
          (ORBITS MARS NEPTUNE)
          (CRAVES PROSTATITIS LOBSTER-3)
          (EATS CANTELOPE LAMB)
          (EATS RICE BROCCOLI)
          (EATS BROCCOLI SNICKERS)
          (EATS LETTUCE MARZIPAN)
          (EATS HAROSET SNICKERS)
          (CRAVES JEALOUSY-38 LETTUCE)
          (EATS ORANGE POTATO)
          (LOCALE PEAR-4 OREGON)
          (EATS SCALLOP YOGURT-2)
          (CRAVES GRIEF-100 POTATO)
          (EATS PORK LEMON)
          (CRAVES SCIATICA-41 SWEETROLL)
          (EATS OKRA SWEETROLL)
          (CRAVES GRIEF ARUGULA-5)
          (CRAVES DREAD-104 LOBSTER)
          (CRAVES HANGOVER-126 WONDERBREAD)
          (EATS PEAR CHERRY)
          (EATS CHERRY TOFU)
          (EATS BROCCOLI LAMB)
          (LOCALE TUNA KENTUCKY)
          (CRAVES DREAD-80 HAMBURGER)
          (CRAVES ANXIETY-96 SCALLOP)
          (EATS WURST LOBSTER)
          (EATS TURKEY CUCUMBER)
          (HARMONY ACHIEVEMENT VULCAN)
          (LOCALE GRAPEFRUIT OREGON)
          (EATS HAMBURGER LOBSTER)
          (EATS POPOVER POTATO)
          (CRAVES LACERATION ARUGULA-5)
          (EATS BEEF ARUGULA-5)
          (CRAVES ANGINA-116 KALE)
          (EATS PEA POPOVER)
          (LOCALE PEA BOSNIA)
          (CRAVES ANXIETY-21 RICE)
          (CRAVES HANGOVER-88 MARZIPAN)
          (EATS MARZIPAN SCALLION)
          (LOCALE SNICKERS OREGON)
          (EATS SNICKERS-7 WURST)
          (EATS PEAR CUCUMBER)
          (EATS MUFFIN TUNA)
          (CRAVES ANGER LOBSTER-3)
          (EATS HAROSET PISTACHIO)
          (CRAVES GRIEF-50 PAPAYA)
          (CRAVES ANGER-77 ORANGE)
          (HARMONY EXCITEMENT MARS)
          (CRAVES JEALOUSY-83 HAMBURGER)
          (CRAVES ANGER-24 CUCUMBER)
          (CRAVES BOILS-256 OKRA)
          (CRAVES BOILS-118 KALE)
          (CRAVES BOILS-94 PEA)
          (CRAVES SCIATICA-119 LEMON)
          (CRAVES DREAD SNICKERS-7)
          (EATS PAPAYA SWEETROLL)
          (CRAVES DEPRESSION-101 POTATO)
          (EATS SCALLOP WURST)
          (EATS PISTACHIO HAROSET)
          (EATS YOGURT-2 SCALLOP)
          (EATS LAMB-6 HAM)
          (EATS LOBSTER-3 BROCCOLI)
          (EATS ONION WURST)
          (EATS ONION HAMBURGER)
          (EATS GRAPEFRUIT HAROSET)
          (CRAVES LONELINESS TOFU-16)
          (EATS BROCCOLI RICE)
          (EATS BACON FLOUNDER)
          (CRAVES GRIEF-63 MUTTON)
          (EATS LOBSTER HAMBURGER)
          (LOCALE BROCCOLI GUANABARA)
          (CRAVES ANXIETY LAMB-6)
          (CRAVES DEPRESSION-17 RICE)
          (CRAVES JEALOUSY-254 BROCCOLI)
          (EATS TURKEY MARZIPAN)
          (EATS CHOCOLATE LOBSTER-3)
          (CRAVES DEPRESSION-84 HAROSET)
          (HARMONY EXPECTATION MARS)
          (CRAVES BOILS-25 CUCUMBER)
          (CRAVES DEPRESSION-30 PISTACHIO)
          (CRAVES ANXIETY-107 YOGURT)
          (EATS TUNA BEEF)
          (EATS SNICKERS BROCCOLI)
          (CRAVES JEALOUSY-58 ONION)
          (CRAVES EMPATHY PISTACHIO)
          (EATS PEPPER LEMON)
          (CRAVES LUBRICITY ARUGULA-5)
          (HARMONY STIMULATION MARS)
          (EATS MUTTON SHRIMP)
          (EATS KALE HAMBURGER)
          (EATS APPLE TUNA)
          (LOCALE HAMBURGER GUANABARA)
          (LOCALE PEAR GUANABARA)
          (EATS GRAPEFRUIT ORANGE)
          (LOCALE PORK KENTUCKY)
          (LOCALE COD BOSNIA)
          (CRAVES ANXIETY-53 MUFFIN)
          (EATS ENDIVE PEPPER)
          (LOCALE SHRIMP BOSNIA)
          (CRAVES JEALOUSY-122 LEMON)
          (LOCALE LEMON BOSNIA)
          (EATS SWEETROLL OKRA)
          (EATS CHICKEN-8 SCALLOP)
          (EATS PEAR PORK)
          (HARMONY SATISFACTION NEPTUNE)
          (EATS LEMON CHERRY)
          (EATS PEA COD)
          (CRAVES SCIATICA-79 HAMBURGER)
          (EATS LAMB SCALLOP)
          (CRAVES STIMULATION WONDERBREAD)
          (LOCALE TURKEY OREGON)
          (EATS COD POPOVER)
          (EATS HAROSET OKRA)
          (EATS WURST CANTELOPE)
          (HARMONY LEARNING NEPTUNE)
          (EATS GRAPEFRUIT TOMATO)
          (CRAVES ANGINA-18 RICE)
          (EATS LOBSTER KALE)
          (EATS ORANGE POPOVER)
          (LOCALE BACON BOSNIA)
          (EATS LOBSTER SHRIMP)
          (CRAVES GRIEF-29 ARUGULA)
          (EATS SNICKERS HAROSET)
          (EATS CUCUMBER PORK)
          (EATS BAGUETTE SCALLION)
          (CRAVES ACHIEVEMENT LOBSTER-3)
          (LOCALE HAM GUANABARA)
          (ATTACKS KENTUCKY OREGON)
          (LOCALE LAMB-6 GUANABARA)
          (EATS MARZIPAN LETTUCE)
          (LOCALE PISTACHIO BOSNIA)
          (EATS BEEF TUNA)
          (EATS YOGURT SNICKERS-7)
          (CRAVES LONELINESS-42 HOTDOG)
          (CRAVES ANGINA-112 SNICKERS)
          (LOCALE GUAVA BOSNIA)
          (LOCALE MUFFIN OREGON)
          (EATS ENDIVE PEAR)
          (EATS BEEF WURST)
          (LOCALE HAROSET OREGON)
          (CRAVES DEPRESSION-55 MUFFIN)
          (LOCALE PAPAYA GUANABARA)
          (HARMONY REST MARS)
          (EATS ARUGULA BROCCOLI)
          (CRAVES LONELINESS-78 ORANGE)
          (CRAVES JEALOUSY LOBSTER-3)
          (LOCALE BEEF BOSNIA)
          (CRAVES PROSTATITIS-128 PORK)
          (EATS CANTELOPE HAMBURGER)
          (EATS LAMB YOGURT)
          (LOCALE CANTELOPE BOSNIA)
          (EATS MUTTON MUFFIN)
          (EATS WONDERBREAD HAROSET)
          (CRAVES PROSTATITIS-48 PAPAYA)
          (EATS TURKEY FLOUNDER)
          (CRAVES ABRASION-81 HAMBURGER)
          (HARMONY LUBRICITY NEPTUNE)
          (EATS LAMB BROCCOLI)
          (ORBITS SATURN VULCAN)
          (CRAVES SCIATICA LOBSTER-3)
          (CRAVES HANGOVER-108 YOGURT)
          (EATS GRAPEFRUIT YOGURT-2)
          (CRAVES SATISFACTION LOBSTER)
          (EATS LEMON PORK)
          (EATS BACON SCALLION)
          (CRAVES LACERATION-125 WONDERBREAD)
          (LOCALE POTATO BOSNIA)
          (CRAVES ANGINA TOFU-16)
          (EATS PORK MARZIPAN)
          (CRAVES ABRASION-121 LEMON)
          (EATS GUAVA PEAR-4)
          (LOCALE MUTTON KENTUCKY)
          (LOCALE CHERRY GUANABARA)
          (EATS ORANGE GRAPEFRUIT)
          (LOCALE HOTDOG GUANABARA)
          (CRAVES ABRASION-255 BROCCOLI)
          (CRAVES ANGINA-87 MARZIPAN)
          (CRAVES REST MARZIPAN)
          (EATS HAMBURGER CANTELOPE)
          (EATS TOFU LEMON)
          (EATS GRAPEFRUIT RICE)
          (CRAVES ABRASION-13 YOGURT-2)
          (LOCALE WONDERBREAD GUANABARA)
          (EATS LETTUCE HAMBURGER)
          (CRAVES LONELINESS-92 PEA)
          (EATS TOFU-16 SHRIMP)
          (CRAVES DREAD-12 YOGURT-2)
          (EATS SHRIMP MUTTON)
          (HARMONY CURIOSITY NEPTUNE)
          (LOCALE TOMATO BOSNIA)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS PEAR ENDIVE)
          (CRAVES EXCITEMENT FLOUNDER)
          (CRAVES ANGER-32 BEEF)
          (CRAVES SCIATICA-62 MUTTON)
          (EATS POTATO COD)
          (EATS BEEF CUCUMBER-1)
          (LOCALE WURST BOSNIA)
          (CRAVES LACERATION-36 PORK)
          (ORBITS VULCAN MARS)
          (EATS WURST SNICKERS-7)
          (EATS ARUGULA-5 BEEF)
          (CRAVES BOILS-75 ORANGE)
          (EATS KALE CHERRY)
          (CRAVES ANGER-44 CANTELOPE)
          (EATS LAMB MELON)
          (CRAVES PROSTATITIS-102 POTATO)
          (EATS FLOUNDER CHICKEN)
          (CRAVES HANGOVER-14 PEAR-4)
          (EATS SHRIMP TOFU-16)
          (EATS POTATO WONDERBREAD)
          (CRAVES SCIATICA-103 POTATO)
          (EATS BROCCOLI LOBSTER-3)
          (EATS TUNA MUFFIN)
          (EATS WURST GRAPEFRUIT)
          (CRAVES ANGER-95 MELON)
          (EATS KALE TOFU)
          (EATS CHERRY LOBSTER)
          (EATS SCALLOP CHICKEN-8)
          (EATS BROCCOLI ARUGULA)
          (EATS LEMON LETTUCE)
          (CRAVES PROSTATITIS-114 KALE)
          (EATS HAM LAMB-6)
          (LOCALE OKRA OREGON)
          (EATS WURST SCALLOP)
          (EATS HOTDOG SWEETROLL)
          (EATS BAGUETTE MELON)
          (EATS CANTELOPE WURST)
          (EATS PORK PEAR)
          (EATS PEAR-4 GUAVA)
          (LOCALE YOGURT OREGON)
          (EATS HAM CHICKEN-8)
          (CRAVES LACERATION-9 BEEF)
          (EATS LAMB CANTELOPE)
          (EATS TOFU KALE)
          (CRAVES ANGER-66 CHERRY)
          (CRAVES ANXIETY-69 COD)
          (EATS HAROSET GRAPEFRUIT)
          (EATS PAPAYA PISTACHIO)
          (EATS TUNA PEA)
          (EATS CHERRY TUNA)
          (CRAVES ABRASION LAMB-6)
          (LOCALE TOFU-16 GUANABARA)
          (CRAVES SCIATICA-49 PAPAYA)
          (CRAVES GRIEF-35 PORK)
          (EATS CUCUMBER-1 APPLE)
          (EATS TOFU CHERRY)
          (EATS CHICKEN FLOUNDER)
          (LOCALE LOBSTER GUANABARA)
          (ATTACKS BOSNIA GUANABARA)
          (EATS ARUGULA-5 POPOVER)
          (LOCALE CHOCOLATE BOSNIA)
          (CRAVES PROSTATITIS-252 BROCCOLI)
          (CRAVES EXPECTATION TOMATO)
          (CRAVES ANXIETY-11 YOGURT-2)
          (LOCALE ARUGULA-5 OREGON)
          (EATS PORK CUCUMBER)
          (EATS PISTACHIO PAPAYA)
          (CRAVES CURIOSITY LAMB)
          (CRAVES PROSTATITIS-74 ORANGE)
          (EATS FLOUNDER BACON)
          (CRAVES BOILS-27 ARUGULA)
          (CRAVES LACERATION-89 MARZIPAN)
          (EATS POPOVER WURST)
          (LOCALE YOGURT-2 KENTUCKY)
          (CRAVES BOILS-113 SNICKERS)
          (EATS OKRA HAROSET)
          (EATS LEMON MARZIPAN)
          (LOCALE ARUGULA BOSNIA)
          (EATS CUCUMBER-1 BEEF)
          (LOCALE APPLE KENTUCKY)
          (EATS MELON PEAR-4)
          (EATS SCALLION BAGUETTE)
          (CRAVES DEPRESSION ARUGULA-5)
          (EATS LOBSTER CHERRY)
          (LOCALE MELON KENTUCKY)
          (EATS CHERRY LEMON)
          (EATS CUCUMBER PEAR)
          (EATS LEMON TOFU)
          (EATS BROCCOLI HAROSET)
          (EATS LOBSTER WURST)
          (CRAVES LACERATION-72 FLOUNDER)
          (LOCALE SWEETROLL BOSNIA)
          (LOCALE BAGUETTE BOSNIA)
          (CRAVES DREAD-60 ONION)
          (CRAVES ABRASION-110 YOGURT)
          (CRAVES LONELINESS-64 MUTTON)
          (CRAVES ANGER-115 KALE)
          (CRAVES DEPRESSION-39 LETTUCE)
          (EATS HAMBURGER LETTUCE)
          (EATS CHICKEN ARUGULA)
          (EATS MARZIPAN TURKEY)
          (EATS HAROSET BROCCOLI)
          (CRAVES HANGOVER-40 SWEETROLL)
          (CRAVES HANGOVER-57 ONION)
          (CRAVES DEPRESSION-65 OKRA)
          (LOCALE FLOUNDER OREGON)
          (EATS MELON LAMB)
          (EATS CUCUMBER-1 WURST)
          (CRAVES ANXIETY-37 LETTUCE)
          (HARMONY ENTERTAINMENT VULCAN)
          (LOCALE CUCUMBER-1 OREGON)
          (EATS POPOVER ARUGULA-5)
          (CRAVES AESTHETICS SNICKERS)
          (CRAVES ANXIETY-73 FLOUNDER)
          (CRAVES PROSTATITIS-93 PEA)
          (EATS CHERRY PEAR)
          (CRAVES HANGOVER-70 FLOUNDER)
          (EATS HAMBURGER ONION)
          (EATS SHRIMP LOBSTER)
          (CRAVES LACERATION-106 TUNA)
          (CRAVES ANGER-54 MUFFIN)
          (LOCALE PEPPER OREGON)
          (CRAVES LONELINESS-10 YOGURT-2)
          (EATS POTATO HOTDOG)
          (EATS SWEETROLL HOTDOG)
          (EATS POPOVER COD)
          (LOCALE TOFU BOSNIA)
          (EATS SCALLION MARZIPAN)
          (EATS CHERRY KALE)
          (EATS TUNA CHERRY)
          (CRAVES BOILS ARUGULA-5)
          (CRAVES ANGINA-76 ORANGE)
          (CRAVES BOILS-59 ONION)
          (LOCALE ONION BOSNIA)
          (CRAVES ABRASION-34 PORK)
          (EATS WURST POPOVER)
          (EATS WONDERBREAD POTATO)
          (CRAVES ANGINA-45 CANTELOPE)
          (EATS LEMON PEPPER)
          (EATS POTATO TOMATO)
          (EATS HAROSET WONDERBREAD)
          (EATS YOGURT LAMB)
          (EATS SCALLION BACON)
          (EATS MARZIPAN BACON)
          (CRAVES JEALOUSY-109 YOGURT)
          (EATS FLOUNDER TURKEY)
          (CRAVES LACERATION-20 RICE)
          (CRAVES ABRASION-47 GUAVA)
          (CRAVES ANGINA-28 ARUGULA)
          (LOCALE CUCUMBER OREGON)
          (EATS MELON BAGUETTE)
          (CRAVES GRIEF-67 CHERRY)
          (EATS RICE HAROSET)
          (CRAVES DREAD-33 PORK)
          (EATS WURST CUCUMBER-1)
          (CRAVES ANGINA-71 FLOUNDER)
          (EATS SWEETROLL PAPAYA)
          (CRAVES ABRASION-61 MUTTON)
          (EATS HAMBURGER KALE)
          (LOCALE ORANGE BOSNIA)
          (EATS HAROSET RICE)
          (EATS APPLE CUCUMBER-1)
          (EATS POPOVER ORANGE)
          (EATS CUCUMBER TURKEY)
          (EATS WURST BEEF)
          (LOCALE MARZIPAN BOSNIA)
          (EATS PEA TUNA)
          (EATS OKRA SNICKERS)
          (EATS PEAR-4 MELON)
          (CRAVES HANGOVER-19 RICE)
          (EATS CHICKEN-8 HAM)
          (CRAVES DREAD-46 CANTELOPE)
          (LOCALE KALE OREGON)
          (CRAVES HANGOVER ARUGULA-5)
          (LOCALE SCALLION BOSNIA)
          (LOCALE LETTUCE OREGON)
          (EATS ARUGULA CHICKEN)
          (EATS COD PEA)
          (EATS GRAPEFRUIT WURST)
          (EATS POTATO ORANGE)
          (CRAVES LEARNING PEA)
          (CRAVES DREAD-91 PEA)
          (CRAVES LACERATION-52 TOFU)
          (LOCALE SNICKERS-7 OREGON)
          (EATS SNICKERS-7 YOGURT)
          (CRAVES ANGER-111 SNICKERS)
          (CRAVES DREAD-127 WONDERBREAD)
          (CRAVES GRIEF-85 HAROSET)
          (LOCALE ENDIVE GUANABARA)
          (EATS LOBSTER-3 CHOCOLATE)
          (EATS CHERRY MUFFIN)
          (EATS POPOVER PEA)
          (CRAVES ABRASION-99 CHOCOLATE)
          (CRAVES SCIATICA-98 CHOCOLATE)
          (EATS TOMATO POTATO)
          (CRAVES DEPRESSION-117 KALE)
          (EATS MUFFIN MUTTON)
          (EATS MUFFIN CHERRY)
          (CRAVES GRIEF-86 HAROSET)
          (CRAVES JEALOUSY-97 SCALLOP)
          (EATS BACON MARZIPAN)
          (HARMONY AESTHETICS NEPTUNE)
          (CRAVES LONELINESS-253 BROCCOLI)
          (EATS CHERRY TOFU-16)
          (LOCALE LAMB BOSNIA)
          (EATS HOTDOG POTATO)
          (EATS TUNA APPLE)
          (EATS CHOCOLATE GUAVA)
          (CRAVES DEPRESSION-90 PEA)
          (LOCALE LOBSTER-3 GUANABARA)
          (CRAVES BOILS-43 HOTDOG)
          (CRAVES LONELINESS-56 MUFFIN)
          (CRAVES PROSTATITIS-22 CUCUMBER)
          (CRAVES PROSTATITIS-15 LOBSTER-3)
          (CRAVES LONELINESS-105 LOBSTER)
          (CRAVES LONELINESS-120 LEMON)
          (EATS TOMATO GRAPEFRUIT)
          (CRAVES ENTERTAINMENT YOGURT)
          (EATS MARZIPAN LEMON)
          (HARMONY EMPATHY NEPTUNE)
          (CRAVES GRIEF-124 WONDERBREAD)
          (LOCALE SCALLOP OREGON)
          (EATS PEPPER ENDIVE)
          (EATS TOFU-16 CHERRY)
          (EATS WURST ONION)
          (LOCALE CHICKEN KENTUCKY)
          (EATS SCALLOP LAMB)
          (EATS POTATO POPOVER)
          (EATS GUAVA CHOCOLATE)
          (EATS LAMB-6 RICE)
          (CRAVES LACERATION-68 CHERRY))
   (:GOAL (AND (CRAVES DREAD-104 COD))))

(DEFINE (PROBLEM STRIPS-MYSTY-34)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS BEEF-23 SNICKERS-27 KALE-26 ARUGULA-25 POPOVER-24
             SCALLION-28 SHRIMP-29 ENDIVE-30 CHICKEN-31 HAROSET-32
             HAMBURGER-9 RICE-10 HOTDOG-11 LOBSTER-12 BROCCOLI-13 TURKEY-14
             LEMON-15 CUCUMBER-16 GUAVA-5 PAPAYA-6 SCALLOP-7 OKRA-8 PEAR-3
             FLOUNDER-4 CHOCOLATE-1 PEPPER-2 RICE WURST PEAR ENDIVE PORK TURKEY
             OKRA HAMBURGER GRAPEFRUIT LEMON BEEF POPOVER HAROSET ONION
             MUTTON LOBSTER MUFFIN SCALLOP GUAVA TOMATO LETTUCE HAM
             SWEETROLL TOFU PEA CHOCOLATE ORANGE BROCCOLI HOTDOG APPLE LAMB
             BACON PISTACHIO SHRIMP PAPAYA POTATO SNICKERS WONDERBREAD
             CHICKEN MELON YOGURT BAGUETTE MARZIPAN PEPPER CHERRY CANTELOPE
             CUCUMBER COD SCALLION KALE ARUGULA TUNA FLOUNDER EMPATHY SATIETY
             AESTHETICS UNDERSTANDING LEARNING ACHIEVEMENT TRIUMPH
             EXCITEMENT LUBRICITY LOVE EXPECTATION STIMULATION CURIOSITY
             SATISFACTION ENTERTAINMENT INTOXICATION REST INTOXICATION-22
             LOVE-21 DREAD LONELINESS ABRASION GRIEF LACERATION BOILS
             ANXIETY SCIATICA ANGER PROSTATITIS DEPRESSION HANGOVER
             JEALOUSY BOILS-17 GRIEF-18 JEALOUSY-19 HANGOVER-20 ANGINA
             ANXIETY-60 ANGER-61 DREAD-62 ANGINA-63 SCIATICA-64
             PROSTATITIS-55 LONELINESS-56 LACERATION-57 ABRASION-58
             DEPRESSION-59 PROSTATITIS-52 DEPRESSION-53 GRIEF-54 ABRASION-49
             ANGER-50 LACERATION-51 ANGINA-47 ANXIETY-48 SCIATICA-44
             JEALOUSY-45 DREAD-46 PROSTATITIS-40 BOILS-41 HANGOVER-42
             LONELINESS-43 ANXIETY-37 HANGOVER-38 ANGER-39 JEALOUSY-34 BOILS-35
             DREAD-36 ANGINA-33 SCIATICA-124 LONELINESS-125
             DEPRESSION-126 GRIEF-127 LACERATION-128 ABRASION-123 ANGINA-119
             HANGOVER-120 DREAD-121 ANGER-122 LACERATION-117 PROSTATITIS-118
             ANXIETY-115 SCIATICA-116 ABRASION-111 BOILS-112 JEALOUSY-113
             LONELINESS-114 LONELINESS-108 DEPRESSION-109 GRIEF-110 ANGER-104
             GRIEF-105 DEPRESSION-106 ANGINA-107 HANGOVER-102 BOILS-103
             LACERATION-100 ABRASION-101 DREAD-96 JEALOUSY-97 ANXIETY-98
             PROSTATITIS-99 ANGER-92 LONELINESS-93 PROSTATITIS-94 SCIATICA-95
             DEPRESSION-89 ANGINA-90 GRIEF-91 HANGOVER-88 BOILS-86 ABRASION-87
             LACERATION-82 SCIATICA-83 JEALOUSY-84 ANXIETY-85 DREAD-81 BOILS-78
             DEPRESSION-79 JEALOUSY-80 ABRASION-76 HANGOVER-77 ANGER-74
             ANGINA-75 PROSTATITIS-72 LACERATION-73 GRIEF-69 ANXIETY-70
             DREAD-71 ANGINA-66 SCIATICA-67 LONELINESS-68 HANGOVER-254
             PROSTATITIS-255 ANGER-256 BOILS-65 JEALOUSY-250 ANXIETY-251
             DEPRESSION-252 GRIEF-253 SURREY QUEBEC ALSACE KENTUCKY BOSNIA OREGON
             PENNSYLVANIA BAVARIA GUANABARA GOIAS MORAVIA ARIZONA MANITOBA
             JUPITER EARTH MERCURY VENUS)
   (:INIT (FOOD BEEF-23)
          (FOOD SNICKERS-27)
          (FOOD KALE-26)
          (FOOD ARUGULA-25)
          (FOOD POPOVER-24)
          (FOOD SCALLION-28)
          (FOOD SHRIMP-29)
          (FOOD ENDIVE-30)
          (FOOD CHICKEN-31)
          (FOOD HAROSET-32)
          (FOOD HAMBURGER-9)
          (FOOD RICE-10)
          (FOOD HOTDOG-11)
          (FOOD LOBSTER-12)
          (FOOD BROCCOLI-13)
          (FOOD TURKEY-14)
          (FOOD LEMON-15)
          (FOOD CUCUMBER-16)
          (FOOD GUAVA-5)
          (FOOD PAPAYA-6)
          (FOOD SCALLOP-7)
          (FOOD OKRA-8)
          (FOOD PEAR-3)
          (FOOD FLOUNDER-4)
          (FOOD CHOCOLATE-1)
          (FOOD PEPPER-2)
          (FOOD RICE)
          (FOOD WURST)
          (FOOD PEAR)
          (FOOD ENDIVE)
          (FOOD PORK)
          (FOOD TURKEY)
          (FOOD OKRA)
          (FOOD HAMBURGER)
          (FOOD GRAPEFRUIT)
          (FOOD LEMON)
          (FOOD BEEF)
          (FOOD POPOVER)
          (FOOD HAROSET)
          (FOOD ONION)
          (FOOD MUTTON)
          (FOOD LOBSTER)
          (FOOD MUFFIN)
          (FOOD SCALLOP)
          (FOOD GUAVA)
          (FOOD TOMATO)
          (FOOD LETTUCE)
          (FOOD HAM)
          (FOOD SWEETROLL)
          (FOOD TOFU)
          (FOOD PEA)
          (FOOD CHOCOLATE)
          (FOOD ORANGE)
          (FOOD BROCCOLI)
          (FOOD HOTDOG)
          (FOOD APPLE)
          (FOOD LAMB)
          (FOOD BACON)
          (FOOD PISTACHIO)
          (FOOD SHRIMP)
          (FOOD PAPAYA)
          (FOOD POTATO)
          (FOOD SNICKERS)
          (FOOD WONDERBREAD)
          (FOOD CHICKEN)
          (FOOD MELON)
          (FOOD YOGURT)
          (FOOD BAGUETTE)
          (FOOD MARZIPAN)
          (FOOD PEPPER)
          (FOOD CHERRY)
          (FOOD CANTELOPE)
          (FOOD CUCUMBER)
          (FOOD COD)
          (FOOD SCALLION)
          (FOOD KALE)
          (FOOD ARUGULA)
          (FOOD TUNA)
          (FOOD FLOUNDER)
          (PLEASURE EMPATHY)
          (PLEASURE SATIETY)
          (PLEASURE AESTHETICS)
          (PLEASURE UNDERSTANDING)
          (PLEASURE LEARNING)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE TRIUMPH)
          (PLEASURE EXCITEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE LOVE)
          (PLEASURE EXPECTATION)
          (PLEASURE STIMULATION)
          (PLEASURE CURIOSITY)
          (PLEASURE SATISFACTION)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE INTOXICATION)
          (PLEASURE REST)
          (PLEASURE INTOXICATION-22)
          (PLEASURE LOVE-21)
          (PAIN DREAD)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN GRIEF)
          (PAIN LACERATION)
          (PAIN BOILS)
          (PAIN ANXIETY)
          (PAIN SCIATICA)
          (PAIN ANGER)
          (PAIN PROSTATITIS)
          (PAIN DEPRESSION)
          (PAIN HANGOVER)
          (PAIN JEALOUSY)
          (PAIN BOILS-17)
          (PAIN GRIEF-18)
          (PAIN JEALOUSY-19)
          (PAIN HANGOVER-20)
          (PAIN ANGINA)
          (PAIN ANXIETY-60)
          (PAIN ANGER-61)
          (PAIN DREAD-62)
          (PAIN ANGINA-63)
          (PAIN SCIATICA-64)
          (PAIN PROSTATITIS-55)
          (PAIN LONELINESS-56)
          (PAIN LACERATION-57)
          (PAIN ABRASION-58)
          (PAIN DEPRESSION-59)
          (PAIN PROSTATITIS-52)
          (PAIN DEPRESSION-53)
          (PAIN GRIEF-54)
          (PAIN ABRASION-49)
          (PAIN ANGER-50)
          (PAIN LACERATION-51)
          (PAIN ANGINA-47)
          (PAIN ANXIETY-48)
          (PAIN SCIATICA-44)
          (PAIN JEALOUSY-45)
          (PAIN DREAD-46)
          (PAIN PROSTATITIS-40)
          (PAIN BOILS-41)
          (PAIN HANGOVER-42)
          (PAIN LONELINESS-43)
          (PAIN ANXIETY-37)
          (PAIN HANGOVER-38)
          (PAIN ANGER-39)
          (PAIN JEALOUSY-34)
          (PAIN BOILS-35)
          (PAIN DREAD-36)
          (PAIN ANGINA-33)
          (PAIN SCIATICA-124)
          (PAIN LONELINESS-125)
          (PAIN DEPRESSION-126)
          (PAIN GRIEF-127)
          (PAIN LACERATION-128)
          (PAIN ABRASION-123)
          (PAIN ANGINA-119)
          (PAIN HANGOVER-120)
          (PAIN DREAD-121)
          (PAIN ANGER-122)
          (PAIN LACERATION-117)
          (PAIN PROSTATITIS-118)
          (PAIN ANXIETY-115)
          (PAIN SCIATICA-116)
          (PAIN ABRASION-111)
          (PAIN BOILS-112)
          (PAIN JEALOUSY-113)
          (PAIN LONELINESS-114)
          (PAIN LONELINESS-108)
          (PAIN DEPRESSION-109)
          (PAIN GRIEF-110)
          (PAIN ANGER-104)
          (PAIN GRIEF-105)
          (PAIN DEPRESSION-106)
          (PAIN ANGINA-107)
          (PAIN HANGOVER-102)
          (PAIN BOILS-103)
          (PAIN LACERATION-100)
          (PAIN ABRASION-101)
          (PAIN DREAD-96)
          (PAIN JEALOUSY-97)
          (PAIN ANXIETY-98)
          (PAIN PROSTATITIS-99)
          (PAIN ANGER-92)
          (PAIN LONELINESS-93)
          (PAIN PROSTATITIS-94)
          (PAIN SCIATICA-95)
          (PAIN DEPRESSION-89)
          (PAIN ANGINA-90)
          (PAIN GRIEF-91)
          (PAIN HANGOVER-88)
          (PAIN BOILS-86)
          (PAIN ABRASION-87)
          (PAIN LACERATION-82)
          (PAIN SCIATICA-83)
          (PAIN JEALOUSY-84)
          (PAIN ANXIETY-85)
          (PAIN DREAD-81)
          (PAIN BOILS-78)
          (PAIN DEPRESSION-79)
          (PAIN JEALOUSY-80)
          (PAIN ABRASION-76)
          (PAIN HANGOVER-77)
          (PAIN ANGER-74)
          (PAIN ANGINA-75)
          (PAIN PROSTATITIS-72)
          (PAIN LACERATION-73)
          (PAIN GRIEF-69)
          (PAIN ANXIETY-70)
          (PAIN DREAD-71)
          (PAIN ANGINA-66)
          (PAIN SCIATICA-67)
          (PAIN LONELINESS-68)
          (PAIN HANGOVER-254)
          (PAIN PROSTATITIS-255)
          (PAIN ANGER-256)
          (PAIN BOILS-65)
          (PAIN JEALOUSY-250)
          (PAIN ANXIETY-251)
          (PAIN DEPRESSION-252)
          (PAIN GRIEF-253)
          (PROVINCE SURREY)
          (PROVINCE QUEBEC)
          (PROVINCE ALSACE)
          (PROVINCE KENTUCKY)
          (PROVINCE BOSNIA)
          (PROVINCE OREGON)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PROVINCE GUANABARA)
          (PROVINCE GOIAS)
          (PROVINCE MORAVIA)
          (PROVINCE ARIZONA)
          (PROVINCE MANITOBA)
          (PLANET JUPITER)
          (PLANET EARTH)
          (PLANET MERCURY)
          (PLANET VENUS)
          (CRAVES GRIEF-54 PEPPER-2)
          (EATS PISTACHIO POTATO)
          (CRAVES ANGINA-33 HAROSET)
          (LOCALE SCALLION-28 BAVARIA)
          (LOCALE ARUGULA BOSNIA)
          (EATS TURKEY-14 FLOUNDER)
          (CRAVES ABRASION-111 HAM)
          (EATS ARUGULA-25 BEEF-23)
          (EATS PISTACHIO SNICKERS)
          (CRAVES BOILS-112 HAM)
          (EATS LOBSTER CHICKEN-31)
          (EATS SHRIMP-29 GRAPEFRUIT)
          (CRAVES HANGOVER-38 GRAPEFRUIT)
          (CRAVES JEALOUSY-250 FLOUNDER)
          (EATS PEA CANTELOPE)
          (EATS SCALLOP KALE)
          (EATS HAM YOGURT)
          (EATS TUNA FLOUNDER)
          (EATS FLOUNDER TURKEY-14)
          (CRAVES HANGOVER-88 POTATO)
          (EATS BAGUETTE TURKEY-14)
          (EATS OKRA CUCUMBER)
          (EATS CHICKEN-31 PEPPER-2)
          (EATS GUAVA-5 BAGUETTE)
          (EATS COD ARUGULA)
          (CRAVES LOVE GUAVA)
          (EATS GUAVA BROCCOLI-13)
          (EATS POPOVER SNICKERS)
          (EATS BAGUETTE CUCUMBER)
          (CRAVES JEALOUSY-97 LAMB)
          (EATS SHRIMP GUAVA-5)
          (EATS CANTELOPE HOTDOG)
          (CRAVES DREAD-36 BEEF)
          (EATS POTATO PISTACHIO)
          (LOCALE LOBSTER-12 MORAVIA)
          (ATTACKS GUANABARA GOIAS)
          (EATS FLOUNDER-4 POPOVER)
          (CRAVES ANXIETY-115 GUAVA)
          (CRAVES HANGOVER-20 GUAVA-5)
          (ATTACKS QUEBEC ALSACE)
          (EATS KALE-26 ARUGULA-25)
          (HARMONY LEARNING VENUS)
          (CRAVES SCIATICA-124 ONION)
          (EATS COD PEPPER-2)
          (EATS HAROSET MUTTON)
          (EATS CANTELOPE SWEETROLL)
          (EATS SCALLION SCALLOP)
          (LOCALE MUFFIN ARIZONA)
          (EATS TURKEY-14 BAGUETTE)
          (EATS SCALLOP-7 WONDERBREAD)
          (EATS LEMON FLOUNDER)
          (CRAVES ANGINA-47 PEAR)
          (EATS LEMON-15 COD)
          (LOCALE COD GOIAS)
          (EATS PEA LAMB)
          (EATS BAGUETTE CHICKEN)
          (CRAVES PROSTATITIS-40 HAMBURGER)
          (EATS PAPAYA MUTTON)
          (EATS HAMBURGER-9 SCALLION-28)
          (LOCALE ENDIVE PENNSYLVANIA)
          (CRAVES ANXIETY-98 LAMB)
          (HARMONY LUBRICITY VENUS)
          (LOCALE MARZIPAN OREGON)
          (EATS FLOUNDER CHICKEN)
          (EATS BROCCOLI POTATO)
          (LOCALE OKRA-8 ALSACE)
          (EATS ENDIVE CUCUMBER-16)
          (CRAVES ACHIEVEMENT PAPAYA-6)
          (LOCALE LOBSTER BOSNIA)
          (EATS COD KALE)
          (LOCALE CHICKEN MANITOBA)
          (EATS CUCUMBER OKRA)
          (EATS PORK CANTELOPE)
          (LOCALE RICE GOIAS)
          (EATS WURST RICE)
          (EATS MUFFIN COD)
          (LOCALE LEMON-15 OREGON)
          (CRAVES EXCITEMENT MUTTON)
          (HARMONY REST MERCURY)
          (LOCALE GRAPEFRUIT BAVARIA)
          (LOCALE SCALLOP BAVARIA)
          (EATS MUFFIN BROCCOLI-13)
          (EATS CUCUMBER GUAVA)
          (EATS ARUGULA CHERRY)
          (EATS HAROSET APPLE)
          (CRAVES SCIATICA-83 YOGURT)
          (CRAVES LACERATION-117 SCALLOP)
          (EATS PISTACHIO ENDIVE)
          (EATS LOBSTER OKRA-8)
          (CRAVES ABRASION-101 BROCCOLI)
          (EATS BEEF-23 SNICKERS-27)
          (EATS PAPAYA KALE)
          (EATS PAPAYA OKRA)
          (LOCALE ORANGE PENNSYLVANIA)
          (CRAVES LOVE-21 CUCUMBER)
          (EATS APPLE SHRIMP)
          (CRAVES JEALOUSY-113 HAM)
          (EATS SNICKERS POPOVER)
          (HARMONY CURIOSITY MERCURY)
          (EATS KALE-26 SNICKERS-27)
          (LOCALE SHRIMP-29 SURREY)
          (EATS POTATO ENDIVE)
          (EATS LOBSTER CHOCOLATE)
          (LOCALE WURST ALSACE)
          (EATS FLOUNDER LEMON)
          (EATS GRAPEFRUIT SHRIMP-29)
          (EATS APPLE HAROSET)
          (LOCALE PORK PENNSYLVANIA)
          (EATS COD OKRA-8)
          (CRAVES ANXIETY HAMBURGER-9)
          (CRAVES ANGER-74 CHERRY)
          (LOCALE CUCUMBER BOSNIA)
          (HARMONY SATISFACTION VENUS)
          (HARMONY AESTHETICS VENUS)
          (CRAVES ANGINA-63 SCALLOP-7)
          (EATS LEMON SCALLION)
          (LOCALE KALE MORAVIA)
          (EATS HAMBURGER APPLE)
          (EATS ORANGE TOMATO)
          (EATS COD LEMON-15)
          (EATS CHERRY GRAPEFRUIT)
          (CRAVES LACERATION-73 CUCUMBER)
          (CRAVES DEPRESSION RICE-10)
          (EATS TOMATO BROCCOLI)
          (CRAVES GRIEF-127 ONION)
          (EATS POPOVER TUNA)
          (CRAVES JEALOUSY-19 GUAVA-5)
          (EATS RICE CHOCOLATE)
          (LOCALE GUAVA-5 QUEBEC)
          (EATS POPOVER FLOUNDER-4)
          (CRAVES INTOXICATION WONDERBREAD)
          (HARMONY EMPATHY EARTH)
          (EATS TURKEY BEEF)
          (CRAVES ANXIETY-37 GRAPEFRUIT)
          (LOCALE PISTACHIO ARIZONA)
          (EATS BACON TOFU)
          (CRAVES DREAD-46 ENDIVE)
          (EATS MARZIPAN FLOUNDER-4)
          (EATS SHRIMP SCALLION)
          (EATS CANTELOPE PEA)
          (EATS HOTDOG LAMB)
          (EATS CHICKEN-31 LOBSTER)
          (EATS MUFFIN SNICKERS-27)
          (EATS HOTDOG-11 BACON)
          (CRAVES SATIETY KALE-26)
          (CRAVES EXPECTATION LETTUCE)
          (LOCALE BROCCOLI BOSNIA)
          (EATS YOGURT PISTACHIO)
          (EATS FLOUNDER CUCUMBER-16)
          (LOCALE CHERRY BOSNIA)
          (CRAVES PROSTATITIS-52 PEPPER-2)
          (EATS MUTTON PAPAYA)
          (EATS RICE WURST)
          (CRAVES DEPRESSION-106 CHOCOLATE)
          (CRAVES GRIEF-18 GUAVA-5)
          (CRAVES BOILS HAMBURGER-9)
          (EATS SCALLION-28 SNICKERS)
          (EATS HAROSET SCALLOP)
          (HARMONY EXCITEMENT EARTH)
          (EATS CHERRY PEPPER)
          (EATS CANTELOPE POTATO)
          (EATS SWEETROLL CANTELOPE)
          (EATS LAMB HOTDOG)
          (EATS BAGUETTE GUAVA-5)
          (EATS ORANGE LETTUCE)
          (CRAVES ANGER-61 SCALLOP-7)
          (EATS PAPAYA-6 CHERRY)
          (CRAVES LONELINESS-108 PEA)
          (EATS PISTACHIO TUNA)
          (CRAVES PROSTATITIS-55 CHOCOLATE-1)
          (EATS YOGURT LOBSTER-12)
          (CRAVES TRIUMPH OKRA-8)
          (EATS BROCCOLI YOGURT)
          (EATS SCALLOP SCALLION)
          (ATTACKS SURREY QUEBEC)
          (ATTACKS BAVARIA GUANABARA)
          (EATS APPLE HAMBURGER)
          (CRAVES LEARNING TURKEY-14)
          (EATS HAROSET-32 CUCUMBER)
          (CRAVES LONELINESS-68 KALE)
          (LOCALE BACON BAVARIA)
          (CRAVES CURIOSITY PISTACHIO)
          (EATS SNICKERS SCALLION-28)
          (EATS COD LOBSTER-12)
          (EATS SHRIMP APPLE)
          (CRAVES SATISFACTION SHRIMP)
          (EATS BACON HOTDOG-11)
          (EATS SCALLION SHRIMP)
          (CRAVES DEPRESSION-53 PEPPER-2)
          (EATS MUFFIN KALE)
          (EATS FLOUNDER-4 WONDERBREAD)
          (LOCALE OKRA MORAVIA)
          (EATS PAPAYA-6 POPOVER)
          (CRAVES GRIEF HAROSET-32)
          (ATTACKS ARIZONA MANITOBA)
          (EATS HOTDOG-11 SNICKERS)
          (EATS KALE-26 BEEF-23)
          (LOCALE PEA OREGON)
          (EATS ENDIVE-30 HAMBURGER-9)
          (EATS TOMATO ORANGE)
          (CRAVES PROSTATITIS-94 SHRIMP)
          (EATS TUNA POPOVER)
          (ATTACKS MORAVIA ARIZONA)
          (EATS LEMON-15 PEAR)
          (CRAVES BOILS-103 ORANGE)
          (EATS HAMBURGER SCALLION)
          (LOCALE PEPPER-2 BOSNIA)
          (LOCALE GUAVA GUANABARA)
          (CRAVES ABRASION-87 MELON)
          (CRAVES DEPRESSION-126 ONION)
          (CRAVES ANGINA-66 KALE)
          (CRAVES LONELINESS-56 CHOCOLATE-1)
          (CRAVES BOILS-78 MARZIPAN)
          (EATS MARZIPAN TURKEY)
          (EATS SNICKERS-27 MUFFIN)
          (CRAVES JEALOUSY-34 BEEF)
          (EATS PEPPER CHERRY)
          (CRAVES BOILS-17 GUAVA-5)
          (EATS FLOUNDER TUNA)
          (CRAVES PROSTATITIS-72 CUCUMBER)
          (EATS PORK ORANGE)
          (CRAVES HANGOVER RICE-10)
          (EATS KALE COD)
          (LOCALE TURKEY SURREY)
          (LOCALE CHOCOLATE-1 BAVARIA)
          (CRAVES JEALOUSY-84 YOGURT)
          (EATS ENDIVE POTATO)
          (EATS MELON PEAR-3)
          (LOCALE BEEF-23 BAVARIA)
          (LOCALE SHRIMP BOSNIA)
          (CRAVES LONELINESS-125 ONION)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (CRAVES JEALOUSY RICE-10)
          (CRAVES AESTHETICS SCALLION-28)
          (EATS CUCUMBER HAROSET-32)
          (EATS SCALLION LEMON)
          (EATS BROCCOLI-13 MUFFIN)
          (EATS HOTDOG MELON)
          (EATS SNICKERS-27 BEEF-23)
          (EATS POTATO YOGURT)
          (EATS LAMB BAGUETTE)
          (CRAVES REST CHERRY)
          (EATS MELON HOTDOG)
          (EATS SCALLOP HAROSET)
          (EATS CHOCOLATE YOGURT)
          (EATS PEAR LEMON-15)
          (HARMONY UNDERSTANDING EARTH)
          (ATTACKS OREGON PENNSYLVANIA)
          (EATS CHICKEN BAGUETTE)
          (CRAVES HANGOVER-42 HAMBURGER)
          (LOCALE POPOVER-24 PENNSYLVANIA)
          (EATS LETTUCE LEMON-15)
          (LOCALE WONDERBREAD ALSACE)
          (EATS BROCCOLI-13 GUAVA)
          (LOCALE KALE-26 OREGON)
          (EATS POPOVER-24 SNICKERS-27)
          (EATS HAM TOFU)
          (EATS HAMBURGER-9 ENDIVE-30)
          (EATS PEPPER-2 COD)
          (LOCALE APPLE BOSNIA)
          (LOCALE POTATO KENTUCKY)
          (EATS SCALLION HAMBURGER)
          (CRAVES ANGER-256 ARUGULA)
          (CRAVES ANGER-122 MUFFIN)
          (EATS YOGURT CHOCOLATE)
          (EATS GRAPEFRUIT CHERRY)
          (CRAVES ANXIETY-70 SCALLION)
          (EATS PEAR-3 BAGUETTE)
          (CRAVES LACERATION-100 BROCCOLI)
          (LOCALE LEMON BAVARIA)
          (LOCALE PEAR BOSNIA)
          (CRAVES DEPRESSION-252 FLOUNDER)
          (EATS PEAR ORANGE)
          (CRAVES ANGINA-107 CHOCOLATE)
          (CRAVES ANGER-92 SHRIMP)
          (CRAVES DREAD-81 BAGUETTE)
          (CRAVES HANGOVER-254 ARUGULA)
          (CRAVES SCIATICA-67 KALE)
          (CRAVES ANGINA-90 PAPAYA)
          (EATS RICE-10 LETTUCE)
          (EATS SWEETROLL ORANGE)
          (EATS ENDIVE-30 BACON)
          (HARMONY ENTERTAINMENT VENUS)
          (EATS SNICKERS-27 KALE-26)
          (LOCALE FLOUNDER-4 BAVARIA)
          (CRAVES PROSTATITIS-255 ARUGULA)
          (CRAVES ANXIETY-85 YOGURT)
          (EATS LETTUCE ORANGE)
          (LOCALE YOGURT GUANABARA)
          (EATS CHOCOLATE-1 CHICKEN)
          (LOCALE HAMBURGER-9 BAVARIA)
          (EATS LEMON-15 LETTUCE)
          (HARMONY INTOXICATION-22 EARTH)
          (CRAVES BOILS-35 BEEF)
          (EATS OKRA-8 COD)
          (EATS ORANGE PORK)
          (CRAVES DEPRESSION-79 MARZIPAN)
          (CRAVES LACERATION-57 CHOCOLATE-1)
          (EATS CHICKEN CHOCOLATE-1)
          (EATS CANTELOPE PORK)
          (EATS BEEF TURKEY)
          (HARMONY INTOXICATION VENUS)
          (CRAVES BOILS-41 HAMBURGER)
          (ORBITS MERCURY VENUS)
          (LOCALE TUNA ARIZONA)
          (EATS PEAR-3 MELON)
          (EATS TOFU BACON)
          (EATS WONDERBREAD MARZIPAN)
          (EATS ARUGULA-25 POPOVER-24)
          (LOCALE MUTTON BAVARIA)
          (EATS GRAPEFRUIT CHOCOLATE)
          (EATS CUCUMBER-16 FLOUNDER)
          (LOCALE HAROSET BAVARIA)
          (EATS SHRIMP-29 ARUGULA)
          (LOCALE HAROSET-32 GOIAS)
          (EATS MUFFIN HAROSET-32)
          (CRAVES JEALOUSY-80 MARZIPAN)
          (EATS BROCCOLI CANTELOPE)
          (HARMONY TRIUMPH MERCURY)
          (CRAVES LACERATION-128 ONION)
          (CRAVES ANGER-39 GRAPEFRUIT)
          (CRAVES ENTERTAINMENT SNICKERS)
          (EATS CHOCOLATE RICE)
          (EATS ARUGULA SHRIMP-29)
          (HARMONY EXPECTATION VENUS)
          (CRAVES EMPATHY SNICKERS-27)
          (EATS COD PEAR)
          (LOCALE SCALLION BAVARIA)
          (CRAVES ANXIETY-251 FLOUNDER)
          (CRAVES STIMULATION APPLE)
          (EATS LETTUCE RICE-10)
          (EATS LOBSTER-12 COD)
          (HARMONY SATIETY MERCURY)
          (EATS LETTUCE PORK)
          (EATS PEPPER TUNA)
          (CRAVES PROSTATITIS-118 SCALLOP)
          (EATS POPOVER-24 BACON)
          (EATS MUTTON HAROSET)
          (LOCALE BAGUETTE MORAVIA)
          (EATS LEMON-15 GUAVA)
          (EATS LAMB PEA)
          (CRAVES DEPRESSION-109 PEA)
          (EATS COD MUFFIN)
          (EATS ARUGULA-25 KALE-26)
          (CRAVES ANGINA-119 MUFFIN)
          (CRAVES DREAD ARUGULA-25)
          (CRAVES INTOXICATION-22 CANTELOPE)
          (CRAVES ANGER RICE-10)
          (EATS PORK LETTUCE)
          (CRAVES GRIEF-253 FLOUNDER)
          (LOCALE BROCCOLI-13 GOIAS)
          (EATS SNICKERS FLOUNDER-4)
          (EATS FLOUNDER-4 SNICKERS)
          (LOCALE CUCUMBER-16 GUANABARA)
          (CRAVES HANGOVER-102 ORANGE)
          (CRAVES PROSTATITIS RICE-10)
          (LOCALE HAM ALSACE)
          (LOCALE HOTDOG-11 ARIZONA)
          (CRAVES ABRASION-123 LOBSTER)
          (EATS GUAVA LEMON-15)
          (EATS ORANGE SWEETROLL)
          (EATS CHOCOLATE-1 ONION)
          (CRAVES PROSTATITIS-99 LAMB)
          (CRAVES BOILS-65 ARUGULA)
          (EATS HOTDOG CANTELOPE)
          (EATS BEEF-23 ARUGULA-25)
          (LOCALE SWEETROLL BAVARIA)
          (CRAVES HANGOVER-77 PEPPER)
          (EATS SCALLOP-7 CHERRY)
          (CRAVES LACERATION-51 RICE)
          (EATS POTATO ONION)
          (EATS ARUGULA COD)
          (EATS YOGURT BROCCOLI)
          (EATS CUCUMBER-16 ENDIVE)
          (CRAVES JEALOUSY-45 ENDIVE)
          (CRAVES DREAD-71 SCALLION)
          (LOCALE ENDIVE-30 OREGON)
          (EATS WONDERBREAD FLOUNDER-4)
          (EATS CHOCOLATE BEEF)
          (EATS TOFU HAM)
          (CRAVES GRIEF-91 PAPAYA)
          (CRAVES LUBRICITY SCALLOP)
          (EATS KALE SCALLOP)
          (CRAVES ANGER-50 RICE)
          (CRAVES ABRASION POPOVER-24)
          (EATS BACON ENDIVE-30)
          (EATS GUAVA-5 SHRIMP)
          (CRAVES DREAD-96 LAMB)
          (LOCALE FLOUNDER MANITOBA)
          (EATS CUCUMBER RICE-10)
          (CRAVES DEPRESSION-59 CHOCOLATE-1)
          (LOCALE CHICKEN-31 PENNSYLVANIA)
          (LOCALE TOMATO KENTUCKY)
          (LOCALE TURKEY-14 OREGON)
          (EATS PEAR COD)
          (EATS CHICKEN LAMB)
          (HARMONY ACHIEVEMENT MERCURY)
          (CRAVES HANGOVER-120 MUFFIN)
          (LOCALE RICE-10 OREGON)
          (CRAVES ABRASION-76 PEPPER)
          (CRAVES SCIATICA-64 SCALLOP-7)
          (LOCALE MELON PENNSYLVANIA)
          (CRAVES LACERATION-82 YOGURT)
          (EATS PISTACHIO YOGURT)
          (LOCALE ONION BOSNIA)
          (CRAVES DEPRESSION-89 PAPAYA)
          (EATS SNICKERS HOTDOG-11)
          (LOCALE SNICKERS MANITOBA)
          (EATS LOBSTER-12 YOGURT)
          (ATTACKS BOSNIA OREGON)
          (EATS POTATO CANTELOPE)
          (EATS BAGUETTE PEAR-3)
          (CRAVES ANGER-104 CHOCOLATE)
          (LOCALE LAMB GUANABARA)
          (EATS TUNA PISTACHIO)
          (CRAVES ABRASION-58 CHOCOLATE-1)
          (CRAVES DREAD-121 MUFFIN)
          (CRAVES LONELINESS ARUGULA-25)
          (ATTACKS GOIAS MORAVIA)
          (CRAVES SCIATICA HAMBURGER-9)
          (LOCALE BEEF OREGON)
          (HARMONY STIMULATION EARTH)
          (EATS SNICKERS-27 POPOVER-24)
          (EATS YOGURT HAM)
          (EATS BROCCOLI TOMATO)
          (CRAVES ANXIETY-48 PEAR)
          (EATS HAROSET-32 MUFFIN)
          (EATS WURST HOTDOG-11)
          (CRAVES GRIEF-105 CHOCOLATE)
          (EATS POPOVER PAPAYA-6)
          (LOCALE POPOVER BOSNIA)
          (EATS BEEF CHOCOLATE)
          (CRAVES BOILS-86 MELON)
          (EATS RICE-10 CUCUMBER)
          (EATS WONDERBREAD SCALLOP-7)
          (EATS OKRA PAPAYA)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS GUAVA CUCUMBER)
          (EATS LAMB CHICKEN)
          (LOCALE SNICKERS-27 GOIAS)
          (LOCALE ARUGULA-25 OREGON)
          (EATS PEPPER-2 CHICKEN-31)
          (CRAVES DREAD-62 SCALLOP-7)
          (EATS YOGURT PEPPER-2)
          (EATS ONION CHOCOLATE-1)
          (LOCALE PAPAYA ARIZONA)
          (CRAVES SCIATICA-44 ENDIVE)
          (CRAVES ABRASION-49 RICE)
          (EATS ONION POTATO)
          (EATS SCALLION-28 HAMBURGER-9)
          (EATS KALE PAPAYA)
          (LOCALE PEAR-3 GOIAS)
          (ATTACKS ALSACE KENTUCKY)
          (EATS BEEF-23 KALE-26)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS CHOCOLATE GRAPEFRUIT)
          (EATS YOGURT POTATO)
          (EATS CHERRY ARUGULA)
          (CRAVES ANGINA-75 CHERRY)
          (EATS BAGUETTE LAMB)
          (EATS CHOCOLATE LOBSTER)
          (CRAVES SCIATICA-95 SHRIMP)
          (HARMONY LOVE-21 MERCURY)
          (CRAVES SCIATICA-116 GUAVA)
          (CRAVES ANGINA GUAVA-5)
          (EATS CUCUMBER BAGUETTE)
          (EATS POTATO BROCCOLI)
          (EATS PEPPER-2 YOGURT)
          (LOCALE SCALLOP-7 SURREY)
          (ORBITS EARTH MERCURY)
          (CRAVES UNDERSTANDING SHRIMP-29)
          (LOCALE TOFU QUEBEC)
          (CRAVES LONELINESS-114 HAM)
          (EATS TURKEY MARZIPAN)
          (LOCALE LETTUCE GOIAS)
          (CRAVES LONELINESS-43 HAMBURGER)
          (EATS MARZIPAN WONDERBREAD)
          (EATS TUNA PEPPER)
          (LOCALE PAPAYA-6 BAVARIA)
          (EATS SNICKERS PISTACHIO)
          (EATS CHERRY PAPAYA-6)
          (EATS ENDIVE PISTACHIO)
          (EATS POPOVER-24 ARUGULA-25)
          (EATS CANTELOPE BROCCOLI)
          (CRAVES GRIEF-110 PEA)
          (LOCALE PEPPER BOSNIA)
          (EATS BACON POPOVER-24)
          (EATS KALE MUFFIN)
          (CRAVES GRIEF-69 SCALLION)
          (EATS CHERRY SCALLOP-7)
          (EATS ORANGE PEAR)
          (EATS HOTDOG-11 WURST)
          (ORBITS JUPITER EARTH)
          (LOCALE HOTDOG KENTUCKY)
          (EATS FLOUNDER-4 MARZIPAN)
          (EATS CHICKEN FLOUNDER)
          (CRAVES ANXIETY-60 SCALLOP-7)
          (LOCALE CANTELOPE OREGON)
          (LOCALE HAMBURGER KENTUCKY)
          (CRAVES LONELINESS-93 SHRIMP)
          (EATS OKRA-8 LOBSTER)
          (CRAVES LACERATION HAROSET-32)
          (HARMONY LOVE VENUS))
   (:GOAL (AND (CRAVES BOILS-86 CANTELOPE)
               (CRAVES ABRASION-87 CANTELOPE)
               (CRAVES ANXIETY-115 CANTELOPE)
               (CRAVES SCIATICA-116 CANTELOPE))))

(DEFINE (PROBLEM STRIPS-MYSTY-35)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PEAR POPOVER GRAPEFRUIT PORK ENDIVE ORANGE POTATO COD
             YOGURT MUTTON TURKEY HAROSET KALE CUCUMBER PAPAYA APPLE
             MARZIPAN SNICKERS GUAVA WONDERBREAD ONION SCALLOP BROCCOLI TUNA
             WURST SCALLION MUFFIN MELON HAMBURGER PEPPER SHRIMP RICE
             TOMATO CHOCOLATE CHICKEN PEA FLOUNDER LOBSTER HAM LOVE
             INTOXICATION EXCITEMENT REST CURIOSITY SATISFACTION EXPECTATION
             STIMULATION ACHIEVEMENT LEARNING UNDERSTANDING HANGOVER ANXIETY
             BOILS ANGINA JEALOUSY LACERATION ANGER ABRASION GRIEF
             DEPRESSION LONELINESS DREAD GUANABARA PENNSYLVANIA BAVARIA
             JUPITER VULCAN EARTH URANUS)
   (:INIT (FOOD PEAR)
          (FOOD POPOVER)
          (FOOD GRAPEFRUIT)
          (FOOD PORK)
          (FOOD ENDIVE)
          (FOOD ORANGE)
          (FOOD POTATO)
          (FOOD COD)
          (FOOD YOGURT)
          (FOOD MUTTON)
          (FOOD TURKEY)
          (FOOD HAROSET)
          (FOOD KALE)
          (FOOD CUCUMBER)
          (FOOD PAPAYA)
          (FOOD APPLE)
          (FOOD MARZIPAN)
          (FOOD SNICKERS)
          (FOOD GUAVA)
          (FOOD WONDERBREAD)
          (FOOD ONION)
          (FOOD SCALLOP)
          (FOOD BROCCOLI)
          (FOOD TUNA)
          (FOOD WURST)
          (FOOD SCALLION)
          (FOOD MUFFIN)
          (FOOD MELON)
          (FOOD HAMBURGER)
          (FOOD PEPPER)
          (FOOD SHRIMP)
          (FOOD RICE)
          (FOOD TOMATO)
          (FOOD CHOCOLATE)
          (FOOD CHICKEN)
          (FOOD PEA)
          (FOOD FLOUNDER)
          (FOOD LOBSTER)
          (FOOD HAM)
          (PLEASURE LOVE)
          (PLEASURE INTOXICATION)
          (PLEASURE EXCITEMENT)
          (PLEASURE REST)
          (PLEASURE CURIOSITY)
          (PLEASURE SATISFACTION)
          (PLEASURE EXPECTATION)
          (PLEASURE STIMULATION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE LEARNING)
          (PLEASURE UNDERSTANDING)
          (PAIN HANGOVER)
          (PAIN ANXIETY)
          (PAIN BOILS)
          (PAIN ANGINA)
          (PAIN JEALOUSY)
          (PAIN LACERATION)
          (PAIN ANGER)
          (PAIN ABRASION)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN DREAD)
          (PROVINCE GUANABARA)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PLANET JUPITER)
          (PLANET VULCAN)
          (PLANET EARTH)
          (PLANET URANUS)
          (CRAVES JEALOUSY TUNA)
          (EATS ONION SHRIMP)
          (CRAVES LACERATION TUNA)
          (EATS TOMATO WONDERBREAD)
          (EATS CHICKEN HAM)
          (LOCALE APPLE PENNSYLVANIA)
          (LOCALE RICE PENNSYLVANIA)
          (HARMONY SATISFACTION VULCAN)
          (EATS HAROSET MUTTON)
          (LOCALE FLOUNDER BAVARIA)
          (EATS SCALLION SNICKERS)
          (EATS PEPPER BROCCOLI)
          (HARMONY UNDERSTANDING URANUS)
          (EATS TUNA HAMBURGER)
          (LOCALE KALE PENNSYLVANIA)
          (LOCALE SNICKERS GUANABARA)
          (EATS CUCUMBER SCALLOP)
          (CRAVES HANGOVER POTATO)
          (EATS CUCUMBER YOGURT)
          (EATS ORANGE PEAR)
          (HARMONY EXPECTATION EARTH)
          (LOCALE PEPPER BAVARIA)
          (LOCALE SCALLOP GUANABARA)
          (LOCALE WURST PENNSYLVANIA)
          (EATS MUTTON APPLE)
          (LOCALE PEAR PENNSYLVANIA)
          (CRAVES EXCITEMENT POTATO)
          (CRAVES LEARNING MELON)
          (EATS PEPPER WURST)
          (CRAVES CURIOSITY APPLE)
          (EATS POTATO GRAPEFRUIT)
          (CRAVES STIMULATION BROCCOLI)
          (EATS APPLE POPOVER)
          (EATS TURKEY APPLE)
          (EATS SHRIMP FLOUNDER)
          (EATS WURST CHOCOLATE)
          (EATS SNICKERS SCALLION)
          (EATS RICE MELON)
          (LOCALE SHRIMP GUANABARA)
          (EATS MARZIPAN TURKEY)
          (EATS HAM CHICKEN)
          (EATS ONION LOBSTER)
          (HARMONY REST EARTH)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (EATS TOMATO SCALLION)
          (EATS HAM MUFFIN)
          (EATS POPOVER PORK)
          (EATS HAROSET PAPAYA)
          (LOCALE SCALLION GUANABARA)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (LOCALE PEA GUANABARA)
          (EATS WURST PEPPER)
          (EATS BROCCOLI HAM)
          (ORBITS VULCAN EARTH)
          (LOCALE MUTTON BAVARIA)
          (HARMONY ACHIEVEMENT URANUS)
          (EATS LOBSTER ONION)
          (HARMONY CURIOSITY VULCAN)
          (EATS MELON CHOCOLATE)
          (EATS BROCCOLI PEPPER)
          (CRAVES EXPECTATION SCALLOP)
          (EATS APPLE GRAPEFRUIT)
          (EATS GRAPEFRUIT POTATO)
          (EATS GUAVA RICE)
          (EATS PEA PEPPER)
          (EATS YOGURT TURKEY)
          (EATS PORK CUCUMBER)
          (EATS ORANGE POPOVER)
          (EATS WONDERBREAD CHICKEN)
          (CRAVES UNDERSTANDING CHICKEN)
          (EATS CHOCOLATE SCALLION)
          (EATS SCALLION TOMATO)
          (EATS COD CUCUMBER)
          (EATS POPOVER APPLE)
          (EATS FLOUNDER SHRIMP)
          (LOCALE TOMATO BAVARIA)
          (EATS KALE TURKEY)
          (EATS ENDIVE POTATO)
          (LOCALE TUNA GUANABARA)
          (EATS FLOUNDER LOBSTER)
          (EATS SHRIMP ONION)
          (EATS APPLE MUTTON)
          (EATS SCALLOP CHOCOLATE)
          (EATS TURKEY YOGURT)
          (CRAVES DREAD PEA)
          (EATS MARZIPAN KALE)
          (EATS CHOCOLATE WURST)
          (HARMONY INTOXICATION URANUS)
          (CRAVES REST KALE)
          (EATS SCALLOP BROCCOLI)
          (EATS HAMBURGER SNICKERS)
          (EATS BROCCOLI MUFFIN)
          (EATS COD PAPAYA)
          (EATS CHOCOLATE SCALLOP)
          (EATS HAMBURGER TOMATO)
          (LOCALE CHICKEN BAVARIA)
          (EATS CHOCOLATE HAMBURGER)
          (EATS PAPAYA HAROSET)
          (LOCALE PAPAYA GUANABARA)
          (EATS SNICKERS HAMBURGER)
          (EATS RICE CHICKEN)
          (EATS TOMATO SHRIMP)
          (EATS MUTTON PEAR)
          (CRAVES ABRASION HAMBURGER)
          (ORBITS JUPITER VULCAN)
          (EATS HAROSET CUCUMBER)
          (LOCALE HAROSET GUANABARA)
          (CRAVES GRIEF HAMBURGER)
          (EATS POTATO ENDIVE)
          (EATS PORK POPOVER)
          (EATS CHOCOLATE MELON)
          (LOCALE GUAVA GUANABARA)
          (EATS GUAVA SCALLION)
          (EATS MUFFIN PEPPER)
          (ORBITS EARTH URANUS)
          (LOCALE ENDIVE PENNSYLVANIA)
          (LOCALE BROCCOLI PENNSYLVANIA)
          (EATS TOMATO HAMBURGER)
          (EATS TUNA FLOUNDER)
          (HARMONY EXCITEMENT VULCAN)
          (CRAVES LOVE POPOVER)
          (EATS HAMBURGER CHOCOLATE)
          (LOCALE HAM GUANABARA)
          (EATS TOMATO LOBSTER)
          (CRAVES ANGER TUNA)
          (LOCALE POTATO GUANABARA)
          (EATS YOGURT CUCUMBER)
          (LOCALE POPOVER GUANABARA)
          (EATS MUTTON HAROSET)
          (LOCALE CUCUMBER PENNSYLVANIA)
          (EATS MUFFIN HAM)
          (LOCALE GRAPEFRUIT PENNSYLVANIA)
          (CRAVES SATISFACTION GUAVA)
          (EATS YOGURT ENDIVE)
          (HARMONY STIMULATION EARTH)
          (CRAVES ACHIEVEMENT WURST)
          (EATS CHICKEN WONDERBREAD)
          (CRAVES INTOXICATION ORANGE)
          (LOCALE PORK GUANABARA)
          (LOCALE YOGURT GUANABARA)
          (EATS PEPPER PEA)
          (EATS GRAPEFRUIT APPLE)
          (EATS SCALLION CHOCOLATE)
          (EATS TURKEY MARZIPAN)
          (CRAVES LONELINESS CHICKEN)
          (LOCALE TURKEY PENNSYLVANIA)
          (EATS YOGURT KALE)
          (EATS MELON RICE)
          (EATS WONDERBREAD TOMATO)
          (EATS SHRIMP TOMATO)
          (LOCALE HAMBURGER PENNSYLVANIA)
          (LOCALE ORANGE GUANABARA)
          (EATS SCALLOP CUCUMBER)
          (EATS PAPAYA COD)
          (EATS CUCUMBER KALE)
          (EATS HAMBURGER TUNA)
          (EATS BROCCOLI SCALLOP)
          (EATS MUFFIN BROCCOLI)
          (HARMONY LEARNING URANUS)
          (EATS PEAR ORANGE)
          (EATS POPOVER ORANGE)
          (LOCALE WONDERBREAD GUANABARA)
          (LOCALE LOBSTER BAVARIA)
          (EATS CUCUMBER PORK)
          (EATS SCALLION GUAVA)
          (EATS MELON HAM)
          (CRAVES ANXIETY COD)
          (EATS PEAR MUTTON)
          (EATS KALE YOGURT)
          (EATS KALE MARZIPAN)
          (EATS PEA MUFFIN)
          (LOCALE MELON GUANABARA)
          (LOCALE ONION BAVARIA)
          (HARMONY LOVE URANUS)
          (LOCALE COD GUANABARA)
          (EATS HAM MELON)
          (EATS ORANGE HAROSET)
          (EATS APPLE TURKEY)
          (EATS PEPPER MUFFIN)
          (EATS TURKEY KALE)
          (EATS LOBSTER FLOUNDER)
          (CRAVES DEPRESSION PEPPER)
          (EATS ENDIVE YOGURT)
          (CRAVES BOILS COD)
          (CRAVES ANGINA SCALLOP)
          (EATS FLOUNDER TUNA)
          (LOCALE MUFFIN GUANABARA)
          (EATS HAROSET ORANGE)
          (EATS CHICKEN RICE)
          (EATS CUCUMBER HAROSET)
          (ATTACKS GUANABARA PENNSYLVANIA)
          (EATS RICE GUAVA)
          (EATS KALE CUCUMBER)
          (EATS CUCUMBER COD)
          (EATS LOBSTER TOMATO)
          (EATS HAM BROCCOLI)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (EATS MUFFIN PEA))
   (:GOAL (AND (CRAVES LONELINESS HAMBURGER)
               (CRAVES GRIEF HAMBURGER)
               (CRAVES HANGOVER ONION)
               (CRAVES ANGINA MELON))))

(DEFINE (PROBLEM STRIPS-MYSTY-36)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PAPAYA-15 LAMB-16 TOFU-5 SNICKERS-6 MUFFIN-7 HAM-8
             TUNA-3 SHRIMP-4 WONDERBREAD-1 BACON-2 POTATO YOGURT
             GRAPEFRUIT KALE BROCCOLI TUNA BACON FLOUNDER PISTACHIO OKRA LEMON
             MARZIPAN BEEF HAMBURGER SCALLOP LAMB TOFU CANTELOPE LOBSTER
             HOTDOG SWEETROLL WONDERBREAD BAGUETTE ORANGE HAM PEPPER
             SCALLION MELON COD PEA APPLE CHERRY TOMATO PAPAYA TURKEY CUCUMBER
             WURST ARUGULA ONION RICE GUAVA POPOVER PEAR CHOCOLATE LETTUCE
             MUTTON SHRIMP ENDIVE SNICKERS CHICKEN MUFFIN PORK HAROSET
             EMPATHY UNDERSTANDING REST SATISFACTION STIMULATION
             EXPECTATION INTOXICATION TRIUMPH LEARNING EXCITEMENT SATIETY
             CURIOSITY LOVE LUBRICITY AESTHETICS ACHIEVEMENT ENTERTAINMENT
             TRIUMPH-14 LUBRICITY-13 LOVE-12 SATISFACTION-11 CURIOSITY-10
             STIMULATION-9 EXPECTATION-32 ENTERTAINMENT-31 AESTHETICS-30
             INTOXICATION-29 UNDERSTANDING-28 ACHIEVEMENT-27 SATIETY-26
             EMPATHY-25 LEARNING-24 REST-23 EXCITEMENT-22 AESTHETICS-21
             EXCITEMENT-20 REST-19 STIMULATION-18 LEARNING-17 TRIUMPH-64
             SCIATICA GRIEF DREAD ABRASION LACERATION ANXIETY DEPRESSION
             LONELINESS ANGINA PROSTATITIS ANGER HANGOVER BOILS GRIEF-63
             JEALOUSY ANGER-60 HANGOVER-61 DEPRESSION-62 PROSTATITIS-57
             DREAD-58 JEALOUSY-59 SCIATICA-53 LONELINESS-54 BOILS-55
             ABRASION-56 ANXIETY-52 LACERATION-50 ANGINA-51 ANGINA-49
             JEALOUSY-45 DREAD-46 HANGOVER-47 LACERATION-48 ANXIETY-41
             GRIEF-42 ANGER-43 PROSTATITIS-44 BOILS-40 DEPRESSION-39
             ABRASION-37 LONELINESS-38 HANGOVER-35 SCIATICA-36
             PROSTATITIS-127 ABRASION-128 ANGER-33 ANGINA-34 JEALOUSY-124
             DEPRESSION-125 GRIEF-126 LACERATION-122 BOILS-123 LONELINESS-119
             DREAD-120 ANXIETY-121 SCIATICA-118 DREAD-116 GRIEF-117
             LACERATION-115 ANGER-113 DEPRESSION-114 ANGINA-112 PROSTATITIS-108
             ANXIETY-109 HANGOVER-110 BOILS-111 SCIATICA-105 ABRASION-106
             JEALOUSY-107 DREAD-101 ABRASION-102 PROSTATITIS-103
             LONELINESS-104 LONELINESS-98 BOILS-99 ANGINA-100 SCIATICA-94
             HANGOVER-95 DEPRESSION-96 GRIEF-97 LACERATION-91 JEALOUSY-92
             ANGER-93 LACERATION-89 ANXIETY-90 DEPRESSION-85 ANXIETY-86
             LONELINESS-87 ANGER-88 ANGINA-82 BOILS-83 DREAD-84 JEALOUSY-80
             GRIEF-81 PROSTATITIS-77 ABRASION-78 HANGOVER-79 ANGINA-73
             BOILS-74 PROSTATITIS-75 SCIATICA-76 ABRASION-71 SCIATICA-72
             DEPRESSION-67 ANGER-68 DREAD-69 LONELINESS-70 KENTUCKY QUEBEC
             MERCURY SATURN MARS JUPITER)
   (:INIT (FOOD PAPAYA-15)
          (FOOD LAMB-16)
          (FOOD TOFU-5)
          (FOOD SNICKERS-6)
          (FOOD MUFFIN-7)
          (FOOD HAM-8)
          (FOOD TUNA-3)
          (FOOD SHRIMP-4)
          (FOOD WONDERBREAD-1)
          (FOOD BACON-2)
          (FOOD POTATO)
          (FOOD YOGURT)
          (FOOD GRAPEFRUIT)
          (FOOD KALE)
          (FOOD BROCCOLI)
          (FOOD TUNA)
          (FOOD BACON)
          (FOOD FLOUNDER)
          (FOOD PISTACHIO)
          (FOOD OKRA)
          (FOOD LEMON)
          (FOOD MARZIPAN)
          (FOOD BEEF)
          (FOOD HAMBURGER)
          (FOOD SCALLOP)
          (FOOD LAMB)
          (FOOD TOFU)
          (FOOD CANTELOPE)
          (FOOD LOBSTER)
          (FOOD HOTDOG)
          (FOOD SWEETROLL)
          (FOOD WONDERBREAD)
          (FOOD BAGUETTE)
          (FOOD ORANGE)
          (FOOD HAM)
          (FOOD PEPPER)
          (FOOD SCALLION)
          (FOOD MELON)
          (FOOD COD)
          (FOOD PEA)
          (FOOD APPLE)
          (FOOD CHERRY)
          (FOOD TOMATO)
          (FOOD PAPAYA)
          (FOOD TURKEY)
          (FOOD CUCUMBER)
          (FOOD WURST)
          (FOOD ARUGULA)
          (FOOD ONION)
          (FOOD RICE)
          (FOOD GUAVA)
          (FOOD POPOVER)
          (FOOD PEAR)
          (FOOD CHOCOLATE)
          (FOOD LETTUCE)
          (FOOD MUTTON)
          (FOOD SHRIMP)
          (FOOD ENDIVE)
          (FOOD SNICKERS)
          (FOOD CHICKEN)
          (FOOD MUFFIN)
          (FOOD PORK)
          (FOOD HAROSET)
          (PLEASURE EMPATHY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE REST)
          (PLEASURE SATISFACTION)
          (PLEASURE STIMULATION)
          (PLEASURE EXPECTATION)
          (PLEASURE INTOXICATION)
          (PLEASURE TRIUMPH)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE SATIETY)
          (PLEASURE CURIOSITY)
          (PLEASURE LOVE)
          (PLEASURE LUBRICITY)
          (PLEASURE AESTHETICS)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE TRIUMPH-14)
          (PLEASURE LUBRICITY-13)
          (PLEASURE LOVE-12)
          (PLEASURE SATISFACTION-11)
          (PLEASURE CURIOSITY-10)
          (PLEASURE STIMULATION-9)
          (PLEASURE EXPECTATION-32)
          (PLEASURE ENTERTAINMENT-31)
          (PLEASURE AESTHETICS-30)
          (PLEASURE INTOXICATION-29)
          (PLEASURE UNDERSTANDING-28)
          (PLEASURE ACHIEVEMENT-27)
          (PLEASURE SATIETY-26)
          (PLEASURE EMPATHY-25)
          (PLEASURE LEARNING-24)
          (PLEASURE REST-23)
          (PLEASURE EXCITEMENT-22)
          (PLEASURE AESTHETICS-21)
          (PLEASURE EXCITEMENT-20)
          (PLEASURE REST-19)
          (PLEASURE STIMULATION-18)
          (PLEASURE LEARNING-17)
          (PLEASURE TRIUMPH-64)
          (PAIN SCIATICA)
          (PAIN GRIEF)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN LACERATION)
          (PAIN ANXIETY)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN ANGINA)
          (PAIN PROSTATITIS)
          (PAIN ANGER)
          (PAIN HANGOVER)
          (PAIN BOILS)
          (PAIN GRIEF-63)
          (PAIN JEALOUSY)
          (PAIN ANGER-60)
          (PAIN HANGOVER-61)
          (PAIN DEPRESSION-62)
          (PAIN PROSTATITIS-57)
          (PAIN DREAD-58)
          (PAIN JEALOUSY-59)
          (PAIN SCIATICA-53)
          (PAIN LONELINESS-54)
          (PAIN BOILS-55)
          (PAIN ABRASION-56)
          (PAIN ANXIETY-52)
          (PAIN LACERATION-50)
          (PAIN ANGINA-51)
          (PAIN ANGINA-49)
          (PAIN JEALOUSY-45)
          (PAIN DREAD-46)
          (PAIN HANGOVER-47)
          (PAIN LACERATION-48)
          (PAIN ANXIETY-41)
          (PAIN GRIEF-42)
          (PAIN ANGER-43)
          (PAIN PROSTATITIS-44)
          (PAIN BOILS-40)
          (PAIN DEPRESSION-39)
          (PAIN ABRASION-37)
          (PAIN LONELINESS-38)
          (PAIN HANGOVER-35)
          (PAIN SCIATICA-36)
          (PAIN PROSTATITIS-127)
          (PAIN ABRASION-128)
          (PAIN ANGER-33)
          (PAIN ANGINA-34)
          (PAIN JEALOUSY-124)
          (PAIN DEPRESSION-125)
          (PAIN GRIEF-126)
          (PAIN LACERATION-122)
          (PAIN BOILS-123)
          (PAIN LONELINESS-119)
          (PAIN DREAD-120)
          (PAIN ANXIETY-121)
          (PAIN SCIATICA-118)
          (PAIN DREAD-116)
          (PAIN GRIEF-117)
          (PAIN LACERATION-115)
          (PAIN ANGER-113)
          (PAIN DEPRESSION-114)
          (PAIN ANGINA-112)
          (PAIN PROSTATITIS-108)
          (PAIN ANXIETY-109)
          (PAIN HANGOVER-110)
          (PAIN BOILS-111)
          (PAIN SCIATICA-105)
          (PAIN ABRASION-106)
          (PAIN JEALOUSY-107)
          (PAIN DREAD-101)
          (PAIN ABRASION-102)
          (PAIN PROSTATITIS-103)
          (PAIN LONELINESS-104)
          (PAIN LONELINESS-98)
          (PAIN BOILS-99)
          (PAIN ANGINA-100)
          (PAIN SCIATICA-94)
          (PAIN HANGOVER-95)
          (PAIN DEPRESSION-96)
          (PAIN GRIEF-97)
          (PAIN LACERATION-91)
          (PAIN JEALOUSY-92)
          (PAIN ANGER-93)
          (PAIN LACERATION-89)
          (PAIN ANXIETY-90)
          (PAIN DEPRESSION-85)
          (PAIN ANXIETY-86)
          (PAIN LONELINESS-87)
          (PAIN ANGER-88)
          (PAIN ANGINA-82)
          (PAIN BOILS-83)
          (PAIN DREAD-84)
          (PAIN JEALOUSY-80)
          (PAIN GRIEF-81)
          (PAIN PROSTATITIS-77)
          (PAIN ABRASION-78)
          (PAIN HANGOVER-79)
          (PAIN ANGINA-73)
          (PAIN BOILS-74)
          (PAIN PROSTATITIS-75)
          (PAIN SCIATICA-76)
          (PAIN ABRASION-71)
          (PAIN SCIATICA-72)
          (PAIN DEPRESSION-67)
          (PAIN ANGER-68)
          (PAIN DREAD-69)
          (PAIN LONELINESS-70)
          (PROVINCE KENTUCKY)
          (PROVINCE QUEBEC)
          (PLANET MERCURY)
          (PLANET SATURN)
          (PLANET MARS)
          (PLANET JUPITER)
          (EATS LETTUCE ARUGULA)
          (CRAVES DREAD LAMB-16)
          (CRAVES SATIETY FLOUNDER)
          (CRAVES ACHIEVEMENT LAMB)
          (EATS HOTDOG POPOVER)
          (CRAVES EMPATHY PAPAYA-15)
          (CRAVES ANGINA-82 LETTUCE)
          (EATS BACON HAM)
          (CRAVES GRIEF-117 COD)
          (HARMONY LUBRICITY JUPITER)
          (LOCALE SCALLION KENTUCKY)
          (EATS ONION OKRA)
          (CRAVES SATISFACTION-11 ORANGE)
          (EATS CUCUMBER SNICKERS)
          (EATS TOFU MUTTON)
          (CRAVES CURIOSITY-10 HAM)
          (EATS ORANGE CANTELOPE)
          (EATS SNICKERS-6 KALE)
          (EATS SNICKERS CUCUMBER)
          (EATS CHOCOLATE PEA)
          (ORBITS MERCURY SATURN)
          (LOCALE TOFU-5 KENTUCKY)
          (CRAVES HANGOVER-47 FLOUNDER)
          (HARMONY EXPECTATION-32 MARS)
          (EATS TOFU-5 GRAPEFRUIT)
          (CRAVES DEPRESSION-96 ONION)
          (EATS POTATO KALE)
          (CRAVES HANGOVER-61 SHRIMP-4)
          (CRAVES ANXIETY-90 POPOVER)
          (CRAVES ANGER-113 CHERRY)
          (EATS POTATO PAPAYA-15)
          (HARMONY ACHIEVEMENT SATURN)
          (EATS MELON LOBSTER)
          (EATS BROCCOLI SNICKERS-6)
          (EATS OKRA PAPAYA)
          (EATS GRAPEFRUIT PAPAYA-15)
          (EATS CHOCOLATE TOMATO)
          (LOCALE HAM QUEBEC)
          (EATS PEA ENDIVE)
          (EATS POPOVER LETTUCE)
          (LOCALE LAMB-16 QUEBEC)
          (EATS ENDIVE PEA)
          (EATS SNICKERS SCALLOP)
          (HARMONY INTOXICATION SATURN)
          (LOCALE OKRA KENTUCKY)
          (LOCALE PEAR QUEBEC)
          (EATS RICE SHRIMP)
          (HARMONY STIMULATION-9 JUPITER)
          (EATS POPOVER LAMB)
          (EATS MUFFIN-7 LAMB-16)
          (CRAVES UNDERSTANDING-28 TURKEY)
          (EATS KALE SHRIMP-4)
          (EATS GRAPEFRUIT TOFU-5)
          (LOCALE POPOVER KENTUCKY)
          (CRAVES AESTHETICS SCALLOP)
          (CRAVES PROSTATITIS-127 WONDERBREAD)
          (EATS TUNA-3 YOGURT)
          (CRAVES UNDERSTANDING SNICKERS-6)
          (LOCALE MELON QUEBEC)
          (CRAVES ANXIETY-109 PAPAYA)
          (EATS YOGURT TUNA-3)
          (HARMONY LEARNING-24 SATURN)
          (CRAVES DEPRESSION-125 BAGUETTE)
          (CRAVES ANGER-68 HAROSET)
          (CRAVES PROSTATITIS-103 CUCUMBER)
          (EATS TURKEY MUFFIN)
          (EATS SNICKERS-6 BROCCOLI)
          (CRAVES EXPECTATION POTATO)
          (CRAVES ANGINA-34 WONDERBREAD)
          (LOCALE ORANGE QUEBEC)
          (CRAVES BOILS-123 PEPPER)
          (EATS YOGURT BACON-2)
          (LOCALE KALE KENTUCKY)
          (CRAVES SCIATICA-94 ONION)
          (LOCALE ENDIVE KENTUCKY)
          (CRAVES ABRASION-128 WONDERBREAD)
          (CRAVES LONELINESS-119 SCALLION)
          (EATS COD GUAVA)
          (HARMONY LEARNING JUPITER)
          (CRAVES LONELINESS TOFU-5)
          (EATS ARUGULA LETTUCE)
          (EATS POPOVER LOBSTER)
          (CRAVES ANXIETY TOFU-5)
          (CRAVES ANXIETY-86 PEAR)
          (EATS TOFU-5 BACON-2)
          (HARMONY UNDERSTANDING MARS)
          (EATS FLOUNDER ENDIVE)
          (EATS PEAR WURST)
          (EATS MUTTON PEPPER)
          (EATS LETTUCE HAROSET)
          (CRAVES JEALOUSY-107 TURKEY)
          (EATS PEAR MUTTON)
          (EATS SCALLION BAGUETTE)
          (CRAVES ABRASION-71 PORK)
          (LOCALE PORK KENTUCKY)
          (CRAVES STIMULATION BACON-2)
          (CRAVES DREAD-58 WONDERBREAD-1)
          (EATS WONDERBREAD-1 BACON-2)
          (EATS ORANGE PEAR)
          (EATS PAPAYA CUCUMBER)
          (CRAVES EMPATHY-25 GUAVA)
          (EATS WONDERBREAD LETTUCE)
          (CRAVES ANGINA-73 MUFFIN)
          (CRAVES LEARNING-24 PEAR)
          (LOCALE TOMATO KENTUCKY)
          (HARMONY CURIOSITY-10 SATURN)
          (CRAVES DREAD-46 FLOUNDER)
          (EATS HAM BACON)
          (EATS BACON-2 WONDERBREAD-1)
          (HARMONY REST-19 SATURN)
          (LOCALE PEPPER KENTUCKY)
          (LOCALE SNICKERS-6 KENTUCKY)
          (EATS LAMB POPOVER)
          (EATS WURST SNICKERS)
          (CRAVES PROSTATITIS-108 PAPAYA)
          (EATS ENDIVE FLOUNDER)
          (LOCALE GUAVA KENTUCKY)
          (EATS TURKEY CHICKEN)
          (CRAVES JEALOUSY TUNA-3)
          (EATS LOBSTER POPOVER)
          (LOCALE PEA KENTUCKY)
          (EATS TURKEY COD)
          (EATS POPOVER HOTDOG)
          (EATS PISTACHIO TURKEY)
          (EATS ARUGULA CHICKEN)
          (LOCALE PAPAYA-15 KENTUCKY)
          (LOCALE CANTELOPE QUEBEC)
          (EATS HAM-8 BROCCOLI)
          (EATS SNICKERS WURST)
          (EATS BROCCOLI HAM-8)
          (EATS PEAR COD)
          (EATS LAMB MUTTON)
          (EATS CANTELOPE HAM)
          (CRAVES LONELINESS-54 YOGURT)
          (HARMONY LEARNING-17 JUPITER)
          (EATS GUAVA ARUGULA)
          (LOCALE SNICKERS KENTUCKY)
          (EATS WONDERBREAD LOBSTER)
          (EATS MUTTON LAMB)
          (CRAVES DREAD-120 SCALLION)
          (EATS MUTTON TOFU)
          (EATS MELON WONDERBREAD)
          (EATS TUNA BACON-2)
          (HARMONY LOVE-12 JUPITER)
          (LOCALE WONDERBREAD-1 KENTUCKY)
          (CRAVES STIMULATION-18 SNICKERS)
          (LOCALE MUTTON KENTUCKY)
          (LOCALE MARZIPAN KENTUCKY)
          (EATS TOFU WURST)
          (HARMONY EMPATHY-25 MARS)
          (EATS SCALLOP SNICKERS)
          (EATS PEA BEEF)
          (EATS ARUGULA POPOVER)
          (EATS HAM CANTELOPE)
          (EATS MARZIPAN LETTUCE)
          (EATS BACON-2 TOFU-5)
          (CRAVES JEALOUSY-92 GUAVA)
          (ORBITS MARS JUPITER)
          (EATS HAROSET BAGUETTE)
          (CRAVES ANGER-93 GUAVA)
          (LOCALE POTATO KENTUCKY)
          (EATS BEEF TOMATO)
          (CRAVES SCIATICA-76 MUFFIN)
          (EATS CHERRY CHICKEN)
          (EATS HAMBURGER SNICKERS)
          (CRAVES ABRASION-106 TURKEY)
          (CRAVES REST-19 ENDIVE)
          (LOCALE LEMON KENTUCKY)
          (EATS SHRIMP ENDIVE)
          (CRAVES GRIEF-63 TUNA-3)
          (CRAVES DREAD-84 LETTUCE)
          (LOCALE PAPAYA KENTUCKY)
          (CRAVES EXCITEMENT-20 SHRIMP)
          (EATS MELON SHRIMP)
          (CRAVES DREAD-69 HAROSET)
          (CRAVES EXCITEMENT-22 LETTUCE)
          (LOCALE COD QUEBEC)
          (HARMONY SATISFACTION-11 SATURN)
          (LOCALE CHERRY KENTUCKY)
          (EATS LEMON CHOCOLATE)
          (EATS SNICKERS HAMBURGER)
          (CRAVES LEARNING-17 CHICKEN)
          (CRAVES AESTHETICS-21 MUTTON)
          (CRAVES EXCITEMENT BACON)
          (HARMONY ENTERTAINMENT MARS)
          (EATS COD CHERRY)
          (EATS CHOCOLATE BEEF)
          (EATS PORK SNICKERS)
          (HARMONY AESTHETICS-30 SATURN)
          (HARMONY TRIUMPH SATURN)
          (CRAVES BOILS-83 LETTUCE)
          (EATS GUAVA CHICKEN)
          (CRAVES LACERATION-122 PEPPER)
          (CRAVES PROSTATITIS-75 MUFFIN)
          (EATS TURKEY PISTACHIO)
          (CRAVES JEALOUSY-80 ENDIVE)
          (LOCALE HAM-8 QUEBEC)
          (CRAVES LOVE-12 WONDERBREAD)
          (EATS PEPPER GUAVA)
          (EATS MUTTON PEAR)
          (EATS GUAVA PEAR)
          (LOCALE MUFFIN KENTUCKY)
          (LOCALE BAGUETTE KENTUCKY)
          (CRAVES GRIEF PAPAYA-15)
          (CRAVES JEALOUSY-124 BAGUETTE)
          (HARMONY STIMULATION SATURN)
          (EATS WURST LEMON)
          (EATS SWEETROLL APPLE)
          (CRAVES INTOXICATION KALE)
          (LOCALE SWEETROLL KENTUCKY)
          (EATS COD PEAR)
          (CRAVES LUBRICITY HAMBURGER)
          (CRAVES HANGOVER SNICKERS-6)
          (CRAVES GRIEF-42 LAMB)
          (LOCALE SHRIMP-4 QUEBEC)
          (EATS CHERRY COD)
          (CRAVES SATIETY-26 RICE)
          (LOCALE HAROSET KENTUCKY)
          (HARMONY ENTERTAINMENT-31 MARS)
          (EATS HOTDOG GUAVA)
          (EATS ONION PORK)
          (LOCALE PISTACHIO KENTUCKY)
          (EATS CHOCOLATE SNICKERS)
          (CRAVES PROSTATITIS SNICKERS-6)
          (EATS LAMB-16 MUFFIN-7)
          (EATS HAMBURGER MUFFIN)
          (CRAVES SCIATICA-72 PORK)
          (EATS PEA CHOCOLATE)
          (EATS LETTUCE WONDERBREAD)
          (EATS TOMATO CHOCOLATE)
          (EATS CHOCOLATE LEMON)
          (HARMONY LUBRICITY-13 SATURN)
          (LOCALE LETTUCE QUEBEC)
          (CRAVES PROSTATITIS-44 LAMB)
          (CRAVES GRIEF-97 ONION)
          (EATS SNICKERS PORK)
          (HARMONY AESTHETICS-21 SATURN)
          (CRAVES ANXIETY-121 SCALLION)
          (EATS HAM PISTACHIO)
          (HARMONY EXPECTATION MARS)
          (HARMONY INTOXICATION-29 MARS)
          (LOCALE CUCUMBER KENTUCKY)
          (CRAVES TRIUMPH BROCCOLI)
          (EATS CHICKEN GUAVA)
          (CRAVES REST MUFFIN-7)
          (EATS BEEF PEA)
          (EATS BACON-2 TUNA)
          (LOCALE WURST QUEBEC)
          (LOCALE ARUGULA QUEBEC)
          (CRAVES ACHIEVEMENT-27 CUCUMBER)
          (EATS HOTDOG YOGURT)
          (LOCALE TUNA-3 QUEBEC)
          (LOCALE HOTDOG KENTUCKY)
          (EATS OKRA ONION)
          (CRAVES AESTHETICS-30 PEA)
          (EATS SCALLION MARZIPAN)
          (CRAVES JEALOUSY-59 WONDERBREAD-1)
          (LOCALE BROCCOLI KENTUCKY)
          (CRAVES ANGINA-112 TOMATO)
          (EATS LETTUCE POPOVER)
          (LOCALE HAMBURGER KENTUCKY)
          (EATS ONION CHOCOLATE)
          (CRAVES EXPECTATION-32 MELON)
          (CRAVES LACERATION-48 FLOUNDER)
          (EATS TOMATO BEEF)
          (LOCALE YOGURT KENTUCKY)
          (CRAVES ANGINA-49 TUNA)
          (EATS PEAR GUAVA)
          (EATS SHRIMP RICE)
          (CRAVES JEALOUSY-45 FLOUNDER)
          (EATS WONDERBREAD-1 HAM-8)
          (CRAVES ENTERTAINMENT-31 COD)
          (CRAVES ABRASION LAMB-16)
          (CRAVES REST-23 CHOCOLATE)
          (LOCALE SHRIMP KENTUCKY)
          (EATS BACON MUFFIN)
          (EATS PAPAYA-15 ORANGE)
          (EATS GRAPEFRUIT TUNA)
          (LOCALE RICE KENTUCKY)
          (CRAVES CURIOSITY LEMON)
          (EATS RICE SCALLION)
          (HARMONY SATISFACTION MARS)
          (EATS BACON-2 YOGURT)
          (LOCALE LOBSTER KENTUCKY)
          (HARMONY EXCITEMENT-22 SATURN)
          (CRAVES DEPRESSION-85 PEAR)
          (LOCALE CHOCOLATE KENTUCKY)
          (LOCALE FLOUNDER KENTUCKY)
          (LOCALE APPLE KENTUCKY)
          (EATS WONDERBREAD-1 MUFFIN-7)
          (EATS LETTUCE CHICKEN)
          (EATS FLOUNDER MUTTON)
          (EATS YOGURT SHRIMP-4)
          (CRAVES ABRASION-37 HOTDOG)
          (CRAVES ANGINA-51 BROCCOLI)
          (EATS TUNA LAMB-16)
          (EATS LOBSTER MELON)
          (CRAVES SCIATICA-105 TURKEY)
          (CRAVES BOILS-55 YOGURT)
          (EATS PAPAYA-15 GRAPEFRUIT)
          (EATS LAMB-16 TUNA)
          (EATS TUNA GRAPEFRUIT)
          (EATS CHICKEN ARUGULA)
          (HARMONY STIMULATION-18 JUPITER)
          (EATS ARUGULA GUAVA)
          (EATS POPOVER APPLE)
          (EATS GUAVA COD)
          (LOCALE TOFU KENTUCKY)
          (CRAVES PROSTATITIS-57 WONDERBREAD-1)
          (CRAVES DEPRESSION-114 CHERRY)
          (CRAVES LONELINESS-70 HAROSET)
          (CRAVES LACERATION-115 APPLE)
          (EATS SNICKERS CHOCOLATE)
          (EATS WONDERBREAD MELON)
          (CRAVES SCIATICA-118 MELON)
          (EATS KALE SNICKERS-6)
          (EATS CHICKEN LETTUCE)
          (EATS MUTTON WURST)
          (ORBITS SATURN MARS)
          (LOCALE ONION QUEBEC)
          (EATS WURST PEAR)
          (CRAVES LACERATION-50 BROCCOLI)
          (EATS APPLE MELON)
          (CRAVES PROSTATITIS-77 CHICKEN)
          (EATS POPOVER ARUGULA)
          (CRAVES ANXIETY-41 LAMB)
          (LOCALE GRAPEFRUIT QUEBEC)
          (LOCALE SCALLOP QUEBEC)
          (LOCALE BACON QUEBEC)
          (EATS KALE POTATO)
          (CRAVES LONELINESS-87 PEAR)
          (LOCALE LAMB KENTUCKY)
          (HARMONY EMPATHY SATURN)
          (CRAVES SATISFACTION HAM-8)
          (EATS PAPAYA OKRA)
          (EATS MUFFIN HAMBURGER)
          (EATS MUTTON FLOUNDER)
          (EATS HAM-8 WONDERBREAD-1)
          (CRAVES BOILS HAM-8)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES ABRASION-56 YOGURT)
          (CRAVES ABRASION-78 CHICKEN)
          (EATS PISTACHIO HAM)
          (CRAVES DREAD-101 CUCUMBER)
          (CRAVES BOILS-40 CANTELOPE)
          (EATS PORK TOMATO)
          (EATS ORANGE PAPAYA-15)
          (EATS PORK ONION)
          (EATS SHRIMP-4 KALE)
          (EATS MUFFIN BACON)
          (EATS APPLE POPOVER)
          (EATS MELON APPLE)
          (CRAVES ENTERTAINMENT TOFU)
          (HARMONY ACHIEVEMENT-27 JUPITER)
          (LOCALE CHICKEN KENTUCKY)
          (CRAVES LONELINESS-104 CUCUMBER)
          (LOCALE WONDERBREAD KENTUCKY)
          (CRAVES DEPRESSION TOFU-5)
          (EATS COD TURKEY)
          (EATS SCALLOP PEAR)
          (EATS PEPPER MUTTON)
          (EATS BEEF CHOCOLATE)
          (EATS CHICKEN TURKEY)
          (CRAVES HANGOVER-35 SWEETROLL)
          (CRAVES SCIATICA-36 SWEETROLL)
          (LOCALE TURKEY KENTUCKY)
          (EATS ENDIVE CHOCOLATE)
          (EATS PAPAYA-15 POTATO)
          (HARMONY AESTHETICS SATURN)
          (CRAVES HANGOVER-95 ONION)
          (EATS CANTELOPE ORANGE)
          (CRAVES GRIEF-81 ENDIVE)
          (EATS ENDIVE SHRIMP)
          (CRAVES ANGER-43 LAMB)
          (HARMONY REST SATURN)
          (EATS LETTUCE MARZIPAN)
          (CRAVES LOVE BEEF)
          (CRAVES BOILS-111 PAPAYA)
          (EATS GUAVA HOTDOG)
          (EATS CHOCOLATE ONION)
          (HARMONY LOVE MARS)
          (HARMONY REST-23 SATURN)
          (EATS CHOCOLATE ENDIVE)
          (EATS APPLE SWEETROLL)
          (CRAVES ANXIETY-52 GRAPEFRUIT)
          (EATS SHRIMP SWEETROLL)
          (EATS BAGUETTE HAROSET)
          (EATS WURST TOFU)
          (ATTACKS KENTUCKY QUEBEC)
          (HARMONY SATIETY-26 SATURN)
          (EATS LEMON WURST)
          (EATS CUCUMBER PAPAYA)
          (HARMONY EXCITEMENT-20 JUPITER)
          (LOCALE MUFFIN-7 KENTUCKY)
          (EATS CHOCOLATE TOFU)
          (HARMONY SATIETY MARS)
          (CRAVES TRIUMPH-64 PORK)
          (CRAVES LACERATION-89 POPOVER)
          (EATS SWEETROLL SHRIMP)
          (CRAVES DEPRESSION-62 SHRIMP-4)
          (CRAVES ANGER-33 WONDERBREAD)
          (EATS MUFFIN TURKEY)
          (CRAVES LUBRICITY-13 HOTDOG)
          (HARMONY UNDERSTANDING-28 JUPITER)
          (CRAVES BOILS-99 WURST)
          (EATS SHRIMP-4 YOGURT)
          (EATS BAGUETTE SCALLION)
          (CRAVES DEPRESSION-67 HAROSET)
          (EATS PEAR ORANGE)
          (CRAVES ANGINA SNICKERS-6)
          (CRAVES LEARNING TUNA)
          (EATS CHICKEN CHERRY)
          (CRAVES LACERATION-91 GUAVA)
          (EATS HAROSET LETTUCE)
          (HARMONY TRIUMPH-14 SATURN)
          (CRAVES ANGER-60 SHRIMP-4)
          (CRAVES ANGER-88 PEAR)
          (EATS LOBSTER WONDERBREAD)
          (EATS WURST MUTTON)
          (CRAVES LONELINESS-98 WURST)
          (CRAVES DREAD-116 COD)
          (CRAVES HANGOVER-110 PAPAYA)
          (LOCALE BACON-2 QUEBEC)
          (CRAVES DEPRESSION-39 LOBSTER)
          (EATS GUAVA PEPPER)
          (CRAVES SCIATICA-53 YOGURT)
          (CRAVES BOILS-74 MUFFIN)
          (EATS PEAR SCALLOP)
          (CRAVES SCIATICA PAPAYA-15)
          (EATS MUFFIN-7 WONDERBREAD-1)
          (EATS BROCCOLI TUNA-3)
          (CRAVES GRIEF-126 BAGUETTE)
          (EATS SCALLION RICE)
          (LOCALE TUNA KENTUCKY)
          (CRAVES HANGOVER-79 CHICKEN)
          (CRAVES STIMULATION-9 PEPPER)
          (CRAVES INTOXICATION-29 CHERRY)
          (EATS YOGURT HOTDOG)
          (EATS MARZIPAN SCALLION)
          (EATS TOMATO PORK)
          (EATS SHRIMP MELON)
          (CRAVES ANGER SNICKERS-6)
          (LOCALE BEEF KENTUCKY)
          (HARMONY TRIUMPH-64 MARS)
          (CRAVES LACERATION LAMB-16)
          (CRAVES TRIUMPH-14 LOBSTER)
          (EATS TOFU CHOCOLATE)
          (CRAVES ANGINA-100 WURST)
          (CRAVES LONELINESS-38 HOTDOG)
          (CRAVES ABRASION-102 CUCUMBER)
          (EATS TUNA-3 BROCCOLI)
          (HARMONY EXCITEMENT SATURN))
   (:GOAL (AND (CRAVES JEALOUSY CANTELOPE)
               (CRAVES GRIEF-117 CANTELOPE)
               (CRAVES ANGINA-73 ORANGE)
               (CRAVES PROSTATITIS HOTDOG)
               (CRAVES ANGINA HOTDOG)
               (CRAVES BOILS-123 BEEF)
               (CRAVES ABRASION-102 GRAPEFRUIT))))

(DEFINE (PROBLEM STRIPS-MYSTY-37)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS HAROSET KALE LETTUCE TOMATO SHRIMP HOTDOG LEMON
             BROCCOLI TUNA TOFU HAM SWEETROLL BACON BEEF SCALLOP MARZIPAN
             CUCUMBER WONDERBREAD FLOUNDER SATISFACTION INTOXICATION
             LUBRICITY EMPATHY AESTHETICS CURIOSITY EXPECTATION STIMULATION
             ENTERTAINMENT ANGINA DEPRESSION HANGOVER ANGER JEALOUSY PROSTATITIS
             GRIEF DREAD LACERATION SCIATICA ABRASION ANXIETY BOILS
             ANXIETY-2 LONELINESS ANGINA-4 HANGOVER-1 ANGER-8 LACERATION-3
             SCIATICA-7 JEALOUSY-6 PROSTATITIS-15 DREAD-16 ABRASION-5
             ARIZONA MANITOBA GUANABARA ALSACE URANUS JUPITER PLUTO VULCAN)
   (:INIT (FOOD HAROSET)
          (FOOD KALE)
          (FOOD LETTUCE)
          (FOOD TOMATO)
          (FOOD SHRIMP)
          (FOOD HOTDOG)
          (FOOD LEMON)
          (FOOD BROCCOLI)
          (FOOD TUNA)
          (FOOD TOFU)
          (FOOD HAM)
          (FOOD SWEETROLL)
          (FOOD BACON)
          (FOOD BEEF)
          (FOOD SCALLOP)
          (FOOD MARZIPAN)
          (FOOD CUCUMBER)
          (FOOD WONDERBREAD)
          (FOOD FLOUNDER)
          (PLEASURE SATISFACTION)
          (PLEASURE INTOXICATION)
          (PLEASURE LUBRICITY)
          (PLEASURE EMPATHY)
          (PLEASURE AESTHETICS)
          (PLEASURE CURIOSITY)
          (PLEASURE EXPECTATION)
          (PLEASURE STIMULATION)
          (PLEASURE ENTERTAINMENT)
          (PAIN ANGINA)
          (PAIN DEPRESSION)
          (PAIN HANGOVER)
          (PAIN ANGER)
          (PAIN JEALOUSY)
          (PAIN PROSTATITIS)
          (PAIN GRIEF)
          (PAIN DREAD)
          (PAIN LACERATION)
          (PAIN SCIATICA)
          (PAIN ABRASION)
          (PAIN ANXIETY)
          (PAIN BOILS)
          (PAIN ANXIETY-2)
          (PAIN LONELINESS)
          (PAIN ANGINA-4)
          (PAIN HANGOVER-1)
          (PAIN ANGER-8)
          (PAIN LACERATION-3)
          (PAIN SCIATICA-7)
          (PAIN JEALOUSY-6)
          (PAIN PROSTATITIS-15)
          (PAIN DREAD-16)
          (PAIN ABRASION-5)
          (PROVINCE ARIZONA)
          (PROVINCE MANITOBA)
          (PROVINCE GUANABARA)
          (PROVINCE ALSACE)
          (PLANET URANUS)
          (PLANET JUPITER)
          (PLANET PLUTO)
          (PLANET VULCAN)
          (HARMONY SATISFACTION JUPITER)
          (EATS TOFU SCALLOP)
          (EATS SWEETROLL MARZIPAN)
          (EATS WONDERBREAD KALE)
          (HARMONY ENTERTAINMENT JUPITER)
          (EATS BACON HOTDOG)
          (CRAVES ANGINA-4 HAM)
          (CRAVES INTOXICATION SHRIMP)
          (CRAVES CURIOSITY BEEF)
          (LOCALE SCALLOP ARIZONA)
          (LOCALE BEEF ARIZONA)
          (LOCALE BACON MANITOBA)
          (LOCALE FLOUNDER ARIZONA)
          (ATTACKS MANITOBA GUANABARA)
          (HARMONY INTOXICATION JUPITER)
          (EATS BROCCOLI MARZIPAN)
          (LOCALE TUNA ALSACE)
          (EATS KALE WONDERBREAD)
          (CRAVES LACERATION-3 SWEETROLL)
          (CRAVES EMPATHY BROCCOLI)
          (CRAVES ENTERTAINMENT WONDERBREAD)
          (EATS TUNA FLOUNDER)
          (HARMONY AESTHETICS PLUTO)
          (CRAVES BOILS HOTDOG)
          (LOCALE LEMON ARIZONA)
          (LOCALE KALE ARIZONA)
          (CRAVES STIMULATION MARZIPAN)
          (EATS TOMATO HAROSET)
          (LOCALE BROCCOLI ARIZONA)
          (EATS BROCCOLI TOFU)
          (CRAVES ANGER-8 SWEETROLL)
          (EATS HAROSET TOMATO)
          (EATS HAROSET TOFU)
          (CRAVES LACERATION SHRIMP)
          (EATS WONDERBREAD CUCUMBER)
          (CRAVES PROSTATITIS-15 WONDERBREAD)
          (HARMONY EMPATHY PLUTO)
          (CRAVES GRIEF TOMATO)
          (EATS HOTDOG HAM)
          (EATS WONDERBREAD HAROSET)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES ANGINA KALE)
          (EATS TOMATO LEMON)
          (CRAVES EXPECTATION SCALLOP)
          (CRAVES PROSTATITIS TOMATO)
          (CRAVES JEALOUSY-6 SCALLOP)
          (LOCALE SHRIMP GUANABARA)
          (EATS MARZIPAN BROCCOLI)
          (EATS WONDERBREAD SHRIMP)
          (ORBITS PLUTO VULCAN)
          (EATS KALE LEMON)
          (EATS FLOUNDER MARZIPAN)
          (HARMONY LUBRICITY VULCAN)
          (CRAVES HANGOVER-1 HAM)
          (EATS HOTDOG LEMON)
          (LOCALE LETTUCE MANITOBA)
          (ORBITS URANUS JUPITER)
          (LOCALE SWEETROLL ARIZONA)
          (EATS HAM HOTDOG)
          (EATS LEMON HOTDOG)
          (CRAVES SCIATICA HOTDOG)
          (EATS HAM WONDERBREAD)
          (CRAVES LONELINESS BROCCOLI)
          (CRAVES AESTHETICS BACON)
          (EATS HAROSET WONDERBREAD)
          (EATS HAM BACON)
          (CRAVES ABRASION-5 WONDERBREAD)
          (CRAVES JEALOUSY TOMATO)
          (LOCALE HOTDOG ALSACE)
          (EATS BEEF CUCUMBER)
          (EATS LEMON KALE)
          (EATS SWEETROLL LETTUCE)
          (CRAVES SCIATICA-7 BACON)
          (EATS SCALLOP SHRIMP)
          (CRAVES LUBRICITY LEMON)
          (CRAVES SATISFACTION LETTUCE)
          (EATS BACON HAM)
          (CRAVES DREAD-16 WONDERBREAD)
          (EATS BACON LETTUCE)
          (EATS SCALLOP TOFU)
          (CRAVES HANGOVER KALE)
          (EATS TOFU HAROSET)
          (EATS CUCUMBER BEEF)
          (EATS WONDERBREAD BEEF)
          (LOCALE CUCUMBER ARIZONA)
          (CRAVES DEPRESSION KALE)
          (LOCALE TOFU ARIZONA)
          (CRAVES DREAD SHRIMP)
          (CRAVES ANXIETY-2 BROCCOLI)
          (EATS MARZIPAN FLOUNDER)
          (HARMONY EXPECTATION VULCAN)
          (EATS SHRIMP WONDERBREAD)
          (EATS BEEF SCALLOP)
          (EATS LETTUCE BACON)
          (CRAVES ANGER KALE)
          (LOCALE MARZIPAN ARIZONA)
          (CRAVES ABRASION HOTDOG)
          (HARMONY STIMULATION VULCAN)
          (EATS LEMON TOMATO)
          (EATS TOFU BROCCOLI)
          (EATS SCALLOP BEEF)
          (EATS MARZIPAN SWEETROLL)
          (CRAVES ANXIETY HOTDOG)
          (LOCALE HAM MANITOBA)
          (LOCALE TOMATO ARIZONA)
          (ATTACKS GUANABARA ALSACE)
          (EATS LETTUCE SWEETROLL)
          (LOCALE WONDERBREAD GUANABARA)
          (EATS FLOUNDER TUNA)
          (EATS HOTDOG BACON)
          (EATS WONDERBREAD HAM)
          (EATS BEEF WONDERBREAD)
          (EATS TUNA HAM)
          (EATS CUCUMBER WONDERBREAD)
          (ATTACKS ARIZONA MANITOBA)
          (LOCALE HAROSET ARIZONA)
          (EATS SHRIMP SCALLOP)
          (EATS HAM TUNA)
          (ORBITS JUPITER PLUTO))
   (:GOAL (AND (CRAVES PROSTATITIS-15 MARZIPAN)
               (CRAVES DREAD-16 KALE)
               (CRAVES LACERATION HAM)
               (CRAVES LACERATION-3 LEMON)
               (CRAVES PROSTATITIS SHRIMP)
               (CRAVES JEALOUSY TOMATO)
               (CRAVES ANXIETY BACON)
               (CRAVES ANXIETY-2 TOFU)
               (CRAVES GRIEF WONDERBREAD)
               (CRAVES JEALOUSY-6 TOMATO))))

(DEFINE (PROBLEM STRIPS-MYSTY-38)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PISTACHIO-47 HAROSET-51 COD-50 APPLE-49 CANTELOPE-48
             TUNA-52 BROCCOLI-53 HOTDOG-54 PEA-55 PORK-56 SCALLION-57
             WONDERBREAD-58 CHERRY-59 KALE-60 CHOCOLATE-61 BAGUETTE-62 WURST-63
             HAMBURGER-64 CHICKEN-17 YOGURT-18 POPOVER-19 TOMATO-20 SCALLOP-21
             PEPPER-22 PAPAYA-23 FLOUNDER-24 CUCUMBER-25 POTATO-26 HAM-27
             SWEETROLL-28 GRAPEFRUIT-29 MELON-30 RICE-31 MUFFIN-32 PEAR-9
             LEMON-10 ONION-11 BEEF-12 MARZIPAN-13 TURKEY-14 LAMB-15
             LETTUCE-16 SHRIMP-5 OKRA-6 LOBSTER-7 ENDIVE-8 TOFU-3 MUTTON-4
             SNICKERS-1 GUAVA-2 ONION ARUGULA HAROSET ORANGE PEA MELON CHERRY
             KALE LEMON CHICKEN BACON BROCCOLI GUAVA LOBSTER BAGUETTE
             TOMATO COD MUTTON WURST HOTDOG WONDERBREAD TUNA ENDIVE LAMB
             BEEF APPLE TOFU TURKEY PISTACHIO MARZIPAN POPOVER CUCUMBER
             YOGURT PEAR OKRA CHOCOLATE SNICKERS GRAPEFRUIT MUFFIN LETTUCE
             PAPAYA HAMBURGER PEPPER SHRIMP POTATO SWEETROLL FLOUNDER PORK
             SCALLION RICE HAM CANTELOPE SCALLOP STIMULATION LOVE
             ENTERTAINMENT UNDERSTANDING REST INTOXICATION LEARNING EXCITEMENT
             EXPECTATION SATIETY EMPATHY TRIUMPH LUBRICITY SATISFACTION
             ACHIEVEMENT AESTHETICS CURIOSITY SATISFACTION-46 EXCITEMENT-45
             REST-44 EMPATHY-43 STIMULATION-42 TRIUMPH-41 EXPECTATION-40
             AESTHETICS-39 LUBRICITY-38 ENTERTAINMENT-37 ACHIEVEMENT-36
             CURIOSITY-35 LEARNING-34 LOVE-33 UNDERSTANDING-128
             INTOXICATION-127 SATIETY-126 CURIOSITY-125 INTOXICATION-124
             LUBRICITY-123 STIMULATION-122 EXPECTATION-121 AESTHETICS-120
             SATISFACTION-119 ACHIEVEMENT-118 LEARNING-117 ENTERTAINMENT-116
             EXCITEMENT-115 UNDERSTANDING-114 EMPATHY-113 SATIETY-112 REST-111
             TRIUMPH-110 LOVE-109 LOVE-108 EXCITEMENT-107 ENTERTAINMENT-106
             SATIETY-105 ACHIEVEMENT-104 ANGINA BOILS LONELINESS ABRASION
             JEALOUSY LACERATION PROSTATITIS GRIEF ANXIETY DEPRESSION
             SCIATICA HANGOVER DREAD ANGER LONELINESS-102 DREAD-103
             SCIATICA-100 GRIEF-101 HANGOVER-98 PROSTATITIS-99 DEPRESSION-97
             ABRASION-96 ANXIETY-94 LACERATION-95 BOILS-92 ANGER-93
             JEALOUSY-91 SCIATICA-89 ANGINA-90 HANGOVER-88 LACERATION-86
             BOILS-87 ANXIETY-84 ANGER-85 ANGINA-83 DREAD-81 GRIEF-82
             ABRASION-79 JEALOUSY-80 PROSTATITIS-77 LONELINESS-78 DREAD-75
             DEPRESSION-76 GRIEF-73 ANGINA-74 ANXIETY-71 ANGER-72 LACERATION-69
             BOILS-70 DEPRESSION-67 JEALOUSY-68 ABRASION-66 PENNSYLVANIA
             GUANABARA ALSACE KENTUCKY BOSNIA QUEBEC MANITOBA SURREY ARIZONA
             GOIAS OREGON MORAVIA BAVARIA PLUTO URANUS EARTH MERCURY)
   (:INIT (FOOD PISTACHIO-47)
          (FOOD HAROSET-51)
          (FOOD COD-50)
          (FOOD APPLE-49)
          (FOOD CANTELOPE-48)
          (FOOD TUNA-52)
          (FOOD BROCCOLI-53)
          (FOOD HOTDOG-54)
          (FOOD PEA-55)
          (FOOD PORK-56)
          (FOOD SCALLION-57)
          (FOOD WONDERBREAD-58)
          (FOOD CHERRY-59)
          (FOOD KALE-60)
          (FOOD CHOCOLATE-61)
          (FOOD BAGUETTE-62)
          (FOOD WURST-63)
          (FOOD HAMBURGER-64)
          (FOOD CHICKEN-17)
          (FOOD YOGURT-18)
          (FOOD POPOVER-19)
          (FOOD TOMATO-20)
          (FOOD SCALLOP-21)
          (FOOD PEPPER-22)
          (FOOD PAPAYA-23)
          (FOOD FLOUNDER-24)
          (FOOD CUCUMBER-25)
          (FOOD POTATO-26)
          (FOOD HAM-27)
          (FOOD SWEETROLL-28)
          (FOOD GRAPEFRUIT-29)
          (FOOD MELON-30)
          (FOOD RICE-31)
          (FOOD MUFFIN-32)
          (FOOD PEAR-9)
          (FOOD LEMON-10)
          (FOOD ONION-11)
          (FOOD BEEF-12)
          (FOOD MARZIPAN-13)
          (FOOD TURKEY-14)
          (FOOD LAMB-15)
          (FOOD LETTUCE-16)
          (FOOD SHRIMP-5)
          (FOOD OKRA-6)
          (FOOD LOBSTER-7)
          (FOOD ENDIVE-8)
          (FOOD TOFU-3)
          (FOOD MUTTON-4)
          (FOOD SNICKERS-1)
          (FOOD GUAVA-2)
          (FOOD ONION)
          (FOOD ARUGULA)
          (FOOD HAROSET)
          (FOOD ORANGE)
          (FOOD PEA)
          (FOOD MELON)
          (FOOD CHERRY)
          (FOOD KALE)
          (FOOD LEMON)
          (FOOD CHICKEN)
          (FOOD BACON)
          (FOOD BROCCOLI)
          (FOOD GUAVA)
          (FOOD LOBSTER)
          (FOOD BAGUETTE)
          (FOOD TOMATO)
          (FOOD COD)
          (FOOD MUTTON)
          (FOOD WURST)
          (FOOD HOTDOG)
          (FOOD WONDERBREAD)
          (FOOD TUNA)
          (FOOD ENDIVE)
          (FOOD LAMB)
          (FOOD BEEF)
          (FOOD APPLE)
          (FOOD TOFU)
          (FOOD TURKEY)
          (FOOD PISTACHIO)
          (FOOD MARZIPAN)
          (FOOD POPOVER)
          (FOOD CUCUMBER)
          (FOOD YOGURT)
          (FOOD PEAR)
          (FOOD OKRA)
          (FOOD CHOCOLATE)
          (FOOD SNICKERS)
          (FOOD GRAPEFRUIT)
          (FOOD MUFFIN)
          (FOOD LETTUCE)
          (FOOD PAPAYA)
          (FOOD HAMBURGER)
          (FOOD PEPPER)
          (FOOD SHRIMP)
          (FOOD POTATO)
          (FOOD SWEETROLL)
          (FOOD FLOUNDER)
          (FOOD PORK)
          (FOOD SCALLION)
          (FOOD RICE)
          (FOOD HAM)
          (FOOD CANTELOPE)
          (FOOD SCALLOP)
          (PLEASURE STIMULATION)
          (PLEASURE LOVE)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE UNDERSTANDING)
          (PLEASURE REST)
          (PLEASURE INTOXICATION)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE SATIETY)
          (PLEASURE EMPATHY)
          (PLEASURE TRIUMPH)
          (PLEASURE LUBRICITY)
          (PLEASURE SATISFACTION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE AESTHETICS)
          (PLEASURE CURIOSITY)
          (PLEASURE SATISFACTION-46)
          (PLEASURE EXCITEMENT-45)
          (PLEASURE REST-44)
          (PLEASURE EMPATHY-43)
          (PLEASURE STIMULATION-42)
          (PLEASURE TRIUMPH-41)
          (PLEASURE EXPECTATION-40)
          (PLEASURE AESTHETICS-39)
          (PLEASURE LUBRICITY-38)
          (PLEASURE ENTERTAINMENT-37)
          (PLEASURE ACHIEVEMENT-36)
          (PLEASURE CURIOSITY-35)
          (PLEASURE LEARNING-34)
          (PLEASURE LOVE-33)
          (PLEASURE UNDERSTANDING-128)
          (PLEASURE INTOXICATION-127)
          (PLEASURE SATIETY-126)
          (PLEASURE CURIOSITY-125)
          (PLEASURE INTOXICATION-124)
          (PLEASURE LUBRICITY-123)
          (PLEASURE STIMULATION-122)
          (PLEASURE EXPECTATION-121)
          (PLEASURE AESTHETICS-120)
          (PLEASURE SATISFACTION-119)
          (PLEASURE ACHIEVEMENT-118)
          (PLEASURE LEARNING-117)
          (PLEASURE ENTERTAINMENT-116)
          (PLEASURE EXCITEMENT-115)
          (PLEASURE UNDERSTANDING-114)
          (PLEASURE EMPATHY-113)
          (PLEASURE SATIETY-112)
          (PLEASURE REST-111)
          (PLEASURE TRIUMPH-110)
          (PLEASURE LOVE-109)
          (PLEASURE LOVE-108)
          (PLEASURE EXCITEMENT-107)
          (PLEASURE ENTERTAINMENT-106)
          (PLEASURE SATIETY-105)
          (PLEASURE ACHIEVEMENT-104)
          (PAIN ANGINA)
          (PAIN BOILS)
          (PAIN LONELINESS)
          (PAIN ABRASION)
          (PAIN JEALOUSY)
          (PAIN LACERATION)
          (PAIN PROSTATITIS)
          (PAIN GRIEF)
          (PAIN ANXIETY)
          (PAIN DEPRESSION)
          (PAIN SCIATICA)
          (PAIN HANGOVER)
          (PAIN DREAD)
          (PAIN ANGER)
          (PAIN LONELINESS-102)
          (PAIN DREAD-103)
          (PAIN SCIATICA-100)
          (PAIN GRIEF-101)
          (PAIN HANGOVER-98)
          (PAIN PROSTATITIS-99)
          (PAIN DEPRESSION-97)
          (PAIN ABRASION-96)
          (PAIN ANXIETY-94)
          (PAIN LACERATION-95)
          (PAIN BOILS-92)
          (PAIN ANGER-93)
          (PAIN JEALOUSY-91)
          (PAIN SCIATICA-89)
          (PAIN ANGINA-90)
          (PAIN HANGOVER-88)
          (PAIN LACERATION-86)
          (PAIN BOILS-87)
          (PAIN ANXIETY-84)
          (PAIN ANGER-85)
          (PAIN ANGINA-83)
          (PAIN DREAD-81)
          (PAIN GRIEF-82)
          (PAIN ABRASION-79)
          (PAIN JEALOUSY-80)
          (PAIN PROSTATITIS-77)
          (PAIN LONELINESS-78)
          (PAIN DREAD-75)
          (PAIN DEPRESSION-76)
          (PAIN GRIEF-73)
          (PAIN ANGINA-74)
          (PAIN ANXIETY-71)
          (PAIN ANGER-72)
          (PAIN LACERATION-69)
          (PAIN BOILS-70)
          (PAIN DEPRESSION-67)
          (PAIN JEALOUSY-68)
          (PAIN ABRASION-66)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE GUANABARA)
          (PROVINCE ALSACE)
          (PROVINCE KENTUCKY)
          (PROVINCE BOSNIA)
          (PROVINCE QUEBEC)
          (PROVINCE MANITOBA)
          (PROVINCE SURREY)
          (PROVINCE ARIZONA)
          (PROVINCE GOIAS)
          (PROVINCE OREGON)
          (PROVINCE MORAVIA)
          (PROVINCE BAVARIA)
          (PLANET PLUTO)
          (PLANET URANUS)
          (PLANET EARTH)
          (PLANET MERCURY)
          (LOCALE KALE ARIZONA)
          (EATS MUTTON HAMBURGER)
          (LOCALE SWEETROLL-28 OREGON)
          (CRAVES SATISFACTION PAPAYA-23)
          (EATS CANTELOPE GUAVA-2)
          (EATS BACON MELON)
          (HARMONY LUBRICITY URANUS)
          (EATS RICE SWEETROLL-28)
          (CRAVES EXCITEMENT-45 MELON-30)
          (EATS FLOUNDER-24 MUFFIN-32)
          (CRAVES SCIATICA-89 MELON)
          (EATS TURKEY-14 APPLE)
          (EATS CHOCOLATE SNICKERS)
          (EATS HOTDOG PISTACHIO)
          (EATS PEA SCALLION)
          (EATS BACON LEMON)
          (CRAVES ANXIETY-94 MUTTON-4)
          (LOCALE SCALLOP-21 SURREY)
          (ATTACKS BOSNIA QUEBEC)
          (EATS BROCCOLI TOFU-3)
          (LOCALE ENDIVE GUANABARA)
          (EATS TOFU SHRIMP-5)
          (EATS HAM-27 LETTUCE-16)
          (LOCALE FLOUNDER OREGON)
          (EATS BAGUETTE TOMATO)
          (EATS POPOVER CUCUMBER)
          (EATS APPLE TOFU-3)
          (HARMONY LOVE-33 URANUS)
          (CRAVES ANGER PEPPER-22)
          (EATS TUNA-52 BAGUETTE-62)
          (CRAVES DEPRESSION-76 PEAR)
          (EATS CUCUMBER LEMON)
          (LOCALE TOMATO-20 ALSACE)
          (CRAVES DREAD-75 PEAR)
          (EATS SCALLION-57 MELON)
          (CRAVES LACERATION PEA-55)
          (HARMONY EXCITEMENT-115 EARTH)
          (EATS MELON-30 LEMON-10)
          (EATS CHICKEN GRAPEFRUIT)
          (EATS TURKEY-14 HAMBURGER)
          (CRAVES TRIUMPH-110 CHOCOLATE)
          (EATS POPOVER SCALLOP-21)
          (LOCALE PEPPER KENTUCKY)
          (ORBITS PLUTO URANUS)
          (CRAVES ACHIEVEMENT POTATO-26)
          (CRAVES LACERATION-86 LEMON)
          (EATS TOFU-3 TURKEY-14)
          (EATS YOGURT TOFU)
          (HARMONY INTOXICATION-124 EARTH)
          (LOCALE TOFU-3 OREGON)
          (EATS ONION PAPAYA)
          (CRAVES REST-44 RICE-31)
          (CRAVES ANGER-93 GUAVA-2)
          (EATS MELON-30 HAMBURGER)
          (LOCALE CUCUMBER-25 GOIAS)
          (CRAVES DREAD PEPPER-22)
          (LOCALE COD-50 MANITOBA)
          (LOCALE BEEF SURREY)
          (CRAVES EXCITEMENT WONDERBREAD-58)
          (EATS SWEETROLL TURKEY)
          (LOCALE BEEF-12 PENNSYLVANIA)
          (EATS TUNA FLOUNDER)
          (LOCALE SHRIMP GUANABARA)
          (EATS PISTACHIO SCALLION)
          (EATS HAMBURGER TURKEY-14)
          (LOCALE BAGUETTE-62 QUEBEC)
          (EATS KALE POPOVER)
          (HARMONY EXPECTATION MERCURY)
          (CRAVES SATISFACTION-46 GRAPEFRUIT-29)
          (EATS BEEF-12 SNICKERS)
          (EATS MARZIPAN CHERRY)
          (LOCALE GUAVA QUEBEC)
          (HARMONY EXPECTATION-40 MERCURY)
          (LOCALE HAM ARIZONA)
          (EATS BAGUETTE ENDIVE-8)
          (EATS BEEF CHERRY)
          (EATS SNICKERS CHOCOLATE)
          (EATS CHERRY-59 ONION)
          (LOCALE PISTACHIO ALSACE)
          (CRAVES LONELINESS TUNA-52)
          (CRAVES STIMULATION-42 LEMON-10)
          (CRAVES EXPECTATION CHOCOLATE-61)
          (EATS APPLE TURKEY-14)
          (LOCALE MUFFIN-32 ARIZONA)
          (EATS LEMON SCALLION)
          (HARMONY EXCITEMENT-45 URANUS)
          (CRAVES EMPATHY-113 POPOVER)
          (EATS ARUGULA LETTUCE)
          (EATS HAM HAM-27)
          (HARMONY REST-44 URANUS)
          (EATS TOFU-3 BROCCOLI)
          (EATS LETTUCE-16 HAM-27)
          (EATS TURKEY PAPAYA)
          (EATS TURKEY-14 TOFU-3)
          (EATS MUTTON-4 CHERRY)
          (LOCALE TURKEY-14 GOIAS)
          (EATS APPLE-49 PISTACHIO-47)
          (LOCALE TURKEY ARIZONA)
          (EATS PEAR BAGUETTE)
          (EATS COD-50 PISTACHIO-47)
          (EATS MELON SWEETROLL)
          (HARMONY REST URANUS)
          (CRAVES ENTERTAINMENT-116 LAMB)
          (EATS PISTACHIO-47 COD-50)
          (EATS ENDIVE ENDIVE-8)
          (HARMONY LOVE-109 MERCURY)
          (EATS YOGURT-18 MELON)
          (EATS TOMATO-20 SCALLOP-21)
          (CRAVES GRIEF-82 TOFU)
          (EATS MELON BACON)
          (EATS CUCUMBER-25 LETTUCE)
          (CRAVES EMPATHY-43 PEAR-9)
          (EATS TUNA HAROSET)
          (HARMONY TRIUMPH-110 EARTH)
          (LOCALE WURST ARIZONA)
          (CRAVES LEARNING-117 TUNA)
          (HARMONY LOVE-108 EARTH)
          (EATS BAGUETTE PEAR)
          (HARMONY EMPATHY-43 EARTH)
          (EATS BROCCOLI KALE)
          (EATS MARZIPAN-13 POTATO)
          (EATS TOFU GUAVA)
          (LOCALE SHRIMP-5 MANITOBA)
          (CRAVES DEPRESSION-97 LAMB-15)
          (EATS FLOUNDER GRAPEFRUIT)
          (EATS ENDIVE TOMATO)
          (LOCALE BAGUETTE ARIZONA)
          (EATS PEAR-9 POPOVER)
          (EATS LEMON-10 TUNA)
          (EATS LEMON-10 MELON-30)
          (HARMONY LEARNING EARTH)
          (EATS ENDIVE PAPAYA-23)
          (LOCALE YOGURT ALSACE)
          (CRAVES SATIETY-126 CHICKEN)
          (EATS OKRA-6 YOGURT)
          (EATS SWEETROLL BACON)
          (LOCALE COD BOSNIA)
          (LOCALE LEMON QUEBEC)
          (EATS TURKEY-14 POPOVER-19)
          (EATS HAMBURGER TOFU-3)
          (HARMONY EXCITEMENT-107 EARTH)
          (EATS WONDERBREAD WURST-63)
          (EATS PAPAYA-23 RICE-31)
          (CRAVES AESTHETICS-120 WURST)
          (EATS CHICKEN ENDIVE-8)
          (ATTACKS QUEBEC MANITOBA)
          (HARMONY ENTERTAINMENT-37 MERCURY)
          (EATS LAMB-15 SCALLOP)
          (EATS TOFU YOGURT)
          (EATS TURKEY-14 LOBSTER-7)
          (CRAVES DREAD-81 TOFU)
          (EATS SNICKERS SCALLION)
          (EATS SNICKERS ORANGE)
          (EATS SNICKERS KALE)
          (LOCALE TOMATO SURREY)
          (EATS BROCCOLI-53 YOGURT)
          (EATS GUAVA-2 CANTELOPE)
          (EATS SCALLOP-21 POPOVER)
          (EATS LOBSTER-7 PEPPER)
          (CRAVES ANXIETY YOGURT-18)
          (EATS WURST PORK)
          (CRAVES LOVE COD-50)
          (EATS YOGURT MELON)
          (EATS COD-50 APPLE-49)
          (EATS PORK-56 BACON)
          (EATS POPOVER PEA-55)
          (LOCALE CHERRY-59 QUEBEC)
          (EATS PISTACHIO CUCUMBER)
          (CRAVES ABRASION-96 SHRIMP-5)
          (EATS PORK WURST)
          (HARMONY LUBRICITY-38 MERCURY)
          (HARMONY ACHIEVEMENT-36 MERCURY)
          (EATS RICE-31 SNICKERS)
          (ATTACKS ALSACE KENTUCKY)
          (CRAVES CURIOSITY-35 SNICKERS-1)
          (LOCALE GRAPEFRUIT-29 MANITOBA)
          (EATS SWEETROLL-28 RICE)
          (CRAVES LONELINESS-102 MELON-30)
          (EATS CHICKEN LETTUCE-16)
          (EATS POTATO-26 PEA)
          (EATS BACON SCALLION)
          (EATS BEEF PEPPER)
          (EATS MUFFIN-32 FLOUNDER-24)
          (ATTACKS SURREY ARIZONA)
          (EATS ORANGE GRAPEFRUIT-29)
          (CRAVES LOVE-33 ORANGE)
          (LOCALE LEMON-10 GOIAS)
          (EATS CANTELOPE PAPAYA)
          (EATS ENDIVE SNICKERS)
          (LOCALE MUTTON MANITOBA)
          (EATS HAMBURGER MELON-30)
          (EATS MARZIPAN TUNA)
          (EATS RICE BEEF)
          (EATS TURKEY MARZIPAN-13)
          (ORBITS URANUS EARTH)
          (EATS ONION-11 GRAPEFRUIT-29)
          (EATS GRAPEFRUIT-29 ONION-11)
          (CRAVES REST-111 PEAR)
          (EATS ENDIVE-8 CHICKEN)
          (EATS OKRA SHRIMP)
          (EATS PAPAYA SCALLION)
          (EATS KALE-60 POPOVER)
          (EATS POTATO GUAVA-2)
          (EATS SHRIMP-5 LOBSTER)
          (EATS PEPPER MUTTON-4)
          (EATS YOGURT BROCCOLI-53)
          (CRAVES STIMULATION-122 COD)
          (EATS SCALLOP-21 TOMATO-20)
          (ATTACKS OREGON MORAVIA)
          (LOCALE ONION-11 SURREY)
          (EATS POTATO PAPAYA)
          (HARMONY LEARNING-117 URANUS)
          (HARMONY REST-111 MERCURY)
          (LOCALE LAMB-15 MANITOBA)
          (LOCALE WONDERBREAD-58 GUANABARA)
          (EATS SCALLION SNICKERS)
          (EATS LOBSTER-7 HAMBURGER-64)
          (EATS GRAPEFRUIT-29 BEEF-12)
          (CRAVES ANGINA-90 MELON)
          (EATS GUAVA TOFU)
          (EATS CHERRY MUTTON-4)
          (LOCALE ORANGE KENTUCKY)
          (LOCALE PORK BOSNIA)
          (EATS POTATO CANTELOPE)
          (EATS COD LETTUCE)
          (HARMONY EMPATHY MERCURY)
          (HARMONY SATIETY-126 MERCURY)
          (EATS CUCUMBER POPOVER)
          (HARMONY ENTERTAINMENT-106 URANUS)
          (CRAVES DREAD-103 MELON-30)
          (EATS CHOCOLATE-61 WURST-63)
          (LOCALE CHOCOLATE ARIZONA)
          (EATS ONION GRAPEFRUIT-29)
          (CRAVES PROSTATITIS-77 YOGURT)
          (LOCALE BROCCOLI-53 ALSACE)
          (EATS CANTELOPE LAMB)
          (EATS SCALLOP-21 SCALLOP)
          (EATS CHERRY-59 PAPAYA)
          (EATS CUCUMBER COD)
          (EATS HAROSET TUNA)
          (EATS TOMATO WONDERBREAD-58)
          (HARMONY SATISFACTION-119 MERCURY)
          (CRAVES UNDERSTANDING-128 CHERRY)
          (EATS FLOUNDER MUFFIN)
          (LOCALE HOTDOG GUANABARA)
          (EATS PEA-55 SCALLOP)
          (EATS LETTUCE ARUGULA)
          (EATS LAMB OKRA-6)
          (CRAVES LUBRICITY-123 BAGUETTE)
          (EATS ORANGE SNICKERS)
          (EATS CHERRY-59 OKRA)
          (CRAVES LOVE-109 SNICKERS)
          (EATS COD LAMB-15)
          (HARMONY EXPECTATION-121 URANUS)
          (LOCALE CHICKEN SURREY)
          (EATS SHRIMP OKRA)
          (EATS ONION-11 ONION)
          (EATS YOGURT-18 CUCUMBER)
          (EATS BROCCOLI PEAR-9)
          (EATS SHRIMP COD-50)
          (CRAVES PROSTATITIS-99 BEEF-12)
          (LOCALE ARUGULA GUANABARA)
          (CRAVES EXCITEMENT-115 TOFU)
          (ATTACKS MORAVIA BAVARIA)
          (CRAVES ANXIETY-84 HOTDOG)
          (LOCALE WURST-63 SURREY)
          (EATS TUNA-52 PORK-56)
          (EATS PAPAYA CHERRY-59)
          (CRAVES BOILS-87 LEMON)
          (CRAVES HANGOVER-98 BEEF-12)
          (EATS SCALLOP LAMB-15)
          (LOCALE PEAR ARIZONA)
          (EATS WONDERBREAD HAM)
          (EATS LEMON-10 FLOUNDER)
          (ORBITS EARTH MERCURY)
          (CRAVES STIMULATION PISTACHIO-47)
          (LOCALE FLOUNDER-24 KENTUCKY)
          (EATS SNICKERS ENDIVE)
          (EATS TOMATO SNICKERS-1)
          (EATS ENDIVE-8 BAGUETTE)
          (EATS PISTACHIO KALE)
          (LOCALE PEA-55 PENNSYLVANIA)
          (EATS BACON PORK-56)
          (EATS MARZIPAN PORK)
          (CRAVES AESTHETICS HAM-27)
          (LOCALE PORK-56 KENTUCKY)
          (CRAVES ACHIEVEMENT-36 MUTTON-4)
          (LOCALE LETTUCE-16 QUEBEC)
          (EATS TOFU-3 HAMBURGER)
          (EATS LETTUCE-16 CHICKEN)
          (HARMONY AESTHETICS URANUS)
          (EATS TOMATO-20 SCALLOP)
          (CRAVES JEALOUSY PEA-55)
          (LOCALE TUNA GUANABARA)
          (EATS HAMBURGER BROCCOLI)
          (EATS POPOVER-19 PORK)
          (LOCALE PAPAYA-23 BOSNIA)
          (LOCALE PEA ARIZONA)
          (ATTACKS ARIZONA GOIAS)
          (LOCALE MARZIPAN PENNSYLVANIA)
          (LOCALE HOTDOG-54 BOSNIA)
          (HARMONY EMPATHY-113 MERCURY)
          (EATS SCALLION PAPAYA)
          (EATS BACON SWEETROLL)
          (CRAVES BOILS-92 GUAVA-2)
          (LOCALE CHOCOLATE-61 QUEBEC)
          (EATS BROCCOLI-53 CHICKEN-17)
          (EATS MARZIPAN SWEETROLL-28)
          (EATS MELON SCALLION-57)
          (HARMONY LUBRICITY-123 MERCURY)
          (EATS GRAPEFRUIT WONDERBREAD)
          (HARMONY UNDERSTANDING-114 EARTH)
          (CRAVES LEARNING SCALLION-57)
          (EATS GRAPEFRUIT FLOUNDER)
          (CRAVES LUBRICITY-38 OKRA-6)
          (EATS POTATO-26 ONION)
          (EATS CANTELOPE-48 APPLE-49)
          (EATS APPLE BROCCOLI)
          (EATS CHICKEN CHOCOLATE-61)
          (EATS LOBSTER ARUGULA)
          (CRAVES EMPATHY CHICKEN-17)
          (EATS PAPAYA-23 ENDIVE)
          (EATS RICE MUFFIN)
          (LOCALE ENDIVE-8 GUANABARA)
          (LOCALE PAPAYA QUEBEC)
          (EATS CUCUMBER LETTUCE)
          (EATS SNICKERS-1 ONION-11)
          (EATS MELON YOGURT)
          (CRAVES TRIUMPH YOGURT-18)
          (EATS ONION CHERRY-59)
          (EATS PEAR HAM)
          (EATS BEEF-12 SNICKERS-1)
          (HARMONY TRIUMPH-41 MERCURY)
          (LOCALE TOFU SURREY)
          (LOCALE POTATO-26 SURREY)
          (EATS APPLE TOMATO-20)
          (EATS OKRA WONDERBREAD-58)
          (CRAVES EXCITEMENT-107 LETTUCE)
          (CRAVES CURIOSITY SWEETROLL-28)
          (EATS FLOUNDER LEMON-10)
          (HARMONY EXCITEMENT URANUS)
          (CRAVES SATISFACTION-119 HOTDOG)
          (CRAVES ANGER-72 LETTUCE)
          (EATS PEPPER PORK)
          (EATS SCALLION LEMON)
          (LOCALE GRAPEFRUIT GOIAS)
          (CRAVES SATIETY-112 CUCUMBER)
          (EATS CANTELOPE POTATO)
          (EATS ENDIVE-8 LEMON-10)
          (EATS LETTUCE CUCUMBER-25)
          (LOCALE LAMB SURREY)
          (CRAVES BOILS-70 HAMBURGER)
          (EATS SCALLION BACON)
          (EATS HAROSET-51 PISTACHIO-47)
          (CRAVES EXPECTATION-121 MUTTON)
          (EATS KALE SNICKERS)
          (HARMONY LEARNING-34 MERCURY)
          (EATS HOTDOG KALE-60)
          (EATS SNICKERS-1 BEEF-12)
          (EATS TOMATO RICE-31)
          (CRAVES PROSTATITIS KALE-60)
          (CRAVES LACERATION-69 HAMBURGER)
          (LOCALE SCALLION QUEBEC)
          (CRAVES EXPECTATION-40 TURKEY-14)
          (EATS BROCCOLI HAMBURGER)
          (LOCALE HAROSET-51 KENTUCKY)
          (LOCALE PEPPER-22 GUANABARA)
          (HARMONY SATISFACTION MERCURY)
          (EATS SHRIMP-5 TOFU)
          (CRAVES LOVE-108 MUFFIN)
          (EATS CHOCOLATE MUTTON)
          (HARMONY AESTHETICS-39 MERCURY)
          (LOCALE ONION KENTUCKY)
          (EATS TOMATO ENDIVE)
          (CRAVES TRIUMPH-41 MARZIPAN-13)
          (HARMONY TRIUMPH EARTH)
          (HARMONY SATIETY-112 EARTH)
          (CRAVES ANGINA COD-50)
          (CRAVES LONELINESS-78 YOGURT)
          (CRAVES SATIETY HAMBURGER-64)
          (HARMONY INTOXICATION MERCURY)
          (CRAVES DEPRESSION-67 PORK)
          (CRAVES ANGER-85 HOTDOG)
          (EATS LETTUCE COD)
          (EATS CANTELOPE-48 HAROSET-51)
          (EATS ORANGE PEA)
          (EATS PORK HAMBURGER)
          (CRAVES ENTERTAINMENT-37 ENDIVE-8)
          (HARMONY ACHIEVEMENT-104 EARTH)
          (EATS ONION-11 SNICKERS-1)
          (EATS LAMB CANTELOPE)
          (ATTACKS GUANABARA ALSACE)
          (EATS YOGURT OKRA-6)
          (EATS SWEETROLL-28 MARZIPAN)
          (EATS HAMBURGER PORK)
          (EATS WURST-63 WONDERBREAD)
          (EATS TUNA MARZIPAN)
          (EATS CHOCOLATE-61 CHICKEN)
          (EATS SCALLION PEA)
          (EATS SCALLOP-21 APPLE)
          (EATS CUCUMBER PISTACHIO)
          (LOCALE POPOVER-19 OREGON)
          (EATS SNICKERS-1 TOMATO)
          (CRAVES JEALOUSY-68 PORK)
          (EATS KALE BROCCOLI)
          (EATS POPOVER PEAR-9)
          (EATS BAGUETTE-62 TUNA-52)
          (EATS POTATO MARZIPAN-13)
          (CRAVES DEPRESSION YOGURT-18)
          (EATS SCALLOP TOMATO-20)
          (EATS SNICKERS-1 HOTDOG-54)
          (HARMONY UNDERSTANDING EARTH)
          (CRAVES SATIETY-105 CANTELOPE)
          (LOCALE GUAVA-2 MANITOBA)
          (CRAVES BOILS APPLE-49)
          (LOCALE MELON-30 GOIAS)
          (LOCALE POPOVER GUANABARA)
          (LOCALE SCALLION-57 BOSNIA)
          (LOCALE TUNA-52 GUANABARA)
          (HARMONY CURIOSITY-125 URANUS)
          (CRAVES GRIEF CHOCOLATE-61)
          (EATS PEPPER-22 CHOCOLATE)
          (HARMONY AESTHETICS-120 MERCURY)
          (EATS PEAR OKRA)
          (HARMONY CURIOSITY-35 URANUS)
          (EATS ENDIVE PEPPER-22)
          (EATS LETTUCE CUCUMBER)
          (EATS HAMBURGER-64 APPLE)
          (EATS BROCCOLI APPLE)
          (EATS APPLE-49 CANTELOPE-48)
          (LOCALE MUTTON-4 QUEBEC)
          (LOCALE HAMBURGER-64 ARIZONA)
          (EATS MELON YOGURT-18)
          (HARMONY ENTERTAINMENT-116 MERCURY)
          (LOCALE OKRA-6 PENNSYLVANIA)
          (EATS TOMATO-20 APPLE)
          (EATS ONION POTATO-26)
          (EATS ONION OKRA)
          (EATS OKRA-6 GUAVA-2)
          (EATS SCALLION-57 CUCUMBER)
          (EATS COD-50 SHRIMP)
          (EATS PAPAYA TURKEY)
          (HARMONY CURIOSITY EARTH)
          (EATS LOBSTER-7 TURKEY-14)
          (LOCALE HAMBURGER QUEBEC)
          (CRAVES INTOXICATION-124 BROCCOLI)
          (EATS CUCUMBER SCALLION-57)
          (EATS CUCUMBER YOGURT-18)
          (EATS ONION ONION-11)
          (LOCALE RICE GOIAS)
          (LOCALE MELON GUANABARA)
          (EATS PAPAYA POTATO)
          (CRAVES INTOXICATION PEA-55)
          (EATS CANTELOPE SHRIMP)
          (CRAVES UNDERSTANDING-114 MARZIPAN)
          (EATS POPOVER KALE-60)
          (HARMONY STIMULATION EARTH)
          (HARMONY UNDERSTANDING-128 EARTH)
          (LOCALE MUFFIN ARIZONA)
          (EATS HAMBURGER TUNA)
          (LOCALE BACON MANITOBA)
          (EATS SCALLOP PEPPER)
          (EATS GRAPEFRUIT-29 ORANGE)
          (EATS KALE-60 HOTDOG)
          (CRAVES ANGINA-83 ENDIVE)
          (CRAVES LEARNING-34 ARUGULA)
          (CRAVES JEALOUSY-91 ONION)
          (EATS PAPAYA BAGUETTE-62)
          (EATS PORK POPOVER-19)
          (EATS HAROSET WURST)
          (EATS CHICKEN-17 TURKEY)
          (LOCALE YOGURT-18 ALSACE)
          (EATS HOTDOG-54 OKRA)
          (EATS LEMON-10 ENDIVE-8)
          (HARMONY SATIETY URANUS)
          (EATS POTATO FLOUNDER-24)
          (EATS PEAR-9 BROCCOLI)
          (EATS FLOUNDER-24 POTATO)
          (EATS SHRIMP CANTELOPE)
          (EATS BAGUETTE-62 PAPAYA)
          (EATS TUNA HAMBURGER)
          (EATS CUCUMBER-25 SCALLION-57)
          (EATS PAPAYA SHRIMP)
          (EATS TURKEY SWEETROLL)
          (EATS MUFFIN-32 YOGURT)
          (CRAVES HANGOVER-88 KALE)
          (LOCALE SNICKERS SURREY)
          (EATS HAM WONDERBREAD)
          (EATS HAMBURGER-64 LOBSTER-7)
          (LOCALE PEAR-9 ARIZONA)
          (EATS APPLE HAMBURGER-64)
          (HARMONY ACHIEVEMENT-118 MERCURY)
          (LOCALE CHICKEN-17 MANITOBA)
          (EATS LOBSTER SHRIMP-5)
          (CRAVES ACHIEVEMENT-104 SCALLOP)
          (EATS TURKEY-14 PEPPER)
          (CRAVES REST TUNA-52)
          (CRAVES JEALOUSY-80 MARZIPAN)
          (LOCALE WONDERBREAD BAVARIA)
          (HARMONY STIMULATION-122 URANUS)
          (EATS GRAPEFRUIT-29 ONION)
          (EATS OKRA ONION)
          (CRAVES ENTERTAINMENT APPLE-49)
          (LOCALE BROCCOLI BOSNIA)
          (HARMONY STIMULATION-42 EARTH)
          (CRAVES ENTERTAINMENT-106 PEPPER)
          (EATS CHERRY BEEF)
          (HARMONY ENTERTAINMENT MERCURY)
          (CRAVES GRIEF-73 MUFFIN)
          (CRAVES ABRASION-66 CANTELOPE)
          (ATTACKS KENTUCKY BOSNIA)
          (EATS CHERRY MARZIPAN)
          (LOCALE CANTELOPE-48 ALSACE)
          (EATS PISTACHIO-47 APPLE-49)
          (EATS PEA POTATO-26)
          (EATS APPLE-49 COD-50)
          (LOCALE LETTUCE QUEBEC)
          (EATS PEPPER LOBSTER-7)
          (EATS SCALLION PISTACHIO)
          (EATS PEA-55 POPOVER)
          (CRAVES UNDERSTANDING CANTELOPE-48)
          (EATS SCALLOP SCALLOP-21)
          (CRAVES AESTHETICS-39 SHRIMP-5)
          (EATS TOFU LOBSTER)
          (HARMONY SATISFACTION-46 EARTH)
          (LOCALE OKRA SURREY)
          (EATS WURST-63 CHOCOLATE-61)
          (CRAVES ANXIETY-71 LETTUCE)
          (EATS COD POPOVER)
          (LOCALE HAM-27 GUANABARA)
          (LOCALE RICE-31 BOSNIA)
          (LOCALE CANTELOPE QUEBEC)
          (CRAVES ACHIEVEMENT-118 WONDERBREAD)
          (EATS TUNA LEMON-10)
          (EATS ARUGULA LOBSTER)
          (EATS RICE-31 PAPAYA-23)
          (LOCALE SCALLOP SURREY)
          (EATS SCALLOP PEA-55)
          (LOCALE APPLE-49 GUANABARA)
          (EATS LAMB-15 COD)
          (LOCALE CUCUMBER ALSACE)
          (LOCALE SNICKERS-1 GUANABARA)
          (LOCALE APPLE QUEBEC)
          (EATS LEMON BACON)
          (EATS BEEF RICE)
          (EATS PEPPER TURKEY-14)
          (EATS GUAVA SCALLOP)
          (HARMONY LOVE URANUS)
          (EATS RICE-31 TOMATO)
          (EATS HAM-27 HAM)
          (EATS HAM PEAR)
          (CRAVES ANGINA-74 MUFFIN)
          (EATS PAPAYA CANTELOPE)
          (EATS PEPPER-22 ENDIVE)
          (LOCALE LOBSTER-7 MORAVIA)
          (LOCALE MARZIPAN-13 ARIZONA)
          (CRAVES CURIOSITY-125 BACON)
          (EATS OKRA HOTDOG-54)
          (EATS TURKEY CHICKEN-17)
          (EATS POPOVER KALE)
          (EATS GUAVA-2 POTATO)
          (EATS COD CUCUMBER)
          (EATS MARZIPAN-13 TURKEY)
          (EATS LEMON CUCUMBER)
          (EATS WONDERBREAD-58 TOMATO)
          (EATS SCALLOP GUAVA)
          (EATS OKRA-6 LAMB)
          (LOCALE LOBSTER GOIAS)
          (EATS APPLE SCALLOP-21)
          (EATS POPOVER-19 TURKEY-14)
          (CRAVES ABRASION-79 MARZIPAN)
          (CRAVES HANGOVER TOMATO-20)
          (EATS GUAVA-2 LAMB)
          (EATS WONDERBREAD-58 OKRA)
          (EATS PISTACHIO HOTDOG)
          (LOCALE SWEETROLL ARIZONA)
          (EATS PISTACHIO-47 HAROSET-51)
          (EATS HOTDOG-54 SNICKERS-1)
          (EATS TOMATO BAGUETTE)
          (EATS WONDERBREAD GRAPEFRUIT)
          (HARMONY ACHIEVEMENT EARTH)
          (EATS PEPPER BEEF)
          (EATS SCALLION-57 CUCUMBER-25)
          (EATS HAROSET-51 CANTELOPE-48)
          (EATS ENDIVE-8 ENDIVE)
          (EATS PEPPER SCALLOP)
          (EATS OKRA PEAR)
          (ATTACKS MANITOBA SURREY)
          (CRAVES LUBRICITY PEPPER-22)
          (EATS PORK-56 TUNA-52)
          (CRAVES LACERATION-95 MUTTON-4)
          (CRAVES INTOXICATION-127 LEMON)
          (CRAVES SCIATICA-100 MUFFIN-32)
          (EATS KALE PISTACHIO)
          (LOCALE PISTACHIO-47 PENNSYLVANIA)
          (ATTACKS GOIAS OREGON)
          (CRAVES SCIATICA TOMATO-20)
          (EATS MUFFIN RICE)
          (LOCALE CHERRY SURREY)
          (EATS PORK MARZIPAN)
          (EATS SNICKERS RICE-31)
          (EATS SHRIMP-5 SCALLOP)
          (EATS SWEETROLL MELON)
          (EATS MUTTON CHOCOLATE)
          (EATS OKRA CHERRY-59)
          (EATS GUAVA-2 OKRA-6)
          (EATS LAMB GUAVA-2)
          (CRAVES GRIEF-101 MUFFIN-32)
          (LOCALE POTATO MORAVIA)
          (HARMONY INTOXICATION-127 URANUS)
          (EATS SNICKERS BEEF-12)
          (EATS WURST HAROSET)
          (EATS YOGURT MUFFIN-32)
          (EATS GRAPEFRUIT CHICKEN)
          (EATS SHRIMP PAPAYA)
          (EATS POPOVER COD)
          (EATS CHICKEN-17 BROCCOLI-53)
          (EATS TOFU-3 APPLE)
          (EATS PAPAYA ONION)
          (LOCALE HAROSET ALSACE)
          (EATS MUTTON-4 PEPPER)
          (ATTACKS PENNSYLVANIA GUANABARA)
          (EATS SCALLOP SHRIMP-5)
          (EATS CHOCOLATE PEPPER-22)
          (EATS LOBSTER TOFU)
          (EATS FLOUNDER TUNA)
          (EATS PEA ORANGE)
          (EATS BEEF-12 GRAPEFRUIT-29)
          (CRAVES ABRASION TUNA-52)
          (EATS PORK PEPPER)
          (HARMONY SATIETY-105 MERCURY)
          (EATS MUFFIN FLOUNDER)
          (LOCALE KALE-60 BOSNIA)
          (EATS HAMBURGER MUTTON))
   (:GOAL (AND (CRAVES DREAD COD-50)
               (CRAVES ANGER COD-50))))

(DEFINE (PROBLEM STRIPS-MYSTY-39)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS TUNA-54 LEMON-53 PEPPER-52 FLOUNDER-51 POTATO-55
             ORANGE-56 HOTDOG-57 GRAPEFRUIT-58 SNICKERS-59 PEAR-60
             TOMATO-61 CHERRY-62 BAGUETTE-63 GUAVA-64 LAMB-17 APPLE-18
             PORK-19 TOFU-20 WONDERBREAD-21 ENDIVE-22 COD-23 KALE-24
             YOGURT-25 HAMBURGER-26 PAPAYA-27 WURST-28 CANTELOPE-29
             CHICKEN-30 SCALLOP-31 RICE-32 OKRA-9 HAM-10 TURKEY-11 LOBSTER-12
             CHOCOLATE-13 POPOVER-14 MARZIPAN-15 LETTUCE-16 SCALLION-5
             CUCUMBER-6 MUFFIN-7 SHRIMP-8 BROCCOLI-3 BEEF-4 MUTTON-1
             SWEETROLL-2 PEPPER SCALLOP FLOUNDER WURST BAGUETTE CHOCOLATE BEEF
             PEA GRAPEFRUIT CHERRY TOFU BACON PEAR LETTUCE HAM APPLE
             HOTDOG SNICKERS COD ENDIVE HAMBURGER POPOVER MUTTON CHICKEN
             ARUGULA WONDERBREAD KALE MUFFIN PISTACHIO BROCCOLI SCALLION
             CUCUMBER PORK LEMON TOMATO LAMB TURKEY RICE CANTELOPE HAROSET
             TUNA ONION OKRA LOBSTER POTATO YOGURT SWEETROLL SHRIMP
             MARZIPAN ORANGE MELON PAPAYA GUAVA SATISFACTION EXPECTATION
             ENTERTAINMENT AESTHETICS CURIOSITY EMPATHY EXCITEMENT STIMULATION
             SATIETY UNDERSTANDING ACHIEVEMENT REST LEARNING LUBRICITY
             TRIUMPH INTOXICATION LOVE INTOXICATION-50 TRIUMPH-49
             STIMULATION-48 ACHIEVEMENT-47 LEARNING-46 EXPECTATION-45
             ENTERTAINMENT-44 SATISFACTION-43 LUBRICITY-42 UNDERSTANDING-41
             REST-40 LOVE-39 SATIETY-38 EXCITEMENT-37 EMPATHY-36
             AESTHETICS-35 CURIOSITY-34 EXCITEMENT-33 UNDERSTANDING-128
             SATISFACTION-127 TRIUMPH-126 CURIOSITY-125 REST-124
             ENTERTAINMENT-123 SATIETY-122 ACHIEVEMENT-121 LUBRICITY-120
             EXPECTATION-119 STIMULATION-118 LEARNING-117 AESTHETICS-116
             LOVE-115 INTOXICATION-114 EMPATHY-113 EXPECTATION-112
             LUBRICITY-111 INTOXICATION-110 SATISFACTION-109 SCIATICA
             PROSTATITIS DEPRESSION LONELINESS ANGER LACERATION HANGOVER GRIEF
             JEALOUSY ANXIETY ANGINA BOILS DREAD DEPRESSION-106 ANGINA-107
             LACERATION-108 ABRASION HANGOVER-102 JEALOUSY-103 ANGER-104
             GRIEF-105 BOILS-99 PROSTATITIS-100 SCIATICA-101 LONELINESS-96
             ABRASION-97 DREAD-98 LACERATION-92 DREAD-93 HANGOVER-94
             ANXIETY-95 JEALOUSY-89 GRIEF-90 SCIATICA-91 LONELINESS-85
             BOILS-86 PROSTATITIS-87 DEPRESSION-88 ANGINA-81 ANGER-82
             ABRASION-83 ANXIETY-84 ANGER-76 ANGINA-77 HANGOVER-78 ANXIETY-79
             GRIEF-80 SCIATICA-73 LONELINESS-74 LACERATION-75 JEALOUSY-70
             PROSTATITIS-71 ABRASION-72 DEPRESSION-68 BOILS-69 DREAD-67
             DREAD-256 SCIATICA-65 LONELINESS-66 ANGINA-255 ANXIETY-254
             LACERATION-250 HANGOVER-251 ANGER-252 JEALOUSY-253 ABRASION-248
             BOILS-249 GRIEF-247 DEPRESSION-246 GRIEF-242 JEALOUSY-243
             SCIATICA-244 PROSTATITIS-245 HANGOVER-239 DEPRESSION-240
             BOILS-241 PROSTATITIS-238 ANXIETY-236 LONELINESS-237
             ABRASION-234 ANGINA-235 BOILS-230 ANGER-231 DREAD-232
             LACERATION-233 ANGINA-228 ANGER-229 SCIATICA-224 ANXIETY-225
             JEALOUSY-226 HANGOVER-227 ABRASION-220 LONELINESS-221 DREAD-222
             LACERATION-223 GRIEF-219 ANGINA-215 HANGOVER-216 PROSTATITIS-217
             DEPRESSION-218 GRIEF-211 LONELINESS-212 SCIATICA-213 ANGER-214
             JEALOUSY-207 BOILS-208 LACERATION-209 ANXIETY-210 DREAD-203
             DEPRESSION-204 ABRASION-205 PROSTATITIS-206 ABRASION-198
             LACERATION-199 DREAD-200 ANGINA-201 HANGOVER-202 ANGER-197
             GRIEF-192 ANXIETY-193 BOILS-194 DEPRESSION-195 JEALOUSY-196
             PROSTATITIS-191 LONELINESS-190 HANGOVER-188 SCIATICA-189 DREAD-186
             DEPRESSION-187 ABRASION-184 GRIEF-185 ANGER-181 SCIATICA-182
             PROSTATITIS-183 ANXIETY-176 JEALOUSY-177 ANGINA-178 LONELINESS-179
             BOILS-180 LACERATION-175 JEALOUSY-172 LONELINESS-173
             HANGOVER-174 BOILS-167 PROSTATITIS-168 DREAD-169 SCIATICA-170
             GRIEF-171 ANXIETY-165 ANGER-166 ANGINA-161 LACERATION-162
             DEPRESSION-163 ABRASION-164 ANGER-157 BOILS-158 DREAD-159
             SCIATICA-160 ANXIETY-153 ANGINA-154 JEALOUSY-155 GRIEF-156
             ABRASION-151 PROSTATITIS-152 ABRASION-146 LONELINESS-147
             LACERATION-148 DEPRESSION-149 HANGOVER-150 ANXIETY-141
             JEALOUSY-142 DEPRESSION-143 GRIEF-144 HANGOVER-145 BOILS-136
             ANGINA-137 PROSTATITIS-138 ANGER-139 LACERATION-140 BOILS-131
             ANGER-132 SCIATICA-133 LONELINESS-134 DREAD-135 GRIEF-129
             HANGOVER-130 JEALOUSY-508 DEPRESSION-509 ANXIETY-510 ANGINA-511
             SCIATICA-512 ABRASION-506 PROSTATITIS-507 LONELINESS-504
             DREAD-505 ABRASION-499 ANGINA-500 GRIEF-501 BOILS-502
             LACERATION-503 ANGER-497 LACERATION-498 JEALOUSY-493 HANGOVER-494
             DREAD-495 ANXIETY-496 SCIATICA-492 LONELINESS-491
             PROSTATITIS-490 GRIEF-488 DEPRESSION-489 DREAD-484 HANGOVER-485
             ANXIETY-486 ANGER-487 LACERATION-481 DEPRESSION-482
             PROSTATITIS-483 JEALOUSY-476 ANGINA-477 SCIATICA-478 LONELINESS-479
             ABRASION-480 BOILS-475 LONELINESS-471 DEPRESSION-472
             HANGOVER-473 LACERATION-474 JEALOUSY-466 BOILS-467 ANXIETY-468
             ANGINA-469 ANGER-470 ABRASION-463 GRIEF-464 PROSTATITIS-465
             DREAD-461 SCIATICA-462 JEALOUSY-459 GRIEF-460 PROSTATITIS-457
             LACERATION-458 DREAD-456 ANXIETY-454 DEPRESSION-455 LONELINESS-449
             SCIATICA-450 HANGOVER-451 BOILS-452 ABRASION-453 PROSTATITIS-446
             ANGINA-447 ANGER-448 ABRASION-443 ANXIETY-444 ANGINA-445
             GRIEF-440 HANGOVER-441 SCIATICA-442 LONELINESS-437
             DEPRESSION-438 BOILS-439 LACERATION-436 JEALOUSY-433 ANGER-434
             DREAD-435 HANGOVER-431 DEPRESSION-432 LACERATION-428
             ANGER-429 ANXIETY-430 LONELINESS-426 JEALOUSY-427
             SCIATICA-425 ABRASION-424 ANGINA-422 GRIEF-423 SCIATICA-417
             LONELINESS-418 DREAD-419 PROSTATITIS-420 BOILS-421 ABRASION-415
             DREAD-416 GUANABARA QUEBEC BAVARIA KENTUCKY SURREY JUPITER PLUTO
             EARTH URANUS)
   (:INIT (FOOD TUNA-54)
          (FOOD LEMON-53)
          (FOOD PEPPER-52)
          (FOOD FLOUNDER-51)
          (FOOD POTATO-55)
          (FOOD ORANGE-56)
          (FOOD HOTDOG-57)
          (FOOD GRAPEFRUIT-58)
          (FOOD SNICKERS-59)
          (FOOD PEAR-60)
          (FOOD TOMATO-61)
          (FOOD CHERRY-62)
          (FOOD BAGUETTE-63)
          (FOOD GUAVA-64)
          (FOOD LAMB-17)
          (FOOD APPLE-18)
          (FOOD PORK-19)
          (FOOD TOFU-20)
          (FOOD WONDERBREAD-21)
          (FOOD ENDIVE-22)
          (FOOD COD-23)
          (FOOD KALE-24)
          (FOOD YOGURT-25)
          (FOOD HAMBURGER-26)
          (FOOD PAPAYA-27)
          (FOOD WURST-28)
          (FOOD CANTELOPE-29)
          (FOOD CHICKEN-30)
          (FOOD SCALLOP-31)
          (FOOD RICE-32)
          (FOOD OKRA-9)
          (FOOD HAM-10)
          (FOOD TURKEY-11)
          (FOOD LOBSTER-12)
          (FOOD CHOCOLATE-13)
          (FOOD POPOVER-14)
          (FOOD MARZIPAN-15)
          (FOOD LETTUCE-16)
          (FOOD SCALLION-5)
          (FOOD CUCUMBER-6)
          (FOOD MUFFIN-7)
          (FOOD SHRIMP-8)
          (FOOD BROCCOLI-3)
          (FOOD BEEF-4)
          (FOOD MUTTON-1)
          (FOOD SWEETROLL-2)
          (FOOD PEPPER)
          (FOOD SCALLOP)
          (FOOD FLOUNDER)
          (FOOD WURST)
          (FOOD BAGUETTE)
          (FOOD CHOCOLATE)
          (FOOD BEEF)
          (FOOD PEA)
          (FOOD GRAPEFRUIT)
          (FOOD CHERRY)
          (FOOD TOFU)
          (FOOD BACON)
          (FOOD PEAR)
          (FOOD LETTUCE)
          (FOOD HAM)
          (FOOD APPLE)
          (FOOD HOTDOG)
          (FOOD SNICKERS)
          (FOOD COD)
          (FOOD ENDIVE)
          (FOOD HAMBURGER)
          (FOOD POPOVER)
          (FOOD MUTTON)
          (FOOD CHICKEN)
          (FOOD ARUGULA)
          (FOOD WONDERBREAD)
          (FOOD KALE)
          (FOOD MUFFIN)
          (FOOD PISTACHIO)
          (FOOD BROCCOLI)
          (FOOD SCALLION)
          (FOOD CUCUMBER)
          (FOOD PORK)
          (FOOD LEMON)
          (FOOD TOMATO)
          (FOOD LAMB)
          (FOOD TURKEY)
          (FOOD RICE)
          (FOOD CANTELOPE)
          (FOOD HAROSET)
          (FOOD TUNA)
          (FOOD ONION)
          (FOOD OKRA)
          (FOOD LOBSTER)
          (FOOD POTATO)
          (FOOD YOGURT)
          (FOOD SWEETROLL)
          (FOOD SHRIMP)
          (FOOD MARZIPAN)
          (FOOD ORANGE)
          (FOOD MELON)
          (FOOD PAPAYA)
          (FOOD GUAVA)
          (PLEASURE SATISFACTION)
          (PLEASURE EXPECTATION)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE AESTHETICS)
          (PLEASURE CURIOSITY)
          (PLEASURE EMPATHY)
          (PLEASURE EXCITEMENT)
          (PLEASURE STIMULATION)
          (PLEASURE SATIETY)
          (PLEASURE UNDERSTANDING)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE REST)
          (PLEASURE LEARNING)
          (PLEASURE LUBRICITY)
          (PLEASURE TRIUMPH)
          (PLEASURE INTOXICATION)
          (PLEASURE LOVE)
          (PLEASURE INTOXICATION-50)
          (PLEASURE TRIUMPH-49)
          (PLEASURE STIMULATION-48)
          (PLEASURE ACHIEVEMENT-47)
          (PLEASURE LEARNING-46)
          (PLEASURE EXPECTATION-45)
          (PLEASURE ENTERTAINMENT-44)
          (PLEASURE SATISFACTION-43)
          (PLEASURE LUBRICITY-42)
          (PLEASURE UNDERSTANDING-41)
          (PLEASURE REST-40)
          (PLEASURE LOVE-39)
          (PLEASURE SATIETY-38)
          (PLEASURE EXCITEMENT-37)
          (PLEASURE EMPATHY-36)
          (PLEASURE AESTHETICS-35)
          (PLEASURE CURIOSITY-34)
          (PLEASURE EXCITEMENT-33)
          (PLEASURE UNDERSTANDING-128)
          (PLEASURE SATISFACTION-127)
          (PLEASURE TRIUMPH-126)
          (PLEASURE CURIOSITY-125)
          (PLEASURE REST-124)
          (PLEASURE ENTERTAINMENT-123)
          (PLEASURE SATIETY-122)
          (PLEASURE ACHIEVEMENT-121)
          (PLEASURE LUBRICITY-120)
          (PLEASURE EXPECTATION-119)
          (PLEASURE STIMULATION-118)
          (PLEASURE LEARNING-117)
          (PLEASURE AESTHETICS-116)
          (PLEASURE LOVE-115)
          (PLEASURE INTOXICATION-114)
          (PLEASURE EMPATHY-113)
          (PLEASURE EXPECTATION-112)
          (PLEASURE LUBRICITY-111)
          (PLEASURE INTOXICATION-110)
          (PLEASURE SATISFACTION-109)
          (PAIN SCIATICA)
          (PAIN PROSTATITIS)
          (PAIN DEPRESSION)
          (PAIN LONELINESS)
          (PAIN ANGER)
          (PAIN LACERATION)
          (PAIN HANGOVER)
          (PAIN GRIEF)
          (PAIN JEALOUSY)
          (PAIN ANXIETY)
          (PAIN ANGINA)
          (PAIN BOILS)
          (PAIN DREAD)
          (PAIN DEPRESSION-106)
          (PAIN ANGINA-107)
          (PAIN LACERATION-108)
          (PAIN ABRASION)
          (PAIN HANGOVER-102)
          (PAIN JEALOUSY-103)
          (PAIN ANGER-104)
          (PAIN GRIEF-105)
          (PAIN BOILS-99)
          (PAIN PROSTATITIS-100)
          (PAIN SCIATICA-101)
          (PAIN LONELINESS-96)
          (PAIN ABRASION-97)
          (PAIN DREAD-98)
          (PAIN LACERATION-92)
          (PAIN DREAD-93)
          (PAIN HANGOVER-94)
          (PAIN ANXIETY-95)
          (PAIN JEALOUSY-89)
          (PAIN GRIEF-90)
          (PAIN SCIATICA-91)
          (PAIN LONELINESS-85)
          (PAIN BOILS-86)
          (PAIN PROSTATITIS-87)
          (PAIN DEPRESSION-88)
          (PAIN ANGINA-81)
          (PAIN ANGER-82)
          (PAIN ABRASION-83)
          (PAIN ANXIETY-84)
          (PAIN ANGER-76)
          (PAIN ANGINA-77)
          (PAIN HANGOVER-78)
          (PAIN ANXIETY-79)
          (PAIN GRIEF-80)
          (PAIN SCIATICA-73)
          (PAIN LONELINESS-74)
          (PAIN LACERATION-75)
          (PAIN JEALOUSY-70)
          (PAIN PROSTATITIS-71)
          (PAIN ABRASION-72)
          (PAIN DEPRESSION-68)
          (PAIN BOILS-69)
          (PAIN DREAD-67)
          (PAIN DREAD-256)
          (PAIN SCIATICA-65)
          (PAIN LONELINESS-66)
          (PAIN ANGINA-255)
          (PAIN ANXIETY-254)
          (PAIN LACERATION-250)
          (PAIN HANGOVER-251)
          (PAIN ANGER-252)
          (PAIN JEALOUSY-253)
          (PAIN ABRASION-248)
          (PAIN BOILS-249)
          (PAIN GRIEF-247)
          (PAIN DEPRESSION-246)
          (PAIN GRIEF-242)
          (PAIN JEALOUSY-243)
          (PAIN SCIATICA-244)
          (PAIN PROSTATITIS-245)
          (PAIN HANGOVER-239)
          (PAIN DEPRESSION-240)
          (PAIN BOILS-241)
          (PAIN PROSTATITIS-238)
          (PAIN ANXIETY-236)
          (PAIN LONELINESS-237)
          (PAIN ABRASION-234)
          (PAIN ANGINA-235)
          (PAIN BOILS-230)
          (PAIN ANGER-231)
          (PAIN DREAD-232)
          (PAIN LACERATION-233)
          (PAIN ANGINA-228)
          (PAIN ANGER-229)
          (PAIN SCIATICA-224)
          (PAIN ANXIETY-225)
          (PAIN JEALOUSY-226)
          (PAIN HANGOVER-227)
          (PAIN ABRASION-220)
          (PAIN LONELINESS-221)
          (PAIN DREAD-222)
          (PAIN LACERATION-223)
          (PAIN GRIEF-219)
          (PAIN ANGINA-215)
          (PAIN HANGOVER-216)
          (PAIN PROSTATITIS-217)
          (PAIN DEPRESSION-218)
          (PAIN GRIEF-211)
          (PAIN LONELINESS-212)
          (PAIN SCIATICA-213)
          (PAIN ANGER-214)
          (PAIN JEALOUSY-207)
          (PAIN BOILS-208)
          (PAIN LACERATION-209)
          (PAIN ANXIETY-210)
          (PAIN DREAD-203)
          (PAIN DEPRESSION-204)
          (PAIN ABRASION-205)
          (PAIN PROSTATITIS-206)
          (PAIN ABRASION-198)
          (PAIN LACERATION-199)
          (PAIN DREAD-200)
          (PAIN ANGINA-201)
          (PAIN HANGOVER-202)
          (PAIN ANGER-197)
          (PAIN GRIEF-192)
          (PAIN ANXIETY-193)
          (PAIN BOILS-194)
          (PAIN DEPRESSION-195)
          (PAIN JEALOUSY-196)
          (PAIN PROSTATITIS-191)
          (PAIN LONELINESS-190)
          (PAIN HANGOVER-188)
          (PAIN SCIATICA-189)
          (PAIN DREAD-186)
          (PAIN DEPRESSION-187)
          (PAIN ABRASION-184)
          (PAIN GRIEF-185)
          (PAIN ANGER-181)
          (PAIN SCIATICA-182)
          (PAIN PROSTATITIS-183)
          (PAIN ANXIETY-176)
          (PAIN JEALOUSY-177)
          (PAIN ANGINA-178)
          (PAIN LONELINESS-179)
          (PAIN BOILS-180)
          (PAIN LACERATION-175)
          (PAIN JEALOUSY-172)
          (PAIN LONELINESS-173)
          (PAIN HANGOVER-174)
          (PAIN BOILS-167)
          (PAIN PROSTATITIS-168)
          (PAIN DREAD-169)
          (PAIN SCIATICA-170)
          (PAIN GRIEF-171)
          (PAIN ANXIETY-165)
          (PAIN ANGER-166)
          (PAIN ANGINA-161)
          (PAIN LACERATION-162)
          (PAIN DEPRESSION-163)
          (PAIN ABRASION-164)
          (PAIN ANGER-157)
          (PAIN BOILS-158)
          (PAIN DREAD-159)
          (PAIN SCIATICA-160)
          (PAIN ANXIETY-153)
          (PAIN ANGINA-154)
          (PAIN JEALOUSY-155)
          (PAIN GRIEF-156)
          (PAIN ABRASION-151)
          (PAIN PROSTATITIS-152)
          (PAIN ABRASION-146)
          (PAIN LONELINESS-147)
          (PAIN LACERATION-148)
          (PAIN DEPRESSION-149)
          (PAIN HANGOVER-150)
          (PAIN ANXIETY-141)
          (PAIN JEALOUSY-142)
          (PAIN DEPRESSION-143)
          (PAIN GRIEF-144)
          (PAIN HANGOVER-145)
          (PAIN BOILS-136)
          (PAIN ANGINA-137)
          (PAIN PROSTATITIS-138)
          (PAIN ANGER-139)
          (PAIN LACERATION-140)
          (PAIN BOILS-131)
          (PAIN ANGER-132)
          (PAIN SCIATICA-133)
          (PAIN LONELINESS-134)
          (PAIN DREAD-135)
          (PAIN GRIEF-129)
          (PAIN HANGOVER-130)
          (PAIN JEALOUSY-508)
          (PAIN DEPRESSION-509)
          (PAIN ANXIETY-510)
          (PAIN ANGINA-511)
          (PAIN SCIATICA-512)
          (PAIN ABRASION-506)
          (PAIN PROSTATITIS-507)
          (PAIN LONELINESS-504)
          (PAIN DREAD-505)
          (PAIN ABRASION-499)
          (PAIN ANGINA-500)
          (PAIN GRIEF-501)
          (PAIN BOILS-502)
          (PAIN LACERATION-503)
          (PAIN ANGER-497)
          (PAIN LACERATION-498)
          (PAIN JEALOUSY-493)
          (PAIN HANGOVER-494)
          (PAIN DREAD-495)
          (PAIN ANXIETY-496)
          (PAIN SCIATICA-492)
          (PAIN LONELINESS-491)
          (PAIN PROSTATITIS-490)
          (PAIN GRIEF-488)
          (PAIN DEPRESSION-489)
          (PAIN DREAD-484)
          (PAIN HANGOVER-485)
          (PAIN ANXIETY-486)
          (PAIN ANGER-487)
          (PAIN LACERATION-481)
          (PAIN DEPRESSION-482)
          (PAIN PROSTATITIS-483)
          (PAIN JEALOUSY-476)
          (PAIN ANGINA-477)
          (PAIN SCIATICA-478)
          (PAIN LONELINESS-479)
          (PAIN ABRASION-480)
          (PAIN BOILS-475)
          (PAIN LONELINESS-471)
          (PAIN DEPRESSION-472)
          (PAIN HANGOVER-473)
          (PAIN LACERATION-474)
          (PAIN JEALOUSY-466)
          (PAIN BOILS-467)
          (PAIN ANXIETY-468)
          (PAIN ANGINA-469)
          (PAIN ANGER-470)
          (PAIN ABRASION-463)
          (PAIN GRIEF-464)
          (PAIN PROSTATITIS-465)
          (PAIN DREAD-461)
          (PAIN SCIATICA-462)
          (PAIN JEALOUSY-459)
          (PAIN GRIEF-460)
          (PAIN PROSTATITIS-457)
          (PAIN LACERATION-458)
          (PAIN DREAD-456)
          (PAIN ANXIETY-454)
          (PAIN DEPRESSION-455)
          (PAIN LONELINESS-449)
          (PAIN SCIATICA-450)
          (PAIN HANGOVER-451)
          (PAIN BOILS-452)
          (PAIN ABRASION-453)
          (PAIN PROSTATITIS-446)
          (PAIN ANGINA-447)
          (PAIN ANGER-448)
          (PAIN ABRASION-443)
          (PAIN ANXIETY-444)
          (PAIN ANGINA-445)
          (PAIN GRIEF-440)
          (PAIN HANGOVER-441)
          (PAIN SCIATICA-442)
          (PAIN LONELINESS-437)
          (PAIN DEPRESSION-438)
          (PAIN BOILS-439)
          (PAIN LACERATION-436)
          (PAIN JEALOUSY-433)
          (PAIN ANGER-434)
          (PAIN DREAD-435)
          (PAIN HANGOVER-431)
          (PAIN DEPRESSION-432)
          (PAIN LACERATION-428)
          (PAIN ANGER-429)
          (PAIN ANXIETY-430)
          (PAIN LONELINESS-426)
          (PAIN JEALOUSY-427)
          (PAIN SCIATICA-425)
          (PAIN ABRASION-424)
          (PAIN ANGINA-422)
          (PAIN GRIEF-423)
          (PAIN SCIATICA-417)
          (PAIN LONELINESS-418)
          (PAIN DREAD-419)
          (PAIN PROSTATITIS-420)
          (PAIN BOILS-421)
          (PAIN ABRASION-415)
          (PAIN DREAD-416)
          (PROVINCE GUANABARA)
          (PROVINCE QUEBEC)
          (PROVINCE BAVARIA)
          (PROVINCE KENTUCKY)
          (PROVINCE SURREY)
          (PLANET JUPITER)
          (PLANET PLUTO)
          (PLANET EARTH)
          (PLANET URANUS)
          (CRAVES BOILS-452 CANTELOPE)
          (CRAVES ANGER-157 GRAPEFRUIT)
          (CRAVES HANGOVER-102 HOTDOG-57)
          (CRAVES ABRASION-151 TOFU)
          (EATS TOFU PISTACHIO)
          (LOCALE SWEETROLL-2 GUANABARA)
          (EATS MUTTON-1 SWEETROLL)
          (EATS ENDIVE MELON)
          (EATS LETTUCE TUNA)
          (EATS GUAVA-64 ONION)
          (CRAVES BOILS-208 LETTUCE-16)
          (EATS ARUGULA MUTTON-1)
          (EATS SWEETROLL-2 MUFFIN)
          (HARMONY REST EARTH)
          (EATS WURST-28 SCALLION)
          (EATS CANTELOPE KALE)
          (CRAVES JEALOUSY-155 CHERRY)
          (CRAVES DREAD-159 GRAPEFRUIT)
          (CRAVES GRIEF-501 ENDIVE)
          (EATS PEA POPOVER)
          (EATS PORK SHRIMP)
          (EATS ARUGULA PORK-19)
          (CRAVES GRIEF-211 MARZIPAN-15)
          (CRAVES LACERATION-233 OKRA-9)
          (CRAVES ANXIETY-430 SWEETROLL)
          (CRAVES JEALOUSY-508 HOTDOG)
          (CRAVES LONELINESS-173 BAGUETTE)
          (LOCALE CHOCOLATE GUANABARA)
          (CRAVES HANGOVER-494 POPOVER)
          (EATS TURKEY LETTUCE)
          (CRAVES BOILS-241 CANTELOPE-29)
          (CRAVES ANGINA-161 PEA)
          (EATS CUCUMBER-6 TOFU)
          (EATS GRAPEFRUIT YOGURT)
          (HARMONY ENTERTAINMENT URANUS)
          (EATS OKRA TUNA)
          (CRAVES SATIETY-38 CHERRY)
          (LOCALE ARUGULA QUEBEC)
          (EATS KALE-24 PAPAYA-27)
          (EATS SHRIMP-8 BROCCOLI)
          (ATTACKS KENTUCKY SURREY)
          (CRAVES BOILS-167 CHOCOLATE)
          (LOCALE ONION KENTUCKY)
          (CRAVES HANGOVER-94 PEAR-60)
          (CRAVES ANGINA-511 HOTDOG)
          (LOCALE SHRIMP-8 KENTUCKY)
          (CRAVES JEALOUSY-466 CUCUMBER)
          (LOCALE MUFFIN QUEBEC)
          (LOCALE APPLE-18 BAVARIA)
          (CRAVES ABRASION-453 CANTELOPE)
          (EATS BACON COD)
          (CRAVES PROSTATITIS-87 CHERRY-62)
          (CRAVES LONELINESS-471 SCALLION)
          (HARMONY EMPATHY-36 URANUS)
          (CRAVES BOILS-131 HAM)
          (EATS SCALLOP SWEETROLL-2)
          (CRAVES ANGINA-77 GUAVA-64)
          (CRAVES LONELINESS-479 PISTACHIO)
          (CRAVES HANGOVER-174 BAGUETTE)
          (EATS HOTDOG HAROSET)
          (EATS GRAPEFRUIT-58 SCALLION-5)
          (CRAVES ANXIETY-193 SHRIMP-8)
          (CRAVES PROSTATITIS-420 PAPAYA)
          (EATS BAGUETTE-63 GUAVA-64)
          (HARMONY SATISFACTION-127 PLUTO)
          (EATS POPOVER TOFU-20)
          (CRAVES PROSTATITIS-152 TOFU)
          (CRAVES AESTHETICS-35 SNICKERS)
          (EATS SCALLOP PEA)
          (CRAVES DEPRESSION-455 RICE)
          (EATS KALE ORANGE-56)
          (LOCALE OKRA-9 GUANABARA)
          (CRAVES SCIATICA-462 LEMON)
          (EATS BROCCOLI-3 PISTACHIO)
          (LOCALE SNICKERS GUANABARA)
          (LOCALE WURST QUEBEC)
          (CRAVES PROSTATITIS-490 ARUGULA)
          (CRAVES STIMULATION-48 TURKEY-11)
          (CRAVES LACERATION PEPPER-52)
          (CRAVES SCIATICA-170 CHOCOLATE)
          (EATS WURST BAGUETTE-63)
          (EATS BEEF COD)
          (LOCALE SCALLION-5 GUANABARA)
          (CRAVES ENTERTAINMENT-44 MUTTON-1)
          (LOCALE FLOUNDER BAVARIA)
          (HARMONY EXCITEMENT PLUTO)
          (EATS CHERRY-62 SCALLION)
          (EATS TURKEY TOMATO)
          (CRAVES ANGINA-81 BAGUETTE-63)
          (EATS MUFFIN POTATO)
          (CRAVES DEPRESSION-438 OKRA)
          (LOCALE POPOVER QUEBEC)
          (LOCALE ORANGE-56 KENTUCKY)
          (EATS PEAR-60 TUNA)
          (EATS POPOVER LAMB)
          (CRAVES DEPRESSION-240 CANTELOPE-29)
          (EATS COD MUTTON)
          (CRAVES SCIATICA-478 PISTACHIO)
          (EATS BROCCOLI-3 POTATO)
          (EATS OKRA-9 MARZIPAN)
          (CRAVES ANGINA-201 CUCUMBER-6)
          (LOCALE HOTDOG BAVARIA)
          (LOCALE KALE QUEBEC)
          (LOCALE COD QUEBEC)
          (EATS PEAR-60 OKRA-9)
          (HARMONY CURIOSITY-34 EARTH)
          (CRAVES LACERATION-148 BACON)
          (HARMONY SATIETY-38 EARTH)
          (EATS PEA COD-23)
          (CRAVES EMPATHY TOMATO-61)
          (LOCALE LETTUCE-16 GUANABARA)
          (LOCALE LEMON QUEBEC)
          (EATS POTATO TOMATO-61)
          (EATS ORANGE-56 MUFFIN-7)
          (EATS FLOUNDER KALE)
          (EATS CUCUMBER-6 ARUGULA)
          (CRAVES HANGOVER-227 TURKEY-11)
          (EATS WURST KALE)
          (EATS LETTUCE-16 SCALLION)
          (CRAVES ANGINA-178 FLOUNDER)
          (EATS PEA PEPPER-52)
          (EATS COD-23 PEA)
          (CRAVES ANGER-132 HAM)
          (CRAVES ANGER-429 SWEETROLL)
          (EATS HAM-10 POTATO)
          (EATS MARZIPAN-15 APPLE-18)
          (EATS ORANGE-56 KALE)
          (CRAVES DEPRESSION-68 PORK-19)
          (HARMONY EMPATHY-113 PLUTO)
          (EATS YOGURT APPLE-18)
          (EATS APPLE CANTELOPE-29)
          (CRAVES ABRASION-205 SCALLION-5)
          (EATS POTATO HAM)
          (EATS BEEF-4 ENDIVE)
          (CRAVES BOILS-230 OKRA-9)
          (CRAVES SCIATICA-189 MUTTON-1)
          (CRAVES LUBRICITY-120 SCALLION)
          (CRAVES ANGINA-477 PISTACHIO)
          (EATS SHRIMP PORK)
          (EATS CHERRY-62 LOBSTER-12)
          (EATS ENDIVE-22 CHOCOLATE-13)
          (EATS PEA SCALLOP)
          (CRAVES LACERATION-140 LETTUCE)
          (EATS PAPAYA-27 CHERRY)
          (EATS GRAPEFRUIT CHOCOLATE)
          (CRAVES HANGOVER-485 KALE)
          (EATS CHOCOLATE HOTDOG)
          (CRAVES DREAD-416 GUAVA)
          (CRAVES TRIUMPH HAMBURGER-26)
          (LOCALE MUFFIN-7 BAVARIA)
          (EATS WURST TUNA)
          (EATS LOBSTER-12 CHERRY-62)
          (LOCALE PEA QUEBEC)
          (ORBITS PLUTO EARTH)
          (EATS LEMON-53 TUNA-54)
          (CRAVES LONELINESS LEMON-53)
          (CRAVES SCIATICA-244 WURST-28)
          (EATS MUFFIN RICE)
          (CRAVES ANGINA-235 RICE-32)
          (EATS CHERRY ONION)
          (LOCALE CHERRY SURREY)
          (CRAVES ANGER-139 LETTUCE)
          (EATS YOGURT CANTELOPE)
          (LOCALE BEEF QUEBEC)
          (HARMONY INTOXICATION-114 PLUTO)
          (CRAVES TRIUMPH-49 OKRA-9)
          (CRAVES CURIOSITY-34 COD)
          (EATS GRAPEFRUIT-58 YOGURT)
          (EATS BACON PISTACHIO)
          (CRAVES EXCITEMENT-37 HAM)
          (EATS OKRA-9 PEAR-60)
          (EATS FLOUNDER-51 LEMON-53)
          (EATS CHOCOLATE HAROSET)
          (CRAVES PROSTATITIS-465 PORK)
          (CRAVES ANGINA-137 LETTUCE)
          (EATS CANTELOPE HAM)
          (CRAVES SCIATICA TUNA-54)
          (EATS PISTACHIO TOFU)
          (CRAVES LONELINESS-74 LAMB-17)
          (EATS HAMBURGER PAPAYA)
          (LOCALE HAM QUEBEC)
          (HARMONY LUBRICITY-120 PLUTO)
          (CRAVES LONELINESS-504 COD)
          (LOCALE CANTELOPE-29 QUEBEC)
          (CRAVES ANXIETY-79 GUAVA-64)
          (EATS BAGUETTE ARUGULA)
          (CRAVES DEPRESSION-143 PEAR)
          (LOCALE TURKEY BAVARIA)
          (CRAVES HANGOVER-150 BACON)
          (CRAVES LONELINESS-212 MARZIPAN-15)
          (CRAVES SCIATICA-182 SCALLOP)
          (CRAVES JEALOUSY-103 HOTDOG-57)
          (EATS BROCCOLI SHRIMP-8)
          (HARMONY TRIUMPH-126 EARTH)
          (EATS SNICKERS HOTDOG-57)
          (CRAVES ABRASION-184 PEPPER)
          (EATS FLOUNDER HAMBURGER-26)
          (EATS PEAR CANTELOPE)
          (CRAVES SCIATICA-160 GRAPEFRUIT)
          (EATS RICE-32 PISTACHIO)
          (CRAVES GRIEF-423 MELON)
          (EATS PEA RICE-32)
          (CRAVES GRIEF-80 GUAVA-64)
          (EATS SWEETROLL-2 SCALLOP)
          (EATS LOBSTER-12 LETTUCE-16)
          (LOCALE SCALLOP-31 KENTUCKY)
          (HARMONY LUBRICITY EARTH)
          (LOCALE GUAVA-64 BAVARIA)
          (CRAVES BOILS-439 OKRA)
          (CRAVES LACERATION-458 LAMB)
          (CRAVES ANGINA-422 MELON)
          (CRAVES SCIATICA-492 MUTTON)
          (HARMONY SATISFACTION-109 PLUTO)
          (CRAVES DREAD-484 KALE)
          (LOCALE CHERRY-62 GUANABARA)
          (EATS KALE WURST)
          (EATS PISTACHIO CHICKEN)
          (EATS TOMATO PORK)
          (CRAVES LACERATION-503 ENDIVE)
          (HARMONY CURIOSITY URANUS)
          (EATS RICE-32 SNICKERS-59)
          (HARMONY EXPECTATION-119 URANUS)
          (LOCALE GRAPEFRUIT BAVARIA)
          (LOCALE CHICKEN-30 GUANABARA)
          (EATS RICE WURST-28)
          (EATS SCALLION CHERRY-62)
          (LOCALE YOGURT-25 GUANABARA)
          (EATS HOTDOG-57 SNICKERS)
          (EATS SNICKERS LOBSTER)
          (HARMONY SATISFACTION PLUTO)
          (EATS FLOUNDER-51 TUNA-54)
          (EATS BAGUETTE LOBSTER)
          (CRAVES LACERATION-108 ORANGE-56)
          (EATS SCALLION-5 GRAPEFRUIT-58)
          (EATS CHICKEN PISTACHIO)
          (CRAVES ABRASION-164 PEA)
          (EATS WURST CHERRY)
          (CRAVES DEPRESSION-204 SCALLION-5)
          (CRAVES ENTERTAINMENT-123 WONDERBREAD)
          (LOCALE CUCUMBER GUANABARA)
          (EATS CHOCOLATE CUCUMBER)
          (EATS HAM CANTELOPE)
          (EATS SCALLOP POPOVER)
          (EATS HAROSET LAMB-17)
          (CRAVES DEPRESSION-509 HOTDOG)
          (CRAVES GRIEF-185 PEPPER)
          (EATS PAPAYA-27 PEAR-60)
          (CRAVES PROSTATITIS-446 HAROSET)
          (LOCALE SCALLION QUEBEC)
          (CRAVES GRIEF PEPPER-52)
          (EATS COD BACON)
          (CRAVES GRIEF-247 HAMBURGER-26)
          (EATS ARUGULA CUCUMBER-6)
          (EATS SCALLION PAPAYA)
          (EATS CUCUMBER-6 BROCCOLI-3)
          (CRAVES DEPRESSION-432 YOGURT)
          (CRAVES DEPRESSION-472 SCALLION)
          (HARMONY INTOXICATION-110 EARTH)
          (EATS WONDERBREAD MELON)
          (HARMONY LUBRICITY-111 URANUS)
          (CRAVES DREAD-456 TURKEY)
          (CRAVES LACERATION-474 SCALLION)
          (EATS HOTDOG CHOCOLATE)
          (CRAVES SATISFACTION-43 SWEETROLL-2)
          (CRAVES DREAD-256 WONDERBREAD-21)
          (LOCALE TOMATO-61 SURREY)
          (CRAVES DREAD-435 POTATO)
          (CRAVES GRIEF-242 WURST-28)
          (EATS SCALLOP-31 CHERRY)
          (LOCALE TOMATO QUEBEC)
          (EATS BROCCOLI GUAVA)
          (CRAVES PROSTATITIS-483 MUFFIN)
          (CRAVES BOILS-194 SHRIMP-8)
          (CRAVES DREAD-186 SWEETROLL-2)
          (EATS GUAVA PEPPER)
          (CRAVES ANXIETY-95 PEAR-60)
          (CRAVES ANXIETY-236 SCALLOP-31)
          (EATS PORK-19 ARUGULA)
          (CRAVES ANXIETY-176 FLOUNDER)
          (CRAVES LONELINESS-221 LOBSTER-12)
          (CRAVES ANGER-197 MUFFIN-7)
          (EATS CANTELOPE TUNA)
          (EATS LOBSTER YOGURT)
          (HARMONY REST-40 URANUS)
          (CRAVES JEALOUSY-172 BAGUETTE)
          (HARMONY SATISFACTION-43 URANUS)
          (EATS MARZIPAN SHRIMP)
          (EATS HOTDOG-57 GRAPEFRUIT)
          (EATS SCALLOP RICE)
          (CRAVES ACHIEVEMENT TOFU-20)
          (LOCALE POPOVER-14 GUANABARA)
          (EATS CHICKEN-30 POPOVER)
          (CRAVES DREAD-93 PEAR-60)
          (EATS COD BEEF)
          (LOCALE SWEETROLL KENTUCKY)
          (CRAVES LONELINESS-491 CHICKEN)
          (EATS MUTTON TOFU)
          (CRAVES ANGER-487 KALE)
          (LOCALE PORK QUEBEC)
          (EATS YOGURT GRAPEFRUIT-58)
          (EATS HAROSET FLOUNDER)
          (CRAVES PROSTATITIS-457 LAMB)
          (HARMONY STIMULATION-48 EARTH)
          (EATS HAM-10 BAGUETTE)
          (CRAVES ANXIETY FLOUNDER-51)
          (EATS POPOVER-14 COD-23)
          (EATS SWEETROLL CHOCOLATE-13)
          (CRAVES HANGOVER-188 MUTTON-1)
          (EATS ONION GUAVA-64)
          (CRAVES ACHIEVEMENT-47 CHOCOLATE-13)
          (CRAVES HANGOVER-251 KALE-24)
          (CRAVES SATISFACTION LEMON-53)
          (CRAVES ABRASION-480 PISTACHIO)
          (EATS CUCUMBER MELON)
          (LOCALE MUTTON QUEBEC)
          (LOCALE MUTTON-1 QUEBEC)
          (LOCALE HOTDOG-57 BAVARIA)
          (EATS TUNA MUFFIN-7)
          (CRAVES LEARNING COD-23)
          (EATS PORK TOMATO)
          (CRAVES PROSTATITIS-507 SNICKERS)
          (EATS RICE MUFFIN)
          (EATS SCALLOP-31 PAPAYA-27)
          (CRAVES BOILS-421 PAPAYA)
          (CRAVES JEALOUSY-70 APPLE-18)
          (CRAVES UNDERSTANDING PORK-19)
          (EATS SWEETROLL BEEF)
          (LOCALE APPLE GUANABARA)
          (LOCALE TUNA-54 BAVARIA)
          (CRAVES ABRASION-220 LOBSTER-12)
          (EATS LEMON POTATO-55)
          (LOCALE PEPPER-52 KENTUCKY)
          (EATS APPLE LEMON)
          (CRAVES EXPECTATION-112 POTATO)
          (EATS GRAPEFRUIT HOTDOG-57)
          (EATS BROCCOLI-3 CUCUMBER-6)
          (EATS ENDIVE BEEF-4)
          (CRAVES ABRASION-499 ENDIVE)
          (EATS ENDIVE-22 MUTTON)
          (CRAVES ANXIETY-141 PEAR)
          (EATS TUNA LETTUCE)
          (HARMONY LOVE PLUTO)
          (EATS MUFFIN POPOVER-14)
          (CRAVES DEPRESSION-106 ORANGE-56)
          (EATS MUTTON PORK-19)
          (EATS LAMB POPOVER)
          (LOCALE ORANGE QUEBEC)
          (CRAVES SCIATICA-417 PAPAYA)
          (EATS LEMON-53 FLOUNDER-51)
          (CRAVES ABRASION ORANGE-56)
          (CRAVES LONELINESS-66 WONDERBREAD-21)
          (CRAVES PROSTATITIS-217 POPOVER-14)
          (EATS TOFU-20 PISTACHIO)
          (LOCALE CUCUMBER-6 QUEBEC)
          (CRAVES LONELINESS-190 BEEF-4)
          (CRAVES ABRASION-463 PORK)
          (CRAVES PROSTATITIS-168 CHOCOLATE)
          (CRAVES ANXIETY-210 LETTUCE-16)
          (EATS KALE FLOUNDER)
          (EATS HAMBURGER RICE)
          (CRAVES DREAD-98 SNICKERS-59)
          (EATS POTATO SNICKERS-59)
          (CRAVES ABRASION-424 ORANGE)
          (CRAVES GRIEF-90 TOMATO-61)
          (EATS POPOVER SCALLION)
          (EATS KALE-24 SCALLOP-31)
          (EATS ORANGE HOTDOG)
          (LOCALE OKRA QUEBEC)
          (CRAVES GRIEF-460 TOMATO)
          (CRAVES HANGOVER-441 ONION)
          (CRAVES DREAD-203 SCALLION-5)
          (CRAVES ANXIETY-165 BEEF)
          (EATS HAROSET YOGURT)
          (EATS PEAR POTATO)
          (LOCALE HAM-10 GUANABARA)
          (EATS MELON ENDIVE)
          (EATS POTATO MUFFIN)
          (CRAVES DEPRESSION-489 WONDERBREAD)
          (EATS GUAVA BROCCOLI)
          (CRAVES DREAD-461 LEMON)
          (EATS YOGURT GRAPEFRUIT)
          (CRAVES ABRASION-83 BAGUETTE-63)
          (HARMONY TRIUMPH PLUTO)
          (EATS POTATO HAM-10)
          (EATS TUNA OKRA-9)
          (CRAVES GRIEF-129 APPLE)
          (LOCALE BEEF-4 GUANABARA)
          (EATS POPOVER SCALLOP)
          (EATS LAMB-17 KALE)
          (CRAVES EXPECTATION-119 CUCUMBER)
          (CRAVES GRIEF-144 PEAR)
          (CRAVES JEALOUSY-493 POPOVER)
          (EATS CHICKEN-30 LETTUCE-16)
          (EATS YOGURT LOBSTER)
          (CRAVES PROSTATITIS-100 GRAPEFRUIT-58)
          (CRAVES LUBRICITY YOGURT-25)
          (EATS GUAVA-64 BAGUETTE-63)
          (EATS MUTTON-1 ARUGULA)
          (CRAVES HANGOVER-130 APPLE)
          (LOCALE POTATO-55 GUANABARA)
          (EATS MARZIPAN PAPAYA-27)
          (LOCALE LAMB-17 BAVARIA)
          (CRAVES BOILS-158 GRAPEFRUIT)
          (CRAVES LONELINESS-134 HAM)
          (EATS TOFU MUTTON)
          (CRAVES LACERATION-92 PEAR-60)
          (CRAVES ABRASION-415 GUAVA)
          (CRAVES ANGER-252 KALE-24)
          (CRAVES STIMULATION BAGUETTE-63)
          (CRAVES BOILS-249 YOGURT-25)
          (HARMONY EXCITEMENT-37 PLUTO)
          (CRAVES JEALOUSY-243 WURST-28)
          (CRAVES DEPRESSION-246 PAPAYA-27)
          (EATS LOBSTER SNICKERS)
          (LOCALE MARZIPAN GUANABARA)
          (EATS PISTACHIO BACON)
          (CRAVES LUBRICITY-42 PEPPER)
          (EATS MARZIPAN OKRA-9)
          (ATTACKS GUANABARA QUEBEC)
          (CRAVES JEALOUSY-476 PISTACHIO)
          (EATS PISTACHIO TOFU-20)
          (EATS MELON LEMON)
          (CRAVES DREAD-169 CHOCOLATE)
          (HARMONY EXPECTATION-45 URANUS)
          (HARMONY CURIOSITY-125 EARTH)
          (ATTACKS QUEBEC BAVARIA)
          (EATS LOBSTER BAGUETTE)
          (EATS KALE CANTELOPE)
          (CRAVES LONELINESS-449 CANTELOPE)
          (EATS POPOVER-14 RICE-32)
          (EATS RICE LOBSTER-12)
          (HARMONY EXPECTATION-112 EARTH)
          (EATS PAPAYA-27 KALE-24)
          (CRAVES JEALOUSY-427 SHRIMP)
          (EATS CANTELOPE YOGURT)
          (CRAVES LACERATION-162 PEA)
          (CRAVES ANGINA-469 CUCUMBER)
          (CRAVES PROSTATITIS-238 CHICKEN-30)
          (CRAVES ANGER-448 HAROSET)
          (CRAVES LACERATION-175 WURST)
          (EATS LEMON-53 PEPPER-52)
          (CRAVES LOVE CANTELOPE-29)
          (CRAVES DREAD-419 PAPAYA)
          (CRAVES ANXIETY-225 TURKEY-11)
          (EATS LEMON MELON)
          (EATS TOMATO-61 MARZIPAN-15)
          (EATS TUNA OKRA)
          (CRAVES ABRASION-248 YOGURT-25)
          (EATS TOMATO MARZIPAN)
          (EATS KALE ONION)
          (CRAVES LUBRICITY-111 SWEETROLL)
          (LOCALE LETTUCE QUEBEC)
          (CRAVES EXCITEMENT CHERRY-62)
          (LOCALE PEAR-60 QUEBEC)
          (CRAVES ANGINA-255 ENDIVE-22)
          (EATS ORANGE CUCUMBER)
          (EATS LAMB CHICKEN)
          (LOCALE PEAR KENTUCKY)
          (EATS RICE SCALLOP)
          (EATS WONDERBREAD-21 KALE-24)
          (EATS FLOUNDER HAROSET)
          (ATTACKS BAVARIA KENTUCKY)
          (LOCALE POTATO KENTUCKY)
          (EATS CANTELOPE-29 COD)
          (LOCALE WONDERBREAD-21 GUANABARA)
          (HARMONY AESTHETICS-116 EARTH)
          (HARMONY ACHIEVEMENT-47 EARTH)
          (EATS POTATO PEAR)
          (EATS WURST-28 RICE)
          (CRAVES SATIETY-122 PISTACHIO)
          (CRAVES REST WONDERBREAD-21)
          (EATS KALE-24 WONDERBREAD-21)
          (HARMONY STIMULATION EARTH)
          (LOCALE PORK-19 QUEBEC)
          (HARMONY LUBRICITY-42 EARTH)
          (CRAVES ANXIETY-468 CUCUMBER)
          (LOCALE LOBSTER-12 GUANABARA)
          (LOCALE COD-23 KENTUCKY)
          (CRAVES ABRASION-443 TUNA)
          (EATS HOTDOG ORANGE)
          (CRAVES EXPECTATION-45 SHRIMP-8)
          (CRAVES EMPATHY-36 APPLE)
          (EATS OKRA PEPPER)
          (CRAVES ANGER-231 OKRA-9)
          (EATS MARZIPAN TOMATO)
          (CRAVES CURIOSITY PEAR-60)
          (LOCALE GUAVA BAVARIA)
          (CRAVES PROSTATITIS-191 BROCCOLI-3)
          (LOCALE LOBSTER KENTUCKY)
          (CRAVES EMPATHY-113 LOBSTER)
          (HARMONY UNDERSTANDING PLUTO)
          (CRAVES ANXIETY-254 COD-23)
          (CRAVES HANGOVER-473 SCALLION)
          (EATS SNICKERS-59 RICE-32)
          (EATS ENDIVE CANTELOPE-29)
          (CRAVES UNDERSTANDING-41 BAGUETTE)
          (CRAVES ANGINA-228 HAM-10)
          (EATS PEPPER GUAVA)
          (EATS HAMBURGER-26 TURKEY-11)
          (EATS PEPPER-52 FLOUNDER-51)
          (EATS TURKEY-11 HAMBURGER-26)
          (CRAVES GRIEF-440 ONION)
          (EATS COD-23 POPOVER-14)
          (LOCALE LAMB QUEBEC)
          (CRAVES SATISFACTION-127 POPOVER)
          (CRAVES HANGOVER-239 CANTELOPE-29)
          (EATS TUNA HAM)
          (EATS RICE HAMBURGER)
          (CRAVES SCIATICA-224 TURKEY-11)
          (EATS SCALLOP-31 KALE-24)
          (CRAVES JEALOUSY-253 KALE-24)
          (CRAVES DREAD-135 HAM)
          (EATS PAPAYA-27 MARZIPAN)
          (LOCALE HAMBURGER-26 QUEBEC)
          (LOCALE MARZIPAN-15 KENTUCKY)
          (CRAVES GRIEF-171 CHOCOLATE)
          (HARMONY AESTHETICS-35 EARTH)
          (EATS LAMB WONDERBREAD)
          (CRAVES ABRASION-97 SNICKERS-59)
          (CRAVES LACERATION-436 LOBSTER)
          (EATS KALE YOGURT)
          (CRAVES SCIATICA-442 ONION)
          (CRAVES PROSTATITIS-183 SCALLOP)
          (EATS TOMATO TURKEY)
          (EATS SCALLION LETTUCE-16)
          (ORBITS JUPITER PLUTO)
          (CRAVES LEARNING-117 LAMB)
          (CRAVES DREAD-222 LOBSTER-12)
          (CRAVES SCIATICA-65 WONDERBREAD-21)
          (CRAVES JEALOUSY FLOUNDER-51)
          (EATS PEAR-60 PAPAYA-27)
          (EATS RICE-32 POPOVER-14)
          (CRAVES ANGER-214 MARZIPAN-15)
          (CRAVES SATIETY GUAVA-64)
          (EATS WONDERBREAD-21 TUNA)
          (EATS POTATO-55 LEMON)
          (EATS ORANGE MARZIPAN)
          (CRAVES LONELINESS-96 SNICKERS-59)
          (EATS CHERRY WURST)
          (EATS SNICKERS YOGURT-25)
          (EATS TUNA PEAR-60)
          (EATS CHICKEN POPOVER)
          (EATS ONION KALE)
          (CRAVES LONELINESS-418 PAPAYA)
          (EATS TUNA-54 LEMON-53)
          (HARMONY ENTERTAINMENT-123 PLUTO)
          (HARMONY TRIUMPH-49 PLUTO)
          (EATS COD CANTELOPE-29)
          (CRAVES SCIATICA-133 HAM)
          (EATS BEEF SWEETROLL)
          (HARMONY EMPATHY PLUTO)
          (CRAVES ANGER-470 CUCUMBER)
          (EATS HAMBURGER-26 FLOUNDER)
          (EATS CUCUMBER CHOCOLATE)
          (CRAVES ANXIETY-486 KALE)
          (CRAVES ABRASION-146 BACON)
          (CRAVES LONELINESS-426 SHRIMP)
          (HARMONY INTOXICATION PLUTO)
          (EATS APPLE COD)
          (CRAVES LOVE-39 GRAPEFRUIT)
          (LOCALE GRAPEFRUIT-58 BAVARIA)
          (CRAVES LACERATION-250 KALE-24)
          (HARMONY REST-124 PLUTO)
          (CRAVES ANGINA-107 ORANGE-56)
          (CRAVES ABRASION-234 RICE-32)
          (CRAVES BOILS-86 CHERRY-62)
          (EATS SCALLION WURST-28)
          (LOCALE HAROSET QUEBEC)
          (HARMONY LEARNING-117 PLUTO)
          (EATS PAPAYA-27 SCALLOP-31)
          (LOCALE ENDIVE BAVARIA)
          (CRAVES HANGOVER-431 YOGURT)
          (EATS LOBSTER-12 RICE)
          (EATS POTATO BROCCOLI-3)
          (EATS WONDERBREAD LAMB)
          (CRAVES DEPRESSION-195 SHRIMP-8)
          (EATS SWEETROLL MUTTON-1)
          (CRAVES JEALOUSY-142 PEAR)
          (LOCALE BAGUETTE QUEBEC)
          (CRAVES ACHIEVEMENT-121 BROCCOLI)
          (CRAVES BOILS-99 GRAPEFRUIT-58)
          (CRAVES AESTHETICS ORANGE-56)
          (CRAVES GRIEF-219 CHOCOLATE-13)
          (EATS PEPPER-52 PEA)
          (CRAVES PROSTATITIS-138 LETTUCE)
          (EATS CANTELOPE-29 ENDIVE)
          (HARMONY LEARNING-46 PLUTO)
          (CRAVES HANGOVER-78 GUAVA-64)
          (LOCALE TUNA KENTUCKY)
          (LOCALE TURKEY-11 GUANABARA)
          (HARMONY INTOXICATION-50 URANUS)
          (CRAVES DEPRESSION-149 BACON)
          (CRAVES BOILS POTATO-55)
          (EATS FLOUNDER-51 PEPPER-52)
          (LOCALE BACON QUEBEC)
          (EATS PEPPER-52 LEMON-53)
          (LOCALE PAPAYA GUANABARA)
          (CRAVES BOILS-502 ENDIVE)
          (CRAVES DEPRESSION-187 SWEETROLL-2)
          (EATS CHOCOLATE-13 SWEETROLL)
          (LOCALE HAMBURGER QUEBEC)
          (CRAVES GRIEF-488 WONDERBREAD)
          (EATS WONDERBREAD CHICKEN)
          (EATS APPLE-18 YOGURT)
          (LOCALE CHOCOLATE-13 BAVARIA)
          (CRAVES PROSTATITIS-245 WURST-28)
          (CRAVES EXCITEMENT-33 ENDIVE)
          (EATS MUFFIN-7 ORANGE-56)
          (EATS SCALLION-5 BAGUETTE)
          (CRAVES LONELINESS-85 CHERRY-62)
          (CRAVES ANGER-181 SCALLOP)
          (CRAVES DEPRESSION-482 MUFFIN)
          (EATS TURKEY-11 MARZIPAN)
          (CRAVES UNDERSTANDING-128 HAMBURGER)
          (EATS MUFFIN-7 CANTELOPE)
          (CRAVES DEPRESSION LEMON-53)
          (EATS MUFFIN-7 TUNA)
          (CRAVES HANGOVER-216 POPOVER-14)
          (CRAVES ANGER-229 HAM-10)
          (EATS YOGURT HAROSET)
          (CRAVES JEALOUSY-226 TURKEY-11)
          (CRAVES INTOXICATION WURST-28)
          (EATS MUTTON ENDIVE-22)
          (LOCALE BROCCOLI-3 BAVARIA)
          (EATS RICE-32 PEA)
          (LOCALE PAPAYA-27 GUANABARA)
          (LOCALE RICE QUEBEC)
          (CRAVES DEPRESSION-88 CHERRY-62)
          (EATS CHERRY PAPAYA-27)
          (CRAVES CURIOSITY-125 CHICKEN)
          (HARMONY UNDERSTANDING-41 PLUTO)
          (CRAVES GRIEF-192 SHRIMP-8)
          (EATS PEAR YOGURT)
          (CRAVES SCIATICA-512 HOTDOG)
          (CRAVES STIMULATION-118 LEMON)
          (LOCALE TOFU BAVARIA)
          (HARMONY LEARNING PLUTO)
          (EATS MELON CUCUMBER)
          (CRAVES LEARNING-46 SCALLION-5)
          (LOCALE YOGURT KENTUCKY)
          (EATS TUNA-54 FLOUNDER-51)
          (EATS CHERRY SCALLOP-31)
          (EATS CANTELOPE MUFFIN-7)
          (CRAVES ANGINA-445 TUNA)
          (LOCALE BAGUETTE-63 QUEBEC)
          (CRAVES BOILS-180 FLOUNDER)
          (CRAVES PROSTATITIS-71 APPLE-18)
          (CRAVES HANGOVER-145 PEAR)
          (CRAVES SCIATICA-91 TOMATO-61)
          (CRAVES BOILS-475 BROCCOLI)
          (EATS PORK-19 MUTTON)
          (EATS APPLE-18 MARZIPAN-15)
          (EATS SNICKERS-59 POTATO)
          (CRAVES DEPRESSION-218 POPOVER-14)
          (EATS POPOVER CHICKEN-30)
          (HARMONY AESTHETICS URANUS)
          (EATS PISTACHIO BROCCOLI-3)
          (LOCALE WURST-28 KENTUCKY)
          (LOCALE KALE-24 GUANABARA)
          (EATS OKRA-9 TUNA)
          (CRAVES INTOXICATION-110 PAPAYA)
          (CRAVES DEPRESSION-163 PEA)
          (EATS CUCUMBER LEMON)
          (EATS SHRIMP SHRIMP-8)
          (EATS CHICKEN BEEF-4)
          (CRAVES ANXIETY-153 CHERRY)
          (CRAVES ANGER-434 POTATO)
          (LOCALE PISTACHIO QUEBEC)
          (CRAVES ABRASION-198 CUCUMBER-6)
          (EATS BAGUETTE SCALLION-5)
          (EATS PISTACHIO RICE-32)
          (CRAVES ANXIETY-510 HOTDOG)
          (LOCALE FLOUNDER-51 KENTUCKY)
          (CRAVES LONELINESS-237 SCALLOP-31)
          (CRAVES REST-124 ARUGULA)
          (EATS PAPAYA SCALLION)
          (CRAVES GRIEF-464 PORK)
          (EATS MELON WONDERBREAD)
          (CRAVES JEALOUSY-433 POTATO)
          (EATS CUCUMBER ORANGE)
          (CRAVES GRIEF-156 CHERRY)
          (CRAVES JEALOUSY-196 SHRIMP-8)
          (CRAVES JEALOUSY-207 LETTUCE-16)
          (EATS MARZIPAN TURKEY-11)
          (EATS YOGURT KALE)
          (CRAVES DREAD-200 CUCUMBER-6)
          (EATS HAROSET HOTDOG)
          (CRAVES ANXIETY-444 TUNA)
          (HARMONY LOVE-115 URANUS)
          (EATS LOBSTER SWEETROLL)
          (CRAVES LONELINESS-147 BACON)
          (LOCALE SNICKERS-59 BAVARIA)
          (EATS POTATO-55 YOGURT-25)
          (EATS LETTUCE-16 CHICKEN-30)
          (CRAVES ANGINA-215 POPOVER-14)
          (CRAVES ANGINA-447 HAROSET)
          (EATS POTATO ARUGULA)
          (LOCALE LEMON-53 SURREY)
          (LOCALE RICE-32 QUEBEC)
          (EATS ARUGULA POTATO)
          (CRAVES LONELINESS-437 OKRA)
          (CRAVES ANGINA-154 CHERRY)
          (LOCALE PEPPER GUANABARA)
          (CRAVES DREAD-495 POPOVER)
          (LOCALE CANTELOPE KENTUCKY)
          (EATS CHICKEN LAMB)
          (EATS MARZIPAN ORANGE)
          (EATS HAMBURGER-26 ORANGE)
          (HARMONY STIMULATION-118 URANUS)
          (HARMONY UNDERSTANDING-128 URANUS)
          (EATS ARUGULA BAGUETTE)
          (EATS YOGURT-25 POTATO-55)
          (EATS LETTUCE-16 LOBSTER-12)
          (CRAVES ENTERTAINMENT POTATO-55)
          (LOCALE SCALLOP GUANABARA)
          (CRAVES BOILS-467 CUCUMBER)
          (CRAVES JEALOUSY-177 FLOUNDER)
          (CRAVES AESTHETICS-116 RICE)
          (CRAVES DREAD-232 OKRA-9)
          (EATS TUNA WURST)
          (EATS CHOCOLATE-13 ENDIVE-22)
          (EATS TOMATO-61 POTATO)
          (CRAVES LACERATION-481 MUFFIN)
          (CRAVES ANGER-104 HOTDOG-57)
          (LOCALE CHICKEN GUANABARA)
          (HARMONY LOVE-39 PLUTO)
          (CRAVES REST-40 CHOCOLATE)
          (CRAVES EXPECTATION FLOUNDER-51)
          (EATS LEMON APPLE)
          (EATS CANTELOPE PEAR)
          (EATS LAMB-17 HAROSET)
          (CRAVES SCIATICA-213 MARZIPAN-15)
          (HARMONY ACHIEVEMENT-121 EARTH)
          (EATS HAM TUNA)
          (EATS TOFU-20 POPOVER)
          (HARMONY ENTERTAINMENT-44 URANUS)
          (CRAVES ANGER PEPPER-52)
          (CRAVES ABRASION-506 SNICKERS)
          (EATS LETTUCE TURKEY)
          (CRAVES DREAD-67 TOFU-20)
          (EATS TOFU CUCUMBER-6)
          (CRAVES PROSTATITIS-206 SCALLION-5)
          (CRAVES BOILS-69 PORK-19)
          (EATS MUTTON COD)
          (EATS KALE LAMB-17)
          (CRAVES PROSTATITIS LEMON-53)
          (CRAVES ANXIETY-496 POPOVER)
          (CRAVES DREAD POTATO-55)
          (CRAVES HANGOVER-451 CANTELOPE)
          (CRAVES ANGER-166 BEEF)
          (HARMONY EXPECTATION URANUS)
          (LOCALE SHRIMP QUEBEC)
          (EATS ONION CHERRY)
          (EATS COD APPLE)
          (EATS PEPPER OKRA)
          (EATS BEEF-4 CHICKEN)
          (HARMONY ACHIEVEMENT URANUS)
          (EATS SHRIMP MARZIPAN)
          (CRAVES TRIUMPH-126 MUTTON)
          (EATS TUNA CANTELOPE)
          (CRAVES BOILS-136 LETTUCE)
          (CRAVES LACERATION-498 HAMBURGER)
          (HARMONY SATIETY-122 PLUTO)
          (CRAVES ANGINA FLOUNDER-51)
          (CRAVES SATISFACTION-109 GUAVA)
          (HARMONY SATIETY URANUS)
          (CRAVES JEALOUSY-89 TOMATO-61)
          (LOCALE ENDIVE-22 GUANABARA)
          (LOCALE MELON GUANABARA)
          (CRAVES SCIATICA-450 CANTELOPE)
          (EATS SWEETROLL LOBSTER)
          (CRAVES LACERATION-75 LAMB-17)
          (ORBITS EARTH URANUS)
          (EATS YOGURT-25 SNICKERS)
          (CRAVES HANGOVER-202 CUCUMBER-6)
          (EATS CHICKEN WONDERBREAD)
          (CRAVES LACERATION-209 LETTUCE-16)
          (CRAVES GRIEF-105 HOTDOG-57)
          (CRAVES INTOXICATION-50 SCALLOP-31)
          (CRAVES ANXIETY-84 BAGUETTE-63)
          (CRAVES LACERATION-428 SWEETROLL)
          (CRAVES ANGINA-500 ENDIVE)
          (EATS MARZIPAN-15 TOMATO-61)
          (CRAVES LONELINESS-179 FLOUNDER)
          (CRAVES ABRASION-72 APPLE-18)
          (EATS ORANGE HAMBURGER-26)
          (EATS TUNA WONDERBREAD-21)
          (EATS POPOVER PEA)
          (EATS HAM POTATO)
          (EATS POPOVER CHICKEN)
          (EATS CHOCOLATE GRAPEFRUIT)
          (CRAVES ANXIETY-454 RICE)
          (EATS LEMON CUCUMBER)
          (EATS HAROSET CHOCOLATE)
          (LOCALE WONDERBREAD GUANABARA)
          (CRAVES ANGER-76 GUAVA-64)
          (EATS BAGUETTE-63 WURST)
          (LOCALE BROCCOLI KENTUCKY)
          (CRAVES LACERATION-199 CUCUMBER-6)
          (EATS SCALLION POPOVER)
          (CRAVES ANGER-82 BAGUETTE-63)
          (CRAVES ANGER-497 HAMBURGER)
          (EATS YOGURT PEAR)
          (CRAVES INTOXICATION-114 ONION)
          (CRAVES HANGOVER PEPPER-52)
          (EATS PAPAYA HAMBURGER)
          (CRAVES LOVE-115 CANTELOPE)
          (CRAVES JEALOUSY-459 TOMATO)
          (CRAVES SCIATICA-73 LAMB-17)
          (EATS MUFFIN SWEETROLL-2)
          (EATS SHRIMP-8 SHRIMP)
          (EATS BAGUETTE HAM-10)
          (CRAVES DREAD-505 COD)
          (CRAVES SCIATICA-101 GRAPEFRUIT-58)
          (HARMONY EXCITEMENT-33 URANUS)
          (CRAVES LACERATION-223 LOBSTER-12)
          (EATS CANTELOPE-29 APPLE)
          (CRAVES SCIATICA-425 MARZIPAN)
          (EATS POPOVER-14 MUFFIN)
          (LOCALE TOFU-20 KENTUCKY))
   (:GOAL (AND (CRAVES DEPRESSION-438 BAGUETTE)
               (CRAVES LONELINESS-437 RICE-32)
               (CRAVES BOILS-439 RICE-32)
               (CRAVES ANGER-470 RICE-32)
               (CRAVES ANGINA-469 RICE-32)
               (CRAVES JEALOUSY-466 RICE-32)
               (CRAVES BOILS-475 RICE-32)
               (CRAVES HANGOVER-94 RICE-32)
               (CRAVES ANXIETY-95 RICE-32)
               (CRAVES LACERATION-92 TOMATO)
               (CRAVES BOILS-167 TOMATO))))

(DEFINE (PROBLEM STRIPS-MYSTY-40)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS SCALLOP-53 TUNA-54 APPLE-55 SCALLION-56 TOFU-57
             ARUGULA-58 ONION-59 LETTUCE-60 HOTDOG-61 HAROSET-62 PEPPER-63
             WURST-64 COD-17 HAMBURGER-18 PORK-19 TURKEY-20 CHICKEN-21
             ORANGE-22 TOMATO-23 BAGUETTE-24 YOGURT-25 POTATO-26 MUTTON-27
             GUAVA-28 BACON-29 MUFFIN-30 HAM-31 BEEF-32 ENDIVE-9
             CANTELOPE-10 PEA-11 CHOCOLATE-12 LAMB-13 CHERRY-14 LEMON-15
             KALE-16 SHRIMP-5 FLOUNDER-6 PISTACHIO-7 OKRA-8 SNICKERS-3
             GRAPEFRUIT-4 PEAR-1 MARZIPAN-2 SWEETROLL LOBSTER LEMON ORANGE COD
             ARUGULA CANTELOPE PISTACHIO HAM OKRA LAMB SNICKERS KALE
             MARZIPAN TOFU YOGURT WURST SCALLION HAMBURGER CHERRY LETTUCE
             PAPAYA GUAVA POPOVER POTATO CHICKEN PEA CUCUMBER MELON ONION
             TUNA HAROSET BROCCOLI APPLE HOTDOG PORK BACON WONDERBREAD
             BAGUETTE CHOCOLATE RICE SHRIMP MUFFIN TURKEY SCALLOP FLOUNDER
             GRAPEFRUIT PEPPER PEAR BEEF TOMATO MUTTON ENDIVE INTOXICATION
             LEARNING EXCITEMENT LUBRICITY SATIETY LOVE REST ENTERTAINMENT
             EXPECTATION TRIUMPH UNDERSTANDING EMPATHY STIMULATION AESTHETICS
             SATISFACTION ACHIEVEMENT CURIOSITY EXPECTATION-52 LEARNING-51
             LOVE-50 ENTERTAINMENT-49 UNDERSTANDING-48 SATIETY-47
             ACHIEVEMENT-46 AESTHETICS-45 STIMULATION-44 CURIOSITY-43
             SATISFACTION-42 EMPATHY-41 INTOXICATION-40 LUBRICITY-39 TRIUMPH-38
             EXCITEMENT-37 REST-36 INTOXICATION-35 SATISFACTION-34 LEARNING-33
             CURIOSITY-128 LUBRICITY-127 AESTHETICS-126 ACHIEVEMENT-125
             LOVE-124 EXPECTATION-123 SATIETY-122 EMPATHY-121 TRIUMPH-120
             ENTERTAINMENT-119 EXCITEMENT-118 UNDERSTANDING-117 REST-116
             STIMULATION-115 LUBRICITY-114 AESTHETICS-113 TRIUMPH-112 LONELINESS
             HANGOVER ANGINA PROSTATITIS BOILS DREAD SCIATICA GRIEF
             DEPRESSION ANXIETY JEALOUSY ABRASION LACERATION PROSTATITIS-111
             ANGER HANGOVER-110 DEPRESSION-109 DREAD-107 ANGER-108
             ANGINA-106 LACERATION-105 JEALOUSY-103 ANXIETY-104 BOILS-102
             GRIEF-101 LONELINESS-99 SCIATICA-100 ABRASION-97 ABRASION-98
             BOILS-96 DREAD-95 GRIEF-93 JEALOUSY-94 SCIATICA-91
             PROSTATITIS-92 LACERATION-89 ANGER-90 DEPRESSION-88 ANXIETY-86
             LONELINESS-87 ANGINA-85 GRIEF-83 HANGOVER-84 ANXIETY-82
             DEPRESSION-80 LACERATION-81 JEALOUSY-79 LONELINESS-77 BOILS-78
             HANGOVER-75 PROSTATITIS-76 ABRASION-74 SCIATICA-72 DREAD-73
             ANGINA-71 ANGER-70 ANGER-68 ANGINA-69 GRIEF-66 PROSTATITIS-67
             DREAD-256 ABRASION-65 SCIATICA-255 DEPRESSION-254
             HANGOVER-252 LONELINESS-253 LACERATION-250 BOILS-251 ANXIETY-249
             ANXIETY-247 JEALOUSY-248 SCIATICA-246 BOILS-245 LONELINESS-243
             ANGER-244 LACERATION-242 HANGOVER-240 ANGINA-241 ABRASION-239
             MANITOBA ALSACE GUANABARA BOSNIA OREGON KENTUCKY PENNSYLVANIA
             BAVARIA MORAVIA GOIAS QUEBEC SURREY MERCURY JUPITER VULCAN MARS)
   (:INIT (FOOD SCALLOP-53)
          (FOOD TUNA-54)
          (FOOD APPLE-55)
          (FOOD SCALLION-56)
          (FOOD TOFU-57)
          (FOOD ARUGULA-58)
          (FOOD ONION-59)
          (FOOD LETTUCE-60)
          (FOOD HOTDOG-61)
          (FOOD HAROSET-62)
          (FOOD PEPPER-63)
          (FOOD WURST-64)
          (FOOD COD-17)
          (FOOD HAMBURGER-18)
          (FOOD PORK-19)
          (FOOD TURKEY-20)
          (FOOD CHICKEN-21)
          (FOOD ORANGE-22)
          (FOOD TOMATO-23)
          (FOOD BAGUETTE-24)
          (FOOD YOGURT-25)
          (FOOD POTATO-26)
          (FOOD MUTTON-27)
          (FOOD GUAVA-28)
          (FOOD BACON-29)
          (FOOD MUFFIN-30)
          (FOOD HAM-31)
          (FOOD BEEF-32)
          (FOOD ENDIVE-9)
          (FOOD CANTELOPE-10)
          (FOOD PEA-11)
          (FOOD CHOCOLATE-12)
          (FOOD LAMB-13)
          (FOOD CHERRY-14)
          (FOOD LEMON-15)
          (FOOD KALE-16)
          (FOOD SHRIMP-5)
          (FOOD FLOUNDER-6)
          (FOOD PISTACHIO-7)
          (FOOD OKRA-8)
          (FOOD SNICKERS-3)
          (FOOD GRAPEFRUIT-4)
          (FOOD PEAR-1)
          (FOOD MARZIPAN-2)
          (FOOD SWEETROLL)
          (FOOD LOBSTER)
          (FOOD LEMON)
          (FOOD ORANGE)
          (FOOD COD)
          (FOOD ARUGULA)
          (FOOD CANTELOPE)
          (FOOD PISTACHIO)
          (FOOD HAM)
          (FOOD OKRA)
          (FOOD LAMB)
          (FOOD SNICKERS)
          (FOOD KALE)
          (FOOD MARZIPAN)
          (FOOD TOFU)
          (FOOD YOGURT)
          (FOOD WURST)
          (FOOD SCALLION)
          (FOOD HAMBURGER)
          (FOOD CHERRY)
          (FOOD LETTUCE)
          (FOOD PAPAYA)
          (FOOD GUAVA)
          (FOOD POPOVER)
          (FOOD POTATO)
          (FOOD CHICKEN)
          (FOOD PEA)
          (FOOD CUCUMBER)
          (FOOD MELON)
          (FOOD ONION)
          (FOOD TUNA)
          (FOOD HAROSET)
          (FOOD BROCCOLI)
          (FOOD APPLE)
          (FOOD HOTDOG)
          (FOOD PORK)
          (FOOD BACON)
          (FOOD WONDERBREAD)
          (FOOD BAGUETTE)
          (FOOD CHOCOLATE)
          (FOOD RICE)
          (FOOD SHRIMP)
          (FOOD MUFFIN)
          (FOOD TURKEY)
          (FOOD SCALLOP)
          (FOOD FLOUNDER)
          (FOOD GRAPEFRUIT)
          (FOOD PEPPER)
          (FOOD PEAR)
          (FOOD BEEF)
          (FOOD TOMATO)
          (FOOD MUTTON)
          (FOOD ENDIVE)
          (PLEASURE INTOXICATION)
          (PLEASURE LEARNING)
          (PLEASURE EXCITEMENT)
          (PLEASURE LUBRICITY)
          (PLEASURE SATIETY)
          (PLEASURE LOVE)
          (PLEASURE REST)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE EXPECTATION)
          (PLEASURE TRIUMPH)
          (PLEASURE UNDERSTANDING)
          (PLEASURE EMPATHY)
          (PLEASURE STIMULATION)
          (PLEASURE AESTHETICS)
          (PLEASURE SATISFACTION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE CURIOSITY)
          (PLEASURE EXPECTATION-52)
          (PLEASURE LEARNING-51)
          (PLEASURE LOVE-50)
          (PLEASURE ENTERTAINMENT-49)
          (PLEASURE UNDERSTANDING-48)
          (PLEASURE SATIETY-47)
          (PLEASURE ACHIEVEMENT-46)
          (PLEASURE AESTHETICS-45)
          (PLEASURE STIMULATION-44)
          (PLEASURE CURIOSITY-43)
          (PLEASURE SATISFACTION-42)
          (PLEASURE EMPATHY-41)
          (PLEASURE INTOXICATION-40)
          (PLEASURE LUBRICITY-39)
          (PLEASURE TRIUMPH-38)
          (PLEASURE EXCITEMENT-37)
          (PLEASURE REST-36)
          (PLEASURE INTOXICATION-35)
          (PLEASURE SATISFACTION-34)
          (PLEASURE LEARNING-33)
          (PLEASURE CURIOSITY-128)
          (PLEASURE LUBRICITY-127)
          (PLEASURE AESTHETICS-126)
          (PLEASURE ACHIEVEMENT-125)
          (PLEASURE LOVE-124)
          (PLEASURE EXPECTATION-123)
          (PLEASURE SATIETY-122)
          (PLEASURE EMPATHY-121)
          (PLEASURE TRIUMPH-120)
          (PLEASURE ENTERTAINMENT-119)
          (PLEASURE EXCITEMENT-118)
          (PLEASURE UNDERSTANDING-117)
          (PLEASURE REST-116)
          (PLEASURE STIMULATION-115)
          (PLEASURE LUBRICITY-114)
          (PLEASURE AESTHETICS-113)
          (PLEASURE TRIUMPH-112)
          (PAIN LONELINESS)
          (PAIN HANGOVER)
          (PAIN ANGINA)
          (PAIN PROSTATITIS)
          (PAIN BOILS)
          (PAIN DREAD)
          (PAIN SCIATICA)
          (PAIN GRIEF)
          (PAIN DEPRESSION)
          (PAIN ANXIETY)
          (PAIN JEALOUSY)
          (PAIN ABRASION)
          (PAIN LACERATION)
          (PAIN PROSTATITIS-111)
          (PAIN ANGER)
          (PAIN HANGOVER-110)
          (PAIN DEPRESSION-109)
          (PAIN DREAD-107)
          (PAIN ANGER-108)
          (PAIN ANGINA-106)
          (PAIN LACERATION-105)
          (PAIN JEALOUSY-103)
          (PAIN ANXIETY-104)
          (PAIN BOILS-102)
          (PAIN GRIEF-101)
          (PAIN LONELINESS-99)
          (PAIN SCIATICA-100)
          (PAIN ABRASION-97)
          (PAIN ABRASION-98)
          (PAIN BOILS-96)
          (PAIN DREAD-95)
          (PAIN GRIEF-93)
          (PAIN JEALOUSY-94)
          (PAIN SCIATICA-91)
          (PAIN PROSTATITIS-92)
          (PAIN LACERATION-89)
          (PAIN ANGER-90)
          (PAIN DEPRESSION-88)
          (PAIN ANXIETY-86)
          (PAIN LONELINESS-87)
          (PAIN ANGINA-85)
          (PAIN GRIEF-83)
          (PAIN HANGOVER-84)
          (PAIN ANXIETY-82)
          (PAIN DEPRESSION-80)
          (PAIN LACERATION-81)
          (PAIN JEALOUSY-79)
          (PAIN LONELINESS-77)
          (PAIN BOILS-78)
          (PAIN HANGOVER-75)
          (PAIN PROSTATITIS-76)
          (PAIN ABRASION-74)
          (PAIN SCIATICA-72)
          (PAIN DREAD-73)
          (PAIN ANGINA-71)
          (PAIN ANGER-70)
          (PAIN ANGER-68)
          (PAIN ANGINA-69)
          (PAIN GRIEF-66)
          (PAIN PROSTATITIS-67)
          (PAIN DREAD-256)
          (PAIN ABRASION-65)
          (PAIN SCIATICA-255)
          (PAIN DEPRESSION-254)
          (PAIN HANGOVER-252)
          (PAIN LONELINESS-253)
          (PAIN LACERATION-250)
          (PAIN BOILS-251)
          (PAIN ANXIETY-249)
          (PAIN ANXIETY-247)
          (PAIN JEALOUSY-248)
          (PAIN SCIATICA-246)
          (PAIN BOILS-245)
          (PAIN LONELINESS-243)
          (PAIN ANGER-244)
          (PAIN LACERATION-242)
          (PAIN HANGOVER-240)
          (PAIN ANGINA-241)
          (PAIN ABRASION-239)
          (PROVINCE MANITOBA)
          (PROVINCE ALSACE)
          (PROVINCE GUANABARA)
          (PROVINCE BOSNIA)
          (PROVINCE OREGON)
          (PROVINCE KENTUCKY)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PROVINCE GOIAS)
          (PROVINCE QUEBEC)
          (PROVINCE SURREY)
          (PLANET MERCURY)
          (PLANET JUPITER)
          (PLANET VULCAN)
          (PLANET MARS)
          (EATS ONION APPLE)
          (CRAVES SCIATICA-255 APPLE)
          (LOCALE BROCCOLI MORAVIA)
          (EATS SNICKERS TOFU)
          (CRAVES EXCITEMENT ARUGULA-58)
          (LOCALE TOMATO BOSNIA)
          (EATS TUNA-54 MUFFIN)
          (HARMONY LEARNING-33 JUPITER)
          (EATS CHERRY-14 PEAR)
          (CRAVES SATIETY-47 PISTACHIO-7)
          (EATS SNICKERS-3 TURKEY-20)
          (EATS PORK-19 HAROSET)
          (EATS APPLE SHRIMP)
          (CRAVES ANGINA-85 PISTACHIO)
          (EATS TOMATO MARZIPAN-2)
          (LOCALE TOFU PENNSYLVANIA)
          (EATS TUNA LETTUCE)
          (CRAVES UNDERSTANDING-48 FLOUNDER-6)
          (CRAVES HANGOVER APPLE-55)
          (EATS TUNA SHRIMP)
          (EATS BROCCOLI PEAR)
          (EATS OKRA SCALLOP)
          (EATS HAM CANTELOPE-10)
          (EATS LOBSTER SHRIMP)
          (EATS KALE PEPPER)
          (EATS GRAPEFRUIT-4 BAGUETTE-24)
          (EATS POTATO LAMB)
          (EATS CHICKEN POTATO)
          (EATS TOMATO MUTTON-27)
          (EATS FLOUNDER-6 TUNA)
          (CRAVES ANGINA-71 POTATO)
          (LOCALE BACON-29 PENNSYLVANIA)
          (CRAVES JEALOUSY-103 CANTELOPE-10)
          (EATS BEEF KALE-16)
          (LOCALE TOFU-57 PENNSYLVANIA)
          (LOCALE LEMON GUANABARA)
          (HARMONY STIMULATION-115 VULCAN)
          (EATS HAM-31 MUFFIN-30)
          (LOCALE MELON OREGON)
          (CRAVES LONELINESS APPLE-55)
          (HARMONY UNDERSTANDING-117 JUPITER)
          (EATS PEA BROCCOLI)
          (CRAVES ANGER-68 CUCUMBER)
          (HARMONY UNDERSTANDING-48 MARS)
          (CRAVES AESTHETICS-113 BEEF)
          (LOCALE LAMB GUANABARA)
          (HARMONY INTOXICATION VULCAN)
          (CRAVES ANGINA-106 GUAVA-28)
          (LOCALE CUCUMBER KENTUCKY)
          (EATS HAROSET LEMON-15)
          (EATS PISTACHIO-7 MUTTON-27)
          (EATS TOFU LAMB)
          (EATS MUFFIN-30 CHERRY-14)
          (EATS SCALLOP OKRA)
          (HARMONY EXPECTATION MARS)
          (LOCALE SCALLION-56 BOSNIA)
          (CRAVES ANGER-70 CHICKEN)
          (CRAVES SATIETY-122 HOTDOG)
          (EATS CUCUMBER SCALLION)
          (CRAVES LONELINESS-253 WONDERBREAD)
          (EATS APPLE TUNA)
          (EATS HAROSET HAM)
          (EATS CANTELOPE-10 PAPAYA)
          (EATS PEA MUTTON-27)
          (EATS CUCUMBER YOGURT-25)
          (HARMONY LEARNING MARS)
          (CRAVES LUBRICITY-39 MARZIPAN)
          (EATS BAGUETTE-24 GRAPEFRUIT-4)
          (EATS CHOCOLATE-12 WURST)
          (HARMONY CURIOSITY-43 MARS)
          (CRAVES DREAD-73 POPOVER)
          (EATS KALE-16 BEEF)
          (LOCALE ONION-59 OREGON)
          (CRAVES HANGOVER-75 WURST)
          (EATS TOMATO COD)
          (EATS POTATO-26 COD-17)
          (LOCALE MUTTON-27 MANITOBA)
          (HARMONY CURIOSITY-128 VULCAN)
          (LOCALE KALE KENTUCKY)
          (EATS PEAR LAMB-13)
          (CRAVES LOVE-50 LAMB-13)
          (CRAVES INTOXICATION-35 PAPAYA)
          (CRAVES JEALOUSY HAMBURGER-18)
          (CRAVES CURIOSITY-43 MARZIPAN-2)
          (EATS SHRIMP LOBSTER)
          (LOCALE GRAPEFRUIT-4 KENTUCKY)
          (EATS SWEETROLL SNICKERS)
          (CRAVES SATISFACTION-34 GUAVA)
          (EATS FLOUNDER-6 ARUGULA-58)
          (LOCALE LAMB-13 KENTUCKY)
          (CRAVES HANGOVER-110 YOGURT-25)
          (EATS PEPPER KALE)
          (LOCALE HAROSET-62 OREGON)
          (LOCALE PORK BOSNIA)
          (EATS GRAPEFRUIT-4 LEMON-15)
          (HARMONY ENTERTAINMENT-119 VULCAN)
          (LOCALE KALE-16 PENNSYLVANIA)
          (EATS TUNA COD-17)
          (EATS TUNA-54 CANTELOPE-10)
          (EATS ORANGE BAGUETTE)
          (EATS MUFFIN-30 HAM-31)
          (LOCALE BEEF-32 PENNSYLVANIA)
          (EATS YOGURT-25 MUFFIN-30)
          (EATS APPLE LEMON)
          (EATS MUFFIN LEMON-15)
          (CRAVES DEPRESSION-80 SNICKERS)
          (EATS PEAR CHERRY-14)
          (LOCALE FLOUNDER PENNSYLVANIA)
          (EATS TUNA FLOUNDER-6)
          (HARMONY EMPATHY-121 JUPITER)
          (EATS GRAPEFRUIT-4 CHICKEN-21)
          (EATS GRAPEFRUIT-4 SCALLOP)
          (CRAVES GRIEF-101 LAMB-13)
          (EATS SHRIMP-5 OKRA)
          (CRAVES DREAD-256 HAROSET)
          (HARMONY AESTHETICS-45 JUPITER)
          (EATS POTATO ORANGE-22)
          (CRAVES ACHIEVEMENT BEEF-32)
          (EATS HAROSET-62 HAM)
          (CRAVES ACHIEVEMENT-46 SNICKERS-3)
          (EATS ARUGULA-58 FLOUNDER-6)
          (EATS LOBSTER ORANGE)
          (LOCALE CHOCOLATE-12 MORAVIA)
          (EATS HAM CHICKEN)
          (HARMONY EXCITEMENT-118 MARS)
          (EATS BEEF LETTUCE)
          (EATS PEAR HAROSET)
          (CRAVES AESTHETICS-126 ONION)
          (EATS CANTELOPE SNICKERS-3)
          (EATS SCALLOP GRAPEFRUIT-4)
          (EATS CHERRY PORK)
          (CRAVES LACERATION TURKEY-20)
          (CRAVES EXCITEMENT-118 CHOCOLATE)
          (EATS CANTELOPE-10 TUNA-54)
          (CRAVES ABRASION-97 SHRIMP-5)
          (EATS TUNA KALE-16)
          (LOCALE OKRA BOSNIA)
          (EATS LOBSTER ARUGULA-58)
          (CRAVES GRIEF-83 HAM)
          (CRAVES GRIEF-66 ONION)
          (EATS PEPPER MUFFIN)
          (EATS SCALLOP-53 RICE)
          (EATS PEAR BEEF-32)
          (EATS HAROSET-62 HAMBURGER-18)
          (EATS GUAVA-28 LEMON-15)
          (CRAVES BOILS-96 FLOUNDER-6)
          (CRAVES LEARNING SCALLION-56)
          (EATS FLOUNDER GRAPEFRUIT)
          (EATS PEPPER-63 RICE)
          (EATS KALE BAGUETTE)
          (EATS CHERRY MARZIPAN)
          (HARMONY ENTERTAINMENT-49 JUPITER)
          (HARMONY AESTHETICS-113 MARS)
          (CRAVES DEPRESSION-88 LEMON)
          (CRAVES LEARNING-33 POPOVER)
          (EATS SWEETROLL PEPPER)
          (EATS PAPAYA ORANGE-22)
          (EATS SNICKERS SWEETROLL)
          (EATS PISTACHIO-7 TOMATO)
          (EATS HOTDOG-61 RICE)
          (EATS ENDIVE-9 LETTUCE-60)
          (ATTACKS OREGON KENTUCKY)
          (CRAVES CURIOSITY CANTELOPE-10)
          (HARMONY LOVE MARS)
          (LOCALE HAM-31 GUANABARA)
          (ATTACKS MANITOBA ALSACE)
          (HARMONY AESTHETICS JUPITER)
          (HARMONY REST-116 JUPITER)
          (EATS LEMON-15 GRAPEFRUIT-4)
          (HARMONY SATIETY-47 JUPITER)
          (LOCALE WURST OREGON)
          (EATS TOFU OKRA-8)
          (EATS RICE SCALLOP-53)
          (CRAVES LUBRICITY-114 PEAR)
          (LOCALE BEEF PENNSYLVANIA)
          (LOCALE HOTDOG MANITOBA)
          (CRAVES LUBRICITY-127 CUCUMBER)
          (LOCALE ARUGULA BOSNIA)
          (CRAVES ANXIETY COD-17)
          (EATS CHICKEN PAPAYA)
          (EATS HAMBURGER-18 PORK-19)
          (EATS PEPPER APPLE)
          (CRAVES SCIATICA-91 PEAR-1)
          (EATS LAMB POTATO)
          (HARMONY SATISFACTION MARS)
          (EATS FLOUNDER HAMBURGER-18)
          (CRAVES ANXIETY-104 CANTELOPE-10)
          (CRAVES BOILS-102 PEA-11)
          (HARMONY INTOXICATION-40 MARS)
          (HARMONY LUBRICITY JUPITER)
          (EATS MARZIPAN TOFU-57)
          (EATS PEAR POPOVER)
          (HARMONY LOVE-50 JUPITER)
          (CRAVES DREAD-107 MUTTON-27)
          (LOCALE TOMATO-23 ALSACE)
          (EATS LEMON HOTDOG)
          (EATS ARUGULA-58 LOBSTER)
          (LOCALE BACON MANITOBA)
          (LOCALE HAM MORAVIA)
          (EATS KALE SHRIMP)
          (LOCALE PEPPER PENNSYLVANIA)
          (HARMONY EXCITEMENT-37 JUPITER)
          (EATS CHICKEN GUAVA)
          (LOCALE LOBSTER GUANABARA)
          (EATS YOGURT BEEF)
          (CRAVES STIMULATION-44 PEAR-1)
          (CRAVES ANGER-108 MUTTON-27)
          (LOCALE POTATO-26 BOSNIA)
          (LOCALE BAGUETTE-24 ALSACE)
          (EATS MELON GUAVA)
          (HARMONY INTOXICATION-35 VULCAN)
          (LOCALE CHERRY QUEBEC)
          (LOCALE GUAVA ALSACE)
          (LOCALE YOGURT MANITOBA)
          (EATS CHERRY BROCCOLI)
          (EATS CUCUMBER GRAPEFRUIT)
          (EATS PEAR-1 COD)
          (EATS PEPPER-63 LAMB-13)
          (HARMONY ACHIEVEMENT VULCAN)
          (EATS COD PEAR-1)
          (EATS HAM GUAVA-28)
          (CRAVES ABRASION-74 PAPAYA)
          (EATS TOFU SNICKERS)
          (LOCALE BAGUETTE BOSNIA)
          (EATS PEA-11 PEAR)
          (EATS APPLE APPLE-55)
          (LOCALE TURKEY MORAVIA)
          (EATS POTATO CHICKEN)
          (CRAVES ANGINA-241 MUTTON)
          (CRAVES TRIUMPH-38 WURST)
          (EATS CANTELOPE-10 HAM)
          (EATS RICE HOTDOG-61)
          (CRAVES EXPECTATION-123 APPLE)
          (EATS BAGUETTE-24 MUFFIN)
          (CRAVES DEPRESSION-109 POTATO-26)
          (EATS BAGUETTE ENDIVE)
          (LOCALE ENDIVE MANITOBA)
          (EATS TUNA BAGUETTE)
          (EATS SCALLION CUCUMBER)
          (EATS CHICKEN HAM)
          (CRAVES HANGOVER-240 MUTTON)
          (EATS SCALLION-56 CANTELOPE)
          (EATS POTATO WURST-64)
          (EATS GUAVA-28 HAM)
          (EATS HAM HAROSET-62)
          (HARMONY ACHIEVEMENT-46 JUPITER)
          (EATS ARUGULA MUTTON)
          (CRAVES EXCITEMENT-37 CHERRY)
          (EATS ENDIVE BAGUETTE)
          (EATS ONION SCALLOP)
          (LOCALE OKRA-8 MANITOBA)
          (CRAVES INTOXICATION-40 SNICKERS)
          (ATTACKS KENTUCKY PENNSYLVANIA)
          (HARMONY EXPECTATION-52 VULCAN)
          (EATS MELON FLOUNDER)
          (EATS MELON ENDIVE)
          (CRAVES SCIATICA PEPPER-63)
          (EATS WONDERBREAD BEEF-32)
          (EATS PORK SNICKERS-3)
          (EATS WURST CHOCOLATE-12)
          (EATS CHOCOLATE ENDIVE-9)
          (EATS TURKEY PORK)
          (EATS PORK CHERRY)
          (LOCALE SHRIMP-5 MANITOBA)
          (HARMONY LOVE-124 MARS)
          (LOCALE CHICKEN-21 BAVARIA)
          (EATS APPLE-55 MUFFIN)
          (CRAVES ENTERTAINMENT-119 BAGUETTE)
          (EATS BACON-29 OKRA)
          (EATS LAMB ONION-59)
          (CRAVES UNDERSTANDING ORANGE-22)
          (EATS TOFU-57 MARZIPAN)
          (EATS KALE-16 TUNA)
          (HARMONY EXPECTATION-123 VULCAN)
          (EATS WONDERBREAD HOTDOG-61)
          (EATS POPOVER SCALLOP)
          (LOCALE SCALLION ALSACE)
          (CRAVES ANGER-90 MARZIPAN-2)
          (CRAVES LACERATION-89 MARZIPAN-2)
          (EATS HAMBURGER WURST-64)
          (EATS BACON SCALLOP)
          (HARMONY SATIETY MARS)
          (EATS PORK TURKEY)
          (CRAVES ANGER-244 BEEF)
          (EATS WURST-64 HAMBURGER)
          (EATS TOFU-57 MARZIPAN-2)
          (CRAVES JEALOUSY-248 MUFFIN)
          (CRAVES PROSTATITIS-76 WURST)
          (EATS HAM-31 SCALLION)
          (CRAVES BOILS-251 CHOCOLATE)
          (EATS RICE PORK)
          (EATS WURST BAGUETTE)
          (CRAVES ANXIETY-247 MUFFIN)
          (LOCALE PEA-11 GOIAS)
          (EATS PAPAYA CANTELOPE-10)
          (EATS CHERRY-14 MUFFIN-30)
          (EATS MARZIPAN CHERRY)
          (EATS MARZIPAN-2 TOMATO)
          (LOCALE ORANGE MANITOBA)
          (EATS MUFFIN APPLE-55)
          (EATS MUFFIN TUNA-54)
          (EATS MARZIPAN-2 TOFU-57)
          (CRAVES LACERATION-250 CHOCOLATE)
          (CRAVES BOILS-245 SCALLOP)
          (EATS PEA-11 CANTELOPE)
          (EATS CHOCOLATE TURKEY)
          (CRAVES EXPECTATION-52 PEA-11)
          (LOCALE ENDIVE-9 MANITOBA)
          (EATS OKRA SHRIMP-5)
          (CRAVES ENTERTAINMENT-49 SHRIMP-5)
          (LOCALE POTATO GUANABARA)
          (EATS GRAPEFRUIT FLOUNDER)
          (EATS ORANGE-22 PAPAYA)
          (CRAVES SCIATICA-72 POPOVER)
          (ORBITS JUPITER VULCAN)
          (LOCALE MARZIPAN-2 GUANABARA)
          (CRAVES ABRASION-98 SHRIMP-5)
          (CRAVES LACERATION-105 BACON-29)
          (EATS ENDIVE MELON)
          (LOCALE HOTDOG-61 MANITOBA)
          (EATS HAROSET-62 FLOUNDER)
          (EATS MUTTON PISTACHIO)
          (EATS CHOCOLATE-12 PEPPER)
          (LOCALE PEAR GOIAS)
          (EATS LEMON-15 GUAVA-28)
          (CRAVES DEPRESSION COD-17)
          (CRAVES BOILS-78 YOGURT)
          (EATS LEMON-15 MUFFIN)
          (EATS WURST TOFU)
          (HARMONY STIMULATION-44 VULCAN)
          (EATS ENDIVE HAMBURGER)
          (LOCALE HAMBURGER GUANABARA)
          (EATS CANTELOPE SCALLION-56)
          (CRAVES LOVE HOTDOG-61)
          (EATS LAMB-13 PEAR)
          (EATS PEA-11 LAMB-13)
          (EATS GRAPEFRUIT LEMON)
          (EATS TOMATO PISTACHIO-7)
          (EATS HAM-31 HAROSET)
          (EATS SCALLION HAM-31)
          (EATS PISTACHIO MUTTON)
          (EATS APPLE PEPPER)
          (EATS BAGUETTE FLOUNDER-6)
          (EATS PEPPER SWEETROLL)
          (LOCALE SCALLOP-53 PENNSYLVANIA)
          (HARMONY TRIUMPH-112 JUPITER)
          (CRAVES DREAD ONION-59)
          (CRAVES EMPATHY-121 PORK)
          (EATS APPLE ONION)
          (EATS COD-17 ONION)
          (EATS ONION COD-17)
          (EATS FLOUNDER MELON)
          (LOCALE RICE KENTUCKY)
          (CRAVES PROSTATITIS-67 ONION)
          (HARMONY SATISFACTION-42 JUPITER)
          (CRAVES SCIATICA-246 TURKEY)
          (EATS COD-17 POTATO-26)
          (EATS BROCCOLI CHERRY)
          (HARMONY TRIUMPH-120 JUPITER)
          (EATS LAMB-13 PEPPER-63)
          (EATS PAPAYA CHICKEN)
          (EATS ONION-59 LAMB)
          (EATS POTATO-26 SCALLOP)
          (EATS COD-17 TUNA)
          (LOCALE PISTACHIO MANITOBA)
          (LOCALE ONION BOSNIA)
          (CRAVES SCIATICA-100 KALE-16)
          (CRAVES ACHIEVEMENT-125 TUNA)
          (LOCALE PEAR-1 GUANABARA)
          (ATTACKS GUANABARA BOSNIA)
          (EATS PORK LETTUCE-60)
          (LOCALE PEPPER-63 BAVARIA)
          (HARMONY TRIUMPH MARS)
          (LOCALE HAROSET BOSNIA)
          (EATS MUTTON-27 BACON)
          (EATS ARUGULA CHOCOLATE)
          (EATS TURKEY PEAR-1)
          (EATS BROCCOLI PEA)
          (LOCALE SCALLOP ALSACE)
          (EATS HAROSET PORK-19)
          (EATS SHRIMP APPLE)
          (LOCALE COD OREGON)
          (CRAVES JEALOUSY-79 KALE)
          (EATS RICE MUTTON)
          (CRAVES TRIUMPH HAMBURGER-18)
          (EATS HAMBURGER-18 FLOUNDER)
          (EATS WURST-64 POTATO)
          (CRAVES EMPATHY TOMATO-23)
          (EATS SHRIMP TUNA)
          (EATS MUFFIN TOMATO-23)
          (EATS BACON-29 POPOVER)
          (EATS BEEF-32 PEAR)
          (CRAVES PROSTATITIS-111 BAGUETTE-24)
          (CRAVES JEALOUSY-94 SNICKERS-3)
          (LOCALE FLOUNDER-6 ALSACE)
          (CRAVES EMPATHY-41 LAMB)
          (EATS CHERRY PEAR)
          (EATS TOMATO-23 MUFFIN)
          (EATS PORK-19 HAM-31)
          (CRAVES LONELINESS-99 KALE-16)
          (LOCALE MUTTON BAVARIA)
          (EATS BAGUETTE POTATO)
          (EATS LETTUCE POTATO-26)
          (CRAVES AESTHETICS MUTTON-27)
          (CRAVES TRIUMPH-112 ENDIVE)
          (EATS SCALLOP-53 TURKEY-20)
          (EATS LETTUCE TUNA)
          (CRAVES HANGOVER-84 HAM)
          (EATS ONION-59 MUFFIN)
          (EATS PEAR BROCCOLI)
          (LOCALE POPOVER GUANABARA)
          (EATS YOGURT BAGUETTE)
          (LOCALE ARUGULA-58 MANITOBA)
          (EATS CHICKEN FLOUNDER)
          (EATS BROCCOLI SHRIMP-5)
          (CRAVES DREAD-95 PISTACHIO-7)
          (LOCALE CHICKEN ALSACE)
          (EATS PISTACHIO-7 BROCCOLI)
          (CRAVES GRIEF-93 SNICKERS-3)
          (EATS BAGUETTE TUNA)
          (EATS MUFFIN-30 YOGURT-25)
          (ATTACKS GOIAS QUEBEC)
          (CRAVES ANXIETY-82 OKRA)
          (EATS POTATO BAGUETTE)
          (EATS HAROSET PEAR)
          (EATS TOFU WURST)
          (CRAVES LEARNING-51 CHOCOLATE-12)
          (EATS SHRIMP-5 BROCCOLI)
          (EATS OKRA-8 BAGUETTE)
          (EATS FLOUNDER GUAVA)
          (LOCALE TUNA KENTUCKY)
          (CRAVES UNDERSTANDING-117 TURKEY)
          (EATS LEMON GRAPEFRUIT)
          (EATS GUAVA FLOUNDER)
          (EATS CHICKEN-21 GRAPEFRUIT-4)
          (CRAVES LONELINESS-87 ARUGULA)
          (HARMONY SATISFACTION-34 VULCAN)
          (EATS SCALLOP BACON)
          (EATS CHOCOLATE ARUGULA)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (HARMONY UNDERSTANDING MARS)
          (EATS TURKEY-20 SCALLOP-53)
          (EATS HOTDOG-61 WONDERBREAD)
          (EATS FLOUNDER-6 BAGUETTE)
          (EATS MARZIPAN PISTACHIO-7)
          (CRAVES ABRASION-65 HAROSET)
          (LOCALE TUNA-54 MORAVIA)
          (EATS PEAR CHERRY)
          (CRAVES LACERATION-81 SNICKERS)
          (CRAVES LACERATION-242 TOMATO)
          (CRAVES LUBRICITY ONION-59)
          (ORBITS VULCAN MARS)
          (EATS COD TOMATO)
          (LOCALE SNICKERS-3 PENNSYLVANIA)
          (EATS BACON PEA)
          (CRAVES LONELINESS-77 YOGURT)
          (CRAVES STIMULATION POTATO-26)
          (EATS MUFFIN PEPPER)
          (EATS BEEF YOGURT)
          (EATS SHRIMP KALE)
          (HARMONY EXCITEMENT MARS)
          (CRAVES STIMULATION-115 PEPPER)
          (LOCALE PAPAYA ALSACE)
          (EATS GUAVA ENDIVE)
          (CRAVES EXPECTATION COD-17)
          (EATS CHICKEN HAMBURGER)
          (EATS PORK RICE)
          (EATS SCALLOP ONION)
          (EATS HAMBURGER-18 HAROSET-62)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES INTOXICATION APPLE-55)
          (HARMONY ACHIEVEMENT-125 JUPITER)
          (HARMONY AESTHETICS-126 VULCAN)
          (EATS BAGUETTE KALE)
          (HARMONY LUBRICITY-39 JUPITER)
          (LOCALE CANTELOPE-10 GOIAS)
          (HARMONY REST-36 MARS)
          (CRAVES BOILS ONION-59)
          (EATS ORANGE LOBSTER)
          (LOCALE SHRIMP ALSACE)
          (CRAVES ABRASION HAMBURGER-18)
          (LOCALE WONDERBREAD BOSNIA)
          (HARMONY LUBRICITY-127 VULCAN)
          (CRAVES SATISFACTION HAM-31)
          (LOCALE GUAVA-28 BOSNIA)
          (LOCALE MUFFIN-30 MANITOBA)
          (EATS HOTDOG PISTACHIO)
          (EATS LEMON APPLE)
          (EATS WONDERBREAD GRAPEFRUIT)
          (LOCALE CANTELOPE OREGON)
          (HARMONY SATIETY-122 MARS)
          (EATS LETTUCE-60 ENDIVE-9)
          (EATS TURKEY CHOCOLATE)
          (EATS OKRA BACON-29)
          (EATS GRAPEFRUIT CUCUMBER)
          (EATS MUFFIN ONION-59)
          (HARMONY LEARNING-51 JUPITER)
          (EATS LAMB TOFU)
          (CRAVES REST HAROSET-62)
          (EATS APPLE-55 APPLE)
          (EATS MUTTON-27 PISTACHIO-7)
          (CRAVES ANXIETY-249 SHRIMP)
          (EATS POPOVER PEAR)
          (EATS OKRA-8 LAMB)
          (EATS ENDIVE GUAVA)
          (EATS BROCCOLI PISTACHIO-7)
          (CRAVES GRIEF WURST-64)
          (ATTACKS MORAVIA GOIAS)
          (LOCALE ORANGE-22 OREGON)
          (ATTACKS QUEBEC SURREY)
          (HARMONY TRIUMPH-38 MARS)
          (LOCALE COD-17 ALSACE)
          (EATS CHICKEN-21 APPLE)
          (EATS BAGUETTE ORANGE)
          (EATS BAGUETTE YOGURT)
          (LOCALE YOGURT-25 MANITOBA)
          (CRAVES PROSTATITIS-92 PEAR-1)
          (HARMONY CURIOSITY JUPITER)
          (CRAVES ANXIETY-86 ARUGULA)
          (EATS TUNA APPLE)
          (CRAVES REST-116 FLOUNDER)
          (LOCALE LETTUCE-60 OREGON)
          (EATS PEAR-1 TURKEY)
          (EATS LEMON-15 HAROSET)
          (CRAVES CURIOSITY-128 POTATO)
          (EATS FLOUNDER SCALLION)
          (LOCALE MARZIPAN BOSNIA)
          (EATS SNICKERS-3 PORK)
          (EATS LETTUCE-60 PORK)
          (EATS RICE SCALLION-56)
          (CRAVES LONELINESS-243 BEEF)
          (EATS HAM HAROSET)
          (ATTACKS ALSACE GUANABARA)
          (EATS PORK-19 HAMBURGER-18)
          (EATS GRAPEFRUIT WONDERBREAD)
          (EATS RICE CHOCOLATE)
          (CRAVES LOVE-124 HAROSET)
          (CRAVES ANGINA-69 CUCUMBER)
          (CRAVES SATIETY LETTUCE-60)
          (LOCALE TURKEY-20 KENTUCKY)
          (EATS CHOCOLATE RICE)
          (LOCALE APPLE SURREY)
          (EATS BAGUETTE OKRA-8)
          (EATS PEAR PEA-11)
          (EATS POTATO-26 LETTUCE)
          (LOCALE SNICKERS BOSNIA)
          (LOCALE GRAPEFRUIT BAVARIA)
          (EATS GUAVA CHICKEN)
          (EATS FLOUNDER HAROSET-62)
          (EATS GUAVA MELON)
          (LOCALE SWEETROLL BOSNIA)
          (HARMONY REST MARS)
          (CRAVES ANGINA SCALLION-56)
          (EATS LAMB OKRA-8)
          (LOCALE LETTUCE MANITOBA)
          (LOCALE CHERRY-14 MANITOBA)
          (EATS MUTTON-27 PEA)
          (CRAVES TRIUMPH-120 BACON)
          (EATS POPOVER BACON-29)
          (CRAVES ANGER BAGUETTE-24)
          (EATS ORANGE-22 POTATO)
          (CRAVES HANGOVER-252 WONDERBREAD)
          (EATS HOTDOG LEMON)
          (EATS SCALLOP POTATO-26)
          (EATS LETTUCE BEEF)
          (EATS FLOUNDER CHICKEN)
          (EATS BACON MUTTON-27)
          (HARMONY EMPATHY MARS)
          (EATS TOMATO-23 PAPAYA)
          (CRAVES SATISFACTION-42 PISTACHIO)
          (EATS PISTACHIO-7 MARZIPAN)
          (EATS SCALLOP POPOVER)
          (EATS PAPAYA TOMATO-23)
          (EATS LAMB-13 PEA-11)
          (CRAVES PROSTATITIS TOFU-57)
          (EATS TURKEY-20 SNICKERS-3)
          (EATS PISTACHIO HOTDOG)
          (CRAVES REST-36 LETTUCE)
          (LOCALE PEA ALSACE)
          (CRAVES ENTERTAINMENT PEPPER-63)
          (EATS ENDIVE-9 CHOCOLATE)
          (EATS SCALLION-56 RICE)
          (EATS MUTTON RICE)
          (EATS MARZIPAN PORK)
          (EATS SNICKERS-3 CANTELOPE)
          (EATS PORK MARZIPAN)
          (EATS HAMBURGER CHICKEN)
          (LOCALE PISTACHIO-7 OREGON)
          (EATS YOGURT-25 CUCUMBER)
          (EATS RICE PEPPER-63)
          (EATS HAMBURGER ENDIVE)
          (LOCALE MUFFIN OREGON)
          (ORBITS MERCURY JUPITER)
          (CRAVES AESTHETICS-45 GRAPEFRUIT-4)
          (HARMONY EMPATHY-41 JUPITER)
          (EATS BEEF-32 WONDERBREAD)
          (LOCALE HAMBURGER-18 GOIAS)
          (LOCALE WURST-64 OREGON)
          (EATS APPLE CHICKEN-21)
          (HARMONY STIMULATION VULCAN)
          (EATS PEA BACON)
          (EATS PEPPER CHOCOLATE-12)
          (HARMONY LUBRICITY-114 MARS)
          (LOCALE CHOCOLATE PENNSYLVANIA)
          (CRAVES ABRASION-239 ENDIVE)
          (LOCALE PORK-19 KENTUCKY)
          (CRAVES DEPRESSION-254 PORK)
          (EATS OKRA-8 TOFU)
          (EATS SCALLION FLOUNDER)
          (LOCALE LEMON-15 MANITOBA)
          (ATTACKS BOSNIA OREGON)
          (EATS BAGUETTE WURST)
          (EATS MUTTON-27 TOMATO)
          (EATS MUFFIN BAGUETTE-24)
          (EATS MUTTON ARUGULA)
          (EATS CANTELOPE PEA-11)
          (EATS HAROSET HAM-31)
          (LOCALE APPLE-55 GOIAS)
          (EATS HAM-31 PORK-19)
          (HARMONY ENTERTAINMENT VULCAN))
   (:GOAL (AND (CRAVES DREAD PORK-19)
               (CRAVES BOILS PORK-19))))

(DEFINE (PROBLEM STRIPS-MYSTY-41)
   (:DOMAIN MYSTERY-STRIPS)
   (:OBJECTS PORK-107 CANTELOPE-108 RICE-109 MUTTON-110 KALE-111
             SHRIMP-112 LAMB-113 OKRA-114 SCALLION-118 TOMATO-117 PAPAYA-116
             HAMBURGER-115 WONDERBREAD-119 BROCCOLI-120 TUNA-121 ENDIVE-122
             MARZIPAN-123 MUFFIN-124 MELON-125 SCALLOP-126 POTATO-127
             SNICKERS-128 POPOVER-33 CHOCOLATE-34 FLOUNDER-35 PEA-36
             CUCUMBER-37 GUAVA-38 PEPPER-39 HAM-40 TURKEY-41 WURST-42
             YOGURT-43 TUNA-44 BROCCOLI-45 ENDIVE-46 HAMBURGER-47 PORK-48
             BEEF-49 HAM-50 APPLE-51 LAMB-52 CHERRY-53 CANTELOPE-54
             OKRA-55 YOGURT-56 TOMATO-57 SCALLOP-58 PEPPER-59
             GRAPEFRUIT-60 BAGUETTE-61 HOTDOG-62 LETTUCE-63 LEMON-64 POPOVER-17
             MUTTON-18 PISTACHIO-19 LOBSTER-20 GUAVA-21 CHOCOLATE-22
             KALE-23 WURST-24 ONION-25 ARUGULA-26 PEAR-27 TURKEY-28
             CUCUMBER-29 COD-30 MELON-31 TOFU-32 PEA-9 WONDERBREAD-10
             FLOUNDER-11 PAPAYA-12 ORANGE-13 BACON-14 SHRIMP-15 SWEETROLL-16
             HAROSET-5 SNICKERS-6 MARZIPAN-7 RICE-8 MUFFIN-3 POTATO-4
             SCALLION-1 CHICKEN-2 PAPAYA SCALLION HAM CANTELOPE LAMB COD
             PISTACHIO ENDIVE BACON BAGUETTE PEPPER WONDERBREAD CHOCOLATE
             LOBSTER SNICKERS MUTTON ARUGULA GRAPEFRUIT GUAVA RICE PEAR PORK
             KALE CHICKEN TOMATO SCALLOP MUFFIN HOTDOG ONION BEEF WURST
             SWEETROLL PEA MELON TUNA HAMBURGER YOGURT SHRIMP LETTUCE CUCUMBER
             APPLE TURKEY BROCCOLI POTATO OKRA HAROSET TOFU POPOVER LEMON
             ORANGE CHERRY MARZIPAN FLOUNDER REST INTOXICATION
             STIMULATION ENTERTAINMENT EXCITEMENT LOVE UNDERSTANDING EMPATHY
             SATIETY LEARNING SATISFACTION CURIOSITY TRIUMPH EXPECTATION
             ACHIEVEMENT AESTHETICS LUBRICITY UNDERSTANDING-106 LEARNING-105
             LOVE-104 INTOXICATION-103 EMPATHY-102 TRIUMPH-101
             SATISFACTION-100 EXCITEMENT-99 SATIETY-98 REST-97 EXPECTATION-96
             CURIOSITY-95 ACHIEVEMENT-94 LUBRICITY-93 ENTERTAINMENT-92
             STIMULATION-91 AESTHETICS-90 STIMULATION-89 UNDERSTANDING-88
             SATIETY-87 EXPECTATION-86 EXCITEMENT-85 ENTERTAINMENT-84
             INTOXICATION-83 LEARNING-82 REST-81 ACHIEVEMENT-80 CURIOSITY-79
             AESTHETICS-78 LOVE-77 EMPATHY-76 SATISFACTION-75 TRIUMPH-74
             LUBRICITY-73 INTOXICATION-72 EXPECTATION-71 LUBRICITY-70
             ACHIEVEMENT-69 STIMULATION-68 AESTHETICS-67 LOVE-66
             UNDERSTANDING-65 CURIOSITY-256 SATISFACTION-255 ENTERTAINMENT-254
             SATIETY-253 TRIUMPH-252 REST-251 EXCITEMENT-250 LEARNING-249
             EMPATHY-248 TRIUMPH-247 ACHIEVEMENT-246 SATISFACTION-245
             EXCITEMENT-244 STIMULATION-243 LOVE-242 REST-241 INTOXICATION-240
             LUBRICITY-239 ENTERTAINMENT-238 LEARNING-237 SATIETY-236
             UNDERSTANDING-235 EMPATHY-234 AESTHETICS-233 CURIOSITY-232
             EXPECTATION-231 LOVE-230 ENTERTAINMENT-229 SATISFACTION-228
             TRIUMPH-227 EXCITEMENT-226 EMPATHY-225 REST-224 STIMULATION-223
             UNDERSTANDING-222 INTOXICATION-221 ACHIEVEMENT-220 ANGER PROSTATITIS
             HANGOVER LONELINESS ANGINA ANXIETY BOILS LACERATION JEALOUSY
             SCIATICA DEPRESSION GRIEF ANGER-218 HANGOVER-219 DREAD
             ABRASION ABRASION-217 ANGINA-215 BOILS-216 LACERATION-213
             JEALOUSY-214 SCIATICA-210 ANXIETY-211 GRIEF-212 DREAD-207
             LONELINESS-208 DEPRESSION-209 LONELINESS-205 PROSTATITIS-206
             ANGINA-201 JEALOUSY-202 SCIATICA-203 HANGOVER-204 DREAD-200
             GRIEF-197 ABRASION-198 LACERATION-199 ANXIETY-194 ANGER-195
             DEPRESSION-196 HANGOVER-191 BOILS-192 PROSTATITIS-193 ANGER-187
             ANXIETY-188 GRIEF-189 SCIATICA-190 BOILS-184 LACERATION-185
             DEPRESSION-186 LONELINESS-182 PROSTATITIS-183 ANGINA-180
             JEALOUSY-181 GRIEF-177 ABRASION-178 DREAD-179 JEALOUSY-173
             HANGOVER-174 PROSTATITIS-175 BOILS-176 ANGINA-169 LONELINESS-170
             SCIATICA-171 ANGER-172 ABRASION-165 DREAD-166 LACERATION-167
             ANXIETY-168 HANGOVER-163 DEPRESSION-164 DEPRESSION-161
             GRIEF-162 JEALOUSY-157 BOILS-158 PROSTATITIS-159 ANXIETY-160
             LACERATION-155 ANGER-156 SCIATICA-151 ABRASION-152 DREAD-153
             ANGINA-154 ANXIETY-148 DEPRESSION-149 LONELINESS-150
             LACERATION-144 BOILS-145 HANGOVER-146 SCIATICA-147 ANGINA-143
             LONELINESS-142 ANGER-140 ABRASION-141 GRIEF-137 DREAD-138
             JEALOUSY-139 SCIATICA-134 PROSTATITIS-135 PROSTATITIS-136
             DEPRESSION-132 GRIEF-133 ABRASION-131 JEALOUSY-129 LONELINESS-130
             DREAD-511 ANGINA-512 HANGOVER-510 BOILS-509 BOILS-505
             ANXIETY-506 LACERATION-507 ANGER-508 SCIATICA-501 ABRASION-502
             GRIEF-503 ANGINA-504 ANXIETY-497 DEPRESSION-498 HANGOVER-499
             LACERATION-500 PROSTATITIS-494 ANGER-495 JEALOUSY-496 DREAD-492
             LONELINESS-493 SCIATICA-488 BOILS-489 DREAD-490 PROSTATITIS-491
             DEPRESSION-487 LACERATION-485 ANXIETY-486 LONELINESS-481
             ABRASION-482 ANGER-483 GRIEF-484 ANGINA-480 HANGOVER-478
             JEALOUSY-479 BOILS-475 JEALOUSY-476 GRIEF-477 DREAD-471
             PROSTATITIS-472 ANXIETY-473 DEPRESSION-474 LACERATION-470
             LONELINESS-468 ABRASION-469 ANGINA-466 HANGOVER-467 JEALOUSY-463
             SCIATICA-464 ANGER-465 LACERATION-460 GRIEF-461 ANXIETY-462
             DEPRESSION-459 BOILS-455 ANGINA-456 PROSTATITIS-457 HANGOVER-458
             SCIATICA-454 DREAD-452 ANGER-453 LONELINESS-451 ANGINA-448
             LONELINESS-449 ABRASION-450 BOILS-446 GRIEF-447 PROSTATITIS-445
             SCIATICA-441 DEPRESSION-442 JEALOUSY-443 HANGOVER-444
             ANXIETY-439 LACERATION-440 DREAD-437 ABRASION-438 ANGER-436
             DEPRESSION-433 GRIEF-434 BOILS-435 LACERATION-431 ANXIETY-432
             PROSTATITIS-429 HANGOVER-430 SCIATICA-427 ANGINA-428 LONELINESS-424
             ANGER-425 JEALOUSY-426 ANXIETY-420 GRIEF-421 DREAD-422
             ABRASION-423 SCIATICA-419 LONELINESS-415 PROSTATITIS-416
             BOILS-417 HANGOVER-418 ANGINA-412 ABRASION-413 JEALOUSY-414
             DREAD-411 LACERATION-408 ANGER-409 DEPRESSION-410 GRIEF-405
             LONELINESS-406 ABRASION-407 ANGER-402 SCIATICA-403 HANGOVER-404
             BOILS-399 DREAD-400 ANGINA-401 PROSTATITIS-398 LACERATION-395
             DEPRESSION-396 JEALOUSY-397 HANGOVER-393 ANXIETY-394 SCIATICA-391
             BOILS-392 ANGER-389 ANGINA-390 JEALOUSY-388 LONELINESS-385
             DREAD-386 LACERATION-387 ABRASION-384 ANXIETY-382
             PROSTATITIS-383 ABRASION-379 GRIEF-380 DEPRESSION-381 HANGOVER-375
             JEALOUSY-376 LACERATION-377 SCIATICA-378 DREAD-371
             LONELINESS-372 PROSTATITIS-373 ANXIETY-374 BOILS-369
             DEPRESSION-370 ANGER-367 ANGINA-368 GRIEF-365 GRIEF-366
             ABRASION-363 PROSTATITIS-364 DEPRESSION-361 DREAD-362 ANGINA-357
             HANGOVER-358 ANGER-359 ANXIETY-360 LACERATION-354 LONELINESS-355
             SCIATICA-356 JEALOUSY-350 HANGOVER-351 JEALOUSY-352 BOILS-353
             GRIEF-346 ANGER-347 LONELINESS-348 DREAD-349 ANGINA-345
             PROSTATITIS-343 DEPRESSION-344 LACERATION-339 BOILS-340
             SCIATICA-341 ABRASION-342 BOILS-337 ANXIETY-338 GRIEF-335
             DEPRESSION-336 ANGER-331 JEALOUSY-332 LACERATION-333
             PROSTATITIS-334 DREAD-328 HANGOVER-329 ABRASION-330 ANGINA-324
             LONELINESS-325 SCIATICA-326 ANXIETY-327 LONELINESS-320 ANXIETY-321
             DREAD-322 ABRASION-323 BOILS-316 JEALOUSY-317 HANGOVER-318
             LACERATION-319 SCIATICA-312 ANGINA-313 PROSTATITIS-314 ANGER-315
             GRIEF-311 SCIATICA-309 DEPRESSION-310 BOILS-306 ABRASION-307
             LACERATION-308 LONELINESS-303 ANGINA-304 ANGER-305 ANXIETY-302
             DEPRESSION-299 JEALOUSY-300 HANGOVER-301 LACERATION-295 DREAD-296
             GRIEF-297 PROSTATITIS-298 ANXIETY-291 ANGER-292 HANGOVER-293
             PROSTATITIS-294 ANGINA-288 BOILS-289 JEALOUSY-290 ABRASION-286
             SCIATICA-287 DREAD-282 GRIEF-283 LONELINESS-284 DEPRESSION-285
             ANXIETY-278 GRIEF-279 PROSTATITIS-280 HANGOVER-281
             DEPRESSION-274 ANGER-275 ABRASION-276 BOILS-277 DREAD-273
             SCIATICA-269 LACERATION-270 JEALOUSY-271 ANGINA-272
             DEPRESSION-267 LONELINESS-268 SCIATICA-263 LACERATION-264
             ANGER-265 ABRASION-266 BOILS-260 ANGINA-261 HANGOVER-262
             PROSTATITIS-258 JEALOUSY-259 BAVARIA-1023 GUANABARA-1024 ALSACE-257
             GOIAS ARIZONA BOSNIA OREGON PENNSYLVANIA BAVARIA MORAVIA
             MANITOBA QUEBEC SURREY ALSACE GUANABARA KENTUCKY JUPITER
             NEPTUNE MARS PLUTO)
   (:INIT (FOOD PORK-107)
          (FOOD CANTELOPE-108)
          (FOOD RICE-109)
          (FOOD MUTTON-110)
          (FOOD KALE-111)
          (FOOD SHRIMP-112)
          (FOOD LAMB-113)
          (FOOD OKRA-114)
          (FOOD SCALLION-118)
          (FOOD TOMATO-117)
          (FOOD PAPAYA-116)
          (FOOD HAMBURGER-115)
          (FOOD WONDERBREAD-119)
          (FOOD BROCCOLI-120)
          (FOOD TUNA-121)
          (FOOD ENDIVE-122)
          (FOOD MARZIPAN-123)
          (FOOD MUFFIN-124)
          (FOOD MELON-125)
          (FOOD SCALLOP-126)
          (FOOD POTATO-127)
          (FOOD SNICKERS-128)
          (FOOD POPOVER-33)
          (FOOD CHOCOLATE-34)
          (FOOD FLOUNDER-35)
          (FOOD PEA-36)
          (FOOD CUCUMBER-37)
          (FOOD GUAVA-38)
          (FOOD PEPPER-39)
          (FOOD HAM-40)
          (FOOD TURKEY-41)
          (FOOD WURST-42)
          (FOOD YOGURT-43)
          (FOOD TUNA-44)
          (FOOD BROCCOLI-45)
          (FOOD ENDIVE-46)
          (FOOD HAMBURGER-47)
          (FOOD PORK-48)
          (FOOD BEEF-49)
          (FOOD HAM-50)
          (FOOD APPLE-51)
          (FOOD LAMB-52)
          (FOOD CHERRY-53)
          (FOOD CANTELOPE-54)
          (FOOD OKRA-55)
          (FOOD YOGURT-56)
          (FOOD TOMATO-57)
          (FOOD SCALLOP-58)
          (FOOD PEPPER-59)
          (FOOD GRAPEFRUIT-60)
          (FOOD BAGUETTE-61)
          (FOOD HOTDOG-62)
          (FOOD LETTUCE-63)
          (FOOD LEMON-64)
          (FOOD POPOVER-17)
          (FOOD MUTTON-18)
          (FOOD PISTACHIO-19)
          (FOOD LOBSTER-20)
          (FOOD GUAVA-21)
          (FOOD CHOCOLATE-22)
          (FOOD KALE-23)
          (FOOD WURST-24)
          (FOOD ONION-25)
          (FOOD ARUGULA-26)
          (FOOD PEAR-27)
          (FOOD TURKEY-28)
          (FOOD CUCUMBER-29)
          (FOOD COD-30)
          (FOOD MELON-31)
          (FOOD TOFU-32)
          (FOOD PEA-9)
          (FOOD WONDERBREAD-10)
          (FOOD FLOUNDER-11)
          (FOOD PAPAYA-12)
          (FOOD ORANGE-13)
          (FOOD BACON-14)
          (FOOD SHRIMP-15)
          (FOOD SWEETROLL-16)
          (FOOD HAROSET-5)
          (FOOD SNICKERS-6)
          (FOOD MARZIPAN-7)
          (FOOD RICE-8)
          (FOOD MUFFIN-3)
          (FOOD POTATO-4)
          (FOOD SCALLION-1)
          (FOOD CHICKEN-2)
          (FOOD PAPAYA)
          (FOOD SCALLION)
          (FOOD HAM)
          (FOOD CANTELOPE)
          (FOOD LAMB)
          (FOOD COD)
          (FOOD PISTACHIO)
          (FOOD ENDIVE)
          (FOOD BACON)
          (FOOD BAGUETTE)
          (FOOD PEPPER)
          (FOOD WONDERBREAD)
          (FOOD CHOCOLATE)
          (FOOD LOBSTER)
          (FOOD SNICKERS)
          (FOOD MUTTON)
          (FOOD ARUGULA)
          (FOOD GRAPEFRUIT)
          (FOOD GUAVA)
          (FOOD RICE)
          (FOOD PEAR)
          (FOOD PORK)
          (FOOD KALE)
          (FOOD CHICKEN)
          (FOOD TOMATO)
          (FOOD SCALLOP)
          (FOOD MUFFIN)
          (FOOD HOTDOG)
          (FOOD ONION)
          (FOOD BEEF)
          (FOOD WURST)
          (FOOD SWEETROLL)
          (FOOD PEA)
          (FOOD MELON)
          (FOOD TUNA)
          (FOOD HAMBURGER)
          (FOOD YOGURT)
          (FOOD SHRIMP)
          (FOOD LETTUCE)
          (FOOD CUCUMBER)
          (FOOD APPLE)
          (FOOD TURKEY)
          (FOOD BROCCOLI)
          (FOOD POTATO)
          (FOOD OKRA)
          (FOOD HAROSET)
          (FOOD TOFU)
          (FOOD POPOVER)
          (FOOD LEMON)
          (FOOD ORANGE)
          (FOOD CHERRY)
          (FOOD MARZIPAN)
          (FOOD FLOUNDER)
          (PLEASURE REST)
          (PLEASURE INTOXICATION)
          (PLEASURE STIMULATION)
          (PLEASURE ENTERTAINMENT)
          (PLEASURE EXCITEMENT)
          (PLEASURE LOVE)
          (PLEASURE UNDERSTANDING)
          (PLEASURE EMPATHY)
          (PLEASURE SATIETY)
          (PLEASURE LEARNING)
          (PLEASURE SATISFACTION)
          (PLEASURE CURIOSITY)
          (PLEASURE TRIUMPH)
          (PLEASURE EXPECTATION)
          (PLEASURE ACHIEVEMENT)
          (PLEASURE AESTHETICS)
          (PLEASURE LUBRICITY)
          (PLEASURE UNDERSTANDING-106)
          (PLEASURE LEARNING-105)
          (PLEASURE LOVE-104)
          (PLEASURE INTOXICATION-103)
          (PLEASURE EMPATHY-102)
          (PLEASURE TRIUMPH-101)
          (PLEASURE SATISFACTION-100)
          (PLEASURE EXCITEMENT-99)
          (PLEASURE SATIETY-98)
          (PLEASURE REST-97)
          (PLEASURE EXPECTATION-96)
          (PLEASURE CURIOSITY-95)
          (PLEASURE ACHIEVEMENT-94)
          (PLEASURE LUBRICITY-93)
          (PLEASURE ENTERTAINMENT-92)
          (PLEASURE STIMULATION-91)
          (PLEASURE AESTHETICS-90)
          (PLEASURE STIMULATION-89)
          (PLEASURE UNDERSTANDING-88)
          (PLEASURE SATIETY-87)
          (PLEASURE EXPECTATION-86)
          (PLEASURE EXCITEMENT-85)
          (PLEASURE ENTERTAINMENT-84)
          (PLEASURE INTOXICATION-83)
          (PLEASURE LEARNING-82)
          (PLEASURE REST-81)
          (PLEASURE ACHIEVEMENT-80)
          (PLEASURE CURIOSITY-79)
          (PLEASURE AESTHETICS-78)
          (PLEASURE LOVE-77)
          (PLEASURE EMPATHY-76)
          (PLEASURE SATISFACTION-75)
          (PLEASURE TRIUMPH-74)
          (PLEASURE LUBRICITY-73)
          (PLEASURE INTOXICATION-72)
          (PLEASURE EXPECTATION-71)
          (PLEASURE LUBRICITY-70)
          (PLEASURE ACHIEVEMENT-69)
          (PLEASURE STIMULATION-68)
          (PLEASURE AESTHETICS-67)
          (PLEASURE LOVE-66)
          (PLEASURE UNDERSTANDING-65)
          (PLEASURE CURIOSITY-256)
          (PLEASURE SATISFACTION-255)
          (PLEASURE ENTERTAINMENT-254)
          (PLEASURE SATIETY-253)
          (PLEASURE TRIUMPH-252)
          (PLEASURE REST-251)
          (PLEASURE EXCITEMENT-250)
          (PLEASURE LEARNING-249)
          (PLEASURE EMPATHY-248)
          (PLEASURE TRIUMPH-247)
          (PLEASURE ACHIEVEMENT-246)
          (PLEASURE SATISFACTION-245)
          (PLEASURE EXCITEMENT-244)
          (PLEASURE STIMULATION-243)
          (PLEASURE LOVE-242)
          (PLEASURE REST-241)
          (PLEASURE INTOXICATION-240)
          (PLEASURE LUBRICITY-239)
          (PLEASURE ENTERTAINMENT-238)
          (PLEASURE LEARNING-237)
          (PLEASURE SATIETY-236)
          (PLEASURE UNDERSTANDING-235)
          (PLEASURE EMPATHY-234)
          (PLEASURE AESTHETICS-233)
          (PLEASURE CURIOSITY-232)
          (PLEASURE EXPECTATION-231)
          (PLEASURE LOVE-230)
          (PLEASURE ENTERTAINMENT-229)
          (PLEASURE SATISFACTION-228)
          (PLEASURE TRIUMPH-227)
          (PLEASURE EXCITEMENT-226)
          (PLEASURE EMPATHY-225)
          (PLEASURE REST-224)
          (PLEASURE STIMULATION-223)
          (PLEASURE UNDERSTANDING-222)
          (PLEASURE INTOXICATION-221)
          (PLEASURE ACHIEVEMENT-220)
          (PAIN ANGER)
          (PAIN PROSTATITIS)
          (PAIN HANGOVER)
          (PAIN LONELINESS)
          (PAIN ANGINA)
          (PAIN ANXIETY)
          (PAIN BOILS)
          (PAIN LACERATION)
          (PAIN JEALOUSY)
          (PAIN SCIATICA)
          (PAIN DEPRESSION)
          (PAIN GRIEF)
          (PAIN ANGER-218)
          (PAIN HANGOVER-219)
          (PAIN DREAD)
          (PAIN ABRASION)
          (PAIN ABRASION-217)
          (PAIN ANGINA-215)
          (PAIN BOILS-216)
          (PAIN LACERATION-213)
          (PAIN JEALOUSY-214)
          (PAIN SCIATICA-210)
          (PAIN ANXIETY-211)
          (PAIN GRIEF-212)
          (PAIN DREAD-207)
          (PAIN LONELINESS-208)
          (PAIN DEPRESSION-209)
          (PAIN LONELINESS-205)
          (PAIN PROSTATITIS-206)
          (PAIN ANGINA-201)
          (PAIN JEALOUSY-202)
          (PAIN SCIATICA-203)
          (PAIN HANGOVER-204)
          (PAIN DREAD-200)
          (PAIN GRIEF-197)
          (PAIN ABRASION-198)
          (PAIN LACERATION-199)
          (PAIN ANXIETY-194)
          (PAIN ANGER-195)
          (PAIN DEPRESSION-196)
          (PAIN HANGOVER-191)
          (PAIN BOILS-192)
          (PAIN PROSTATITIS-193)
          (PAIN ANGER-187)
          (PAIN ANXIETY-188)
          (PAIN GRIEF-189)
          (PAIN SCIATICA-190)
          (PAIN BOILS-184)
          (PAIN LACERATION-185)
          (PAIN DEPRESSION-186)
          (PAIN LONELINESS-182)
          (PAIN PROSTATITIS-183)
          (PAIN ANGINA-180)
          (PAIN JEALOUSY-181)
          (PAIN GRIEF-177)
          (PAIN ABRASION-178)
          (PAIN DREAD-179)
          (PAIN JEALOUSY-173)
          (PAIN HANGOVER-174)
          (PAIN PROSTATITIS-175)
          (PAIN BOILS-176)
          (PAIN ANGINA-169)
          (PAIN LONELINESS-170)
          (PAIN SCIATICA-171)
          (PAIN ANGER-172)
          (PAIN ABRASION-165)
          (PAIN DREAD-166)
          (PAIN LACERATION-167)
          (PAIN ANXIETY-168)
          (PAIN HANGOVER-163)
          (PAIN DEPRESSION-164)
          (PAIN DEPRESSION-161)
          (PAIN GRIEF-162)
          (PAIN JEALOUSY-157)
          (PAIN BOILS-158)
          (PAIN PROSTATITIS-159)
          (PAIN ANXIETY-160)
          (PAIN LACERATION-155)
          (PAIN ANGER-156)
          (PAIN SCIATICA-151)
          (PAIN ABRASION-152)
          (PAIN DREAD-153)
          (PAIN ANGINA-154)
          (PAIN ANXIETY-148)
          (PAIN DEPRESSION-149)
          (PAIN LONELINESS-150)
          (PAIN LACERATION-144)
          (PAIN BOILS-145)
          (PAIN HANGOVER-146)
          (PAIN SCIATICA-147)
          (PAIN ANGINA-143)
          (PAIN LONELINESS-142)
          (PAIN ANGER-140)
          (PAIN ABRASION-141)
          (PAIN GRIEF-137)
          (PAIN DREAD-138)
          (PAIN JEALOUSY-139)
          (PAIN SCIATICA-134)
          (PAIN PROSTATITIS-135)
          (PAIN PROSTATITIS-136)
          (PAIN DEPRESSION-132)
          (PAIN GRIEF-133)
          (PAIN ABRASION-131)
          (PAIN JEALOUSY-129)
          (PAIN LONELINESS-130)
          (PAIN DREAD-511)
          (PAIN ANGINA-512)
          (PAIN HANGOVER-510)
          (PAIN BOILS-509)
          (PAIN BOILS-505)
          (PAIN ANXIETY-506)
          (PAIN LACERATION-507)
          (PAIN ANGER-508)
          (PAIN SCIATICA-501)
          (PAIN ABRASION-502)
          (PAIN GRIEF-503)
          (PAIN ANGINA-504)
          (PAIN ANXIETY-497)
          (PAIN DEPRESSION-498)
          (PAIN HANGOVER-499)
          (PAIN LACERATION-500)
          (PAIN PROSTATITIS-494)
          (PAIN ANGER-495)
          (PAIN JEALOUSY-496)
          (PAIN DREAD-492)
          (PAIN LONELINESS-493)
          (PAIN SCIATICA-488)
          (PAIN BOILS-489)
          (PAIN DREAD-490)
          (PAIN PROSTATITIS-491)
          (PAIN DEPRESSION-487)
          (PAIN LACERATION-485)
          (PAIN ANXIETY-486)
          (PAIN LONELINESS-481)
          (PAIN ABRASION-482)
          (PAIN ANGER-483)
          (PAIN GRIEF-484)
          (PAIN ANGINA-480)
          (PAIN HANGOVER-478)
          (PAIN JEALOUSY-479)
          (PAIN BOILS-475)
          (PAIN JEALOUSY-476)
          (PAIN GRIEF-477)
          (PAIN DREAD-471)
          (PAIN PROSTATITIS-472)
          (PAIN ANXIETY-473)
          (PAIN DEPRESSION-474)
          (PAIN LACERATION-470)
          (PAIN LONELINESS-468)
          (PAIN ABRASION-469)
          (PAIN ANGINA-466)
          (PAIN HANGOVER-467)
          (PAIN JEALOUSY-463)
          (PAIN SCIATICA-464)
          (PAIN ANGER-465)
          (PAIN LACERATION-460)
          (PAIN GRIEF-461)
          (PAIN ANXIETY-462)
          (PAIN DEPRESSION-459)
          (PAIN BOILS-455)
          (PAIN ANGINA-456)
          (PAIN PROSTATITIS-457)
          (PAIN HANGOVER-458)
          (PAIN SCIATICA-454)
          (PAIN DREAD-452)
          (PAIN ANGER-453)
          (PAIN LONELINESS-451)
          (PAIN ANGINA-448)
          (PAIN LONELINESS-449)
          (PAIN ABRASION-450)
          (PAIN BOILS-446)
          (PAIN GRIEF-447)
          (PAIN PROSTATITIS-445)
          (PAIN SCIATICA-441)
          (PAIN DEPRESSION-442)
          (PAIN JEALOUSY-443)
          (PAIN HANGOVER-444)
          (PAIN ANXIETY-439)
          (PAIN LACERATION-440)
          (PAIN DREAD-437)
          (PAIN ABRASION-438)
          (PAIN ANGER-436)
          (PAIN DEPRESSION-433)
          (PAIN GRIEF-434)
          (PAIN BOILS-435)
          (PAIN LACERATION-431)
          (PAIN ANXIETY-432)
          (PAIN PROSTATITIS-429)
          (PAIN HANGOVER-430)
          (PAIN SCIATICA-427)
          (PAIN ANGINA-428)
          (PAIN LONELINESS-424)
          (PAIN ANGER-425)
          (PAIN JEALOUSY-426)
          (PAIN ANXIETY-420)
          (PAIN GRIEF-421)
          (PAIN DREAD-422)
          (PAIN ABRASION-423)
          (PAIN SCIATICA-419)
          (PAIN LONELINESS-415)
          (PAIN PROSTATITIS-416)
          (PAIN BOILS-417)
          (PAIN HANGOVER-418)
          (PAIN ANGINA-412)
          (PAIN ABRASION-413)
          (PAIN JEALOUSY-414)
          (PAIN DREAD-411)
          (PAIN LACERATION-408)
          (PAIN ANGER-409)
          (PAIN DEPRESSION-410)
          (PAIN GRIEF-405)
          (PAIN LONELINESS-406)
          (PAIN ABRASION-407)
          (PAIN ANGER-402)
          (PAIN SCIATICA-403)
          (PAIN HANGOVER-404)
          (PAIN BOILS-399)
          (PAIN DREAD-400)
          (PAIN ANGINA-401)
          (PAIN PROSTATITIS-398)
          (PAIN LACERATION-395)
          (PAIN DEPRESSION-396)
          (PAIN JEALOUSY-397)
          (PAIN HANGOVER-393)
          (PAIN ANXIETY-394)
          (PAIN SCIATICA-391)
          (PAIN BOILS-392)
          (PAIN ANGER-389)
          (PAIN ANGINA-390)
          (PAIN JEALOUSY-388)
          (PAIN LONELINESS-385)
          (PAIN DREAD-386)
          (PAIN LACERATION-387)
          (PAIN ABRASION-384)
          (PAIN ANXIETY-382)
          (PAIN PROSTATITIS-383)
          (PAIN ABRASION-379)
          (PAIN GRIEF-380)
          (PAIN DEPRESSION-381)
          (PAIN HANGOVER-375)
          (PAIN JEALOUSY-376)
          (PAIN LACERATION-377)
          (PAIN SCIATICA-378)
          (PAIN DREAD-371)
          (PAIN LONELINESS-372)
          (PAIN PROSTATITIS-373)
          (PAIN ANXIETY-374)
          (PAIN BOILS-369)
          (PAIN DEPRESSION-370)
          (PAIN ANGER-367)
          (PAIN ANGINA-368)
          (PAIN GRIEF-365)
          (PAIN GRIEF-366)
          (PAIN ABRASION-363)
          (PAIN PROSTATITIS-364)
          (PAIN DEPRESSION-361)
          (PAIN DREAD-362)
          (PAIN ANGINA-357)
          (PAIN HANGOVER-358)
          (PAIN ANGER-359)
          (PAIN ANXIETY-360)
          (PAIN LACERATION-354)
          (PAIN LONELINESS-355)
          (PAIN SCIATICA-356)
          (PAIN JEALOUSY-350)
          (PAIN HANGOVER-351)
          (PAIN JEALOUSY-352)
          (PAIN BOILS-353)
          (PAIN GRIEF-346)
          (PAIN ANGER-347)
          (PAIN LONELINESS-348)
          (PAIN DREAD-349)
          (PAIN ANGINA-345)
          (PAIN PROSTATITIS-343)
          (PAIN DEPRESSION-344)
          (PAIN LACERATION-339)
          (PAIN BOILS-340)
          (PAIN SCIATICA-341)
          (PAIN ABRASION-342)
          (PAIN BOILS-337)
          (PAIN ANXIETY-338)
          (PAIN GRIEF-335)
          (PAIN DEPRESSION-336)
          (PAIN ANGER-331)
          (PAIN JEALOUSY-332)
          (PAIN LACERATION-333)
          (PAIN PROSTATITIS-334)
          (PAIN DREAD-328)
          (PAIN HANGOVER-329)
          (PAIN ABRASION-330)
          (PAIN ANGINA-324)
          (PAIN LONELINESS-325)
          (PAIN SCIATICA-326)
          (PAIN ANXIETY-327)
          (PAIN LONELINESS-320)
          (PAIN ANXIETY-321)
          (PAIN DREAD-322)
          (PAIN ABRASION-323)
          (PAIN BOILS-316)
          (PAIN JEALOUSY-317)
          (PAIN HANGOVER-318)
          (PAIN LACERATION-319)
          (PAIN SCIATICA-312)
          (PAIN ANGINA-313)
          (PAIN PROSTATITIS-314)
          (PAIN ANGER-315)
          (PAIN GRIEF-311)
          (PAIN SCIATICA-309)
          (PAIN DEPRESSION-310)
          (PAIN BOILS-306)
          (PAIN ABRASION-307)
          (PAIN LACERATION-308)
          (PAIN LONELINESS-303)
          (PAIN ANGINA-304)
          (PAIN ANGER-305)
          (PAIN ANXIETY-302)
          (PAIN DEPRESSION-299)
          (PAIN JEALOUSY-300)
          (PAIN HANGOVER-301)
          (PAIN LACERATION-295)
          (PAIN DREAD-296)
          (PAIN GRIEF-297)
          (PAIN PROSTATITIS-298)
          (PAIN ANXIETY-291)
          (PAIN ANGER-292)
          (PAIN HANGOVER-293)
          (PAIN PROSTATITIS-294)
          (PAIN ANGINA-288)
          (PAIN BOILS-289)
          (PAIN JEALOUSY-290)
          (PAIN ABRASION-286)
          (PAIN SCIATICA-287)
          (PAIN DREAD-282)
          (PAIN GRIEF-283)
          (PAIN LONELINESS-284)
          (PAIN DEPRESSION-285)
          (PAIN ANXIETY-278)
          (PAIN GRIEF-279)
          (PAIN PROSTATITIS-280)
          (PAIN HANGOVER-281)
          (PAIN DEPRESSION-274)
          (PAIN ANGER-275)
          (PAIN ABRASION-276)
          (PAIN BOILS-277)
          (PAIN DREAD-273)
          (PAIN SCIATICA-269)
          (PAIN LACERATION-270)
          (PAIN JEALOUSY-271)
          (PAIN ANGINA-272)
          (PAIN DEPRESSION-267)
          (PAIN LONELINESS-268)
          (PAIN SCIATICA-263)
          (PAIN LACERATION-264)
          (PAIN ANGER-265)
          (PAIN ABRASION-266)
          (PAIN BOILS-260)
          (PAIN ANGINA-261)
          (PAIN HANGOVER-262)
          (PAIN PROSTATITIS-258)
          (PAIN JEALOUSY-259)
          (PROVINCE BAVARIA-1023)
          (PROVINCE GUANABARA-1024)
          (PROVINCE ALSACE-257)
          (PROVINCE GOIAS)
          (PROVINCE ARIZONA)
          (PROVINCE BOSNIA)
          (PROVINCE OREGON)
          (PROVINCE PENNSYLVANIA)
          (PROVINCE BAVARIA)
          (PROVINCE MORAVIA)
          (PROVINCE MANITOBA)
          (PROVINCE QUEBEC)
          (PROVINCE SURREY)
          (PROVINCE ALSACE)
          (PROVINCE GUANABARA)
          (PROVINCE KENTUCKY)
          (PLANET JUPITER)
          (PLANET NEPTUNE)
          (PLANET MARS)
          (PLANET PLUTO)
          (EATS TUNA-44 POPOVER)
          (CRAVES SCIATICA-287 POTATO)
          (LOCALE POTATO-4 ALSACE-257)
          (CRAVES STIMULATION-91 BEEF-49)
          (EATS GUAVA-21 LEMON-64)
          (CRAVES LEARNING-249 PISTACHIO)
          (CRAVES GRIEF-133 BEEF-49)
          (LOCALE MUTTON-18 OREGON)
          (CRAVES HANGOVER-351 PORK)
          (EATS SNICKERS PAPAYA-12)
          (EATS ONION-25 YOGURT-43)
          (CRAVES ANGER-195 MARZIPAN-123)
          (EATS PEA-36 BEEF)
          (EATS LETTUCE-63 MARZIPAN)
          (CRAVES PROSTATITIS-334 ONION)
          (CRAVES SCIATICA-464 KALE-23)
          (CRAVES EXCITEMENT-99 HAM-40)
          (EATS LETTUCE TURKEY)
          (EATS PISTACHIO-19 CUCUMBER-29)
          (EATS WONDERBREAD-119 GRAPEFRUIT)
          (EATS MUTTON SHRIMP)
          (EATS ORANGE GRAPEFRUIT-60)
          (CRAVES LONELINESS-268 ORANGE)
          (CRAVES PROSTATITIS-175 CHOCOLATE-34)
          (LOCALE WONDERBREAD-10 ALSACE-257)
          (HARMONY ACHIEVEMENT-246 NEPTUNE)
          (LOCALE PEPPER-59 MANITOBA)
          (CRAVES DEPRESSION-149 WURST-42)
          (EATS PORK POTATO)
          (CRAVES GRIEF-189 MELON-125)
          (EATS CHERRY KALE)
          (CRAVES LUBRICITY MELON-125)
          (EATS WURST-24 PISTACHIO)
          (HARMONY EXCITEMENT PLUTO)
          (CRAVES ANXIETY RICE-109)
          (CRAVES JEALOUSY-476 MUTTON-18)
          (EATS SCALLION-118 LAMB-113)
          (HARMONY SATIETY-253 NEPTUNE)
          (HARMONY EXCITEMENT-244 NEPTUNE)
          (CRAVES ABRASION-438 FLOUNDER-11)
          (CRAVES ABRASION-217 OKRA-114)
          (EATS TURKEY-28 PEAR)
          (EATS YOGURT-43 ONION-25)
          (EATS PAPAYA-12 SNICKERS)
          (CRAVES GRIEF-461 WURST-24)
          (CRAVES HANGOVER-146 YOGURT-43)
          (LOCALE MELON PENNSYLVANIA)
          (CRAVES SCIATICA SHRIMP-112)
          (CRAVES ENTERTAINMENT-84 PEPPER-59)
          (CRAVES ANGINA-313 MELON)
          (HARMONY AESTHETICS-78 MARS)
          (EATS OKRA-55 PEA-9)
          (LOCALE TUNA-44 BOSNIA)
          (CRAVES PROSTATITIS-429 SHRIMP-15)
          (CRAVES LONELINESS-451 CUCUMBER-29)
          (CRAVES LACERATION-460 WURST-24)
          (CRAVES TRIUMPH-74 TOFU-32)
          (CRAVES DREAD-179 POPOVER-33)
          (EATS GUAVA-21 MUFFIN)
          (CRAVES ENTERTAINMENT-92 HAMBURGER-47)
          (CRAVES AESTHETICS MUFFIN-124)
          (CRAVES BOILS-306 YOGURT)
          (CRAVES LACERATION-485 HOTDOG-62)
          (CRAVES SATISFACTION-245 ARUGULA)
          (EATS HAMBURGER SHRIMP-15)
          (EATS SHRIMP CHICKEN)
          (EATS LAMB BROCCOLI)
          (CRAVES ANXIETY-360 RICE)
          (CRAVES DREAD-471 PISTACHIO-19)
          (EATS CANTELOPE HOTDOG)
          (EATS MUFFIN GUAVA-21)
          (CRAVES ANXIETY-160 PEPPER-39)
          (EATS ONION SNICKERS)
          (EATS WONDERBREAD GUAVA-38)
          (CRAVES SCIATICA-151 TURKEY-41)
          (HARMONY SATISFACTION-100 MARS)
          (CRAVES DEPRESSION-274 TOFU)
          (CRAVES LOVE-77 KALE-23)
          (CRAVES JEALOUSY-414 MUFFIN-3)
          (CRAVES ANGER-508 OKRA-55)
          (HARMONY UNDERSTANDING-222 NEPTUNE)
          (LOCALE CHOCOLATE-34 BOSNIA)
          (EATS TOMATO-57 WONDERBREAD-10)
          (HARMONY CURIOSITY-256 NEPTUNE)
          (CRAVES AESTHETICS-67 RICE-8)
          (LOCALE HOTDOG ARIZONA)
          (EATS HAM-50 RICE)
          (HARMONY EXPECTATION-71 PLUTO)
          (EATS TOMATO APPLE-51)
          (EATS CHICKEN OKRA)
          (CRAVES ANGINA-368 MUTTON)
          (CRAVES JEALOUSY-290 BROCCOLI)
          (EATS CHOCOLATE HAM-40)
          (EATS BROCCOLI CUCUMBER-37)
          (ATTACKS BAVARIA-1023 GUANABARA-1024)
          (EATS TURKEY PORK)
          (CRAVES HANGOVER-430 SHRIMP-15)
          (EATS CHICKEN-2 HAM)
          (CRAVES ANGINA-401 SCALLION)
          (CRAVES ANXIETY-432 BACON-14)
          (CRAVES LOVE-104 CHOCOLATE-34)
          (EATS PEA-9 OKRA-55)
          (HARMONY AESTHETICS-67 PLUTO)
          (EATS SCALLOP LOBSTER-20)
          (CRAVES DEPRESSION-410 SCALLION-1)
          (CRAVES DEPRESSION-186 SCALLOP-126)
          (EATS CHERRY-53 RICE-8)
          (CRAVES SCIATICA-203 BROCCOLI-120)
          (EATS PAPAYA-12 ONION)
          (HARMONY SATISFACTION-228 NEPTUNE)
          (CRAVES ANGER-436 PAPAYA-12)
          (LOCALE ENDIVE-122 GOIAS)
          (CRAVES SCIATICA-190 MELON-125)
          (CRAVES DEPRESSION-459 ONION-25)
          (EATS CANTELOPE-54 GRAPEFRUIT)
          (HARMONY INTOXICATION-103 PLUTO)
          (LOCALE PEPPER QUEBEC)
          (EATS HOTDOG CANTELOPE)
          (CRAVES ANXIETY-473 PISTACHIO-19)
          (CRAVES SATISFACTION-100 PEPPER-39)
          (EATS TOMATO-117 CANTELOPE-108)
          (CRAVES HANGOVER-281 HAROSET)
          (EATS GRAPEFRUIT-60 ORANGE)
          (EATS BAGUETTE COD)
          (EATS YOGURT BROCCOLI-120)
          (HARMONY EXPECTATION-86 NEPTUNE)
          (EATS PEA-9 POPOVER-33)
          (CRAVES HANGOVER-318 PEA)
          (CRAVES SATISFACTION-228 CUCUMBER)
          (CRAVES DREAD-138 HAMBURGER-47)
          (CRAVES DEPRESSION-336 HOTDOG)
          (CRAVES HANGOVER-191 MUFFIN-124)
          (LOCALE SHRIMP-15 ARIZONA)
          (HARMONY STIMULATION-91 NEPTUNE)
          (EATS ORANGE ORANGE-13)
          (EATS GUAVA-21 BROCCOLI)
          (CRAVES ANGINA-466 CHOCOLATE-22)
          (CRAVES GRIEF-311 TUNA)
          (EATS LOBSTER CHICKEN-2)
          (EATS LEMON-64 GUAVA-21)
          (EATS PEA MELON)
          (CRAVES DEPRESSION-209 HAMBURGER-115)
          (LOCALE HAMBURGER GOIAS)
          (EATS COD-30 MUTTON-18)
          (CRAVES LACERATION-264 CHERRY)
          (CRAVES PROSTATITIS-135 PORK-48)
          (CRAVES SCIATICA-391 COD)
          (CRAVES BOILS-455 ARUGULA-26)
          (CRAVES ANXIETY-278 HAROSET)
          (EATS LEMON SWEETROLL-16)
          (EATS WONDERBREAD-10 CUCUMBER)
          (EATS BACON-14 SHRIMP)
          (CRAVES HANGOVER-478 POPOVER-17)
          (CRAVES CURIOSITY-256 CHICKEN-2)
          (EATS GUAVA-21 BROCCOLI-120)
          (LOCALE CANTELOPE-108 ALSACE-257)
          (CRAVES ANGINA-448 COD-30)
          (EATS HAROSET SCALLOP)
          (EATS BROCCOLI-120 YOGURT)
          (CRAVES LACERATION-500 TOMATO-57)
          (HARMONY STIMULATION-89 MARS)
          (LOCALE TOFU-32 ARIZONA)
          (CRAVES LACERATION-185 SCALLOP-126)
          (HARMONY CURIOSITY MARS)
          (EATS PEA HOTDOG)
          (EATS RICE-8 CHERRY-53)
          (LOCALE HAM-40 PENNSYLVANIA)
          (HARMONY INTOXICATION-72 MARS)
          (CRAVES BOILS MUTTON-110)
          (CRAVES JEALOUSY-479 POPOVER-17)
          (EATS PEPPER-59 FLOUNDER)
          (EATS RICE PEPPER-39)
          (EATS LOBSTER YOGURT)
          (LOCALE PAPAYA QUEBEC)
          (EATS SWEETROLL-16 KALE-23)
          (CRAVES HANGOVER-418 RICE-8)
          (HARMONY LOVE-242 NEPTUNE)
          (EATS OKRA SCALLOP-58)
          (EATS TOFU KALE)
          (HARMONY LEARNING-82 MARS)
          (CRAVES EXCITEMENT KALE-111)
          (CRAVES PROSTATITIS-416 RICE-8)
          (CRAVES DREAD-411 POTATO-4)
          (CRAVES LACERATION MUTTON-110)
          (CRAVES EMPATHY-234 WURST)
          (EATS CUCUMBER WONDERBREAD-10)
          (EATS MUTTON TOMATO)
          (EATS ORANGE WONDERBREAD)
          (EATS WURST ONION)
          (LOCALE PORK-107 BAVARIA-1023)
          (EATS WURST-24 SWEETROLL)
          (CRAVES SATIETY-98 TURKEY-41)
          (CRAVES BOILS-505 OKRA-55)
          (HARMONY EMPATHY-225 NEPTUNE)
          (EATS OKRA-114 HAMBURGER-115)
          (LOCALE POPOVER-33 ALSACE-257)
          (CRAVES ANGINA-143 TUNA-44)
          (EATS BROCCOLI TUNA-121)
          (EATS MARZIPAN YOGURT)
          (CRAVES TRIUMPH BROCCOLI-120)
          (EATS PAPAYA PEPPER-59)
          (CRAVES LACERATION-167 PEA-36)
          (LOCALE HAROSET-5 MANITOBA)
          (CRAVES ANXIETY-439 WONDERBREAD-10)
          (CRAVES ANGINA-154 TURKEY-41)
          (EATS SCALLOP HAROSET)
          (CRAVES LONELINESS-415 RICE-8)
          (CRAVES PROSTATITIS-294 TURKEY)
          (CRAVES INTOXICATION-221 POPOVER)
          (CRAVES ANGINA-345 CHICKEN)
          (LOCALE HAM GOIAS)
          (CRAVES LACERATION-155 HAM-40)
          (CRAVES ANGER-367 MUTTON)
          (CRAVES HANGOVER-204 BROCCOLI-120)
          (CRAVES DREAD-490 GRAPEFRUIT-60)
          (HARMONY SATIETY PLUTO)
          (CRAVES ABRASION-413 MUFFIN-3)
          (LOCALE TOMATO GOIAS)
          (LOCALE PAPAYA-116 BOSNIA)
          (CRAVES ENTERTAINMENT-229 LETTUCE)
          (CRAVES ABRASION-502 YOGURT-56)
          (CRAVES ANGER-156 HAM-40)
          (HARMONY EMPATHY-248 MARS)
          (CRAVES LONELINESS-424 HAROSET-5)
          (CRAVES CURIOSITY-232 PEA)
          (HARMONY STIMULATION-243 PLUTO)
          (HARMONY LUBRICITY-239 MARS)
          (EATS POPOVER-33 PEA-9)
          (EATS GUAVA-38 PEA)
          (CRAVES ANXIETY-327 WURST)
          (LOCALE BAGUETTE-61 BOSNIA)
          (EATS MELON PEA)
          (EATS SNICKERS PEA)
          (CRAVES ANGINA-428 SWEETROLL-16)
          (CRAVES LACERATION-408 SCALLION-1)
          (CRAVES GRIEF SHRIMP-112)
          (EATS LAMB-113 OKRA-114)
          (CRAVES BOILS-316 PEA)
          (LOCALE SHRIMP OREGON)
          (HARMONY LOVE-230 PLUTO)
          (EATS APPLE-51 TOMATO)
          (CRAVES ANGER-140 ENDIVE-46)
          (CRAVES ANGINA-180 SNICKERS-128)
          (EATS MUTTON-18 FLOUNDER)
          (EATS BROCCOLI-120 GUAVA-21)
          (EATS OKRA-114 PAPAYA-116)
          (CRAVES ANGINA-456 ARUGULA-26)
          (CRAVES JEALOUSY-202 BROCCOLI-120)
          (CRAVES HANGOVER-375 CHOCOLATE)
          (EATS APPLE-51 TUNA-44)
          (EATS TURKEY-28 KALE)
          (CRAVES JEALOUSY-350 PORK)
          (EATS SNICKERS-128 APPLE)
          (CRAVES SCIATICA-488 GRAPEFRUIT-60)
          (LOCALE POTATO-127 GUANABARA-1024)
          (EATS TUNA POTATO)
          (LOCALE CUCUMBER-29 OREGON)
          (EATS ARUGULA MARZIPAN-7)
          (LOCALE CHERRY-53 BAVARIA)
          (LOCALE FLOUNDER BAVARIA)
          (CRAVES JEALOUSY-388 ENDIVE)
          (EATS TURKEY-28 MARZIPAN-123)
          (CRAVES ENTERTAINMENT-254 SCALLION)
          (EATS SHRIMP-112 SCALLION-118)
          (EATS PEA-36 GRAPEFRUIT-60)
          (CRAVES SCIATICA-309 HAMBURGER)
          (CRAVES BOILS-158 PEPPER-39)
          (EATS RICE OKRA-55)
          (CRAVES ANXIETY-486 HOTDOG-62)
          (HARMONY UNDERSTANDING-106 NEPTUNE)
          (EATS BROCCOLI-45 TURKEY)
          (EATS MELON-31 OKRA)
          (CRAVES EXPECTATION-86 OKRA-55)
          (CRAVES JEALOUSY-259 FLOUNDER)
          (CRAVES JEALOUSY-463 KALE-23)
          (EATS TURKEY PEPPER-59)
          (EATS LOBSTER LETTUCE-63)
          (CRAVES HANGOVER-499 TOMATO-57)
          (EATS MARZIPAN-123 BROCCOLI)
          (EATS FLOUNDER-11 TURKEY)
          (EATS KALE-23 BROCCOLI)
          (EATS MUFFIN-3 OKRA)
          (EATS SHRIMP-15 WURST)
          (CRAVES DEPRESSION-381 WONDERBREAD)
          (EATS WONDERBREAD ORANGE)
          (CRAVES ACHIEVEMENT-69 SWEETROLL-16)
          (EATS LAMB HOTDOG-62)
          (CRAVES JEALOUSY-317 PEA)
          (ATTACKS MORAVIA MANITOBA)
          (CRAVES CURIOSITY-95 TUNA-44)
          (CRAVES EMPATHY-248 BAGUETTE)
          (EATS LAMB-113 PORK-107)
          (CRAVES JEALOUSY-443 PEA-9)
          (CRAVES ABRASION-152 TURKEY-41)
          (EATS GUAVA-21 PEAR)
          (CRAVES ANXIETY-338 MUFFIN)
          (EATS WONDERBREAD-10 TOMATO-57)
          (EATS SHRIMP BACON-14)
          (CRAVES GRIEF-177 POPOVER-33)
          (CRAVES GRIEF-162 GUAVA-38)
          (HARMONY REST-81 MARS)
          (HARMONY ENTERTAINMENT-84 MARS)
          (HARMONY CURIOSITY-79 NEPTUNE)
          (LOCALE MARZIPAN-123 BAVARIA-1023)
          (CRAVES SATISFACTION-255 PAPAYA)
          (EATS LEMON-64 SHRIMP)
          (EATS ONION-25 SWEETROLL)
          (CRAVES ANGER-305 SHRIMP)
          (CRAVES ABRASION-323 SWEETROLL)
          (LOCALE FLOUNDER-35 GUANABARA-1024)
          (CRAVES DEPRESSION-433 ORANGE-13)
          (CRAVES HANGOVER-174 CHOCOLATE-34)
          (CRAVES GRIEF-484 LETTUCE-63)
          (CRAVES ANXIETY-291 TURKEY)
          (CRAVES REST-241 KALE)
          (CRAVES ANGINA-504 YOGURT-56)
          (EATS POTATO YOGURT-56)
          (EATS MUTTON APPLE)
          (EATS ORANGE-13 ORANGE)
          (CRAVES ANGINA-324 WURST)
          (EATS BEEF-49 LAMB)
          (CRAVES LUBRICITY-93 ENDIVE-46)
          (CRAVES DREAD-511 LAMB-52)
          (EATS TURKEY LETTUCE)
          (CRAVES EMPATHY OKRA-114)
          (LOCALE OKRA-55 MANITOBA)
          (CRAVES ANGER-347 KALE)
          (CRAVES ABRASION-407 CHICKEN-2)
          (LOCALE POPOVER-17 ARIZONA)
          (CRAVES LONELINESS CANTELOPE-108)
          (ATTACKS BOSNIA OREGON)
          (EATS HAM-40 RICE)
          (EATS RICE HAM-50)
          (CRAVES ANXIETY-394 LAMB)
          (EATS PAPAYA-12 HAROSET-5)
          (LOCALE BACON QUEBEC)
          (CRAVES UNDERSTANDING-235 BEEF)
          (LOCALE LOBSTER-20 MANITOBA)
          (EATS SCALLOP-58 OKRA)
          (CRAVES DREAD-349 KALE)
          (HARMONY CURIOSITY-95 NEPTUNE)
          (EATS PAPAYA-116 CANTELOPE-108)
          (LOCALE KALE-111 BAVARIA-1023)
          (CRAVES ABRASION-450 COD-30)
          (CRAVES LACERATION-395 CANTELOPE)
          (CRAVES ANGINA-480 LEMON-64)
          (EATS SCALLION CHOCOLATE-34)
          (EATS KALE CHERRY)
          (CRAVES ANGER-359 RICE)
          (LOCALE ONION ALSACE)
          (EATS TUNA PORK-48)
          (EATS MUFFIN LEMON-64)
          (HARMONY ACHIEVEMENT-220 MARS)
          (CRAVES SATIETY-87 CHERRY-53)
          (EATS GRAPEFRUIT WONDERBREAD-119)
          (LOCALE BROCCOLI-45 GOIAS)
          (CRAVES DREAD-492 PEPPER-59)
          (CRAVES UNDERSTANDING-88 LAMB-52)
          (EATS HAMBURGER-47 ARUGULA-26)
          (ORBITS JUPITER NEPTUNE)
          (EATS SNICKERS-6 PEAR-27)
          (CRAVES DREAD-322 SWEETROLL)
          (CRAVES LEARNING TOMATO-117)
          (EATS LEMON CHOCOLATE-34)
          (EATS MUFFIN-124 BEEF-49)
          (CRAVES AESTHETICS-90 HAM-50)
          (EATS YOGURT OKRA)
          (CRAVES ABRASION-307 YOGURT)
          (LOCALE SWEETROLL GOIAS)
          (CRAVES HANGOVER-510 CHERRY-53)
          (LOCALE BEEF-49 ALSACE)
          (CRAVES EXPECTATION TUNA-121)
          (EATS PORK ONION)
          (EATS APPLE PEPPER)
          (EATS SHRIMP-112 RICE-109)
          (EATS PEA POTATO-127)
          (EATS ONION PAPAYA-12)
          (LOCALE MUFFIN-124 OREGON)
          (EATS POPOVER PEPPER)
          (CRAVES ABRASION LAMB-113)
          (LOCALE PISTACHIO-19 PENNSYLVANIA)
          (CRAVES EXCITEMENT-244 GUAVA)
          (HARMONY UNDERSTANDING-235 MARS)
          (CRAVES PROSTATITIS-280 HAROSET)
          (LOCALE PEAR GUANABARA-1024)
          (HARMONY AESTHETICS PLUTO)
          (EATS ARUGULA-26 HAMBURGER-47)
          (EATS BAGUETTE-61 FLOUNDER)
          (HARMONY ACHIEVEMENT-69 MARS)
          (EATS PEA HAROSET-5)
          (CRAVES BOILS-435 ORANGE-13)
          (EATS YOGURT-43 HOTDOG)
          (CRAVES GRIEF-137 HAMBURGER-47)
          (CRAVES ABRASION-286 POTATO)
          (CRAVES JEALOUSY-129 APPLE-51)
          (CRAVES LONELINESS-150 WURST-42)
          (LOCALE CANTELOPE GUANABARA-1024)
          (EATS TUNA LAMB-52)
          (HARMONY SATISFACTION-245 MARS)
          (LOCALE SCALLION GUANABARA-1024)
          (EATS TURKEY FLOUNDER-11)
          (HARMONY LUBRICITY-73 NEPTUNE)
          (EATS CHOCOLATE-34 LEMON)
          (CRAVES LONELINESS-303 SHRIMP)
          (EATS HOTDOG-62 LEMON)
          (CRAVES SCIATICA-403 PAPAYA)
          (EATS CANTELOPE SWEETROLL)
          (LOCALE WURST OREGON)
          (EATS HAMBURGER GUAVA)
          (CRAVES PROSTATITIS-298 APPLE)
          (EATS SCALLION-118 HAMBURGER-115)
          (CRAVES DREAD-422 SNICKERS-6)
          (LOCALE ORANGE PENNSYLVANIA)
          (CRAVES HANGOVER-329 BEEF)
          (EATS GUAVA HAMBURGER)
          (LOCALE HAROSET QUEBEC)
          (LOCALE HAMBURGER-115 GOIAS)
          (CRAVES DREAD-328 BEEF)
          (EATS ONION PORK)
          (CRAVES ACHIEVEMENT-246 CHOCOLATE)
          (EATS COD BAGUETTE)
          (EATS GUAVA-38 WONDERBREAD)
          (EATS BROCCOLI MARZIPAN-123)
          (EATS SCALLOP-58 SCALLOP)
          (EATS FLOUNDER PEPPER-59)
          (CRAVES ANGER-331 ONION)
          (EATS CHERRY-53 LETTUCE)
          (EATS MELON-125 PEPPER)
          (CRAVES HANGOVER-404 PAPAYA)
          (CRAVES DEPRESSION-299 CUCUMBER)
          (CRAVES GRIEF-380 WONDERBREAD)
          (HARMONY TRIUMPH-74 MARS)
          (LOCALE TURKEY-41 BAVARIA)
          (EATS LETTUCE CUCUMBER)
          (CRAVES ANXIETY-211 PAPAYA-116)
          (CRAVES LONELINESS-325 WURST)
          (EATS ARUGULA ENDIVE-46)
          (EATS BROCCOLI KALE-23)
          (CRAVES GRIEF-365 ARUGULA)
          (CRAVES REST-97 WURST-42)
          (CRAVES INTOXICATION-240 CHICKEN)
          (CRAVES SCIATICA-269 LEMON)
          (CRAVES BOILS-260 MARZIPAN)
          (EATS SCALLION-1 COD)
          (LOCALE GRAPEFRUIT-60 GOIAS)
          (EATS CANTELOPE-108 TOMATO-117)
          (LOCALE LETTUCE-63 BAVARIA)
          (CRAVES DREAD-153 TURKEY-41)
          (EATS OKRA MELON-31)
          (EATS MARZIPAN-123 TURKEY-28)
          (LOCALE LEMON OREGON)
          (HARMONY ENTERTAINMENT NEPTUNE)
          (EATS HAMBURGER-47 SCALLION-1)
          (CRAVES EXPECTATION-231 TUNA)
          (EATS HAM TOFU)
          (HARMONY AESTHETICS-90 NEPTUNE)
          (EATS PORK MARZIPAN-7)
          (EATS TOMATO-117 RICE-109)
          (EATS CUCUMBER POPOVER-17)
          (CRAVES ANGER-402 PAPAYA)
          (CRAVES JEALOUSY-181 SNICKERS-128)
          (EATS KALE-23 SWEETROLL-16)
          (CRAVES SCIATICA-378 CHOCOLATE)
          (CRAVES GRIEF-297 APPLE)
          (EATS SWEETROLL CANTELOPE)
          (EATS TUNA TURKEY)
          (EATS BACON APPLE)
          (CRAVES GRIEF-197 ENDIVE-122)
          (CRAVES LACERATION-431 BACON-14)
          (LOCALE BACON-14 BOSNIA)
          (LOCALE HOTDOG-62 ALSACE-257)
          (LOCALE SCALLION-118 ARIZONA)
          (EATS MELON-31 BACON)
          (EATS ENDIVE BACON-14)
          (EATS PISTACHIO WURST-24)
          (EATS LAMB BEEF-49)
          (EATS CUCUMBER ARUGULA-26)
          (CRAVES HANGOVER-301 CUCUMBER)
          (CRAVES JEALOUSY-300 CUCUMBER)
          (LOCALE WURST-42 BAVARIA-1023)
          (EATS BEEF ORANGE-13)
          (CRAVES HANGOVER-393 LAMB)
          (CRAVES TRIUMPH-227 APPLE)
          (LOCALE LAMB-113 GOIAS)
          (CRAVES EMPATHY-225 BROCCOLI)
          (CRAVES ACHIEVEMENT-94 BROCCOLI-45)
          (EATS PEPPER MELON-125)
          (EATS ENDIVE-46 ONION)
          (EATS KALE TURKEY-28)
          (EATS PEPPER POPOVER)
          (HARMONY SATIETY-87 PLUTO)
          (EATS MUTTON-110 TOMATO-117)
          (ATTACKS MANITOBA QUEBEC)
          (EATS COD SCALLION-1)
          (CRAVES ANGER PORK-107)
          (EATS SCALLOP-126 MARZIPAN)
          (EATS SWEETROLL GRAPEFRUIT)
          (CRAVES DREAD-166 PEA-36)
          (CRAVES DEPRESSION-161 GUAVA-38)
          (HARMONY EMPATHY-234 PLUTO)
          (EATS LAMB-52 WONDERBREAD-119)
          (CRAVES ANGINA-261 MARZIPAN)
          (CRAVES LONELINESS-493 PEPPER-59)
          (HARMONY ENTERTAINMENT-238 MARS)
          (EATS CUCUMBER-37 BROCCOLI)
          (HARMONY LOVE-104 MARS)
          (CRAVES LACERATION-270 LEMON)
          (CRAVES GRIEF-421 SNICKERS-6)
          (CRAVES LACERATION-470 LOBSTER-20)
          (EATS BEEF-49 MUFFIN-124)
          (EATS BROCCOLI-45 PAPAYA)
          (LOCALE MUFFIN GUANABARA-1024)
          (CRAVES DEPRESSION-285 OKRA)
          (CRAVES DREAD-386 BACON)
          (CRAVES LONELINESS-406 CHICKEN-2)
          (EATS MUTTON-110 KALE-111)
          (EATS CUCUMBER POPOVER)
          (ORBITS MARS PLUTO)
          (LOCALE COD ALSACE-257)
          (LOCALE LOBSTER GOIAS)
          (CRAVES LACERATION-354 PEAR)
          (CRAVES SCIATICA-326 WURST)
          (EATS WONDERBREAD PISTACHIO-19)
          (EATS OKRA YOGURT)
          (EATS PAPAYA CHOCOLATE-22)
          (CRAVES EMPATHY-102 PEA-36)
          (EATS POTATO-127 PEA)
          (LOCALE TOMATO-57 GOIAS)
          (CRAVES ABRASION-198 ENDIVE-122)
          (EATS PEA SNICKERS)
          (CRAVES ANXIETY-188 MELON-125)
          (CRAVES ANGINA-201 BROCCOLI-120)
          (EATS BEEF MELON)
          (EATS LEMON-64 MUFFIN)
          (CRAVES PROSTATITIS-494 SCALLOP-58)
          (EATS HAROSET-5 PAPAYA-12)
          (CRAVES DEPRESSION-474 PISTACHIO-19)
          (LOCALE POPOVER ALSACE)
          (EATS GRAPEFRUIT COD-30)
          (CRAVES REST-81 MUTTON-18)
          (CRAVES DREAD-207 HAMBURGER-115)
          (CRAVES REST-251 LAMB)
          (EATS SCALLION-1 HAMBURGER-47)
          (CRAVES LOVE SHRIMP-112)
          (CRAVES SCIATICA-501 YOGURT-56)
          (CRAVES LONELINESS-372 LOBSTER)
          (EATS PORK-48 FLOUNDER-11)
          (LOCALE YOGURT-56 BAVARIA-1023)
          (HARMONY LOVE MARS)
          (LOCALE CHICKEN MANITOBA)
          (CRAVES ANXIETY-374 LOBSTER)
          (ATTACKS ARIZONA BOSNIA)
          (EATS LOBSTER-20 SCALLOP)
          (CRAVES SCIATICA-210 PAPAYA-116)
          (CRAVES TRIUMPH-247 WONDERBREAD)
          (CRAVES UNDERSTANDING-65 SCALLION-1)
          (EATS SWEETROLL HAROSET-5)
          (CRAVES JEALOUSY-214 TOMATO-117)
          (CRAVES LACERATION-377 CHOCOLATE)
          (EATS POTATO PISTACHIO)
          (CRAVES BOILS-176 CHOCOLATE-34)
          (CRAVES PROSTATITIS-445 TOFU-32)
          (EATS SCALLOP SCALLOP-58)
          (EATS PEAR-27 POPOVER)
          (LOCALE GUAVA BAVARIA)
          (EATS MELON-125 MUTTON)
          (EATS PEAR-27 SNICKERS-6)
          (EATS YOGURT LOBSTER)
          (HARMONY EXPECTATION-96 NEPTUNE)
          (EATS OKRA-55 RICE)
          (EATS KALE-111 SCALLION-118)
          (EATS TURKEY BROCCOLI-45)
          (CRAVES DEPRESSION-344 TOMATO)
          (LOCALE SHRIMP-112 GUANABARA-1024)
          (HARMONY REST-251 MARS)
          (LOCALE APPLE QUEBEC)
          (EATS MELON-31 SCALLOP)
          (CRAVES BOILS-446 MELON-31)
          (CRAVES BOILS-184 SCALLOP-126)
          (CRAVES ANGER-483 LETTUCE-63)
          (CRAVES HANGOVER-458 ARUGULA-26)
          (CRAVES ANGER-389 PISTACHIO)
          (CRAVES LUBRICITY-70 SHRIMP-15)
          (CRAVES ABRASION-266 CHERRY)
          (CRAVES JEALOUSY-139 HAMBURGER-47)
          (EATS BACON HAROSET)
          (LOCALE PORK BOSNIA)
          (LOCALE WONDERBREAD-119 GUANABARA-1024)
          (EATS CUCUMBER-29 SCALLION)
          (EATS POTATO-127 CUCUMBER-29)
          (LOCALE ARUGULA GOIAS)
          (CRAVES LACERATION-295 APPLE)
          (LOCALE YOGURT-43 ALSACE-257)
          (EATS HAMBURGER-115 PORK-107)
          (CRAVES BOILS-192 MUFFIN-124)
          (LOCALE RICE-109 BAVARIA)
          (HARMONY ENTERTAINMENT-92 MARS)
          (CRAVES PROSTATITIS PORK-107)
          (EATS HAMBURGER-115 OKRA-114)
          (CRAVES ANGER-292 TURKEY)
          (EATS WURST-42 LEMON-64)
          (LOCALE CHICKEN-2 GOIAS)
          (CRAVES EXCITEMENT-85 SCALLOP-58)
          (HARMONY ACHIEVEMENT PLUTO)
          (CRAVES JEALOUSY-352 PORK)
          (CRAVES GRIEF-335 HOTDOG)
          (EATS TURKEY TUNA)
          (CRAVES LACERATION-339 SCALLOP)
          (EATS TURKEY-41 RICE)
          (HARMONY EMPATHY MARS)
          (EATS CHOCOLATE-34 SCALLION)
          (HARMONY INTOXICATION-240 NEPTUNE)
          (EATS KALE TOFU)
          (CRAVES HANGOVER PORK-107)
          (EATS POTATO TUNA)
          (EATS HAM-40 CHOCOLATE)
          (EATS POPOVER PEAR-27)
          (CRAVES LACERATION-333 ONION)
          (LOCALE OKRA MANITOBA)
          (CRAVES LACERATION-144 YOGURT-43)
          (CRAVES PROSTATITIS-193 MUFFIN-124)
          (HARMONY INTOXICATION MARS)
          (EATS PEPPER-59 TURKEY)
          (CRAVES GRIEF-405 CHICKEN-2)
          (CRAVES CURIOSITY HAMBURGER-115)
          (HARMONY EMPATHY-76 MARS)
          (CRAVES BOILS-417 RICE-8)
          (EATS BACON-14 ENDIVE)
          (CRAVES LACERATION-440 WONDERBREAD-10)
          (EATS POPOVER CUCUMBER)
          (EATS BAGUETTE HAROSET)
          (EATS GRAPEFRUIT CANTELOPE-54)
          (CRAVES TRIUMPH-101 CUCUMBER-37)
          (EATS MELON BEEF)
          (CRAVES GRIEF-279 HAROSET)
          (ATTACKS OREGON PENNSYLVANIA)
          (EATS BEEF PEA-36)
          (CRAVES ABRASION-131 HAM-50)
          (EATS MUTTON-18 COD-30)
          (CRAVES ABRASION-330 BEEF)
          (CRAVES LEARNING-105 SNICKERS-128)
          (CRAVES ABRASION-165 PEA-36)
          (CRAVES LACERATION-319 PEA)
          (CRAVES GRIEF-503 YOGURT-56)
          (EATS POPOVER-17 CUCUMBER)
          (EATS CUCUMBER-37 TURKEY-28)
          (EATS SHRIMP-15 HAMBURGER)
          (CRAVES LOVE-230 SHRIMP)
          (EATS SHRIMP-15 POPOVER-17)
          (EATS SCALLOP MELON-31)
          (EATS LOBSTER PEAR)
          (EATS TOMATO MUTTON)
          (CRAVES PROSTATITIS-373 LOBSTER)
          (LOCALE TURKEY-28 ARIZONA)
          (EATS YOGURT-56 FLOUNDER-11)
          (CRAVES HANGOVER-262 MARZIPAN)
          (CRAVES ENTERTAINMENT MUTTON-110)
          (CRAVES SCIATICA-454 PEAR-27)
          (EATS PEPPER-39 ONION-25)
          (HARMONY EXPECTATION NEPTUNE)
          (EATS TOFU-32 COD-30)
          (EATS PEAR LOBSTER)
          (CRAVES JEALOUSY-157 PEPPER-39)
          (CRAVES ABRASION-469 GUAVA-21)
          (EATS ENDIVE-122 BAGUETTE)
          (CRAVES SCIATICA-341 SCALLOP)
          (EATS TUNA-121 MUTTON)
          (EATS LAMB-113 SCALLION-118)
          (EATS ORANGE-13 BEEF)
          (LOCALE YOGURT MORAVIA)
          (EATS ONION WURST)
          (EATS POPOVER-17 SHRIMP-15)
          (EATS TOMATO-117 MUTTON-110)
          (ATTACKS GUANABARA-1024 ALSACE-257)
          (CRAVES ANGER-495 SCALLOP-58)
          (EATS TOFU MARZIPAN)
          (LOCALE LAMB-52 ARIZONA)
          (EATS SWEETROLL ONION-25)
          (CRAVES INTOXICATION-103 FLOUNDER-35)
          (CRAVES ABRASION-342 SCALLOP)
          (EATS RICE TURKEY-41)
          (LOCALE LETTUCE ARIZONA)
          (CRAVES LACERATION-308 YOGURT)
          (EATS HAMBURGER-115 OKRA)
          (CRAVES PROSTATITIS-457 ARUGULA-26)
          (EATS FLOUNDER BAGUETTE-61)
          (CRAVES UNDERSTANDING-222 TOFU)
          (CRAVES EXPECTATION-71 ORANGE-13)
          (CRAVES ANGINA-169 FLOUNDER-35)
          (EATS PORK-107 HAMBURGER-115)
          (CRAVES STIMULATION-68 SNICKERS-6)
          (EATS POTATO PORK)
          (HARMONY LUBRICITY-70 MARS)
          (HARMONY REST-97 MARS)
          (EATS TOMATO-57 ONION)
          (CRAVES ANGER-218 LAMB-113)
          (HARMONY UNDERSTANDING-88 PLUTO)
          (HARMONY LEARNING-249 NEPTUNE)
          (LOCALE SNICKERS-6 QUEBEC)
          (CRAVES PROSTATITIS-136 PORK-48)
          (LOCALE CHOCOLATE GUANABARA-1024)
          (LOCALE ORANGE-13 BOSNIA)
          (LOCALE TURKEY ALSACE-257)
          (CRAVES SATIETY-236 ONION)
          (EATS ARUGULA LETTUCE)
          (EATS POTATO-4 ENDIVE)
          (EATS FLOUNDER-35 PEAR)
          (CRAVES PROSTATITIS-343 TOMATO)
          (HARMONY REST-241 PLUTO)
          (CRAVES SATISFACTION PAPAYA-116)
          (HARMONY STIMULATION-68 NEPTUNE)
          (LOCALE TOFU PENNSYLVANIA)
          (EATS SWEETROLL-16 LEMON)
          (CRAVES HANGOVER-293 TURKEY)
          (CRAVES AESTHETICS-78 CHOCOLATE-22)
          (CRAVES DEPRESSION-132 BEEF-49)
          (EATS OKRA MUFFIN-3)
          (EATS ONION ENDIVE-46)
          (EATS APPLE-51 MUFFIN-124)
          (EATS CHICKEN SHRIMP)
          (LOCALE PISTACHIO BOSNIA)
          (CRAVES LONELINESS-348 KALE)
          (CRAVES HANGOVER-163 CUCUMBER-37)
          (EATS PORK-48 TUNA)
          (LOCALE GUAVA-38 GUANABARA-1024)
          (LOCALE SWEETROLL-16 BOSNIA)
          (CRAVES JEALOUSY-271 LEMON)
          (CRAVES DREAD-273 POPOVER)
          (CRAVES SCIATICA-441 PEA-9)
          (CRAVES ENTERTAINMENT-238 SCALLOP)
          (CRAVES BOILS-145 YOGURT-43)
          (CRAVES DEPRESSION-498 TOMATO-57)
          (EATS GRAPEFRUIT SWEETROLL)
          (CRAVES PROSTATITIS-398 HAM)
          (EATS PEAR TURKEY-28)
          (EATS MARZIPAN LOBSTER-20)
          (EATS LEMON HOTDOG-62)
          (EATS BEEF-49 POPOVER)
          (HARMONY TRIUMPH-101 NEPTUNE)
          (CRAVES SCIATICA-356 PEAR)
          (CRAVES DEPRESSION-267 ORANGE)
          (ATTACKS SURREY ALSACE)
          (CRAVES LONELINESS-355 PEAR)
          (EATS ONION-25 PEPPER-39)
          (CRAVES ANGINA-288 BROCCOLI)
          (EATS PAPAYA-116 SHRIMP-112)
          (EATS PAPAYA-12 POTATO)
          (CRAVES STIMULATION-243 PEAR)
          (HARMONY CURIOSITY-232 MARS)
          (EATS APPLE MUFFIN-3)
          (EATS MARZIPAN-7 PORK)
          (EATS LETTUCE CHERRY-53)
          (CRAVES ANGER-315 MELON)
          (EATS BACON MELON-31)
          (CRAVES JEALOUSY KALE-111)
          (CRAVES BOILS-289 BROCCOLI)
          (CRAVES ANXIETY-420 SNICKERS-6)
          (LOCALE SCALLION-1 MORAVIA)
          (EATS ENDIVE-46 ARUGULA)
          (CRAVES BOILS-340 SCALLOP)
          (EATS POTATO PAPAYA-12)
          (EATS CANTELOPE-108 PAPAYA-116)
          (EATS APPLE SNICKERS-128)
          (CRAVES GRIEF-346 KALE)
          (EATS BAGUETTE-61 CHOCOLATE)
          (CRAVES ABRASION-363 GRAPEFRUIT)
          (CRAVES ANXIETY-302 LETTUCE)
          (EATS HAROSET BACON)
          (LOCALE APPLE-51 ARIZONA)
          (EATS OKRA-114 LAMB-113)
          (CRAVES LONELINESS-320 SWEETROLL)
          (LOCALE PORK-48 ALSACE-257)
          (EATS PEPPER-59 PAPAYA)
          (HARMONY EXCITEMENT-226 NEPTUNE)
          (LOCALE BEEF BOSNIA)
          (EATS MELON POPOVER-33)
          (LOCALE GRAPEFRUIT GUANABARA-1024)
          (EATS RICE-8 HAROSET)
          (CRAVES LONELINESS-449 COD-30)
          (CRAVES SCIATICA-312 MELON)
          (EATS PAPAYA-116 OKRA-114)
          (CRAVES ANGINA-412 MUFFIN-3)
          (CRAVES PROSTATITIS-314 MELON)
          (CRAVES ANGINA-215 SCALLION-118)
          (EATS CHERRY CUCUMBER-37)
          (LOCALE ENDIVE-46 MORAVIA)
          (HARMONY TRIUMPH-252 NEPTUNE)
          (CRAVES INTOXICATION-72 PAPAYA-12)
          (EATS TURKEY HAROSET)
          (CRAVES BOILS-509 CANTELOPE-54)
          (EATS SNICKERS ONION)
          (EATS PEPPER-39 RICE)
          (EATS CANTELOPE-54 TOFU-32)
          (EATS COD-30 TOFU-32)
          (CRAVES JEALOUSY-376 CHOCOLATE)
          (HARMONY SATIETY-98 NEPTUNE)
          (CRAVES LONELINESS-481 LETTUCE-63)
          (CRAVES PROSTATITIS-183 POTATO-127)
          (LOCALE MARZIPAN-7 GUANABARA-1024)
          (EATS YOGURT-56 POTATO)
          (CRAVES SATISFACTION-75 ONION-25)
          (EATS MUFFIN POTATO-4)
          (EATS SCALLOP-126 HAM)
          (EATS HAROSET BAGUETTE)
          (EATS ARUGULA-26 CUCUMBER)
          (EATS PEAR GUAVA-21)
          (EATS BROCCOLI GUAVA-21)
          (HARMONY UNDERSTANDING MARS)
          (EATS MARZIPAN LETTUCE-63)
          (CRAVES GRIEF-447 MELON-31)
          (HARMONY LOVE-66 NEPTUNE)
          (ATTACKS BAVARIA MORAVIA)
          (CRAVES HANGOVER-358 RICE)
          (EATS CHERRY BROCCOLI)
          (HARMONY LOVE-77 MARS)
          (EATS HAM-50 ORANGE-13)
          (HARMONY SATISFACTION-255 MARS)
          (CRAVES LOVE-66 POTATO-4)
          (CRAVES DREAD-437 FLOUNDER-11)
          (CRAVES DEPRESSION-164 CUCUMBER-37)
          (HARMONY STIMULATION-223 PLUTO)
          (CRAVES ABRASION-384 BAGUETTE)
          (LOCALE SNICKERS-128 OREGON)
          (HARMONY SATISFACTION-75 NEPTUNE)
          (LOCALE HAM-50 BAVARIA)
          (EATS PEAR FLOUNDER-35)
          (EATS SNICKERS-6 GUAVA)
          (LOCALE KALE-23 ALSACE-257)
          (EATS WURST SHRIMP-15)
          (LOCALE TOMATO-117 GOIAS)
          (EATS SNICKERS-128 HAROSET)
          (EATS WONDERBREAD-119 LAMB-52)
          (CRAVES LONELINESS-385 BACON)
          (EATS ENDIVE-122 POPOVER)
          (EATS PISTACHIO-19 LEMON)
          (LOCALE WONDERBREAD PENNSYLVANIA)
          (LOCALE LEMON-64 BAVARIA-1023)
          (CRAVES ANGER-453 TURKEY-28)
          (EATS SCALLION CUCUMBER-29)
          (EATS BAGUETTE ENDIVE-122)
          (CRAVES EXCITEMENT-226 TURKEY)
          (HARMONY LUBRICITY-93 PLUTO)
          (CRAVES GRIEF-366 ARUGULA)
          (LOCALE MUFFIN-3 OREGON)
          (CRAVES INTOXICATION-83 BAGUETTE-61)
          (CRAVES LUBRICITY-73 PEA-9)
          (CRAVES LOVE-242 PORK)
          (HARMONY INTOXICATION-221 NEPTUNE)
          (LOCALE ENDIVE OREGON)
          (CRAVES LONELINESS-142 BROCCOLI-45)
          (CRAVES STIMULATION RICE-109)
          (EATS FLOUNDER TURKEY)
          (CRAVES SCIATICA-147 YOGURT-43)
          (LOCALE MUTTON-110 GUANABARA-1024)
          (CRAVES LACERATION-507 OKRA-55)
          (EATS ORANGE-13 HAM-50)
          (LOCALE CHOCOLATE-22 PENNSYLVANIA)
          (CRAVES ANGER-275 TOFU)
          (EATS HAROSET RICE-8)
          (EATS POPOVER-33 MELON)
          (EATS RICE HAM-40)
          (CRAVES ANGER-172 FLOUNDER-35)
          (CRAVES BOILS-277 TOFU)
          (EATS CUCUMBER-37 CHERRY)
          (LOCALE FLOUNDER-11 BAVARIA-1023)
          (CRAVES DEPRESSION-361 GUAVA)
          (CRAVES ANGER-425 HAROSET-5)
          (CRAVES DEPRESSION-370 SNICKERS)
          (CRAVES LONELINESS-130 APPLE-51)
          (CRAVES DREAD-282 OKRA)
          (CRAVES BOILS-369 SNICKERS)
          (CRAVES PROSTATITIS-491 GRAPEFRUIT-60)
          (CRAVES UNDERSTANDING LAMB-113)
          (CRAVES DEPRESSION-196 MARZIPAN-123)
          (EATS HAROSET-5 SWEETROLL)
          (EATS WURST-42 BROCCOLI)
          (CRAVES PROSTATITIS-206 WONDERBREAD-119)
          (LOCALE ONION-25 OREGON)
          (CRAVES JEALOUSY-426 HAROSET-5)
          (CRAVES DEPRESSION-396 CANTELOPE)
          (LOCALE GUAVA-21 GOIAS)
          (EATS POPOVER BEEF-49)
          (LOCALE POTATO OREGON)
          (EATS PISTACHIO-19 WONDERBREAD)
          (HARMONY LEARNING-237 MARS)
          (HARMONY UNDERSTANDING-65 NEPTUNE)
          (EATS YOGURT CHICKEN)
          (EATS HAROSET COD)
          (EATS PEPPER APPLE)
          (EATS ONION POTATO)
          (LOCALE HAMBURGER-47 BAVARIA)
          (CRAVES PROSTATITIS-258 FLOUNDER)
          (CRAVES ANXIETY-168 PEA-36)
          (CRAVES ABRASION-423 SNICKERS-6)
          (EATS RICE-109 SHRIMP-112)
          (EATS APPLE MUTTON)
          (EATS LEMON-64 WURST-42)
          (EATS HOTDOG YOGURT-43)
          (EATS HAROSET SNICKERS-128)
          (CRAVES ANGINA-357 RICE)
          (CRAVES PROSTATITIS-364 GRAPEFRUIT)
          (HARMONY ENTERTAINMENT-229 MARS)
          (CRAVES ANXIETY-497 TOMATO-57)
          (EATS PAPAYA BROCCOLI-45)
          (CRAVES SCIATICA-263 CHERRY)
          (LOCALE PEPPER-39 PENNSYLVANIA)
          (CRAVES ANGER-187 MELON-125)
          (LOCALE MELON-125 BAVARIA)
          (HARMONY INTOXICATION-83 MARS)
          (CRAVES SATIETY SCALLION-118)
          (CRAVES DEPRESSION-487 BAGUETTE-61)
          (EATS PISTACHIO POTATO)
          (CRAVES GRIEF-434 ORANGE-13)
          (CRAVES SCIATICA-427 SWEETROLL-16)
          (EATS OKRA CHICKEN)
          (EATS SWEETROLL WURST-24)
          (CRAVES CURIOSITY-79 LOBSTER-20)
          (CRAVES JEALOUSY-496 SCALLOP-58)
          (EATS TUNA-44 APPLE-51)
          (EATS SHRIMP-112 PAPAYA-116)
          (ATTACKS GOIAS ARIZONA)
          (LOCALE PEAR-27 MORAVIA)
          (ORBITS NEPTUNE MARS)
          (CRAVES HANGOVER-444 PEA-9)
          (CRAVES ABRASION-141 ENDIVE-46)
          (EATS MARZIPAN-7 ARUGULA)
          (CRAVES PROSTATITIS-472 PISTACHIO-19)
          (EATS TOFU PEAR)
          (EATS SHRIMP LEMON-64)
          (CRAVES DREAD-362 GUAVA)
          (CRAVES BOILS-475 MUTTON-18)
          (EATS TOFU-32 CANTELOPE-54)
          (CRAVES JEALOUSY-397 CANTELOPE)
          (CRAVES ANGINA-390 PISTACHIO)
          (HARMONY TRIUMPH-227 MARS)
          (CRAVES LONELINESS-182 POTATO-127)
          (EATS LAMB-52 TUNA)
          (ATTACKS QUEBEC SURREY)
          (LOCALE LAMB MORAVIA)
          (CRAVES ACHIEVEMENT MARZIPAN-123)
          (HARMONY ENTERTAINMENT-254 NEPTUNE)
          (HARMONY STIMULATION MARS)
          (CRAVES SCIATICA-171 FLOUNDER-35)
          (CRAVES ACHIEVEMENT-80 PISTACHIO-19)
          (CRAVES ANXIETY-321 SWEETROLL)
          (EATS FLOUNDER-35 BROCCOLI)
          (EATS CHOCOLATE-22 HAROSET)
          (HARMONY ACHIEVEMENT-80 NEPTUNE)
          (EATS PORK-107 LAMB-113)
          (CRAVES DREAD LAMB-113)
          (CRAVES EMPATHY-76 WURST-24)
          (EATS COD-30 GRAPEFRUIT)
          (CRAVES PROSTATITIS-383 PEPPER)
          (LOCALE SCALLOP MORAVIA)
          (EATS HAROSET-5 PEA)
          (EATS CUCUMBER-29 POTATO-127)
          (CRAVES EXPECTATION-96 YOGURT-43)
          (LOCALE SCALLOP-58 PENNSYLVANIA)
          (EATS COD HAROSET)
          (CRAVES ANGINA-512 LAMB-52)
          (EATS OKRA HAMBURGER-115)
          (LOCALE MELON-31 MANITOBA)
          (EATS HAM SCALLOP-126)
          (EATS CHICKEN YOGURT)
          (EATS PEAR TOFU)
          (HARMONY EXPECTATION-231 MARS)
          (LOCALE PEA-9 BAVARIA-1023)
          (CRAVES ANGER-409 SCALLION-1)
          (CRAVES DREAD-200 TUNA-121)
          (LOCALE CUCUMBER BAVARIA)
          (EATS PEA GUAVA-38)
          (EATS SCALLION-118 SHRIMP-112)
          (HARMONY SATISFACTION MARS)
          (EATS CUCUMBER LETTUCE)
          (EATS POTATO-4 MUFFIN)
          (EATS MELON HOTDOG)
          (ATTACKS PENNSYLVANIA BAVARIA)
          (EATS YOGURT MARZIPAN)
          (EATS FLOUNDER-11 PORK-48)
          (EATS BROCCOLI CHERRY)
          (EATS POPOVER ENDIVE-122)
          (EATS TOFU HAM)
          (EATS HOTDOG MELON)
          (CRAVES LEARNING-82 HOTDOG-62)
          (CRAVES ANGINA RICE-109)
          (EATS POTATO ONION)
          (CRAVES DREAD-452 TURKEY-28)
          (EATS HAMBURGER-115 SCALLION-118)
          (CRAVES ANXIETY-194 MARZIPAN-123)
          (CRAVES DEPRESSION SHRIMP-112)
          (EATS SHRIMP MUTTON)
          (EATS RICE-109 TOMATO-117)
          (EATS BROCCOLI WURST-42)
          (EATS KALE-111 MUTTON-110)
          (EATS ENDIVE POTATO-4)
          (EATS YOGURT-43 TURKEY-41)
          (EATS TURKEY FLOUNDER)
          (EATS MUFFIN-3 APPLE)
          (EATS CHICKEN-2 LOBSTER)
          (HARMONY TRIUMPH NEPTUNE)
          (EATS SHRIMP-112 OKRA-114)
          (CRAVES BOILS-489 GRAPEFRUIT-60)
          (CRAVES SCIATICA-134 PORK-48)
          (CRAVES ABRASION-482 LETTUCE-63)
          (ATTACKS GUANABARA KENTUCKY)
          (EATS HAROSET CHOCOLATE-22)
          (CRAVES LONELINESS-468 GUAVA-21)
          (LOCALE BROCCOLI-120 GUANABARA-1024)
          (CRAVES LACERATION-199 ENDIVE-122)
          (CRAVES DREAD-400 SCALLION)
          (CRAVES DEPRESSION-442 PEA-9)
          (EATS MUTTON TUNA-121)
          (EATS CHOCOLATE-22 PAPAYA)
          (LOCALE CHERRY BOSNIA)
          (CRAVES HANGOVER-219 LAMB-113)
          (CRAVES ANXIETY-148 WURST-42)
          (CRAVES LACERATION-387 BACON)
          (EATS OKRA-114 SHRIMP-112)
          (HARMONY LEARNING NEPTUNE)
          (EATS BROCCOLI FLOUNDER-35)
          (EATS FLOUNDER-11 YOGURT-56)
          (CRAVES ANGINA-272 LEMON)
          (LOCALE COD-30 MORAVIA)
          (CRAVES INTOXICATION CANTELOPE-108)
          (EATS CUCUMBER-29 PISTACHIO-19)
          (CRAVES DREAD-371 LOBSTER)
          (CRAVES ABRASION-379 WONDERBREAD)
          (CRAVES LONELINESS-208 HAMBURGER-115)
          (LOCALE BAGUETTE GUANABARA-1024)
          (HARMONY EXCITEMENT-85 MARS)
          (HARMONY SATIETY-236 PLUTO)
          (CRAVES LONELINESS-284 OKRA)
          (EATS TURKEY-28 CUCUMBER-37)
          (EATS HAM CHICKEN-2)
          (CRAVES REST PORK-107)
          (CRAVES GRIEF-283 OKRA)
          (EATS MUFFIN-124 APPLE-51)
          (CRAVES HANGOVER-467 CHOCOLATE-22)
          (CRAVES ANXIETY-382 PEPPER)
          (LOCALE CUCUMBER-37 ALSACE-257)
          (EATS LETTUCE ARUGULA)
          (CRAVES BOILS-337 MUFFIN)
          (CRAVES AESTHETICS-233 SWEETROLL)
          (HARMONY EXCITEMENT-250 NEPTUNE)
          (LOCALE SCALLOP-126 QUEBEC)
          (CRAVES TRIUMPH-252 CANTELOPE)
          (CRAVES BOILS-353 PORK)
          (CRAVES REST-224 POTATO)
          (CRAVES ABRASION-178 POPOVER-33)
          (CRAVES EXCITEMENT-250 COD)
          (LOCALE WURST-24 GUANABARA-1024)
          (EATS POPOVER TUNA-44)
          (EATS ONION TOMATO-57)
          (CRAVES DREAD-296 APPLE)
          (CRAVES ANXIETY-462 WURST-24)
          (CRAVES ANGER-265 CHERRY)
          (ATTACKS ALSACE GUANABARA)
          (EATS TURKEY TOFU-32)
          (EATS MARZIPAN SCALLOP-126)
          (CRAVES LONELINESS-170 FLOUNDER-35)
          (LOCALE ARUGULA-26 PENNSYLVANIA)
          (CRAVES LONELINESS-205 WONDERBREAD-119)
          (LOCALE PEA MORAVIA)
          (EATS LETTUCE-63 LOBSTER)
          (HARMONY TRIUMPH-247 MARS)
          (LOCALE SNICKERS SURREY)
          (CRAVES JEALOUSY-173 CHOCOLATE-34)
          (EATS MUTTON MELON-125)
          (HARMONY EMPATHY-102 MARS)
          (CRAVES ANGER-465 KALE-23)
          (EATS SCALLION-118 KALE-111)
          (EATS GRAPEFRUIT-60 PEA-36)
          (LOCALE KALE MORAVIA)
          (CRAVES PROSTATITIS-159 PEPPER-39)
          (CRAVES UNDERSTANDING-106 POTATO-127)
          (LOCALE TUNA ALSACE-257)
          (HARMONY LEARNING-105 MARS)
          (LOCALE RICE-8 MORAVIA)
          (LOCALE MUTTON OREGON)
          (EATS PORK TURKEY)
          (EATS APPLE BACON)
          (EATS BROCCOLI LAMB)
          (LOCALE TUNA-121 GUANABARA-1024)
          (LOCALE PEA-36 GUANABARA-1024)
          (CRAVES GRIEF-477 MUTTON-18)
          (CRAVES ABRASION-276 TOFU)
          (CRAVES SATIETY-253 HAM)
          (CRAVES JEALOUSY-332 ONION)
          (LOCALE PAPAYA-12 MANITOBA)
          (LOCALE BROCCOLI ALSACE-257)
          (CRAVES ANXIETY-506 OKRA-55)
          (CRAVES ACHIEVEMENT-220 MARZIPAN)
          (EATS TUNA-121 BROCCOLI)
          (LOCALE OKRA-114 ARIZONA)
          (HARMONY REST PLUTO)
          (EATS HOTDOG-62 LAMB)
          (EATS HAROSET TURKEY)
          (EATS FLOUNDER MUTTON-18)
          (HARMONY REST-224 MARS)
          (EATS GUAVA SNICKERS-6)
          (CRAVES BOILS-399 SCALLION)
          (HARMONY AESTHETICS-233 PLUTO)
          (CRAVES GRIEF-212 PAPAYA-116)
          (EATS TURKEY-41 YOGURT-43)
          (HARMONY EXCITEMENT-99 MARS)
          (HARMONY ACHIEVEMENT-94 NEPTUNE)
          (EATS CHOCOLATE BAGUETTE-61)
          (HARMONY LUBRICITY PLUTO)
          (CRAVES BOILS-216 SCALLION-118)
          (ATTACKS ALSACE-257 GOIAS)
          (EATS LEMON PISTACHIO-19)
          (CRAVES STIMULATION-223 OKRA)
          (CRAVES STIMULATION-89 APPLE-51)
          (CRAVES LACERATION-213 TOMATO-117)
          (LOCALE MARZIPAN KENTUCKY)
          (CRAVES DEPRESSION-310 HAMBURGER)
          (EATS TOFU-32 TURKEY)
          (CRAVES BOILS-392 COD)
          (EATS HOTDOG PEA)
          (EATS LOBSTER-20 MARZIPAN)
          (CRAVES ANGINA-304 SHRIMP)
          (CRAVES LEARNING-237 HOTDOG)
          (LOCALE CANTELOPE-54 GUANABARA-1024)
          (LOCALE RICE ALSACE)
          (CRAVES SCIATICA-419 MARZIPAN-7)
          (EATS MARZIPAN TOFU)
          (CRAVES LUBRICITY-239 TOMATO))
   (:GOAL (AND (CRAVES BOILS-216 WONDERBREAD)
               (CRAVES LACERATION-333 POTATO-127)
               (CRAVES JEALOUSY-332 POTATO-127)
               (CRAVES HANGOVER-204 POTATO-127)
               (CRAVES ANGINA-201 POTATO-127)
               (CRAVES GRIEF-212 POTATO-127)
               (CRAVES ANGER-292 POTATO-127)
               (CRAVES PROSTATITIS-294 POTATO-127)
               (CRAVES DEPRESSION-361 POTATO-127)
               (CRAVES DREAD-362 POTATO-127)
               (CRAVES ANGER-409 POTATO-127)
               (CRAVES LACERATION-395 YOGURT)
               (CRAVES PROSTATITIS-429 YOGURT)
               (CRAVES HANGOVER-430 YOGURT)
               (CRAVES ANGER-425 YOGURT)
               (CRAVES JEALOUSY-426 MUFFIN))))

